// envirion.h

#ifndef ENVIRON_H
#define ENVIRON_H

#ifdef __cplusplus
extern "C" {
#endif


char *GetEnvA ( const char *szName ) ;
wchar_t *GetEnvW ( const wchar_t *szName ) ;
char *GetEnvAllocA ( const char *szName ) ;
wchar_t *GetEnvAllocW ( const wchar_t *szName ) ;

int PutEnvA ( const char *szString ) ;
int PutEnvW ( const wchar_t *szString ) ;
int SetEnvA ( const char *szName, const char *szValue, int IsOverwrite ) ;
int SetEnvW ( const wchar_t *szName, const wchar_t *szValue, int IsOverwrite ) ;

int AddEnvPathA ( const char *szPath, int IsAddToTop ) ;
int AddEnvPathW ( const wchar_t *szPath, int IsAddToTop ) ;

int EnumEnvironmentVariablesA ( int ( CALLBACK *CallbackProc ) ( const char *szName, const char *szValue, LPARAM lParam ), LPARAM lParam ) ;
int EnumEnvironmentVariablesW ( int ( CALLBACK *CallbackProc ) ( const wchar_t *szName, const wchar_t *szValue, LPARAM lParam ), LPARAM lParam ) ;


#ifdef UNICODE
#define GetEnv GetEnvW
#define GetEnvAlloc GetEnvAllocW
#define PutEnv PutEnvW
#define SetEnv SetEnvW
#define AddEnvPath AddEnvPathW
#define EnumEnvironmentVariables EnumEnvironmentVariablesW
#else
#define GetEnv GetEnvA
#define GetEnvAlloc GetEnvAllocA
#define PutEnv PutEnvA
#define SetEnv SetEnvA
#define AddEnvPath AddEnvPathA
#define EnumEnvironmentVariables EnumEnvironmentVariablesA
#endif


#define getenv GetEnvA
#define wgetenv GetEnvW
#define _wgetenv GetEnvW

#define putenv PutEnvA
#define _putenv PutEnvA
#define wputenv PutEnvW
#define _wputenv PutEnvW

#define setenv SetEnvA
#define _setenv SetEnvA
#define wsetenv SetEnvW
#define _wsetenv SetEnvW


#ifdef __cplusplus
}
#endif

#endif


