// winmain.h

#ifndef WINMAIN_H
#define WINMAIN_H


#ifdef __cplusplus
extern "C" {
#endif


#if defined _CONSOLE || defined _WINDOWS && ! defined _USRDLL
#if defined NOARG || defined NOCRT
int winmain_ ( void ) ;
#else
int winmain_ ( int argc, char *argv [] ) ;
#endif
#define main   winmain_
#endif


#if defined _USRDLL && ! defined NOCRT && defined _MT
int WINAPI DllMain_ ( HINSTANCE hInst, unsigned long dwReason, void *pReserved ) ;
#define DllMain DllMain_
#endif


#if defined _CONSOLE
void EnableAlertOnClose ( void ) ;
void DisableAlertOnClose ( void ) ;
int IsConsole ( void ) ;
#endif


#if defined _CONSOLE || defined _WINDOWS && ! defined _USRDLL
char *GetArgumentA ( int nCount ) ;
wchar_t *GetArgumentW ( int nCount ) ;
#endif


#ifdef UNICODE
#define GetArgument GetArgumentW
#else
#define GetArgument GetArgumentA
#endif


#if ( defined NOARG || defined NOCRT ) && ! defined _USRDLL
char *GetWinMainCmdLineA ( void ) ;
wchar_t *GetWinMainCmdLineW ( void ) ;
#endif


#ifdef UNICODE
#define GetWinMainCmdLine GetWinMainCmdLineW
#else
#define GetWinMainCmdLine GetWinMainCmdLineA
#endif


#ifdef __cplusplus
}
#endif


#endif // WINMAIN_H


