// fileconv.h

#ifndef FILECONV_H
#define FILECONV_H

#ifdef __cplusplus
extern "C" {
#endif


int FileConvertA ( const char *szSrcFileName, const char *szExtension, int ( WINAPI *pFunction ) ( const char *szSrcFileName, const char *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pFunctionData ), int nSrcCodePage, int nDstCodePage, void *pFunctionData, unsigned long dwMode ) ;
int FileConvertW ( const wchar_t *szSrcFileName, const wchar_t *szExtension, int ( WINAPI *pFunction ) ( const wchar_t *szSrcFileName, const wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pFunctionData ), int nSrcCodePage, int nDstCodePage, void *pFunctionData, unsigned long dwMode ) ;


#ifdef UNICODE
#define FileConvert FileConvertW
#else
#define FileConvert FileConvertA
#endif


// mode
#define FILECONV_NO_ECHO               1
#define FILECONV_SAVE_TIMESTAMP        2
#define FILECONV_TO_HIDDEN             4


// error code
#define FILECONV_ERROR_ACCESS       -1
#define FILECONV_ERROR_EXTENSION    -2
#define FILECONV_ERROR_MEMORY       -3


// well-knwon converter error code
#include "conv_err.h"


#ifdef __cplusplus
}
#endif

#endif


