// filetime.cpp

#include <windows.h>
#include <string.h>
#include "msc.h"
#include "filename.h"
#include "filetime.h"



//////////////////////////////
//          ANSI          //
//////////////////////////////



// t@C^C擾iANSIŁj
// R̈̂Kv̂Ȃ̂ NULL ł
//  0 As 0 ȊOԂ
int GetFileTimeExA ( const char *szFileName, FILETIME *pCreationTime, FILETIME *pLastAccessTime, FILETIME *pLastWriteTime ) {

   const char *szString = GetFileNameA ( szFileName ) ;
   if ( szString && ( strchr ( szString, '?' ) || strchr ( szString, '*' ) ) ) return 1 ;

   WIN32_FIND_DATAA FindData ;

   HANDLE hFindFile = FindFirstFileA ( szFileName, & FindData ) ;
   if ( hFindFile == INVALID_HANDLE_VALUE ) return 1 ;
   FindClose ( hFindFile ) ;

   if ( pCreationTime ) *pCreationTime = FindData.ftCreationTime ;
   if ( pLastAccessTime ) *pLastAccessTime = FindData.ftLastAccessTime ;
   if ( pLastWriteTime ) *pLastWriteTime = FindData.ftLastWriteTime ;

   return 0 ;
}



// t@C^Cݒ肷iANSIŁj
//  1, s 0 Ԃ
int SetFileTimeExA ( const char *szFileName, const FILETIME *pCreationTime, const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime ) {

   HANDLE hFile = CreateFileA ( szFileName, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
   if ( hFile == INVALID_HANDLE_VALUE ) return 1 ;
   int nResult = SetFileTime ( hFile, pCreationTime, pLastAccessTime, pLastWriteTime ) ;
   CloseHandle ( hFile ) ;

   return ! nResult ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// t@C^C擾iUNICODEŁj
// R̈̂Kv̂Ȃ̂ NULL ł
//  0 As 0 ȊOԂ
int GetFileTimeExW ( const wchar_t *szFileName, FILETIME *pCreationTime, FILETIME *pLastAccessTime, FILETIME *pLastWriteTime ) {

   const wchar_t *szString = GetFileNameW ( szFileName ) ;
   if ( szString && ( wcschr ( szString, '?' ) || wcschr ( szString, '*' ) ) ) return 1 ;

   WIN32_FIND_DATAW FindData ;

   HANDLE hFindFile = FindFirstFileW ( szFileName, & FindData ) ;
   if ( hFindFile == INVALID_HANDLE_VALUE ) return 1 ;
   FindClose ( hFindFile ) ;

   if ( pCreationTime ) *pCreationTime = FindData.ftCreationTime ;
   if ( pLastAccessTime ) *pLastAccessTime = FindData.ftLastAccessTime ;
   if ( pLastWriteTime ) *pLastWriteTime = FindData.ftLastWriteTime ;

   return 0 ;
}



// t@C^Cݒ肷iUNICODEŁj
// R̈̂Kv̂Ȃ̂ NULL ł
//  0 As 0 ȊOԂ
int SetFileTimeExW ( const wchar_t *szFileName, const FILETIME *pCreationTime, const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime ) {

   HANDLE hFile = CreateFileW ( szFileName, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
   if ( hFile == INVALID_HANDLE_VALUE ) return 1 ;
   int nResult = SetFileTime ( hFile, pCreationTime, pLastAccessTime, pLastWriteTime ) ;
   CloseHandle ( hFile ) ;

   return ! nResult ;
}



