// filetime.h

#ifndef FILETIME_H
#define FILETIME_H

#ifdef __cplusplus
extern "C" {
#endif


int GetFileTimeExA ( const char *szFileName, FILETIME *pCreationTime, FILETIME *pLastAccessTime, FILETIME *pLastWriteTime ) ;
int GetFileTimeExW ( const wchar_t *szFileName, FILETIME *pCreationTime, FILETIME *pLastAccessTime, FILETIME *pLastWriteTime ) ;
int SetFileTimeExA ( const char *szFileName, const FILETIME *pCreationTime, const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime ) ;
int SetFileTimeExW ( const wchar_t *szFileName, const FILETIME *pCreationTime, const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime ) ;


#ifdef UNICODE
#define GetFileTimeEx GetFileTimeExW
#define SetFileTimeEx SetFileTimeExW
#else
#define GetFileTimeEx GetFileTimeExA
#define SetFileTimeEx SetFileTimeExA
#endif


#ifdef __cplusplus
}
#endif

#endif


