// MSC.H



////////////////////////////////////////////
//              STRING LOCALE             //
////////////////////////////////////////////



#pragma setlocale ( "japanese" )



////////////////////////////////////////////
//             TO INCLUDE ONCE            //
////////////////////////////////////////////



#ifndef MSC_H
#define MSC_H



////////////////////////////////////////////
//               CONFORMANCE              //
////////////////////////////////////////////



#ifdef _MSC_VER

#pragma warning ( error: 4010 )     // single-line comment contains line-continuation character
#pragma warning ( error: 4018 )     // signed/unsigned mismatch ( '<', '>' )
#pragma warning ( error: 4389 )     // signed/unsigned mismatch ( '==' )

#if _MSC_VER >= 1400
#pragma warning ( disable: 4996 )   // function was declared deprecated
#endif

#if _MSC_VER < 1300
#define for    if (0) {} else for
#elif _MSC_VER < 1400
#pragma conform ( forScope, on )
#endif

#endif // _MSC_VER



////////////////////////////////////////////
//             NON-ANSI NAMES             //
////////////////////////////////////////////



// Non-ANSI names for compatibility


// <stdio.h>
#define wfopen _wfopen
#define fsopen _fsopen
#define wfsopen _wfsopen
#define snprintf _snprintf
#define snwprintf _snwprintf
#define vsnprintf _vsnprintf
#define vsnwprintf _vsnwprintf

// <conio.h>
#define outp _outp
#define inp _inp

// <stdlib.h>
#define wtoi _wtoi
#define wtol _wtol
#define wtof _wtof

// <ctype.h>
#ifndef isascii
#define isascii __isascii
#endif

// <string.h>
#define strrev _strrev
#define wcsrev _wcsrev
#define strdup _strdup
#define wcsdup _wcsdup

// <mbctype.h>
#define ismbblead _ismbblead
#define ismbbtrail _ismbbtrail
#define ismbbkana _ismbbkana

#ifndef __cplusplus
#define inline __inline
#endif



////////////////////////////////////////////
//                BORLAND                 //
////////////////////////////////////////////



// for Borland C++ 5.5.1
#if defined __BORLANDC__

#pragma option -w-8008  // ɐ^܂͋U
#pragma option -w-8027  // CCWJłȂ
#pragma option -w-8057  // xgpĂȂ
#pragma option -w-8060  // 炭sȑ
#pragma option -w-8066  // sȂR[h


// <stdio.h>
#define _base buffer    // inside of FILE
#define _ptr  curp      // inside of FILE

// <io.h>
#define _isatty isatty
#define _setmode setmode

// <share.h>
#define _SH_DENYNO SH_DENYNO
#define _SH_DENYWR SH_DENYWR

// <stdlib.h>
#define __wargv wargv_dummy_

// <string.h>
#define _strrev strrev
#define _strdup strdup

// "stringex.h"
#undef strlwr
#undef strupr
#define strlwr strlwr_by_stringex
#define strupr strupr_by_stringex

#endif // __BORLANDC__



////////////////////////////////////////////
//              DIGITAL MARS              //
////////////////////////////////////////////



// for Digital Mars C++ 8.36
#if defined __DMC__

// for wcstol,wcstoul,wcstod
#ifdef _WCHAR_T_DEFINED
#include <wchar.h>
#endif

// "stringex.h"
#define strlwr strlwr_by_stringex
#define strupr strupr_by_stringex
#define wcslwr wcslwr_by_stringex
#define wcsupr wcsupr_by_stringex

#endif // __DMC__



////////////////////////////////////////////
//                WATCOM C                //
////////////////////////////////////////////



// for Watcom C++ 1.4
#if defined __WATCOMC__

#define __cdecl

// <stdio.h>
#define _base _ptr      // inside of FILE

// <io.h>
#define _isatty isatty
#define _setmode setmode
#define _fileno fileno

// <conio.h>
#define _outp outp
#define _inp inp

// <share.h>
#define _SH_DENYNO SH_DENYNO
#define _SH_DENYWR SH_DENYWR

// SEH
#define __try        if ( 1 )
#define __except     else if
#define __finally

// SEH
#define GetExceptionCode()          0
#define GetExceptionInformation()   NULL

#endif // __WATCOMC__



////////////////////////////////////////////
//                  GCC                   //
////////////////////////////////////////////



// for MinGW G++ 1.4
#if defined __GNUC__

// SEH
#define __try        if ( 1 )
#define __except     else if
#define __finally

// SEH
#define GetExceptionCode()          0
#define GetExceptionInformation()   NULL

#endif // __GNUC__



////////////////////////////////////////////
//                STDDEF.H                //
////////////////////////////////////////////



#include <stddef.h>


#if defined _MSC_VER || defined __BORLANDC__ && __BORLANDC__ < 1370

#ifndef _INTPTR_T_DEFINED
typedef int             intptr_t ;
#define _INTPTR_T_DEFINED
#endif
#ifndef _UINTPTR_T_DEFINED
typedef unsigned int    uintptr_t ;
#define _UINTPTR_T_DEFINED
#endif

#ifndef _INT64_T_DEFINED
typedef __int64            int64_t ;
#define _INT64_T_DEFINED
#endif
#ifndef _UINT64_T_DEFINED
typedef unsigned __int64   uint64_t ;
#define _UINT64_T_DEFINED
#endif

#else

#include <stdint.h>

#endif



////////////////////////////////////////////
//                STDARG.H                //
////////////////////////////////////////////



#ifdef FILENAME_MAX  // stdio.h
#include <stdarg.h>
#endif


#ifdef va_start      // stdarg.h
#ifndef va_copy
#define va_copy(dst,src)   ((void)((dst)=(src)))
#endif
#endif



////////////////////////////////////////////
//              STDIO.H/IO.H              //
////////////////////////////////////////////



#ifdef FILENAME_MAX  // stdio.h
#include <io.h>
#include <fcntl.h>
#include <share.h>
#endif


#ifdef FILENAME_MAX  // stdio.h
#ifndef MAX_PATH
#define MAX_PATH FILENAME_MAX
#endif
#endif


// Xg[[ǂ
// [Ȃ 0 ȊOA[łȂ 0 Ԃ
// is associated with tele-typewriter
#define fisatty(stream)          _isatty ( _fileno ( stream ) )

// Xg[̕ϊ[hύX
// O̕ϊ[hԂ
#define fsetmode(stream,mode)    _setmode ( _fileno ( stream ), mode )

// OS̃t@CnhԂ
#define fget_osfhandle(stream)   (HANDLE) _get_osfhandle ( _fileno ( stream ) )


#ifdef __cplusplus
extern "C" {
#endif

#ifdef FILENAME_MAX  // stdio.h
#if defined _MSC_VER
#if _MSC_VER < 1400
int __cdecl _fseeki64 ( FILE *stream, __int64 offset, int origin ) ;
__int64 __cdecl _ftelli64 ( FILE *stream ) ;
#endif
#define fseek64 _fseeki64
#define ftell64 _ftelli64
#else
#define fseek64 fseek
#define ftell64 ftell
#endif
#endif


#if defined _MSC_VER && _MSC_VER >= 1400 || defined __DMC__ || defined __WATCOMC__
#ifdef FILENAME_MAX  // stdio.h
static inline int __cdecl swprintf_ ( wchar_t *buffer, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int result = vswprintf ( buffer, 0x7FFFFFFF, format, args ) ;
   va_end ( args ) ;
   return result ;
}
#define swprintf swprintf_
#define vswprintf(s,f,a)   vswprintf ( s, 0x7FFFFFFF, f, a )
#endif
#endif

#ifdef __cplusplus
}
#endif


// stdio.h header's bug
#if defined _MSC_VER && _MSC_VER == 1400 && defined _CRT_DISABLE_PERFCRIT_LOCKS
#undef _fseeki64
#define _fseeki64(_stm,_offset,_origin)   _fseeki64_nolock(_stm,_offset,_origin)
#endif


// oemio.cpp

#define wprintf oem_wprintf
#define fwprintf oem_fwprintf
#define vfwprintf oem_vfwprintf
#define fputws oem_fputws
#define fgetws oem_fgetws



////////////////////////////////////////////
//                 CTYPE.H                //
////////////////////////////////////////////



#define toupper toupper_inline
#define tolower tolower_inline
static inline int toupper ( int c ) { return ( c >= 'a' && c <= 'z' ) ? ( c - 'a' + 'A' ) : c ; }
static inline int tolower ( int c ) { return ( c >= 'A' && c <= 'Z' ) ? ( c - 'A' + 'a' ) : c ; }

#define isblank isblank_inline
static inline int isblank ( int c ) { return c == 0x20 || c == '\t' ; }


#if ! defined __BORLANDC__
#undef __iscsym
#undef __iscsymf
#endif
#define iscsym __iscsym
#define iscsymf __iscsymf


#if defined _MSC_VER

#undef isalpha
#undef isupper
#undef islower
#undef isdigit
#undef isxdigit
#undef isspace
#undef ispunct
#undef isalnum
#undef isprint
#undef isgraph
#undef iscntrl

// These macros are faster than functions in MSC's <ctype.h>.
#define isalpha(c)   ( _pctype [ c ] & ( _UPPER | _LOWER ) )
#define isupper(c)   ( _pctype [ c ] & ( _UPPER ) )
#define islower(c)   ( _pctype [ c ] & ( _LOWER ) )
#define isdigit(c)   ( _pctype [ c ] & ( _DIGIT ) )
#define isxdigit(c)  ( _pctype [ c ] & ( _HEX ) )
#define isspace(c)   ( _pctype [ c ] & ( _SPACE ) )
#define ispunct(c)   ( _pctype [ c ] & ( _PUNCT ) )
#define isalnum(c)   ( _pctype [ c ] & ( _UPPER | _LOWER | _DIGIT ) )
#define isprint(c)   ( _pctype [ c ] & ( _BLANK | _PUNCT | _UPPER | _LOWER | _DIGIT ) )
#define isgraph(c)   ( _pctype [ c ] & ( _PUNCT | _UPPER | _LOWER | _DIGIT ) )
#define iscntrl(c)   ( _pctype [ c ] & ( _CONTROL ) )

#endif // defined _MSC_VER



////////////////////////////////////////////
//                STRING.H                //
////////////////////////////////////////////



// ̖ikjԂ
#if defined _MSC_VER && ! defined DEBUG_CONST_STRING
static inline char *strend ( const char *s ) {
   while ( *s ) s ++ ;
   return (char*) s ;
}
static inline wchar_t *wcsend ( const wchar_t *s ) {
   while ( *s ) s ++ ;
   return (wchar_t*) s ;
}
#else
#undef NOCRT
#define strend(s)    strchr ( s, 0 )
#define wcsend(s)    wcschr ( s, 0 )
#endif


#define memzero(p,n)    memset ( p, 0, n )


#if defined DEBUG_CONST_STRING && defined __cplusplus && defined _INC_STRING     // for debug

#define FUNC_STR_STR(func,type)  \
   static inline const type *func##_ ( const type *s1, const type *s2 ) { return func ( s1, s2 ) ; } \
   static inline       type *func##_ (       type *s1, const type *s2 ) { return func ( s1, s2 ) ; }

#define FUNC_STR_INT(func,type)  \
   static inline const type *func##_ ( const type *s, int c ) { return func ( s, c ) ; } \
   static inline       type *func##_ (       type *s, int c ) { return func ( s, c ) ; }

#define FUNC_STR_INT_SIZET(func,type)  \
   static inline const type *func##_ ( const type *s, int c, size_t i ) { return func ( s, c, i ) ; } \
   static inline       type *func##_ (       type *s, int c, size_t i ) { return func ( s, c, i ) ; }

FUNC_STR_STR ( strstr, char )
FUNC_STR_STR ( wcsstr, wchar_t )
FUNC_STR_STR ( strpbrk, char )
FUNC_STR_STR ( wcspbrk, wchar_t )
FUNC_STR_INT ( strchr, char )
FUNC_STR_INT ( wcschr, wchar_t )
FUNC_STR_INT ( strrchr, char )
FUNC_STR_INT ( wcsrchr, wchar_t )
FUNC_STR_INT_SIZET ( memchr, void )

#undef FUNC_STR_STR
#undef FUNC_STR_INT
#undef FUNC_STR_INT_SIZET

#define strstr    strstr_
#define wcsstr    wcsstr_
#define strpbrk   strpbrk_
#define wcspbrk   wcspbrk_
#define strchr    strchr_
#define wcschr    wcschr_
#define strrchr   strrchr_
#define wcsrchr   wcsrchr_
#define memchr    memchr_

#endif // defined DEBUG_CONST_STRING && defined __cplusplus && defined _INC_STRING



////////////////////////////////////////////
//                STDLIB.H                //
////////////////////////////////////////////



#ifdef EXIT_SUCCESS  // stdlib.h
#ifndef __max
#define __max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif
#ifndef __min
#define __min(a,b)  ( ((a) < (b)) ? (a) : (b) )
#endif
#endif


// execute.cpp

#define system ExecuteViaComspecA
#define wsystem ExecuteViaComspecW
#define _wsystem ExecuteViaComspecW


// environ.cpp

#define getenv GetEnvA
#define wgetenv GetEnvW
#define _wgetenv GetEnvW

#define putenv PutEnvA
#define _putenv PutEnvA
#define wputenv PutEnvW
#define _wputenv PutEnvW

#define setenv SetEnvA
#define _setenv SetEnvA
#define wsetenv SetEnvW
#define _wsetenv SetEnvW



#if defined DEBUG_CONST_STRING && defined __cplusplus && defined _INC_STDLIB     // for debug

#define FUNC_STR_STR_BASE(func,type,data) \
   static inline data func##_ ( const type *s1, const type **s2, int base ) { return func ( s1, (type**) s2, base ) ; } \
   static inline data func##_ (       type *s1,       type **s2, int base ) { return func ( s1,          s2, base ) ; }

#define FUNC_STR_STR(func,type,data)   \
   static inline data func##_ ( const type *s1, const type **s2 ) { return func ( s1, (type**) s2 ) ; } \
   static inline data func##_ (       type *s1,       type **s2 ) { return func ( s1,          s2 ) ; }

FUNC_STR_STR_BASE ( strtol, char, long )
FUNC_STR_STR_BASE ( strtoul, char, unsigned long )
FUNC_STR_STR ( strtod, char, double )
FUNC_STR_STR_BASE ( wcstol, wchar_t, long )
FUNC_STR_STR_BASE ( wcstoul, wchar_t, unsigned long )
FUNC_STR_STR ( wcstod, wchar_t, double )

#if defined _MSC_VER && _MSC_VER >= 1310
FUNC_STR_STR_BASE ( _strtoi64, char, __int64 )
FUNC_STR_STR_BASE ( _strtoui64, char, unsigned __int64 )
FUNC_STR_STR_BASE ( _wcstoi64, wchar_t, __int64 )
FUNC_STR_STR_BASE ( _wcstoui64, wchar_t, unsigned __int64 )
#endif

#undef FUNC_STR_STR_BASE
#undef FUNC_STR_STR

#define strtol          strtol_
#define strtoul         strtoul_
#define strtod          strtod_
#define wcstol          wcstol_
#define wcstoul         wcstoul_
#define wcstod          wcstod_

#define _strtoi64       _strtoi64_
#define _strtoui64      _strtoui64_
#define _wcstoi64       _wcstoi64_
#define _wcstoui64      _wcstoui64_

#else

#define strtol(s,p,b)   strtol ( s, (char**) p, b )
#define strtoul(s,p,b)  strtoul ( s, (char**) p, b )
#define strtod(s,p)     strtod ( s, (char**) p )
#define wcstol(s,p,b)   wcstol ( s, (wchar_t**) p, b )
#define wcstoul(s,p,b)  wcstoul ( s, (wchar_t**) p, b )
#define wcstod(s,p)     wcstod ( s, (wchar_t**) p )

#define _strtoi64(s,p,b)   _strtoi64 ( s, (char**) p, b )
#define _strtoui64(s,p,b)  _strtoui64 ( s, (char**) p, b )
#define _wcstoi64(s,p,b)   _wcstoi64 ( s, (wchar_t**) p, b )
#define _wcstoui64(s,p,b)  _wcstoui64 ( s, (wchar_t**) p, b )

#endif // else of defined DEBUG_CONST_STRING && defined __cplusplus && defined _INC_STDLIB



////////////////////////////////////////////
//                 TIME.H                 //
////////////////////////////////////////////



// clock.cpp

#define clock clock_nt



////////////////////////////////////////////
//                 ERRNO.H                //
////////////////////////////////////////////



#ifdef ERANGE  // errno.h

#ifndef EILSEQ
#define EILSEQ    200
#endif

#endif



////////////////////////////////////////////
//                LIMITS.H                //
////////////////////////////////////////////



#ifdef CHAR_BIT
#define SHORT_BIT    16
#define LONG_BIT     32
#define INT_BIT      32
#endif


#ifdef INT_MAX

#ifndef SIZE_MAX
#define SIZE_MAX        (~((size_t)0))
#endif
#ifndef SIZE_MIN
#define SIZE_MIN        ((size_t)0)
#endif
#ifndef PTRDIFF_MAX
#define PTRDIFF_MAX     ((ptrdiff_t)( SIZE_MAX >>1))
#endif
#ifndef PTRDIFF_MIN
#define PTRDIFF_MIN     ((ptrdiff_t)(~(( SIZE_MAX >>1)))
#endif

#ifndef UINTPTR_MAX
#define UINTPTR_MAX     (~((uintptr_t)0))
#endif
#ifndef UINTPTR_MIN
#define UINTPTR_MIN     ((uintptr_t)0)
#endif
#ifndef INTPTR_MAX
#define INTPTR_MAX      ((intptr_t)( UINTPTR_MAX >>1))
#endif
#ifndef INTPTR_MIN
#define INTPTR_MIN      ((intptr_t)(~( UINTPTR_MAX >>1)))
#endif

#ifndef UINT64_MAX
#define UINT64_MAX      (~((uint64_t)0))
#endif
#ifndef UINT64_MIN
#define UINT64_MIN      ((uint64_t)0)
#endif
#ifndef INT64_MAX
#define INT64_MAX       ((int64_t)( UINT64_MAX >>1))
#endif
#ifndef INT64_MIN
#define INT64_MIN       ((int64_t)(~( UINT64_MAX >>1)))
#endif

#endif // INT_MAX



////////////////////////////////////////////
//                 UNICODE                //
////////////////////////////////////////////



typedef wchar_t         wchar16_t ;
typedef unsigned long   wchar32_t ;


#ifdef INT_MAX
#define UTF16_MAX               0x10FFFF
#define UTF32_MAX             0x7FFFFFFF
#endif


#define IsUnicodeHighSurrogate(x)   ( ( (x) & 0xFFFFFC00 ) == 0xD800 )
#define IsUnicodeLowSurrogate(x)    ( ( (x) & 0xFFFFFC00 ) == 0xDC00 )
#define IsUnicodeSurrogate(x)       ( ( (x) & 0xFFFFF800 ) == 0xD800 )


// XJ[lTQ[gl쐬
static inline unsigned long MAKE_UNICODE_SURROGATE ( long x ) {
   return ( (unsigned long)( (unsigned)( x - 0x10000 ) / 0x400 + 0xD800 ) << 16 ) + ( (unsigned)( x - 0x10000 ) % 0x400 + 0xDC00 ) ;
}

// TQ[glXJ[l쐬
static inline long MAKE_UNICODE_SCALAR ( unsigned long high, unsigned long low ) {
   return ( high - 0xD800 ) * 0x400 + ( low - 0xDC00 ) + 0x10000 ;
}


#define BYTE_ORDER_MARK          0xFEFF
#define BYTE_ORDER_MARK_BE       0xFFFE
#define REPLACEMENT_CHARACTER    0xFFFD



////////////////////////////////////////////
//                 UTILITY                //
////////////////////////////////////////////



#define NELEMOF(x)      ( sizeof(x) / sizeof(x[0]) )



#ifdef __cplusplus
extern "C" {
#endif

// winmain.cpp
size_t strlcpylen ( char *dst, const char *src, size_t srclen, size_t bufsiz ) ;
size_t wcslcpylen ( wchar_t *dst, const wchar_t *src, size_t srclen, size_t bufsiz ) ;
#define strlcpy(dst,src,bufsiz)  strlcpylen ( dst, src, (size_t) -1, bufsiz )
#define wcslcpy(dst,src,bufsiz)  wcslcpylen ( dst, src, (size_t) -1, bufsiz )

// winmain.cpp
size_t a2wlcpylen_cp ( wchar_t *dst, const char *src, size_t srclen, size_t bufsiz, int codepage ) ;
size_t w2alcpylen_cp ( char *dst, const wchar_t *src, size_t srclen, size_t bufsiz, int codepage ) ;
#define a2wlcpy_cp(dst,src,bufsiz,codepage)  a2wlcpylen_cp ( dst, src, (size_t) -1, bufsiz, codepage )
#define w2alcpy_cp(dst,src,bufsiz,codepage)  w2alcpylen_cp ( dst, src, (size_t) -1, bufsiz, codepage )
#define a2wlcpylen(dst,src,srclen,bufsiz)    a2wlcpylen_cp ( dst, src, srclen, bufsiz, 0 )
#define w2alcpylen(dst,src,srclen,bufsiz)    w2alcpylen_cp ( dst, src, srclen, bufsiz, 0 )
#define a2wlcpy(dst,src,bufsiz)              a2wlcpylen_cp ( dst, src, (size_t) -1, bufsiz, 0 )
#define w2alcpy(dst,src,bufsiz)              w2alcpylen_cp ( dst, src, (size_t) -1, bufsiz, 0 )

// winmain.cpp
char *strduplen_max_expand ( const char *string, size_t srclen, size_t maxlen, size_t addlen ) ;
wchar_t *wcsduplen_max_expand ( const wchar_t *string, size_t srclen, size_t maxlen, size_t addlen ) ;
#define strduplen(string,srclen)                strduplen_max_expand ( string, srclen, (size_t) -1, 0 )
#define wcsduplen(string,srclen)                wcsduplen_max_expand ( string, srclen, (size_t) -1, 0 )
#define strdup_expand(string,maxlen,addlen)     strduplen_max_expand ( string, (size_t) -1, maxlen, addlen )
#define wcsdup_expand(string,maxlen,addlen)     wcsduplen_max_expand ( string, (size_t) -1, maxlen, addlen )
#define strdup_max(string,maxlen)               strduplen_max_expand ( string, (size_t) -1, maxlen, 0 )
#define wcsdup_max(string,maxlen)               wcsduplen_max_expand ( string, (size_t) -1, maxlen, 0 )

// winmain.cpp
wchar_t *a2wduplen_max_expand_cp ( const char *string, size_t srclen, size_t maxlen, size_t addlen, size_t *p_dstlen, int codepage ) ;
char *w2aduplen_max_expand_cp ( const wchar_t *string, size_t srclen, size_t maxlen, size_t addlen, size_t *p_dstlen, int codepage ) ;
#define a2wdup(string)                 a2wduplen_max_expand_cp ( string, (size_t) -1, (size_t) -1, 0, NULL, 0 )
#define w2adup(string)                 w2aduplen_max_expand_cp ( string, (size_t) -1, (size_t) -1, 0, NULL, 0 )
#define a2wduplen(string,srclen)       a2wduplen_max_expand_cp ( string, srclen, (size_t) -1, 0, NULL, 0 )
#define w2aduplen(string,srclen)       w2aduplen_max_expand_cp ( string, srclen, (size_t) -1, 0, NULL, 0 )
#define a2wduplen_expand(string,srclen,addlen,p_dstlen)  a2wduplen_max_expand_cp ( string, srclen, (size_t) -1, addlen, p_dstlen, 0 )
#define w2aduplen_expand(string,srclen,addlen,p_dstlen)  w2aduplen_max_expand_cp ( string, srclen, (size_t) -1, addlen, p_dstlen, 0 )

#ifdef __cplusplus
}
#endif



////////////////////////////////////////////
//             PATH / FILENAME            //
////////////////////////////////////////////



// pX؂蕶H
static inline int IsPathSeparator ( int c ) { return c == '\\' || c == '/' ; }

// pX؂蕶уhCuwH
static inline int IsPathOrDriveSeparator ( int c ) { return c == '\\' || c == ':' || c == '/' ; }


// MAX_PATH 𒴂pX
// max len of "\\?\C:\<path>", "\\?\UNC\<server>\<share>"
#ifdef MAX_PATH
#define MAX_LONG_PATH   0x8000
#endif

// URL ̍ő咷
#ifdef MAX_PATH
#define MAX_URL   2084     // INTERNET_MAX_URL_LENGTH (wininet.h)
#endif



////////////////////////////////////////////
//             WINDOWS VERSION            //
////////////////////////////////////////////



#ifdef _WIN64
#define IS_WIN64  1
#else
#define IS_WIN64  0
#endif

#if defined _WIN64
#define REQUIRED_MINIMUM_WINVER  0x502
#elif defined _MSC_VER && _MSC_VER >= 1500
#define REQUIRED_MINIMUM_WINVER  0x500
#else
#define REQUIRED_MINIMUM_WINVER  0x400
#endif

#if REQUIRED_MINIMUM_WINVER >= 0x500
#define IS_COMPILER_NT_ONLY   1
#else
#define IS_COMPILER_NT_ONLY   0
#endif

#if IS_COMPILER_NT_ONLY && ! defined NT_ONLY
#define NT_ONLY
#endif

#ifdef NT_ONLY
#define NTFUNC_IMPORT_IMPLICITLY
#endif

#ifdef NT_ONLY
#define IsNT()    1
#elif ! defined _MSC_VER || _MSC_VER >= 1310
#define IsNT()    ( _osplatform >= 2 )
#else
#define IsNT()    (!( _osver & 0x8000 ))
#endif


#define TEST_WINVER_(v)          ( REQUIRED_MINIMUM_WINVER <= v && _winver == v )
#define TEST_WINVER2_(v1,v2)     ( REQUIRED_MINIMUM_WINVER <= v1 && _winver >= v1 &&  _winver <= v2 )
#define TEST_WINVER_OR_LATER_(v) ( REQUIRED_MINIMUM_WINVER >= v || _winver >= v )

#define IsWin95()                ( ! IsNT() && TEST_WINVER_ ( 0x400 ) )
#define IsWin98()                ( ! IsNT() && TEST_WINVER_ ( 0x40A ) )
#define IsWinME()                ( ! IsNT() && TEST_WINVER_ ( 0x45A ) )

#define IsWin95orLater()         ( ! IsNT() && TEST_WINVER_OR_LATER_ ( 0x400 ) )
#define IsWin98orLater()         ( ! IsNT() && TEST_WINVER_OR_LATER_ ( 0x40A ) )
#define IsWinMEorLater()         ( ! IsNT() && TEST_WINVER_OR_LATER_ ( 0x45A ) )

#define IsWinNT31()              ( IsNT() && TEST_WINVER_ ( 0x30A ) )
#define IsWinNT35()              ( IsNT() && TEST_WINVER_ ( 0x332 ) )
#define IsWinNT351()             ( IsNT() && TEST_WINVER_ ( 0x333 ) )
#define IsWinNT40()              ( IsNT() && TEST_WINVER_ ( 0x400 ) )
#define IsWin2000()              ( IsNT() && TEST_WINVER_ ( 0x500 ) )
#define IsWinXP()                ( IsNT() && TEST_WINVER2_ ( 0x501, 0x502 ) )
#define IsWinVISTA()             ( IsNT() && TEST_WINVER_ ( 0x600 ) )
#define IsWin7()                 ( IsNT() && TEST_WINVER_ ( 0x601 ) )

#define IsWinNT31orLater()       ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x30A ) )
#define IsWinNT35orLater()       ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x332 ) )
#define IsWinNT351orLater()      ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x333 ) )
#define IsWinNT40orLater()       ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x400 ) )
#define IsWin2000orLater()       ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x500 ) )
#define IsWinXPorLater()         ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x501 ) )
#define IsWinVISTAorLater()      ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x600 ) )
#define IsWin7orLater()          ( IsNT() && TEST_WINVER_OR_LATER_ ( 0x601 ) )


// winmain.cpp
#if ! defined _MSC_VER || _MSC_VER >= 1500 || defined NOCRT
unsigned int GetOsverWinver_ ( int mode ) ;
#define _osver       ( GetOsverWinver_ ( 0 ) )
#define _winver      ( GetOsverWinver_ ( 1 ) )
#define _osplatform  ( GetOsverWinver_ ( -1 ) )
#endif


// winmain.cpp
#if defined _WIN64
#define IsWin64()    1
#else
int IsWin64 ( void ) ;
#endif



////////////////////////////////////////////
//               WINDOWS API              //
////////////////////////////////////////////



#if defined CreateFile     // windows.h


#include <commctrl.h>

#if ! defined _MSC_VER || _MSC_VER < 1310
#include <shlobj.h>
#else
#include <shtypes.h>
#endif


// winbase.h
#ifndef INVALID_SET_FILE_POINTER
#define INVALID_SET_FILE_POINTER    ((DWORD)-1)
#endif
#ifndef INVALID_FILE_ATTRIBUTES
#define INVALID_FILE_ATTRIBUTES     ((DWORD)-1)
#endif

#ifndef FILE_ATTRIBUTE_DEVICE
#define FILE_ATTRIBUTE_DEVICE                0x00000040
#endif
#ifndef FILE_ATTRIBUTE_NOT_CONTENT_INDEXED
#define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED   0x00002000
#endif
#ifndef FILE_ATTRIBUTE_ENCRYPTED
#define FILE_ATTRIBUTE_ENCRYPTED             0x00004000
#endif

// GetFileAttributes Őݒ\ȑ
#define FILE_ATTRIBUTES_THROUGH              \
      ( ~ ( FILE_ATTRIBUTE_COMPRESSED        \
          | FILE_ATTRIBUTE_DEVICE            \
          | FILE_ATTRIBUTE_DIRECTORY         \
          | FILE_ATTRIBUTE_ENCRYPTED         \
          | FILE_ATTRIBUTE_REPARSE_POINT     \
          | FILE_ATTRIBUTE_SPARSE_FILE       \
      ) )



#define GETPROCADDRESS(dll,type,function)          ( ! dll || ! function && ( function = (type) GetProcAddress ( dll, #function ) ) == NULL )


// winbase.h
#if ! defined _MSC_VER || _MSC_VER < 1310
#define InterlockedExchange(t,v)    InterlockedExchange ( (LONG*)(t), v )
#define InterlockedIncrement(t)     InterlockedIncrement ( (LONG*)(t) )
#define InterlockedDecrement(t)     InterlockedDecrement ( (LONG*)(t) )
#endif

// winbase.h, winmain.cpp
#if ! defined _MSC_VER
#define InterlockedExchangeAdd(a,i)    InterlockedExchangeAdd ( (LONG*)(a), i )
#elif ! defined NT_ONLY
long InterlockedExchangeAdd_95 ( long volatile *Addend, long Increment ) ;
#define InterlockedExchangeAdd InterlockedExchangeAdd_95
#endif

// winbase.h, winmain.cpp
#if ! defined _MSC_VER && ! defined __DMC__
#define InterlockedCompareExchange(d,e,c)    InterlockedCompareExchange ( (LONG*)(d), e, c )
#elif defined __DMC__
#define InterlockedCompareExchange(d,e,c)    (LONG) InterlockedCompareExchange ( (VOID**)(d), (VOID*)(e), (VOID*)(c) )
#elif ! defined NT_ONLY
long InterlockedCompareExchange_95 ( long volatile *Destination, long Exchange, long Comperand ) ;
#define InterlockedCompareExchange InterlockedCompareExchange_95
#endif


// winmain.cpp
int InitializeCriticalSectionEx ( PCRITICAL_SECTION pCriticalSection ) ;


#ifdef __cplusplus
extern "C" {
#endif

#if _WIN32_WINNT < 0x0500
BOOL WINAPI InitializeCriticalSectionAndSpinCount ( LPCRITICAL_SECTION lpCriticalSection, DWORD dwSpinCount ) ;
#endif

#if ! defined NOCRT && defined _MT
extern CRITICAL_SECTION LoadDllSection ;
#endif

#ifdef __cplusplus
}
#endif

#endif // defined CreateFile



////////////////////////////////////////////
//               INTSHCUT.H               //
////////////////////////////////////////////



// intshcut.h (wcc,gcc)
#if defined DECLARE_INTERFACE_ && defined TranslateURL && ! defined IUniformResourceLocator

#define IUniformResourceLocatorA IUniformResourceLocator
#define IID_IUniformResourceLocatorA IID_IUniformResourceLocator

#undef INTERFACE
#define INTERFACE IUniformResourceLocatorW
DECLARE_INTERFACE_ ( IUniformResourceLocatorW, IUnknown ) {
   STDMETHOD ( QueryInterface ) ( THIS_ REFIID,PVOID* ) PURE ;
   STDMETHOD_ ( ULONG, AddRef ) ( THIS ) PURE ;
   STDMETHOD_ ( ULONG, Release ) ( THIS ) PURE ;
   STDMETHOD ( SetURL ) ( THIS_ PCWSTR, DWORD ) PURE ;
   STDMETHOD ( GetURL ) ( THIS_ PWSTR* ) PURE ;
   STDMETHOD ( InvokeCommand ) ( THIS_ PURLINVOKECOMMANDINFO ) PURE ;
} ;
#undef INTERFACE

DEFINE_GUID ( IID_IUniformResourceLocatorW, 0xCABB0DA0L, 0xDA57, 0x11CF, 0x99, 0x74, 0x00, 0x20, 0xAF, 0xD7, 0x97, 0x62 ) ;

#endif // defined DECLARE_INTERFACE_ && defined TranslateURL && ! defined IUniformResourceLocator



////////////////////////////////////////////
//                  WIN64                 //
////////////////////////////////////////////



#if defined GetWindowLong     // winuser.h


#ifndef GetWindowLongPtr
#define LONG_PTR  LONG
#define ULONG_PTR ULONG
#define INT_PTR   INT
#define UINT_PTR  UINT
#define DWORD_PTR DWORD
#endif


#if ! defined _WIN64

#undef GetWindowLongPtrA
#undef GetWindowLongPtrW
#undef SetWindowLongPtrA
#undef SetWindowLongPtrW

#define GetWindowLongPtrA(h,i)      (LONG_PTR) GetWindowLongA ( h, i )
#define GetWindowLongPtrW(h,i)      (LONG_PTR) GetWindowLongW ( h, i )
#define SetWindowLongPtrA(h,i,v)    (LONG_PTR) SetWindowLongA ( h, i, (LONG)(v) )
#define SetWindowLongPtrW(h,i,v)    (LONG_PTR) SetWindowLongW ( h, i, (LONG)(v) )

#ifndef GetWindowLongPtr
#ifdef UNICODE
#define GetWindowLongPtr   GetWindowLongPtrW
#define SetWindowLongPtr   SetWindowLongPtrW
#else
#define GetWindowLongPtr   GetWindowLongPtrA
#define SetWindowLongPtr   SetWindowLongPtrA
#endif
#endif

#endif // ! defined _WIN64


#ifndef GWLP_WNDPROC
#define GWLP_WNDPROC       GWL_WNDPROC
#define GWLP_HINSTANCE     GWL_HINSTANCE
#define GWLP_HWNDPARENT    GWL_HWNDPARENT
#define GWLP_USERDATA      GWL_USERDATA
#define GWLP_ID            GWL_ID
#define DWLP_MSGRESULT     DWL_MSGRESULT
#define DWLP_DLGPROC       DWL_DLGPROC
#define DWLP_USER          DWL_USER
#endif


#if ! defined _WIN64

#undef GetClassLongPtrA
#undef GetClassLongPtrW
#undef SetClassLongPtrA
#undef SetClassLongPtrW

#define GetClassLongPtrA(h,i)       (ULONG_PTR) GetClassLongA ( h, i )
#define GetClassLongPtrW(h,i)       (ULONG_PTR) GetClassLongW ( h, i )
#define SetClassLongPtrA(h,i,v)     (ULONG_PTR) SetClassLongA ( h, i, (LONG)(v) )
#define SetClassLongPtrW(h,i,v)     (ULONG_PTR) SetClassLongW ( h, i, (LONG)(v) )

#ifndef GetClassLongPtr
#ifdef UNICODE
#define GetClassLongPtr   GetClassLongPtrW
#define SetClassLongPtr   SetClassLongPtrW
#else
#define GetClassLongPtr   GetClassLongPtrA
#define SetClassLongPtr   SetClassLongPtrA
#endif
#endif

#endif // ! defined _WIN64


#ifndef GCLP_MENUNAME
#define GCLP_MENUNAME      GCL_MENUNAME
#define GCLP_HBRBACKGROUND GCL_HBRBACKGROUND
#define GCLP_HCURSOR       GCL_HCURSOR
#define GCLP_HICON         GCL_HICON
#define GCLP_HMODULE       GCL_HMODULE
#define GCLP_WNDPROC       GCL_WNDPROC
#define GCLP_HICONSM       GCL_HICONSM
#endif


#undef MAKEINTRESOURCEW
#undef MAKEINTRESOURCEA
#define MAKEINTRESOURCEW(x)   (wchar_t*) ( ( (LONG_PTR)(x) ) & 0xFFFF )
#define MAKEINTRESOURCEA(x)   (char*)    ( ( (LONG_PTR)(x) ) & 0xFFFF )


#ifndef _WIN64
#undef  InterlockedExchangePointer
#define InterlockedExchangePointer(t,v)            (PVOID)(LONG_PTR) InterlockedExchange ( (LONG*)(t), (LONG)(LONG_PTR)(v) )
#undef  InterlockedCompareExchangePointer
#define InterlockedCompareExchangePointer(d,e,c)   (PVOID)(LONG_PTR) InterlockedCompareExchange ( (LONG*)(d), (LONG)(LONG_PTR)(e), (LONG)(LONG_PTR)(c) )
#endif


#endif // defined GetWindowLong


#ifdef EXIT_SUCCESS  // stdlib.h

#ifdef _WIN64
#define strtolp(s,p,b)     (intptr_t) _strtoi64 ( s, p, b )
#define wcstolp(s,p,b)     (intptr_t) _wcstoi64 ( s, p, b )
#define strtoulp(s,p,b)    (intptr_t) _strtoui64 ( s, p, b )
#define wcstoulp(s,p,b)    (intptr_t) _wcstoui64 ( s, p, b )
#else
#define strtolp(s,p,b)     (intptr_t) strtol ( s, p, b )
#define wcstolp(s,p,b)     (intptr_t) wcstol ( s, p, b )
#define strtoulp(s,p,b)    (intptr_t) strtoul ( s, p, b )
#define wcstoulp(s,p,b)    (intptr_t) wcstoul ( s, p, b )
#endif

#endif


// Strings
#define WIN3264BIT_SUFFIX_W      ( IS_WIN64 ) ? L"(64-bit)" : L"(32-bit)"
#define WIN3264BIT_SUFFIX_A      ( IS_WIN64 ) ?  "(64-bit)" :  "(32-bit)"

#ifdef UNICODE
#define WIN3264BIT_SUFFIX  WIN3264BIT_SUFFIX_W
#else
#define WIN3264BIT_SUFFIX  WIN3264BIT_SUFFIX_A
#endif



////////////////////////////////////////////
//               MULTITHREAD              //
////////////////////////////////////////////



typedef struct {

   // thread.cpp
   int ( *pFunction ) ( void *pInitialData ) ;
   void *pInitialData ;

   // res.cpp
   char *szGetStringA ;
   wchar_t *szGetStringW ;
   char *szCopyrightA ;

   // environ.cpp
   char *szEnvironA ;
   wchar_t *szEnvironW ;

} THREAD_DATA ;



THREAD_DATA *GetThreadData ( void ) ;
THREAD_DATA *AllocThreadData ( void ) ;
int InitializeThreadData ( THREAD_DATA *pThreadData ) ;
void FreeThreadData ( THREAD_DATA *pThreadData ) ;



////////////////////////////////////////////
//                 THE END                //
////////////////////////////////////////////



#endif // MSC_H


