// nls.cpp

#include <windows.h>
#include <stdlib.h>
#include <errno.h>
#include "msc.h"
#include "codepage.h"
#include "nls.h"



//////////////////////////////
//        Zbg        //
//////////////////////////////



// ZbgR[hy[WԂ
int CharsetToCodePage ( int nCharset ) {

   int nCodePage ;

   switch ( nCharset ) {
      case ANSI_CHARSET :        nCodePage = CP_ANSI_EUROPEAN ; break ;
      case SHIFTJIS_CHARSET :    nCodePage = CP_JAPANESE ; break ;
      case HANGUL_CHARSET :      nCodePage = CP_KOREAN ; break ;
      case GB2312_CHARSET :      nCodePage = CP_CHINESE_SIMPLIFIED ; break ;
      case CHINESEBIG5_CHARSET : nCodePage = CP_CHINESE_TRADITIONAL ; break ;
      case GREEK_CHARSET :       nCodePage = CP_ANSI_GREEK ; break ;
      case TURKISH_CHARSET :     nCodePage = CP_ANSI_TURKISH ; break ;
      case VIETNAMESE_CHARSET :  nCodePage = CP_ANSI_VIETNAMESE ; break ;
      case HEBREW_CHARSET :      nCodePage = CP_ANSI_HEBREW ; break ;
      case ARABIC_CHARSET :      nCodePage = CP_ANSI_ARABIC ; break ;
      case BALTIC_CHARSET :      nCodePage = CP_ANSI_BALTIC ; break ;
      case RUSSIAN_CHARSET :     nCodePage = CP_ANSI_CYRILLIC ; break ;
      case THAI_CHARSET :        nCodePage = CP_THAI ; break ;
      case EASTEUROPE_CHARSET :  nCodePage = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case SYMBOL_CHARSET :      nCodePage = CP_SYMBOL ; break ;
      case JOHAB_CHARSET :       nCodePage = CP_KOREAN_JOHAB ; break ;
      case MAC_CHARSET :         nCodePage = CP_MAC_EUROPEAN ; break ;
      case OEM_CHARSET :         nCodePage = CP_US ; break ;
      default :                  nCodePage = CP_ANSI_EUROPEAN ; break ;
   }

   return nCodePage ;
}



// R[hy[W當ZbgԂ
int CodePageToCharset ( int nCodePage ) {

   int nCharset ;

   switch ( nCodePage ) {
      case CP_ANSI_EUROPEAN :          nCharset = ANSI_CHARSET ; break ;
      case CP_JAPANESE :               nCharset = SHIFTJIS_CHARSET ; break ;
      case CP_KOREAN :                 nCharset = HANGUL_CHARSET ; break ;
      case CP_CHINESE_SIMPLIFIED :     nCharset = GB2312_CHARSET ; break ;
      case CP_CHINESE_TRADITIONAL :    nCharset = CHINESEBIG5_CHARSET ; break ;
      case CP_ANSI_GREEK :             nCharset = GREEK_CHARSET ; break ;
      case CP_ANSI_TURKISH :           nCharset = TURKISH_CHARSET ; break ;
      case CP_ANSI_VIETNAMESE :        nCharset = VIETNAMESE_CHARSET ; break ;
      case CP_ANSI_HEBREW :            nCharset = HEBREW_CHARSET ; break ;
      case CP_ANSI_ARABIC :            nCharset = ARABIC_CHARSET ; break ;
      case CP_ANSI_BALTIC :            nCharset = BALTIC_CHARSET ; break ;
      case CP_ANSI_CYRILLIC :          nCharset = RUSSIAN_CHARSET ; break ;
      case CP_THAI :                   nCharset = THAI_CHARSET ; break ;
      case CP_ANSI_CENTRAL_EUROPEAN :  nCharset = EASTEUROPE_CHARSET ; break ;
      case CP_SYMBOL :                 nCharset = SYMBOL_CHARSET ; break ;
      case CP_KOREAN_JOHAB :           nCharset = JOHAB_CHARSET ; break ;
      case CP_MAC_EUROPEAN :           nCharset = MAC_CHARSET ; break ;
      case CP_US :                     nCharset = OEM_CHARSET ; break ;
      default :                        nCharset = ANSI_CHARSET ; break ;
   }

   return nCharset ;
}



// Zbg}`oCgǂ
int IsMultiByteCharset ( int nCharset ) {

   int nResult ;

   switch ( nCharset ) {
      case SHIFTJIS_CHARSET :
      case HANGUL_CHARSET :
      case GB2312_CHARSET :
      case CHINESEBIG5_CHARSET :
      case JOHAB_CHARSET :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



//////////////////////////////
//       R[hy[W       //
//////////////////////////////



// [ĥR[hy[W烂[ĥȂR[hy[WԂ
// UTF8/16/32 w肷 CP_UTF32 Ԃ
int GetModelessCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      // Unicode
      case CP_UTF7 :                      nResult = CP_UTF32 ; break ;
      case CP_UTF8 :                      nResult = CP_UTF32 ; break ;
      case CP_UTF16 :                     nResult = CP_UTF32 ; break ;
      case CP_UTF16_BE :                  nResult = CP_UTF32 ; break ;
      case CP_UTF32 :                     nResult = CP_UTF32 ; break ;
      case CP_UTF32_BE :                  nResult = CP_UTF32 ; break ;
      // Japanese
      case CP_ISO_JAPANESE :              nResult = CP_JAPANESE ; break ;
      case CP_ISO_JAPANESE_AND_KANA :     nResult = CP_JAPANESE ; break ;
      case CP_ISO_JAPANESE_AND_KANA_SIO : nResult = CP_JAPANESE ; break ;
      // Korean
      case CP_ISO_KOREAN :                nResult = CP_KOREAN ; break ;
      // Chinese
      case CP_HZ_CHINESE_SIMPLIFIED :     nResult = CP_CHINESE_SIMPLIFIED ; break ;
      // etc.
      default :                           nResult = nCodePage ; break ;
   }

   return nResult ;
}



// [ĥȂR[hy[W Windows {R[hy[WԂ
// UTF32 w肷 CP_UTF16 Ԃ
int GetWinCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      // Unicode
      case CP_UTF32 :                     nResult = CP_UTF16 ; break ;
      // Japanese
      case CP_JAPANESE :                  nResult = CP_JAPANESE ; break ;
      case CP_MAC_JAPANESE :              nResult = CP_JAPANESE ; break ;
      case CP_EUC_JAPANESE :              nResult = CP_JAPANESE ; break ;
      case CP_EUC_JAPANESE_MS :           nResult = CP_JAPANESE ; break ;
      // Korean
      case CP_KOREAN :                    nResult = CP_KOREAN ; break ;
      case CP_KOREAN_JOHAB :              nResult = CP_KOREAN ; break ;
      case CP_MAC_KOREAN :                nResult = CP_KOREAN ; break ;
      case CP_EUC_KOREAN :                nResult = CP_KOREAN ; break ;
      case CP_EUC_KOREAN_2 :              nResult = CP_KOREAN ; break ;
      // Chinese
      case CP_CHINESE_SIMPLIFIED :        nResult = CP_CHINESE_SIMPLIFIED ; break ;
      case CP_CHINESE_SIMPLIFIED_EX :     nResult = CP_CHINESE_SIMPLIFIED ; break ;
      case CP_MAC_CHINESE_SIMPLIFIED :    nResult = CP_CHINESE_SIMPLIFIED ; break ;
      case CP_EUC_CHINESE_SIMPLIFIED :    nResult = CP_CHINESE_SIMPLIFIED ; break ;
      case CP_EUC_CHINESE_SIMPLIFIED_2 :  nResult = CP_CHINESE_SIMPLIFIED ; break ;
      // Chinese
      case CP_CHINESE_TRADITIONAL :       nResult = CP_CHINESE_TRADITIONAL ; break ;
      case CP_CHINESE_HKSCS :             nResult = CP_CHINESE_TRADITIONAL ; break ;
      case CP_MAC_CHINESE_TRADITIONAL :   nResult = CP_CHINESE_TRADITIONAL ; break ;
      case CP_CHINESE_TRADITIONAL_2 :     nResult = CP_CHINESE_TRADITIONAL ; break ;
      case CP_EUC_CHINESE_TRADITIONAL :   nResult = CP_CHINESE_TRADITIONAL ; break ;
      // Thai
      case CP_THAI :                      nResult = CP_THAI ; break ;
      case CP_MAC_THAI :                  nResult = CP_THAI ; break ;
      // European
      case CP_WIN31_EUROPEAN :            nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_EUROPEAN :                  nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_EUROPEAN_EURO :             nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_PORTUGUESE :                nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_ICELANDIC :                 nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_CANADIAN_FRENCH :           nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_NORDIC :                    nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_ANSI_EUROPEAN :             nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_MAC_EUROPEAN :              nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_MAC_ICELANDIC :             nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_ISO_EUROPEAN :              nResult = CP_ANSI_EUROPEAN ; break ;
      case CP_ISO_NORDIC :                nResult = CP_ANSI_EUROPEAN ; break ;
      // Central European
      case CP_CENTRAL_EUROPEAN :          nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_ANSI_CENTRAL_EUROPEAN :     nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_MAC_CENTRAL_EUROPEAN :      nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_ISO_CENTRAL_EUROPEAN :      nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_MAC_CROATIAN :              nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_MAC_ROMANIAN :              nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      case CP_ISO_ROMANIAN :              nResult = CP_ANSI_CENTRAL_EUROPEAN ; break ;
      // Greek
      case CP_GREEK :                     nResult = CP_ANSI_GREEK ; break ;
      case CP_MODERN_GREEK :              nResult = CP_ANSI_GREEK ; break ;
      case CP_ANSI_GREEK :                nResult = CP_ANSI_GREEK ; break ;
      case CP_MAC_GREEK :                 nResult = CP_ANSI_GREEK ; break ;
      case CP_ISO_GREEK :                 nResult = CP_ANSI_GREEK ; break ;
      // Cyrillic
      case CP_CYRILLIC :                  nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_RUSSIAN :                   nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_ANSI_CYRILLIC :             nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_MAC_CYRILLIC :              nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_MAC_UKRAINIAN :             nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8R :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8U :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_ISO_CYRILLIC :              nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8RU :           nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8T :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8C :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8O :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KOI8UNI :          nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_ECMA :             nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_CYRWIN :           nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_ASIAN :            nResult = CP_ANSI_CYRILLIC ; break ;
      case CP_CYRILLIC_KAZ :              nResult = CP_ANSI_CYRILLIC ; break ;
      // Turkish
      case CP_TURKISH :                   nResult = CP_ANSI_TURKISH ; break ;
      case CP_ANSI_TURKISH :              nResult = CP_ANSI_TURKISH ; break ;
      case CP_MAC_TURKISH :               nResult = CP_ANSI_TURKISH ; break ;
      case CP_ISO_TURKISH_OLD :           nResult = CP_ANSI_TURKISH ; break ;
      case CP_ISO_TURKISH :               nResult = CP_ANSI_TURKISH ; break ;
      // Baltic
      case CP_BALTIC :                    nResult = CP_ANSI_BALTIC ; break ;
      case CP_ANSI_BALTIC :               nResult = CP_ANSI_BALTIC ; break ;
      case CP_ISO_BALTIC :                nResult = CP_ANSI_BALTIC ; break ;
      case CP_ISO_BALTIC_EX :             nResult = CP_ANSI_BALTIC ; break ;
      // Arabic
      case CP_ARABIC_ASMO_708 :           nResult = CP_ANSI_ARABIC ; break ;
      case CP_ARABIC_ASMO_449P :          nResult = CP_ANSI_ARABIC ; break ;
      case CP_ARABIC_TP :                 nResult = CP_ANSI_ARABIC ; break ;
      case CP_ARABIC_NAFITHA :            nResult = CP_ANSI_ARABIC ; break ;
      case CP_ARABIC_TP_ASMO :            nResult = CP_ANSI_ARABIC ; break ;
      case CP_ARABIC :                    nResult = CP_ANSI_ARABIC ; break ;
      case CP_ANSI_ARABIC :               nResult = CP_ANSI_ARABIC ; break ;
      case CP_MAC_ARABIC :                nResult = CP_ANSI_ARABIC ; break ;
      case CP_ISO_ARABIC :                nResult = CP_ANSI_ARABIC ; break ;
      case CP_PERSIAN_ISIRI :             nResult = CP_ANSI_ARABIC ; break ;
      // Hebrew
      case CP_HEBREW_OLD :                nResult = CP_ANSI_HEBREW ; break ;
      case CP_HEBREW :                    nResult = CP_ANSI_HEBREW ; break ;
      case CP_ANSI_HEBREW :               nResult = CP_ANSI_HEBREW ; break ;
      case CP_MAC_HEBREW :                nResult = CP_ANSI_HEBREW ; break ;
      case CP_ISO_HEBREW_VISUAL :         nResult = CP_ANSI_HEBREW ; break ;
      case CP_ISO_HEBREW_LOGICAL :        nResult = CP_ANSI_HEBREW ; break ;
      // etc.
      default :
         if ( IsCodePageVietnamese ( nCodePage ) )    { nResult = CP_ANSI_VIETNAMESE ; break ; }
         if ( IsTaiwanLegacyCodePage ( nCodePage ) )  { nResult = CP_CHINESE_TRADITIONAL ; break ; }
         nResult = nCodePage ; break ;
   }

   return nResult ;
}



// Windows {R[hy[W}`oCgǂ
int IsMultiByteCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_JAPANESE :
      case CP_KOREAN :
      case CP_CHINESE_SIMPLIFIED :
      case CP_CHINESE_TRADITIONAL :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// xgĩR[hy[Wǂ
int IsCodePageVietnamese ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_ANSI_VIETNAMESE :
      case CP_VIETNAMESE_TCVN :
      case CP_VIETNAMESE_TCVN2 :
      case CP_VIETNAMESE_TCVN3 :
      case CP_VIETNAMESE_VISCII :
      case CP_VIETNAMESE_VPS :
      case CP_VIETNAMESE_VNI :
      case CP_VIETNAMESE_VIQR :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// Macintosh ̃R[hy[Wǂ
int IsMacCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_MAC_EUROPEAN :
      case CP_MAC_JAPANESE :
      case CP_MAC_CHINESE_TRADITIONAL :
      case CP_MAC_KOREAN :
      case CP_MAC_ARABIC :
      case CP_MAC_HEBREW :
      case CP_MAC_GREEK :
      case CP_MAC_CYRILLIC :
      case CP_MAC_CHINESE_SIMPLIFIED :
      case CP_MAC_ROMANIAN :
      case CP_MAC_UKRAINIAN :
      case CP_MAC_THAI :
      case CP_MAC_CENTRAL_EUROPEAN :
      case CP_MAC_ICELANDIC :
      case CP_MAC_TURKISH :
      case CP_MAC_CROATIAN :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// p̌ÂR[hy[Wǂ
int IsTaiwanLegacyCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_CHINESE_TRADITIONAL_CNS :
      case CP_CHINESE_TRADITIONAL_TCA :
      case CP_CHINESE_TRADITIONAL_ETEN :
      case CP_CHINESE_TRADITIONAL_IBM5550 :
      case CP_CHINESE_TRADITIONAL_TELETEXT :
      case CP_CHINESE_TRADITIONAL_WANG :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// ISCII R[hy[Wǂ
int IsCodePageIscii ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_ISCII_DEVANAGARI :
      case CP_ISCII_BENGALI :
      case CP_ISCII_TAMIL :
      case CP_ISCII_TELUGU :
      case CP_ISCII_ASSAMESE :
      case CP_ISCII_ORIYA :
      case CP_ISCII_KANNADA :
      case CP_ISCII_MALAYALAM :
      case CP_ISCII_GUJARATHI :
      case CP_ISCII_PANJABI :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// ^~p R[hy[Wǂ
int IsCodePageTamil ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_TAMIL_TSCII :
      case CP_TAMIL_TAM :
      case CP_TAMIL_TAB :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// Ch̃R[hy[Wǂ
int IsCodePageIndic ( int nCodePage ) {
   return IsCodePageIscii ( nCodePage ) || IsCodePageTamil ( nCodePage ) ;
}



// EBCDIC ̃R[hy[Wǂ
int IsCodePageEbcdic ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_EBCDIC_US_CANADA :
      case CP_EBCDIC_INTERNATIONAL :
      case CP_EBCDIC_MULTILINGUAL :
      case CP_EBCDIC_GREEK_MODERN :
      case CP_EBCDIC_AIX_PAKISTAN :
      case CP_EBCDIC_CYRILLIC :
      case CP_EBCDIC_TURKISH :
      case CP_EBCDIC_OPEN_EDITION_US :
      case CP_EBCDIC_SYSTEM_390 :
      case CP_EBCDIC_PERSIAN :
      case CP_EBCDIC_PERSIAN_PC :
      case CP_EBCDIC_LATVIA_LITHUANIA :
      case CP_EBCDIC_ESTONIA :
      case CP_EBCDIC_UKRAINE :
      case CP_EBCDIC_AIX_UKRAINE :
      case CP_EBCDIC_VIETNAMESE :
      case CP_EBCDIC_LAO :
      case CP_EBCDIC_DEVANAGARI :
      case CP_EBCDIC_US_CANADA_EURO :
      case CP_EBCDIC_GERMANY_EURO :
      case CP_EBCDIC_DENMARK_NORWAY_EURO :
      case CP_EBCDIC_FINLAND_SWEDEN_EURO :
      case CP_EBCDIC_ITALY_EURO :
      case CP_EBCDIC_SPAIN_EURO :
      case CP_EBCDIC_UK_EURO :
      case CP_EBCDIC_FRANCE_EURO :
      case CP_EBCDIC_INTERNATIONAL_EURO :
      case CP_EBCDIC_ICELANDIC_EURO :
      case CP_EBCDIC_MULTILINGUAL_EUR :
      case CP_EBCDIC_CYRILLIC_EURO :
      case CP_EBCDIC_TURKEY_EURO :
      case CP_EBCDIC_BALTIC_EURO :
      case CP_EBCDIC_ESTONIA_EURO :
      case CP_EBCDIC_UKRAINE_EURO :
      case CP_EBCDIC_VIETNAMESE_EURO :

      case CP_EBCDIC_GERMANY :
      case CP_EBCDIC_DENMARK_NORWAY :
      case CP_EBCDIC_FINLAND_SWEDEN :
      case CP_EBCDIC_ITALY :
      case CP_EBCDIC_SPAIN :
      case CP_EBCDIC_UK :
      case CP_EBCDIC_JAPANESE_KATAKANA :
      case CP_EBCDIC_FRANCE :
      case CP_EBCDIC_ARABIC :
      case CP_EBCDIC_GREEK :
      case CP_EBCDIC_HEBREW :
      case CP_EBCDIC_KOREAN_EXTENDED :
      case CP_EBCDIC_THAI :
      case CP_EBCDIC_ICELANDIC :
      case CP_EBCDIC_RUSSIAN :
      case CP_EBCDIC_TURKISH2 :
      case CP_EBCDIC_LATIN1_OPEN_SYSTEM :
      case CP_EBCDIC_SERBIAN_BULGARIAN :

      case CP_EBCDIC_JAPANESE_AND_KATAKANA :
      case CP_EBCDIC_JAPANESE_AND_LATIN :
      case CP_EBCDIC_JAPANESE_AND_US_CANADA :
      case CP_EBCDIC_KOREAN_AND_KOREAN_EX :
      case CP_EBCDIC_SIMPLIFIED_CHINESE :
      case CP_EBCDIC_TRADITIONAL_CHINESE :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



// VXẽR[hy[W HKSCS ǂ
int IsOsCodePageHkscs ( void ) {

   if ( GetACP () != CP_CHINESE_TRADITIONAL ) return 0 ;

   return IsValidCodePageHkscs () ;
}



// HKSCS LȃR[hy[Wǂ
int IsValidCodePageHkscs ( void ) {

   if ( ! IsValidCodePage ( CP_CHINESE_TRADITIONAL ) ) return 0 ;

   wchar_t szBuffer [ 2 ] ;

   int nLen = MultiByteToWideChar ( CP_CHINESE_TRADITIONAL, 0, "\x9D\xF1", 2, szBuffer, 2 ) ;
   if ( nLen == 1 && *szBuffer == 0x66F1 ) return 1 ;

   return 0 ;
}



// CP_THREAD_ACP ɑΉR[hy[WԂ
// G[Ȃ 0 Ԃ
int GetThreadACP ( void ) {

   if ( IsNT () ) {
      wchar_t szResult [ 0x10 ] ;
      if ( GetLocaleInfoW ( GetThreadLocale (), LOCALE_IDEFAULTANSICODEPAGE, szResult, 0x10 ) ) {
         errno = 0 ;
         int nResult = wcstoul ( szResult, NULL, 10 ) ;
         if ( ! errno && nResult >= 0x10 ) return nResult ;
      }
   }
   else {
      char szResult [ 0x10 ] ;
      if ( GetLocaleInfoA ( GetThreadLocale (), LOCALE_IDEFAULTANSICODEPAGE, szResult, 0x10 ) ) {
         errno = 0 ;
         int nResult = strtoul ( szResult, NULL, 10 ) ;
         if ( ! errno && nResult >= 0x10 ) return nResult ;
      }
   }

   return 0 ;
}



// Some compilers do not support
#ifndef LOCALE_IDEFAULTMACCODEPAGE
#define LOCALE_IDEFAULTMACCODEPAGE  0x00001011   /* default mac code page */
#endif



// CP_MACCP ɑΉR[hy[WԂ
// G[Ȃ 0 Ԃ
int GetMacCP ( void ) {

   if ( IsNT () ) {
      wchar_t szResult [ 0x10 ] ;
      if ( GetLocaleInfoW ( LOCALE_USER_DEFAULT, LOCALE_IDEFAULTMACCODEPAGE, szResult, 0x10 ) ) {
         errno = 0 ;
         int nResult = wcstoul ( szResult, NULL, 10 ) ;
         if ( ! errno && nResult >= 0x10 ) return nResult ;
      }
   }
   else {
      char szResult [ 0x10 ] ;
      if ( GetLocaleInfoA ( LOCALE_USER_DEFAULT, LOCALE_IDEFAULTMACCODEPAGE, szResult, 0x10 ) ) {
         errno = 0 ;
         int nResult = strtoul ( szResult, NULL, 10 ) ;
         if ( ! errno && nResult >= 0x10 ) return nResult ;
      }
   }

   return 0 ;
}



//////////////////////////////
//        ꎯʎq        //
//////////////////////////////



// ZbgK؂ȌꎯʎqԂ
// ŶȂ 0 Ԃ
int CharsetToLangId ( int nCharset ) {

   int nLang ;

   switch ( nCharset ) {
      case ANSI_CHARSET :        nLang = MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ; break ;
      case GREEK_CHARSET :       nLang = MAKELANGID ( LANG_GREEK, SUBLANG_DEFAULT ) ; break ;
      case RUSSIAN_CHARSET :     nLang = MAKELANGID ( LANG_RUSSIAN, SUBLANG_DEFAULT ) ; break ;
      case BALTIC_CHARSET :      nLang = MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ; break ;
      case EASTEUROPE_CHARSET :  nLang = MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ; break ;
      case TURKISH_CHARSET :     nLang = MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ; break ;
      case SHIFTJIS_CHARSET :    nLang = MAKELANGID ( LANG_JAPANESE, SUBLANG_DEFAULT ) ; break ;
      case HANGUL_CHARSET :      nLang = MAKELANGID ( LANG_KOREAN, SUBLANG_DEFAULT ) ; break ;
      case GB2312_CHARSET :      nLang = MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_SIMPLIFIED ) ; break ;
      case CHINESEBIG5_CHARSET : nLang = MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_TRADITIONAL ) ; break ;
      case THAI_CHARSET :        nLang = MAKELANGID ( LANG_THAI, SUBLANG_DEFAULT ) ; break ;
      case VIETNAMESE_CHARSET :  nLang = MAKELANGID ( LANG_VIETNAMESE, SUBLANG_DEFAULT ) ; break ;
      case HEBREW_CHARSET :      nLang = MAKELANGID ( LANG_HEBREW, SUBLANG_DEFAULT ) ; break ;
      case ARABIC_CHARSET :      nLang = MAKELANGID ( LANG_ARABIC, SUBLANG_DEFAULT ) ; break ;
      default :                  nLang = 0 ; break ;
   }

   return nLang ;
}



// w̌ꎯʎq CJK ǂ
int IsLangIdCjk ( int nLangId ) {

   nLangId = PRIMARYLANGID ( nLangId ) ;

   int nResult ;

   switch ( nLangId ) {
      case LANG_JAPANESE :
      case LANG_KOREAN :
      case LANG_CHINESE :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



