// convchar.cpp

#include <windows.h>
#include <limits.h>
#include "msc.h"
#include "convchar.h"
#include "codepage.h"



#define IS_ALLOW_FOURBYTE  0     // SoCgɑΉ邩

#define BUFFER_SIZE     8



// Unicodegĕϊ
// [ĥR[hy[W CP_UTF16/32 ̂
// ꂽԂ
// G[Ȃ 0 Ԃ
int ConvertCharacter ( int C, int nSrcCodePage, int nDstCodePage ) {

   char szBufferA [ BUFFER_SIZE ] ;
   wchar_t szBufferW [ BUFFER_SIZE ] ;
   int nLen ;


   if ( nSrcCodePage == CP_UTF32 || nSrcCodePage == CP_UTF16 ) {
      if ( ! ( C & 0xFFFF0000 ) ) {
         szBufferW [ 0 ] = (wchar_t) C ;
         nLen = 1 ;
      }
      else {
         if ( IS_ALLOW_FOURBYTE ) {
            if ( nSrcCodePage == CP_UTF32 ) {
               if ( C > UTF16_MAX ) return 0 ;
               C = MAKE_UNICODE_SURROGATE ( C ) ;
            }
            szBufferW [ 0 ] = (wchar_t) ( C >> 16 ) ;
            szBufferW [ 1 ] = (wchar_t) C ;
            nLen = 2 ;
         }
         else return 0 ;
      }
   }
   else {

      if ( ! ( C & 0xFFFFFF00 ) ) {
         szBufferA [ 0 ] = (unsigned char) C ;
         nLen = 1 ;
      }
      else if ( ! ( C & 0xFFFF0000 ) ) {
         szBufferA [ 0 ] = (unsigned char) ( C >> 8 ) ;
         szBufferA [ 1 ] = (unsigned char) C ;
         nLen = 2 ;
      }
      else {
         if ( IS_ALLOW_FOURBYTE ) {
            if ( ! ( C & 0xFF0000 ) ) {
               szBufferA [ 0 ] = (unsigned char) ( C >> 16 ) ;
               szBufferA [ 1 ] = (unsigned char) ( C >> 8 ) ;
               szBufferA [ 2 ] = (unsigned char) C ;
               nLen = 3 ;
            }
            else {
               szBufferA [ 0 ] = (unsigned char) ( C >> 24 ) ;
               szBufferA [ 1 ] = (unsigned char) ( C >> 16 ) ;
               szBufferA [ 2 ] = (unsigned char) ( C >> 8 ) ;
               szBufferA [ 3 ] = (unsigned char) C ;
               nLen = 4 ;
            }
         }
         else return 0 ;
      }

      nLen = MultiByteToWideChar ( nSrcCodePage, 0, szBufferA, nLen, szBufferW, BUFFER_SIZE ) ;
      if ( nLen == 0 ) return 0 ;
      if ( nLen > ( ( IS_ALLOW_FOURBYTE ) ? 2 : 1 ) ) return 0 ;

      if ( *szBufferW == L'?' && C != '?' && ( nSrcCodePage != CP_US_ASCII || ( C & 0x7F ) != '?' ) ) return 0 ;
      if ( *szBufferW == 0x30FB ) {
         if ( nSrcCodePage == CP_JAPANESE && C != 0x8145 ) return 0 ;
         if ( nSrcCodePage == CP_EUC_JAPANESE_MS && C != 0xA1A6 ) return 0 ;
      }
   }


   if ( ! IS_ALLOW_FOURBYTE || nLen == 1 ) {
      if ( IsUnicodeSurrogate ( *szBufferW ) ) return 0 ;
   }


   if ( nDstCodePage == CP_UTF32 || nDstCodePage == CP_UTF16 ) {
      if ( IS_ALLOW_FOURBYTE && nLen == 2 ) {
         if ( nDstCodePage == CP_UTF32 ) return MAKE_UNICODE_SCALAR ( szBufferW [ 0 ], szBufferW [ 1 ] ) ;
         else                            return ( szBufferW [ 0 ] << 16 ) + szBufferW [ 1 ] ;
      }
      if ( nLen > 1 ) return 0 ;
      return szBufferW [ 0 ] ;
   }


   int IsUsedDefaultChar ;
   nLen = WideCharToMultiByte ( nDstCodePage, 0, szBufferW, nLen, szBufferA, BUFFER_SIZE, NULL, & IsUsedDefaultChar ) ;
   if ( IsUsedDefaultChar ) return 0 ;

   switch ( nLen ) {
      case 1 : return (unsigned char) szBufferA [ 0 ] ;
      case 2 : return ( ( (unsigned char) szBufferA [ 0 ] ) << 8 ) + ( (unsigned char) szBufferA [ 1 ] ) ;
      case 3 : if ( ! IS_ALLOW_FOURBYTE ) break ;
               return ( ( (unsigned char) szBufferA [ 0 ] ) << 16 ) + ( ( (unsigned char) szBufferA [ 1 ] ) << 8 ) + ( (unsigned char) szBufferA [ 2 ] ) ;
      case 4 : if ( ! IS_ALLOW_FOURBYTE ) break ;
               return ( ( (unsigned char) szBufferA [ 0 ] ) << 24 ) + ( ( (unsigned char) szBufferA [ 1 ] ) << 16 ) + ( ( (unsigned char) szBufferA [ 2 ] ) << 8 ) + ( (unsigned char) szBufferA [ 3 ] ) ;
      default : break ;
   }


   return 0 ;
}



