// fontname.cpp

#include <windows.h>
#include <string.h>
#include "msc.h"
#include "stringex.h"
#include "fontname.h"



typedef struct {
   int nCharset ;
   const char *szEnglishName ;
   const char *szLocalizedName ;
} LOCALIZED_FONTNAME ;



static const LOCALIZED_FONTNAME LocalizedFontname [] = {
   { SHIFTJIS_CHARSET, "MS Mincho", "\x82\x6C\x82\x72 \x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "MS Gothic", "\x82\x6C\x82\x72 \x83\x53\x83\x56\x83\x62\x83\x4E" },
#if defined RTFCONV_DLL
   { SHIFTJIS_CHARSET, "MS PMincho", "\x82\x6C\x82\x72 \x82\x6F\x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "MS PGothic", "\x82\x6C\x82\x72 \x82\x6F\x83\x53\x83\x56\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "Meiryo", "\x83\x81\x83\x43\x83\x8A\x83\x49" },
   { SHIFTJIS_CHARSET, "Meiryo Italic", "\x83\x81\x83\x43\x83\x8A\x83\x49 \x83\x43\x83\x5E\x83\x8A\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "Meiryo Bold", "\x83\x81\x83\x43\x83\x8A\x83\x49 \x83\x7B\x81\x5B\x83\x8B\x83\x68" },
   { SHIFTJIS_CHARSET, "Meiryo Bold Italic", "\x83\x81\x83\x43\x83\x8A\x83\x49 \x83\x7B\x81\x5B\x83\x8B\x83\x68 \x83\x43\x83\x5E\x83\x8A\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "HGGothicE", "\x48\x47\xBA\xDE\xBC\xAF\xB8\x45" },
   { SHIFTJIS_CHARSET, "HGPGothicE", "\x48\x47\x50\xBA\xDE\xBC\xAF\xB8\x45" },
   { SHIFTJIS_CHARSET, "HGSGothicE", "\x48\x47\x53\xBA\xDE\xBC\xAF\xB8\x45" },
   { SHIFTJIS_CHARSET, "HGGothicM", "\x48\x47\xBA\xDE\xBC\xAF\xB8\x4D" },
   { SHIFTJIS_CHARSET, "HGPGothicM", "\x48\x47\x50\xBA\xDE\xBC\xAF\xB8\x4D" },
   { SHIFTJIS_CHARSET, "HGSGothicM", "\x48\x47\x53\xBA\xDE\xBC\xAF\xB8\x4D" },
   { SHIFTJIS_CHARSET, "HGGyoshotai", "\x48\x47\x8D\x73\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGPGyoshotai", "\x48\x47\x50\x8D\x73\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGSGyoshotai", "\x48\x47\x53\x8D\x73\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGSoeiKakugothicUB", "\x48\x47\x91\x6E\x89\x70\x8A\x70\xBA\xDE\xBC\xAF\xB8\x55\x42" },
   { SHIFTJIS_CHARSET, "HGPSoeiKakugothicUB", "\x48\x47\x50\x91\x6E\x89\x70\x8A\x70\xBA\xDE\xBC\xAF\xB8\x55\x42" },
   { SHIFTJIS_CHARSET, "HGSSoeiKakugothicUB", "\x48\x47\x53\x91\x6E\x89\x70\x8A\x70\xBA\xDE\xBC\xAF\xB8\x55\x42" },
   { SHIFTJIS_CHARSET, "HGSoeiKakupoptai", "\x48\x47\x91\x6E\x89\x70\x8A\x70\xCE\xDF\xAF\xCC\xDF\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGPSoeiKakupoptai", "\x48\x47\x50\x91\x6E\x89\x70\x8A\x70\xCE\xDF\xAF\xCC\xDF\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGSSoeiKakupoptai", "\x48\x47\x53\x91\x6E\x89\x70\x8A\x70\xCE\xDF\xAF\xCC\xDF\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGSeikaishotaiPRO", "\x48\x47\x90\xB3\x9E\xB2\x8F\x91\x91\xCC-\x50\x52\x4F" },
   { SHIFTJIS_CHARSET, "HGMaruGothicMPRO", "\x48\x47\x8A\xDB\xBA\xDE\xBC\xAF\xB8\x4D-\x50\x52\x4F" },
   { SHIFTJIS_CHARSET, "HGKyokashotai", "\x48\x47\x8B\xB3\x89\xC8\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGPKyokashotai", "\x48\x47\x50\x8B\xB3\x89\xC8\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGSKyokashotai", "\x48\x47\x53\x8B\xB3\x89\xC8\x8F\x91\x91\xCC" },
   { SHIFTJIS_CHARSET, "HGMinchoB", "\x48\x47\x96\xBE\x92\xA9\x42" },
   { SHIFTJIS_CHARSET, "HGPMinchoB", "\x48\x47\x50\x96\xBE\x92\xA9\x42" },
   { SHIFTJIS_CHARSET, "HGSMinchoB", "\x48\x47\x53\x96\xBE\x92\xA9\x42" },
   { SHIFTJIS_CHARSET, "HGMinchoE", "\x48\x47\x96\xBE\x92\xA9\x45" },
   { SHIFTJIS_CHARSET, "HGPMinchoE", "\x48\x47\x50\x96\xBE\x92\xA9\x45" },
   { SHIFTJIS_CHARSET, "HGSMinchoE", "\x48\x47\x53\x96\xBE\x92\xA9\x45" },
   { SHIFTJIS_CHARSET, "HGSoeiPresenceEB", "\x48\x47\x91\x6E\x89\x70\xCC\xDF\xDA\xBE\xDE\xDD\xBD\x45\x42" },
   { SHIFTJIS_CHARSET, "HGPSoeiPresenceEB", "\x48\x47\x50\x91\x6E\x89\x70\xCC\xDF\xDA\xBE\xDE\xDD\xBD\x45\x42" },
   { SHIFTJIS_CHARSET, "HGSSoeiPresenceEB", "\x48\x47\x53\x91\x6E\x89\x70\xCC\xDF\xDA\xBE\xDE\xDD\xBD\x45\x42" },
   { SHIFTJIS_CHARSET, "Mincho", "\x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "Gothic", "\x83\x53\x83\x56\x83\x62\x83\x4E" },
   { HANGUL_CHARSET, "Gulim", "\xB1\xBC\xB8\xB2" },
   { HANGUL_CHARSET, "GulimChe", "\xB1\xBC\xB8\xB2\xC3\xBC" },
   { HANGUL_CHARSET, "Dotum", "\xB5\xB8\xBF\xF2" },
   { HANGUL_CHARSET, "DotumChe", "\xB5\xB8\xBF\xF2\xC3\xBC" },
   { HANGUL_CHARSET, "Batang", "\xB9\xD9\xC5\xC1" },
   { HANGUL_CHARSET, "BatangChe", "\xB9\xD9\xC5\xC1\xC3\xBC" },
   { HANGUL_CHARSET, "Gungsuh", "\xB1\xC3\xBC\xAD" },
   { HANGUL_CHARSET, "GungsuhChe", "\xB1\xC3\xBC\xAD\xC3\xBC" },
   { HANGUL_CHARSET, "New Gulim", "\xBB\xF5\xB1\xBC\xB8\xB2" },
   { HANGUL_CHARSET, "New Batang", "\xBB\xF5\xB9\xD9\xC5\xC1" },
   { HANGUL_CHARSET, "Malgun Gothic", "\xB8\xBC\xC0\xBA \xB0\xED\xB5\xF1" },
   { HANGUL_CHARSET, "Malgun Gothic Bold", "\xB8\xBC\xC0\xBA \xB0\xED\xB5\xF1 \x42\x6F\x6C\x64" },
   { HANGUL_CHARSET, "HYGothic-Extra", "\x48\x59\xB0\xDF\xB0\xED\xB5\xF1" },
   { HANGUL_CHARSET, "HYGothic-Medium", "\x48\x59\xC1\xDF\xB0\xED\xB5\xF1" },
   { HANGUL_CHARSET, "HYGraphic-Medium", "\x48\x59\xB1\xD7\xB7\xA1\xC7\xC8\x4D" },
   { HANGUL_CHARSET, "HYGungSo-Bold", "\x48\x59\xB1\xC3\xBC\xAD\x42" },
   { HANGUL_CHARSET, "HYHeadLine-Medium", "\x48\x59\xC7\xEC\xB5\xE5\xB6\xF3\xC0\xCE\x4D" },
   { HANGUL_CHARSET, "HYMyeongJo-Extra", "\x48\x59\xB0\xDF\xB8\xED\xC1\xB6" },
   { HANGUL_CHARSET, "HYPost-Light", "\x48\x59\xBF\xB1\xBC\xAD\x4C" },
   { HANGUL_CHARSET, "HYShortSamul-Medium", "\x48\x59\xBE\xE8\xC0\xBA\xBB\xF9\xB9\xB0\x4D" },
   { HANGUL_CHARSET, "HYSinMyeongJo-Medium", "\x48\x59\xBD\xC5\xB8\xED\xC1\xB6" },
   { HANGUL_CHARSET, "HYPMokGak-Bold", "\x48\x59\xB8\xF1\xB0\xA2\xC6\xC4\xC0\xD3\x42" },
   { HANGUL_CHARSET, "HYPost-Medium", "\x48\x59\xBF\xB1\xBC\xAD\x4D" },
   { HANGUL_CHARSET, "HYSinMun-MyeongJo", "\x48\x59\xBD\xC5\xB9\xAE\xB8\xED\xC1\xB6" },
   { HANGUL_CHARSET, "HYTaJa-Medium", "\x48\x59\xC5\xB8\xC0\xDA\x4D" },
   { HANGUL_CHARSET, "Magic R", "\xC8\xDE\xB8\xD5\xB8\xC5\xC1\xF7\xC3\xBC" },
   { HANGUL_CHARSET, "Yet R", "\xC8\xDE\xB8\xD5\xBF\xBE\xC3\xBC" },
#endif
   { GB2312_CHARSET, "SimSun", "\xCB\xCE\xCC\xE5" },
   { GB2312_CHARSET, "SimHei", "\xBA\xDA\xCC\xE5" },
   { GB2312_CHARSET, "NSimSun", "\xD0\xC2\xCB\xCE\xCC\xE5" },
   { GB2312_CHARSET, "LiSu", "\xC1\xA5\xCA\xE9" },
   { GB2312_CHARSET, "YouYuan", "\xD3\xD7\xD4\xB2" },
   { GB2312_CHARSET, "FangSong_GB2312", "\xB7\xC2\xCB\xCE_\x47\x42\x32\x33\x31\x32" },
   { GB2312_CHARSET, "KaiTi_GB2312", "\xBF\xAC\xCC\xE5_\x47\x42\x32\x33\x31\x32" },
   { GB2312_CHARSET, "Simsun (Founder Extended)", "\xCB\xCE\xCC\xE5-\xB7\xBD\xD5\xFD\xB3\xAC\xB4\xF3\xD7\xD6\xB7\xFB\xBC\xAF" },
   { GB2312_CHARSET, "SimSun-18030", "\xCB\xCE\xCC\xE5-\x31\x38\x30\x33\x30" },
   { GB2312_CHARSET, "NSimSun-18030", "\xD0\xC2\xCB\xCE\xCC\xE5-\x31\x38\x30\x33\x30" },
   { GB2312_CHARSET, "FangSong", "\xB7\xC2\xCB\xCE" },
   { GB2312_CHARSET, "KaiTi", "\xBF\xAC\xCC\xE5" },
   { GB2312_CHARSET, "SimSun-ExtB", "\xCB\xCE\xCC\xE5-\x45\x78\x74\x42" },
   { GB2312_CHARSET, "Microsoft YaHei", "\xCE\xA2\xC8\xED\xD1\xC5\xBA\xDA" },
   { GB2312_CHARSET, "Microsoft YaHei Bold", "\xCE\xA2\xC8\xED\xD1\xC5\xBA\xDA \x42\x6F\x6C\x64" },
   { GB2312_CHARSET, "STSong", "\xBB\xAA\xCE\xC4\xCB\xCE\xCC\xE5" },
   { GB2312_CHARSET, "STZhongsong", "\xBB\xAA\xCE\xC4\xD6\xD0\xCB\xCE" },
   { GB2312_CHARSET, "STKaiti", "\xBB\xAA\xCE\xC4\xBF\xAC\xCC\xE5" },
   { GB2312_CHARSET, "STFangsong", "\xBB\xAA\xCE\xC4\xB7\xC2\xCB\xCE" },
   { GB2312_CHARSET, "STXihei", "\xBB\xAA\xCE\xC4\xCF\xB8\xBA\xDA" },
   { GB2312_CHARSET, "STLiti", "\xBB\xAA\xCE\xC4\xC1\xA5\xCA\xE9" },
   { GB2312_CHARSET, "STXingkai", "\xBB\xAA\xCE\xC4\xD0\xD0\xBF\xAC" },
   { GB2312_CHARSET, "STXinwei", "\xBB\xAA\xCE\xC4\xD0\xC2\xCE\xBA" },
   { GB2312_CHARSET, "STHupo", "\xBB\xAA\xCE\xC4\xE7\xFA\xE7\xEA" },
   { GB2312_CHARSET, "STCaiyun", "\xBB\xAA\xCE\xC4\xB2\xCA\xD4\xC6" },
   { GB2312_CHARSET, "FZYaoTi", "\xB7\xBD\xD5\xFD\xD2\xA6\xCC\xE5" },
   { GB2312_CHARSET, "FZShuTi", "\xB7\xBD\xD5\xFD\xCA\xE6\xCC\xE5" },
   { CHINESEBIG5_CHARSET, "MingLiu", "\xB2\xD3\xA9\xFA\xC5\xE9" },
   { CHINESEBIG5_CHARSET, "PMingLiu", "\xB7\x73\xB2\xD3\xA9\xFA\xC5\xE9" },
   { CHINESEBIG5_CHARSET, "DFKai-SB", "\xBC\xD0\xB7\xA2\xC5\xE9" },
   { CHINESEBIG5_CHARSET, "MingLiU-ExtB", "\xB2\xD3\xA9\xFA\xC5\xE9-\x45\x78\x74\x42" },
   { CHINESEBIG5_CHARSET, "PMingLiU-ExtB", "\xB7\x73\xB2\xD3\xA9\xFA\xC5\xE9-\x45\x78\x74\x42" },
   { CHINESEBIG5_CHARSET, "Microsoft JhengHei", "\xB7\x4C\xB3\x6E\xA5\xBF\xB6\xC2\xC5\xE9" },
   { CHINESEBIG5_CHARSET, "Microsoft JhengHei Bold", "\xB7\x4C\xB3\x6E\xA5\xBF\xB6\xC2\xC5\xE9 \x42\x6F\x6C\x64" },
#if defined CHNCONV_DLL
   { SHIFTJIS_CHARSET, "CW-GB Mincho", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "CW-GB Gothic", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x83\x53\x83\x56\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "CW-GB Kaishu", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x9E\xB2\x8F\x91" },
   { SHIFTJIS_CHARSET, "CW-GB FangSong", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x91\x76\x92\xA9" },
   { SHIFTJIS_CHARSET, "CW-GB YuanHei", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x8A\xDB\x83\x53\x83\x56\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "CW-GB WeiBei", "\x82\x66\x82\x61 \x92\x86\x8D\x91\xE9\xB0\x94\xE8" },
   { SHIFTJIS_CHARSET, "CW-GB Mincho UB", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x95\x57\x91\xE8\x91\x76" },
   { SHIFTJIS_CHARSET, "CW-GB WeiBei", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x96\xD1\x95\x4D" },
   { SHIFTJIS_CHARSET, "CW-GB Gothic", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x9B\x4C\x91\xCC" },
   { SHIFTJIS_CHARSET, "CW-GB WeiBei", "\x82\x66\x82\x61 \x92\x86\x8D\x91\x97\xEA\x8F\x91" },
   { SHIFTJIS_CHARSET, "CW-B5 Mincho", "\x82\x6A\x82\x66 \x94\xC9\x91\xCC\x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "CW-B5 Gothic", "\x82\x6A\x82\x66 \x94\xC9\x91\xCC\x83\x53\x83\x56\x83\x62\x83\x4E" },
   { SHIFTJIS_CHARSET, "CXGBM3", "\x43\x58 \x8A\xC8\x83\x7E\x83\x93-\x52" },
   { SHIFTJIS_CHARSET, "CXGBG3", "\x43\x58 \x8A\xC8\x83\x53-\x52" },
   { SHIFTJIS_CHARSET, "CXPGBM3", "\x43\x58 \x50\x8A\xC8\x83\x7E\x83\x93-\x52" },
   { SHIFTJIS_CHARSET, "CXPGBG3", "\x43\x58 \x50\x8A\xC8\x83\x53-\x52" },
   { SHIFTJIS_CHARSET, "A6GJ-JP", "\x92\x86\x8D\x91\x8A\xC8\x91\xCC\x96\xBE\x92\xA9" },
   { SHIFTJIS_CHARSET, "B1GJ-JP", "\x92\x86\x8D\x91\x8A\xC8\x91\xCC\xBA\xDE\xBC\xAF\xB8" },
#endif
} ;

static const int LOCALIZED_FONTNAME_NELEM = NELEMOF ( LocalizedFontname ) ;



// [JȃtHgp̃tHg擾
// nCharset  -1 ȂAnCharsetɂ炸
// tHg̃R[hy[W pCharset Ɋi[
// pCharset  NULL ł
// Ȃ NULL Ԃ
const char *GetEnglishFontName ( int nCharset, const char *szLocalizedName, int *pCharset ) {

   for ( int nCount = 0 ; nCount < LOCALIZED_FONTNAME_NELEM ; nCount ++ ) {

      if ( nCharset >= 0 && ( LocalizedFontname [ nCount ] ).nCharset != nCharset ) continue ;

      if ( ! strcmp ( szLocalizedName, ( LocalizedFontname [ nCount ] ).szLocalizedName ) ) {
         if ( pCharset ) *pCharset = ( LocalizedFontname [ nCount ] ).nCharset ;
         return ( LocalizedFontname [ nCount ] ).szEnglishName ;
      }
   }

   return NULL ;
}



// p̃tHg烍[JȃtHg擾
// nCharset  -1 ȂAnCharsetɂ炸
// tHg̃R[hy[W pCharset Ɋi[
// pCharset  NULL ł
// Ȃ NULL Ԃ
const char *GetLocalizedFontName ( int nCharset, const char *szEnglishName, int *pCharset ) {

   for ( int nCount = 0 ; nCount < LOCALIZED_FONTNAME_NELEM ; nCount ++ ) {

      if ( nCharset >= 0 && ( LocalizedFontname [ nCount ] ).nCharset != nCharset ) continue ;

      if ( ! stricmp ( szEnglishName, ( LocalizedFontname [ nCount ] ).szEnglishName ) ) {
         if ( pCharset ) *pCharset = ( LocalizedFontname [ nCount ] ).nCharset ;
         return ( LocalizedFontname [ nCount ] ).szLocalizedName ;
      }
   }

   return NULL ;
}



