// hkscsver.cpp

#include "msc.h"
#include "hkscsver.h"



#ifndef GetShortArrayBit
#define GetShortArrayBit(Array,Index)  ( ( (Array) [ (Index) >> 4 ] >> ( (Index) & 0xF ) ) & 1 )
#endif



///////////////////////////////////////////////////////////////////////////////////////
//                                    VERSION 1999
///////////////////////////////////////////////////////////////////////////////////////



int IsHkscs1999 ( int cUnicode ) {

   // UNICODE PUA ̏ɃrbgŔz
   static const unsigned short BitTable [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF0xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF1xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF2xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xFFF8,  0xFFFF,  0xFF5F,  0xFFFF,  0x0FAF,  0,       0,       0,       // 0xF3xx
      0,       0,       0xF3CB,  0xFFFF,  0xFFFF,  0xFFFF,  0xDE1F,  0xBFF9,  
      0xFFFB,  0xFFFF,  0xFFFF,  0x7FFF,  0xFFFF,  0xFFFF,  0xFFFE,  0xFFFB,  // 0xF4xx
      0xEFBF,  0xFFDF,  0xFEF7,  0xFCFF,  0xFFFF,  0xFFFE,  0xBFFF,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFDF,  0xFFFF,  0x003F,  // 0xF5xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xFFF0,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF6xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0x3F57,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF7xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0,       
      0,       0xFF80,  0xFFFF,  0x8FFF,  0x01FF,  0,       0,       0,       // 0xF8xx
      0,       0,       0,       0,       0,       0,       0,       0,       
   } ;

   if ( cUnicode >= 0xE000 && cUnicode < 0xF000 ) return 1 ;

   if ( GetShortArrayBit ( BitTable, cUnicode - 0xF000 ) ) return 1 ;

   return 0 ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                                    VERSION 2001
///////////////////////////////////////////////////////////////////////////////////////



int IsHkscs2001 ( int cUnicode ) {

   // UNICODE PUA ̏ɃrbgŔz
   static const unsigned short BitTable [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF0xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF1xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF2xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xFFF8,  0xFFFF,  0xFF5F,  0xFFFF,  0x0FAF,  0,       0,       0,       // 0xF3xx
      0,       0,       0xF3CB,  0xFFFF,  0xFFFF,  0xFFFF,  0xDE1F,  0xBFF9,  
      0xFFFB,  0xFFFF,  0xFFFF,  0x7FFF,  0xFFFF,  0xFFFF,  0xFFFE,  0xFFFB,  // 0xF4xx
      0xEFBF,  0xFFDF,  0xFEF7,  0xFCFF,  0xFFFF,  0xFFFE,  0xBFFF,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFDF,  0xFFFF,  0xFFBF,  // 0xF5xx
      0xFFFF,  0xFDFF,  0xFFFF,  0xF7FF,  0xFFFF,  0xC7FF,  0xFFFB,  0x0002,  
      0,       0,       0,       0xFFF0,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF6xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0x3F57,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF7xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0,       
      0,       0xFF80,  0xFFFF,  0x8FFF,  0x01FF,  0,       0,       0,       // 0xF8xx
      0,       0,       0,       0,       0,       0,       0,       0,       
   } ;

   if ( cUnicode >= 0xE000 && cUnicode < 0xF000 ) return 1 ;

   if ( GetShortArrayBit ( BitTable, cUnicode - 0xF000 ) ) return 1 ;

   return 0 ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                                    VERSION 2004
///////////////////////////////////////////////////////////////////////////////////////



int IsHkscs2004 ( int cUnicode ) {

   // UNICODE PUA ̏ɃrbgŔz
   static const unsigned short BitTable [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF0xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xF1xx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0xFFC0,  0xFFFF,  // 0xF2xx
      0xEFFF,  0xFFFF,  0,       0,       0,       0,       0,       0,       
      0xFFF8,  0xFFFF,  0xFF5F,  0xFFFF,  0x0FAF,  0,       0,       0,       // 0xF3xx
      0,       0,       0xF3CB,  0xFFFF,  0xFFFF,  0xFFFF,  0xDE1F,  0xBFF9,  
      0xFFFB,  0xFFFF,  0xFFFF,  0x7FFF,  0xFFFF,  0xFFFF,  0xFFFE,  0xFFFB,  // 0xF4xx
      0xEFBF,  0xFFDF,  0xFEF7,  0xFCFF,  0xFFFF,  0xFFFE,  0xBFFF,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFDF,  0xFFFF,  0xFFBF,  // 0xF5xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xF7FF,  0xFFFF,  0xC7FF,  0xFFFB,  0xFBFF,  
      0xFFFF,  0xFFDF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF6xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0x3F57,  0xFFFF,  
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  // 0xF7xx
      0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0x7FFF,  0,       
      0,       0xFF80,  0xFFFF,  0x8FFF,  0x01FF,  0,       0,       0,       // 0xF8xx
      0,       0,       0,       0,       0,       0,       0,       0,       
   } ;

   if ( cUnicode >= 0xE000 && cUnicode < 0xF000 ) return 1 ;

   if ( GetShortArrayBit ( BitTable, cUnicode - 0xF000 ) ) return 1 ;

   return 0 ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                               UNICODE 4.10 or Later
///////////////////////////////////////////////////////////////////////////////////////



int IsHkscsUnicode410orLater ( int cUnicode ) {

   switch ( cUnicode ) {
      case 0x23DA :
      case 0x23DB :
      case 0x31C0 :
      case 0x31C1 :
      case 0x31C2 :
      case 0x31C3 :
      case 0x31C4 :
      case 0x31C5 :
      case 0x31C6 :
      case 0x31C7 :
      case 0x31C8 :
      case 0x31C9 :
      case 0x31CA :
      case 0x31CB :
      case 0x31CC :
      case 0x31CD :
      case 0x31CE :
      case 0x31CF :
      case 0x9FA6 :
      case 0x9FA7 :
      case 0x9FA8 :
      case 0x9FA9 :
      case 0x9FAA :
      case 0x9FAB :
      case 0x9FAC :
      case 0x9FAD :
      case 0x9FAE :
      case 0x9FAF :
      case 0x9FB0 :
      case 0x9FB1 :
      case 0x9FB2 :
      case 0x9FB3 :
      case 0x9FC7 :
      case 0x9FC8 :
      case 0x9FC9 :
      case 0x9FCA :
      case 0x9FCB :
      case 0x2ADFF :
         return 1 ;
   }

   return 0 ;
}



