// storechr.h

#ifndef STORECHR_H
#define STORECHR_H


#ifdef __cplusplus
extern "C" {
#endif


#define STOREDCHARS_ERROR  ( (void*) -1 )


// STOREDCHARS \́iANSIŁj
typedef struct {
   char           *szStart ;        // obt@̐擪AhX
   char           *szWrite ;        // obt@̏ݗp̃AhX
   char           *szEnd ;          // obt@̖̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYij
} STOREDCHARSA ;


// STOREDCHARS \́iUNICODEŁj
typedef struct {
   wchar_t        *szStart ;        // obt@̐擪AhX
   wchar_t        *szWrite ;        // obt@̏ݗp̃AhX
   wchar_t        *szEnd ;          // obt@̖̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYij
} STOREDCHARSW ;


// STOREDCHARS \́iUTF32Łj
typedef struct {
   wchar32_t      *szStart ;        // obt@̐擪AhX
   wchar32_t      *szWrite ;        // obt@̏ݗp̃AhX
   wchar32_t      *szEnd ;          // obt@̖̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYij
} STOREDCHARSW32 ;


STOREDCHARSA *StoreCharsA ( int C, STOREDCHARSA *StoredChars ) ;
STOREDCHARSA *StoreCharsStringA ( const char *szString, STOREDCHARSA *StoredChars ) ;
void ClearStoredCharsA ( STOREDCHARSA *StoredChars ) ;
void FreeStoredCharsA ( STOREDCHARSA *StoredChars ) ;
char *GetStoredCharsA ( STOREDCHARSA *StoredChars ) ;
STOREDCHARSA *PushStoredCharsA ( int C, STOREDCHARSA *StoredChars ) ;
int PopStoredCharsA ( STOREDCHARSA *StoredChars ) ;

STOREDCHARSW *StoreCharsW ( int C, STOREDCHARSW *StoredChars ) ;
STOREDCHARSW *StoreCharsStringW ( const wchar_t *szString, STOREDCHARSW *StoredChars ) ;
void ClearStoredCharsW ( STOREDCHARSW *StoredChars ) ;
void FreeStoredCharsW ( STOREDCHARSW *StoredChars ) ;
wchar_t *GetStoredCharsW ( STOREDCHARSW *StoredChars ) ;
STOREDCHARSW *PushStoredCharsW ( int C, STOREDCHARSW *StoredChars ) ;
int PopStoredCharsW ( STOREDCHARSW *StoredChars ) ;

STOREDCHARSW32 *StoreCharsW32 ( int C, STOREDCHARSW32 *StoredChars ) ;
STOREDCHARSW32 *StoreCharsStringW32 ( const wchar32_t *szString, STOREDCHARSW32 *StoredChars ) ;
void ClearStoredCharsW32 ( STOREDCHARSW32 *StoredChars ) ;
void FreeStoredCharsW32 ( STOREDCHARSW32 *StoredChars ) ;
wchar32_t *GetStoredCharsW32 ( STOREDCHARSW32 *StoredChars ) ;
STOREDCHARSW32 *PushStoredCharsW32 ( int C, STOREDCHARSW32 *StoredChars ) ;
int PopStoredCharsW32 ( STOREDCHARSW32 *StoredChars ) ;


#ifdef UNICODE
#define STOREDCHARS STOREDCHARSW
#define StoreChars StoreCharsW
#define GetStoredChars GetStoredCharsW
#define FreeStoredChars FreeStoredCharsW
#define GetStoredChars GetStoredCharsW
#else
#define STOREDCHARS STOREDCHARSA
#define StoreChars StoreCharsA
#define GetStoredChars GetStoredCharsA
#define FreeStoredChars FreeStoredCharsA
#define GetStoredChars GetStoredCharsA
#endif


#ifdef __cplusplus
}
#endif

#endif


