// stream.cpp

#include <windows.h>
#include <stdio.h>
#include <limits.h>
#include "msc.h"
#include "stream.h"



// t@CXg[ƕ𓯂Xg[Ƃď邽߂̃Cu


// Flags
#define STREAM_TO_WRITE       1
#define STREAM_STD_HANDLE     2
#define STREAM_STRING         4
#define STREAM_ERROR          0x10
#define STREAM_EOF            0x20

#define STREAM_BUFFER_SIZE    0x1000


// ˂̂ FILE_TYPE_REMOTE (0x8000) ͂
#define GetFileType(h)   ( GetFileType ( h ) & ~ FILE_TYPE_REMOTE )


#define PRINTF_BUFFER_SIZE    ( MAX_PATH + 0x10 )

#if ! defined _MSC_VER || _MSC_VER < 1300
static int __cdecl vscprintf ( const char *format, va_list args ) ;
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) ;
#else
#define vscprintf _vscprintf
#define vscwprintf _vscwprintf
#endif



////////////////////////////////////////////
//          ǂݍݗp̊{֐          //
////////////////////////////////////////////



// ǂݍ݃obt@𖞂
// t@C̏I[ɒB EOF Ԃ
// ŏ̕Ԃ
static int FillBuffer ( STREAM *Stream ) {

   if ( Stream->Flags & ( STREAM_ERROR | STREAM_STRING | STREAM_EOF ) ) return EOF ;

   unsigned long dwByteRead = 0 ;
   unsigned long dwByteToRead = (unsigned long) Stream->Length ;

   int nResult = ReadFile ( Stream->File, Stream->Buffer, dwByteToRead, & dwByteRead, NULL ) ;
   if ( ! nResult ) {
      if ( GetLastError () == ERROR_BROKEN_PIPE ) Stream->Flags |= STREAM_EOF ;
      else                                        Stream->Flags |= STREAM_ERROR ;
      return EOF ;
   }
   if ( ! dwByteRead ) {
      Stream->Flags |= STREAM_EOF ;
      return EOF ;
   }

   Stream->Count = dwByteRead ;
   Stream->Current = Stream->Buffer ;

   Stream->Count -- ;

   return (unsigned char) ( *( Stream->Current ) ++ ) ;
}



// Xg[當ǂݍ
// t@C̏I[ɒB EOF Ԃ
// Ԃ
int StreamRead ( STREAM *Stream ) {

   if ( Stream->Flags & STREAM_TO_WRITE ) {
      Stream->Flags |= STREAM_ERROR ;
      return EOF ;
   }

   if ( Stream->UnreadCount ) {
      Stream->UnreadCount -- ;
      return (unsigned char) *( Stream->UnreadBuffer + Stream->UnreadCount ) ;
   }

   if ( ! Stream->Count ) return FillBuffer ( Stream ) ;
   Stream->Count -- ;

   return (unsigned char) ( *( Stream->Current ) ++ ) ;
}



// ǂݖ߂obt@ɕ߂
// s EOF Ԃ
// Ԃ
int StreamUnread ( int C, STREAM *Stream ) {

   if ( C == EOF ) return EOF ;
   if ( Stream->UnreadCount >= STREAM_UNREAD_BUFFER_SIZE ) return EOF ;

   *( Stream->UnreadBuffer + Stream->UnreadCount ) = (unsigned char) C ;
   Stream->UnreadCount ++ ;

   return (unsigned char) C ;
}



////////////////////////////////////////////
//          ݗp̊{֐          //
////////////////////////////////////////////



// ݃obt@tbV
// IsIgnoreChar  0 ȊOȂA C 𖳎
// s EOF Ԃ
// Ō̕Ԃ
static int FlushBuffer ( int C, STREAM *Stream, int IsIgnoreChar ) {

   if ( Stream->Flags & STREAM_ERROR ) return EOF ;
   if ( Stream->Flags & STREAM_STRING ) {
      if ( ! IsIgnoreChar ) Stream->Flags |= STREAM_ERROR ;
      return EOF ;
   }

   if ( ! IsIgnoreChar ) *( Stream->Current ) ++ = (unsigned char) C ;

   unsigned long dwByteWritten = 0 ;
   unsigned long dwByteToWrite = (unsigned long) ( Stream->Current - Stream->Buffer ) ;

   if ( dwByteToWrite ) {

      int nResult = WriteFile ( Stream->File, Stream->Buffer, dwByteToWrite, & dwByteWritten, NULL ) ;
      if ( ! nResult || dwByteToWrite != dwByteWritten ) {
         Stream->Flags |= STREAM_ERROR ;
         return EOF ;
      }
   }

   Stream->Count = Stream->Length - 1 ;
   Stream->Current = Stream->Buffer ;

   if ( IsIgnoreChar ) return 0 ;

   return (unsigned char) C ;
}



// Xg[֕
// s EOF Ԃ
// Ԃ
int StreamWrite ( int C, STREAM *Stream ) {

   if ( ! ( Stream->Flags & STREAM_TO_WRITE ) ) {
      Stream->Flags |= STREAM_ERROR ;
      return EOF ;
   }

   if ( ! Stream->Count ) return FlushBuffer ( C, Stream, 0 ) ;
   Stream->Count -- ;

   if ( Stream->Buffer ) *( Stream->Current ) ++ = (unsigned char) C ;
   else                  Stream->Current ++ ;

   return (unsigned char) C ;
}



////////////////////////////////////////////
//          ǂݍݗp̉p֐          //
////////////////////////////////////////////



// Xg[oCgǂݍ
// ۂɓǂݍ񂾃oCgԂ
size_t StreamReadBuffer ( char *szBuffer, size_t nSize, STREAM *Stream ) {

   size_t nCurrentSize = 0 ;

   while ( nCurrentSize < nSize ) {
      int C = StreamRead ( Stream ) ;
      if ( C == EOF ) break ;
      *szBuffer = (unsigned char) C ;
      szBuffer ++ ;
      nCurrentSize ++ ;
   }

   return nCurrentSize ;
}



////////////////////////////////////////////
//          ݗp̉p֐          //
////////////////////////////////////////////



// ̂
#define SPEEDUP_TUNING  1



// Xg[փoCg
// ۂɏ񂾃oCgԂ
size_t StreamWriteBuffer ( const char *szBuffer, size_t nSize, STREAM *Stream ) {

   if ( SPEEDUP_TUNING && Stream->Count >= (size_t) nSize ) {

      if ( ! ( Stream->Flags & STREAM_TO_WRITE ) ) {
         Stream->Flags |= STREAM_ERROR ;
         return 0 ;
      }

      if ( Stream->Buffer ) memmove ( Stream->Current, szBuffer, nSize ) ;
      Stream->Count -= nSize ;
      Stream->Current += nSize ;

      return nSize ;
   }

   size_t nCurrentSize = 0 ;

   while ( nCurrentSize < nSize ) {
      if ( StreamWrite ( (unsigned char) *szBuffer, Stream ) == EOF ) break ;
      szBuffer ++ ;
      nCurrentSize ++ ;
   }

   return nCurrentSize ;
}



// Xg[֕
//  0 As EOF Ԃ
int StreamWriteString ( const char *szBuffer, STREAM *Stream ) {

   size_t nLength = strlen ( szBuffer ) ;

   if ( StreamWriteBuffer ( szBuffer, nLength, Stream ) != nLength ) return EOF ;

   return 0 ;
}



// Xg[ɏtf[^
// s EOF Ԃ
// 񂾃oCgԂ
int __cdecl StreamWriteFormat ( STREAM *Stream, const char *format,... ) {

#if defined _MSC_VER && _MSC_VER >= 1300

   if ( SPEEDUP_TUNING && ! Stream->Buffer ) {

      if ( ! ( Stream->Flags & STREAM_TO_WRITE ) ) {
         Stream->Flags |= STREAM_ERROR ;
         return EOF ;
      }

      va_list args ;
      va_start ( args, format ) ;
      int retvalue = vscprintf ( format, args ) ;
      va_end ( args ) ;

      if ( Stream->Count < (size_t) retvalue ) {
         Stream->Count = 0 ;
         Stream->Current = (char*) SIZE_MAX ;
         Stream->Flags |= STREAM_ERROR ;
         return EOF ;
      }

      Stream->Count -= retvalue ;
      Stream->Current += retvalue ;

      return retvalue ;
   }

#endif

   int retvalue = EOF ;

   va_list args ;
   va_list args1 ;
   va_list args2 ;
   va_start ( args, format ) ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   char buffer [ PRINTF_BUFFER_SIZE ] ;      // for short strings
   char *string = NULL ;
   int result ;

   if ( ( result = vsnprintf ( buffer, PRINTF_BUFFER_SIZE, format, args ) ) < 0 || result > PRINTF_BUFFER_SIZE - 1 ) {

      int length ;
      if ( ( length = vscprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (char*) malloc ( ( length + 1 ) * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;
   }

   if ( StreamWriteBuffer ( ( string ) ? string : buffer, result, Stream ) == (size_t) result ) retvalue = result ;

   CAUGHT_ERROR :

   free ( string ) ;

   va_end ( args ) ;
   va_end ( args1 ) ;
   va_end ( args2 ) ;

   if ( retvalue == EOF ) Stream->Flags |= STREAM_ERROR ;

   return retvalue ;
}



////////////////////////////////////////////
//           Xg[̃G[           //
////////////////////////////////////////////



// G[o EOF Ԃ
// ȊO 0 Ԃ
int StreamError ( STREAM *Stream ) {

   if ( Stream->Flags & STREAM_ERROR ) return EOF ;

   return 0 ;
}



////////////////////////////////////////////
//            Xg[̎            //
////////////////////////////////////////////



// 񂩂ǂ
int StreamIsString ( STREAM *Stream ) {

   if ( Stream->Flags & STREAM_STRING ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//      iǂݍݗpt@Cj      //
////////////////////////////////////////////



static STREAM *OpenFileStreamForReadingAW ( const char *szFileNameA, const wchar_t *szFileNameW ) ;



// ǂݎpɃt@CJiANSIŁj
// t@C NULL ȂR\[J
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenFileStreamForReadingA ( const char *szFileName ) {

   if ( ! IsNT () || ! szFileName ) return OpenFileStreamForReadingAW ( szFileName, NULL ) ;

   wchar_t szTmp [ MAX_PATH ] ;
   if ( ! MultiByteToWideChar ( CP_ACP, 0, szFileName, -1, szTmp, MAX_PATH ) ) return NULL ;

   return OpenFileStreamForReadingAW ( NULL, szTmp ) ;
}



// ǂݎpɃt@CJiUNICODEŁj
// t@C NULL ȂR\[J
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenFileStreamForReadingW ( const wchar_t *szFileName ) {

   if ( IsNT () || ! szFileName ) return OpenFileStreamForReadingAW ( NULL, szFileName ) ;

   char szTmp [ MAX_PATH ] ;
   if ( ! WideCharToMultiByte ( CP_ACP, 0, szFileName, -1, szTmp, MAX_PATH, NULL, NULL ) ) return NULL ;

   return OpenFileStreamForReadingAW ( szTmp, NULL ) ;
}



static STREAM *OpenFileStreamForReadingAW ( const char *szFileNameA, const wchar_t *szFileNameW ) {

   STREAM *Stream = (STREAM*) malloc ( sizeof(STREAM) ) ;
   if ( ! Stream ) return NULL ;

   memzero ( Stream, sizeof(STREAM) ) ;

   if ( szFileNameW )      Stream->File = CreateFileW ( szFileNameW, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL ) ;
#ifndef NT_ONLY
   else if ( szFileNameA ) Stream->File = CreateFileA ( szFileNameA, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL ) ;
#else
   else if ( szFileNameA ) Stream->File = INVALID_HANDLE_VALUE ;
#endif
   else {
      Stream->File = GetStdHandle ( STD_INPUT_HANDLE ) ;
      Stream->Flags |= STREAM_STD_HANDLE ;
   }

   if ( Stream->File == INVALID_HANDLE_VALUE ) {
      free ( Stream ) ;
      return NULL ;
   }

   if ( STREAM_BUFFER_SIZE ) {
      Stream->Buffer = (char*) malloc ( STREAM_BUFFER_SIZE ) ;
      Stream->Length = STREAM_BUFFER_SIZE ;
   }

   if ( ! Stream->Buffer ) {
      Stream->Buffer = Stream->TmpBuffer ;
      Stream->Length = 1 ;
   }

   Stream->Current = Stream->Buffer ;

   return Stream ;
}



////////////////////////////////////////////
//      iݗpt@Cj      //
////////////////////////////////////////////



static STREAM *OpenFileStreamForWritingAW ( const char *szFileNameA, const wchar_t *szFileNameW ) ;



// ݗpɃt@CJiANSIŁj
// t@C NULL ȂR\[J
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenFileStreamForWritingA ( const char *szFileName ) {

   if ( ! IsNT () || ! szFileName || szFileName == (char*) -1 ) return OpenFileStreamForWritingAW ( szFileName, NULL ) ;

   wchar_t szTmp [ MAX_PATH ] ;
   if ( ! MultiByteToWideChar ( CP_ACP, 0, szFileName, -1, szTmp, MAX_PATH ) ) return NULL ;

   return OpenFileStreamForWritingAW ( NULL, szTmp ) ;
}



// ݗpɃt@CJiUNICODEŁj
// t@C NULL ȂR\[J
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenFileStreamForWritingW ( const wchar_t *szFileName ) {

   if ( IsNT () || ! szFileName || szFileName == (wchar_t*) -1 ) return OpenFileStreamForWritingAW ( NULL, szFileName ) ;

   char szTmp [ MAX_PATH ] ;
   if ( ! WideCharToMultiByte ( CP_ACP, 0, szFileName, -1, szTmp, MAX_PATH, NULL, NULL ) ) return NULL ;

   return OpenFileStreamForWritingAW ( szTmp, NULL ) ;
}



static STREAM *OpenFileStreamForWritingAW ( const char *szFileNameA, const wchar_t *szFileNameW ) {

   STREAM *Stream = (STREAM*) malloc ( sizeof(STREAM) ) ;
   if ( ! Stream ) return NULL ;

   memzero ( Stream, sizeof(STREAM) ) ;

   if ( szFileNameA != (char*) -1 && szFileNameW != (wchar_t*) -1 ) {
      if ( szFileNameW )      Stream->File = CreateFileW ( szFileNameW, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL ) ;
#ifndef NT_ONLY
      else if ( szFileNameA ) Stream->File = CreateFileA ( szFileNameA, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL ) ;
#else
      else if ( szFileNameA ) Stream->File = INVALID_HANDLE_VALUE ;
#endif
      else {
         Stream->File = GetStdHandle ( STD_OUTPUT_HANDLE ) ;
         Stream->Flags |= STREAM_STD_HANDLE ;
      }
   }
   else {
      Stream->File = GetStdHandle ( STD_ERROR_HANDLE ) ;
      Stream->Flags |= STREAM_STD_HANDLE ;
   }

   if ( Stream->File == INVALID_HANDLE_VALUE ) {
      free ( Stream ) ;
      return NULL ;
   }

   if ( STREAM_BUFFER_SIZE && GetFileType ( Stream->File ) != FILE_TYPE_CHAR ) {
      Stream->Buffer = (char*) malloc ( STREAM_BUFFER_SIZE ) ;
      Stream->Length = STREAM_BUFFER_SIZE ;
   }

   if ( ! Stream->Buffer ) {
      Stream->Buffer = Stream->TmpBuffer ;
      Stream->Length = 1 ;
   }

   Stream->Current = Stream->Buffer ;
   Stream->Flags |= STREAM_TO_WRITE ;

   return Stream ;
}



////////////////////////////////////////////
//            ij            //
////////////////////////////////////////////



static const void *SearchEnd ( const void *String, int nCharSize ) ;
static inline int IsValidCharSize ( int n ) ;



// ǂݎpɕJ
// nLength ɂ͒ioCgjw
// nLength  (size_t) -1 ȂAnCharSize Ŏw肵TCYioCgj̃k璷vZ
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenStringStreamForReading ( const void *String, size_t nLength, int nCharSize ) {

   STREAM *Stream = (STREAM*) malloc ( sizeof(STREAM) ) ;
   if ( ! Stream ) return NULL ;

   memzero ( Stream, sizeof(STREAM) ) ;

   if ( IsValidCharSize ( nCharSize ) ) Stream->CharSize = nCharSize ;
   else                                 Stream->CharSize = 1 ;

   Stream->Current = (char*) String ;
   Stream->Buffer = (char*) String ;
   Stream->Flags |= STREAM_STRING ;

   if ( nLength != (size_t) -1 ) Stream->Length = nLength ;
   else                          Stream->Length = (char*) SearchEnd ( String, Stream->CharSize ) - (char*) String ;

   Stream->Count = Stream->Length ;

   return Stream ;
}



// ݗpɕJ
//  NULL Ȃۂɂ͏܂Ȃ
// nLength ɂ͍ő咷ioCgjw
// nCharSize ɂ͂P̃TCYioCgjw
//  STREAM ւ̃|C^Ԃ
// s NULL Ԃ
STREAM *OpenStringStreamForWriting ( void *String, size_t nLength, int nCharSize ) {

   STREAM *Stream = (STREAM*) malloc ( sizeof(STREAM) ) ;
   if ( ! Stream ) return NULL ;

   memzero ( Stream, sizeof(STREAM) ) ;

   if ( IsValidCharSize ( nCharSize ) ) Stream->CharSize = nCharSize ;
   else                                 Stream->CharSize = 1 ;

   Stream->Current = (char*) String ;
   Stream->Buffer = (char*) String ;
   Stream->Flags |= STREAM_STRING ;
   Stream->Flags |= STREAM_TO_WRITE ;

   if ( String ) Stream->Length = nLength ;
   else          Stream->Length = SIZE_MAX ;

   Stream->Count = Stream->Length ;

   return Stream ;
}



// k̃|C^Ԃ
static const void *SearchEnd ( const void *String, int nCharSize ) {

   const char *Current = (const char*) String ;

   while ( 1 ) {
      int C = 0 ;
      for ( int nCount = 0 ; nCount < nCharSize ; nCount ++ ) ( *Current ++ ) ? C ++ : 0 ;
      if ( ! C ) break ;
   }

   return (const void*) ( Current - nCharSize ) ;
}



// 0 łȂA 2 ̙pȂ 0 ȊOԂ
static inline int IsValidCharSize ( int n ) {
   if ( n && ! ( n & ( n - 1 ) ) ) return 1 ;
   return 0 ;
}



////////////////////////////////////////////
//                  I                  //
////////////////////////////////////////////



static int TerminateStringStream ( STREAM *Stream, size_t *pSize ) ;



// Xg[
//  0 Ԃ
// s EOF Ԃ
int CloseStream ( STREAM *Stream, size_t *pSize ) {

   int nResult = 0 ;

   if ( Stream->Flags & STREAM_STRING ) {
      if ( TerminateStringStream ( Stream, pSize ) ) nResult = EOF ;
   }
   else {

      if ( Stream->Flags & STREAM_TO_WRITE ) FlushBuffer ( 0, Stream, 1 ) ;

      if ( pSize ) {
         if ( GetFileType ( Stream->File ) == FILE_TYPE_DISK ) {

            long dwHighByte = 0 ;
            unsigned long dwLowByte = SetFilePointer ( Stream->File, 0, & dwHighByte, FILE_CURRENT ) ;

            if ( dwLowByte == INVALID_SET_FILE_POINTER ) {
               if ( GetLastError () != NO_ERROR ) dwLowByte = dwHighByte = 0 ;
            }

            if ( sizeof(size_t) == sizeof(uint64_t) ) *pSize = (size_t) ( ( ( (uint64_t) dwHighByte ) << LONG_BIT ) + dwLowByte ) ;
            else if ( dwHighByte )                    *pSize = SIZE_MAX ;
            else                                      *pSize = dwLowByte ;
         }
         else {
            *pSize = 0 ;
         }
      }

      if ( ! ( Stream->Flags & STREAM_STD_HANDLE ) ) CloseHandle ( Stream->File ) ;

      if ( Stream->Buffer != Stream->TmpBuffer ) free ( Stream->Buffer ) ;

      if ( Stream->Flags & STREAM_ERROR ) nResult = EOF ;
   }

   free ( Stream ) ;

   return nResult ;
}



// kŏI
//  0 Ԃ
// G[o EOF Ԃ
// \łȂ΁AZkăkAEOF Ԃ
static int TerminateStringStream ( STREAM *Stream, size_t *pSize ) {

   if ( Stream->Flags & STREAM_TO_WRITE ) {

      int CharSize = Stream->CharSize ;
      size_t CharSizeBitMask = CharSize - 1 ;

      for ( size_t nLength = Stream->Current - Stream->Buffer ; nLength & CharSizeBitMask ; nLength ++ ) StreamWrite ( 0, Stream ) ;
      for ( int nCount = 0 ; nCount < CharSize ; nCount ++ ) StreamWrite ( 0, Stream ) ;

      // G[oꂽ
      if ( Stream->Flags & STREAM_ERROR && Stream->Buffer ) {

         Stream->Flags &= ~ STREAM_ERROR ;   // ꎞIɃG[

         Stream->Current = Stream->Buffer + ( ( Stream->Length & ~ CharSizeBitMask ) - CharSize ) ;
         Stream->Count = Stream->Length - ( Stream->Current - Stream->Buffer ) ;

         for ( int nCount = 0 ; nCount < CharSize ; nCount ++ ) StreamWrite ( 0, Stream ) ;

         Stream->Flags |= STREAM_ERROR ;  // ꎞIɉG[߂
      }
   }

   if ( pSize ) *pSize = Stream->Current - Stream->Buffer ;

   return ( Stream->Flags & STREAM_ERROR ) ? EOF : 0 ;
}



////////////////////////////////////////////
//               VSCPRINTF                //
////////////////////////////////////////////



#if ! defined _MSC_VER || _MSC_VER < 1300


// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscprintf ( const char *format, va_list args ) {
   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;
   int retvalue = vfprintf ( stdnul, format, args ) ;
   fclose ( stdnul ) ;
   return retvalue ;
}


#endif



