// stream.h

#ifndef STREAM_H
#define STREAM_H


#ifdef __cplusplus
extern "C" {
#endif


#define STREAM_UNREAD_BUFFER_SIZE   0x10


typedef struct {

   // t@Cƕŋ
   char *Buffer ;             // obt@̐擪
   char *Current ;            // obt@ł̃|C^݂̌̈ʒu
   size_t Length ;            // obt@̃TCY
   size_t Count ;             // c̕
   void *UserDefinedValue ;
   unsigned long Flags ;

   // p
   int CharSize ;             // ̃TCY

   // t@Cp
   HANDLE File ;              // t@Cnh
   char TmpBuffer [ 1 ] ;     // obt@mۂłȂƂ̂߂̃obt@

   // ǂݖ߂p
   int UnreadCount ;
   unsigned char UnreadBuffer [ STREAM_UNREAD_BUFFER_SIZE ] ;

} STREAM ;



#define GetStreamValue(Stream)         ((Stream)->UserDefinedValue)
#define SetStreamValue(Stream,value)   ((Stream)->UserDefinedValue=(value))


int StreamRead ( STREAM *Stream ) ;
int StreamWrite ( int C, STREAM *Stream ) ;
int StreamError ( STREAM *Stream ) ;
int StreamIsString ( STREAM *Stream ) ;

int StreamUnread ( int C, STREAM *Stream ) ;
size_t StreamReadBuffer ( char *szBuffer, size_t nSize, STREAM *Stream ) ;
size_t StreamWriteBuffer ( const char *szBuffer, size_t nSize, STREAM *Stream ) ;
int StreamWriteString ( const char *szBuffer, STREAM *Stream ) ;
int __cdecl StreamWriteFormat ( STREAM *Stream, const char *format,... ) ;

STREAM *OpenFileStreamForReadingA ( const char *szFileName ) ;
STREAM *OpenFileStreamForWritingA ( const char *szFileName ) ;
STREAM *OpenFileStreamForReadingW ( const wchar_t *szFileName ) ;
STREAM *OpenFileStreamForWritingW ( const wchar_t *szFileName ) ;

STREAM *OpenStringStreamForReading ( const void *String, size_t nLength, int nCharSize ) ;
STREAM *OpenStringStreamForWriting ( void *String, size_t nLength, int nCharSize ) ;

int CloseStream ( STREAM *Stream, size_t *pSize ) ;


#ifdef UNICODE
#define OpenFileStreamForReading OpenFileStreamForReadingW
#define OpenFileStreamForWriting OpenFileStreamForWritingW
#else
#define OpenFileStreamForReading OpenFileStreamForReadingA
#define OpenFileStreamForWriting OpenFileStreamForWritingA
#endif


#ifdef __cplusplus
}
#endif


#endif


