// tamiltable.h

#ifndef TAMILTABLE_H
#define TAMILTABLE_H


#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#pragma setlocale ( "C" )
#endif



static const TAMIL_EQUIVALENT_TABLE TamilEquivalentTable [] = {
//                                  TSCII             TAB               TAM
   {  L"\x0B94",                    "\xB6",           "\xE5\xF7",       "\xE5\xF7",       },
   {  L"\x0020\x0BBE",              "\x20\xA1",       "\x20\xA3",       "\x20\xA3",       },
   {  L"\x0020\x0BBF",              "\x20\xA2",       "\x20\xA4",       "\x20\xA4",       },
   {  L"\x0020\x0BC0",              "\x20\xA3",       "\x20\xA6",       "\x20\xA6",       },
   {  L"\x0020\x0BC1",              "\x20\xA4",       "\x20\xA7",       "\x20\xA7",       },
   {  L"\x0020\x0BC2",              "\x20\xA5",       "\x20\xA8",       "\x20\xA8",       },
   {  L"\x0020\x0BC6",              "\xA6\x20",       "\xAA\x20",       "\xAA\x20",       },
   {  L"\x0020\x0BC7",              "\xA7\x20",       "\xAB\x20",       "\xAB\x20",       },
   {  L"\x0020\x0BC8",              "\xA8\x20",       "\xAC\x20",       "\xAC\x20",       },
   {  L"\x0020\x0BCA",              "\xA6\x20\xA1",   "\xAA\x20\xA3",   "\xAA\x20\xA3",   },
   {  L"\x0020\x0BCB",              "\xA7\x20\xA1",   "\xAB\x20\xA3",   "\xAB\x20\xA3",   },
   {  L"\x0020\x0BCC",              "\xA6\x20\xAA",   "\xAA\x20\xF7",   "\xAA\x20\xF7",   },
   {  L"\x00A0\x0BBE",              NULL,             "\xA0\xA3",       "\xA0\xA3",       },
   {  L"\x00A0\x0BBF",              NULL,             "\xA0\xA4",       "\xA0\xA4",       },
   {  L"\x00A0\x0BC0",              NULL,             "\xA0\xA6",       "\xA0\xA6",       },
   {  L"\x00A0\x0BC1",              NULL,             "\xA0\xA7",       "\xA0\xA7",       },
   {  L"\x00A0\x0BC2",              NULL,             "\xA0\xA8",       "\xA0\xA8",       },
   {  L"\x00A0\x0BC6",              NULL,             "\xAA\xA0",       "\xAA\xA0",       },
   {  L"\x00A0\x0BC7",              NULL,             "\xAB\xA0",       "\xAB\xA0",       },
   {  L"\x00A0\x0BC8",              NULL,             "\xAC\xA0",       "\xAC\xA0",       },
   {  L"\x00A0\x0BCA",              NULL,             "\xAA\xA0\xA3",   "\xAA\xA0\xA3",   },
   {  L"\x00A0\x0BCB",              NULL,             "\xAB\xA0\xA3",   "\xAB\xA0\xA3",   },
   {  L"\x00A0\x0BCC",              NULL,             "\xAA\xA0\xF7",   "\xAA\xA0\xF7",   },
   {  L"\x0B95\x0BCD",              "\xEC",           "\xE8\xA2",       "\x82",           },
   {  L"\x0B95\x0BBE",              "\xB8\xA1",       "\xE8\xA3",       "\xE8\xA3",       },
   {  L"\x0B95\x0BBF",              "\xB8\xA2",       "\xE8\xA4",       "\x41",           },
   {  L"\x0B95\x0BC0",              "\xB8\xA3",       "\xE8\xA6",       "\x57",           },
   {  L"\x0B95\x0BC1",              "\xCC",           "\xB0",           "\xB0",           },
   {  L"\x0B95\x0BC2",              "\xDC",           "\xC3",           "\xC3",           },
   {  L"\x0B95\x0BC6",              "\xA6\xB8",       "\xAA\xE8",       "\xAA\xE8",       },
   {  L"\x0B95\x0BC7",              "\xA7\xB8",       "\xAB\xE8",       "\xAB\xE8",       },
   {  L"\x0B95\x0BC8",              "\xA8\xB8",       "\xAC\xE8",       "\xAC\xE8",       },
   {  L"\x0B95\x0BCA",              "\xA6\xB8\xA1",   "\xAA\xE8\xA3",   "\xAA\xE8\xA3",   },
   {  L"\x0B95\x0BCB",              "\xA7\xB8\xA1",   "\xAB\xE8\xA3",   "\xAB\xE8\xA3",   },
   {  L"\x0B95\x0BCC",              "\xA6\xB8\xAA",   "\xAA\xE8\xF7",   "\xAA\xE8\xF7",   },
   {  L"\x0B99\x0BCD",              "\xED",           "\xE9\xA2",       "\x83",           },
   {  L"\x0B99\x0BBE",              "\xB9\xA1",       "\xE9\xA3",       "\xE9\xA3",       },
   {  L"\x0B99\x0BBF",              "\xB9\xA2",       "\xE9\xA4",       "\x42",           },
   {  L"\x0B99\x0BC0",              "\xB9\xA3",       "\xE9\xA6",       "\x58",           },
   {  L"\x0B99\x0BC1",              "\x99",           "\xB1",           "\xB1",           },
   {  L"\x0B99\x0BC2",              "\x9B",           "\xC4",           "\xC4",           },
   {  L"\x0B99\x0BC6",              "\xA6\xB9",       "\xAA\xE9",       "\xAA\xE9",       },
   {  L"\x0B99\x0BC7",              "\xA7\xB9",       "\xAB\xE9",       "\xAB\xE9",       },
   {  L"\x0B99\x0BC8",              "\xA8\xB9",       "\xAC\xE9",       "\xAC\xE9",       },
   {  L"\x0B99\x0BCA",              "\xA6\xB9\xA1",   "\xAA\xE9\xA3",   "\xAA\xE9\xA3",   },
   {  L"\x0B99\x0BCB",              "\xA7\xB9\xA1",   "\xAB\xE9\xA3",   "\xAB\xE9\xA3",   },
   {  L"\x0B99\x0BCC",              "\xA6\xB9\xAA",   "\xAA\xE9\xF7",   "\xAA\xE9\xF7",   },
   {  L"\x0B9A\x0BCD",              "\xEE",           "\xEA\xA2",       "\x84",           },
   {  L"\x0B9A\x0BBE",              "\xBA\xA1",       "\xEA\xA3",       "\xEA\xA3",       },
   {  L"\x0B9A\x0BBF",              "\xBA\xA2",       "\xEA\xA4",       "\x43",           },
   {  L"\x0B9A\x0BC0",              "\xBA\xA3",       "\xEA\xA6",       "\x59",           },
   {  L"\x0B9A\x0BC1",              "\xCD",           "\xB2",           "\xB2",           },
   {  L"\x0B9A\x0BC2",              "\xDD",           "\xC5",           "\xC5",           },
   {  L"\x0B9A\x0BC6",              "\xA6\xBA",       "\xAA\xEA",       "\xAA\xEA",       },
   {  L"\x0B9A\x0BC7",              "\xA7\xBA",       "\xAB\xEA",       "\xAB\xEA",       },
   {  L"\x0B9A\x0BC8",              "\xA8\xBA",       "\xAC\xEA",       "\xAC\xEA",       },
   {  L"\x0B9A\x0BCA",              "\xA6\xBA\xA1",   "\xAA\xEA\xA3",   "\xAA\xEA\xA3",   },
   {  L"\x0B9A\x0BCB",              "\xA7\xBA\xA1",   "\xAB\xEA\xA3",   "\xAB\xEA\xA3",   },
   {  L"\x0B9A\x0BCC",              "\xA6\xBA\xAA",   "\xAA\xEA\xF7",   "\xAA\xEA\xF7",   },
   {  L"\x0B9E\x0BCD",              "\xEF",           "\xEB\xA2",       "\x85",           },
   {  L"\x0B9E\x0BBE",              "\xBB\xA1",       "\xEB\xA3",       "\xEB\xA3",       },
   {  L"\x0B9E\x0BBF",              "\xBB\xA2",       "\xEB\xA4",       "\x44",           },
   {  L"\x0B9E\x0BC0",              "\xBB\xA3",       "\xEB\xA6",       "\x5A",           },
   {  L"\x0B9E\x0BC1",              "\x9A",           "\xB3",           "\xB3",           },
   {  L"\x0B9E\x0BC2",              "\x9C",           "\xC6",           "\xC6",           },
   {  L"\x0B9E\x0BC6",              "\xA6\xBB",       "\xAA\xEB",       "\xAA\xEB",       },
   {  L"\x0B9E\x0BC7",              "\xA7\xBB",       "\xAB\xEB",       "\xAB\xEB",       },
   {  L"\x0B9E\x0BC8",              "\xA8\xBB",       "\xAC\xEB",       "\xAC\xEB",       },
   {  L"\x0B9E\x0BCA",              "\xA6\xBB\xA1",   "\xAA\xEB\xA3",   "\xAA\xEB\xA3",   },
   {  L"\x0B9E\x0BCB",              "\xA7\xBB\xA1",   "\xAB\xEB\xA3",   "\xAB\xEB\xA3",   },
   {  L"\x0B9E\x0BCC",              "\xA6\xBB\xAA",   "\xAA\xEB\xF7",   "\xAA\xEB\xF7",   },
   {  L"\x0B9F\x0BCD",              "\xF0",           "\xEC\xA2",       "\x86",           },
   {  L"\x0B9F\x0BBE",              "\xBC\xA1",       "\xEC\xA3",       "\xEC\xA3",       },
   {  L"\x0B9F\x0BBF",              "\xCA",           "\xAE",           "\xAE",           },
   {  L"\x0B9F\x0BC0",              "\xCB",           "\xAF",           "\xAF",           },
   {  L"\x0B9F\x0BC1",              "\xCE",           "\xB4",           "\xB4",           },
   {  L"\x0B9F\x0BC2",              "\xDE",           "\xC7",           "\xC7",           },
   {  L"\x0B9F\x0BC6",              "\xA6\xBC",       "\xAA\xEC",       "\xAA\xEC",       },
   {  L"\x0B9F\x0BC7",              "\xA7\xBC",       "\xAB\xEC",       "\xAB\xEC",       },
   {  L"\x0B9F\x0BC8",              "\xA8\xBC",       "\xAC\xEC",       "\xAC\xEC",       },
   {  L"\x0B9F\x0BCA",              "\xA6\xBC\xA1",   "\xAA\xEC\xA3",   "\xAA\xEC\xA3",   },
   {  L"\x0B9F\x0BCB",              "\xA7\xBC\xA1",   "\xAB\xEC\xA3",   "\xAB\xEC\xA3",   },
   {  L"\x0B9F\x0BCC",              "\xA6\xBC\xAA",   "\xAA\xEC\xF7",   "\xAA\xEC\xF7",   },
   {  L"\x0BA3\x0BCD",              "\xF1",           "\xED\xA2",       "\x87",           },
   {  L"\x0BA3\x0BBE",              "\xBD\xA1",       "\xED\xA3",       "\xED\xA3",       },
   {  L"\x0BA3\x0BBF",              "\xBD\xA2",       "\xED\xA4",       "\x45",           },
   {  L"\x0BA3\x0BC0",              "\xBD\xA3",       "\xED\xA6",       "\x61",           },
   {  L"\x0BA3\x0BC1",              "\xCF",           "\xB5",           "\xB5",           },
   {  L"\x0BA3\x0BC2",              "\xDF",           "\xC8",           "\xC8",           },
   {  L"\x0BA3\x0BC6",              "\xA6\xBD",       "\xAA\xED",       "\xAA\xED",       },
   {  L"\x0BA3\x0BC7",              "\xA7\xBD",       "\xAB\xED",       "\xAB\xED",       },
   {  L"\x0BA3\x0BC8",              "\xA8\xBD",       "\xAC\xED",       "\xAC\xED",       },
   {  L"\x0BA3\x0BCA",              "\xA6\xBD\xA1",   "\xAA\xED\xA3",   "\xAA\xED\xA3",   },
   {  L"\x0BA3\x0BCB",              "\xA7\xBD\xA1",   "\xAB\xED\xA3",   "\xAB\xED\xA3",   },
   {  L"\x0BA3\x0BCC",              "\xA6\xBD\xAA",   "\xAA\xED\xF7",   "\xAA\xED\xF7",   },
   {  L"\x0BA4\x0BCD",              "\xF2",           "\xEE\xA2",       "\x88",           },
   {  L"\x0BA4\x0BBE",              "\xBE\xA1",       "\xEE\xA3",       "\xEE\xA3",       },
   {  L"\x0BA4\x0BBF",              "\xBE\xA2",       "\xEE\xA4",       "\x46",           },
   {  L"\x0BA4\x0BC0",              "\xBE\xA3",       "\xEE\xA6",       "\x62",           },
   {  L"\x0BA4\x0BC1",              "\xD0",           "\xB6",           "\xB6",           },
   {  L"\x0BA4\x0BC2",              "\xE0",           "\xC9",           "\xC9",           },
   {  L"\x0BA4\x0BC6",              "\xA6\xBE",       "\xAA\xEE",       "\xAA\xEE",       },
   {  L"\x0BA4\x0BC7",              "\xA7\xBE",       "\xAB\xEE",       "\xAB\xEE",       },
   {  L"\x0BA4\x0BC8",              "\xA8\xBE",       "\xAC\xEE",       "\xAC\xEE",       },
   {  L"\x0BA4\x0BCA",              "\xA6\xBE\xA1",   "\xAA\xEE\xA3",   "\xAA\xEE\xA3",   },
   {  L"\x0BA4\x0BCB",              "\xA7\xBE\xA1",   "\xAB\xEE\xA3",   "\xAB\xEE\xA3",   },
   {  L"\x0BA4\x0BCC",              "\xA6\xBE\xAA",   "\xAA\xEE\xF7",   "\xAA\xEE\xF7",   },
   {  L"\x0BA8\x0BCD",              "\xF3",           "\xEF\xA2",       "\x89",           },
   {  L"\x0BA8\x0BBE",              "\xBF\xA1",       "\xEF\xA3",       "\xEF\xA3",       },
   {  L"\x0BA8\x0BBF",              "\xBF\xA2",       "\xEF\xA4",       "\x47",           },
   {  L"\x0BA8\x0BC0",              "\xBF\xA3",       "\xEF\xA6",       "\x63",           },
   {  L"\x0BA8\x0BC1",              "\xD1",           "\xB8",           "\xB8",           },
   {  L"\x0BA8\x0BC2",              "\xE1",           "\xCB",           "\xCB",           },
   {  L"\x0BA8\x0BC6",              "\xA6\xBF",       "\xAA\xEF",       "\xAA\xEF",       },
   {  L"\x0BA8\x0BC7",              "\xA7\xBF",       "\xAB\xEF",       "\xAB\xEF",       },
   {  L"\x0BA8\x0BC8",              "\xA8\xBF",       "\xAC\xEF",       "\xAC\xEF",       },
   {  L"\x0BA8\x0BCA",              "\xA6\xBF\xA1",   "\xAA\xEF\xA3",   "\xAA\xEF\xA3",   },
   {  L"\x0BA8\x0BCB",              "\xA7\xBF\xA1",   "\xAB\xEF\xA3",   "\xAB\xEF\xA3",   },
   {  L"\x0BA8\x0BCC",              "\xA6\xBF\xAA",   "\xAA\xEF\xF7",   "\xAA\xEF\xF7",   },
   {  L"\x0BAA\x0BCD",              "\xF4",           "\xF0\xA2",       "\x8A",           },
   {  L"\x0BAA\x0BBE",              "\xC0\xA1",       "\xF0\xA3",       "\xF0\xA3",       },
   {  L"\x0BAA\x0BBF",              "\xC0\xA2",       "\xF0\xA4",       "\x48",           },
   {  L"\x0BAA\x0BC0",              "\xC0\xA3",       "\xF0\xA6",       "\x64",           },
   {  L"\x0BAA\x0BC1",              "\xD2",           "\xB9",           "\xB9",           },
   {  L"\x0BAA\x0BC2",              "\xE2",           "\xCC",           "\xCC",           },
   {  L"\x0BAA\x0BC6",              "\xA6\xC0",       "\xAA\xF0",       "\xAA\xF0",       },
   {  L"\x0BAA\x0BC7",              "\xA7\xC0",       "\xAB\xF0",       "\xAB\xF0",       },
   {  L"\x0BAA\x0BC8",              "\xA8\xC0",       "\xAC\xF0",       "\xAC\xF0",       },
   {  L"\x0BAA\x0BCA",              "\xA6\xC0\xA1",   "\xAA\xF0\xA3",   "\xAA\xF0\xA3",   },
   {  L"\x0BAA\x0BCB",              "\xA7\xC0\xA1",   "\xAB\xF0\xA3",   "\xAB\xF0\xA3",   },
   {  L"\x0BAA\x0BCC",              "\xA6\xC0\xAA",   "\xAA\xF0\xF7",   "\xAA\xF0\xF7",   },
   {  L"\x0BAE\x0BCD",              "\xF5",           "\xF1\xA2",       "\x8B",           },
   {  L"\x0BAE\x0BBE",              "\xC1\xA1",       "\xF1\xA3",       "\xF1\xA3",       },
   {  L"\x0BAE\x0BBF",              "\xC1\xA2",       "\xF1\xA4",       "\x49",           },
   {  L"\x0BAE\x0BC0",              "\xC1\xA3",       "\xF1\xA6",       "\x65",           },
   {  L"\x0BAE\x0BC1",              "\xD3",           "\xBA",           "\xBA",           },
   {  L"\x0BAE\x0BC2",              "\xE3",           "\xCD",           "\xCD",           },
   {  L"\x0BAE\x0BC6",              "\xA6\xC1",       "\xAA\xF1",       "\xAA\xF1",       },
   {  L"\x0BAE\x0BC7",              "\xA7\xC1",       "\xAB\xF1",       "\xAB\xF1",       },
   {  L"\x0BAE\x0BC8",              "\xA8\xC1",       "\xAC\xF1",       "\xAC\xF1",       },
   {  L"\x0BAE\x0BCA",              "\xA6\xC1\xA1",   "\xAA\xF1\xA3",   "\xAA\xF1\xA3",   },
   {  L"\x0BAE\x0BCB",              "\xA7\xC1\xA1",   "\xAB\xF1\xA3",   "\xAB\xF1\xA3",   },
   {  L"\x0BAE\x0BCC",              "\xA6\xC1\xAA",   "\xAA\xF1\xF7",   "\xAA\xF1\xF7",   },
   {  L"\x0BAF\x0BCD",              "\xF6",           "\xF2\xA2",       "\x8C",           },
   {  L"\x0BAF\x0BBE",              "\xC2\xA1",       "\xF2\xA3",       "\xF2\xA3",       },
   {  L"\x0BAF\x0BBF",              "\xC2\xA2",       "\xF2\xA4",       "\x4A",           },
   {  L"\x0BAF\x0BC0",              "\xC2\xA3",       "\xF2\xA6",       "\x66",           },
   {  L"\x0BAF\x0BC1",              "\xD4",           "\xBB",           "\xBB",           },
   {  L"\x0BAF\x0BC2",              "\xE4",           "\xCE",           "\xCE",           },
   {  L"\x0BAF\x0BC6",              "\xA6\xC2",       "\xAA\xF2",       "\xAA\xF2",       },
   {  L"\x0BAF\x0BC7",              "\xA7\xC2",       "\xAB\xF2",       "\xAB\xF2",       },
   {  L"\x0BAF\x0BC8",              "\xA8\xC2",       "\xAC\xF2",       "\xAC\xF2",       },
   {  L"\x0BAF\x0BCA",              "\xA6\xC2\xA1",   "\xAA\xF2\xA3",   "\xAA\xF2\xA3",   },
   {  L"\x0BAF\x0BCB",              "\xA7\xC2\xA1",   "\xAB\xF2\xA3",   "\xAB\xF2\xA3",   },
   {  L"\x0BAF\x0BCC",              "\xA6\xC2\xAA",   "\xAA\xF2\xF7",   "\xAA\xF2\xF7",   },
   {  L"\x0BB0\x0BCD",              "\xF7",           "\xF3\xA2",       "\x98",           },
   {  L"\x0BB0\x0BBE",              "\xC3\xA1",       "\xF3\xA3",       "\xF3\xA3",       },
   {  L"\x0BB0\x0BBF",              "\xC3\xA2",       "\xF3\xA4",       "\x4B",           },
   {  L"\x0BB0\x0BC0",              "\xC3\xA3",       "\xF3\xA6",       "\x67",           },
   {  L"\x0BB0\x0BC1",              "\xD5",           "\xBC",           "\xBC",           },
   {  L"\x0BB0\x0BC2",              "\xE5",           "\xCF",           "\xCF",           },
   {  L"\x0BB0\x0BC6",              "\xA6\xC3",       "\xAA\xF3",       "\xAA\xF3",       },
   {  L"\x0BB0\x0BC7",              "\xA7\xC3",       "\xAB\xF3",       "\xAB\xF3",       },
   {  L"\x0BB0\x0BC8",              "\xA8\xC3",       "\xAC\xF3",       "\xAC\xF3",       },
   {  L"\x0BB0\x0BCA",              "\xA6\xC3\xA1",   "\xAA\xF3\xA3",   "\xAA\xF3\xA3",   },
   {  L"\x0BB0\x0BCB",              "\xA7\xC3\xA1",   "\xAB\xF3\xA3",   "\xAB\xF3\xA3",   },
   {  L"\x0BB0\x0BCC",              "\xA6\xC3\xAA",   "\xAA\xF3\xF7",   "\xAA\xF3\xF7",   },
   {  L"\x0BB2\x0BCD",              "\xF8",           "\xF4\xA2",       "\x99",           },
   {  L"\x0BB2\x0BBE",              "\xC4\xA1",       "\xF4\xA3",       "\xF4\xA3",       },
   {  L"\x0BB2\x0BBF",              "\xC4\xA2",       "\xF4\xA4",       "\x4C",           },
   {  L"\x0BB2\x0BC0",              "\xC4\xA3",       "\xF4\xA6",       "\x68",           },
   {  L"\x0BB2\x0BC1",              "\xD6",           "\xBD",           "\xBD",           },
   {  L"\x0BB2\x0BC2",              "\xE6",           "\xD6",           "\xD6",           },
   {  L"\x0BB2\x0BC6",              "\xA6\xC4",       "\xAA\xF4",       "\xAA\xF4",       },
   {  L"\x0BB2\x0BC7",              "\xA7\xC4",       "\xAB\xF4",       "\xAB\xF4",       },
   {  L"\x0BB2\x0BC8",              "\xA8\xC4",       "\xAC\xF4",       "\xAC\xF4",       },
   {  L"\x0BB2\x0BCA",              "\xA6\xC4\xA1",   "\xAA\xF4\xA3",   "\xAA\xF4\xA3",   },
   {  L"\x0BB2\x0BCB",              "\xA7\xC4\xA1",   "\xAB\xF4\xA3",   "\xAB\xF4\xA3",   },
   {  L"\x0BB2\x0BCC",              "\xA6\xC4\xAA",   "\xAA\xF4\xF7",   "\xAA\xF4\xF7",   },
   {  L"\x0BB5\x0BCD",              "\xF9",           "\xF5\xA2",       "\x9A",           },
   {  L"\x0BB5\x0BBE",              "\xC5\xA1",       "\xF5\xA3",       "\xF5\xA3",       },
   {  L"\x0BB5\x0BBF",              "\xC5\xA2",       "\xF5\xA4",       "\x4D",           },
   {  L"\x0BB5\x0BC0",              "\xC5\xA3",       "\xF5\xA6",       "\x69",           },
   {  L"\x0BB5\x0BC1",              "\xD7",           "\xBE",           "\xBE",           },
   {  L"\x0BB5\x0BC2",              "\xE7",           "\xD7",           "\xD7",           },
   {  L"\x0BB5\x0BC6",              "\xA6\xC5",       "\xAA\xF5",       "\xAA\xF5",       },
   {  L"\x0BB5\x0BC7",              "\xA7\xC5",       "\xAB\xF5",       "\xAB\xF5",       },
   {  L"\x0BB5\x0BC8",              "\xA8\xC5",       "\xAC\xF5",       "\xAC\xF5",       },
   {  L"\x0BB5\x0BCA",              "\xA6\xC5\xA1",   "\xAA\xF5\xA3",   "\xAA\xF5\xA3",   },
   {  L"\x0BB5\x0BCB",              "\xA7\xC5\xA1",   "\xAB\xF5\xA3",   "\xAB\xF5\xA3",   },
   {  L"\x0BB5\x0BCC",              "\xA6\xC5\xAA",   "\xAA\xF5\xF7",   "\xAA\xF5\xF7",   },
   {  L"\x0BB4\x0BCD",              "\xFA",           "\xF6\xA2",       "\x9B",           },
   {  L"\x0BB4\x0BBE",              "\xC6\xA1",       "\xF6\xA3",       "\xF6\xA3",       },
   {  L"\x0BB4\x0BBF",              "\xC6\xA2",       "\xF6\xA4",       "\x4E",           },
   {  L"\x0BB4\x0BC0",              "\xC6\xA3",       "\xF6\xA6",       "\x6A",           },
   {  L"\x0BB4\x0BC1",              "\xD8",           "\xBF",           "\xBF",           },
   {  L"\x0BB4\x0BC2",              "\xE8",           "\xD8",           "\xD8",           },
   {  L"\x0BB4\x0BC6",              "\xA6\xC6",       "\xAA\xF6",       "\xAA\xF6",       },
   {  L"\x0BB4\x0BC7",              "\xA7\xC6",       "\xAB\xF6",       "\xAB\xF6",       },
   {  L"\x0BB4\x0BC8",              "\xA8\xC6",       "\xAC\xF6",       "\xAC\xF6",       },
   {  L"\x0BB4\x0BCA",              "\xA6\xC6\xA1",   "\xAA\xF6\xA3",   "\xAA\xF6\xA3",   },
   {  L"\x0BB4\x0BCB",              "\xA7\xC6\xA1",   "\xAB\xF6\xA3",   "\xAB\xF6\xA3",   },
   {  L"\x0BB4\x0BCC",              "\xA6\xC6\xAA",   "\xAA\xF6\xF7",   "\xAA\xF6\xF7",   },
   {  L"\x0BB3\x0BCD",              "\xFB",           "\xF7\xA2",       "\x9C",           },
   {  L"\x0BB3\x0BBE",              "\xC7\xA1",       "\xF7\xA3",       "\xF7\xA3",       },
   {  L"\x0BB3\x0BBF",              "\xC7\xA2",       "\xF7\xA4",       "\x4F",           },
   {  L"\x0BB3\x0BC0",              "\xC7\xA3",       "\xF7\xA6",       "\x6B",           },
   {  L"\x0BB3\x0BC1",              "\xD9",           "\xC0",           "\xC0",           },
   {  L"\x0BB3\x0BC2",              "\xE9",           "\xD9",           "\xD9",           },
   {  L"\x0BB3\x0BC6",              "\xA6\xC7",       "\xAA\xF7",       "\xAA\xF7",       },
   {  L"\x0BB3\x0BC7",              "\xA7\xC7",       "\xAB\xF7",       "\xAB\xF7",       },
   {  L"\x0BB3\x0BC8",              "\xA8\xC7",       "\xAC\xF7",       "\xAC\xF7",       },
   {  L"\x0BB3\x0BCA",              "\xA6\xC7\xA1",   "\xAA\xF7\xA3",   "\xAA\xF7\xA3",   },
   {  L"\x0BB3\x0BCB",              "\xA7\xC7\xA1",   "\xAB\xF7\xA3",   "\xAB\xF7\xA3",   },
   {  L"\x0BB3\x0BCC",              "\xA6\xC7\xAA",   "\xAA\xF7\xF7",   "\xAA\xF7\xF7",   },
   {  L"\x0BB1\x0BCD",              "\xFC",           "\xF8\xA2",       "\x9F",           },
   {  L"\x0BB1\x0BBE",              "\xC8\xA1",       "\xF8\xA3",       "\xF8\xA3",       },
   {  L"\x0BB1\x0BBF",              "\xC8\xA2",       "\xF8\xA4",       "\x50",           },
   {  L"\x0BB1\x0BC0",              "\xC8\xA3",       "\xF8\xA6",       "\x6C",           },
   {  L"\x0BB1\x0BC1",              "\xDA",           "\xC1",           "\xC1",           },
   {  L"\x0BB1\x0BC2",              "\xEA",           "\xDA",           "\xDA",           },
   {  L"\x0BB1\x0BC6",              "\xA6\xC8",       "\xAA\xF8",       "\xAA\xF8",       },
   {  L"\x0BB1\x0BC7",              "\xA7\xC8",       "\xAB\xF8",       "\xAB\xF8",       },
   {  L"\x0BB1\x0BC8",              "\xA8\xC8",       "\xAC\xF8",       "\xAC\xF8",       },
   {  L"\x0BB1\x0BCA",              "\xA6\xC8\xA1",   "\xAA\xF8\xA3",   "\xAA\xF8\xA3",   },
   {  L"\x0BB1\x0BCB",              "\xA7\xC8\xA1",   "\xAB\xF8\xA3",   "\xAB\xF8\xA3",   },
   {  L"\x0BB1\x0BCC",              "\xA6\xC8\xAA",   "\xAA\xF8\xF7",   "\xAA\xF8\xF7",   },
   {  L"\x0BA9\x0BCD",              "\xFD",           "\xF9\xA2",       "\xA1",           },
   {  L"\x0BA9\x0BBE",              "\xC9\xA1",       "\xF9\xA3",       "\xF9\xA3",       },
   {  L"\x0BA9\x0BBF",              "\xC9\xA2",       "\xF9\xA4",       "\x51",           },
   {  L"\x0BA9\x0BC0",              "\xC9\xA3",       "\xF9\xA6",       "\x6D",           },
   {  L"\x0BA9\x0BC1",              "\xDB",           "\xC2",           "\xC2",           },
   {  L"\x0BA9\x0BC2",              "\xEB",           "\xDB",           "\xDB",           },
   {  L"\x0BA9\x0BC6",              "\xA6\xC9",       "\xAA\xF9",       "\xAA\xF9",       },
   {  L"\x0BA9\x0BC7",              "\xA7\xC9",       "\xAB\xF9",       "\xAB\xF9",       },
   {  L"\x0BA9\x0BC8",              "\xA8\xC9",       "\xAC\xF9",       "\xAC\xF9",       },
   {  L"\x0BA9\x0BCA",              "\xA6\xC9\xA1",   "\xAA\xF9\xA3",   "\xAA\xF9\xA3",   },
   {  L"\x0BA9\x0BCB",              "\xA7\xC9\xA1",   "\xAB\xF9\xA3",   "\xAB\xF9\xA3",   },
   {  L"\x0BA9\x0BCC",              "\xA6\xC9\xAA",   "\xAA\xF9\xF7",   "\xAA\xF9\xF7",   },
   {  L"\x0BB8\x0BCD",              "\x8A",           "\xFA\xA2",       "\x76",           },
   {  L"\x0BB8\x0BBE",              "\x85\xA1",       "\xFA\xA3",       "\xFA\xA3",       },
   {  L"\x0BB8\x0BBF",              "\x85\xA2",       "\xFA\xA4",       "\x52",           },
   {  L"\x0BB8\x0BC0",              "\x85\xA3",       "\xFA\xA6",       "\x6E",           },
   {  L"\x0BB8\x0BC1",              "\x85\xA4",       "\xFA\xA7",       "\xFA\xA7",       },
   {  L"\x0BB8\x0BC2",              "\x85\xA5",       "\xFA\xA8",       "\xFA\xA8",       },
   {  L"\x0BB8\x0BC6",              "\xA6\x85",       "\xAA\xFA",       "\xAA\xFA",       },
   {  L"\x0BB8\x0BC7",              "\xA7\x85",       "\xAB\xFA",       "\xAB\xFA",       },
   {  L"\x0BB8\x0BC8",              "\xA8\x85",       "\xAC\xFA",       "\xAC\xFA",       },
   {  L"\x0BB8\x0BCA",              "\xA6\x85\xA1",   "\xAA\xFA\xA3",   "\xAA\xFA\xA3",   },
   {  L"\x0BB8\x0BCB",              "\xA7\x85\xA1",   "\xAB\xFA\xA3",   "\xAB\xFA\xA3",   },
   {  L"\x0BB8\x0BCC",              "\xA6\x85\xAA",   "\xAA\xFA\xF7",   "\xAA\xFA\xF7",   },
   {  L"\x0BB7\x0BCD",              "\x89",           "\xFB\xA2",       "\x77",           },
   {  L"\x0BB7\x0BBE",              "\x84\xA1",       "\xFB\xA3",       "\xFB\xA3",       },
   {  L"\x0BB7\x0BBF",              "\x84\xA2",       "\xFB\xA4",       "\x53",           },
   {  L"\x0BB7\x0BC0",              "\x84\xA3",       "\xFB\xA6",       "\x6F",           },
   {  L"\x0BB7\x0BC1",              "\x84\xA4",       "\xFB\xA7",       "\xFB\xA7",       },
   {  L"\x0BB7\x0BC2",              "\x84\xA5",       "\xFB\xA8",       "\xFB\xA8",       },
   {  L"\x0BB7\x0BC6",              "\xA6\x84",       "\xAA\xFB",       "\xAA\xFB",       },
   {  L"\x0BB7\x0BC7",              "\xA7\x84",       "\xAB\xFB",       "\xAB\xFB",       },
   {  L"\x0BB7\x0BC8",              "\xA8\x84",       "\xAC\xFB",       "\xAC\xFB",       },
   {  L"\x0BB7\x0BCA",              "\xA6\x84\xA1",   "\xAA\xFB\xA3",   "\xAA\xFB\xA3",   },
   {  L"\x0BB7\x0BCB",              "\xA7\x84\xA1",   "\xAB\xFB\xA3",   "\xAB\xFB\xA3",   },
   {  L"\x0BB7\x0BCC",              "\xA6\x84\xAA",   "\xAA\xFB\xF7",   "\xAA\xFB\xF7",   },
   {  L"\x0B9C\x0BCD",              "\x88",           "\xFC\xA2",       "\x78",           },
   {  L"\x0B9C\x0BBE",              "\x83\xA1",       "\xFC\xA3",       "\xFC\xA3",       },
   {  L"\x0B9C\x0BBF",              "\x83\xA2",       "\xFC\xA4",       "\x54",           },
   {  L"\x0B9C\x0BC0",              "\x83\xA3",       "\xFC\xA6",       "\x70",           },
   {  L"\x0B9C\x0BC1",              "\x83\xA4",       "\xFC\xA7",       "\xFC\xA7",       },
   {  L"\x0B9C\x0BC2",              "\x83\xA5",       "\xFC\xA8",       "\xFC\xA8",       },
   {  L"\x0B9C\x0BC6",              "\xA6\x83",       "\xAA\xFC",       "\xAA\xFC",       },
   {  L"\x0B9C\x0BC7",              "\xA7\x83",       "\xAB\xFC",       "\xAB\xFC",       },
   {  L"\x0B9C\x0BC8",              "\xA8\x83",       "\xAC\xFC",       "\xAC\xFC",       },
   {  L"\x0B9C\x0BCA",              "\xA6\x83\xA1",   "\xAA\xFC\xA3",   "\xAA\xFC\xA3",   },
   {  L"\x0B9C\x0BCB",              "\xA7\x83\xA1",   "\xAB\xFC\xA3",   "\xAB\xFC\xA3",   },
   {  L"\x0B9C\x0BCC",              "\xA6\x83\xAA",   "\xAA\xFC\xF7",   "\xAA\xFC\xF7",   },
   {  L"\x0BB9\x0BCD",              "\x8B",           "\xFD\xA2",       "\x79",           },
   {  L"\x0BB9\x0BBE",              "\x86\xA1",       "\xFD\xA3",       "\xFD\xA3",       },
   {  L"\x0BB9\x0BBF",              "\x86\xA2",       "\xFD\xA4",       "\x55",           },
   {  L"\x0BB9\x0BC0",              "\x86\xA3",       "\xFD\xA6",       "\x71",           },
   {  L"\x0BB9\x0BC1",              "\x86\xA4",       "\xFD\xA7",       "\xFD\xA7",       },
   {  L"\x0BB9\x0BC2",              "\x86\xA5",       "\xFD\xA8",       "\xFD\xA8",       },
   {  L"\x0BB9\x0BC6",              "\xA6\x86",       "\xAA\xFD",       "\xAA\xFD",       },
   {  L"\x0BB9\x0BC7",              "\xA7\x86",       "\xAB\xFD",       "\xAB\xFD",       },
   {  L"\x0BB9\x0BC8",              "\xA8\x86",       "\xAC\xFD",       "\xAC\xFD",       },
   {  L"\x0BB9\x0BCA",              "\xA6\x86\xA1",   "\xAA\xFD\xA3",   "\xAA\xFD\xA3",   },
   {  L"\x0BB9\x0BCB",              "\xA7\x86\xA1",   "\xAB\xFD\xA3",   "\xAB\xFD\xA3",   },
   {  L"\x0BB9\x0BCC",              "\xA6\x86\xAA",   "\xAA\xFD\xF7",   "\xAA\xFD\xF7",   },
   {  L"\x0B95\x0BCD\x0BB7\x0BCD",  "\x8C",           "\xFE\xA2",       "\x7A",           },
   {  L"\x0B95\x0BCD\x0BB7",        "\x87",           "\xFE",           "\xFE",           },
   {  L"\x0B95\x0BCD\x0BB7\x0BBE",  "\x87\xA1",       "\xFE\xA3",       "\xFE\xA3",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BBF",  "\x87\xA2",       "\xFE\xA4",       "\x56",           },
   {  L"\x0B95\x0BCD\x0BB7\x0BC0",  "\x87\xA3",       "\xFE\xA6",       "\x72",           },
   {  L"\x0B95\x0BCD\x0BB7\x0BC1",  "\x87\xA4",       "\xFE\xA7",       "\xFE\xA7",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BC2",  "\x87\xA5",       "\xFE\xA8",       "\xFE\xA8",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BC6",  "\xA6\x87",       "\xAA\xFE",       "\xAA\xFE",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BC7",  "\xA7\x87",       "\xAB\xFE",       "\xAB\xFE",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BC8",  "\xA8\x87",       "\xAC\xFE",       "\xAC\xFE",       },
   {  L"\x0B95\x0BCD\x0BB7\x0BCA",  "\xA6\x87\xA1",   "\xAA\xFE\xA3",   "\xAA\xFE\xA3",   },
   {  L"\x0B95\x0BCD\x0BB7\x0BCB",  "\xA7\x87\xA1",   "\xAB\xFE\xA3",   "\xAB\xFE\xA3",   },
   {  L"\x0B95\x0BCD\x0BB7\x0BCC",  "\xA6\x87\xAA",   "\xAA\xFE\xF7",   "\xAA\xFE\xF7",   },
   {  L"\x0BB6\x0BCD\x0BB0\x0BC0",  "\x82",           "\xFF",           "\xFF",           },
} ;

static const int TAMIL_EQUIVALENT_TABLE_NELEM = NELEMOF ( TamilEquivalentTable ) ;


// U MAXLEN: 4
// C MAXLEN: 3


#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#include "msc.h"
#endif



#endif
