// uniprior.cpp

#include <string.h>
#include "msc.h"
#include "codepage.h"
#include "uniprior.h"


#ifndef GetShortArrayBit
#define GetShortArrayBit(Array,Index)  ( ( (Array) [ (Index) >> 4 ] >> ( (Index) & 0xF ) ) & 1 )
#endif



///////////////////////////////////////////////////////////////////////////////////////
//                            Dxe[u BIT (SRC)
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short SrcPriorityBitTable_00 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00xx
      0,       0,       0,       0,       0x84B4,  0x1170,  0x84B4,  0x1170,  
} ;


static const unsigned short SrcPriorityBitTable_01 [] = {
      0x000C,  0x000D,  0,       0,       0x3000,  0,       0,       0,       // 0x01xx
      0xC200,  0,       0x8003,  0x0001,  0,       0xDFE0,  0,       0xCC00,  
} ;


static const unsigned short SrcPriorityBitTable_02 [] = {
      0,       0,       0xFC00,  0x0003,  0,       0,       0,       0,       // 0x02xx
      0,       0,       0,       0,       0x2000,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_03 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x03xx
      0xD740,  0x0001,  0xFC00,  0x0001,  0x7C00,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_04 [] = {
      0x0080,  0,       0,       0,       0,       0x0080,  0,       0,       // 0x04xx
      0,       0,       0,       0,       0,       0x0500,  0,       0,       
} ;

#define  SrcPriorityBitTable_05  NULL
#define  SrcPriorityBitTable_06  NULL
#define  SrcPriorityBitTable_07  NULL
#define  SrcPriorityBitTable_08  NULL
#define  SrcPriorityBitTable_09  NULL
#define  SrcPriorityBitTable_0A  NULL
#define  SrcPriorityBitTable_0B  NULL
#define  SrcPriorityBitTable_0C  NULL
#define  SrcPriorityBitTable_0D  NULL
#define  SrcPriorityBitTable_0E  NULL
#define  SrcPriorityBitTable_0F  NULL
#define  SrcPriorityBitTable_10  NULL
#define  SrcPriorityBitTable_11  NULL
#define  SrcPriorityBitTable_12  NULL
#define  SrcPriorityBitTable_13  NULL
#define  SrcPriorityBitTable_14  NULL
#define  SrcPriorityBitTable_15  NULL
#define  SrcPriorityBitTable_16  NULL
#define  SrcPriorityBitTable_17  NULL
#define  SrcPriorityBitTable_18  NULL
#define  SrcPriorityBitTable_19  NULL
#define  SrcPriorityBitTable_1A  NULL
#define  SrcPriorityBitTable_1B  NULL
#define  SrcPriorityBitTable_1C  NULL

static const unsigned short SrcPriorityBitTable_1D [] = {
      0,       0,       0,       0x0004,  0,       0,       0,       0,       // 0x1Dxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_1E [] = {
      0x0300,  0x00F0,  0xC000,  0,       0xF000,  0x000F,  0,       0,       // 0x1Exx
      0,       0,       0xFFF0,  0xC0FF,  0x00FF,  0xFFFF,  0xFF0F,  0x0003,  
} ;


static const unsigned short SrcPriorityBitTable_1F [] = {
      0x3030,  0x3030,  0x3030,  0x3030,  0x3030,  0x3030,  0x3030,  0x2AAA,  // 0x1Fxx
      0x3030,  0x3030,  0x3030,  0x0830,  0x0A30,  0x088C,  0x088C,  0x0A10,  
} ;


static const unsigned short SrcPriorityBitTable_20 [] = {
      0,       0x203C,  0,       0x0008,  0,       0,       0,       0,       // 0x20xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_21 [] = {
      0,       0,       0x0800,  0,       0,       0,       0,       0,       // 0x21xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_22 [] = {
      0,       0,       0x0008,  0x1040,  0,       0,       0,       0,       // 0x22xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  SrcPriorityBitTable_23  NULL

static const unsigned short SrcPriorityBitTable_24 [] = {
      0,       0,       0,       0,       0,       0,       0xFFFF,  0x000F,  // 0x24xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  SrcPriorityBitTable_25  NULL
#define  SrcPriorityBitTable_26  NULL
#define  SrcPriorityBitTable_27  NULL
#define  SrcPriorityBitTable_28  NULL
#define  SrcPriorityBitTable_29  NULL
#define  SrcPriorityBitTable_2A  NULL
#define  SrcPriorityBitTable_2B  NULL
#define  SrcPriorityBitTable_2C  NULL
#define  SrcPriorityBitTable_2D  NULL
#define  SrcPriorityBitTable_2E  NULL
#define  SrcPriorityBitTable_2F  NULL

static const unsigned short SrcPriorityBitTable_30 [] = {
      0x0080,  0x4000,  0,       0,       0,       0,       0,       0,       // 0x30xx
      0,       0,       0,       0,       0,       0,       0,       0x1000,  
} ;

#define  SrcPriorityBitTable_31  NULL
#define  SrcPriorityBitTable_32  NULL
#define  SrcPriorityBitTable_33  NULL
#define  SrcPriorityBitTable_34  NULL
#define  SrcPriorityBitTable_35  NULL
#define  SrcPriorityBitTable_36  NULL
#define  SrcPriorityBitTable_37  NULL
#define  SrcPriorityBitTable_38  NULL
#define  SrcPriorityBitTable_39  NULL
#define  SrcPriorityBitTable_3A  NULL
#define  SrcPriorityBitTable_3B  NULL
#define  SrcPriorityBitTable_3C  NULL
#define  SrcPriorityBitTable_3D  NULL
#define  SrcPriorityBitTable_3E  NULL
#define  SrcPriorityBitTable_3F  NULL
#define  SrcPriorityBitTable_40  NULL
#define  SrcPriorityBitTable_41  NULL
#define  SrcPriorityBitTable_42  NULL
#define  SrcPriorityBitTable_43  NULL
#define  SrcPriorityBitTable_44  NULL
#define  SrcPriorityBitTable_45  NULL
#define  SrcPriorityBitTable_46  NULL
#define  SrcPriorityBitTable_47  NULL
#define  SrcPriorityBitTable_48  NULL

static const unsigned short SrcPriorityBitTable_49 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x49xx
      0x0040,  0,       0,       0,       0,       0,       0,       0,       
} ;

#define  SrcPriorityBitTable_4A  NULL
#define  SrcPriorityBitTable_4B  NULL
#define  SrcPriorityBitTable_4C  NULL

static const unsigned short SrcPriorityBitTable_4D [] = {
      0,       0x0300,  0,       0,       0,       0,       0,       0,       // 0x4Dxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_4E [] = {
      0,       0,       0x0440,  0,       0,       0,       0,       0x4200,  // 0x4Exx
      0x4002,  0x0001,  0,       0,       0x00C0,  0,       0,       0x0080,  
} ;


static const unsigned short SrcPriorityBitTable_4F [] = {
      0,       0,       0,       0,       0x0001,  0x0010,  0,       0x0020,  // 0x4Fxx
      0x0010,  0,       0x2000,  0,       0,       0,       0,       0x0004,  
} ;


static const unsigned short SrcPriorityBitTable_50 [] = {
      0x0004,  0,       0,       0,       0,       0,       0x0400,  0,       // 0x50xx
      0,       0x0400,  0,       0,       0x0400,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_51 [] = {
      0x1002,  0x0100,  0,       0x8200,  0,       0,       0,       0x8000,  // 0x51xx
      0,       0x0002,  0x0004,  0x0006,  0x0018,  0x0040,  0x0001,  0,       
} ;


static const unsigned short SrcPriorityBitTable_52 [] = {
      0,       0,       0,       0,       0x0A00,  0,       0,       0,       // 0x52xx
      0x0010,  0,       0x0100,  0,       0,       0x0022,  0x0001,  0x000C,  
} ;


static const unsigned short SrcPriorityBitTable_53 [] = {
      0,       0x8000,  0,       0,       0,       0,       0x0010,  0,       // 0x53xx
      0x0044,  0x0100,  0x8000,  0x0080,  0x003E,  0,       0,       0x0040,  
} ;


static const unsigned short SrcPriorityBitTable_54 [] = {
      0,       0,       0x1000,  0,       0,       0,       0,       0,       // 0x54xx
      0,       0x0040,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_55 [] = {
      0,       0,       0,       0x0100,  0,       0,       0x4002,  0,       // 0x55xx
      0x0044,  0x0004,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_56 [] = {
      0,       0x0002,  0,       0,       0x0002,  0x0800,  0,       0x0200,  // 0x56xx
      0,       0x0200,  0x4020,  0,       0x1000,  0x0008,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_57 [] = {
      0x4040,  0x0008,  0x1000,  0,       0x8004,  0x0800,  0x8000,  0x8020,  // 0x57xx
      0,       0,       0,       0,       0,       0x1200,  0,       0x0009,  
} ;


static const unsigned short SrcPriorityBitTable_58 [] = {
      0x0008,  0,       0,       0,       0,       0,       0x0010,  0x1000,  // 0x58xx
      0x0200,  0x8000,  0,       0,       0x0490,  0x5000,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_59 [] = {
      0,       0,       0,       0x4300,  0x0002,  0,       0x0200,  0x0100,  // 0x59xx
      0x0040,  0x2000,  0,       0x0080,  0,       0,       0x0400,  0,       
} ;


static const unsigned short SrcPriorityBitTable_5A [] = {
      0,       0,       0x0010,  0,       0,       0,       0x1000,  0x4000,  // 0x5Axx
      0,       0,       0x4000,  0,       0x0800,  0,       0,       0x0400,  
} ;


static const unsigned short SrcPriorityBitTable_5B [] = {
      0,       0,       0x2004,  0x4000,  0x0008,  0,       0,       0,       // 0x5Bxx
      0x200A,  0xC000,  0,       0x1000,  0x0080,  0x0090,  0x0040,  0,       
} ;


static const unsigned short SrcPriorityBitTable_5C [] = {
      0x0020,  0x8000,  0x0001,  0x2100,  0x0080,  0,       0,       0,       // 0x5Cxx
      0x0020,  0,       0x0200,  0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_5D [] = {
      0x0800,  0x0323,  0,       0,       0,       0x000C,  0,       0,       // 0x5Dxx
      0x1000,  0,       0,       0,       0x1000,  0x00C0,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_5E [] = {
      0,       0x0001,  0,       0x0008,  0,       0,       0,       0x82C4,  // 0x5Exx
      0,       0,       0,       0,       0,       0x0020,  0,       0x3B20,  
} ;


static const unsigned short SrcPriorityBitTable_5F [] = {
      0x3000,  0x0001,  0,       0,       0x0400,  0x0600,  0,       0x8080,  // 0x5Fxx
      0,       0,       0x1000,  0x1030,  0,       0,       0x0200,  0x0080,  
} ;


static const unsigned short SrcPriorityBitTable_60 [] = {
      0,       0x1000,  0,       0x000A,  0x0200,  0,       0x0002,  0,       // 0x60xx
      0x0800,  0,       0x0010,  0x2008,  0,       0,       0x2400,  0x0080,  
} ;


static const unsigned short SrcPriorityBitTable_61 [] = {
      0,       0,       0,       0xA000,  0x0010,  0x0402,  0,       0xB010,  // 0x61xx
      0,       0x0002,  0,       0,       0x0008,  0x4004,  0,       0x6040,  
} ;


static const unsigned short SrcPriorityBitTable_62 [] = {
      0,       0x2000,  0,       0,       0,       0x4000,  0x0009,  0x0020,  // 0x62xx
      0,       0,       0,       0x0030,  0,       0x0002,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_63 [] = {
      0x0004,  0,       0,       0,       0x0010,  0x1000,  0,       0x0020,  // 0x63xx
      0,       0,       0,       0x2000,  0,       0,       0,       0x0200,  
} ;


static const unsigned short SrcPriorityBitTable_64 [] = {
      0,       0x1000,  0x81B0,  0,       0x0009,  0,       0,       0,       // 0x64xx
      0,       0,       0x0048,  0,       0,       0,       0x0008,  0,       
} ;


static const unsigned short SrcPriorityBitTable_65 [] = {
      0x0020,  0x0004,  0x0204,  0x0080,  0,       0,       0x2000,  0x0400,  // 0x65xx
      0,       0,       0,       0x1000,  0,       0x0A00,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_66 [] = {
      0,       0,       0,       0x0001,  0,       0,       0,       0x0800,  // 0x66xx
      0x4000,  0,       0x0001,  0,       0x8000,  0,       0,       0x0004,  
} ;


static const unsigned short SrcPriorityBitTable_67 [] = {
      0,       0x4040,  0xC000,  0x0400,  0x0080,  0,       0,       0,       // 0x67xx
      0x8000,  0x0004,  0x0002,  0x0012,  0,       0x8000,  0,       0x0400,  
} ;


static const unsigned short SrcPriorityBitTable_68 [] = {
      0,       0x4010,  0,       0,       0x1000,  0,       0,       0,       // 0x68xx
      0,       0,       0,       0,       0,       0,       0,       0x0002,  
} ;


static const unsigned short SrcPriorityBitTable_69 [] = {
      0,       0x2080,  0,       0x4000,  0,       0,       0,       0,       // 0x69xx
      0,       0,       0x0040,  0,       0,       0x8020,  0,       0x1800,  
} ;


static const unsigned short SrcPriorityBitTable_6A [] = {
      0,       0x0002,  0,       0x0100,  0,       0,       0,       0,       // 0x6Axx
      0x8000,  0,       0x8000,  0x0008,  0,       0x0020,  0,       0x0002,  
} ;


static const unsigned short SrcPriorityBitTable_6B [] = {
      0,       0x6802,  0x0001,  0,       0,       0x0800,  0,       0x0090,  // 0x6Bxx
      0x0001,  0,       0x2000,  0,       0,       0x0108,  0x1080,  0,       
} ;


static const unsigned short SrcPriorityBitTable_6C [] = {
      0x0004,  0,       0,       0,       0,       0,       0,       0,       // 0x6Cxx
      0x0300,  0,       0,       0,       0x0010,  0x2800,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_6D [] = {
      0,       0x0004,  0,       0,       0,       0x1000,  0,       0,       // 0x6Dxx
      0,       0,       0,       0,       0,       0x0804,  0,       0x1000,  
} ;


static const unsigned short SrcPriorityBitTable_6E [] = {
      0,       0x0060,  0,       0x0500,  0,       0,       0,       0x8000,  // 0x6Exx
      0,       0x0040,  0x8000,  0x0080,  0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_6F [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x6Fxx
      0x0004,  0,       0,       0,       0x0080,  0x0820,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_70 [] = {
      0x0800,  0,       0,       0x0001,  0x0800,  0,       0x0100,  0,       // 0x70xx
      0,       0,       0x4000,  0,       0,       0x8000,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_71 [] = {
      0,       0,       0,       0,       0x0080,  0x0200,  0,       0,       // 0x71xx
      0x8000,  0,       0,       0,       0,       0,       0x1000,  0,       
} ;


static const unsigned short SrcPriorityBitTable_72 [] = {
      0,       0,       0,       0,       0x4801,  0x0029,  0x0001,  0x0010,  // 0x72xx
      0x0080,  0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_73 [] = {
      0,       0,       0,       0,       0,       0,       0x0080,  0,       // 0x73xx
      0,       0,       0,       0,       0x4900,  0,       0x4000,  0,       
} ;


static const unsigned short SrcPriorityBitTable_74 [] = {
      0,       0,       0,       0x0006,  0,       0,       0x0001,  0,       // 0x74xx
      0x0080,  0,       0x0004,  0,       0x0100,  0,       0x4008,  0,       
} ;


static const unsigned short SrcPriorityBitTable_75 [] = {
      0,       0x0020,  0x8040,  0,       0x0400,  0,       0,       0,       // 0x75xx
      0,       0,       0,       0,       0x0100,  0,       0x0001,  0x0008,  
} ;


static const unsigned short SrcPriorityBitTable_76 [] = {
      0x0200,  0,       0,       0,       0x0100,  0x0024,  0,       0x0001,  // 0x76xx
      0,       0x1000,  0,       0x0001,  0x1000,  0,       0x0002,  0,       
} ;


static const unsigned short SrcPriorityBitTable_77 [] = {
      0,       0,       0x8000,  0,       0x8000,  0,       0x0001,  0,       // 0x77xx
      0,       0,       0x2000,  0,       0x0080,  0x0200,  0,       0x8000,  
} ;


static const unsigned short SrcPriorityBitTable_78 [] = {
      0,       0x0040,  0,       0x8004,  0x0008,  0,       0,       0x0080,  // 0x78xx
      0x0002,  0x0080,  0,       0,       0,       0x8400,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_79 [] = {
      0x0040,  0,       0x4040,  0,       0,       0,       0,       0,       // 0x79xx
      0,       0,       0,       0,       0,       0x0040,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_7A [] = {
      0,       0x1000,  0x0100,  0x4400,  0x0201,  0,       0,       0,       // 0x7Axx
      0,       0,       0x2000,  0x0040,  0,       0x2000,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_7B [] = {
      0,       0,       0,       0x0400,  0,       0,       0x8200,  0x0002,  // 0x7Bxx
      0x0880,  0x2400,  0x1000,  0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_7C [] = {
      0,       0,       0,       0,       0,       0x0101,  0x0004,  0x0104,  // 0x7Cxx
      0,       0,       0x0080,  0,       0x0040,  0x0008,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_7D [] = {
      0,       0,       0x4020,  0,       0x8000,  0,       0,       0,       // 0x7Dxx
      0,       0,       0,       0x0020,  0,       0,       0x0002,  0x0800,  
} ;


static const unsigned short SrcPriorityBitTable_7E [] = {
      0,       0x0400,  0,       0x4010,  0x0C00,  0x0040,  0x0800,  0,       // 0x7Exx
      0x6000,  0x0050,  0x0010,  0,       0,       0,       0x0200,  0,       
} ;


static const unsigned short SrcPriorityBitTable_7F [] = {
      0,       0x0080,  0,       0x0400,  0x4940,  0x0001,  0x0008,  0,       // 0x7Fxx
      0x0088,  0,       0x0004,  0,       0,       0,       0x0840,  0,       
} ;


static const unsigned short SrcPriorityBitTable_80 [] = {
      0,       0,       0x0002,  0,       0,       0,       0,       0,       // 0x80xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_81 [] = {
      0,       0,       0x0200,  0,       0,       0,       0,       0,       // 0x81xx
      0x0040,  0,       0,       0,       0x0100,  0x2020,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_82 [] = {
      0x6000,  0,       0,       0,       0,       0,       0x0408,  0x0500,  // 0x82xx
      0,       0,       0,       0x0140,  0xC020,  0,       0x0080,  0,       
} ;


static const unsigned short SrcPriorityBitTable_83 [] = {
      0x0008,  0,       0,       0,       0,       0x0101,  0x8000,  0x0008,  // 0x83xx
      0x0400,  0,       0,       0,       0x0200,  0x0010,  0,       0x0110,  
} ;


static const unsigned short SrcPriorityBitTable_84 [] = {
      0,       0,       0,       0x0200,  0x0400,  0,       0x8001,  0,       // 0x84xx
      0,       0,       0,       0,       0x0040,  0,       0x0002,  0,       
} ;


static const unsigned short SrcPriorityBitTable_85 [] = {
      0,       0x0110,  0,       0x0010,  0,       0x0008,  0,       0,       // 0x85xx
      0,       0,       0x1000,  0x0010,  0x0400,  0x2000,  0x0020,  0,       
} ;


static const unsigned short SrcPriorityBitTable_86 [] = {
      0x0080,  0x00C8,  0,       0,       0,       0x0040,  0,       0,       // 0x86xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_87 [] = {
      0,       0,       0,       0x0400,  0,       0,       0,       0,       // 0x87xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_88 [] = {
      0,       0,       0,       0,       0x0400,  0x253C,  0,       0,       // 0x88xx
      0,       0,       0,       0x0080,  0x9000,  0,       0x0002,  0,       
} ;


static const unsigned short SrcPriorityBitTable_89 [] = {
      0,       0x2000,  0x2000,  0,       0x0002,  0,       0x1000,  0,       // 0x89xx
      0x8300,  0,       0,       0x0001,  0x0010,  0x2020,  0x8000,  0x0040,  
} ;


static const unsigned short SrcPriorityBitTable_8A [] = {
      0,       0x0080,  0,       0,       0,       0,       0x0080,  0,       // 0x8Axx
      0,       0x0040,  0,       0,       0,       0,       0x0001,  0,       
} ;


static const unsigned short SrcPriorityBitTable_8B [] = {
      0x1000,  0x0400,  0,       0x1000,  0,       0x0010,  0x2000,  0,       // 0x8Bxx
      0x4008,  0x0401,  0x1000,  0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_8C [] = {
      0,       0,       0x0020,  0,       0,       0x0018,  0,       0,       // 0x8Cxx
      0,       0,       0,       0x0008,  0,       0x0800,  0x1000,  0x0100,  
} ;


static const unsigned short SrcPriorityBitTable_8D [] = {
      0x0400,  0x0001,  0x0040,  0x0001,  0x0040,  0x4000,  0,       0,       // 0x8Dxx
      0,       0x8000,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_8E [] = {
      0,       0,       0,       0x0001,  0x0800,  0x0400,  0,       0x0200,  // 0x8Exx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_8F [] = {
      0,       0x0008,  0,       0,       0,       0,       0,       0,       // 0x8Fxx
      0,       0,       0x8380,  0x0008,  0,       0,       0,       0x0410,  
} ;


static const unsigned short SrcPriorityBitTable_90 [] = {
      0x0004,  0,       0x0020,  0x0001,  0x0400,  0,       0x8002,  0x0040,  // 0x90xx
      0,       0,       0x0100,  0,       0,       0,       0x0010,  0,       
} ;


static const unsigned short SrcPriorityBitTable_91 [] = {
      0,       0,       0,       0,       0,       0x0040,  0x0004,  0,       // 0x91xx
      0x4000,  0x1000,  0,       0,       0,       0,       0x1000,  0,       
} ;


static const unsigned short SrcPriorityBitTable_92 [] = {
      0,       0,       0x0002,  0,       0x0800,  0x4080,  0,       0,       // 0x92xx
      0,       0x1000,  0,       0x0004,  0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_93 [] = {
      0,       0,       0,       0x0040,  0,       0,       0,       0x1000,  // 0x93xx
      0,       0x0090,  0,       0,       0x0080,  0xC400,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_94 [] = {
      0,       0x2100,  0,       0,       0,       0,       0,       0x0020,  // 0x94xx
      0x0002,  0x8000,  0,       0x0408,  0x0080,  0,       0,       0x0004,  
} ;


static const unsigned short SrcPriorityBitTable_95 [] = {
      0,       0,       0,       0,       0,       0x8820,  0x0004,  0,       // 0x95xx
      0,       0x0004,  0x0080,  0,       0x00C0,  0x0500,  0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_96 [] = {
      0,       0,       0x0D00,  0,       0,       0x4000,  0,       0,       // 0x96xx
      0,       0,       0,       0,       0,       0x2020,  0x0001,  0,       
} ;


static const unsigned short SrcPriorityBitTable_97 [] = {
      0,       0,       0x0010,  0,       0,       0,       0x0010,  0,       // 0x97xx
      0x0010,  0,       0x0040,  0,       0x0040,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_98 [] = {
      0,       0,       0,       0,       0x0080,  0,       0x0040,  0,       // 0x98xx
      0,       0,       0,       0x8008,  0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_99 [] = {
      0,       0x0110,  0x1080,  0x2020,  0x0C00,  0,       0,       0,       // 0x99xx
      0x0101,  0x0008,  0,       0,       0,       0,       0x4000,  0,       
} ;


static const unsigned short SrcPriorityBitTable_9A [] = {
      0,       0,       0,       0x0004,  0,       0,       0x0200,  0,       // 0x9Axx
      0,       0,       0,       0,       0,       0x0004,  0x4408,  0x0010,  
} ;


static const unsigned short SrcPriorityBitTable_9B [] = {
      0x2040,  0x0400,  0x3560,  0x0003,  0,       0x0080,  0,       0,       // 0x9Bxx
      0,       0,       0,       0,       0x0002,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_9C [] = {
      0,       0,       0,       0x0004,  0,       0,       0,       0,       // 0x9Cxx
      0,       0,       0x0001,  0,       0x1000,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_9D [] = {
      0x0040,  0,       0,       0,       0,       0,       0,       0x0001,  // 0x9Dxx
      0,       0,       0,       0,       0x0200,  0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_9E [] = {
      0x0400,  0,       0x0200,  0,       0,       0,       0,       0x0220,  // 0x9Exx
      0x0012,  0,       0xAC10,  0x0630,  0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_9F [] = {
      0x0100,  0x0020,  0,       0,       0,       0,       0x0288,  0,       // 0x9Fxx
      0,       0x4000,  0x0021,  0,       0,       0,       0,       0,       
} ;

#define  SrcPriorityBitTable_A0  NULL
#define  SrcPriorityBitTable_A1  NULL
#define  SrcPriorityBitTable_A2  NULL
#define  SrcPriorityBitTable_A3  NULL
#define  SrcPriorityBitTable_A4  NULL
#define  SrcPriorityBitTable_A5  NULL
#define  SrcPriorityBitTable_A6  NULL
#define  SrcPriorityBitTable_A7  NULL
#define  SrcPriorityBitTable_A8  NULL
#define  SrcPriorityBitTable_A9  NULL
#define  SrcPriorityBitTable_AA  NULL
#define  SrcPriorityBitTable_AB  NULL
#define  SrcPriorityBitTable_AC  NULL
#define  SrcPriorityBitTable_AD  NULL
#define  SrcPriorityBitTable_AE  NULL
#define  SrcPriorityBitTable_AF  NULL
#define  SrcPriorityBitTable_B0  NULL
#define  SrcPriorityBitTable_B1  NULL
#define  SrcPriorityBitTable_B2  NULL
#define  SrcPriorityBitTable_B3  NULL
#define  SrcPriorityBitTable_B4  NULL
#define  SrcPriorityBitTable_B5  NULL
#define  SrcPriorityBitTable_B6  NULL
#define  SrcPriorityBitTable_B7  NULL
#define  SrcPriorityBitTable_B8  NULL
#define  SrcPriorityBitTable_B9  NULL
#define  SrcPriorityBitTable_BA  NULL
#define  SrcPriorityBitTable_BB  NULL
#define  SrcPriorityBitTable_BC  NULL
#define  SrcPriorityBitTable_BD  NULL
#define  SrcPriorityBitTable_BE  NULL
#define  SrcPriorityBitTable_BF  NULL
#define  SrcPriorityBitTable_C0  NULL
#define  SrcPriorityBitTable_C1  NULL
#define  SrcPriorityBitTable_C2  NULL
#define  SrcPriorityBitTable_C3  NULL
#define  SrcPriorityBitTable_C4  NULL
#define  SrcPriorityBitTable_C5  NULL
#define  SrcPriorityBitTable_C6  NULL
#define  SrcPriorityBitTable_C7  NULL
#define  SrcPriorityBitTable_C8  NULL
#define  SrcPriorityBitTable_C9  NULL
#define  SrcPriorityBitTable_CA  NULL
#define  SrcPriorityBitTable_CB  NULL
#define  SrcPriorityBitTable_CC  NULL
#define  SrcPriorityBitTable_CD  NULL
#define  SrcPriorityBitTable_CE  NULL
#define  SrcPriorityBitTable_CF  NULL
#define  SrcPriorityBitTable_D0  NULL
#define  SrcPriorityBitTable_D1  NULL
#define  SrcPriorityBitTable_D2  NULL
#define  SrcPriorityBitTable_D3  NULL
#define  SrcPriorityBitTable_D4  NULL
#define  SrcPriorityBitTable_D5  NULL
#define  SrcPriorityBitTable_D6  NULL
#define  SrcPriorityBitTable_D7  NULL
#define  SrcPriorityBitTable_D8  NULL
#define  SrcPriorityBitTable_D9  NULL
#define  SrcPriorityBitTable_DA  NULL
#define  SrcPriorityBitTable_DB  NULL
#define  SrcPriorityBitTable_DC  NULL
#define  SrcPriorityBitTable_DD  NULL
#define  SrcPriorityBitTable_DE  NULL
#define  SrcPriorityBitTable_DF  NULL
#define  SrcPriorityBitTable_E0  NULL
#define  SrcPriorityBitTable_E1  NULL
#define  SrcPriorityBitTable_E2  NULL
#define  SrcPriorityBitTable_E3  NULL
#define  SrcPriorityBitTable_E4  NULL
#define  SrcPriorityBitTable_E5  NULL
#define  SrcPriorityBitTable_E6  NULL
#define  SrcPriorityBitTable_E7  NULL
#define  SrcPriorityBitTable_E8  NULL
#define  SrcPriorityBitTable_E9  NULL
#define  SrcPriorityBitTable_EA  NULL
#define  SrcPriorityBitTable_EB  NULL
#define  SrcPriorityBitTable_EC  NULL
#define  SrcPriorityBitTable_ED  NULL
#define  SrcPriorityBitTable_EE  NULL
#define  SrcPriorityBitTable_EF  NULL
#define  SrcPriorityBitTable_F0  NULL
#define  SrcPriorityBitTable_F1  NULL
#define  SrcPriorityBitTable_F2  NULL
#define  SrcPriorityBitTable_F3  NULL
#define  SrcPriorityBitTable_F4  NULL
#define  SrcPriorityBitTable_F5  NULL
#define  SrcPriorityBitTable_F6  NULL
#define  SrcPriorityBitTable_F7  NULL
#define  SrcPriorityBitTable_F8  NULL
#define  SrcPriorityBitTable_F9  NULL

static const unsigned short SrcPriorityBitTable_FA [] = {
      0,       0x8000,  0,       0,       0,       0,       0,       0,       // 0xFAxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  SrcPriorityBitTable_FB  NULL
#define  SrcPriorityBitTable_FC  NULL
#define  SrcPriorityBitTable_FD  NULL

static const unsigned short SrcPriorityBitTable_FE [] = {
      0,       0,       0,       0xFFFF,  0xFF9F,  0xFFF7,  0x0F7F,  0,       // 0xFExx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short SrcPriorityBitTable_FF [] = {
      0x0004,  0,       0,       0x8000,  0x0001,  0x5000,  0,       0x0001,  // 0xFFxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;



const unsigned short *SrcPriorityBitTable ( int C ) {

   static const unsigned short *const SrcPriorityBitTable_00_FF [] = {
      SrcPriorityBitTable_00, SrcPriorityBitTable_01, SrcPriorityBitTable_02, SrcPriorityBitTable_03,
      SrcPriorityBitTable_04, SrcPriorityBitTable_05, SrcPriorityBitTable_06, SrcPriorityBitTable_07,
      SrcPriorityBitTable_08, SrcPriorityBitTable_09, SrcPriorityBitTable_0A, SrcPriorityBitTable_0B,
      SrcPriorityBitTable_0C, SrcPriorityBitTable_0D, SrcPriorityBitTable_0E, SrcPriorityBitTable_0F,

      SrcPriorityBitTable_10, SrcPriorityBitTable_11, SrcPriorityBitTable_12, SrcPriorityBitTable_13,
      SrcPriorityBitTable_14, SrcPriorityBitTable_15, SrcPriorityBitTable_16, SrcPriorityBitTable_17,
      SrcPriorityBitTable_18, SrcPriorityBitTable_19, SrcPriorityBitTable_1A, SrcPriorityBitTable_1B,
      SrcPriorityBitTable_1C, SrcPriorityBitTable_1D, SrcPriorityBitTable_1E, SrcPriorityBitTable_1F,

      SrcPriorityBitTable_20, SrcPriorityBitTable_21, SrcPriorityBitTable_22, SrcPriorityBitTable_23,
      SrcPriorityBitTable_24, SrcPriorityBitTable_25, SrcPriorityBitTable_26, SrcPriorityBitTable_27,
      SrcPriorityBitTable_28, SrcPriorityBitTable_29, SrcPriorityBitTable_2A, SrcPriorityBitTable_2B,
      SrcPriorityBitTable_2C, SrcPriorityBitTable_2D, SrcPriorityBitTable_2E, SrcPriorityBitTable_2F,

      SrcPriorityBitTable_30, SrcPriorityBitTable_31, SrcPriorityBitTable_32, SrcPriorityBitTable_33,
      SrcPriorityBitTable_34, SrcPriorityBitTable_35, SrcPriorityBitTable_36, SrcPriorityBitTable_37,
      SrcPriorityBitTable_38, SrcPriorityBitTable_39, SrcPriorityBitTable_3A, SrcPriorityBitTable_3B,
      SrcPriorityBitTable_3C, SrcPriorityBitTable_3D, SrcPriorityBitTable_3E, SrcPriorityBitTable_3F,

      SrcPriorityBitTable_40, SrcPriorityBitTable_41, SrcPriorityBitTable_42, SrcPriorityBitTable_43,
      SrcPriorityBitTable_44, SrcPriorityBitTable_45, SrcPriorityBitTable_46, SrcPriorityBitTable_47,
      SrcPriorityBitTable_48, SrcPriorityBitTable_49, SrcPriorityBitTable_4A, SrcPriorityBitTable_4B,
      SrcPriorityBitTable_4C, SrcPriorityBitTable_4D, SrcPriorityBitTable_4E, SrcPriorityBitTable_4F,

      SrcPriorityBitTable_50, SrcPriorityBitTable_51, SrcPriorityBitTable_52, SrcPriorityBitTable_53,
      SrcPriorityBitTable_54, SrcPriorityBitTable_55, SrcPriorityBitTable_56, SrcPriorityBitTable_57,
      SrcPriorityBitTable_58, SrcPriorityBitTable_59, SrcPriorityBitTable_5A, SrcPriorityBitTable_5B,
      SrcPriorityBitTable_5C, SrcPriorityBitTable_5D, SrcPriorityBitTable_5E, SrcPriorityBitTable_5F,

      SrcPriorityBitTable_60, SrcPriorityBitTable_61, SrcPriorityBitTable_62, SrcPriorityBitTable_63,
      SrcPriorityBitTable_64, SrcPriorityBitTable_65, SrcPriorityBitTable_66, SrcPriorityBitTable_67,
      SrcPriorityBitTable_68, SrcPriorityBitTable_69, SrcPriorityBitTable_6A, SrcPriorityBitTable_6B,
      SrcPriorityBitTable_6C, SrcPriorityBitTable_6D, SrcPriorityBitTable_6E, SrcPriorityBitTable_6F,

      SrcPriorityBitTable_70, SrcPriorityBitTable_71, SrcPriorityBitTable_72, SrcPriorityBitTable_73,
      SrcPriorityBitTable_74, SrcPriorityBitTable_75, SrcPriorityBitTable_76, SrcPriorityBitTable_77,
      SrcPriorityBitTable_78, SrcPriorityBitTable_79, SrcPriorityBitTable_7A, SrcPriorityBitTable_7B,
      SrcPriorityBitTable_7C, SrcPriorityBitTable_7D, SrcPriorityBitTable_7E, SrcPriorityBitTable_7F,

      SrcPriorityBitTable_80, SrcPriorityBitTable_81, SrcPriorityBitTable_82, SrcPriorityBitTable_83,
      SrcPriorityBitTable_84, SrcPriorityBitTable_85, SrcPriorityBitTable_86, SrcPriorityBitTable_87,
      SrcPriorityBitTable_88, SrcPriorityBitTable_89, SrcPriorityBitTable_8A, SrcPriorityBitTable_8B,
      SrcPriorityBitTable_8C, SrcPriorityBitTable_8D, SrcPriorityBitTable_8E, SrcPriorityBitTable_8F,

      SrcPriorityBitTable_90, SrcPriorityBitTable_91, SrcPriorityBitTable_92, SrcPriorityBitTable_93,
      SrcPriorityBitTable_94, SrcPriorityBitTable_95, SrcPriorityBitTable_96, SrcPriorityBitTable_97,
      SrcPriorityBitTable_98, SrcPriorityBitTable_99, SrcPriorityBitTable_9A, SrcPriorityBitTable_9B,
      SrcPriorityBitTable_9C, SrcPriorityBitTable_9D, SrcPriorityBitTable_9E, SrcPriorityBitTable_9F,

      SrcPriorityBitTable_A0, SrcPriorityBitTable_A1, SrcPriorityBitTable_A2, SrcPriorityBitTable_A3,
      SrcPriorityBitTable_A4, SrcPriorityBitTable_A5, SrcPriorityBitTable_A6, SrcPriorityBitTable_A7,
      SrcPriorityBitTable_A8, SrcPriorityBitTable_A9, SrcPriorityBitTable_AA, SrcPriorityBitTable_AB,
      SrcPriorityBitTable_AC, SrcPriorityBitTable_AD, SrcPriorityBitTable_AE, SrcPriorityBitTable_AF,

      SrcPriorityBitTable_B0, SrcPriorityBitTable_B1, SrcPriorityBitTable_B2, SrcPriorityBitTable_B3,
      SrcPriorityBitTable_B4, SrcPriorityBitTable_B5, SrcPriorityBitTable_B6, SrcPriorityBitTable_B7,
      SrcPriorityBitTable_B8, SrcPriorityBitTable_B9, SrcPriorityBitTable_BA, SrcPriorityBitTable_BB,
      SrcPriorityBitTable_BC, SrcPriorityBitTable_BD, SrcPriorityBitTable_BE, SrcPriorityBitTable_BF,

      SrcPriorityBitTable_C0, SrcPriorityBitTable_C1, SrcPriorityBitTable_C2, SrcPriorityBitTable_C3,
      SrcPriorityBitTable_C4, SrcPriorityBitTable_C5, SrcPriorityBitTable_C6, SrcPriorityBitTable_C7,
      SrcPriorityBitTable_C8, SrcPriorityBitTable_C9, SrcPriorityBitTable_CA, SrcPriorityBitTable_CB,
      SrcPriorityBitTable_CC, SrcPriorityBitTable_CD, SrcPriorityBitTable_CE, SrcPriorityBitTable_CF,

      SrcPriorityBitTable_D0, SrcPriorityBitTable_D1, SrcPriorityBitTable_D2, SrcPriorityBitTable_D3,
      SrcPriorityBitTable_D4, SrcPriorityBitTable_D5, SrcPriorityBitTable_D6, SrcPriorityBitTable_D7,
      SrcPriorityBitTable_D8, SrcPriorityBitTable_D9, SrcPriorityBitTable_DA, SrcPriorityBitTable_DB,
      SrcPriorityBitTable_DC, SrcPriorityBitTable_DD, SrcPriorityBitTable_DE, SrcPriorityBitTable_DF,

      SrcPriorityBitTable_E0, SrcPriorityBitTable_E1, SrcPriorityBitTable_E2, SrcPriorityBitTable_E3,
      SrcPriorityBitTable_E4, SrcPriorityBitTable_E5, SrcPriorityBitTable_E6, SrcPriorityBitTable_E7,
      SrcPriorityBitTable_E8, SrcPriorityBitTable_E9, SrcPriorityBitTable_EA, SrcPriorityBitTable_EB,
      SrcPriorityBitTable_EC, SrcPriorityBitTable_ED, SrcPriorityBitTable_EE, SrcPriorityBitTable_EF,

      SrcPriorityBitTable_F0, SrcPriorityBitTable_F1, SrcPriorityBitTable_F2, SrcPriorityBitTable_F3,
      SrcPriorityBitTable_F4, SrcPriorityBitTable_F5, SrcPriorityBitTable_F6, SrcPriorityBitTable_F7,
      SrcPriorityBitTable_F8, SrcPriorityBitTable_F9, SrcPriorityBitTable_FA, SrcPriorityBitTable_FB,
      SrcPriorityBitTable_FC, SrcPriorityBitTable_FD, SrcPriorityBitTable_FE, SrcPriorityBitTable_FF,
   } ;

   if ( (unsigned) C <= 0xFF ) return SrcPriorityBitTable_00_FF [ C ] ;

   return NULL ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                            Dxe[u BIT (DST)
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short DstPriorityBitTable_00 [] = {
      0,       0,       0,       0,       0xFFFE,  0x07FF,  0xFFFE,  0x07FF,  // 0x00xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_01  NULL
#define  DstPriorityBitTable_02  NULL

static const unsigned short DstPriorityBitTable_03 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x03xx
      0,       0x8AAA,  0x032B,  0x9ABE,  0x02E3,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_04 [] = {
      0,       0xFFE9,  0x18EF,  0xFFE9,  0x18EF,  0,       0,       0,       // 0x04xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_05  NULL
#define  DstPriorityBitTable_06  NULL
#define  DstPriorityBitTable_07  NULL
#define  DstPriorityBitTable_08  NULL
#define  DstPriorityBitTable_09  NULL
#define  DstPriorityBitTable_0A  NULL
#define  DstPriorityBitTable_0B  NULL
#define  DstPriorityBitTable_0C  NULL
#define  DstPriorityBitTable_0D  NULL
#define  DstPriorityBitTable_0E  NULL
#define  DstPriorityBitTable_0F  NULL
#define  DstPriorityBitTable_10  NULL
#define  DstPriorityBitTable_11  NULL
#define  DstPriorityBitTable_12  NULL
#define  DstPriorityBitTable_13  NULL
#define  DstPriorityBitTable_14  NULL
#define  DstPriorityBitTable_15  NULL
#define  DstPriorityBitTable_16  NULL
#define  DstPriorityBitTable_17  NULL
#define  DstPriorityBitTable_18  NULL
#define  DstPriorityBitTable_19  NULL
#define  DstPriorityBitTable_1A  NULL
#define  DstPriorityBitTable_1B  NULL
#define  DstPriorityBitTable_1C  NULL
#define  DstPriorityBitTable_1D  NULL
#define  DstPriorityBitTable_1E  NULL
#define  DstPriorityBitTable_1F  NULL
#define  DstPriorityBitTable_20  NULL
#define  DstPriorityBitTable_21  NULL
#define  DstPriorityBitTable_22  NULL
#define  DstPriorityBitTable_23  NULL
#define  DstPriorityBitTable_24  NULL
#define  DstPriorityBitTable_25  NULL
#define  DstPriorityBitTable_26  NULL
#define  DstPriorityBitTable_27  NULL
#define  DstPriorityBitTable_28  NULL
#define  DstPriorityBitTable_29  NULL
#define  DstPriorityBitTable_2A  NULL
#define  DstPriorityBitTable_2B  NULL
#define  DstPriorityBitTable_2C  NULL
#define  DstPriorityBitTable_2D  NULL
#define  DstPriorityBitTable_2E  NULL
#define  DstPriorityBitTable_2F  NULL
#define  DstPriorityBitTable_30  NULL
#define  DstPriorityBitTable_31  NULL
#define  DstPriorityBitTable_32  NULL
#define  DstPriorityBitTable_33  NULL
#define  DstPriorityBitTable_34  NULL
#define  DstPriorityBitTable_35  NULL
#define  DstPriorityBitTable_36  NULL
#define  DstPriorityBitTable_37  NULL
#define  DstPriorityBitTable_38  NULL
#define  DstPriorityBitTable_39  NULL
#define  DstPriorityBitTable_3A  NULL
#define  DstPriorityBitTable_3B  NULL
#define  DstPriorityBitTable_3C  NULL
#define  DstPriorityBitTable_3D  NULL
#define  DstPriorityBitTable_3E  NULL
#define  DstPriorityBitTable_3F  NULL
#define  DstPriorityBitTable_40  NULL
#define  DstPriorityBitTable_41  NULL
#define  DstPriorityBitTable_42  NULL
#define  DstPriorityBitTable_43  NULL
#define  DstPriorityBitTable_44  NULL
#define  DstPriorityBitTable_45  NULL
#define  DstPriorityBitTable_46  NULL
#define  DstPriorityBitTable_47  NULL
#define  DstPriorityBitTable_48  NULL
#define  DstPriorityBitTable_49  NULL
#define  DstPriorityBitTable_4A  NULL
#define  DstPriorityBitTable_4B  NULL
#define  DstPriorityBitTable_4C  NULL
#define  DstPriorityBitTable_4D  NULL

static const unsigned short DstPriorityBitTable_4E [] = {
      0,       0x0002,  0,       0x0001,  0x0100,  0,       0,       0,       // 0x4Exx
      0x4000,  0x0202,  0,       0,       0x0040,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_4F [] = {
      0,       0,       0,       0,       0,       0,       0x0008,  0,       // 0x4Fxx
      0,       0x0400,  0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_50  NULL

static const unsigned short DstPriorityBitTable_51 [] = {
      0,       0,       0,       0x8000,  0,       0,       0,       0,       // 0x51xx
      0,       0,       0,       0,       0,       0x1000,  0x0001,  0,       
} ;


static const unsigned short DstPriorityBitTable_52 [] = {
      0,       0x0004,  0,       0,       0,       0,       0,       0,       // 0x52xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_53 [] = {
      0,       0,       0,       0,       0x0080,  0,       0,       0,       // 0x53xx
      0,       0,       0,       0,       0,       0,       0,       0x0040,  
} ;


static const unsigned short DstPriorityBitTable_54 [] = {
      0x4000,  0,       0x1000,  0,       0,       0,       0,       0,       // 0x54xx
      0,       0,       0,       0x0100,  0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_55  NULL
#define  DstPriorityBitTable_56  NULL

static const unsigned short DstPriorityBitTable_57 [] = {
      0,       0,       0,       0,       0x8000,  0,       0,       0,       // 0x57xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_58  NULL

static const unsigned short DstPriorityBitTable_59 [] = {
      0,       0,       0,       0x0100,  0,       0,       0,       0,       // 0x59xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_5A [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x5Axx
      0,       0,       0x0001,  0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_5B [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x5Bxx
      0,       0,       0,       0,       0x0008,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_5C [] = {
      0x0020,  0,       0,       0x0100,  0,       0,       0,       0,       // 0x5Cxx
      0,       0,       0,       0,       0,       0,       0,       0x0020,  
} ;


static const unsigned short DstPriorityBitTable_5D [] = {
      0,       0,       0x0080,  0,       0,       0,       0,       0,       // 0x5Dxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_5E [] = {
      0,       0x0100,  0,       0,       0,       0,       0,       0x0200,  // 0x5Exx
      0,       0,       0,       0,       0x0102,  0x2000,  0,       0,       
} ;


static const unsigned short DstPriorityBitTable_5F [] = {
      0,       0,       0,       0,       0,       0x5800,  0,       0,       // 0x5Fxx
      0x1000,  0,       0,       0x0030,  0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_60 [] = {
      0,       0x1000,  0,       0,       0,       0,       0,       0,       // 0x60xx
      0,       0,       0x4000,  0,       0,       0,       0x0080,  0,       
} ;


static const unsigned short DstPriorityBitTable_61 [] = {
      0,       0,       0,       0x8000,  0,       0,       0,       0,       // 0x61xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_62 [] = {
      0,       0,       0,       0,       0,       0x0002,  0,       0,       // 0x62xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_63 [] = {
      0x0004,  0,       0,       0,       0,       0,       0,       0,       // 0x63xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_64  NULL

static const unsigned short DstPriorityBitTable_65 [] = {
      0,       0,       0,       0,       0,       0,       0,       0x0800,  // 0x65xx
      0,       0,       0,       0x1000,  0,       0,       0x0001,  0,       
} ;

#define  DstPriorityBitTable_66  NULL

static const unsigned short DstPriorityBitTable_67 [] = {
      0,       0,       0,       0x0400,  0,       0,       0,       0x0001,  // 0x67xx
      0,       0x0004,  0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_68  NULL

static const unsigned short DstPriorityBitTable_69 [] = {
      0,       0x0080,  0,       0,       0,       0,       0,       0,       // 0x69xx
      0x0020,  0,       0x0040,  0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_6A [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x6Axx
      0,       0,       0,       0,       0x0002,  0,       0,       0x0002,  
} ;


static const unsigned short DstPriorityBitTable_6B [] = {
      0,       0x2000,  0x0001,  0,       0,       0,       0,       0,       // 0x6Bxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_6C [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x6Cxx
      0,       0,       0,       0x0004,  0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_6D [] = {
      0,       0x0004,  0,       0,       0,       0x1000,  0,       0,       // 0x6Dxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_6E [] = {
      0,       0x0040,  0,       0,       0,       0,       0,       0,       // 0x6Exx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_6F [] = {
      0,       0x0008,  0,       0,       0,       0,       0,       0,       // 0x6Fxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_70 [] = {
      0,       0,       0x0080,  0,       0,       0,       0,       0,       // 0x70xx
      0,       0,       0,       0,       0,       0x8000,  0,       0,       
} ;


static const unsigned short DstPriorityBitTable_71 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x71xx
      0x0100,  0x0200,  0,       0,       0x0100,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_72 [] = {
      0,       0,       0,       0x1000,  0,       0,       0,       0,       // 0x72xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_73 [] = {
      0,       0,       0,       0x0008,  0,       0,       0,       0,       // 0x73xx
      0,       0,       0,       0,       0x0100,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_74 [] = {
      0x0020,  0,       0,       0x0004,  0,       0,       0x0010,  0,       // 0x74xx
      0,       0,       0,       0,       0,       0,       0x4000,  0,       
} ;


static const unsigned short DstPriorityBitTable_75 [] = {
      0,       0,       0x8000,  0,       0,       0,       0,       0x0010,  // 0x75xx
      0x0800,  0,       0,       0,       0,       0,       0,       0x0004,  
} ;

#define  DstPriorityBitTable_76  NULL
#define  DstPriorityBitTable_77  NULL

static const unsigned short DstPriorityBitTable_78 [] = {
      0,       0,       0,       0x8000,  0,       0,       0,       0,       // 0x78xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_79 [] = {
      0,       0,       0x0040,  0,       0,       0,       0,       0,       // 0x79xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_7A  NULL

static const unsigned short DstPriorityBitTable_7B [] = {
      0,       0,       0,       0,       0,       0x0002,  0,       0,       // 0x7Bxx
      0x8080,  0x2000,  0,       0,       0,       0,       0x0400,  0,       
} ;

#define  DstPriorityBitTable_7C  NULL

static const unsigned short DstPriorityBitTable_7D [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7Dxx
      0,       0,       0,       0,       0,       0x0010,  0,       0,       
} ;


static const unsigned short DstPriorityBitTable_7E [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7Exx
      0x0400,  0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_7F [] = {
      0,       0,       0,       0x0040,  0,       0,       0,       0,       // 0x7Fxx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_80  NULL
#define  DstPriorityBitTable_81  NULL
#define  DstPriorityBitTable_82  NULL

static const unsigned short DstPriorityBitTable_83 [] = {
      0x0008,  0,       0,       0,       0,       0x0001,  0x8000,  0,       // 0x83xx
      0,       0,       0,       0,       0,       0,       0,       0x0100,  
} ;


static const unsigned short DstPriorityBitTable_84 [] = {
      0,       0,       0,       0,       0x0020,  0,       0x8000,  0,       // 0x84xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_85 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x85xx
      0,       0,       0,       0x0010,  0,       0,       0,       0x0008,  
} ;


static const unsigned short DstPriorityBitTable_86 [] = {
      0,       0x0040,  0,       0,       0x0001,  0,       0x4000,  0,       // 0x86xx
      0,       0,       0,       0,       0,       0,       0x0080,  0,       
} ;

#define  DstPriorityBitTable_87  NULL
#define  DstPriorityBitTable_88  NULL

static const unsigned short DstPriorityBitTable_89 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x89xx
      0,       0,       0,       0x0001,  0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_8A [] = {
      0,       0,       0,       0x1000,  0,       0,       0,       0,       // 0x8Axx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_8B  NULL

static const unsigned short DstPriorityBitTable_8C [] = {
      0,       0,       0,       0,       0,       0x0004,  0,       0,       // 0x8Cxx
      0,       0,       0,       0,       0x2000,  0,       0,       0,       
} ;

#define  DstPriorityBitTable_8D  NULL

static const unsigned short DstPriorityBitTable_8E [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8Exx
      0,       0x0200,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_8F [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8Fxx
      0,       0x8000,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_90 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x90xx
      0,       0,       0,       0,       0x0002,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_91 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x91xx
      0,       0,       0x0008,  0,       0x1000,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_92 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x92xx
      0,       0,       0,       0,       0,       0,       0x0400,  0,       
} ;

#define  DstPriorityBitTable_93  NULL
#define  DstPriorityBitTable_94  NULL
#define  DstPriorityBitTable_95  NULL
#define  DstPriorityBitTable_96  NULL

static const unsigned short DstPriorityBitTable_97 [] = {
      0,       0,       0,       0x0800,  0,       0,       0x0010,  0,       // 0x97xx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_98  NULL

static const unsigned short DstPriorityBitTable_99 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x99xx
      0,       0,       0x8000,  0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_9A  NULL
#define  DstPriorityBitTable_9B  NULL
#define  DstPriorityBitTable_9C  NULL

static const unsigned short DstPriorityBitTable_9D [] = {
      0,       0,       0,       0,       0,       0,       0,       0x0001,  // 0x9Dxx
      0,       0,       0,       0,       0x0040,  0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_9E [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9Exx
      0,       0,       0,       0x2000,  0,       0,       0,       0,       
} ;


static const unsigned short DstPriorityBitTable_9F [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9Fxx
      0x2000,  0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_A0  NULL
#define  DstPriorityBitTable_A1  NULL
#define  DstPriorityBitTable_A2  NULL
#define  DstPriorityBitTable_A3  NULL
#define  DstPriorityBitTable_A4  NULL
#define  DstPriorityBitTable_A5  NULL
#define  DstPriorityBitTable_A6  NULL
#define  DstPriorityBitTable_A7  NULL
#define  DstPriorityBitTable_A8  NULL
#define  DstPriorityBitTable_A9  NULL
#define  DstPriorityBitTable_AA  NULL
#define  DstPriorityBitTable_AB  NULL
#define  DstPriorityBitTable_AC  NULL
#define  DstPriorityBitTable_AD  NULL
#define  DstPriorityBitTable_AE  NULL
#define  DstPriorityBitTable_AF  NULL
#define  DstPriorityBitTable_B0  NULL
#define  DstPriorityBitTable_B1  NULL
#define  DstPriorityBitTable_B2  NULL
#define  DstPriorityBitTable_B3  NULL
#define  DstPriorityBitTable_B4  NULL
#define  DstPriorityBitTable_B5  NULL
#define  DstPriorityBitTable_B6  NULL
#define  DstPriorityBitTable_B7  NULL
#define  DstPriorityBitTable_B8  NULL
#define  DstPriorityBitTable_B9  NULL
#define  DstPriorityBitTable_BA  NULL
#define  DstPriorityBitTable_BB  NULL
#define  DstPriorityBitTable_BC  NULL
#define  DstPriorityBitTable_BD  NULL
#define  DstPriorityBitTable_BE  NULL
#define  DstPriorityBitTable_BF  NULL
#define  DstPriorityBitTable_C0  NULL
#define  DstPriorityBitTable_C1  NULL
#define  DstPriorityBitTable_C2  NULL
#define  DstPriorityBitTable_C3  NULL
#define  DstPriorityBitTable_C4  NULL
#define  DstPriorityBitTable_C5  NULL
#define  DstPriorityBitTable_C6  NULL
#define  DstPriorityBitTable_C7  NULL
#define  DstPriorityBitTable_C8  NULL
#define  DstPriorityBitTable_C9  NULL
#define  DstPriorityBitTable_CA  NULL
#define  DstPriorityBitTable_CB  NULL
#define  DstPriorityBitTable_CC  NULL
#define  DstPriorityBitTable_CD  NULL
#define  DstPriorityBitTable_CE  NULL
#define  DstPriorityBitTable_CF  NULL
#define  DstPriorityBitTable_D0  NULL
#define  DstPriorityBitTable_D1  NULL
#define  DstPriorityBitTable_D2  NULL
#define  DstPriorityBitTable_D3  NULL
#define  DstPriorityBitTable_D4  NULL
#define  DstPriorityBitTable_D5  NULL
#define  DstPriorityBitTable_D6  NULL
#define  DstPriorityBitTable_D7  NULL
#define  DstPriorityBitTable_D8  NULL
#define  DstPriorityBitTable_D9  NULL
#define  DstPriorityBitTable_DA  NULL
#define  DstPriorityBitTable_DB  NULL
#define  DstPriorityBitTable_DC  NULL
#define  DstPriorityBitTable_DD  NULL
#define  DstPriorityBitTable_DE  NULL
#define  DstPriorityBitTable_DF  NULL
#define  DstPriorityBitTable_E0  NULL
#define  DstPriorityBitTable_E1  NULL
#define  DstPriorityBitTable_E2  NULL
#define  DstPriorityBitTable_E3  NULL
#define  DstPriorityBitTable_E4  NULL
#define  DstPriorityBitTable_E5  NULL
#define  DstPriorityBitTable_E6  NULL
#define  DstPriorityBitTable_E7  NULL
#define  DstPriorityBitTable_E8  NULL
#define  DstPriorityBitTable_E9  NULL
#define  DstPriorityBitTable_EA  NULL
#define  DstPriorityBitTable_EB  NULL
#define  DstPriorityBitTable_EC  NULL
#define  DstPriorityBitTable_ED  NULL
#define  DstPriorityBitTable_EE  NULL
#define  DstPriorityBitTable_EF  NULL
#define  DstPriorityBitTable_F0  NULL
#define  DstPriorityBitTable_F1  NULL
#define  DstPriorityBitTable_F2  NULL
#define  DstPriorityBitTable_F3  NULL
#define  DstPriorityBitTable_F4  NULL
#define  DstPriorityBitTable_F5  NULL
#define  DstPriorityBitTable_F6  NULL
#define  DstPriorityBitTable_F7  NULL
#define  DstPriorityBitTable_F8  NULL
#define  DstPriorityBitTable_F9  NULL
#define  DstPriorityBitTable_FA  NULL
#define  DstPriorityBitTable_FB  NULL
#define  DstPriorityBitTable_FC  NULL
#define  DstPriorityBitTable_FD  NULL

static const unsigned short DstPriorityBitTable_FE [] = {
      0,       0,       0,       0xFFFF,  0xFF9F,  0xFFF7,  0x0F7F,  0,       // 0xFExx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  DstPriorityBitTable_FF  NULL


const unsigned short *DstPriorityBitTable ( int C ) {

   static const unsigned short *const DstPriorityBitTable_00_FF [] = {
      DstPriorityBitTable_00, DstPriorityBitTable_01, DstPriorityBitTable_02, DstPriorityBitTable_03,
      DstPriorityBitTable_04, DstPriorityBitTable_05, DstPriorityBitTable_06, DstPriorityBitTable_07,
      DstPriorityBitTable_08, DstPriorityBitTable_09, DstPriorityBitTable_0A, DstPriorityBitTable_0B,
      DstPriorityBitTable_0C, DstPriorityBitTable_0D, DstPriorityBitTable_0E, DstPriorityBitTable_0F,

      DstPriorityBitTable_10, DstPriorityBitTable_11, DstPriorityBitTable_12, DstPriorityBitTable_13,
      DstPriorityBitTable_14, DstPriorityBitTable_15, DstPriorityBitTable_16, DstPriorityBitTable_17,
      DstPriorityBitTable_18, DstPriorityBitTable_19, DstPriorityBitTable_1A, DstPriorityBitTable_1B,
      DstPriorityBitTable_1C, DstPriorityBitTable_1D, DstPriorityBitTable_1E, DstPriorityBitTable_1F,

      DstPriorityBitTable_20, DstPriorityBitTable_21, DstPriorityBitTable_22, DstPriorityBitTable_23,
      DstPriorityBitTable_24, DstPriorityBitTable_25, DstPriorityBitTable_26, DstPriorityBitTable_27,
      DstPriorityBitTable_28, DstPriorityBitTable_29, DstPriorityBitTable_2A, DstPriorityBitTable_2B,
      DstPriorityBitTable_2C, DstPriorityBitTable_2D, DstPriorityBitTable_2E, DstPriorityBitTable_2F,

      DstPriorityBitTable_30, DstPriorityBitTable_31, DstPriorityBitTable_32, DstPriorityBitTable_33,
      DstPriorityBitTable_34, DstPriorityBitTable_35, DstPriorityBitTable_36, DstPriorityBitTable_37,
      DstPriorityBitTable_38, DstPriorityBitTable_39, DstPriorityBitTable_3A, DstPriorityBitTable_3B,
      DstPriorityBitTable_3C, DstPriorityBitTable_3D, DstPriorityBitTable_3E, DstPriorityBitTable_3F,

      DstPriorityBitTable_40, DstPriorityBitTable_41, DstPriorityBitTable_42, DstPriorityBitTable_43,
      DstPriorityBitTable_44, DstPriorityBitTable_45, DstPriorityBitTable_46, DstPriorityBitTable_47,
      DstPriorityBitTable_48, DstPriorityBitTable_49, DstPriorityBitTable_4A, DstPriorityBitTable_4B,
      DstPriorityBitTable_4C, DstPriorityBitTable_4D, DstPriorityBitTable_4E, DstPriorityBitTable_4F,

      DstPriorityBitTable_50, DstPriorityBitTable_51, DstPriorityBitTable_52, DstPriorityBitTable_53,
      DstPriorityBitTable_54, DstPriorityBitTable_55, DstPriorityBitTable_56, DstPriorityBitTable_57,
      DstPriorityBitTable_58, DstPriorityBitTable_59, DstPriorityBitTable_5A, DstPriorityBitTable_5B,
      DstPriorityBitTable_5C, DstPriorityBitTable_5D, DstPriorityBitTable_5E, DstPriorityBitTable_5F,

      DstPriorityBitTable_60, DstPriorityBitTable_61, DstPriorityBitTable_62, DstPriorityBitTable_63,
      DstPriorityBitTable_64, DstPriorityBitTable_65, DstPriorityBitTable_66, DstPriorityBitTable_67,
      DstPriorityBitTable_68, DstPriorityBitTable_69, DstPriorityBitTable_6A, DstPriorityBitTable_6B,
      DstPriorityBitTable_6C, DstPriorityBitTable_6D, DstPriorityBitTable_6E, DstPriorityBitTable_6F,

      DstPriorityBitTable_70, DstPriorityBitTable_71, DstPriorityBitTable_72, DstPriorityBitTable_73,
      DstPriorityBitTable_74, DstPriorityBitTable_75, DstPriorityBitTable_76, DstPriorityBitTable_77,
      DstPriorityBitTable_78, DstPriorityBitTable_79, DstPriorityBitTable_7A, DstPriorityBitTable_7B,
      DstPriorityBitTable_7C, DstPriorityBitTable_7D, DstPriorityBitTable_7E, DstPriorityBitTable_7F,

      DstPriorityBitTable_80, DstPriorityBitTable_81, DstPriorityBitTable_82, DstPriorityBitTable_83,
      DstPriorityBitTable_84, DstPriorityBitTable_85, DstPriorityBitTable_86, DstPriorityBitTable_87,
      DstPriorityBitTable_88, DstPriorityBitTable_89, DstPriorityBitTable_8A, DstPriorityBitTable_8B,
      DstPriorityBitTable_8C, DstPriorityBitTable_8D, DstPriorityBitTable_8E, DstPriorityBitTable_8F,

      DstPriorityBitTable_90, DstPriorityBitTable_91, DstPriorityBitTable_92, DstPriorityBitTable_93,
      DstPriorityBitTable_94, DstPriorityBitTable_95, DstPriorityBitTable_96, DstPriorityBitTable_97,
      DstPriorityBitTable_98, DstPriorityBitTable_99, DstPriorityBitTable_9A, DstPriorityBitTable_9B,
      DstPriorityBitTable_9C, DstPriorityBitTable_9D, DstPriorityBitTable_9E, DstPriorityBitTable_9F,

      DstPriorityBitTable_A0, DstPriorityBitTable_A1, DstPriorityBitTable_A2, DstPriorityBitTable_A3,
      DstPriorityBitTable_A4, DstPriorityBitTable_A5, DstPriorityBitTable_A6, DstPriorityBitTable_A7,
      DstPriorityBitTable_A8, DstPriorityBitTable_A9, DstPriorityBitTable_AA, DstPriorityBitTable_AB,
      DstPriorityBitTable_AC, DstPriorityBitTable_AD, DstPriorityBitTable_AE, DstPriorityBitTable_AF,

      DstPriorityBitTable_B0, DstPriorityBitTable_B1, DstPriorityBitTable_B2, DstPriorityBitTable_B3,
      DstPriorityBitTable_B4, DstPriorityBitTable_B5, DstPriorityBitTable_B6, DstPriorityBitTable_B7,
      DstPriorityBitTable_B8, DstPriorityBitTable_B9, DstPriorityBitTable_BA, DstPriorityBitTable_BB,
      DstPriorityBitTable_BC, DstPriorityBitTable_BD, DstPriorityBitTable_BE, DstPriorityBitTable_BF,

      DstPriorityBitTable_C0, DstPriorityBitTable_C1, DstPriorityBitTable_C2, DstPriorityBitTable_C3,
      DstPriorityBitTable_C4, DstPriorityBitTable_C5, DstPriorityBitTable_C6, DstPriorityBitTable_C7,
      DstPriorityBitTable_C8, DstPriorityBitTable_C9, DstPriorityBitTable_CA, DstPriorityBitTable_CB,
      DstPriorityBitTable_CC, DstPriorityBitTable_CD, DstPriorityBitTable_CE, DstPriorityBitTable_CF,

      DstPriorityBitTable_D0, DstPriorityBitTable_D1, DstPriorityBitTable_D2, DstPriorityBitTable_D3,
      DstPriorityBitTable_D4, DstPriorityBitTable_D5, DstPriorityBitTable_D6, DstPriorityBitTable_D7,
      DstPriorityBitTable_D8, DstPriorityBitTable_D9, DstPriorityBitTable_DA, DstPriorityBitTable_DB,
      DstPriorityBitTable_DC, DstPriorityBitTable_DD, DstPriorityBitTable_DE, DstPriorityBitTable_DF,

      DstPriorityBitTable_E0, DstPriorityBitTable_E1, DstPriorityBitTable_E2, DstPriorityBitTable_E3,
      DstPriorityBitTable_E4, DstPriorityBitTable_E5, DstPriorityBitTable_E6, DstPriorityBitTable_E7,
      DstPriorityBitTable_E8, DstPriorityBitTable_E9, DstPriorityBitTable_EA, DstPriorityBitTable_EB,
      DstPriorityBitTable_EC, DstPriorityBitTable_ED, DstPriorityBitTable_EE, DstPriorityBitTable_EF,

      DstPriorityBitTable_F0, DstPriorityBitTable_F1, DstPriorityBitTable_F2, DstPriorityBitTable_F3,
      DstPriorityBitTable_F4, DstPriorityBitTable_F5, DstPriorityBitTable_F6, DstPriorityBitTable_F7,
      DstPriorityBitTable_F8, DstPriorityBitTable_F9, DstPriorityBitTable_FA, DstPriorityBitTable_FB,
      DstPriorityBitTable_FC, DstPriorityBitTable_FD, DstPriorityBitTable_FE, DstPriorityBitTable_FF,
   } ;

   if ( (unsigned) C <= 0xFF ) return DstPriorityBitTable_00_FF [ C ] ;

   return NULL ;
}



int IsAdjustPrioritySrc ( int C ) {

   const unsigned short *pTable = SrcPriorityBitTable ( C >> 8 ) ;
   if ( pTable ) return GetShortArrayBit ( pTable, C & 0xFF ) ;

   return 0 ;
}



int IsAdjustPriorityDst ( int C ) {

   const unsigned short *pTable = DstPriorityBitTable ( C >> 8 ) ;
   if ( pTable ) return GetShortArrayBit ( pTable, C & 0xFF ) ;

   return 0 ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                                   Dx֐
///////////////////////////////////////////////////////////////////////////////////////



// XJ[lƂ݂Ȃ BMP ̂݌
// k͌Ȃ
static const wchar_t *wcschr_bmp ( const wchar_t *string, int c ) {

   while ( *string ) {
      if ( *string == c ) return string ;
      string ++ ;
   }

   return NULL ;
}



// R}̎̈ʒuLȂ當
// XJ[lƂ݂Ȃ BMP ̂݌
// kƃR}͌Ȃ
// R}̎̈ʒuԂ
static const wchar_t *wcschr_get_group_start ( const wchar_t *string, int c ) {

   const wchar_t *start = string ;

   while ( *string ) {
      if ( *string == ',' ) start = string + 1 ;
      else if ( *string == c ) return start ;
      string ++ ;
   }

   return NULL ;
}



// R}̏I[ƌȂĕ
// XJ[lƂ݂Ȃ BMP ̂݌
// k͌Ȃ
static const wchar_t *wcschr_within_group ( const wchar_t *string, int c ) {

   while ( *string && *string != ',' ) {
      if ( *string == c ) return string ;
      string ++ ;
   }

   return NULL ;
}



#define is_within_range(c,min,max)  ( (c) >= (min) && (c) <= (max) )



// ̗D揇ʂ𒲐i݊܂܂j
int AdjustCjkPriority ( int nPriority, int cUnicode, int cUnicodeSrc, int nSrcCodePage, int nDstCodePage, int IsToGbFanti ) {

   const wchar_t *szString ;


   // "nPriority >>= 1"  equals to  "nPriority /= 2"
   // "nPriority >>= 2"  equals to  "nPriority /= 4"


   // łّ̈̎̊͌㊿ꎌT
   // {łّ̈̎̊͐V
   // pł̊gp͗݌㊿pTɁiH䦁j

   //   ÂV؎Tł͒ƊL{𕪂Ȃ
   //       ͊ȑ̎Ɣɑ̎̑ΉĂ


   //////////////////////////////
   //       Sɋ       //
   //////////////////////////////


   if ( 1 ) {
      // O[vłȂΌ炷
      szString = L"\x7260,\x4E81\x4E79,\x69A6,\x5E10,\x8CEC\x8D26,\x96E0,,f\x5FAC,A\x7816\x587C,\x6151,{r,[,\x684C\x69D5,\x9221\x949F,^\x9988,G,\x955B,\x8E4B\x8E79,\x5B9E,m\x7F17,\x93C7\x955F,Y,\x5611\x8B3C,\x5284" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΂Ɍ炷
      szString = L"\x9DC9\x4D18,\x9E0A\x4D19,\x93C7\x955F" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 3 ;
      // O[vłȂ΃[
      szString = L"O\x9555,\x5C85" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
      // ̂Ƃ炷
      szString = L"戝ഛyE۟tX\x6FC7\x8E5A\x8D9F\x5803\x83C9\x7253\x8A67\x6424\x704B\x8656\x6630" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"\x6DDB" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
   }


   //////////////////////////////
   //      {̓o      //
   //////////////////////////////


   if ( nDstCodePage == CP_JAPANESE ) {
      // O[vłȂΌ炷
      szString = L"\x8D30,\x5BBC,\x5939,\x52A8,\x60A4\x5FE9,\x5941\x7C62,b\x5364,\x61D2,\x60ED,F\x69DF,\x693E\x7B3A,\x8989,\x9E29,\x5EFD,\x9025,P\x7F4B,\x617F,,d,B\x5A24\x5986,\x89EF\x89F6" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"蟛k{Lଛ@SkkݘJ{ǜ{x\x5582\x6375" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // ̂Ƃ炷
      szString = L"pe\x89B0" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // 炷
      szString = L"ӑTⵛBSf\GqiUW\x89B0" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage == CP_JAPANESE ) {
      if ( ( nSrcCodePage == CP_CHINESE_SIMPLIFIED || nSrcCodePage == CP_CHINESE_TRADITIONAL ) ) {
         // 炷
         szString = L"{" ;
         if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
      }
      else {
         // O[vłȂ΃[
         szString = L"{\x77FF" ;
         if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      }
      if ( nSrcCodePage == CP_CHINESE_SIMPLIFIED ) {
         // 炷
         szString = L"" ;
         if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
      }
      if ( nSrcCodePage != CP_CHINESE_SIMPLIFIED ) {
         // ̂Ƃ炷
         szString = L"" ;
         if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      }
   }

   if ( nDstCodePage != CP_JAPANESE ) {
      // O[vłȂΌ炷
      szString = L"p\x7F46,A," ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΃[
      szString = L"\x8FA9" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"A" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
   }

   if ( nDstCodePage != CP_JAPANESE && nSrcCodePage == CP_JAPANESE ) {
      // 镶̂Ƃ͑[
      if ( wcschr_bmp ( L"|", cUnicodeSrc ) && ! wcschr_bmp ( L"Y\x827A", cUnicode ) ) nPriority = 0 ;
      if ( wcschr_bmp ( L"", cUnicodeSrc ) && ! wcschr_bmp ( L"|", cUnicode ) ) nPriority = 0 ;
      // ̂Ƃ[
      szString = L"" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // [
      szString = L"l茇" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority = 0 ;
   }

   if ( nDstCodePage != CP_CHINESE_SIMPLIFIED && nSrcCodePage == CP_JAPANESE ) {
      // ̂Ƃ[
      szString = L"䦙ʙ{" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
   }

   if ( nDstCodePage != CP_JAPANESE && nSrcCodePage != CP_JAPANESE ) {
      // ̂Ƃ[
      szString = L"l\x5496\x5561" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
   }


   //////////////////////////////
   //      ؍̓o      //
   //////////////////////////////


   if ( nDstCodePage == CP_KOREAN ) {
      // O[vłȂΌ炷
      szString = L"Q\x53C5,榏Q\x96E0,o\x7A3A,\x5706\x570E,q,\x6C89,P\x7F4B" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"nqh" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // 炷
      szString = L"|l" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΃[
      szString = L"" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
   }

   if ( nDstCodePage == CP_JAPANESE || nDstCodePage == CP_KOREAN ) {
      // O[vłȂΌ炷
      szString = L"\x73CB" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"竞M\x6B1B\x8FB3\x85CA\x95C6\x7E34" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
   }


   //////////////////////////////
   //   ȑ̎̓o   //
   //////////////////////////////


   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED ) {
      // O[vłȂΌ炷
      szString = L"wQ,\x69A6,\x7877\x7906,v\x4986,\x941D\x9562,\x75C8\x7655" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΃[
      szString = L"c\x6E16,,\x576F\x962B,\x7CC6\x9EAF,\x9EB4" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
      // ̂Ƃ[
      szString = L"纝I" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // ̂Ƃ炷
      szString = L"ĚЊ\x53B7\x4F40" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // 炷
      szString = L"P⭕D\x9EBD\x6AF1\x85B4\x69A6\x6E16\x5FB5\x83F8\x91A3\x99AF\x7333\x6CB2" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED && ! IsToGbFanti ) {
      // 炷
      szString = L"\x657B" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }
   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED && IsToGbFanti ) {
      // 炷
      szString = L"\x85F3\x7DD4" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED && nSrcCodePage != CP_JAPANESE ) {
      // O[vłȂ΃[
      szString = L"|" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
   }

   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED ) {
      if ( ( nSrcCodePage == CP_JAPANESE || nSrcCodePage == CP_KOREAN || nSrcCodePage == CP_CHINESE_TRADITIONAL ) ) {
         // 镶̂Ƃ͑[
         if ( wcschr_bmp ( L"", cUnicodeSrc ) && ! wcschr_bmp ( L"\x82CE", cUnicode ) ) nPriority = 0 ;
         if ( wcschr_bmp ( L"\x85B4", cUnicodeSrc ) && ! wcschr_bmp ( L"", cUnicode ) ) nPriority = 0 ;
      }
      else {
         // O[vłȂ΃[
         szString = L"\x85B4" ;
         if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
      }
   }

   if ( nDstCodePage != CP_CHINESE_SIMPLIFIED ) {
      // O[vłȂΌ炷
      szString = L",\x6B77\x5386\x53AF,Ï,\x9B26\x9B2C\x9B2D,p\x9EB5\x9EAB,],^\x8D5E,\x5002,\x5E77,,i,q\x7E6B,b\x5F5A,\x8BAC,U,\x5FB5,\x6061,\x7D25F,\x5C1F,\x9F9E,\x5BD7,,,K\x89C4,\x69FC\x691D,\x8263,p\x672F,\x8854\x8858,\x94B3,\x94BA,q\x76CC,\x4FF2,o,c\x6E16,h^\x82CF,AP\x6AF1,\x82CE,\x556E\x5699,\x57D9\x5864,\x836F,Z,\x9CCC,ś,\x7CD3,V\x9030,\x7CC6\x9EAF\x9EB4,؝,\x83D4,\x844A,c\x918E,W\x58C4,X\x9B57,\x6A8F,\x7EE9,\x59B7,e\x9E84\x9EA4,{\x60EA,\x994A\x9993" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΃[
      szString = L"d\x575B,\x7F48,\x8460\x84E1,ޛ\x5DD7,Ԗ,ᶐs,ሖ,i\x67FA,\x617C\x617D,\x678F\x67DF,,\x8C25,\x5D10,\x6AD5\x6B11," ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
      // ̂Ƃ[
      if ( cUnicodeSrc < 0x7000 ) szString = L"AsXTNɜМLQga\x4F54\x506A\x5139\x51C3\x52D1\x531F\x5641\x5679\x56CC\x572C\x5775\x57F0\x587C\x5ED5\x5EF5\x5EF9\x6049\x61DE\x62B4\x6344\x63F9\x6425\x6427\x642F\x656D\x657A\x66CF\x6747\x6792\x6814\x6917\x6A11\x6BE7" ;
      else                        szString = L"oW\ImÊOVoq\x7250\x7367\x74C8\x75E0\x774F\x7760\x7843\x7A28\x7B69\x7B6F\x7E1A\x7F63\x7FA2\x81DD\x82B6\x83F8\x8439\x8534\x85B4\x873A\x884A\x8855\x885A\x896C\x89D5\x8A96\x8B54\x8B6D\x8CF8\x9336\x93DA\x95DA\x9847\x9866\x98B3\x9935\x9A32\x9AD2\x9B0D\x9EA4\x9F69" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // ̂Ƃ炷
      szString = L"䇚XIqMkY\x77D9\x57F3\x4F84\x672F" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // 炷
      szString = L"ٟP\x4E30\x4E48\x6792" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage != CP_CHINESE_SIMPLIFIED && nSrcCodePage == CP_CHINESE_SIMPLIFIED ) {
      // 镶̂Ƃ͑[
      if ( wcschr_bmp ( L"", cUnicodeSrc ) && ! wcschr_bmp ( L"\x85B4", cUnicode ) ) nPriority = 0 ;
      // O[vłȂΌ炷
      szString = L"t,\x836FZ" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // O[vłȂ΃[
      szString = L",\x576F\x962B" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority = 0 ;
      // 炷
      szString = L"@N}蘰{ߙ𛙜Ýk^D\x5212\x5E18\x6251\x4F63\x836F" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage != CP_CHINESE_SIMPLIFIED && nSrcCodePage != CP_CHINESE_SIMPLIFIED ) {
      // O[vłȂ΃[
      szString = L"TT\x9B30,\x576F\x962B,,\x4E90" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ炷
      szString = L"䗟Xߙ{nʗ\x68F1\x5B81\x9002" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
   }


   //////////////////////////////
   //   ɑ̎̓o   //
   //////////////////////////////


   if ( nDstCodePage == CP_CHINESE_TRADITIONAL ) {
      // O[vłȂΌ炷
      szString = L"\x93DF\x94F2,,Y,|,Y\x517F\x827A,\x69FC\x691D,\x8D46,\x9BC1\x9CA0,C\x792E,\x91EC\x92B2,\x8439\x85CA,\x8C53\x8C54,@\x7EA4,\x6512\x6522,\x5A7E\x5AAE,\x8989,\x94C7,\x75C8\x7655,\x53C1\x53C4,\x7AAD,\x6275,\x7C72\x9FA5,\x67B1\x6AAF" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"㰟ňś]nQÊ\x5249\x5889\x61DE\x63BD\x6427\x657A\x78DF\x7BAC\x8855\x885A\x96DD\x6443\x64A6\x6440\x7487\x7C78" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // ̂Ƃ炷
      szString = L"YpDaIGeόLȊ|\x83F8\x772F\x5592\x6BAD\x8186\x5B2D\x892D\x5C47\x98BF\x7431\x5FF7\x6033\x64A3\x667B\x6B1E\x6C02\x7068\x7E8D\x81D5\x6529\x53C4\x510C\x79D6" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // 炷
      szString = L"|XA\x5E18\x6917\x866E\x7BEA\x8445\x86E7\x60AE\x6985\x8C52\x99AF\x5AA0\x8640" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
      // 炷 (EUC-TW)
      szString = L"\x5F5E\x5F5B" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 4 ;
   }

   if ( nDstCodePage == CP_CHINESE_TRADITIONAL && nSrcCodePage == CP_CHINESE_SIMPLIFIED ) {
      // ̂Ƃ炷
      szString = L"" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority >>= 2 ;
      // 炷
      szString = L"]k" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }

   if ( nDstCodePage == CP_CHINESE_TRADITIONAL && nSrcCodePage == CP_CHINESE_TRADITIONAL ) {
      // O[vłȂΌ炷
      szString = L"\x724E\x7255" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
   }


   if ( nDstCodePage == CP_CHINESE_TRADITIONAL || nDstCodePage == CP_KOREAN ) {
      // O[vłȂΌ炷
      szString = L"\x5EFD\x9025,M,P\x9980" ;
      if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;
      // ̂Ƃ[
      szString = L"Ј\x88CC" ;
      if ( cUnicodeSrc != cUnicode && wcschr_bmp ( szString, cUnicodeSrc ) ) nPriority = 0 ;
      // 炷
      szString = L"" ;
      if ( wcschr_bmp ( szString, cUnicode ) ) nPriority >>= 2 ;
   }


   return nPriority ;
}



// At@xbgEǓ_̗D揇ʂ𒲐
int AdjustPriority ( int nPriority, int cUnicode, int cUnicodeSrc, int nSrcCodePage, int nDstCodePage ) {

#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#pragma setlocale ( "C" )
#endif


   const wchar_t *szString ;


   // Latin with accent, etc.
   szString =
      /* a */  L"\x00E4\x01DF,\x00E5\x01FB,\x00E2\x1EA5\x1EA7\x1EA9\x1EAB\x1EAD,\x0103\x1EAF\x1EB1\x1EB3\x1EB5\x1EB7,"
      /* c */  L"\x00E7\x1E09,"
      /* e */  L"\x00EA\x1EBF\x1EC1\x1EC3\x1EC5\x1EC7,\x0113\x1E15\x1E17,"
      /* i */  L"\x00EF\x0457\x1E2F,"
      /* o */  L"\x00F8\x01FF,\x00F4\x1ED1\x1ED3\x1ED5\x1ED7\x1ED9,\x00F5\x022D\x1E4D\x1E4F,\x014D\x1E51\x1E53,\x01A1\x1EDB\x1EDD\x1EDF\x1EE1\x1EE3,\x00F6\x022B,\x022F\x0231,"
      /* U */  L"\x00FC\x01D6\x01D8\x01DA\x01DC,\x01B0\x1EE9\x1EEB\x1EED\x1EEF\x1EF1,"
      /* A */  L"\x00C4\x01DE,\x00C5\x01FA\x212B,\x00C2\x1EA4\x1EA6\x1EA8\x1EAA\x1EAC,\x0102\x1EAE\x1EB0\x1EB2\x1EB4\x1EB6,"
      /* C */  L"\x00C7\x1E08,"
      /* D */  L"\x0110\x0189,"
      /* E */  L"\x00CA\x1EBE\x1EC0\x1EC2\x1EC4\x1EC6,\x0112\x1E14\x1E16,"
      /* I */  L"\x00CF\x0407\x1E2E,"
      /* O */  L"\x00D8\x01FE,\x00D4\x1ED0\x1ED2\x1ED4\x1ED6\x1ED8,\x00D5\x022C\x1E4C\x1E4E,\x014C\x1E50\x1E52,\x01A0\x1EDA\x1EDC\x1EDE\x1EE0\x1EE2,\x00D6\x022A,\x022E\x0230,"
      /* U */  L"\x00DC\x01D5\x01D7\x01D9\x01DB,\x01AF\x1EE8\x1EEA\x1EEC\x1EEE\x1EF0,"
      /*else*/ L"\x2012\x2013,\x2014\x2015,\x2033\x301E,\x30FC\xFF70,\x02CD\xFF3F,\x223C\xFF5E,\xFE34\xFE4F,\x201D\xFF02,\x2223\xFF5C,"
               L"\x018E\x1D32,\x018F\x04D8\x04DA,"
      ;
   // O[vłȂΌ炷
   if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;


   // Dash
   szString = L"\x2012\x2013\xFE32,\x2014\x2015\xFE31" ;
   // O[vłȂ΂Ɍ炷
   if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 2 ;


   // Greek with oxia (tonos), dialytika (diaeresis)
   szString =
      // oxia
      /*  */ L"\x03AC\x1F04\x1F05\x1F71\x1F84\x1F85\x1FB4\x1FB5,"
      /*  */ L"\x03AD\x1F14\x1F15\x1F73,"
      /*  */ L"\x03AE\x1F24\x1F25\x1F75\x1F94\x1F95\x1FC4\x1FC5,"
      /*  */ L"\x03AF\x1F34\x1F35\x1F77,"
      /*  */ L"\x03CC\x1F44\x1F45\x1F79,"
      /*  */ L"\x03CD\x1F54\x1F55\x1F7B,"
      /*  */ L"\x03CE\x1F64\x1F65\x1F7D\x1FA4\x1FA5\x1FF4,"
      /*  */ L"\x0386\x1F0C\x1F0D\x1F8C\x1F8D\x1FBB,"
      /*  */ L"\x0388\x1F1C\x1F1D\x1FC9,"
      /*  */ L"\x0389\x1F2C\x1F2D\x1F9C\x1F9D\x1FCB,"
      /*  */ L"\x038A\x1F3C\x1F3D\x1FDB,"
      /*  */ L"\x038C\x1F4C\x1F4D\x1FF9,"
      /*  */ L"\x038E\x1F5C\x1F5D\x1FEB,"
      /*  */ L"\x038F\x1F6C\x1F6D\x1FAC\x1FAD\x1FFB,"
      // dialytika
      /*  */ L"\x03CA\x1FD2\x1FD7,"
      /*  */ L"\x03CB\x1FE2\x1FE7,"
      /*  */ L"\x03AA,"
      /*  */ L"\x03AB,"
      // dialytika and oxia
      /*  */ L"\x0390\x1FD3,"
      /*  */ L"\x03B0\x1FE3,"
      ;
   // O[vłȂΌ炷
   if ( ( szString = wcschr_get_group_start ( szString, cUnicodeSrc ) ) && ! wcschr_within_group ( szString, cUnicode ) ) nPriority >>= 1 ;


   // Latin
   if ( is_within_range ( cUnicode, 'A', 'Z' ) || is_within_range ( cUnicode, 'a', 'z' ) ) nPriority += 0x10 ;
   // Russian
   if ( is_within_range ( cUnicode, 0x0410, 0x044F ) ) nPriority += 0x10 ;
   // Greek
   if ( is_within_range ( cUnicode, 0x0391, 0x03A9 ) || is_within_range ( cUnicode, 0x03B1, 0x03C9 ) ) nPriority += 0x10 ;


   // CJK Compatibility Forms
   if ( is_within_range ( cUnicodeSrc, 0xFE30, 0xFE4F ) && ( is_within_range ( cUnicode, 0x3000, 0x3020 ) || is_within_range ( cUnicode, 0xFF00, 0xFF5F ) ) ) nPriority += 0x100 ;
   if ( is_within_range ( cUnicode, 0xFE30, 0xFE4F ) && cUnicodeSrc != cUnicode ) nPriority >>= 2 ;
   // Small Form
   if ( is_within_range ( cUnicodeSrc, 0xFE50, 0xFE6F ) && ( is_within_range ( cUnicode, 0x3000, 0x3020 ) || is_within_range ( cUnicode, 0xFF00, 0xFF5F ) ) ) nPriority += 0x100 ;
   if ( is_within_range ( cUnicode, 0xFE50, 0xFE6F ) && cUnicodeSrc != cUnicode ) nPriority >>= 2 ;
   // Enclosed Numerals
   if ( is_within_range ( cUnicodeSrc, 0x2460, 0x2473 ) && is_within_range ( cUnicode, 0x2488, 0x249B ) ) nPriority -= 0x10 ;
   // CJK Zero
   if ( is_within_range ( cUnicodeSrc, 0x3007, 0x3007 ) && cUnicodeSrc != cUnicode ) nPriority >>= 2 ;


   // GB
   if ( nSrcCodePage == CP_CHINESE_SIMPLIFIED &&
       ( nDstCodePage == CP_JAPANESE ||
         nDstCodePage == CP_CHINESE_TRADITIONAL ||
         nDstCodePage == CP_KOREAN )
   ) {
      if ( is_within_range ( cUnicodeSrc, 0x2236, 0x2236 ) && is_within_range ( cUnicode, 0xFF1A, 0xFF1A ) ) nPriority <<= 1 ;      // F
      if ( is_within_range ( cUnicodeSrc, 0xFF40, 0xFF40 ) && is_within_range ( cUnicode, 0x2035, 0x2035 ) ) nPriority <<= 1 ;      // M
   }


#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#include "msc.h"
#endif

   return nPriority ;
}



