// brsfile.cpp

#include <windows.h>
#include <string.h>
#include "msc.h"
#include "brsfile.h"



#ifndef OFN_DONTADDTORECENT
#define OFN_DONTADDTORECENT   0x02000000    // Win2K or later only
#endif



//////////////////////////////
//          ANSI          //
//////////////////////////////



// t@CuEYĎ擾iANSIŁj
// nMaxLen  MAX_PATH ȏw
// szFilter  "\0pX}XN\0\0" w
// Ȃ 0 AsȂ 0 ȊOԂ
int WINAPI BrowseForFileA ( HWND hWnd, char *szSelectedFile, int nMaxLen, const char *szInitialDir, const char *szTitle, const char *szFilter, int IsAllowMultiSelect ) {

   unsigned long dwFlags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR ;
   if ( IsWin2000orLater() ) dwFlags |= OFN_DONTADDTORECENT ;
   if ( IsAllowMultiSelect ) dwFlags |= OFN_ALLOWMULTISELECT ;

   // szInitialDir  szSelectedFile obt@Ƃ̑΍
   char szInitialDirSaved [ MAX_PATH ] ;
   if ( szInitialDir ) {
      if ( strlen ( szInitialDir ) >= MAX_PATH ) szInitialDir = "" ;
      else szInitialDir = strcpy ( szInitialDirSaved, szInitialDir ) ;
   }

   if ( nMaxLen ) *szSelectedFile = 0 ;

   OPENFILENAMEA OpenFileName = { 0 } ;
   OpenFileName.lStructSize   = sizeof(OPENFILENAMEA) ;
   OpenFileName.hwndOwner     = hWnd ;
   OpenFileName.lpstrFile     = szSelectedFile ;
   OpenFileName.nMaxFile      = nMaxLen ;
   OpenFileName.Flags         = dwFlags ;
   OpenFileName.lpstrInitialDir = szInitialDir ;
   OpenFileName.lpstrTitle    = szTitle ;
   OpenFileName.lpstrFilter   = szFilter ;

   if ( GetOpenFileNameA ( & OpenFileName ) ) return 0 ;

   if ( nMaxLen ) *szSelectedFile = 0 ;
   if ( IsAllowMultiSelect && nMaxLen > 1 ) *( szSelectedFile + 1 ) = 0 ;

   return 1 ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// t@CuEYĎ擾iUNICODEŁj
// nMaxLen  MAX_PATH ȏw
// szFilter  "\0pX}XN\0\0" w
// Ȃ 0 AsȂ 0 ȊOԂ
int WINAPI BrowseForFileW ( HWND hWnd, wchar_t *szSelectedFile, int nMaxLen, const wchar_t *szInitialDir, const wchar_t *szTitle, const wchar_t *szFilter, int IsAllowMultiSelect ) {

   unsigned long dwFlags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR ;
   if ( IsWin2000orLater() ) dwFlags |= OFN_DONTADDTORECENT ;
   if ( IsAllowMultiSelect ) dwFlags |= OFN_ALLOWMULTISELECT ;

   // szInitialDir  szSelectedFile obt@Ƃ̑΍
   wchar_t szInitialDirSaved [ MAX_PATH ] ;
   if ( szInitialDir ) {
      if ( wcslen ( szInitialDir ) >= MAX_PATH ) szInitialDir = L"" ;
      else szInitialDir = wcscpy ( szInitialDirSaved, szInitialDir ) ;
   }

   if ( nMaxLen ) *szSelectedFile = 0 ;

   OPENFILENAMEW OpenFileName = { 0 } ;
   OpenFileName.lStructSize   = sizeof(OPENFILENAMEW) ;
   OpenFileName.hwndOwner     = hWnd ;
   OpenFileName.lpstrFile     = szSelectedFile ;
   OpenFileName.nMaxFile      = nMaxLen ;
   OpenFileName.Flags         = dwFlags ;
   OpenFileName.lpstrInitialDir = szInitialDir ;
   OpenFileName.lpstrTitle    = szTitle ;
   OpenFileName.lpstrFilter   = szFilter ;

   if ( GetOpenFileNameW ( & OpenFileName ) ) return 0 ;

   if ( nMaxLen ) *szSelectedFile = 0 ;
   if ( IsAllowMultiSelect && nMaxLen > 1 ) *( szSelectedFile + 1 ) = 0 ;

   return 1 ;
}



