// conv_icon.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "msc.h"
#include "res.h"
#include "resource.h"
#include "conv_icon.h"



////////////////////////////////////////
//     C_CAȌ󋵕\     //
////////////////////////////////////////



static int StatusIconStatus [ SRC_DST_FILE_NELEM ] ;



// 󋵕\̏Ԃݒ
int SetStatusIcon ( HWND hWnd, int nIndex, int nStatus ) {

   if ( (unsigned) nStatus >= STATUS_ICON_NELEM ) nStatus = STATUS_ICON_READY ;

   int nPrevStatus = StatusIconStatus [ nIndex ] ;
   StatusIconStatus [ nIndex ] = nStatus ;

   if ( nPrevStatus != nStatus ) {
      HWND hCtrl = GetDlgItem ( hWnd, IDC_STATIC_STATUS_MIN + nIndex ) ;
      InvalidateRect ( hCtrl, NULL, 0 ) ;
      UpdateWindow ( hCtrl ) ;
   }

   return nPrevStatus ;
}



static HICON GetStatusIcon ( int nStatus, int nSize ) ;



// 󋵕\`
// ACRLbV̂ŁAI DestoryStatusIcon() ĂԂ
int DrawStatusIcon ( DRAWITEMSTRUCT *pDrawItem, int nIndex ) {

   RECT Rect = pDrawItem->rcItem ;     // ACẽTCY
   HDC hDC = pDrawItem->hDC ;          // foCXReLXg

   // wi`
   HBRUSH hBrush = CreateSolidBrush ( GetBkColor ( hDC ) ) ;
   FillRect ( hDC, & Rect, hBrush ) ;
   DeleteObject ( hBrush ) ;

   // ACR̃TCY
   int nSize = __min ( Rect.right - Rect.left, Rect.bottom - Rect.top ) ;

   HICON hIcon = GetStatusIcon ( StatusIconStatus [ nIndex ], nSize ) ;
   if ( ! hIcon ) return 1 ;

   // ACR`
   int nLeft = Rect.left + ( ( Rect.right - Rect.left ) - nSize ) / 2 ;
   int nTop = Rect.top + ( ( Rect.bottom - Rect.top ) - nSize ) / 2 ;
   DrawIconEx ( hDC, nLeft, nTop, hIcon, nSize, nSize, 0, NULL, DI_NORMAL ) ;

   return 0 ;
}



static HICON StatusIconHandle [ STATUS_ICON_NELEM ] ;

static void __cdecl ExitProc ( void ) ;



static HICON GetStatusIcon ( int nStatus, int nSize ) {

   // LbVĂACR擾
   HICON hIcon = StatusIconHandle [ nStatus ] ;
   if ( ! hIcon ) {

      // ACRI
      int nIconId ;
      switch ( nStatus ) {
         case STATUS_ICON_READY :   nIconId = IDI_ICON_STATUS_READY ; break ;
         case STATUS_ICON_NOW :     nIconId = IDI_ICON_STATUS_NOW ; break ;
         case STATUS_ICON_SUCCESS : nIconId = IDI_ICON_STATUS_SUCCESS ; break ;
         case STATUS_ICON_FAILURE : nIconId = IDI_ICON_STATUS_FAILURE ; break ;
         default :                  nIconId = IDI_ICON_STATUS_READY ; break ;
      }

      // ACR𐶐
      hIcon = GetIconEx ( nIconId, nSize, nSize ) ;
      if ( ! hIcon ) hIcon = GetIcon ( nIconId ) ;

      // ACRLbV
      StatusIconHandle [ nStatus ] = hIcon ;

      static volatile long IsExitProcRegistered ;
      if ( ! InterlockedExchange ( & IsExitProcRegistered, TRUE ) ) atexit ( ExitProc ) ;
   }

   return hIcon ;
}



// LbVꂽACRp
static void __cdecl ExitProc ( void ) {

   for ( int nStatus = 0 ; nStatus < STATUS_ICON_NELEM ; nStatus ++ ) {
      HICON hIcon = StatusIconHandle [ nStatus ] ;
      if ( hIcon ) DestroyIcon ( hIcon ) ;
      StatusIconHandle [ nStatus ] = NULL ;
   }

}



////////////////////////////////////////
//              fobO              //
////////////////////////////////////////



// C_CAÕACe̐`FbN
int IsDlgItemIdConformable ( void ) {

   if ( ( IDC_BUTTON_SRC_MIN - IDC_EDIT_SRC_MIN ) != SRC_DST_FILE_NELEM ) return 0 ;
   if ( ( IDC_STATIC_STATUS_MIN - IDC_BUTTON_SRC_MIN ) != SRC_DST_FILE_NELEM ) return 0 ;
   if ( ( IDC_EDIT_DST_MIN - IDC_STATIC_STATUS_MIN ) != SRC_DST_FILE_NELEM ) return 0 ;
   if ( ( IDC_BUTTON_DST_MIN - IDC_EDIT_DST_MIN ) != SRC_DST_FILE_NELEM ) return 0 ;

   return 1 ;
}



// Rg[̃TCY\
int DisplayControlSize ( HWND hWnd, int nId ) {

   RECT Rect ;
   GetWindowRect ( GetDlgItem ( hWnd, nId ), & Rect ) ;

   char buffer [ 0x100 ] ;
   int x = Rect.right - Rect.left ;
   int y = Rect.bottom - Rect.top ;
   sprintf ( buffer, "(ID:%d)  x:%d, y:%d\n", nId, x, y ) ;

   MessageBoxA ( hWnd, buffer, "", MB_OK ) ;

   return 0 ;
}



