// guifont.cpp

#include <windows.h>
#include "msc.h"
#include "guifont.h"



//////////////////////////////
//     VXetHg     //
//////////////////////////////



// fXNgbvŎgĂtHg擾iANSIŁj
// szFontName ɂ LF_FACESIZE ̒mۂ
// szFontName  pHeight ͕KvłȂ NULL ł
// tHg̕Zbg, s畉Ԃ
int GetDesktopFontA ( char *szFontName, int *pHeight ) {

   LOGFONTA LogFont ;
   *LogFont.lfFaceName = 0 ;

   if ( ! SystemParametersInfoA ( SPI_GETICONTITLELOGFONT, sizeof(LOGFONTA), & LogFont, 0 ) || ! *LogFont.lfFaceName ) return -1 ;

   if ( szFontName ) strcpy ( szFontName, LogFont.lfFaceName ) ;
   if ( pHeight ) *pHeight = LogFont.lfHeight ;

   return LogFont.lfCharSet ;
}



// fXNgbvŎgĂtHg擾iUNICODEŁj
// szFontName ɂ LF_FACESIZE ̒mۂ
// szFontName  pHeight ͕KvłȂ NULL ł
// tHg̕Zbg, s畉Ԃ
int GetDesktopFontW ( wchar_t *szFontName, int *pHeight ) {

   LOGFONTW LogFont ;
   *LogFont.lfFaceName = 0 ;

   if ( ! SystemParametersInfoW ( SPI_GETICONTITLELOGFONT, sizeof(LOGFONTW), & LogFont, 0 ) || ! *LogFont.lfFaceName ) return -1 ;

   if ( szFontName ) wcscpy ( szFontName, LogFont.lfFaceName ) ;
   if ( pHeight ) *pHeight = LogFont.lfHeight ;

   return LogFont.lfCharSet ;
}



//////////////////////////////
//       R[hy[W       //
//////////////////////////////



// R[hy[W當ZbgԂ
static int CodePageToCharSet ( int nCodePage ) {

   CHARSETINFO CharsetInfo ;

   if ( ! IsValidCodePage ( nCodePage ) || ! TranslateCharsetInfo ( (ULONG*)(ULONG_PTR) nCodePage, & CharsetInfo, TCI_SRCCODEPAGE ) ) return ANSI_CHARSET ;

   return CharsetInfo.ciCharset ;
}



//////////////////////////////
//     T^IȃtHg     //
//////////////////////////////



// T^IȃtHgԂiANSIŁj
static const char *GetWellKnownFontA ( int nCharset, int IsUseLocalName ) {

   switch ( nCharset ) {
      case SHIFTJIS_CHARSET :       return ( ! IsUseLocalName ) ? "MS PGothic"   : "lr oSVbN"  ;
      case GB2312_CHARSET :         return ( ! IsUseLocalName ) ? "SimSun"       : "\xCB\xCE\xCC\xE5" ;
      case HANGUL_CHARSET :         return ( ! IsUseLocalName ) ? "Gulim"        : "\xB1\xBC\xB8\xB2" ;
      case CHINESEBIG5_CHARSET :
                  if ( IsWin95 () ) return ( ! IsUseLocalName ) ? "MingLiU"      : "\xB2\xD3\xA9\xFA\xC5\xE9" ;
                  else              return ( ! IsUseLocalName ) ? "PMingLiU"     : "\xB7\x73\xB2\xD3\xA9\xFA\xC5\xE9" ;
      case THAI_CHARSET :           return "Tahoma" ;
      default :                     return "Arial" ;
   }
}



// T^IȃtHgԂiUNICODEŁj
static const wchar_t *GetWellKnownFontW ( int nCharset, int IsUseLocalName ) {

   switch ( nCharset ) {
      case SHIFTJIS_CHARSET :       return ( ! IsUseLocalName ) ? L"MS PGothic"  : L"lr oSVbN" ;
      case GB2312_CHARSET :         return ( ! IsUseLocalName ) ? L"SimSun"      : L"v" ;
      case HANGUL_CHARSET :         return ( ! IsUseLocalName ) ? L"Gulim"       : L"\xAD74\xB9BC" ;
      case CHINESEBIG5_CHARSET :
                  if ( IsWinNT40 () ) return ( ! IsUseLocalName ) ? L"MingLiU"   : L"ז" ;
                  else                return ( ! IsUseLocalName ) ? L"PMingLiU"  : L"Vז" ;
      case THAI_CHARSET :           return L"Tahoma" ;
      default :                     return L"Arial" ;
   }
}



//////////////////////////////
//       XP ptHg      //
//////////////////////////////



// WindowsXP p̃VXeptHg[JŕԂiUNICODEŁj
static const wchar_t *GetXpGuiFontW ( int nCharset ) {

   switch ( nCharset ) {
      case SHIFTJIS_CHARSET :       return L"MS UI Gothic" ;
      case GB2312_CHARSET :         return L"Tahoma" ;
      case HANGUL_CHARSET :         return L"\xAD74\xB9BC" ;
      case CHINESEBIG5_CHARSET :    return L"Vז" ;
      case THAI_CHARSET :           return L"Tahoma" ;
      default :                     return L"Tahoma" ;
   }
}



//////////////////////////////
//       tHg쐬       //
//////////////////////////////



// tHg쐬p̓֐
static HFONT CreateFontInternal ( int nSize, int nCodePage, int IsAllowSegoe ) {

   int nHeight ;

   if ( nSize > 0 ) {
      HDC hDC = GetDC ( NULL ) ;
      nHeight = - MulDiv ( nSize, GetDeviceCaps ( hDC, LOGPIXELSY ), 72 ) ;
      ReleaseDC ( NULL, hDC ) ;
   }
   else if ( ! nSize ) {
      if ( IsNT () ) { if ( GetDesktopFontW ( NULL, & nHeight ) < 0 ) nHeight = -12 ; }
      else           { if ( GetDesktopFontA ( NULL, & nHeight ) < 0 ) nHeight = -12 ; }
   }
   else {
      nHeight = nSize ;
   }


   if ( IsNT () ) {

      int nCharset ;
      int nFontFamily = FF_DONTCARE ;
      const wchar_t *szFontName = NULL ;
      wchar_t szBuffer [ LF_FACESIZE ] ;

      if ( ! nCodePage ) {
         if ( IsAllowSegoe || ! IsWinVISTAorLater () ) {
            nCharset = GetDesktopFontW ( szBuffer, NULL ) ;
            if ( nCharset >= 0 ) szFontName = szBuffer ;
            else                 nCodePage = GetACP () ;
         }
         else {
            nCharset = CodePageToCharSet ( GetACP () ) ;
            szFontName = GetXpGuiFontW ( nCharset ) ;
         }
      }
      if ( nCodePage ) {
         nCharset = CodePageToCharSet ( nCodePage ) ;
         szFontName = GetWellKnownFontW ( nCharset, ( (int) GetACP () == nCodePage ) ) ;
         nFontFamily = ( nCharset == GB2312_CHARSET || nCharset == CHINESEBIG5_CHARSET ) ? FF_MODERN : FF_SWISS ;
      }

      return CreateFontW ( nHeight, 0, 0, 0, 0, FALSE, FALSE, FALSE, nCharset, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | nFontFamily, szFontName ) ;
   }
   else {

      int nCharset ;
      int nFontFamily = FF_DONTCARE ;
      const char *szFontName = NULL ;
      char szBuffer [ LF_FACESIZE ] ;

      if ( ! nCodePage ) {
         if ( IsAllowSegoe || ! IsWinVISTAorLater () ) {
            nCharset = GetDesktopFontA ( szBuffer, NULL ) ;
            if ( nCharset >= 0 ) szFontName = szBuffer ;
            else                 nCodePage = GetACP () ;
         }
         else {
            nCharset = CodePageToCharSet ( GetACP () ) ;
            WideCharToMultiByte ( CP_ACP, 0, GetXpGuiFontW ( nCharset ), -1, szBuffer, LF_FACESIZE, NULL, NULL ) ;
            szFontName = szBuffer ;
         }
      }
      if ( nCodePage ) {
         nCharset = CodePageToCharSet ( nCodePage ) ;
         szFontName = GetWellKnownFontA ( nCharset, ( (int) GetACP () == nCodePage ) ) ;
         nFontFamily = ( nCharset == GB2312_CHARSET || nCharset == CHINESEBIG5_CHARSET ) ? FF_MODERN : FF_SWISS ;
      }

      return CreateFontA ( nHeight, 0, 0, 0, 0, FALSE, FALSE, FALSE, nCharset, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | nFontFamily, szFontName ) ;
   }

}



// R[hy[WtHg쐬
// R[hy[W 0 Ȃ \ptHg쐬
// TCYȂ|CgAȂsNZƂ
// TCY 0 ȂÃTCYō쐬
HFONT CreateFontByCodePage ( int nSize, int nCodePage ) {
   return CreateFontInternal ( nSize, nCodePage, 0 ) ;
}



// \ptHg쐬
// TCYȂ|CgAȂsNZƂ
// TCY 0 ȂÃTCYō쐬
HFONT CreateGuiFont ( int nSize ) {
   return CreateFontInternal ( nSize, 0, 0 ) ;
}



// \ptHg쐬iVistaptHgΉj
// TCYȂ|CgAȂsNZƂ
// TCY 0 ȂÃTCYō쐬
HFONT CreateVistaGuiFont ( int nSize ) {
   return CreateFontInternal ( nSize, 0, 1 ) ;
}



