// mvwnd.cpp

#include <windows.h>
#include <limits.h>
#include "msc.h"
#include "mvwnd.h"



#define DEBUG_RECT   0

static int GetMonitorRect ( HWND hWnd, RECT *pRect ) ;
static HWND GetParentWindow ( HWND hWnd ) ;
static int IsChildWindow ( HWND hWnd ) ;

static int DebugRect ( HWND hWnd, RECT *pRectParent, RECT *pRect, POINT *pPoint ) ;



////////////////////////////////////////////
//              Sňړ              //
////////////////////////////////////////////



// ֐
// Sɂ 0  100 ̒lw肷
// S -1 w肵AړȂ
//  0 As 0 ȊOԂ
static int MoveWindowByRatio ( HWND hWnd, HWND hWndParent, int nHorizontalRatio, int nVerticalRatio ) {

   RECT Rect, RectParent ;
   POINT Point ;

   if ( nHorizontalRatio < -1 || nHorizontalRatio > 100 ) return 1 ;
   if ( nVerticalRatio < -1 || nVerticalRatio > 100 ) return 1 ;
   if ( IsChildWindow ( hWnd ) ) return 1 ;

   if ( ! GetWindowRect ( hWnd, & Rect ) ) return 1 ;
   if ( hWndParent ) { if ( ! GetWindowRect ( hWndParent, & RectParent ) ) return 1 ; }
   else              { if ( ! GetMonitorRect ( hWnd, & RectParent ) ) return 1 ; }

   Point.x = Rect.left ;
   Point.y = Rect.top ;

   if ( nHorizontalRatio >= 0 ) {
      Point.x = ( RectParent.right - RectParent.left ) - ( Rect.right - Rect.left ) ;
      if ( ! hWndParent && Point.x < 0 ) Point.x = 0 ;
      Point.x = RectParent.left + ( ( Point.x * nHorizontalRatio ) / 100 ) ;
   }
   if ( nVerticalRatio >= 0 ) {
      Point.y = ( RectParent.bottom - RectParent.top ) - ( Rect.bottom - Rect.top ) ;
      if ( ! hWndParent && Point.y < 0 ) Point.y = 0 ;
      Point.y = RectParent.top + ( ( Point.y * nVerticalRatio ) / 100 ) ;
   }

   if ( DEBUG_RECT ) DebugRect ( hWnd, & RectParent, & Rect, & Point ) ;

   if ( Point.x != Rect.left || Point.y != Rect.top ) SetWindowPos ( hWnd, NULL, Point.x, Point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER ) ;
   return 0 ;
}



// EBhEfXNgbvňړ
//  0 As 0 ȊOԂ
int MoveWindowInDesktop ( HWND hWnd, int nHorizontalRatio, int nVerticalRatio ) {
   return MoveWindowByRatio ( hWnd, NULL, nHorizontalRatio, nVerticalRatio ) ;
}



// EBhEeEBhEňړ
//  0 As 0 ȊOԂ
int MoveWindowInParent ( HWND hWnd, int nHorizontalRatio, int nVerticalRatio ) {
   return MoveWindowByRatio ( hWnd, GetParentWindow ( hWnd ), nHorizontalRatio, nVerticalRatio ) ;
}



////////////////////////////////////////////
//         EBhEɈړ         //
////////////////////////////////////////////



// ֐
//  0 As 0 ȊOԂ
static int MoveWindowInto ( HWND hWnd, HWND hWndParent ) {

   RECT Rect, RectParent ;
   POINT Point ;

   if ( IsChildWindow ( hWnd ) ) return 1 ;

   if ( ! GetWindowRect ( hWnd, & Rect ) ) return 1 ;
   if ( hWndParent ) { if ( ! GetWindowRect ( hWndParent, & RectParent ) ) return 1 ; }
   else              { if ( ! GetMonitorRect ( hWnd, & RectParent ) ) return 1 ; }

   Point.x = Rect.left ;
   Point.y = Rect.top ;

   if ( RectParent.right < Rect.right ) Point.x = RectParent.right - ( Rect.right - Rect.left ) ;
   if ( RectParent.bottom < Rect.bottom ) Point.y = RectParent.bottom - ( Rect.bottom - Rect.top ) ;
   if ( RectParent.left > Rect.left ) Point.x = RectParent.left ;
   if ( RectParent.top > Rect.top ) Point.y = RectParent.top ;

   if ( DEBUG_RECT ) DebugRect ( hWnd, & RectParent, & Rect, & Point ) ;

   if ( Point.x != Rect.left || Point.y != Rect.top ) SetWindowPos ( hWnd, NULL, Point.x, Point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER ) ;
   return 0 ;
}



// EBhEfXNgbvɈړ
//  0 As 0 ȊOԂ
int MoveWindowIntoDesktop ( HWND hWnd ) {
   return MoveWindowInto ( hWnd, NULL ) ;
}



// EBhEeEBhEɈړ
//  0 As 0 ȊOԂ
int MoveWindowIntoParent ( HWND hWnd ) {
   return MoveWindowInto ( hWnd, GetParentWindow ( hWnd ) ) ;
}



////////////////////////////////////////////
//        ^Cgo[Ɉړ        //
////////////////////////////////////////////



// ֐
//  0 As 0 ȊOԂ
static int MoveWindowTitleInto ( HWND hWnd, HWND hWndParent ) {

   RECT Rect, RectParent ;
   POINT Point ;

   if ( IsChildWindow ( hWnd ) ) return 1 ;

   if ( ! GetWindowRect ( hWnd, & Rect ) ) return 1 ;
   if ( hWndParent ) { if ( ! GetWindowRect ( hWndParent, & RectParent ) ) return 1 ; }
   else              { if ( ! GetMonitorRect ( hWnd, & RectParent ) ) return 1 ; }

   Point.x = Rect.left ;
   Point.y = Rect.top ;

   RECT RectRim ;
   POINT PointRim ;

   RectRim = RectParent ;
   PointRim.x = ( Rect.right - Rect.left ) - 200 ;
   PointRim.y = ( Rect.bottom - Rect.top ) - 200 ;
   if ( PointRim.x < 0 ) PointRim.x = 0 ;
   if ( PointRim.y < 0 ) PointRim.y = 0 ;
   RectRim.bottom += PointRim.y ;
   RectRim.right += PointRim.x ;
   RectRim.left -= PointRim.x ;

   if ( RectRim.right < Rect.right ) Point.x = RectRim.right - ( Rect.right - Rect.left ) ;
   if ( RectRim.bottom < Rect.bottom ) Point.y = RectRim.bottom - ( Rect.bottom - Rect.top ) ;
   if ( RectRim.left > Rect.left ) Point.x = RectRim.left ;
   if ( RectRim.top > Rect.top ) Point.y = RectRim.top ;

   if ( DEBUG_RECT ) DebugRect ( hWnd, & RectParent, & Rect, & Point ) ;

   if ( Point.x != Rect.left || Point.y != Rect.top ) SetWindowPos ( hWnd, NULL, Point.x, Point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER ) ;
   return 0 ;
}



// EBhẼ^Cgo[fXNgbvɈړ
//  0 As 0 ȊOԂ
int MoveWindowTitleIntoDesktop ( HWND hWnd ) {
   return MoveWindowTitleInto ( hWnd, NULL ) ;
}



// EBhẼ^Cgo[eEBhEɈړ
//  0 As 0 ȊOԂ
int MoveWindowTitleIntoParent ( HWND hWnd ) {
   return MoveWindowTitleInto ( hWnd, GetParentWindow ( hWnd ) ) ;
}



////////////////////////////////////////////
//        EBhËʒu炷        //
////////////////////////////////////////////



static BOOL CALLBACK ShiftWindowProc ( HWND hWnd, LPARAM lParam ) ;



typedef struct {
   RECT *pRect ;
   HWND hWnd ;
   ATOM nClass ;
   short IsFound ;
} SHIFT_WINDOW_DATA ;



// NX̃EBhEAEBhEʒu炷
int ShiftWindow ( HWND hWnd ) {

   RECT Rect ;
   if ( ! GetWindowRect ( hWnd, & Rect ) ) return -1 ;

   RECT RectSaved = Rect ;

   SHIFT_WINDOW_DATA ShiftWindowData ;
   ShiftWindowData.pRect = & Rect ;
   ShiftWindowData.hWnd = hWnd ;
   if ( IsNT () ) ShiftWindowData.nClass = (ATOM) GetClassLongPtrW ( hWnd, GCW_ATOM ) ;
   else           ShiftWindowData.nClass = (ATOM) GetClassLongPtrA ( hWnd, GCW_ATOM ) ;

   for ( int nCount = 0 ; nCount < 0x10 ; nCount ++ ) {

      ShiftWindowData.IsFound = 0 ;

      EnumWindows ( ShiftWindowProc, (LPARAM) & ShiftWindowData ) ;

      if ( ! ShiftWindowData.IsFound ) break ;

      const unsigned int nShiftWidth = ( nCount / 4 + 1 ) * 20 ;

      switch ( nCount % 4 ) {
         case 0 :
            Rect.left = RectSaved.left + nShiftWidth ;
            Rect.top = RectSaved.top + nShiftWidth ;
            Rect.right = RectSaved.right + nShiftWidth ;
            Rect.bottom = RectSaved.bottom + nShiftWidth ;
            break ;
         case 1 :
            Rect.left = RectSaved.left - nShiftWidth ;
            Rect.top = RectSaved.top - nShiftWidth ;
            Rect.right = RectSaved.right - nShiftWidth ;
            Rect.bottom = RectSaved.bottom - nShiftWidth ;
            break ;
         case 2 :
            Rect.left = RectSaved.left + ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.top = RectSaved.top - ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.right = RectSaved.right + ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.bottom = RectSaved.bottom - ( nShiftWidth + nShiftWidth / 2 ) ;
            break ;
         case 3 :
            Rect.left = RectSaved.left - ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.top = RectSaved.top + ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.right = RectSaved.right - ( nShiftWidth + nShiftWidth / 2 ) ;
            Rect.bottom = RectSaved.bottom + ( nShiftWidth + nShiftWidth / 2 ) ;
            break ;
      }
   }

   if ( ! CompareRect ( & Rect, & RectSaved ) ) return 0 ;

   SetWindowPos ( hWnd, NULL, Rect.left, Rect.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER ) ;

   return 1 ;
}



static BOOL CALLBACK ShiftWindowProc ( HWND hWnd, LPARAM lParam ) {

   SHIFT_WINDOW_DATA *pShiftWindowData = (SHIFT_WINDOW_DATA*) lParam ;

   if ( hWnd == pShiftWindowData->hWnd ) return TRUE ;

   if ( IsNT () ) { if ( GetClassLongPtrW ( hWnd, GCW_ATOM ) != (ULONG_PTR) pShiftWindowData->nClass ) return TRUE ; }
   else           { if ( GetClassLongPtrA ( hWnd, GCW_ATOM ) != (ULONG_PTR) pShiftWindowData->nClass ) return TRUE ; }

   RECT Rect ;
   if ( ! GetWindowNormalPositionRect ( hWnd, & Rect ) || CompareRect ( & Rect, pShiftWindowData->pRect ) ) return TRUE ;

   pShiftWindowData->IsFound = 1 ;

   return FALSE ;
}



////////////////////////////////////////////
//               `擾               //
////////////////////////////////////////////



// `r
// v 0 AvȂ 0 ȊOԂ
int CompareRect ( RECT *pRect1, RECT *pRect2 ) {

   if ( pRect1->left != pRect2->left ) return 1 ;
   if ( pRect1->top != pRect2->top ) return 1 ;
   if ( pRect1->right != pRect2->right ) return 1 ;
   if ( pRect1->bottom != pRect2->bottom ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//               `擾               //
////////////////////////////////////////////



// EBhE̋`擾
// ŏEő剻ꂽEBhEłAʏ펞̃TCY擾
//  0 ȊOAs 0 Ԃ
int GetWindowNormalPositionRect ( HWND hWnd, RECT *pRect ) {

   if ( IsIconic ( hWnd ) || IsZoomed ( hWnd ) ) {

      WINDOWPLACEMENT WindowPlacement = { sizeof(WINDOWPLACEMENT) } ;
      if ( ! GetWindowPlacement ( hWnd, & WindowPlacement ) ) return 0 ;

      RECT Rect ;
      if ( IsNT () ) { if ( ! SystemParametersInfoW ( SPI_GETWORKAREA, 0, & Rect, 0 ) ) return 0 ; }
      else           { if ( ! SystemParametersInfoA ( SPI_GETWORKAREA, 0, & Rect, 0 ) ) return 0 ; }

      pRect->left = WindowPlacement.rcNormalPosition.left + Rect.left ;
      pRect->right = WindowPlacement.rcNormalPosition.right + Rect.left ;
      pRect->top = WindowPlacement.rcNormalPosition.top + Rect.top ;
      pRect->bottom = WindowPlacement.rcNormalPosition.bottom + Rect.top ;

      return 1 ;
   }

   return GetWindowRect ( hWnd, pRect ) ;
}



////////////////////////////////////////////
//                ֐                //
////////////////////////////////////////////



// eEBhẼnh擾
static HWND GetParentWindow ( HWND hWnd ) {
   if ( IsNT () ) return (HWND) GetWindowLongPtrW ( hWnd, GWLP_HWNDPARENT ) ;
   else           return (HWND) GetWindowLongPtrA ( hWnd, GWLP_HWNDPARENT ) ;
}



// qEBhEȂ 0 ȊOԂ
static int IsChildWindow ( HWND hWnd ) {
   if ( IsNT () ) return ( ( GetWindowLongPtrW ( hWnd, GWL_STYLE ) ) & WS_CHILD ) ? 1 : 0 ;
   else           return ( ( GetWindowLongPtrA ( hWnd, GWL_STYLE ) ) & WS_CHILD ) ? 1 : 0 ;
}



static int DebugRect ( HWND hWnd, RECT *pRectParent, RECT *pRect, POINT *pPoint ) {

   char szBuffer [ MAX_PATH * 2 ] ;
   *szBuffer = 0 ;

   if ( pRectParent ) wsprintf ( strend ( szBuffer ), "(PARENT)\nleft: %d\ntop: %d\nright: %d\nbottom: %d\n\n", pRectParent->left, pRectParent->top, pRectParent->right, pRectParent->bottom ) ;
   if ( pRect )       wsprintf ( strend ( szBuffer ), "(CHILD)\nleft: %d\ntop: %d\nright: %d\nbottom: %d\n\n", pRect->left, pRect->top, pRect->right, pRect->bottom ) ;
   if ( pPoint )      wsprintf ( strend ( szBuffer ), "(New)\nx: %d\ny: %d\n", pPoint->x, pPoint->y ) ;

   const char szTitle [] = "mvwnd.cpp debug" ;

   MessageBox ( hWnd, szBuffer, szTitle, MB_OK ) ;

   return 0 ;
}



////////////////////////////////////////////
//         ֐ (}`j^)        //
////////////////////////////////////////////



#if ! defined _MSC_VER || WINVER < 0x0500

#define HMONITOR HMONITOR_
#define MONITORINFO MONITORINFO_
#define LPMONITORINFO LPMONITORINFO_

typedef HANDLE HMONITOR ;

typedef struct {
    DWORD   cbSize;
    RECT    rcMonitor;
    RECT    rcWork;
    DWORD   dwFlags;
} MONITORINFO, *LPMONITORINFO;

#endif


#ifndef MONITOR_DEFAULTTONULL
#define MONITOR_DEFAULTTONULL       0x00000000
#define MONITOR_DEFAULTTOPRIMARY    0x00000001
#define MONITOR_DEFAULTTONEAREST    0x00000002
#endif


#if ! defined _MSC_VER || WINVER < 0x0500
typedef HMONITOR ( WINAPI *MONITORFROMWINDOW ) ( HWND hwnd, DWORD dwFlags ) ;
typedef BOOL ( WINAPI *GETMONITORINFOA ) ( HMONITOR hMonitor, LPMONITORINFO lpmi ) ;
typedef BOOL ( WINAPI *GETMONITORINFOW ) ( HMONITOR hMonitor, LPMONITORINFO lpmi ) ;
#endif



// w肳ꂽEBhE郂j^[̍Ɨ̈̋`擾
//  0 ȊOAs 0 Ԃ
static int GetMonitorRect ( HWND hWnd, RECT *pRect ) {

   if ( IsNT () ) {

      if ( hWnd ) {

         int IsMultiMonitor = 1 ;

#if ! defined _MSC_VER || WINVER < 0x0500
         MONITORFROMWINDOW MonitorFromWindow = NULL ;
         GETMONITORINFOW GetMonitorInfoW = NULL ;

         HINSTANCE hUser32 = GetModuleHandleW ( L"USER32.DLL" ) ;
         if ( GETPROCADDRESS ( hUser32, MONITORFROMWINDOW, MonitorFromWindow ) ) IsMultiMonitor = 0 ;
         if ( GETPROCADDRESS ( hUser32, GETMONITORINFOW, GetMonitorInfoW ) ) IsMultiMonitor = 0 ;
#endif

         if ( IsMultiMonitor ) {

            HMONITOR hMonitor = MonitorFromWindow ( hWnd, MONITOR_DEFAULTTONEAREST ) ;

            if ( hMonitor ) {

               MONITORINFO MonitorInfo = { sizeof(MONITORINFO) } ;
               if ( GetMonitorInfoW ( hMonitor, & MonitorInfo ) ) {
                  *pRect = MonitorInfo.rcWork ;
                  return 1 ;
               }
            }
         }
      }

      return SystemParametersInfoW ( SPI_GETWORKAREA, 0, pRect, 0 ) ;

   }
   else {

      if ( hWnd ) {

         int IsMultiMonitor = 1 ;

#if ! defined _MSC_VER || WINVER < 0x0500
         MONITORFROMWINDOW MonitorFromWindow = NULL ;
         GETMONITORINFOA GetMonitorInfoA = NULL ;

         HINSTANCE hUser32 = GetModuleHandleA ( "USER32.DLL" ) ;
         if ( GETPROCADDRESS ( hUser32, MONITORFROMWINDOW, MonitorFromWindow ) ) IsMultiMonitor = 0 ;
         if ( GETPROCADDRESS ( hUser32, GETMONITORINFOA, GetMonitorInfoA ) ) IsMultiMonitor = 0 ;
#endif

         if ( IsMultiMonitor ) {

            HMONITOR hMonitor = MonitorFromWindow ( hWnd, MONITOR_DEFAULTTONEAREST ) ;

            if ( hMonitor ) {

               MONITORINFO MonitorInfo = { sizeof(MONITORINFO) } ;
               if ( GetMonitorInfoA ( hMonitor, & MonitorInfo ) ) {
                  *pRect = MonitorInfo.rcWork ;
                  return 1 ;
               }
            }
         }
      }

      return SystemParametersInfoA ( SPI_GETWORKAREA, 0, pRect, 0 ) ;

   }
}



