// rtfconv_opt.cpp

#include <windows.h>
#include "msc.h"
#include "codepage.h"
#include "resource.h"
#include "rtfconv.h"
#include "uniblock.h"

#ifdef RTFCONV_COM
#include "nls.h"
#endif


#define RTFCONV_OPT_GLOBAL(type,name)              extern type name ;    type name = (type) 0
#define RTFCONV_OPT_GLOBAL_INIT(type,name,init)    extern type name ;    type name = init
#define RTFCONV_OPT_GLOBAL_ARRAY(type,name,size)   extern type name [] ; type name [size] = { 0 }
// C++ ł const ̓ftHgł͓ɂȂ̂ŁAextern ł̐錾Kv

#include "rtfconv_opt.h"



////////////////////////////////////////
//    IvVt@C̓ǂݎ    //
////////////////////////////////////////



// ̃IvV
const OPTION_INTEGER OptionIntegerList [] = {
   { & IsNoVariant, "IsNoVariant" },
   { & IsNoHanKana, "IsNoHanKana" },
   { & IsNoZenAlpha, "IsNoZenAlpha" },
   { & IsNoZenSpace, "IsNoZenSpace" },
   { & IsNoZenSymbol, "IsNoZenSymbol" },
   { & IsYenNoBackslash, "IsYenNoBackslash" },
   { & nUnmappableCharFormat, "UnmappableCharFormat" },
   { & IsOutputNumberSurrogate, "IsOutputNumberSurrogate" },
   { & IsInputNumberHtml, "IsInputNumberHtml" },
   { & IsInputNumberC, "IsInputNumberC" },
   { & IsConvertPua, "IsConvertPua" },
   { & IsNoByteOrderMark, "IsNoByteOrderMark" },
   { & IsUtf8ByteOrderMark, "IsUtf8ByteOrderMark" },
   { & IsOutputRuby, "IsOutputRuby" },
   { & IsOutputLink, "IsOutputLink" },
   { & IsOutputHidden, "IsOutputHidden" },
   { & IsEndianAuto, "IsEndianAuto" },
   { & IsDeleteEof, "IsDeleteEof" },
   { & IsUseSameFont, "IsUseSameFont" },
   { & nFontSize, "FontSize" },
   { & nDefaultCjkCodePage, "CjkCodePage" },
   { & IsUseArray, "IsUseArray" },
   { & IsNotUseArray, "IsNotUseArray" },
   { & IsOutputCR, "IsOutputCR" },
   { & IsOutputLF, "IsOutputLF" },
   { & IsInputJisNoVendor, "IsInputJisNoVendor" },
   { & IsOutputJisNoVendor, "IsOutputJisNoVendor" },
   { & IsInputJisMac, "IsInputJisMac" },
   { & IsOutputJisMac, "IsOutputJisMac" },
   { & IsInputJis2004, "IsInputJis2004" },
   { & IsOutputJis2004, "IsOutputJis2004" },
   { & IsNoJis83New, "IsNoJis83New" },
   { & IsNoJis83Old, "IsNoJis83Old" },
   { & IsEucOutputHojo, "IsEucOutputHojo" },
   { & IsOverlineNoTilde, "IsOverlineNoTilde" },
   { & IsGbOutput, "IsGbOutput" },
   { & IsPua2Hkscs, "IsPua2Hkscs" },
   { & IsHkscsCjka2Pua, "IsHkscsCjka2Pua" },
   { & IsHkscsCjkb2Pua, "IsHkscsCjkb2Pua" },
   { & IsHkscsCjk412Pua, "IsHkscsCjk412Pua" },
   { & IsOutputHkscs1999, "IsOutputHkscs1999" },
   { & IsOutputHkscs2001, "IsOutputHkscs2001" },
   { & IsOutputHkscs2004, "IsOutputHkscs2004" },
   { & IsGbk2Pua, "IsGbk2Pua" },
   { & IsPua2Gbk, "IsPua2Gbk" },
   { & IsGbkOutputFantizi, "IsGbkOutputFantizi" },
   { & IsKsNoUhc, "IsKsNoUhc" },
   { & IsConvKsPunc, "IsConvKsPunc" },
   { & IsRtfFontXp, "IsRtfFontXp" },
   { & IsRtfFontVista, "IsRtfFontVista" },
#if defined RTFCONV_EXE || defined SETUP_R
   { & IsNoConfirm, "IsNoConfirm" },
   { & IsNoRecycle, "IsNoRecycle" },
   { & IsNoMessage, "IsNoMessage" },
   { & IsNoAddExtension, "IsNoAddExtension" },
   { & IsConfirmOnExit, "IsConfirmOnExit" },
   { & nSavedMuiLangId, "MuiLangId" },
   { & nSavedSrcType, "SrcType" },
   { & nSavedDstType, "DstType" },
   { & nSavedSrcCode, "SrcCode" },
   { & nSavedDstCode, "DstCode" },
   { & nSavedWindowX, "WindowX" },
   { & nSavedWindowY, "WindowY" },
#endif
} ;

const int OPTION_INTEGER_LIST_NELEM = NELEMOF ( OptionIntegerList ) ;



// ̃IvV (ANSI)
const OPTION_STRING_A OptionStringListA [] = {
   { szEuropeanFont,             "EuropeanFont",            FONTNAME_MAX },
   { szJapaneseFont,             "JapaneseFont",            FONTNAME_MAX },
   { szKoreanFont,               "KoreanFont",              FONTNAME_MAX },
   { szChineseSimplifiedFont,    "ChineseSimplifiedFont",   FONTNAME_MAX },
   { szChineseTraditionalFont,   "ChineseTraditionalFont",  FONTNAME_MAX },
   { szThaiFont,                 "ThaiFont",                FONTNAME_MAX },
   { szFontNameArrayDummy,       "FontEx",                  FONTNAME_MAX },
#if defined RTFCONV_EXE || defined SETUP_R
   { szBrowsePathA,              "BrowsePathA",             MAX_PATH },
#endif
} ;

const int OPTION_STRING_LIST_A_NELEM = NELEMOF ( OptionStringListA ) ;



#if defined RTFCONV_EXE || defined SETUP_R
// ̃IvV (UNICODE)
const OPTION_STRING_W OptionStringListW [] = {
   { szBrowsePathW,  "BrowsePathW",    MAX_PATH },
} ;

const int OPTION_STRING_LIST_W_NELEM = NELEMOF ( OptionStringListW ) ;
#endif



// z̃IvV
const OPTION_BINARY OptionBinaryList [] = {
   { LangIdArray, "LangId",   UNICODE_BLOCK_NELEM },
} ;

const int OPTION_BINARY_LIST_NELEM = NELEMOF ( OptionBinaryList ) ;



////////////////////////////////////////
//          IvV̐ݒ          //
////////////////////////////////////////



// o͂łȂ̏o͌`
const UNMAPPABLE_CHAR_FORMAT UnmappableCharFormatList [] = {
   { IDS_UNMAPPABLE_CHAR_FORMAT_0,  NULL },
   { IDS_UNMAPPABLE_CHAR_FORMAT_1,  "?" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_2,  "[UNICODE:%04X]" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_3,  "&#x%04X;" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_4,  "&#%u;" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_5,  "[U+%04X]" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_6,  "[U+%u]" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_7,  "[%04X]" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_8,  "[%u]" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_9,  "\\x%04X" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_10, "\\u%04X" },
   { IDS_UNMAPPABLE_CHAR_FORMAT_11, "\\U%08X" },
} ;

const int UNMAPPABLE_CHAR_FORMAT_LIST_NELEM = NELEMOF ( UnmappableCharFormatList ) ;



#ifdef RTFCONV_COM
// R}hC̕ϊ[hIvVp (-m*)
const OPTION_INTEGER ModeOptionNameList [] = {
   { & IsOutputNumberMsc,     "MSC" },
   { & IsRtfFontVista,        "RTFFONTVISTA" },
   { & IsRtfFontXp,           "RTFFONTXP" },
   { & IsInputJisNoVendor,    "JISNOVENIN" },
   { & IsOutputJisNoVendor,   "JISNOVENOUT" },
   { & IsOutputJisNoVendor,   "JISNOVEN" },
   { & IsInputJisMac,         "JISMACIN" },
   { & IsOutputJisMac,        "JISMACOUT" },
   { & IsInputJis2004,        "JIS2004IN" },
   { & IsOutputJis2004,       "JIS2004OUT" },
   { & IsInputJisNoVendor,    "JIS1997IN" },
   { & IsOutputJisNoVendor,   "JIS1997OUT" },
   { & IsEucOutputHojo,       "JISHOJO" },
   { & IsNoJis83New,          "JISNO83NEW" },
   { & IsNoJis83Old,          "JISNO83OLD" },
   { & IsNoGbk,               "NOGBK" },
   { & IsGb18030,             "GB18030" },
   { & IsPua2Hkscs,           "PUA2HK" },
   { & IsHkscsCjka2Pua,       "HKA2PUA" },
   { & IsHkscsCjkb2Pua,       "HKB2PUA" },
   { & IsHkscsCjk412Pua,      "HK412PUA" },
   { & IsGbk2Pua,             "GBK2PUA" },
   { & IsPua2Gbk,             "PUA2GBK" },
   { & IsGbkOutputFantizi,    "GBFANTI" },
   { & IsKsNoUhc,             "NOUHC" },
   { & IsConvKsPunc,          "KSPUNC" },
   { & IsOutputHkscs1999,     "HK1999" },
   { & IsOutputHkscs2001,     "HK2001" },
   { & IsOutputHkscs2004,     "HK2004" },
   { & IsVariantOnlyRoundTrip, "ROUNDTRIP" },
   { & IsNoVariantEuropean,   "A" },
   { & IsNoByteOrderMark,     "B" },
   { & IsOutputNumber,        "C" },
   { & IsUtf8ByteOrderMark,   "D" },
   { & IsEndianAuto,          "E" },
   { & IsOutputNumberSurrogate,  "F" },
   { & IsOneQuestionMark,     "G" },
   { & IsNoHanKana,           "H" },
   { & IsNoVariantKanji,      "K" },
   { & IsOutputLink,          "L" },
   { & IsOutputHidden,        "N" },
   { & IsConvertPua,          "P" },
   { & IsOutputRuby,          "R" },
   { & IsNoZenSpace,          "S" },
   { & IsDeleteEof,           "T" },
   { & IsOutputNumberHtml,    "U" },
   { & IsInputNumberHtml,     "V" },
   { & IsInputNumberC,        "X" },
   { & IsNoZenSymbol,         "Y" },
   { & IsNoZenAlpha,          "Z" },
   { & IsYenNoBackslash,      "\\" },
   { & IsOverlineNoTilde,     "~" },
} ;

const int MODE_OPTION_NAME_LIST_NELEM = NELEMOF ( ModeOptionNameList ) ;
#endif



////////////////////////////////////////
//         R[hy[W̑I         //
////////////////////////////////////////



#ifdef RTFCONV_EXE
// R[hy[W̑I
const CODEPAGE AvailableCodeList [] = {
   { CP_US_ASCII, IDS_CP_US_ASCII },
   { CP_US, IDS_CP_US },
   { CP_EUROPEAN, IDS_CP_EUROPEAN },
   { CP_EUROPEAN_EURO, IDS_CP_EUROPEAN_EURO },
   { CP_CENTRAL_EUROPEAN, IDS_CP_CENTRAL_EUROPEAN },
   { CP_TURKISH_OLD, IDS_CP_TURKISH_OLD },
   { CP_PORTUGUESE, IDS_CP_PORTUGUESE },
   { CP_CANADIAN_FRENCH, IDS_CP_CANADIAN_FRENCH },
   { CP_ICELANDIC, IDS_CP_ICELANDIC },
   { CP_NORDIC, IDS_CP_NORDIC },
   { CP_BALTIC, IDS_CP_BALTIC },
   { CP_CYRILLIC, IDS_CP_CYRILLIC },
   { CP_RUSSIAN, IDS_CP_RUSSIAN },
   { CP_GREEK, IDS_CP_GREEK },
   { CP_MODERN_GREEK, IDS_CP_MODERN_GREEK },
   { CP_TURKISH, IDS_CP_TURKISH },
   { CP_CZECH, IDS_CP_CZECH },
   { CP_ARABIC_ASMO_708, IDS_CP_ARABIC_ASMO_708 },
   { CP_ARABIC_ASMO_449P, IDS_CP_ARABIC_ASMO_449P },
   { CP_ARABIC_TP_ASMO, IDS_CP_ARABIC_TP_ASMO },
   { CP_ARABIC, IDS_CP_ARABIC },
   { CP_HEBREW_OLD, IDS_CP_HEBREW_OLD },
   { CP_HEBREW, IDS_CP_HEBREW },

   { CP_ISO_EUROPEAN, IDS_CP_ISO_EUROPEAN },
   { CP_ISO_CENTRAL_EUROPEAN, IDS_CP_ISO_CENTRAL_EUROPEAN },
   { CP_ISO_TURKISH_OLD, IDS_CP_ISO_TURKISH_OLD },
   { CP_ISO_BALTIC, IDS_CP_ISO_BALTIC },
   { CP_ISO_CYRILLIC, IDS_CP_ISO_CYRILLIC },
   { CP_ISO_ARABIC, IDS_CP_ISO_ARABIC },
   { CP_ISO_GREEK, IDS_CP_ISO_GREEK },
   { CP_ISO_HEBREW_VISUAL, IDS_CP_ISO_HEBREW_VISUAL },
   { CP_ISO_HEBREW_LOGICAL, IDS_CP_ISO_HEBREW_LOGICAL },
   { CP_ISO_TURKISH, IDS_CP_ISO_TURKISH },
   { CP_ISO_NORDIC, IDS_CP_ISO_NORDIC },
   { CP_ISO_THAI, IDS_CP_ISO_THAI },
   { CP_ISO_BALTIC_EX, IDS_CP_ISO_BALTIC_EX },
   { CP_ISO_CELTIC, IDS_CP_ISO_CELTIC },
   { CP_ISO_EUROPEAN_EX, IDS_CP_ISO_EUROPEAN_EX },
   { CP_ISO_ROMANIAN, IDS_CP_ISO_ROMANIAN },

   { CP_ANSI_EUROPEAN, IDS_CP_ANSI_EUROPEAN },
   { CP_ANSI_CENTRAL_EUROPEAN, IDS_CP_ANSI_CENTRAL_EUROPEAN },
   { CP_ANSI_CYRILLIC, IDS_CP_ANSI_CYRILLIC },
   { CP_ANSI_GREEK, IDS_CP_ANSI_GREEK },
   { CP_ANSI_TURKISH, IDS_CP_ANSI_TURKISH },
   { CP_ANSI_BALTIC, IDS_CP_ANSI_BALTIC },
   { CP_ANSI_HEBREW, IDS_CP_ANSI_HEBREW },
   { CP_ANSI_ARABIC, IDS_CP_ANSI_ARABIC },
   { CP_THAI, IDS_CP_THAI },
   { CP_ANSI_VIETNAMESE, IDS_CP_ANSI_VIETNAMESE },

   { CP_VIETNAMESE_TCVN, IDS_CP_VIETNAMESE_TCVN },
   { CP_VIETNAMESE_TCVN2, IDS_CP_VIETNAMESE_TCVN2 },
   { CP_VIETNAMESE_TCVN3, IDS_CP_VIETNAMESE_TCVN3 },
   { CP_VIETNAMESE_VISCII, IDS_CP_VIETNAMESE_VISCII },
   { CP_VIETNAMESE_VPS, IDS_CP_VIETNAMESE_VPS },
   { CP_VIETNAMESE_VNI, IDS_CP_VIETNAMESE_VNI },
   { CP_VIETNAMESE_VIQR, IDS_CP_VIETNAMESE_VIQR },

   { CP_NORDIC_ISOIR197, IDS_CP_NORDIC_ISOIR197 },
   { CP_NORDIC_ISOIR209, IDS_CP_NORDIC_ISOIR209 },
   { CP_NORDIC_SAMIWS2, IDS_CP_NORDIC_SAMIWS2 },

   { CP_CYRILLIC_KOI8R, IDS_CP_CYRILLIC_KOI8R },
   { CP_CYRILLIC_KOI8U, IDS_CP_CYRILLIC_KOI8U },
   { CP_CYRILLIC_KOI8RU, IDS_CP_CYRILLIC_KOI8RU },
   { CP_CYRILLIC_KOI8T, IDS_CP_CYRILLIC_KOI8T },
   { CP_CYRILLIC_KOI8C, IDS_CP_CYRILLIC_KOI8C },
   { CP_CYRILLIC_KOI8O, IDS_CP_CYRILLIC_KOI8O },
   { CP_CYRILLIC_KOI8UNI, IDS_CP_CYRILLIC_KOI8UNI },
   { CP_CYRILLIC_ECMA, IDS_CP_CYRILLIC_ECMA },
   { CP_CYRILLIC_ASIAN, IDS_CP_CYRILLIC_ASIAN },
   { CP_CYRILLIC_KAZ, IDS_CP_CYRILLIC_KAZ },

   { CP_GEORGIAN, IDS_CP_GEORGIAN },
   { CP_GEORGIAN_AC, IDS_CP_GEORGIAN_AC },
   { CP_GEORGIAN_PS, IDS_CP_GEORGIAN_PS },
   { CP_ARMENIAN, IDS_CP_ARMENIAN },
   { CP_ARMENIAN_8A, IDS_CP_ARMENIAN_8A },

   { CP_MAC_EUROPEAN, IDS_CP_MAC_EUROPEAN },
   { CP_MAC_CENTRAL_EUROPEAN, IDS_CP_MAC_CENTRAL_EUROPEAN },
   { CP_MAC_ICELANDIC, IDS_CP_MAC_ICELANDIC },
   { CP_MAC_CYRILLIC, IDS_CP_MAC_CYRILLIC },
   { CP_MAC_GREEK, IDS_CP_MAC_GREEK },
   { CP_MAC_TURKISH, IDS_CP_MAC_TURKISH },
   { CP_MAC_ROMANIAN, IDS_CP_MAC_ROMANIAN },
   { CP_MAC_CROATIAN, IDS_CP_MAC_CROATIAN },
   { CP_MAC_UKRAINIAN, IDS_CP_MAC_UKRAINIAN },
   { CP_MAC_HEBREW, IDS_CP_MAC_HEBREW },
   { CP_MAC_ARABIC, IDS_CP_MAC_ARABIC },
   { CP_MAC_THAI, IDS_CP_MAC_THAI },

   { CP_PERSIAN_ISIRI, IDS_CP_PERSIAN_ISIRI },
   { CP_ISCII_DEVANAGARI, IDS_CP_ISCII_DEVANAGARI },
   { CP_ISCII_BENGALI, IDS_CP_ISCII_BENGALI },
   { CP_ISCII_TAMIL, IDS_CP_ISCII_TAMIL },
   { CP_ISCII_TELUGU, IDS_CP_ISCII_TELUGU },
   { CP_ISCII_ASSAMESE, IDS_CP_ISCII_ASSAMESE },
   { CP_ISCII_ORIYA, IDS_CP_ISCII_ORIYA },
   { CP_ISCII_KANNADA, IDS_CP_ISCII_KANNADA },
   { CP_ISCII_MALAYALAM, IDS_CP_ISCII_MALAYALAM },
   { CP_ISCII_GUJARATHI, IDS_CP_ISCII_GUJARATHI },
   { CP_ISCII_PANJABI, IDS_CP_ISCII_PANJABI },
   { CP_TAMIL_TSCII, IDS_CP_TAMIL_TSCII },
   { CP_TAMIL_TAM, IDS_CP_TAMIL_TAM },
   { CP_TAMIL_TAB, IDS_CP_TAMIL_TAB },

   { CP_JAPANESE, IDS_CP_JAPANESE },
   { CP_EUC_JAPANESE, IDS_CP_EUC_JAPANESE },
   { CP_ISO_JAPANESE, IDS_CP_ISO_JAPANESE },
   { CP_CHINESE_SIMPLIFIED, IDS_CP_CHINESE_SIMPLIFIED },
   { CP_CHINESE_SIMPLIFIED_EX, IDS_CP_CHINESE_SIMPLIFIED_EX },
   { CP_HZ_CHINESE_SIMPLIFIED, IDS_CP_HZ_CHINESE_SIMPLIFIED },
   { CP_CHINESE_TRADITIONAL, IDS_CP_CHINESE_TRADITIONAL },
   { CP_CHINESE_HKSCS, IDS_CP_CHINESE_HKSCS },
   { CP_EUC_CHINESE_TRADITIONAL, IDS_CP_EUC_CHINESE_TRADITIONAL },
   { CP_KOREAN, IDS_CP_KOREAN },
   { CP_ISO_KOREAN, IDS_CP_ISO_KOREAN },
   { CP_KOREAN_JOHAB, IDS_CP_KOREAN_JOHAB },

   { CP_UTF16, IDS_CP_UTF16 },
   { CP_UTF16_BE, IDS_CP_UTF16_BE },
   { CP_UTF8, IDS_CP_UTF8 },
   { CP_UTF7, IDS_CP_UTF7 },
   { CP_UTF32, IDS_CP_UTF32 },
   { CP_UTF32_BE, IDS_CP_UTF32_BE },
} ;

const int AVAILABLE_CODE_LIST_NELEM = NELEMOF ( AvailableCodeList ) ;
#endif



#ifdef RTFCONV_EXE
// }`oCgR[hy[W̃Xg
const CODEPAGE MultiByteCodeList [] = {
   { CP_JAPANESE, IDS_JAPANESE },
   { CP_CHINESE_SIMPLIFIED, IDS_CHINESE_SIMPLIFIED },
   { CP_CHINESE_TRADITIONAL, IDS_CHINESE_TRADITIONAL },
   { CP_KOREAN, IDS_KOREAN },
} ;

const int MULTIBYTE_CODE_LIST_NELEM = NELEMOF ( MultiByteCodeList ) ;
#endif



#ifdef RTFCONV_COM
// R[hy[W̑I
const CODEPAGE_NAME CodePageNameList [] = {
   { 0,                          "RTF" },
   { CP_UTF16,                   "U" },
   { CP_UTF16,                   "UNICODE" },
   { CP_UTF16_BE,                "UBIG" },
   { CP_UTF8,                    "UTF8" },
   { CP_UTF7,                    "UTF7" },
   { CP_UTF16,                   "UTF16" },
   { CP_UTF16_BE,                "UTF16BIG" },
   { CP_UTF16_BE,                "UTF16BE" },
   { CP_UTF32,                   "UTF32" },
   { CP_UTF32_BE,                "UTF32BIG" },
   { CP_UTF32_BE,                "UTF32BE" },
   { CP_ANSI_EUROPEAN,           "E" },
   { CP_ANSI_CENTRAL_EUROPEAN,   "CE" },
   { CP_ANSI_CYRILLIC,           "CY" },
   { CP_ANSI_GREEK,              "GR" },
   { CP_ANSI_TURKISH,            "TU" },
   { CP_ANSI_BALTIC,             "BA" },
   { CP_ANSI_HEBREW,             "HE" },
   { CP_ANSI_ARABIC,             "AR" },
   { CP_THAI,                    "TH" },
   { CP_ANSI_VIETNAMESE,         "VN" },
   { CP_JAPANESE,                "J" },
   { CP_ISO_JAPANESE,            "JIS" },
   { CP_EUC_JAPANESE,            "JEUC" },
   { CP_CHINESE_SIMPLIFIED,      "C" },
   { CP_HZ_CHINESE_SIMPLIFIED,   "HZ" },
   { CP_CHINESE_TRADITIONAL,     "T" },
   { CP_CHINESE_HKSCS,           "HK" },
   { CP_EUC_CHINESE_TRADITIONAL, "TEUC" },
   { CP_KOREAN,                  "K" },
   { CP_ISO_KOREAN,              "KISO" },
   { CP_KOREAN_JOHAB,            "KJ" },
   { CP_ISO_EUROPEAN,            "ISO-1" },
   { CP_ISO_CENTRAL_EUROPEAN,    "ISO-2" },
   { CP_ISO_TURKISH_OLD,         "ISO-3" },
   { CP_ISO_BALTIC,              "ISO-4" },
   { CP_ISO_CYRILLIC,            "ISO-5" },
   { CP_ISO_ARABIC,              "ISO-6" },
   { CP_ISO_GREEK,               "ISO-7" },
   { CP_ISO_HEBREW_VISUAL,       "ISO-8" },
   { CP_ISO_TURKISH,             "ISO-9" },
   { CP_ISO_NORDIC,              "ISO-10" },
   { CP_ISO_THAI,                "ISO-11" },
   { CP_ISO_BALTIC_EX,           "ISO-13" },
   { CP_ISO_CELTIC,              "ISO-14" },
   { CP_ISO_EUROPEAN_EX,         "ISO-15" },
   { CP_ISO_ROMANIAN,            "ISO-16" },
   { CP_ISO_HEBREW_VISUAL,       "ISO-8-V" },
   { CP_ISO_HEBREW_LOGICAL,      "ISO-8-L" },
   { CP_US_ASCII,                "ASCII" },
   { CP_CYRILLIC_KOI8R,          "KOI8-R" },
   { CP_CYRILLIC_KOI8U,          "KOI8-U" },
} ;

const int CODEPAGE_NAME_LIST_NELEM = NELEMOF ( CodePageNameList ) ;
#endif



////////////////////////////////////////
//          ꎯʎq̑I          //
////////////////////////////////////////



#ifdef RTFCONV_EXE

#define NAME(s)   L##s
#include "langid.h"

const LANGID_NAME LangIdNameList [] = {
   { MAKELANGID ( LANG_AFRIKAANS, SUBLANG_DEFAULT ), NAME ( "Afrikaans" ) },
   { MAKELANGID ( LANG_ALBANIAN, SUBLANG_DEFAULT ), NAME ( "Albanian" ) },
   { MAKELANGID ( LANG_ALSATIAN, SUBLANG_DEFAULT ), NAME ( "Alsatian" ) },
   { MAKELANGID ( LANG_AMHARIC, SUBLANG_DEFAULT ), NAME ( "Amharic" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_ALGERIA ), NAME ( "Arabic (Algeria)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_BAHRAIN ), NAME ( "Arabic (Bahrain)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_EGYPT ), NAME ( "Arabic (Egypt)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_IRAQ ), NAME ( "Arabic (Iraq)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_JORDAN ), NAME ( "Arabic (Jordan)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_KUWAIT ), NAME ( "Arabic (Kuwait)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_LEBANON ), NAME ( "Arabic (Lebanon)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_LIBYA ), NAME ( "Arabic (Libya)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_MOROCCO ), NAME ( "Arabic (Morocco)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_OMAN ), NAME ( "Arabic (Oman)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_QATAR ), NAME ( "Arabic (Qatar)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_SAUDI_ARABIA ), NAME ( "Arabic (Saudi Arabia)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_SYRIA ), NAME ( "Arabic (Syria)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_TUNISIA ), NAME ( "Arabic (Tunisia)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_UAE ), NAME ( "Arabic (U.A.E.)" ) },
   { MAKELANGID ( LANG_ARABIC, SUBLANG_ARABIC_YEMEN ), NAME ( "Arabic (Yemen)" ) },
   { MAKELANGID ( LANG_ARMENIAN, SUBLANG_DEFAULT ), NAME ( "Armenian" ) },
   { MAKELANGID ( LANG_ASSAMESE, SUBLANG_DEFAULT ), NAME ( "Assamese" ) },
   { MAKELANGID ( LANG_AZERI, SUBLANG_AZERI_CYRILLIC ), NAME ( "Azeri (Cyrillic)" ) },
   { MAKELANGID ( LANG_AZERI, SUBLANG_AZERI_LATIN ), NAME ( "Azeri (Latin)" ) },
   { MAKELANGID ( LANG_BASHKIR, SUBLANG_DEFAULT ), NAME ( "Bashkir" ) },
   { MAKELANGID ( LANG_BASQUE, SUBLANG_DEFAULT ), NAME ( "Basque" ) },
   { MAKELANGID ( LANG_BELARUSIAN, SUBLANG_DEFAULT ), NAME ( "Belarusian" ) },
   { MAKELANGID ( LANG_BENGALI, SUBLANG_BENGALI_BANGLADESH ), NAME ( "Bengali (Bangladesh)" ) },
   { MAKELANGID ( LANG_BENGALI, SUBLANG_DEFAULT ), NAME ( "Bengali (India)" ) },
   { MAKELANGID ( LANG_BOSNIAN, SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC ), NAME ( "Bosnian (Cyrillic)" ) },
   { MAKELANGID ( LANG_BOSNIAN, SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN ), NAME ( "Bosnian (Latin)" ) },
   { MAKELANGID ( LANG_BRETON, SUBLANG_DEFAULT ), NAME ( "Breton" ) },
   { MAKELANGID ( LANG_BULGARIAN, SUBLANG_DEFAULT ), NAME ( "Bulgarian" ) },
   { MAKELANGID ( LANG_BURMESE, SUBLANG_DEFAULT ), NAME ( "Burmese" ) },
   { MAKELANGID ( LANG_CATALAN, SUBLANG_DEFAULT ), NAME ( "Catalan" ) },
   { MAKELANGID ( LANG_CHEROKEE, SUBLANG_DEFAULT ), NAME ( "Cherokee" ) },
   { MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_HONGKONG ), NAME ( "Chinese (Hong Kong)" ) },
   { MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_MACAU ), NAME ( "Chinese (Macau)" ) },
   { MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_SIMPLIFIED ), NAME ( "Chinese (PRC)" ) },
   { MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_SINGAPORE ), NAME ( "Chinese (Singapore)" ) },
   { MAKELANGID ( LANG_CHINESE, SUBLANG_CHINESE_TRADITIONAL ), NAME ( "Chinese (Taiwan)" ) },
   { MAKELANGID ( LANG_CORSICAN, SUBLANG_DEFAULT ), NAME ( "Corsican" ) },
   { MAKELANGID ( LANG_CROATIAN, SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN ), NAME ( "Croatian (Bosnia-Herzegovina)" ) },
   { MAKELANGID ( LANG_CROATIAN, SUBLANG_DEFAULT ), NAME ( "Croatian (Croatia)" ) },
   { MAKELANGID ( LANG_CZECH, SUBLANG_DEFAULT ), NAME ( "Czech" ) },
   { MAKELANGID ( LANG_DANISH, SUBLANG_DEFAULT ), NAME ( "Danish" ) },
   { MAKELANGID ( LANG_DARI, SUBLANG_DEFAULT ), NAME ( "Dari" ) },
   { MAKELANGID ( LANG_DIVEHI, SUBLANG_DEFAULT ), NAME ( "Divehi" ) },
   { MAKELANGID ( LANG_DUTCH, SUBLANG_DUTCH ), NAME ( "Dutch (Netherlands)" ) },
   { MAKELANGID ( LANG_DUTCH, SUBLANG_DUTCH_BELGIAN ), NAME ( "Dutch (Belgium)" ) },
   { MAKELANGID ( LANG_EDO, SUBLANG_DEFAULT ), NAME ( "Edo" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_AUS ), NAME ( "English (Australian)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_BELIZE ), NAME ( "English (Belize)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_CAN ), NAME ( "English (Canadian)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_CARIBBEAN ), NAME ( "English (Caribbean)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_INDIA ), NAME ( "English (India)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_IRELAND ), NAME ( "English (Ireland)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_JAMAICA ), NAME ( "English (Jamaica)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_MALAYSIA ), NAME ( "English (Malaysia)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_NZ ), NAME ( "English (New Zealand)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_PHILIPPINES ), NAME ( "English (Philippines)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_SINGAPORE ), NAME ( "English (Singapore)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_SOUTH_AFRICA ), NAME ( "English (South Africa)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_TRINIDAD ), NAME ( "English (Trinidad)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_UK ), NAME ( "English (United Kingdom)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ), NAME ( "English (United States)" ) },
   { MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_ZIMBABWE ), NAME ( "English (Zimbabwe)" ) },
   { MAKELANGID ( LANG_ESTONIAN, SUBLANG_DEFAULT ), NAME ( "Estonian" ) },
   { MAKELANGID ( LANG_FAEROESE, SUBLANG_DEFAULT ), NAME ( "Faeroese" ) },
   { MAKELANGID ( LANG_FILIPINO, SUBLANG_DEFAULT ), NAME ( "Filipino, Tagalog" ) },
   { MAKELANGID ( LANG_FINNISH, SUBLANG_DEFAULT ), NAME ( "Finnish" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH ), NAME ( "French (France)" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH_BELGIAN ), NAME ( "French (Belgian)" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH_CANADIAN ), NAME ( "French (Canadian)" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH_LUXEMBOURG ), NAME ( "French (Luxembourg)" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH_MONACO ), NAME ( "French (Monaco)" ) },
   { MAKELANGID ( LANG_FRENCH, SUBLANG_FRENCH_SWISS ), NAME ( "French (Switzerland)" ) },
   { MAKELANGID ( LANG_FRISIAN, SUBLANG_DEFAULT ), NAME ( "Frisian" ) },
   { MAKELANGID ( LANG_FULFULDE, SUBLANG_DEFAULT ), NAME ( "Fulfulde" ) },
   { MAKELANGID ( LANG_GAELIC, SUBLANG_GAELIC_IRISH ), NAME ( "Gaelic (Irish)" ) },
   { MAKELANGID ( LANG_GAELIC, SUBLANG_GAELIC_SCOTTISH ), NAME ( "Gaelic (Scottish)" ) },
   { MAKELANGID ( LANG_GALICIAN, SUBLANG_DEFAULT ), NAME ( "Galician" ) },
   { MAKELANGID ( LANG_GEORGIAN, SUBLANG_DEFAULT ), NAME ( "Georgian" ) },
   { MAKELANGID ( LANG_GERMAN, SUBLANG_GERMAN ), NAME ( "German (Germany)" ) },
   { MAKELANGID ( LANG_GERMAN, SUBLANG_GERMAN_AUSTRIAN ), NAME ( "German (Austria)" ) },
   { MAKELANGID ( LANG_GERMAN, SUBLANG_GERMAN_LIECHTENSTEIN ), NAME ( "German (Liechtenstein)" ) },
   { MAKELANGID ( LANG_GERMAN, SUBLANG_GERMAN_LUXEMBOURG ), NAME ( "German (Luxembourg)" ) },
   { MAKELANGID ( LANG_GERMAN, SUBLANG_GERMAN_SWISS ), NAME ( "German (Switzerland)" ) },
   { MAKELANGID ( LANG_GREEK, SUBLANG_DEFAULT ), NAME ( "Greek" ) },
   { MAKELANGID ( LANG_GREENLANDIC, SUBLANG_DEFAULT ), NAME ( "Greenlandic" ) },
   { MAKELANGID ( LANG_GUARANI, SUBLANG_DEFAULT ), NAME ( "Guarani" ) },
   { MAKELANGID ( LANG_GUJARATI, SUBLANG_DEFAULT ), NAME ( "Gujarati" ) },
   { MAKELANGID ( LANG_HAUSA, SUBLANG_DEFAULT ), NAME ( "Hausa" ) },
   { MAKELANGID ( LANG_HAWAIIAN, SUBLANG_DEFAULT ), NAME ( "Hawaiian" ) },
   { MAKELANGID ( LANG_HEBREW, SUBLANG_DEFAULT ), NAME ( "Hebrew" ) },
   { MAKELANGID ( LANG_HINDI, SUBLANG_DEFAULT ), NAME ( "Hindi" ) },
   { MAKELANGID ( LANG_HUNGARIAN, SUBLANG_DEFAULT ), NAME ( "Hungarian" ) },
   { MAKELANGID ( LANG_IBIBIO, SUBLANG_DEFAULT ), NAME ( "Ibibio" ) },
   { MAKELANGID ( LANG_ICELANDIC, SUBLANG_DEFAULT ), NAME ( "Icelandic" ) },
   { MAKELANGID ( LANG_IGBO, SUBLANG_DEFAULT ), NAME ( "Igbo" ) },
   { MAKELANGID ( LANG_INDONESIAN, SUBLANG_DEFAULT ), NAME ( "Indonesian" ) },
   { MAKELANGID ( LANG_INUKTITUT, SUBLANG_DEFAULT ), NAME ( "Inuktitut (Canadian Aboriginal Syllabics)" ) },
   { MAKELANGID ( LANG_INUKTITUT, SUBLANG_INUKTITUT_CANADA_LATIN ), NAME ( "Inuktitut (Latin)" ) },
   { MAKELANGID ( LANG_ITALIAN, SUBLANG_ITALIAN ), NAME ( "Italian (Italy)" ) },
   { MAKELANGID ( LANG_ITALIAN, SUBLANG_ITALIAN_SWISS ), NAME ( "Italian (Switzerland)" ) },
   { MAKELANGID ( LANG_JAPANESE, SUBLANG_DEFAULT ), NAME ( "Japanese" ) },
   { MAKELANGID ( LANG_KANNADA, SUBLANG_DEFAULT ), NAME ( "Kannada" ) },
   { MAKELANGID ( LANG_KANURI, SUBLANG_DEFAULT ), NAME ( "Kanuri" ) },
   { MAKELANGID ( LANG_KASHMIRI, SUBLANG_DEFAULT ), NAME ( "Kashmiri (Pakistan)" ) },
   { MAKELANGID ( LANG_KASHMIRI, SUBLANG_KASHMIRI_INDIA ), NAME ( "Kashmiri (India)" ) },
   { MAKELANGID ( LANG_KASHMIRI, SUBLANG_KASHMIRI_SASIA ), NAME ( "Kashmiri (South Asia)" ) },
   { MAKELANGID ( LANG_KAZAK, SUBLANG_DEFAULT ), NAME ( "Kazak" ) },
   { MAKELANGID ( LANG_KHMER, SUBLANG_DEFAULT ), NAME ( "Khmer, Cambodian" ) },
   { MAKELANGID ( LANG_KICHE, SUBLANG_DEFAULT ), NAME ( "Kiche" ) },
   { MAKELANGID ( LANG_KINYARWANDA, SUBLANG_DEFAULT ), NAME ( "Kinyarwanda" ) },
   { MAKELANGID ( LANG_KONKANI, SUBLANG_DEFAULT ), NAME ( "Konkani" ) },
   { MAKELANGID ( LANG_KOREAN, SUBLANG_DEFAULT ), NAME ( "Korean" ) },
   { MAKELANGID ( LANG_KYRGYZ, SUBLANG_DEFAULT ), NAME ( "Kyrgyz" ) },
   { MAKELANGID ( LANG_LAO, SUBLANG_DEFAULT ), NAME ( "Lao" ) },
   { MAKELANGID ( LANG_LATIN, SUBLANG_DEFAULT ), NAME ( "Latin" ) },
   { MAKELANGID ( LANG_LATVIAN, SUBLANG_DEFAULT ), NAME ( "Latvian" ) },
   { MAKELANGID ( LANG_LITHUANIAN, SUBLANG_LITHUANIAN_CLASSIC ), NAME ( "Lithuanian (Classic)" ) },
   { MAKELANGID ( LANG_LITHUANIAN, SUBLANG_LITHUANIAN_LITHUANIA ), NAME ( "Lithuanian (Modern)" ) },
   { MAKELANGID ( LANG_LUXEMBOURGISH, SUBLANG_DEFAULT ), NAME ( "Luxembourgish" ) },
   { MAKELANGID ( LANG_MACEDONIAN, SUBLANG_DEFAULT ), NAME ( "Macedonian" ) },
   { MAKELANGID ( LANG_MALAGASY, SUBLANG_DEFAULT ), NAME ( "Malagasy" ) },
   { MAKELANGID ( LANG_MALAY, SUBLANG_MALAY_BRUNEI_DARUSSALAM ), NAME ( "Malay (Brunei Darussalam)" ) },
   { MAKELANGID ( LANG_MALAY, SUBLANG_MALAY_MALAYSIA ), NAME ( "Malay (Malaysian)" ) },
   { MAKELANGID ( LANG_MALAYALAM, SUBLANG_DEFAULT ), NAME ( "Malayalam" ) },
   { MAKELANGID ( LANG_MALTESE, SUBLANG_DEFAULT ), NAME ( "Maltese" ) },
   { MAKELANGID ( LANG_MANIPURI, SUBLANG_DEFAULT ), NAME ( "Manipuri" ) },
   { MAKELANGID ( LANG_MAORI, SUBLANG_DEFAULT ), NAME ( "Maori" ) },
   { MAKELANGID ( LANG_MAPUDUNGUN, SUBLANG_DEFAULT ), NAME ( "Mapudungun" ) },
   { MAKELANGID ( LANG_MARATHI, SUBLANG_DEFAULT ), NAME ( "Marathi" ) },
   { MAKELANGID ( LANG_MOHAWK, SUBLANG_DEFAULT ), NAME ( "Mohawk" ) },
   { MAKELANGID ( LANG_MONGOLIAN, SUBLANG_DEFAULT ), NAME ( "Mongolian (Cyrillic)" ) },
   { MAKELANGID ( LANG_MONGOLIAN, SUBLANG_MONGOLIAN_PRC ), NAME ( "Mongolian (PRC)" ) },
   { MAKELANGID ( LANG_NEPALI, SUBLANG_DEFAULT ), NAME ( "Nepali (Nepal)" ) },
   { MAKELANGID ( LANG_NEPALI, SUBLANG_NEPALI_INDIA ), NAME ( "Nepali (India)" ) },
   { MAKELANGID ( LANG_NORWEGIAN, SUBLANG_NORWEGIAN_BOKMAL ), NAME ( "Norwegian (Bokmal)" ) },
   { MAKELANGID ( LANG_NORWEGIAN, SUBLANG_NORWEGIAN_NYNORSK ), NAME ( "Norwegian (Nynorsk)" ) },
   { MAKELANGID ( LANG_OCCITAN, SUBLANG_DEFAULT ), NAME ( "Occitan" ) },
   { MAKELANGID ( LANG_ORIYA, SUBLANG_DEFAULT ), NAME ( "Oriya" ) },
   { MAKELANGID ( LANG_OROMO, SUBLANG_DEFAULT ), NAME ( "Oromo" ) },
   { MAKELANGID ( LANG_PAPIAMENTU, SUBLANG_DEFAULT ), NAME ( "Papiamentu" ) },
   { MAKELANGID ( LANG_PASHTO, SUBLANG_DEFAULT ), NAME ( "Pashto" ) },
   { MAKELANGID ( LANG_PERSIAN, SUBLANG_DEFAULT ), NAME ( "Persian, Farsi" ) },
   { MAKELANGID ( LANG_POLISH, SUBLANG_DEFAULT ), NAME ( "Polish" ) },
   { MAKELANGID ( LANG_PORTUGUESE, SUBLANG_PORTUGUESE_BRAZILIAN ), NAME ( "Portuguese (Brazil)" ) },
   { MAKELANGID ( LANG_PORTUGUESE, SUBLANG_PORTUGUESE_PORTUGAL ), NAME ( "Portuguese (Portugal)" ) },
   { MAKELANGID ( LANG_PUNJABI, SUBLANG_DEFAULT ), NAME ( "Punjabi" ) },
   { MAKELANGID ( LANG_QUECHUA, SUBLANG_QUECHUA_BOLIVIA ), NAME ( "Quechua (Bolivia)" ) },
   { MAKELANGID ( LANG_QUECHUA, SUBLANG_QUECHUA_ECUADOR ), NAME ( "Quechua (Ecuador)" ) },
   { MAKELANGID ( LANG_QUECHUA, SUBLANG_QUECHUA_PERU ), NAME ( "Quechua (Peru)" ) },
   { MAKELANGID ( LANG_ROMANIAN, SUBLANG_DEFAULT ), NAME ( "Romanian" ) },
   { MAKELANGID ( LANG_ROMANSH, SUBLANG_DEFAULT ), NAME ( "Romansh, Rhaeto-Romance" ) },
   { MAKELANGID ( LANG_RUSSIAN, SUBLANG_DEFAULT ), NAME ( "Russian" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_DEFAULT ), NAME ( "Sami (Lappish, Northern Norway)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_INARI_FINLAND ), NAME ( "Sami (Lappish, Inari Finland)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_LULE_NORWAY ), NAME ( "Sami (Lappish, Lule Norway)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_LULE_SWEDEN ), NAME ( "Sami (Lappish, Lule Sweden)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_NORTHERN_FINLAND ), NAME ( "Sami (Lappish, Northern Finland)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_NORTHERN_SWEDEN ), NAME ( "Sami (Lappish, Northern Sweden)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_SKOLT_FINLAND ), NAME ( "Sami (Lappish, Skolt Finland)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_SOUTHERN_NORWAY ), NAME ( "Sami (Lappish, Southern Norway)" ) },
   { MAKELANGID ( LANG_SAMI, SUBLANG_SAMI_SOUTHERN_SWEDEN ), NAME ( "Sami (Lappish, Southern Sweden)" ) },
   { MAKELANGID ( LANG_SANSKRIT, SUBLANG_DEFAULT ), NAME ( "Sanskrit" ) },
   { MAKELANGID ( LANG_SERBIAN, SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC ), NAME ( "Serbian (Cyrillic, Bosnia-Herzegovina)" ) },
   { MAKELANGID ( LANG_SERBIAN, SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN ), NAME ( "Serbian (Latin, Bosnia-Herzegovina)" ) },
   { MAKELANGID ( LANG_SERBIAN, SUBLANG_SERBIAN_CYRILLIC ), NAME ( "Serbian (Cyrillic)" ) },
   { MAKELANGID ( LANG_SERBIAN, SUBLANG_SERBIAN_LATIN ), NAME ( "Serbian (Latin)" ) },
   { MAKELANGID ( LANG_SINDHI, SUBLANG_SINDHI_AFGHANISTAN ), NAME ( "Sindhi (Afghanistan)" ) },
   { MAKELANGID ( LANG_SINDHI, SUBLANG_DEFAULT ), NAME ( "Sindhi (India)" ) },
   { MAKELANGID ( LANG_SINDHI, SUBLANG_SINDHI_PAKISTAN ), NAME ( "Sindhi (Pakistan)" ) },
   { MAKELANGID ( LANG_SINHALESE, SUBLANG_DEFAULT ), NAME ( "Sinhalese" ) },
   { MAKELANGID ( LANG_SLOVAK, SUBLANG_DEFAULT ), NAME ( "Slovak" ) },
   { MAKELANGID ( LANG_SLOVENIAN, SUBLANG_DEFAULT ), NAME ( "Slovenian" ) },
   { MAKELANGID ( LANG_SOMALI, SUBLANG_DEFAULT ), NAME ( "Somali" ) },
   { MAKELANGID ( LANG_SORBIAN, SUBLANG_LOWER_SORBIAN_GERMANY ), NAME ( "Sorbian (Lower)" ) },
   { MAKELANGID ( LANG_SORBIAN, SUBLANG_UPPER_SORBIAN_GERMANY ), NAME ( "Sorbian (Upper)" ) },
   { MAKELANGID ( LANG_SOTHO, SUBLANG_DEFAULT ), NAME ( "Sotho" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH ), NAME ( "Spanish (Spain, Traditional Sort)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_ARGENTINA ), NAME ( "Spanish (Argentina)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_BOLIVIA ), NAME ( "Spanish (Bolivia)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_CHILE ), NAME ( "Spanish (Chile)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_COLOMBIA ), NAME ( "Spanish (Colombia)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_COSTA_RICA ), NAME ( "Spanish (Costa Rica)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_DOMINICAN_REPUBLIC ), NAME ( "Spanish (Dominican Republic)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_ECUADOR ), NAME ( "Spanish (Ecuador)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_EL_SALVADOR ), NAME ( "Spanish (El Salvador)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_GUATEMALA ), NAME ( "Spanish (Guatemala)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_HONDURAS ), NAME ( "Spanish (Honduras)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_MEXICAN ), NAME ( "Spanish (Mexican)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_MODERN ), NAME ( "Spanish (Spain, Modern Sort)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_NICARAGUA ), NAME ( "Spanish (Nicaragua)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_PANAMA ), NAME ( "Spanish (Panama)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_PARAGUAY ), NAME ( "Spanish (Paraguay)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_PERU ), NAME ( "Spanish (Peru)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_PUERTO_RICO ), NAME ( "Spanish (Puerto Rico)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_URUGUAY ), NAME ( "Spanish (Uruguay)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_US ), NAME ( "Spanish (United States)" ) },
   { MAKELANGID ( LANG_SPANISH, SUBLANG_SPANISH_VENEZUELA ), NAME ( "Spanish (Venezuela)" ) },
   { MAKELANGID ( LANG_SUTU, SUBLANG_DEFAULT ), NAME ( "Sutu" ) },
   { MAKELANGID ( LANG_SWAHILI, SUBLANG_DEFAULT ), NAME ( "Swahili (Kenya)" ) },
   { MAKELANGID ( LANG_SWEDISH, SUBLANG_SWEDISH_FINLAND ), NAME ( "Swedish (Finland)" ) },
   { MAKELANGID ( LANG_SWEDISH, SUBLANG_SWEDISH_SWEDEN ), NAME ( "Swedish (Sweden)" ) },
   { MAKELANGID ( LANG_SYRIAC, SUBLANG_DEFAULT ), NAME ( "Syriac" ) },
   { MAKELANGID ( LANG_TAJIK, SUBLANG_DEFAULT ), NAME ( "Tajik" ) },
   { MAKELANGID ( LANG_TAMAZIGHT, SUBLANG_DEFAULT ), NAME ( "Tamazight" ) },
   { MAKELANGID ( LANG_TAMAZIGHT, SUBLANG_TAMAZIGHT_ALGERIA_LATIN ), NAME ( "Tamazight (Algeria Latin)" ) },
   { MAKELANGID ( LANG_TAMIL, SUBLANG_DEFAULT ), NAME ( "Tamil" ) },
   { MAKELANGID ( LANG_TATAR, SUBLANG_DEFAULT ), NAME ( "Tatar (Tatarstan)" ) },
   { MAKELANGID ( LANG_TELUGU, SUBLANG_DEFAULT ), NAME ( "Telugu" ) },
   { MAKELANGID ( LANG_THAI, SUBLANG_DEFAULT ), NAME ( "Thai" ) },
   { MAKELANGID ( LANG_TIBETAN, SUBLANG_DEFAULT ), NAME ( "Tibetan (Tibet)" ) },
   { MAKELANGID ( LANG_TIBETAN, SUBLANG_TIBETAN_BHUTAN ), NAME ( "Tibetan (Bhutan)" ) },
   { MAKELANGID ( LANG_TIGRIGNA, SUBLANG_DEFAULT ), NAME ( "Tigrigna" ) },
   { MAKELANGID ( LANG_TSONGA, SUBLANG_DEFAULT ), NAME ( "Tsonga" ) },
   { MAKELANGID ( LANG_TSWANA, SUBLANG_DEFAULT ), NAME ( "Tswana" ) },
   { MAKELANGID ( LANG_TURKISH, SUBLANG_DEFAULT ), NAME ( "Turkish" ) },
   { MAKELANGID ( LANG_TURKMEN, SUBLANG_DEFAULT ), NAME ( "Turkmen" ) },
   { MAKELANGID ( LANG_UIGHUR, SUBLANG_DEFAULT ), NAME ( "Uighur" ) },
   { MAKELANGID ( LANG_UKRAINIAN, SUBLANG_DEFAULT ), NAME ( "Ukrainian" ) },
   { MAKELANGID ( LANG_URDU, SUBLANG_URDU_INDIA ), NAME ( "Urdu (India)" ) },
   { MAKELANGID ( LANG_URDU, SUBLANG_URDU_PAKISTAN ), NAME ( "Urdu (Pakistan)" ) },
   { MAKELANGID ( LANG_UZBEK, SUBLANG_UZBEK_CYRILLIC ), NAME ( "Uzbek (Cyrillic)" ) },
   { MAKELANGID ( LANG_UZBEK, SUBLANG_UZBEK_LATIN ), NAME ( "Uzbek (Latin)" ) },
   { MAKELANGID ( LANG_VENDA, SUBLANG_DEFAULT ), NAME ( "Venda" ) },
   { MAKELANGID ( LANG_VIETNAMESE, SUBLANG_DEFAULT ), NAME ( "Vietnamese" ) },
   { MAKELANGID ( LANG_WELSH, SUBLANG_DEFAULT ), NAME ( "Welsh" ) },
   { MAKELANGID ( LANG_WOLOF, SUBLANG_DEFAULT ), NAME ( "Wolof" ) },
   { MAKELANGID ( LANG_XHOSA, SUBLANG_DEFAULT ), NAME ( "Xhosa" ) },
   { MAKELANGID ( LANG_YAKUT, SUBLANG_DEFAULT ), NAME ( "Yakut" ) },
   { MAKELANGID ( LANG_YI, SUBLANG_DEFAULT ), NAME ( "Yi" ) },
   { MAKELANGID ( LANG_YIDDISH, SUBLANG_DEFAULT ), NAME ( "Yiddish" ) },
   { MAKELANGID ( LANG_YORUBA, SUBLANG_DEFAULT ), NAME ( "Yoruba" ) },
   { MAKELANGID ( LANG_ZULU, SUBLANG_DEFAULT ), NAME ( "Zulu" ) },
} ;

const int LANGID_NAME_LIST_NELEM = NELEMOF ( LangIdNameList ) ;
#endif



////////////////////////////////////////
//          IvV̉          //
////////////////////////////////////////



// IvV̉
unsigned long TranslateConversionMode ( int nSrcCodePage, int nDstCodePage ) {

   unsigned long dwConversionMode = 0 ;

   if ( IsNoVariant ) dwConversionMode |= CONVMODE_NO_VARIANT_EUROPEAN | CONVMODE_NO_VARIANT_KANJI ;
   if ( IsNoHanKana ) dwConversionMode |= CONVMODE_NO_HANKANA ;
   if ( IsNoZenAlpha ) dwConversionMode |= CONVMODE_NO_ZENALPHA ;
   if ( IsNoZenSpace ) dwConversionMode |= CONVMODE_NO_ZENSPACE ;
   if ( IsNoZenSymbol ) dwConversionMode |= CONVMODE_NO_ZENSYMBOL ;
   if ( IsYenNoBackslash ) dwConversionMode |= CONVMODE_YEN_NO_BACKSLASH ;
   if ( IsInputNumberHtml ) dwConversionMode |= CONVMODE_INPUT_CODE_NUMBER_HTML ;
   if ( IsInputNumberC ) dwConversionMode |= CONVMODE_INPUT_CODE_NUMBER_C ;
   if ( IsConvertPua ) dwConversionMode |= CONVMODE_CONVERT_PUA ;
   if ( IsUseArray ) dwConversionMode |= CONVMODE_USE_DLL_TABLE ;
   if ( IsNotUseArray ) dwConversionMode |= CONVMODE_USE_SYSTEM_TABLE ;
   if ( IsUseSameFont ) dwConversionMode |= CONVMODE_USE_LOCAL_FONT ;
   if ( IsEucOutputHojo ) dwConversionMode |= CONVMODE_EUC_HOJO ;
   if ( IsGbOutput < 1 ) dwConversionMode |= CONVMODE_NO_GBK ;
   if ( IsGbOutput > 1 ) dwConversionMode |= CONVMODE_OUTPUT_GB18030 ;
   if ( ! IsOutputCR && ! IsOutputLF ) IsOutputCR = IsOutputLF = 1 ;
   if ( IsOutputCR ) dwConversionMode |= CONVMODE_OUTPUT_CR ;
   if ( IsOutputLF ) dwConversionMode |= CONVMODE_OUTPUT_LF ;
   if ( IsOutputRuby ) dwConversionMode |= CONVMODE_OUTPUT_RUBY ;
   if ( IsOutputLink ) dwConversionMode |= CONVMODE_OUTPUT_LINK ;
   if ( IsOutputHidden ) dwConversionMode |= CONVMODE_OUTPUT_HIDDEN ;
   if ( IsEndianAuto ) dwConversionMode |= CONVMODE_ENDIAN_AUTO ;

   if ( IsNoByteOrderMark ) {
      if ( nDstCodePage == CP_UTF16 || nDstCodePage == CP_UTF16_BE ) dwConversionMode |= CONVMODE_NO_OUTPUT_BOM ;
      if ( nDstCodePage == CP_UTF32 || nDstCodePage == CP_UTF32_BE ) dwConversionMode |= CONVMODE_NO_OUTPUT_BOM ;
   }

   if ( IsUtf8ByteOrderMark && nDstCodePage == CP_UTF8 ) dwConversionMode |= CONVMODE_UTF8_WITH_BOM ;
   if ( IsOutputNumberSurrogate ) dwConversionMode |= CONVMODE_OUTPUT_NUMBER_SURROGATE ;
   if ( IsDeleteEof ) dwConversionMode |= CONVMODE_DELETE_EOF ;

#ifdef RTFCONV_COM
   if ( IsNoVariantEuropean ) dwConversionMode |= CONVMODE_NO_VARIANT_EUROPEAN ;
   if ( IsNoVariantKanji ) dwConversionMode |= CONVMODE_NO_VARIANT_KANJI ;
   if ( IsOutputNumber ) dwConversionMode |= CONVMODE_OUTPUT_CODE_NUMBER ;
   if ( IsOutputNumberHtml ) dwConversionMode |= CONVMODE_OUTPUT_CODE_NUMBER_HTML ;
   if ( IsOneQuestionMark ) dwConversionMode |= CONVMODE_OUTPUT_CODE_NUMBER ;
   if ( IsVariantOnlyRoundTrip ) dwConversionMode |= CONVMODE_VARIANT_ONLY_ROUNDTRIP ;
   if ( IsOutputNumberMsc ) dwConversionMode |= ( CONVMODE_OUTPUT_CODE_NUMBER | CONVMODE_OUTPUT_NUMBER_SURROGATE ) ;
#endif

   return dwConversionMode ;
}



// gIvV̉
unsigned long TranslateAdditionalMode ( int nSrcCodePage, int nDstCodePage ) {

   unsigned long dwAdditionalMode = 0 ;

   if ( IsInputJisNoVendor ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_INPUT_NO_VENDOR ;
   if ( IsOutputJisNoVendor ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_OUTPUT_NO_VENDOR ;
   if ( IsInputJisMac ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_INPUT_MAC ;
   if ( IsOutputJisMac ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_OUTPUT_MAC ;
   if ( IsInputJis2004 ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_INPUT_2004 ;
   if ( IsOutputJis2004 ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_OUTPUT_2004 ;
   if ( IsNoJis83New ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_NO_JIS83_NEW_STYLE ;
   if ( IsNoJis83Old ) dwAdditionalMode |= ADDITIONAL_MODE_JIS_NO_JIS83_NEW_STYLE ;
   if ( IsOverlineNoTilde ) dwAdditionalMode |= ADDITIONAL_MODE_OVERLINE_NO_TILDE ;
   if ( IsPua2Hkscs ) dwAdditionalMode |= ADDITIONAL_MODE_PUA_TO_HKSCS ;
   if ( IsHkscsCjka2Pua ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_CJKA_TO_PUA ;
   if ( IsHkscsCjkb2Pua ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_CJKB_TO_PUA ;
   if ( IsHkscsCjk412Pua ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_CJK41_TO_PUA ;
   if ( IsGbk2Pua ) dwAdditionalMode |= ADDITIONAL_MODE_GBK_TO_LINSHIDAIMA ;
   if ( IsPua2Gbk ) dwAdditionalMode |= ADDITIONAL_MODE_LINSHIDAIMA_TO_GBK ;
   if ( IsGbkOutputFantizi ) dwAdditionalMode |= ADDITIONAL_MODE_GBK_OUTPUT_FANTIZI ;
   if ( IsKsNoUhc ) dwAdditionalMode |= ADDITIONAL_MODE_KS_NO_UHC ;
   if ( IsConvKsPunc ) dwAdditionalMode |= ADDITIONAL_MODE_KS_PUNC ;
   if ( IsRtfFontXp ) dwAdditionalMode |= ADDITIONAL_MODE_RTFFONT_XP ;
   if ( IsRtfFontVista ) dwAdditionalMode |= ADDITIONAL_MODE_RTFFONT_VISTA ;
   if ( IsOutputHkscs1999 ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_1999 ;
   if ( IsOutputHkscs2001 ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_2001 ;
   if ( IsOutputHkscs2004 ) dwAdditionalMode |= ADDITIONAL_MODE_HKSCS_2004 ;

   return dwAdditionalMode ;
}



