// shortcut.cpp

#include <windows.h>
#include <shlobj.h>
#include <intshcut.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "msc.h"
#include "filename.h"
#include "shortcut.h"
#include "stringex.h"



// for IsLnkOrUrl
#define IS_LINK_UNKNOWN       0
#define IS_LINK_FILESYSTEM    1
#define IS_LINK_URL           2


// IMalloc
#define ShAlloc   CoTaskMemAlloc
#define ShFree    CoTaskMemFree


// gq
#define szExtensionLnkA     ".lnk"
#define szExtensionLnkW    L".lnk"
#define szExtensionPifA     ".pif"
#define szExtensionPifW    L".pif"
#define szExtensionUrlA     ".url"
#define szExtensionUrlW    L".url"



// zbgL[̎w
// ʃoCgɓL[R[h HOTKEYF_ALT Ȃ j
// ʃoCgɉzL[R[h VK_UP Ȃǁj



/////////////////////////////////////////////
//      V[gJbg̍쐬iANSIŁj     //
/////////////////////////////////////////////



static int GetSavedShortcurPathA ( IPersistFile *pIPersistFile, char *szPath ) ;



// V[gJbg쐬iANSIŁj
// ̂ŏ̂QȊO NULL ł
// t@C͑΃pXł
// V[gJbg̊gq .lnk/.pif/.url ͗Lǂ
//  0 As 0 ȊOԂ
int WINAPI CreateShortcutA ( const char *szShortcutPathA,
                             const char *szDestinationPath,
                             const char *szArguments,
                             const char *szDirectory,
                             const char *szDescription,
                             const char *szIconPath,
                             int  nIconIndex,
                             int  nShowCommand,
                             unsigned short wHotKey,
                             LPCITEMIDLIST pItemIdList,
                             char *szSavedShortcutPath ) {

   // 
   if ( ! szShortcutPathA ) return 1 ;
   if ( ! szDestinationPath && ! pItemIdList ) return 1 ;


   int nResult = 1 ;
   char *szTmp1 = NULL, *szTmp2 = NULL, *szTmp3 = NULL ;
   wchar_t *szShortcutPathW = NULL ;


   if ( 1 ) {

      // gq𐄑
      int IsLnkOrUrl = IS_LINK_FILESYSTEM ;
      if ( ! pItemIdList && IsFileNameUrlA ( szDestinationPath ) ) IsLnkOrUrl = IS_LINK_URL ;

      const char *szExtPreferable ; // hbgt
      if ( IsLnkOrUrl == IS_LINK_URL ) szExtPreferable = szExtensionUrlA ;
      else {
         const char *szExtension = GetExtensionA ( szDestinationPath ) ;
         if ( szExtension && ! stricmp ( szExtension, "com" ) ) szExtPreferable = szExtensionPifA ;
         else                                                   szExtPreferable = szExtensionLnkA ;
      }

      // gq
      const char *szExtension = GetExtensionA ( szShortcutPathA ) ;
      if ( ! ( szExtension && ! stricmp ( szExtension, szExtPreferable + 1 ) ) ) {
         if ( ! ( szTmp1 = (char*) malloc ( ( strlen ( szShortcutPathA ) + strlen ( szExtPreferable ) + 1 ) * sizeof(char) ) ) ) { nResult = 3 ; goto CAUGHT_ERROR ; }
         strcpy ( szTmp1, szShortcutPathA ) ;
         strcat ( szTmp1, szExtPreferable ) ;
         szShortcutPathA = szTmp1 ;
      }

      // t@C݂̑
      unsigned long dwFileAttributes = GetFileAttributesA ( szShortcutPathA ) ;
      if ( dwFileAttributes != INVALID_FILE_ATTRIBUTES ) {
         if ( dwFileAttributes & FILE_ATTRIBUTE_READONLY ) { nResult = 2 ; goto CAUGHT_ERROR ; }
         if ( ! DeleteFileA ( szShortcutPathA ) ) { nResult = 2 ; goto CAUGHT_ERROR ; }
      }

      // t@CtpX
      if ( ! IsFullPathNameA ( szShortcutPathA ) ) {
         szShortcutPathA = szTmp2 = GetFullPathNameAllocA ( szShortcutPathA ) ;
         if ( ! szTmp2 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }

      // NtpX
      if ( IsLnkOrUrl == IS_LINK_FILESYSTEM && ! pItemIdList && ! IsFullPathNameA ( szDestinationPath ) ) {
         szDestinationPath = szTmp3 = GetFullPathNameAllocA ( szDestinationPath ) ;
         if ( ! szTmp3 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }

      // t@CCh
      szShortcutPathW = a2wdup ( szShortcutPathA ) ;
      if ( ! szShortcutPathW ) { nResult = 3 ; goto CAUGHT_ERROR ; }


      // URL ̏ꍇ
      if ( IsLnkOrUrl == IS_LINK_URL ) {

         IUniformResourceLocatorA *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_InternetShortcut, NULL, CLSCTX_INPROC_SERVER, IID_IUniformResourceLocatorA, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  pIShellLink->SetURL ( szDestinationPath, 0 ) ;
                  if ( SUCCEEDED ( pIPersistFile->Save ( szShortcutPathW, TRUE ) ) ) {
                     nResult = 0 ;
                     if ( szSavedShortcutPath ) GetSavedShortcurPathA ( pIPersistFile, szSavedShortcutPath ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }
      // t@C̏ꍇ
      else {

         IShellLinkA *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkA, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( pItemIdList ) pIShellLink->SetIDList ( pItemIdList ) ;
                  else               pIShellLink->SetPath ( szDestinationPath ) ;
                  if ( szArguments ) pIShellLink->SetArguments ( szArguments ) ;
                  if ( szDirectory ) pIShellLink->SetWorkingDirectory ( szDirectory ) ;
                  if ( szDescription ) pIShellLink->SetDescription ( szDescription ) ;
                  if ( szIconPath ) pIShellLink->SetIconLocation ( szIconPath, nIconIndex ) ;
                  if ( nShowCommand ) pIShellLink->SetShowCmd ( nShowCommand ) ;
                  if ( wHotKey ) pIShellLink->SetHotkey ( wHotKey ) ;
                  if ( SUCCEEDED ( pIPersistFile->Save ( szShortcutPathW, TRUE ) ) ) {
                     nResult = 0 ;
                     if ( szSavedShortcutPath ) GetSavedShortcurPathA ( pIPersistFile, szSavedShortcutPath ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }

   }

   CAUGHT_ERROR :

   free ( szTmp1 ) ;
   free ( szTmp2 ) ;
   free ( szTmp3 ) ;
   free ( szShortcutPathW ) ;

   return nResult ;
}



static int GetSavedShortcurPathA ( IPersistFile *pIPersistFile, char *szPath ) {
   wchar_t *pTmp ;
   if ( SUCCEEDED ( pIPersistFile->GetCurFile ( & pTmp ) ) ) {
      WideCharToMultiByte ( CP_ACP, 0, pTmp, -1, szPath, MAX_PATH, NULL, NULL ) ;
      ShFree ( pTmp ) ;
      return 0 ;
   }
   return 1 ;
}



/////////////////////////////////////////////
//      V[gJbg̎擾iANSIŁj     //
/////////////////////////////////////////////



static int GetUrlDestinationPathA ( IUniformResourceLocatorA *pIShellLink, char *szPath ) ;
static int GetMsiShortcutA ( const char *szShortcutPath, char *szDestinationPath, char *szProductCode, char *szFeatureId, char *szComponentCode ) ;



// V[gJbg̓e擾iANSIŁj
// ̂ szShortcutPathA ȊO NULL ł
// V[gJbg̊gq .lnk/.pif/.url ͗Lǂ
//  0 As 0 ȊOԂ
int WINAPI GetShortcutA ( const char *szShortcutPathA,
                          char *szDestinationPath,
                          char *szArguments,
                          char *szDirectory,
                          char *szDescription,
                          char *szIconPath,
                          int  *pnIconIndex,
                          int  *pnShowCommand,
                          unsigned short *pwHotKey,
                          LPITEMIDLIST *ppItemIdList,
                          char *szSavedShortcutPath ) {

   // 
   if ( ! szShortcutPathA ) return 1 ;


   int nResult = 1 ;
   char *szTmp1 = NULL, *szTmp2 = NULL ;
   wchar_t *szShortcutPathW = NULL ;


   if ( 1 ) {

      // t@C݌
      int IsLnkOrUrl = IS_LINK_UNKNOWN ;
      const char *szExtension = GetExtensionA ( szShortcutPathA ) ;
      if ( szExtension && GetFileAttributesA ( szShortcutPathA ) != INVALID_FILE_ATTRIBUTES ) {
         if ( ! stricmp ( szExtension, szExtensionLnkA + 1 ) ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         if ( ! stricmp ( szExtension, szExtensionPifA + 1 ) ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         if ( ! stricmp ( szExtension, szExtensionUrlA + 1 ) ) IsLnkOrUrl = IS_LINK_URL ;
      }
      if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
         if ( ! ( szTmp1 = (char*) malloc ( ( strlen ( szShortcutPathA ) + 0x10 ) * sizeof(char) ) ) ) { nResult = 3 ; goto CAUGHT_ERROR ; }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            strcpy ( szTmp1, szShortcutPathA ) ;
            strcat ( szTmp1, szExtensionLnkA ) ;
            if ( GetFileAttributesA ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            strcpy ( szTmp1, szShortcutPathA ) ;
            strcat ( szTmp1, szExtensionPifA ) ;
            if ( GetFileAttributesA ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            strcpy ( szTmp1, szShortcutPathA ) ;
            strcat ( szTmp1, szExtensionUrlA ) ;
            if ( GetFileAttributesA ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_URL ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) { nResult = 2 ; goto CAUGHT_ERROR ; }
         szShortcutPathA = szTmp1 ;
      }


      // t@CtpX
      if ( ! IsFullPathNameA ( szShortcutPathA ) ) {
         szShortcutPathA = szTmp2 = GetFullPathNameAllocA ( szShortcutPathA ) ;
         if ( ! szTmp2 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }

      // t@CCh
      szShortcutPathW = a2wdup ( szShortcutPathA ) ;
      if ( ! szShortcutPathW ) { nResult = 3 ; goto CAUGHT_ERROR ; }


      // URL ̏ꍇ
      if ( IsLnkOrUrl == IS_LINK_URL ) {

         IUniformResourceLocatorA *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_InternetShortcut, NULL, CLSCTX_INPROC_SERVER, IID_IUniformResourceLocatorA, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( SUCCEEDED ( pIPersistFile->Load ( szShortcutPathW, STGM_READ ) ) ) {
                     nResult = 0 ;
                     if ( szDestinationPath ) GetUrlDestinationPathA ( pIShellLink, szDestinationPath ) ;
                     if ( szArguments ) *szArguments = 0 ;
                     if ( szDirectory ) *szDirectory = 0 ;
                     if ( szDescription ) *szDescription = 0 ;
                     if ( szIconPath ) *szIconPath = 0 ;
                     if ( pnShowCommand ) *pnShowCommand = 0 ;
                     if ( pwHotKey ) *pwHotKey = 0 ;
                     if ( ppItemIdList ) *ppItemIdList = NULL ;
                     if ( szSavedShortcutPath ) strcpy ( szSavedShortcutPath, szShortcutPathA ) ;
                  }
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }
      // t@C̏ꍇ
      else {

         IShellLinkA *pIShellLink ;
         IPersistFile *pIPersistFile ;
         WIN32_FIND_DATAA fData ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkA, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( SUCCEEDED ( pIPersistFile->Load ( szShortcutPathW, STGM_READ ) ) ) {
                     nResult = 0 ;
                     int nIconIndexTmp = 0 ;
                     if ( szDestinationPath ) pIShellLink->GetPath ( szDestinationPath, MAX_PATH, & fData, SLGP_UNCPRIORITY ) ;
                     if ( szArguments ) pIShellLink->GetArguments ( szArguments, MAX_PATH ) ;
                     if ( szDirectory ) pIShellLink->GetWorkingDirectory ( szDirectory, MAX_PATH ) ;
                     if ( szDescription ) pIShellLink->GetDescription ( szDescription, MAX_PATH ) ;
                     if ( szIconPath ) pIShellLink->GetIconLocation ( szIconPath, MAX_PATH, & nIconIndexTmp ) ;
                     if ( pnIconIndex ) *pnIconIndex = nIconIndexTmp ;
                     if ( pnShowCommand ) pIShellLink->GetShowCmd ( pnShowCommand ) ;
                     if ( pwHotKey ) pIShellLink->GetHotkey ( pwHotKey ) ;
                     if ( ppItemIdList ) pIShellLink->GetIDList ( ppItemIdList ) ;
                     if ( szSavedShortcutPath ) strcpy ( szSavedShortcutPath, szShortcutPathA ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }

         if ( szDestinationPath ) {
            char szDstTmp [ MAX_PATH ] ;
            if ( ! GetMsiShortcutA ( szShortcutPathA, szDstTmp, NULL, NULL, NULL ) ) strcpy ( szDestinationPath, szDstTmp ) ;
         }
      }
   }

   CAUGHT_ERROR :

   free ( szTmp1 ) ;
   free ( szTmp2 ) ;
   free ( szShortcutPathW ) ;

   return nResult ;
}



static int GetUrlDestinationPathA ( IUniformResourceLocatorA *pIShellLink, char *szPath ) {
   char *pTmp ;
   if ( SUCCEEDED ( pIShellLink->GetURL ( & pTmp ) ) ) {
      strcpy ( szPath, pTmp ) ;
      ShFree ( pTmp ) ;
      return 0 ;
   }
   return 1 ;
}



/////////////////////////////////////////////
//    V[gJbg̍쐬iUNICODEŁj    //
/////////////////////////////////////////////



static int GetSavedShortcurPathW ( IPersistFile *pIPersistFile, wchar_t *szPath ) ;



// V[gJbg쐬iUNICODEŁj
// ̂ŏ̂QȊO NULL ł
// t@C͑΃pXł
// V[gJbg̊gq .lnk/.pif/.url ͗Lǂ
//  0 As 0 ȊOԂ
int WINAPI CreateShortcutW ( const wchar_t *szShortcutPathW,
                             const wchar_t *szDestinationPath,
                             const wchar_t *szArguments,
                             const wchar_t *szDirectory,
                             const wchar_t *szDescription,
                             const wchar_t *szIconPath,
                             int  nIconIndex,
                             int  nShowCommand,
                             unsigned short wHotKey,
                             LPCITEMIDLIST pItemIdList,
                             wchar_t *szSavedShortcutPath ) {

   // 
   if ( ! szShortcutPathW ) return 1 ;
   if ( ! szDestinationPath && ! pItemIdList ) return 1 ;


   int nResult = 1 ;
   wchar_t *szTmp1 = NULL, *szTmp2 = NULL, *szTmp3 = NULL ;


   if ( 1 ) {

      // gq𐄑
      int IsLnkOrUrl = IS_LINK_FILESYSTEM ;
      if ( ! pItemIdList && IsFileNameUrlW ( szDestinationPath ) ) IsLnkOrUrl = IS_LINK_URL ;

      const wchar_t *szExtPreferable ; // hbgt
      if ( IsLnkOrUrl == IS_LINK_URL ) szExtPreferable = szExtensionUrlW ;
      else {
         const wchar_t *szExtension = GetExtensionW ( szDestinationPath ) ;
         if ( szExtension && ! wcsicmp ( szExtension, L"com" ) ) szExtPreferable = szExtensionPifW ;
         else                                                    szExtPreferable = szExtensionLnkW ;
      }

      // gq
      const wchar_t *szExtension = GetExtensionW ( szShortcutPathW ) ;
      if ( ! ( szExtension && ! wcsicmp ( szExtension, szExtPreferable + 1 ) ) ) {
         if ( ! ( szTmp1 = (wchar_t*) malloc ( ( wcslen ( szShortcutPathW ) + wcslen ( szExtPreferable ) + 1 ) * sizeof(wchar_t) ) ) ) { nResult = 3 ; goto CAUGHT_ERROR ; }
         wcscpy ( szTmp1, szShortcutPathW ) ;
         wcscat ( szTmp1, szExtPreferable ) ;
         szShortcutPathW = szTmp1 ;
      }

      // t@C݂̑
      unsigned long dwFileAttributes = GetFileAttributesW ( szShortcutPathW ) ;
      if ( dwFileAttributes != INVALID_FILE_ATTRIBUTES ) {
         if ( dwFileAttributes & FILE_ATTRIBUTE_READONLY ) { nResult = 2 ; goto CAUGHT_ERROR ; }
         if ( ! DeleteFileW ( szShortcutPathW ) ) { nResult = 2 ; goto CAUGHT_ERROR ; }
      }

      // t@CtpX
      if ( ! IsFullPathNameW ( szShortcutPathW ) ) {
         szShortcutPathW = szTmp2 = GetFullPathNameAllocW ( szShortcutPathW ) ;
         if ( ! szTmp2 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }

      // NtpX
      if ( IsLnkOrUrl == IS_LINK_FILESYSTEM && ! pItemIdList && ! IsFullPathNameW ( szDestinationPath ) ) {
         szDestinationPath = szTmp3 = GetFullPathNameAllocW ( szDestinationPath ) ;
         if ( ! szTmp3 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }


      // URL ̏ꍇ
      if ( IsLnkOrUrl == IS_LINK_URL ) {

         IUniformResourceLocatorW *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_InternetShortcut, NULL, CLSCTX_INPROC_SERVER, IID_IUniformResourceLocatorW, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  pIShellLink->SetURL ( szDestinationPath, 0 ) ;
                  if ( SUCCEEDED ( pIPersistFile->Save ( szShortcutPathW, TRUE ) ) ) {
                     nResult = 0 ;
                     if ( szSavedShortcutPath ) GetSavedShortcurPathW ( pIPersistFile, szSavedShortcutPath ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }
      // t@C̏ꍇ
      else {

         IShellLinkW *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkW, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( pItemIdList ) pIShellLink->SetIDList ( pItemIdList ) ;
                  else               pIShellLink->SetPath ( szDestinationPath ) ;
                  if ( szArguments ) pIShellLink->SetArguments ( szArguments ) ;
                  if ( szDirectory ) pIShellLink->SetWorkingDirectory ( szDirectory ) ;
                  if ( szDescription ) pIShellLink->SetDescription ( szDescription ) ;
                  if ( szIconPath ) pIShellLink->SetIconLocation ( szIconPath, nIconIndex ) ;
                  if ( nShowCommand ) pIShellLink->SetShowCmd ( nShowCommand ) ;
                  if ( wHotKey ) pIShellLink->SetHotkey ( wHotKey ) ;
                  if ( SUCCEEDED ( pIPersistFile->Save ( szShortcutPathW, TRUE ) ) ) {
                     nResult = 0 ;
                     if ( szSavedShortcutPath ) GetSavedShortcurPathW ( pIPersistFile, szSavedShortcutPath ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }

   }

   CAUGHT_ERROR :

   free ( szTmp1 ) ;
   free ( szTmp2 ) ;
   free ( szTmp3 ) ;

   return nResult ;
}



static int GetSavedShortcurPathW ( IPersistFile *pIPersistFile, wchar_t *szPath ) {
   wchar_t *pTmp ;
   if ( SUCCEEDED ( pIPersistFile->GetCurFile ( & pTmp ) ) ) {
      wcscpy ( szPath, pTmp ) ;
      ShFree ( pTmp ) ;
      return 0 ;
   }
   return 1 ;
}



/////////////////////////////////////////////
//    V[gJbg̎擾iUNICODEŁj    //
/////////////////////////////////////////////



static int GetUrlDestinationPathW ( IUniformResourceLocatorW *pIShellLink, wchar_t *szPath ) ;
static int GetMsiShortcutW ( const wchar_t *szShortcutPath, wchar_t *szDestinationPath, wchar_t *szProductCode, wchar_t *szFeatureId, wchar_t *szComponentCode ) ;



// V[gJbg̓e擾iUNICODEŁj
// ̂ szShortcutPathW ȊO NULL ł
// V[gJbg̊gq .lnk/.pif/.url ͗Lǂ
//  0 As 0 ȊOԂ
int WINAPI GetShortcutW ( const wchar_t *szShortcutPathW,
                          wchar_t *szDestinationPath,
                          wchar_t *szArguments,
                          wchar_t *szDirectory,
                          wchar_t *szDescription,
                          wchar_t *szIconPath,
                          int  *pnIconIndex,
                          int  *pnShowCommand,
                          unsigned short *pwHotKey,
                          LPITEMIDLIST *ppItemIdList,
                          wchar_t *szSavedShortcutPath ) {

   // 
   if ( ! szShortcutPathW ) return 1 ;


   int nResult = 1 ;
   wchar_t *szTmp1 = NULL, *szTmp2 = NULL ;


   if ( 1 ) {

      // t@C݌
      int IsLnkOrUrl = IS_LINK_UNKNOWN ;
      const wchar_t *szExtension = GetExtensionW ( szShortcutPathW ) ;
      if ( szExtension && GetFileAttributesW ( szShortcutPathW ) != INVALID_FILE_ATTRIBUTES ) {
         if ( ! wcsicmp ( szExtension, szExtensionLnkW + 1 ) ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         if ( ! wcsicmp ( szExtension, szExtensionPifW + 1 ) ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         if ( ! wcsicmp ( szExtension, szExtensionUrlW + 1 ) ) IsLnkOrUrl = IS_LINK_URL ;
      }
      if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
         if ( ! ( szTmp1 = (wchar_t*) malloc ( ( wcslen ( szShortcutPathW ) + 0x10 ) * sizeof(wchar_t) ) ) ) { nResult = 3 ; goto CAUGHT_ERROR ; }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            wcscpy ( szTmp1, szShortcutPathW ) ;
            wcscat ( szTmp1, szExtensionLnkW ) ;
            if ( GetFileAttributesW ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            wcscpy ( szTmp1, szShortcutPathW ) ;
            wcscat ( szTmp1, szExtensionPifW ) ;
            if ( GetFileAttributesW ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_FILESYSTEM ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) {
            wcscpy ( szTmp1, szShortcutPathW ) ;
            wcscat ( szTmp1, szExtensionUrlW ) ;
            if ( GetFileAttributesW ( szTmp1 ) != INVALID_FILE_ATTRIBUTES ) IsLnkOrUrl = IS_LINK_URL ;
         }
         if ( IsLnkOrUrl == IS_LINK_UNKNOWN ) { nResult = 2 ; goto CAUGHT_ERROR ; }
         szShortcutPathW = szTmp1 ;
      }


      // t@CtpX
      if ( ! IsFullPathNameW ( szShortcutPathW ) ) {
         szShortcutPathW = szTmp2 = GetFullPathNameAllocW ( szShortcutPathW ) ;
         if ( ! szTmp2 ) { nResult = 3 ; goto CAUGHT_ERROR ; }
      }


      // URL ̏ꍇ
      if ( IsLnkOrUrl == IS_LINK_URL ) {

         IUniformResourceLocatorW *pIShellLink ;
         IPersistFile *pIPersistFile ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_InternetShortcut, NULL, CLSCTX_INPROC_SERVER, IID_IUniformResourceLocatorW, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( SUCCEEDED ( pIPersistFile->Load ( szShortcutPathW, STGM_READ ) ) ) {
                     nResult = 0 ;
                     if ( szDestinationPath ) GetUrlDestinationPathW ( pIShellLink, szDestinationPath ) ;
                     if ( szArguments ) *szArguments = 0 ;
                     if ( szDirectory ) *szDirectory = 0 ;
                     if ( szDescription ) *szDescription = 0 ;
                     if ( szIconPath ) *szIconPath = 0 ;
                     if ( pnShowCommand ) *pnShowCommand = 0 ;
                     if ( pwHotKey ) *pwHotKey = 0 ;
                     if ( ppItemIdList ) *ppItemIdList = NULL ;
                     if ( szSavedShortcutPath ) wcscpy ( szSavedShortcutPath, szShortcutPathW ) ;
                  }
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }
      }
      // t@C̏ꍇ
      else {

         IShellLinkW *pIShellLink ;
         IPersistFile *pIPersistFile ;
         WIN32_FIND_DATAW fData ;

         if ( SUCCEEDED ( CoInitialize ( NULL ) ) ) {
            if ( SUCCEEDED ( CoCreateInstance ( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkW, (void**) & pIShellLink ) ) ) {
               if ( SUCCEEDED ( pIShellLink->QueryInterface ( IID_IPersistFile, (void**) & pIPersistFile ) ) ) {
                  if ( SUCCEEDED ( pIPersistFile->Load ( szShortcutPathW, STGM_READ ) ) ) {
                     nResult = 0 ;
                     int nIconIndexTmp = 0 ;
                     if ( szDestinationPath ) pIShellLink->GetPath ( szDestinationPath, MAX_PATH, & fData, SLGP_UNCPRIORITY ) ;
                     if ( szArguments ) pIShellLink->GetArguments ( szArguments, MAX_PATH ) ;
                     if ( szDirectory ) pIShellLink->GetWorkingDirectory ( szDirectory, MAX_PATH ) ;
                     if ( szDescription ) pIShellLink->GetDescription ( szDescription, MAX_PATH ) ;
                     if ( szIconPath ) pIShellLink->GetIconLocation ( szIconPath, MAX_PATH, & nIconIndexTmp ) ;
                     if ( pnIconIndex ) *pnIconIndex = nIconIndexTmp ;
                     if ( pnShowCommand ) pIShellLink->GetShowCmd ( pnShowCommand ) ;
                     if ( pwHotKey ) pIShellLink->GetHotkey ( pwHotKey ) ;
                     if ( ppItemIdList ) pIShellLink->GetIDList ( ppItemIdList ) ;
                     if ( szSavedShortcutPath ) wcscpy ( szSavedShortcutPath, szShortcutPathW ) ;
                  }
                  pIPersistFile->Release () ;
               }
               pIShellLink->Release () ;
            }
            CoUninitialize () ;
         }

         if ( szDestinationPath ) {
            wchar_t szDstTmp [ MAX_PATH ] ;
            if ( ! GetMsiShortcutW ( szShortcutPathW, szDstTmp, NULL, NULL, NULL ) ) wcscpy ( szDestinationPath, szDstTmp ) ;
         }
      }
   }

   CAUGHT_ERROR :

   free ( szTmp1 ) ;
   free ( szTmp2 ) ;

   return nResult ;
}



static int GetUrlDestinationPathW ( IUniformResourceLocatorW *pIShellLink, wchar_t *szPath ) {
   wchar_t *pTmp ;
   if ( SUCCEEDED ( pIShellLink->GetURL ( & pTmp ) ) ) {
      wcscpy ( szPath, pTmp ) ;
      ShFree ( pTmp ) ;
      return 0 ;
   }
   return 1 ;
}



////////////////////////////////////
//              MSI               //
////////////////////////////////////



#define MsiGetShortcutTargetA MsiGetShortcutTargetA_
#define MsiGetShortcutTargetW MsiGetShortcutTargetW_
#define MsiGetComponentPathA MsiGetComponentPathA_
#define MsiGetComponentPathW MsiGetComponentPathW_
typedef UINT ( WINAPI *MSIGETSHORTCUTTARGETA ) ( LPCSTR szShortcutPath, LPSTR szProductCode, LPSTR szFeatureId, LPSTR szComponentCode ) ;
typedef UINT ( WINAPI *MSIGETSHORTCUTTARGETW ) ( LPCWSTR szShortcutPath, LPWSTR szProductCode, LPWSTR szFeatureId, LPWSTR szComponentCode ) ;
typedef INT ( WINAPI *MSIGETCOMPONENTPATHA ) ( LPCSTR szProduct, LPCSTR szComponent, LPSTR lpPathBuf, DWORD *pcchBuf ) ;
typedef INT ( WINAPI *MSIGETCOMPONENTPATHW ) ( LPCWSTR szProduct, LPCWSTR szComponent, LPWSTR lpPathBuf, DWORD *pcchBuf ) ;
static HINSTANCE hMsi ;
static int FreeLibraryOnDetach ( void ) ;


#define INSTALLSTATE_LOCAL 3
#define MAX_FEATURE_CHARS  38



// MSIō쐬ꂽV[gJbg擾iANSIŁj
// szShortcutPath ȊO NULL ł
// szProductCode, szFeatureId, szComponentCode ̃TCY MAX_FEATURE_CHARS + 1 ȏ
//  0 As 0 ȊOԂ
static int GetMsiShortcutA ( const char *szShortcutPath, char *szDestinationPath, char *szProductCode, char *szFeatureId, char *szComponentCode ) {

   static MSIGETSHORTCUTTARGETA MsiGetShortcutTargetA ;
   static MSIGETCOMPONENTPATHA MsiGetComponentPathA ;

   static volatile int IsDllErrorSaved = -1 ;

   if ( IsDllErrorSaved < 0 ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( IsDllErrorSaved < 0 ) {
#endif
            int IsDllError = 0 ;

            if ( ! hMsi && ( hMsi = LoadLibraryA ( "MSI.DLL" ) ) ) FreeLibraryOnDetach () ;
            if ( GETPROCADDRESS ( hMsi, MSIGETSHORTCUTTARGETA, MsiGetShortcutTargetA ) ) IsDllError = 1 ;
            if ( GETPROCADDRESS ( hMsi, MSIGETCOMPONENTPATHA, MsiGetComponentPathA ) ) IsDllError = 1 ;

            IsDllErrorSaved = IsDllError ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( IsDllErrorSaved ) return 1 ;


   char szProductCodeTmp [ MAX_FEATURE_CHARS + 1 ] ;
   char szComponentCodeTmp [ MAX_FEATURE_CHARS + 1 ] ;

   if ( szDestinationPath ) *szDestinationPath = 0 ;
   if ( szProductCode ) *szProductCode = 0 ;
   if ( szFeatureId ) *szFeatureId = 0 ;
   if ( szComponentCode ) *szComponentCode = 0 ;

   if ( MsiGetShortcutTargetA ( szShortcutPath, szProductCodeTmp, szFeatureId, szComponentCodeTmp ) ) return 2 ;

   unsigned long nLength = MAX_PATH ;
   if ( MsiGetComponentPathA ( szProductCodeTmp, szComponentCodeTmp, szDestinationPath, & nLength ) != INSTALLSTATE_LOCAL ) return 3 ;

   if ( szProductCode ) strcpy ( szProductCode, szProductCodeTmp ) ;
   if ( szComponentCode ) strcpy ( szComponentCode, szComponentCodeTmp ) ;

   return 0 ;
}



// MSIō쐬ꂽV[gJbg擾iUNICODEŁj
// szShortcutPath ȊO NULL ł
// szProductCode, szFeatureId, szComponentCode ̃TCY MAX_FEATURE_CHARS + 1 ȏ
//  0 As 0 ȊOԂ
static int GetMsiShortcutW ( const wchar_t *szShortcutPath, wchar_t *szDestinationPath, wchar_t *szProductCode, wchar_t *szFeatureId, wchar_t *szComponentCode ) {

   static MSIGETSHORTCUTTARGETW MsiGetShortcutTargetW ;
   static MSIGETCOMPONENTPATHW MsiGetComponentPathW ;

   static volatile int IsDllErrorSaved = -1 ;

   if ( IsDllErrorSaved < 0 ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( IsDllErrorSaved < 0 ) {
#endif
            int IsDllError = 0 ;

            if ( ! hMsi && ( hMsi = LoadLibraryW ( L"MSI.DLL" ) ) ) FreeLibraryOnDetach () ;
            if ( GETPROCADDRESS ( hMsi, MSIGETSHORTCUTTARGETW, MsiGetShortcutTargetW ) ) IsDllError = 1 ;
            if ( GETPROCADDRESS ( hMsi, MSIGETCOMPONENTPATHW, MsiGetComponentPathW ) ) IsDllError = 1 ;

            IsDllErrorSaved = IsDllError ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( IsDllErrorSaved ) return 1 ;


   wchar_t szProductCodeTmp [ MAX_FEATURE_CHARS + 1 ] ;
   wchar_t szComponentCodeTmp [ MAX_FEATURE_CHARS + 1 ] ;

   if ( szDestinationPath ) *szDestinationPath = 0 ;
   if ( szProductCode ) *szProductCode = 0 ;
   if ( szFeatureId ) *szFeatureId = 0 ;
   if ( szComponentCode ) *szComponentCode = 0 ;

   if ( MsiGetShortcutTargetW ( szShortcutPath, szProductCodeTmp, szFeatureId, szComponentCodeTmp ) ) return 2 ;

   unsigned long nLength = MAX_PATH ;
   if ( MsiGetComponentPathW ( szProductCodeTmp, szComponentCodeTmp, szDestinationPath, & nLength ) != INSTALLSTATE_LOCAL ) return 3 ;

   if ( szProductCode ) wcscpy ( szProductCode, szProductCodeTmp ) ;
   if ( szComponentCode ) wcscpy ( szComponentCode, szComponentCodeTmp ) ;

   return 0 ;
}



static void __cdecl ExitProc ( void ) {
   if ( hMsi ) FreeLibrary ( hMsi ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



