// shortcut.h

#ifndef SHORTCUT_H
#define SHORTCUT_H


#ifdef __cplusplus
extern "C" {
#endif


int WINAPI CreateShortcutA ( const char *szShortcutPath,
                             const char *szDestinationPath,
                             const char *szArguments,
                             const char *szDirectory,
                             const char *szDescription,
                             const char *szIconPath,
                             int  nIconIndex,
                             int  nShowCommand,
                             unsigned short wHotKey,
                             LPCITEMIDLIST pItemIdList,
                             char *szSavedShortcutPath
) ;

int WINAPI GetShortcutA ( const char *szShortcutPath,
                          char *szDestinationPath,
                          char *szArguments,
                          char *szDirectory,
                          char *szDescription,
                          char *szIconPath,
                          int  *pnIconIndex,
                          int  *pnShowCommand,
                          unsigned short *pwHotKey,
                          LPITEMIDLIST *ppItemIdList,
                          char *szSavedShortcutPath
) ;

int WINAPI CreateShortcutW ( const wchar_t *szShortcutPath,
                             const wchar_t *szDestinationPath,
                             const wchar_t *szArguments,
                             const wchar_t *szDirectory,
                             const wchar_t *szDescription,
                             const wchar_t *szIconPath,
                             int  nIconIndex,
                             int  nShowCommand,
                             unsigned short wHotKey,
                             LPCITEMIDLIST pItemIdList,
                             wchar_t *szSavedShortcutPath
) ;

int WINAPI GetShortcutW ( const wchar_t *szShortcutPath,
                          wchar_t *szDestinationPath,
                          wchar_t *szArguments,
                          wchar_t *szDirectory,
                          wchar_t *szDescription,
                          wchar_t *szIconPath,
                          int  *pnIconIndex,
                          int  *pnShowCommand,
                          unsigned short *pwHotKey,
                          LPITEMIDLIST *ppItemIdList,
                          wchar_t *szSavedShortcutPath
) ;


#ifdef UNICODE
#define CreateShortcut CreateShortcutW
#define GetShortcut GetShortcutW
#else
#define CreateShortcut CreateShortcutA
#define GetShortcut GetShortcutA
#endif


#ifdef __cplusplus
}
#endif

#endif


