// stringex.cpp

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <mbctype.h>
#include <limits.h>
#include <errno.h>
#include "msc.h"

#undef DEBUG_CONST_STRING
#include "stringex.h"



////////////////////////////////////////////
//               strend ()                //
////////////////////////////////////////////



// ̏I[ԂiUTF32Łj
wchar32_t *wcsend32 ( const wchar32_t *string ) {

   while ( *string ) string ++ ;

   return (wchar32_t*) string ;
}



////////////////////////////////////////////
//               strcpy ()                //
////////////////////////////////////////////



// Rs[iUTF32Łj
wchar32_t *wcscpy32 ( wchar32_t *dst, const wchar32_t *src ) {

   wchar32_t *p = dst ;
   while ( *p ++ = *src ++ ) ;

   return dst ;
}



////////////////////////////////////////////
//               strcat ()                //
////////////////////////////////////////////



// AiUTF32Łj
wchar32_t *wcscat32 ( wchar32_t *dst, const wchar32_t *src ) {

   wchar32_t *p = dst ;
   while ( *p ) p ++ ;
   while ( *p ++ = *src ++ ) ;

   return dst ;
}



////////////////////////////////////////////
//               strlcpy ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕRs[iUTF16Łj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t wcslcpylen16 ( wchar16_t *dst, const wchar16_t *src, size_t srclen, size_t bufsiz ) {

   if ( srclen == (size_t) -1 ) srclen = wcslen16 ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(wchar16_t) ) ;
      wcstrunc16 ( dst, cpylen ) ;
   }

   return srclen ;
}



// w肳ꂽ܂ŕRs[iUTF32Łj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t wcslcpylen32 ( wchar32_t *dst, const wchar32_t *src, size_t srclen, size_t bufsiz ) {

   if ( srclen == (size_t) -1 ) srclen = wcslen32 ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(wchar32_t) ) ;
      dst [ cpylen ] = 0 ;
   }

   return srclen ;
}



// w肳ꂽ܂ŕRs[iMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t mbslcpylen ( char *dst, const char *src, size_t srclen, size_t bufsiz ) {

   if ( srclen == (size_t) -1 ) srclen = strlen ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(char) ) ;
      mbstrunc ( dst, cpylen ) ;
   }

   return srclen ;
}



////////////////////////////////////////////
//               strlcat ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕAiANSIŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t strlcat ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;
   size_t dstlen = strlen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(char) ) ;
      ( dst + dstlen ) [ cpylen ] = 0 ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t wcslcat ( wchar_t *dst, const wchar_t *src, size_t bufsiz ) {

   size_t srclen = wcslen ( src ) ;
   size_t dstlen = wcslen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(wchar_t) ) ;
      ( dst + dstlen ) [ cpylen ] = 0 ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiUTF16Łj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t wcslcat16 ( wchar16_t *dst, const wchar16_t *src, size_t bufsiz ) {

   size_t srclen = wcslen16 ( src ) ;
   size_t dstlen = wcslen16 ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(wchar16_t) ) ;
      wcstrunc16 ( dst, dstlen + cpylen ) ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiUTF32Łj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t wcslcat32 ( wchar32_t *dst, const wchar32_t *src, size_t bufsiz ) {

   size_t srclen = wcslen32 ( src ) ;
   size_t dstlen = wcslen32 ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(wchar32_t) ) ;
      ( dst + dstlen ) [ cpylen ] = 0 ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t mbslcat ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;
   size_t dstlen = strlen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(char) ) ;
      mbstrunc ( dst, dstlen + cpylen ) ;
   }

   return srclen + dstlen ;
}



////////////////////////////////////////////
//               strmove ()               //
////////////////////////////////////////////



// Rs[iANSIŁj
// src  dst ̗̈悪dȂĂĂ
char *strmove ( char *dst, const char *src ) {
   return (char*) memmove ( dst, src, ( strlen ( src ) + 1 ) * sizeof(char) ) ;
}



// Rs[iUNICODEŁj
// src  dst ̗̈悪dȂĂĂ
wchar_t *wcsmove ( wchar_t *dst, const wchar_t *src ) {
   return (wchar_t*) memmove ( dst, src, ( wcslen ( src ) + 1 ) * sizeof(wchar_t) ) ;
}



// Rs[iUTF32Łj
// src  dst ̗̈悪dȂĂĂ
wchar32_t *wcsmove32 ( wchar32_t *dst, const wchar32_t *src ) {
   return (wchar32_t*) memmove ( dst, src, ( wcslen32 ( src ) + 1 ) * sizeof(wchar32_t) ) ;
}



////////////////////////////////////////////
//              strinsert ()              //
////////////////////////////////////////////



// }iANSIŁj
// }̖̃AhXԂ
char *strinsert ( char *dst, const char *src ) {

   size_t srclen = strlen ( src ) ;

   memmove ( dst + srclen, dst, ( strlen ( dst ) + 1 ) * sizeof(char) ) ;
   memmove ( dst, src, srclen * sizeof(char) ) ;

   return dst + srclen ;
}



// }iUNICODEŁj
// }̖̃AhXԂ
wchar_t *wcsinsert ( wchar_t *dst, const wchar_t *src ) {

   size_t srclen = wcslen ( src ) ;

   memmove ( dst + srclen, dst, ( wcslen ( dst ) + 1 ) * sizeof(wchar_t) ) ;
   memmove ( dst, src, srclen * sizeof(wchar_t) ) ;

   return dst + srclen ;
}



// }iUTF32Łj
// }̖̃AhXԂ
wchar32_t *wcsinsert32 ( wchar32_t *dst, const wchar32_t *src ) {

   size_t srclen = wcslen32 ( src ) ;

   memmove ( dst + srclen, dst, ( wcslen32 ( dst ) + 1 ) * sizeof(wchar32_t) ) ;
   memmove ( dst, src, srclen * sizeof(wchar32_t) ) ;

   return dst + srclen ;
}



////////////////////////////////////////////
//              strreplace ()             //
////////////////////////////////////////////



// uiANSIŁj
// max ɂ͒uső吔܂ SIZE_MAX w肷
// pnext ɂ͍Ōɒu̒̈ʒuۑiNULLłj
// us񐔂Ԃ
size_t strreplace ( char *string, const char *pattern, const char *replace, char **pnext, size_t max ) {

   size_t count = 0 ;

   size_t patlen = strlen ( pattern ) ;
   size_t replen = strlen ( replace ) ;

   while ( ++ count <= max ) {

      char *p = strstr ( string, pattern ) ;
      if ( ! p ) break ;

      if ( replen != patlen ) memmove ( p + replen, p + patlen, ( strlen ( p + patlen ) + 1 ) * sizeof(char) ) ;
      memmove ( p, replace, replen * sizeof(char) ) ;
      string = p + replen ;
   }

   if ( pnext ) *pnext = string ;

   return count - 1 ;
}



// uiUNICODEŁj
// max ɂ͒uső吔܂ SIZE_MAX w肷
// pnext ɂ͍Ōɒu̒̈ʒuۑiNULLłj
// us񐔂Ԃ
size_t wcsreplace ( wchar_t *string, const wchar_t *pattern, const wchar_t *replace, wchar_t **pnext, size_t max ) {

   size_t count = 0 ;

   size_t patlen = wcslen ( pattern ) ;
   size_t replen = wcslen ( replace ) ;

   while ( ++ count <= max ) {

      wchar_t *p = wcsstr ( string, pattern ) ;
      if ( ! p ) break ;

      if ( replen != patlen ) memmove ( p + replen, p + patlen, ( wcslen ( p + patlen ) + 1 ) * sizeof(wchar_t) ) ;
      memmove ( p, replace, replen * sizeof(wchar_t) ) ;
      string = p + replen ;
   }

   if ( pnext ) *pnext = string ;

   return count - 1 ;
}



// uiUTF32Łj
// max ɂ͒uső吔܂ SIZE_MAX w肷
// pnext ɂ͍Ōɒu̒̈ʒuۑiNULLłj
// us񐔂Ԃ
size_t wcsreplace32 ( wchar32_t *string, const wchar32_t *pattern, const wchar32_t *replace, wchar32_t **pnext, size_t max ) {

   size_t count = 0 ;

   size_t patlen = wcslen32 ( pattern ) ;
   size_t replen = wcslen32 ( replace ) ;

   while ( ++ count <= max ) {

      wchar32_t *p = wcsstr32 ( string, pattern ) ;
      if ( ! p ) break ;

      if ( replen != patlen ) memmove ( p + replen, p + patlen, ( wcslen32 ( p + patlen ) + 1 ) * sizeof(wchar32_t) ) ;
      memmove ( p, replace, replen * sizeof(wchar32_t) ) ;
      string = p + replen ;
   }

   if ( pnext ) *pnext = string ;

   return count - 1 ;
}



// uiMULTIBYTEŁj
// max ɂ͒uső吔܂ SIZE_MAX w肷
// pnext ɂ͍Ōɒu̒̈ʒuۑiNULLłj
// us񐔂Ԃ
size_t mbsreplace ( char *string, const char *pattern, const char *replace, char **pnext, size_t max ) {

   size_t count = 0 ;

   size_t patlen = strlen ( pattern ) ;
   size_t replen = strlen ( replace ) ;

   while ( ++ count <= max ) {

      char *p = mbsstr ( string, pattern ) ;
      if ( ! p ) break ;

      if ( replen != patlen ) memmove ( p + replen, p + patlen, ( strlen ( p + patlen ) + 1 ) * sizeof(char) ) ;
      memmove ( p, replace, replen * sizeof(char) ) ;
      string = p + replen ;
   }

   if ( pnext ) *pnext = string ;

   return count - 1 ;
}



////////////////////////////////////////////
//               strlset ()               //
////////////////////////////////////////////



// obt@𕶎Ŗ߂iANSIŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
char *strlset ( char *dst, int c, size_t bufsiz ) {

   char *start = dst ;
   char *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = (char) c ;
      *dst = 0 ;
   }

   return start ;
}



// obt@𕶎Ŗ߂iUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
wchar_t *wcslset ( wchar_t *dst, int c, size_t bufsiz ) {

   wchar_t *start = dst ;
   wchar_t *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = (wchar_t) c ;
      *dst = 0 ;
   }

   return start ;
}



// obt@𕶎Ŗ߂iUTF32Łj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
wchar32_t *wcslset32 ( wchar32_t *dst, int c, size_t bufsiz ) {

   wchar32_t *start = dst ;
   wchar32_t *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = (wchar32_t) c ;
      *dst = 0 ;
   }

   return start ;
}



// obt@𕶎Ŗ߂iMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
char *mbslset ( char *dst, int c, size_t bufsiz ) {

   char *start = dst ;
   char *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      if ( c < 0x100 ) {
         while ( dst < end ) *dst ++ = (char) c ;
         *dst = 0 ;
      }
      else {
         while ( dst < end - 1 ) {
            *dst ++ = (unsigned char) ( c >> 8 ) ;
            *dst ++ = (unsigned char) c ;
         }
         *dst = 0 ;
      }
   }

   return start ;
}



////////////////////////////////////////////
//               strcmp ()                //
////////////////////////////////////////////



// riANSIŁj
int strncmp_i ( const char *string1, const char *string2, size_t count, int isignore ) {

   int c1, c2 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      c1 = (unsigned char) *string1 ;
      c2 = (unsigned char) *string2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// riUNICODEŁj
int wcsncmp_i ( const wchar_t *string1, const wchar_t *string2, size_t count, int isignore ) {

   int c1, c2 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      c1 = *string1 ;
      c2 = *string2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// riUTF32Łj
int wcsncmp32_i ( const wchar32_t *string1, const wchar32_t *string2, size_t count, int isignore ) {

   int c1, c2 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      c1 = *string1 ;
      c2 = *string2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// riMULTIBYTEŁj
int mbsncmp_i ( const char *string1, const char *string2, size_t count, int isignore ) {

   int c1, c2 ;
   int isprevlead1 = 0, isprevlead2 = 0 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      c1 = (unsigned char) *string1 ;
      if ( isprevlead1 ) isprevlead1 = 0 ;
      else {
         if ( ismbblead ( c1 ) ) isprevlead1 = 1 ;
         else if ( isignore )    c1 = tolower ( c1 ) ;
      }

      c2 = (unsigned char) *string2 ;
      if ( isprevlead2 ) isprevlead2 = 0 ;
      else {
         if ( ismbblead ( c2 ) ) isprevlead2 = 1 ;
         else if ( isignore )    c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//               strrcmp ()               //
////////////////////////////////////////////



// 𖖔riANSIŁj
int strrncmp_i ( const char *string1, const char *string2, size_t count, int isignore ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      if ( current1 < string1 ) c1 = 0 ;
      else                      c1 = (unsigned char) *current1 ;

      if ( current2 < string2 ) c2 = 0 ;
      else                      c2 = (unsigned char) *current2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      current1 -- ;
      current2 -- ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// 𖖔riUNICODEŁj
int wcsrncmp_i ( const wchar_t *string1, const wchar_t *string2, size_t count, int isignore ) {

   int c1, c2 ;

   const wchar_t *current1 = wcsend ( string1 ) - 1 ;
   const wchar_t *current2 = wcsend ( string2 ) - 1 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      if ( current1 < string1 ) c1 = 0 ;
      else                      c1 = *current1 ;

      if ( current2 < string2 ) c2 = 0 ;
      else                      c2 = *current2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      current1 -- ;
      current2 -- ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// 𖖔riUTF32Łj
int wcsrncmp32_i ( const wchar32_t *string1, const wchar32_t *string2, size_t count, int isignore ) {

   int c1, c2 ;

   const wchar32_t *current1 = wcsend32 ( string1 ) - 1 ;
   const wchar32_t *current2 = wcsend32 ( string2 ) - 1 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      if ( current1 < string1 ) c1 = 0 ;
      else                      c1 = *current1 ;

      if ( current2 < string2 ) c2 = 0 ;
      else                      c2 = *current2 ;

      if ( isignore ) {
         c1 = tolower ( c1 ) ;
         c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      current1 -- ;
      current2 -- ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



// 𖖔riMULTIBYTEŁj
int mbsrncmp_i ( const char *string1, const char *string2, size_t count, int isignore ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      if ( current1 < string1 ) c1 = 0 ;
      else {
         c1 = (unsigned char) *current1 ;
         if ( ismbstrail ( string1, current1 ) ) c1 += 0x100 ;
         else if ( isignore )                    c1 = tolower ( c1 ) ;
      }

      if ( current2 < string2 ) c2 = 0 ;
      else {
         c2 = (unsigned char) *current2 ;
         if ( ismbstrail ( string2, current2 ) ) c2 += 0x100 ;
         else if ( isignore )                    c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      current1 -- ;
      current2 -- ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//              strheadcmp ()             //
////////////////////////////////////////////



// ̐擪riANSIŁj
int strheadcmp_i ( const char *string1, const char *string2, int isignore ) {
   return strncmp_i ( string1, string2, strlen ( string2 ), isignore ) ;
}



// ̐擪riUNICODEŁj
int wcsheadcmp_i ( const wchar_t *string1, const wchar_t *string2, int isignore ) {
   return wcsncmp_i ( string1, string2, wcslen ( string2 ), isignore ) ;
}



// ̐擪riUTF32Łj
int wcsheadcmp32_i ( const wchar32_t *string1, const wchar32_t *string2, int isignore ) {
   return wcsncmp32_i ( string1, string2, wcslen32 ( string2 ), isignore ) ;
}



// ̐擪riMULTIBYTEŁj
int mbsheadcmp_i ( const char *string1, const char *string2, int isignore ) {
   return mbsncmp_i ( string1, string2, strlen ( string2 ), isignore ) ;
}



////////////////////////////////////////////
//              strtailcmp ()             //
////////////////////////////////////////////



// ̖riANSIŁj
int strtailcmp_i ( const char *string1, const char *string2, int isignore ) {
   return strrncmp_i ( string1, string2, strlen ( string2 ), isignore ) ;
}



// ̖riUNICODEŁj
int wcstailcmp_i ( const wchar_t *string1, const wchar_t *string2, int isignore ) {
   return wcsrncmp_i ( string1, string2, wcslen ( string2 ), isignore ) ;
}



// ̖riUTF32Łj
int wcstailcmp32_i ( const wchar32_t *string1, const wchar32_t *string2, int isignore ) {
   return wcsrncmp32_i ( string1, string2, wcslen32 ( string2 ), isignore ) ;
}



// ̖riMULTIBYTEŁj
int mbstailcmp_i ( const char *string1, const char *string2, int isignore ) {
   return mbsrncmp_i ( string1, string2, strlen ( string2 ), isignore ) ;
}



////////////////////////////////////////////
//               strstr ()                //
////////////////////////////////////////////



// 񂩂當iANSIŁj
char *strstr_i_r ( const char *string, const char *pattern, int isignore, int islast ) {

   const char *result = NULL ;

   size_t patlen = strlen ( pattern ) ;
   if ( ! patlen ) return (char*) string ;

   const char *tail = string + strlen ( string ) - patlen ;

   int c2 = (unsigned char) *pattern ;
   if ( isignore ) c2 = tolower ( c2 ) ;

   while ( string <= tail ) {

      int c1 = (unsigned char) *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c1 == c2 && ! strncmp_i ( string, pattern, patlen, isignore ) ) {
         result = string ;
         if ( ! islast ) break ;
      }

      string ++ ;
   }

   return (char*) result ;
}



// 񂩂當iUNICODEŁj
wchar_t *wcsstr_i_r ( const wchar_t *string, const wchar_t *pattern, int isignore, int islast ) {

   const wchar_t *result = NULL ;

   size_t patlen = wcslen ( pattern ) ;
   if ( ! patlen ) return (wchar_t*) string ;

   const wchar_t *tail = string + wcslen ( string ) - patlen ;

   int c2 = *pattern ;
   if ( isignore ) c2 = tolower ( c2 ) ;

   while ( string <= tail ) {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c1 == c2 && ! wcsncmp_i ( string, pattern, patlen, isignore ) ) {
         result = string ;
         if ( ! islast ) break ;
      }

      string ++ ;
   }

   return (wchar_t*) result ;
}



// 񂩂當iUTF32Łj
wchar32_t *wcsstr32_i_r ( const wchar32_t *string, const wchar32_t *pattern, int isignore, int islast ) {

   const wchar32_t *result = NULL ;

   size_t patlen = wcslen32 ( pattern ) ;
   if ( ! patlen ) return (wchar32_t*) string ;

   const wchar32_t *tail = string + wcslen32 ( string ) - patlen ;

   int c2 = *pattern ;
   if ( isignore ) c2 = tolower ( c2 ) ;

   while ( string <= tail ) {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c1 == c2 && ! wcsncmp32_i ( string, pattern, patlen, isignore ) ) {
         result = string ;
         if ( ! islast ) break ;
      }

      string ++ ;
   }

   return (wchar32_t*) result ;
}



// 񂩂當iMULTIBYTEŁj
char *mbsstr_i_r ( const char *string, const char *pattern, int isignore, int islast ) {

   const char *result = NULL ;

   size_t patlen = strlen ( pattern ) ;
   if ( ! patlen ) return (char*) string ;

   const char *tail = string + strlen ( string ) - patlen ;

   int c2 = *pattern ;
   if ( isignore ) c2 = tolower ( c2 ) ;

   while ( string <= tail ) {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c1 == c2 && ! mbsncmp_i ( string, pattern, patlen, isignore ) ) {
         result = string ;
         if ( ! islast ) break ;
      }

      if ( ismbblead ( (unsigned char) *string ) && *( string + 1 ) ) string ++ ;
      string ++ ;
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               strchr ()                //
////////////////////////////////////////////



// 񂩂當iANSIŁj
char *strchr_i_r ( const char *string, int c, int isignore, int islast ) {

   const char *result = NULL ;

   if ( isignore ) c = tolower ( c ) ;

   do {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c == c1 ) {
         result = string ;
         if ( ! islast ) break ;
      }

   } while ( *string ++ ) ;

   return (char*) result ;
}



// 񂩂當iUNICODEŁj
wchar_t *wcschr_i_r ( const wchar_t *string, int c, int isignore, int islast ) {

   const wchar_t *result = NULL ;

   if ( isignore ) c = tolower ( c ) ;

   do {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c == c1 ) {
         result = string ;
         if ( ! islast ) break ;
      }

   } while ( *string ++ ) ;

   return (wchar_t*) result ;
}



// 񂩂當iUTF16Łj
// c ̓TQ[głXJ[lł
wchar16_t *wcschr16_i_r ( const wchar16_t *string, int c, int isignore, int islast ) {

   const wchar16_t *result = NULL ;

   if ( (unsigned) c >> 16 && ! IsUnicodeHighSurrogate ( (unsigned) c >> 16 ) ) {
      if ( (unsigned) c > UTF16_MAX ) return NULL ;
      c = MAKE_UNICODE_SURROGATE ( c ) ;
   }

   if ( isignore ) c = tolower ( c ) ;

   do {

      if ( IsUnicodeHighSurrogate ( *string ) ) {

         if ( *( string + 1 ) ) {
            if ( c == ( *string << 16 ) + *( string + 1 ) ) {
               result = string ;
               if ( ! islast ) break ;
            }
            string ++ ;
         }
      }
      else {

         int c1 = *string ;
         if ( isignore ) c1 = tolower ( c1 ) ;

         if ( c == c1 ) {
            result = string ;
            if ( ! islast ) break ;
         }
      }

   } while ( *string ++ ) ;

   return (wchar16_t*) result ;
}



// 񂩂當iUTF32Łj
wchar32_t *wcschr32_i_r ( const wchar32_t *string, int c, int isignore, int islast ) {

   const wchar32_t *result = NULL ;

   if ( isignore ) c = tolower ( c ) ;

   do {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c == c1 ) {
         result = string ;
         if ( ! islast ) break ;
      }

   } while ( *string ++ ) ;

   return (wchar32_t*) result ;
}



// 񂩂當iMULTIBYTEŁj
char *mbschr_i_r ( const char *string, int c, int isignore, int islast ) {

   const char *result = NULL ;

   if ( isignore ) c = tolower ( c ) ;

   do {

      if ( ismbblead ( (unsigned char) *string ) ) {

         if ( *( string + 1 ) ) {
            if ( c == ( (unsigned char) *string << 8 ) + (unsigned char) *( string + 1 ) ) {
               result = string ;
               if ( ! islast ) break ;
            }
            string ++ ;
         }
      }
      else {

         int c1 = *string ;
         if ( isignore ) c1 = tolower ( c1 ) ;

         if ( c == c1 ) {
            result = string ;
            if ( ! islast ) break ;
         }
      }

   } while ( *string ++ ) ;

   return (char*) result ;
}



////////////////////////////////////////////
//                strspn ()               //
////////////////////////////////////////////



// keys ɑȂ string ōŏɏoʒuԂiUTF32Łj
// ȂΖԂ
size_t wcsspn32 ( const wchar32_t *string, const wchar32_t *keys ) {

   const wchar32_t *current ;

   for ( current = string ; *current ; current ++ ) {
      if ( ! wcschr32 ( keys, *current ) ) break ;
   }

   return current - string ;
}



// keys ɑȂ string ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbsspn ( const char *string, const char *keys ) {

   int c ;
   const char *current ;

   for ( current = string ; *current ; current ++ ) {

      int islead = ismbblead ( (unsigned char) *current ) ;
      if ( islead ) c = ( (unsigned char) *current << 8 ) + (unsigned char) *( current + 1 ) ;
      else          c = *current ;

      if ( ! mbschr ( keys, c ) ) break ;

      if ( islead && *( current + 1 ) ) current ++ ;
   }

   return current - string ;
}



////////////////////////////////////////////
//                strcspn ()              //
////////////////////////////////////////////



// keys ɑ string ōŏɏoʒuԂiUTF32Łj
// ȂΖԂ
size_t wcscspn32 ( const wchar32_t *string, const wchar32_t *keys ) {

   const wchar32_t *current ;

   for ( current = string ; *current ; current ++ ) {
      if ( wcschr32 ( keys, *current ) ) break ;
   }

   return current - string ;
}



// keys ɑ string ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbscspn ( const char *string, const char *keys ) {

   int c ;
   const char *current ;

   for ( current = string ; *current ; current ++ ) {

      int islead = ismbblead ( (unsigned char) *current ) ;
      if ( islead ) c = ( (unsigned char) *current << 8 ) + (unsigned char) *( current + 1 ) ;
      else          c = *current ;

      if ( mbschr ( keys, c ) ) break ;

      if ( islead && *( current + 1 ) ) current ++ ;
   }

   return current - string ;
}



////////////////////////////////////////////
//               strspnp ()               //
////////////////////////////////////////////



// keys ɑȂ string ōŏɏoʒuԂiANSIŁj
// Ȃ NULL Ԃ
char *strspnp ( const char *string, const char *keys ) {

   const char *result = string + strspn ( string, keys ) ;
   if ( *result ) return (char*) result ;

   return NULL ;
}



// keys ɑȂ string ōŏɏoʒuԂiUNICODEŁj
// Ȃ NULL Ԃ
wchar_t *wcsspnp ( const wchar_t *string, const wchar_t *keys ) {

   const wchar_t *result = string + wcsspn ( string, keys ) ;
   if ( *result ) return (wchar_t*) result ;

   return NULL ;
}



// keys ɑȂ string ōŏɏoʒuԂiUTF32Łj
// Ȃ NULL Ԃ
wchar32_t *wcsspnp32 ( const wchar32_t *string, const wchar32_t *keys ) {

   const wchar32_t *result = string + wcsspn32 ( string, keys ) ;
   if ( *result ) return (wchar32_t*) result ;

   return NULL ;
}



// keys ɑȂ string ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbsspnp ( const char *string, const char *keys ) {

   const char *result = string + mbsspn ( string, keys ) ;
   if ( *result ) return (char*) result ;

   return NULL ;
}



////////////////////////////////////////////
//               strpbrk ()               //
////////////////////////////////////////////



// keys ɑ string ōŏɏoʒuԂiUTF32Łj
// Ȃ NULL Ԃ
wchar32_t *wcspbrk32 ( const wchar32_t *string, const wchar32_t *keys ) {

   const wchar32_t *result = string + wcscspn32 ( string, keys ) ;
   if ( *result ) return (wchar32_t*) result ;

   return NULL ;
}



// keys ɑ string ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbspbrk ( const char *string, const char *keys ) {

   const char *result = string + mbscspn ( string, keys ) ;
   if ( *result ) return (char*) result ;

   return NULL ;
}



////////////////////////////////////////////
//               strlwr ()                //
////////////////////////////////////////////



// ɁiANSIŁj
char *strlwr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      *current = tolower ( *current ) ;
   }

   return string ;
}



// ɁiUNICODEŁj
wchar_t *wcslwr ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      *current = tolower ( *current ) ;
   }

   return string ;
}



// ɁiUTF32Łj
wchar32_t *wcslwr32 ( wchar32_t *string ) {

   for ( wchar32_t *current = string ; *current ; current ++ ) {
      *current = tolower ( *current ) ;
   }

   return string ;
}



// ɁiMULTIBYTEŁj
char *mbslwr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) && *( current + 1 ) ) {
         current ++ ;
         continue ;
      }
      *current = tolower ( *current ) ;
   }

   return string ;
}



// ɁiUNICODEŁj
// U+00`U+FF ̕ɑΉ
wchar_t *wcslwrex ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( *current >= 0xC0 && *current <= 0xDE && *current != 0xD7 ) *current = *current + ( 0xE0 - 0xC0 ) ;
      else                                                            *current = tolower ( *current ) ;
   }

   return string ;
}



////////////////////////////////////////////
//               strupr ()                //
////////////////////////////////////////////



// 啶ɁiANSIŁj
char *strupr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      *current = toupper ( *current ) ;
   }

   return string ;
}



// 啶ɁiUNICODEŁj
wchar_t *wcsupr ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      *current = toupper ( *current ) ;
   }

   return string ;
}



// 啶ɁiUTF32Łj
wchar32_t *wcsupr32 ( wchar32_t *string ) {

   for ( wchar32_t *current = string ; *current ; current ++ ) {
      *current = toupper ( *current ) ;
   }

   return string ;
}



// 啶ɁiMULTIBYTEŁj
char *mbsupr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) && *( current + 1 ) ) {
         current ++ ;
         continue ;
      }
      *current = toupper ( *current ) ;
   }

   return string ;
}



// 啶ɁiUNICODEŁj
// U+00`U+FF ̕ɑΉ
wchar_t *wcsuprex ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( *current >= 0xE0 && *current <= 0xFE && *current != 0xF7 ) *current = *current + ( 0xC0 - 0xE0 ) ;
      else                                                            *current = toupper ( *current ) ;
   }

   return string ;
}



////////////////////////////////////////////
//               strrev ()                //
////////////////////////////////////////////



// t]iUTF16Łj
wchar16_t *wcsrev16 ( wchar16_t *string ) {

   for ( wchar16_t *current = string ; *current ; current ++ ) {
      if ( IsUnicodeHighSurrogate ( *current ) ) {
         if ( *( current + 1 ) ) {
            wchar16_t c = *( current + 1 ) ;
            *( current + 1 ) = *current ;
            *current = c ;
            current ++ ;
            continue ;
         }
         else {
            *current = 0 ;
            break ;
         }
      }
   }

   return wcsrev ( string ) ;
}



// t]iUTF32Łj
wchar32_t *wcsrev32 ( wchar32_t *string ) {

   wchar32_t *start = string ;
   wchar32_t *left = string ;

   while ( *string ++ ) ;
   string -= 2 ;

   while ( left < string ) {
      int c = *left ;
      *left ++ = *string ;
      *string -- = c ;
   }

   return start ;
}



// t]iMULTIBYTEŁj
char *mbsrev ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) ) {
         if ( *( current + 1 ) ) {
            unsigned char c = *( current + 1 ) ;
            *( current + 1 ) = *current ;
            *current = c ;
            current ++ ;
            continue ;
         }
         else {
            *current = 0 ;
            break ;
         }
      }
   }

   return strrev ( string ) ;
}



////////////////////////////////////////////
//               strtrunc ()              //
////////////////////////////////////////////



// ZkiANSIŁj
// len ͍ő厚iI[k܂܂Ȃj
char *strtrunc ( char *string, size_t len ) {

   char *end = string + len ;

   for ( char *current = string ; *current ; current ++ ) {
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiUNICODEŁj
// len ͍ő厚iI[k܂܂Ȃj
wchar_t *wcstrunc ( wchar_t *string, size_t len ) {

   wchar_t *end = string + len ;

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiUTF16Łj
// len ͍ő厚iI[k܂܂Ȃj
wchar16_t *wcstrunc16 ( wchar16_t *string, size_t len ) {

   wchar16_t *end = string + len ;

   for ( wchar16_t *current = string ; *current ; current ++ ) {
      if ( IsUnicodeHighSurrogate ( *current ) && current + 1 >= end ) {
         *current = 0 ;
         break ;
      }
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiUTF32Łj
// len ͍ő厚iI[k܂܂Ȃj
wchar32_t *wcstrunc32 ( wchar32_t *string, size_t len ) {

   wchar32_t *end = string + len ;

   for ( wchar32_t *current = string ; *current ; current ++ ) {
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiMULTIBYTEŁj
// len ͍ő厚iI[k܂܂Ȃj
char *mbstrunc ( char *string, size_t len ) {

   char *end = string + len ;

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) ) {
         if ( current >= end - 1 || ! *( current + 1 ) ) {
            *current = 0 ;
            break ;
         }
         current ++ ;
      }
      else {
         if ( current >= end ) {
            *current = 0 ;
            break ;
         }
      }
   }

   return string ;
}



////////////////////////////////////////////
//                strlen ()               //
////////////////////////////////////////////



// ԂiUTF32Łj
size_t wcslen32 ( const wchar32_t *string ) {

   size_t n ;

   for ( n = 0 ; *string ; n ++, string ++ ) ;

   return n ;
}



// ԂiMULTIBYTEŁj
// QoCg͂PƂĐ
size_t mbslen ( const char *string ) {

   size_t n ;

   for ( n = 0 ; *string ; n ++, string ++ ) {
      if ( ismbblead ( (unsigned char) *string ) && *( string + 1 ) ) string ++ ;
   }

   return n ;
}



////////////////////////////////////////////
//         strduplen_max_expand ()        //
////////////////////////////////////////////



// w肵ĕ𕡐iUTF32Łj
//  (size_t) -1 ȂkI[ƌȂ
// string ̒ maxlen ȏȂ NULL Ԃ
// o̖͂ɃkI[
// w肳ꂽ]Ɋmۂ
// s NULL Ԃ
wchar32_t *wcsduplen_max_expand32 ( const wchar32_t *string, size_t srclen, size_t maxlen, size_t addlen ) {

   if ( srclen == (size_t) -1 ) srclen = wcslen32 ( string ) ;
   if ( srclen >= maxlen ) return NULL ;

   wchar32_t *buffer = (wchar32_t*) malloc ( ( srclen + addlen + 1 ) * sizeof(wchar32_t) ) ;
   if ( buffer ) {
      memmove ( buffer, string, srclen * sizeof(wchar32_t) ) ;
      buffer [ srclen ] = 0 ;
   }

   return buffer ;
}



////////////////////////////////////////////
//               strldup ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕ𕡐iANSIŁj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
char *strldup ( const char *string, size_t bufsiz ) {

   size_t len = strlen ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   char *buffer = (char*) malloc ( ( len + 1 ) * sizeof(char) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(char) ) ;
      buffer [ len ] = 0 ;
   }

   return buffer ;
}



// w肳ꂽ܂ŕ𕡐iUNICODEŁj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
wchar_t *wcsldup ( const wchar_t *string, size_t bufsiz ) {

   size_t len = wcslen ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   wchar_t *buffer = (wchar_t*) malloc ( ( len + 1 ) * sizeof(wchar_t) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(wchar_t) ) ;
      buffer [ len ] = 0 ;
   }

   return buffer ;
}



// w肳ꂽ܂ŕ𕡐iUTF16Łj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
wchar16_t *wcsldup16 ( const wchar16_t *string, size_t bufsiz ) {

   size_t len = wcslen16 ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   wchar16_t *buffer = (wchar16_t*) malloc ( ( len + 1 ) * sizeof(wchar16_t) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(wchar16_t) ) ;
      wcstrunc16 ( buffer, len ) ;
   }

   return buffer ;
}



// w肳ꂽ܂ŕ𕡐iUTF32Łj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
wchar32_t *wcsldup32 ( const wchar32_t *string, size_t bufsiz ) {

   size_t len = wcslen32 ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   wchar32_t *buffer = (wchar32_t*) malloc ( ( len + 1 ) * sizeof(wchar32_t) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(wchar32_t) ) ;
      buffer [ len ] = 0 ;
   }

   return buffer ;
}



// w肳ꂽ܂ŕ𕡐iMULTIBYTEŁj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
char *mbsldup ( const char *string, size_t bufsiz ) {

   size_t len = strlen ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   char *buffer = (char*) malloc ( ( len + 1 ) * sizeof(char) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(char) ) ;
      mbstrunc ( buffer, len ) ;
   }

   return buffer ;
}



////////////////////////////////////////////
//               mbsbtype ()              //
////////////////////////////////////////////



// }`oCg𔻒
int mbsbtype ( const char *string, size_t count ) {

   int isprevlead = 0 ;

   for ( const char *current = string ; *current ; current ++ ) {
      if ( size_t ( current - string ) == count ) {
         if ( isprevlead ) {
            if ( ismbbtrail ( (unsigned char) *current ) ) return _MBC_TRAIL ;
            else                                           return _MBC_ILLEGAL ;
         }
         else {
            if ( ismbblead ( (unsigned char) *current ) ) return _MBC_LEAD ;
            else if ( *current )                          return _MBC_SINGLE ;
            else                                          return _MBC_ILLEGAL ;
         }
      }
      if ( ! isprevlead && ismbblead ( (unsigned char) *current ) ) isprevlead = 1 ;
      else                                                          isprevlead = 0 ;
   }

   return _MBC_ILLEGAL ;
}



// }`oCg𔻒
int ismbslead ( const char *string, const char *current ) {
   if ( mbsbtype ( string, current - string ) == _MBC_LEAD ) return -1 ;
   return 0 ;
}



// }`oCg𔻒
int ismbstrail ( const char *string, const char *current ) {
   if ( mbsbtype ( string, current - string ) == _MBC_TRAIL ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//               strtokex ()              //
////////////////////////////////////////////



// 󔒕Ő؂蕪iANSIŁj
// dpF
// 擪̋󔒂͓ǂݔ΂
// pnext  NULL ł
// ؂蕪Ԃ
// ̏I[ɒB NULL Ԃ
// pnext ̏I[ɒBI[̃AhXi[
char *strtokex ( char *string, char **pnext ) {

   if ( ! string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   while ( *string && isascii ( *string ) && isspace ( *string ) ) string ++ ;
   if ( ! *string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   int mode = 0 ;
   size_t countquote = 0 ;
   char *start ;

   for ( start = string ; *string ; string ++ ) {
      if ( *string == '\"' ) {
         mode = ! mode ;
         if ( string == start ) start ++ ;
         else                   countquote ++ ;
      }
      if ( ! mode && isascii ( *string ) && isspace ( *string ) ) break ;
   }

   if ( *string ) { if ( pnext ) *pnext = string + 1 ; }
   else           { if ( pnext ) *pnext = string ; }
   *string = 0 ;

   for ( string = start ; *string && countquote ; string ++ ) {
      if ( *string == '\"' ) {
         memmove ( string, string + 1, ( strlen ( string + 1 ) + 1 ) * sizeof(char) ) ;
         string -- ;
         countquote -- ;
      }
   }

   return start ;
}



// 󔒕Ő؂蕪iUNICODEŁj
// dpF
// 擪̋󔒂͓ǂݔ΂
// pnext  NULL ł
// ؂蕪Ԃ
// ̏I[ɒB NULL Ԃ
// pnext ̏I[ɒBI[̃AhXi[
wchar_t *wcstokex ( wchar_t *string, wchar_t **pnext ) {

   if ( ! string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   while ( *string && isascii ( *string ) && isspace ( *string ) ) string ++ ;
   if ( ! *string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   int mode = 0 ;
   size_t countquote = 0 ;
   wchar_t *start ;

   for ( start = string ; *string ; string ++ ) {
      if ( *string == '\"' ) {
         mode = ! mode ;
         if ( string == start ) start ++ ;
         else                   countquote ++ ;
      }
      if ( ! mode && isascii ( *string ) && isspace ( *string ) ) break ;
   }

   if ( *string ) { if ( pnext ) *pnext = string + 1 ; }
   else           { if ( pnext ) *pnext = string ; }
   *string = 0 ;

   for ( string = start ; *string && countquote ; string ++ ) {
      if ( *string == '\"' ) {
         memmove ( string, string + 1, ( wcslen ( string + 1 ) + 1 ) * sizeof(wchar_t) ) ;
         string -- ;
         countquote -- ;
      }
   }

   return start ;
}



// 󔒕Ő؂蕪iUTF32Łj
// dpF
// 擪̋󔒂͓ǂݔ΂
// pnext  NULL ł
// ؂蕪Ԃ
// ̏I[ɒB NULL Ԃ
// pnext ̏I[ɒBI[̃AhXi[
wchar32_t *wcstokex32 ( wchar32_t *string, wchar32_t **pnext ) {

   if ( ! string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   while ( *string && isascii ( *string ) && isspace ( *string ) ) string ++ ;
   if ( ! *string ) {
      if ( pnext ) *pnext = string ;
      return NULL ;
   }

   int mode = 0 ;
   size_t countquote = 0 ;
   wchar32_t *start ;

   for ( start = string ; *string ; string ++ ) {
      if ( *string == '\"' ) {
         mode = ! mode ;
         if ( string == start ) start ++ ;
         else                   countquote ++ ;
      }
      if ( ! mode && isascii ( *string ) && isspace ( *string ) ) break ;
   }

   if ( *string ) { if ( pnext ) *pnext = string + 1 ; }
   else           { if ( pnext ) *pnext = string ; }
   *string = 0 ;

   for ( string = start ; *string && countquote ; string ++ ) {
      if ( *string == '\"' ) {
         memmove ( string, string + 1, ( wcslen32 ( string + 1 ) + 1 ) * sizeof(wchar32_t) ) ;
         string -- ;
         countquote -- ;
      }
   }

   return start ;
}



////////////////////////////////////////////
//               memchr ()                //
////////////////////////////////////////////



// [ÃTCYw肵āA
// count ɂ͕w肷ioCgł͂Ȃj
// sȃTCYw肷ƁAerrno  EINVAL ZbgANULL Ԃ
void *memchrex_i_r ( const void *string, int64_t c, size_t count, size_t charsize, int isignore ) {


   if ( isignore && c <= INT_MAX ) c = (unsigned) tolower ( (int) c ) ;


   switch ( charsize ) {

      case sizeof(unsigned char) :
      {
         const unsigned char *p = (const unsigned char*) string ;

         while ( count ) {

            unsigned char c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned char) c == c1 ) return (void*) p ;

            p ++ ;
            count -- ;
         }

         break ;
      }

      case sizeof(unsigned short) :
      {
         const unsigned short *p = (const unsigned short*) string ;

         while ( count ) {

            unsigned short c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned short) c == c1 ) return (void*) p ;

            p ++ ;
            count -- ;
         }

         break ;
      }

      case sizeof(unsigned long) :
      {
         const unsigned long *p = (const unsigned long*) string ;

         while ( count ) {

            unsigned long c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned long) c == c1 ) return (void*) p ;

            p ++ ;
            count -- ;
         }

         break ;
      }

      case sizeof(uint64_t) :
      {
         const uint64_t *p = (const uint64_t*) string ;

         while ( count ) {

            uint64_t c1 = *p ;
            if ( isignore && c1 <= INT_MAX ) c1 = (unsigned) tolower ( (int) c1 ) ;

            if ( (uint64_t) c == c1 ) return (void*) p ;

            p ++ ;
            count -- ;
         }

         break ;
      }

      default :
         errno = EINVAL ;
         break ;
   }

   return NULL ;
}



////////////////////////////////////////////
//               memrchr ()               //
////////////////////////////////////////////



// [ÃTCYw肵āA납猟
// count ɂ͕w肷ioCgł͂Ȃj
// sȃTCYw肷ƁAerrno  EINVAL ZbgANULL Ԃ
void *memrchrex_i ( const void *string, int64_t c, size_t count, size_t charsize, int isignore ) {


   if ( isignore && c <= INT_MAX ) c = (unsigned) tolower ( (int) c ) ;


   switch ( charsize ) {

      case sizeof(unsigned char) :
      {
         const unsigned char *p = (const unsigned char*) string + count - 1 ;

         while ( count ) {

            unsigned char c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned char) c == c1 ) return (void*) p ;

            p -- ;
            count -- ;
         }

         break ;
      }

      case sizeof(unsigned short) :
      {
         const unsigned short *p = (const unsigned short*) string + count - 1 ;

         while ( count ) {

            unsigned short c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned short) c == c1 ) return (void*) p ;

            p -- ;
            count -- ;
         }

         break ;
      }

      case sizeof(unsigned long) :
      {
         const unsigned long *p = (const unsigned long*) string + count - 1 ;

         while ( count ) {

            unsigned long c1 = *p ;
            if ( isignore ) c1 = tolower ( c1 ) ;

            if ( (unsigned long) c == c1 ) return (void*) p ;

            p -- ;
            count -- ;
         }

         break ;
      }

      case sizeof(uint64_t) :
      {
         const uint64_t *p = (const uint64_t*) string + count - 1 ;

         while ( count ) {

            uint64_t c1 = *p ;
            if ( isignore && c1 <= INT_MAX ) c1 = (unsigned) tolower ( (int) c1 ) ;

            if ( (uint64_t) c == c1 ) return (void*) p ;

            p -- ;
            count -- ;
         }

         break ;
      }

      default :
         errno = EINVAL ;
         break ;
   }

   return NULL ;
}



////////////////////////////////////////////
//                memcmp ()               //
////////////////////////////////////////////



// [ÃTCYw肵Ĕr
// count ɂ͕w肷ioCgł͂Ȃj
// sȃTCYw肷ƁAerrno  EINVAL ZbgA0 Ԃ
int memcmpex_i ( const void *string1, const void *string2, size_t count, size_t charsize, int isignore ) {

   switch ( charsize ) {

      case sizeof(unsigned char) :
      {
         const unsigned char *p1 = (const unsigned char*) string1 ;
         const unsigned char *p2 = (const unsigned char*) string2 ;

         unsigned char c1, c2 ;

         while ( 1 ) {

            if ( ! count ) return 0 ;

            c1 = (unsigned char) *p1 ;
            c2 = (unsigned char) *p2 ;

            if ( isignore ) {
               c1 = tolower ( c1 ) ;
               c2 = tolower ( c2 ) ;
            }

            if ( c1 != c2 ) break ;

            p1 ++ ;
            p2 ++ ;
            count -- ;
         }

         if ( c1 > c2 ) return 1 ;
         if ( c1 < c2 ) return -1 ;
         break ;
      }

      case sizeof(unsigned short) :
      {
         const unsigned short *p1 = (const unsigned short*) string1 ;
         const unsigned short *p2 = (const unsigned short*) string2 ;

         unsigned short c1, c2 ;

         while ( 1 ) {

            if ( ! count ) return 0 ;

            c1 = (unsigned short) *p1 ;
            c2 = (unsigned short) *p2 ;

            if ( isignore ) {
               c1 = tolower ( c1 ) ;
               c2 = tolower ( c2 ) ;
            }

            if ( c1 != c2 ) break ;

            p1 ++ ;
            p2 ++ ;
            count -- ;
         }

         if ( c1 > c2 ) return 1 ;
         if ( c1 < c2 ) return -1 ;
         break ;
      }

      case sizeof(unsigned long) :
      {
         const unsigned long *p1 = (const unsigned long*) string1 ;
         const unsigned long *p2 = (const unsigned long*) string2 ;

         unsigned long c1, c2 ;

         while ( 1 ) {

            if ( ! count ) return 0 ;

            c1 = (unsigned long) *p1 ;
            c2 = (unsigned long) *p2 ;

            if ( isignore ) {
               c1 = tolower ( c1 ) ;
               c2 = tolower ( c2 ) ;
            }

            if ( c1 != c2 ) break ;

            p1 ++ ;
            p2 ++ ;
            count -- ;
         }

         if ( c1 > c2 ) return 1 ;
         if ( c1 < c2 ) return -1 ;
         break ;
      }

      case sizeof(uint64_t) :
      {
         const uint64_t *p1 = (const uint64_t*) string1 ;
         const uint64_t *p2 = (const uint64_t*) string2 ;

         uint64_t c1, c2 ;

         while ( 1 ) {

            if ( ! count ) return 0 ;

            c1 = *p1 ;
            c2 = *p2 ;

            if ( isignore ) {
               if ( c1 <= INT_MAX ) c1 = (unsigned) tolower ( (int) c1 ) ;
               if ( c2 <= INT_MAX ) c2 = (unsigned) tolower ( (int) c2 ) ;
            }

            if ( c1 != c2 ) break ;

            p1 ++ ;
            p2 ++ ;
            count -- ;
         }

         if ( c1 > c2 ) return 1 ;
         if ( c1 < c2 ) return -1 ;
         break ;
      }

      default :
         errno = EINVAL ;
         break ;
   }

   return 0 ;
}



////////////////////////////////////////////
//               memset ()                //
////////////////////////////////////////////



// [ÃTCYw肵āAŖ߂
// count ɂ͕w肷ioCgł͂Ȃj
// sȃTCYw肷ƁAerrno  EINVAL ZbgANULL Ԃ
void *memsetex ( void *buffer, int64_t c, size_t count, size_t charsize ) {

   switch ( charsize ) {

      case sizeof(unsigned char) :
      {
         unsigned char *p = (unsigned char*) buffer ;

         while ( count ) {
            *p = (unsigned char) c ;
            p ++ ;
            count -- ;
         }

         return buffer ;
      }

      case sizeof(unsigned short) :
      {
         unsigned short *p = (unsigned short*) buffer ;

         while ( count ) {
            *p = (unsigned short) c ;
            p ++ ;
            count -- ;
         }

         return buffer ;
      }

      case sizeof(unsigned long) :
      {
         unsigned long *p = (unsigned long*) buffer ;

         while ( count ) {
            *p = (unsigned long) c ;
            p ++ ;
            count -- ;
         }

         return buffer ;
      }

      case sizeof(uint64_t) :
      {
         uint64_t *p = (uint64_t*) buffer ;

         while ( count ) {
            *p = (uint64_t) c ;
            p ++ ;
            count -- ;
         }

         return buffer ;
      }

      default :
         errno = EINVAL ;
         break ;
   }

   return NULL ;
}



////////////////////////////////////////////
//               memdup ()                //
////////////////////////////////////////////



// [𕡐
// len ɂ̓oCgw肷
void *memdup ( void *src, size_t len ) {

   void *dst = malloc ( len * sizeof(char) ) ;
   if ( dst ) memmove ( dst, src, len * sizeof(char) ) ;

   return dst ;
}



// [𕡐
// len, addlen ɂ̓oCgw肷
// addlen Ɏw肳ꂽ]Ɋmۂ
void *memdup_expand ( void *src, size_t len, size_t addlen ) {

   void *dst = malloc ( ( len + addlen ) * sizeof(char) ) ;
   if ( dst ) memmove ( dst, src, len * sizeof(char) ) ;

   return dst ;
}



