// uniblock.h

#ifndef UNIBLOCK_H
#define UNIBLOCK_H

#ifdef __cplusplus
extern "C" {
#endif


int GetUnicodeBlock ( int cUnicode, int nOrdinal, int nIndex, int *pStart, int *pEnd, int *pOrdinal ) ;
const char *GetUnicodeBlockNameA ( int nOrdinal ) ;
const wchar_t *GetUnicodeBlockNameW ( int nOrdinal ) ;


#ifdef UNICODE
#define GetUnicodeBlockName GetUnicodeBlockNameW
#else
#define GetUnicodeBlockName GetUnicodeBlockNameA
#endif


#define UNICODE_BLOCK_NELEM            194



#define UB_BASIC_LATIN                                         0
#define UB_LATIN_1_SUPPLEMENT                                  1
#define UB_LATIN_EXTENDED_A                                    2
#define UB_LATIN_EXTENDED_B                                    3
#define UB_IPA_EXTENSIONS                                      4
#define UB_SPACING_MODIFIER_LETTERS                            5
#define UB_COMBINING_DIACRITICAL_MARKS                         6
#define UB_GREEK_AND_COPTIC                                    7
#define UB_CYRILLIC                                            8
#define UB_CYRILLIC_SUPPLEMENT                                 9
#define UB_ARMENIAN                                            10
#define UB_HEBREW                                              11
#define UB_ARABIC                                              12
#define UB_SYRIAC                                              13
#define UB_ARABIC_SUPPLEMENT                                   122
#define UB_THAANA                                              14
#define UB_NKO                                                 142
#define UB_SAMARITAN                                           168
#define UB_DEVANAGARI                                          15
#define UB_BENGALI                                             16
#define UB_GURMUKHI                                            17
#define UB_GUJARATI                                            18
#define UB_ORIYA                                               19
#define UB_TAMIL                                               20
#define UB_TELUGU                                              21
#define UB_KANNADA                                             22
#define UB_MALAYALAM                                           23
#define UB_SINHALA                                             24
#define UB_THAI                                                25
#define UB_LAO                                                 26
#define UB_TIBETAN                                             27
#define UB_MYANMAR                                             28
#define UB_GEORGIAN                                            29
#define UB_HANGUL_JAMO                                         30
#define UB_ETHIOPIC                                            31
#define UB_ETHIOPIC_SUPPLEMENT                                 123
#define UB_CHEROKEE                                            32
#define UB_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS               33
#define UB_OGHAM                                               34
#define UB_RUNIC                                               35
#define UB_TAGALOG                                             36
#define UB_HANUNOO                                             37
#define UB_BUHID                                               38
#define UB_TAGBANWA                                            39
#define UB_KHMER                                               40
#define UB_MONGOLIAN                                           41
#define UB_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS_EXTENDED      169
#define UB_LIMBU                                               42
#define UB_TAI_LE                                              43
#define UB_NEW_TAI_LUE                                         124
#define UB_KHMER_SYMBOLS                                       44
#define UB_BUGINESE                                            125
#define UB_TAI_THAM                                            170
#define UB_BALINESE                                            143
#define UB_SUNDANESE                                           151
#define UB_LEPCHA                                              152
#define UB_OL_CHIKI                                            153
#define UB_VEDIC_EXTENSIONS                                    171
#define UB_PHONETIC_EXTENSIONS                                 45
#define UB_PHONETIC_EXTENSIONS_SUPPLEMENT                      126
#define UB_COMBINING_DIACRITICAL_MARKS_SUPPLEMENT              127
#define UB_LATIN_EXTENDED_ADDITIONAL                           46
#define UB_GREEK_EXTENDED                                      47
#define UB_GENERAL_PUNCTUATION                                 48
#define UB_SUPERSCRIPTS_AND_SUBSCRIPTS                         49
#define UB_CURRENCY_SYMBOLS                                    50
#define UB_COMBINING_DIACRITICAL_MARKS_FOR_SYMBOLS             51
#define UB_LETTERLIKE_SYMBOLS                                  52
#define UB_NUMBER_FORMS                                        53
#define UB_ARROWS                                              54
#define UB_MATHEMATICAL_OPERATORS                              55
#define UB_MISCELLANEOUS_TECHNICAL                             56
#define UB_CONTROL_PICTURES                                    57
#define UB_OPTICAL_CHARACTER_RECOGNITION                       58
#define UB_ENCLOSED_ALPHANUMERICS                              59
#define UB_BOX_DRAWING                                         60
#define UB_BLOCK_ELEMENTS                                      61
#define UB_GEOMETRIC_SHAPES                                    62
#define UB_MISCELLANEOUS_SYMBOLS                               63
#define UB_DINGBATS                                            64
#define UB_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_A                65
#define UB_SUPPLEMENTAL_ARROWS_A                               66
#define UB_BRAILLE_PATTERNS                                    67
#define UB_SUPPLEMENTAL_ARROWS_B                               68
#define UB_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_B                69
#define UB_SUPPLEMENTAL_MATHEMATICAL_OPERATORS                 70
#define UB_MISCELLANEOUS_SYMBOLS_AND_ARROWS                    71
#define UB_GLAGOLITIC                                          128
#define UB_LATIN_EXTENDED_C                                    144
#define UB_COPTIC                                              129
#define UB_GEORGIAN_SUPPLEMENT                                 130
#define UB_TIFINAGH                                            131
#define UB_ETHIOPIC_EXTENDED                                   132
#define UB_CYRILLIC_EXTENDED_A                                 154
#define UB_SUPPLEMENTAL_PUNCTUATION                            133
#define UB_CJK_RADICALS_SUPPLEMENT                             72
#define UB_KANGXI_RADICALS                                     73
#define UB_IDEOGRAPHIC_DESCRIPTION_CHARACTERS                  74
#define UB_CJK_SYMBOLS_AND_PUNCTUATION                         75
#define UB_HIRAGANA                                            76
#define UB_KATAKANA                                            77
#define UB_BOPOMOFO                                            78
#define UB_HANGUL_COMPATIBILITY_JAMO                           79
#define UB_KANBUN                                              80
#define UB_BOPOMOFO_EXTENDED                                   81
#define UB_CJK_STROKES                                         134
#define UB_KATAKANA_PHONETIC_EXTENSIONS                        82
#define UB_ENCLOSED_CJK_LETTERS_AND_MONTHS                     83
#define UB_CJK_COMPATIBILITY                                   84
#define UB_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A                  85
#define UB_YIJING_HEXAGRAM_SYMBOLS                             86
#define UB_CJK_UNIFIED_IDEOGRAPHS                              87
#define UB_YI_SYLLABLES                                        88
#define UB_YI_RADICALS                                         89
#define UB_LISU                                                172
#define UB_VAI                                                 155
#define UB_CYRILLIC_EXTENDED_B                                 156
#define UB_BAMUM                                               173
#define UB_MODIFIER_TONE_LETTERS                               135
#define UB_LATIN_EXTENDED_D                                    145
#define UB_SYLOTI_NAGRI                                        136
#define UB_COMMON_INDIC_NUMBER_FORMS                           174
#define UB_PHAGS_PA                                            146
#define UB_SAURASHTRA                                          157
#define UB_DEVANAGARI_EXTENDED                                 175
#define UB_KAYAH_LI                                            158
#define UB_REJANG                                              159
#define UB_HANGUL_JAMO_EXTENDED_A                              176
#define UB_JAVANESE                                            177
#define UB_CHAM                                                160
#define UB_MYANMAR_EXTENDED_A                                  178
#define UB_TAI_VIET                                            179
#define UB_MEETEI_MAYEK                                        180
#define UB_HANGUL_SYLLABLES                                    90
#define UB_HANGUL_JAMO_EXTENDED_B                              181
#define UB_PRIVATE_USE_AREA                                    91
#define UB_CJK_COMPATIBILITY_IDEOGRAPHS                        92
#define UB_ALPHABETIC_PRESENTATION_FORMS                       93
#define UB_ARABIC_PRESENTATION_FORMS_A                         94
#define UB_VARIATION_SELECTORS                                 95
#define UB_VERTICAL_FORMS                                      137
#define UB_COMBINING_HALF_MARKS                                96
#define UB_CJK_COMPATIBILITY_FORMS                             97
#define UB_SMALL_FORM_VARIANTS                                 98
#define UB_ARABIC_PRESENTATION_FORMS_B                         99
#define UB_HALFWIDTH_AND_FULLWIDTH_FORMS                       100
#define UB_SPECIALS                                            101
#define UB_LINEAR_B_SYLLABARY                                  102
#define UB_LINEAR_B_IDEOGRAMS                                  103
#define UB_AEGEAN_NUMBERS                                      104
#define UB_ANCIENT_GREEK_NUMBERS                               138
#define UB_ANCIENT_SYMBOLS                                     161
#define UB_PHAISTOS_DISC                                       162
#define UB_LYCIAN                                              163
#define UB_CARIAN                                              164
#define UB_OLD_ITALIC                                          105
#define UB_GOTHIC                                              106
#define UB_UGARITIC                                            107
#define UB_OLD_PERSIAN                                         139
#define UB_DESERET                                             108
#define UB_SHAVIAN                                             109
#define UB_OSMANYA                                             110
#define UB_CYPRIOT_SYLLABARY                                   111
#define UB_IMPERIAL_ARAMAIC                                    182
#define UB_PHOENICIAN                                          147
#define UB_LYDIAN                                              165
#define UB_KHAROSHTHI                                          140
#define UB_OLD_SOUTH_ARABIAN                                   183
#define UB_AVESTAN                                             184
#define UB_INSCRIPTIONAL_PARTHIAN                              185
#define UB_INSCRIPTIONAL_PAHLAVI                               186
#define UB_OLD_TURKIC                                          187
#define UB_RUMI_NUMERAL_SYMBOLS                                188
#define UB_KAITHI                                              189
#define UB_CUNEIFORM                                           148
#define UB_CUNEIFORM_NUMBERS_AND_PUNCTUATION                   149
#define UB_EGYPTIAN_HIEROGLYPHS                                190
#define UB_BYZANTINE_MUSICAL_SYMBOLS                           112
#define UB_MUSICAL_SYMBOLS                                     113
#define UB_ANCIENT_GREEK_MUSICAL_NOTATION                      141
#define UB_TAI_XUAN_JING_SYMBOLS                               114
#define UB_COUNTING_ROD_NUMERALS                               150
#define UB_MATHEMATICAL_ALPHANUMERIC_SYMBOLS                   115
#define UB_MAHJONG_TILES                                       166
#define UB_DOMINO_TILES                                        167
#define UB_ENCLOSED_ALPHANUMERIC_SUPPLEMENT                    191
#define UB_ENCLOSED_IDEOGRAPHIC_SUPPLEMENT                     192
#define UB_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_B                  116
#define UB_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_C                  193
#define UB_CJK_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT             117
#define UB_TAGS                                                118
#define UB_VARIATION_SELECTORS_SUPPLEMENT                      119
#define UB_SUPPLEMENTARY_PRIVATE_USE_AREA_A                    120
#define UB_SUPPLEMENTARY_PRIVATE_USE_AREA_B                    121



#define  IsInUnicodeBlock(C,nBlock)    ( GetUnicodeBlock ( C, 0, 0, NULL, NULL, NULL ) == nBlock )



#ifdef __cplusplus
}
#endif

#endif
