// brsfolder.cpp

#include <windows.h>
#include <shlobj.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "brsfolder.h"
#include "shfolder.h"



// ̑ CSIDL ʎqw肳ꂽ
#define IsSpecifiedCsidl(s)         ( (char*) (s) < (char*) 0xFFFF )



//////////////////////////////
//          ANSI          //
//////////////////////////////



static int CALLBACK SHBrowseProcA ( HWND hWnd, unsigned int dwMessage, LPARAM lParam, LPARAM lpData ) ;


typedef struct {
   const char *szTitle ;
   LPCITEMIDLIST pInitial ;
} BROWSEFORFOLDERINFOA ;



// tH_I_CAONiANSIŁj
// ITEMIDLIST Ԃ
LPITEMIDLIST WINAPI ShBrowseForFolderA ( HWND hWnd, LPCITEMIDLIST pInitial, const char *szTitle, const char *szMessage, unsigned long dwFlags ) {

   BROWSEFORFOLDERINFOA BrowseForFolderInfo ;

   BROWSEINFOA BrowseInfo = { 0 } ;
   BrowseInfo.hwndOwner = hWnd ;
   BrowseInfo.lpfn = SHBrowseProcA ;
   BrowseInfo.lParam = (LPARAM) & BrowseForFolderInfo ;
   BrowseInfo.lpszTitle = szMessage ;
   BrowseInfo.ulFlags = dwFlags ;
   BrowseForFolderInfo.szTitle = szTitle ;
   BrowseForFolderInfo.pInitial = pInitial ;

   return SHBrowseForFolderA ( & BrowseInfo ) ;
}



static int CALLBACK SHBrowseProcA ( HWND hWnd, unsigned int dwMessage, LPARAM lParam, LPARAM lpData ) {

   BROWSEFORFOLDERINFOA *pBrowseForFolderInfo = (BROWSEFORFOLDERINFOA *) lpData ;

   switch ( dwMessage ) {
      case BFFM_INITIALIZED :
         if ( pBrowseForFolderInfo->szTitle ) SetWindowTextA ( hWnd, pBrowseForFolderInfo->szTitle ) ;
         if ( pBrowseForFolderInfo->pInitial ) SendMessageA ( hWnd, BFFM_SETSELECTIONW, FALSE, (LPARAM) pBrowseForFolderInfo->pInitial ) ;
         break ;
      default :
         break ;
   }

   return 0 ;
}



// tH_I_CAONiANSIŁj
// szInitialFolder  CSIDL ʎqł
//  0 As 0 ȊOԂ
int WINAPI BrowseForFolderA ( HWND hWnd, char *szSelectedFolder, const char *szInitialFolder, const char *szTitle, const char *szMessage, unsigned long dwFlags ) {

   int nRetValue = 1 ;

   LPITEMIDLIST pInitial ;
   if ( IsSpecifiedCsidl ( szInitialFolder ) ) pInitial = ShOpenSpecialItemIdList ( (int)(intptr_t) szInitialFolder ) ;
   else                                        pInitial = ShOpenItemIdListA ( szInitialFolder ) ;

   *szSelectedFolder = 0 ;

   LPITEMIDLIST pResult = ShBrowseForFolderA ( hWnd, pInitial, szTitle, szMessage, dwFlags | BIF_RETURNONLYFSDIRS ) ;
   if ( pResult ) {
      if ( ! ShGetPathA ( pResult, szSelectedFolder ) ) nRetValue = 0 ;
      ShCloseItemIdList ( pResult ) ;
   }

   if ( pInitial ) ShCloseItemIdList ( pInitial ) ;

   return nRetValue ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



#ifndef NTFUNC_IMPORT_IMPLICITLY
#define SHBrowseForFolderW   SHBrowseForFolderW_
static LPITEMIDLIST WINAPI SHBrowseForFolderW ( LPBROWSEINFOW lpbi ) ;
#endif



static int CALLBACK SHBrowseProcW ( HWND hWnd, unsigned int dwMessage, LPARAM lParam, LPARAM lpData ) ;


typedef struct {
   const wchar_t *szTitle ;
   LPCITEMIDLIST pInitial ;
} BROWSEFORFOLDERINFOW ;



// tH_I_CAONiUNICODEŁj
// ITEMIDLIST Ԃ
LPITEMIDLIST WINAPI ShBrowseForFolderW ( HWND hWnd, LPCITEMIDLIST pInitial, const wchar_t *szTitle, const wchar_t *szMessage, unsigned long dwFlags ) {

   BROWSEFORFOLDERINFOW BrowseForFolderInfo ;

   BROWSEINFOW BrowseInfo = { 0 } ;
   BrowseInfo.hwndOwner = hWnd ;
   BrowseInfo.lpfn = SHBrowseProcW ;
   BrowseInfo.lParam = (LPARAM) & BrowseForFolderInfo ;
   BrowseInfo.lpszTitle = szMessage ;
   BrowseInfo.ulFlags = dwFlags ;
   BrowseForFolderInfo.szTitle = szTitle ;
   BrowseForFolderInfo.pInitial = pInitial ;

   return SHBrowseForFolderW ( & BrowseInfo ) ;
}



static int CALLBACK SHBrowseProcW ( HWND hWnd, unsigned int dwMessage, LPARAM lParam, LPARAM lpData ) {

   BROWSEFORFOLDERINFOW *pBrowseForFolderInfo = (BROWSEFORFOLDERINFOW *) lpData ;

   switch ( dwMessage ) {
      case BFFM_INITIALIZED :
         if ( pBrowseForFolderInfo->szTitle ) SetWindowTextW ( hWnd, pBrowseForFolderInfo->szTitle ) ;
         if ( pBrowseForFolderInfo->pInitial ) SendMessageW ( hWnd, BFFM_SETSELECTIONW, FALSE, (LPARAM) pBrowseForFolderInfo->pInitial ) ;
         break ;
      default :
         break ;
   }

   return 0 ;
}



// tH_I_CAONiUNICODEŁj
// szInitialFolder  CSIDL ʎqł
//  0 As 0 ȊOԂ
int WINAPI BrowseForFolderW ( HWND hWnd, wchar_t *szSelectedFolder, const wchar_t *szInitialFolder, const wchar_t *szTitle, const wchar_t *szMessage, unsigned long dwFlags ) {

   int nRetValue = 1 ;

   LPITEMIDLIST pInitial ;
   if ( IsSpecifiedCsidl ( szInitialFolder ) ) pInitial = ShOpenSpecialItemIdList ( (int)(intptr_t) szInitialFolder ) ;
   else                                        pInitial = ShOpenItemIdListW ( szInitialFolder ) ;

   *szSelectedFolder = 0 ;

   LPITEMIDLIST pResult = ShBrowseForFolderW ( hWnd, pInitial, szTitle, szMessage, dwFlags | BIF_RETURNONLYFSDIRS ) ;
   if ( pResult ) {
      if ( ! ShGetPathW ( pResult, szSelectedFolder ) ) nRetValue = 0 ;
      ShCloseItemIdList ( pResult ) ;
   }

   if ( pInitial ) ShCloseItemIdList ( pInitial ) ;

   return nRetValue ;
}



//////////////////////////////
//       NT FUNCTIONS       //
//////////////////////////////



#ifndef NTFUNC_IMPORT_IMPLICITLY



typedef LPITEMIDLIST ( WINAPI *SHBROWSEFORFOLDERW ) ( LPBROWSEINFOW lpbi ) ;
static HINSTANCE hShell32 ;
static int FreeLibraryOnDetach ( void ) ;



static LPITEMIDLIST WINAPI SHBrowseForFolderW ( LPBROWSEINFOW lpbi ) {
#undef SHBrowseForFolderW

   static SHBROWSEFORFOLDERW SHBrowseForFolderW ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hShell32, SHBROWSEFORFOLDERW, SHBrowseForFolderW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! SHBrowseForFolderW ) return NULL ;

   return SHBrowseForFolderW ( lpbi ) ;
}



static void __cdecl ExitProc ( void ) {
   if ( hShell32 ) FreeLibrary ( hShell32 ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



#endif // ! NTFUNC_IMPORT_IMPLICITLY



