// res.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>
#include <mbctype.h>
#include <limits.h>
#include "msc.h"
#include "res.h"



////////////////////////////////////////
//       \[X̃CX^X       //
////////////////////////////////////////



// \[X̃CX^X̃AhX擾
static inline HINSTANCE *GetResourceInstanceAddress ( void ) {
   static HINSTANCE hInstance ;
   return & hInstance ;
}



// \[X̃CX^XύX
// hInstance  NULL w肷ƁAƂɖ߂
// VlԂ
HINSTANCE SetResourceInstance ( HINSTANCE hInstance ) {
   return (HINSTANCE) InterlockedExchangePointer ( (PVOID*) GetResourceInstanceAddress (), hInstance ) ;
}



// \[X̃CX^X擾
HINSTANCE GetResourceInstance ( void ) {
   return *GetResourceInstanceAddress () ;
}



#if ! defined NOCRT
////////////////////////////////////////
//      TeCg\[X̐ݒ      //
////////////////////////////////////////



// p\[X̃CX^X̃AhX擾
static inline HINSTANCE *GetSatelliteResourceInstanceAddress ( void ) {
   static HINSTANCE hInstance ;
   return & hInstance ;
}



// p\[X̃CX^XύX
// hInstance  NULL w肷ƁAƂɖ߂
// VlԂ
HINSTANCE SetSatelliteResourceInstance ( HINSTANCE hInstance ) {
   return (HINSTANCE) InterlockedExchangePointer ( (PVOID*) GetSatelliteResourceInstanceAddress (), hInstance ) ;
}



// p\[X̃CX^X擾
HINSTANCE GetSatelliteResourceInstance ( void ) {
   return *GetSatelliteResourceInstanceAddress () ;
}



////////////////////////////////////////
//          \[X̌            //
////////////////////////////////////////



// \[X̌ꃍP[̃AhX擾
static inline long *GetResourceLanguageAddress ( void ) {
   static long nLangId = LANGID_NEUTRAL ;
   return & nLangId ;
}



// \[X̌ꃍP[ύX
// ȑǑꃍP[Ԃ
int SetResourceLanguage ( int nLangId ) {
   return InterlockedExchange ( GetResourceLanguageAddress (), nLangId ) ;
}



// \[X̌ꃍP[擾
int GetResourceLanguage ( void ) {

   int nLangId = *GetResourceLanguageAddress () ;

#if defined _CONSOLE
   if ( nLangId == LANGID_NEUTRAL ) {
      static int IsConsoleEnglish = -1 ;
      if ( IsConsoleEnglish < 0 ) {
         if ( GetConsoleOutputCP () != GetOEMCP () ) IsConsoleEnglish = 1 ;
         else                                        IsConsoleEnglish = 0 ;
      }
      if ( IsConsoleEnglish > 0 ) nLangId = LANGID_ENGLISH ;
   }
#endif

   return nLangId ;
}



////////////////////////////////////////
//           񃊃\[X           //
////////////////////////////////////////



// GetStringTableData ̉֐
//  0 As 0 ȊOԂ
static int GetStringTableDataSub ( int nId, const wchar_t **pVsString, int *pLength, HINSTANCE hInstance, int nLangId ) {

   HRSRC hRsrc ;
   if ( 1 ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_STRING ), MAKEINTRESOURCEW ( ( (unsigned) nId / 0x10 + 1 ) ), (LANGID) nLangId ) ;
   else     hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_STRING ), MAKEINTRESOURCEA ( ( (unsigned) nId / 0x10 + 1 ) ), (LANGID) nLangId ) ;
   if ( ! hRsrc ) return 1 ;

   HGLOBAL hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( ! hGlobal ) return 1 ;

   const wchar_t *pStringTable = (const wchar_t*) LockResource ( hGlobal ) ;
   if ( ! pStringTable ) return 1 ;

   for ( int nCount = (unsigned) nId % 0x10 ; nCount > 0 ; nCount -- ) pStringTable += 1 + *pStringTable ;
   if ( ! *pStringTable ) return 1 ;

   *pLength = *pStringTable ;
   *pVsString = pStringTable + 1 ;

   return 0 ;
}



// LoadStringEx ̉֐
//  0 As 0 ȊOԂ
static int GetStringTableData ( int nId, const wchar_t **pVsString, int *pLength ) {

   HINSTANCE hInstance = GetResourceInstance () ;
   HINSTANCE hSatelliteInstance = GetSatelliteResourceInstance () ;
   int nLangId = GetResourceLanguage () ;

   if ( hSatelliteInstance        && ! GetStringTableDataSub ( nId, pVsString, pLength, hSatelliteInstance, nLangId ) ) return 0 ;
   if ( 1                         && ! GetStringTableDataSub ( nId, pVsString, pLength, hInstance, nLangId ) ) return 0 ;
   if ( nLangId != LANGID_ENGLISH && ! GetStringTableDataSub ( nId, pVsString, pLength, hInstance, LANGID_ENGLISH ) ) return 0 ;
   if ( nLangId != LANGID_NEUTRAL && ! GetStringTableDataSub ( nId, pVsString, pLength, hInstance, LANGID_NEUTRAL ) ) return 0 ;

   return 1 ;
}



// 񃊃\[X擾iANSIŁj
// obt@̃TCYȂƂ́A؂l߂
// \[X{̒̕ԂiI[k܂܂Ȃj
// s 0 Ԃ
int LoadStringExA ( int nId, char *szBuffer, int nBufferSize ) {

   if ( ! szBuffer ) return 0 ;
   if ( nBufferSize ) *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return 0 ;

   if ( nLength && ! *( szString + nLength - 1 ) ) nLength -- ;

   return (int) w2alcpylen ( szBuffer, szString, nLength, nBufferSize ) ;
}



// 񃊃\[X擾iUNICODEŁj
// obt@̃TCYȂƂ́A؂l߂
// \[X{̒̕ԂiI[k܂܂Ȃj
// s 0 Ԃ
// Win95/98/Me łgp
int LoadStringExW ( int nId, wchar_t *szBuffer, int nBufferSize ) {

   if ( ! szBuffer ) return 0 ;
   if ( nBufferSize ) *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return 0 ;

   if ( nLength && ! *( szString + nLength - 1 ) ) nLength -- ;

   return (int) wcslcpylen ( szBuffer, szString, nLength, nBufferSize ) ;
}



// 񃊃\[X擾iANSIŁj
// \[XȂ΁A[̕Ԃ
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
const char *GetStringA ( int nId ) {

   THREAD_DATA *pThreadData = GetThreadData () ;
   if ( ! pThreadData ) return "" ;

   free ( pThreadData->szGetStringA ) ;
   pThreadData->szGetStringA = NULL ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return "" ;

   if ( nLength && ! *( szString + nLength - 1 ) ) nLength -- ;
   if ( ! nLength ) return "" ;

   pThreadData->szGetStringA = w2aduplen ( szString, nLength ) ;

   if ( ! pThreadData->szGetStringA ) return "" ;
   return pThreadData->szGetStringA ;
}



// 񃊃\[X擾iUNICODEŁj
// \[XȂ΁A[̕Ԃ
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
// Win95/98/Me łgp
const wchar_t *GetStringW ( int nId ) {

   THREAD_DATA *pThreadData = GetThreadData () ;
   if ( ! pThreadData ) return L"" ;

   free ( pThreadData->szGetStringW ) ;
   pThreadData->szGetStringW = NULL ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return L"" ;

   if ( nLength && ! *( szString + nLength - 1 ) ) return szString ;
   if ( ! nLength ) return L"" ;

   pThreadData->szGetStringW = wcsduplen ( szString, nLength ) ;

   if ( ! pThreadData->szGetStringW ) return L"" ;
   return pThreadData->szGetStringW ;
}



// [mۂĕ񃊃\[X擾iANSIŁj
// free() gĉ邱
// \[XȂ΁ANULL Ԃ
char *GetStringAllocA ( int nId ) {

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return NULL ;

   if ( nLength && ! *( szString + nLength - 1 ) ) nLength -- ;
   if ( ! nLength ) return NULL ;

   return w2aduplen ( szString, nLength ) ;
}



// [mۂĕ񃊃\[X擾iUNICODEŁj
// free() gĉ邱
// \[XȂ΁ANULL Ԃ
// Win95/98/Me łgp
wchar_t *GetStringAllocW ( int nId ) {

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return NULL ;

   if ( nLength && ! *( szString + nLength - 1 ) ) nLength -- ;
   if ( ! nLength ) return NULL ;

   return wcsduplen ( szString, nLength ) ;
}



#endif // ! defined NOCRT



////////////////////////////////////////
//         o[W\[X         //
////////////////////////////////////////



// VS_VERSIONINFO, StringFileInfo, StringTable, String,...etc
#pragma pack(2)
typedef struct {
   unsigned short wLength ;
   unsigned short wValueLength ;
   unsigned short wType ;
   wchar_t szKey [ 1 ] ;
   // ȉȗ
} VS_TABLE ;
#pragma pack()



#define RoundUp(n,r)       (((n)+(r)-1)&~((r)-1))           // 2 ̙p r ̔{ɐ؂グ
#define RoundUpLong(Size)  RoundUp ( Size, sizeof(long) )   // 32rbgEɐ؂グ

#define GetVsValue(pVs)    ( (const void*)     ( (pVs->wValueLength) ? ( (char*)pVs + RoundUpLong ( (char*)( wcsend ( pVs->szKey ) + 1 ) - (char*)pVs ) ) : NULL ) )
#define GetVsChildren(pVs) ( (const VS_TABLE*) ( (char*)pVs + RoundUpLong ( (char*)( wcsend ( pVs->szKey ) + 1 ) - (char*)pVs ) + RoundUpLong ( pVs->wValueLength << ( (pVs->wType)? 1 : 0 ) ) ) )
#define GetVsNext(pVs)     ( (const VS_TABLE*) ( (char*)pVs + RoundUpLong ( pVs->wLength ) ) )
#define GetVsEnd(pVs)      ( (const VS_TABLE*) ( (char*)pVs + pVs->wLength ) )



// \[X VS_TABLE ւ̃|C^擾
// o[W\[XȂ NULL Ԃ
static const VS_TABLE *GetVersionInfo ( void ) {

   HINSTANCE hInstance = GetResourceInstance () ;

   HRSRC hRsrc ;
   if ( 1 ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_VERSION ), MAKEINTRESOURCEW ( VS_VERSION_INFO ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   else     hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_VERSION ), MAKEINTRESOURCEA ( VS_VERSION_INFO ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   if ( ! hRsrc ) return NULL ;

   HGLOBAL hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( ! hGlobal ) return NULL ;

   const VS_TABLE *pVsVersionInfo = (const VS_TABLE*) LockResource ( hGlobal ) ;
   if ( ! pVsVersionInfo ) return NULL ;

   return pVsVersionInfo ;
}



// o[W擾
//  0 As 0 ȊOԂ
int GetFileVersion ( FILEVERSION *pFileVersion ) {

   const VS_TABLE *pVsVersionInfo = GetVersionInfo () ;
   if ( ! pVsVersionInfo ) return 1 ;

   const VS_FIXEDFILEINFO *pFixedFileInfo = (const VS_FIXEDFILEINFO*) GetVsValue ( pVsVersionInfo ) ;
   if ( ! pFixedFileInfo ) return 1 ;

   pFileVersion->wMajor = HIWORD ( pFixedFileInfo->dwProductVersionMS ) ;
   pFileVersion->wMinor = LOWORD ( pFixedFileInfo->dwProductVersionMS ) ;
   pFileVersion->wBuild = HIWORD ( pFixedFileInfo->dwProductVersionLS ) ;
   pFileVersion->wPrivate = LOWORD ( pFixedFileInfo->dwProductVersionLS ) ;

   return 0 ;
}



// o[Wr
int CompareFileVersion ( const FILEVERSION *pFileVersion1, const FILEVERSION *pFileVersion2 ) {

   if ( pFileVersion1->wMajor != pFileVersion2->wMajor ) return (short) ( pFileVersion1->wMajor - pFileVersion2->wMajor ) ;
   if ( pFileVersion1->wMinor != pFileVersion2->wMinor ) return (short) ( pFileVersion1->wMinor - pFileVersion2->wMinor ) ;
   if ( pFileVersion1->wBuild != pFileVersion2->wBuild ) return (short) ( pFileVersion1->wBuild - pFileVersion2->wBuild ) ;
   if ( pFileVersion1->wPrivate != pFileVersion2->wPrivate ) return (short) ( pFileVersion1->wPrivate - pFileVersion2->wPrivate ) ;

   return 0 ;
}



// o[W wMajor  wMinor 𐮐ɕϊ
// wMinor  99 Ƃ
int TranslateVersionInfo ( const FILEVERSION *pFileVersion ) {

   int nMajor = pFileVersion->wMajor ;
   int nMinor = pFileVersion->wMinor ;

   if ( nMinor > 99 ) nMinor = 99 ;

   return  nMajor * 100 + nMinor ;
}



////////////////////////////////////////
//      o[W\[Xi񋓁j    //
////////////////////////////////////////



// R[obN֐ 0 ԂA񋓂~
//                    0 ȊOԂA񋓂p
// szKey  NULL Ȃ pValue ɂ 32rbg̐
//     łȂȂ pValue ɂ Unicode  ܂ NULL 
static int EnumVsTable ( int nLevel, const VS_TABLE *pVsTable, int ( CALLBACK *Callback ) ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ), LPARAM lParam ) {

   if ( pVsTable->wType ) {
      if ( ! Callback ( nLevel, pVsTable->szKey, (const wchar_t*) GetVsValue ( pVsTable ), NULL, pVsTable->wValueLength, lParam ) ) return 0 ;
   }
   else {
      if ( ! Callback ( nLevel, pVsTable->szKey, NULL, (const long*) GetVsValue ( pVsTable ), ( pVsTable->wValueLength / sizeof(long) ), lParam ) ) return 0 ;
   }

   const VS_TABLE *pChildStart = GetVsChildren ( pVsTable ) ;
   const VS_TABLE *pChildEnd = GetVsEnd ( pVsTable ) ;

   for ( const VS_TABLE *pChild = pChildStart ; pChild < pChildEnd ; pChild = GetVsNext ( pChild ) ) {
      if ( ! EnumVsTable ( nLevel + 1, pChild, Callback, lParam ) ) return 0 ;
   }

   return 1 ;
}



// o[W
//  0 As 0 ȊOԂ
int EnumVersionInfo ( int ( CALLBACK *Callback ) ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ), LPARAM lParam ) {

   const VS_TABLE *pVsVersionInfo = GetVersionInfo () ;
   if ( ! pVsVersionInfo ) return 1 ;

   EnumVsTable ( 0, pVsVersionInfo, Callback, lParam ) ;

   return 0 ;
}



#if ! defined NOCRT
////////////////////////////////////////
//   o[W\[Xi쌠\j //
////////////////////////////////////////



// \[X̒쌠\擾iANSIŁj
// ̌̏񂪂΁Aŏ̌̏Ԃ
// \[XȂ΁A[̕Ԃ
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
const char *GetVersionCopyrightA ( void ) {

   THREAD_DATA *pThreadData = GetThreadData () ;
   if ( ! pThreadData ) return "" ;

   free ( pThreadData->szCopyrightA ) ;
   pThreadData->szCopyrightA = NULL ;

   const wchar_t *szString = GetVersionCopyrightW () ;

   pThreadData->szCopyrightA = w2adup ( szString ) ;

   if ( ! pThreadData->szCopyrightA ) return "" ;
   return pThreadData->szCopyrightA ;
}



typedef struct {
   int IsStringFileInfo ;
   const wchar_t *szResult ;
} SEARCH_COPYRIGHT_INFO ;



static int CALLBACK CallbackSearchCopyRight ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ) {

   SEARCH_COPYRIGHT_INFO *pSearchCopyrightInfo = (SEARCH_COPYRIGHT_INFO*) lParam ;

   if ( ! szKey ) return 1 ;

   if ( nLevel == 1 ) {
      if ( ! wcscmp ( szKey, L"StringFileInfo" ) ) pSearchCopyrightInfo->IsStringFileInfo = 1 ;
      else                                         pSearchCopyrightInfo->IsStringFileInfo = 0 ;
   }

   if ( nLevel == 3 ) {
      if ( pSearchCopyrightInfo->IsStringFileInfo && ! wcscmp ( szKey, L"LegalCopyright" ) ) {
         pSearchCopyrightInfo->szResult = (const wchar_t*) szValue ;
         return 0 ;
      }
   }

   return 1 ;
}



// \[X̒쌠\擾iUNICODEŁj
// ̌̏񂪂΁Aŏ̌̏Ԃ
// \[XȂ΁A[̕Ԃ
// Win95/98/Me łgp
const wchar_t *GetVersionCopyrightW ( void ) {

   SEARCH_COPYRIGHT_INFO SearchCopyrightInfo = { 0 } ;
   EnumVersionInfo ( CallbackSearchCopyRight, (LPARAM) & SearchCopyrightInfo ) ;
   if ( ! SearchCopyrightInfo.szResult ) return L"" ;

   return SearchCopyrightInfo.szResult ;
}



#endif // ! defined NOCRT



#if ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT
////////////////////////////////////////
//          ACR\[X          //
////////////////////////////////////////



// CfbNXAs 0 Ԃ
static int GetIconDataIndex ( int nId, int nX, int nY, HINSTANCE hInstance, int nLangId ) {

   HRSRC hRsrc ;
   if ( 1 ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_GROUP_ICON ), MAKEINTRESOURCEW ( nId ), (LANGID) nLangId ) ;
   else     hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_GROUP_ICON ), MAKEINTRESOURCEA ( nId ), (LANGID) nLangId ) ;
   if ( ! hRsrc ) return 0 ;

   HGLOBAL hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( ! hGlobal ) return 0 ;

   unsigned char *pData = (unsigned char*) LockResource ( hGlobal ) ;
   if ( ! pData ) return 0 ;

   return LookupIconIdFromDirectoryEx ( pData, TRUE, nX, nY, LR_DEFAULTCOLOR ) ;
}



// nhAs 0 Ԃ
static HICON GetIconDataHandle ( int nId, int nX, int nY, HINSTANCE hInstance, int nLangId ) {

   HRSRC hRsrc ;
   if ( 1 ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_ICON ), MAKEINTRESOURCEW ( nId ), (LANGID) nLangId ) ;
   else     hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_ICON ), MAKEINTRESOURCEA ( nId ), (LANGID) nLangId ) ;
   if ( ! hRsrc ) return NULL ;

   HGLOBAL hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( ! hGlobal ) return NULL ;

   unsigned char *pData = (unsigned char*) LockResource ( hGlobal ) ;
   if ( ! pData ) return NULL ;

   return CreateIconFromResourceEx ( pData, SizeofResource ( hInstance, hRsrc ), TRUE, 0x00030000, nX, nY, LR_DEFAULTCOLOR ) ;
}



// GetIconData ̉֐
//  0 As 0 ȊOԂ
static int GetIconDataSub ( int nId, int nX, int nY, HICON *pIcon, HINSTANCE hInstance, int nLangId ) {

   int nIndex = GetIconDataIndex ( nId, nX, nY, hInstance, nLangId ) ;
   if ( ! nIndex ) return 1 ;

   HICON hIcon = GetIconDataHandle ( nIndex, nX, nY, hInstance, nLangId ) ;
   if ( ! hIcon ) return 1 ;

   *pIcon = hIcon ;

   return 0 ;
}



// GetIconEx ̉֐
//  0 As 0 ȊOԂ
static int GetIconData ( int nId, int nX, int nY, HICON *pIcon ) {

   HINSTANCE hInstance = GetResourceInstance () ;
   HINSTANCE hSatelliteInstance = GetSatelliteResourceInstance () ;
   int nLangId = GetResourceLanguage () ;

   if ( hSatelliteInstance        && ! GetIconDataSub ( nId, nX, nY, pIcon, hSatelliteInstance, nLangId ) ) return 0 ;
   if ( 1                         && ! GetIconDataSub ( nId, nX, nY, pIcon, hInstance, nLangId ) ) return 0 ;
   if ( nLangId != LANGID_ENGLISH && ! GetIconDataSub ( nId, nX, nY, pIcon, hInstance, LANGID_ENGLISH ) ) return 0 ;
   if ( nLangId != LANGID_NEUTRAL && ! GetIconDataSub ( nId, nX, nY, pIcon, hInstance, LANGID_NEUTRAL ) ) return 0 ;

   return 1 ;
}



// ACRԂ
// nX, nY  0 w肷ƁAVXẽTCYŎ擾
// gp DestroyIcon Ŕp邱
// s NULL Ԃ
HICON GetIconEx ( int nId, int nX, int nY ) {

   HICON hIcon ;
   if ( GetIconData ( nId, nX, nY, & hIcon ) ) return NULL ;

   return hIcon ;
}



#endif // ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT



#if ! defined NOCRT
////////////////////////////////////////
//         _CAO\[X         //
////////////////////////////////////////



#pragma pack(2)
typedef struct {
   unsigned short dlgVer ;
   unsigned short signature ;
   unsigned long helpID ;
   unsigned long exStyle ;
   unsigned long style ;
   unsigned short cDlgItems ;
   short x ;
   short y ;
   short cx ;
   short cy ;
   // ȉȗ
} DLGTEMPLATEEX ;
#pragma pack()



// GetDialog ̉֐
//  0 ԂAʂ ppDlg Ɋi[
// s 0 ȊOԂ
static int GetDialogSub ( int nTemplate, const DLGTEMPLATE **ppDlg, HINSTANCE *pInstance, HINSTANCE hInstance, int nLangId ) {

   HRSRC hRsrc ;
   if ( 1 ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_DIALOG ), MAKEINTRESOURCEW ( nTemplate ), (LANGID) nLangId ) ;
   else     hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_DIALOG ), MAKEINTRESOURCEA ( nTemplate ), (LANGID) nLangId ) ;
   if ( ! hRsrc ) return 1 ;

   HGLOBAL hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( ! hGlobal ) return 1 ;

   const DLGTEMPLATE *pDlg = (const DLGTEMPLATE*) LockResource ( hGlobal ) ;
   if ( ! pDlg ) return 1 ;

   *ppDlg = pDlg ;

   if ( pInstance ) {      // _CAOĂяo֐Ŏgp邽
      if ( ! hInstance ) {
         if ( IsNT () ) hInstance = GetModuleHandleW ( NULL ) ;
         else           hInstance = GetModuleHandleA ( NULL ) ;
      }
      *pInstance = hInstance ;
   }

   return 0 ;
}



// \[X̃_CAOev[g̃AhX擾
// _CAOȂ NULL Ԃ
static const DLGTEMPLATE *GetDialog ( int nTemplate, HINSTANCE *pInstance ) {

   HINSTANCE hInstance = GetResourceInstance () ;
   HINSTANCE hSatelliteInstance = GetSatelliteResourceInstance () ;
   int nLangId = GetResourceLanguage () ;

   const DLGTEMPLATE *pDlg ;

   if ( hSatelliteInstance        && ! GetDialogSub ( nTemplate, & pDlg, pInstance, hSatelliteInstance, nLangId ) ) return pDlg ;
   if ( 1                         && ! GetDialogSub ( nTemplate, & pDlg, pInstance, hInstance, nLangId ) ) return pDlg ;
   if ( nLangId != LANGID_ENGLISH && ! GetDialogSub ( nTemplate, & pDlg, pInstance, hInstance, LANGID_ENGLISH ) ) return pDlg ;
   if ( nLangId != LANGID_NEUTRAL && ! GetDialogSub ( nTemplate, & pDlg, pInstance, hInstance, LANGID_NEUTRAL ) ) return pDlg ;

   return NULL ;
}



// _CAÕev[gtHg擾iANSIŁj
//  0 As 0 ȊOԂ
int GetDialogFontA ( int nTemplate, DIALOGFONTA *pDialogFont ) {

   DIALOGFONTW DialogFont ;
   if ( GetDialogFontW ( nTemplate, & DialogFont ) ) return 1 ;

   pDialogFont->nHeight = DialogFont.nHeight ;
   pDialogFont->nWeight = DialogFont.nWeight ;
   pDialogFont->IsItalic = DialogFont.IsItalic ;
   pDialogFont->nCharSet = DialogFont.nCharSet ;

   w2alcpylen ( pDialogFont->szFaceName, DialogFont.szFaceName, (size_t) -1, LF_FACESIZE ) ;

   return 0 ;
}



// _CAÕev[gtHg擾iUNICODEŁj
//  0 As 0 ȊOԂ
int GetDialogFontW ( int nTemplate, DIALOGFONTW *pDialogFont ) {

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate, NULL ) ;
   if ( ! pDlg ) return 1 ;

   const DLGTEMPLATEEX *pDlgEx = (const DLGTEMPLATEEX*) pDlg ;
   if ( pDlgEx->signature != 0xFFFF ) pDlgEx = NULL ;

   const wchar_t *szMenu ;
   if ( pDlgEx ) {
      if ( ! ( pDlgEx->style & DS_SETFONT ) ) return 1 ;
      szMenu = (const wchar_t*) ( pDlgEx + 1 ) ;
   }
   else {
      if ( ! ( pDlg->style & DS_SETFONT ) ) return 1 ;
      szMenu = (const wchar_t*) ( pDlg + 1 ) ;
   }

   const wchar_t *szClass ;
   if ( *szMenu == 0xFFFF ) szClass = szMenu + 2 ;
   else                     szClass = wcsend ( szMenu ) + 1 ;

   const wchar_t *szTitle ;
   if ( *szClass == 0xFFFF ) szTitle = szClass + 2 ;
   else                      szTitle = wcsend ( szClass ) + 1 ;

   const wchar_t *pFontInfo = wcsend ( szTitle ) + 1 ;

   const wchar_t *szFaceName ;
   if ( pDlgEx ) {
      pDialogFont->nHeight = pFontInfo [ 0 ] ;
      pDialogFont->nWeight = pFontInfo [ 1 ] ;
      pDialogFont->IsItalic = LOBYTE ( pFontInfo [ 2 ] ) ;
      pDialogFont->nCharSet = HIBYTE ( pFontInfo [ 2 ] ) ;
      szFaceName = pFontInfo + 3 ;
   }
   else {
      pDialogFont->nHeight = pFontInfo [ 0 ] ;
      pDialogFont->nWeight = FW_DONTCARE ;
      pDialogFont->IsItalic = 0 ;
      pDialogFont->nCharSet = DEFAULT_CHARSET ;
      szFaceName = pFontInfo + 1 ;
   }

   wcslcpylen ( pDialogFont->szFaceName, szFaceName, (size_t) -1, LF_FACESIZE ) ;

   return 0 ;
}



// _CAÕtHg̍擾
// tHgTCYAs 0 Ԃ
int GetDialogFontHeight ( int nTemplate ) {

   DIALOGFONTW DialogFont ;
   if ( GetDialogFontW ( nTemplate, & DialogFont ) ) return 0 ;

   return DialogFont.nHeight ;
}



#endif // ! defined NOCRT



#if ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT
////////////////////////////////////////
//          _CAŐN          //
////////////////////////////////////////



// P[ɉă_CAONiANSIŁj
// s畉Ԃ
INT_PTR DialogBoxParamExA ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) {

   HINSTANCE hInstance ;
   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate, & hInstance ) ;
   if ( ! pDlg ) return -1 ;

   return DialogBoxIndirectParamA ( hInstance, pDlg, hWnd, pDialogProc, lParam ) ;
}



// P[ɉă_CAONiUNICODEŁj
// s畉Ԃ
INT_PTR DialogBoxParamExW ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) {

   HINSTANCE hInstance ;
   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate, & hInstance ) ;
   if ( ! pDlg ) return -1 ;

   return DialogBoxIndirectParamW ( hInstance, pDlg, hWnd, pDialogProc, lParam ) ;
}



// P[ɉă[hX_CAONiANSIŁj
// s NULL Ԃ
HWND CreateDialogParamExA ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) {

   HINSTANCE hInstance ;
   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate, & hInstance ) ;
   if ( ! pDlg ) return NULL ;

   return CreateDialogIndirectParamA ( hInstance, pDlg, hParent, pDialogProc, lParam ) ;
}



// P[ɉă[hX_CAONiUNICODEŁj
// s NULL Ԃ
HWND CreateDialogParamExW ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) {

   HINSTANCE hInstance ;
   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate, & hInstance ) ;
   if ( ! pDlg ) return NULL ;

   return CreateDialogIndirectParamW ( hInstance, pDlg, hParent, pDialogProc, lParam ) ;
}



#endif // ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT



