// rtfconv_opt.h

#ifndef RTFCONV_OPT_H
#define RTFCONV_OPT_H


#ifndef RTFCONV_OPT_GLOBAL
#define RTFCONV_OPT_GLOBAL(type,name)              extern type name
#endif

#ifndef RTFCONV_OPT_GLOBAL_INIT
#define RTFCONV_OPT_GLOBAL_INIT(type,name,init)    extern type name
#endif

#ifndef RTFCONV_OPT_GLOBAL_ARRAY
#define RTFCONV_OPT_GLOBAL_ARRAY(type,name,size)   extern type name []
#endif



// obt@̒
#define SHORTSTRING_MAX             0x80
#define MESSAGE_BUFFER_SIZE         ( MAX_PATH * 2 )
#define OPTION_FILE_LINE_BUFFER     __max ( ( MAX_PATH * 4 ) + 0x40, ( UNICODE_BLOCK_NELEM * 4 ) + 0x40 )
#define LANGID_ARRAY_SIZE           ( UNICODE_BLOCK_NELEM * sizeof(unsigned short) )
#define FONTNAME_ARRAY_SIZE         ( LF_FACESIZE * UNICODE_BLOCK_NELEM * sizeof(char) )



#if defined RTFCONV_EXE
// [UC^[tFCX̃t@C
#define MUILANG_PREFIX_A          "rtfc_"
#define MUILANG_PREFIX_W         L"rtfc_"
#endif



#if defined RTFCONV_EXE
// R[hy[W̑I
typedef struct {
   int nCodePage ;
   int nNameId ;
} CODEPAGE ;

extern const CODEPAGE AvailableCodeList [] ;
extern const int AVAILABLE_CODE_LIST_NELEM ;

extern const CODEPAGE MultiByteCodeList [] ;
extern const int MULTIBYTE_CODE_LIST_NELEM ;
#endif


#if defined RTFCONV_COM
// R[hy[W̑I
typedef struct {
   int nCodePage ;
   const char *szCodeName ;
} CODEPAGE_NAME ;

extern const CODEPAGE_NAME CodePageNameList [] ;
extern const int CODEPAGE_NAME_LIST_NELEM ;
#endif


#if defined RTFCONV_EXE
// ꎯʎq̑I
typedef struct {
   int nLangId ;
   const wchar_t *szName ;
} LANGID_NAME ;

extern const LANGID_NAME LangIdNameList [] ;
extern const int LANGID_NAME_LIST_NELEM ;
#endif



#if defined RTFCONV_COM
// R}hCł̕ϐ
RTFCONV_OPT_GLOBAL ( int, IsOutputNumber ) ;
RTFCONV_OPT_GLOBAL ( int, IsOneQuestionMark ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoVariantEuropean ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoVariantKanji ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputNumberHtml ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputNumberMsc ) ;
RTFCONV_OPT_GLOBAL ( int, IsVariantOnlyRoundTrip ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoGbk ) ;
RTFCONV_OPT_GLOBAL ( int, IsGb18030 ) ;
RTFCONV_OPT_GLOBAL ( const char *, szUnmappableCharFormat ) ;
#endif

#if defined RTFCONV_EXE
// _CAOŗp̕ϐ
RTFCONV_OPT_GLOBAL_INIT ( int, nSrcType, TYPE_RTF ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nDstType, TYPE_TXT ) ;
RTFCONV_OPT_GLOBAL ( int, nSrcCode ) ; // z AvailableCodeList ̔ԍ
RTFCONV_OPT_GLOBAL ( int, nDstCode ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultAsciiFont,                DEFAULT_EUROPEAN_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultJapaneseFont,             DEFAULT_JAPANESE_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultChineseSimplifiedFont,    DEFAULT_CHINESE_SIMPLIFIED_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultChineseTraditionalFont,   DEFAULT_CHINESE_TRADITIONAL_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultKoreanFont,               DEFAULT_KOREAN_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultThaiFont,                 DEFAULT_THAI_FONT ) ;
RTFCONV_OPT_GLOBAL_INIT ( const char *, szDefaultGb18030Font,              DEFAULT_GB18030_FONT ) ;
#endif



// IvVt@C
#define CFG_FILENAME_A      "rtfconv.cfg"
#define CFG_FILENAME_W     L"rtfconv.cfg"
#if defined RTFCONV_EXE || defined SETUP_R
RTFCONV_OPT_GLOBAL ( int, IsOptionChanged ) ;      // IvVύX
RTFCONV_OPT_GLOBAL ( int, IsOptionReadOnly ) ;
RTFCONV_OPT_GLOBAL ( int, IsSavePath ) ;
RTFCONV_OPT_GLOBAL ( int, IsSaveCode ) ;
RTFCONV_OPT_GLOBAL ( int, IsSaveWindow ) ;
RTFCONV_OPT_GLOBAL ( int, IsIgnoreSaveWindow ) ;
#endif
RTFCONV_OPT_GLOBAL ( int, IsLangIdUserDefined ) ;        // ꎯʎq[Uݒ



// ̃IvV
RTFCONV_OPT_GLOBAL ( int, IsNoVariant ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoHanKana ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoZenAlpha ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoZenSpace ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoZenSymbol ) ;
RTFCONV_OPT_GLOBAL ( int, IsYenNoBackslash ) ;
RTFCONV_OPT_GLOBAL ( int, nUnmappableCharFormat ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputNumberSurrogate ) ;
RTFCONV_OPT_GLOBAL ( int, IsInputNumberHtml ) ;
RTFCONV_OPT_GLOBAL ( int, IsInputNumberC ) ;
RTFCONV_OPT_GLOBAL ( int, IsConvertPua ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoByteOrderMark ) ;
RTFCONV_OPT_GLOBAL ( int, IsUtf8ByteOrderMark ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputRuby ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputLink ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputHidden ) ;
RTFCONV_OPT_GLOBAL ( int, IsEndianAuto ) ;
RTFCONV_OPT_GLOBAL ( int, IsDeleteEof ) ;
RTFCONV_OPT_GLOBAL ( int, IsUseSameFont ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nFontSize, DEFAULT_FONT_SIZE ) ;
RTFCONV_OPT_GLOBAL ( int, nDefaultCjkCodePage ) ;
RTFCONV_OPT_GLOBAL ( int, IsUseArray ) ;
RTFCONV_OPT_GLOBAL ( int, IsNotUseArray ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, IsOutputCR, 1 ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, IsOutputLF, 1 ) ;
RTFCONV_OPT_GLOBAL ( int, IsInputJisNoVendor ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputJisNoVendor ) ;
RTFCONV_OPT_GLOBAL ( int, IsInputJisMac ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputJisMac ) ;
RTFCONV_OPT_GLOBAL ( int, IsInputJis2004 ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputJis2004 ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoJis83New ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoJis83Old ) ;
RTFCONV_OPT_GLOBAL ( int, IsEucOutputHojo ) ;
RTFCONV_OPT_GLOBAL ( int, IsOverlineNoTilde ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, IsGbOutput, 1 ) ;         // 0: GB2312,  1: GBK,  2: GB18030
RTFCONV_OPT_GLOBAL ( int, IsPua2Hkscs ) ;
RTFCONV_OPT_GLOBAL ( int, IsHkscsCjka2Pua ) ;
RTFCONV_OPT_GLOBAL ( int, IsHkscsCjkb2Pua ) ;
RTFCONV_OPT_GLOBAL ( int, IsHkscsCjk412Pua ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputHkscs1999 ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputHkscs2001 ) ;
RTFCONV_OPT_GLOBAL ( int, IsOutputHkscs2004 ) ;
RTFCONV_OPT_GLOBAL ( int, IsGbk2Pua ) ;
RTFCONV_OPT_GLOBAL ( int, IsPua2Gbk ) ;
RTFCONV_OPT_GLOBAL ( int, IsGbkOutputFantizi ) ;
RTFCONV_OPT_GLOBAL ( int, IsKsNoUhc ) ;
RTFCONV_OPT_GLOBAL ( int, IsConvKsPunc ) ;
RTFCONV_OPT_GLOBAL ( int, IsRtfFontXp ) ;
RTFCONV_OPT_GLOBAL ( int, IsRtfFontVista ) ;
#if defined RTFCONV_EXE || defined SETUP_R
RTFCONV_OPT_GLOBAL ( int, IsNoConfirm ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoRecycle ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoMessage ) ;
RTFCONV_OPT_GLOBAL ( int, IsNoAddExtension ) ;
RTFCONV_OPT_GLOBAL ( int, IsConfirmOnExit ) ;
RTFCONV_OPT_GLOBAL ( int, nSavedMuiLangId ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nSavedSrcType, -1 ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nSavedDstType, -1 ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nSavedSrcCode, -1 ) ;
RTFCONV_OPT_GLOBAL_INIT ( int, nSavedDstCode, -1 ) ;
RTFCONV_OPT_GLOBAL ( int, nSavedWindowX ) ;
RTFCONV_OPT_GLOBAL ( int, nSavedWindowY ) ;
#endif

// ̃IvV
RTFCONV_OPT_GLOBAL_ARRAY ( char, szEuropeanFont,            FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szJapaneseFont,            FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szKoreanFont,              FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szChineseSimplifiedFont,   FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szChineseTraditionalFont,  FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szThaiFont,                FONTNAME_MAX ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( char, szFontNameArrayDummy,      FONTNAME_MAX ) ;
#if defined RTFCONV_EXE || defined SETUP_R
RTFCONV_OPT_GLOBAL_ARRAY ( char, szBrowsePathA,             MAX_PATH ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( wchar_t, szBrowsePathW,          MAX_PATH ) ;
#endif

// UNICODEubNʂ̃IvV
RTFCONV_OPT_GLOBAL ( char *, FontNameArray ) ;
RTFCONV_OPT_GLOBAL_ARRAY ( unsigned short, LangIdArray, UNICODE_BLOCK_NELEM ) ;



// IvVt@C̓ǂݎ



typedef struct {
   int *nValue ;
   const char *szName ;
} OPTION_INTEGER ;

extern const OPTION_INTEGER OptionIntegerList [] ;
extern const int OPTION_INTEGER_LIST_NELEM ;


typedef struct {
   char *szValue ;
   const char *szName ;
   int nMaxSize ;
} OPTION_STRING_A ;


extern const OPTION_STRING_A OptionStringListA [] ;
extern const int OPTION_STRING_LIST_A_NELEM ;


typedef struct {
   wchar_t *szValue ;
   const char *szName ;
   int nMaxSize ;
} OPTION_STRING_W ;

extern const OPTION_STRING_W OptionStringListW [] ;
extern const int OPTION_STRING_LIST_W_NELEM ;


typedef struct {
   unsigned short *pValue ;
   const char *szName ;
   int nSize ;
} OPTION_BINARY ;

extern const OPTION_BINARY OptionBinaryList [] ;
extern const int OPTION_BINARY_LIST_NELEM ;



// ԍ̏o̓X^C̑I
typedef struct {
   int nNameId ;
   const char *szFormat ;
} UNMAPPABLE_CHAR_FORMAT ;


extern const UNMAPPABLE_CHAR_FORMAT UnmappableCharFormatList [] ;
extern const int UNMAPPABLE_CHAR_FORMAT_LIST_NELEM ;



// R}hC̕ϊ[hIvVp (-m*)
extern const OPTION_INTEGER ModeOptionNameList [] ;
extern const int MODE_OPTION_NAME_LIST_NELEM ;



// dummy
#if defined RTFCONV_COM || defined SETUP_R
#define IDS_UNMAPPABLE_CHAR_FORMAT_0   0
#define IDS_UNMAPPABLE_CHAR_FORMAT_1   1
#define IDS_UNMAPPABLE_CHAR_FORMAT_2   2
#define IDS_UNMAPPABLE_CHAR_FORMAT_3   3
#define IDS_UNMAPPABLE_CHAR_FORMAT_4   4
#define IDS_UNMAPPABLE_CHAR_FORMAT_5   5
#define IDS_UNMAPPABLE_CHAR_FORMAT_6   6
#define IDS_UNMAPPABLE_CHAR_FORMAT_7   7
#define IDS_UNMAPPABLE_CHAR_FORMAT_8   8
#define IDS_UNMAPPABLE_CHAR_FORMAT_9   9
#define IDS_UNMAPPABLE_CHAR_FORMAT_10  10
#define IDS_UNMAPPABLE_CHAR_FORMAT_11  11
#endif



// IvV̖|
unsigned long TranslateConversionMode ( int nSrcCodePage, int nDstCodePage ) ;
unsigned long TranslateAdditionalMode ( int nSrcCodePage, int nDstCodePage ) ;



#endif


