// setup_r.cpp : rtfconvpCXg[

#include <windows.h>
#include <shlobj.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "msc.h"

#include "access.h"
#include "brsfolder.h"
#include "codepage.h"
#include "execute.h"
#include "filename.h"
#include "mkdir.h"
#include "mvwnd.h"
#include "oemio.h"
#include "reg.h"
#include "res.h"
#include "resource.h"
#include "sendmsg.h"
#include "shfolder.h"
#include "shortcut.h"
#include "stringex.h"
#include "tmpfile.h"
#include "winmain.h"

#include "rtfconv.h"
#include "rtfconv_opt.h"
#include "uniblock.h"
#include "setup_r.h"
#include "conv_reg.h"
#include "conv_opt.h"
#include "conv_opt_old_r.h"



static int nOsCodePage ;         // OS̃R[hy[W

static char szCommandNameA [ MAX_PATH ] ;
static wchar_t szCommandNameW [ MAX_PATH ] ;

static char szInstallFolderA [ MAX_PATH ] ;
static wchar_t szInstallFolderW [ MAX_PATH ] ;


#define MAX_PATH_FOLDER          ( MAX_PATH - 0x20 )
#define MAX_PATH_FOLDER_PARENT   ( MAX_PATH - 0x40 )


// ANSIUNICODE̋pobt@
typedef union {
   char A [ MAX_PATH ] ;
   wchar_t W [ MAX_PATH ] ;
} FILENAME_BUFFER ;


typedef union {
   char A [ 0x2000 ] ;
   wchar_t W [ 0x2000 ] ;
} MESSAGE_BUFFER ;


int Install ( void ) ;
int PrepareUninstall ( void ) ;
int UninstallA ( const char *szInstallDir ) ;
int UninstallW ( const wchar_t *szInstallDir ) ;



int main ( int argc, char *argv [] ) {


   // for XP Visual Style
   InitCommonControls () ;

   // VXe擾
   nOsCodePage = GetACP () ;


   // ̏
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {
      char *szArgv = argv [ nCountArgv ] ;
      if ( *szArgv == '/' || *szArgv == '-' ) {
         switch ( szArgv [ 1 ] ) {
            case 'E' :
            case 'e' :
               SetResourceLanguage ( LANGID_ENGLISH ) ;
               break ;
            case 'L' :
            case 'l' :
               if ( *( szArgv + 2 ) ) {
                  char *szString ;
                  errno = 0 ;
                  int nLangId = strtoul ( szArgv + 2, & szString, 0x10 ) ;
                  if ( errno || *szString ) break ;
                  SetResourceLanguage ( nLangId ) ;
                  continue ;
               }
               break ;
            case 'R' :
            case 'r' :
               if ( argv [ nCountArgv + 1 ] && ! stricmp ( argv [ nCountArgv + 1 ], "/yes" ) ) {
                  if ( IsNT () ) UninstallW ( GetArgumentW ( nCountArgv + 2 ) ) ;
                  else           UninstallA ( GetArgumentA ( nCountArgv + 2 ) ) ;
               }
               else {
                  PrepareUninstall () ;
               }
               return 0 ;
            default :
               break ;
         }
      }
   }


   Install () ;
   return 0 ;
}



////////////////////////////////////////////////////////
//                   CXg[                     //
////////////////////////////////////////////////////////



INT_PTR CALLBACK DialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK EditDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
int InstallFileA ( HWND hWnd, const char *szFileName, const char *szFolderName ) ;
int InstallFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szFolderName ) ;
int DeleteOldFileA ( HWND hWnd, const char *szFileName, const char *szFolderName ) ;
int DeleteOldFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szFolderName ) ;
int UpdateConfigFile ( HWND hWnd, int nOldVersion ) ;
int MoveOldConfigFile ( HWND hWnd, int nOldVersion ) ;
int MakeBatchFileA ( const char *szFolderName, int IsForEnglish ) ;
int MakeBatchFileW ( const wchar_t *szFolderName, int IsForEnglish ) ;
int MakeShortcutA ( const char *szShortcutFolder, const char *szFolderName, int IsDesktop ) ;
int MakeShortcutW ( const wchar_t *szShortcutFolder, const wchar_t *szFolderName, int IsDesktop ) ;
int DeleteShortcutA ( void ) ;
int DeleteShortcutW ( void ) ;
int GetDllVersionA ( const char *szDllFileName ) ;
int GetDllVersionW ( const wchar_t *szDllFileName ) ;
int IsAdministrator ( void ) ;

int AdjustOld32bitRegistry ( HWND hWnd ) ;
int IsFoundAnotherBitRegistry ( void ) ;

#define X86_SUFFIX_W    ( ! IS_WIN64 && IsWin64 () ) ? L" (32-bit)" : L""
#define X86_SUFFIX_A    ( ! IS_WIN64 && IsWin64 () ) ?  " (32-bit)" :  ""



// CXg[s
int Install ( void ) {


   // 
   LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, MAX_PATH ) ;
   LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, MAX_PATH ) ;


   // ǗҌ邩H
   if ( IsNT () && ! IsAdministrator () ) {
      if ( IsNT () ) MessageBoxW ( NULL, GetStringW ( IDS_CANNOT_INSTALL ), szCommandNameW, MB_OK ) ;
      else           MessageBoxA ( NULL, GetStringA ( IDS_CANNOT_INSTALL ), szCommandNameA, MB_OK ) ;
      return 0 ;
   }


   // tH_擾
   if ( IsNT () ) {

      wchar_t *szString ;

      // ACXg[񂩂擾
      if ( ! GetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"UninstallString", szInstallFolderW, MAX_PATH_FOLDER, REG_MODE_NORMAL ) && ( szString = wcstokex ( szInstallFolderW, NULL ) ) && *szString ) {
         wcsmove ( szInstallFolderW, szString ) ;
         ChangeFileNameW ( szInstallFolderW, NULL ) ;
         SetPathSeparatorW ( szInstallFolderW, REMOVE_SEPARATOR_ALWAYS ) ;
      }
      // pX񂩂擾
      else if ( ! GetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_W, L"Path", szInstallFolderW, MAX_PATH_FOLDER, REG_MODE_NORMAL ) && *szInstallFolderW ) {
         // thru
      }
      // VKɎ擾
      else {
         if ( ! IsWin2000orLater () || GetSpecialFolderPathW ( NULL, szInstallFolderW, CSIDL_PROGRAM_FILES, 0 ) || ! *szInstallFolderW || wcslen ( szInstallFolderW ) >= MAX_PATH_FOLDER_PARENT ) {
            if ( GetRegStringW ( HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion", L"ProgramFilesDir", szInstallFolderW, MAX_PATH, REG_MODE_NORMAL ) || ! *szInstallFolderW || wcslen ( szInstallFolderW ) >= MAX_PATH_FOLDER_PARENT ) {
               if ( ! GetEnvironmentVariableW ( L"WINDIR", szInstallFolderW, MAX_PATH ) ) wcscpy ( szInstallFolderW, L"C:\\" ) ;
               wcscpy ( szInstallFolderW + 2, L"\\Program Files" ) ;
            }
         }
         SetPathSeparatorW ( szInstallFolderW, REMOVE_SEPARATOR_ALWAYS ) ;
         wcscat ( szInstallFolderW, L"\\Harigaya\\" ) ;
         wcscat ( szInstallFolderW, FOLDER_NAME_W ) ;
      }

   }
   else {

      char *szString ;

      // ACXg[񂩂擾
      if ( ! GetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "UninstallString", szInstallFolderA, MAX_PATH_FOLDER, REG_MODE_NORMAL ) && ( szString = strtokex ( szInstallFolderA, NULL ) ) && *szString ) {
         strmove ( szInstallFolderA, szString ) ;
         ChangeFileNameA ( szInstallFolderA, NULL ) ;
         SetPathSeparatorA ( szInstallFolderA, REMOVE_SEPARATOR_ALWAYS ) ;
      }
      // pX񂩂擾
      else if ( ! GetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_A, "Path", szInstallFolderA, MAX_PATH_FOLDER, REG_MODE_NORMAL ) && *szInstallFolderA ) {
         // thru
      }
      // VKɎ擾
      else {
         if ( ! IsWin2000orLater () || GetSpecialFolderPathA ( NULL, szInstallFolderA, CSIDL_PROGRAM_FILES, 0 ) || ! *szInstallFolderA || strlen ( szInstallFolderA ) >= MAX_PATH_FOLDER_PARENT ) {
            if ( GetRegStringA ( HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion", "ProgramFilesDir", szInstallFolderA, MAX_PATH, REG_MODE_NORMAL ) || ! *szInstallFolderA || strlen ( szInstallFolderA ) >= MAX_PATH_FOLDER_PARENT ) {
               if ( ! GetEnvironmentVariableA ( "WINDIR", szInstallFolderA, MAX_PATH ) ) strcpy ( szInstallFolderA, "C:\\" ) ;
               strcpy ( szInstallFolderA + 2, "\\Program Files" ) ;
            }
         }
         SetPathSeparatorA ( szInstallFolderA, REMOVE_SEPARATOR_ALWAYS ) ;
         strcat ( szInstallFolderA, "\\Harigaya\\" ) ;
         strcat ( szInstallFolderA, FOLDER_NAME_A ) ;
      }

   }


   // _CA[O\ACXg[s
   if ( IsNT () ) DialogBoxExW ( IDD_DIALOG_PROG, NULL, DialogProc ) ;
   else           DialogBoxExA ( IDD_DIALOG_PROG, NULL, DialogProc ) ;


   return 0 ;
}



// \Rg[
INT_PTR CALLBACK DialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static int nStep ;
   static int nOldVersion ;

   FILENAME_BUFFER FileName ;


   switch ( dwMessage ) {

      case WM_INITDIALOG :

         MoveWindowToCenter ( hWnd ) ;
         ShiftWindow ( hWnd ) ;
         MoveWindowTitleIntoDesktop ( hWnd ) ;

         if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s %s", GetStringW ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_W ) ;
         else           Wm_SetTextFormatA ( hWnd,  "%s %s", GetStringA ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_A ) ;

         if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_ASK_START ) ) ;
         else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_ASK_START ) ) ;

         MessageBeep ( MB_OK ) ;
         nStep = 0 ;
         return TRUE ;


      case WM_COMMAND :

         // XebvO
         if ( nStep == 0 ) {

            // ɏI
            if ( LOWORD ( wParam ) == IDCANCEL ) {
               EndDialog ( hWnd, 0 ) ;
               return TRUE ;
            }

            // tH_mF
            if ( LOWORD ( wParam ) == IDOK ) {

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDOK, GetStringW ( IDS_OK ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDOK, GetStringA ( IDS_OK ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_CANCEL ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_CANCEL ) ) ;

               ASK_FOLDER_PROC :

               if ( IsNT () ) SetPathSeparatorW ( szInstallFolderW, ADD_SEPARATOR_ONLY_ROOT ) ;
               else           SetPathSeparatorA ( szInstallFolderA, ADD_SEPARATOR_ONLY_ROOT ) ;

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_ASK_FOLDER ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_ASK_FOLDER ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, szInstallFolderW ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, szInstallFolderA ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_CHANGE ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_CHANGE ) ) ;

               if ( IsNT () ) SetPathSeparatorW ( szInstallFolderW, REMOVE_SEPARATOR_ALWAYS ) ;
               else           SetPathSeparatorA ( szInstallFolderA, REMOVE_SEPARATOR_ALWAYS ) ;

               Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
               Dlg_SetFocus ( hWnd, IDOK ) ;
               MessageBeep ( MB_OK ) ;
               nStep = 1 ;
               return TRUE ;
            }

            break ;
         }


         // XebvP
         if ( nStep == 1 ) {

            // tH_ύX
            if ( LOWORD ( wParam ) == IDCANCEL ) {

               if ( IsNT () ) SetPathSeparatorW ( szInstallFolderW, ADD_SEPARATOR_ONLY_ROOT ) ;
               else           SetPathSeparatorA ( szInstallFolderA, ADD_SEPARATOR_ONLY_ROOT ) ;

               intptr_t nResult ;
               if ( IsNT () ) nResult = DialogBoxExW ( IDD_DIALOG_EDIT, hWnd, EditDialogProc ) ;
               else           nResult = DialogBoxExA ( IDD_DIALOG_EDIT, hWnd, EditDialogProc ) ;

               if ( IsNT () ) SetPathSeparatorW ( szInstallFolderW, REMOVE_SEPARATOR_ALWAYS ) ;
               else           SetPathSeparatorA ( szInstallFolderA, REMOVE_SEPARATOR_ALWAYS ) ;

               if ( nResult ) {
                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_CANCEL ) ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_CANCEL ) ) ;
                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDOK, GetStringW ( IDS_CONTINUE ) ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDOK, GetStringA ( IDS_CONTINUE ) ) ;
                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_STOP ) ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_STOP ) ) ;
                  Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
                  Dlg_SetFocus ( hWnd, IDOK ) ;
                  MessageBeep ( MB_OK ) ;
                  nStep = 0 ;
                  return TRUE ;
               }

               goto ASK_FOLDER_PROC ;
            }

            // t@CRs[
            if ( LOWORD ( wParam ) == IDOK ) {

               if ( IsNT () ) SetPathSeparatorW ( szInstallFolderW, REMOVE_SEPARATOR_ALWAYS ) ;
               else           SetPathSeparatorA ( szInstallFolderA, REMOVE_SEPARATOR_ALWAYS ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_CANCEL ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_CANCEL ) ) ;

               // tH_쐬
               int IsFailedMakeDir = 0 ;
               if ( IsNT () ) IsFailedMakeDir += ( ! IsFolderExistW ( szInstallFolderW ) ) && MakeDirectoryW ( szInstallFolderW, 0 ) ;
               else           IsFailedMakeDir += ( ! IsFolderExistA ( szInstallFolderA ) ) && MakeDirectoryA ( szInstallFolderA, 0 ) ;

               // \p̃tH_쐬
               if ( IsNT () ) {
                  wchar_t szTmp [ MAX_PATH ] ;
                  wcscpy ( szTmp, szInstallFolderW ) ;
                  wcscat ( szTmp, LangDllFolder.W ) ;
                  IsFailedMakeDir += ( ! IsFolderExistW ( szTmp ) ) && MakeDirectoryW ( szTmp, 0 ) ;
               }
               else {
                  char szTmp [ MAX_PATH ] ;
                  strcpy ( szTmp, szInstallFolderA ) ;
                  strcat ( szTmp, LangDllFolder.A ) ;
                  IsFailedMakeDir += ( ! IsFolderExistA ( szTmp ) ) && MakeDirectoryA ( szTmp, 0 ) ;
               }

               if ( IsFailedMakeDir ) {
                  nStep = -1 ;
                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_FAIL_MKDIR ) ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_FAIL_MKDIR ) ) ;
                  Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;
                  Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
                  Dlg_SetFocus ( hWnd, IDOK ) ;
                  MessageBeep ( MB_OK ) ;
                  return TRUE ;
               }

               nStep = -1 ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_COPYING ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_COPYING ) ) ;

               // o[W邩ǂmF
               if ( IsNT () ) {
                  swprintf ( FileName.W, L"%s\\%s", szInstallFolderW, ( InstallFileName [ 2 ] ).W ) ;
                  if ( IsFileExistW ( FileName.W ) ) nOldVersion = GetDllVersionW ( FileName.W ) ;
               }
               else {
                  sprintf ( FileName.A, "%s\\%s", szInstallFolderA, ( InstallFileName [ 2 ] ).A ) ;
                  if ( IsFileExistA ( FileName.A ) ) nOldVersion = GetDllVersionA ( FileName.A ) ;
               }
               if ( ! nOldVersion ) nOldVersion = 300 ;

               // t@CCXg[
               if ( IsNT () ) {
                  for ( int nCount = 0 ; ( InstallFileName [ nCount ] ).W ; nCount ++ ) {
                     if ( InstallFileW ( hWnd, ( InstallFileName [ nCount ] ).W, szInstallFolderW ) ) return TRUE ;
                  }
               }
               else {
                  for ( int nCount = 0 ; ( InstallFileName [ nCount ] ).A ; nCount ++ ) {
                     if ( InstallFileA ( hWnd, ( InstallFileName [ nCount ] ).A, szInstallFolderA ) ) return TRUE ;
                  }
               }

               // Ât@C폜
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_DELETE_OLD ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_DELETE_OLD ) ) ;
               if ( IsNT () ) {
                  for ( int nCount = 0 ; ( OldFileName [ nCount ] ).W ; nCount ++ ) {
                     if ( DeleteOldFileW ( hWnd, ( OldFileName [ nCount ] ).W, szInstallFolderW ) ) return TRUE ;
                  }
               }
               else {
                  for ( int nCount = 0 ; ( OldFileName [ nCount ] ).A ; nCount ++ ) {
                     if ( DeleteOldFileA ( hWnd, ( OldFileName [ nCount ] ).A, szInstallFolderA ) ) return TRUE ;
                  }
               }

               // Â 32-bit vOoĒ
               if ( IS_WIN64 || IsWin64 () && ! IsFoundAnotherBitRegistry () ) AdjustOld32bitRegistry ( hWnd ) ;

               // SẴV[gJbg폜
               if ( IsNT () ) DeleteShortcutW () ;
               else           DeleteShortcutA () ;

               // ob`t@C쐬
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_CREATING ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_CREATING ) ) ;

               if ( IsNT () ) MakeBatchFileW ( szInstallFolderW, 0 ) ;
               else           MakeBatchFileA ( szInstallFolderA, 0 ) ;
               if ( IsNT () ) MakeBatchFileW ( szInstallFolderW, 1 ) ;
               else           MakeBatchFileA ( szInstallFolderA, 1 ) ;

               // t@C̃Rs[I
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;

               // Âo[W̃IvVړ
               MoveOldConfigFile ( hWnd, nOldVersion ) ;

               // Âo[W̃IvVC
               UpdateConfigFile ( hWnd, nOldVersion ) ;

               // X^[gj[ɃV[gJbg쐬
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_STARTMENU ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_STARTMENU ) ) ;

               if ( IsNT () ) GetSpecialFolderPathW ( NULL, FileName.W, CSIDL_COMMON_PROGRAMS, 0 ) ;
               else           GetSpecialFolderPathA ( NULL, FileName.A, CSIDL_PROGRAMS, 0 ) ;
               if ( IsNT () ) swprintf ( wcsend ( FileName.W ), L"\\%s%s", GetStringW ( IDS_STARTMENU_FOLDER ), X86_SUFFIX_W ) ;
               else           sprintf  ( strend ( FileName.A ),  "\\%s%s", GetStringA ( IDS_STARTMENU_FOLDER ), X86_SUFFIX_A ) ;
               if ( IsNT () ) MakeDirectoryW ( FileName.W, 0 ) ;
               else           MakeDirectoryA ( FileName.A, 0 ) ;
               if ( IsNT () ) MakeShortcutW ( FileName.W, szInstallFolderW, 0 ) ;
               else           MakeShortcutA ( FileName.A, szInstallFolderA, 0 ) ;

               // fXNgbvɃV[gJbg쐬邩mF
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDOK, GetStringW ( IDS_YES ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDOK, GetStringA ( IDS_YES ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_NO ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_NO ) ) ;

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_ASK_DESKTOP ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_ASK_DESKTOP ) ) ;
               MessageBeep ( MB_OK ) ;
               nStep = 2 ;
               return TRUE ;
            }

            break ;
         }

         // XebvQ
         if ( nStep == 2 ) {

            if ( LOWORD ( wParam ) == IDOK || LOWORD ( wParam ) == IDCANCEL ) {

               // fXNgbvɃV[gJbg쐬
               if ( LOWORD ( wParam ) == IDOK ) {

                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_DESKTOP ) ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_DESKTOP ) ) ;

                  if ( IsNT () ) GetSpecialFolderPathW ( NULL, FileName.W, CSIDL_COMMON_DESKTOPDIRECTORY, 0 ) ;
                  else           GetSpecialFolderPathA ( NULL, FileName.A, CSIDL_DESKTOPDIRECTORY, 0 ) ;
                  if ( IsNT () ) MakeShortcutW ( FileName.W, szInstallFolderW, 1 ) ;
                  else           MakeShortcutA ( FileName.A, szInstallFolderA, 1 ) ;

                  if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
                  else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
               }

               // WXgɏ
               if ( IsNT () ) {
                  // pX
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_W, L"Path", szInstallFolderW, REG_MODE_NORMAL ) ;
                  // ACXg[
                  swprintf ( FileName.W, L"%s %s", GetStringW ( IDS_SOFTWARENAME ), WIN3264BIT_SUFFIX_W ) ;
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"DisplayName", FileName.W, REG_MODE_NORMAL ) ;
                  swprintf ( FileName.W, L"\"%s\\%s\" /r", szInstallFolderW, L"setup.exe" ) ;
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"UninstallString", FileName.W, REG_MODE_NORMAL ) ;
                  wcscpy ( FileName.W, HOMEPAGE_ADDRESS_W ) ;
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"HelpLink", FileName.W, REG_MODE_NORMAL ) ;
                  wcscpy ( FileName.W, L"Harigaya Soichi" ) ;
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"Publisher", FileName.W, REG_MODE_NORMAL ) ;
                  swprintf ( FileName.W, L"%s\\%s", szInstallFolderW, ( InstallFileName [ 0 ] ).W ) ;
                  SetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"DisplayIcon", FileName.W, REG_MODE_NORMAL ) ;
               }
               else {
                  // pX
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_A, "Path", szInstallFolderA, REG_MODE_NORMAL ) ;
                  // ACXg[
                  sprintf ( FileName.A, "%s %s", GetStringA ( IDS_SOFTWARENAME ), WIN3264BIT_SUFFIX_A ) ;
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "DisplayName", FileName.A, REG_MODE_NORMAL ) ;
                  sprintf ( FileName.A, "\"%s\\%s\" /r", szInstallFolderA, "setup.exe" ) ;
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "UninstallString", FileName.A, REG_MODE_NORMAL ) ;
                  strcpy ( FileName.A, HOMEPAGE_ADDRESS_A ) ;
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "HelpLink", FileName.A, REG_MODE_NORMAL ) ;
                  strcpy ( FileName.A, "Harigaya Soichi" ) ;
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "Publisher", FileName.A, REG_MODE_NORMAL ) ;
                  sprintf ( FileName.A, "%s\\%s", szInstallFolderA, ( InstallFileName [ 0 ] ).A ) ;
                  SetRegStringA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, "DisplayIcon", FileName.A, REG_MODE_NORMAL ) ;
               }

               Sleep ( 500 ) ;

               // IbZ[W
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_STEP_SUCCESS ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_STEP_SUCCESS ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDOK, GetStringW ( IDS_OK ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDOK, GetStringA ( IDS_OK ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDCANCEL, GetStringW ( IDS_CANCEL ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDCANCEL, GetStringA ( IDS_CANCEL ) ) ;

               Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;
               Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
               Dlg_SetFocus ( hWnd, IDOK ) ;
               MessageBeep ( MB_OK ) ;
               nStep = -1 ;
               return TRUE ;
            }

            break ;
         }


         // I
         if ( nStep == -1 ) {
            if ( LOWORD ( wParam ) == IDOK || LOWORD ( wParam ) == IDCANCEL ) {
               EndDialog ( hWnd, 0 ) ;
               return TRUE ;
            }
            break ;
         }

         break ;

      default :
         break ;
   }

   return FALSE ;
}



// \Rg[
// OK Ȃ 0 ŁACANCEL Ȃ 1 ŏI
INT_PTR CALLBACK EditDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s %s", GetStringW ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_W ) ;
         else           Wm_SetTextFormatA ( hWnd,  "%s %s", GetStringA ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_A ) ;

         if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_EDIT, szInstallFolderW ) ;
         else           Dlg_Wm_SetTextA ( hWnd, IDC_EDIT, szInstallFolderA ) ;

         return TRUE ;

      case WM_COMMAND :

         if ( LOWORD ( wParam ) == IDCANCEL ) {
            EndDialog ( hWnd, 1 ) ;
            return TRUE ;
         }

         if ( LOWORD ( wParam ) == IDOK ) {

            if ( IsNT () ) {

               wchar_t szBuffer [ MAX_PATH ] ;

               Dlg_Wm_GetTextW ( hWnd, IDC_EDIT, szBuffer, MAX_PATH ) ;
               if ( wcslen ( szBuffer ) > MAX_PATH_FOLDER_PARENT ) {
                  MessageBoxW ( hWnd, GetStringW ( IDS_PATH_TOO_LONG ), szCommandNameW, MB_OK ) ;
                  return TRUE ;
               }

               wcscpy ( szInstallFolderW, szBuffer ) ;
            }
            else {

               char szBuffer [ MAX_PATH ] ;

               Dlg_Wm_GetTextA ( hWnd, IDC_EDIT, szBuffer, MAX_PATH ) ;
               if ( strlen ( szBuffer ) > MAX_PATH_FOLDER_PARENT ) {
                  MessageBoxA ( hWnd, GetStringA ( IDS_PATH_TOO_LONG ), szCommandNameA, MB_OK ) ;
                  return TRUE ;
               }

               strcpy ( szInstallFolderA, szBuffer ) ;
            }

            EndDialog ( hWnd, 0 ) ;
            return TRUE ;
         }

         if ( LOWORD ( wParam ) == IDC_BUTTON_REF ) {

            if ( IsNT () ) {

               wchar_t szBuffer [ MAX_PATH ] ;

               Dlg_Wm_GetTextW ( hWnd, IDC_EDIT, szBuffer, MAX_PATH ) ;
               SetPathSeparatorW ( szBuffer, ADD_SEPARATOR_ONLY_ROOT ) ;

               while ( GetFileAttributesW ( szBuffer ) == INVALID_FILE_ATTRIBUTES ) {
                  ChangeFileNameW ( szBuffer, NULL ) ;
                  SetPathSeparatorW ( szBuffer, ADD_SEPARATOR_ONLY_ROOT ) ;
                  if ( ! GetFileNameW ( szBuffer ) ) break ;
               }

               if ( ! BrowseForFolderW ( hWnd, szBuffer, szBuffer, szCommandNameW, GetStringW ( IDS_BROWSE_FOLDER ), 0 ) ) {
                  SetPathSeparatorW ( szBuffer, REMOVE_SEPARATOR_ALWAYS ) ;
                  if ( ! wcsstri ( szBuffer, FOLDER_NAME_W ) ) {
                     if ( ! wcsstri ( szBuffer, L"HARIGAYA" ) ) wcscat ( szBuffer, L"\\Harigaya\\" ) ;
                     else                                       wcscat ( szBuffer, L"\\" ) ;
                     wcscat ( szBuffer, FOLDER_NAME_W ) ;
                  }
                  Dlg_Wm_SetTextW ( hWnd, IDC_EDIT, szBuffer ) ;
                  return TRUE ;
               }
            }
            else {

               char szBuffer [ MAX_PATH ] ;

               Dlg_Wm_GetTextA ( hWnd, IDC_EDIT, szBuffer, MAX_PATH ) ;
               SetPathSeparatorA ( szBuffer, ADD_SEPARATOR_ONLY_ROOT ) ;

               while ( GetFileAttributesA ( szBuffer ) == INVALID_FILE_ATTRIBUTES ) {
                  ChangeFileNameA ( szBuffer, NULL ) ;
                  SetPathSeparatorA ( szBuffer, ADD_SEPARATOR_ONLY_ROOT ) ;
                  if ( ! GetFileNameA ( szBuffer ) ) break ;
               }

               if ( ! BrowseForFolderA ( hWnd, szBuffer, szBuffer, szCommandNameA, GetStringA ( IDS_BROWSE_FOLDER ), 0 ) ) {
                  SetPathSeparatorA ( szBuffer, REMOVE_SEPARATOR_ALWAYS ) ;
                  if ( ! strstri ( szBuffer, FOLDER_NAME_A ) ) {
                     if ( ! strstri ( szBuffer, "HARIGAYA" ) ) strcat ( szBuffer, "\\Harigaya\\" ) ;
                     else                                      strcat ( szBuffer, "\\" ) ;
                     strcat ( szBuffer, FOLDER_NAME_A ) ;
                  }
                  Dlg_Wm_SetTextA ( hWnd, IDC_EDIT, szBuffer ) ;
                  return TRUE ;
               }
            }

            return TRUE ;
         }

      default :
         break ;
   }

   return FALSE ;
}



////////////////////////////////////////////////////////
//               Vt@C̃Rs[               //
////////////////////////////////////////////////////////



// t@CRs[iANSIŁj
// Rs[ɎsCXg[𒆎~ 1 Ԃ
int InstallFileA ( HWND hWnd, const char *szFileName, const char *szFolderName ) {

   char szSrcFileName [ MAX_PATH ] ;
   char szDstFileName [ MAX_PATH ] ;

   GetModuleFileNameA ( NULL, szSrcFileName, MAX_PATH ) ;
   ChangeFileNameA ( szSrcFileName, szFileName ) ;

   strcpy ( szDstFileName, szFolderName ) ;
   strcat ( szDstFileName, "\\" ) ;
   strcat ( szDstFileName, szFileName ) ;

   if ( ! strcmp ( szSrcFileName, szDstFileName ) ) return 0 ;

   if ( hWnd ) Dlg_Wm_SetTextFormatA ( hWnd, IDC_STATIC_PROG, "Copying  %s", szFileName ) ;

   if ( IsFileExistA ( szSrcFileName ) ) {

      if ( IsFileExistA ( szDstFileName ) ) SetFileAttributesA ( szDstFileName, 0 ) ;

      if ( CopyFileA ( szSrcFileName, szDstFileName, FALSE ) ) {
         SetFileAttributesA ( szDstFileName, FILE_ATTRIBUTE_ARCHIVE ) ;
         ShellChangeNotifyA ( SHCNE_UPDATEITEM, szDstFileName, NULL, 0 ) ;
         return 0 ;
      }
   }

   if ( MessageBoxFormatA ( hWnd, szCommandNameA, MB_OKCANCEL, GetStringA ( IDS_CANNOT_COPY ), szFileName ) == IDOK ) return 0 ;

   if ( hWnd ) {
      Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_ABORT ) ) ;
      Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
      Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;
      Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
      Dlg_SetFocus ( hWnd, IDOK ) ;
   }

   MessageBeep ( MB_OK ) ;
   return 1 ;
}



// t@CRs[iUNICODEŁj
// Rs[ɎsCXg[𒆎~ 1 Ԃ
int InstallFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szFolderName ) {

   wchar_t szSrcFileName [ MAX_PATH ] ;
   wchar_t szDstFileName [ MAX_PATH ] ;

   GetModuleFileNameW ( NULL, szSrcFileName, MAX_PATH ) ;
   ChangeFileNameW ( szSrcFileName, szFileName ) ;

   wcscpy ( szDstFileName, szFolderName ) ;
   wcscat ( szDstFileName, L"\\" ) ;
   wcscat ( szDstFileName, szFileName ) ;

   if ( ! wcscmp ( szSrcFileName, szDstFileName ) ) return 0 ;

   if ( hWnd ) Dlg_Wm_SetTextFormatW ( hWnd, IDC_STATIC_PROG, L"Copying  %s", szFileName ) ;

   if ( IsFileExistW ( szSrcFileName ) ) {

      if ( IsFileExistW ( szDstFileName ) ) SetFileAttributesW ( szDstFileName, 0 ) ;

      if ( CopyFileW ( szSrcFileName, szDstFileName, FALSE ) ) {
         SetFileAttributesW ( szDstFileName, FILE_ATTRIBUTE_ARCHIVE ) ;
         ShellChangeNotifyW ( SHCNE_UPDATEITEM, szDstFileName, NULL, 0 ) ;
         return 0 ;
      }
   }

   if ( MessageBoxFormatW ( hWnd, szCommandNameW, MB_OKCANCEL, GetStringW ( IDS_CANNOT_COPY ), szFileName ) == IDOK ) return 0 ;

   if ( hWnd ) {
      Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_ABORT ) ) ;
      Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
      Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;
      Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
      Dlg_SetFocus ( hWnd, IDOK ) ;
   }

   MessageBeep ( MB_OK ) ;
   return 1 ;
}



// Ât@C폜iANSIŁj
// 폜ɎsCXg[𒆎~ 1 Ԃ
int DeleteOldFileA ( HWND hWnd, const char *szFileName, const char *szFolderName ) {

   char szDstFileName [ MAX_PATH ] ;

   strcpy ( szDstFileName, szFolderName ) ;
   strcat ( szDstFileName, "\\" ) ;
   strcat ( szDstFileName, szFileName ) ;

   if ( ! IsFileExistA ( szDstFileName ) ) return 0 ;

   SetFileAttributesA ( szDstFileName, 0 ) ;

   if ( DeleteFileA ( szDstFileName ) ) {
      Dlg_Wm_SetTextFormatA ( hWnd, IDC_STATIC_PROG, "Deleting  %s", szFileName ) ;
      return 0 ;
   }

   if ( MessageBoxFormatA ( hWnd, szCommandNameA, MB_OKCANCEL, GetStringA ( IDS_CANNOT_DELETE ), szFileName ) == IDOK ) return 0 ;

   Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_ABORT ) ) ;
   Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;

   Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;

   Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
   Dlg_SetFocus ( hWnd, IDOK ) ;

   MessageBeep ( MB_OK ) ;
   return 1 ;
}



// Ât@C폜iUNICODEŁj
// 폜ɎsCXg[𒆎~ 1 Ԃ
int DeleteOldFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szFolderName ) {

   wchar_t szDstFileName [ MAX_PATH ] ;

   wcscpy ( szDstFileName, szFolderName ) ;
   wcscat ( szDstFileName, L"\\" ) ;
   wcscat ( szDstFileName, szFileName ) ;

   if ( ! IsFileExistW ( szDstFileName ) ) return 0 ;

   SetFileAttributesW ( szDstFileName, 0 ) ;

   if ( DeleteFileW ( szDstFileName ) ) {
      Dlg_Wm_SetTextFormatW ( hWnd, IDC_STATIC_PROG, L"Deleting  %s", szFileName ) ;
      return 0 ;
   }

   if ( MessageBoxFormatW ( hWnd, szCommandNameW, MB_OKCANCEL, GetStringW ( IDS_CANNOT_DELETE ), szFileName ) == IDOK ) return 0 ;

   Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_ABORT ) ) ;
   Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;

   Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;

   Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
   Dlg_SetFocus ( hWnd, IDOK ) ;

   MessageBeep ( MB_OK ) ;
   return 1 ;
}



// ob`t@C쐬iANSIŁj
int MakeBatchFileA ( const char *szFolderName, int IsForEnglish ) {

   char szBatchFileName [ MAX_PATH ] ;
   int nLangIdPrev ;

   if ( IsForEnglish ) nLangIdPrev = SetResourceLanguage ( LANGID_ENGLISH ) ;

   // ob`t@C
   strcpy ( szBatchFileName, szFolderName ) ;
   strcat ( szBatchFileName, "\\" ) ;
   if ( IsForEnglish ) strcat ( szBatchFileName, BATCH_FILE_NAME_E_A ) ;
   else                strcat ( szBatchFileName, BATCH_FILE_NAME_J_A ) ;

   SetFileAttributesA ( szBatchFileName, 0 ) ;
   DeleteFileA ( szBatchFileName ) ;

   // ob`t@C̏
   FILE *Fout = fsopen ( szBatchFileName, "w", _SH_DENYWR ) ;
   if ( Fout ) {

      fputs ( "@echo off\n", Fout ) ;
      fputs ( GetStringA ( IDS_BAT_MESSAGE ), Fout ) ;
      fputs ( "\n", Fout ) ;

      // NTnȂApX̐ݒ loadcmd.exe 
      // 96nȂApX̐ݒ̓ob`t@C
      if ( ! IsNT () ) {
         fputs ( "doskey /insert > nul\nrem prompt $e[;37;1;40m$P$G\n", Fout ) ;
         if ( strchr ( szFolderName, 0x20 ) ) fprintf ( Fout, "path %%path%%;\"%s\"\n", szFolderName ) ;
         else                                 fprintf ( Fout, "path %%path%%;%s\n", szFolderName ) ;
      }

      fclose ( Fout ) ;
   }

   if ( IsForEnglish ) SetResourceLanguage ( nLangIdPrev ) ;

   return 0 ;
}



// ob`t@C쐬iUNICODEŁj
int MakeBatchFileW ( const wchar_t *szFolderName, int IsForEnglish ) {

   wchar_t szBatchFileName [ MAX_PATH ] ;
   int nLangIdPrev ;

   if ( IsForEnglish ) nLangIdPrev = SetResourceLanguage ( LANGID_ENGLISH ) ;

   // ob`t@C
   wcscpy ( szBatchFileName, szFolderName ) ;
   wcscat ( szBatchFileName, L"\\" ) ;
   if ( IsForEnglish ) wcscat ( szBatchFileName, BATCH_FILE_NAME_E_W ) ;
   else                wcscat ( szBatchFileName, BATCH_FILE_NAME_J_W ) ;

   SetFileAttributesW ( szBatchFileName, 0 ) ;
   DeleteFileW ( szBatchFileName ) ;

   // ob`t@C̏
   FILE *Fout = wfsopen ( szBatchFileName, L"w", _SH_DENYWR ) ;
   if ( Fout ) {

      fputws ( L"@echo off\n", Fout ) ;
      fputws ( GetStringW ( IDS_BAT_MESSAGE ), Fout ) ;
      fputws ( L"\n", Fout ) ;

      // NTnȂApX̐ݒ loadcmd.exe 
      // 96nȂApX̐ݒ̓ob`t@C
      if ( ! IsNT () ) {
         fputws ( L"doskey /insert > nul\nrem prompt $e[;37;1;40m$P$G\n", Fout ) ;
         if ( wcschr ( szFolderName, 0x20 ) ) fwprintf ( Fout, L"path %%path%%;\"%s\"\n", szFolderName ) ;
         else                                 fwprintf ( Fout, L"path %%path%%;%s\n", szFolderName ) ;
      }

      fclose ( Fout ) ;
   }

   if ( IsForEnglish ) SetResourceLanguage ( nLangIdPrev ) ;

   return 0 ;
}



// V[gJbg쐬iANSIŁj
int MakeShortcutA ( const char *szShortcutFolder, const char *szFolderName, int IsDesktop ) {

   char szComspecBuffer [ MAX_PATH ] ;
   char *szComspec = szComspecBuffer ;
   char *szTmp ;

   if ( IsNT () ) {
      if ( ! GetEnvironmentVariableA ( "COMSPEC", szComspec, MAX_PATH ) ) {
         int nResult = SearchPathA ( NULL, "CMD.EXE", NULL, MAX_PATH, szComspec, & szTmp ) ;
         if ( nResult <= 0 || nResult >= MAX_PATH ) szComspec = NULL ;
      }
   }
   else {
      int nResult = SearchPathA ( NULL, "PIFMGR.DLL", NULL, MAX_PATH, szComspec, & szTmp ) ;
      if ( nResult <= 0 || nResult >= MAX_PATH ) szComspec = NULL ;
   }


   char szLinkFileName [ MAX_PATH ] ;
   char szFileName [ MAX_PATH ] ;

   // st@C
   sprintf ( szFileName, "%s\\%s", szFolderName, ( InstallFileName [ 0 ] ).A ) ;
   sprintf ( szLinkFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_EXE_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameA ( szLinkFileName, X86_SUFFIX_A ) ;
   if ( IsFileExistA ( szLinkFileName ) ) { DeleteFileA ( szLinkFileName ) ; Sleep ( 200 ) ; }
   CreateShortcutA ( szLinkFileName, szFileName, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;

   // R}hC
   sprintf ( szFileName, "%s\\%s", szFolderName, ( InstallFileName [ 3 ] ).A ) ;
   sprintf ( szLinkFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_COM_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameA ( szLinkFileName, X86_SUFFIX_A ) ;
   if ( IsFileExistA ( szLinkFileName ) ) { DeleteFileA ( szLinkFileName ) ; Sleep ( 200 ) ; }
   CreateShortcutA ( szLinkFileName, szFileName, NULL, NULL, NULL, szComspec, 0, 0, 0, NULL, NULL ) ;

   if ( ! IsDesktop ) {

      // wvt@C
      sprintf ( szFileName, "%s\\%s", szFolderName, GetStringA ( IDS_HELPFILE_HTML_FILENAME ) ) ;
      sprintf ( szLinkFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_HELP_LINK ) ) ;
      if ( IsFileExistA ( szLinkFileName ) ) { DeleteFileA ( szLinkFileName ) ; Sleep ( 200 ) ; }
      CreateShortcutA ( szLinkFileName, szFileName, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;

      // ACXg[
      sprintf ( szFileName, "%s\\%s", szFolderName, "setup.exe" ) ;
      sprintf ( szLinkFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_UNINSTALL_LINK ) ) ;
      if ( IsFileExistA ( szLinkFileName ) ) { DeleteFileA ( szLinkFileName ) ; Sleep ( 200 ) ; }
      CreateShortcutA ( szLinkFileName, szFileName, "/r", NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;
   }

   return 0 ;
}



// V[gJbg쐬iUNICODEŁj
int MakeShortcutW ( const wchar_t *szShortcutFolder, const wchar_t *szFolderName, int IsDesktop ) {

   wchar_t szComspecBuffer [ MAX_PATH ] ;
   wchar_t *szComspec = szComspecBuffer ;
   wchar_t *szTmp ;

   if ( IsNT () ) {
      if ( ! GetEnvironmentVariableW ( L"COMSPEC", szComspec, MAX_PATH ) ) {
         int nResult = SearchPathW ( NULL, L"CMD.EXE", NULL, MAX_PATH, szComspec, & szTmp ) ;
         if ( nResult <= 0 || nResult >= MAX_PATH ) szComspec = NULL ;
      }
   }
   else {
      int nResult = SearchPathW ( NULL, L"PIFMGR.DLL", NULL, MAX_PATH, szComspec, & szTmp ) ;
      if ( nResult <= 0 || nResult >= MAX_PATH ) szComspec = NULL ;
   }


   wchar_t szLinkFileName [ MAX_PATH ] ;
   wchar_t szFileName [ MAX_PATH ] ;

   // st@C
   swprintf ( szFileName, L"%s\\%s", szFolderName, ( InstallFileName [ 0 ] ).W ) ;
   swprintf ( szLinkFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_EXE_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameW ( szLinkFileName, X86_SUFFIX_W ) ;
   if ( IsFileExistW ( szLinkFileName ) ) { DeleteFileW ( szLinkFileName ) ; Sleep ( 200 ) ; }
   CreateShortcutW ( szLinkFileName, szFileName, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;

   // R}hC
   swprintf ( szFileName, L"%s\\%s", szFolderName, ( InstallFileName [ 3 ] ).W ) ;
   swprintf ( szLinkFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_COM_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameW ( szLinkFileName, X86_SUFFIX_W ) ;
   if ( IsFileExistW ( szLinkFileName ) ) { DeleteFileW ( szLinkFileName ) ; Sleep ( 200 ) ; }
   CreateShortcutW ( szLinkFileName, szFileName, NULL, NULL, NULL, szComspec, 0, 0, 0, NULL, NULL ) ;

   if ( ! IsDesktop ) {

      // wvt@C
      swprintf ( szFileName, L"%s\\%s", szFolderName, GetStringW ( IDS_HELPFILE_HTML_FILENAME ) ) ;
      swprintf ( szLinkFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_HELP_LINK ) ) ;
      if ( IsFileExistW ( szLinkFileName ) ) { DeleteFileW ( szLinkFileName ) ; Sleep ( 200 ) ; }
      CreateShortcutW ( szLinkFileName, szFileName, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;

      // ACXg[
      swprintf ( szFileName, L"%s\\%s", szFolderName, L"setup.exe" ) ;
      swprintf ( szLinkFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_UNINSTALL_LINK ) ) ;
      if ( IsFileExistW ( szLinkFileName ) ) { DeleteFileW ( szLinkFileName ) ; Sleep ( 200 ) ; }
      CreateShortcutW ( szLinkFileName, szFileName, L"/r", NULL, NULL, NULL, 0, 0, 0, NULL, NULL ) ;
   }

   return 0 ;
}



////////////////////////////////////////////////////////
//              IvVt@C̍XV              //
////////////////////////////////////////////////////////



int SetNewConfig ( int nOldVersion ) ;



int UpdateConfigFile ( HWND hWnd, int nOldVersion ) {

   if ( IsNT () ) {

      wchar_t szUserProfilePath [ MAX_PATH ] ;
      wchar_t szAppdataPath [ MAX_PATH ] ;

      if ( GetSpecialFolderPathW ( NULL, szUserProfilePath, CSIDL_PROFILE, 0 ) && ! GetEnvironmentVariableW ( L"USERPROFILE", szUserProfilePath, MAX_PATH ) ) return 1 ;
      if ( GetSpecialFolderPathW ( NULL, szAppdataPath, CSIDL_APPDATA, 0 ) && ! GetEnvironmentVariableW ( L"APPDATA", szAppdataPath, MAX_PATH ) ) return 1 ;
      if ( wcsheadcmp ( szAppdataPath, szUserProfilePath ) ) return 1 ;

      wchar_t *szAppdataPathSuffix = szAppdataPath + wcslen ( szUserProfilePath ) ;

      ChangeFileNameW ( szUserProfilePath, L"*" ) ;

      HANDLE hFind ;
      WIN32_FIND_DATAW FindFileDataW ;

      if ( ( hFind = FindFirstFileW ( szUserProfilePath, & FindFileDataW ) ) != INVALID_HANDLE_VALUE ) {
         do {

            if ( ! wcscmp ( FindFileDataW.cFileName, L"." ) ) continue ;
            if ( ! wcscmp ( FindFileDataW.cFileName, L".." ) ) continue ;
            if ( ! ( FindFileDataW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;

            wchar_t szFileName [ MAX_PATH ] ;

            wcscpy ( szFileName, szUserProfilePath ) ;
            ChangeFileNameW ( szFileName, FindFileDataW.cFileName ) ;
            wcscat ( szFileName, szAppdataPathSuffix ) ;

            wcscat ( szFileName, L"\\Harigaya" ) ;

            SetPathSeparatorW ( szFileName, ADD_SEPARATOR_ALWAYS ) ;
            wcscat ( szFileName, CFG_FILENAME_W ) ;

            if ( ReadOldOptionW ( szFileName ) ) continue ;
            if ( ReadOptionW ( szFileName ) ) continue ;
            Dlg_Wm_SetTextFormatW ( hWnd, IDC_STATIC_PROG, L"Updating %s", szFileName ) ;
            if ( SetNewConfig ( nOldVersion ) ) WriteOptionW ( szFileName ) ;

         } while ( FindNextFileW ( hFind, & FindFileDataW ) ) ;
      }

   }
   else {

      char szFileName [ MAX_PATH ] ;

      strcpy ( szFileName, szInstallFolderA ) ;
      SetPathSeparatorA ( szFileName, ADD_SEPARATOR_ALWAYS ) ;
      strcat ( szFileName, CFG_FILENAME_A ) ;

      if ( ReadOldOptionA ( szFileName ) ) return 0 ;
      if ( ReadOptionA ( szFileName ) ) return 0 ;
      if ( SetNewConfig ( nOldVersion ) ) WriteOptionA ( szFileName ) ;

   }

   Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;
   return 0 ;
}



// ύX 1 Ԃ
int SetNewConfig ( int nOldVersion ) {

   int IsChanged = 0 ;

   if ( nOldVersion < 512 ) {
      if ( ! stricmp ( szChineseSimplifiedFont, "MS Song" ) ) {
         strcpy ( szChineseSimplifiedFont, DEFAULT_CHINESE_SIMPLIFIED_FONT ) ;
         IsChanged = 1 ;
      }
      if ( IsOutputNumberHtml && ! nOutputNumberStyle ) {
         IsOutputNumber = 1 ;
         nOutputNumberStyle = 1 ;
         IsChanged = 1 ;
      }
   }
   if ( nOldVersion < 520 ) {
      nSavedSrcCode = 0 ;
      nSavedDstCode = 0 ;
      IsChanged = 1 ;
   }
   if ( nOldVersion < 550 ) {
      if ( ! stricmp ( szKoreanFont, "GulimChe" ) ) {
         strcpy ( szKoreanFont, DEFAULT_KOREAN_FONT ) ;
         IsChanged = 1 ;
      }
      if ( nOsCodePage == CP_JAPANESE && ! stricmp ( szJapaneseFont, DEFAULT_JAPANESE_FONT ) ) {
         strcpy ( szJapaneseFont, DEFAULT_JAPANESE_FONT_L ) ;
         IsChanged = 1 ;
      }
      if ( nOsCodePage == CP_CHINESE_SIMPLIFIED && ! stricmp ( szChineseSimplifiedFont, DEFAULT_CHINESE_SIMPLIFIED_FONT ) ) {
         strcpy ( szChineseSimplifiedFont, DEFAULT_CHINESE_SIMPLIFIED_FONT_L ) ;
         IsChanged = 1 ;
      }
      if ( nOsCodePage == CP_CHINESE_TRADITIONAL && ! stricmp ( szChineseTraditionalFont, DEFAULT_CHINESE_TRADITIONAL_FONT ) ) {
         strcpy ( szChineseTraditionalFont, DEFAULT_CHINESE_TRADITIONAL_FONT_L ) ;
         IsChanged = 1 ;
      }
      if ( nOsCodePage == CP_KOREAN && ! stricmp ( szKoreanFont, DEFAULT_KOREAN_FONT ) ) {
         strcpy ( szKoreanFont, DEFAULT_KOREAN_FONT_L ) ;
         IsChanged = 1 ;
      }
   }
   if ( nOldVersion < 566 ) {
      if ( IsOutputNumber ) nInvalidCharFormat = nOutputNumberStyle + 2 ;
      else                  nInvalidCharFormat = 0 ;
      IsChanged = 1 ;
   }
   if ( nOldVersion < 570 ) {
      nUnmappableCharFormat = nInvalidCharFormat ;
      IsChanged = 1 ;
   }
   if ( nOldVersion < 610 ) {
      IsOutputJisNoVendor = IsJisNoVendor ;
      IsChanged = 1 ;
   }
   if ( nOldVersion < 620 ) {
      if ( nSavedType ) {
         nSavedSrcType = ( nSavedType / 10 ) - 1 ;
         nSavedDstType = ( nSavedType % 10 ) - 1 ;
         IsSaveCode = 1 ;
         IsChanged = 1 ;
      }
   }

   return IsChanged ;
}



// Ât@C APPDATA Ɉړ
int MoveOldConfigFile ( HWND hWnd, int nOldVersion ) {

   if ( ! IsNT () ) return 0 ;

#if defined SETUP_R_EXE
   if ( nOldVersion > 610 ) return 0 ;
#endif
#if defined SETUP_C_EXE
   if ( nOldVersion > 490 ) return 0 ;
#endif

   wchar_t szFileName [ MAX_PATH ] ;

   wcscpy ( szFileName, szInstallFolderW ) ;
   SetPathSeparatorW ( szFileName, ADD_SEPARATOR_ALWAYS ) ;
   wcscat ( szFileName, CFG_FILENAME_W ) ;


   int IsDelete = 0 ;


   FILE *Fin = wfopen ( szFileName, L"r" ) ;
   if ( ! Fin ) return 0 ;

   char szLineBuffer [ OPTION_FILE_LINE_BUFFER ] ;

   while ( fgets ( szLineBuffer, OPTION_FILE_LINE_BUFFER, Fin ) ) {

      // sƂ
      if ( ! strchr ( szLineBuffer, '\n' ) ) {
         while ( 1 ) {
            int C = fgetc ( Fin ) ;
            if ( C == '\n' || C == EOF ) break ;
         }
      }

      if ( ! strheadcmp ( szLineBuffer, "IncludePathW" ) || ! strheadcmp ( szLineBuffer, "IncludePathA" ) ) {
         IsDelete = 1 ;
         break ;
      }
   }

   fclose ( Fin ) ;


   if ( ! IsDelete ) {

      wchar_t szNewFileName [ MAX_PATH ] ;

      if ( GetSpecialFolderPathW ( NULL, szNewFileName, CSIDL_APPDATA, 0 ) ) return 1 ;

      wcscat ( szNewFileName, L"\\Harigaya" ) ;

      if ( ! IsFolderExistW ( szNewFileName ) && MakeDirectoryW ( szNewFileName, NULL ) ) return 1 ;

      SetPathSeparatorW ( szNewFileName, ADD_SEPARATOR_ALWAYS ) ;
      wcscat ( szNewFileName, CFG_FILENAME_W ) ;

      CopyFileW ( szFileName, szNewFileName, FALSE ) ;
   }

   DeleteFileW ( szFileName ) ;

   return 1 ;
}



////////////////////////////////////////////////////////
//                       MISC                         //
////////////////////////////////////////////////////////



// DLL ̃o[W擾iANSIŁj
int GetDllVersionA ( const char *szDllFileName ) {

   HINSTANCE hDll = LoadLibraryA ( szDllFileName ) ;

   GETDLLVERSION GetDllVersion = NULL ;
   if ( GETPROCADDRESS ( hDll, GETDLLVERSION, GetDllVersion ) ) return 0 ;

   int nVersion = GetDllVersion () ;
   FreeLibrary ( hDll ) ;

   return nVersion ;
}



// DLL ̃o[W擾iUNICODEŁj
int GetDllVersionW ( const wchar_t *szDllFileName ) {

   HINSTANCE hDll = LoadLibraryW ( szDllFileName ) ;

   GETDLLVERSION GetDllVersion = NULL ;
   if ( GETPROCADDRESS ( hDll, GETDLLVERSION, GetDllVersion ) ) return 0 ;

   int nVersion = GetDllVersion () ;
   FreeLibrary ( hDll ) ;

   return nVersion ;
}



// ǗҌ邩Ԃ
int IsAdministrator ( void ) {

   if ( IsNT () ) {

      wchar_t szRegKey [ MAX_PATH ] ;
      wcscpy ( szRegKey, REG_SUBKEY_UNINSTALL_W ) ;

      ChangeFileNameW ( szRegKey, NULL ) ;
      SetPathSeparatorW ( szRegKey, REMOVE_SEPARATOR_ALWAYS ) ;
      ChangeFileNameW ( szRegKey, NULL ) ;
      SetPathSeparatorW ( szRegKey, REMOVE_SEPARATOR_ALWAYS ) ;

      return IsRegKeyAccessibleW ( HKEY_LOCAL_MACHINE, szRegKey, KEY_WRITE, REG_MODE_NORMAL ) ;

   }
   else {

      char szRegKey [ MAX_PATH ] ;
      strcpy ( szRegKey, REG_SUBKEY_UNINSTALL_A ) ;

      ChangeFileNameA ( szRegKey, NULL ) ;
      SetPathSeparatorA ( szRegKey, REMOVE_SEPARATOR_ALWAYS ) ;
      ChangeFileNameA ( szRegKey, NULL ) ;
      SetPathSeparatorA ( szRegKey, REMOVE_SEPARATOR_ALWAYS ) ;

      return IsRegKeyAccessibleA ( HKEY_LOCAL_MACHINE, szRegKey, KEY_WRITE, REG_MODE_NORMAL ) ;

   }
}



////////////////////////////////////////////////////////
//                 ACXg[                   //
////////////////////////////////////////////////////////



INT_PTR CALLBACK UninstallDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
int DeleteInstalledFilesA ( HWND hWnd, const char *szInstallFolder, char *szMessageBuffer ) ;
int DeleteInstalledFilesW ( HWND hWnd, const wchar_t *szInstallFolder, wchar_t *szMessageBuffer ) ;
int DeleteConfigFile ( HWND hWnd ) ;
int IsSpecialFolderA ( const char *szFolderName ) ;
int IsSpecialFolderW ( const wchar_t *szFolderName ) ;

#define TEMPFILE_HEADER_A      "sur"
#define TEMPFILE_HEADER_W     L"sur"



// ACXg[
int PrepareUninstall ( void ) {

   // 
   LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, MAX_PATH ) ;
   LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, MAX_PATH ) ;

   if ( IsNT () ) {

      wchar_t szSrcFileName [ MAX_PATH ] ;
      wchar_t szDstFileName [ MAX_PATH ] ;
      wchar_t szCmdLine [ MAX_PATH * 2 ] ;

      GetModuleFileNameW ( NULL, szSrcFileName, MAX_PATH ) ;

      GetTempFileNameExW ( TEMPFILE_HEADER_W, szDstFileName ) ;
//    ChangeExtensionW ( szDstFileName, L"exe" ) ;

      CopyFileW ( szSrcFileName, szDstFileName, FALSE ) ;

      ChangeFileNameW ( szSrcFileName, NULL ) ;
      SetPathSeparatorW ( szSrcFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      swprintf ( szCmdLine, L"\"%s\" /r /yes \"%s\"", szDstFileName, szSrcFileName ) ;

      // JgfBNgςĂȂƁAqvZXŃtH_폜łȂ
      ChangeFileNameW ( szDstFileName, NULL ) ;
      SetPathSeparatorW ( szDstFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      SetCurrentDirectoryW ( szDstFileName ) ;

      ExecuteW ( szCmdLine, SW_SHOWDEFAULT, 0, NULL ) ;
   }
   else {

      char szSrcFileName [ MAX_PATH ] ;
      char szDstFileName [ MAX_PATH ] ;
      char szCmdLine [ MAX_PATH * 2 ] ;

      GetModuleFileNameA ( NULL, szSrcFileName, MAX_PATH ) ;

      GetTempFileNameExA ( TEMPFILE_HEADER_A, szDstFileName ) ;
//    ChangeExtensionA ( szDstFileName, "exe" ) ;

      CopyFileA ( szSrcFileName, szDstFileName, FALSE ) ;

      ChangeFileNameA ( szSrcFileName, NULL ) ;
      SetPathSeparatorA ( szSrcFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      sprintf ( szCmdLine, "\"%s\" /r /yes \"%s\"", szDstFileName, szSrcFileName ) ;

      // JgfBNgςĂȂƁAqvZXŃtH_폜łȂ
      ChangeFileNameA ( szDstFileName, NULL ) ;
      SetPathSeparatorA ( szDstFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      SetCurrentDirectoryA ( szDstFileName ) ;

      ExecuteA ( szCmdLine, SW_SHOWDEFAULT, 0, NULL ) ;
   }

   return 0 ;
}



// ACXg[siANSIŁj
int UninstallA ( const char *szInstallDir ) {

   // 
   LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, MAX_PATH ) ;
   LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, MAX_PATH ) ;

   // ǗҌ邩H
   if ( IsNT () && ! IsAdministrator () ) {
      MessageBoxA ( NULL, GetStringA ( IDS_CANNOT_INSTALL ), szCommandNameA, MB_OK ) ;
   }
   else {
      // _CA[O\AACXg[s
      DialogBoxParamExA ( IDD_DIALOG_PROG, NULL, UninstallDialogProc, (LPARAM) szInstallDir ) ;
   }

   // g폜
   char szSelfFileName [ MAX_PATH ] ;
   char szBatchFileName [ MAX_PATH ] ;
   char szCmdLine [ MAX_PATH * 2 ] ;

   GetModuleFileNameA ( NULL, szSelfFileName, MAX_PATH ) ;
   GetModuleFileNameA ( NULL, szBatchFileName, MAX_PATH ) ;
   ChangeExtensionA ( szBatchFileName, "bat" ) ;

   FILE *Fout = fsopen ( szBatchFileName, "w", _SH_DENYWR ) ;
   if ( ! Fout ) return 1 ;
   fprintf ( Fout, "del \"%s\"\n", szSelfFileName ) ;
   fprintf ( Fout, "del \"%s\"\n", szBatchFileName ) ;
   fclose ( Fout ) ;

   sprintf ( szCmdLine, "\"%s\" /c \"%s\"", ( IsNT () ) ? "cmd.exe" : "command.com", szBatchFileName ) ;

   ExecuteA ( szCmdLine, SW_HIDE, 0, NULL ) ;
   return 0 ;
}



// ACXg[siUNICODEŁj
int UninstallW ( const wchar_t *szInstallDir ) {

   // 
   LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, MAX_PATH ) ;
   LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, MAX_PATH ) ;

   // ǗҌ邩H
   if ( IsNT () && ! IsAdministrator () ) {
      MessageBoxW ( NULL, GetStringW ( IDS_CANNOT_INSTALL ), szCommandNameW, MB_OK ) ;
   }
   else {
      // _CA[O\AACXg[s
      DialogBoxParamExW ( IDD_DIALOG_PROG, NULL, UninstallDialogProc, (LPARAM) szInstallDir ) ;
   }

   // g폜
   wchar_t szSelfFileName [ MAX_PATH ] ;
   wchar_t szBatchFileName [ MAX_PATH ] ;
   wchar_t szCmdLine [ MAX_PATH * 2 ] ;

   GetModuleFileNameW ( NULL, szSelfFileName, MAX_PATH ) ;
   GetModuleFileNameW ( NULL, szBatchFileName, MAX_PATH ) ;
   ChangeExtensionW ( szBatchFileName, L"bat" ) ;

   FILE *Fout = wfsopen ( szBatchFileName, L"w", _SH_DENYWR ) ;
   if ( ! Fout ) return 1 ;
   fwprintf ( Fout, L"del \"%s\"\n", szSelfFileName ) ;
   fwprintf ( Fout, L"del \"%s\"\n", szBatchFileName ) ;
   fclose ( Fout ) ;

   swprintf ( szCmdLine, L"\"%s\" /c \"%s\"", ( IsNT () ) ? L"cmd.exe" : L"command.com", szBatchFileName ) ;

   ExecuteW ( szCmdLine, SW_HIDE, 0, NULL ) ;
   return 0 ;
}



// \Rg[
INT_PTR CALLBACK UninstallDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static char *szInstallDirA ;
   static wchar_t *szInstallDirW ;
   static MESSAGE_BUFFER Message ;
   static int IsFailed ;
   static int nStep ;

   FILENAME_BUFFER FileName ;


   switch ( dwMessage ) {

      case WM_INITDIALOG :

         if ( IsNT () ) szInstallDirW = (wchar_t*) lParam ;
         else           szInstallDirA = (char*) lParam ;

         MoveWindowToCenter ( hWnd ) ;
         ShiftWindow ( hWnd ) ;
         MoveWindowTitleIntoDesktop ( hWnd ) ;

         if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s %s", GetStringW ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_W ) ;
         else           Wm_SetTextFormatA ( hWnd,  "%s %s", GetStringA ( IDS_COMMANDNAME ), WIN3264BIT_SUFFIX_A ) ;

         if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_UNINSTALL_ASK ) ) ;
         else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_UNINSTALL_ASK ) ) ;

         MessageBeep ( MB_OK ) ;
         nStep = 0 ;
         return TRUE ;


      case WM_COMMAND :

         // XebvO
         if ( nStep == 0 ) {

            // ɏI
            if ( LOWORD ( wParam ) == IDCANCEL ) {
               EndDialog ( hWnd, 0 ) ;
               return TRUE ;
            }

            // s
            if ( LOWORD ( wParam ) == IDOK ) {

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_DELETING_FILE ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_DELETING_FILE ) ) ;

               if ( IsNT () ) wcscpy ( Message.W, GetStringW ( IDS_UNINSTALL_FAILED ) ) ;
               else           strcpy ( Message.A, GetStringA ( IDS_UNINSTALL_FAILED ) ) ;

               // t@C폜
               if ( IsNT () ) DeleteInstalledFilesW ( hWnd, szInstallDirW, Message.W ) ;
               else           DeleteInstalledFilesA ( hWnd, szInstallDirA, Message.A ) ;

               // SẴV[gJbg폜
               if ( IsNT () ) DeleteShortcutW () ;
               else           DeleteShortcutA () ;

               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;

               // e[Ůt@C폜
               if ( ! IsWin64 () || ! IsFoundAnotherBitRegistry () ) DeleteConfigFile ( hWnd ) ;

               // WXg폜 (ACXg[)
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_DELETING_REGISTRY ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_DELETING_REGISTRY ) ) ;
               if ( IsNT () ) DeleteRegInfoW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, NULL, REG_MODE_NORMAL ) ;
               else           DeleteRegInfoA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_A, NULL, REG_MODE_NORMAL ) ;

               // WXg폜 (pX)
               if ( IsNT () ) {
                  DeleteRegInfoW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_W, NULL, REG_MODE_NORMAL ) ;
                  wcscpy ( FileName.W, REG_SUBKEY_W ) ;
                  ChangeFileNameW ( FileName.W, NULL ) ;
                  SetPathSeparatorW ( FileName.W, REMOVE_SEPARATOR_ALWAYS ) ;
                  DeleteRegInfoW ( HKEY_LOCAL_MACHINE, FileName.W, NULL, REG_MODE_NORMAL ) ;
               }
               else {
                  DeleteRegInfoA ( HKEY_LOCAL_MACHINE, REG_SUBKEY_A, NULL, REG_MODE_NORMAL ) ;
                  strcpy ( FileName.A, REG_SUBKEY_A ) ;
                  ChangeFileNameA ( FileName.A, NULL ) ;
                  SetPathSeparatorA ( FileName.A, REMOVE_SEPARATOR_ALWAYS ) ;
                  DeleteRegInfoA ( HKEY_LOCAL_MACHINE, FileName.A, NULL, REG_MODE_NORMAL ) ;
               }

               Sleep ( 500 ) ;

               // IbZ[W
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_MESSAGE, GetStringW ( IDS_UNINSTALL_SUCCESS ) ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_MESSAGE, GetStringA ( IDS_UNINSTALL_SUCCESS ) ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_PROG, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_PROG, "" ) ;

               Dlg_EnableWindow ( hWnd, IDCANCEL, FALSE ) ;
               Dlg_Button_SetStyle ( hWnd, IDOK, BS_DEFPUSHBUTTON, TRUE ) ;
               Dlg_SetFocus ( hWnd, IDOK ) ;

               // 񍐃bZ[W
               if ( IsFailed ) {
                  if ( IsNT () ) {
                     wcscat ( Message.W, GetStringW ( IDS_UNINSTALL_FAILED_TAIL ) ) ;
                     MessageBoxW ( hWnd, Message.W, szCommandNameW, MB_OK ) ;
                  }
                  else {
                     strcat ( Message.A, GetStringA ( IDS_UNINSTALL_FAILED_TAIL ) ) ;
                     MessageBoxA ( hWnd, Message.A, szCommandNameA, MB_OK ) ;
                  }
               }
               else {
                  MessageBeep ( MB_OK ) ;
               }

               nStep = -1 ;
               return TRUE ;
            }

            break ;
         }

         // I
         if ( nStep == -1 ) {
            if ( LOWORD ( wParam ) == IDOK || LOWORD ( wParam ) == IDCANCEL ) {
               EndDialog ( hWnd, 0 ) ;
               return TRUE ;
            }
            break ;
         }

         break ;

      default :
         break ;
   }

   return FALSE ;
}



int UninstallFileA ( HWND hWnd, const char *szFileName ) ;
int UninstallFileW ( HWND hWnd, const wchar_t *szFileName ) ;



// SẴCXg[ꂽt@C폜iANSIŁj
// bZ[Wobt@ NULL ł
// 폜Ɏst@C 0 ȊOԂ
int DeleteInstalledFilesA ( HWND hWnd, const char *szInstallFolder, char *szMessageBuffer ) {

   char szFileName [ MAX_PATH ] ;
   int IsFailed = 0 ;

   // ʏ̃t@C폜
   for ( int nCount = 0 ; ( InstallFileName [ nCount ] ).A ; nCount ++ ) {
      sprintf ( szFileName, "%s\\%s", szInstallFolder, ( InstallFileName [ nCount ] ).A ) ;
      if ( UninstallFileA ( hWnd, szFileName ) ) {
         if ( szMessageBuffer ) sprintf ( strend ( szMessageBuffer ), "%s\n", szFileName ) ;
         IsFailed = 1 ;
      }
   }
   for ( int nCount = 0 ; ( OldFileName [ nCount ] ).A ; nCount ++ ) {
      sprintf ( szFileName, "%s\\%s", szInstallFolder, ( OldFileName [ nCount ] ).A ) ;
      UninstallFileA ( hWnd, szFileName ) ;
   }
   for ( int nCount = 0 ; ( OldBatFileName [ nCount ] ).A ; nCount ++ ) {
      sprintf ( szFileName, "%s\\%s", szInstallFolder, ( OldBatFileName [ nCount ] ).A ) ;
      UninstallFileA ( hWnd, szFileName ) ;
   }

   // t@C폜
   sprintf ( szFileName, "%s\\%s", szInstallFolder, CFG_FILENAME_A ) ;
   UninstallFileA ( hWnd, szFileName ) ;

   // ob`t@C폜
   sprintf ( szFileName, "%s\\%s", szInstallFolder, BATCH_FILE_NAME_J_A ) ;
   UninstallFileA ( hWnd, szFileName ) ;
   sprintf ( szFileName, "%s\\%s", szInstallFolder, BATCH_FILE_NAME_E_A ) ;
   UninstallFileA ( hWnd, szFileName ) ;

   // \p̃tH_폜
   strcpy ( szFileName, szInstallFolder ) ;
   strcat ( szFileName, LangDllFolder.A ) ;
   UninstallFileA ( hWnd, szFileName ) ;

   // tH_폜
   strcpy ( szFileName, szInstallFolder ) ;
   for ( int nCount = 0 ; nCount < 10 ; nCount ++ ) {
      if ( UninstallFileA ( hWnd, szFileName ) ) break ;
      ChangeFileNameA ( szFileName, NULL ) ;
      SetPathSeparatorA ( szFileName, REMOVE_SEPARATOR_ALWAYS ) ;
   }

   return IsFailed ;
}



// SẴCXg[ꂽt@C폜iUNICODEŁj
// bZ[Wobt@ NULL ł
// 폜Ɏst@C 0 ȊOԂ
int DeleteInstalledFilesW ( HWND hWnd, const wchar_t *szInstallFolder, wchar_t *szMessageBuffer ) {

   wchar_t szFileName [ MAX_PATH ] ;
   int IsFailed = 0 ;

   // ʏ̃t@C폜
   for ( int nCount = 0 ; ( InstallFileName [ nCount ] ).W ; nCount ++ ) {
      swprintf ( szFileName, L"%s\\%s", szInstallFolder, ( InstallFileName [ nCount ] ).W ) ;
      if ( UninstallFileW ( hWnd, szFileName ) ) {
         if ( szMessageBuffer ) swprintf ( wcsend ( szMessageBuffer ), L"%s\n", szFileName ) ;
         IsFailed = 1 ;
      }
   }
   for ( int nCount = 0 ; ( OldFileName [ nCount ] ).W ; nCount ++ ) {
      swprintf ( szFileName, L"%s\\%s", szInstallFolder, ( OldFileName [ nCount ] ).W ) ;
      UninstallFileW ( hWnd, szFileName ) ;
   }
   for ( int nCount = 0 ; ( OldBatFileName [ nCount ] ).W ; nCount ++ ) {
      swprintf ( szFileName, L"%s\\%s", szInstallFolder, ( OldBatFileName [ nCount ] ).W ) ;
      UninstallFileW ( hWnd, szFileName ) ;
   }

   // t@C폜
   swprintf ( szFileName, L"%s\\%s", szInstallFolder, CFG_FILENAME_W ) ;
   UninstallFileW ( hWnd, szFileName ) ;

   // ob`t@C폜
   swprintf ( szFileName, L"%s\\%s", szInstallFolder, BATCH_FILE_NAME_J_W ) ;
   UninstallFileW ( hWnd, szFileName ) ;
   swprintf ( szFileName, L"%s\\%s", szInstallFolder, BATCH_FILE_NAME_E_W ) ;
   UninstallFileW ( hWnd, szFileName ) ;

   // \p̃tH_폜
   wcscpy ( szFileName, szInstallFolder ) ;
   wcscat ( szFileName, LangDllFolder.W ) ;
   UninstallFileW ( hWnd, szFileName ) ;

   // tH_폜
   wcscpy ( szFileName, szInstallFolder ) ;
   for ( int nCount = 0 ; nCount < 10 ; nCount ++ ) {
      if ( UninstallFileW ( hWnd, szFileName ) ) break ;
      ChangeFileNameW ( szFileName, NULL ) ;
      SetPathSeparatorW ( szFileName, REMOVE_SEPARATOR_ALWAYS ) ;
   }

   return IsFailed ;
}



// e[Ůt@C폜
int DeleteConfigFile ( HWND hWnd ) {

   if ( IsNT () ) {

      wchar_t szUserProfilePath [ MAX_PATH ] ;
      wchar_t szAppdataPath [ MAX_PATH ] ;

      if ( GetSpecialFolderPathW ( NULL, szUserProfilePath, CSIDL_PROFILE, 0 ) && ! GetEnvironmentVariableW ( L"USERPROFILE", szUserProfilePath, MAX_PATH ) ) return 1 ;
      if ( GetSpecialFolderPathW ( NULL, szAppdataPath, CSIDL_APPDATA, 0 ) && ! GetEnvironmentVariableW ( L"APPDATA", szAppdataPath, MAX_PATH ) ) return 1 ;
      if ( wcsheadcmp ( szAppdataPath, szUserProfilePath ) ) return 1 ;

      wchar_t *szAppdataPathSuffix = szAppdataPath + wcslen ( szUserProfilePath ) ;

      ChangeFileNameW ( szUserProfilePath, L"*" ) ;

      HANDLE hFind ;
      WIN32_FIND_DATAW FindFileDataW ;

      if ( ( hFind = FindFirstFileW ( szUserProfilePath, & FindFileDataW ) ) != INVALID_HANDLE_VALUE ) {
         do {

            if ( ! wcscmp ( FindFileDataW.cFileName, L"." ) ) continue ;
            if ( ! wcscmp ( FindFileDataW.cFileName, L".." ) ) continue ;
            if ( ! ( FindFileDataW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;

            wchar_t szFileName [ MAX_PATH ] ;

            wcscpy ( szFileName, szUserProfilePath ) ;
            ChangeFileNameW ( szFileName, FindFileDataW.cFileName ) ;
            wcscat ( szFileName, szAppdataPathSuffix ) ;

            wcscat ( szFileName, L"\\Harigaya" ) ;

            SetPathSeparatorW ( szFileName, ADD_SEPARATOR_ALWAYS ) ;
            wcscat ( szFileName, CFG_FILENAME_W ) ;
            UninstallFileW ( hWnd, szFileName ) ;

            ChangeFileNameW ( szFileName, NULL ) ;
            SetPathSeparatorW ( szFileName, REMOVE_SEPARATOR_ALWAYS ) ;
            UninstallFileW ( hWnd, szFileName ) ;

         } while ( FindNextFileW ( hFind, & FindFileDataW ) ) ;
      }

   }

   return 0 ;
}



int UninstallShortcutA ( HWND hWnd, const char *szShortcutFolder, int IsDesktop ) ;
int UninstallShortcutW ( HWND hWnd, const wchar_t *szShortcutFolder, int IsDesktop ) ;



// SẴV[gJbg폜iANSIŁj
int DeleteShortcutA ( void ) {

   char szFileName [ MAX_PATH ] ;

   int nLangId = GetResourceLanguage () ;

   for ( int nCount = 0 ; nCount < 3 ; nCount ++ ) {

      if ( nCount == 1 ) SetResourceLanguage ( LANGID_ENGLISH ) ;
      if ( nCount == 2 ) SetResourceLanguage ( LANGID_JAPANESE ) ;

      if ( GetResourceLanguage () == LANGID_JAPANESE && GetACP () != CP_JAPANESE ) continue ;

      if ( IsNT () ) GetSpecialFolderPathA ( NULL, szFileName, CSIDL_COMMON_PROGRAMS, 0 ) ;
      else           GetSpecialFolderPathA ( NULL, szFileName, CSIDL_PROGRAMS, 0 ) ;
      sprintf ( strend ( szFileName ), "\\%s", OldStartMenuFolder.A ) ;
      UninstallShortcutA ( NULL, szFileName, 0 ) ;

      if ( IsNT () ) GetSpecialFolderPathA ( NULL, szFileName, CSIDL_COMMON_PROGRAMS, 0 ) ;
      else           GetSpecialFolderPathA ( NULL, szFileName, CSIDL_PROGRAMS, 0 ) ;
      sprintf ( strend ( szFileName ), "\\%s%s", GetStringA ( IDS_STARTMENU_FOLDER ), X86_SUFFIX_A ) ;
      UninstallShortcutA ( NULL, szFileName, 0 ) ;

      if ( IsNT () ) GetSpecialFolderPathA ( NULL, szFileName, CSIDL_COMMON_DESKTOPDIRECTORY, 0 ) ;
      else           GetSpecialFolderPathA ( NULL, szFileName, CSIDL_DESKTOPDIRECTORY, 0 ) ;
      UninstallShortcutA ( NULL, szFileName, 1 ) ;
   }

   SetResourceLanguage ( nLangId ) ;

   return 0 ;
}



// SẴV[gJbg폜iUNICODEŁj
int DeleteShortcutW ( void ) {

   wchar_t szFileName [ MAX_PATH ] ;

   int nLangId = GetResourceLanguage () ;

   for ( int nCount = 0 ; nCount < 3 ; nCount ++ ) {

      if ( nCount == 1 ) SetResourceLanguage ( LANGID_ENGLISH ) ;
      if ( nCount == 2 ) SetResourceLanguage ( LANGID_JAPANESE ) ;

      if ( IsNT () ) GetSpecialFolderPathW ( NULL, szFileName, CSIDL_COMMON_PROGRAMS, 0 ) ;
      else           GetSpecialFolderPathW ( NULL, szFileName, CSIDL_PROGRAMS, 0 ) ;
      swprintf ( wcsend ( szFileName ), L"\\%s", OldStartMenuFolder.W ) ;
      UninstallShortcutW ( NULL, szFileName, 0 ) ;

      if ( IsNT () ) GetSpecialFolderPathW ( NULL, szFileName, CSIDL_COMMON_PROGRAMS, 0 ) ;
      else           GetSpecialFolderPathW ( NULL, szFileName, CSIDL_PROGRAMS, 0 ) ;
      swprintf ( wcsend ( szFileName ), L"\\%s%s", GetStringW ( IDS_STARTMENU_FOLDER ), X86_SUFFIX_W ) ;
      UninstallShortcutW ( NULL, szFileName, 0 ) ;

      if ( IsNT () ) GetSpecialFolderPathW ( NULL, szFileName, CSIDL_COMMON_DESKTOPDIRECTORY, 0 ) ;
      else           GetSpecialFolderPathW ( NULL, szFileName, CSIDL_DESKTOPDIRECTORY, 0 ) ;
      UninstallShortcutW ( NULL, szFileName, 1 ) ;
   }

   SetResourceLanguage ( nLangId ) ;

   return 0 ;
}



////////////////////////////////////////////////////////
//                  t@C̍폜                    //
////////////////////////////////////////////////////////



// t@C폜iANSIŁj
// t@C폜łȂ 1 Ԃ
int UninstallFileA ( HWND hWnd, const char *szFileName ) {

   if ( IsFileExistA ( szFileName ) ) {
      if ( hWnd ) Dlg_Wm_SetTextFormatA ( hWnd, IDC_STATIC_PROG, "Deleting  %s", GetFileNameA ( szFileName ) ) ;
      SetFileAttributesA ( szFileName, 0 ) ;
      if ( ! DeleteFileA ( szFileName ) ) return 1 ;
      ShellChangeNotifyA ( SHCNE_DELETE, szFileName, NULL, 0 ) ;
      return 0 ;
   }

   if ( IsFolderExistA ( szFileName ) ) {
      if ( szFileName [ 1 ] == ':' && ! szFileName [ 2 ] ) return 1 ;   // root
      if ( IsSpecialFolderA ( szFileName ) ) return 1 ;
      if ( ! RemoveDirectoryA ( szFileName ) ) return 1 ;
      if ( hWnd ) Dlg_Wm_SetTextFormatA ( hWnd, IDC_STATIC_PROG, "Deleting  %s", GetFileNameA ( szFileName ) ) ;
      ShellChangeNotifyA ( SHCNE_RMDIR, szFileName, NULL, 0 ) ;
      return 0 ;
   }

   return 0 ;
}



// t@C폜iUNICODEŁj
// t@C폜łȂ 1 Ԃ
int UninstallFileW ( HWND hWnd, const wchar_t *szFileName ) {

   if ( IsFileExistW ( szFileName ) ) {
      if ( hWnd ) Dlg_Wm_SetTextFormatW ( hWnd, IDC_STATIC_PROG, L"Deleting  %s", GetFileNameW ( szFileName ) ) ;
      if ( ! DeleteFileW ( szFileName ) ) return 1 ;
      ShellChangeNotifyW ( SHCNE_DELETE, szFileName, NULL, 0 ) ;
      return 0 ;
   }

   if ( IsFolderExistW ( szFileName ) ) {
      if ( szFileName [ 1 ] == ':' && ! szFileName [ 2 ] ) return 1 ;      // root
      if ( IsSpecialFolderW ( szFileName ) ) return 1 ;
      if ( ! RemoveDirectoryW ( szFileName ) ) return 1 ;
      if ( hWnd ) Dlg_Wm_SetTextFormatW ( hWnd, IDC_STATIC_PROG, L"Deleting  %s", GetFileNameW ( szFileName ) ) ;
      ShellChangeNotifyW ( SHCNE_RMDIR, szFileName, NULL, 0 ) ;
      return 0 ;
   }

   return 0 ;
}



// V[gJbg폜iANSIŁj
int UninstallShortcutA ( HWND hWnd, const char *szShortcutFolder, int IsDesktop ) {

   char szFileName [ MAX_PATH ] ;

   sprintf ( szFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_EXE_LINK ) ) ;
   UninstallFileA ( hWnd, szFileName ) ;
   if ( IsDesktop ) AddToFileNameA ( szFileName, X86_SUFFIX_A ) ;
   sprintf ( szFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_COM_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameA ( szFileName, X86_SUFFIX_A ) ;
   UninstallFileA ( hWnd, szFileName ) ;
   ChangeExtensionA ( szFileName, "pif" ) ;
   UninstallFileA ( hWnd, szFileName ) ;
   ChangeExtensionA ( szFileName, "lnk.pif" ) ;
   UninstallFileA ( hWnd, szFileName ) ;

   if ( *GetStringA ( IDS_COM_LINK_OLD ) ) {
      sprintf ( szFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_COM_LINK_OLD ) ) ;
      UninstallFileA ( hWnd, szFileName ) ;
      ChangeExtensionA ( szFileName, "pif" ) ;
      UninstallFileA ( hWnd, szFileName ) ;
      ChangeExtensionA ( szFileName, "lnk.pif" ) ;
      UninstallFileA ( hWnd, szFileName ) ;
   }

   if ( ! IsDesktop ) {
      sprintf ( szFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_HELP_LINK ) ) ;
      UninstallFileA ( hWnd, szFileName ) ;
      sprintf ( szFileName, "%s\\%s", szShortcutFolder, GetStringA ( IDS_UNINSTALL_LINK ) ) ;
      UninstallFileA ( hWnd, szFileName ) ;
      ChangeFileNameA ( szFileName, NULL ) ;
      SetPathSeparatorA ( szFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      UninstallFileA ( hWnd, szFileName ) ;
   }

   return 0 ;
}



// V[gJbg폜iUNICODEŁj
int UninstallShortcutW ( HWND hWnd, const wchar_t *szShortcutFolder, int IsDesktop ) {

   wchar_t szFileName [ MAX_PATH ] ;

   swprintf ( szFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_EXE_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameW ( szFileName, X86_SUFFIX_W ) ;
   UninstallFileW ( hWnd, szFileName ) ;
   swprintf ( szFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_COM_LINK ) ) ;
   if ( IsDesktop ) AddToFileNameW ( szFileName, X86_SUFFIX_W ) ;
   UninstallFileW ( hWnd, szFileName ) ;
   ChangeExtensionW ( szFileName, L"pif" ) ;
   UninstallFileW ( hWnd, szFileName ) ;
   ChangeExtensionW ( szFileName, L"lnk.pif" ) ;
   UninstallFileW ( hWnd, szFileName ) ;

   if ( *GetStringW ( IDS_COM_LINK_OLD ) ) {
      swprintf ( szFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_COM_LINK_OLD ) ) ;
      UninstallFileW ( hWnd, szFileName ) ;
      ChangeExtensionW ( szFileName, L"pif" ) ;
      UninstallFileW ( hWnd, szFileName ) ;
      ChangeExtensionW ( szFileName, L"lnk.pif" ) ;
      UninstallFileW ( hWnd, szFileName ) ;
   }

   if ( ! IsDesktop ) {
      swprintf ( szFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_HELP_LINK ) ) ;
      UninstallFileW ( hWnd, szFileName ) ;
      swprintf ( szFileName, L"%s\\%s", szShortcutFolder, GetStringW ( IDS_UNINSTALL_LINK ) ) ;
      UninstallFileW ( hWnd, szFileName ) ;
      ChangeFileNameW ( szFileName, NULL ) ;
      SetPathSeparatorW ( szFileName, REMOVE_SEPARATOR_ALWAYS ) ;
      UninstallFileW ( hWnd, szFileName ) ;
   }

   return 0 ;
}



int IsSpecialFolderA ( const char *szFolderName ) {

   char szSpecFolderName [ MAX_PATH ] ;

   for ( int nId = CSIDL_DESKTOP ; nId <= CSIDL_MAX ; nId ++ ) {
      if ( GetSpecialFolderPathA ( NULL, szSpecFolderName, nId, 0 ) ) continue ;
      if ( ! stricmp ( szFolderName + 2, szSpecFolderName + 2 ) ) return 1 ;
   }

   if ( GetEnvironmentVariableA ( "WINDIR", szSpecFolderName, MAX_PATH ) ) {
      if ( ! stricmp ( szFolderName + 2, szSpecFolderName + 2 ) ) return 1 ;
   }

   if ( ! stricmp ( szFolderName + 2, "\\Program Files" ) ) return 1 ;

   return 0 ;
}



int IsSpecialFolderW ( const wchar_t *szFolderName ) {

   wchar_t szSpecFolderName [ MAX_PATH ] ;

   for ( int nId = CSIDL_DESKTOP ; nId <= CSIDL_MAX ; nId ++ ) {
      if ( GetSpecialFolderPathW ( NULL, szSpecFolderName, nId, 0 ) ) continue ;
      if ( ! wcsicmp ( szFolderName + 2, szSpecFolderName + 2 ) ) return 1 ;
   }

   if ( GetEnvironmentVariableW ( L"WINDIR", szSpecFolderName, MAX_PATH ) ) {
      if ( ! wcsicmp ( szFolderName + 2, szSpecFolderName + 2 ) ) return 1 ;
   }

   if ( ! wcsicmp ( szFolderName + 2, L"\\Program Files" ) ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////////////////
//                     Windows 64                     //
////////////////////////////////////////////////////////



// 64-bit ŌÂ 32-bit ACXg[
// Ât@C폜 0 ȊOԂ
int AdjustOld32bitRegistry ( HWND hWnd ) {

   // WXg

   wchar_t szDisplayName [ MAX_PATH ] ;
   if ( GetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"DisplayName", szDisplayName, MAX_PATH, REG_MODE_ALWAYS_32 ) ) return 0 ;
   if ( wcsstr ( szDisplayName, L"32" ) || wcsstr ( szDisplayName, L"86" ) ) return 0 ;

   // t@C폜

   wchar_t *szString ;
   wchar_t szInstallFolder [ MAX_PATH ] ;

   if ( ! GetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"UninstallString", szInstallFolder, MAX_PATH_FOLDER, REG_MODE_ALWAYS_32 ) && ( szString = wcstokex ( szInstallFolder, NULL ) ) && *szString ) {

      wcsmove ( szInstallFolder, szString ) ;
      ChangeFileNameW ( szInstallFolder, NULL ) ;
      SetPathSeparatorW ( szInstallFolder, REMOVE_SEPARATOR_ALWAYS ) ;

      DeleteInstalledFilesW ( hWnd, szInstallFolder, NULL ) ;
   }


   // WXg폜 (ACXg[)
   DeleteRegInfoW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, NULL, REG_MODE_ALWAYS_32 ) ;

   // WXg폜 (pX)
   DeleteRegInfoW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_W, NULL, REG_MODE_ALWAYS_32 ) ;
   wchar_t szSubkey [ MAX_PATH ] ;
   wcscpy ( szSubkey, REG_SUBKEY_W ) ;
   ChangeFileNameW ( szSubkey, NULL ) ;
   SetPathSeparatorW ( szSubkey, REMOVE_SEPARATOR_ALWAYS ) ;
   DeleteRegInfoW ( HKEY_LOCAL_MACHINE, szSubkey, NULL, REG_MODE_ALWAYS_32 ) ;

   return 1 ;
}



// 64-bit ŁAƂ͈Ⴄ bit ̃WXg݂邩
//  0 ȊOԂ
int IsFoundAnotherBitRegistry ( void ) {

   // WXg

   wchar_t szDisplayName [ MAX_PATH ] ;
   if ( GetRegStringW ( HKEY_LOCAL_MACHINE, REG_SUBKEY_UNINSTALL_W, L"DisplayName", szDisplayName, MAX_PATH, ( IS_WIN64 ) ? REG_MODE_ALWAYS_32 : REG_MODE_ALWAYS_64 ) ) return 0 ;

   return 1 ;
}



