// uni2cns.h

#ifndef UNI2CNS_H
#define UNI2CNS_H



///////////////////////////////////////////////////////////////////////////////////////
//                                UNICODE (P0) -> CNS
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short Uni2cnsP0Table_00 [] = {
      0,       0x0001,  0x0002,  0x0003,  0x0004,  0x0005,  0x0006,  0x0007,  // 0x000x
      0x0008,  0x0009,  0x000A,  0x000B,  0x000C,  0x000D,  0x000E,  0x000F,  
      0x0010,  0x0011,  0x0012,  0x0013,  0x0014,  0x0015,  0x0016,  0x0017,  // 0x001x
      0x0018,  0x0019,  0x001A,  0x001B,  0x001C,  0x001D,  0x001E,  0x001F,  
      0x0020,  0x0021,  0x0022,  0x0023,  0x0024,  0x0025,  0x0026,  0x0027,  // 0x002x
      0x0028,  0x0029,  0x002A,  0x002B,  0x002C,  0x002D,  0x002E,  0x002F,  
      0x0030,  0x0031,  0x0032,  0x0033,  0x0034,  0x0035,  0x0036,  0x0037,  // 0x003x
      0x0038,  0x0039,  0x003A,  0x003B,  0x003C,  0x003D,  0x003E,  0x003F,  
      0x0040,  0x0041,  0x0042,  0x0043,  0x0044,  0x0045,  0x0046,  0x0047,  // 0x004x
      0x0048,  0x0049,  0x004A,  0x004B,  0x004C,  0x004D,  0x004E,  0x004F,  
      0x0050,  0x0051,  0x0052,  0x0053,  0x0054,  0x0055,  0x0056,  0x0057,  // 0x005x
      0x0058,  0x0059,  0x005A,  0x005B,  0x005C,  0x005D,  0x005E,  0x005F,  
      0x0060,  0x0061,  0x0062,  0x0063,  0x0064,  0x0065,  0x0066,  0x0067,  // 0x006x
      0x0068,  0x0069,  0x006A,  0x006B,  0x006C,  0x006D,  0x006E,  0x006F,  
      0x0070,  0x0071,  0x0072,  0x0073,  0x0074,  0x0075,  0x0076,  0x0077,  // 0x007x
      0x0078,  0x0079,  0x007A,  0x007B,  0x007C,  0x007D,  0x007E,  0x007F,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x008x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x009x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x21F0,  // 0x00Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x22F8,  0x22B4,  0,       0,       0,       0,       0,       0x21B1,  // 0x00Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x22B2,  // 0x00Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x22B3,  // 0x00Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_01  NULL

static const unsigned short Uni2cnsP0Table_02 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x020x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x021x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x022x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x023x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x024x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x025x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x026x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x027x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x028x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x029x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x02Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x02Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x25EF,  // 0x02Cx
      0,       0x25ED,  0x25EE,  0x25F0,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x02Dx
      0,       0x25EC,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x02Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x02Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_03 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x030x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x031x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x032x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x033x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x034x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x035x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x036x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x037x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x038x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x24F5,  0x24F6,  0x24F7,  0x24F8,  0x24F9,  0x24FA,  0x24FB,  // 0x039x
      0x24FC,  0x24FD,  0x24FE,  0x25A1,  0x25A2,  0x25A3,  0x25A4,  0x25A5,  
      0x25A6,  0x25A7,  0,       0x25A8,  0x25A9,  0x25AA,  0x25AB,  0x25AC,  // 0x03Ax
      0x25AD,  0x25AE,  0,       0,       0,       0,       0,       0,       
      0,       0x25AF,  0x25B0,  0x25B1,  0x25B2,  0x25B3,  0x25B4,  0x25B5,  // 0x03Bx
      0x25B6,  0x25B7,  0x25B8,  0x25B9,  0x25BA,  0x25BB,  0x25BC,  0x25BD,  
      0x25BE,  0x25BF,  0,       0x25C0,  0x25C1,  0x25C2,  0x25C3,  0x25C4,  // 0x03Cx
      0x25C5,  0x25C6,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x03Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x03Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x03Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_04  NULL
#define  Uni2cnsP0Table_05  NULL
#define  Uni2cnsP0Table_06  NULL
#define  Uni2cnsP0Table_07  NULL
#define  Uni2cnsP0Table_08  NULL
#define  Uni2cnsP0Table_09  NULL
#define  Uni2cnsP0Table_0A  NULL
#define  Uni2cnsP0Table_0B  NULL
#define  Uni2cnsP0Table_0C  NULL
#define  Uni2cnsP0Table_0D  NULL
#define  Uni2cnsP0Table_0E  NULL
#define  Uni2cnsP0Table_0F  NULL
#define  Uni2cnsP0Table_10  NULL
#define  Uni2cnsP0Table_11  NULL
#define  Uni2cnsP0Table_12  NULL
#define  Uni2cnsP0Table_13  NULL
#define  Uni2cnsP0Table_14  NULL
#define  Uni2cnsP0Table_15  NULL
#define  Uni2cnsP0Table_16  NULL
#define  Uni2cnsP0Table_17  NULL
#define  Uni2cnsP0Table_18  NULL
#define  Uni2cnsP0Table_19  NULL
#define  Uni2cnsP0Table_1A  NULL
#define  Uni2cnsP0Table_1B  NULL
#define  Uni2cnsP0Table_1C  NULL
#define  Uni2cnsP0Table_1D  NULL
#define  Uni2cnsP0Table_1E  NULL
#define  Uni2cnsP0Table_1F  NULL

static const unsigned short Uni2cnsP0Table_20 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x200x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x21B9,  0x21B7,  0,       0x22DD,  0,       // 0x201x
      0x21E4,  0x21E5,  0,       0,       0x21E6,  0x21E7,  0,       0,       
      0,       0,       0,       0,       0,       0x21AD,  0x21AC,  0,       // 0x202x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x21EA,  0,       0,       0x21EB,  0,       0,       // 0x203x
      0,       0,       0,       0x21EF,  0,       0,       0x22A3,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x204x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x205x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x206x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x207x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x208x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x209x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Ax
      0,       0,       0,       0,       0x42C2,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_21 [] = {
      0,       0,       0,       0x22EA,  0,       0x22A2,  0,       0,       // 0x210x
      0,       0x22EB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x211x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x212x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x213x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x214x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x215x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x24AB,  0x24AC,  0x24AD,  0x24AE,  0x24AF,  0x24B0,  0x24B1,  0x24B2,  // 0x216x
      0x24B3,  0x24B4,  0,       0,       0,       0,       0,       0,       
      0x26B5,  0x26B6,  0x26B7,  0x26B8,  0x26B9,  0x26BA,  0x26BB,  0x26BC,  // 0x217x
      0x26BD,  0x26BE,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x218x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x22D8,  0x22D5,  0x22D7,  0x22D6,  0,       0,       0x22D9,  0x22DA,  // 0x219x
      0x22DC,  0x22DB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_22 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x220x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x22E1,  0,       0,       // 0x221x
      0,       0,       0x22B5,  0,       0,       0,       0x22BC,  0x22C9,  
      0x22C8,  0,       0,       0,       0,       0,       0,       0,       // 0x222x
      0,       0x22C5,  0x22C6,  0x22CD,  0,       0,       0x22CE,  0,       
      0,       0,       0,       0,       0x22D0,  0x22CF,  0,       0,       // 0x223x
      0,       0,       0,       0,       0x22C4,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x224x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x22BD,  0,       0,       0,       0,       0,       // 0x225x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x22BB,  0x22BE,  0,       0,       0,       0,       0x22B9,  0x22BA,  // 0x226x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x227x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x228x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x229x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x22C7,  0,       0,       // 0x22Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Bx
      0,       0,       0,       0,       0,       0,       0,       0x22CA,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_23  NULL

static const unsigned short Uni2cnsP0Table_24 [] = {
      0x42A1,  0x42A2,  0x42A3,  0x42A4,  0x42A5,  0x42A6,  0x42A7,  0x42A8,  // 0x240x
      0x42A9,  0x42AA,  0x42AB,  0x42AC,  0x42AD,  0x42AE,  0x42AF,  0x42B0,  
      0x42B1,  0x42B2,  0x42B3,  0x42B4,  0x42B5,  0x42B6,  0x42B7,  0x42B8,  // 0x241x
      0x42B9,  0x42BA,  0x42BB,  0x42BC,  0x42BD,  0x42BE,  0x42BF,  0x42C0,  
      0,       0x42C1,  0,       0,       0,       0,       0,       0,       // 0x242x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x243x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x244x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x245x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x26A1,  0x26A2,  0x26A3,  0x26A4,  0x26A5,  0x26A6,  0x26A7,  0x26A8,  // 0x246x
      0x26A9,  0x26AA,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x26AB,  0x26AC,  0x26AD,  0x26AE,  // 0x247x
      0x26AF,  0x26B0,  0x26B1,  0x26B2,  0x26B3,  0x26B4,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x248x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x249x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_25 [] = {
      0x23B9,  0,       0x23BA,  0,       0,       0,       0,       0,       // 0x250x
      0,       0,       0,       0,       0x23BC,  0,       0,       0,       
      0x23BD,  0,       0,       0,       0x23BE,  0,       0,       0,       // 0x251x
      0x23BF,  0,       0,       0,       0x23B7,  0,       0,       0,       
      0,       0,       0,       0,       0x23B6,  0,       0,       0,       // 0x252x
      0,       0,       0,       0,       0x23B5,  0,       0,       0,       
      0,       0,       0,       0,       0x23B4,  0,       0,       0,       // 0x253x
      0,       0,       0,       0,       0x23B3,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x254x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x23C4,  0,       0,       0,       0,       0,       0,       0,       // 0x255x
      0,       0,       0,       0,       0,       0,       0x23C5,  0,       
      0,       0x23C7,  0,       0,       0,       0,       0,       0,       // 0x256x
      0,       0,       0x23C6,  0,       0,       0x23C0,  0x23C1,  0x23C3,  
      0x23C2,  0x23CC,  0x23CD,  0x23CE,  0,       0,       0,       0,       // 0x257x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x23A4,  0x23A5,  0x23A6,  0x23A7,  0x23A8,  0x23A9,  0x23AA,  // 0x258x
      0x23AB,  0x23B2,  0x23B1,  0x23B0,  0x23AF,  0x23AE,  0x23AD,  0x23AC,  
      0,       0,       0,       0,       0x23B8,  0x23BB,  0,       0,       // 0x259x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x21FC,  0x21FB,  0,       0,       0,       0,       0,       0,       // 0x25Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x21F5,  0x21F4,  0,       0,       0,       0,       // 0x25Bx
      0,       0,       0,       0,       0x21FE,  0x21FD,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x21FA,  0x21F9,  // 0x25Cx
      0,       0,       0,       0x21F2,  0,       0,       0x21F6,  0x21F3,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x25Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x23C8,  0x23C9,  0x23CB,  0x23CA,  0,       0,       // 0x25Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x25Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_26 [] = {
      0,       0,       0,       0,       0,       0x21F8,  0x21F7,  0,       // 0x260x
      0,       0x22D4,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x261x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x262x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x263x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x22D1,  0x22D3,  0x22D2,  0,       0,       0,       0,       0,       // 0x264x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x265x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x266x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x267x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x268x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x269x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_27  NULL
#define  Uni2cnsP0Table_28  NULL
#define  Uni2cnsP0Table_29  NULL
#define  Uni2cnsP0Table_2A  NULL
#define  Uni2cnsP0Table_2B  NULL
#define  Uni2cnsP0Table_2C  NULL
#define  Uni2cnsP0Table_2D  NULL
#define  Uni2cnsP0Table_2E  NULL
#define  Uni2cnsP0Table_2F  NULL

static const unsigned short Uni2cnsP0Table_30 [] = {
      0x21A1,  0x21A3,  0x21A4,  0x21F1,  0,       0,       0,       0,       // 0x300x
      0x21D2,  0x21D3,  0x21CE,  0x21CF,  0x21D6,  0x21D7,  0x21DA,  0x21DB,  
      0x21CA,  0x21CB,  0x22E5,  0,       0x21C6,  0x21C7,  0,       0,       // 0x301x
      0,       0,       0,       0,       0,       0x21E8,  0x21E9,  0,       
      0,       0x24B5,  0x24B6,  0x24B7,  0x24B8,  0x24B9,  0x24BA,  0x24BB,  // 0x302x
      0x24BC,  0x24BD,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x303x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x304x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x305x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x306x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x307x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x308x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x309x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Fx
      0,       0,       0,       0x21A6,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_31 [] = {
      0,       0,       0,       0,       0,       0x25C7,  0x25C8,  0x25C9,  // 0x310x
      0x25CA,  0x25CB,  0x25CC,  0x25CD,  0x25CE,  0x25CF,  0x25D0,  0x25D1,  
      0x25D2,  0x25D3,  0x25D4,  0x25D5,  0x25D6,  0x25D7,  0x25D8,  0x25D9,  // 0x311x
      0x25DA,  0x25DB,  0x25DC,  0x25DD,  0x25DE,  0x25DF,  0x25E0,  0x25E1,  
      0x25E2,  0x25E3,  0x25E4,  0x25E5,  0x25E6,  0x25E7,  0x25E8,  0x25E9,  // 0x312x
      0x25EA,  0x25EB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x313x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x314x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x315x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x316x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x317x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x318x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x319x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x31Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_32 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x320x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x321x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x322x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x323x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x324x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x325x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x326x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x327x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x328x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x329x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x22A1,  0,       0,       0,       0,       // 0x32Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_33 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x330x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x331x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x332x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x333x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x334x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x335x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x336x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x337x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x338x
      0,       0,       0,       0,       0,       0,       0x22F5,  0x22F6,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x339x
      0,       0,       0,       0,       0x22F0,  0x22F1,  0x22F2,  0,       
      0,       0x22F4,  0,       0,       0,       0,       0,       0,       // 0x33Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x33Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x22F7,  0,       0,       0,       // 0x33Cx
      0,       0,       0,       0,       0,       0,       0x22F3,  0,       
      0,       0x22CC,  0x22CB,  0,       0,       0x22EF,  0,       0,       // 0x33Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x33Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x33Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_34 [] = {
      0xA22C,  0x2224,  0,       0,       0xA130,  0xA123,  0xA1EC,  0,       // 0x340x
      0,       0,       0,       0,       0x2157,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x2336,  0,       // 0x341x
      0,       0,       0,       0,       0x2835,  0,       0,       0,       
      0,       0xB4BB,  0,       0,       0xB9ED,  0,       0,       0,       // 0x342x
      0xA7C1,  0xA8EC,  0,       0xA3A3,  0x2337,  0x2534,  0xC0B4,  0,       
      0x2159,  0xA1F5,  0xA1EE,  0xA1F1,  0xA1F3,  0,       0xA1C4,  0,       // 0x343x
      0xA34E,  0xA2F1,  0x2231,  0xA2E9,  0xA2EA,  0,       0xA1F2,  0,       
      0,       0x23B4,  0xA4CA,  0xA4C7,  0xA4CD,  0xA571,  0,       0,       // 0x344x
      0,       0xA7C6,  0x25A5,  0x2539,  0x253C,  0xA7C5,  0x25AB,  0x253B,  
      0x2538,  0xA7D0,  0,       0xA5CA,  0,       0,       0,       0xABB1,  // 0x345x
      0xAE5A,  0x2839,  0xABB0,  0x28A1,  0x283A,  0xABAA,  0x2837,  0x283C,  
      0,       0,       0,       0x2BEC,  0xB4C9,  0xAFD2,  0x2B65,  0xB538,  // 0x346x
      0,       0,       0,       0,       0,       0,       0x3045,  0xB4BE,  
      0xB4C8,  0x304A,  0,       0x3638,  0xB9F3,  0x3632,  0x3637,  0xC655,  // 0x347x
      0,       0xC97B,  0xB9F4,  0xC0B5,  0xC0B8,  0xC0BB,  0x3C2C,  0x3C2D,  
      0x3C28,  0x3C2A,  0x44D7,  0x4237,  0x4233,  0x422E,  0xC5F8,  0xDA73,  // 0x348x
      0x422F,  0xC5F3,  0x4F59,  0xC5F2,  0xC5EF,  0xC5F7,  0x4232,  0,       
      0,       0x487B,  0xCBA6,  0xCBA5,  0x487D,  0xCBA4,  0xCBA8,  0xCBAA,  // 0x349x
      0,       0xD0B2,  0x4F5D,  0x53D9,  0x4F5B,  0xD4BF,  0xD7D3,  0x5A67,  
      0x5A68,  0x5F49,  0,       0,       0x632F,  0xDCB3,  0xDCB1,  0xD2F4,  // 0x34Ax
      0xD7CC,  0x6A41,  0xE1BC,  0x2233,  0xA6DA,  0x2B69,  0,       0xD7D4,  
      0xA1F6,  0,       0xA2F9,  0xA4D5,  0x23B7,  0xA57B,  0xA57D,  0xA4D6,  // 0x34Bx
      0xABB8,  0xCDBD,  0xAACC,  0x304C,  0x31A6,  0x363D,  0x3C32,  0x6A42,  
      0,       0,       0xABBA,  0xB9F8,  0x4922,  0xA1D0,  0,       0xA3A1,  // 0x34Cx
      0xA4D8,  0x25AE,  0xA7D7,  0xA7D6,  0xA7D8,  0,       0x2843,  0xABBC,  
      0xAFDD,  0xAFDC,  0,       0x304D,  0xB9FB,  0xB9FC,  0x3C34,  0xC5F9,  // 0x34Dx
      0x31A9,  0,       0x2161,  0xA241,  0xA1FE,  0x223C,  0x22B0,  0x233E,  
      0x233F,  0x254A,  0x254C,  0x2548,  0x2547,  0,       0,       0xABC1,  // 0x34Ex
      0xABC5,  0xABC2,  0,       0,       0x2BFC,  0x3053,  0xAFE7,  0xAFE9,  
      0,       0x3057,  0x3058,  0x3052,  0x31AC,  0x3054,  0x3059,  0xBAA4,  // 0x34Fx
      0xD06C,  0x3642,  0x3645,  0xBAA2,  0x3DF0,  0xC0C2,  0x4241,  0,       
} ;


static const unsigned short Uni2cnsP0Table_35 [] = {
      0x4243,  0x4242,  0x423C,  0xC5FD,  0xC5FB,  0x423F,  0x423E,  0xC5FC,  // 0x350x
      0,       0,       0x4923,  0x4F62,  0x4F61,  0x4F63,  0x61BB,  0x556C,  
      0xBEFD,  0x5F4A,  0x6330,  0x2164,  0,       0x2240,  0,       0x2344,  // 0x351x
      0xA4E4,  0x254F,  0xA96F,  0,       0xAF27,  0x2B75,  0xAFEB,  0,       
      0x305A,  0x364B,  0xC6A2,  0x556F,  0xD4C3,  0x5570,  0x53E3,  0x5A6E,  // 0x352x
      0x305C,  0x364D,  0x3DF8,  0,       0xA972,  0xB4D3,  0x70F8,  0x234B,  
      0xA638,  0x2B77,  0xBAA5,  0xD076,  0x3C3E,  0x44EC,  0x6D53,  0xA636,  // 0x353x
      0x3650,  0xA1D8,  0xA371,  0xA3AC,  0xD07A,  0xA7E4,  0x212B,  0xA13B,  
      0xA864,  0x2556,  0xA3B0,  0x22BC,  0xA3AE,  0xA4EA,  0xA4E9,  0xA4E8,  // 0x354x
      0xA7E8,  0xAA2A,  0xABCC,  0xAFF0,  0x2B7A,  0xAFF1,  0x3651,  0xD122,  
      0x4CB1,  0xC6A4,  0x4927,  0,       0xE0F0,  0xA1DD,  0xAFF2,  0xBD61,  // 0x355x
      0xB4D6,  0x4929,  0x21C1,  0xA1DF,  0xA3B2,  0,       0x255A,  0x2857,  
      0xBFF8,  0xC6A7,  0x4756,  0x216B,  0xA2B0,  0xA2AC,  0xA3B8,  0xA3B6,  // 0x356x
      0,       0xA4EC,  0x2351,  0xA4EB,  0xA4F1,  0x2354,  0x2359,  0xA4F2,  
      0x2353,  0xA4EF,  0xA4EE,  0xA4FA,  0,       0xA3C9,  0xA5A5,  0xA7FA,  // 0x357x
      0xA7ED,  0x255D,  0xA7F6,  0x25C2,  0xAA39,  0,       0,       0,       
      0xABD2,  0xABE0,  0xABDF,  0xABE2,  0xABDA,  0x2859,  0x285C,  0xABD6,  // 0x358x
      0xA9DC,  0,       0,       0,       0,       0,       0,       0x2C25,  
      0xAFFD,  0x2B7E,  0xAFF5,  0xAFFC,  0x2C21,  0x2B7D,  0xB57D,  0xB0A4,  // 0x359x
      0x2CC3,  0,       0,       0,       0,       0,       0,       0xB4DD,  
      0xB4E5,  0x306A,  0x36F0,  0xB4E3,  0xB4DC,  0x3070,  0xB4DA,  0x3073,  // 0x35Ax
      0x3071,  0x306D,  0x306C,  0xB3C3,  0,       0,       0,       0,       
      0,       0,       0,       0,       0xB8D3,  0x306F,  0x36F6,  0xBAB2,  // 0x35Bx
      0x3667,  0xBAB5,  0xBAAC,  0x365E,  0x3659,  0xBAB9,  0xBABE,  0xBAAD,  
      0x3660,  0xBABD,  0x365F,  0xBAB7,  0xC739,  0x36F9,  0x36FA,  0xBAB0,  // 0x35Cx
      0x3658,  0x3665,  0x3663,  0xBAC1,  0x36EE,  0xBABF,  0,       0,       
      0xBABA,  0,       0,       0x3EB9,  0x3C4A,  0x3C46,  0xC0CF,  0x3EBD,  // 0x35Dx
      0x3C47,  0x3C4C,  0xC0CD,  0xC0D0,  0xD132,  0,       0,       0,       
      0,       0,       0x4252,  0xC6B2,  0xC6AF,  0xC6AD,  0x424F,  0x424A,  // 0x35Ex
      0x4255,  0xC6AB,  0xCBBA,  0x4253,  0x4256,  0x4251,  0,       0,       
      0x45A2,  0x4930,  0x492C,  0xCBC2,  0x492D,  0xCBB6,  0xA1CE,  0,       // 0x35Fx
      0,       0,       0,       0x4F6B,  0x4F6C,  0xD0C1,  0x4F67,  0x4F6A,  
} ;


static const unsigned short Uni2cnsP0Table_36 [] = {
      0x4F6F,  0xD0BC,  0xD0BA,  0,       0,       0xB7B7,  0x5572,  0xD4C6,  // 0x360x
      0x5573,  0x4F6D,  0x61C0,  0x5A70,  0xD7D6,  0x61C5,  0,       0,       
      0x5F4C,  0x67D9,  0,       0x6BF3,  0xDCB5,  0xDEA7,  0x6632,  0,       // 0x361x
      0,       0xE0AE,  0xE0AD,  0x6C6C,  0xE2AF,  0xA2B2,  0xA2A1,  0xA3BD,  
      0x25D3,  0xA7FE,  0xABE4,  0xB0A6,  0x4258,  0x6332,  0xA2B3,  0xA5AE,  // 0x362x
      0x235F,  0xA5B9,  0xA5BA,  0x235E,  0xA5BD,  0xA5BF,  0,       0xA5BB,  
      0xA5B4,  0xA8A7,  0x256D,  0xA8AB,  0xA8AC,  0,       0xABF6,  0xAF65,  // 0x363x
      0xABF4,  0xABF5,  0xABF3,  0xABEF,  0,       0,       0,       0xB0A9,  
      0x2C2F,  0x2C31,  0xB0AD,  0xB0AC,  0xB0AE,  0xB0B1,  0,       0xB4EC,  // 0x364x
      0xB4ED,  0xB4F3,  0xB4EA,  0xB3D7,  0,       0x3121,  0x366B,  0xBAC6,  
      0x366E,  0xBAD1,  0xC74E,  0xBAC8,  0,       0xBACD,  0,       0,       // 0x365x
      0,       0x3C59,  0x3C5B,  0xC0D3,  0xC0D5,  0x3C56,  0x3C58,  0,       
      0x425E,  0x425D,  0x425B,  0xC6BB,  0x425F,  0xC6B9,  0,       0xA1EA,  // 0x366x
      0xCBD2,  0xCBC8,  0x4933,  0xCBCA,  0xCBCE,  0xCEA5,  0xCEAE,  0x492A,  
      0xD0C4,  0x4F78,  0xD0C7,  0xD0C2,  0xD0C3,  0xD0C6,  0xD0C5,  0x557C,  // 0x367x
      0xD4CD,  0xD4CA,  0x557B,  0xBFB0,  0xD7DD,  0,       0xC6C4,  0,       
      0x6BF6,  0xE0F2,  0x6C6E,  0x37BC,  0xCDC1,  0xABF8,  0,       0x2861,  // 0x368x
      0,       0x25D8,  0x3677,  0x4260,  0xC6C7,  0x5A7A,  0xA2BA,  0xA3C6,  
      0xA3C8,  0,       0x2365,  0xA5CA,  0x2571,  0x25D9,  0x2577,  0x2573,  // 0x369x
      0x2578,  0,       0xABFD,  0,       0x3125,  0xBE42,  0xB4FA,  0xBAD5,  
      0x3C5C,  0xD0BE,  0xA1F4,  0xA3CC,  0xA3CA,  0x2256,  0x2259,  0x2255,  // 0x36Ax
      0xA3C9,  0xA5D2,  0xA5D7,  0xA5D0,  0xA5CF,  0xA5CD,  0xA5D4,  0,       
      0xA8B1,  0xA8BB,  0x257B,  0xA8C2,  0xA8B2,  0xA8BA,  0xA8C3,  0xA8C7,  // 0x36Bx
      0xA8B4,  0x2621,  0xA8C4,  0xA8BE,  0xA8B6,  0xA8BC,  0x25DD,  0xA8B9,  
      0,       0xA8B0,  0x286D,  0x2869,  0xABFE,  0xACA2,  0,       0,       // 0x36Cx
      0,       0xAAAA,  0x2867,  0,       0,       0xB0BF,  0xB0C2,  0xB0BD,  
      0xB0C9,  0xB0C7,  0x2C3B,  0xB0C3,  0xB0D0,  0xB0CC,  0xB0C4,  0x2C3F,  // 0x36Dx
      0x2C3A,  0xB0B9,  0x2C3C,  0xB0D1,  0xB0C6,  0xB0C1,  0xB0BA,  0,       
      0,       0xAEEB,  0xAEF8,  0,       0,       0x3129,  0xB5A6,  0xB5AD,  // 0x36Ex
      0xB5A1,  0xB5B6,  0x3128,  0xB5AC,  0xB5A3,  0xB5A5,  0xBAF1,  0xBAE7,  
      0xBAF4,  0xBAE4,  0xBAF6,  0xBAEC,  0xBAEA,  0xBAE5,  0x37CE,  0xBAEE,  // 0x36Fx
      0x37C6,  0x367E,  0xBAEF,  0xBADF,  0x367D,  0xBAF0,  0xBADD,  0,       
} ;


static const unsigned short Uni2cnsP0Table_37 [] = {
      0,       0xBABC,  0xBAED,  0xBAE9,  0xBAE8,  0x3C5F,  0xC0E2,  0x3C61,  // 0x370x
      0xC0EE,  0xC0ED,  0xC0E8,  0xC0E3,  0x3C64,  0xC0E5,  0x3C63,  0xC0F0,  
      0xC0EB,  0xC0EF,  0xC0EC,  0xC0E9,  0,       0xC6CB,  0x4267,  0x426C,  // 0x371x
      0x4268,  0x4266,  0xC6C9,  0xC6D2,  0xC6D1,  0x426B,  0x426D,  0,       
      0xC6CD,  0xC6CE,  0x4269,  0x493C,  0x493A,  0xCBD9,  0xCBD7,  0x4940,  // 0x372x
      0xCBD5,  0xD0D2,  0xD0D5,  0x5021,  0xD4AA,  0,       0x5622,  0x5624,  
      0xD7DF,  0xD7E0,  0x5F54,  0x67DE,  0xDAB0,  0xDAB2,  0xDCB7,  0x6335,  // 0x373x
      0xDCB8,  0x6637,  0x6865,  0xE1E2,  0xE1E3,  0xA3CE,  0xA678,  0x236D,  
      0xA8C9,  0x2870,  0x2C41,  0xB0D4,  0xBAFD,  0x3C67,  0,       0xADAD,  // 0x374x
      0xE1BD,  0,       0xA2BC,  0,       0xA3CF,  0xA679,  0xA5D9,  0x2370,  
      0xA5DB,  0xA67A,  0xA8CF,  0x28EE,  0xACB0,  0xACB1,  0xACB3,  0x2C42,  // 0x375x
      0x2CFC,  0xB65D,  0,       0xB5C2,  0xB5BD,  0xB5BE,  0x312E,  0xBE5A,  
      0xB5C0,  0,       0xBBA1,  0x3722,  0x3C6A,  0x3C6C,  0x3C6F,  0xC0F7,  // 0x376x
      0,       0x4274,  0x4275,  0xCBE0,  0x4277,  0x4943,  0x4945,  0x4946,  
      0x5A7D,  0xDEAB,  0xE2B5,  0,       0x2371,  0x2626,  0xB668,  0xBBA2,  // 0x377x
      0x2C4C,  0xBE64,  0x4278,  0x4CE3,  0x225D,  0x2374,  0x2628,  0x2627,  
      0x2874,  0x2875,  0x2C4D,  0x31F5,  0x3133,  0x31F3,  0x3132,  0x3728,  // 0x378x
      0x3729,  0x3C71,  0x4279,  0xA2C0,  0xA3D3,  0,       0,       0x262A,  
      0xA8D2,  0xA8D3,  0x2879,  0x2878,  0xACB9,  0xACB8,  0xACB6,  0x2C4E,  // 0x379x
      0xBE6B,  0xB5C5,  0x372B,  0x37E6,  0x427D,  0,       0,       0x494A,  
      0,       0xDAB7,  0xA1E2,  0x2377,  0xA2C2,  0xA2C3,  0xA2C1,  0xA2C4,  // 0x37Ax
      0xA3D6,  0x2261,  0x22D1,  0x237B,  0x22D0,  0xA3D7,  0,       0xA3D8,  
      0x2378,  0x2379,  0xA5E0,  0x23F0,  0x23F4,  0xA5E4,  0xA5E5,  0x2376,  // 0x37Bx
      0,       0xA8DB,  0xAA7B,  0x2631,  0x2632,  0x262E,  0xA8D6,  0xAA76,  
      0xA8D9,  0xA8DA,  0,       0x25EE,  0xACBA,  0x287B,  0,       0x2C5B,  // 0x37Cx
      0x2C53,  0x2C51,  0xB0E0,  0x2C5F,  0x2C55,  0xB0DC,  0x2C5A,  0x2C5E,  
      0x2C57,  0xB0DD,  0xB67C,  0x2DAE,  0xB0E5,  0,       0x2C54,  0xB5D6,  // 0x37Dx
      0xB5C9,  0x3137,  0xB5CC,  0x313D,  0xBE75,  0xB5CD,  0x3139,  0xBE78,  
      0xB5D0,  0,       0xB4BF,  0,       0,       0xB5D3,  0xBBAF,  0xBBB2,  // 0x37Ex
      0xBBA9,  0x3732,  0x3734,  0xBBB5,  0x3C72,  0xBBB0,  0,       0xBBAC,  
      0x3C76,  0x3C73,  0x3C7E,  0x3EED,  0x3D21,  0xD234,  0xC0FB,  0,       // 0x37Fx
      0x3C77,  0x4322,  0xDC44,  0x432D,  0x432A,  0x4321,  0xC6D5,  0x4324,  
} ;


static const unsigned short Uni2cnsP0Table_38 [] = {
      0xC6DB,  0xC6D8,  0x432E,  0,       0xC6D7,  0x4950,  0x494C,  0x4CEC,  // 0x380x
      0xCBE2,  0x4CE8,  0x494B,  0x4953,  0xCBE4,  0x494F,  0x494D,  0xCBE1,  
      0x4954,  0x5026,  0x5027,  0x5628,  0x5025,  0x54B6,  0xD0D9,  0xADCC,  // 0x381x
      0xD4DA,  0xD4D6,  0x5BBC,  0x5627,  0xD4D8,  0xBFC4,  0,       0,       
      0x5F5A,  0x67E3,  0x67E4,  0,       0,       0x663A,  0xDEAC,  0x6868,  // 0x382x
      0x7BBD,  0xA3DB,  0xA16E,  0,       0,       0xBBB8,  0x4955,  0xA2C5,  
      0,       0x3142,  0xA2C6,  0,       0x2265,  0x2266,  0xA3DD,  0x2422,  // 0x383x
      0x2424,  0xA5E9,  0x2421,  0xA5EA,  0xA4A5,  0x2636,  0x2637,  0x2925,  
      0x2425,  0x2922,  0x2924,  0xB063,  0xACC7,  0x2923,  0x2921,  0x2C66,  // 0x384x
      0x2C68,  0x3147,  0x3148,  0x3145,  0x3149,  0,       0xB5DC,  0x373B,  
      0x3736,  0x373D,  0x373A,  0xBBBC,  0x373C,  0xBBB9,  0x3739,  0x3D28,  // 0x385x
      0x3D23,  0x3D27,  0x3D26,  0x3D29,  0x4333,  0x4332,  0x4331,  0x432F,  
      0xCBEE,  0,       0xCBEF,  0x5029,  0,       0x562D,  0x562B,  0x633B,  // 0x386x
      0x633A,  0xDFC4,  0x686B,  0xC844,  0,       0xC6DE,  0x502B,  0xA3E0,  
      0xA3DF,  0xA3DE,  0xA5EC,  0xA747,  0x2638,  0x263D,  0x263B,  0x26A6,  // 0x387x
      0x263C,  0xA8E4,  0x263A,  0xA8E6,  0xAFB8,  0xACC9,  0xACCA,  0x292A,  
      0x29A6,  0x2929,  0x2928,  0x2C6B,  0x2C6D,  0x2C6C,  0xB0ED,  0,       // 0x388x
      0xB5DE,  0x314E,  0x314C,  0x314F,  0xB5DD,  0x38A9,  0x3740,  0x3741,  
      0xBBC1,  0x3FA1,  0x4336,  0xC6DF,  0x4339,  0x433A,  0x495B,  0x495C,  // 0x389x
      0xCBF1,  0xD0DD,  0x502C,  0x502E,  0x54C2,  0x5F5E,  0x633C,  0x2429,  
      0xA8EA,  0xC6E2,  0,       0xADDB,  0,       0x292B,  0x3D2D,  0xA179,  // 0x38Ax
      0x226A,  0xA3E3,  0xA3E4,  0,       0xA5F0,  0,       0xA8EF,  0x2640,  
      0x2641,  0,       0xACCE,  0x292D,  0xB07A,  0x292E,  0xACCF,  0,       // 0x38Bx
      0x2C71,  0,       0x32C6,  0x3151,  0x2C72,  0xBBC6,  0xBBC3,  0,       
      0x3FA9,  0x3D2F,  0x3D2E,  0xD24D,  0x495D,  0x495F,  0xDEAE,  0x2642,  // 0x38Cx
      0x5031,  0xA470,  0,       0xA8F3,  0x2643,  0xA8F2,  0xB5E4,  0xBBC8,  
      0xBBC9,  0x433B,  0x4961,  0xD0DF,  0xA2CB,  0,       0,       0,       // 0x38Dx
      0xAB3E,  0xA8F4,  0x2932,  0x2934,  0xACD2,  0x29AF,  0x29B3,  0xACD3,  
      0xB125,  0,       0x2DC7,  0xAFBE,  0x3154,  0xB5E6,  0xB5E7,  0,       // 0x38Ex
      0,       0,       0,       0x3749,  0xBBCA,  0x3748,  0,       0x3D33,  
      0x45E9,  0x433D,  0xDC67,  0,       0,       0xD0E0,  0x5034,  0x562F,  // 0x38Fx
      0,       0,       0xA17E,  0xA3E5,  0xA3E8,  0x2431,  0x22E7,  0x2270,  
} ;


static const unsigned short Uni2cnsP0Table_39 [] = {
      0,       0xA8FB,  0xA8FD,  0xA5F9,  0x242E,  0xA8FC,  0x2430,  0x2433,  // 0x390x
      0xA5F3,  0x242F,  0x2432,  0xA6A4,  0xA8F9,  0x2935,  0x2937,  0x264D,  
      0xACD9,  0xA9A4,  0x2648,  0xA9A3,  0x264E,  0x264C,  0x2646,  0xAABE,  // 0x391x
      0,       0xACD8,  0x2941,  0xACE2,  0x293C,  0x2649,  0x2939,  0xB0FD,  
      0xB754,  0x293D,  0x29B5,  0x2D28,  0x2948,  0x293A,  0x293B,  0x2940,  // 0x392x
      0xACD5,  0xB75A,  0xB0FC,  0,       0xACDE,  0,       0x315B,  0x2DDA,  
      0xB5F3,  0x2D22,  0xB5E9,  0xB0F5,  0x2D23,  0xB5F0,  0x2D24,  0xB0F7,  // 0x393x
      0xB75E,  0xB1A4,  0x2D2B,  0x315A,  0,       0,       0x315C,  0x3162,  
      0xB5EB,  0xC86F,  0x3163,  0xB5F5,  0x3160,  0x32DB,  0x315D,  0xB5EC,  // 0x394x
      0xBBCE,  0x316C,  0x3167,  0xBBCC,  0xB5ED,  0xB5F7,  0xBBD7,  0x3164,  
      0xC875,  0xBBD3,  0x3166,  0x315E,  0x2DD7,  0xBBD2,  0x38C2,  0,       // 0x395x
      0,       0,       0x316A,  0x38C8,  0x3756,  0x3750,  0xBBDC,  0x3759,  
      0xBBDF,  0x3754,  0x374E,  0x3FB2,  0xC1A5,  0x3755,  0x3D3E,  0xBBE0,  // 0x396x
      0x3D37,  0x32D8,  0,       0xBBDB,  0xC1A6,  0xC1AD,  0x3D3B,  0x4343,  
      0x3FC2,  0xD269,  0xC6E7,  0x3D3A,  0x3D3C,  0xC1B0,  0xC6E5,  0x4342,  // 0x397x
      0x4350,  0xC6E6,  0xC1AF,  0,       0x4348,  0x4347,  0x4349,  0xCBFD,  
      0x434D,  0x4965,  0xCCA2,  0xC6E9,  0xCBFB,  0x434A,  0x434C,  0x4346,  // 0x398x
      0,       0xCCA7,  0xCBF8,  0x434B,  0x5038,  0xCCAA,  0x4967,  0x4969,  
      0x4968,  0x496B,  0xA2FC,  0x496D,  0xD0E9,  0x496C,  0xCCA6,  0x5039,  // 0x399x
      0x5BCC,  0,       0x5B23,  0x5B29,  0x5636,  0x5B25,  0xD7E7,  0x5B24,  
      0xDAA9,  0xD7E6,  0x503A,  0x67F8,  0x6343,  0x5F64,  0x67F3,  0xC7AC,  // 0x39Ax
      0xDEB0,  0x6342,  0x6340,  0xDFC7,  0x686C,  0xE1F8,  0xA3EA,  0xA6A6,  
      0x2654,  0,       0xAB52,  0,       0x2D2F,  0x2D30,  0x2DDD,  0xB5FA,  // 0x39Bx
      0xBBE5,  0x3D42,  0x4354,  0x4DB7,  0xCCAB,  0xD4E2,  0xA76E,  0x2655,  
      0x2656,  0x294D,  0xACE4,  0x217B,  0x217A,  0xA2CF,  0x2274,  0x2273,  // 0x39Cx
      0x2275,  0x243A,  0x2436,  0xA6AC,  0xA6AD,  0xA6B0,  0xA6AB,  0,       
      0,       0,       0x2658,  0xA9AD,  0x26BA,  0xA9AC,  0xA9B8,  0x2955,  // 0x39Dx
      0x2D33,  0x2659,  0xA9AB,  0,       0,       0,       0xA7AE,  0,       
      0,       0x294E,  0x2954,  0xACE6,  0xA9A7,  0xACE7,  0xACE9,  0x2D3C,  // 0x39Ex
      0xACF1,  0x2956,  0xACE8,  0x2952,  0x2D32,  0x2D31,  0xACEA,  0xACE5,  
      0,       0xB1B4,  0xB1AA,  0xB5FB,  0xB1B1,  0xB1BA,  0x2D3B,  0xB1AD,  // 0x39Fx
      0xB1AB,  0x317C,  0x3221,  0x317B,  0xB6AC,  0xC032,  0x3225,  0xB6AF,  
} ;


static const unsigned short Uni2cnsP0Table_3A [] = {
      0xB6B0,  0x3179,  0xB5FE,  0x3171,  0xB6A5,  0x317E,  0x317A,  0xBBEB,  // 0x3A0x
      0xB6AA,  0x376E,  0x3762,  0xB6A1,  0x3D45,  0xC1B1,  0x3764,  0xBBEA,  
      0x376B,  0x3768,  0x3765,  0xBBEC,  0xBBE9,  0x3770,  0x3761,  0xBBEE,  // 0x3A1x
      0,       0x3D50,  0x3D4F,  0xC1B7,  0x3D4C,  0x3D4A,  0xC1B5,  0xC1BB,  
      0x3D48,  0x3D4E,  0xC1BC,  0xC1CA,  0xC1C3,  0xC1BF,  0xC1C7,  0xC1C0,  // 0x3A2x
      0xC1C6,  0xC1C1,  0xC1B9,  0,       0,       0x4358,  0x4361,  0xDD32,  
      0xC6F9,  0xC7AE,  0xC7AD,  0x4356,  0xC6FC,  0xC7A7,  0xC7AF,  0x435C,  // 0x3A3x
      0xC6F7,  0x46A5,  0xC6FD,  0x4975,  0xCCB6,  0x4364,  0x46A3,  0xC7AB,  
      0xC7AC,  0,       0,       0x4A24,  0xCCB3,  0xA3BA,  0x4979,  0x497A,  // 0x3A4x
      0x4976,  0x4A28,  0x4A22,  0x4DBA,  0x497E,  0x4DBE,  0xCCBC,  0,       
      0x4A23,  0,       0xD0F4,  0x5639,  0x5045,  0xD0F3,  0xD0EE,  0xD0F8,  // 0x3A5x
      0xD0F2,  0xD0F1,  0xD4E5,  0xD4EA,  0xD4E8,  0xD4E3,  0xD4E6,  0,       
      0x5B2D,  0xD7E9,  0x5B32,  0x5B30,  0x5B2E,  0xD7EF,  0xD7F1,  0x5B31,  // 0x3A6x
      0xD7E8,  0x5B2F,  0xD7F2,  0xDEF3,  0xDABD,  0xDABE,  0,       0x6347,  
      0xDCC0,  0x6346,  0x70A4,  0xDEB2,  0x6640,  0xE0B1,  0x6A49,  0x6A48,  // 0x3A7x
      0,       0x79AA,  0x265B,  0x2D40,  0x2D3F,  0x3227,  0x3D54,  0x2440,  
      0xA6BA,  0x265E,  0x265F,  0,       0x295D,  0xACF5,  0,       0xB1BE,  // 0x3A8x
      0x2D42,  0xB82B,  0,       0xB6B3,  0x3228,  0xB6B5,  0x322C,  0x3779,  
      0,       0x3775,  0x3778,  0x3777,  0,       0x3776,  0x38FC,  0,       // 0x3A9x
      0,       0,       0xBBF7,  0,       0x3D5C,  0x3D59,  0x3D5B,  0xC1CC,  
      0x4366,  0x46B0,  0x46AE,  0x4369,  0x4A2B,  0x4A2A,  0x4A29,  0,       // 0x3AAx
      0x5049,  0x504C,  0,       0xD7F3,  0x5B3A,  0x634C,  0x6643,  0xA6BB,  
      0xB82C,  0xC1CF,  0,       0,       0xA9BA,  0x2961,  0xB1C1,  0xB9AB,  // 0x3ABx
      0xBBF8,  0x4A2E,  0x563E,  0x6A4B,  0x2962,  0,       0x2D49,  0xB830,  
      0xC961,  0xDD51,  0x4DCB,  0xA3F1,  0xAB70,  0xB834,  0,       0,       // 0x3ACx
      0,       0,       0xB6BB,  0xB6BE,  0,       0x3D65,  0x4A30,  0x4A31,  
      0x2278,  0x2279,  0x2443,  0xA6BC,  0xA6BF,  0xA6BE,  0,       0xA6C0,  // 0x3ADx
      0xA9BF,  0xA9BD,  0x2663,  0x29CF,  0x2963,  0xACFB,  0x2964,  0x2965,  
      0xACF8,  0xADA6,  0,       0,       0xB167,  0x2D4C,  0x323B,  0x2D4B,  // 0x3AEx
      0,       0xB1C7,  0xB837,  0xB1CA,  0xAFEE,  0,       0x2D4D,  0xC051,  
      0x3236,  0x323A,  0x3237,  0xB6C3,  0xC04F,  0xBCA2,  0x377E,  0xBBFA,  // 0x3AFx
      0xBBFB,  0x3825,  0xBCA7,  0x3822,  0xC973,  0xBCA1,  0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_3B [] = {
      0,       0xD33D,  0x3FE2,  0xC1D2,  0xC1D7,  0xC1DA,  0xC1D5,  0xC1D3,  // 0x3B0x
      0xC1DC,  0xC1D8,  0x3D68,  0x3D67,  0xC1D4,  0xC7B8,  0x436E,  0xC7B2,  
      0xC7B6,  0,       0x4DD3,  0x4A32,  0xCCC2,  0xCCC5,  0,       0x5052,  // 0x3B1x
      0x5051,  0xD1A1,  0x4DD0,  0xD0FB,  0xD0FC,  0x5053,  0xAEDA,  0,       
      0xD4F3,  0xD4EE,  0x5640,  0x5B40,  0,       0x5B41,  0x5B3F,  0xBFF6,  // 0x3B2x
      0,       0xDAC0,  0xDAC1,  0xDCC4,  0xDFCC,  0xDFCD,  0x75EE,  0x75ED,  
      0xA3F4,  0x5056,  0xD4F4,  0xA9C4,  0xB1CE,  0x2EA5,  0xB6C9,  0,       // 0x3B3x
      0xBCA8,  0x3A43,  0,       0x46C5,  0x4DD8,  0,       0,       0xD1A5,  
      0,       0xA3F6,  0xA6C3,  0x2448,  0xA6C6,  0,       0,       0xA9CB,  // 0x3B4x
      0xA9C6,  0xA7CC,  0xA9D0,  0xA9CD,  0x26D1,  0,       0,       0,       
      0,       0xADA8,  0xADAC,  0x296F,  0x296C,  0xADA9,  0,       0,       // 0x3B5x
      0x2D57,  0x2D51,  0x2D54,  0x2D58,  0xB1D2,  0x2EAB,  0x2D52,  0x2D5B,  
      0xB1D5,  0x2D56,  0xB1D1,  0,       0,       0,       0,       0,       // 0x3B6x
      0xB6D9,  0x3243,  0xB6CA,  0xB6CF,  0x32F9,  0x3242,  0x3246,  0x3241,  
      0x3834,  0xB6D8,  0xB6DD,  0,       0,       0,       0,       0,       // 0x3B7x
      0x382F,  0xBCAE,  0x382C,  0xBCBF,  0xBCB0,  0x382A,  0x39B3,  0x382D,  
      0xBCAC,  0x39B9,  0x3835,  0xBCB5,  0x3837,  0xBCB6,  0xBCC3,  0xBCAB,  // 0x3B8x
      0xBCAD,  0,       0,       0x3D78,  0xC1F1,  0xC1E6,  0xC1F0,  0x3D6B,  
      0x3D6E,  0x3D6F,  0xC1EC,  0xC1E9,  0xC1E4,  0x3D6D,  0xC1DE,  0x3D75,  // 0x3B9x
      0xC1E2,  0xC1E3,  0xC1FA,  0xC1E1,  0xC1DF,  0x4423,  0x3D76,  0xC1E0,  
      0,       0xC2DA,  0,       0xC1E7,  0xC8D5,  0x4424,  0x4375,  0x4421,  // 0x3BAx
      0x437C,  0xC7BF,  0x4378,  0x4373,  0xC7C1,  0x4374,  0xC7CA,  0x437D,  
      0x437E,  0x437A,  0x4422,  0xC7CF,  0xC7C0,  0x4425,  0x4371,  0x46CB,  // 0x3BBx
      0xC7C9,  0x3D72,  0xC7D0,  0,       0xC8D2,  0,       0,       0xCCCE,  
      0x4DED,  0x4A3A,  0xCCCC,  0x4DE1,  0xCCD3,  0x4A37,  0x4A36,  0xCCDD,  // 0x3BCx
      0xCCD8,  0xA3EF,  0x4A38,  0x4A42,  0xCCDA,  0xCCDC,  0xCCC8,  0xCCD5,  
      0xD1C3,  0,       0,       0xD1C2,  0x5060,  0x505A,  0xD1B7,  0xD1B0,  // 0x3BDx
      0x5059,  0x4A39,  0xD1BF,  0xD1AA,  0xD1BD,  0x5649,  0xD1B3,  0xD1B9,  
      0xCCCB,  0x505E,  0xD1AD,  0x5064,  0xD1B5,  0xD1B4,  0xD1B6,  0,       // 0x3BEx
      0,       0,       0xD5A2,  0x5648,  0xD4FE,  0xD5A5,  0xD4FD,  0x564B,  
      0xB8D5,  0x5BE8,  0xD4F7,  0xD5A6,  0xDFA9,  0xD4F9,  0xD5A8,  0x5B48,  // 0x3BFx
      0x5B44,  0xD7FC,  0x5B4A,  0x5B49,  0,       0,       0x5F6F,  0x5F73,  
} ;


static const unsigned short Uni2cnsP0Table_3C [] = {
      0xDAC9,  0x5F70,  0x5F6E,  0x5F72,  0x5F75,  0xDACC,  0xDACB,  0xE2D3,  // 0x3C0x
      0xDACA,  0xDCCC,  0xDCC6,  0x6351,  0x634F,  0xDCC8,  0xDCCD,  0x6354,  
      0xDCCB,  0xDCC5,  0xE5BE,  0,       0x70A7,  0xDEB6,  0xDCCA,  0xDFD0,  // 0x3C1x
      0x686E,  0xE0B5,  0xE0B3,  0xE0B4,  0,       0x24C8,  0xA830,  0x266D,  
      0x26D6,  0x2670,  0x266C,  0x2D60,  0x2970,  0x2971,  0xB178,  0x2974,  // 0x3C2x
      0x2973,  0x2EAE,  0x2D5D,  0x2D61,  0x2D62,  0x2D5E,  0xB6E1,  0x3248,  
      0x3249,  0xC06E,  0x383B,  0x3839,  0xBCC6,  0x39C3,  0x383C,  0xB864,  // 0x3C3x
      0,       0x3E21,  0x3D7C,  0x3D7B,  0x3D7D,  0x3D7E,  0x3E22,  0xC7D2,  
      0xDD77,  0x442A,  0x4A4C,  0xCCE8,  0x5066,  0x5067,  0x564F,  0x564E,  // 0x3C4x
      0xD5AA,  0xD5AC,  0x5F77,  0xCEA2,  0x6871,  0x75F7,  0x79AF,  0xA525,  
      0,       0,       0xADBE,  0,       0xABFB,  0xBCC8,  0x383F,  0x46DF,  // 0x3C5x
      0xD8A4,  0x227C,  0xA9D7,  0x26E2,  0x2675,  0,       0xADBF,  0xADC1,  
      0xADC0,  0xB1E9,  0xB6E3,  0x324A,  0x3845,  0x3844,  0x3846,  0x3842,  // 0x3C6x
      0xBCCA,  0,       0xC2A3,  0x3E23,  0x3E24,  0xC2A4,  0,       0x4432,  
      0x46E0,  0x4433,  0x4430,  0x4A50,  0x4A4F,  0x506B,  0x506A,  0,       // 0x3C7x
      0x5651,  0x6355,  0xDCCE,  0x75F8,  0x24CE,  0x2678,  0x2D64,  0xB1EB,  
      0x324F,  0x3849,  0x384A,  0x384B,  0xC2A5,  0x4435,  0xD1C7,  0xD1C8,  // 0x3C8x
      0x506E,  0x5653,  0xD8A5,  0x297B,  0xA3FB,  0x2679,  0xA9DB,  0x267A,  
      0,       0xA7DB,  0xADC3,  0x2D66,  0x3252,  0x3254,  0x3253,  0x3255,  // 0x3C9x
      0xB6E7,  0x2D67,  0x3251,  0x39DB,  0xBCCC,  0x384F,  0x384C,  0x3E29,  
      0xC2A7,  0x3E28,  0x3E27,  0x443F,  0x4438,  0x4439,  0x443A,  0x46E8,  // 0x3CAx
      0x443C,  0,       0x506F,  0x5071,  0x5072,  0xD1C9,  0,       0x5B50,  
      0x5B4F,  0xDAD0,  0x6D57,  0x2D6A,  0xA9DC,  0xB6E8,  0xCCE9,  0xD1CA,  // 0x3CBx
      0x214F,  0xA2D6,  0xA2D5,  0xA4A2,  0x21F4,  0x2322,  0xA6D4,  0,       
      0xA6CF,  0x244F,  0xA6DD,  0xA849,  0xA6DA,  0x2451,  0xA6CB,  0xA84A,  // 0x3CCx
      0xA844,  0,       0xA6D8,  0xA9E1,  0xA9DF,  0xA9DE,  0xA9E2,  0xA9E0,  
      0x267E,  0xA9E8,  0xA9E6,  0xA7E6,  0,       0,       0xADC4,  0x2AA4,  // 0x3CDx
      0x2722,  0xADD4,  0x29FB,  0x29FC,  0x297E,  0xADD6,  0xADCC,  0xB0C9,  
      0,       0,       0,       0,       0xB872,  0xB1F0,  0xB1F1,  0x2D6B,  // 0x3CEx
      0xB933,  0xB1F4,  0x2D6C,  0xB6E9,  0xB2A4,  0xB2A3,  0xB1FE,  0,       
      0,       0,       0,       0xB1F5,  0x3257,  0xB6F1,  0x3263,  0x3264,  // 0x3CFx
      0xB6EE,  0x325E,  0xB7A2,  0xB6ED,  0xBCCF,  0xB6FE,  0x3258,  0x3268,  
} ;


static const unsigned short Uni2cnsP0Table_3D [] = {
      0x39DE,  0x325A,  0x325C,  0xC12B,  0x33BD,  0xBCDE,  0xB6FB,  0xBCDF,  // 0x3D0x
      0xB6F3,  0xC141,  0xB6F8,  0,       0,       0,       0xB6B3,  0x3851,  
      0x3856,  0xBCE5,  0x3852,  0xBCD9,  0x3859,  0xBCEA,  0xBCE7,  0xBCD5,  // 0x3D1x
      0x3857,  0x385A,  0xBCD3,  0xBCD7,  0xBCE1,  0xC2AB,  0xCA6D,  0,       
      0xBCC3,  0xBCDA,  0,       0,       0,       0x3E37,  0xC2AC,  0xC2B7,  // 0x3D2x
      0xC2B5,  0xC2C8,  0xC2B8,  0x3E30,  0x3E39,  0x3E2D,  0xC2C2,  0x3E38,  
      0xC2B4,  0xC2BC,  0x3E3C,  0xC2AF,  0xC2C1,  0x40A7,  0x3E2F,  0x3E32,  // 0x3D3x
      0xC2B2,  0,       0,       0xC2C3,  0xC7D5,  0x4449,  0xC7E0,  0xDE3B,  
      0xC7D9,  0xD450,  0xC7D8,  0x4446,  0x444D,  0x444A,  0xDE40,  0,       // 0x3D4x
      0,       0,       0xCCEE,  0x4A5F,  0x4A61,  0xCCEF,  0xCCFC,  0x4A68,  
      0x4A5D,  0xCCED,  0x4A59,  0xCCF2,  0x46F8,  0xA4E1,  0xCCF0,  0x5074,  // 0x3D5x
      0xD1CB,  0xCCF6,  0,       0,       0,       0x5077,  0x507D,  0x55B6,  
      0x5076,  0xD1CF,  0xD1CE,  0x507A,  0x55AD,  0xD1D3,  0xD1D7,  0x507B,  // 0x3D6x
      0x5656,  0xD1D1,  0xD1CC,  0x5078,  0xD1D2,  0x4A62,  0x55AE,  0xD5B2,  
      0xD5B8,  0x565E,  0x5660,  0xD5B4,  0x5658,  0xD5AE,  0x5657,  0x565C,  // 0x3D7x
      0xD5BB,  0x5659,  0x565B,  0xD5B3,  0,       0x5B56,  0x5B54,  0x5B5A,  
      0x5B57,  0x5B60,  0,       0,       0x5F7B,  0x5F7D,  0x5B5B,  0x5F79,  // 0x3D8x
      0xDAD1,  0,       0,       0,       0xDCD0,  0x635A,  0x635E,  0x635B,  
      0,       0xDCD2,  0x6649,  0x70BE,  0x664A,  0x664C,  0x6873,  0xDEB9,  // 0x3D9x
      0xDEB8,  0,       0xDFD1,  0x6A4E,  0xE0B8,  0,       0x6B6D,  0x6B6E,  
      0xE1E6,  0xA4AA,  0,       0x2452,  0xA6E1,  0xA4EE,  0xA9EE,  0x2727,  // 0x3DAx
      0xA9F8,  0xA7EE,  0xA9F3,  0xADE7,  0xADD9,  0xADE6,  0xADE1,  0xADE0,  
      0xADDB,  0,       0x2A27,  0xB2AE,  0x2D73,  0xB2B2,  0,       0,       // 0x3DBx
      0,       0xB7AB,  0xB7AA,  0xB7B4,  0x3271,  0,       0x3276,  0x3270,  
      0x3277,  0xB6C8,  0xBCF6,  0x3865,  0x3861,  0xBCF5,  0x3862,  0x3864,  // 0x3DCx
      0x3860,  0xBBA3,  0xBCFE,  0xBCF0,  0,       0xBCF8,  0xC2D4,  0xC2CD,  
      0xC2D6,  0x3E4B,  0xC2CA,  0xC2D5,  0x3E48,  0x3E46,  0x3E49,  0xD454,  // 0x3DDx
      0xC2CB,  0xC2D0,  0xC2F8,  0xC3BC,  0,       0,       0,       0x4459,  
      0xC7F3,  0xC7E9,  0xD467,  0x4456,  0x445A,  0x445C,  0xC7F1,  0,       // 0x3DEx
      0xC9D8,  0,       0,       0xCDA6,  0xCDA3,  0xCDAB,  0xCDA1,  0xCDA7,  
      0x4A6A,  0,       0,       0x5125,  0xD1DD,  0xD1DB,  0x512B,  0xD1DF,  // 0x3DFx
      0xD1E1,  0x5124,  0,       0xD1E4,  0xD1E5,  0,       0xD5BD,  0x5662,  
} ;


static const unsigned short Uni2cnsP0Table_3E [] = {
      0xD5BF,  0xD5C4,  0xB9A6,  0xD7D1,  0xD8AC,  0x5664,  0,       0,       // 0x3E0x
      0xDCDA,  0xDAD9,  0xDCD4,  0xDCDB,  0x635F,  0x664E,  0x73D7,  0x6A50,  
      0xE0BA,  0xE1FA,  0x272C,  0xA9FA,  0xB7D8,  0xC7F4,  0xADEA,  0x2D76,  // 0x3E1x
      0xB7B6,  0x386B,  0xA9FB,  0x2A2C,  0x386C,  0xA9FD,  0xA9FE,  0x2ED3,  
      0xB940,  0x2D7A,  0x445F,  0xB9AD,  0x5B64,  0x6650,  0xA1EA,  0xB2B3,  // 0x3E2x
      0x2326,  0xA6E5,  0x2455,  0xAC71,  0x2733,  0x26F7,  0x2732,  0x272F,  
      0xADEC,  0xADEF,  0x2A2E,  0xADEE,  0,       0xB2B4,  0xB2B5,  0x2D7D,  // 0x3E3x
      0x2D7C,  0x327A,  0x33CD,  0x3279,  0x327E,  0xB7B8,  0xC166,  0,       
      0xB7B7,  0x3870,  0x3872,  0x3873,  0x4463,  0xD478,  0x3E4E,  0xC2DE,  // 0x3E4x
      0,       0x4462,  0x4460,  0x4464,  0x4A6F,  0x4A6E,  0x4A72,  0x4A71,  
      0x4A73,  0x512E,  0x5130,  0x512F,  0x5667,  0xD5C6,  0xD5C7,  0x5B66,  // 0x3E5x
      0x5B65,  0x6024,  0xD3EB,  0x6A51,  0x2734,  0x2459,  0xA6ED,  0x2456,  
      0xA6EC,  0xAC75,  0x2739,  0x27AE,  0xAAA9,  0xAAA4,  0xAAA5,  0x273A,  // 0x3E6x
      0,       0,       0,       0x2A32,  0x2A34,  0x2A35,  0xADF2,  0xB267,  
      0,       0xB2B7,  0x2EDC,  0x2E21,  0x2D7E,  0x2E22,  0x2E26,  0xC16D,  // 0x3E7x
      0x2E27,  0x33D1,  0x3328,  0xC175,  0x3329,  0x3325,  0x332B,  0x3327,  
      0x332E,  0x3879,  0x3877,  0xBDAC,  0x387B,  0xCB43,  0,       0x4465,  // 0x3E8x
      0x3E54,  0x4466,  0x3E53,  0xC2E0,  0x3E52,  0,       0x446A,  0xDE6E,  
      0x4469,  0x4468,  0x4467,  0xC7F6,  0x387A,  0x4A7B,  0x4A76,  0x4A7A,  // 0x3E9x
      0x4A7C,  0,       0xAFF4,  0x5132,  0x5134,  0xD5C8,  0x566A,  0x566B,  
      0x5B67,  0x68BB,  0,       0x6365,  0x6366,  0x6367,  0x6363,  0x6B6F,  // 0x3EAx
      0xA4AE,  0x2329,  0xA4B0,  0xA4B1,  0xA6F1,  0xA6EF,  0xA6F0,  0,       
      0xAAAE,  0xADF6,  0xAD21,  0xAAB0,  0x273B,  0xAAB1,  0,       0xADFD,  // 0x3EBx
      0xB2BA,  0x2A37,  0x2A38,  0,       0,       0xACB2,  0,       0x332F,  
      0xB2C3,  0xB2C4,  0xB2BB,  0x3330,  0xB2C5,  0,       0,       0xB1A7,  // 0x3ECx
      0xB2C2,  0xB7BF,  0xB7C2,  0xB7C1,  0x3333,  0xB7BE,  0xB7C3,  0,       
      0,       0xBDB4,  0x387D,  0x3AAD,  0xC2E3,  0xBDB1,  0xBDB0,  0xC2EC,  // 0x3EDx
      0,       0xB6D9,  0xBDBB,  0,       0,       0x3E59,  0xC2E5,  0xC2E9,  
      0x40CE,  0xC2F2,  0xC3C9,  0xC3D6,  0,       0,       0,       0xC8A4,  // 0x3EEx
      0xA5B7,  0,       0,       0x4B22,  0x4B21,  0xCDB7,  0xCDBC,  0xCDB3,  
      0xCDB8,  0xCDB4,  0xCDB2,  0,       0,       0xD1E8,  0x55DD,  0x5137,  // 0x3EFx
      0xD1E9,  0xD5CA,  0x566F,  0xD5FA,  0xD6A2,  0xD5CE,  0x5B69,  0xD5CC,  
} ;


static const unsigned short Uni2cnsP0Table_3F [] = {
      0,       0xDBAD,  0xD8B1,  0,       0x602A,  0xE2F8,  0xE2FB,  0xDCE1,  // 0x3F0x
      0,       0x2A39,  0x2A3A,  0x2EE2,  0x2E2B,  0x3335,  0x3334,  0x387E,  
      0x4470,  0x4471,  0x446F,  0x4B23,  0x4B24,  0x5B6C,  0x6D5A,  0x245E,  // 0x3F1x
      0x27B2,  0xAAB4,  0xAEA3,  0x2A3D,  0xB2CA,  0xB2CB,  0x2E2D,  0xB2C9,  
      0x2E2C,  0x333B,  0x3921,  0x333A,  0x3338,  0x3339,  0x3337,  0x3923,  // 0x3F2x
      0x3926,  0x333C,  0x3924,  0x3E62,  0x3E61,  0x3E5D,  0x3E60,  0xC2F6,  
      0x3E63,  0x47C8,  0x4473,  0x4476,  0x4474,  0x4478,  0x4477,  0x4475,  // 0x3F3x
      0x4B25,  0x4B27,  0x4B26,  0x513F,  0xD1EF,  0x5142,  0x5141,  0x5672,  
      0x5673,  0xD5D1,  0x5675,  0xD5D0,  0x5671,  0,       0x5B6F,  0x5B6E,  // 0x3F4x
      0x602C,  0x602B,  0x6875,  0x6B70,  0x6A53,  0xB2CC,  0x3E65,  0,       
      0xCDBF,  0x5678,  0xBDC0,  0xD0CE,  0,       0x24E3,  0xA862,  0xA6F2,  // 0x3F5x
      0x2A41,  0xAEA9,  0x2A43,  0x2E2F,  0x2E31,  0x33E4,  0xB7C8,  0xBDC1,  
      0x3928,  0x3E69,  0xC2F9,  0xC2FA,  0x3E68,  0x4479,  0xCDC0,  0x4B2A,  // 0x3F6x
      0x4B29,  0x5144,  0x5CAF,  0x5B72,  0x5B73,  0x602E,  0x6369,  0x6A54,  
      0x3E6D,  0x2461,  0x2462,  0,       0x27B7,  0xAABC,  0,       0x2A46,  // 0x3F7x
      0xAEAD,  0x2A49,  0xAEAC,  0xAEAE,  0,       0xB2D6,  0x2E37,  0x2E3B,  
      0x2E35,  0x2E36,  0xB2D4,  0x2E33,  0x2E3F,  0x2E39,  0xB96B,  0xB2D3,  // 0x3F8x
      0x2E38,  0x2E3A,  0x33ED,  0x3342,  0xB7CC,  0x3340,  0x2E3C,  0x333F,  
      0x3345,  0xB7CB,  0x3343,  0x3932,  0x3933,  0xBDC6,  0xBDCB,  0xCB5A,  // 0x3F9x
      0xBDC9,  0x3936,  0x40E0,  0x392F,  0x3930,  0xBDC8,  0xBDCA,  0x3ABB,  
      0x3935,  0x3938,  0x3E74,  0x40E4,  0x3E6F,  0x3E78,  0x3E6E,  0x3E76,  // 0x3FAx
      0x3E73,  0x3E7A,  0x4524,  0x4528,  0xDF2D,  0xC8AA,  0xC8AC,  0x4523,  
      0x4521,  0,       0,       0,       0,       0,       0xA5D8,  0x4B38,  // 0x3FBx
      0xCDC2,  0x4B37,  0x4B35,  0x4B33,  0x4B2F,  0xA5DC,  0x4B2E,  0x47D9,  
      0,       0x4B3B,  0xB0B6,  0x5148,  0x5149,  0xD1F5,  0x514E,  0x514A,  // 0x3FCx
      0x5150,  0x5726,  0x5722,  0x5B7B,  0x5B77,  0xC0EB,  0x5725,  0xC0E7,  
      0,       0x6032,  0x602F,  0x6030,  0,       0x6658,  0x6659,  0xDEC0,  // 0x3FDx
      0x73DC,  0x6A55,  0x6B72,  0x6B71,  0xE2AD,  0xA6F5,  0xAEB0,  0xB2D8,  
      0,       0xB7CE,  0xC3A2,  0xC8AD,  0x47DB,  0x4ED9,  0x5156,  0x6037,  // 0x3FEx
      0x665B,  0x6C73,  0x2746,  0x2A4E,  0xAEB1,  0x2E46,  0x2E45,  0x3347,  
      0x3348,  0x393A,  0xD552,  0x4530,  0x4532,  0xC8AF,  0xCDC3,  0x4B3D,  // 0x3FFx
      0x5157,  0x5B7E,  0x636C,  0x2748,  0x2A51,  0x2A50,  0x2E47,  0x2E49,  
} ;


static const unsigned short Uni2cnsP0Table_40 [] = {
      0xB2D9,  0x334B,  0xB7CF,  0xBDCE,  0xC3A3,  0x40EF,  0xC8B2,  0x515A,  // 0x400x
      0x4536,  0x572C,  0x6038,  0xDFB8,  0,       0x6E48,  0xA6F9,  0x2465,  
      0x274E,  0x274F,  0x274D,  0x274C,  0x274A,  0x2A53,  0x2A56,  0x2A57,  // 0x401x
      0x2A54,  0x2A58,  0x2AED,  0x2A5A,  0xB338,  0,       0xAEB4,  0x2E52,  
      0xB2DD,  0xB2E6,  0xB2E0,  0x2E4D,  0xB2E1,  0,       0,       0x33F6,  // 0x402x
      0x3350,  0x3351,  0xB7D6,  0xB7D4,  0x3352,  0x334E,  0x334D,  0xBDD0,  
      0x3949,  0xBDD4,  0x394A,  0xBDD5,  0x3945,  0x3948,  0x393F,  0x3941,  // 0x403x
      0x394B,  0x3946,  0x394D,  0x3947,  0x3943,  0x3F22,  0x394C,  0x3942,  
      0,       0x3F30,  0x3F2D,  0xC3A4,  0x3F25,  0x3F26,  0x3F27,  0x3F2B,  // 0x404x
      0x3F2C,  0xD561,  0x47E1,  0x4539,  0x4541,  0x453C,  0x4537,  0xC8B7,  
      0x4543,  0x4546,  0x453F,  0x4544,  0xC8BA,  0x4538,  0,       0xCDC5,  // 0x405x
      0x4B45,  0x4B42,  0x4B44,  0x4B47,  0x4B43,  0x4B4D,  0xCDC7,  0x4EE0,  
      0x4B3F,  0,       0xD1F7,  0xD1F8,  0x515C,  0x5160,  0xD1FC,  0xD1FA,  // 0x406x
      0x515D,  0x5164,  0,       0x5732,  0x572E,  0x5731,  0x572F,  0xD5DA,  
      0x5730,  0x5733,  0x5734,  0x56A2,  0x62E9,  0x5C27,  0x5C29,  0x5C2A,  // 0x407x
      0x5C25,  0xD8B7,  0x5C26,  0x6370,  0x636E,  0x6371,  0x636F,  0x665D,  
      0xDEC1,  0x6878,  0x6A57,  0x687A,  0x6C75,  0x6E4D,  0x2751,  0x2A5F,  // 0x408x
      0x3357,  0x454A,  0xD5DD,  0,       0x5738,  0x6374,  0x6B75,  0x2E57,  
      0x2E58,  0x335A,  0x3359,  0xCC2B,  0x3F33,  0x454C,  0xA4B2,  0xA6FA,  // 0x409x
      0x2753,  0xA8FA,  0x2A64,  0xAEB8,  0x2A62,  0xAEBC,  0xADBB,  0x2E5F,  
      0x2E5C,  0x2E62,  0x2FB4,  0xB7DB,  0xB2EA,  0xB2EB,  0x2E5E,  0x2E61,  // 0x40Ax
      0,       0x335E,  0x3361,  0xB7DC,  0x335F,  0xB7DA,  0x3360,  0xB7DE,  
      0xBDDB,  0x3AD9,  0xCC33,  0x3958,  0xBDD8,  0,       0x3953,  0x3F40,  // 0x40Bx
      0x3F39,  0x3F3F,  0xC3AF,  0x3F3C,  0xC3B2,  0x3F3D,  0xC3AC,  0x3F3E,  
      0x3F38,  0x3F3A,  0x3F3B,  0,       0,       0,       0,       0x3F42,  // 0x40Cx
      0x454E,  0xC8C3,  0x4551,  0xC8C1,  0x454D,  0x4555,  0x454F,  0x47F6,  
      0,       0x4B5C,  0x4B58,  0x4B56,  0x4B55,  0x4B5E,  0xA6A4,  0x4B5B,  // 0x40Dx
      0xD2A3,  0xD1FD,  0x516C,  0xD1FE,  0xB0D9,  0x56B3,  0x5170,  0,       
      0x516D,  0x573B,  0x5741,  0xC8C2,  0x5739,  0xD5DE,  0xD5DF,  0x573F,  // 0x40Ex
      0,       0xD8C1,  0x5C2D,  0xD8BD,  0x5C31,  0x5C2F,  0x5C2E,  0,       
      0x603F,  0xCEDC,  0xDCE3,  0x6376,  0x6375,  0x665F,  0x6660,  0x6661,  // 0x40Fx
      0x687C,  0x687B,  0xE0F5,  0xE1E7,  0,       0xAEBF,  0x2A67,  0x2A66,  
} ;


static const unsigned short Uni2cnsP0Table_41 [] = {
      0xB348,  0xB2EE,  0x2E64,  0xB2F1,  0xB7E4,  0x3363,  0x3362,  0xBDE1,  // 0x410x
      0xBDE0,  0x3959,  0,       0x3F45,  0x3F44,  0xC3BA,  0xC3BB,  0xC3BE,  
      0x3F47,  0xC3BC,  0xC3BF,  0xC8C6,  0x48A4,  0xC8C9,  0,       0,       // 0x411x
      0x4EF6,  0xCDCE,  0x5176,  0xD2A5,  0x5174,  0x5175,  0,       0x5742,  
      0xD8C6,  0xD8C7,  0xDAE4,  0,       0x6663,  0xE2B4,  0x24EE,  0xA6FD,  // 0x412x
      0x27C6,  0xAD49,  0x2756,  0xAAC0,  0xAAC1,  0xAAC3,  0x2A6A,  0x2A6F,  
      0x2A6B,  0x2A69,  0x2A6C,  0xACED,  0,       0,       0x2E65,  0xB2F5,  // 0x413x
      0xB2FA,  0,       0xC266,  0x3367,  0x3366,  0xB7ED,  0x3365,  0x34BB,  
      0x34B9,  0x336A,  0x3369,  0x336B,  0xB7E8,  0x336D,  0x34B8,  0xB7EE,  // 0x414x
      0xB7BB,  0,       0x3364,  0x3AE5,  0x395E,  0x3962,  0xBDE7,  0x3964,  
      0xBDEA,  0x3963,  0xBDEB,  0x3961,  0x3F4F,  0xC3C0,  0x3F4D,  0xC3C5,  // 0x415x
      0x3F4C,  0xC3C2,  0x3F4B,  0xC3C3,  0x4557,  0x3F49,  0x41B1,  0,       
      0xC8D1,  0xC8CA,  0x455B,  0xC8D3,  0xC8CE,  0x455A,  0xC8CC,  0x4558,  // 0x416x
      0xDF6B,  0x4559,  0,       0,       0x4B65,  0x4B61,  0xCDD4,  0x4B62,  
      0xCDD2,  0xA6B2,  0xCDD8,  0x4B68,  0x4B66,  0x4B64,  0xCDD9,  0x517D,  // 0x417x
      0x517C,  0xD2AB,  0x5179,  0x5178,  0x517A,  0xD2AD,  0x5745,  0xD5E3,  
      0x5747,  0xD8C8,  0xC1AE,  0x5C37,  0x5C35,  0x5C36,  0,       0,       // 0x418x
      0xDEC6,  0x6379,  0x6665,  0xD8CC,  0,       0x6664,  0x687E,  0x6921,  
      0xE2B9,  0x2469,  0xAD4E,  0xAEC6,  0xAEC5,  0x2A71,  0x2A72,  0xB3A1,  // 0x419x
      0xB2FE,  0xB2FD,  0x336F,  0x3370,  0xB7EF,  0x34C5,  0x3372,  0x3371,  
      0xC26F,  0xBDEC,  0x3967,  0xBDED,  0xCC53,  0xBDEE,  0x41B9,  0x3F53,  // 0x41Ax
      0x3F52,  0xD627,  0x4560,  0xDF78,  0x4B6C,  0x4FA3,  0,       0x54A4,  
      0x5225,  0x5222,  0x5224,  0xB0EF,  0,       0xD5E5,  0xD5E6,  0x574C,  // 0x41Bx
      0x574D,  0x574B,  0x574F,  0xD5E7,  0x5C39,  0x5C3A,  0x6048,  0x6049,  
      0x637C,  0x6922,  0xA4B4,  0xAAC6,  0,       0x2A76,  0xAECA,  0xB3A5,  // 0x41Cx
      0x2E6D,  0xB3A2,  0,       0x34C6,  0xBDEF,  0x396A,  0xC3C8,  0x3F54,  
      0x3F55,  0x3F5A,  0x4563,  0x5752,  0x5C3B,  0xDAE8,  0x2BA1,  0x2E75,  // 0x41Dx
      0x2E70,  0xB3A8,  0x2E77,  0xB3A9,  0x2E73,  0x2E72,  0x3376,  0x337D,  
      0xB7F4,  0x34C8,  0x3377,  0x337B,  0xB7F5,  0xC276,  0x3378,  0x396D,  // 0x41Ex
      0x3974,  0x3971,  0xBDF4,  0x3F5B,  0x3972,  0xBDFA,  0x3975,  0xBDF3,  
      0x396F,  0xCC5B,  0xCC56,  0,       0,       0xC3D0,  0x3F66,  0x3F62,  // 0x41Fx
      0x3F61,  0xC3D2,  0xC3D3,  0x3F5D,  0xC3CE,  0x3F60,  0xC3CB,  0,       
} ;


static const unsigned short Uni2cnsP0Table_42 [] = {
      0x3F63,  0x48C6,  0x3976,  0x4565,  0xC8DB,  0x456A,  0x4569,  0xC8DF,  // 0x420x
      0x456E,  0x4568,  0xC8D9,  0x456D,  0x4566,  0x48B6,  0x4B7B,  0x4B75,  
      0x4B70,  0xCDE1,  0xCDDE,  0x4C22,  0xCDE7,  0x4B7E,  0xCDE2,  0x4C2E,  // 0x421x
      0x4FBB,  0xCDE4,  0x4C30,  0x4C25,  0x4C2D,  0x4B79,  0x4FB2,  0xCDDF,  
      0x4FC5,  0x4C2C,  0x4C27,  0x4B77,  0xCDE6,  0xCDE8,  0x4C28,  0x4FB6,  // 0x422x
      0,       0,       0x5234,  0x523A,  0xD2B1,  0x5237,  0x522B,  0x5238,  
      0xD2B5,  0x5239,  0x523B,  0x5236,  0x522F,  0x523D,  0x5229,  0xD2B2,  // 0x423x
      0x575B,  0x5CED,  0x575E,  0x575A,  0x5762,  0x5CFD,  0x5765,  0x5753,  
      0xD5EC,  0x5756,  0x5758,  0x5759,  0x5CFE,  0x5755,  0x5DB0,  0,       // 0x424x
      0x5C44,  0x5C4F,  0x5C4B,  0x5C50,  0x5C43,  0xD8CA,  0x5C4A,  0xDAEC,  
      0x5C42,  0x5C4C,  0xC1BF,  0x5C46,  0x5C49,  0x5C40,  0x63B4,  0x5C48,  // 0x425x
      0xD8CD,  0xD8CB,  0x63C1,  0x6056,  0x68EE,  0xDAEA,  0x6053,  0x68E6,  
      0xDAED,  0xDAE9,  0xDAEB,  0x5C51,  0,       0x637E,  0x6669,  0x666C,  // 0x426x
      0x666E,  0xDECA,  0x666A,  0xDECD,  0x6668,  0x666D,  0xDFD6,  0x70E1,  
      0x6926,  0x6928,  0x6A5D,  0x6A61,  0x6A5C,  0xE0DF,  0x6B76,  0x6D5C,  // 0x427x
      0x6D76,  0xE5DD,  0x2A77,  0xB3AF,  0xB3B3,  0xC322,  0x3425,  0x34D9,  
      0xB7FC,  0xCC60,  0x397B,  0x397C,  0xBDFD,  0xBDFC,  0x397D,  0xC3DA,  // 0x428x
      0xC3D6,  0xC3D7,  0xC3D9,  0xC3DB,  0,       0xC8E3,  0x4572,  0xC8E4,  
      0xC8E5,  0xE02C,  0xC8E6,  0xCDEB,  0xCDEC,  0xCDE9,  0xCDEA,  0x4C37,  // 0x429x
      0xA6D7,  0x4C35,  0xD2B6,  0x576D,  0xD5F3,  0xD5F2,  0x5769,  0x576A,  
      0xCDF4,  0x576B,  0,       0x63CE,  0x5C56,  0xD8D2,  0x5C55,  0x5C54,  // 0x42Ax
      0x63D4,  0xD8D3,  0xDAF0,  0x605B,  0x605D,  0x6423,  0xDCE8,  0xD4BA,  
      0x70F0,  0x6A65,  0x76B9,  0x6C7A,  0xE1C5,  0x275C,  0xB364,  0xAED7,  // 0x42Bx
      0xAED5,  0xAED8,  0x2E78,  0x2E7E,  0xB3B5,  0xB3B4,  0x2E7C,  0xB3B9,  
      0x2F21,  0xB3B8,  0x2E7D,  0xB3B6,  0xB3BA,  0,       0,       0,       // 0x42Cx
      0x342E,  0x3426,  0xB8A3,  0xB8AA,  0x3427,  0x3430,  0xB8AC,  0x342D,  
      0x342B,  0x3429,  0xB8A8,  0xB8AD,  0xB8A5,  0xBEB6,  0x3BAC,  0xBEAD,  // 0x42Dx
      0xBEB2,  0xBEA7,  0xBEB0,  0xBEA5,  0xCC71,  0,       0xBEB1,  0x3F6A,  
      0xC3E5,  0xC3EB,  0x3F6E,  0x3F73,  0x3F6F,  0xC3E1,  0xC3DD,  0xC8EC,  // 0x42Ex
      0x4575,  0x457E,  0x4579,  0x4621,  0xC8E7,  0xC3DF,  0xC8F2,  0xC8F5,  
      0x4623,  0x48D4,  0xC8EF,  0xCEAA,  0x4FD3,  0x4C3E,  0x4C3C,  0x4C40,  // 0x42Fx
      0xCDFB,  0xCEA1,  0xCEAD,  0xCDF6,  0xCDF9,  0x4C3A,  0x4C3D,  0x4C3F,  
} ;


static const unsigned short Uni2cnsP0Table_43 [] = {
      0xCDFA,  0x4C44,  0x4FD4,  0xCEA6,  0xCEA3,  0xD2BA,  0x5249,  0xD2BC,  // 0x430x
      0x5247,  0xD2BD,  0xD2BE,  0,       0x5773,  0xD5F8,  0x5DBF,  0xD5F6,  
      0x5DC6,  0xD5F7,  0x576E,  0xD5FC,  0xD5FB,  0xBAB9,  0x5C62,  0x5C60,  // 0x431x
      0x5772,  0xD8D7,  0xD8D6,  0xD9A9,  0x6066,  0x6063,  0x6068,  0x6062,  
      0xC7CA,  0xDAF3,  0xDAF1,  0x6DA2,  0xDCE9,  0x6424,  0xDCEA,  0xDCEB,  // 0x432x
      0xDECF,  0xDECE,  0x692A,  0xD8D8,  0xDFD9,  0x692B,  0x6A66,  0x6B79,  
      0x6B78,  0xDFB3,  0xE0F8,  0x6C7C,  0x6C7B,  0x6D77,  0,       0,       // 0x433x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x2A79,  0x2F29,  0xB8AF,  0xB8B2,  0x34E0,  0x3434,  // 0x434x
      0xB8B0,  0x3433,  0x3A28,  0x4625,  0xC8F6,  0x524E,  0x6A6B,  0xA1C7,  
      0xAACD,  0xAEDC,  0xAEDB,  0xAED9,  0x2A7B,  0x2F2A,  0xBA6B,  0x2F2D,  // 0x435x
      0x3435,  0x3F75,  0x3A2A,  0xC3EC,  0xC3ED,  0x41E5,  0xC8FA,  0xC8FB,  
      0,       0x524F,  0x5775,  0x5C65,  0x606D,  0x667B,  0x6B7B,  0xBA74,  // 0x436x
      0x2F2E,  0xB1BF,  0x3438,  0x3436,  0x3437,  0xC33C,  0x3A2D,  0x3A31,  
      0x3A30,  0x3F76,  0xC8FE,  0x4627,  0xC8FD,  0x4628,  0xC8FC,  0x4C49,  // 0x437x
      0x5253,  0xD2C1,  0x5777,  0x5C6A,  0x5C6B,  0x692C,  0xB3C0,  0xB3C1,  
      0x343A,  0xB8B3,  0x343B,  0x343E,  0x343C,  0xB8B5,  0xB8B4,  0x3A34,  // 0x438x
      0x3A35,  0x3BBA,  0x3A33,  0xC3F0,  0x3F78,  0xC3F1,  0x3F77,  0xC3EF,  
      0xC9A1,  0x462A,  0x4629,  0x462B,  0x5255,  0x5256,  0xD8DE,  0xD8E0,  // 0x439x
      0xD8DF,  0xDCEE,  0x667D,  0,       0xBEB9,  0xBEBA,  0,       0x2B27,  
      0x2B28,  0x2F38,  0x2B29,  0xB8B8,  0x3F7A,  0,       0x462E,  0x462D,  // 0x43Ax
      0x462F,  0x4632,  0x4630,  0x4C4F,  0,       0x577D,  0x577A,  0x577B,  
      0x5C70,  0x6721,  0x246D,  0xB3C6,  0xB3C5,  0xB8BA,  0x3441,  0x3A39,  // 0x43Bx
      0x41F0,  0xC3F4,  0x4636,  0x4634,  0x4635,  0x4637,  0xC9A4,  0xCEB3,  
      0x4C52,  0x525A,  0xD2C2,  0x525B,  0x5821,  0x5824,  0x5823,  0x5822,  // 0x43Cx
      0xD8E4,  0x6428,  0xDFDC,  0xD66D,  0x232D,  0xA549,  0x246F,  0x246E,  
      0xAAD1,  0xBB28,  0xAAD5,  0xAAD0,  0x2766,  0xA8D2,  0x2762,  0x2767,  // 0x43Dx
      0x2763,  0x2765,  0x27D8,  0xAADA,  0xAAD3,  0,       0x2BB3,  0x2B2F,  
      0x2B2A,  0x2B2C,  0xAEE2,  0xAEDF,  0xB37D,  0x2BB9,  0xB3D1,  0x2F41,  // 0x43Ex
      0x2F46,  0x2F47,  0x2F3F,  0xBB31,  0x2FED,  0,       0,       0xB8C6,  
      0x344C,  0x3448,  0xB8C4,  0x344B,  0x3452,  0x3451,  0x344A,  0x3453,  // 0x43Fx
      0xC358,  0xB8C0,  0xB8BF,  0xB8C3,  0x3A49,  0x3A3A,  0xBEBF,  0x3A45,  
} ;


static const unsigned short Uni2cnsP0Table_44 [] = {
      0x3BCD,  0x3A4A,  0x3A41,  0x3A40,  0x3A42,  0x3A3D,  0,       0xBEC6,  // 0x440x
      0x3A3F,  0x3A44,  0x3A4B,  0xC97E,  0xCD54,  0xD676,  0x4027,  0xC3F8,  
      0x402A,  0x4023,  0x4026,  0xC3FA,  0x3F7D,  0x4028,  0xC4A1,  0x402C,  // 0x441x
      0xC3FD,  0xC3F9,  0x34EA,  0x4025,  0x4645,  0x463E,  0x463C,  0x463D,  
      0x463F,  0xD2C8,  0x4642,  0x4640,  0x463B,  0xC9A9,  0xC9A8,  0x4638,  // 0x442x
      0x4647,  0x4641,  0,       0x4C5D,  0x4C58,  0x4C5E,  0x4C55,  0x4C5C,  
      0xE06F,  0x4C54,  0x4C5B,  0x4C5F,  0x42A8,  0x5263,  0x5264,  0xD2C6,  // 0x443x
      0xD2C5,  0x525E,  0x5261,  0x5262,  0x5266,  0xD1D5,  0x5DDB,  0x582B,  
      0x5828,  0x582C,  0x5C74,  0xD8E6,  0x5C76,  0xD8E7,  0xDAF6,  0x6074,  // 0x444x
      0x6073,  0x6DAC,  0x642A,  0x6722,  0x6724,  0x6723,  0x6725,  0x6930,  
      0xC364,  0xC2A4,  0xABC4,  0xC4A4,  0x2F4A,  0x3458,  0,       0x4C63,  // 0x445x
      0x526B,  0xB3D3,  0xB3D4,  0xB8CA,  0x4C64,  0xE121,  0xD2CB,  0xDED4,  
      0x276F,  0x2B33,  0x2B32,  0xAEE7,  0xB3D6,  0x2F50,  0xB8CB,  0xC371,  // 0x446x
      0xC370,  0,       0xBECA,  0x3A4E,  0x3A4F,  0xCD63,  0,       0x42AD,  
      0x402F,  0x464F,  0x4651,  0x4650,  0xC9AC,  0xE124,  0x49AC,  0,       // 0x447x
      0,       0xCEBE,  0x4C68,  0x4C65,  0x526C,  0x526D,  0,       0x5830,  
      0x5834,  0x5833,  0xD6A5,  0xD6A6,  0x5DE7,  0x5CCD,  0x5832,  0,       // 0x448x
      0x5C7C,  0x642D,  0x2F53,  0x345C,  0x526F,  0x526E,  0x5835,  0x5C7D,  
      0x6933,  0,       0xA54F,  0xA4B7,  0xA4B9,  0xA7A7,  0x2476,  0x247D,  // 0x449x
      0xA7AC,  0,       0xAAE3,  0xAAE7,  0xAAE4,  0xAAEA,  0x2772,  0xAAE2,  
      0x2821,  0x2773,  0xAAE5,  0xAAE9,  0x27E3,  0xAAE1,  0xAEED,  0x2B36,  // 0x44Ax
      0xAEF0,  0xAEF1,  0xAEEC,  0xAEF3,  0xAEF5,  0xB43A,  0,       0,       
      0x2F55,  0xB3E1,  0x2F61,  0xB3E4,  0xB3DB,  0xB3DE,  0xBB56,  0xB3DD,  // 0x44Bx
      0x2F5E,  0xB3DC,  0xB3E5,  0x30A1,  0x2F59,  0x2F64,  0,       0,       
      0,       0xB3E0,  0x345E,  0x346C,  0x3471,  0xB8DA,  0x3469,  0x3465,  // 0x44Cx
      0xB8D6,  0x3466,  0x3462,  0x345D,  0x3463,  0xC42C,  0xB8CC,  0xC428,  
      0x35AA,  0xB8D9,  0xB8DC,  0x35A4,  0,       0,       0,       0x3A6C,  // 0x44Dx
      0x3A60,  0x3A5F,  0x3A64,  0x3A59,  0x3BD6,  0x3A5B,  0x3A56,  0xBED3,  
      0x3A5E,  0xBED4,  0xBED1,  0x3A5C,  0x3A61,  0xBED5,  0xCE27,  0xBECC,  // 0x44Ex
      0,       0,       0xBEEB,  0,       0,       0x4030,  0x4032,  0x3A65,  
      0xC4B7,  0x4669,  0x4047,  0x4049,  0x403A,  0xC4AB,  0xC4A9,  0xC4B4,  // 0x44Fx
      0x4048,  0xC4BD,  0x404C,  0,       0x4665,  0xC9AF,  0x4657,  0xE144,  
} ;


static const unsigned short Uni2cnsP0Table_45 [] = {
      0x4664,  0xC9B1,  0x4653,  0x49BC,  0x4661,  0xC9B0,  0x466D,  0x4660,  // 0x450x
      0x465C,  0xC9B4,  0x49BB,  0xE158,  0xC9B7,  0xC9C0,  0xCEC3,  0x4C72,  
      0xCEBF,  0x4C70,  0x4D24,  0x4C6B,  0xCEC1,  0x4C71,  0xCED3,  0x4C6D,  // 0x451x
      0x4C73,  0xCEC7,  0xCEC5,  0xCED6,  0x4C7D,  0xD2D1,  0x4C6C,  0xCECA,  
      0x4C6E,  0xCEC8,  0xCED5,  0xCEC9,  0x50C6,  0xCED0,  0xD1E5,  0xD1F3,  // 0x452x
      0xD1F6,  0x4D21,  0x4C6F,  0xCED1,  0x4C77,  0x5277,  0x527B,  0x5279,  
      0x532C,  0x5321,  0x5276,  0xD2D3,  0x5325,  0xD2D7,  0x527E,  0xD2CD,  // 0x453x
      0x5323,  0x527A,  0x527C,  0x5272,  0x64AD,  0xD2CC,  0x5322,  0x5273,  
      0xD2CE,  0x5327,  0,       0x5331,  0x4667,  0x5844,  0x583C,  0x5838,  // 0x454x
      0x5842,  0x5DF9,  0x5836,  0x583B,  0xD6AE,  0xD6A7,  0x583D,  0xD6AA,  
      0,       0xD6AF,  0xD8E9,  0x5C7E,  0x5D2B,  0xD8ED,  0xD8F0,  0xD8EA,  // 0x455x
      0xD8F1,  0x5D23,  0xC2B8,  0x5D21,  0xE0CE,  0xBBB2,  0x6077,  0xDCF3,  
      0xDBA3,  0x6078,  0xDBA1,  0,       0xDBA4,  0xC9D3,  0x642F,  0x6434,  // 0x456x
      0xDCFD,  0x6433,  0xDCF4,  0xD4E8,  0xDCF9,  0x6432,  0x6438,  0xDCFA,  
      0x6430,  0xDCF5,  0x6436,  0x6727,  0xDED9,  0x6728,  0,       0xE8B9,  // 0x457x
      0xDFDD,  0x6937,  0xD8F2,  0xE0C1,  0xE0C2,  0x78A5,  0x6B7D,  0x6D5E,  
      0x6C7D,  0xE1EA,  0x6D79,  0x6D7B,  0xECEC,  0x6E37,  0x6E36,  0x7CBE,  // 0x458x
      0xAAED,  0x2B3E,  0x2F67,  0xB3E7,  0xB3E6,  0xB3E8,  0x35B5,  0xB8E2,  
      0x3BF0,  0xBEE0,  0xC4C1,  0x42D4,  0x42D3,  0xC4C2,  0xC4C3,  0x4D26,  // 0x459x
      0x5336,  0x5D32,  0x64BB,  0x64BA,  0x643A,  0xA7AE,  0xAEFD,  0xAFA1,  
      0xAFA2,  0x2F69,  0x2F6B,  0xBB69,  0xB8E8,  0xB8E7,  0x347C,  0xB8E5,  // 0x45Ax
      0x347B,  0x3479,  0x3CA6,  0xC448,  0,       0x3A72,  0xBEE7,  0x3A74,  
      0xBEE5,  0x3BF4,  0x3A70,  0x3A6D,  0xBEE4,  0xBEE6,  0x4056,  0x4057,  // 0x45Bx
      0xC4CB,  0xC4C7,  0x405B,  0x3A6E,  0x405D,  0xC4CA,  0,       0x4678,  
      0xC9C6,  0x4672,  0x4673,  0x4671,  0x4675,  0xC9C7,  0x4670,  0x4676,  // 0x45Cx
      0xE169,  0xC9C8,  0x467B,  0xCEDA,  0xCEDC,  0xA8C2,  0xCED7,  0xCED8,  
      0x4D30,  0xCEDB,  0x4679,  0x4D36,  0x4D2F,  0xC9CD,  0,       0x533E,  // 0x45Dx
      0xD2DC,  0xB2F3,  0x533D,  0x584D,  0xD2E0,  0xB2F5,  0xD2E1,  0x5EB2,  
      0x5857,  0x5852,  0xD6B7,  0x5858,  0x584F,  0x5856,  0xD6B8,  0x584E,  // 0x45Ex
      0xD6B2,  0x5854,  0x585F,  0xD6B5,  0xD6BC,  0,       0xD6B1,  0x5D3B,  
      0x5EB5,  0x5D39,  0xD8F2,  0,       0x6124,  0x69C1,  0xDBAA,  0x6121,  // 0x45Fx
      0x6125,  0xE3EE,  0x6DCB,  0,       0x643B,  0x643C,  0x6440,  0x643E,  
} ;


static const unsigned short Uni2cnsP0Table_46 [] = {
      0x6441,  0xDDA6,  0xDEDE,  0x6730,  0x643D,  0x693E,  0xDFDE,  0xDFE0,  // 0x460x
      0xE0C4,  0xD9A5,  0xDCDE,  0x6A78,  0xDCE3,  0xE1C8,  0x6E39,  0xAFA5,  
      0xBB73,  0xB8E9,  0xC4CC,  0x4723,  0x4D37,  0x2F6F,  0x3A78,  0xCEDE,  // 0x461x
      0x534A,  0xDBAE,  0xAAEE,  0,       0xAFA8,  0x2B46,  0,       0x30BD,  
      0x2F72,  0x30B9,  0x352A,  0x3A7A,  0x352D,  0x352E,  0x352C,  0xB2D1,  // 0x462x
      0x3A79,  0xBEF1,  0x3530,  0xBEEE,  0xBEEC,  0xBEEB,  0xAFCA,  0x4062,  
      0x4725,  0xD82B,  0,       0xC9D3,  0x472D,  0x49EC,  0x49ED,  0x4066,  // 0x463x
      0x4731,  0x4727,  0xC9D5,  0x4060,  0x472A,  0x472E,  0x4726,  0x472B,  
      0xC9DA,  0xC9D0,  0xC9DB,  0x4D3C,  0x4D3F,  0x4D3A,  0x4D39,  0x4D42,  // 0x464x
      0x4D40,  0x4D47,  0,       0,       0,       0,       0x5352,  0x5355,  
      0x5356,  0xCEE3,  0x534F,  0,       0x5863,  0x5867,  0xD6C5,  0xD6C3,  // 0x465x
      0x5864,  0xD6BE,  0xBBD9,  0xD6C4,  0x5865,  0xD6C1,  0x64D6,  0x5D4A,  
      0x5D48,  0x5D49,  0x5D44,  0x5D46,  0x612A,  0xC3A2,  0x6443,  0xD0A5,  // 0x466x
      0xDDA7,  0x6444,  0xDEDF,  0,       0x6A7B,  0xD9B2,  0xE0FA,  0x6C26,  
      0xE0F9,  0x6D7D,  0x2BC7,  0x2F73,  0x3531,  0x3B21,  0,       0xB3F9,  // 0x467x
      0xB3F8,  0x3533,  0x3535,  0,       0x3B23,  0x3CB5,  0x3B22,  0xBEF3,  
      0xC4D0,  0xC4D1,  0x4736,  0x4738,  0x4D4A,  0x4D48,  0x535A,  0x535B,  // 0x468x
      0x58B2,  0x535C,  0x5EC3,  0x5868,  0x5869,  0x5D4E,  0x5D50,  0x612D,  
      0x612E,  0xDBB0,  0x612C,  0x6130,  0xDEE0,  0,       0xE2BC,  0x353A,  // 0x469x
      0xC4D3,  0x4067,  0xC4D2,  0x473A,  0x4D51,  0x4D4C,  0x4D4E,  0x4D53,  
      0x4D4F,  0x5364,  0x5361,  0x5362,  0,       0x586B,  0x586A,  0x64E3,  // 0x46Ax
      0x6131,  0x6134,  0x6446,  0x6447,  0,       0x6D22,  0xAFAB,  0x2BC9,  
      0xAFAD,  0x2F7E,  0xB3FD,  0x3541,  0xB8FC,  0xB8F8,  0x35D7,  0x3544,  // 0x46Bx
      0x35DE,  0xB9A4,  0xB9A8,  0xB9A1,  0x353F,  0xB8FD,  0xB9A7,  0x3543,  
      0x35DD,  0xC46D,  0xB9A6,  0x35D6,  0x3B33,  0xBEF9,  0xBEFA,  0x3B36,  // 0x46Cx
      0x3B35,  0xBEF6,  0xBEFB,  0xBEF7,  0x3B34,  0x3B2A,  0x3B29,  0x3B2B,  
      0xBFA6,  0xCE6B,  0xBFA5,  0,       0xC4D7,  0xD841,  0xC4DE,  0x406E,  // 0x46Dx
      0x406D,  0x406C,  0xC4DA,  0xC4DF,  0xC4E2,  0x473D,  0x4740,  0x474A,  
      0x473C,  0xC9EA,  0x4746,  0x4742,  0xC9E1,  0x4743,  0xC9E9,  0xC9E7,  // 0x46Ex
      0xC9DD,  0x4D59,  0x4D56,  0x4D5C,  0x4D5E,  0xCEE8,  0x4D61,  0x4D58,  
      0x4D5B,  0xCEED,  0x4D5F,  0x4D5A,  0xCEEB,  0x4D60,  0xA8F9,  0x4D55,  // 0x46Fx
      0xCEF1,  0x536A,  0xD2EC,  0xD2ED,  0xB3CD,  0x536B,  0xD6C7,  0x5870,  
} ;


static const unsigned short Uni2cnsP0Table_47 [] = {
      0xD6CB,  0xD6CC,  0x5ED5,  0x5D5A,  0xCAA5,  0x5D57,  0x5D5B,  0xD9A2,  // 0x470x
      0xD9A5,  0x5D54,  0xD9A7,  0x6140,  0x69D2,  0xDBB3,  0x613B,  0x613D,  
      0x6145,  0x69D1,  0x644E,  0xDDAD,  0xD0B1,  0x644C,  0xDDAF,  0x6448,  // 0x471x
      0xDDB1,  0x673D,  0x673F,  0xD5B2,  0x673E,  0x6740,  0x6739,  0xD9B8,  
      0xDFE3,  0x6948,  0x76CC,  0,       0,       0,       0,       0,       // 0x472x
      0,       0,       0x2B49,  0x3023,  0xCE7A,  0xBFA7,  0x474C,  0xCEF7,  
      0x5875,  0x5D61,  0x694C,  0,       0x354A,  0xBFA8,  0x4074,  0x474E,  // 0x473x
      0x474F,  0xC9EC,  0x4D64,  0xD2F0,  0x5373,  0xD2EF,  0x5372,  0xD2F1,  
      0x5876,  0x5877,  0xD6CE,  0x6744,  0x6D24,  0x3025,  0x354B,  0xC522,  // 0x474x
      0x354C,  0xC4F4,  0x4D67,  0x4D65,  0x4D68,  0x5375,  0x5377,  0x5D64,  
      0x6148,  0x6146,  0x6745,  0xDFE5,  0xE1CC,  0x6D25,  0x3550,  0xC524,  // 0x475x
      0xB9AF,  0,       0x3B3E,  0,       0xC9EE,  0xCEF9,  0xCEF8,  0xD2F2,  
      0xD6D0,  0xD9AC,  0xD9AD,  0x614A,  0xCAC1,  0xDBB7,  0x5D68,  0x3551,  // 0x476x
      0x3554,  0x3CCC,  0x3B3F,  0x3B41,  0xBFAE,  0x3B42,  0xCF29,  0x3B43,  
      0x4121,  0xC4E6,  0xC4E8,  0x4AA9,  0xE26A,  0xC9EF,  0xCEFB,  0xCEFC,  // 0x477x
      0x4D6E,  0x4D6C,  0xA9B6,  0x4D6D,  0,       0x51B9,  0xCFA1,  0xD2F4,  
      0x537D,  0x5379,  0x537B,  0x537A,  0xD2F6,  0xBCB3,  0x587A,  0xE0FA,  // 0x478x
      0x537E,  0xDDB5,  0xDEE4,  0x6B21,  0,       0,       0,       0,       
      0,       0x30CB,  0x43B4,  0x4759,  0x4758,  0x6748,  0x30CC,  0x3027,  // 0x479x
      0x3028,  0x3555,  0x3556,  0xB9B4,  0xB9B6,  0xBFB1,  0x3B45,  0xBFB6,  
      0xBFB2,  0x3CD2,  0xBFB5,  0x3B48,  0x3B47,  0x4126,  0x4127,  0x43BC,  // 0x47Ax
      0xC4EA,  0x4128,  0x43B8,  0x475A,  0xE275,  0x475B,  0xC9F6,  0x4AB4,  
      0xC9F7,  0x4AB2,  0,       0xCFA7,  0x4D73,  0x4D71,  0xCFA4,  0x4D74,  // 0x47Bx
      0xA9BD,  0x5426,  0x58DC,  0x58D5,  0xD2F8,  0x587D,  0x5925,  0x587C,  
      0x5EED,  0x5D6D,  0xD9AF,  0x5D6C,  0x5D6A,  0x5D6E,  0xD9B0,  0x614D,  // 0x47Cx
      0xDDB6,  0x6455,  0x6453,  0x6456,  0x674A,  0x694E,  0xDFE6,  0x694F,  
      0x6B23,  0x6C28,  0x6D27,  0x2B4C,  0xAFAF,  0x302A,  0xB3FE,  0x355E,  // 0x47Dx
      0x3559,  0x35F2,  0xB9BB,  0x355B,  0x355C,  0x355D,  0xB9BC,  0x3CE3,  
      0x3B4C,  0x3B50,  0xBFBD,  0x3B4D,  0x3B49,  0xCF36,  0xCF3C,  0x3CDC,  // 0x47Ex
      0x3B4A,  0x3B4B,  0x3B4F,  0xBFBC,  0x3CDF,  0x3B51,  0x4129,  0x43CB,  
      0xC4EC,  0xC4EE,  0,       0xC5D8,  0x4ABE,  0x475E,  0x4761,  0x475F,  // 0x47Fx
      0x4762,  0x4765,  0xC9F8,  0x4764,  0xCFA8,  0xC4EF,  0x4D77,  0x4E22,  
} ;


static const unsigned short Uni2cnsP0Table_48 [] = {
      0xCFAA,  0xA9CE,  0xCFAE,  0xCFA9,  0x4D7E,  0x4E21,  0x4D7D,  0x4D79,  // 0x480x
      0x4D78,  0x4D76,  0xCFAD,  0x4E23,  0,       0x542E,  0xD2FD,  0xD2FA,  
      0x542F,  0x542D,  0x58E2,  0x5430,  0xD2F9,  0x5EFB,  0,       0x592B,  // 0x481x
      0x592C,  0x5926,  0xDCF8,  0x592A,  0x5928,  0xD6D3,  0xD9B3,  0x5D74,  
      0x5D78,  0x5D72,  0x5D75,  0xCAD7,  0x6150,  0xD9B4,  0x6151,  0x5D77,  // 0x482x
      0x645B,  0x645A,  0x6750,  0x674C,  0x74CB,  0x6B24,  0xDCF7,  0x6C29,  
      0xE1CF,  0xE2AE,  0xBFC2,  0x3CE7,  0x3B52,  0x3B53,  0xBFC1,  0xC4F1,  // 0x483x
      0xC4F0,  0xC4F2,  0,       0x4E26,  0x5432,  0x5930,  0xD6D6,  0xDBBE,  
      0x645F,  0xE0CC,  0x2B4D,  0x2B4E,  0xADD3,  0xB4A2,  0xB9C3,  0xB9C4,  // 0x484x
      0xB9C8,  0x3561,  0x3562,  0xB9C5,  0xB9C6,  0xB9C2,  0xC545,  0xBFC8,  
      0xBFC3,  0x3B54,  0xBFCA,  0xC4F5,  0x412A,  0xC4F4,  0xD924,  0x412C,  // 0x485x
      0x4766,  0x4769,  0x4767,  0xC9FE,  0x4E28,  0x4E27,  0x4E2A,  0x4E29,  
      0xD3A3,  0x58F2,  0x5433,  0x5434,  0x51E1,  0xD6D8,  0x5932,  0x5935,  // 0x486x
      0x5937,  0xD6D7,  0x5931,  0x5D7C,  0x5D7B,  0x5D7A,  0x65B5,  0x5D7D,  
      0x5D7E,  0,       0x6159,  0x6158,  0x6157,  0x6460,  0x6461,  0x6752,  // 0x487x
      0xE8D3,  0xDFE8,  0xDFE7,  0,       0xE0FD,  0x6D61,  0x6E21,  0xE2BD,  
      0,       0,       0,       0x4E2E,  0xDDB9,  0x476B,  0xCCE7,  0xCFB8,  // 0x488x
      0x6463,  0xD0D6,  0xA7B2,  0x2522,  0xA8F2,  0xAAEF,  0x27E9,  0,       
      0x2B53,  0x2B50,  0xB4A3,  0x302D,  0x3030,  0xB4A4,  0x302E,  0,       // 0x489x
      0,       0xB9C9,  0x3569,  0xB9CD,  0xBFD3,  0x3B57,  0xBFCE,  0xCF48,  
      0xBFD2,  0x412F,  0xCAA5,  0,       0x476C,  0xCAA3,  0xCFBA,  0x4E31,  // 0x48Ax
      0x4E35,  0xCFBD,  0xD3AA,  0xD3A8,  0xD3A9,  0x5938,  0x5939,  0xC3F7,  
      0xD9B9,  0x615E,  0x6C2C,  0xA2DF,  0x2332,  0xA7B6,  0xA7B7,  0xA7B8,  // 0x48Bx
      0xAAF6,  0x2829,  0,       0xAFB6,  0x2B56,  0xC5A2,  0xAFBD,  0x2B54,  
      0x2B58,  0xAFB9,  0xAFBA,  0xB46D,  0x3038,  0x3034,  0xB4A8,  0x3033,  // 0x48Cx
      0x4771,  0,       0x356C,  0x356E,  0x3573,  0x356B,  0xB9D0,  0x3570,  
      0x3B5E,  0xBFD8,  0,       0x4134,  0x4136,  0xC5A1,  0x593C,  0x4138,  // 0x48Dx
      0x476D,  0x476E,  0xCAA9,  0xCAA8,  0x4AE0,  0x4770,  0xCFBE,  0x4E3D,  
      0x4E3C,  0x58FE,  0x5FBC,  0xE0CD,  0x6B26,  0xAFBF,  0,       0xB4AB,  // 0x48Ex
      0xB4AC,  0x3578,  0x3574,  0xB9D3,  0x36B6,  0x3575,  0x3B60,  0xBFDA,  
      0xBFDB,  0xBFDC,  0x3B64,  0,       0xD94C,  0xC5A6,  0x413D,  0x413C,  // 0x48Fx
      0x413F,  0x413E,  0x4773,  0x4774,  0x4E3F,  0x4E41,  0x4E3E,  0x4E40,  
} ;


static const unsigned short Uni2cnsP0Table_49 [] = {
      0,       0x543D,  0x543C,  0x543A,  0xD3AE,  0x5440,  0x543B,  0xB4D4,  // 0x490x
      0xD3B0,  0x593D,  0x5942,  0xBCF0,  0x5941,  0x65C5,  0x6161,  0x6164,  
      0x6163,  0x6162,  0x6165,  0x675A,  0x675B,  0x6954,  0x6953,  0x6C2E,  // 0x491x
      0x6C2D,  0x6E3D,  0x357A,  0xBC63,  0xB9DA,  0xBFDF,  0xBFE4,  0xBFE1,  
      0xBFE7,  0xC5AC,  0x43ED,  0,       0xCAAE,  0x4779,  0xCAB6,  0x4776,  // 0x492x
      0x477B,  0,       0x4778,  0xCFCF,  0x4E43,  0xCFC7,  0xCFC6,  0xAAB8,  
      0xCFCA,  0xAABE,  0,       0xD3B3,  0xD3B4,  0x5448,  0x5446,  0xBCFB,  // 0x493x
      0xD6E9,  0xBCF7,  0x5945,  0x5944,  0xDDCC,  0xD9BF,  0xD9C1,  0x5E2F,  
      0x5E2C,  0xC4B9,  0x5E27,  0x65CF,  0x5E2B,  0xD9C8,  0xD9C7,  0,       // 0x494x
      0xDBC6,  0x6166,  0xDBCB,  0xDBC0,  0xDBD2,  0x6169,  0x6AB3,  0x6168,  
      0xDBD1,  0xDBCC,  0xDBC9,  0xE4B4,  0xDDBB,  0x616C,  0xDDC0,  0x6466,  // 0x495x
      0x646C,  0x6EB5,  0xDDC8,  0x646D,  0,       0x675F,  0xDEEB,  0x6469,  
      0x6761,  0xDEEC,  0x6763,  0xD5E8,  0xDEE9,  0xDEEE,  0xDEEF,  0xDFEF,  // 0x496x
      0xE0D1,  0x71D5,  0xD9E7,  0xDFED,  0xD9E8,  0xDFF0,  0x74D5,  0x6B2A,  
      0x76DF,  0x6B27,  0xE0CE,  0xE0D0,  0xE1A3,  0xE1A1,  0x6C30,  0xE1A4,  // 0x497x
      0xE1EE,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xBC65,  // 0x498x
      0x3B67,  0xBFF6,  0x4149,  0x5E32,  0xB9DB,  0x357C,  0xBFEA,  0x3B6B,  
      0xBFEE,  0xBFEB,  0xC5BB,  0x4150,  0x414E,  0x4823,  0xCABB,  0xCABF,  // 0x499x
      0xCABA,  0x4AEE,  0xCABC,  0,       0xAAC6,  0x4E48,  0xCFD4,  0xCFD7,  
      0x544F,  0x544B,  0xD3BF,  0x544C,  0xD3C1,  0xD3C3,  0xD3C6,  0xD3C5,  // 0x49Ax
      0xB4F3,  0,       0x594E,  0x594F,  0x5954,  0xD6EE,  0xD6EC,  0x594D,  
      0,       0x5952,  0x6766,  0x6471,  0x71DB,  0x6955,  0,       0,       // 0x49Bx
      0,       0x21FD,  0xA2E0,  0xA4BE,  0x24FB,  0xA935,  0,       0,       
      0,       0x2831,  0x2832,  0xAAFA,  0x2BE4,  0x2B5A,  0xAFC1,  0x2B59,  // 0x49Cx
      0,       0x3040,  0x303D,  0xB4B5,  0x303E,  0xB4B7,  0x303C,  0,       
      0xB9E3,  0xB9DD,  0x357D,  0xB9E0,  0xB9E2,  0xB9E4,  0xB9DF,  0xBFEF,  // 0x49Dx
      0x3B6D,  0xBFF4,  0xC5BF,  0xC5BE,  0x4155,  0x4154,  0xC5BD,  0xC5C1,  
      0xCAC1,  0xCAC0,  0xCAC3,  0xCAC2,  0xCFD9,  0xCFD8,  0xAAD4,  0xD3C7,  // 0x49Ex
      0x5453,  0,       0x5451,  0,       0x5955,  0,       0xDBD4,  0x6473,  
      0x6767,  0xB4B8,  0x3624,  0xBFFA,  0xBFF6,  0xBFF9,  0xBFF7,  0x4156,  // 0x49Fx
      0xC5C4,  0xC5C3,  0xC5C5,  0xCAC8,  0xCFDD,  0xCFDC,  0xD3CB,  0xD3CA,  
} ;


static const unsigned short Uni2cnsP0Table_4A [] = {
      0xD2B8,  0x5958,  0xD6F2,  0xD9CC,  0xDBD5,  0xDDCA,  0xDBD6,  0xDDCB,  // 0x4A0x
      0x6956,  0xE1D1,  0xE2C0,  0xB9E6,  0xBFFD,  0xD031,  0xC5C8,  0x482D,  
      0x4831,  0x482E,  0xCACA,  0x4834,  0xCACB,  0x4833,  0xE37B,  0xCFDE,  // 0x4A1x
      0xCFE1,  0xCFDF,  0,       0x5459,  0xD3CF,  0xD3CE,  0x5960,  0xD6F3,  
      0xD6F7,  0x5458,  0xD6F6,  0x595D,  0x595F,  0x5E35,  0xD9CD,  0xD9CE,  // 0x4A2x
      0x5E36,  0xC4D8,  0xC4E0,  0x6174,  0x6173,  0xDBD7,  0xDBD8,  0xDBD9,  
      0x6475,  0xDDCD,  0x6958,  0x695A,  0x695B,  0xE0D8,  0xE1D3,  0xE1A7,  // 0x4A3x
      0xE1D2,  0xE2A4,  0xE2C4,  0xE2C6,  0x695C,  0x3628,  0x362A,  0x3B74,  
      0x4E4C,  0x647B,  0x415A,  0xC5CA,  0,       0xCACD,  0x4838,  0x4837,  // 0x4A4x
      0x545D,  0x545C,  0x5962,  0x647C,  0x676E,  0x71E3,  0,       0x6C33,  
      0x3B79,  0xC0A3,  0x3B76,  0xC5CD,  0x415D,  0x415F,  0xC5CC,  0xC6B2,  // 0x4A5x
      0xDA28,  0x483A,  0x4840,  0x483B,  0xCACF,  0xCAD0,  0x483D,  0x4E4F,  
      0x5463,  0x5461,  0x5460,  0x5464,  0x5462,  0x5963,  0x5468,  0xD3D2,  // 0x4A6x
      0xD6FC,  0x5968,  0x5964,  0xBDD6,  0xD6F9,  0xD6FD,  0xD6FE,  0x5E3E,  
      0x65FE,  0x5E42,  0x5E3C,  0x65F3,  0x65FB,  0x5E3B,  0x5E41,  0xDBDC,  // 0x4A7x
      0xDBDB,  0x6177,  0x617B,  0xDBDA,  0x6523,  0x647E,  0x6EC9,  0xD6A7,  
      0xD6A5,  0x6772,  0x6770,  0x71E9,  0xD6A6,  0xDFF4,  0x74E2,  0x6B2C,  // 0x4A8x
      0xE0DA,  0x6C34,  0x6D2D,  0xE1D4,  0x6D65,  0xE1F0,  0x6E22,  0x4161,  
      0x4843,  0x4841,  0x4842,  0x4844,  0xD3D4,  0x596B,  0xC4F7,  0x5E45,  // 0x4A9x
      0xD9D2,  0x617D,  0x617E,  0x6773,  0x6960,  0xE0DB,  0xC5CE,  0,       
      0xD7A1,  0xDBE3,  0xDBE2,  0xDDD2,  0x6775,  0x6B2D,  0xC0A5,  0xC0A6,  // 0x4AAx
      0xC0A7,  0xC5D1,  0,       0x546A,  0x5469,  0xD9D3,  0x6222,  0x6223,  
      0xDFF5,  0x3B7B,  0xC0AD,  0x4165,  0x4164,  0x44B4,  0x4BBE,  0x484D,  // 0x4ABx
      0xCAD1,  0x484E,  0xCAD3,  0x484C,  0x484B,  0x4BBF,  0x4847,  0xCFE8,  
      0x4E59,  0x4E5C,  0x52E0,  0x546D,  0x546F,  0xD3D6,  0x4E5D,  0xD3E0,  // 0x4ACx
      0xD3D7,  0xD3DE,  0xB5D1,  0xD7A5,  0x5973,  0xBDE9,  0xD7A2,  0x5977,  
      0xD7A3,  0xD7A4,  0xD7A7,  0xD7A9,  0x5E4E,  0xD9D4,  0x5E49,  0x5E47,  // 0x4ADx
      0x5E4B,  0xD9D7,  0xD9D5,  0x5E4D,  0x5E4C,  0xD9DA,  0x6227,  0x6229,  
      0x622D,  0x6226,  0x622C,  0xDBE4,  0x6225,  0x622F,  0x6228,  0x622B,  // 0x4AEx
      0x652F,  0x6531,  0x6530,  0xDDD4,  0x6777,  0x6779,  0x6776,  0x677C,  
      0x677B,  0xD6B2,  0x6963,  0xDFF6,  0x6962,  0x6C39,  0x78C8,  0xE1D5,  // 0x4AFx
      0x362B,  0x3B7E,  0xC5D3,  0x416D,  0x4172,  0x416E,  0x4851,  0x4856,  
} ;


static const unsigned short Uni2cnsP0Table_4B [] = {
      0x4859,  0x4850,  0x4854,  0xCAD7,  0x4E60,  0x4E61,  0x5476,  0x5477,  // 0x4B0x
      0x5473,  0x5474,  0x5475,  0x597D,  0x5A22,  0x5A21,  0x597C,  0x597A,  
      0x597E,  0x5E51,  0xC4FE,  0x5E50,  0x5E52,  0xD9DD,  0xD9DE,  0xD9DF,  // 0x4B1x
      0x6232,  0xDBE7,  0xDBE6,  0x6536,  0xDDD5,  0x677E,  0x6B30,  0x6C3A,  
      0xD7AB,  0xD9E0,  0xB4BA,  0x362C,  0xC0A9,  0xC0AA,  0x3C24,  0xC0A8,  // 0x4B2x
      0x3C25,  0xC5DD,  0xC0AC,  0x4177,  0x4174,  0xCADC,  0xC5DE,  0x4175,  
      0xC5D6,  0xC5D5,  0xC5DA,  0x4179,  0x417A,  0xCAD8,  0xCAD9,  0x485B,  // 0x4B3x
      0xABB8,  0xCADA,  0x485C,  0xE440,  0xCFEA,  0x4E65,  0x4E64,  0x4E67,  
      0x4E66,  0x5478,  0x4E69,  0x547C,  0x547D,  0x547A,  0x5A27,  0x5522,  // 0x4B4x
      0x5A28,  0x5A2A,  0x60B1,  0xD7AD,  0xD9E4,  0x60AC,  0xD7AC,  0,       
      0x5E58,  0x5E57,  0x5E5B,  0x5E59,  0x5E5A,  0x6539,  0x6236,  0xDBE8,  // 0x4B5x
      0x653C,  0x653B,  0xDDD7,  0xDDD9,  0,       0x6824,  0x6823,  0xDEFD,  
      0x6822,  0x6967,  0x6965,  0xDFF7,  0x6968,  0x6B31,  0xE1D6,  0x6D30,  // 0x4B6x
      0x6D67,  0x6E25,  0,       0xCFEC,  0xD3E7,  0x5E5F,  0x623C,  0x485D,  
      0xD7AF,  0x5526,  0xD7AE,  0xE1F1,  0xC0AD,  0x44CA,  0xC5E0,  0x485E,  // 0x4B7x
      0xCAE5,  0x485F,  0xCADF,  0xCAE7,  0xCAE8,  0xCAEB,  0xCAE9,  0x4E6F,  
      0xCFF1,  0xCFF0,  0x4E6E,  0xCFEF,  0x4E6D,  0x4E70,  0xD3EF,  0xD3EE,  // 0x4B8x
      0xD3ED,  0x5AAC,  0xD3E9,  0x552D,  0x5AAE,  0xB6A8,  0x5A2E,  0xD7B2,  
      0xD7B5,  0x5A2D,  0xD7B1,  0x5E67,  0x6AEE,  0x5E62,  0xD9E8,  0x5E68,  // 0x4B9x
      0xD9E9,  0x5E63,  0x5E65,  0xD9EC,  0x6241,  0x623F,  0xDBEA,  0x6246,  
      0x6240,  0x6244,  0x6245,  0x6541,  0x6540,  0xDDDD,  0xDDDB,  0x6547,  // 0x4BAx
      0x6EE6,  0x6EED,  0xDDDC,  0x6829,  0x682A,  0x682B,  0x682D,  0xDFA3,  
      0x72AD,  0x6828,  0xDABE,  0x74F6,  0x696B,  0x6969,  0xDFFA,  0x6B33,  // 0x4BBx
      0x6B34,  0x6B32,  0xE1AB,  0xE0AE,  0xE0AD,  0xE1D7,  0x6D68,  0xE2A7,  
      0x6E3F,  0xE2B7,  0x6E57,  0,       0,       0,       0xB9E9,  0xC0AE,  // 0x4BCx
      0x4862,  0xCAED,  0xCFF5,  0x4E75,  0x4E73,  0x4E76,  0xCFF8,  0xD3F2,  
      0xD3F3,  0x5530,  0x5532,  0x552F,  0x552E,  0xD7B9,  0x5A31,  0x5A35,  // 0x4BDx
      0x5A30,  0xD7B8,  0x5A33,  0x66D1,  0x5E6E,  0xDBF0,  0x6248,  0x6247,  
      0x6549,  0xDDDF,  0x6830,  0x696E,  0x6B35,  0x6C3E,  0x6D33,  0xC0B0,  // 0x4BEx
      0x4222,  0,       0x624A,  0x74FA,  0xE4F5,  0xC0B1,  0x3DD2,  0xE45E,  
      0x486A,  0x4869,  0x4867,  0xCAF4,  0x4BD9,  0x4E7B,  0xCFFA,  0x5535,  // 0x4BFx
      0x5536,  0x5A38,  0xD7BD,  0,       0x5A3B,  0x5E70,  0x5E73,  0xD9EE,  
} ;


static const unsigned short Uni2cnsP0Table_4C [] = {
      0x5E74,  0x5E76,  0x5E75,  0x5E77,  0x624E,  0xDBF2,  0x624C,  0,       // 0x4C0x
      0x654D,  0x654F,  0x654E,  0xD1F9,  0x72BF,  0xDFA6,  0x6972,  0x6C43,  
      0x6C41,  0xE1AD,  0x78D2,  0x6D35,  0xE1EA,  0x6D69,  0x6E49,  0xD1FD,  // 0x4C1x
      0x72C1,  0xCAF7,  0xCAF6,  0xCDBE,  0xD3F6,  0xDACB,  0xE1D8,  0xCAF9,  
      0x4F24,  0x4F25,  0x553F,  0xD3F7,  0x5E7E,  0xD9F0,  0x5E7D,  0x5E7C,  // 0x4C2x
      0xDBF3,  0x66E8,  0xDDE5,  0x6977,  0x6976,  0xDACF,  0,       0x6C48,  
      0x6C49,  0x6E58,  0x3DD4,  0,       0x486D,  0x4BE4,  0,       0x4F28,  // 0x4C3x
      0x4F34,  0xD0A1,  0xABEA,  0x4F39,  0x4F32,  0x4F2B,  0x4F29,  0xD4A7,  
      0x5544,  0x5542,  0x5548,  0xD3FE,  0xD4A8,  0x5541,  0xD4A6,  0xD4A4,  // 0x4C4x
      0xD4A2,  0xD3FB,  0x5A40,  0xD7C1,  0x5F21,  0xBEC9,  0x5A42,  0xD9F2,  
      0x5F23,  0x66EE,  0x5F27,  0x5F25,  0xD9F8,  0x5F24,  0xD9F7,  0x5F29,  // 0x4C5x
      0x5F2B,  0x625D,  0x6BB5,  0x6267,  0x6257,  0x6261,  0x6259,  0x6254,  
      0xDBF6,  0x6BB1,  0x6262,  0x6BAB,  0x6260,  0x6264,  0xDBF8,  0xDBFB,  // 0x4C6x
      0xDBFC,  0xE4F2,  0,       0xDDF7,  0x6555,  0xD2B1,  0x655B,  0xDDEC,  
      0xD2B3,  0x6553,  0xDDEB,  0xDDED,  0,       0x683D,  0xDFAD,  0xDFB0,  // 0x4C7x
      0x683C,  0xDFAE,  0xDFAB,  0x683A,  0xDFA9,  0xDFAF,  0x697D,  0xDFFD,  
      0x6A21,  0x697C,  0xDFFC,  0x697E,  0xE0A4,  0x697B,  0xE0A1,  0,       // 0x4C8x
      0xEABF,  0x6B3C,  0x6B3D,  0x6B40,  0x6B3B,  0xDEA3,  0xE0E7,  0xE0E4,  
      0x78DB,  0x78D6,  0xE1B0,  0x6C4D,  0x6C4E,  0x77A4,  0xE1DA,  0x6D39,  // 0x4C9x
      0,       0xE1B1,  0x6E2C,  0x6E2D,  0x6E5B,  0,       0,       0,       
      0,       0,       0,       0,       0,       0xC5E5,  0xCAFA,  0xCAFB,  // 0x4CAx
      0xCAFC,  0xCAFE,  0x4BEB,  0xCAFD,  0x53B8,  0x4F3F,  0xD0A3,  0x4F44,  
      0x4F3B,  0xABED,  0x4F40,  0xD0A8,  0xD0A9,  0xD0A6,  0,       0xCCE3,  // 0x4CBx
      0x4F41,  0x554E,  0xD4AF,  0x554D,  0xD4B0,  0x554F,  0xD4AB,  0x5554,  
      0xB6CA,  0x554A,  0xD4AE,  0x5557,  0xD7CB,  0x554B,  0xD4B1,  0x5555,  // 0x4CCx
      0xD4B4,  0x5550,  0xB6D1,  0xD6B3,  0xD7CC,  0x5A51,  0xD7C7,  0xD7C9,  
      0xD7C6,  0x5A52,  0xD7CE,  0x5A50,  0x5F2F,  0x5F35,  0x5F2C,  0xDAA1,  // 0x4CDx
      0xD9FC,  0x5F32,  0x5F31,  0x67A6,  0x5F38,  0x626A,  0xDCA1,  0x626C,  
      0x6561,  0xDCA8,  0x626F,  0x6BBC,  0x5F36,  0xE4F5,  0xDDF8,  0x656C,  // 0x4CEx
      0xDDFD,  0xDDFB,  0x656A,  0x6564,  0xDDFC,  0xD2C2,  0x6562,  0x656B,  
      0xDDFE,  0xDFB4,  0x6840,  0x6842,  0x6841,  0x72E3,  0xDFB3,  0x6A27,  // 0x4CFx
      0x6A2C,  0,       0xE0A8,  0x6A26,  0xE0A6,  0xE0A7,  0x6B45,  0xE0EB,  
} ;


static const unsigned short Uni2cnsP0Table_4D [] = {
      0x77AC,  0x6B44,  0x77B4,  0x6B47,  0xE0EA,  0xE0E9,  0x6B48,  0x6C50,  // 0x4D0x
      0x6C52,  0x6C51,  0xE1B6,  0x6C54,  0x6D3D,  0xE1DC,  0xE3B7,  0xE2AA,  
      0xE2BE,  0x6E59,  0xE2C3,  0,       0,       0,       0,       0,       // 0x4D1x
      0,       0,       0x4F47,  0x5F39,  0xD7A9,  0x6B4D,  0x79F3,  0x4BED,  
      0x4F49,  0x4F4A,  0xD0AD,  0xD4B8,  0x5558,  0xB6DC,  0xDAA3,  0x6272,  // 0x4D2x
      0,       0xDFB9,  0xE1B7,  0xE1B8,  0x4873,  0x4874,  0xCBA1,  0x4F4D,  
      0x4F4B,  0x5559,  0x555C,  0x555A,  0x555D,  0xD7CF,  0x5F3C,  0x5F3B,  // 0x4D3x
      0xDAA7,  0x6279,  0x6276,  0x627D,  0x6277,  0x627C,  0x6849,  0x6848,  
      0x684A,  0x75CD,  0x75C8,  0x6B4E,  0xE1B9,  0xDAFD,  0x6D41,  0xACB1,  // 0x4D4x
      0x6571,  0x6572,  0xB6E5,  0x5F3D,  0x6321,  0x6576,  0x684B,  0x6B52,  
      0x6C5A,  0xACB3,  0x555E,  0xB6E7,  0x6FD2,  0x6579,  0x6FD4,  0x684C,  // 0x4D5x
      0x684E,  0x684D,  0x6A31,  0x6B55,  0x6D42,  0x422C,  0xCBA3,  0x4F52,  
      0x4F53,  0x555F,  0x5A5F,  0x61A3,  0x67C0,  0x67BD,  0x5F3F,  0x67C1,  // 0x4D6x
      0x6323,  0xDCAB,  0x657C,  0x6621,  0x657D,  0x6FD8,  0x6852,  0xDFBB,  
      0x6B56,  0x6C5B,  0x6D44,  0xE1DE,  0x6D43,  0x6D6F,  0x5F40,  0xDCAC,  // 0x4D7x
      0x6A37,  0xE1BA,  0x5561,  0x6C61,  0x6C62,  0x5F43,  0x5F42,  0x5F44,  
      0x6326,  0x6859,  0x5562,  0x5A63,  0x5F45,  0x6327,  0x685A,  0xE0AA,  // 0x4D8x
      0x6B58,  0x6B5B,  0xDAAC,  0x5F46,  0xDEA3,  0xD2E7,  0x6FE1,  0x685C,  
      0x6E31,  0x7BFA,  0x5A66,  0x61AD,  0x5F48,  0x6329,  0x632B,  0x6627,  // 0x4D9x
      0x6625,  0x6626,  0xDFBD,  0x6861,  0x6A3D,  0x6A3C,  0xE0EE,  0x77CD,  
      0x6C69,  0x6C66,  0x6C6A,  0x6D4C,  0x6D4B,  0x6D70,  0xE1F6,  0xE2AB,  // 0x4DAx
      0xE2B2,  0x6E4B,  0x6E4C,  0x6E5A,  0x75E1,  0,       0,       0x6BE9,  
      0x6CC4,  0x6862,  0,       0x6863,  0x6D51,  0xE2AC,  0,       0,       // 0x4DBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4DCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4DDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4DEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4DFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_4E [] = {
      0x44A1,  0x44A3,  0x2126,  0x44A4,  0xA1A6,  0xA1A5,  0,       0xA126,  // 0x4E0x
      0x44B7,  0x44B5,  0x44B8,  0x44B6,  0xA127,  0x44E2,  0xA12F,  0xA12D,  
      0x44E1,  0x44E0,  0x2139,  0,       0x45E2,  0x45E1,  0x45E0,  0x2155,  // 0x4E1x
      0x45E3,  0x45DF,  0,       0,       0,       0,       0x47A2,  0x47A3,  
      0xA2E2,  0xA2E1,  0xA2E3,  0x2335,  0xA4BF,  0,       0x4BE4,  0,       // 0x4E2x
      0xA1A1,  0x2127,  0xA1AC,  0x44B9,  0,       0x44E3,  0xA130,  0x213A,  
      0x44E4,  0xA143,  0x48EB,  0xA531,  0,       0x2B5E,  0xA1A2,  0,       // 0x4E3x
      0x44BA,  0x44E5,  0,       0x45E4,  0xA144,  0xA7C0,  0,       0xA1A3,  
      0x2122,  0x2123,  0xA121,  0x44A5,  0,       0x44BC,  0xA1B0,  0xA128,  // 0x4E4x
      0x44BD,  0xA1AE,  0,       0x44E6,  0,       0x45E5,  0x45E7,  0x45E6,  
      0,       0x2227,  0x47A4,  0x47A5,  0xA3C5,  0,       0x4BE5,  0xABA2,  // 0x4E5x
      0x53FD,  0x44A2,  0x2124,  0,       0xA122,  0x44A6,  0x44BF,  0x44BE,  
      0,       0,       0xA1C6,  0xA1C5,  0,       0,       0,       0,       // 0x4E6x
      0xA2E4,  0x47A6,  0x2228,  0,       0,       0,       0,       0,       
      0,       0xA4C0,  0,       0x4BE6,  0x2531,  0x2530,  0,       0,       // 0x4E7x
      0,       0xABA3,  0,       0,       0,       0,       0x58F1,  0xB34E,  
      0xB9EC,  0xB9EE,  0x63AA,  0xC156,  0xC157,  0xA1A4,  0x44A7,  0xA1AD,  // 0x4E8x
      0x44E8,  0xA2E5,  0,       0x4BE7,  0x44A8,  0xA129,  0x44C0,  0xA1B1,  
      0,       0x44E9,  0x44EB,  0xA131,  0x44EC,  0x44EA,  0x213B,  0xA1EC,  // 0x4E9x
      0xA2E6,  0x47A7,  0,       0x4BE8,  0xA4C2,  0xA7C2,  0x4BE9,  0x4FE7,  
      0x27A8,  0x44C1,  0x44ED,  0xA1C7,  0x47A8,  0x47AA,  0x47A9,  0,       // 0x4EAx
      0x48EC,  0,       0,       0x4BEA,  0x4BEB,  0x4FE8,  0x4FE9,  0xABA6,  
      0xABA5,  0xABA7,  0xABA4,  0x53FE,  0x362E,  0,       0xC158,  0xC0B3,  // 0x4EBx
      0,       0xED44,  0x44A9,  0,       0xA1B2,  0,       0xA1B3,  0,       
      0x44EF,  0x44EE,  0xA132,  0x44F0,  0x44F6,  0xA1C9,  0x44F1,  0x44F2,  // 0x4ECx
      0xA134,  0xA133,  0x44F4,  0x44F5,  0xA1CC,  0x44F3,  0xA1CB,  0xA1CA,  
      0x213C,  0,       0,       0,       0x45EA,  0x45EB,  0x45EC,  0x45ED,  // 0x4EDx
      0x45E9,  0x45F0,  0xA14A,  0x215B,  0xA146,  0xA149,  0x45F1,  0x46A3,  
      0xA1ED,  0xA148,  0x215A,  0x45EE,  0x45EF,  0x45E8,  0xA1F2,  0xA1F0,  // 0x4EEx
      0xA145,  0xA147,  0,       0,       0,       0,       0xA2EF,  0xA2E8,  
      0x47B7,  0xA16F,  0x47B4,  0x47B8,  0xA179,  0xA16D,  0x47B5,  0xA171,  // 0x4EFx
      0xA2EB,  0xA2E7,  0xA2F6,  0x47B6,  0xA2EE,  0x47B9,  0x222D,  0x47AB,  
} ;


static const unsigned short Uni2cnsP0Table_4F [] = {
      0xA170,  0x47BA,  0xA174,  0xA2ED,  0xA178,  0xA175,  0xA2EC,  0xA2F4,  // 0x4F0x
      0xA172,  0x47AC,  0x47AE,  0x47BB,  0x222A,  0x47B0,  0xA16A,  0x47B3,  
      0x47B1,  0x47B2,  0xA17A,  0xA177,  0xA16E,  0x47AF,  0xA2F0,  0xA2F7,  // 0x4F1x
      0xA16B,  0x47AD,  0xA2F5,  0x222E,  0xA2F3,  0xA173,  0,       0,       
      0,       0,       0xA176,  0,       0,       0,       0,       0,       // 0x4F2x
      0xA2F2,  0xA1F1,  0,       0,       0xA16C,  0xA328,  0x2339,  0x49A4,  
      0x48F5,  0xA4D0,  0xA4C8,  0xA329,  0x48F2,  0xA4CF,  0x49A6,  0xA4C6,  // 0x4F3x
      0x48FA,  0xA4C5,  0x48F9,  0xA27B,  0x48FD,  0x48F8,  0xA322,  0xA32A,  
      0xA4CE,  0xA326,  0xA4C9,  0x48FB,  0xA4CB,  0xA4C3,  0x48FE,  0x48EF,  // 0x4F4x
      0x49A9,  0xA27D,  0xA4C4,  0xA4CC,  0xA53D,  0x48ED,  0x49A5,  0x48EE,  
      0x48F6,  0x48F7,  0xA324,  0xA27E,  0x48FC,  0x48F4,  0xA27A,  0x48F0,  // 0x4F5x
      0xA327,  0x49A7,  0x49AA,  0x48F3,  0x49A2,  0x49A8,  0x48F1,  0xA325,  
      0x49A3,  0xA32B,  0xA27C,  0x49A1,  0xA321,  0,       0xE4C8,  0xA323,  // 0x4F6x
      0xE4C9,  0x4BF9,  0xA53F,  0xA54B,  0x4BF1,  0xA7C7,  0xA54C,  0x4BEC,  
      0x4BF6,  0x253E,  0xA7CF,  0x4BEF,  0xA539,  0x4BF7,  0xA538,  0xA53C,  // 0x4F7x
      0xA543,  0xA541,  0x4CA1,  0x4BFA,  0xA533,  0xA535,  0x4BFC,  0x4BF0,  
      0xA536,  0xA542,  0xA549,  0x4BF5,  0xA53B,  0xA534,  0x4BF4,  0xA537,  // 0x4F8x
      0x4BF8,  0xA53A,  0xA7C4,  0x4BF3,  0xA7D1,  0x4BEE,  0xA7C8,  0x4BFD,  
      0xA544,  0x4BFE,  0xA548,  0xA7C3,  0xA546,  0xA54A,  0x4BFB,  0xA53E,  // 0x4F9x
      0xA532,  0x2536,  0xA540,  0x4BF2,  0xA545,  0x4BED,  0xA547,  0xA7CC,  
      0xA7C9,  0xA7CB,  0xA7CA,  0xA7CD,  0,       0,       0,       0,       // 0x4FAx
      0,       0,       0,       0xA5C4,  0,       0,       0x4FF8,  0x4FEC,  
      0xABAD,  0xABAE,  0xA922,  0xA92A,  0xABB6,  0x4FEB,  0x4FF3,  0x50A1,  // 0x4FBx
      0xABAC,  0xA930,  0xA92E,  0xA929,  0x2838,  0x283E,  0xABAB,  0x4FED,  
      0xA92F,  0xA925,  0x4FFB,  0x4FF2,  0x4FFA,  0xA87E,  0xABB2,  0xA92C,  // 0x4FCx
      0xABAF,  0xA923,  0x4FF6,  0xA924,  0xABB3,  0xA87D,  0x4FFD,  0x4FF0,  
      0x4FF9,  0x4FEF,  0xABA8,  0xA921,  0xA926,  0xABA9,  0xA92D,  0x4FF7,  // 0x4FDx
      0x4FF4,  0xA928,  0x4FFC,  0xA92B,  0xA927,  0x4FF1,  0x4FFE,  0x4FF5,  
      0x4FEE,  0x4FEA,  0x283F,  0xABB5,  0xA9AD,  0xABB4,  0,       0xE4CA,  // 0x4FEx
      0,       0x283D,  0,       0,       0xA931,  0,       0x54BA,  0x54A4,  
      0xAFC8,  0x54B4,  0xAFCD,  0x54B9,  0xAD71,  0xAD70,  0xAD75,  0xAD76,  // 0x4FFx
      0x54A7,  0xAFC4,  0x54B0,  0xAFD8,  0xAFCC,  0xAFD6,  0x54BD,  0xAFC6,  
} ;


static const unsigned short Uni2cnsP0Table_50 [] = {
      0x54B1,  0x2B62,  0xAFCB,  0xAFC9,  0xAFC7,  0xAD6A,  0x54AA,  0xAD6B,  // 0x500x
      0xAFCF,  0x54BF,  0x2B64,  0x54B6,  0x54A1,  0x54A2,  0xAD7E,  0x59A4,  
      0xAFD3,  0x54AF,  0x54AE,  0xAD6C,  0x54B2,  0xB35E,  0x54A9,  0xAD77,  // 0x501x
      0x54B8,  0x54B7,  0x54AD,  0xAD6F,  0xAD78,  0xAFC5,  0xAD69,  0x54AC,  
      0xAD79,  0x54B5,  0xAD6D,  0x54A3,  0xAFCE,  0x54A6,  0x54A5,  0xAD7A,  // 0x502x
      0x54B3,  0x54A8,  0x54BC,  0x54BE,  0xAD74,  0x54BB,  0xAFD1,  0xAD7C,  
      0xAD6E,  0xAD7D,  0xAFC3,  0xAD72,  0x2B61,  0xAD7B,  0xAFD0,  0xAD73,  // 0x503x
      0xAFD4,  0xAFD5,  0,       0,       0x54AB,  0,       0,       0xE4CB,  
      0xB366,  0xB35A,  0xB4BC,  0x58F6,  0xB4BF,  0xB35F,  0xB365,  0x58F5,  // 0x504x
      0xB358,  0x58F9,  0xB35C,  0xB355,  0x58F7,  0xB359,  0x58FC,  0x59A3,  
      0xB4C4,  0xB36A,  0xB4C1,  0xB354,  0xB4C2,  0x58FD,  0xAFD7,  0xB369,  // 0x505x
      0xB4C7,  0xB4BD,  0x58F8,  0xB35B,  0x58F4,  0xB356,  0xB352,  0xB360,  
      0xB353,  0xB351,  0xB35D,  0xB363,  0xB364,  0x58FA,  0xB4C0,  0x3047,  // 0x506x
      0xBA3F,  0xB361,  0xB350,  0xB362,  0xB4CB,  0x59A6,  0xB367,  0x59A5,  
      0xB34F,  0xB4C3,  0xB357,  0xB368,  0x59A1,  0x58FE,  0x58FB,  0x59A2,  // 0x507x
      0xB4CC,  0xB4CA,  0x58F2,  0xB4C5,  0xB4C6,  0x58F3,  0,       0,       
      0x5EAE,  0xB9F5,  0xBA42,  0xBA3B,  0x3634,  0x5EAB,  0x3633,  0xBA43,  // 0x508x
      0xB9F1,  0xB9F2,  0x3636,  0xBA39,  0xBA3C,  0x5EAA,  0xBA3D,  0xB9EF,  
      0x3631,  0x5EAD,  0xBA41,  0x363C,  0xBA37,  0xBA36,  0x5EAF,  0xB9F0,  // 0x509x
      0x5EB0,  0x5EAC,  0x5EB1,  0xBA35,  0xBA40,  0xBA3E,  0xBA38,  0x3639,  
      0x3630,  0x363A,  0x5EA9,  0xBA3A,  0,       0,       0xE4CD,  0,       // 0x50Ax
      0,       0,       0xC0B9,  0xC0BC,  0x63B1,  0x63AB,  0xC15C,  0x63B4,  
      0xC162,  0xC165,  0x63AD,  0x63AE,  0xC15F,  0x63AC,  0xC168,  0x63B2,  // 0x50Bx
      0xC169,  0xC0BA,  0xC164,  0x63B3,  0xC0B7,  0xC159,  0x63B0,  0xC15A,  
      0x3C29,  0xC163,  0xC161,  0xC0BD,  0xC15D,  0x63AF,  0xC15B,  0x63B5,  // 0x50Cx
      0xC160,  0xC167,  0xC15E,  0xC166,  0xC0B6,  0xC0BE,  0x67FC,  0x67F9,  
      0xC5EB,  0x67FA,  0x422D,  0xC921,  0xC877,  0x67F8,  0x67F5,  0xC878,  // 0x50Dx
      0xC5EE,  0xC5EC,  0x67F7,  0xC87B,  0xC5ED,  0xC87D,  0xC5F6,  0x4235,  
      0xC926,  0xC5F0,  0xC5F5,  0xC925,  0xC87E,  0x67F4,  0xC876,  0x67F2,  // 0x50Ex
      0xC879,  0x67FD,  0xC87C,  0xC5F1,  0xC922,  0x67F6,  0x67F3,  0xC924,  
      0xC923,  0x67FB,  0,       0xC87A,  0xC5F4,  0x6CA3,  0xCF54,  0xCBA9,  // 0x50Fx
      0xCF51,  0x6CA4,  0x4879,  0x6CA2,  0xCBAB,  0xCF58,  0xCF55,  0xCF4E,  
} ;


static const unsigned short Uni2cnsP0Table_51 [] = {
      0x6CA1,  0xCBAD,  0x6CA5,  0xCF4F,  0x6BFE,  0x6CA8,  0xCF52,  0xCF53,  // 0x510x
      0x6CA6,  0x6CA7,  0xCF59,  0xCF56,  0xCF57,  0xCBAC,  0xCBA7,  0xE4CE,  
      0x70B3,  0xD643,  0x70B0,  0xD640,  0x70B2,  0x70B4,  0xD0B1,  0xD641,  // 0x511x
      0x70B1,  0x4F5A,  0xD642,  0xD0B5,  0xD63F,  0xD0B0,  0xD0B4,  0x73C1,  
      0xDC49,  0x73C2,  0xDC47,  0x5565,  0xDC48,  0xDC46,  0xDC45,  0xD4C1,  // 0x512x
      0xD4C0,  0xDC4A,  0x73C0,  0xD0B3,  0x5569,  0xE144,  0xE145,  0xD7D2,  
      0xCF50,  0xE143,  0x73C3,  0x78AB,  0xE537,  0xE538,  0xDCB2,  0x7AE2,  // 0x513x
      0x7AE3,  0xEB4F,  0xEB4E,  0x7BD8,  0x7BD7,  0xEE7D,  0xE0EF,  0x44AA,  
      0x44C2,  0x44F8,  0x213D,  0x44F7,  0x45F3,  0x45F2,  0x47BE,  0x47BD,  // 0x514x
      0x47BF,  0x47BC,  0xA2F8,  0x49AC,  0x49AB,  0x49AD,  0xA4D4,  0x233B,  
      0xA4D3,  0xA4D1,  0x4CA3,  0x253F,  0x4CA2,  0x4CA4,  0xA7D2,  0x50A2,  // 0x515x
      0x2840,  0x22F9,  0xAE21,  0x22FA,  0x59A7,  0x22FC,  0x22FB,  0xBA44,  
      0xB9F6,  0x22FD,  0x67FE,  0x22FE,  0xDEA5,  0x44AB,  0xA1B4,  0x44F9,  // 0x516x
      0x47C0,  0x4CA5,  0xABB7,  0x44AC,  0x44FC,  0x44FA,  0x44FB,  0,       
      0,       0x47C1,  0xA2FA,  0x2234,  0,       0x49AE,  0x4CA7,  0x4CA6,  // 0x517x
      0x4CA8,  0xAEFB,  0,       0,       0x54C0,  0,       0xC0BF,  0xE4D3,  
      0x70B5,  0,       0xA1A7,  0x213E,  0xA1CD,  0xA1C8,  0xA1CE,  0xA12E,  // 0x518x
      0x2152,  0x45F4,  0x45F5,  0xA1F8,  0xA1F9,  0x47C2,  0x2236,  0xA32C,  
      0xA7D5,  0x50A4,  0x50A3,  0xAE23,  0xAE22,  0x59A8,  0xA1A8,  0x44FD,  // 0x519x
      0xA135,  0xA1FA,  0,       0,       0,       0xA4D7,  0xA54D,  0xABB9,  
      0x50A5,  0xAFDB,  0x54C3,  0xAFD9,  0x54C1,  0x54C2,  0xAFDA,  0,       // 0x51Ax
      0xB4CD,  0xC6DC,  0x70B6,  0x27AF,  0x45F6,  0x215E,  0,       0,       
      0x47C3,  0xA17B,  0xA2FE,  0xA2FD,  0xA2FC,  0xA4D9,  0x49AF,  0x49B0,  // 0x51Bx
      0xA4DA,  0xA32D,  0x233D,  0,       0xA54E,  0x4CA9,  0xA54F,  0x2540,  
      0x2543,  0xABBB,  0xABBD,  0xABBE,  0xAE25,  0xAE26,  0x54C6,  0xAFDE,  // 0x51Cx
      0xAE27,  0xAFDF,  0xAE24,  0x54C7,  0x54C5,  0x54C4,  0xAE28,  0xB4CF,  
      0xB36B,  0xB4CE,  0xB9FD,  0xB9FA,  0xBA45,  0x363F,  0xB9FE,  0xC16A,  // 0x51Dx
      0xC927,  0xCBAF,  0xCBAE,  0xCBB0,  0x6CA9,  0x70B7,  0xD644,  0xD4C2,  
      0x44AD,  0x44BB,  0xA1AF,  0xA1B5,  0xA1D1,  0xA1FB,  0,       0,       // 0x51Ex
      0xA3A2,  0,       0xA2D9,  0,       0xA4DB,  0xA7D9,  0x2545,  0,       
      0x59A9,  0x5EB3,  0xC665,  0x68A1,  0xC5FA,  0xA123,  0x44FE,  0x2160,  // 0x51Fx
      0x45F9,  0x45F7,  0x45F8,  0,       0,       0x4CAA,  0xA7DA,  0,       
} ;


static const unsigned short Uni2cnsP0Table_52 [] = {
      0x44AE,  0x44AF,  0x212A,  0x44C3,  0xA1B6,  0xA1D2,  0x45A1,  0x45A2,  // 0x520x
      0x45A3,  0xA14C,  0x45FA,  0xA1FD,  0xA14B,  0,       0x47C7,  0xA3A5,  
      0xA17D,  0x47C5,  0x47C6,  0xA17C,  0xA3A4,  0xA3A6,  0x47C8,  0x47C4,  // 0x521x
      0xA3A7,  0,       0,       0,       0xA32E,  0x4FCF,  0xA32F,  0xA4DF,  
      0xA4E1,  0xA330,  0x2340,  0xA4DC,  0x49B2,  0x49B1,  0xA4DE,  0xA4DD,  // 0x522x
      0x49B5,  0x49B3,  0x49B4,  0xA4E0,  0,       0,       0x4CB0,  0xA7DB,  
      0x4CAF,  0xA554,  0xA551,  0xA552,  0xA7DE,  0xA550,  0x4CB1,  0x4CAD,  // 0x523x
      0x4CAC,  0xA7DF,  0x4CAE,  0x4CAB,  0xA7DD,  0x254E,  0xE4CF,  0,       
      0,       0x4CB2,  0,       0x50A7,  0xA932,  0xABBF,  0xA553,  0x50AC,  // 0x524x
      0xABC0,  0xA933,  0x50A8,  0x50AB,  0x50AA,  0x50A9,  0x50A6,  0xABC3,  
      0,       0,       0xAE2B,  0xAFE8,  0x54CA,  0xAE2E,  0x54C8,  0xAFE5,  // 0x525x
      0x2B6E,  0xAFE2,  0xAE2A,  0x54CB,  0x54C9,  0x54CC,  0xAE2C,  0xAE2D,  
      0xAFE0,  0xAE29,  0xAE2F,  0xAFE6,  0xAFE1,  0xAFE3,  0xAEAD,  0xAFE4,  // 0x526x
      0xB4D0,  0x5EB7,  0x59AA,  0xB36C,  0xB36E,  0xB36D,  0xB36F,  0x59AB,  
      0xBAA3,  0,       0x5EB4,  0xBAA1,  0x5EB5,  0x5EB6,  0xB4D1,  0x63B7,  // 0x527x
      0xC16C,  0xC0C1,  0xC16B,  0xC16D,  0xC16E,  0x63B8,  0xC0C0,  0x63B6,  
      0xC928,  0xC929,  0x68A3,  0x68A2,  0xCC61,  0x4925,  0xCBB1,  0x6CAA,  // 0x528x
      0x6CAB,  0x6CAC,  0x6CAE,  0xCF5A,  0xCF5B,  0x6CAD,  0xCBB2,  0,       
      0xD0B6,  0x70B8,  0x4F64,  0x70B9,  0xD0B7,  0x556D,  0xE539,  0xEB51,  // 0x529x
      0xEB50,  0xEE7E,  0xE0AC,  0x44B0,  0xA1B7,  0xA1D4,  0xA1D3,  0x45FC,  
      0x45FB,  0,       0,       0x47C9,  0x2242,  0x223F,  0xA17E,  0x2241,  // 0x52Ax
      0xA3A8,  0x49B7,  0x49B8,  0x49B6,  0x49B9,  0xA331,  0xA332,  0x2346,  
      0x2347,  0x2348,  0,       0xA4E3,  0xA4E2,  0xA7E1,  0x25BA,  0x25B7,  // 0x52Bx
      0x25B8,  0xA7E0,  0x25BB,  0x4CB4,  0xA555,  0x2550,  0x4CB3,  0xA7E2,  
      0xA934,  0x50B0,  0xA935,  0x50AF,  0xABC8,  0xABC6,  0x2849,  0x50AD,  // 0x52Cx
      0x284B,  0x50AE,  0xABC7,  0,       0xAFEF,  0xAE30,  0xAFEC,  0xAFEA,  
      0xAFED,  0xAFEE,  0x59AC,  0xB371,  0xB4D2,  0x59AF,  0xB370,  0x5BAB,  // 0x52Dx
      0x59AE,  0x59AD,  0,       0x5EBA,  0x36EA,  0x5EB9,  0x5EB8,  0x63B9,  
      0xC0C5,  0xC0C4,  0x63BC,  0x63BD,  0x63BB,  0x3C3C,  0x63BA,  0xC0C6,  // 0x52Ex
      0x44E7,  0xC92A,  0xC6A1,  0xC92B,  0x44E3,  0xC5FE,  0xCBB3,  0xCF5D,  
      0x6CAF,  0xCF5C,  0xCDAC,  0x70BA,  0xDC4B,  0x73C4,  0x53E2,  0xE53A,  // 0x52Fx
      0x79E1,  0x27B4,  0x44C4,  0x45A4,  0xA136,  0xA1D5,  0x45A5,  0x45A6,  
} ;


static const unsigned short Uni2cnsP0Table_53 [] = {
      0xA1D6,  0xA1B0,  0,       0xA2A3,  0xA2A2,  0x45FD,  0x45FE,  0xA2A4,  // 0x530x
      0x47CA,  0xA333,  0xA556,  0xA557,  0x2551,  0x50B1,  0xAE31,  0x59B1,  
      0x59B0,  0xBA47,  0xBA46,  0xD074,  0xD0B8,  0x44B1,  0x45A7,  0x46A1,  // 0x531x
      0x305E,  0x59B2,  0xA124,  0x2165,  0xA14D,  0x46A2,  0xA2A6,  0xA222,  
      0x47CC,  0x47CB,  0xA221,  0x49BA,  0xE4D0,  0xA4E5,  0,       0xABC9,  // 0x532x
      0x284E,  0x2850,  0x54CD,  0x2B78,  0x305F,  0xB372,  0,       0x63BE,  
      0xC92C,  0x68A4,  0xC6A3,  0xCBB4,  0xD645,  0xD4C4,  0xDCB4,  0xE86A,  // 0x533x
      0xA1A9,  0x45A8,  0xA1D7,  0xA4E6,  0xA558,  0xA936,  0x59B5,  0x59B3,  
      0x59B4,  0x44B2,  0x2130,  0x44C5,  0x24BF,  0x45AB,  0xA1D9,  0x45AA,  // 0x534x
      0x45A9,  0x46A5,  0x46A4,  0xA3AA,  0xA14E,  0xA223,  0xA2AC,  0xA3AB,  
      0xA3AD,  0x4CB8,  0x4CB5,  0x4CB7,  0x4CB6,  0xA7E3,  0,       0x50B2,  // 0x535x
      0xABCA,  0x3060,  0x5EBB,  0x6630,  0x44B3,  0xA1DA,  0x45AC,  0xA2A7,  
      0x46A7,  0x46A6,  0,       0xA334,  0x234D,  0xE4D1,  0x4CB9,  0xAADC,  // 0x536x
      0x3064,  0xA1AA,  0x2131,  0,       0xA137,  0xA2A8,  0x46A9,  0x46A8,  
      0x47CD,  0x47CE,  0xA335,  0x49BB,  0xA4E7,  0x49BC,  0xA7E5,  0x4CBA,  // 0x537x
      0x4CBB,  0x4CBC,  0xA7E6,  0x50B3,  0xA937,  0xABCB,  0x3065,  0x54CE,  
      0xC0C7,  0,       0xA125,  0x2144,  0x45AD,  0,       0xA1DB,  0x2167,  // 0x538x
      0x2166,  0xA2A9,  0xA224,  0xA3AF,  0,       0,       0xA336,  0xA337,  
      0,       0,       0xA559,  0xA7E7,  0xA55A,  0,       0xA939,  0xA938,  // 0x539x
      0xA93B,  0xA93A,  0x50B4,  0xE4D2,  0xB373,  0x54D0,  0xAE32,  0x54CF,  
      0xB4D4,  0x3068,  0,       0,       0xBA48,  0x5EBC,  0xBAA8,  0xBA49,  // 0x53Ax
      0xBAA7,  0xC0CA,  0xC0C9,  0xC0C8,  0xC92D,  0x68A5,  0xC6A5,  0x3C40,  
      0xC6A6,  0xCBB5,  0x6CB0,  0xD4C5,  0xE53B,  0xEDAE,  0xA1AB,  0xA1DC,  // 0x53Bx
      0x2145,  0xA138,  0xA2AA,  0x46AA,  0,       0x2248,  0xA3B1,  0,       
      0x2559,  0xA7E9,  0xA7EA,  0x59B6,  0xB4D5,  0xBAA9,  0,       0,       // 0x53Cx
      0x44B4,  0x44C6,  0x45AF,  0x45AE,  0xA1DE,  0x45B0,  0xA1E0,  0x2169,  
      0xA2AB,  0,       0xA3B3,  0x234F,  0x4CBE,  0xA7EB,  0x4CBD,  0x4CBF,  // 0x53Dx
      0,       0xABD0,  0xABCF,  0x50B5,  0xABCE,  0xABCD,  0xB578,  0x54D1,  
      0xC0CB,  0xD646,  0x76BB,  0x44C7,  0x46AC,  0x46BB,  0x46B6,  0x216C,  // 0x53Ex
      0x46B1,  0x46B0,  0x46B7,  0x46B5,  0x46AE,  0x46BC,  0x46AF,  0x46AB,  
      0x46BA,  0x46B9,  0x46B8,  0x46AD,  0xA2B1,  0x46B4,  0xA2AD,  0xA2AE,  // 0x53Fx
      0x46B3,  0xA2AF,  0xA1D0,  0x46BD,  0x46B2,  0x216A,  0,       0xA3B5,  
} ;


static const unsigned short Uni2cnsP0Table_54 [] = {
      0xA3B7,  0x47D4,  0x224C,  0x47DA,  0x47D6,  0xA3B9,  0x47DC,  0xA225,  // 0x540x
      0x47D9,  0x47CF,  0x47D2,  0x47D5,  0x47D1,  0x47D8,  0x47DB,  0x47D0,  
      0x47D3,  0x47D7,  0x47DD,  0xA3BA,  0,       0xA3BB,  0xA3B4,  0,       // 0x541x
      0xA340,  0xA33D,  0xA4F6,  0x49C9,  0xA33E,  0x49BD,  0x49BF,  0x49D7,  
      0x49D2,  0xA4F9,  0xA4FE,  0xA4F5,  0xA345,  0xA33F,  0x49C1,  0x49C3,  // 0x542x
      0xA344,  0x49CA,  0xA33A,  0x49D6,  0x49D8,  0x49BE,  0x49CF,  0xA5A4,  
      0xA338,  0x49D5,  0xA4F7,  0x49C6,  0xA4FB,  0x49D0,  0x49D1,  0xA339,  // 0x543x
      0x49CE,  0x49CC,  0xA4F0,  0x49CD,  0x49D3,  0xA341,  0x49C0,  0xA5A1,  
      0x49D4,  0xA343,  0x49C8,  0x49C5,  0xA4F3,  0xA33C,  0x49C4,  0xA346,  // 0x544x
      0x49C7,  0xA4FC,  0x49CB,  0xA4F8,  0xA4F4,  0xA4ED,  0x49C2,  0xA342,  
      0xA4FD,  0xA5A2,  0,       0,       0xA33B,  0,       0,       0,       // 0x545x
      0,       0,       0xA5A3,  0,       0,       0x2564,  0x2563,  0xA7EE,  
      0xA56B,  0xA56A,  0x4CD1,  0xA56D,  0xA56F,  0xA564,  0xA567,  0xA56E,  // 0x546x
      0x4CD2,  0xA7F4,  0xA7F8,  0xA561,  0xA565,  0xA7F5,  0x255F,  0xA569,  
      0xA94A,  0x4CCD,  0xA94E,  0x4CC0,  0xA566,  0x4CC1,  0x4CCE,  0x4CC7,  // 0x547x
      0x4CC3,  0xA7F1,  0xA562,  0x4CC6,  0x4CCB,  0x4CD4,  0xA563,  0xA55C,  
      0x4CC5,  0xA55D,  0xA55F,  0x2560,  0x4CC8,  0xA7EC,  0x4CCA,  0xA55B,  // 0x548x
      0xA560,  0xA7F0,  0xA7F9,  0x4CD3,  0x4CCF,  0xA568,  0x4CD5,  0xA7F3,  
      0x4CCC,  0xA55E,  0x4CC9,  0xA7EF,  0xA7F7,  0x4CC4,  0x4CC2,  0,       // 0x549x
      0xA56C,  0,       0x4CD0,  0,       0xA5F1,  0,       0xABDC,  0xABDD,  
      0xA949,  0xA93D,  0xA94C,  0xABD7,  0xABD9,  0xA93F,  0x50BC,  0x50CA,  // 0x54Ax
      0x50B8,  0x50C9,  0x50C1,  0x50C6,  0x50B6,  0xA93E,  0xA944,  0x50C5,  
      0xA950,  0x50C7,  0xABDB,  0x50BD,  0xABD4,  0xABDE,  0xA946,  0xA943,  // 0x54Bx
      0x50BB,  0xABD1,  0xA93C,  0x50C8,  0xA94B,  0x50C0,  0xA94D,  0x50CB,  
      0x50B7,  0x50C2,  0x50BF,  0xA941,  0x50C3,  0xA947,  0xA948,  0x50BE,  // 0x54Cx
      0x50C4,  0x50BA,  0xABD5,  0xE4D4,  0xABE3,  0xABE1,  0x50B9,  0xA940,  
      0xABD3,  0,       0,       0,       0,       0,       0xA945,  0,       // 0x54Dx
      0,       0,       0xABD8,  0,       0,       0,       0xA94F,  0,       
      0xAE46,  0x54DE,  0xAE34,  0x2C2D,  0xAE39,  0x54D7,  0x54E2,  0xAE37,  // 0x54Ex
      0x54D2,  0x54DC,  0x54E1,  0xAE3E,  0x2C26,  0x54DD,  0x54E0,  0xAFF7,  
      0xB0A1,  0xAE41,  0x54D8,  0xAE38,  0xAFF4,  0xAFF8,  0xB0A2,  0xAE44,  // 0x54Fx
      0xAE45,  0xAFF9,  0x54DA,  0xAE43,  0x54D6,  0x54E5,  0x2C29,  0xAE3B,  
} ;


static const unsigned short Uni2cnsP0Table_55 [] = {
      0xAFFB,  0x54D4,  0xAFFA,  0xAE48,  0xAE3C,  0xAE40,  0x54D9,  0x54E4,  // 0x550x
      0xAE3D,  0x54DF,  0xAE42,  0xAE49,  0xB424,  0xAFF3,  0xAE47,  0x54E6,  
      0x54D3,  0xAE3F,  0xAE36,  0xAFF6,  0x54DB,  0x2C28,  0x2C2E,  0xAE35,  // 0x551x
      0xAFFE,  0xB0A5,  0xAE3A,  0xA9D4,  0,       0,       0,       0,       
      0xAEC2,  0xAECA,  0,       0,       0,       0,       0xAE33,  0x54E3,  // 0x552x
      0xE7A1,  0xB4DF,  0xB37A,  0xB4E8,  0x59C9,  0xB42A,  0x59C7,  0x59C4,  
      0xB421,  0x59C0,  0xB425,  0x59CB,  0xB379,  0xB37E,  0xB37D,  0x54D5,  // 0x553x
      0x59C6,  0xB428,  0xB4E6,  0xB42B,  0xB376,  0x3077,  0x5ECE,  0xB4E7,  
      0xB42C,  0x59CC,  0x3072,  0x59BE,  0x59BB,  0xB423,  0x59B8,  0x3074,  // 0x554x
      0xB429,  0xB4DB,  0x59BF,  0xB42D,  0xB4D8,  0xB377,  0xB427,  0x59C2,  
      0xB378,  0xB37B,  0xB422,  0xB4E2,  0xB4E1,  0x59C3,  0x59C1,  0x59CD,  // 0x555x
      0xB4D7,  0xBAB6,  0xB4E4,  0x306B,  0x59C8,  0xB4DE,  0x59BC,  0x5AF6,  
      0x307A,  0x59BD,  0xB37C,  0x59CA,  0x59C5,  0xB426,  0x59BA,  0,       // 0x556x
      0xB4D9,  0,       0x59B9,  0xE4D7,  0,       0,       0,       0,       
      0,       0xE4D6,  0xE7A2,  0xE4D5,  0,       0xB374,  0xB375,  0xBA4E,  // 0x557x
      0,       0,       0xBABC,  0x5EBD,  0x5EC0,  0xBA59,  0x5ED4,  0xBA5C,  
      0x5EBE,  0xBA55,  0x5EC4,  0x5ECA,  0x61C3,  0xBAB1,  0xBAB8,  0x5EC8,  // 0x558x
      0xBA52,  0x5ED5,  0x5EC1,  0x5EC9,  0xBA5A,  0xC17C,  0xBA5F,  0xBA53,  
      0x365C,  0xBA4A,  0xBA57,  0xBA51,  0x5EC7,  0xBA5D,  0xBAAE,  0xBAAA,  // 0x559x
      0x5EC3,  0x5ED7,  0x5ED0,  0xBAB3,  0x5EC5,  0x5EC2,  0xBAC0,  0x5ECD,  
      0xBAB4,  0xBA5E,  0xBA50,  0xBA56,  0xBA58,  0xBA4C,  0xBA5B,  0x5EBF,  // 0x55Ax
      0xBA4B,  0xBAC2,  0x5EC6,  0x5ED6,  0x5ED2,  0xBA4D,  0x5ECC,  0xBABB,  
      0xB9F1,  0x5ED3,  0x5ECF,  0x5ECB,  0xBAAF,  0xBA54,  0xC729,  0,       // 0x55Bx
      0,       0,       0xE7A3,  0x5ED1,  0,       0,       0,       0xC17A,  
      0xC176,  0xC0D1,  0xC227,  0xC16F,  0xC178,  0x63CC,  0x63CD,  0x63C5,  // 0x55Cx
      0xC223,  0x63CF,  0xC174,  0xC173,  0xC171,  0xC225,  0x63C3,  0xC17D,  
      0xC172,  0x63C6,  0xC17B,  0x63C1,  0xC177,  0xC17E,  0xC222,  0xC0CE,  // 0x55Dx
      0x3C4B,  0xC226,  0x63CA,  0xC170,  0x63C4,  0xC175,  0xBAAB,  0x63BF,  
      0xD143,  0x63CB,  0xC221,  0x63C7,  0x63C8,  0x63CE,  0x63C2,  0x23A1,  // 0x55Ex
      0x63C0,  0xC179,  0xC0CC,  0,       0,       0,       0xE7A5,  0x63C9,  
      0xE7A4,  0xC0E2,  0xC224,  0,       0xE4D8,  0,       0x68B5,  0x68B0,  // 0x55Fx
      0xC6AE,  0xC93C,  0xC938,  0xC6A8,  0xC932,  0x68AA,  0x68A6,  0xC93B,  
} ;


static const unsigned short Uni2cnsP0Table_56 [] = {
      0x68A7,  0xC935,  0xC937,  0xC6A9,  0xC93A,  0xC6B6,  0x68AC,  0xC6AC,  // 0x560x
      0x68B3,  0x68AD,  0x4257,  0xC6AA,  0xC930,  0x68AE,  0x68AF,  0xC933,  
      0x68B4,  0xC6B4,  0xC931,  0xC936,  0x68AB,  0xC92F,  0x68B1,  0x68A9,  // 0x561x
      0xC6B3,  0x424B,  0,       0x68A8,  0xC934,  0xC939,  0xC6B1,  0x68B2,  
      0xE4DA,  0,       0xE4D9,  0,       0,       0,       0xC6D0,  0xC92E,  // 0x562x
      0xC6B0,  0x6CB7,  0xCF6E,  0xCBC1,  0xCF6B,  0xCBB8,  0x6CB1,  0x6CBD,  
      0x6CBE,  0xCBBD,  0x6CB4,  0xCF69,  0x6CB6,  0xCF61,  0x6CBC,  0xCBC4,  // 0x563x
      0xCF6D,  0x6CB3,  0xCF6F,  0x6CB2,  0x4931,  0xCF6A,  0xCF6C,  0x6CB5,  
      0xCF68,  0xCF62,  0xCF5F,  0x492E,  0xCBBE,  0xBA4F,  0xCF65,  0xCBB7,  // 0x564x
      0xCF5E,  0xCF64,  0xCF63,  0xCBBB,  0xCF60,  0xCBC3,  0x6CB9,  0xCBC5,  
      0xCBC0,  0xC6B5,  0xCBBC,  0x6CB8,  0xCBB9,  0xA1E3,  0xCBBF,  0x6CBA,  // 0x565x
      0xCF66,  0x70BB,  0xCF67,  0,       0,       0,       0xD64F,  0xD0BF,  
      0xD648,  0xD0C0,  0x70C7,  0xD64C,  0x70BF,  0x70C3,  0xD64B,  0xD0BB,  // 0x566x
      0x70C2,  0x70BE,  0x70C1,  0x70BC,  0x70C6,  0xD64D,  0xD649,  0x70C5,  
      0xD647,  0x70C4,  0xD64E,  0xD64A,  0x6CBB,  0x4F71,  0x70C8,  0xD650,  // 0x567x
      0x70C0,  0x70BD,  0xD3DD,  0xD0BD,  0,       0xD4C8,  0xDC52,  0xDC54,  
      0x73C6,  0xDC55,  0xDC53,  0xDC51,  0xDC50,  0x73C8,  0xDC4F,  0x73C9,  // 0x568x
      0x5574,  0xD4C9,  0xD4C7,  0x5578,  0xDC4D,  0xDC4E,  0x73C5,  0x73CA,  
      0x73C7,  0xE4DD,  0xE4DB,  0xDC4C,  0xD7DB,  0x76BC,  0xD7DA,  0xE148,  // 0x569x
      0xE146,  0xE14B,  0xE149,  0xD7D8,  0xE147,  0xE14A,  0xD7D9,  0xD7D7,  
      0xD7DC,  0,       0,       0,       0,       0x78AC,  0xE53E,  0xE53F,  // 0x56Ax
      0x78AD,  0x5F4D,  0xE540,  0xE53C,  0xE541,  0xE53D,  0x76BD,  0xDAAD,  
      0xE4DE,  0x6331,  0xE86B,  0xE86D,  0x79E4,  0xE86C,  0x79E3,  0x79E2,  // 0x56Bx
      0xE7A6,  0xE7A7,  0xE4DC,  0xDEA6,  0x79E5,  0xEB53,  0xEB54,  0x6634,  
      0x7AE5,  0x7AE4,  0x7AE6,  0xEB52,  0xE7A8,  0xED46,  0xED45,  0xDFC0,  // 0x56Cx
      0x7BD9,  0x7BDB,  0x7BDA,  0xED47,  0x7CB4,  0xF034,  0,       0x6A44,  
      0x6A43,  0x7CDD,  0xE0F1,  0xF033,  0xF07C,  0,       0,       0xA12A,  // 0x56Dx
      0xA1F7,  0x216F,  0x46BF,  0x46BE,  0x216D,  0x47E0,  0x47DF,  0xA227,  
      0x47DE,  0xA226,  0,       0xA3BE,  0x49DB,  0xA349,  0xA5AC,  0xA348,  // 0x56Ex
      0xA3D0,  0xA5A6,  0x49D9,  0x49DC,  0xA5AB,  0xA5AA,  0xA347,  0xA5A9,  
      0x49DA,  0xA5C8,  0xA5A7,  0xA5A8,  0,       0,       0xA8A2,  0xA570,  // 0x56Fx
      0xA7FD,  0xA571,  0x4CD6,  0xA7FC,  0xA8A1,  0xA7FB,  0,       0x50CC,  
} ;


static const unsigned short Uni2cnsP0Table_57 [] = {
      0xABE5,  0xAE4A,  0xAE4B,  0x54E7,  0x54E8,  0xB0A7,  0,       0xB42F,  // 0x570x
      0x59CE,  0x59D0,  0xB42E,  0x59CF,  0xBA60,  0x5ED8,  0xBAC4,  0xBAC3,  
      0x3668,  0x3C52,  0x63D0,  0x63D1,  0xC228,  0xC0D2,  0x68B7,  0xC6B7,  // 0x571x
      0x68B6,  0,       0xCF70,  0xD652,  0xD651,  0xDFC1,  0xF15A,  0x44C8,  
      0xA139,  0xA1E1,  0xA14F,  0xA150,  0xA2B4,  0x2170,  0,       0x2171,  // 0x572x
      0x47E3,  0x47E7,  0xA229,  0x2251,  0x47E5,  0x47E4,  0xA228,  0x47E6,  
      0x47E2,  0xA3C1,  0xA3C2,  0x47E1,  0xA22A,  0xA3BF,  0xA3C0,  0,       // 0x573x
      0,       0,       0,       0x49E6,  0xA5B1,  0xA5BE,  0x49E3,  0xA5B0,  
      0x49DF,  0xA34A,  0xA5C0,  0xA5B6,  0xA5AF,  0xA34B,  0xA5BC,  0x49E1,  // 0x574x
      0xA5AD,  0xA34D,  0x49DD,  0xA34E,  0xA34C,  0x49E0,  0x49E2,  0x49E5,  
      0x49E4,  0x49DE,  0xA34F,  0xA5B2,  0xA5C1,  0xA5C2,  0xA5B3,  0xA5B8,  // 0x575x
      0xA5B7,  0xE4DF,  0,       0xA3D2,  0,       0,       0,       0xA5B5,  
      0,       0x4CDB,  0xA57E,  0xA8A5,  0x4CDD,  0xA8A3,  0x4CDC,  0xA8A6,  // 0x576x
      0xA621,  0x4CDA,  0x4CD9,  0xA575,  0x2569,  0xA574,  0xA8A8,  0xA572,  
      0xA577,  0xA576,  0xA573,  0xA57C,  0xA57D,  0xA57A,  0xA578,  0x4CD8,  // 0x577x
      0xA8A9,  0x2566,  0x2568,  0xA57B,  0x4CDE,  0xA622,  0x2565,  0xA8AA,  
      0xA579,  0xA8A4,  0x50CD,  0x4CD7,  0,       0,       0,       0x256E,  // 0x578x
      0xA6B3,  0,       0xE4E0,  0x50CE,  0xA955,  0xABE9,  0xABE8,  0xA95B,  
      0xABEC,  0xABE7,  0xABEA,  0x50D4,  0xA959,  0xA95F,  0xABF1,  0xA956,  // 0x579x
      0xA95A,  0xA95C,  0xA95E,  0xA958,  0xABF0,  0xA957,  0xA952,  0xA953,  
      0x50CF,  0xABEB,  0x50D1,  0x50D0,  0xA954,  0xA95D,  0xABED,  0xABF2,  // 0x57Ax
      0xABEE,  0x2860,  0xA9EA,  0xA9F1,  0xABE6,  0,       0x50D3,  0,       
      0,       0,       0,       0,       0x285E,  0xA951,  0xAE55,  0xB0AA,  // 0x57Bx
      0xAE54,  0xAE59,  0xAE50,  0xB0B0,  0xAE53,  0xAE52,  0xB0AF,  0xAE56,  
      0xB0B8,  0xAE5A,  0x54E9,  0x54EC,  0xB0B4,  0xB0B5,  0xAE51,  0xAE57,  // 0x57Cx
      0xB0B3,  0xB0A8,  0xB0B7,  0x54EB,  0xAE4C,  0xB0AB,  0x50D2,  0xB43D,  
      0xAE58,  0xB0B6,  0xAE4F,  0x2C33,  0x54EA,  0xAE4E,  0,       0xAEDC,  // 0x57Dx
      0,       0,       0,       0xB0B2,  0xB434,  0xB4EE,  0xB4F1,  0x59D1,  
      0x59D5,  0xB444,  0xB432,  0xB440,  0x59D6,  0xB442,  0xB4F2,  0xB448,  // 0x57Ex
      0xB4F4,  0xB44C,  0xB4E9,  0x307B,  0xB443,  0xB437,  0xB43F,  0xB4EB,  
      0xB44D,  0xB44B,  0xB441,  0xB43C,  0xB435,  0xBA68,  0xB433,  0x59DA,  // 0x57Fx
      0xB43A,  0x59DB,  0x59D7,  0xB430,  0xB446,  0xB438,  0xB4EF,  0xB4F5,  
} ;


static const unsigned short Uni2cnsP0Table_58 [] = {
      0xB436,  0xB449,  0x59D8,  0xB4F6,  0xB44F,  0x59D2,  0x59D4,  0xB43E,  // 0x580x
      0xB439,  0x54ED,  0x59D3,  0xB43B,  0xB44A,  0xB44E,  0xB445,  0xE4E1,  
      0xB447,  0,       0xE4E2,  0xE4E3,  0xB431,  0,       0,       0x3669,  // 0x581x
      0xBACA,  0xBA63,  0xBAC5,  0xBA6C,  0xBA6B,  0x5EE0,  0xBA64,  0xBAC7,  
      0x5EE1,  0x5EDF,  0xBAD0,  0xBA66,  0x5EDC,  0xBA6A,  0xBACC,  0xBA65,  // 0x582x
      0xBA67,  0xBA61,  0x5EDA,  0x366F,  0xBA74,  0xBA73,  0xBA70,  0x5ED9,  
      0x5EDD,  0x5EDE,  0xAE4D,  0xBA6D,  0x5EDB,  0x59D9,  0xBA6F,  0xBA62,  // 0x583x
      0xBA72,  0xBA71,  0xBACE,  0xBA75,  0xBAC9,  0xC236,  0xBACB,  0xBA6E,  
      0xB9FD,  0,       0xB9FE,  0x3C57,  0x366D,  0x3671,  0,       0xE4E4,  // 0x584x
      0xBA69,  0xC22E,  0x63DB,  0x63DE,  0x63D9,  0xC22D,  0xC231,  0xC22C,  
      0xC0D7,  0x63D3,  0x63DD,  0xC229,  0x63D7,  0xC230,  0xC0DB,  0x63D5,  // 0x585x
      0x63D4,  0xC233,  0x63D6,  0xC235,  0xC0D6,  0xC232,  0x63D2,  0xC0DE,  
      0xC0DC,  0xC0D8,  0x63DC,  0xC237,  0xC22B,  0xC234,  0xC0DD,  0x3C53,  // 0x586x
      0xC22A,  0xC0DA,  0xC0D9,  0x63D8,  0xC0D4,  0x63DA,  0,       0xC22F,  
      0,       0xC238,  0xC6C3,  0xC6BE,  0xC944,  0x68B8,  0xC94A,  0xC6C2,  // 0x587x
      0xC6BC,  0x68BD,  0xC946,  0xC94D,  0xC93E,  0x68BF,  0x68B9,  0xC943,  
      0x6CBF,  0xC942,  0xC94B,  0x68BA,  0xC6BD,  0x68BE,  0xC941,  0xC947,  // 0x588x
      0xC94C,  0xC93D,  0x68BC,  0xC945,  0xC6BA,  0xC6C5,  0xC949,  0xC94F,  
      0xC93F,  0xC948,  0xC6B8,  0x68BB,  0xC94E,  0xC6C1,  0xC6C4,  0xC6C0,  // 0x589x
      0xC940,  0,       0x4259,  0xE4E5,  0x6CC3,  0xCF72,  0x6CC1,  0x6CC0,  
      0xCF74,  0xCF79,  0xCBC6,  0xCF75,  0xCBD0,  0xCF78,  0x6CC6,  0xCBD1,  // 0x58Ax
      0x70AE,  0x6CC5,  0xCBCB,  0xCF71,  0xCF77,  0xC6BF,  0x6CC4,  0xCF76,  
      0xCBCD,  0xCF73,  0xCBC9,  0x6CC2,  0xCBCF,  0xCBCC,  0,       0xCBC7,  // 0x58Bx
      0,       0,       0xD657,  0xD0CA,  0xD659,  0xD654,  0x70CA,  0xD656,  
      0xD0CB,  0x70C9,  0xD658,  0xD0C8,  0xD0CC,  0x70CC,  0xD65A,  0x70CB,  // 0x58Cx
      0xD653,  0xD655,  0xD0C9,  0,       0,       0xD4CB,  0x73CE,  0xDC58,  
      0xD4CC,  0x73CD,  0xDC59,  0x73CC,  0xDC57,  0x73CB,  0xDC56,  0,       // 0x58Dx
      0x76BF,  0x76BE,  0xE542,  0xE544,  0xDAAF,  0xE543,  0x78AE,  0x78AF,  
      0xDAAE,  0xC6C5,  0x78B0,  0xE86E,  0x79E6,  0,       0xDEA8,  0xEF22,  // 0x58Ex
      0xEF21,  0x7CDE,  0,       0x44C9,  0x45B1,  0,       0xA3C3,  0x49E7,  
      0xA5C5,  0xA5C3,  0xA5C4,  0xA8AD,  0xA960,  0xABF7,  0,       0xB4F7,  // 0x58Fx
      0,       0x5EE2,  0x5EE3,  0xBAD2,  0xC239,  0x68C0,  0xC950,  0xCF7A,  
} ;


static const unsigned short Uni2cnsP0Table_59 [] = {
      0xE4E6,  0xD0CD,  0xA1B9,  0xA13A,  0xA2B5,  0xA3C4,  0xA350,  0,       // 0x590x
      0xABFA,  0xABF9,  0xA1BA,  0xA5C6,  0xA623,  0xA961,  0xAE5B,  0x54EE,  
      0xC6C6,  0xE5E0,  0xE545,  0x5F52,  0x7AE7,  0x44CA,  0x46C0,  0xA151,  // 0x591x
      0xA2B6,  0x47E8,  0x47E9,  0x2252,  0x4CDF,  0x2570,  0,       0xB4F9,  
      0x59DC,  0x37BD,  0x68C2,  0xC0DF,  0x68C3,  0x68C1,  0xCBD3,  0x44CB,  // 0x592x
      0x2149,  0x45B2,  0x45B4,  0x45B3,  0xA13B,  0x45B5,  0x46C1,  0xA152,  
      0xA2B8,  0x46C2,  0xA2B7,  0x2172,  0xA2B9,  0x2253,  0xA3C7,  0x47EA,  // 0x593x
      0x47EB,  0,       0,       0,       0xA22B,  0xA5C9,  0x49E8,  0x2362,  
      0xA351,  0,       0,       0x2575,  0x4CE3,  0xA624,  0x2572,  0x4CE1,  // 0x594x
      0x4CE2,  0x4CE0,  0xAE5C,  0xA8AE,  0xA8AF,  0xE4E7,  0x50D8,  0x50D7,  
      0x50D9,  0x50D6,  0xABFC,  0xA962,  0x4CE4,  0x50D5,  0,       0x54EF,  // 0x595x
      0x54F0,  0x2C38,  0x54F1,  0xB4FB,  0xB450,  0xB4FC,  0xB4FD,  0x3126,  
      0x5EE4,  0xBA76,  0x59DD,  0xBAD3,  0xBAD4,  0x3679,  0xC0E0,  0x63DF,  // 0x596x
      0xC0E1,  0x68C5,  0x68C4,  0xC951,  0xC6C8,  0x6CC7,  0x70CD,  0x4F7B,  
      0xE14C,  0xED48,  0xEF23,  0x44CC,  0x46C3,  0xA2BB,  0x46C4,  0xA231,  // 0x597x
      0x47ED,  0x47F0,  0xA3CB,  0xA22F,  0xA22D,  0x47EF,  0xA230,  0xA232,  
      0xA22C,  0x47F2,  0x47F1,  0x47EE,  0x47EC,  0xA22E,  0xA3CD,  0,       // 0x598x
      0,       0xA5D5,  0x49F3,  0x2367,  0xA5CC,  0x49F0,  0xA356,  0xA359,  
      0xA358,  0x2369,  0x49EA,  0x49F2,  0xA5CB,  0x236A,  0x49EF,  0xA355,  // 0x599x
      0xA353,  0x49EE,  0xA5D6,  0xA5D3,  0xA5CE,  0x49E9,  0x49EC,  0xA5D1,  
      0xA354,  0xA35B,  0xA357,  0x49ED,  0x49F1,  0x49F4,  0xA352,  0xA35A,  // 0x59Ax
      0x49EB,  0,       0,       0,       0xA8C1,  0xA8B3,  0x4CE9,  0x4CF1,  
      0xA8B8,  0xA630,  0xA629,  0x4CF2,  0xA634,  0xA625,  0xA62C,  0xA8C5,  // 0x59Bx
      0xA8C0,  0x4CE8,  0xA626,  0x4CE6,  0xA62D,  0xA631,  0x4CE5,  0xA8BD,  
      0xA632,  0xA62B,  0xA8B7,  0xA62E,  0xA8B5,  0x4CF4,  0x4CEB,  0xA635,  // 0x59Cx
      0xA633,  0xA8BF,  0x4CF0,  0x4CEE,  0xA62A,  0x4CED,  0xA628,  0xA627,  
      0x4CEC,  0x4CEA,  0x4CF3,  0x4CEF,  0x4CE7,  0xACA6,  0xA62F,  0xA8C6,  // 0x59Dx
      0x50DB,  0xACAD,  0x50E2,  0xA970,  0x50DA,  0xA968,  0xA964,  0xACA1,  
      0xA974,  0xA963,  0xACAC,  0x50DD,  0xA96D,  0x50E0,  0x50E3,  0xACAE,  // 0x59Ex
      0x50DE,  0xA971,  0x50E1,  0xACA3,  0x54F8,  0xA977,  0xA965,  0xACA4,  
      0xACA5,  0xA967,  0xA96E,  0xA972,  0xA976,  0xA973,  0xA96C,  0xA96F,  // 0x59Fx
      0xACAB,  0xACA9,  0xA969,  0x50E5,  0xA96B,  0xA96A,  0xA975,  0x50DC,  
} ;


static const unsigned short Uni2cnsP0Table_5A [] = {
      0xA966,  0x50E4,  0xACAA,  0x50DF,  0xACA8,  0,       0,       0,       // 0x5A0x
      0,       0x54FE,  0xAE64,  0xB0C0,  0x54FD,  0xACA7,  0x2C40,  0xAE62,  
      0x2C3E,  0x54F2,  0xB0CF,  0x54F7,  0xB0CA,  0xAE61,  0xAE5E,  0xAE63,  // 0x5A1x
      0x54F3,  0xAE5D,  0xB0CE,  0x54F6,  0x54F4,  0xB0BE,  0xAE65,  0x54F5,  
      0x54F9,  0xB0BB,  0xB0C5,  0x54FA,  0xB0C8,  0x54FC,  0xB0D2,  0x2C39,  // 0x5A2x
      0x2C3D,  0x54FB,  0xB0BC,  0xB5A2,  0xB5B8,  0xAE5F,  0xAE60,  0xB0CD,  
      0xB657,  0xB0CB,  0,       0xAE66,  0,       0xB457,  0x59DE,  0xBB26,  // 0x5A3x
      0xB456,  0xB469,  0xB5A8,  0xB5A4,  0x59E4,  0xB5B1,  0xB467,  0xB5B3,  
      0x59E3,  0x59DF,  0xB470,  0xB460,  0xB463,  0xB5AE,  0x59E7,  0xB46D,  // 0x5A4x
      0xB465,  0x59E0,  0x59E8,  0xB5AA,  0xB46A,  0xB468,  0xB5AF,  0xB5BB,  
      0xB459,  0xB46E,  0xB462,  0xB45D,  0xB5BA,  0xB453,  0xB46F,  0xB45F,  // 0x5A5x
      0xB452,  0xB5B9,  0x59E6,  0xB464,  0xB471,  0xB461,  0xB455,  0xB45A,  
      0xB451,  0xB5A7,  0x59E5,  0xB5BC,  0xB45E,  0xB45B,  0x59E1,  0xB454,  // 0x5A6x
      0xB5B0,  0xB46C,  0x59E2,  0xB5AB,  0xB45C,  0xB458,  0xB5A9,  0xB5B4,  
      0xB46B,  0xB5B2,  0xB3F3,  0xB5B7,  0,       0xB5B5,  0,       0x5EE5,  // 0x5A7x
      0xBA7D,  0xBAF5,  0xBA7A,  0xBB2D,  0xBB21,  0xBB2E,  0xBAFC,  0x5EE7,  
      0xBAE3,  0xBAE1,  0xBAD8,  0xBB2A,  0xBB27,  0xBADB,  0xBAF7,  0xBAF2,  // 0x5A8x
      0xBAD9,  0xBAE0,  0xBB28,  0xBB2B,  0xBB2F,  0xBAFB,  0xB466,  0xBB31,  
      0xC24D,  0xBAE6,  0x5EE8,  0xBB32,  0xBA78,  0xBB24,  0xBAE2,  0xBB29,  // 0x5A9x
      0xBADC,  0xBADE,  0x5EE6,  0x5EE9,  0xBB30,  0xBB33,  0xBA7C,  0xBA79,  
      0xBAF3,  0xBADA,  0xBA7B,  0xBAD7,  0xBAFA,  0xBB22,  0xBA7E,  0x5EEA,  // 0x5AAx
      0xBAD6,  0xBB2C,  0xBAF9,  0xBAF8,  0xBB23,  0,       0xBB25,  0xBA77,  
      0xC241,  0xC23F,  0x63E8,  0x63E6,  0xC249,  0xC240,  0xC24A,  0xC246,  // 0x5ABx
      0xC23E,  0xC24C,  0xC23D,  0xC244,  0x63E5,  0x63E4,  0x63E3,  0xC242,  
      0xC247,  0x63E0,  0x63E7,  0xC0E7,  0xC23B,  0xC0E6,  0xC245,  0xC23A,  // 0x5ACx
      0xC243,  0x63E1,  0xC248,  0xC23C,  0x63E2,  0xC24B,  0xC0E4,  0xBAEB,  
      0xC0EA,  0xE4E8,  0,       0xE4E9,  0,       0xC955,  0x68CA,  0x68C9,  // 0x5ADx
      0x68CB,  0xC961,  0xC957,  0xC95D,  0xC952,  0xC960,  0xC95F,  0xC963,  
      0xC95C,  0x68C6,  0xC95B,  0x68CC,  0xC6CC,  0xC954,  0x68C7,  0xC6CA,  // 0x5AEx
      0xC962,  0x68C8,  0xC956,  0xC959,  0xC95E,  0xC958,  0xC953,  0xC6CF,  
      0xC6D3,  0,       0,       0xC95A,  0xCF7C,  0x6CCB,  0xD021,  0xCF7E,  // 0x5AFx
      0xD023,  0xD025,  0xCBDC,  0x6CC9,  0xCBD8,  0xCF7D,  0xCBD4,  0xCF7B,  
} ;


static const unsigned short Uni2cnsP0Table_5B [] = {
      0xCBDE,  0xD026,  0xD024,  0xD022,  0xCBD6,  0xD028,  0xCBDA,  0xD027,  // 0x5B0x
      0x6CCD,  0x6CC8,  0xCBDB,  0x6CCA,  0x6CCC,  0xCBDD,  0xCBDF,  0xD029,  
      0xD661,  0xD0D0,  0xD0D3,  0xD660,  0xD65F,  0xD0D1,  0xD662,  0xD65B,  // 0x5B1x
      0xD0CF,  0xD65C,  0xD664,  0xD65D,  0xD0D4,  0x70CE,  0xD666,  0xD0CE,  
      0xD665,  0xD65E,  0xD0D6,  0xDC5D,  0x73D1,  0xDC5B,  0xDC60,  0xDC5F,  // 0x5B2x
      0xD663,  0xD4D0,  0x73D0,  0xD4CE,  0xDC5E,  0xDC5A,  0xDC62,  0xDC61,  
      0x73CF,  0xD4D2,  0xDC5C,  0xD4CF,  0x70CF,  0xD4D1,  0,       0xD4D3,  // 0x5B3x
      0x76C0,  0xDAB1,  0xD7E1,  0xD7DE,  0xE14D,  0xE546,  0xE547,  0xE548,  
      0x79E7,  0x6334,  0xDCB6,  0x79E8,  0xDCB9,  0xE86F,  0xDCBA,  0xEB56,  // 0x5B4x
      0xEB55,  0xDEA9,  0xDFC2,  0xED49,  0xED4A,  0xEF24,  0xF035,  0xE0F3,  
      0x44CD,  0x44CE,  0x2132,  0x44CF,  0x45B6,  0x46C5,  0xA233,  0x47F3,  // 0x5B5x
      0x47F4,  0,       0x49F7,  0x49F8,  0x49F6,  0x49F5,  0,       0x4CF5,  
      0xA8C8,  0x2622,  0xA636,  0x4CF7,  0x4CF6,  0xA637,  0x2623,  0xE4EA,  // 0x5B6x
      0x286E,  0x50E6,  0xACAF,  0x55A1,  0xAE67,  0,       0xB473,  0x312C,  
      0x59E9,  0x5EEC,  0xB472,  0x5EEB,  0xC0F1,  0x68CD,  0xC0F2,  0xC964,  // 0x5B7x
      0x70D0,  0xD0D7,  0x73D2,  0xDC63,  0xDAB4,  0x79E9,  0xDCBB,  0x7BDC,  
      0xA1BB,  0xA153,  0xA2BD,  0x46C6,  0xA154,  0x47F7,  0xA3D0,  0x47F5,  // 0x5B8x
      0x47F6,  0x47F8,  0x236F,  0x49FA,  0x49F9,  0xA5DA,  0xA35C,  0x49FB,  
      0x2625,  0,       0xA35D,  0xA638,  0xA8CC,  0xA639,  0xA8CA,  0x4CF8,  // 0x5B9x
      0x4CFA,  0x4CFC,  0x4CF9,  0x4CFD,  0x4CFB,  0xA8CE,  0xA8CB,  0xA8CD,  
      0,       0,       0x50EA,  0x50E7,  0x50E9,  0x50EB,  0x50E8,  0xAE68,  // 0x5BAx
      0xA978,  0xAAB9,  0,       0xACB2,  0xAE6A,  0xAE69,  0x55A7,  0x2C46,  
      0x55A3,  0x2C49,  0xB666,  0x55A4,  0x55A6,  0x55A8,  0x55A5,  0xB0D7,  // 0x5BBx
      0x55AA,  0x55A9,  0x2C48,  0xB0D6,  0xB0D5,  0,       0xAEFE,  0x59EE,  
      0xB475,  0xB474,  0x59ED,  0xB5C1,  0x59EC,  0x59EB,  0x59EF,  0x59EA,  // 0x5BCx
      0xB5BF,  0,       0xBB39,  0xBB36,  0x5EEE,  0xBB35,  0xBB3A,  0x3724,  
      0x5EF0,  0xBB38,  0x5EED,  0x5EEF,  0xBB37,  0xBAFE,  0xC24E,  0xC0F4,  // 0x5BDx
      0xC24F,  0xC250,  0xC0F5,  0xC0F6,  0xC0F3,  0x3C6E,  0x68CE,  0x68D6,  
      0xC965,  0x68D0,  0x68D4,  0xC966,  0x68D5,  0x68D1,  0x68D2,  0x68CF,  // 0x5BEx
      0x68D3,  0x6CD0,  0xBB34,  0x6CD1,  0x6CCF,  0x4944,  0x6CCE,  0xD667,  
      0x70D1,  0xDC64,  0xDC65,  0xDAB5,  0x5F55,  0x78B1,  0x79EA,  0xDEAA,  // 0x5BFx
      0x44D0,  0xA2BE,  0x47F9,  0,       0,       0xA5DE,  0xA5DC,  0xA5DD,  
} ;


static const unsigned short Uni2cnsP0Table_5C [] = {
      0xA8D0,  0x50EC,  0,       0xAE6B,  0x55AB,  0xB0D8,  0xB0D9,  0x59F2,  // 0x5C0x
      0x59F1,  0x59F0,  0x5EF1,  0x5EF2,  0xBB3B,  0x68D7,  0x70D2,  0x44D1,  
      0xA13C,  0x45B7,  0xA155,  0x2173,  0xA2BF,  0xA234,  0x47FA,  0x225C,  // 0x5C1x
      0xA3D2,  0xA8D1,  0x4CFE,  0xACB4,  0,       0,       0xBBA4,  0xC251,  
      0xC0F8,  0xE5A5,  0x44D2,  0x214B,  0x45B8,  0xA235,  0,       0,       // 0x5C2x
      0xA35E,  0x2629,  0xA35F,  0xA5DF,  0x49FC,  0xA5D4,  0,       0xACB5,  
      0xBB3C,  0x5EF3,  0,       0xC252,  0,       0x4949,  0xD4D4,  0x73D3,  // 0x5C3x
      0x44D3,  0x44E7,  0x45B9,  0xA156,  0x46C7,  0xA3D4,  0x4AA2,  0x4AA1,  
      0x49FD,  0x49FE,  0,       0,       0xA63A,  0x4DA2,  0x4DA3,  0xA63B,  // 0x5C4x
      0x4DA1,  0xA8D4,  0xA8D5,  0x50F0,  0xA979,  0x50EF,  0x50ED,  0x50EE,  
      0x55AE,  0x55AC,  0xB0DA,  0xB0DB,  0xAE6D,  0x55AD,  0xAE6C,  0xE4EB,  // 0x5C5x
      0x55A2,  0xB476,  0x3135,  0xB5C3,  0x59F4,  0x59F5,  0xBBA6,  0xBBA5,  
      0x59F3,  0xB5C4,  0x68D8,  0xC967,  0x6CD2,  0x6CD3,  0,       0xD02A,  // 0x5C6x
      0x73D4,  0xE14E,  0xE14F,  0xDAB8,  0x7AE8,  0xF036,  0xA12B,  0x45BA,  
      0x225F,  0x44D4,  0,       0xA158,  0xA157,  0x2176,  0,       0xE4EC,  // 0x5C7x
      0xA3D5,  0x47FB,  0xA237,  0xA238,  0xA236,  0x2260,  0xA239,  0,       
      0xA3DA,  0xA2C7,  0,       0,       0xA5E1,  0xA5E6,  0xA367,  0x237A,  // 0x5C8x
      0xA362,  0xA364,  0xA366,  0xA363,  0x4AA6,  0xA360,  0xA5E2,  0xA361,  
      0x4AA3,  0x4AA4,  0xA365,  0xA368,  0x4AA5,  0xA369,  0,       0xA3FC,  // 0x5C9x
      0,       0xA3F8,  0,       0,       0xA5E3,  0xA649,  0xA8DD,  0xA643,  
      0xA63E,  0x4DA5,  0xA646,  0xA644,  0xA63D,  0xA64A,  0xA64D,  0xA648,  // 0x5CAx
      0xA641,  0x4DA7,  0xA647,  0x4DA8,  0xA642,  0xA645,  0xA63C,  0xA640,  
      0xA64C,  0x4DA9,  0x262F,  0x4DAA,  0xA8DE,  0xA63F,  0xA64B,  0x4DA4,  // 0x5CBx
      0x4DA6,  0xA8DC,  0xA8DF,  0xA8D7,  0,       0,       0,       0,       
      0x2634,  0xA8D8,  0,       0,       0,       0,       0xAA2C,  0xAA25,  // 0x5CCx
      0xAA2B,  0xAA24,  0xAA26,  0xA97E,  0xA97C,  0xACBF,  0xAA2D,  0xAA2A,  
      0xA97A,  0xACBB,  0x50F2,  0xAA28,  0xAA29,  0xE4ED,  0xAA27,  0xA97D,  // 0x5CDx
      0xA97B,  0x50F1,  0xAA23,  0xAA21,  0xACBC,  0xACC2,  0xAA22,  0xAA2E,  
      0,       0xACBE,  0xACC1,  0,       0,       0xACC3,  0xACBD,  0,       // 0x5CEx
      0x55B3,  0xB0E3,  0x55B2,  0xB0DF,  0xAE6E,  0x55AF,  0xAE70,  0xB0E4,  
      0x55B4,  0xAE71,  0x2C60,  0xB0E1,  0x55B7,  0xB0E2,  0x55B5,  0xAE72,  // 0x5CFx
      0xAA2F,  0xAE74,  0xB0DE,  0x55B1,  0x2C5C,  0x55B0,  0x2C61,  0xAE6F,  
} ;


static const unsigned short Uni2cnsP0Table_5D [] = {
      0xAE73,  0x55B6,  0,       0,       0,       0,       0x59F7,  0x59F6,  // 0x5D0x
      0xB5CB,  0xB5C8,  0xB5C7,  0xB478,  0xB47C,  0xB47E,  0x59F8,  0xB523,  
      0xB5D1,  0x59FC,  0xB525,  0xB5D2,  0x59FE,  0xB5CF,  0x59FA,  0x5AA4,  // 0x5D1x
      0xB5D5,  0x5AA1,  0xB47A,  0x59F9,  0xBBAB,  0xB479,  0xB477,  0xB527,  
      0xB47B,  0xB5C6,  0x59FB,  0xB526,  0x5AA2,  0xB522,  0xB521,  0x5AA3,  // 0x5D2x
      0xB47D,  0x59FD,  0xB5CE,  0xBE76,  0xB5CA,  0,       0xB528,  0xB5D4,  
      0xB524,  0xBB4B,  0xBB52,  0xBB47,  0x5EF6,  0xBB43,  0xBB53,  0xBB3D,  // 0x5D3x
      0xBB50,  0xBB4E,  0xBB48,  0xBBB6,  0xBB51,  0xBB4A,  0xBBA8,  0xBB42,  
      0xBB54,  0xBB40,  0xBB4D,  0xBB3E,  0xBBA7,  0xBB55,  0xBBB7,  0x5EF7,  // 0x5D4x
      0xBBAA,  0xBB4F,  0xC255,  0xBB41,  0x5EF4,  0xBBAE,  0xBB45,  0xBBB4,  
      0x5EF5,  0xBB44,  0xBB49,  0xBBB3,  0x3735,  0xBB46,  0x372F,  0xBBB1,  // 0x5D5x
      0,       0xBB4C,  0,       0xBBAD,  0,       0,       0xC259,  0x3C79,  
      0xC1A1,  0x3C7B,  0xC25C,  0xC254,  0xC0FC,  0xC256,  0xC0FA,  0xC25B,  // 0x5D6x
      0xC25A,  0x63E9,  0x3C75,  0xBB3F,  0xC258,  0xC0F9,  0xC0FD,  0x63EA,  
      0x3C74,  0xC253,  0xC257,  0x3C7C,  0x3C78,  0xE4EE,  0,       0xC96E,  // 0x5D7x
      0xC6DC,  0xC975,  0xC96C,  0xC6D4,  0xC973,  0xC96A,  0xC972,  0xC976,  
      0xC969,  0xC96D,  0xC968,  0xC6D6,  0x68D9,  0x432C,  0xC96B,  0x68DA,  // 0x5D8x
      0xC971,  0xC970,  0xC96F,  0xC6D9,  0xC6DA,  0xC974,  0xE4EF,  0xCBE5,  
      0xCBE6,  0xCBE3,  0xD02E,  0xD030,  0x6CD5,  0xD031,  0xCBEB,  0xD02C,  // 0x5D9x
      0xCBE7,  0xD02B,  0xD035,  0xCBE9,  0xD033,  0x6CD4,  0xD036,  0xD02D,  
      0xD032,  0xD034,  0xD02F,  0xCBEA,  0xCBE8,  0xE4F0,  0xD0D8,  0xD66B,  // 0x5DAx
      0xD670,  0xD66A,  0xD66F,  0xD0DB,  0xD668,  0xD672,  0xD66E,  0xD673,  
      0xD66D,  0xD669,  0xD671,  0xD0DA,  0xD674,  0xD66C,  0xE4F1,  0xDC66,  // 0x5DBx
      0x73D8,  0xD4D7,  0x73D6,  0xD4D9,  0x73D5,  0x73D7,  0xD4D5,  0xE4F2,  
      0xE150,  0xD7E2,  0xE43E,  0xE549,  0xDAB9,  0,       0xE870,  0xE871,  // 0x5DCx
      0xDCBD,  0x79EB,  0xDCBC,  0xEB57,  0xDCBE,  0x7AE9,  0x663B,  0xEB58,  
      0xDEAD,  0xED4C,  0x7BDE,  0xDFC3,  0x7BDD,  0xED4B,  0x7CB5,  0xE0B0,  // 0x5DDx
      0xEF25,  0x6B68,  0x6A46,  0xA1BC,  0x212C,  0x44D5,  0x47FC,  0xA23A,  
      0xA36A,  0x4BD6,  0x5AA5,  0xB5D7,  0xCBEC,  0x44D6,  0x46CA,  0x46C9,  // 0x5DEx
      0x46C8,  0x2263,  0,       0x4AA7,  0,       0,       0x55B8,  0,       
      0xC25D,  0x44D7,  0x44D8,  0x44D9,  0x45BB,  0xA5E7,  0xA8E0,  0x50F3,  // 0x5DFx
      0x2C64,  0xAA30,  0xACC5,  0xACC4,  0,       0x5EF8,  0x44DA,  0xA13D,  
} ;


static const unsigned short Uni2cnsP0Table_5E [] = {
      0xA1E3,  0x214C,  0x46CB,  0x46CC,  0xA159,  0,       0x47FD,  0x22DC,  // 0x5E0x
      0xA3DC,  0xA5E8,  0xA36B,  0xA5EB,  0x4AA8,  0x2423,  0xA36C,  0,       
      0,       0x4DB0,  0xA8E2,  0xA8E1,  0xA64F,  0x4DAE,  0x4DAD,  0xA64E,  // 0x5E1x
      0x4DAB,  0xA650,  0x4DAC,  0x4DAF,  0,       0x50F4,  0xACC6,  0x50F6,  
      0xAA34,  0xAA31,  0xAA32,  0xAA33,  0xAA35,  0x50F5,  0,       0,       // 0x5E2x
      0xAE76,  0xAE75,  0xB0E6,  0x55BA,  0xB0E9,  0x55B9,  0xB0E8,  0xB0EA,  
      0xB0E7,  0,       0xB5DB,  0x5AA8,  0xB52A,  0xB5D9,  0x5AA7,  0x5AA9,  // 0x5E3x
      0x5AA6,  0xB5D8,  0xB5DA,  0,       0,       0x5EFA,  0xB529,  0x37FC,  
      0x5EFB,  0xBB57,  0xB9F9,  0x5EFC,  0xBB56,  0x5EF9,  0xBBBA,  0xBBBB,  // 0x5E4x
      0xBBBD,  0,       0xC260,  0xC262,  0x63EB,  0xC261,  0xC25F,  0xC25E,  
      0x3D2A,  0x4335,  0xC6DD,  0xC979,  0x68DF,  0x68DD,  0x4330,  0x68DE,  // 0x5E5x
      0xC977,  0xC978,  0xCBED,  0x68DB,  0xD03A,  0xD038,  0xCBF0,  0x6CD7,  
      0xD039,  0x6CD8,  0x6CD6,  0x68DC,  0xCEDE,  0xE4F3,  0xD677,  0xD675,  // 0x5E6x
      0xD676,  0xD037,  0xDC68,  0x73D9,  0xDC67,  0xE151,  0xE152,  0xD678,  
      0xE54A,  0xE6F7,  0x44DB,  0x46CD,  0x48A1,  0xA23B,  0x47FE,  0xA8E3,  // 0x5E7x
      0x4DB1,  0x63EC,  0xA1BD,  0x45BC,  0x46CE,  0x50F7,  0x5EFD,  0xA1BE,  
      0xA15A,  0xA2C7,  0xA15B,  0xA2C8,  0xA23C,  0xE6F8,  0,       0x4AAA,  // 0x5E8x
      0xA370,  0xA36E,  0x4AAB,  0xA36D,  0xA36F,  0xA371,  0x2428,  0x4AA9,  
      0xA5EE,  0,       0xA5ED,  0,       0,       0x4DB5,  0x4DB6,  0x4DB3,  // 0x5E9x
      0xA8E5,  0xA8E7,  0x4DB2,  0xAA39,  0x4DB4,  0xA8E8,  0,       0,       
      0x50F8,  0xACC8,  0xAA38,  0xAA3A,  0xAA37,  0xAA3B,  0x50F9,  0x55BD,  // 0x5EAx
      0xAE77,  0xB0EC,  0xAE79,  0x55BB,  0xAE7A,  0x55BC,  0xAE78,  0xB0EB,  
      0xAA36,  0xB52B,  0xB52E,  0xB52F,  0xB52C,  0x5AAD,  0x5AAC,  0x5AAA,  // 0x5EBx
      0x5AAB,  0xB52D,  0xB5E1,  0xB5E0,  0,       0xBBBF,  0x5AAE,  0xBBC0,  
      0xBBBE,  0x5FA1,  0x5FA2,  0xC845,  0x5FA3,  0xC263,  0xC265,  0xC267,  // 0x5ECx
      0x63EE,  0x63ED,  0x5EFE,  0xC266,  0xC264,  0xE4F4,  0xC97D,  0xC6E1,  
      0xC6E0,  0xC97B,  0xCA23,  0x68E0,  0xCA24,  0xCA21,  0x68E1,  0xC97C,  // 0x5EDx
      0xC97A,  0xCA22,  0x6CDA,  0xD03C,  0xC97E,  0x6CDC,  0xD03D,  0x6CDB,  
      0x6CDE,  0xD03E,  0x6CD9,  0x6CDD,  0,       0xD67D,  0xD67B,  0xD67A,  // 0x5EEx
      0xD67C,  0xD679,  0xD0DC,  0x5B21,  0x78B3,  0xE4F5,  0xE872,  0xE873,  
      0xDCBF,  0xEB59,  0xED4D,  0x7DA2,  0xA1BF,  0xA3E1,  0x4DB7,  0x4AAC,  // 0x5EFx
      0xA8E9,  0xA8EB,  0x50FA,  0xACCC,  0xACCB,  0xB0EE,  0x44DC,  0x45BD,  
} ;


static const unsigned short Uni2cnsP0Table_5F [] = {
      0x214D,  0x46CF,  0xA23D,  0xA5EF,  0x4AAD,  0xA372,  0xA8ED,  0xAA3C,  // 0x5F0x
      0x50FB,  0,       0x68E2,  0x44DD,  0xA1E4,  0xA2C9,  0xA3E2,  0x48A2,  
      0xA2CE,  0xBBC2,  0x63EF,  0x44DE,  0x45BE,  0x45BF,  0,       0x46D1,  // 0x5F1x
      0x46D0,  0x226B,  0xA23E,  0x48A3,  0x226C,  0xA373,  0xA5F1,  0x4AAE,  
      0,       0xA8EE,  0xA652,  0xA653,  0xA654,  0xA8F0,  0x4DB8,  0x4DB9,  // 0x5F2x
      0xA651,  0x4DBA,  0,       0x292C,  0x2C70,  0x50FC,  0xAA3D,  0xACCD,  
      0xAE7C,  0x55BE,  0xB0EF,  0xAE7B,  0xB5E2,  0x5AAF,  0xB530,  0x5AB0,  // 0x5F3x
      0xB531,  0xB5E3,  0xBBC7,  0xBBC5,  0x5FA4,  0x3745,  0xBBC4,  0x3D30,  
      0xC268,  0xC1BF,  0xC1A2,  0xCA26,  0xCA25,  0,       0x68E3,  0x495E,  // 0x5F4x
      0x6CDF,  0xD03F,  0x70D3,  0xD67E,  0x73DA,  0xD7E3,  0x7BDF,  0xEF27,  
      0xA1C0,  0xA1C1,  0xA2CA,  0xA3D1,  0xA655,  0xA8F1,  0xAA3E,  0x5AB1,  // 0x5F5x
      0xBB58,  0x63F0,  0xC1A3,  0xD0DE,  0xD4C3,  0xD7E4,  0x76C1,  0,       
      0xE1E4,  0xA1C2,  0x4AB0,  0xA5F2,  0x4AAF,  0x50FD,  0xACD0,  0xAE7D,  // 0x5F6x
      0,       0x5AB3,  0x5DA9,  0x5AB4,  0x5AB2,  0x5FA5,  0xC1A4,  0xCA27,  
      0x68E4,  0x6CE0,  0xDFC5,  0xA12C,  0xA23F,  0x226D,  0xA375,  0x4AB1,  // 0x5F7x
      0xA374,  0x4AB2,  0x242C,  0,       0x4DBE,  0xA658,  0xA657,  0x4DBD,  
      0x4DBB,  0x4DBC,  0xA656,  0xA8F6,  0xA8F5,  0x51A1,  0xAA3F,  0x51A4,  // 0x5F8x
      0x50FE,  0x51A6,  0x51A2,  0x51A3,  0x51A5,  0x2931,  0xB0F0,  0xB0F2,  
      0x55C1,  0x55C0,  0x55BF,  0xB0F1,  0xE4F6,  0,       0xB533,  0x5AB5,  // 0x5F9x
      0x5AB8,  0x5AB6,  0xE4F7,  0xB532,  0x5ABB,  0x3153,  0x5AB7,  0xB534,  
      0x5ABA,  0x5AB9,  0x3152,  0x3157,  0x374A,  0xBB5A,  0xBB59,  0xBBCB,  // 0x5FAx
      0x5FA8,  0x5FA6,  0x5FA7,  0xBB5B,  0x63F1,  0xC26A,  0x63F2,  0xC269,  
      0x3D34,  0x433F,  0xD040,  0xC6E3,  0xC6E4,  0x6CE2,  0xCA28,  0x6CE1,  // 0x5FBx
      0xCBF2,  0x68E5,  0xE4F8,  0xD722,  0xD721,  0x73DB,  0xDC69,  0xE54B,  
      0xE874,  0xE875,  0xDEAF,  0x45C0,  0x2136,  0x46D2,  0,       0xA2CD,  // 0x5FCx
      0x2271,  0xA15C,  0xA2CC,  0x22E6,  0x4AB4,  0x4AB6,  0xA5F8,  0xA242,  
      0xA378,  0xA377,  0xA376,  0xA3E6,  0xA241,  0xA240,  0x48A5,  0x4AB5,  // 0x5FDx
      0x4AB3,  0x48A4,  0xA3E7,  0xA3E9,  0xA5F7,  0x4DBF,  0xA659,  0xA5FB,  
      0x4DC0,  0xA37D,  0x2650,  0xA421,  0xA37E,  0xA65A,  0xA5F6,  0xA5F4,  // 0x5FEx
      0xA37A,  0xA8FE,  0x4ABA,  0x4AB8,  0xA5FC,  0xA379,  0xA37B,  0xA423,  
      0xA6A2,  0x4AB7,  0xA6A1,  0xA37C,  0xA427,  0x4DC2,  0xA5FD,  0xA424,  // 0x5FFx
      0x4AB9,  0xA6A3,  0xA422,  0xA425,  0xA5FA,  0x4DC1,  0xA5F5,  0x4DC3,  
} ;


static const unsigned short Uni2cnsP0Table_60 [] = {
      0xA426,  0,       0,       0,       0,       0,       0,       0xA8F8,  // 0x600x
      0xA9A2,  0xA66E,  0xA661,  0xA65F,  0xA66D,  0xA668,  0x51AB,  0x4DC4,  
      0xA669,  0xA66C,  0x51A7,  0xA66B,  0x4DC5,  0x4DCA,  0x4DC8,  0xA662,  // 0x601x
      0x2936,  0xA65D,  0xA664,  0x4DCF,  0xA66F,  0x51A8,  0xA665,  0x264F,  
      0x51A9,  0x4DCB,  0xA667,  0xACDA,  0xAA4E,  0x51AA,  0xA65C,  0x4DCC,  // 0x602x
      0x51AC,  0x4DCD,  0x4DC9,  0x4DCE,  0xA666,  0xA65B,  0xA66A,  0x4DC6,  
      0xA8F7,  0xACDB,  0xA65E,  0xA663,  0xA660,  0x4DC7,  0xA8FA,  0xAA40,  // 0x603x
      0x2945,  0xAA41,  0,       0,       0,       0xA9A1,  0,       0,       
      0xAA4B,  0xAF23,  0xAA4C,  0x51B2,  0xAA4F,  0xAA45,  0x51B1,  0xAA47,  // 0x604x
      0x293F,  0xAA48,  0xACE0,  0xB0F9,  0xAA4A,  0x51AD,  0xACD6,  0xB0F3,  
      0x55C5,  0xACD7,  0xACDD,  0xAA46,  0xAA42,  0x55C6,  0xB0FE,  0x293E,  // 0x605x
      0xAA50,  0x55C2,  0xAF21,  0xAA49,  0xACD4,  0xAE7E,  0xAA44,  0xAA4D,  
      0xACDF,  0xACE1,  0x51B0,  0x55C3,  0x51B6,  0x55C4,  0xAA51,  0xAF22,  // 0x606x
      0x51AF,  0x55C8,  0x51B5,  0x51B4,  0x51B3,  0x55C7,  0xAA52,  0x55C9,  
      0x51AE,  0x294B,  0xAA43,  0xB0FA,  0xB0F8,  0xB0FB,  0,       0,       // 0x607x
      0,       0,       0,       0,       0xACDC,  0,       0xB0F6,  0x5ABC,  
      0xAF26,  0xAF28,  0x2D25,  0xAF2A,  0x55CA,  0x55D0,  0xB537,  0xAF2E,  // 0x608x
      0xAF25,  0x5ABE,  0xB535,  0xB1A2,  0x55CF,  0x55CD,  0xAF30,  0x2D2D,  
      0xB536,  0x2D2C,  0xAF27,  0xB1A5,  0x55CE,  0xAF2B,  0x55D1,  0xAF2D,  // 0x609x
      0xB5E8,  0xB0F4,  0x55CC,  0xAF2C,  0xAF2F,  0xAF29,  0xB1A7,  0x55CB,  
      0x5ABF,  0xB5F1,  0xAF24,  0x5ABD,  0xB5F2,  0x316B,  0xB1A3,  0xB1A8,  // 0x60Ax
      0x5AC0,  0xB1A1,  0xB5EF,  0,       0,       0,       0xB1A6,  0,       
      0xB539,  0xB542,  0x5FAB,  0xBBD4,  0x5AC2,  0x5AC7,  0x5FAC,  0xB544,  // 0x60Bx
      0x5ACE,  0xBB5D,  0xB53A,  0x5AC6,  0x5AC9,  0x5AC4,  0xB538,  0xB546,  
      0xB549,  0xBB6C,  0x3168,  0xB547,  0xBB61,  0x5AC5,  0x5ACC,  0x5AD0,  // 0x60Cx
      0xB541,  0xBB5C,  0xB545,  0x5AC1,  0xBB5E,  0xB548,  0xBB60,  0xB53D,  
      0xB5EA,  0x5FA9,  0xBBD6,  0xB53B,  0xB53C,  0x5ACB,  0xBBD5,  0xB5EE,  // 0x60Dx
      0x5ACA,  0xB53F,  0x5ACF,  0xB543,  0x5AC8,  0xB540,  0xB5F9,  0x5ACD,  
      0x5FAD,  0x5FAA,  0xBB5F,  0xBBD8,  0xB53E,  0xBBD9,  0x5AC3,  0xB5F6,  // 0x60Ex
      0xB5F8,  0xBBDA,  0xBBCD,  0,       0,       0,       0xB5F4,  0,       
      0x5FB2,  0x5FB6,  0xBB63,  0x63F7,  0x5FB4,  0xBB67,  0x5FB8,  0xC26B,  // 0x60Fx
      0xBB69,  0x63F9,  0x5FB0,  0x5FB3,  0xBB6A,  0xBBDE,  0xBB6B,  0xBB71,  
} ;


static const unsigned short Uni2cnsP0Table_61 [] = {
      0x5FBA,  0x63FA,  0x3D3D,  0xBB6D,  0xBB72,  0xBB66,  0x64A6,  0xBBCF,  // 0x610x
      0x63FB,  0x5FB9,  0xBB64,  0xBB73,  0xBBD1,  0x64A5,  0x5FB7,  0x63F4,  
      0xBB70,  0xBBDD,  0x5FBB,  0xBB68,  0xBB62,  0x5FB1,  0xBB65,  0x3FB0,  // 0x611x
      0xBB6E,  0xC1AB,  0x63F3,  0x63F8,  0x5FAE,  0xBB6F,  0xBBE1,  0x63F6,  
      0xBBE2,  0xBBE3,  0xBBD0,  0x5FAF,  0,       0xE4F9,  0,       0x64A4,  // 0x612x
      0xCA2A,  0xC276,  0xC1A9,  0xC26E,  0xCA29,  0x3D39,  0xC272,  0xC274,  
      0xC1A7,  0xC1AC,  0xC271,  0xC6EF,  0x64A3,  0x3D38,  0xC270,  0x64A7,  // 0x613x
      0xC6EE,  0xD264,  0xC1A8,  0xCA39,  0xC6EC,  0xC1AE,  0x64A2,  0x68E7,  
      0xC277,  0xCA2B,  0xC6ED,  0xC1AA,  0x63FE,  0xC26F,  0xC273,  0x68E6,  // 0x614x
      0x63F5,  0xC26C,  0xC26D,  0x68E8,  0x63FD,  0x64A1,  0x63FC,  0xC275,  
      0xE4FA,  0,       0xCA2F,  0xCA30,  0xCA35,  0x6CE7,  0xCA3C,  0xCBF3,  // 0x615x
      0x68EE,  0xCBFE,  0x68ED,  0xCA37,  0xCBF4,  0x6CE6,  0xCA2C,  0x68EC,  
      0xC6F1,  0xCA3B,  0x68EA,  0x68EB,  0xCBFC,  0xCA38,  0xD051,  0x6CE4,  // 0x616x
      0x5FB5,  0xC6F2,  0xCA3A,  0x6CEB,  0xCA32,  0x496F,  0x6CE5,  0xC6EA,  
      0x6CEA,  0xCA2D,  0xCA31,  0xCA2E,  0xCA34,  0x68EF,  0x6CE3,  0x68E9,  // 0x617x
      0xCCA1,  0xD043,  0xCA36,  0xC6E8,  0x6CE9,  0xC6F3,  0x6CEC,  0xA2F1,  
      0xCA33,  0xC6EB,  0x6CE8,  0xD042,  0x4DAA,  0xCCA3,  0xC6F4,  0xCCA4,  // 0x618x
      0xCBF7,  0xD047,  0x70D7,  0xD041,  0xD72E,  0xD050,  0x6CF0,  0xCBFA,  
      0x6CEE,  0x70D5,  0xD04D,  0xD049,  0x6CF4,  0xCBF6,  0xD725,  0xD0E8,  // 0x619x
      0xCCA8,  0xD0E7,  0x6CF2,  0xD048,  0xCCA9,  0xD723,  0xCCA5,  0xD04C,  
      0x503B,  0xD04F,  0xD046,  0xCBF9,  0x6CF3,  0x5037,  0xCBF5,  0x6CED,  // 0x61Ax
      0xD724,  0x70D6,  0xD04E,  0x6CEF,  0x6CF1,  0xD04B,  0x6CF5,  0xD04A,  
      0xD045,  0xD044,  0x70D4,  0xD052,  0xD727,  0xDC6B,  0x70D9,  0xD0E1,  // 0x61Bx
      0xD72D,  0xD0E3,  0xD72B,  0xD0EA,  0xDC6C,  0xD0E4,  0x70DA,  0xD72C,  
      0xD0E6,  0xD729,  0x73DD,  0xDC6A,  0xD0EC,  0xD726,  0xD728,  0x73DE,  // 0x61Cx
      0x70DC,  0x73DC,  0x70DB,  0x73E0,  0xD72A,  0x70D8,  0xD0E2,  0xD0E5,  
      0xD0EB,  0,       0,       0xE6F9,  0,       0x5B2B,  0xE15B,  0x5633,  // 0x61Dx
      0xE153,  0xD4E1,  0xD4DF,  0xD4DC,  0xD4DE,  0xD4DD,  0xDC72,  0xE154,  
      0xDC6E,  0x5632,  0xD4DB,  0x76C2,  0xDC70,  0xDC6F,  0x73DF,  0xDC6D,  // 0x61Ex
      0xDC71,  0xE15C,  0xE158,  0xE15A,  0x5F60,  0xE155,  0xE156,  0x5F61,  
      0xE159,  0xE157,  0x78B4,  0xD7E5,  0,       0x78B7,  0x78B6,  0x78B5,  // 0x61Fx
      0x79EC,  0xE876,  0x79ED,  0xE54C,  0x7AEA,  0xEB5A,  0x7AEB,  0x7BE0,  
} ;


static const unsigned short Uni2cnsP0Table_62 [] = {
      0x7CB6,  0xEF28,  0xDFC6,  0xEF29,  0xEF2A,  0xE1BE,  0,       0xF22A,  // 0x620x
      0x45C1,  0xA15D,  0x46D3,  0,       0x48A7,  0x48A8,  0x48A6,  0xA3EB,  
      0x48A9,  0x4ABC,  0x4ABB,  0xA6A5,  0xA670,  0x4DD1,  0x4DD0,  0,       // 0x621x
      0xACE3,  0xAF31,  0x5AD1,  0x5AD2,  0x316E,  0x3170,  0xBBE4,  0x5FBC,  
      0xC278,  0x64A8,  0x64A9,  0xC27A,  0xC27C,  0xC27B,  0x3D43,  0xCA3E,  // 0x622x
      0xC6F6,  0xCA3D,  0x68F0,  0xCA3F,  0xC6F5,  0xD053,  0x6CF6,  0xCCAC,  
      0x70DD,  0xD0ED,  0x73E1,  0x76C3,  0x73E2,  0xDFC8,  0x45C2,  0xA1E5,  // 0x623x
      0xA1E6,  0xA2CE,  0xA428,  0xA6A8,  0xA6A9,  0xA671,  0x4DD3,  0x4DD2,  
      0x4DD4,  0x51B7,  0xAA53,  0xAA54,  0,       0xB1A9,  0xAF32,  0x55D2,  // 0x624x
      0x5AD3,  0x5FBD,  0xBB74,  0x45C3,  0x2137,  0x44DF,  0x45C4,  0xA2D0,  
      0xA15E,  0x46D7,  0x46D6,  0x46D4,  0x46D5,  0,       0,       0xA3EF,  // 0x625x
      0x48AC,  0xA249,  0xA24B,  0x48AB,  0xA243,  0xA3EC,  0xA244,  0xA3ED,  
      0xA24A,  0xA246,  0xA248,  0x48AA,  0xA245,  0xA24C,  0xA247,  0xA3EE,  // 0x626x
      0xA2D1,  0,       0,       0,       0,       0x4AC3,  0x4ACC,  0x4ACA,  
      0xA432,  0xA42F,  0xA437,  0x4AC8,  0xA438,  0xA6B9,  0x4AC1,  0xA435,  // 0x627x
      0xA6AE,  0x4AC7,  0xA431,  0xA430,  0x4AC5,  0xA436,  0x4AC6,  0x4DD5,  
      0x4AC0,  0xA433,  0xA6AA,  0xA429,  0x4ABD,  0xA6B7,  0x4AD0,  0xA42E,  // 0x628x
      0xA434,  0x4AC2,  0x4AC4,  0xA6AF,  0xA42A,  0xA6B6,  0xA42B,  0xA42C,  
      0x2439,  0x4ACF,  0x4AC9,  0x4ACE,  0xA42D,  0x4ACD,  0x4ABF,  0x4ABE,  // 0x629x
      0x4ACB,  0xA6B5,  0x243C,  0xA6B3,  0xA6B4,  0xA6B8,  0xA6B1,  0,       
      0,       0,       0,       0xE4FB,  0xA4B9,  0xA6B2,  0xA9B1,  0xA9AA,  // 0x62Ax
      0x4DE3,  0xA67D,  0xA676,  0x4DDE,  0x4DF1,  0xA672,  0xA679,  0xA67B,  
      0xA67E,  0x4DEC,  0xA9A6,  0xA67A,  0xA673,  0x4DEA,  0xA677,  0xA9A8,  // 0x62Bx
      0xA721,  0x4DDB,  0xA9A5,  0xA67C,  0x4DE5,  0x4DE4,  0xA675,  0x4DD9,  
      0xA9B4,  0xA9B2,  0x4DDA,  0xA7B0,  0x4DD8,  0xA9B3,  0x4DF0,  0x4DE8,  // 0x62Cx
      0x4DE2,  0x4DD6,  0xA678,  0x4DE1,  0x4DD7,  0x4DE9,  0x4DF2,  0xAA55,  
      0x4DE6,  0xA674,  0x4DDC,  0x4DDF,  0x4DE0,  0xA9AE,  0x4DEE,  0x4DEF,  // 0x62Dx
      0x4DED,  0x4DE7,  0x4DEB,  0x4DDD,  0x51B8,  0xA9B0,  0xA9B7,  0xA9B5,  
      0xA9B6,  0xA9AF,  0,       0,       0xA9A9,  0,       0,       0,       // 0x62Ex
      0,       0,       0xACED,  0xAA5B,  0x51C4,  0x51BC,  0x51BE,  0x51C3,  
      0xAA67,  0x51C1,  0xAF33,  0x55D3,  0x51C6,  0xAA58,  0xAA60,  0x51C2,  // 0x62Fx
      0xAA5F,  0xAA5C,  0xAA64,  0xAA66,  0x51BB,  0x51BF,  0x51C5,  0x55D5,  
} ;


static const unsigned short Uni2cnsP0Table_63 [] = {
      0xAA61,  0x51BD,  0x51C8,  0xAA5A,  0xACEF,  0xACF0,  0x29C5,  0x51C0,  // 0x630x
      0x55D4,  0x51BA,  0x2959,  0xAA57,  0xAA5E,  0xAA56,  0xAA59,  0xAA5D,  
      0xAF34,  0x51C7,  0x2951,  0xAA62,  0xAA63,  0xAA65,  0x51B9,  0xACEC,  // 0x631x
      0,       0xB1B2,  0,       0xB1B3,  0,       0,       0,       0xACEB,  
      0,       0xACEE,  0,       0x295B,  0,       0,       0,       0,       // 0x632x
      0x55E3,  0xAF40,  0x55E1,  0x55E2,  0xAF36,  0xAF46,  0xB1AC,  0x55D8,  
      0xB1AF,  0xB1B5,  0xB54A,  0xAF48,  0xAF42,  0xB1B8,  0xAF39,  0xB1B7,  // 0x633x
      0xAF4B,  0xAF3C,  0x55DE,  0xB561,  0xAF3F,  0x55E0,  0x55D7,  0xB1BC,  
      0xAF4D,  0xAF41,  0x55DA,  0xAF3A,  0xAF37,  0xAF38,  0x55DB,  0xAF47,  // 0x634x
      0xAF4E,  0x55DD,  0xAF3E,  0xAF3D,  0x55E5,  0x55E4,  0x55D6,  0x55DC,  
      0x55DF,  0xAF4A,  0xB1AE,  0xB1B9,  0xAF44,  0x55D9,  0xAF35,  0xAF4C,  // 0x635x
      0xAF43,  0xAF45,  0xAF49,  0xB1B0,  0xB1BB,  0xB1B6,  0,       0,       
      0xE4FC,  0,       0,       0,       0xE4FD,  0xB54B,  0xB6B1,  0x5ADB,  // 0x636x
      0x5AEF,  0x5AEE,  0xB6A7,  0x5AE3,  0xB6A9,  0xB55D,  0xB559,  0xB556,  
      0xB568,  0x5ADE,  0x5AD6,  0xB6A6,  0xB6B2,  0xB55B,  0x5FCD,  0x5ADA,  // 0x637x
      0xB563,  0xB6A2,  0x5AF0,  0x5AED,  0xB55F,  0xB54E,  0xB5FC,  0xB6AB,  
      0x5AEC,  0xB565,  0xB54D,  0x5AE1,  0x5AE5,  0xB564,  0xB6A3,  0xB557,  // 0x638x
      0x5AE6,  0x5AE0,  0xB54C,  0xB5FD,  0x5FBF,  0xB567,  0xB555,  0x5AEB,  
      0xB558,  0xB566,  0x5AEA,  0xB6A4,  0xBB75,  0x3177,  0x5AD7,  0xB553,  // 0x639x
      0x5ADC,  0x5AE7,  0x3178,  0x5AE2,  0xB55C,  0xB552,  0xB550,  0xB562,  
      0x5AD4,  0x5AE8,  0x5AD8,  0x5FBE,  0xB560,  0x5AD9,  0x3223,  0x5AD5,  // 0x63Ax
      0x5AE4,  0x5ADF,  0x5ADD,  0xB554,  0x5AE9,  0xB551,  0xB55E,  0xB55A,  
      0xBB77,  0xBB76,  0xB6AD,  0,       0,       0,       0xE4FE,  0,       // 0x63Bx
      0,       0,       0xB6AE,  0,       0,       0xB54F,  0xBC29,  0xBBF1,  
      0x5FC1,  0xBBF0,  0xBC2F,  0xBB7C,  0xBC2C,  0xC27D,  0x5FC4,  0xBC30,  // 0x63Cx
      0xBC33,  0x5FC3,  0xBC21,  0xBC32,  0xBC31,  0x5FC5,  0xBB78,  0x5FC0,  
      0x5FC8,  0xBBF3,  0x5FC6,  0xBC2E,  0x3771,  0xBC24,  0x5FCA,  0xBC35,  // 0x63Dx
      0xBC2D,  0xBC36,  0x5FD2,  0x5FD0,  0xBC2B,  0xBC2A,  0xBBE7,  0xBC28,  
      0xBC22,  0x5FC9,  0xBBE6,  0x5FC7,  0xAF3B,  0xBB79,  0xBBE8,  0xC33D,  // 0x63Ex
      0xBB7A,  0x5FC2,  0x5FCF,  0xC321,  0x3760,  0x5FCB,  0x5FCC,  0xBB7B,  
      0xBC34,  0xC27E,  0xBC25,  0xBB7E,  0x5FCE,  0xBC26,  0xBC23,  0xBBF2,  // 0x63Fx
      0xBBED,  0x5FD3,  0x376F,  0,       0,       0,       0xBBEF,  0,       
} ;


static const unsigned short Uni2cnsP0Table_64 [] = {
      0,       0,       0,       0xE5A1,  0,       0,       0x64B8,  0xC1C9,  // 0x640x
      0xC1B2,  0xC324,  0xC337,  0xC33C,  0xC330,  0x64B4,  0xC341,  0x64B1,  
      0xC322,  0xC1BA,  0xC323,  0x64AA,  0x64B3,  0xC32A,  0x64B6,  0x64B7,  // 0x641x
      0xC32B,  0xC1B8,  0xC338,  0xC33E,  0x64B2,  0xC1BE,  0x64AC,  0xC329,  
      0xC325,  0xC340,  0xC32E,  0xC32F,  0xC326,  0xC33A,  0xC331,  0xC33B,  // 0x642x
      0xC333,  0xC1BD,  0x64AD,  0xCA40,  0x64B0,  0x64AE,  0xC33F,  0xC336,  
      0xC332,  0xC1B6,  0xC1B3,  0xC327,  0x68FA,  0xC335,  0x64B5,  0xC32D,  // 0x643x
      0xC1B4,  0xC32C,  0xC1C8,  0xC7A5,  0xC1C2,  0x64AF,  0x64AB,  0xCA55,  
      0xC339,  0xC334,  0,       0xC328,  0,       0,       0xC1C4,  0xC1C5,  // 0x644x
      0,       0xE6F6,  0,       0xCA50,  0xC6F8,  0xCA41,  0xCA4C,  0xC7A8,  
      0xCA53,  0x68F8,  0x5FD1,  0xCA51,  0x68F3,  0xC6FE,  0xC7A4,  0xC6FA,  // 0x645x
      0x68F2,  0xCA58,  0x435D,  0xCA42,  0xCA4F,  0xCA43,  0xCA4E,  0x68F6,  
      0xCA52,  0xBC27,  0xC7A1,  0x435E,  0xC7AA,  0xCA59,  0xCA4A,  0x68F9,  // 0x646x
      0xD061,  0x6CF7,  0xC7A3,  0xCA57,  0xCA56,  0x68FB,  0xD054,  0x6CF8,  
      0xD055,  0xC7A2,  0xCA46,  0xCA47,  0xCA44,  0xCA49,  0xCA45,  0xCA5A,  // 0x647x
      0x68F5,  0x6CF9,  0x68F7,  0x68FC,  0xC6FB,  0xCA48,  0xC7A9,  0xCA54,  
      0xCCAD,  0xC7A6,  0xCA4D,  0xCCB5,  0,       0xD058,  0xCCB8,  0x68F1,  // 0x648x
      0x6CFC,  0xD735,  0xD05D,  0xD05C,  0xD05E,  0xCCB0,  0xCCAF,  0xD05B,  
      0x6CFD,  0xCCBB,  0x6DA5,  0x6DA2,  0xCCB1,  0x6DA3,  0xD056,  0xD059,  // 0x649x
      0xD063,  0x6DAB,  0x6DA9,  0xCCAE,  0xD05A,  0xBB7D,  0x6CFA,  0xD060,  
      0xD057,  0xCCBE,  0x6DAC,  0xD05F,  0x68F4,  0x6DA1,  0xCA4B,  0xCCBF,  // 0x64Ax
      0xCCB4,  0x6DA4,  0xCCBD,  0x6DA8,  0x6DAA,  0x6DA7,  0x6DA6,  0xCCBA,  
      0x6CFE,  0xD062,  0x6CFB,  0x6DAD,  0xCCB9,  0,       0xE5A2,  0,       // 0x64Bx
      0,       0xCCB7,  0,       0x70E1,  0x70E2,  0xD734,  0x70EB,  0x70E8,  
      0xD0F0,  0x70DF,  0x70E6,  0xD736,  0x70E4,  0x70DE,  0xCCB2,  0x70E5,  // 0x64Cx
      0xD0F7,  0xD733,  0x73E4,  0x70E0,  0x54DE,  0x70E7,  0x73E3,  0xD732,  
      0xD731,  0xD0F6,  0x70E9,  0xD0EF,  0x70EA,  0xD0F9,  0xD730,  0xD72F,  // 0x64Dx
      0x73E5,  0xD739,  0x70E3,  0xD737,  0xD0F5,  0,       0,       0xD4E4,  
      0x73E6,  0xD4E7,  0x73EB,  0xDC75,  0xDC77,  0xD7EB,  0x73E8,  0xD7ED,  // 0x64Ex
      0xDC78,  0xDC74,  0xD7EC,  0xDC76,  0x73E9,  0x73EC,  0xD4E9,  0xDC73,  
      0x73E7,  0x73EA,  0x76C5,  0xD738,  0x76C4,  0xBFE2,  0xD7EA,  0x76CA,  // 0x64Fx
      0xE160,  0xD7F0,  0x76C8,  0x76C9,  0xE163,  0xE15F,  0x76C6,  0xE15D,  
} ;


static const unsigned short Uni2cnsP0Table_65 [] = {
      0x78B8,  0xE161,  0x5B36,  0xE162,  0xE15E,  0xD7EE,  0x76C7,  0xE54D,  // 0x650x
      0xDABB,  0xE550,  0xDABC,  0xDABA,  0xE551,  0xE54F,  0xE552,  0x78B9,  
      0xE54E,  0xDEB1,  0,       0xE87A,  0x79EF,  0xE879,  0xE878,  0xE877,  // 0x651x
      0x79EE,  0x79F0,  0xE5A3,  0xEB5B,  0x7AED,  0x7AEC,  0xDFCA,  0xDFCB,  
      0xED4F,  0xED4E,  0xED51,  0x7CB7,  0x7BE1,  0xEF2C,  0xED50,  0xDFC9,  // 0x652x
      0xE0B2,  0xEF2B,  0x7CB9,  0x7CB8,  0x7CDF,  0xF037,  0xF07D,  0x45C5,  
      0xA36C,  0xACF2,  0xBC37,  0xD73A,  0xA1E7,  0xA1E8,  0x48AD,  0xA24D,  // 0x653x
      0x4AD3,  0x4AD1,  0x243F,  0x4AD2,  0x243E,  0xA722,  0x4DF3,  0x51C9,  
      0xACF4,  0xAA68,  0xACF6,  0xAA69,  0xACF3,  0x51CA,  0xAF50,  0x2D43,  // 0x654x
      0x55E6,  0x55E7,  0xAF4F,  0xB1BD,  0x2D44,  0xB6B7,  0xB6B6,  0x5AF7,  
      0x322B,  0x5AF3,  0x322F,  0xB569,  0x5AFA,  0x5AF9,  0x5AF2,  0x5AF5,  // 0x655x
      0x5AF8,  0x5AF4,  0xB6B4,  0,       0xBC3B,  0x5AF1,  0x5FD4,  0xBBF4,  
      0xBBF5,  0xBBF6,  0x5FD6,  0x5FD7,  0xBC3A,  0xBC3D,  0x5FD5,  0xBC38,  // 0x656x
      0xBC3C,  0,       0xBC39,  0xC1CB,  0x64B9,  0xC1CE,  0x3D5D,  0xC342,  
      0xC1CD,  0xC7B0,  0x68FD,  0xCA5B,  0x70EC,  0x6DAE,  0xD064,  0x6DAF,  // 0x657x
      0x6DB0,  0xD066,  0xD065,  0xD067,  0xD73C,  0,       0,       0xD73B,  
      0xDC7A,  0xDC79,  0x73ED,  0x73EE,  0xE553,  0xDCC1,  0,       0x45C6,  // 0x658x
      0xA5D8,  0xA9B9,  0x2D47,  0xB1C0,  0xBC3E,  0xB6B8,  0xB6B9,  0,       
      0x5FD9,  0x5FD8,  0xC343,  0,       0xE164,  0x7AEE,  0xEF2D,  0x45C7,  // 0x659x
      0x2441,  0x55E8,  0xB1C2,  0x5AFC,  0x5AFB,  0xBC3F,  0xBC40,  0x64BA,  
      0xCA5C,  0x68FE,  0xD73D,  0x563F,  0x45C8,  0x46D8,  0xA9BB,  0x4DF4,  // 0x65Ax
      0xA723,  0,       0xAA6A,  0x51CB,  0x5AFD,  0xB6BA,  0xBC41,  0x5FDA,  
      0x64BB,  0x3D63,  0xD068,  0xD069,  0x504E,  0xD4EB,  0xDC7B,  0x76CB,  // 0x65Bx
      0xF07E,  0x45C9,  0xA9BC,  0xA724,  0x4DF5,  0x51CC,  0xACF7,  0xAA6B,  
      0,       0x55E9,  0xAF54,  0xAF52,  0xAF53,  0x55EA,  0xAF51,  0xB6BC,  // 0x65Cx
      0x3234,  0xB6BF,  0xB6BD,  0x5BA1,  0x5BA2,  0xB56A,  0x5BA3,  0x5AFE,  
      0xBC42,  0xBBF9,  0xBC43,  0xC344,  0x3D64,  0,       0x69A2,  0x69A1,  // 0x65Dx
      0x504F,  0xD4E4,  0xDC7C,  0xE165,  0xDABF,  0xE555,  0xE554,  0xE87B,  
      0xA1E9,  0xA13E,  0x51CD,  0xB6C1,  0xC1D0,  0x45CA,  0x46D9,  0xA2D1,  // 0x65Ex
      0x48AF,  0x48AE,  0xA3F3,  0xA3F2,  0x48B0,  0x48B1,  0xA24F,  0xA24E,  
      0xA439,  0x4AD4,  0xA43C,  0xA43B,  0xA43A,  0xA43D,  0xA6BD,  0,       // 0x65Fx
      0,       0x2662,  0x4DF6,  0xA72A,  0xA726,  0xA72F,  0xA9C3,  0xA9BE,  
} ;


static const unsigned short Uni2cnsP0Table_66 [] = {
      0x4DFD,  0xA9C2,  0x4DFB,  0xA72B,  0xA727,  0xA72E,  0x4DFA,  0x4EA3,  // 0x660x
      0xA729,  0xA725,  0x4EA2,  0xA72C,  0x4DF9,  0xA72D,  0x4DFC,  0x4DFE,  
      0xA731,  0xA730,  0xA728,  0x4DF8,  0x4DF7,  0x4EA1,  0x2661,  0xA9C0,  // 0x661x
      0xA9C1,  0xA7BE,  0xACFE,  0xACFA,  0xAA70,  0xAA76,  0xADA3,  0x51D3,  
      0x51D0,  0xAA6D,  0xAA72,  0xACFC,  0x51D6,  0x51CE,  0xAA71,  0x51D1,  // 0x662x
      0x51D4,  0xACF9,  0x2967,  0xAA74,  0xACFD,  0x51CF,  0xAA79,  0x51D2,  
      0xADA1,  0x51D5,  0xAA6E,  0xAA73,  0xAA77,  0xAA6F,  0xAA6C,  0xADA4,  // 0x663x
      0xADA5,  0xAA78,  0xAA75,  0xADA2,  0xACB7,  0,       0,       0,       
      0xB1C6,  0x55F2,  0x55EB,  0x55EE,  0xB1CC,  0x55F1,  0xB1C4,  0xAF57,  // 0x664x
      0xB1C9,  0x55EC,  0xAF55,  0xB1C8,  0x55F0,  0xB1CD,  0xB1C5,  0x55ED,  
      0xB1C3,  0xAF58,  0x55EF,  0,       0,       0,       0,       0xB6C2,  // 0x665x
      0x3239,  0xB56E,  0x5BA5,  0xB56D,  0xB56F,  0x5BA4,  0x5BA9,  0xAF56,  
      0xB1CB,  0xB56C,  0xB570,  0xB6C4,  0x5BA6,  0xB56B,  0x5BA8,  0xB6C5,  // 0x666x
      0x5BA7,  0xBCA6,  0xBC4A,  0xBBFD,  0xBC45,  0xBCA5,  0x5FDB,  0x5FDF,  
      0x5FDC,  0xBC48,  0xBC4B,  0xBCA3,  0x5FDD,  0x3824,  0x5FDE,  0x5FE3,  // 0x667x
      0xC34D,  0xBC49,  0x5FE1,  0xBC46,  0xBC44,  0xBBFC,  0x5FE2,  0xBBFE,  
      0xBC47,  0xBCA4,  0,       0,       0x64C1,  0x3D69,  0xC345,  0x64BE,  // 0x668x
      0x64BF,  0x64BD,  0xC34A,  0xC349,  0xC346,  0x64C3,  0xC1DB,  0xC1D6,  
      0xC348,  0x5FE0,  0xC1D9,  0xC1D1,  0xC34C,  0xC347,  0x64C0,  0x64BC,  // 0x669x
      0x64C2,  0xC34B,  0xC7B4,  0x436B,  0xC7B5,  0x69A5,  0x436F,  0xCA5F,  
      0xCA5E,  0xCA5D,  0x69A3,  0x436D,  0xC7B9,  0xC7B3,  0xC7B7,  0,       // 0x66Ax
      0x69A4,  0xD06C,  0xD06F,  0x6DB2,  0xCCC4,  0xCCC6,  0x6DB1,  0xD070,  
      0xD06B,  0x6DB4,  0xD06D,  0xCCC1,  0x6DB3,  0xD06A,  0xCCC0,  0xD06E,  // 0x66Bx
      0x70F2,  0x70EF,  0xD746,  0xD745,  0xCCC3,  0xD744,  0xD73F,  0xD0FD,  
      0xD740,  0xD1A3,  0x5050,  0xD0FA,  0x70F0,  0xD0FE,  0x70ED,  0x70F1,  // 0x66Cx
      0xD73E,  0x70EE,  0xD741,  0xD742,  0xD747,  0xD1A2,  0xD4F1,  0xD743,  
      0xD4EF,  0xD4F0,  0xDC7D,  0x5641,  0xD4EC,  0xD4ED,  0x73F0,  0xD4F2,  // 0x66Dx
      0xE168,  0x73EF,  0xE166,  0xE167,  0x76CC,  0x78BB,  0xE556,  0xDAC3,  
      0x78BA,  0xDAC2,  0xE5A6,  0xE87D,  0xE87E,  0xDCC2,  0x79F1,  0xDCC3,  // 0x66Ex
      0xE87C,  0x7AEF,  0x6A4C,  0xEF2E,  0x7CBA,  0xF038,  0xF039,  0xE1BF,  
      0x45CB,  0x217C,  0x48B2,  0x48B3,  0x4AD5,  0xA6C1,  0xA732,  0x51D7,  // 0x66Fx
      0x55F3,  0x5BAA,  0xB2F3,  0,       0x59B7,  0,       0x5FE4,  0x5FE5,  
} ;


static const unsigned short Uni2cnsP0Table_67 [] = {
      0x5EB2,  0xBC4C,  0xE5A7,  0x64C4,  0xCA61,  0xCA60,  0xD1A4,  0xD3C7,  // 0x670x
      0x45CC,  0x48B4,  0xA733,  0x4EA5,  0xA9C5,  0x4EA4,  0xADA7,  0xAA7A,  
      0xAA7B,  0xE6B2,  0xAF59,  0xAF5A,  0x55F4,  0x55F5,  0xB6C8,  0x55F6,  // 0x671x
      0xB571,  0xB6C7,  0xB6C6,  0x5BAC,  0x3829,  0x5FE7,  0xBCA9,  0x5FE6,  
      0xC34E,  0xC641,  0xCA62,  0xD748,  0xD1A6,  0xE6B3,  0x76CD,  0x79F2,  // 0x672x
      0x45CD,  0,       0x46DC,  0x46DD,  0x46DB,  0x46DE,  0x46DA,  0xA2D2,  
      0,       0x48B7,  0xA3F7,  0xA257,  0x48B6,  0x48B8,  0xA3F8,  0xA3F5,  // 0x673x
      0xA252,  0xA251,  0xA254,  0xA253,  0xA256,  0x48B5,  0xA250,  0xA255,  
      0xA2D8,  0,       0xA2D7,  0,       0xA6C8,  0xA43E,  0x4ADF,  0xA43F,  // 0x674x
      0xA443,  0x4ADE,  0xA6C9,  0xA447,  0xA442,  0xA445,  0x4AD7,  0x4AD8,  
      0x4AD9,  0x4ADA,  0xA6C5,  0x4AE1,  0xA6C4,  0xA441,  0x4ADC,  0x4AE2,  // 0x675x
      0xA6C7,  0xA440,  0xA446,  0xA6C2,  0x4ADB,  0xA444,  0x4ADD,  0x4AD6,  
      0x4AE0,  0xA6CA,  0xA4A2,  0,       0,       0x2446,  0xA4D3,  0,       // 0x676x
      0,       0,       0x4EBA,  0xA9C7,  0xA735,  0x4EA6,  0x2669,  0x4EB0,  
      0x4EB1,  0x4EA9,  0x4EBB,  0x4EAB,  0xA73D,  0x4EB6,  0xA738,  0x4EAC,  // 0x677x
      0xA747,  0xA748,  0xA740,  0xA739,  0x4EB9,  0xA745,  0x4EB4,  0x4EB2,  
      0xA9D2,  0xA746,  0xA9C9,  0xA744,  0xA73C,  0xA734,  0xA73B,  0x4EAD,  // 0x678x
      0x2665,  0x4EB3,  0xA9CA,  0x4EA7,  0xA73F,  0xA73E,  0xA736,  0xA9CF,  
      0x4EB5,  0xA742,  0xA737,  0x4EB8,  0xA749,  0x4EA8,  0xA9C8,  0x4EAF,  // 0x679x
      0xA73A,  0xA743,  0x4EB7,  0x2667,  0x4EAA,  0x4EAE,  0x266A,  0xA741,  
      0,       0xA7CE,  0xA9CE,  0xA9CC,  0xE5A8,  0,       0xA7D0,  0,       // 0x67Ax
      0,       0,       0,       0,       0xE5A9,  0,       0xAB3D,  0x51DF,  
      0x51EC,  0xADB6,  0xAB38,  0xAB2E,  0x51E5,  0xAB2C,  0x51DE,  0xAB27,  // 0x67Bx
      0x51E8,  0xAB34,  0xAB21,  0xAB23,  0xADAE,  0x2D59,  0x296E,  0xADB0,  
      0xAB26,  0xAA7C,  0xAB33,  0xAB43,  0x51E3,  0xAB28,  0xAB3A,  0xADAD,  // 0x67Cx
      0xAA7E,  0xAB41,  0xAB42,  0xAB45,  0xAB3C,  0xAB2D,  0xAB35,  0x51E9,  
      0x51DC,  0x51E4,  0x51F0,  0x51D9,  0x51DB,  0xADB1,  0xADAB,  0xADBA,  // 0x67Dx
      0xAB25,  0x51ED,  0x51E6,  0xAB3F,  0xAB22,  0x51EF,  0x51EA,  0xAB2B,  
      0x296D,  0x2D4E,  0x51EE,  0xAB32,  0xAB2A,  0x51E7,  0xAB3E,  0xAB36,  // 0x67Ex
      0xADAA,  0x51E1,  0xAB44,  0xAB29,  0x51DD,  0xAB3B,  0xAB31,  0x51E2,  
      0xAB37,  0x51DA,  0xAA7D,  0x51EB,  0x56A7,  0x51E0,  0xAB30,  0xAB2F,  // 0x67Fx
      0xAB24,  0xA9D1,  0xAB40,  0xADB4,  0xAB39,  0,       0xADB2,  0x51D8,  
} ;


static const unsigned short Uni2cnsP0Table_68 [] = {
      0xADB9,  0xADB7,  0,       0,       0xB172,  0xADB8,  0xE5AB,  0,       // 0x680x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xE5AA,  0xABC8,  0xAF6E,  0x56AE,  0xAF6F,  0xB1DD,  0xAF63,  0x56A3,  // 0x681x
      0x56AF,  0xB1D7,  0xAF5C,  0xB1D3,  0xAF65,  0xAF6D,  0xB1DB,  0xAF5B,  
      0xAF76,  0x55F7,  0xB1DE,  0xB1E4,  0xB1D0,  0xAF75,  0xAF70,  0xB1DF,  // 0x682x
      0xAF71,  0x56A1,  0x56AC,  0xAF67,  0xB1D6,  0xAF68,  0xAF72,  0xAF69,  
      0xB1E3,  0xAF64,  0xAF5E,  0xAF5F,  0xAF6C,  0xAF66,  0xB1D4,  0xB1CF,  // 0x683x
      0x55F8,  0x55FC,  0xAF74,  0xAF60,  0x56AA,  0x56A6,  0xB1DA,  0x2D55,  
      0x56A9,  0x56B0,  0x55FD,  0x56AB,  0xAF6B,  0x56AD,  0x55FA,  0xB1D9,  // 0x684x
      0x55F9,  0xAF5D,  0x2D4F,  0xAF61,  0x56A4,  0xAF73,  0xAF6A,  0xAF62,  
      0x56A8,  0x56A5,  0xADAF,  0x55FB,  0x55FE,  0xB1E2,  0xB1D8,  0xB0A4,  // 0x685x
      0xB1E1,  0xB1E0,  0xE5AD,  0,       0,       0,       0xE5AC,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x686x
      0,       0,       0,       0xB628,  0xB6D5,  0xB576,  0xB577,  0xB57B,  
      0xB6E0,  0xB62C,  0xB629,  0xB6CE,  0xB622,  0xB621,  0x5BB3,  0xB625,  // 0x687x
      0xB634,  0xB572,  0xB6DB,  0xB635,  0xB627,  0xB639,  0xB62D,  0x5BB2,  
      0xB62B,  0x5BAD,  0x5BC2,  0x5BB8,  0xB6D7,  0x5BBC,  0x5BBB,  0xB573,  // 0x688x
      0x323F,  0xB632,  0xB638,  0xB630,  0xB637,  0,       0xB6D1,  0xB624,  
      0xB574,  0xB636,  0xB626,  0x5BB0,  0x5BBD,  0xB6DA,  0xB62F,  0x5BB6,  // 0x689x
      0xB6CD,  0xB6DC,  0xB6D0,  0xB62E,  0xB575,  0x5BBE,  0xB6CB,  0x5BC0,  
      0xB631,  0x5BC1,  0x5BAF,  0xB57C,  0xB633,  0xB6D4,  0xB4F8,  0x5BB5,  // 0x68Ax
      0x5BBF,  0xB57E,  0xB62A,  0xB579,  0xB57D,  0x5BBA,  0xB578,  0x5BAE,  
      0x5BB7,  0x5BB4,  0xB623,  0x56A2,  0xBC63,  0x5BB1,  0xB6CC,  0xB6D2,  // 0x68Bx
      0xB6DE,  0xB6DF,  0,       0,       0,       0xB5D7,  0,       0,       
      0,       0xB6D6,  0,       0xBCC5,  0x5BB9,  0xBCC1,  0xBC66,  0xBC7C,  // 0x68Cx
      0xBC71,  0x5FFB,  0xBCB8,  0x5FF6,  0xBC60,  0x5FF7,  0xBC70,  0xBCBE,  
      0xBC69,  0xBC76,  0x5FF3,  0xBC4E,  0xBC78,  0x5FE9,  0xBC56,  0x5FEC,  // 0x68Dx
      0x5FEB,  0x3832,  0x5FFC,  0xB6D3,  0xBC50,  0xBC72,  0xBC73,  0x5FEE,  
      0x5FEA,  0xBC5E,  0xBCBD,  0x5FF5,  0xBC59,  0xBCB2,  0xBC74,  0x5FF1,  // 0x68Ex
      0xBC6C,  0xBC79,  0xBC53,  0xBC58,  0xBC52,  0xBCAA,  0x5FF0,  0xBC65,  
      0xC364,  0xBC54,  0x5FF4,  0xBC5D,  0xBC75,  0x5FEF,  0xBC5A,  0xBC57,  // 0x68Fx
      0xBC68,  0x5FF2,  0x5FE8,  0x5FFE,  0xBC6B,  0xBC6A,  0xBCB1,  0xBCC2,  
} ;


static const unsigned short Uni2cnsP0Table_69 [] = {
      0xBCB9,  0xBCBB,  0xBCB4,  0xBCAF,  0xBC4F,  0x5FED,  0xBC77,  0xBC5F,  // 0x690x
      0xBC61,  0xBCB7,  0xBC6E,  0xBC6D,  0xBC4D,  0x5FF8,  0x5FFA,  0xBC55,  
      0xBC5C,  0xBC64,  0x5FF9,  0xBC5B,  0xBC67,  0xBC7A,  0xBBF0,  0xBC6F,  // 0x691x
      0xBCBC,  0,       0,       0xBCA1,  0xBCC4,  0,       0xBCB3,  0,       
      0,       0,       0,       0,       0,       0xBC7B,  0,       0xBCA9,  // 0x692x
      0,       0xE5AF,  0xBC51,  0xBBEE,  0xE5AE,  0,       0xBCC0,  0xC378,  
      0x64CC,  0xC1E5,  0xC376,  0xC361,  0xC366,  0xC35F,  0xC1F7,  0xC372,  // 0x693x
      0xC351,  0xC358,  0x3D71,  0xC370,  0xC37A,  0xC362,  0xC1E8,  0xC355,  
      0xC368,  0xC36D,  0xC359,  0xC1EB,  0xC36A,  0xC356,  0xC1DD,  0xC1F5,  // 0x694x
      0xC35D,  0xC35E,  0x64CE,  0xC371,  0xC36F,  0xC1F3,  0xC352,  0xC374,  
      0xC1F4,  0xC375,  0xC377,  0x64D2,  0x64CA,  0xC1EF,  0xB57A,  0xC35A,  // 0x695x
      0xC36C,  0xC35B,  0x64C7,  0x64D7,  0xC373,  0x64D5,  0x64D1,  0xC350,  
      0x64C9,  0xC1F9,  0xC353,  0x64D6,  0xC1F8,  0xC363,  0xC34F,  0xC1F6,  // 0x696x
      0x64CF,  0xC367,  0xC357,  0x64D0,  0xC360,  0x64C6,  0x5FFD,  0xC369,  
      0xBC62,  0xC354,  0x3D6C,  0xC1ED,  0xC36E,  0x64CB,  0xC36B,  0x64C8,  // 0x697x
      0xC365,  0x64D3,  0xC35C,  0xC379,  0xC1EA,  0xC1FB,  0,       0xC2C9,  
      0xC2C7,  0,       0x64CD,  0xC52C,  0,       0xC1F2,  0x64D4,  0,       // 0x698x
      0,       0,       0xC2A8,  0,       0xC2BC,  0xCA70,  0xCA6E,  0xC7BA,  
      0xCB26,  0xCA6C,  0xC7BD,  0xCA7E,  0x64C5,  0x69A8,  0xCA68,  0xCB25,  // 0x699x
      0xC7D1,  0xCA6D,  0xCA7B,  0x69AD,  0x69A6,  0xC7CE,  0xCB23,  0xC7C6,  
      0xCA66,  0xCB22,  0xC7C7,  0x69B8,  0xCA77,  0xCB29,  0x69B6,  0xCA6F,  // 0x69Ax
      0x69A7,  0xCA71,  0xCB21,  0x69B0,  0xCA6A,  0x69B4,  0x69AA,  0xCA73,  
      0xCA69,  0xCA63,  0xC7BE,  0xCA7D,  0x69B1,  0xCB28,  0xCA64,  0x69AE,  // 0x69Bx
      0x4377,  0xCA79,  0x4379,  0x69AF,  0xCA6B,  0xCA76,  0xCA72,  0xCA74,  
      0xC7C3,  0x69A9,  0xCB27,  0x69B7,  0xCA75,  0xC7BB,  0xCB2A,  0x4427,  // 0x69Cx
      0xC7BC,  0xCA65,  0xCA7A,  0x69AC,  0x69B5,  0x69B3,  0xCA67,  0xCA7C,  
      0x69B2,  0xC7C5,  0xC7C8,  0x69AB,  0xCA78,  0xC7CD,  0xC7C4,  0x4428,  // 0x69Dx
      0xCCD4,  0xCB24,  0,       0,       0,       0,       0,       0,       
      0,       0xC7CC,  0xD07C,  0xC7C2,  0xD078,  0xD074,  0xD12A,  0xD127,  // 0x69Ex
      0x6DB7,  0xCCE4,  0xCCE0,  0xD12E,  0xD07B,  0x6DC2,  0xD124,  0xCCCF,  
      0xCCD1,  0xD077,  0xD123,  0x6DBF,  0xD137,  0x4A3D,  0xD134,  0xD126,  // 0x69Fx
      0xD075,  0xCCDF,  0xCCD7,  0xD12B,  0xD12D,  0x6DBB,  0xD121,  0xD07A,  
} ;


static const unsigned short Uni2cnsP0Table_6A [] = {
      0xD071,  0x6DB8,  0x6DC0,  0x4A48,  0xD130,  0x6DC1,  0xD072,  0xD136,  // 0x6A0x
      0xD129,  0xD12F,  0x6DBE,  0xCCCD,  0xCCD0,  0xD12C,  0xCCC7,  0xD133,  
      0xCCDB,  0x6DC3,  0xCCD6,  0x6DBD,  0xD125,  0xD076,  0xD138,  0xD073,  // 0x6A1x
      0xD131,  0x6DBA,  0xCCCA,  0xD07D,  0xCCC9,  0xD07E,  0x6DB9,  0x6DB6,  
      0xD079,  0x6DBC,  0xCCD2,  0x6DB5,  0xCCE2,  0xD132,  0xD135,  0xD122,  // 0x6A2x
      0xD755,  0xCCDE,  0xCCD9,  0xCFC2,  0xCCE1,  0xE5B0,  0,       0,       
      0,       0,       0xD74D,  0xD1AC,  0xD749,  0x71A1,  0xD1BC,  0xD1B8,  // 0x6A3x
      0x70F4,  0x70F9,  0x70F5,  0xD757,  0xD762,  0x70F3,  0xD74F,  0xD758,  
      0xD128,  0xD759,  0xD1A8,  0xD1AB,  0x70FA,  0xD1C0,  0xD768,  0x70FE,  // 0x6A4x
      0x71A3,  0xD74B,  0xD1BB,  0x70FD,  0xD1B1,  0xD766,  0xD767,  0xD75D,  
      0xD75C,  0xD754,  0xD1A9,  0xD1BE,  0xD75E,  0xD765,  0xD764,  0xD1AF,  // 0x6A5x
      0x70F8,  0x70F6,  0xD756,  0xD753,  0xD1C4,  0xD750,  0xD763,  0x71A2,  
      0xD761,  0x70FC,  0x70FB,  0xD1A7,  0xD75B,  0x4A4B,  0xD74A,  0xD74C,  // 0x6A6x
      0xD74E,  0xD760,  0xD75A,  0x70F7,  0xD1AE,  0xD751,  0xD1B2,  0xD75F,  
      0xD1C1,  0xD1BA,  0xD4FB,  0,       0,       0,       0xD752,  0xE5B1,  // 0x6A7x
      0xD5A9,  0,       0xE5B2,  0,       0,       0xD4F5,  0x73F8,  0xDD31,  
      0x73F1,  0xDD22,  0xD4FB,  0xDD2D,  0x73F3,  0xDD34,  0xD5A1,  0xDD29,  // 0x6A8x
      0xD4FC,  0xDD24,  0xD4F6,  0x5645,  0xDD35,  0xDC7E,  0xDD2B,  0xD5A7,  
      0x73FA,  0xDD30,  0xDD36,  0xDD2A,  0x73F2,  0xDD2C,  0xDD21,  0x73F9,  // 0x6A9x
      0xD5A3,  0xD4FA,  0xDD33,  0xDD26,  0x73F5,  0xD5A4,  0xDD28,  0xDD25,  
      0x73FB,  0xDD27,  0x73F4,  0x73F7,  0xDD2F,  0xDD23,  0xDD32,  0xD4F8,  // 0x6AAx
      0xDD2E,  0,       0xD5A9,  0xD7F4,  0x76CF,  0xE173,  0x76D4,  0x76D5,  
      0xD7F7,  0xD8A1,  0xD7F6,  0x76CE,  0xE172,  0xD7F8,  0xE16F,  0xE170,  // 0x6ABx
      0x76D2,  0xE16A,  0xE16E,  0x76D1,  0xD7FE,  0xE16B,  0xD7F9,  0xD8A3,  
      0xD7FD,  0xD7FA,  0x76D3,  0x76D0,  0xD8A2,  0xE169,  0xE16D,  0xE171,  // 0x6ACx
      0xD7FB,  0,       0xE5B3,  0xE55C,  0xE559,  0xE562,  0xDAC4,  0xE561,  
      0xE55F,  0xE55A,  0xDACF,  0x78BF,  0xDAC5,  0xDACE,  0x5F71,  0xDAC7,  // 0x6ADx
      0xDACD,  0xE55B,  0x78BE,  0x73F6,  0xE55E,  0x78BD,  0xE563,  0xE55D,  
      0xE558,  0xE16C,  0xDAC8,  0xDAC6,  0,       0x78BC,  0xE5B4,  0xE557,  // 0x6AEx
      0xE924,  0xDCC9,  0xE923,  0xE560,  0x79F3,  0xD7F5,  0xE927,  0xE928,  
      0xE922,  0xE926,  0x6350,  0xE921,  0xDCC7,  0xE5B5,  0x634E,  0,       // 0x6AFx
      0xEB5F,  0xE925,  0x7AF2,  0x7AF0,  0xEB5D,  0xDEB5,  0xDEB4,  0xDEB3,  
} ;


static const unsigned short Uni2cnsP0Table_6B [] = {
      0xEB60,  0xDEB7,  0xEB5C,  0xEB5E,  0x7AF1,  0,       0xDFCF,  0xDFCE,  // 0x6B0x
      0xED53,  0xED54,  0x7BE2,  0xED52,  0xE9CC,  0xE5B6,  0xE5B7,  0xEF31,  
      0x7CBB,  0xEF2F,  0xEF30,  0xF03A,  0xE0F4,  0xEBD1,  0x7DA3,  0xF123,  // 0x6B1x
      0xF121,  0xF122,  0xF124,  0xE1C0,  0xE1E5,  0xE1C1,  0xF22B,  0,       
      0x45CE,  0x48B9,  0xA3F9,  0x4EBC,  0x2671,  0xA74A,  0xA9D3,  0xA9D4,  // 0x6B2x
      0xAB46,  0x2972,  0xADBC,  0xB1E6,  0xAF77,  0xAF79,  0xB1E5,  0xAF78,  
      0xB1E7,  0xAF7A,  0x5BC3,  0xB63B,  0xAF7B,  0xB6E2,  0xB63A,  0xB63C,  // 0x6B3x
      0xB63D,  0xBC7D,  0x60A2,  0xBC7E,  0xBD22,  0x60A3,  0x60A1,  0xBD21,  
      0xC1FD,  0xC422,  0xC37E,  0xC37D,  0xC1FC,  0xC37C,  0xC37B,  0x64D8,  // 0x6B4x
      0xC421,  0x69B9,  0xCB2B,  0xCB2D,  0x69BA,  0xCB2C,  0x6DC5,  0xCCE6,  
      0x6DC4,  0xD139,  0xCCE5,  0xCCE7,  0xD76A,  0xD769,  0xD76B,  0xD1C6,  // 0x6B5x
      0xD1C5,  0x71A4,  0xD5B9,  0xDD37,  0x73FC,  0xD5AB,  0xE174,  0x76D6,  
      0xE564,  0x7BE3,  0x45CF,  0x46DF,  0x48BA,  0x4AE3,  0x4EBD,  0x4EBE,  // 0x6B6x
      0xA9D5,  0xA9D6,  0x51F1,  0xADBD,  0xB1E8,  0xAF7C,  0xBCC9,  0xBCC7,  
      0x442D,  0xC1FE,  0x64D9,  0xC2A1,  0xC7D3,  0x4A4E,  0xD259,  0x71A5,  // 0x6B7x
      0x76D7,  0x45D0,  0xA2D3,  0x48BB,  0,       0x2676,  0xA74C,  0x4EBF,  
      0xA74B,  0xA9D8,  0xAB47,  0x51F2,  0xAB48,  0x29E9,  0x51F3,  0,       // 0x6B8x
      0xAF7E,  0x56B2,  0x56B1,  0xB1EA,  0xB642,  0xB640,  0xB641,  0xB63F,  
      0xB6E4,  0xB63E,  0,       0,       0xBD23,  0xBD26,  0x60A5,  0xBD24,  // 0x6B9x
      0x60A4,  0xBD25,  0,       0xC423,  0xC2A2,  0x4431,  0xCB2E,  0xCB2F,  
      0xCB30,  0xC7D4,  0xD13C,  0xD13B,  0x6DC6,  0xD13A,  0xD13D,  0xD76C,  // 0x6BAx
      0x506D,  0x5BF2,  0xD76D,  0xD76E,  0x5652,  0xDD38,  0x73FD,  0x76D8,  
      0xE565,  0,       0x7AF3,  0xA13F,  0xA9D9,  0x51F4,  0xAB49,  0x56B3,  // 0x6BBx
      0x324E,  0x3250,  0x5BC4,  0xB6E5,  0x60A6,  0xBD27,  0xBCCB,  0x64DB,  
      0x64DA,  0xC2A6,  0,       0xCB31,  0xCB32,  0x6DC7,  0x6DC8,  0xD770,  // 0x6BCx
      0xD76F,  0xE175,  0xEF32,  0x45D1,  0xA140,  0x46E0,  0xA3FA,  0x4AE4,  
      0xA448,  0xA9DA,  0x51F5,  0x64DC,  0x45D2,  0,       0xAB4A,  0x51F6,  // 0x6BDx
      0xAB4B,  0,       0x73FE,  0x45D3,  0xE5B8,  0xE5B9,  0xA74D,  0,       
      0xAB4C,  0xADC2,  0xB025,  0xB024,  0xB022,  0xB1EE,  0xB021,  0xB026,  // 0x6BEx
      0xB023,  0xB1EC,  0xB1ED,  0x5BC5,  0x5BC6,  0xB6E6,  0,       0x60A7,  
      0xBD28,  0x384E,  0xBD29,  0xBD2A,  0xBCCD,  0xBCBC,  0xE5BA,  0xC427,  // 0x6BFx
      0xC428,  0xC426,  0xC2A8,  0xC424,  0xC425,  0x64DD,  0xCB33,  0xD140,  
} ;


static const unsigned short Uni2cnsP0Table_6C [] = {
      0xD13F,  0xD13E,  0xD141,  0xD772,  0xD771,  0x71A6,  0xD773,  0,       // 0x6C0x
      0x74A1,  0xDD39,  0xD5AD,  0xE176,  0xE566,  0xED55,  0,       0x45D4,  
      0x46E2,  0x46E1,  0x2321,  0x4EC0,  0xA141,  0xA15F,  0x48BC,  0,       // 0x6C1x
      0xA258,  0xA449,  0xA44A,  0x4EC1,  0xA9DD,  0xA74E,  0xE5BB,  0x51F7,  
      0xAB4D,  0xAB4E,  0,       0x56B4,  0x56B8,  0xB027,  0x56B7,  0x56B5,  // 0x6C2x
      0x56B6,  0,       0xB643,  0x5BC7,  0x60AA,  0xBCCE,  0x60A8,  0x60A9,  
      0xBD2B,  0xC2A9,  0xC2AA,  0x69BB,  0x45D5,  0,       0xA160,  0xA2D7,  // 0x6C3x
      0x46E3,  0xA2D4,  0,       0xA163,  0xA4A1,  0,       0x46E6,  0xA162,  
      0x46E5,  0x46E4,  0x4AE5,  0xA161,  0xA2D8,  0xA2D9,  0xA259,  0,       // 0x6C4x
      0,       0xA1E6,  0xA25D,  0xA25F,  0xA260,  0x48C6,  0x48C7,  0xA25C,  
      0x48C2,  0xA3FD,  0xA25A,  0xA4A5,  0xA25E,  0x48C3,  0xA6D5,  0x48BE,  // 0x6C5x
      0xA3FC,  0x48BF,  0xA4A3,  0x48C5,  0xA25B,  0x48BD,  0x4AE6,  0x48C0,  
      0x48C1,  0x48C4,  0xA2DD,  0xE5BC,  0,       0xA45B,  0xA459,  0xA44C,  // 0x6C6x
      0x4AF2,  0xA453,  0x4AED,  0xA44D,  0xA9E4,  0xA455,  0xA6D0,  0xA452,  
      0x4AF0,  0xA451,  0x4AF7,  0xA45A,  0x4AF9,  0xA6D3,  0x4AFB,  0xA3FE,  // 0x6C7x
      0xA44B,  0xA6D7,  0x4AEE,  0xA45C,  0xA6D1,  0x4AF5,  0x4AF8,  0xA6CC,  
      0xA765,  0x4AE8,  0x4BA1,  0x4AF6,  0xA44E,  0x4AEB,  0x4AFA,  0xA456,  // 0x6C8x
      0x4AE9,  0x4AEA,  0xA763,  0xA44F,  0x4AF1,  0x4AFC,  0xA45D,  0xA450,  
      0x4AEF,  0xA6CD,  0x4AF4,  0xA74F,  0x4AFD,  0xA457,  0x4AF3,  0xA9E3,  // 0x6C9x
      0x4AFE,  0x4AE7,  0xA454,  0x4AEC,  0xA458,  0xA764,  0xA6CE,  0xA6D2,  
      0xA6DC,  0xA6D9,  0xA6D6,  0xA4E8,  0,       0,       0,       0,       // 0x6CAx
      0,       0,       0xA6DB,  0x4ECD,  0x4EDD,  0xA756,  0x4ED4,  0xADCE,  
      0xA76B,  0x4EC5,  0xA9EB,  0x4EC8,  0xA762,  0x2726,  0xA754,  0xA758,  // 0x6CBx
      0x4ED0,  0x4ED2,  0xA75B,  0x4ED9,  0x4ECB,  0x4EC9,  0x4ECA,  0x4ED8,  
      0xA767,  0x4ED3,  0xA75A,  0xA75C,  0x4ED1,  0x4ED6,  0xA75D,  0xA76A,  // 0x6CCx
      0xA9ED,  0x51F8,  0x4EDC,  0x267D,  0x4EC6,  0xA769,  0xA9EC,  0xA76D,  
      0xA759,  0xA76F,  0xA760,  0x4ECF,  0xA755,  0x4ECE,  0x4EE0,  0x4ED5,  // 0x6CDx
      0xA9EA,  0xA753,  0xAB57,  0x4EDB,  0x4EDF,  0xA761,  0xA766,  0xA9E5,  
      0x4EE1,  0x4EDA,  0x4ECC,  0x4EC2,  0xA9E9,  0x4EC7,  0x267B,  0xA757,  // 0x6CEx
      0x4EC3,  0xA76E,  0xA9E7,  0xA751,  0xA750,  0xA75E,  0xA752,  0x4EDE,  
      0x56B9,  0x4ED7,  0xA75F,  0x4EC4,  0xADCF,  0x52A9,  0,       0,       // 0x6CFx
      0,       0xA76C,  0,       0,       0,       0,       0,       0xADC6,  
} ;


static const unsigned short Uni2cnsP0Table_6D [] = {
      0xAB5E,  0xAB61,  0xADD0,  0xAB64,  0xAB59,  0xADC8,  0xADCA,  0xAB67,  // 0x6D0x
      0xAB6A,  0xAB6C,  0xAB56,  0x51F9,  0x51FE,  0xB02C,  0x52B0,  0xAB65,  
      0xAB6D,  0xAB5D,  0xAB55,  0xADC9,  0xADC7,  0xADCD,  0xB047,  0x52A3,  // 0x6D1x
      0xAB62,  0xAB5A,  0xAB5C,  0x52A8,  0xB1FA,  0xAB5F,  0x52A2,  0xAB52,  
      0xAB68,  0xADCB,  0xAB6B,  0xADC5,  0xADD7,  0x51FD,  0xADD3,  0x52AB,  // 0x6D2x
      0xAB4F,  0x52AD,  0x51FB,  0x52B1,  0xAB69,  0xAB51,  0x52AE,  0xB041,  
      0xA768,  0x52A1,  0x51FA,  0xAB58,  0xAB50,  0x52AF,  0x52A7,  0xAB63,  // 0x6D3x
      0x52AC,  0x52AA,  0xAB5B,  0x52A4,  0xAB53,  0x52A5,  0x52A6,  0xAB54,  
      0xAB66,  0x51FC,  0xAB60,  0x2A21,  0xADD5,  0xADD1,  0,       0,       // 0x6D4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0xB1F7,  0xB1F3,  // 0x6D5x
      0xB02F,  0x56C1,  0x56C6,  0xB1F9,  0xB2A6,  0xB1F6,  0xB038,  0xB03E,  
      0xB03A,  0xB02D,  0xB030,  0xB029,  0xB02A,  0x56CD,  0x56BE,  0xB039,  // 0x6D6x
      0xB042,  0x56C8,  0x56BA,  0xB1EF,  0x56C3,  0xB031,  0x56C5,  0xB032,  
      0xB03C,  0xB2A2,  0xB2A5,  0xB1F2,  0x56C7,  0xB04B,  0xB02B,  0x56C0,  // 0x6D7x
      0x56BF,  0x56CB,  0xB028,  0xB049,  0xB03D,  0xB04A,  0xB044,  0xB036,  
      0xB045,  0xB2A1,  0xB03F,  0xB048,  0xB046,  0x56CC,  0xB037,  0x56BD,  // 0x6D8x
      0x56BC,  0x56C4,  0x56CA,  0xB043,  0x56C9,  0xB034,  0x5BC8,  0xB1F8,  
      0xB04C,  0xB033,  0xB02E,  0x56C2,  0x56CE,  0x56BB,  0xB2A7,  0xB03B,  // 0x6D9x
      0xB040,  0xB1FD,  0xB1FB,  0xB1FC,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0xE5BD,  0,       0,       // 0x6DAx
      0,       0,       0x5BEA,  0xB645,  0xB649,  0xB6EF,  0x5BD7,  0x5BD5,  
      0xB6FA,  0xB7A1,  0x5BCC,  0xB647,  0xB646,  0x5BE0,  0xBCD0,  0xB64C,  // 0x6DBx
      0x5BDA,  0xB6F2,  0xB65E,  0xB66A,  0x5BC9,  0xB65B,  0xB654,  0x5BEC,  
      0xB644,  0xB6EA,  0xB660,  0xB6EB,  0x5BE9,  0x5BDD,  0x5BE8,  0x5BD3,  // 0x6DCx
      0xB650,  0xB662,  0xB65A,  0x5BD4,  0x5BCE,  0xB668,  0xB6EC,  0xB661,  
      0xB663,  0x5BD6,  0x5BDE,  0xB665,  0xB64E,  0xB65F,  0xB653,  0xB667,  // 0x6DDx
      0x5BE3,  0x5BCB,  0x5BE1,  0xB658,  0xB656,  0xB657,  0x5BD8,  0xB652,  
      0xB651,  0x5BCD,  0xB64B,  0xB669,  0x5BCF,  0xB655,  0x5BED,  0xB6F4,  // 0x6DEx
      0x5BE7,  0xB64A,  0x5BE4,  0x5BE2,  0x5BEB,  0xB65C,  0x5BE6,  0xB035,  
      0xB65D,  0x5BE5,  0xB664,  0x5BCA,  0xB659,  0x5BDC,  0xB64D,  0x5BDB,  // 0x6DFx
      0xB6FC,  0x5BD9,  0x5BD1,  0x5BD0,  0xBD2C,  0xB666,  0xBCDD,  0xB7A8,  
} ;


static const unsigned short Uni2cnsP0Table_6E [] = {
      0xB64F,  0xB7A6,  0xB7A3,  0xBD41,  0xB6F0,  0x5BD2,  0xB6F7,  0xB7A4,  // 0x6E0x
      0xB6F6,  0xB7A5,  0xB6F9,  0x326D,  0xB6FD,  0,       0,       0xE5BE,  
      0,       0,       0xB7A9,  0,       0,       0xB6A9,  0,       0xB7A7,  // 0x6E1x
      0xBCD4,  0x60C7,  0x5BDF,  0x60B5,  0xBD3B,  0x60C3,  0xBCD2,  0xBD2F,  
      0x60B2,  0x60AE,  0xBD4D,  0x60B4,  0x60B8,  0x60B3,  0x60BC,  0xBD51,  // 0x6E2x
      0xBD48,  0xBCEB,  0xBCED,  0xBD36,  0x60C1,  0x60BB,  0xBD42,  0x60AB,  
      0xBD4E,  0xBD47,  0x60AF,  0xBD3C,  0x60BE,  0xBD59,  0xBD5A,  0x385B,  // 0x6E3x
      0x60AC,  0xBD4C,  0x60C0,  0xBD40,  0xBD32,  0xBD33,  0x60C4,  0xBD37,  
      0xBD3E,  0xBD38,  0xBCDA,  0x60C2,  0x60CA,  0xBD34,  0xBD2D,  0xBD2E,  // 0x6E4x
      0xBCD6,  0xBD30,  0x60B1,  0xBD3D,  0xBCEE,  0x60BF,  0x60C8,  0xBCD8,  
      0xBCE9,  0xBD3F,  0xBD57,  0xBD4F,  0x60AD,  0xBD55,  0x60B9,  0xBCE6,  // 0x6E5x
      0x60B7,  0xBCE4,  0xBD5B,  0x60B6,  0xBD45,  0xBD39,  0xBD43,  0x60CD,  
      0xBD49,  0xBD46,  0xBD35,  0x60C9,  0xBD53,  0xBD50,  0xBD58,  0x60B0,  // 0x6E6x
      0xBD44,  0x60CC,  0xBCDB,  0xBD4B,  0xC2BA,  0xBCE0,  0x60BA,  0x60BD,  
      0xBCDC,  0xBD4A,  0x60CB,  0xBD3A,  0xB648,  0xBCD1,  0xBCEC,  0xBD54,  // 0x6E7x
      0xBD52,  0xBD56,  0xBCDD,  0xBCE2,  0xE5C2,  0x385E,  0xBCE3,  0,       
      0xBCE8,  0,       0xBCC7,  0,       0xE5C0,  0,       0x385F,  0,       // 0x6E8x
      0xBD31,  0x60C6,  0xE5BF,  0xE5C1,  0,       0xC447,  0xC446,  0xC42C,  
      0x64E3,  0xC2B0,  0xC445,  0xC42F,  0xC430,  0x3E3F,  0x64ED,  0xC44E,  // 0x6E9x
      0x64E8,  0xC444,  0xC2B3,  0xC429,  0x64EE,  0x64E4,  0xC438,  0xC42E,  
      0xC431,  0xC449,  0x64DE,  0xC450,  0xC448,  0x64E7,  0xC43D,  0x64F2,  // 0x6EAx
      0xC2AE,  0xC2B6,  0x64F1,  0x64EB,  0xC2C0,  0x3E36,  0xC44F,  0x64DF,  
      0xC43B,  0xC432,  0xC43F,  0xC44B,  0x64F3,  0xC2B9,  0x64E1,  0xC43A,  // 0x6EBx
      0xC2AD,  0xC433,  0x64EA,  0xC2B1,  0x64E9,  0xC436,  0xC440,  0xC44A,  
      0xC42D,  0xC437,  0x64E2,  0xC441,  0x64EF,  0x64E6,  0xC434,  0x64E5,  // 0x6ECx
      0xC42B,  0xC439,  0xC44D,  0x60C5,  0x69D7,  0xC43C,  0xCB34,  0xC43E,  
      0xC44C,  0x64EC,  0xC435,  0x64E0,  0x64F0,  0x6DDA,  0xC42A,  0xD44E,  // 0x6EDx
      0xC443,  0xC2C4,  0xC2BE,  0xC2C7,  0xC442,  0xC2BD,  0,       0,       
      0,       0,       0,       0xC2C5,  0,       0,       0xC2BF,  0,       // 0x6EEx
      0xC2BB,  0xC2C6,  0,       0xCB50,  0x69D4,  0xCB45,  0xCB4A,  0x69C9,  
      0xC7D6,  0xCB36,  0x69D6,  0xC7D7,  0x69C0,  0xCB35,  0xCB56,  0x69D8,  // 0x6EFx
      0xCB39,  0xCB49,  0xC7E5,  0xCB3B,  0xCB59,  0xCB55,  0x69BE,  0x69C8,  
} ;


static const unsigned short Uni2cnsP0Table_6F [] = {
      0xD15B,  0x69D5,  0x69C6,  0xCB37,  0xC7E3,  0xCB54,  0x69CA,  0xCB51,  // 0x6F0x
      0xCB5E,  0xCB3D,  0xCB46,  0xCCF8,  0xC7DB,  0xCB5C,  0xCB52,  0x69C5,  
      0xCCEA,  0xC7E4,  0xCB44,  0x69BF,  0x69BD,  0x69CF,  0x4443,  0xC7DF,  // 0x6F1x
      0xCB42,  0xCB3F,  0xCB40,  0xC7DA,  0xCB58,  0xC7DC,  0xCB5D,  0xCB5B,  
      0x69C3,  0xCB5F,  0x69C7,  0x69CE,  0x4444,  0xCB38,  0xD143,  0xCB41,  // 0x6F2x
      0xC7DE,  0x69C1,  0x69D3,  0x69D0,  0x69C4,  0xCB4B,  0xCB3C,  0x69D1,  
      0xCB4D,  0x69CB,  0x69CD,  0x69BC,  0xC7DD,  0xCB4F,  0xCB47,  0xCB3A,  // 0x6F3x
      0x69CC,  0xCB57,  0xCB5A,  0xCB43,  0xCB4E,  0xCCF4,  0x69C2,  0x6DC9,  
      0xCB4C,  0xD142,  0xC7E2,  0xCB53,  0xC7E1,  0x4452,  0xCFF9,  0,       // 0x6F4x
      0xE5C4,  0xE5C5,  0xC7E6,  0,       0xE5C3,  0,       0xCB3E,  0xD14C,  
      0xD156,  0x6DCC,  0xD155,  0xD161,  0x6DCE,  0xD153,  0x4A58,  0xD157,  // 0x6F5x
      0x6DD9,  0xCCFD,  0xD14E,  0x6DD1,  0xCCF3,  0xD15A,  0xD77B,  0x6DDD,  
      0x6DDC,  0xD15C,  0xD14B,  0xD166,  0x6DD7,  0xCCEB,  0x6DCD,  0xD15F,  // 0x6F6x
      0x4A69,  0xD163,  0xD168,  0xD15D,  0xD151,  0x6DD0,  0x6DD3,  0x6DDB,  
      0x6DD6,  0xCCF5,  0xD154,  0xCB48,  0xCCFE,  0xCCEC,  0xD150,  0xD167,  // 0x6F7x
      0x6DD2,  0xCCF9,  0x6DD5,  0xD169,  0x6DCA,  0xD15E,  0xD144,  0xD164,  
      0x74AA,  0xCCFA,  0xD152,  0x5075,  0x6DCB,  0xD14D,  0x6DCF,  0xD145,  // 0x6F8x
      0x69D2,  0xD149,  0x4A57,  0xD162,  0xD14A,  0xD148,  0x6DD4,  0xCCFB,  
      0xD160,  0xCCF7,  0xD147,  0xD159,  0xD158,  0xD165,  0xD14F,  0x6DD8,  // 0x6F9x
      0x4A64,  0xE5C7,  0xCFFD,  0,       0,       0xE5C6,  0xD77E,  0xD1D6,  
      0x71B3,  0x71A9,  0xD82C,  0xD776,  0x71AB,  0xD824,  0x71B2,  0x71AD,  // 0x6FAx
      0xD822,  0xDD3B,  0xD828,  0xD82E,  0xD827,  0xD774,  0xD825,  0xD830,  
      0xD832,  0x71A8,  0xD831,  0x71AE,  0x71B4,  0xD1D4,  0x71B1,  0xD1D8,  // 0x6FBx
      0xD82B,  0x71B0,  0xD826,  0xD1CD,  0xD778,  0xD77D,  0xD1D0,  0xD82A,  
      0x71AF,  0x71AC,  0x71A7,  0x71AA,  0xD77C,  0x5122,  0xD146,  0xD777,  // 0x6FCx
      0xD77A,  0xD82D,  0xD821,  0xD775,  0xDD3A,  0xD82F,  0xD779,  0xD829,  
      0xCCF1,  0,       0,       0xD1D5,  0xDD3D,  0x74AE,  0xD5B0,  0xD5AF,  // 0x6FDx
      0x74A2,  0xD5B5,  0xD5B6,  0x74A6,  0xDD3F,  0xDD45,  0xDD43,  0x74A4,  
      0x74A5,  0x74AC,  0xDD46,  0xDD3E,  0x74A7,  0xD5B1,  0xDD42,  0xDD41,  // 0x6FEx
      0xDD47,  0x74AD,  0xD5B7,  0x74A8,  0x74AB,  0xDD40,  0x74AF,  0x74A9,  
      0x74B0,  0x74A3,  0xDD44,  0xDAD5,  0xDD3C,  0xD1D9,  0xD5B9,  0xE225,  // 0x6FFx
      0xE5C8,  0,       0x76DD,  0xE222,  0xE224,  0xD8A8,  0x76DB,  0xE17E,  
} ;


static const unsigned short Uni2cnsP0Table_70 [] = {
      0xE221,  0xE17A,  0xD8AA,  0xD8A7,  0xD823,  0xE17B,  0x76DC,  0xE177,  // 0x700x
      0xD8A6,  0x76D9,  0xE226,  0x76DA,  0xE178,  0xE179,  0xE17D,  0x76DF,  
      0xD8A9,  0x76DE,  0x5B5E,  0xD8AB,  0xE17C,  0x78C5,  0xE56A,  0xE570,  // 0x701x
      0x78C6,  0xE567,  0x78C3,  0x78C0,  0xE572,  0x78C4,  0xDAD2,  0x78C1,  
      0xE569,  0xE56C,  0xE56D,  0xE56E,  0xE571,  0xDAD4,  0xE223,  0xE568,  // 0x702x
      0x78C2,  0xE56F,  0xE934,  0xE56B,  0xDAD3,  0xE5CA,  0xE5C9,  0xE92B,  
      0x79F5,  0xE92E,  0x79F6,  0xE937,  0xE92D,  0xE92A,  0xDCD1,  0xE92C,  // 0x703x
      0xE930,  0xE933,  0xE932,  0xE936,  0xE929,  0xDCCF,  0x79F4,  0xE931,  
      0xE935,  0xE938,  0xE92F,  0xEB61,  0xEB62,  0xEB66,  0xEB67,  0xDEBC,  // 0x704x
      0xEB64,  0xEB65,  0xEB63,  0xDEBA,  0x7AF4,  0xDEBB,  0,       0,       
      0,       0x7BE4,  0xED59,  0xE0B6,  0xDFD2,  0xED56,  0xED57,  0xED58,  // 0x705x
      0x7BE5,  0xE0B7,  0xEF34,  0xEF33,  0xE5CB,  0xF03D,  0x7CE0,  0xF03B,  
      0xF03E,  0xF03C,  0xF125,  0x7DA4,  0x7DB2,  0xF171,  0xF15B,  0xE1F9,  // 0x706x
      0xF170,  0xF23E,  0xF23F,  0x45D6,  0x2150,  0,       0xA4A8,  0xA4A6,  
      0x48C8,  0xA261,  0xA4A7,  0xA4AB,  0xA45E,  0xA6E2,  0x4BA2,  0xA6DF,  // 0x707x
      0x4BA5,  0xA6DE,  0xA45F,  0xA6E3,  0x4BA3,  0x4BA4,  0xA6E0,  0xA4F1,  
      0,       0xA9F7,  0xA778,  0xA77A,  0xA775,  0xA772,  0xA774,  0xA9F4,  // 0x708x
      0xA9F0,  0xA9F5,  0x4EE5,  0xA9EF,  0xA9F9,  0xA9F6,  0x4EE3,  0xA9F2,  
      0xA9F1,  0xA776,  0x4EE4,  0xA773,  0xA770,  0x4EE2,  0xA777,  0x2729,  // 0x709x
      0xA771,  0x4EE6,  0xA779,  0x272B,  0,       0,       0,       0xAB6F,  
      0xADDE,  0xAB73,  0xADDC,  0xADDA,  0x52BA,  0xADD8,  0x2A26,  0xADE5,  // 0x70Ax
      0xADE2,  0xAB76,  0xADDF,  0x52B2,  0x52B5,  0x52B7,  0x52B9,  0x52B6,  
      0xAB72,  0xAB71,  0xADE4,  0x52B4,  0xAB74,  0xAB75,  0xADE3,  0xAB6E,  // 0x70Bx
      0x52B8,  0xADE8,  0x52B3,  0xADDD,  0,       0,       0xAB70,  0xE5CD,  
      0x2A28,  0,       0,       0,       0xB2A8,  0xB05A,  0xB05B,  0xB05C,  // 0x70Cx
      0x56D3,  0x2D75,  0x56CF,  0xB051,  0xB2AA,  0xB059,  0xB05E,  0x56D4,  
      0xB2AB,  0xB04F,  0xB055,  0xB04E,  0xB058,  0xB2B1,  0xB2AF,  0xB054,  // 0x70Dx
      0x56D0,  0x56D2,  0xB05D,  0xB2A9,  0xB04D,  0xB050,  0xB056,  0xB2AD,  
      0xB057,  0xB05F,  0xB053,  0xB2AC,  0x56D1,  0xE5CF,  0,       0,       // 0x70Ex
      0,       0,       0xE5CE,  0,       0,       0,       0xB2B0,  0x5BF2,  
      0xB671,  0xB7B0,  0xB7B2,  0xB673,  0xB66F,  0xB7AF,  0xB67B,  0xB66D,  // 0x70Fx
      0xB67A,  0x5BEE,  0xB66B,  0xBD5F,  0xB675,  0x5BF1,  0xB7B5,  0xB676,  
} ;


static const unsigned short Uni2cnsP0Table_71 [] = {
      0xB679,  0xB7AE,  0xB67D,  0xB7AC,  0xB672,  0x3272,  0xB677,  0xB7AD,  // 0x710x
      0xB7B1,  0x5BEF,  0x5BF0,  0xB67C,  0xB670,  0xB66C,  0xB67E,  0xB7B3,  
      0xB674,  0xE5D0,  0xE5D1,  0xB678,  0,       0,       0,       0xB66E,  // 0x711x
      0,       0x60CE,  0x60CF,  0xBD69,  0x60D5,  0xBCF4,  0xBD5D,  0xBD66,  
      0xBD5C,  0x60D2,  0xBD64,  0xBD62,  0xBCFD,  0xBD63,  0x60D0,  0xBCFC,  // 0x712x
      0xBD67,  0xBCFE,  0xBCEF,  0xBCFA,  0xBCF2,  0xBDA1,  0xBD60,  0xBD5E,  
      0x60D1,  0xBD61,  0xBD65,  0xBCFB,  0xBCF9,  0xBCF1,  0x60D3,  0xBCF3,  // 0x713x
      0xBCF7,  0xE5D3,  0xBD68,  0xE5D4,  0,       0xE5D5,  0,       0xE5D2,  
      0,       0xC456,  0xC45D,  0xC45F,  0xC465,  0xC2D7,  0x65A2,  0xC451,  // 0x714x
      0xC2CC,  0x64F8,  0xC2CE,  0xC460,  0x64FD,  0xC466,  0x64F4,  0xC2D1,  
      0xC463,  0xC2D8,  0xC453,  0xC464,  0xC452,  0,       0x65A4,  0xC2D2,  // 0x715x
      0xC45E,  0x64F5,  0xC467,  0xC8BC,  0x64FA,  0xC457,  0x65A1,  0xC462,  
      0xC455,  0xC45C,  0xC458,  0xC454,  0x64F7,  0x64FE,  0x64FC,  0x64F9,  // 0x716x
      0x65A3,  0x64F6,  0xC45B,  0xC2CF,  0x64FB,  0xC2D9,  0x60D4,  0xC2C9,  
      0xC461,  0xE5D9,  0xC459,  0,       0xC2D3,  0xE5D7,  0xE5D8,  0xE5D6,  // 0x717x
      0xC45A,  0x4457,  0x445B,  0xCB67,  0xC7EF,  0x69DB,  0xC7EE,  0xC7EC,  
      0xCB63,  0xCB69,  0xCB65,  0xC7F0,  0x69DD,  0xCB64,  0xCB68,  0xCB60,  // 0x718x
      0xC7F2,  0xCB62,  0x69DC,  0xC7EA,  0xC7ED,  0xC7EB,  0xC7E8,  0xCB66,  
      0xCB61,  0xC7E7,  0x69DE,  0xE5DB,  0x69D9,  0xC9CB,  0xE5DA,  0xCB6A,  // 0x719x
      0xC9DF,  0x69DA,  0xD16F,  0xD16C,  0xD178,  0xD172,  0xD174,  0x6DDE,  
      0xD16E,  0xD176,  0xCDAA,  0xCDA4,  0xD175,  0xD173,  0xCDA9,  0xD179,  // 0x71Ax
      0x6DE1,  0xD170,  0xD177,  0xCDA8,  0x6DDF,  0xCDA5,  0xCDA2,  0xD16B,  
      0xD16D,  0x6DE0,  0xD16A,  0xD17A,  0xE5DC,  0xD171,  0xD1E2,  0xD1DA,  // 0x71Bx
      0xD836,  0x71BB,  0xD1E0,  0xD1DC,  0xD841,  0xD83F,  0x71B5,  0xD835,  
      0xD838,  0xD839,  0xD834,  0x71BF,  0x71C0,  0xD833,  0xD842,  0xD83D,  // 0x71Cx
      0x71B9,  0x71B6,  0xD83C,  0xD83A,  0xD1E3,  0x5123,  0x71BC,  0xD83E,  
      0x71B7,  0xD1DE,  0x71B8,  0xD1E6,  0xD83B,  0x71BA,  0xD837,  0xAFCF,  // 0x71Dx
      0xD840,  0x71BD,  0xD843,  0xD844,  0x71BE,  0xE5DD,  0xE5DE,  0x74B2,  
      0x74B9,  0xDD48,  0xDD4E,  0xD5BC,  0xDD4C,  0x74B5,  0x74B4,  0x74B1,  // 0x71Ex
      0xDD4A,  0xD5BE,  0xD5C3,  0xD5C0,  0x74B7,  0x74B6,  0x74B3,  0xD5C1,  
      0xDD4D,  0xDD49,  0xDD4B,  0xD5C2,  0x74B8,  0xDAF3,  0,       0,       // 0x71Fx
      0x76E3,  0xE229,  0xD8AD,  0x76E0,  0x76E1,  0xE22B,  0x76E2,  0xE228,  
} ;


static const unsigned short Uni2cnsP0Table_72 [] = {
      0xD8AE,  0xE227,  0xE576,  0xE22A,  0xDAD6,  0xE577,  0x78C7,  0xE575,  // 0x720x
      0xDAD7,  0x5F7E,  0xE574,  0xDCD9,  0xE573,  0x78C8,  0xE5DF,  0xDCD6,  
      0x79F7,  0xDCD8,  0xDCD5,  0xE939,  0xE93A,  0xDAD8,  0xDCD3,  0xDCD7,  // 0x721x
      0xE5E1,  0xEB6A,  0xEB69,  0x7AF5,  0xDFD3,  0xEB68,  0xED5A,  0xED5B,  
      0xDFD4,  0xE0B9,  0xEF35,  0xF03F,  0xE1C3,  0xE1C2,  0xF126,  0xF22C,  // 0x722x
      0x7DC6,  0xF240,  0x45D7,  0x2151,  0x4EE7,  0x4EE8,  0xADE9,  0x2A2A,  
      0x52BB,  0,       0xBDA2,  0,       0x4A6C,  0x74BA,  0x45D8,  0,       // 0x723x
      0x4EE9,  0x56D5,  0x65A5,  0x45D9,  0xADEB,  0x5BF3,  0x69DF,  0xA142,  
      0xA9FC,  0xAB77,  0xB060,  0x3E4C,  0xCB6B,  0x4A6D,  0x74BB,  0x45DA,  // 0x724x
      0x4EEA,  0xAB78,  0xAB79,  0xBD6A,  0x60D6,  0,       0xC2DD,  0xC468,  
      0xC2DC,  0xC2DB,  0x65A6,  0xCB6C,  0x445E,  0xCDAE,  0x6DE2,  0xCDAD,  // 0x725x
      0x78C9,  0x45DB,  0xBD6B,  0x45DC,  0,       0x48CA,  0xA262,  0x48C9,  
      0x4BA8,  0x4BA7,  0x4BA6,  0xA460,  0xA6E4,  0xAAA1,  0xAAA2,  0x4EEB,  // 0x726x
      0xAAA3,  0x4EEC,  0xA77B,  0x2731,  0xAB7A,  0xADED,  0xAB7D,  0x52BD,  
      0xAB7B,  0x2A2F,  0x52BC,  0xAB7C,  0x52BE,  0,       0xB063,  0xB062,  // 0x727x
      0xB061,  0x56D6,  0xB2B6,  0xB722,  0xB723,  0x5BF4,  0xB721,  0xB724,  
      0x60D8,  0x5BF5,  0xBDA4,  0xBDA3,  0x60D7,  0xBD6F,  0xBD6E,  0xBDA5,  // 0x728x
      0xBD6C,  0xBD6D,  0,       0xBD70,  0xC46A,  0xC469,  0xC46D,  0x3E4F,  
      0xC46C,  0xC46B,  0x69E0,  0xCB6F,  0xC7F5,  0xCB6E,  0x69E1,  0xCB6D,  // 0x729x
      0xD17B,  0xCDAF,  0xD17C,  0x6DE3,  0x512D,  0xD845,  0xD846,  0x4EB7,  
      0,       0xE57C,  0x78CA,  0xE57B,  0xE57A,  0xE578,  0xE579,  0x7AF6,  // 0x72Ax
      0xE93B,  0xED5C,  0xF127,  0xE1FB,  0x45DD,  0x2138,  0xA164,  0x46E7,  
      0xA165,  0xA4AC,  0xA4AD,  0x2327,  0xA263,  0xA264,  0xA6EB,  0,       // 0x72Bx
      0,       0xA6E9,  0xA466,  0xA6E6,  0xA6E7,  0xA462,  0xA6EA,  0xA461,  
      0x4EED,  0xA465,  0x4BAA,  0xA463,  0x4BA9,  0xA467,  0xA464,  0xA6E8,  // 0x72Cx
      0,       0xA821,  0xAB7E,  0xA77D,  0xA826,  0xAAA6,  0x4EEE,  0xAAAA,  
      0x4EF1,  0xA827,  0xA823,  0xAAA7,  0xA824,  0x2736,  0xA77C,  0x4EF0,  // 0x72Dx
      0xA77E,  0x4EEF,  0xA825,  0xAAA8,  0xA822,  0xAC7E,  0,       0xAC24,  
      0x52C0,  0x52C1,  0xADF5,  0xAC27,  0xAC21,  0xADF4,  0xAC26,  0xADF0,  // 0x72Ex
      0xAC22,  0x52BF,  0xAC25,  0xAC23,  0xADF3,  0xADF1,  0,       0,       
      0,       0,       0,       0xB069,  0xB066,  0xB2B8,  0xB068,  0x56DB,  // 0x72Fx
      0x56DA,  0x56D8,  0xB065,  0xB06A,  0x56D7,  0x56D9,  0xB067,  0xB72C,  
} ;


static const unsigned short Uni2cnsP0Table_73 [] = {
      0xB064,  0xB06B,  0xB2B9,  0,       0x3323,  0x332A,  0xBDA6,  0xB727,  // 0x730x
      0xB72B,  0x33D4,  0xB72A,  0xBD72,  0xBD7D,  0x332D,  0xB7BB,  0xB72D,  
      0xB7BA,  0xB728,  0xBD71,  0x5BF9,  0x3322,  0x332C,  0x5BF8,  0xB726,  // 0x731x
      0xB729,  0x5BFA,  0xB7B9,  0x5BF7,  0x5BF6,  0xB725,  0xB72E,  0,       
      0,       0,       0xBD74,  0xBD7B,  0xBDA7,  0x60DA,  0xBD7A,  0xBD77,  // 0x732x
      0xBDAE,  0x60DC,  0xBDA9,  0xBDAB,  0xBDAA,  0xBD79,  0xC2E1,  0xBDAD,  
      0xBD73,  0xBD75,  0xBD78,  0xBD76,  0x60DB,  0xBD7C,  0x60D9,  0x65A7,  // 0x733x
      0xBDA8,  0,       0xC471,  0xC470,  0xC46E,  0xD47C,  0x65AA,  0x65A9,  
      0xC472,  0xC2DF,  0xC46F,  0xCB70,  0x69E2,  0x65A8,  0xC2E2,  0xE5E2,  // 0x734x
      0xE5E3,  0xC474,  0xC473,  0xCDB0,  0xCB73,  0xCB71,  0x6DE4,  0xC7F9,  
      0x69E3,  0xCB72,  0xD17E,  0xC7F8,  0xC7FA,  0xC7F7,  0x4A77,  0x6DE5,  // 0x735x
      0xD17D,  0xD228,  0xD227,  0xD225,  0x4A75,  0xD224,  0xD221,  0xD222,  
      0xD223,  0xD226,  0xD229,  0,       0,       0xD84B,  0xD848,  0xD849,  // 0x736x
      0x71C1,  0xD847,  0xD84D,  0xD84C,  0xD84A,  0,       0xDD50,  0xDD51,  
      0x74BC,  0xD5C9,  0x74BD,  0xDD4F,  0x566C,  0x76E5,  0xE22C,  0x76E4,  // 0x737x
      0x78CB,  0x6025,  0x78CC,  0x79F8,  0xE93D,  0xE93C,  0xEB6B,  0xED5D,  
      0x7BE6,  0xEF37,  0xEF36,  0xEF38,  0x46E8,  0xAC28,  0x56DC,  0x5BFB,  // 0x738x
      0xB72F,  0x46E9,  0xA166,  0x45DE,  0xA2DA,  0xA1EB,  0xA265,  0xA4AF,  
      0x232A,  0xA2E6,  0xA46C,  0xA46A,  0xA46B,  0xA468,  0x4BAB,  0xA469,  // 0x739x
      0xA6EE,  0,       0,       0,       0xAAB3,  0xA82F,  0xAAAD,  0x4EF4,  
      0xA82D,  0xA829,  0xA82C,  0xAAAC,  0xA828,  0x4EF6,  0xA82B,  0xAAAB,  // 0x73Ax
      0x4EF3,  0x4EF2,  0xAAB2,  0x4EF5,  0xA82E,  0xA82A,  0,       0xAAAF,  
      0,       0,       0x52C5,  0x52C8,  0xAC30,  0xAC2F,  0xAC2E,  0x52C2,  // 0x73Bx
      0xAC37,  0xAC2D,  0x2E2A,  0x52C4,  0xB070,  0xADF8,  0xAC34,  0xAC32,  
      0x52C7,  0xADFB,  0xAC2A,  0xAC35,  0xADF7,  0xAC2C,  0xAC36,  0xAC33,  // 0x73Cx
      0xAC2B,  0xADFA,  0x52C3,  0xAC38,  0xAC29,  0x52C6,  0xADFE,  0xADF9,  
      0xADFC,  0,       0xB075,  0xB06C,  0xB077,  0xB2BE,  0xB06F,  0xB07A,  // 0x73Dx
      0xB07B,  0xB06D,  0xB079,  0xB076,  0xB074,  0xB078,  0x56E2,  0xB2C0,  
      0x56E0,  0xB2C7,  0xB2BC,  0xB072,  0xB2C6,  0xB06E,  0xB2C1,  0xB071,  // 0x73Ex
      0xB07C,  0xB073,  0x56E1,  0xAC31,  0xB2BD,  0x56DD,  0x56DF,  0xE5E4,  
      0,       0,       0,       0xB7BD,  0xB73D,  0xB732,  0xB730,  0xBDB8,  // 0x73Fx
      0xB731,  0xB2BF,  0xB738,  0xB7C0,  0xB739,  0xB735,  0x5CA2,  0xB73A,  
} ;


static const unsigned short Uni2cnsP0Table_74 [] = {
      0xB737,  0xB734,  0xB7BC,  0x5BFE,  0xB733,  0x5BFC,  0x5CA1,  0xB736,  // 0x740x
      0xB73E,  0x56DE,  0x5BFD,  0xB73C,  0xB73B,  0x5CA3,  0,       0,       
      0,       0,       0xE5E5,  0xB6D7,  0xBDB6,  0xBDBA,  0xBE24,  0xBDAF,  // 0x741x
      0xBDBB,  0xBDB2,  0xBE25,  0x60E6,  0xBDB9,  0xBE2B,  0xC2ED,  0xBDB5,  
      0xBE2D,  0xBE26,  0x60E0,  0xBE2A,  0xBE29,  0x60E1,  0x60E7,  0xC2E4,  // 0x742x
      0x60E8,  0xBE2C,  0x60DE,  0xBE23,  0xBE21,  0xBE27,  0xBD7E,  0x60E5,  
      0xBE22,  0xBE28,  0xBE2E,  0x60DF,  0x60E4,  0x60E2,  0x60E3,  0,       // 0x743x
      0xBDB3,  0xBDBC,  0x60DD,  0xE5E6,  0xBDB7,  0xC2E8,  0xC2F5,  0x65B1,  
      0xC47B,  0x65B0,  0xC521,  0xC2EF,  0xC475,  0xC2F4,  0xC522,  0xC2EE,  // 0x744x
      0xC2E6,  0xC2F1,  0xC476,  0xC477,  0xC2F3,  0xC523,  0xC47E,  0xC47C,  
      0xC47D,  0xC479,  0xC478,  0xC2E7,  0xC524,  0x65AD,  0xC2EB,  0xC47A,  // 0x745x
      0xC2F0,  0x65B2,  0x65AC,  0x65B3,  0x65B4,  0xC2EA,  0x65AF,  0x65AE,  
      0xC8A5,  0xC7FE,  0xCB74,  0x69E5,  0x69E4,  0xC7FC,  0xC7FD,  0xCB79,  // 0x746x
      0xC8A2,  0x6DE6,  0x69E6,  0xC8A1,  0xC7FB,  0x69E8,  0xCB7A,  0x65AB,  
      0x69E7,  0xCB76,  0xCB78,  0xCB75,  0xC8A7,  0xCB77,  0xC8A3,  0,       // 0x747x
      0xC9F6,  0xD233,  0xCDB1,  0xCDBB,  0xD232,  0xD22F,  0x6DE9,  0xD84E,  
      0x6DEA,  0xD22E,  0xCDB9,  0x6DE8,  0xCDB6,  0xD230,  0xD22D,  0xD22A,  // 0x748x
      0xD231,  0xD22B,  0xD22C,  0x6DE7,  0xCDB5,  0xE5E8,  0,       0x5139,  
      0xDD55,  0x513A,  0xD852,  0xCDBA,  0xD851,  0xD853,  0xD1EA,  0xDD52,  // 0x749x
      0x71C4,  0x5138,  0xD84F,  0xD1E7,  0x71C2,  0xD1EC,  0x71C6,  0x71C5,  
      0xD850,  0xD854,  0xD1EB,  0x71C3,  0xE5E7,  0xDD59,  0x74C0,  0x76E6,  // 0x74Ax
      0x74C1,  0x74BE,  0xDD56,  0xDD54,  0xD5CF,  0xDD57,  0xD5CB,  0xDD5A,  
      0x74BF,  0xDD58,  0xDD53,  0xD5CD,  0xE5E9,  0xE22F,  0xE232,  0xE621,  // 0x74Bx
      0xE22D,  0xD8AF,  0xE93E,  0xE233,  0xD8B0,  0x78CD,  0xE231,  0x76E7,  
      0xE22E,  0xE230,  0xE234,  0xE622,  0xDADA,  0xE57E,  0x6027,  0xDADC,  // 0x74Cx
      0xDADD,  0xDADB,  0x78CE,  0xE57D,  0xDCDE,  0xDCDC,  0xDCDF,  0x79F9,  
      0xDCDD,  0xDCE0,  0,       0xDEBD,  0x7AF8,  0xED5F,  0x7AF7,  0xED61,  // 0x74Dx
      0xED5E,  0xED60,  0x7CBC,  0xF040,  0x46EA,  0xA830,  0xB07D,  0xB07E,  
      0x5CA4,  0xC525,  0x71C7,  0x78CF,  0x7BE7,  0xF041,  0x46EB,  0,       // 0x74Ex
      0xA831,  0x23A2,  0x2A3C,  0xAEA2,  0xAC39,  0xAEA1,  0xAC3A,  0xAEA4,  
      0,       0,       0,       0xB2C8,  0xB121,  0xB122,  0x5CA5,  0x5CA6,  // 0x74Fx
      0xB6E7,  0xBDBD,  0x3925,  0xBE2F,  0,       0xC528,  0xC527,  0xC526,  
} ;


static const unsigned short Uni2cnsP0Table_75 [] = {
      0xCB7B,  0xC2F7,  0xCB7C,  0xCB7D,  0x69E9,  0,       0xC8A8,  0xD235,  // 0x750x
      0xD234,  0xCDBD,  0xD1ED,  0xD855,  0x71C8,  0x71C9,  0xD1EE,  0xDD5E,  
      0xDD5B,  0xDD5C,  0xDD5D,  0xE236,  0xE235,  0x76E8,  0xE623,  0xEB6C,  // 0x751x
      0x46EC,  0,       0x52C9,  0xB7C4,  0x5CA7,  0xC529,  0xC2F8,  0x46ED,  
      0x2A40,  0xB123,  0x5CA8,  0xB7C5,  0xBDBE,  0x60E9,  0x60EA,  0x47C9,  // 0x752x
      0x46EE,  0x46EF,  0xA266,  0x4BAD,  0x4BAC,  0x52CA,  0xAC3B,  0xBE30,  
      0x46F0,  0x46F1,  0x46F2,  0x46F3,  0,       0,       0x232B,  0x4BAE,  // 0x753x
      0x4BAF,  0xA46E,  0xA46D,  0xAAB7,  0,       0x4EF7,  0xA834,  0xA832,  
      0xA833,  0xAAB8,  0xAAB5,  0x2740,  0xAAB6,  0,       0xAEA7,  0xAC3C,  // 0x754x
      0xAC3D,  0xAEA5,  0xAEA8,  0x52CE,  0x52CC,  0xAEAA,  0x52CD,  0x52CB,  
      0xAEA6,  0xABFA,  0,       0xACCA,  0x56E3,  0xB2CE,  0xB2CD,  0xB2D0,  // 0x755x
      0xB2CF,  0x56E7,  0x56E6,  0xB124,  0x56E5,  0x56E4,  0xB2D1,  0xB125,  
      0,       0xB7C6,  0x5CAB,  0xB740,  0xB73F,  0x5CA9,  0x5CAA,  0xB7C9,  // 0x756x
      0xB7C7,  0,       0x60EC,  0x60EB,  0xBE32,  0xBDC3,  0xBDC2,  0xBE31,  
      0x5CAC,  0xBDC4,  0x392C,  0,       0,       0x3E6B,  0x65B5,  0xC52B,  // 0x757x
      0x65B6,  0xC52A,  0xC2FB,  0x447C,  0x447B,  0xCB7E,  0xD236,  0x6DEB,  
      0xD856,  0xD1F0,  0,       0xD5D2,  0xDD5F,  0x5B74,  0x78D1,  0x78D0,  // 0x758x
      0x6368,  0xDCE2,  0x7BE8,  0x46F4,  0xA835,  0,       0xBDC5,  0x5CAD,  
      0xCC21,  0x69EA,  0xA2DB,  0xA6F3,  0xA46F,  0xA470,  0,       0,       // 0x759x
      0xA836,  0x4EF9,  0x4EFA,  0xAABA,  0x2743,  0x4EF8,  0xAABB,  0,       
      0,       0,       0x52D2,  0x52D3,  0x52D0,  0x52D1,  0xAEAB,  0xAC3E,  // 0x75Ax
      0xAEAF,  0x2A4A,  0xAC3F,  0x52CF,  0,       0,       0,       0,       
      0xB126,  0xB2D7,  0x56EB,  0x56EC,  0xB2D5,  0x5CB0,  0xB12C,  0x2E40,  // 0x75Bx
      0x56F1,  0x56EF,  0xB12D,  0xB128,  0x56EE,  0x56ED,  0x56E8,  0xB12B,  
      0xB12A,  0xB127,  0x56F0,  0xB2D2,  0xB129,  0x56E9,  0x2E34,  0x56EA,  // 0x75Cx
      0,       0,       0x5CB1,  0xB744,  0xB745,  0x5CB2,  0xB741,  0xB743,  
      0xB747,  0xB746,  0xB742,  0xB7CA,  0x5CAE,  0x5CAF,  0,       0xBE3A,  // 0x75Dx
      0x60F1,  0x60F0,  0xBE34,  0x60EE,  0x3934,  0xBE37,  0x60F2,  0xBE38,  
      0x60F3,  0xBE35,  0x60ED,  0x60EF,  0xBE39,  0xBDC7,  0xBE36,  0xBE33,  // 0x75Ex
      0,       0,       0,       0,       0x3E77,  0xC538,  0xC2FC,  0xC52D,  
      0x65B8,  0x65BB,  0x65BA,  0x65BF,  0x65BE,  0xC539,  0xC537,  0xC530,  // 0x75Fx
      0xC534,  0xC533,  0x65BC,  0xC536,  0xC532,  0xC53A,  0xC531,  0x65BD,  
} ;


static const unsigned short Uni2cnsP0Table_76 [] = {
      0x65B7,  0x65B9,  0xC2FD,  0xC52F,  0,       0,       0,       0xC8AB,  // 0x760x
      0xCC23,  0x69EE,  0xCC27,  0x69ED,  0xCC24,  0x69EC,  0xC8A9,  0xC52E,  
      0xC535,  0xCC26,  0x447E,  0x69EF,  0xCC28,  0xCC25,  0xCC22,  0,       // 0x761x
      0,       0xD239,  0xD23D,  0xD23F,  0xD23B,  0xD23A,  0xD238,  0x6DEE,  
      0x6DEC,  0x6DF1,  0x6DF2,  0xD23C,  0x6DEF,  0xD237,  0x6DF0,  0x69EB,  // 0x762x
      0xD23E,  0x6DED,  0,       0,       0xD1F1,  0xD858,  0x514F,  0xD857,  
      0xD85F,  0xD859,  0xD85E,  0xD85B,  0x71CA,  0xD85D,  0xD1F3,  0xD1F2,  // 0x763x
      0x71CB,  0x514D,  0x71CC,  0xD1F4,  0xD85C,  0xD85A,  0,       0,       
      0x5721,  0x5724,  0x74C3,  0xDD60,  0xD5D5,  0xD5D3,  0x74C2,  0xDD63,  // 0x764x
      0xDD61,  0xDD62,  0x55E9,  0x5CB6,  0x74C4,  0,       0xD5D4,  0xD8B4,  
      0xE23A,  0xD8B3,  0x76EB,  0xE23B,  0x5B75,  0x5B79,  0x76E9,  0xE23C,  // 0x765x
      0x76EA,  0xE239,  0xE23D,  0xD8B2,  0xE237,  0,       0,       0x78D2,  
      0xE624,  0x78D3,  0x79FA,  0,       0xE238,  0x79FB,  0,       0xDEBF,  // 0x766x
      0xDEBE,  0x7AF9,  0xEB6D,  0,       0x7BEA,  0xED62,  0x7BE9,  0xE0BB,  
      0xEF39,  0x7CE1,  0x7CE2,  0xE5EA,  0xE4D2,  0xF23A,  0xA2DC,  0xE5EB,  // 0x767x
      0x52D4,  0xAC40,  0,       0x60F4,  0x60F5,  0x46F5,  0x48CB,  0xA267,  
      0xA6F4,  0xA471,  0x4BB0,  0xA6F6,  0x4EFB,  0x2A4C,  0x52D5,  0x52D6,  // 0x768x
      0x52D7,  0xB749,  0xB12E,  0x56F2,  0x2E41,  0x2E43,  0x5CB3,  0xB748,  
      0xB7CD,  0,       0xBE3C,  0x60F7,  0xBDCC,  0xBE3B,  0x60F6,  0xC2FE,  // 0x769x
      0xC3A1,  0xC53B,  0x6DF3,  0xD243,  0xD240,  0xD241,  0xD242,  0x5154,  
      0x5155,  0xD1F6,  0x5CC3,  0xD5D6,  0xDD64,  0xD5D7,  0xE23E,  0x5B7C,  // 0x76Ax
      0x5B7D,  0xDADE,  0xE940,  0xE93F,  0x665A,  0xED63,  0x46F6,  0xA837,  
      0x56F3,  0,       0,       0xBDCD,  0x60F8,  0xC53C,  0x4534,  0xC8B0,  // 0x76Bx
      0xCC29,  0xC8AE,  0x6DF4,  0xD860,  0xE5EC,  0xE23F,  0xE941,  0x46F7,  
      0xA6F7,  0xA6F8,  0x4EFC,  0x52DA,  0xAC41,  0x52DB,  0x52D9,  0xAEB2,  // 0x76Cx
      0x52D8,  0xB12F,  0x56F4,  0xB2DA,  0xB2DB,  0x56F5,  0x56F6,  0,       
      0,       0,       0x5CB5,  0xB74A,  0x5CB4,  0xB7D0,  0xB7D2,  0xB7D1,  // 0x76Dx
      0xB7A3,  0xBDCF,  0xBE3D,  0x5CB6,  0x60F9,  0xC53D,  0x65C0,  0x65C1,  
      0x4535,  0x69F0,  0xC8B1,  0x69F1,  0x6DF5,  0x71CE,  0xD861,  0x71CD,  // 0x76Ex
      0x572D,  0xDD65,  0x74C5,  0xD8B5,  0xE240,  0xE942,  0x46F8,  0x4BB1,  
      0xA83A,  0xA839,  0x4EFD,  0xA838,  0x4EFE,  0xA83B,  0x2A55,  0xAC47,  // 0x76Fx
      0x52DE,  0x52DD,  0xAC49,  0xAC48,  0x52E2,  0xAEB5,  0x52E1,  0xAEB3,  
} ;


static const unsigned short Uni2cnsP0Table_77 [] = {
      0x2A59,  0x52DC,  0x2A5D,  0xAC43,  0xAC44,  0xAC45,  0x2A52,  0x52E3,  // 0x770x
      0xAC42,  0x52DF,  0xAC46,  0x52E0,  0,       0,       0xB2E4,  0xB2DF,  
      0xB132,  0xB136,  0xB134,  0xB133,  0x2E55,  0xB137,  0xB2DE,  0x2E4F,  // 0x771x
      0xB2E8,  0xB138,  0xB139,  0xB131,  0x2E51,  0xB130,  0xB7D9,  0x56F8,  
      0x56F9,  0xB2E7,  0xB13A,  0xB135,  0xB2E5,  0xB753,  0xB7D5,  0xB13B,  // 0x772x
      0x56FA,  0x56F7,  0xB2DC,  0xB2E3,  0,       0xB74D,  0x334F,  0xB74C,  
      0xB7D3,  0xB74E,  0xB74F,  0xB751,  0xB750,  0xB755,  0x5CBA,  0x5CB7,  // 0x773x
      0x5CBB,  0xB74B,  0x5CBC,  0xB754,  0x5CB9,  0xB752,  0x5CB8,  0xB2E2,  
      0xB7D7,  0x3356,  0xBDD6,  0xBDD3,  0xBE40,  0xBE42,  0xBE3E,  0xBE3F,  // 0x774x
      0xBDD1,  0xBDD2,  0xBE43,  0xBE45,  0xBE46,  0xBE41,  0xBE44,  0x60FA,  
      0,       0,       0xC541,  0xC3A7,  0xC546,  0xC53E,  0xC542,  0x3F29,  // 0x775x
      0xC3A8,  0xC547,  0xC543,  0x65C2,  0x65CA,  0xC3A5,  0x65C5,  0xC53F,  
      0xC540,  0x69F5,  0x65CD,  0x65C6,  0xC3A6,  0x65CB,  0x65C4,  0xC545,  // 0x776x
      0x65CC,  0xC544,  0x65C8,  0x65C3,  0x65C9,  0xC548,  0xCC2E,  0xCC30,  
      0x4542,  0xC8B9,  0x4540,  0x453D,  0xC8B3,  0xC8B6,  0xC8B5,  0xC8B4,  // 0x777x
      0xC8B8,  0x65C7,  0xC8BB,  0xC8BD,  0xCC2B,  0x69F3,  0xCC31,  0x69F4,  
      0xCC2F,  0xCC2A,  0xCC2D,  0xCC32,  0x69F2,  0xCC2C,  0,       0x6DF7,  // 0x778x
      0xD247,  0xD246,  0xCDC4,  0x6DFA,  0x6DF8,  0xD244,  0x6DF6,  0xD245,  
      0xCDC6,  0x6DF9,  0,       0,       0x515F,  0xD869,  0xD1FB,  0xD86B,  // 0x779x
      0xD1F9,  0xD86A,  0xD862,  0xD866,  0xD865,  0xD863,  0x71D0,  0x71D1,  
      0x71CF,  0xD864,  0xD867,  0xD868,  0xD5D9,  0x71D2,  0xD5D8,  0x74CA,  // 0x77Ax
      0xDD6D,  0xD5DB,  0x74C7,  0xDD67,  0x74C9,  0x74CB,  0x5161,  0xD5DC,  
      0x74C8,  0xDD6C,  0xDD68,  0x74C6,  0xDD6B,  0xDD66,  0xDD6A,  0xDD69,  // 0x77Bx
      0xD8B6,  0xD8B8,  0xE242,  0x76EE,  0x76EF,  0x76EC,  0xD8BB,  0x76ED,  
      0xD8BA,  0xD8B9,  0xE241,  0x6039,  0xE627,  0xDAE0,  0xDADF,  0x78D4,  // 0x77Cx
      0,       0xE625,  0xE626,  0,       0xE943,  0xE946,  0xE944,  0xE945,  
      0xEB6E,  0xDEC2,  0x665E,  0x7AFA,  0xEF3A,  0xF042,  0x6B74,  0x7CE3,  // 0x77Dx
      0xF128,  0xF129,  0x7DB3,  0x46F9,  0x52E4,  0xB2E9,  0xBE47,  0xBDD7,  
      0xC549,  0x6C76,  0x46FA,  0x4BB2,  0x2752,  0x4FA1,  0xAEB6,  0xAC4A,  // 0x77Ex
      0xAC4B,  0x56FB,  0x335B,  0,       0xBE48,  0x60FB,  0x65CE,  0x74CC,  
      0xDD6E,  0xE628,  0xE947,  0x46FB,  0xA6FB,  0xA6FC,  0xA5A3,  0xA841,  // 0x77Fx
      0xA83C,  0xA83E,  0xA840,  0xA83F,  0xA83D,  0x4FA2,  0xA8B4,  0,       
} ;


static const unsigned short Uni2cnsP0Table_78 [] = {
      0,       0,       0x52E5,  0xAC54,  0xAEB9,  0xAC4F,  0xAC4C,  0xAEBB,  // 0x780x
      0xAEBE,  0xAC53,  0xAEB7,  0xAEBA,  0x52E7,  0x52E8,  0xAC52,  0xAC51,  
      0xAC50,  0xAC4D,  0xAC4E,  0xAC55,  0x52E6,  0xAEBD,  0,       0,       // 0x781x
      0xACDC,  0xE5ED,  0,       0xE5EE,  0,       0x57A1,  0xE6FC,  0x57A7,  
      0x57A6,  0xB144,  0xB13E,  0xB13C,  0xB2EC,  0x57A4,  0xB75C,  0x56FD,  // 0x782x
      0xB141,  0xB145,  0xB147,  0xB143,  0xB13D,  0x57A5,  0xB142,  0xB140,  
      0x56FC,  0xB148,  0x57A8,  0xB146,  0x57A2,  0xB13F,  0xB2ED,  0x57A3,  // 0x783x
      0x56FE,  0,       0,       0,       0,       0xE5EF,  0,       0,       
      0,       0,       0xB7E2,  0x5CBE,  0x335D,  0xB75D,  0xB7E3,  0xB7DD,  // 0x784x
      0xB756,  0xB758,  0xB75A,  0xB7DF,  0xB75B,  0xB759,  0x5CBF,  0xB7E1,  
      0xB75E,  0xB7E0,  0xB757,  0xE5F0,  0xE5F1,  0,       0,       0,       // 0x785x
      0xE5F2,  0,       0,       0,       0xBE4C,  0x60FC,  0xBE54,  0xBDDC,  
      0xBE49,  0xCC2F,  0xBE55,  0xBDD9,  0xBE4A,  0xBE4B,  0xBDDD,  0x3954,  // 0x786x
      0xBE53,  0xBE52,  0xBE4F,  0x5CBD,  0x60FD,  0xBE4D,  0xBE50,  0x60FE,  
      0xBE51,  0xBE4E,  0,       0,       0,       0,       0xBDDA,  0,       // 0x787x
      0xC3B1,  0xC554,  0xC3AD,  0xC558,  0x65D5,  0xC3AE,  0xCC38,  0x65D8,  
      0xC556,  0xC3B7,  0xC3A9,  0xC553,  0xC54E,  0xC550,  0xC551,  0xC54A,  // 0x788x
      0xC3B5,  0x65D4,  0xC3AB,  0xC3B0,  0x65D3,  0xC3B4,  0x65CF,  0xC54D,  
      0xC3AA,  0x65D6,  0xC3B6,  0x65D7,  0xC54C,  0xC54F,  0xC557,  0x65D1,  // 0x789x
      0x65D2,  0xC555,  0xC54B,  0,       0xC4A5,  0x4553,  0xCC3A,  0x69F7,  
      0xCC3C,  0xC552,  0xCC3E,  0x69FB,  0xCC3F,  0xCC3B,  0xC8BE,  0x69F8,  // 0x78Ax
      0xCC37,  0x69FA,  0xCC34,  0xCC39,  0xCC3D,  0xCC36,  0xC8BF,  0xC8C5,  
      0x65D0,  0xC8C4,  0xCC33,  0x69F9,  0xCC35,  0,       0,       0xE5F3,  // 0x78Bx
      0xC8C0,  0xCABF,  0x6DFD,  0xD249,  0x6EA3,  0x4B59,  0x6EA1,  0x4B57,  
      0xCDCA,  0x69F6,  0xCDCD,  0xD250,  0xD251,  0x6DFC,  0xCDC8,  0xCDCC,  // 0x78Cx
      0xD24F,  0xD252,  0x6DFE,  0x6DFB,  0xD24B,  0xD248,  0xD24D,  0xD24A,  
      0x6EA4,  0xD24C,  0xCDCB,  0xCDC9,  0xD24E,  0x6EA2,  0xD2A1,  0,       // 0x78Dx
      0xE5F4,  0,       0x71D4,  0xD872,  0xD2A4,  0xD86C,  0xD870,  0xD876,  
      0xD877,  0xD873,  0xD874,  0xD871,  0x4B5D,  0xD86E,  0x516E,  0x71D6,  // 0x78Ex
      0x71D3,  0xD86D,  0xD86F,  0xD2A2,  0x71D5,  0xD875,  0xE5F5,  0x74D0,  
      0xD5E0,  0xD5E2,  0xDD75,  0xDD6F,  0x74CF,  0,       0x573E,  0x74CD,  // 0x78Fx
      0xD5E1,  0xDD77,  0x74CE,  0xDD72,  0xDD73,  0xDD70,  0xDD78,  0xDD74,  
} ;


static const unsigned short Uni2cnsP0Table_79 [] = {
      0x5740,  0x74D1,  0xDD71,  0,       0xDD79,  0xDD76,  0xD8C3,  0xD8BE,  // 0x790x
      0xD8C0,  0xE246,  0xD8BF,  0xD8BC,  0xE243,  0xD8C2,  0x76F0,  0x5C32,  
      0xE247,  0xE249,  0xE248,  0xE244,  0xE245,  0xD8C4,  0,       0xE62D,  // 0x791x
      0xDAE1,  0x78D5,  0xDAE2,  0xE62A,  0xE62C,  0xE629,  0xE62E,  0x6042,  
      0xDAE3,  0xE62B,  0xE5F6,  0xE949,  0xE94C,  0xE948,  0x79FC,  0xE94A,  // 0x792x
      0xE94B,  0xE94D,  0x79FD,  0x7AA1,  0x79FE,  0xEB6F,  0xDEC5,  0xEB71,  
      0xDEC3,  0xEB70,  0xDEC4,  0,       0,       0xED64,  0xEAE6,  0xE0BC,  // 0x793x
      0xF043,  0xF12A,  0x46FC,  0,       0xA4B3,  0xA472,  0x4FA3,  0xA843,  
      0x4FA4,  0x4FA5,  0xA842,  0,       0xAC5A,  0xAC59,  0x52E9,  0x52EC,  // 0x794x
      0x52EB,  0x52EA,  0xAC56,  0xAC58,  0xAC57,  0xE5F7,  0,       0xB14B,  
      0x57AA,  0xB14F,  0xB14E,  0xB14D,  0xB149,  0x57A9,  0x57AD,  0x57B0,  // 0x795x
      0xB2EF,  0xB2F0,  0x57B1,  0xB14A,  0xB14C,  0x57AF,  0x57AE,  0x57AC,  
      0x57AB,  0xB765,  0xB2F2,  0xB763,  0xB75F,  0x5CC0,  0xBDDE,  0xB760,  // 0x796x
      0x5CC1,  0xB761,  0xB762,  0xB764,  0xB7E6,  0x5CC2,  0xB7E5,  0,       
      0xBE59,  0xBDDF,  0xBE58,  0xBE57,  0xBE56,  0xBDE4,  0xBDE2,  0x395A,  // 0x797x
      0,       0xC55C,  0x65D9,  0x3F46,  0xC559,  0xC55B,  0xC3B8,  0x65DA,  
      0xC3BD,  0x65DB,  0xC55A,  0xC3B9,  0xBDE3,  0,       0xE5F8,  0xC8C8,  // 0x798x
      0xCC48,  0xC8C7,  0xCC41,  0xCC42,  0x47FE,  0x69FE,  0x69FC,  0x69FD,  
      0xCC4A,  0x48A2,  0xCC49,  0xCC46,  0xCC45,  0xCC44,  0xCC43,  0xCC47,  // 0x799x
      0xCC40,  0xE5F9,  0xD253,  0xD258,  0xD256,  0xCDD0,  0xCDD1,  0xCDCF,  
      0xD255,  0xD254,  0xD257,  0xE5FA,  0xD878,  0xD2A6,  0x71D7,  0x74D2,  // 0x79Ax
      0xDD7B,  0xD2A7,  0x74D3,  0xDD7A,  0xE24B,  0xE24A,  0x76F1,  0xD8C5,  
      0xE62F,  0x78D6,  0xE94E,  0x7BEB,  0xED65,  0xE0BD,  0xF045,  0xF044,  // 0x79Bx
      0xA167,  0x52ED,  0x52EE,  0xB766,  0xE5FB,  0x65DD,  0x46FD,  0x4BB5,  
      0x4BB4,  0x4BB3,  0x2468,  0xAABE,  0xAABD,  0xA844,  0xAABF,  0xAAC2,  // 0x79Cx
      0x4FA7,  0x4FA6,  0xAAC4,  0x52F1,  0xE5CC,  0xAC5C,  0xAC5F,  0xAC5D,  
      0xAEC2,  0x52EF,  0x52F0,  0xAEC0,  0xAEC1,  0xAC5B,  0xAC5E,  0xAEC3,  // 0x79Dx
      0x57B8,  0xB2F4,  0xB2F3,  0xB2F9,  0xB156,  0xB158,  0xB157,  0x57B5,  
      0xB152,  0xB2F6,  0xB2FB,  0x57B3,  0x57B2,  0xB2F7,  0x57B6,  0x57B4,  // 0x79Ex
      0xB2F8,  0x57B7,  0xB155,  0xB150,  0xB151,  0xB154,  0xB153,  0,       
      0xB2FC,  0xB7E9,  0xB7E7,  0xB7EB,  0,       0xB7EA,  0xB769,  0xB76A,  // 0x79Fx
      0xB768,  0xB7EC,  0xB767,  0x5CC3,  0xB7BF,  0,       0,       0xBDE5,  
} ;


static const unsigned short Uni2cnsP0Table_7A [] = {
      0x61A5,  0xCC48,  0xBE5A,  0xBE5C,  0xBE5E,  0x61A4,  0xCC43,  0xBDE6,  // 0x7A0x
      0x61A2,  0xBDE9,  0xBE5B,  0x61A3,  0xBE5D,  0x61A1,  0xBDE8,  0xC3C1,  
      0xC566,  0xC55D,  0xC560,  0xC564,  0x65E1,  0xC562,  0x3F50,  0xC561,  // 0x7A1x
      0xC55E,  0xC55F,  0x65DF,  0xC565,  0x65DE,  0xC3C4,  0x65E3,  0x65E2,  
      0x65E0,  0x3F4A,  0xC563,  0,       0,       0xE5A4,  0xCC50,  0x455D,  // 0x7A2x
      0xCC4F,  0xC8CB,  0xC8CD,  0xCC4B,  0xC8D0,  0xC8CF,  0x6AA1,  0xCC4E,  
      0xCC4D,  0x6AA2,  0xC8D2,  0xCAE4,  0x4B63,  0x455E,  0x4B6B,  0x6EA9,  // 0x7A3x
      0xCDD5,  0xD25A,  0xCDD6,  0x6EAA,  0x6EA6,  0x6EA8,  0xCDDA,  0x6EA5,  
      0x6EA7,  0xCDD3,  0xCDD7,  0,       0xD879,  0xD2AA,  0x71DA,  0xD87B,  // 0x7A4x
      0xD87A,  0xD5E4,  0xCC4C,  0x71DC,  0x71DB,  0x71D8,  0x71D9,  0xD2AC,  
      0xDBD9,  0,       0,       0xD2A9,  0xDE22,  0x5749,  0xDD7E,  0x74D4,  // 0x7A5x
      0xDE21,  0x5748,  0xDE23,  0xDD7D,  0xDD7C,  0,       0,       0xE24C,  
      0x76F4,  0x76F2,  0x76F3,  0,       0xDAE6,  0x6045,  0xDAE5,  0xE630,  // 0x7A6x
      0xE631,  0x78D8,  0xDAE7,  0x78D7,  0xE950,  0xE951,  0xE94F,  0xDCE4,  
      0xED66,  0xED67,  0xE0F6,  0xE0F7,  0x46FE,  0xA268,  0x4BB6,  0,       // 0x7A7x
      0xA845,  0x4FA9,  0x4FA8,  0xA846,  0xAEC4,  0xAEC7,  0xAC61,  0x52F2,  
      0xAC60,  0x52F3,  0xAEC9,  0xAEC8,  0x57B9,  0xB15B,  0xB159,  0xB15F,  // 0x7A8x
      0x57BA,  0xB15A,  0xB15E,  0xB15C,  0xB15D,  0,       0,       0xB76B,  
      0xB76D,  0xB7F2,  0x5CC4,  0xB7F1,  0xB76C,  0x5CC5,  0x61A8,  0x61A7,  // 0x7A9x
      0x61A6,  0xBE5F,  0xB7F0,  0x3965,  0,       0,       0xC569,  0x65E4,  
      0x65E5,  0xC3C6,  0xC568,  0xC567,  0xC3C7,  0,       0,       0xE5FC,  // 0x7AAx
      0xCC51,  0x6AA4,  0x6AA3,  0xCC52,  0xCC53,  0,       0x6EAC,  0x6EAB,  
      0xCDDB,  0xD921,  0xD25B,  0xD25D,  0xD25C,  0xD87E,  0xD87C,  0xD922,  // 0x7ABx
      0xD87D,  0x56D2,  0x71DD,  0xD2AF,  0x5227,  0xD2AE,  0xDE24,  0x74D5,  
      0xDE25,  0xDE26,  0xD5E8,  0,       0x76F5,  0x76F6,  0x604B,  0x7AA2,  // 0x7ACx
      0xDEC9,  0xDEC8,  0x7CBD,  0x47A1,  0xA6FE,  0xA7A1,  0x275B,  0xAAC7,  
      0xAECE,  0xAC62,  0xAECF,  0xAECD,  0xAECB,  0xAECC,  0,       0xACF6,  // 0x7ADx
      0xB160,  0x57BB,  0xB3A3,  0xB3A6,  0xB3A7,  0xB3A4,  0,       0x5DFE,  
      0x5DFD,  0xB7F3,  0xBDF1,  0x61AA,  0xBE61,  0x61A9,  0xBE60,  0xBDF0,  // 0x7AEx
      0x3F57,  0xC3C9,  0xC3CA,  0xC56A,  0xC8D4,  0x6AA5,  0xCC54,  0x6AA6,  
      0xC8D5,  0xD2B0,  0xD5E9,  0xD5EA,  0x5750,  0xD8C9,  0x7AA3,  0xE952,  // 0x7AFx
      0xDFD5,  0x48CC,  0x4FAA,  0xA847,  0xAED1,  0x52F5,  0xAED0,  0x52F4,  
} ;


static const unsigned short Uni2cnsP0Table_7B [] = {
      0xAC63,  0xAC64,  0,       0,       0xB162,  0xB164,  0x57BC,  0,       // 0x7B0x
      0xB166,  0xB169,  0xB167,  0xB3AB,  0x2E71,  0xB3AA,  0xB168,  0xB165,  
      0xB161,  0x57BD,  0xB16A,  0xB163,  0xB3AC,  0,       0xB7F8,  0xB7F9,  // 0x7B1x
      0xB776,  0x5CCB,  0xB821,  0x5CC8,  0xB7F7,  0xB778,  0x5CCC,  0xB7FB,  
      0x5CC6,  0xB7F6,  0xB773,  0xB822,  0xB774,  0xB771,  0x5CCA,  0x337C,  // 0x7B2x
      0x5CC7,  0x337A,  0xB777,  0xB77A,  0x5CC9,  0xB77B,  0x5CCD,  0xB77C,  
      0xB772,  0xB779,  0xB77D,  0xB775,  0xB770,  0xB76E,  0xB7FA,  0xE5FD,  // 0x7B3x
      0xB77E,  0xB7CD,  0,       0xB76F,  0,       0xB6FE,  0,       0x3BA4,  
      0xBE68,  0xBDFB,  0xBDF8,  0xBDF5,  0xBE64,  0xBE6A,  0x61AD,  0xBE63,  // 0x7B4x
      0xBE65,  0x61AB,  0xBE62,  0x61B2,  0xBE66,  0x61B1,  0xBE67,  0x61B3,  
      0x61AE,  0x61B4,  0x61AF,  0xBDF9,  0x61B0,  0xBDF2,  0x61AC,  0xBDF6,  // 0x7B5x
      0xBE69,  0xE5FE,  0,       0,       0,       0,       0xC3CF,  0x3F67,  
      0x65E8,  0xC575,  0xC3CC,  0xC578,  0xC56C,  0xC571,  0xC56B,  0x65EA,  // 0x7B6x
      0xC3D5,  0xC56F,  0x3F5E,  0xC3CD,  0xBDF7,  0xC56D,  0x65E9,  0xC3D4,  
      0xC574,  0xC573,  0xC570,  0xC572,  0xC56E,  0x6AAA,  0xC577,  0x65E6,  // 0x7B7x
      0xC576,  0xC3D1,  0,       0xC4C5,  0,       0,       0,       0,       
      0,       0xC8D6,  0xCC64,  0xC8D8,  0x6AB1,  0xCC5F,  0xC8E0,  0x6AB0,  // 0x7B8x
      0xCC55,  0x456B,  0xCC57,  0x6AA9,  0xCC5C,  0xCC5B,  0xCC5E,  0x6AAE,  
      0xCC59,  0xCC58,  0xC8DA,  0xC8DE,  0x6AAD,  0x6AA8,  0xCC5A,  0x6AAB,  // 0x7B9x
      0xCC60,  0xCC62,  0,       0xCC5D,  0xCC56,  0x6AAC,  0xC8D7,  0xC8DD,  
      0x6EB4,  0x6AA7,  0x4564,  0xC8DC,  0xCC63,  0x4570,  0,       0,       // 0x7BAx
      0,       0,       0,       0,       0xD261,  0x6EAD,  0xCDDC,  0xD263,  
      0x4C2B,  0x6EAE,  0xCDE5,  0xCDDD,  0x6EB0,  0xD266,  0x4B7A,  0xD25E,  // 0x7BBx
      0x6AAF,  0xD264,  0x4B73,  0x4C31,  0x4B74,  0x4C2A,  0xD260,  0xCDE0,  
      0x65E7,  0x6EB3,  0x4C21,  0x4B78,  0x6EAF,  0x4C26,  0x6EB1,  0x6EB2,  // 0x7BCx
      0x4B76,  0x71E0,  0xD265,  0xD25F,  0x6EB5,  0xCDE3,  0xD262,  0,       
      0xE6A1,  0,       0,       0,       0xD92C,  0xD927,  0x522D,  0x56E9,  // 0x7BDx
      0xD931,  0x71DE,  0xD929,  0x71E2,  0xD92F,  0xD926,  0xD923,  0xD932,  
      0x74DB,  0x71E3,  0xD92E,  0xD924,  0x71E1,  0xD928,  0x71E5,  0xD925,  // 0x7BEx
      0xD92A,  0x71E4,  0xD92D,  0xD930,  0xD2B3,  0xD2B4,  0,       0,       
      0xDE38,  0xDE39,  0xDE29,  0xDE30,  0xDE2E,  0x575F,  0xD5ED,  0x74D9,  // 0x7BFx
      0xDE35,  0xD92B,  0xD5EB,  0xDE2C,  0xD5EE,  0xDE36,  0x74D8,  0xDE2B,  
} ;


static const unsigned short Uni2cnsP0Table_7C [] = {
      0xDE2A,  0xDE34,  0xDE31,  0xDE33,  0x5754,  0xDE27,  0xDE37,  0x74D6,  // 0x7C0x
      0xD5F0,  0xDE32,  0xDE3B,  0xDE2F,  0x74DA,  0x74D7,  0xDE2D,  0xDE28,  
      0xDE3A,  0x71DF,  0xD5F1,  0,       0xDBDF,  0x5757,  0,       0,       // 0x7C1x
      0xD5EF,  0xE24F,  0xD8D0,  0xD8CE,  0xE24D,  0xE253,  0x76FA,  0xE251,  
      0xE250,  0x76FC,  0xE256,  0x76FB,  0xD8D1,  0xE257,  0xE254,  0x76F8,  // 0x7C2x
      0xE255,  0xE24E,  0x76F9,  0x76F7,  0xE635,  0xE252,  0xD8CC,  0xE6A2,  
      0xE258,  0,       0xE6A3,  0xE632,  0xDAEF,  0xDAEE,  0x604E,  0x78DD,  // 0x7C3x
      0x78DB,  0xE634,  0x604C,  0xE636,  0xE633,  0x78DC,  0x78D9,  0x78DA,  
      0x78DE,  0,       0xE6A4,  0x7AA5,  0xDCE6,  0xE957,  0x6CF9,  0xE956,  // 0x7C4x
      0xE954,  0xE953,  0xE955,  0xDCE5,  0x7AA4,  0x7AA6,  0xE6A5,  0xE5E7,  
      0x7AFB,  0xDECC,  0x666F,  0xEB73,  0xEB72,  0xDCE7,  0xDECB,  0xED68,  // 0x7C5x
      0xDFD8,  0xED6A,  0xED6C,  0xED6B,  0xED69,  0xDFD7,  0xE0BF,  0x7BED,  
      0x7BEC,  0,       0xE0BE,  0x7CBF,  0x7CBE,  0x7CC0,  0xEF3C,  0xEF3B,  // 0x7C6x
      0xE6A6,  0xF12B,  0xF046,  0xF12C,  0x7DA5,  0xE1C4,  0x7DA6,  0xF15C,  
      0x6D5B,  0xE2BA,  0x7DCB,  0x48CD,  0xAAC9,  0xA848,  0xAAC8,  0xAED2,  // 0x7C7x
      0xAC66,  0xAC67,  0xAC65,  0xAED4,  0xAED3,  0x52F6,  0xADA1,  0xAC68,  
      0xAC69,  0xAC6A,  0,       0xB3B1,  0xB16B,  0xB171,  0xB3AE,  0xB3B0,  // 0x7C8x
      0xB16F,  0x57BE,  0xB16D,  0xB3B2,  0xB16E,  0xB170,  0xB3AD,  0,       
      0,       0xB16C,  0x5CCE,  0xB7FD,  0xB823,  0x5CD0,  0xB825,  0x5CCF,  // 0x7C9x
      0xB824,  0xB7FE,  0xB8A1,  0xB8BE,  0xB8A2,  0x3422,  0xBE6C,  0x61B5,  
      0xBEA1,  0xBE6E,  0xBE6B,  0xB826,  0xBEA3,  0x61B6,  0xBEA2,  0xBDFE,  // 0x7CAx
      0xBE6D,  0xE6A7,  0,       0xBEA1,  0xBEA3,  0,       0xC3D8,  0xC57B,  
      0xC3DC,  0x65EB,  0xC579,  0x65EC,  0xC57A,  0x65ED,  0x4574,  0xC8E2,  // 0x7CBx
      0xC8E1,  0x6AB2,  0xCC68,  0xCC65,  0xCC67,  0x6AB3,  0x6AB4,  0xCC66,  
      0xCBA7,  0xCBAB,  0xCDEF,  0xCDF1,  0xCDED,  0xD267,  0xCDF0,  0xCDF3,  // 0x7CCx
      0xD268,  0xCDF2,  0x6EB6,  0xD26A,  0xD269,  0xCDEE,  0x23A3,  0x5244,  
      0xD936,  0xD937,  0xD933,  0xD2B7,  0xD934,  0x71E6,  0x71E7,  0xD935,  // 0x7CDx
      0,       0x74E1,  0xD5F5,  0xD5F4,  0x74DD,  0x74E2,  0x74DE,  0x74E0,  
      0x74DC,  0xD2B9,  0x74DF,  0xD8D5,  0x5C5A,  0x5C5B,  0xD8D4,  0x76FD,  // 0x7CEx
      0xDE3C,  0xC8D7,  0xE638,  0x605A,  0xE637,  0xE6A8,  0xE958,  0x7AA7,  
      0x7AA8,  0xED6E,  0xEB74,  0xE1E9,  0xED6D,  0xE0C0,  0xF12D,  0xF172,  // 0x7CFx
      0x48CE,  0,       0xA7A2,  0x4BB7,  0xAACB,  0xA849,  0x4FAB,  0xAACA,  
} ;


static const unsigned short Uni2cnsP0Table_7D [] = {
      0x52F9,  0xAC6D,  0x52F7,  0xAC6B,  0x52FC,  0x52F8,  0x52FD,  0x52FB,  // 0x7D0x
      0xAC6C,  0x52FA,  0x57C2,  0x57C1,  0xB17C,  0x57CA,  0xB175,  0xB17B,  
      0x57C6,  0xB174,  0xB17A,  0xB178,  0x57C5,  0x57C7,  0xB177,  0x57C0,  // 0x7D1x
      0xB176,  0x57CB,  0x57C8,  0x57CC,  0x57C9,  0xB173,  0xB172,  0xB179,  
      0x57C3,  0x57BF,  0x57C4,  0x2F25,  0xB3B7,  0xB3BB,  0,       0,       // 0x7D2x
      0xB835,  0xB82E,  0x3A26,  0x61BB,  0xB82D,  0xB8A9,  0x5CD4,  0x5CDB,  
      0x5CD8,  0x5CDE,  0x5CDD,  0x5CD9,  0xB8A6,  0xB827,  0xB82A,  0xB8A7,  // 0x7D3x
      0xB829,  0x5CD5,  0xB82B,  0xB834,  0x5CD6,  0xB828,  0xB831,  0xB832,  
      0x5CD7,  0xB82F,  0x5CDC,  0x5CD2,  0x5CDA,  0xB82C,  0x5CD1,  0xB830,  // 0x7D4x
      0xB8AE,  0xB8A4,  0xB833,  0xB7D4,  0xB8AB,  0xBEB4,  0xBF21,  0xBE76,  
      0x61B8,  0xBE7D,  0xBE7A,  0xBE72,  0xBE7B,  0x61BA,  0xBE73,  0xBEA9,  // 0x7D5x
      0xBE6F,  0xBEA6,  0xBEAE,  0x65F3,  0xBE78,  0xBEAF,  0x61B7,  0xBE7E,  
      0xBEA8,  0x61BE,  0x61C0,  0xBE71,  0xBEAC,  0x3A27,  0x61BF,  0xBE74,  // 0x7D6x
      0x61B9,  0xBE7C,  0xBE75,  0xBE79,  0xBEAA,  0xBE77,  0x61BC,  0xBE70,  
      0x61C1,  0x5CD3,  0x61BD,  0x61C2,  0xBEA4,  0xBEB5,  0xBEB3,  0,       // 0x7D7x
      0xC3E7,  0x65EF,  0xC624,  0xC626,  0xC628,  0xC62C,  0xBEAB,  0xC622,  
      0xC57E,  0x65F1,  0x3F71,  0xC627,  0xC62B,  0xC623,  0xC57D,  0xC3E6,  // 0x7D8x
      0xC57C,  0xC3E9,  0xC3E0,  0xC3E2,  0xC629,  0xC621,  0xC625,  0x65F2,  
      0xC3DE,  0x65F0,  0xC62D,  0x65EE,  0xC62A,  0xC3E4,  0xCC79,  0xC3E8,  // 0x7D9x
      0xC3EA,  0xC3E3,  0,       0,       0x6AB7,  0xCC71,  0x6EC3,  0xCC7B,  
      0x6ABA,  0xCD21,  0x6AC0,  0xCC6C,  0xC8F4,  0x457B,  0xCC7C,  0xCC69,  // 0x7DAx
      0xC8ED,  0xCC7E,  0xCC6D,  0xC8EE,  0x6AC7,  0x6AC4,  0xCC7D,  0xCC77,  
      0x6AB6,  0x6ABE,  0x6ABD,  0xC8F0,  0x6ABC,  0x6AC2,  0xC8E9,  0xCC6A,  // 0x7DBx
      0x6AC3,  0xCC78,  0x6ABF,  0x6AB5,  0xCC7A,  0x6AB8,  0x6AB9,  0x6AC1,  
      0xCC6F,  0xCC6E,  0xCC6B,  0x457C,  0xCC73,  0xCC70,  0xCC74,  0x6AC6,  // 0x7DCx
      0xC8E8,  0xCD22,  0x6ABB,  0xCC75,  0xCC76,  0xC8F1,  0xCC72,  0xC8F3,  
      0xE6A9,  0xC8EB,  0x6AC5,  0xE6AB,  0,       0,       0xCEA2,  0xD26F,  // 0x7DDx
      0x6EBB,  0x6EC4,  0x6EC0,  0xD26C,  0xCDFC,  0x6EBD,  0x6EC1,  0xD278,  
      0x6EB7,  0xD270,  0xCDF8,  0x6EBF,  0xCEA4,  0xCEAF,  0xD273,  0xD26E,  // 0x7DEx
      0x6EBE,  0x6EC2,  0xD26D,  0xCEAE,  0x6EBC,  0xCDF7,  0xD277,  0x6EB9,  
      0xD276,  0xD275,  0x6EC5,  0xD03B,  0x6EB8,  0xCEAB,  0xD274,  0xD26B,  // 0x7DFx
      0xCDF5,  0x6EC6,  0xD272,  0x6EBA,  0xCEA8,  0xCEA9,  0xCEA5,  0xCEAC,  
} ;


static const unsigned short Uni2cnsP0Table_7E [] = {
      0xCEA7,  0xCDFE,  0xCDFD,  0xD271,  0x4C45,  0,       0,       0xE6AA,  // 0x7E0x
      0x71EA,  0x71EF,  0x71E8,  0xD944,  0xD93B,  0xD947,  0xD93F,  0xD945,  
      0x71F0,  0x71E9,  0xD938,  0xD93E,  0xD948,  0xD941,  0xD946,  0xD93A,  // 0x7E1x
      0x524C,  0xD2BB,  0xD942,  0x71EB,  0xD940,  0x71EE,  0x71ED,  0xD93C,  
      0xD93D,  0xD939,  0xD943,  0x71EC,  0xD94A,  0xD949,  0xD2C0,  0xD2BF,  // 0x7E2x
      0,       0xDE47,  0xDE43,  0x74E9,  0xD5F9,  0xDE3D,  0x74E3,  0x74F3,  
      0xDE49,  0x74EB,  0x74E7,  0xDE40,  0x74EE,  0x74F1,  0xDE4B,  0x74E6,  // 0x7E3x
      0xDE42,  0x74EF,  0xDE4D,  0xDE4A,  0xDE3E,  0x74EA,  0x74E4,  0x74F2,  
      0xDE45,  0x74ED,  0xDE3F,  0x74E8,  0xDE4C,  0x74EC,  0x74E5,  0xDE46,  // 0x7E4x
      0x74F0,  0xDE44,  0,       0,       0xDE48,  0xD5FA,  0x5C5F,  0xD8D9,  
      0xE25A,  0xE260,  0x77A5,  0xE263,  0x76FE,  0x77A1,  0xE25B,  0xE262,  // 0x7E5x
      0xE25D,  0x77A6,  0x77A3,  0xD8DB,  0xE259,  0xD8D8,  0x77A2,  0xE25F,  
      0xE261,  0x77A4,  0xE25E,  0xE25C,  0xE6AC,  0x5C5E,  0xD8DA,  0,       // 0x7E6x
      0xE642,  0x78E2,  0x78E3,  0x78DF,  0xDAF2,  0x78E0,  0xDAF4,  0xE63E,  
      0xE63C,  0xDAF5,  0xE640,  0x78E4,  0xE641,  0xE63A,  0xE639,  0xE63D,  // 0x7E7x
      0xE63B,  0x78E1,  0xE63F,  0xE959,  0x7AAB,  0x7AAA,  0xE95A,  0xDCEC,  
      0xE95C,  0xE95B,  0x7AAC,  0,       0xDED3,  0xDED0,  0xEB79,  0xEB76,  // 0x7E8x
      0xEB77,  0xDED1,  0xEB75,  0xEB78,  0x7AFD,  0xEB7A,  0xDED2,  0x7AFC,  
      0,       0xED6F,  0xDFDA,  0x7CC1,  0x7CC3,  0xEF3D,  0x7CC2,  0xF047,  // 0x7E9x
      0xF12F,  0xF131,  0xF12E,  0xF130,  0x7DB9,  0x6D78,  0xE2B5,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7EAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7EBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7ECx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7EDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7EEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7EFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_7F [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7F0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7F1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7F2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x48CF,  0x2557,  // 0x7F3x
      0x52FE,  0xB052,  0x57CD,  0xB8B1,  0xB1F8,  0x5CDF,  0xBF22,  0xBF23,  
      0xE6AD,  0xC8F7,  0,       0xD94B,  0x74F4,  0xDE4E,  0xD5FD,  0xD8DC,  // 0x7F4x
      0x77A7,  0,       0xE644,  0xE643,  0x7AAD,  0xEB7B,  0xDFDB,  0xED70,  
      0x7CE4,  0xA269,  0x2221,  0,       0x4FAC,  0x4BB8,  0,       0xA8CA,  // 0x7F5x
      0xAC6E,  0xAACE,  0,       0xB224,  0xB17D,  0xB223,  0xB221,  0x57CE,  
      0xB222,  0xB17E,  0xB3BC,  0xB836,  0x3A2B,  0xBF24,  0xBF25,  0xC630,  // 0x7F6x
      0xC631,  0x65F5,  0x65F6,  0xC62F,  0xC632,  0xC62E,  0x65F4,  0xC8F8,  
      0x6AC8,  0xC8F9,  0x65F7,  0xCD23,  0,       0x6EC7,  0xD279,  0x6EC8,  // 0x7F7x
      0xCEB0,  0x71F1,  0xD94E,  0xD94C,  0xD94D,  0xDE51,  0xDE50,  0xDE4F,  
      0xC1E1,  0,       0x5C68,  0xE645,  0x606F,  0x78E5,  0xE646,  0xED71,  // 0x7F8x
      0x7CE5,  0xF048,  0x48D0,  0x4FAE,  0x4FAD,  0xAC70,  0x53A1,  0xAEDD,  
      0x2F30,  0xAC6F,  0xB226,  0xB3BD,  0x57CF,  0xB837,  0xB225,  0xB3BF,  // 0x7F9x
      0x2F2F,  0xB3BE,  0x5CE1,  0xB83A,  0xB838,  0xB839,  0x5CE0,  0,       
      0xBF27,  0xBF28,  0xBF26,  0xC3EE,  0x65FA,  0xC634,  0xC633,  0xC635,  // 0x7FAx
      0x65F9,  0x65F8,  0,       0x4626,  0xD27A,  0xD27C,  0xCEB1,  0x6EC9,  
      0xD27B,  0xD94F,  0x71F2,  0xE265,  0xD8DD,  0xE264,  0x78E6,  0xE647,  // 0x7FBx
      0x78E8,  0x78E7,  0xE95D,  0xEB7C,  0x7AFE,  0x48D1,  0xAC71,  0x53A2,  
      0xB229,  0x57D1,  0xB228,  0xB227,  0xB3C2,  0x57D0,  0xB3C3,  0xB840,  // 0x7FCx
      0x343D,  0xB842,  0xB83B,  0xB83C,  0x5CE2,  0xB83D,  0x5CE3,  0xB841,  
      0xB83E,  0xB83F,  0x5CE4,  0xBEB7,  0x61C4,  0x61C5,  0xBEB8,  0xBF29,  // 0x7FDx
      0,       0,       0,       0xC636,  0xC637,  0xC3F2,  0xCD27,  0x6ACB,  
      0x6AC9,  0x6ACA,  0xCD24,  0xCD25,  0xE058,  0xCD26,  0xD323,  0xCEB2,  // 0x7FEx
      0xD324,  0x6ECA,  0xD321,  0xD27E,  0xD322,  0xD27D,  0x71F5,  0xD950,  
      0x71F3,  0x71F4,  0xDE53,  0x74F5,  0xDE52,  0xE134,  0xD5FE,  0xE266,  // 0x7FFx
      0xE267,  0x77A8,  0xD8E1,  0x77A9,  0x74F6,  0xE648,  0xE649,  0xE95E,  
} ;


static const unsigned short Uni2cnsP0Table_80 [] = {
      0x7AAE,  0x48D2,  0xE6FB,  0x48D3,  0x57D3,  0x4FAF,  0x57D2,  0xAC72,  // 0x800x
      0xB8B6,  0x2B25,  0xB3C4,  0x61C6,  0x48D4,  0x53A4,  0xAC73,  0xAC74,  
      0x53A3,  0x53A5,  0x48D5,  0x2761,  0xAC75,  0x57D5,  0xB22A,  0x57D7,  // 0x801x
      0x57D4,  0x57D6,  0xB8B7,  0xB845,  0x5CE5,  0xB8B9,  0xB844,  0xB843,  
      0x3A38,  0xC638,  0,       0xC9A2,  0xCD28,  0x462C,  0x6ECB,  0,       // 0x802x
      0x71F6,  0xD952,  0xD951,  0xD6A1,  0xDE54,  0x5C71,  0xD8E2,  0xDCEF,  
      0xEB7D,  0x692E,  0x692D,  0x48D6,  0xA473,  0xA84A,  0x53A6,  0xAC76,  // 0x803x
      0xBB21,  0xB22C,  0x2F3A,  0xB3C9,  0xB3C8,  0x57D8,  0xB22B,  0x57D9,  
      0xB3C7,  0xE6AF,  0,       0xB847,  0xB8BD,  0xB8BC,  0x5CE7,  0xB846,  // 0x804x
      0xB848,  0xB8BB,  0x5CE6,  0,       0,       0,       0xBEBC,  0xBF2B,  
      0xBF2C,  0xBF2A,  0x61C7,  0xE7A9,  0,       0x3F7C,  0x65FB,  0xC3F3,  // 0x805x
      0x65FC,  0x4633,  0x6ACD,  0xC9A3,  0xCD2A,  0xCD29,  0x6ACC,  0xC9A6,  
      0xBEBB,  0xC9A5,  0,       0xE6B0,  0xD325,  0xCEB4,  0xCEB6,  0xD326,  // 0x806x
      0xCEB7,  0,       0xCEB5,  0xCEB8,  0xD953,  0x525C,  0xD2C3,  0x74FA,  
      0x74F9,  0x74F7,  0x74F8,  0x74FB,  0xD6A2,  0xE268,  0x77AB,  0x77AA,  // 0x807x
      0xE64A,  0xE95F,  0xDCF0,  0xDCF1,  0xDCF2,  0x7BEF,  0x7BEE,  0x48D7,  
      0,       0xBB24,  0xAF7D,  0,       0x65FE,  0x61C8,  0x65FD,  0x6ACE,  // 0x808x
      0xE060,  0x48D8,  0xA168,  0x48D9,  0x48DA,  0xA4B5,  0xA4B6,  0xA84B,  
      0xA476,  0xA7A4,  0xA477,  0x4BBA,  0xA7A6,  0xA474,  0x4BB9,  0xA7A5,  // 0x809x
      0x4BBC,  0xA475,  0x4BBE,  0x4BBD,  0xA478,  0x4BBB,  0x2470,  0xA7A3,  
      0,       0x4FB4,  0x4FB2,  0xA84D,  0xAAD6,  0x4FB1,  0xAADB,  0xAAD8,  // 0x80Ax
      0xAACF,  0x4FB6,  0x4FB8,  0x4FB5,  0xAAD9,  0xA850,  0xA84C,  0x4FB9,  
      0xAAD2,  0x4FB3,  0x4BBF,  0xAAD4,  0x4FB7,  0xA84F,  0xAAD7,  0x2764,  // 0x80Bx
      0xA84E,  0x2769,  0x4FB0,  0xE6B1,  0,       0,       0,       0,       
      0,       0,       0xAC7C,  0x53AA,  0x53AB,  0xAC7E,  0xAEE6,  0xAC78,  // 0x80Cx
      0xAC7B,  0xAD26,  0xAD24,  0xAEE0,  0x53AC,  0xAD2A,  0x53AF,  0xAD27,  
      0xAC7D,  0xAC7A,  0xAEE1,  0xAEDE,  0xBF2E,  0xAD25,  0x53A7,  0xAD28,  // 0x80Dx
      0xAC77,  0xAD22,  0x53A9,  0x53AE,  0xAD23,  0x53B2,  0x53B0,  0xAEE5,  
      0xAC79,  0x53AD,  0xAEE4,  0xAD21,  0x53B1,  0x53A8,  0xAD29,  0,       // 0x80Ex
      0,       0,       0,       0,       0,       0x57DE,  0xB3CC,  0x57E7,  
      0x57DC,  0x57DA,  0xB22E,  0x57E2,  0x57DF,  0xB230,  0xB3CA,  0xB3D2,  // 0x80Fx
      0x57E1,  0xB22F,  0xB22D,  0xB232,  0x57E6,  0x57E4,  0xBF2D,  0xB3CB,  
} ;


static const unsigned short Uni2cnsP0Table_81 [] = {
      0xB233,  0xB231,  0x57DB,  0xB3CE,  0xB3CD,  0x57DD,  0x57E0,  0xB3CF,  // 0x810x
      0x57E3,  0xAEE3,  0x57E5,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0xBEC4,  0xB852,  0x5CE9,  0xB8C9,  // 0x811x
      0xB849,  0xB84B,  0xB8C7,  0xB84C,  0x344D,  0xB854,  0xB850,  0xB84E,  
      0x3A3B,  0xB851,  0xB855,  0x5CEA,  0x5CEE,  0xB84A,  0x3447,  0xB853,  // 0x812x
      0x3450,  0x5CEC,  0xB8C1,  0x5CEB,  0xB84F,  0xB84D,  0xB8C2,  0x5CE8,  
      0x5CED,  0xB8C5,  0,       0,       0xB8C8,  0,       0,       0,       // 0x813x
      0,       0x61CE,  0xBF36,  0xBEBE,  0x3A3E,  0xBF34,  0x61D0,  0x3A47,  
      0xBEC3,  0xBEC5,  0xBEC1,  0xBF2F,  0xC646,  0xBEBD,  0x61CF,  0xBF33,  // 0x814x
      0xBEC0,  0xBEC2,  0xBF30,  0x61CB,  0x61D1,  0xBF35,  0x61CD,  0xBF32,  
      0x6ACF,  0x61CC,  0xBF31,  0x61D2,  0x61CA,  0x61C9,  0,       0,       // 0x815x
      0xC35A,  0,       0,       0xC63E,  0xC63C,  0xC3FB,  0xC642,  0xC3FE,  
      0xC63A,  0xC647,  0xC63F,  0xC3F5,  0xC639,  0x66A4,  0x66AA,  0xC644,  // 0x816x
      0x4029,  0xC63D,  0xC3F6,  0x66A7,  0xC3F7,  0xC4A3,  0x66A5,  0xC645,  
      0x66A2,  0x66A1,  0xC640,  0x66A6,  0x61D3,  0xC3FC,  0xC643,  0xC63B,  // 0x817x
      0x66A3,  0x66A8,  0x66A9,  0,       0,       0xC4A2,  0,       0x6AD4,  
      0x6AD0,  0xC9A7,  0x6AD5,  0xCD2D,  0xC9AA,  0x4639,  0xCD2C,  0xCD2E,  // 0x818x
      0x6AD2,  0xCD2B,  0x6AD3,  0xCD31,  0xCD30,  0xCD2F,  0x4646,  0x6AD1,  
      0x5267,  0,       0xCEBB,  0xCEBD,  0xCEB9,  0xD32A,  0xCEBC,  0xD32D,  // 0x819x
      0x6ED1,  0xD32C,  0x6ED0,  0x6ECC,  0x6ECD,  0x6ECE,  0xD329,  0xD328,  
      0x6ECF,  0xCEBA,  0xD32B,  0xD327,  0,       0,       0xD955,  0xD95F,  // 0x81Ax
      0x71F9,  0x71F8,  0xD2C9,  0xD959,  0xD95B,  0xD2C7,  0xD956,  0xD2C4,  
      0xD95A,  0xD954,  0xD95D,  0x71F7,  0xD95C,  0xD958,  0,       0xD95E,  // 0x81Bx
      0xD6A3,  0xD957,  0x74FE,  0xDE55,  0xDE5B,  0x75A4,  0x75A6,  0x75A3,  
      0x75A2,  0x5827,  0x75A1,  0x74FD,  0xDE56,  0xDE59,  0x74FC,  0xDE5A,  // 0x81Cx
      0xD6A4,  0x75A5,  0xDE58,  0xC8FC,  0xDE57,  0x77AC,  0xD8E5,  0x77AD,  
      0xE26B,  0xE269,  0xE26A,  0,       0xDAF7,  0xE64C,  0xDAF8,  0xE64B,  // 0x81Dx
      0x78E9,  0xE961,  0x7AAF,  0xE960,  0,       0xEB7E,  0xED72,  0x7BF0,  
      0xF132,  0xF133,  0x7CC4,  0x48DB,  0x276C,  0x4FBA,  0xBF37,  0x6AD6,  // 0x81Ex
      0x75A7,  0xDE5C,  0x48DC,  0x2473,  0x57E9,  0x57E8,  0xBF38,  0xBEC7,  
      0x3A4C,  0x4C62,  0xD960,  0x48DD,  0x53B3,  0x3A4D,  0xBEC8,  0xBF39,  // 0x81Fx
      0xBF3A,  0xBF3B,  0x6AD7,  0x71FA,  0x48DE,  0x276D,  0x4FBB,  0xAD2B,  
} ;


static const unsigned short Uni2cnsP0Table_82 [] = {
      0x57EA,  0xB234,  0x5CEF,  0xBEC9,  0xBF3C,  0x66AB,  0,       0x6AD8,  // 0x820x
      0x71FB,  0x75A8,  0x77AE,  0xE64D,  0x48DF,  0x4FBC,  0xAADD,  0x276E,  
      0x57EB,  0xB856,  0x61D4,  0xC9AB,  0x6AD9,  0xCD32,  0xD32E,  0,       // 0x821x
      0xD2CA,  0xD8E8,  0xDAF9,  0x48E0,  0x61D5,  0xC648,  0x6ADA,  0x48E1,  
      0xA851,  0xAD2C,  0x53B4,  0,       0xAEE8,  0xB236,  0x2F4F,  0xB3D7,  // 0x822x
      0x57EE,  0xB3D8,  0x57EC,  0x57ED,  0x57EF,  0xB3D5,  0,       0xB235,  
      0,       0,       0xB85B,  0xB858,  0xB85A,  0x5CF0,  0x5CF2,  0x5CF1,  // 0x823x
      0xB857,  0x5CF3,  0xB859,  0,       0xBF3D,  0xBF3E,  0,       0xBF3F,  
      0xC64B,  0xC4A6,  0xC64C,  0x402E,  0xC64A,  0xC64D,  0x402D,  0x66AC,  // 0x824x
      0xE6B4,  0xC649,  0xC9AD,  0x6ADB,  0xC9AE,  0,       0xD333,  0xD32F,  
      0xD332,  0xD334,  0xD331,  0xD330,  0,       0xD961,  0xD962,  0xD963,  // 0x825x
      0x71FC,  0x71FD,  0xDE5E,  0xDE5D,  0xDE5F,  0,       0xE26D,  0xE26C,  
      0,       0xE64F,  0xDAFA,  0xE650,  0xE64E,  0xDAFB,  0x7AB0,  0x642C,  // 0x826x
      0xE962,  0xE963,  0xDED5,  0xED73,  0xEF3E,  0xF049,  0x48E2,  0x4BC0,  
      0,       0x75A9,  0x48E3,  0xB2B2,  0xB85C,  0xBF40,  0xDAFC,  0x7CEC,  // 0x827x
      0xA26A,  0x2153,  0,       0xA4B8,  0xA26B,  0xA26D,  0x48E4,  0xA26E,  
      0xA26C,  0x232F,  0,       0xA522,  0xA523,  0xA47B,  0xA7A8,  0x247B,  // 0x828x
      0,       0x2475,  0xA521,  0x4BC2,  0xA7A9,  0x4BC3,  0xA47C,  0xA47A,  
      0xA479,  0xA47D,  0x4BC1,  0xA47E,  0xAD2D,  0xA7AB,  0x2479,  0,       // 0x829x
      0xA856,  0x4FBF,  0xA855,  0xA857,  0xAAE0,  0x4FBE,  0xA85C,  0x4FC2,  
      0xA852,  0xA860,  0xA866,  0x4FC9,  0xA863,  0x4FC6,  0xAAEB,  0xA859,  // 0x82Ax
      0xA85F,  0xA861,  0xAAE6,  0xA854,  0x4FC5,  0x4FC0,  0xA85A,  0x4FC7,  
      0x4FCA,  0x4FC4,  0xAAEC,  0x4FBD,  0xA85E,  0xA858,  0xA865,  0x4FCC,  // 0x82Bx
      0x4FC8,  0x4FC3,  0xA85D,  0x57F0,  0xA85B,  0x4FC1,  0x4FCB,  0x277A,  
      0xA853,  0x277E,  0xA862,  0xA864,  0xAADE,  0xA8E3,  0,       0,       // 0x82Cx
      0,       0xAAE8,  0x277B,  0,       0,       0,       0,       0,       
      0xAEF6,  0x53C5,  0x53BF,  0x53C7,  0x53C4,  0xAD34,  0xAD37,  0x53C0,  // 0x82Dx
      0xAEEA,  0xAD2E,  0x2B3A,  0x53B9,  0x53C3,  0xAEEB,  0x53C6,  0x53C8,  
      0xAD43,  0xAD3A,  0xAEF8,  0x53B8,  0xAD42,  0x53BC,  0x53BA,  0x53B5,  // 0x82Ex
      0xAD32,  0xAEF2,  0xAD41,  0xAD36,  0xAD39,  0xAD46,  0xAEF4,  0x53C9,  
      0xAD40,  0x53C1,  0xAD3B,  0xAD45,  0xAD38,  0xAD3C,  0xAD3F,  0xAEE9,  // 0x82Fx
      0xAEEE,  0xAD30,  0xAD44,  0xAD3E,  0xAEEF,  0xAEFA,  0xAD2F,  0xB43C,  
} ;


static const unsigned short Uni2cnsP0Table_83 [] = {
      0xAD33,  0x53C2,  0x53BD,  0x53B6,  0x53BB,  0x53B7,  0x53CA,  0xAD31,  // 0x830x
      0xB247,  0x53BE,  0x2B3D,  0xAEF9,  0xAD3D,  0xA942,  0xAEF7,  0,       
      0xE6B5,  0,       0xE6B7,  0,       0,       0,       0xB24A,  0x57FE,  // 0x831x
      0xB3E2,  0xB23A,  0x2F5D,  0xB245,  0xB241,  0xB8CD,  0xB254,  0xB3D9,  
      0xB24C,  0xB3DF,  0xB242,  0xB8DB,  0xB24B,  0xB23C,  0xB240,  0xB257,  // 0x832x
      0x58A3,  0xB24F,  0xB246,  0x57F1,  0xB255,  0xB238,  0x2F5A,  0xB24E,  
      0x2F63,  0x58A2,  0x57FB,  0xB237,  0x57F9,  0x57F8,  0x57FD,  0xB24D,  // 0x833x
      0x57F5,  0x57FC,  0xAD35,  0xBF41,  0xB248,  0x2F5F,  0xAADF,  0xB23E,  
      0x58A1,  0xB23F,  0xB243,  0x58A4,  0xB239,  0xB251,  0xBED7,  0xB250,  // 0x834x
      0xB258,  0x57F7,  0x57F4,  0xB256,  0xB252,  0xB249,  0xB244,  0x57FA,  
      0x57F6,  0xB23B,  0x57F2,  0xB253,  0x57F3,  0x2F5C,  0xB23D,  0xB3DA,  // 0x835x
      0xB3E3,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0xE6B6,  0xADB3,  0,       0,       0,       0,       // 0x836x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x3467,  0xB8CE,  0xB8D1,  0xB862,  0xB864,  0xB869,  0xB87D,  0x5DA3,  // 0x837x
      0x5CF7,  0xB8D4,  0xB861,  0x5DA4,  0x5DA5,  0xB86C,  0xB873,  0xB879,  
      0xB8D0,  0xB866,  0x346D,  0xB86D,  0xB8CF,  0xB8DD,  0x5DA6,  0xB87B,  // 0x838x
      0xB876,  0x5DA1,  0x5CFD,  0xB872,  0xB86E,  0xB860,  0x5CF4,  0xB865,  
      0xB85D,  0xB8D5,  0x5CFC,  0x5CFE,  0xB86A,  0xB867,  0x5CF9,  0xB877,  // 0x839x
      0x5CF6,  0xB868,  0xBF6A,  0xB870,  0xB8DE,  0xB86F,  0x5CF5,  0xB8D7,  
      0x5DA2,  0xB8D2,  0x5CF8,  0xB85E,  0xB863,  0xB874,  0xB87A,  0x5DA7,  // 0x83Ax
      0xB85F,  0xB86B,  0xB871,  0x5CFB,  0x346F,  0xB8D8,  0xB87C,  0xB875,  
      0xB878,  0,       0,       0,       0,       0,       0,       0xB8DF,  // 0x83Bx
      0,       0xB7F8,  0,       0,       0,       0x5CFA,  0x3A68,  0xBF51,  
      0xBF45,  0x61DD,  0xBF62,  0xBF6B,  0xBF6E,  0x61DB,  0xBF4D,  0xBF66,  // 0x83Cx
      0xBF4E,  0xBF5C,  0x61E8,  0xBF58,  0x61E5,  0xBEDE,  0xBF59,  0xBF42,  
      0x3BEF,  0xBF67,  0xBECF,  0xBED9,  0x61EE,  0xBF64,  0xBF5A,  0xBF70,  // 0x83Dx
      0xBF55,  0xC66D,  0xBECD,  0xBF73,  0x61EC,  0xBF53,  0xBF5F,  0x61EF,  
      0x61DA,  0xBF57,  0xBF71,  0xBF50,  0xBF49,  0xBF54,  0xBEDF,  0xBF48,  // 0x83Ex
      0xBF46,  0x61D6,  0xBF68,  0xBF4F,  0xBF6C,  0xBECB,  0xBF6D,  0x61DE,  
      0x61E3,  0x61DF,  0x61E7,  0xBF63,  0x61E0,  0xBF5B,  0xBF4B,  0xBEE6,  // 0x83Fx
      0x61D8,  0xBF43,  0xBF65,  0xBF6F,  0xBF4A,  0x61E6,  0xBF74,  0xBF56,  
} ;


static const unsigned short Uni2cnsP0Table_84 [] = {
      0xBED2,  0xBF52,  0xBEDC,  0x61D7,  0x61EB,  0xBEDA,  0xBF61,  0x61ED,  // 0x840x
      0xBED0,  0xBF5D,  0x61E2,  0x61DC,  0x61E4,  0x61D9,  0x61EA,  0xBF5E,  
      0xBF4C,  0xBF60,  0xBF47,  0xBF69,  0xBED8,  0x3A67,  0xBEDD,  0xBED6,  // 0x841x
      0xBECE,  0,       0,       0xBF72,  0,       0,       0xE6B9,  0xBEDB,  
      0,       0xE6B8,  0,       0xBF44,  0,       0,       0,       0,       // 0x842x
      0,       0xC66C,  0xC4AD,  0xC724,  0x65DC,  0xC671,  0xC4B1,  0xC66F,  
      0xC65A,  0x66B0,  0xC66A,  0xC67E,  0xC666,  0x66B8,  0xC67D,  0xC664,  // 0x843x
      0x61E9,  0xC674,  0xC665,  0xC67B,  0x66B7,  0x66AF,  0xC4BA,  0xC64F,  
      0xC657,  0xC4B5,  0xC670,  0xC668,  0xC723,  0xC66B,  0x66BD,  0xC67C,  // 0x844x
      0xC4AC,  0x66B4,  0xC4BE,  0xC66E,  0xC676,  0xC65B,  0xC675,  0xC4A7,  
      0xC728,  0xC656,  0xC677,  0xC4B3,  0xC726,  0xC4BF,  0xC650,  0x61E1,  // 0x845x
      0xC4C0,  0xC65E,  0xC65D,  0x66B6,  0xC4B2,  0xC661,  0xC663,  0xC672,  
      0xC725,  0x66B9,  0xC4B8,  0x66BA,  0xC4B0,  0xC655,  0x66B2,  0xC659,  // 0x846x
      0xC721,  0x66BB,  0x4044,  0x66B3,  0x66B5,  0x66BC,  0xC727,  0xC678,  
      0xC673,  0xC4BC,  0xC4AF,  0xC660,  0xC65F,  0x66B1,  0xC651,  0x66AE,  // 0x847x
      0xC669,  0xC652,  0xC667,  0xC4AE,  0x4041,  0xC65C,  0xC722,  0xC4AA,  
      0xC4B9,  0x4036,  0x66AD,  0xC4BB,  0xC4A8,  0,       0xC658,  0,       // 0x848x
      0x4046,  0,       0,       0,       0,       0xC654,  0xC67A,  0xC653,  
      0x6AE8,  0xCD5A,  0xC9B5,  0xC9C4,  0xCD49,  0xC9B3,  0xC9B8,  0xCD33,  // 0x849x
      0xCD51,  0x6AE0,  0xCD42,  0xCD4C,  0x6AE3,  0xCD45,  0x6AE1,  0xCD36,  
      0xCD54,  0xCD35,  0xCD48,  0xC9BC,  0xCD34,  0xC9B9,  0x466C,  0xCD46,  // 0x84Ax
      0xCD4F,  0xCD4D,  0xCD41,  0xCD3C,  0xCD3A,  0xC9C2,  0xCD3B,  0xCD4E,  
      0xCD59,  0xCD43,  0x6AE2,  0xC9BB,  0xCD3E,  0xC9BA,  0xCD52,  0xC9C1,  // 0x84Bx
      0x6AE5,  0xCD3D,  0xCD37,  0xCD47,  0x6AE9,  0xC9B2,  0x4658,  0x6ADD,  
      0x6AE6,  0xCD3F,  0xCD39,  0xC9B6,  0x6ADF,  0xC679,  0x6ADE,  0xCD4A,  // 0x84Cx
      0xC4B6,  0x6ADC,  0x6AEB,  0x6AE4,  0xCD4B,  0xCD40,  0xCD38,  0xCD53,  
      0xCD44,  0x6AEA,  0xCD57,  0x6AE7,  0xCD56,  0xC9BF,  0xCD50,  0xCD55,  // 0x84Dx
      0xC9BE,  0,       0xC9C3,  0xCD58,  0,       0,       0xE6BB,  0,       
      0,       0xE6BC,  0xE6BA,  0,       0xC9BD,  0,       0,       0xD35C,  // 0x84Ex
      0xD35D,  0xD350,  0xD34F,  0xD34B,  0x6EDD,  0xCECF,  0x6ED5,  0xD35F,  
      0xD35E,  0xC64E,  0xD348,  0xD34C,  0xD346,  0xCEC4,  0xD359,  0xD34A,  // 0x84Fx
      0xCEC2,  0xD360,  0xD343,  0xD341,  0xD34D,  0xD357,  0xD352,  0x6EDF,  
} ;


static const unsigned short Uni2cnsP0Table_85 [] = {
      0xD338,  0xCEC0,  0xD356,  0xCECC,  0xCEC6,  0xCED4,  0x6EE0,  0xC662,  // 0x850x
      0xD344,  0xD33B,  0xD33E,  0xD364,  0xD345,  0xD33C,  0xD33A,  0xD337,  
      0x4C7A,  0x6ED9,  0xD34E,  0x6ED8,  0x6EDC,  0xD349,  0xD351,  0x6ED2,  // 0x851x
      0xD361,  0xD365,  0x6ED4,  0xCECB,  0xD340,  0xD354,  0xD358,  0xD33D,  
      0xD362,  0x6EDB,  0x4C6A,  0x6EDA,  0xD335,  0x6EDE,  0xD35B,  0xD33F,  // 0x852x
      0xD353,  0xD339,  0xD347,  0xD342,  0x6ED6,  0x6ED7,  0xD355,  0xD366,  
      0xD363,  0xD35A,  0x4C78,  0xCECD,  0xCECE,  0xCED2,  0,       0,       // 0x853x
      0x4C74,  0,       0,       0xD336,  0,       0x6ED3,  0xD974,  0xD2DA,  
      0xD96B,  0xD96E,  0xD2D2,  0x72A5,  0xD970,  0xD965,  0xD96C,  0xD972,  // 0x854x
      0x72A2,  0x72A6,  0x71FE,  0xD2D9,  0xD2D0,  0xD967,  0xD977,  0x4D25,  
      0x5333,  0xD971,  0x5324,  0xD968,  0xDA22,  0xD97A,  0xD964,  0xDE72,  // 0x855x
      0xD96A,  0x72A1,  0xD2D8,  0xD975,  0xD2D4,  0xDA21,  0x72A9,  0xD2D6,  
      0xD97C,  0xD969,  0xD96F,  0xD973,  0xD96D,  0xDA23,  0xD97E,  0xD97B,  // 0x856x
      0x72A3,  0x72A4,  0x72A8,  0xD966,  0xDA24,  0x72A7,  0xD978,  0xD2CF,  
      0xD2D5,  0xD976,  0,       0xE6BD,  0,       0xD979,  0xDF21,  0xDE6C,  // 0x857x
      0xDE71,  0xDE7E,  0xDE70,  0xDE68,  0xDE6D,  0x583E,  0x75AC,  0xD6AB,  
      0xDE61,  0xDE79,  0xDE7B,  0xDE60,  0x75AB,  0xDE7D,  0xDE75,  0x75B2,  // 0x858x
      0xDE7C,  0xDE6E,  0x75B4,  0xDE66,  0xD97D,  0xDE76,  0xDE73,  0xDE62,  
      0xDF23,  0x75AE,  0xD6A8,  0xD6A9,  0x75AF,  0xDE64,  0xDE74,  0xD6AD,  // 0x859x
      0xDF22,  0xDE77,  0xDE6A,  0x75B1,  0x75AD,  0xDE78,  0xDE6B,  0xDF24,  
      0xDE65,  0xDE6F,  0xDE7A,  0xDE67,  0xDE69,  0x5840,  0x75B5,  0xDE63,  // 0x85Ax
      0x75B3,  0x77B0,  0x75AA,  0xD6AC,  0xD6B0,  0,       0,       0x75B0,  
      0x77B4,  0xE27D,  0xD8EC,  0xE273,  0xE26E,  0xE274,  0xE27E,  0xE324,  // 0x85Bx
      0xE323,  0x77B6,  0x77B5,  0xD8EE,  0x5D2C,  0xE275,  0xE325,  0xE278,  
      0xE270,  0xD8EF,  0xE272,  0xE271,  0xE277,  0xE27C,  0xE26F,  0xE276,  // 0x85Cx
      0xE27B,  0x77B3,  0x5D28,  0xE279,  0xD8EB,  0x77B1,  0xE27A,  0x77AF,  
      0x77B2,  0xE660,  0xE321,  0,       0xE6BE,  0x78ED,  0xDAFE,  0xE658,  // 0x85Dx
      0xE65C,  0xE654,  0xE657,  0xDAFD,  0xE65F,  0x78EB,  0xE664,  0xE65D,  
      0x607A,  0xE655,  0xE665,  0xE65E,  0x78EE,  0x78EF,  0xE662,  0xDBA2,  // 0x85Ex
      0xE656,  0x78EA,  0x78EC,  0xE651,  0xE659,  0xE653,  0xDCFB,  0xE663,  
      0xE661,  0xE652,  0xE65A,  0x607B,  0xDBA5,  0xE6BF,  0xE96A,  0x78F0,  // 0x85Fx
      0xE65B,  0x7AB2,  0x7AB4,  0x7AB1,  0xDCF6,  0xE96F,  0xE967,  0xE965,  
} ;


static const unsigned short Uni2cnsP0Table_86 [] = {
      0xE969,  0xE966,  0xDCF8,  0xDCFC,  0xE96B,  0xE96D,  0x7AB5,  0x7AB7,  // 0x860x
      0xDDA2,  0xE96C,  0x7AB8,  0x7AB6,  0xE96E,  0xDCFE,  0x6437,  0xDDA3,  
      0xDCF7,  0x7AB3,  0,       0xDDA1,  0,       0xDEDB,  0xDEDA,  0x7BA1,  // 0x861x
      0xEC21,  0xEC27,  0x7BA3,  0xE968,  0xEC26,  0xDEDC,  0xEC2D,  0xEC24,  
      0xEC2B,  0xEC2A,  0xE964,  0xEC25,  0xE322,  0xEC2E,  0xEC23,  0xEC28,  // 0x862x
      0xDED8,  0xEC2C,  0xEC22,  0xDED6,  0xED77,  0x7BA2,  0xEC29,  0xDED7,  
      0,       0xEF43,  0xED78,  0xED76,  0xED74,  0xED75,  0xED79,  0xE6C0,  // 0x863x
      0x7CC5,  0xEF41,  0xEF3F,  0xEF44,  0xEF42,  0xE0C3,  0xEF45,  0x7CC6,  
      0xEF40,  0xE0AF,  0xE1C6,  0xF04A,  0,       0xE6C1,  0xF134,  0xF135,  // 0x864x
      0xF136,  0xE1C7,  0xE1FC,  0xF235,  0xF22D,  0xA26F,  0x4FCD,  0,       
      0x53CB,  0x2F68,  0xB25A,  0xB259,  0x58A5,  0x5DA8,  0xB921,  0xB8E3,  // 0x865x
      0xB8E0,  0xB87E,  0xB8E1,  0x61F0,  0x66BF,  0xBEE1,  0x66BE,  0x66C0,  
      0x49CE,  0xCD5B,  0xD367,  0xDA25,  0xDA27,  0xDA26,  0xB2E1,  0x75B6,  // 0x866x
      0xDF25,  0xE326,  0xF173,  0x48E5,  0xA7AD,  0xA869,  0xA86A,  0xA868,  
      0xA867,  0x4FCE,  0xE6C2,  0xAD4A,  0xAD48,  0xAFA3,  0xAEFC,  0xAD47,  // 0x867x
      0xAEFE,  0x53CC,  0x53CE,  0x53CD,  0xAD49,  0xAFA4,  0xADBE,  0,       
      0,       0,       0,       0,       0xB3E9,  0xB266,  0xB263,  0xB261,  // 0x868x
      0x2F6D,  0xB3EC,  0x58A6,  0xB264,  0x58AB,  0xB25E,  0xB26D,  0xB3EF,  
      0xB26F,  0xB25F,  0xB3EE,  0x58A8,  0xB270,  0xB26B,  0xB25D,  0xB262,  // 0x869x
      0xB26C,  0xB268,  0xB265,  0xB3EB,  0x58AD,  0xB26E,  0xB260,  0xB3EA,  
      0xB3F0,  0xB269,  0xB25B,  0x58AC,  0x58A9,  0xB267,  0xB3ED,  0xB26A,  // 0x86Ax
      0xB25C,  0x58AA,  0x58A7,  0,       0,       0x347A,  0xB8E6,  0x5DB2,  
      0xB928,  0x5DB1,  0xB8E4,  0xB92B,  0xB92E,  0x5DAE,  0x5DAC,  0xB923,  // 0x86Bx
      0xB92C,  0xB92A,  0xB927,  0xB92F,  0xB930,  0xB932,  0xB933,  0xB922,  
      0x5DAB,  0xB925,  0xB924,  0xB931,  0x5DAD,  0xB926,  0x5DAF,  0x5DAA,  // 0x86Cx
      0xB929,  0x5DB3,  0x3526,  0x5DB0,  0xB92D,  0,       0,       0xB8BA,  
      0x61F7,  0xC025,  0x3A71,  0xBF78,  0x61F4,  0xBEE2,  0xC72E,  0xC023,  // 0x86Dx
      0xBF75,  0x61F2,  0xBF7A,  0x61F5,  0xBF7E,  0xBF7C,  0x61F8,  0x61F1,  
      0x3A76,  0xBEE3,  0xBF76,  0xBF79,  0x61F6,  0x3A6F,  0xBF77,  0x3BFB,  // 0x86Ex
      0xC024,  0xC022,  0xBF7B,  0xBF7D,  0xC021,  0x61F3,  0xBEE8,  0,       
      0,       0,       0,       0,       0,       0xC72F,  0xC735,  0xC72B,  // 0x86Fx
      0xC731,  0x66C1,  0xC72D,  0x66C7,  0xC4C4,  0xC4C5,  0x66C6,  0xC4C9,  
} ;


static const unsigned short Uni2cnsP0Table_87 [] = {
      0x66C5,  0xC734,  0x66C8,  0x66C9,  0xC72A,  0xC737,  0x66CA,  0x66C4,  // 0x870x
      0x66C3,  0xC733,  0x66CB,  0xC729,  0xC72C,  0xC736,  0xC732,  0x4059,  
      0x4052,  0xCD7B,  0xCD70,  0x66C2,  0x42DD,  0xC4C6,  0xC4C8,  0,       // 0x871x
      0x6AF2,  0xCD64,  0xCD79,  0xCD65,  0x6AED,  0xC9CF,  0xCD62,  0x4055,  
      0xCD6B,  0xCD63,  0x6AEF,  0xCD5D,  0xCD78,  0x6AF0,  0xCD75,  0xCD76,  // 0x872x
      0xCD5E,  0x6AF5,  0xCD6D,  0xC9CA,  0xCD67,  0xCD6E,  0xCD61,  0x467E,  
      0xCD7A,  0xCD72,  0xCD6C,  0xCD5C,  0x6AF1,  0xCD73,  0xC9C5,  0x6AF4,  // 0x873x
      0xCD77,  0xC9CC,  0xCD71,  0x6AEE,  0xCD6F,  0xC9C9,  0xCD69,  0x6AEC,  
      0xCD60,  0xCD68,  0xCD74,  0xCD66,  0xCCB3,  0xC9CE,  0xCD6A,  0xC9CB,  // 0x874x
      0,       0,       0xE6C3,  0,       0x6EEA,  0xC730,  0xD379,  0xD424,  
      0xD378,  0xD374,  0xD371,  0x6EEB,  0xD36F,  0x6AF3,  0xD368,  0x6EE9,  // 0x875x
      0xD36E,  0x6EE8,  0xD373,  0xD370,  0xD422,  0xD37B,  0xD375,  0xD37A,  
      0x6EE4,  0xD372,  0xD427,  0xD369,  0xD36A,  0xD423,  0x6EE5,  0xD428,  // 0x876x
      0x6EE7,  0xD429,  0xD377,  0xCD5F,  0xD37D,  0xD376,  0xD421,  0xD37C,  
      0x50D5,  0xCEDD,  0x4D28,  0xD36D,  0x6EE2,  0xD426,  0x6EE3,  0xD36B,  // 0x877x
      0x6EE6,  0xDA32,  0xD37E,  0xD425,  0x4D31,  0xCED9,  0,       0,       
      0,       0xDA2F,  0x6EE1,  0x72AA,  0xDA39,  0xDA35,  0x533C,  0xDA33,  // 0x878x
      0xDA2E,  0xDA3D,  0xD2DB,  0xD2DD,  0x5344,  0x72AE,  0xD2DF,  0xDA2A,  
      0xDA36,  0xDA37,  0xDA2D,  0xDA2C,  0xDA3A,  0x5341,  0xDA30,  0xDA2B,  // 0x879x
      0xDA31,  0xD2E2,  0xDA3C,  0xDA29,  0xDA3B,  0xDA38,  0x72AC,  0x72AB,  
      0x5339,  0xD2DE,  0x72AD,  0xDA34,  0xDA28,  0xE6C5,  0,       0,       // 0x87Ax
      0,       0xE6C4,  0xDF27,  0x75BC,  0xDF2B,  0xDF28,  0xDF2F,  0xDF35,  
      0xDF2A,  0xD6BA,  0xDF3E,  0x75B9,  0xDF38,  0xDF2D,  0xDF39,  0xDF34,  // 0x87Bx
      0xDF3B,  0xDF2C,  0x75BE,  0x75BD,  0xDF2E,  0xDF3C,  0xDF26,  0xDF3A,  
      0x75B7,  0xD6B9,  0xDF32,  0xDF31,  0xDF36,  0xDF29,  0x75BB,  0xD6BB,  // 0x87Cx
      0x75BF,  0xDF30,  0xDF37,  0x75C0,  0xDF33,  0xD6B6,  0xD6B4,  0,       
      0,       0x75B8,  0x75BA,  0xE333,  0xE331,  0xDBA8,  0xD8F6,  0xE337,  // 0x87Dx
      0xE335,  0xE338,  0xD8F8,  0xE32A,  0xE332,  0xE33C,  0xDF3D,  0xE32E,  
      0x77BA,  0xD36C,  0xE329,  0xE336,  0xE330,  0xE32D,  0xE328,  0xE327,  // 0x87Ex
      0xE33B,  0xD8F3,  0xE32C,  0xE32B,  0x77B8,  0xE334,  0xD8F4,  0x77B7,  
      0xD8F5,  0x64C8,  0x77B9,  0xE32F,  0xE33A,  0xE6C6,  0xE669,  0xE66A,  // 0x87Fx
      0xDBAC,  0x78F4,  0xE667,  0x78F1,  0xE66F,  0xDBA7,  0x78F5,  0xE671,  
} ;


static const unsigned short Uni2cnsP0Table_88 [] = {
      0xE666,  0xE339,  0xE673,  0xE668,  0x69C3,  0x78F2,  0xE66E,  0xDBA9,  // 0x880x
      0xE670,  0xE66B,  0xE672,  0xE66D,  0xE66C,  0x78F3,  0xD8F7,  0xDBAB,  
      0xE971,  0xE972,  0xDDA5,  0xE974,  0x7AB9,  0x7ABA,  0xE975,  0xE973,  // 0x881x
      0xDDA4,  0xE970,  0xDEDD,  0xEC31,  0xEC34,  0xEC30,  0x6126,  0x7BA7,  
      0xEC32,  0x7BA6,  0x7BA5,  0x7BA4,  0xEC33,  0xED7E,  0xED7C,  0xDFDF,  // 0x882x
      0xED7B,  0xEC2F,  0xED7D,  0xEC35,  0xED7A,  0xE0C5,  0xEF48,  0xEF26,  
      0xEF46,  0x7CC7,  0xEF47,  0xEF49,  0xE6C7,  0xF04D,  0x7CE6,  0xF04C,  // 0x883x
      0xF04B,  0x7CE7,  0x6C23,  0x7DA7,  0xF15D,  0xF175,  0xF174,  0xF176,  
      0x48E6,  0xAD4B,  0xAFA6,  0xB271,  0xB272,  0xB8EA,  0xBEEA,  0xBEE9,  // 0x884x
      0xC026,  0xCE4F,  0xEC36,  0xF04E,  0x48E7,  0x53CF,  0xAD4C,  0xB3F1,  
      0xE6C8,  0x3527,  0xB934,  0x5DB4,  0,       0xC028,  0xC027,  0x61F9,  // 0x885x
      0xC4CD,  0x66CC,  0xD42A,  0x6EEC,  0xCEDF,  0x6EED,  0xD2E3,  0xD2E4,  
      0x534B,  0x72AF,  0x7CE8,  0x48E8,  0,       0,       0xAFA7,  0xAD4D,  // 0x886x
      0x4FD0,  0xAD4F,  0xAD4E,  0x53D0,  0,       0xB273,  0xB3F4,  0xB27A,  
      0x58AE,  0xB278,  0xB276,  0xB3F7,  0xB27D,  0xB274,  0xB275,  0x58AF,  // 0x887x
      0xB3F2,  0x58B3,  0xB3F3,  0xB3F5,  0xB27E,  0x58B2,  0xB27C,  0xB279,  
      0xB277,  0x58B0,  0x58B1,  0xB27B,  0xB3F6,  0,       0,       0xE6C9,  // 0x888x
      0x5DB6,  0xB935,  0xB8F2,  0x5DBB,  0xB945,  0x5DBA,  0xB947,  0xB8EE,  
      0xB8F4,  0xB93B,  0x5DB8,  0xB946,  0xB8EC,  0xB936,  0x5DB9,  0xB942,  // 0x889x
      0xB93E,  0xB940,  0xB93A,  0xB941,  0xB8EB,  0x352F,  0x5DB5,  0xB93D,  
      0xB8F3,  0xB93C,  0xB938,  0xB8ED,  0xB943,  0xB8EF,  0xB8F1,  0xB93F,  // 0x88Ax
      0xB937,  0xB8F0,  0xB939,  0x5DB7,  0xB944,  0,       0,       0,       
      0,       0x61FC,  0xC033,  0x3A7B,  0xBEF0,  0xBEF2,  0xC02F,  0xC031,  // 0x88Bx
      0xC02C,  0xC02B,  0xC029,  0xBEED,  0xC030,  0xC032,  0xC02E,  0xBEEF,  
      0xC02D,  0x61FA,  0x61FB,  0,       0,       0,       0,       0,       // 0x88Cx
      0,       0xC035,  0x66D4,  0xC739,  0xC73F,  0xC73A,  0xC73B,  0xC4CE,  
      0xC740,  0x42EC,  0x66D6,  0x4061,  0x66CE,  0x66D5,  0xC738,  0xC02A,  // 0x88Dx
      0x66D1,  0x66CF,  0xC73E,  0xC73D,  0x66D0,  0x66D2,  0xC73C,  0x66CD,  
      0xC4CF,  0x66D3,  0,       0,       0,       0,       0xCEE0,  0xCD7D,  // 0x88Ex
      0x6AFC,  0xC9D9,  0xC9D2,  0xCE2A,  0xCE29,  0xC9D7,  0xCE24,  0x6AFE,  
      0xCE28,  0xCD7E,  0xCE21,  0x6AF6,  0x6AF8,  0xC9D4,  0xCE26,  0xCD7C,  // 0x88Fx
      0x6AFA,  0x6AF9,  0xCE22,  0xCE27,  0xCE25,  0x6AFB,  0xCE23,  0xC9D1,  
} ;


static const unsigned short Uni2cnsP0Table_89 [] = {
      0xC9D6,  0xC034,  0x6AF7,  0xC9D8,  0,       0xD42B,  0xD432,  0x6EEF,  // 0x890x
      0x4D46,  0xD436,  0x6EF3,  0xD42E,  0xD42C,  0x4D3E,  0xD435,  0xCEE1,  
      0x6EEE,  0xD434,  0x6EF0,  0x6EF1,  0xD42D,  0x6EF2,  0xD433,  0xD42F,  // 0x891x
      0xD430,  0xD431,  0x6AFD,  0xCEE2,  0,       0,       0xDA3E,  0xDA4A,  
      0x5353,  0x72B4,  0xDA45,  0xDA47,  0xD2E5,  0x72B2,  0xDA3F,  0xDA43,  // 0x892x
      0x5350,  0xDA46,  0x72B0,  0x72B3,  0xDA49,  0xDA41,  0xDA42,  0xDA48,  
      0xDA40,  0xDA44,  0x72B1,  0xDF40,  0,       0xDF3F,  0x75C2,  0xDF45,  // 0x893x
      0x75C4,  0xD6C0,  0x5862,  0x75C1,  0xDF41,  0x75C5,  0xDF42,  0xD6BF,  
      0xD6BD,  0xDF43,  0xDF46,  0xD6C2,  0x75C3,  0,       0xE341,  0,       // 0x894x
      0xD8F9,  0xE344,  0xD8FA,  0xE33E,  0xE340,  0xD8FC,  0xD8FB,  0xE33F,  
      0xE342,  0xE343,  0xDF44,  0xE33D,  0xE6CA,  0,       0x78F8,  0xE677,  // 0x895x
      0xE67A,  0xE67C,  0xE675,  0xE676,  0xE679,  0xE67B,  0x78F9,  0x78F7,  
      0x78F6,  0xE678,  0xE674,  0xE976,  0x7ABB,  0xDDA9,  0xE977,  0xDDA8,  // 0x896x
      0,       0xEC38,  0x7BA8,  0xEC3A,  0x7BA9,  0xEC37,  0xEC39,  0x7BF2,  
      0x74B8,  0xEE21,  0x7BF1,  0xEF4C,  0xEF4B,  0x6C25,  0xEF4A,  0xE8CA,  // 0x897x
      0xE1C9,  0xF137,  0xF138,  0xF13A,  0xF139,  0xE1FD,  0xA270,  0x48E9,  
      0,       0x53D1,  0xB948,  0x61FD,  0xE6CB,  0xC741,  0x77BB,  0xDBAF,  // 0x898x
      0xE67D,  0xE0C6,  0xE1CA,  0x4BC4,  0xAFA9,  0x2F76,  0x2F75,  0x5DBD,  
      0x3534,  0xB8F6,  0xB8F5,  0x5DBC,  0xB8F7,  0xC036,  0x61FE,  0xC038,  // 0x899x
      0xC037,  0xCE60,  0xBEF4,  0xC742,  0x66D7,  0xCE2B,  0xCE2E,  0xCE2D,  
      0x4735,  0xCE2C,  0xD437,  0xD439,  0xD438,  0xCEE5,  0x72B6,  0xD2E6,  // 0x89Ax
      0x5359,  0xCEE4,  0x72B5,  0xD6C6,  0x75C6,  0xDF47,  0xDF49,  0xDF48,  
      0xD8FE,  0xD8FD,  0x77BC,  0xD9A1,  0x612F,  0xDBB1,  0xE721,  0xE67E,  // 0x89Bx
      0xE3F7,  0xE978,  0x7ABC,  0xDDAA,  0xDEE1,  0x7BAA,  0xEE23,  0xEE22,  
      0x7DA8,  0,       0,       0,       0,       0,       0,       0,       // 0x89Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x4BC5,  0xAD50,  0x53D2,  0xB94B,  0xB949,  0x3539,  // 0x89Dx
      0x3538,  0xB94A,  0xC03A,  0xC03B,  0xC749,  0xC039,  0,       0xC743,  
      0xC747,  0xC746,  0xC748,  0x66D8,  0xC745,  0xC744,  0xC74A,  0xC4D4,  // 0x89Ex
      0xCE31,  0xCE2F,  0xC9DC,  0xCE30,  0xD43C,  0xD43A,  0xCEE6,  0,       
      0xD43B,  0xDA4B,  0xDF4A,  0xDF4B,  0x77BD,  0xDBB2,  0xE722,  0xE979,  // 0x89Fx
      0x7ABD,  0x6137,  0xEC3B,  0xEE24,  0x7BF3,  0x6945,  0xEF4D,  0xF13B,  
} ;


static const unsigned short Uni2cnsP0Table_8A [] = {
      0x4BC6,  0,       0x53D4,  0x53D5,  0xAD51,  0xAFAA,  0xAFAC,  0xAD52,  // 0x8A0x
      0x53D3,  0x2F7C,  0x58B9,  0xB3FB,  0x58B7,  0xB3FA,  0x58B6,  0x58BD,  
      0x58B5,  0x58BE,  0xB321,  0x58BB,  0x2F7D,  0x58B8,  0x58BC,  0x58BA,  // 0x8A1x
      0x58B4,  0xB3FC,  0,       0x5DC5,  0xB8FE,  0x5DBF,  0xB94F,  0x5DC4,  
      0xB9A3,  0xB9A9,  0x5DC6,  0x5DC0,  0xC470,  0x5DC1,  0xB8F9,  0xB94D,  // 0x8A2x
      0xB8FB,  0xB9A5,  0x5DBE,  0xB9A2,  0xB94E,  0x5DC3,  0x353D,  0x35DB,  
      0xB94C,  0x5DC2,  0xB8FA,  0,       0x62AB,  0xBEFC,  0x62AD,  0x3B2F,  // 0x8A3x
      0xBEFD,  0xC03E,  0x62AC,  0x62A1,  0x62A5,  0xBFA4,  0x66EB,  0xC74F,  
      0xC040,  0x62A6,  0xBEFE,  0xBEF5,  0xC043,  0xC044,  0x62AA,  0x3B30,  // 0x8A4x
      0xC046,  0xBFA1,  0xC048,  0xBFA3,  0xC049,  0xC03D,  0xC03C,  0xC04A,  
      0x62A9,  0xC047,  0xC045,  0x3B2C,  0x62A7,  0x62A3,  0x62AE,  0xC041,  // 0x8A5x
      0xC042,  0xC03F,  0xBEF8,  0x62A8,  0x3B31,  0xBFA2,  0x62A4,  0,       
      0x62A2,  0xC74E,  0x66E6,  0x66E1,  0xC4E0,  0xC4D9,  0x66DC,  0xC4E3,  // 0x8A6x
      0x66EC,  0x66DD,  0xC4D5,  0x66D9,  0x66E8,  0x66E5,  0x66E7,  0xC4D8,  
      0x66DE,  0x66E3,  0x66DA,  0x66DB,  0xC756,  0xC753,  0xC74B,  0xC750,  // 0x8A7x
      0xC4DB,  0x66E9,  0xC757,  0x66EA,  0x66E0,  0xC4DC,  0xC4E1,  0xC74D,  
      0xC4D6,  0xC755,  0xC751,  0xC754,  0xC752,  0x66E4,  0xC74C,  0x66DF,  // 0x8A8x
      0xC4DD,  0,       0,       0xCE34,  0x6BA2,  0x6BA5,  0xC9DF,  0xCE36,  
      0xC9E4,  0x6BAD,  0xCE35,  0x6BA7,  0xC9E3,  0x6EF8,  0xCE37,  0x4745,  // 0x8A9x
      0x6BAC,  0xCE33,  0x6BAE,  0xC9DE,  0xC9E2,  0xC9EB,  0x6BA3,  0xC9E8,  
      0x66E2,  0x6BA6,  0xC9E0,  0x6BA4,  0x6BA8,  0x6BAA,  0x6BA1,  0x6BAF,  // 0x8AAx
      0x6BAB,  0xC9E5,  0x6BA9,  0xCE32,  0xC9E6,  0xCCC1,  0,       0xCEF4,  
      0x6FA1,  0xCEE7,  0x6EFB,  0xCEF2,  0xCEF0,  0xCEEE,  0x6FA4,  0xCEEC,  // 0x8ABx
      0xD43F,  0x6FA5,  0xD44B,  0xD444,  0x6EF4,  0xD44C,  0xD446,  0x6EFE,  
      0xD447,  0xCEF3,  0x6EFD,  0xD44A,  0x6EF7,  0xD448,  0xD43E,  0x6EF6,  // 0x8ACx
      0xDA56,  0x6EFC,  0xCEF5,  0x6EF9,  0xCEE9,  0x6FA3,  0xCEEA,  0xD43D,  
      0xCEF6,  0xD441,  0x6EF5,  0xD440,  0xD442,  0xD443,  0x6FA2,  0xD445,  // 0x8ADx
      0xD449,  0xD44D,  0,       0x6FA6,  0x72BC,  0xDA51,  0xDA57,  0xDA54,  
      0xDA4C,  0xDA58,  0xDA4D,  0xD2EA,  0xDA53,  0xD2EB,  0x72B7,  0x72BD,  // 0x8AEx
      0xDA59,  0xCEEF,  0xD2E7,  0x72B9,  0xD2EE,  0x72C3,  0x72BE,  0xDA5B,  
      0xDA55,  0x72BA,  0xDA4E,  0x72C4,  0xDA4F,  0xDA50,  0x72C5,  0x72C2,  // 0x8AFx
      0x6EFA,  0xD2E9,  0x72B8,  0xDA5C,  0x72C6,  0xD2E8,  0x72BF,  0xDA5A,  
} ;


static const unsigned short Uni2cnsP0Table_8B [] = {
      0x72BB,  0x72C0,  0x72C1,  0xE6CC,  0x75CE,  0xDF50,  0xDF59,  0xDF56,  // 0x8B0x
      0xDF58,  0xD6C9,  0x75CB,  0xDF51,  0xD6CA,  0xDF57,  0x75C7,  0xDF53,  
      0x75CF,  0xDF4F,  0xDF54,  0xDF5B,  0xDA52,  0xDF55,  0xDF4E,  0x75C8,  // 0x8B1x
      0xDF4D,  0x75C9,  0xDF5C,  0x75CA,  0xDF5A,  0x75CD,  0xDF4C,  0xD6C8,  
      0x75CC,  0,       0xDF52,  0xE347,  0xE355,  0xE350,  0xE352,  0xE346,  // 0x8B2x
      0x77BE,  0xD9AA,  0xE345,  0x77C1,  0x77C0,  0xD9A6,  0xE354,  0xE34C,  
      0xE349,  0xE34F,  0xD9A4,  0xE348,  0xD9A8,  0xE34A,  0xE353,  0xE351,  // 0x8B3x
      0xD9A3,  0x77BF,  0xE358,  0xE356,  0xE34D,  0xE357,  0xE34E,  0xDBB4,  
      0xE726,  0x78FA,  0xE72D,  0xDBB5,  0x613A,  0xEC3E,  0x79A3,  0xE34B,  // 0x8B4x
      0xE724,  0x78FD,  0xE725,  0xE72A,  0xDBB6,  0xDDB3,  0x79A1,  0x79A2,  
      0xE723,  0xE72C,  0xE72E,  0xE727,  0xE729,  0xE72B,  0xE728,  0xE72F,  // 0x8B5x
      0x78FC,  0x79A4,  0x78FE,  0,       0x78FB,  0xE97C,  0x644D,  0x7AC2,  
      0xE97A,  0xDDB0,  0xDDAC,  0xE97E,  0xDDB2,  0xEA21,  0x7AC0,  0xEA22,  // 0x8B6x
      0xE97D,  0xDDAB,  0xE97B,  0x7AC3,  0x7ABF,  0xEA23,  0xDDAE,  0x7AC1,  
      0x7ABE,  0xDCED,  0,       0x673B,  0x7BAB,  0xDEE2,  0x6741,  0x7BAC,  // 0x8B7x
      0xEC3D,  0xEC3C,  0xEC3F,  0xEC40,  0xDEE3,  0x7BAD,  0xEE25,  0xEE2A,  
      0x7BF4,  0xDFE1,  0xEE27,  0xDFE2,  0xEE26,  0xEE29,  0xEE28,  0xE0C8,  // 0x8B8x
      0xEF51,  0x6A7C,  0x7CC8,  0xEF50,  0xEF4E,  0xE0C7,  0xEF4F,  0,       
      0xE0C9,  0xE0FB,  0x7CEA,  0x7CE9,  0xF04F,  0xF050,  0x7CEB,  0xE1CB,  // 0x8B9x
      0xF13C,  0xF13D,  0x7DB4,  0xE1EB,  0x7DBA,  0xE1FE,  0xF177,  0xF236,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8BFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_8C [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8C0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8C1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8C2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x4BC7,  // 0x8C3x
      0x30C6,  0xB950,  0xB9AA,  0xB951,  0xC758,  0xCE38,  0xD44E,  0x75D1,  
      0xD6CD,  0x75D0,  0xE359,  0xE730,  0xDFE4,  0xEF52,  0x4BC8,  0xB322,  // 0x8C4x
      0x58BF,  0x5DC7,  0xC75A,  0xC759,  0x6FA7,  0xD44F,  0x6FA8,  0xDF5D,  
      0x77C2,  0xDDB4,  0xE6CD,  0xE2A1,  0x7DC3,  0x4BC9,  0xA86B,  0xB323,  // 0x8C5x
      0xB9AD,  0x354D,  0x5DC8,  0xB9AC,  0xB952,  0xB953,  0xBFAA,  0xC04B,  
      0xBFA9,  0x62AF,  0x66ED,  0xC4E4,  0xC75C,  0xC75B,  0xC75D,  0xC9ED,  // 0x8C6x
      0xCE39,  0xCE3A,  0x6BB0,  0x72C7,  0x6FA9,  0x72C8,  0,       0xDF61,  
      0xDF5E,  0xDF60,  0xDF5F,  0x75D2,  0xD9AB,  0xE35A,  0xE732,  0xE731,  // 0x8C7x
      0xA524,  0x58C1,  0x58C0,  0xB324,  0xB9AE,  0xB954,  0xBFAC,  0xBFAB,  
      0xC04D,  0xC04C,  0x62B0,  0xBFAD,  0xC75F,  0xC760,  0xC75E,  0x4078,  // 0x8C8x
      0xC4E5,  0x66EF,  0x66EE,  0x4754,  0x6BB2,  0x6BB1,  0xCEFA,  0xD450,  
      0xDA5F,  0xDA5D,  0xDA5E,  0x72C9,  0xDF63,  0xDF62,  0xD6CF,  0xE35D,  // 0x8C9x
      0xE35C,  0xE35B,  0xE733,  0xE1CD,  0xF178,  0x4BCA,  0x53D6,  0xAFAE,  
      0x53D7,  0x58C2,  0x58C3,  0xB326,  0xB325,  0xB955,  0xB9B0,  0x5DCE,  // 0x8CAx
      0x5DCC,  0x5DC9,  0x5DCD,  0x5DCB,  0x5DCA,  0xB9B2,  0xB9B1,  0x62B1,  
      0xC050,  0xBFAF,  0x66F4,  0x62B3,  0x62B8,  0xC052,  0x62BA,  0x62B9,  // 0x8CBx
      0x62BC,  0xC051,  0xC04E,  0x62B6,  0x62B2,  0x62B4,  0xC04F,  0x62BB,  
      0x62B7,  0x62B5,  0x66F6,  0x66F5,  0x66F3,  0x66F7,  0x407E,  0x66F1,  // 0x8CCx
      0x66F2,  0xC4E9,  0x66F0,  0x43AD,  0xC761,  0xC4E7,  0,       0xCE3C,  
      0xC9F0,  0x6BB4,  0x6BB5,  0x6BB3,  0xC9F2,  0xCE3B,  0xC9F1,  0xCE3D,  // 0x8CDx
      0xE6CE,  0xD453,  0xD455,  0xCEFE,  0x6FB2,  0xD456,  0x6FAB,  0xD452,  
      0x6FAA,  0x6FB4,  0x6FB0,  0x6FB1,  0x6FAD,  0xD451,  0x6FAC,  0xD457,  // 0x8CEx
      0xD454,  0xCEFD,  0x6FB3,  0xCFA2,  0x6FAE,  0x6FAF,  0xDA61,  0xD2F5,  
      0xDA63,  0xDA62,  0xD2F3,  0xDA64,  0x72CA,  0xDA60,  0xD6D1,  0xD6D2,  // 0x8CFx
      0x75D6,  0xDF64,  0x75D3,  0x75D7,  0x75D5,  0x75D4,  0xE35E,  0x5D69,  
} ;


static const unsigned short Uni2cnsP0Table_8D [] = {
      0xE361,  0xC3D2,  0xE360,  0xD9AE,  0xE35F,  0x77C3,  0xE734,  0xE735,  // 0x8D0x
      0x79A5,  0xE736,  0x79A6,  0xDBB8,  0xE6CF,  0x7AC5,  0x644F,  0x7AC4,  
      0xEC41,  0xDEE5,  0xDEE6,  0x7BAE,  0xEC42,  0xEE2B,  0x7BF5,  0x7BF6,  // 0x8D1x
      0xE6D0,  0xEF53,  0xE0CA,  0x7CED,  0xE1CE,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8D2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8D3x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8D4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8D5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x4BCB,  0xB9B3,  0x5DD0,  0x5DCF,  // 0x8D6x
      0xC762,  0xC763,  0,       0x6BB6,  0xDA65,  0x6FB5,  0xDA66,  0xDF65,  
      0x4BCC,  0xA4BA,  0xAD53,  0x53D9,  0x53D8,  0,       0xB327,  0x58C4,  // 0x8D7x
      0xB328,  0xB958,  0xB9B9,  0xB957,  0xB9B7,  0xB956,  0xB9B5,  0xB9B8,  
      0xC054,  0x62BF,  0xBFB9,  0xBFB4,  0xC053,  0x62BE,  0xBFB7,  0xBFB0,  // 0x8D8x
      0xBFB3,  0xC055,  0x62BD,  0xBFB8,  0xC765,  0xC768,  0xC766,  0xC767,  
      0xC76B,  0xC764,  0xC76C,  0xC769,  0xC76A,  0x6BB8,  0xCE3E,  0xC9F5,  // 0x8D9x
      0xC9F3,  0x6BB7,  0xC9F4,  0xD45B,  0xD459,  0xCFA6,  0x4D75,  0x6FB6,  
      0xD458,  0xD45A,  0xCFA5,  0x6FB7,  0xCFA3,  0xDA67,  0xD2F7,  0xDA68,  // 0x8DAx
      0x75D8,  0xD9B1,  0xE738,  0xE73A,  0xE737,  0xE739,  0xEA24,  0xEC43,  
      0xE6D1,  0,       0xF15E,  0x4BCD,  0x53DA,  0xB329,  0xB32B,  0xB32A,  // 0x8DBx
      0,       0xB95B,  0x5DD2,  0xB9BE,  0xB959,  0xB9BA,  0x5DD1,  0xB95C,  
      0xB9BD,  0xB95D,  0xB95A,  0xC538,  0,       0xC061,  0x62C7,  0xC059,  // 0x8DCx
      0xC05F,  0xBFBF,  0xBFBA,  0x62C2,  0x62C5,  0xC058,  0x62C0,  0xC05C,  
      0xC772,  0x62C4,  0xBFBB,  0xC057,  0xBFBE,  0xC05D,  0xC05A,  0xC060,  // 0x8DDx
      0xC056,  0xC05E,  0x62C3,  0x62C6,  0xC05B,  0x62C1,  0,       0x66F9,  
      0xC76E,  0x66F8,  0xC775,  0xC774,  0x67A1,  0,       0x67A2,  0xC776,  // 0x8DEx
      0x66FA,  0xC773,  0x66FE,  0xC778,  0xC76F,  0xC4EB,  0xC771,  0x66FB,  
      0xC76D,  0xC770,  0xC777,  0x66FC,  0xC779,  0,       0,       0,       // 0x8DFx
      0,       0,       0x66FD,  0,       0x6BB9,  0xCE43,  0xCE49,  0xCE41,  
} ;


static const unsigned short Uni2cnsP0Table_8E [] = {
      0xCE4A,  0xC9FB,  0xCE40,  0xCE45,  0xCE4B,  0xCE48,  0xCE47,  0xCE46,  // 0x8E0x
      0xC9FA,  0xCE3F,  0xCE44,  0xC9F9,  0,       0xCE42,  0,       0x6FBC,  
      0x6FB9,  0xD464,  0xD469,  0xD46B,  0xD468,  0xD461,  0xD463,  0xD46D,  // 0x8E1x
      0xD46A,  0xD465,  0xD46E,  0xD462,  0xD46C,  0x6FBA,  0x6FC0,  0x6FBE,  
      0xD45C,  0x6FBF,  0x6FBB,  0xD45D,  0xD45F,  0xD45E,  0xD466,  0xD467,  // 0x8E2x
      0xCFAC,  0x6FBD,  0xCFAB,  0x6FB8,  0,       0,       0xD460,  0,       
      0xDA72,  0x72CC,  0xD2FE,  0xDA69,  0x72CD,  0x72D0,  0xDA6E,  0x51C8,  // 0x8E3x
      0xDA6B,  0x72CF,  0x5429,  0xD2FB,  0xDA6F,  0xDA70,  0xDA6A,  0xDA73,  
      0xDA6C,  0xDA71,  0x72CE,  0xD2FC,  0x72CB,  0xDA6D,  0xD6D4,  0xDF6B,  // 0x8E4x
      0x75DB,  0x75D9,  0x75DC,  0x75DA,  0xDF6A,  0xDF67,  0xDF66,  0xD6D5,  
      0xDF69,  0x592D,  0,       0xDF68,  0xE36F,  0x77C9,  0xE366,  0xE365,  // 0x8E5x
      0xD9B2,  0x77C4,  0xE36B,  0xE36A,  0xE362,  0xE36D,  0xE367,  0x77C8,  
      0xE364,  0xE36C,  0xE363,  0x77C5,  0x77C7,  0xE368,  0x77C6,  0xE369,  // 0x8E6x
      0xDBBA,  0xE36E,  0xE73E,  0xDBB9,  0x79AB,  0xE73B,  0x6152,  0xE73F,  
      0xDBBB,  0x614F,  0x79A8,  0xE73D,  0x79AD,  0xDBBC,  0x79AA,  0xDBBD,  // 0x8E7x
      0xE73C,  0x6154,  0x79AC,  0xE740,  0x79A7,  0,       0,       0,       
      0,       0x7AC7,  0x7AC9,  0xDDB7,  0xEA27,  0x7AC8,  0xEA25,  0x79A9,  // 0x8E8x
      0xEA26,  0x7AC6,  0x7BAF,  0x7BB1,  0xEC45,  0x7BB0,  0xEC44,  0,       
      0xEE30,  0x7BF7,  0xEE2F,  0x7BF8,  0xEE2D,  0xEE2C,  0xEE31,  0xEE32,  // 0x8E9x
      0xEF54,  0xE0CB,  0xEE2E,  0,       0,       0xF054,  0xF051,  0xF052,  
      0xF053,  0x7DA9,  0xE1D0,  0xF140,  0xF13F,  0xF13E,  0xF15F,  0xE1EC,  // 0x8EAx
      0xF22E,  0xF179,  0x7DBB,  0x4BCE,  0x58C5,  0xB9BF,  0xB8EC,  0xB9C0,  
      0xBFC0,  0xC4F3,  0x67A3,  0xC9FD,  0xC9FC,  0,       0xCFB0,  0xCFB2,  // 0x8EBx
      0xCFAF,  0xCFB1,  0x6FC1,  0,       0xE6D2,  0xDA74,  0xD8B3,  0xD9B5,  
      0x77CA,  0xD9B6,  0xE741,  0xDBBF,  0x6156,  0,       0xDDB8,  0x6751,  // 0x8ECx
      0,       0xF17A,  0x4BCF,  0x4FD1,  0x53DC,  0x53DB,  0x30D5,  0x58C8,  
      0xB4A1,  0xB32C,  0x58C6,  0xB32D,  0x58C7,  0xE6D3,  0xB9C1,  0xB962,  // 0x8EDx
      0xB95E,  0xB9C7,  0x3563,  0x5DD3,  0xB961,  0xB960,  0xB95F,  0x5DD4,  
      0xB963,  0xB964,  0,       0,       0xBFC5,  0xC068,  0xC066,  0xC06A,  // 0x8EEx
      0xC06B,  0xC071,  0xBFC7,  0xC06D,  0xC06F,  0x43D0,  0xC067,  0xC062,  
      0x3B55,  0xC06E,  0xBFC4,  0xBFC6,  0xC070,  0xC069,  0xC06C,  0xC063,  // 0x8EFx
      0x62C9,  0xC065,  0xC064,  0x62C8,  0x62CA,  0xBFC9,  0x67A6,  0xC77B,  
} ;


static const unsigned short Uni2cnsP0Table_8F [] = {
      0xC77D,  0xC77C,  0xC823,  0x67A4,  0xC4F6,  0xC77E,  0xC77A,  0xC821,  // 0x8F0x
      0xC822,  0x67A5,  0x67A7,  0xC824,  0,       0xCE4F,  0xCE4E,  0x476A,  
      0xCE4C,  0xCE4D,  0x6BBB,  0x6BBD,  0x6BBA,  0x6BBC,  0xD475,  0xD476,  // 0x8F1x
      0xD471,  0xCFB6,  0xD472,  0x6FC3,  0x6FC8,  0x6FC2,  0x6FC9,  0x6FC4,  
      0xD473,  0x4E2D,  0xCFB3,  0xD474,  0xD470,  0x6FCA,  0x6FC6,  0xCFB5,  // 0x8F2x
      0x4E2B,  0x6FC5,  0x6FC7,  0xCFB4,  0xD46F,  0xD3A4,  0xDA76,  0x72D2,  
      0xD3A2,  0xD3A1,  0xDA78,  0x72D4,  0xDA7B,  0xDA77,  0xDA75,  0xDA7A,  // 0x8F3x
      0x72D3,  0xDA79,  0xB4B2,  0x72D1,  0xD3A5,  0xD6D9,  0x75DE,  0x75E1,  
      0xDF6D,  0xD6DA,  0x75DF,  0xDF6C,  0x75DD,  0x75E0,  0xE370,  0xE371,  // 0x8F4x
      0xE372,  0x77CB,  0xD9B7,  0xE373,  0,       0x77CC,  0x79AF,  0xE744,  
      0xE745,  0xE743,  0xE742,  0xE746,  0x79AE,  0xEA2B,  0xEA29,  0xEA2A,  // 0x8F5x
      0xEA2C,  0xEA28,  0xEA2D,  0xEC47,  0xDEE7,  0xEC48,  0xEC46,  0x7BB2,  
      0xEE33,  0x7BF9,  0xEE34,  0xEF56,  0xEF55,  0xE2A2,  0,       0,       // 0x8F6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8F7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8F8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8F9x
      0,       0,       0,       0x4BD0,  0x62CB,  0xBFCB,  0xC4F7,  0x67A8,  
      0xC4F8,  0xCAA1,  0xCAA2,  0x6BBE,  0xCFB7,  0xD3A7,  0x72D6,  0xD3A6,  // 0x8FAx
      0x72D5,  0,       0xE6D4,  0,       0xD9B8,  0x79B0,  0x7AA9,  0x7BB3,  
      0x4BD1,  0x58C9,  0x67A9,  0xCFB9,  0xE747,  0xA7AF,  0x2154,  0xA1EA,  // 0x8FBx
      0x2330,  0xA4BB,  0,       0xA2F1,  0xA2F2,  0,       0xA7B0,  0xA526,  
      0x2521,  0xA7B3,  0x4BD2,  0x2523,  0x4BD5,  0x4BD4,  0x4BD3,  0xA7B1,  // 0x8FCx
      0xA5B2,  0xA525,  0xAAF2,  0xA86D,  0xAAF0,  0xA86F,  0x4FD2,  0xAAF4,  
      0x2826,  0x4FD4,  0xA86C,  0xA86E,  0x4FD3,  0xA871,  0xA870,  0xA872,  // 0x8FDx
      0xAAF3,  0xAAF1,  0,       0,       0xA8F1,  0,       0,       0xA8EE,  
      0xAD57,  0xAD55,  0x53DF,  0xAD54,  0x53E4,  0x53E1,  0x53DE,  0xAFB1,  // 0x8FEx
      0x53E5,  0xAFB2,  0x53E0,  0x53E3,  0xB460,  0x53E2,  0xAD56,  0xAFB3,  
      0x53DD,  0xAFB0,  0,       0,       0x58CF,  0xB32F,  0xB335,  0x58CC,  // 0x8FFx
      0x58D3,  0xB4A5,  0x58CE,  0xB332,  0xB334,  0x58D1,  0xB32E,  0xB331,  
} ;


static const unsigned short Uni2cnsP0Table_90 [] = {
      0x58CD,  0x58CA,  0xB330,  0x58D0,  0xB333,  0x58D2,  0x58CB,  0x302F,  // 0x900x
      0xB4A7,  0xB4A6,  0,       0xB966,  0xB969,  0x5DD6,  0xB9CB,  0x5DE0,  
      0x5DDC,  0xB967,  0xB9CA,  0xB9CE,  0x5DE4,  0x5DDD,  0x5DE2,  0x5DD8,  // 0x901x
      0x3568,  0x5DD5,  0x5DD7,  0x5DE3,  0xB968,  0x5DDB,  0x5DDE,  0x5DDA,  
      0x5DDF,  0xB96A,  0x5DE1,  0x5DD9,  0xB965,  0xB9CC,  0,       0,       // 0x902x
      0xBFCF,  0xBFD0,  0xBFCD,  0xBFCC,  0xBFD1,  0xC072,  0x62CC,  0xC074,  
      0xBFD5,  0x62CE,  0x62D0,  0x3566,  0xC073,  0x62CD,  0x62D1,  0xBFD6,  // 0x903x
      0x62CF,  0,       0xBFD4,  0xBFD7,  0x67AF,  0xC829,  0x67B7,  0xC826,  
      0xC4FD,  0x67B8,  0x67AD,  0xC4F9,  0xC827,  0xC4FC,  0xC4FA,  0x67B2,  // 0x904x
      0xC4FB,  0xC828,  0x67AB,  0x67AA,  0xC4FE,  0x67B5,  0x67B4,  0x67B3,  
      0x67B1,  0x67B6,  0xC825,  0x67AC,  0x67AE,  0x67B0,  0,       0,       // 0x905x
      0x6BC0,  0x6BC3,  0xCAA4,  0x6BC7,  0x6BC1,  0x6BC6,  0x6BC4,  0xCAA7,  
      0x6BBF,  0xCAA6,  0x6BC5,  0x6BC2,  0xCCEB,  0,       0x4E32,  0xD47A,  // 0x906x
      0x6FCD,  0x6FCB,  0xCFBC,  0xD47B,  0x4E33,  0x6FCE,  0x6FCC,  0xD479,  
      0xD478,  0xCFBB,  0x72DA,  0xD477,  0x72D8,  0x72D7,  0xDA7C,  0x6FCF,  // 0x907x
      0x72D9,  0xDA7D,  0x72DC,  0xDA7E,  0x72DB,  0x75E3,  0xDF6F,  0x75E2,  
      0x75E7,  0x75E5,  0x75E6,  0x77CE,  0x75E4,  0xDF6E,  0xDB21,  0x77CD,  // 0x908x
      0x77CF,  0xD9BA,  0x79B1,  0x79B2,  0x615F,  0xEA2E,  0x6952,  0x7CCA,  
      0x7CC9,  0x4BD7,  0xA2DE,  0xA2DD,  0xA275,  0x58D4,  0xA4BC,  0xA272,  // 0x909x
      0xA273,  0xA271,  0xA4BD,  0xA274,  0xE6D5,  0,       0xA52A,  0xA527,  
      0xA52C,  0xA528,  0x4BD8,  0x4BDB,  0xA7B5,  0xA529,  0x4BDA,  0xA52B,  // 0x90Ax
      0xA7B9,  0xA7B4,  0x4BD9,  0xB9D1,  0,       0xAAF7,  0x282B,  0xA875,  
      0xA877,  0x4FD7,  0xA873,  0xA876,  0xA874,  0x4FD5,  0x4FD8,  0xAAF5,  // 0x90Bx
      0x4FD6,  0xAAF8,  0,       0,       0xAFB5,  0xAD59,  0xAD5D,  0xAD5A,  
      0xAFB8,  0x53E8,  0xAFB4,  0x53E9,  0xAFBE,  0xAD5C,  0xAFB7,  0xAD5E,  // 0x90Cx
      0xAD60,  0xAFBC,  0x53E6,  0xAD5F,  0x4139,  0xAFBB,  0x53E7,  0,       
      0,       0,       0xC5ED,  0,       0xB971,  0xAD5B,  0xB336,  0xB33F,  // 0x90Dx
      0xB33D,  0xB338,  0xB339,  0xB33E,  0xB340,  0x58D6,  0xB4A9,  0xB33B,  
      0xB337,  0x58D5,  0x58D7,  0xB33A,  0xB341,  0xB33C,  0,       0,       // 0x90Ex
      0x5DE5,  0xB974,  0xB96C,  0xB972,  0xB973,  0x5DE6,  0xB9CF,  0xB96B,  
      0xB96D,  0xAD58,  0xB96F,  0xB970,  0xB96E,  0x62D3,  0x4E3B,  0xB9D2,  // 0x90Fx
      0,       0xC07B,  0xDB22,  0xC07C,  0xC079,  0x5DE7,  0x62D5,  0xC078,  
} ;


static const unsigned short Uni2cnsP0Table_91 [] = {
      0xC07E,  0xC07D,  0x62D2,  0xC123,  0xC077,  0xC122,  0xC075,  0xC121,  // 0x910x
      0xC07A,  0x62D4,  0xBFD9,  0xC830,  0xC5A3,  0xC82B,  0xC831,  0xC82C,  
      0xC82A,  0xC82D,  0x67B9,  0xC5A4,  0xC82F,  0xC5A5,  0xC82E,  0x67BA,  // 0x911x
      0x6BC9,  0x6BC8,  0xCE56,  0xCE59,  0xCE51,  0xCE55,  0x6BCA,  0xCE54,  
      0xCE52,  0xCE58,  0xCE53,  0xCE50,  0xCE57,  0xCAAA,  0xD523,  0x6FD2,  // 0x912x
      0xE374,  0xD47E,  0xD521,  0xD47D,  0xC076,  0x6FD1,  0xD524,  0xD47C,  
      0x6FD0,  0x6FD3,  0xD522,  0xDB23,  0x72DD,  0xDB24,  0xDB25,  0xD3AB,  // 0x913x
      0xDF70,  0x75E8,  0xE375,  0xE376,  0xD9BC,  0xD9BB,  0xE377,  0xE749,  
      0xE748,  0xEA30,  0,       0xEA2F,  0xEC4A,  0xEC4B,  0xEC49,  0xEE35,  // 0x914x
      0x7BFA,  0x4BDC,  0x53EB,  0x53EA,  0x58DA,  0x58D9,  0xB343,  0xB344,  
      0xB342,  0xB4AA,  0x58D8,  0xB978,  0xB9D5,  0xB979,  0xB975,  0x5DE8,  // 0x915x
      0xB976,  0xB9D4,  0xB977,  0,       0xE6D7,  0,       0,       0xC126,  
      0xC128,  0xC124,  0xC127,  0x62D6,  0xC125,  0x62D7,  0,       0xC5A8,  // 0x916x
      0xC279,  0x67BD,  0x67BC,  0xC5A7,  0x67BB,  0x413A,  0xC832,  0xC833,  
      0x413B,  0,       0xCE5B,  0xCE5D,  0x6BCE,  0x6BCB,  0xCAAC,  0x6BCD,  // 0x917x
      0x6BCC,  0xCE5C,  0xCE5A,  0xCAAB,  0xCAAD,  0,       0,       0,       
      0xD52B,  0xD528,  0xD529,  0x6FD7,  0xD52A,  0xD525,  0xD526,  0x6FD4,  // 0x918x
      0xCFBF,  0x6FD5,  0xD527,  0x6FD6,  0xCFC0,  0xDB29,  0xD3AD,  0xDB2A,  
      0xDB27,  0xDB28,  0x72DE,  0xDB26,  0x5442,  0xD3AC,  0xD3AF,  0,       // 0x919x
      0x593F,  0xDF74,  0xDF71,  0xDF73,  0x75EB,  0xDF77,  0x75EA,  0xDF75,  
      0xDF78,  0xDF76,  0xDF72,  0x75E9,  0,       0xE379,  0x5E24,  0xE37A,  // 0x91Ax
      0xE378,  0xD9BD,  0xE37C,  0x77D0,  0x77D1,  0xE74B,  0x79B4,  0xE37B,  
      0xE74A,  0x79B3,  0xEA33,  0xEA34,  0x7ACA,  0xEA32,  0x6465,  0xEA31,  // 0x91Bx
      0,       0xEC4C,  0x7BB4,  0xDEE8,  0xEF57,  0xF056,  0xF055,  0xE0FE,  
      0x7CEE,  0x7DAA,  0xF057,  0xF160,  0xE1ED,  0x7DBC,  0x4BDD,  0x4FD9,  // 0x91Cx
      0,       0x67BE,  0,       0x7ACB,  0x4BDE,  0x53EC,  0x5DE9,  0x62D8,  
      0x77D2,  0x4FDA,  0,       0xAD62,  0xAD61,  0xB345,  0xB4B0,  0x58DD,  // 0x91Dx
      0x58DB,  0x58DF,  0xB347,  0xB4AD,  0x58DE,  0x58DC,  0xB4AF,  0xB4AE,  
      0xB4B1,  0,       0xB346,  0x5DEC,  0xBA21,  0xB9D8,  0x5DEB,  0x5DED,  // 0x91Ex
      0xBA26,  0x5DEF,  0xBA23,  0xBA24,  0xB97A,  0x5DEE,  0xBA27,  0x357B,  
      0xB9D7,  0xB97C,  0xB9D6,  0xB97D,  0xB97B,  0x5DEA,  0xB9D9,  0xBA25,  // 0x91Fx
      0xB97E,  0xBA22,  0,       0,       0,       0xC134,  0xBFDD,  0xC133,  
} ;


static const unsigned short Uni2cnsP0Table_92 [] = {
      0xC131,  0xC129,  0xC138,  0xC12C,  0xC136,  0xC13D,  0xC135,  0x62E0,  // 0x920x
      0xBFE6,  0x62DC,  0xC12A,  0xBFE0,  0xC130,  0x62DE,  0xBFE8,  0xC12F,  
      0x62DF,  0x62E1,  0xC132,  0xBFE9,  0x62D9,  0x62DA,  0xC13E,  0xC13C,  // 0x921x
      0xBFE2,  0xC13B,  0xC12D,  0xBFE5,  0xC139,  0x3B66,  0x62DD,  0xCF6F,  
      0xBFDE,  0xE6D9,  0xBFE3,  0x62DB,  0xC13A,  0xC12B,  0xC12E,  0xC137,  // 0x922x
      0,       0,       0,       0xE6D8,  0,       0xCF22,  0xC83D,  0xC5AE,  
      0xC836,  0xC849,  0xC852,  0xC839,  0x67C9,  0xC5AB,  0xC846,  0x67BF,  // 0x923x
      0x67C1,  0x67CD,  0xC837,  0xC5B7,  0xC5AF,  0x67C2,  0x67C4,  0x67CE,  
      0x67C3,  0xC5B9,  0x4141,  0x4146,  0xC5B8,  0x67CC,  0xC83F,  0x4148,  // 0x924x
      0xC834,  0x67CA,  0xC83E,  0x67C6,  0xC850,  0x67CB,  0xC84E,  0xC842,  
      0xC84C,  0x67C8,  0xC835,  0xC84F,  0xC84A,  0xC5AA,  0xC851,  0x67C0,  // 0x925x
      0x4140,  0xC5AD,  0x67CF,  0x67C5,  0xC5B1,  0xC5A9,  0xC83B,  0xC5B4,  
      0xC843,  0xC847,  0xC5B3,  0xC84B,  0x67C7,  0xC83A,  0xC838,  0xC844,  // 0x926x
      0x4142,  0x4143,  0xC5B2,  0xC5B5,  0xC841,  0xC840,  0xC5B6,  0xC845,  
      0xC848,  0,       0xC84D,  0xE6DA,  0xC5F2,  0x4775,  0xCE60,  0xCDA2,  // 0x927x
      0x6BCF,  0xCE6A,  0xCE62,  0x6BD5,  0x6BD9,  0xCE73,  0xCE7B,  0xCE6C,  
      0x6BD1,  0xCAB4,  0xCE70,  0xC83C,  0xCAB5,  0x6BD2,  0xCE77,  0xCE7C,  // 0x928x
      0xCE74,  0xCAAF,  0xCE76,  0xCF21,  0xCE78,  0xCE66,  0xCE6F,  0xC5B0,  
      0xCAB8,  0x6BDA,  0xCAB3,  0x6BD6,  0xCE64,  0xCE71,  0x6BD4,  0xCE6B,  // 0x929x
      0x6BD3,  0xCE79,  0xCE68,  0xCE61,  0x6BD7,  0xCE7E,  0xCAB9,  0x4777,  
      0xCE63,  0xCE75,  0xCE72,  0xCE6D,  0xCE5F,  0xCE5E,  0xCE67,  0xCE7A,  // 0x92Ax
      0x6BD8,  0xCE7D,  0xCE65,  0xCE69,  0x6BD0,  0xCAB2,  0xCAB7,  0xCDA7,  
      0xE7AA,  0xCAB1,  0x6FE3,  0x6FDE,  0xD54D,  0xD549,  0xD531,  0x6FDA,  // 0x92Bx
      0xCFC2,  0xCFD0,  0x4E45,  0x6FD9,  0x6FDF,  0x4E47,  0xCFC3,  0xCFC1,  
      0xD52F,  0x6FDD,  0xD53B,  0xD52D,  0xD52E,  0x6FD8,  0xD54C,  0x6FE1,  // 0x92Cx
      0xD53E,  0xD543,  0xD53D,  0xDB3C,  0xD539,  0xD541,  0xD53F,  0xD532,  
      0xD52C,  0xD547,  0x6FE0,  0xD548,  0xCFC8,  0xD542,  0xCFC9,  0xD537,  // 0x92Dx
      0xD535,  0xD530,  0xCFCB,  0xCFCE,  0xCFC4,  0xD538,  0xD545,  0xD534,  
      0xD544,  0xD54A,  0xCFD1,  0x4E46,  0x6FDC,  0xCFC5,  0xD540,  0xD546,  // 0x92Ex
      0xD53C,  0xD536,  0x6FDB,  0xCFD2,  0x4E44,  0xCFCC,  0xCE6E,  0xD53A,  
      0x6FE2,  0xD533,  0xD2EB,  0xCFCD,  0xE6DB,  0xE6DC,  0xCAB0,  0xDB41,  // 0x92Fx
      0x72E1,  0xDB40,  0xDB3E,  0xDB50,  0x72E5,  0xD3B5,  0xDB4D,  0xDB45,  
} ;


static const unsigned short Uni2cnsP0Table_93 [] = {
      0xDB4F,  0xDB37,  0xDB43,  0xD3BD,  0x72E7,  0xD3BE,  0xDB2F,  0xD3B8,  // 0x930x
      0xDB2D,  0xDB4E,  0xD3B2,  0xDB4C,  0xDB4B,  0xDB3B,  0xDB3A,  0xDB30,  
      0x72E9,  0x5443,  0xDB36,  0xDB3F,  0xDB4A,  0x72EC,  0xDB51,  0xD3B6,  // 0x931x
      0x75F3,  0x72EE,  0x72E8,  0xDB34,  0xD3B7,  0xDB3D,  0xDB2C,  0xDB2E,  
      0x72DF,  0x72EB,  0x72E4,  0xDB35,  0xDB44,  0xD54B,  0x72EA,  0xDB2B,  // 0x932x
      0x75EE,  0xDB46,  0xDB49,  0x72E6,  0xD3BB,  0xDB39,  0x72ED,  0x72E3,  
      0xD3BC,  0xD3B9,  0xD3BA,  0x72E2,  0xDB42,  0xDB48,  0x72E0,  0x5445,  // 0x933x
      0xDB32,  0xDB47,  0xD8D9,  0xD8C8,  0xDB33,  0xB4E3,  0,       0xE6DD,  
      0xD8D5,  0,       0xE6DE,  0x5449,  0,       0xD3B1,  0xDB38,  0xDF7E,  // 0x934x
      0xD6E5,  0xE025,  0x75F0,  0x75F2,  0xE02B,  0x75EC,  0xE039,  0xE031,  
      0xE026,  0xE027,  0xE030,  0xD6E6,  0x75F9,  0xE02F,  0xDF7D,  0xE02E,  // 0x935x
      0xE022,  0xE03A,  0x75F8,  0x75F6,  0xE023,  0xD6DD,  0xE036,  0xD6E7,  
      0xE028,  0xE035,  0xD6E4,  0xE037,  0xDF7C,  0x75F1,  0xD6DB,  0xE038,  // 0x936x
      0xD6E8,  0xD6DE,  0xE02C,  0xD6EB,  0x75F5,  0xE029,  0xD6E1,  0x5949,  
      0x75F7,  0xE032,  0xD6E2,  0xD6E3,  0xD6DF,  0x75EF,  0xE024,  0xE033,  // 0x937x
      0xD6DC,  0xE02D,  0xDB31,  0xE034,  0xE021,  0xD6E0,  0x75F4,  0xD6EA,  
      0xE42F,  0x5947,  0x75ED,  0xDF7A,  0x5946,  0xDDC1,  0xE6DF,  0xDDB9,  // 0x938x
      0xE42C,  0xE425,  0x77D4,  0xD9C3,  0xE37E,  0xE430,  0xE427,  0xE02A,  
      0xD9C0,  0xE432,  0xE421,  0xD9C2,  0x77D3,  0xE42B,  0x77D5,  0x77DD,  // 0x939x
      0x77DB,  0xE42D,  0x77DC,  0xE423,  0xD9C9,  0xE424,  0xE429,  0xE42E,  
      0xD9BE,  0xDF79,  0x77D6,  0xE437,  0xE434,  0xE761,  0xE42A,  0xE426,  // 0x93Ax
      0xE435,  0xE756,  0xE428,  0x5E31,  0x77D9,  0xD9C4,  0x77D8,  0xDF7B,  
      0x77DA,  0xE431,  0xE433,  0x77D7,  0xE436,  0xE37D,  0x5E29,  0xE422,  // 0x93Bx
      0xD9C6,  0xE1B3,  0,       0xD9C5,  0xE6E1,  0xE6E2,  0xE6E0,  0xE1C3,  
      0xE75F,  0xDBD0,  0xE74F,  0x79B8,  0xE75D,  0xDBC4,  0xDBC5,  0xE74D,  // 0x93Cx
      0x79B9,  0x6167,  0xE758,  0xDBC3,  0xE754,  0x79BE,  0xE75E,  0xE74E,  
      0xE751,  0x79B6,  0xE760,  0xDBC8,  0xE759,  0xE75C,  0x79BC,  0x79C1,  // 0x93Dx
      0x79BF,  0xE755,  0xE750,  0xDBCD,  0x79BA,  0x79BB,  0xE74C,  0x79B7,  
      0xDBCF,  0x79B5,  0x79BD,  0xE75B,  0x79C0,  0xDBCA,  0xE757,  0xE762,  // 0x93Ex
      0x79C2,  0xDBC1,  0xDBC2,  0xDBCE,  0xE753,  0xDBC7,  0xE75A,  0xE6E5,  
      0,       0xE6E3,  0xE6E4,  0xDDC1,  0xDEEA,  0xEA41,  0xEA50,  0xEA43,  // 0x93Fx
      0xEA4A,  0xE752,  0xEA48,  0xEA37,  0xEA4E,  0x7ACE,  0xEA3B,  0xEA4D,  
} ;


static const unsigned short Uni2cnsP0Table_94 [] = {
      0xEA42,  0x6467,  0xDDC3,  0x7ACD,  0xDDBC,  0xDDBF,  0xEA52,  0xEA44,  // 0x940x
      0xDDBE,  0xEA49,  0xEA4C,  0xEA35,  0xEA4F,  0xEA40,  0xEA45,  0xEA39,  
      0xEA3D,  0xEA51,  0xEA47,  0xEA36,  0xEA3A,  0xEA3C,  0xEA46,  0xDDBD,  // 0x941x
      0x7ACC,  0xEA3F,  0xDDC4,  0xDDC5,  0xDDC7,  0x646B,  0xDDC2,  0xDDBA,  
      0xEA38,  0,       0xE6E6,  0xE6E7,  0xE6E8,  0xE6D7,  0,       0xDDC6,  // 0x942x
      0xEA3E,  0xEC50,  0xEC54,  0x7BBB,  0xEC56,  0xDEED,  0x7BB5,  0x646F,  
      0xEC52,  0xEC58,  0x7BBA,  0x7BB6,  0x675C,  0x7BB7,  0xEC4F,  0xEC55,  // 0x943x
      0x7BB9,  0xEC53,  0x7BB8,  0xEC4E,  0xEA4B,  0xEC51,  0x6762,  0xEC4D,  
      0xEC57,  0,       0xDFE9,  0xDFEE,  0x7BFB,  0xEE3C,  0xEE3F,  0xEE3B,  // 0x944x
      0xEE3D,  0xEE3E,  0xEE38,  0xEE39,  0xEE36,  0xDFEA,  0xDFEC,  0xEE3A,  
      0xEE37,  0x7BFC,  0x7BFD,  0,       0xDFEB,  0xEF59,  0xE0D2,  0xEF5B,  // 0x945x
      0x6B29,  0x76DD,  0xE0D5,  0xE0D4,  0xE0D6,  0xEF5A,  0xEF5C,  0xE0CF,  
      0x7CCC,  0xE0D3,  0xEF58,  0x7CCB,  0x7CCD,  0xE0D7,  0xE6EA,  0xE6E9,  // 0x946x
      0xF059,  0xF05A,  0x7CEF,  0xF058,  0xE1A2,  0xF142,  0xF141,  0xF143,  
      0x7DAC,  0xF144,  0x7DAB,  0xF145,  0xF161,  0xF164,  0xF163,  0x7DB5,  // 0x947x
      0xF162,  0x6D62,  0xE1EF,  0xE2A3,  0x7DBF,  0x7DBD,  0x7DBE,  0x7DC4,  
      0xF230,  0xF231,  0xF22F,  0xF237,  0xE2B6,  0,       0,       0,       // 0x948x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x949x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x94Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_95 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x950x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x951x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x952x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x953x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x954x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x955x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x956x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x4FDB,  // 0x957x
      0x252B,  0x303A,  0xBA28,  0xC13F,  0xD54E,  0xE763,  0x71D6,  0,       
      0x4FDC,  0xAFC0,  0x53ED,  0x58E0,  0x303B,  0xB4B2,  0xBA29,  0xB9DC,  // 0x958x
      0xBA2A,  0x5DF0,  0,       0x62E4,  0xC141,  0xC140,  0x62E8,  0x62E3,  
      0xC142,  0x62E5,  0x62E7,  0x62E6,  0x62E2,  0xBFEC,  0xBFFE,  0xE6EB,  // 0x959x
      0x67D0,  0xC5BC,  0xC5BA,  0xC856,  0xC854,  0x4153,  0xC855,  0xC853,  
      0xC5FB,  0x6BDB,  0xCABD,  0x6BDE,  0x6BE0,  0x6BDF,  0x4822,  0xCABE,  // 0x95Ax
      0x6BDC,  0x6BDD,  0,       0xD550,  0xD54F,  0x6FE4,  0xD551,  0xCFD3,  
      0xD552,  0x6FE5,  0xCFD5,  0xCFD6,  0x4E4A,  0xDB59,  0xDB57,  0xE040,  // 0x95Bx
      0xD3C2,  0xDB55,  0xDB56,  0x72EF,  0xDB52,  0xDB5A,  0xDB54,  0xDB58,  
      0xE03C,  0xD3C4,  0xD3C0,  0xE03E,  0xD6ED,  0xE03F,  0x75FE,  0xE03B,  // 0x95Cx
      0x75FD,  0xE03D,  0x75FA,  0x75FB,  0x75FC,  0xDB53,  0xE6EC,  0,       
      0x77E0,  0xE43A,  0xE438,  0xE439,  0x77DE,  0x77E1,  0x77DF,  0xD9CB,  // 0x95Dx
      0xD9CA,  0xCBC0,  0xE764,  0xE765,  0x79C3,  0xDBD3,  0xEA53,  0xEA55,  
      0xEA54,  0x7ACF,  0x7BBC,  0xEC5B,  0xEC5A,  0xEC59,  0xE8F2,  0xE6ED,  // 0x95Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0xA5B9,  0,       0,       // 0x95Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_96 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x960x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x961x
      0,       0,       0,       0,       0x4FDD,  0xA1C3,  0xA169,  0,       
      0xA278,  0x48EA,  0xA276,  0xA279,  0xA277,  0x252E,  0xA7BB,  0xA7BA,  // 0x962x
      0xA52E,  0xA7BF,  0x4BE2,  0xA7BC,  0x4BE3,  0xA530,  0x4BE0,  0xA52F,  
      0xA52D,  0x4BE1,  0x4BDF,  0xA7BD,  0xA7BE,  0,       0,       0xAAF9,  // 0x963x
      0x2833,  0xA878,  0xA87B,  0x4FE0,  0xA87A,  0xA879,  0xAAFC,  0x4FDF,  
      0x4FDE,  0xAAFB,  0x4FE2,  0xA87C,  0x4FE1,  0,       0,       0,       // 0x964x
      0,       0,       0xAD67,  0x53EF,  0x53F0,  0x53F1,  0xAD68,  0xAD64,  
      0x53EE,  0xAD65,  0x2B5D,  0xAD66,  0xAD63,  0x2B5B,  0xB4B6,  0x303F,  // 0x965x
      0x58E7,  0xB4B4,  0xB9DE,  0x58E4,  0xB348,  0x58E5,  0x58E8,  0xB349,  
      0xB4B3,  0x58E3,  0x58E1,  0x58E2,  0x58E6,  0,       0,       0,       // 0x966x
      0,       0,       0x5DF1,  0xBA2D,  0x5DF9,  0xBA2C,  0xB9E1,  0xBA2F,  
      0x5DF5,  0xBA2E,  0x62F0,  0x5DF3,  0x5DF6,  0x5DF2,  0x5DF7,  0x5DF8,  // 0x967x
      0x5DF4,  0xB9E5,  0,       0xBFF1,  0xBA2B,  0x62EC,  0xC144,  0xBFF2,  
      0xC148,  0xBFF3,  0xBFF5,  0xC147,  0x62F1,  0x62ED,  0x62EE,  0xC143,  // 0x968x
      0xC145,  0xC146,  0x62E9,  0x62EB,  0xBFF0,  0x62EF,  0x62EA,  0xC5C0,  
      0,       0xC859,  0xC857,  0xC858,  0x67D2,  0x67D3,  0xC5C2,  0xC85A,  // 0x969x
      0x67D1,  0x6BE1,  0x4824,  0x6BE3,  0x6BE2,  0xCAC5,  0xCF23,  0xCAC6,  
      0xCAC4,  0xCF24,  0xD554,  0xCFDA,  0xD553,  0xCFDB,  0x5452,  0x72F0,  // 0x96Ax
      0x72F1,  0xDB5B,  0x72F2,  0xD3C8,  0xE043,  0xD6F0,  0xE041,  0xD6EF,  
      0xE042,  0x76A1,  0xD6F1,  0xE43B,  0x79C4,  0xDDC9,  0xAAFD,  0xD3C9,  // 0x96Bx
      0x76A2,  0x4FE3,  0x3041,  0x58E9,  0xB34A,  0xB4B9,  0xB2EF,  0xBA30,  
      0x5DFA,  0x62F2,  0xC149,  0xC14B,  0x62F4,  0x62F3,  0x62F5,  0x62F6,  // 0x96Cx
      0xC14A,  0x67D6,  0x67D7,  0x67D5,  0x6BE4,  0x67D4,  0xC85B,  0x4157,  
      0xCAC7,  0xCAC9,  0x6BE5,  0xD555,  0xDB5C,  0x72F3,  0x76A3,  0xE43C,  // 0x96Dx
      0xE440,  0x77E4,  0xE43D,  0x77E5,  0x77E3,  0xE441,  0x77E6,  0xE43F,  
      0,       0xE766,  0x77E2,  0x79C5,  0xDEF0,  0xF05B,  0xE1A5,  0xE2AF,  // 0x96Ex
      0x4FE4,  0x5DFC,  0x5DFB,  0xB9AA,  0xBFFE,  0xBFFC,  0xBFFB,  0x62F7,  
      0xC14D,  0xC14C,  0x62F8,  0,       0xC5C6,  0xC85F,  0x67DB,  0x67D8,  // 0x96Fx
      0xC85E,  0x67DA,  0xC85C,  0x67D9,  0xC5C7,  0xC85D,  0,       0xCF25,  
} ;


static const unsigned short Uni2cnsP0Table_97 [] = {
      0x6BE6,  0,       0xD558,  0x52BB,  0x6FE6,  0xD556,  0x6FE7,  0x6FE8,  // 0x970x
      0xD557,  0x6FE9,  0xCFE0,  0xDB5D,  0xD3D0,  0x72F7,  0x72F4,  0x72F9,  
      0xDB5F,  0x72F5,  0xDB5E,  0x72F8,  0xD3CD,  0xD3CC,  0x72F6,  0xD3D1,  // 0x971x
      0xE046,  0xE048,  0xD6F4,  0xD6F5,  0x76A4,  0xE047,  0x76A5,  0xE045,  
      0xE044,  0x5E38,  0xE443,  0xE442,  0x77E7,  0xE444,  0xE76B,  0x79C7,  // 0x972x
      0xE76A,  0xE767,  0x79C6,  0xE768,  0xE769,  0,       0xEA56,  0xEA57,  
      0x7AD0,  0xDDCF,  0x7BBF,  0xDDCC,  0xDDCE,  0xEC5C,  0xDEF2,  0xDEF1,  // 0x973x
      0x7BBD,  0x7BBE,  0xEC5D,  0xE6EE,  0xDFF1,  0x7BFE,  0x7CA1,  0xEE40,  
      0xDFF2,  0xE0D9,  0x7CF0,  0xF05D,  0x7CF2,  0xE1A6,  0xF05C,  0xF05E,  // 0x974x
      0x7CF1,  0xF146,  0x6D64,  0xF17B,  0,       0xE6EF,  0,       0,       
      0xE2C5,  0xAAFE,  0x4FE5,  0,       0,       0xC5C9,  0x67DC,  0x4835,  // 0x975x
      0xCF26,  0xCACC,  0xD559,  0x72FA,  0x72FB,  0xD9CF,  0x4FE6,  0xC0A1,  
      0x6FEA,  0x79C8,  0x53F2,  0xABA1,  0xCACE,  0,       0x72FC,  0xDEF3,  // 0x976x
      0x7CCE,  0x53F3,  0xBA31,  0x3B77,  0xC14E,  0xC0A4,  0xC150,  0xC0A2,  
      0xC14F,  0,       0xC863,  0xC860,  0x67DD,  0xDA24,  0x67DE,  0xC861,  // 0x977x
      0xC862,  0xC5CB,  0xCF28,  0xCF2D,  0x6BE7,  0xCF27,  0xCF29,  0xCF30,  
      0xCF2B,  0xCF2F,  0xCF2C,  0xCF2A,  0xCF2E,  0x6BE8,  0,       0xCFE2,  // 0x978x
      0xD55C,  0xCFE3,  0xD55A,  0x6FEC,  0xCFE4,  0x6FEB,  0xD55B,  0x6FED,  
      0,       0,       0,       0xD3D3,  0xDB62,  0x545F,  0x5467,  0xDB61,  // 0x979x
      0x72FD,  0xDB60,  0xE049,  0xD6FA,  0xE04B,  0xE04D,  0xE04C,  0xD6FB,  
      0x76A6,  0xE04A,  0xE44B,  0x77E8,  0xE449,  0xE44C,  0x77E9,  0x5E43,  // 0x97Ax
      0xE447,  0xD9D0,  0xE44A,  0xE448,  0xE445,  0x77EA,  0xE446,  0,       
      0x617C,  0xDBDF,  0xDBDD,  0xE76C,  0xDBDE,  0xDBE0,  0xE76E,  0xE76D,  // 0x97Bx
      0xDDD0,  0xEA58,  0xDDD1,  0xEA59,  0x6771,  0xDEF5,  0xDEF4,  0xEC5E,  
      0xDFF3,  0x7CA3,  0x695E,  0x7CA2,  0xEF5D,  0xEF5E,  0x7CF3,  0xF05F,  // 0x97Cx
      0xE1A8,  0x7DB6,  0xE2BB,  0x53F4,  0x62F9,  0xCF32,  0xCF31,  0xD55E,  
      0xD55D,  0x4E57,  0xD3D5,  0x76A7,  0xE04F,  0xE04E,  0xE44F,  0xE44D,  // 0x97Dx
      0xE450,  0xE44E,  0xD9D1,  0x6529,  0x79C9,  0xE76F,  0xE770,  0xE771,  
      0x6527,  0xEC5F,  0xDEF6,  0xEE41,  0xE1A9,  0xF060,  0,       0,       // 0x97Ex
      0,       0,       0,       0,       0,       0x53F5,  0xC5CF,  0xCFE5,  
      0xDB63,  0xE050,  0xDBE1,  0x53F6,  0x4163,  0xC5D0,  0x6BE9,  0x4846,  // 0x97Fx
      0xDB64,  0x77EB,  0xE451,  0x79CA,  0xDDD3,  0xEA5A,  0xEA5B,  0x7BC0,  
} ;


static const unsigned short Uni2cnsP0Table_98 [] = {
      0xEF5F,  0x53F7,  0x5EA1,  0x5EA2,  0xBA32,  0x62FA,  0x62FB,  0xC151,  // 0x980x
      0x62FC,  0x4168,  0x67E2,  0xC5D2,  0x67E4,  0xC865,  0xC866,  0xC864,  
      0x67DF,  0x67E0,  0x67E3,  0x67E1,  0xCAD4,  0xCAD5,  0xCF33,  0x6BEA,  // 0x981x
      0x6BEB,  0xCAD2,  0xCAD6,  0xD565,  0x6FF0,  0xD560,  0xD55F,  0xCFE9,  
      0xD564,  0x6FEE,  0xCFE7,  0x4E5A,  0x73A6,  0x5470,  0xD561,  0xD566,  // 0x982x
      0xD563,  0xD562,  0xCFE6,  0x6FEF,  0,       0x73A4,  0xD3DC,  0xDB66,  
      0x72FE,  0xD3D9,  0xDB67,  0xD3DA,  0xD2A8,  0xDB65,  0xD3D8,  0x73A3,  // 0x983x
      0x73A1,  0x73A5,  0xD3DD,  0x73A2,  0xD3DB,  0xD3DF,  0x5E4F,  0xD9DB,  
      0xD7A6,  0xE051,  0x5970,  0xE056,  0xE052,  0xE055,  0x76A8,  0xD7A8,  // 0x984x
      0xDE41,  0xE054,  0xE053,  0xD9D9,  0x77EE,  0x77EC,  0x77EF,  0x77ED,  
      0xE452,  0xE453,  0xE454,  0x77F0,  0xD9D6,  0xD9D8,  0xDBE5,  0xE775,  // 0x985x
      0x79CC,  0xE773,  0x6230,  0x79CD,  0xE772,  0xE774,  0x79CB,  0xEA5F,  
      0xEA5C,  0x652C,  0xEA5D,  0xEA5E,  0xEC60,  0x7BC2,  0xDEF8,  0x7BC1,  // 0x986x
      0xDEF7,  0xEE43,  0xEE42,  0x7CA4,  0xE0DD,  0xE0DE,  0xE0DC,  0x7CCF,  
      0x7CF4,  0x7DAD,  0xF147,  0xF17C,  0xF17D,  0,       0,       0,       // 0x987x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x988x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x989x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x98Ax
      0x53F8,  0xC152,  0,       0x4171,  0xC867,  0xCF34,  0xCF35,  0x6BEC,  
      0x4857,  0x6BED,  0xD567,  0x6FF1,  0,       0xD3E1,  0x76A9,  0xD7AA,  // 0x98Bx
      0xE455,  0xD9DC,  0x77F1,  0xE778,  0x79CE,  0xE777,  0xE779,  0xE776,  
      0xEC63,  0xEA60,  0xEA61,  0xDDD6,  0x7AD1,  0,       0xEC62,  0xDEFB,  // 0x98Cx
      0xDEF9,  0xEC61,  0xDEFA,  0xEE44,  0xF17E,  0xE2A5,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x98Dx
      0,       0,       0,       0x53F9,  0xDEFC,  0xE2A6,  0,       0x53FA,  
      0,       0xB9E7,  0x58EA,  0xB34B,  0xE6F0,  0xBA33,  0xB9E8,  0x62FD,  // 0x98Ex
      0,       0x63A2,  0x62FE,  0xC153,  0xC5DB,  0x63A4,  0,       0x63A1,  
      0xC0AB,  0xC5DC,  0x63A3,  0xC5D4,  0x67E6,  0xC5D9,  0xC868,  0xC5D7,  // 0x98Fx
      0xCADD,  0xC869,  0xD569,  0x417B,  0x67E5,  0x67E7,  0x67E8,  0xC5D8,  
} ;


static const unsigned short Uni2cnsP0Table_99 [] = {
      0xCF37,  0xCADE,  0xCF36,  0x6BEE,  0x4BCC,  0x6BEF,  0xCADB,  0xCF38,  // 0x990x
      0xD568,  0x6BF1,  0x6FF2,  0x4E63,  0x6BF0,  0,       0xE6FA,  0,       
      0x73A7,  0xD56A,  0x6FF4,  0x6FF3,  0xD56B,  0xD56E,  0xD56C,  0xD56D,  // 0x991x
      0x6FF5,  0xCFEB,  0x73AC,  0x73AA,  0xD3E5,  0xD3E6,  0x73A9,  0xDB69,  
      0xD3E4,  0x73AB,  0xD3E2,  0xD3E3,  0xDB68,  0xE057,  0x547E,  0xDB6A,  // 0x992x
      0x73A8,  0xDB6B,  0xE05A,  0xE058,  0xE059,  0xE05E,  0x77F5,  0xE05D,  
      0xE060,  0xE05F,  0xE05C,  0xE05B,  0x5521,  0x76AA,  0xD9E2,  0x5A29,  // 0x993x
      0xD9E1,  0xD9E6,  0xE458,  0xD9E5,  0xE457,  0x77F4,  0x77F2,  0x77F3,  
      0xD9E3,  0xE456,  0xE6F1,  0xE77C,  0xDBE9,  0x79CF,  0x6238,  0xE77B,  // 0x994x
      0xE77A,  0x79D0,  0x653A,  0xEA66,  0xEA65,  0xDDD8,  0xEA63,  0xDEFE,  
      0xEA62,  0x7AD3,  0x7AD2,  0xEA67,  0xEE45,  0x7CA5,  0xEC65,  0x7BC3,  // 0x995x
      0xEC64,  0xEA64,  0xDFF8,  0xEE46,  0x7CD0,  0xE1AA,  0x7DAE,  0xF148,  
      0x6E24,  0xF221,  0,       0,       0,       0,       0,       0,       // 0x996x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x997x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x998x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x53FB,  0xBA34,  // 0x999x
      0xE061,  0x53FC,  0xC5DF,  0x4BCE,  0xCF3A,  0xCF39,  0xDB6C,  0x5AA6,  
      0xD3E8,  0xE063,  0xD7B0,  0xE062,  0xD9E7,  0x77F6,  0xE77D,  0xE77E,  // 0x99Ax
      0x7AD4,  0xDFA1,  0xE0E0,  0xF222,  0x58EB,  0x63A6,  0x63A5,  0xC86A,  
      0xC86C,  0x67EA,  0xC86B,  0x67E9,  0x67EB,  0xC86D,  0xCAE3,  0xCAE2,  // 0x99Bx
      0xCAE6,  0xCF3C,  0xCF3E,  0xCF3D,  0xCAE1,  0xCF40,  0xCAE0,  0xCAEC,  
      0xCAE4,  0x6BF2,  0xCF3F,  0xCF3B,  0xCAEA,  0,       0x4860,  0xCF41,  // 0x99Cx
      0xCFF3,  0xD575,  0xCFED,  0xD578,  0xD57A,  0xD570,  0xD574,  0xD571,  
      0x6FF7,  0x6FFA,  0x6FFC,  0xD572,  0xD573,  0x6FFB,  0xD576,  0xD579,  // 0x99Dx
      0xD577,  0x6FFD,  0xCFEE,  0x6FF9,  0xD56F,  0x6FF6,  0xCFF2,  0x6FF8,  
      0xCFF4,  0xD3F0,  0x73AE,  0xDB72,  0xDB70,  0xDB6F,  0xD3F1,  0xDB75,  // 0x99Ex
      0xD3EB,  0xDB74,  0xDB73,  0xD3EC,  0xDB6E,  0x73AD,  0xDB6D,  0xD3EA,  
      0xDB71,  0x73AF,  0,       0xD7B4,  0xE066,  0xD7B7,  0xE06A,  0xE067,  // 0x99Fx
      0xE069,  0xE068,  0xE065,  0xE06B,  0xE06E,  0xE06C,  0xE06D,  0x76AC,  
} ;


static const unsigned short Uni2cnsP0Table_9A [] = {
      0xD7B3,  0x76AB,  0xE064,  0xE06F,  0xE45D,  0xE460,  0xE462,  0xE461,  // 0x9A0x
      0xD9EA,  0xE45B,  0xE45F,  0xE45A,  0xD9EB,  0xE45C,  0x77F7,  0xE459,  
      0xD9ED,  0xE45E,  0,       0,       0xE82D,  0xE822,  0x79D1,  0xDBEF,  // 0x9A1x
      0xDBED,  0x79D2,  0xE821,  0xE826,  0xE82C,  0xE824,  0xE82B,  0xDBEC,  
      0xE828,  0xDBEE,  0xE827,  0xE82A,  0xE825,  0xE823,  0xDBEB,  0xE829,  // 0x9A2x
      0,       0xEA6E,  0xEA6C,  0x7AD5,  0xEA6B,  0xEA71,  0xEA6F,  0xDDDA,  
      0x7AD6,  0xEA6A,  0xEA68,  0x6546,  0xEA69,  0x7AD8,  0xEA6D,  0x7AD7,  // 0x9A3x
      0xEA70,  0xEC66,  0xEC6C,  0xDFA4,  0xDFA2,  0xEC67,  0x7BC7,  0xEC6D,  
      0x7BC6,  0xEC6B,  0xEC6A,  0x7BC5,  0xEC69,  0x7BC4,  0xEC68,  0xD6D1,  // 0x9A4x
      0xEE4C,  0xEE4E,  0xEE4D,  0x696A,  0xEE4A,  0x7CA7,  0xEE47,  0xEE4B,  
      0xEE50,  0xDFF9,  0xEE4F,  0xEE48,  0xEE49,  0x7CA6,  0xEF60,  0x7CD3,  // 0x9A5x
      0xE0E2,  0xEF61,  0x7CD1,  0x7CD2,  0xE0E1,  0x6C3D,  0xF061,  0x7CF5,  
      0xF165,  0xE1F2,  0x7DB7,  0xE1F3,  0xF223,  0x7DB8,  0xF224,  0xF225,  // 0x9A6x
      0xF233,  0xF232,  0x7DC7,  0xF23B,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9A7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9A8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9A9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9AAx
      0x58EC,  0xC0AF,  0x4221,  0xC86F,  0x417D,  0xC86E,  0x417E,  0x6BF3,  
      0x6BF4,  0xCF42,  0x4E74,  0xD57B,  0xDB78,  0xCFF7,  0xCFF6,  0x6FFE,  // 0x9ABx
      0x73B0,  0xDB76,  0x5531,  0xDB79,  0x73B1,  0xD7BA,  0xE070,  0xDB77,  
      0xE463,  0x77F8,  0xE82E,  0x6249,  0xDDE1,  0,       0xEA74,  0xEA72,  // 0x9ACx
      0xDDE0,  0xDDDE,  0xEA73,  0,       0,       0xEC6E,  0xDFA5,  0x7BC8,  
      0xEE51,  0x7CD6,  0x7CA8,  0x7CD4,  0x7CD5,  0xF062,  0x7DAF,  0xE1F4,  // 0x9ADx
      0x58ED,  0x362D,  0xCAEE,  0x4E79,  0xE464,  0xDFFB,  0xE0E3,  0xB34C,  
      0xC0B2,  0x67EC,  0xC5E1,  0xCF43,  0xCAEF,  0xCAF3,  0x6BF5,  0xCF44,  // 0x9AEx
      0xCAF1,  0xCAF0,  0xCAF2,  0xD57D,  0xD57C,  0x73B3,  0x70A1,  0x70A2,  
      0x4F21,  0xD622,  0xD621,  0xD57E,  0xCFF9,  0xD3F5,  0xDB7A,  0xDB7D,  // 0x9AFx
      0xD3F4,  0xDB7C,  0xDB7B,  0x73B2,  0xE074,  0xE072,  0xE071,  0x5A37,  
} ;


static const unsigned short Uni2cnsP0Table_9B [] = {
      0xD7BB,  0xE073,  0xD7BC,  0x77F9,  0xE466,  0xE467,  0x77FA,  0xD9EF,  // 0x9B0x
      0xE465,  0xDBF1,  0xE830,  0xE82F,  0xE832,  0x79D3,  0xE831,  0x624F,  
      0xEA75,  0xEA77,  0xEA76,  0,       0xDFA7,  0xEC6F,  0xEC72,  0xEC70,  // 0x9B1x
      0xEC71,  0xEE52,  0x7CA9,  0x6974,  0x6971,  0xE6F2,  0xEF62,  0xEF63,  
      0xEF64,  0xE1AC,  0x7CF6,  0x7DB0,  0xF226,  0x58EE,  0xCAF5,  0x70A3,  // 0x9B2x
      0x73B4,  0xE468,  0xDDE2,  0xEE53,  0xE1AE,  0x6D37,  0xF166,  0xB34D,  
      0xE2A8,  0x7DC8,  0x58EF,  0xDB7E,  0xD7BE,  0xE469,  0,       0xE833,  // 0x9B3x
      0xDDE3,  0x6836,  0xEC73,  0xEE54,  0x58F0,  0xC5E2,  0xCF45,  0xCF46,  
      0xCAF8,  0x6BF6,  0x6BF7,  0xD624,  0x70A5,  0x70A4,  0xD623,  0,       // 0x9B4x
      0xE075,  0xD7BF,  0xE46A,  0xE46C,  0xE46B,  0x77FD,  0x77FC,  0x77FB,  
      0xDDE4,  0x7BCA,  0xEC74,  0xDFA8,  0x7BC9,  0xEE56,  0xEE55,  0xE1AF,  // 0x9B5x
      0x7CF7,  0xF063,  0x5EA3,  0xC870,  0x4229,  0xC5E3,  0,       0xCF49,  
      0xCF47,  0xCF48,  0x486B,  0xCFFE,  0xD62D,  0x4F30,  0xD628,  0xD625,  // 0x9B6x
      0xD62C,  0xCFFC,  0x4F35,  0xCFFB,  0xD62E,  0x4F37,  0x4F2C,  0x70A7,  
      0xD62B,  0xD627,  0xCFFD,  0x4F2A,  0xD626,  0xD62A,  0xD629,  0x70A6,  // 0x9B7x
      0,       0xD3BE,  0xDC2B,  0xDC26,  0xDC24,  0xDC2D,  0xDC25,  0x5547,  
      0xDC21,  0x5543,  0xDC27,  0xD3F8,  0xD3FA,  0xDC22,  0xE07E,  0xDC23,  // 0x9B8x
      0xDC2E,  0xD4A3,  0x5545,  0xD3FC,  0xD4A1,  0x5ACA,  0xD4A5,  0xD3FD,  
      0xDC2A,  0x73B5,  0xDC29,  0xDC28,  0xD3F9,  0xDC2C,  0xD9B8,  0,       // 0x9B9x
      0xE6F3,  0xD7C4,  0xE076,  0xE079,  0x5A49,  0xD7C5,  0xE078,  0xD7C0,  
      0xE122,  0xE07B,  0xE121,  0xD7C2,  0xE07D,  0xE07C,  0xE07A,  0x5A41,  // 0x9BAx
      0xE077,  0x5A3F,  0x76AF,  0x76AE,  0x5A44,  0x76B0,  0x76AD,  0xE123,  
      0x5A45,  0xDDF6,  0,       0x5A43,  0,       0xE472,  0xE475,  0x5F26,  // 0x9BBx
      0xE473,  0xE477,  0x66F9,  0xD9F4,  0x5F22,  0xE478,  0x5F2A,  0xE470,  
      0x78A4,  0xE471,  0xD9F3,  0xE46F,  0xE476,  0xDBF4,  0xE46E,  0xE46D,  // 0x9BCx
      0x78A3,  0x78A1,  0x77FE,  0xD9F6,  0xD9F5,  0xD7C3,  0,       0xE1F2,  
      0,       0,       0xD9F1,  0xE474,  0xE83C,  0xE842,  0x79D6,  0xE83D,  // 0x9BDx
      0x6BB3,  0xE840,  0xE844,  0x79D7,  0xE83F,  0x625C,  0xE837,  0xDBF5,  
      0xE836,  0xE843,  0xE83A,  0xDBF7,  0xE838,  0xE841,  0xE839,  0x79D5,  // 0x9BEx
      0x79D4,  0xDBF9,  0xE834,  0xE835,  0xE83E,  0x6266,  0xDBFA,  0x6268,  
      0xE83B,  0,       0,       0xE4EB,  0x6255,  0,       0xDDEF,  0xEA7A,  // 0x9BFx
      0xEA7D,  0xDDF1,  0x6256,  0xDDE7,  0xDDE9,  0x78A2,  0xDDEA,  0xDDF4,  
} ;


static const unsigned short Uni2cnsP0Table_9C [] = {
      0xDDF5,  0x655A,  0xDDEE,  0x6559,  0xDDE8,  0xEA7B,  0xEB23,  0xEB21,  // 0x9C0x
      0xEA79,  0xEB26,  0xDDE6,  0xEA78,  0xDDF6,  0x7ADA,  0xEB22,  0x6554,  
      0xDDF3,  0x6557,  0xEA7C,  0x7AD9,  0xEB25,  0xDDF2,  0x655D,  0xEB24,  // 0x9C1x
      0,       0,       0,       0xDDF0,  0xEC77,  0xEC76,  0x72D1,  0xDFAC,  
      0x72CB,  0xEC7D,  0x72CE,  0xEC79,  0xEC7C,  0x7BCC,  0x683B,  0x683E,  // 0x9C2x
      0xEC7A,  0xEC7B,  0x6839,  0xEC75,  0xEC78,  0x7BCB,  0xDFAA,  0xE9AA,  
      0,       0x7CAB,  0xEE61,  0xEE5C,  0xEE60,  0xE0A5,  0xEE63,  0xEE5F,  // 0x9C3x
      0xDFFE,  0xEE5B,  0xE0A3,  0x7CAD,  0xEE5E,  0xEE62,  0x7CAC,  0xEE59,  
      0xEA7E,  0xEE5D,  0x6A23,  0x75AD,  0xEE5A,  0xE0A2,  0xEE57,  0xEABE,  // 0x9C4x
      0xEE58,  0x7CAA,  0xEF68,  0xEF6A,  0xEF6D,  0xEF69,  0xEF6E,  0xE0E5,  
      0xEF67,  0xE0E6,  0xEF65,  0xE0E8,  0x7CD7,  0xEF6B,  0x7CD9,  0x7CD8,  // 0x9C5x
      0xEF66,  0xEF6C,  0,       0,       0,       0xE1B2,  0xF068,  0x7CF8,  
      0xF069,  0xE1B3,  0xF067,  0xF064,  0x6C4A,  0xE1B4,  0xF066,  0xF065,  // 0x9C6x
      0xF149,  0,       0,       0,       0xE1D9,  0xF14B,  0xF14A,  0xE1DB,  
      0,       0xF169,  0x7AD3,  0xF168,  0xF167,  0xF16A,  0xE1F5,  0x7DC0,  // 0x9C7x
      0x7DC1,  0xF238,  0xF23C,  0xE2C1,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9C8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9C9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9CAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9CBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9CCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9CDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x5EA4,  0xC154,  0xC873,  // 0x9CEx
      0xC5E4,  0x67ED,  0xC871,  0xC5E6,  0xAFC2,  0xC872,  0xC5E8,  0xC5E7,  
      0,       0xCF4A,  0xCF4B,  0x6BFA,  0x6BF8,  0xCF4C,  0x6BF9,  0xD633,  // 0x9CFx
      0xD0A7,  0xD636,  0xD630,  0xD637,  0xD62F,  0xD631,  0xD0AA,  0xD632,  
} ;


static const unsigned short Uni2cnsP0Table_9D [] = {
      0xD635,  0xD0A4,  0xD0AB,  0x70AA,  0xD63A,  0xD639,  0x70A8,  0xD634,  // 0x9D0x
      0xD638,  0x70A9,  0xD4AD,  0x4F42,  0xD0A5,  0xD0A2,  0,       0xD4AA,  
      0xDC38,  0x5552,  0x73BA,  0xD4AC,  0xDC33,  0x73B6,  0xD4B6,  0xDC30,  // 0x9D1x
      0xDC36,  0xDC39,  0xD4B3,  0x73BB,  0x5A4E,  0xDC35,  0xDC32,  0xDC3A,  
      0xDC31,  0xD4B7,  0xDC37,  0x73B7,  0xD4A9,  0xDC2F,  0x73B8,  0xD4B5,  // 0x9D2x
      0x73B9,  0xDC34,  0xD4B2,  0,       0,       0xE135,  0xE128,  0xE129,  
      0xE12C,  0xE12A,  0x5A55,  0xE124,  0x5A56,  0xD7CD,  0xE127,  0xE131,  // 0x9D3x
      0xE12B,  0xD7C8,  0x5A4F,  0x76B1,  0x5A4D,  0xE133,  0xE130,  0x76B2,  
      0xE132,  0xE125,  0xE12E,  0xE12F,  0xD7CA,  0xE12D,  0,       0xDEA4,  // 0x9D4x
      0,       0xE6F5,  0xE47C,  0xE47E,  0xE523,  0xD9F9,  0xD9FB,  0xE47B,  
      0xD9FD,  0x78A5,  0xE525,  0xE47A,  0xE526,  0xD9FE,  0xE522,  0xE524,  // 0x9D5x
      0xE528,  0xE521,  0xE529,  0xE47D,  0xE479,  0x78A6,  0xDAA2,  0xE527,  
      0x78A7,  0x79D9,  0x5F34,  0xD9FA,  0xE1F7,  0,       0xDBFD,  0xE126,  // 0x9D6x
      0xE85E,  0xE855,  0x79DB,  0xE851,  0x79DC,  0xDCA7,  0xDCA2,  0xE85A,  
      0xE854,  0xE84A,  0x79DA,  0xE857,  0xE852,  0xE853,  0xDCA5,  0xE845,  // 0x9D7x
      0xE84C,  0xE85B,  0xDBFE,  0xE858,  0x6BBF,  0xE850,  0xDCA6,  0xE85C,  
      0xE84B,  0xE846,  0xE859,  0xDCA4,  0xE848,  0xE856,  0xE84D,  0xE85D,  // 0x9D8x
      0xE849,  0x79D8,  0xE847,  0xE84E,  0xE84F,  0,       0,       0,       
      0xEB2D,  0xDCA3,  0xEB2B,  0x6569,  0xEB30,  0xDDF9,  0xEB3C,  0xEB33,  // 0x9D9x
      0xEB2C,  0xEB28,  0xEB35,  0xEB2E,  0xEB31,  0xEB2A,  0xEB38,  0xEB27,  
      0xEB2F,  0xEB34,  0xEB36,  0xEB39,  0xEB29,  0xDDFA,  0xEB3D,  0xEB3E,  // 0x9DAx
      0xEB37,  0xEB3B,  0xEB32,  0,       0xED2F,  0xED32,  0xDFB5,  0x7BCD,  
      0xDFB1,  0xED31,  0xED36,  0xED34,  0x7BCE,  0xED2B,  0xED21,  0xEC7E,  // 0x9DBx
      0x7BD0,  0xED2D,  0xED2E,  0xED2A,  0xED22,  0xDFB2,  0xED27,  0xEB3A,  
      0x6843,  0xED23,  0x7BCF,  0xED29,  0xDFB6,  0xED28,  0,       0xED24,  // 0x9DCx
      0xED30,  0x6844,  0xED25,  0xEE68,  0xED33,  0xED35,  0xED2C,  0xED26,  
      0xEE69,  0xEE6B,  0xEE65,  0x7CAE,  0x6A25,  0xEE72,  0xEE70,  0x7CAF,  // 0x9DDx
      0xEE6F,  0xEE6E,  0xEE67,  0xEE64,  0xEE6A,  0xEE73,  0xEE66,  0xEE6C,  
      0x75C5,  0xEF77,  0xEF7C,  0xEF72,  0xEF75,  0x7CDA,  0xEF79,  0x6B46,  // 0x9DEx
      0xF022,  0xEE6D,  0x6B4A,  0xEF73,  0xEF7D,  0xF023,  0xEF78,  0xEF71,  
      0xEF7B,  0x6B4B,  0xEF7A,  0xF021,  0xEF7E,  0xEE71,  0xEF76,  0xEF70,  // 0x9DFx
      0xEF74,  0x7CF9,  0x7CFA,  0xEF6F,  0xE0EC,  0xF074,  0xF06B,  0xF073,  
} ;


static const unsigned short Uni2cnsP0Table_9E [] = {
      0xF070,  0xF071,  0xF06A,  0xF06D,  0xF075,  0xF06F,  0xF06E,  0xF06C,  // 0x9E0x
      0xE1B5,  0xF072,  0x6C56,  0xF14C,  0x6D3A,  0xF14D,  0xE1DD,  0xF14F,  
      0xF14E,  0xF151,  0xF150,  0xF16C,  0xF16B,  0xF227,  0xE2A9,  0xF228,  // 0x9E1x
      0xE2B0,  0xF234,  0x7DC5,  0x7DC9,  0xE2B8,  0xF23D,  0x7DCA,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E3x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x5EA5,  0x4F48,  0x5ADB,  // 0x9E7x
      0,       0x7ADB,  0xED37,  0xDFB7,  0x7CFB,  0x7CFC,  0,       0x5EA6,  
      0xC874,  0xC5E9,  0x67EE,  0xD63B,  0xD0AC,  0xD4B9,  0xDC3C,  0xDC3D,  // 0x9E8x
      0xDC3B,  0xE137,  0xE136,  0x76B3,  0xE52B,  0xE138,  0xE52A,  0x5F3A,  
      0xDAA4,  0xE860,  0x79DD,  0x79DF,  0xE85F,  0xDCA9,  0x6275,  0x79DE,  // 0x9E9x
      0xDEA1,  0xEB3F,  0xEB41,  0xEB40,  0xED38,  0x7BD1,  0xDFBA,  0x7CDB,  
      0xF076,  0xF152,  0xE2B1,  0xE2BF,  0xF241,  0x5EA7,  0xA5C7,  0xCF4D,  // 0x9EAx
      0x4F4C,  0x70AB,  0xD0AF,  0xD0AE,  0xD4BA,  0xDC3F,  0xDC3E,  0xD7D0,  
      0xE139,  0xDAA6,  0xDAA5,  0x627E,  0x79E0,  0x7ADC,  0xEE74,  0xF239,  // 0x9EBx
      0,       0,       0,       0x5EA8,  0x6BFB,  0xCBA2,  0x70AC,  0xE1FC,  
      0xE861,  0xDEA2,  0xF024,  0x63A7,  0xB9EA,  0xD4BC,  0xD4BB,  0x5A5D,  // 0x9ECx
      0xE13A,  0,       0xDAA8,  0x5F3E,  0x7DB1,  0x63A8,  0x70AD,  0x76B4,  
      0xF025,  0x63A9,  0xB9EB,  0xD63C,  0x73BD,  0xDC40,  0xDC41,  0xD4BD,  // 0x9EDx
      0x73BC,  0x5560,  0xE13B,  0x76B8,  0x76B6,  0x76B7,  0x76B5,  0xE52C,  
      0x78A8,  0,       0x6324,  0xDCAA,  0xEB43,  0xEB42,  0xEB45,  0xEB44,  // 0x9EEx
      0x7ADD,  0,       0,       0xED39,  0x6856,  0xED3B,  0xED3A,  0x7BD2,  
      0xEE75,  0xE0A9,  0xF026,  0xF027,  0x7CDC,  0xF153,  0xF16D,  0x7DC2,  // 0x9EFx
      0x6E43,  0xC155,  0xDC42,  0xE13C,  0xE862,  0xC875,  0xA7F2,  0xE13D,  
} ;


static const unsigned short Uni2cnsP0Table_9F [] = {
      0xE52E,  0xE52D,  0xDAA9,  0xDCAD,  0xDCAE,  0xDFBC,  0xF028,  0x7CFD,  // 0x9F0x
      0xE1DF,  0xF154,  0xF16E,  0,       0,       0,       0x67EF,  0xD63D,  
      0xD63E,  0x4F56,  0xDC43,  0x67F0,  0xC5EA,  0x78A9,  0xE52F,  0xDCB0,  // 0x9F1x
      0xED3D,  0x7BD3,  0xED3E,  0xED3C,  0xF029,  0xE1E0,  0xF077,  0x6D48,  
      0x67F1,  0,       0xE140,  0xE13F,  0xE13E,  0xE530,  0xDAAB,  0xDAAA,  // 0x9F2x
      0xE534,  0xE533,  0xE532,  0xE531,  0x78AA,  0xE863,  0xEB47,  0x7ADE,  
      0xEB46,  0xED3F,  0xEE78,  0xEE77,  0x7CB0,  0xEE76,  0xF02C,  0xF02B,  // 0x9F3x
      0xF02A,  0xE0ED,  0x6E44,  0x6BFC,  0x5563,  0xDC44,  0x76B9,  0x5A64,  
      0xE864,  0xE865,  0xEE79,  0xF02D,  0x6B5C,  0xE1BB,  0xF078,  0xF155,  // 0x9F4x
      0xF229,  0xF243,  0x6BFD,  0x76BA,  0xE535,  0xE866,  0xED40,  0xF02E,  
      0xA3F0,  0,       0x70AF,  0xD4BE,  0xE141,  0xE536,  0xE867,  0xE868,  // 0x9F5x
      0xE869,  0xEB4C,  0xDEA4,  0xEB48,  0x7BD4,  0xEB4B,  0xEB4A,  0x7ADF,  
      0xEB49,  0x7AE1,  0,       0x7AE0,  0xED42,  0xED41,  0x7BD5,  0x7BD6,  // 0x9F6x
      0x6860,  0xDFBE,  0x7CB2,  0xEE7A,  0x7CB1,  0x6B61,  0xF031,  0xF032,  
      0xF030,  0xF02F,  0x7DA1,  0x6C64,  0xF079,  0xF07A,  0xF07B,  0x7CFE,  // 0x9F7x
      0xF156,  0xF159,  0xF158,  0xF157,  0xE2B3,  0x6E45,  0xF242,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9F8x
      0,       0,       0,       0,       0,       0x73BE,  0xD7D5,  0x632D,  
      0x78B2,  0xEB4D,  0xED43,  0xE0AB,  0x7CB3,  0xEE7B,  0x6E55,  0xE2C2,  // 0x9F9x
      0xF244,  0xA1D9,  0,       0,       0x73BF,  0xDEC7,  0x6E33,  0,       
      0xE142,  0xDFBF,  0xEE7C,  0xE1E1,  0xF16F,  0xE1F7,  0,       0,       // 0x9FAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9FBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9FCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9FDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9FEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9FFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_A0  NULL
#define  Uni2cnsP0Table_A1  NULL
#define  Uni2cnsP0Table_A2  NULL
#define  Uni2cnsP0Table_A3  NULL
#define  Uni2cnsP0Table_A4  NULL
#define  Uni2cnsP0Table_A5  NULL
#define  Uni2cnsP0Table_A6  NULL
#define  Uni2cnsP0Table_A7  NULL
#define  Uni2cnsP0Table_A8  NULL
#define  Uni2cnsP0Table_A9  NULL
#define  Uni2cnsP0Table_AA  NULL
#define  Uni2cnsP0Table_AB  NULL
#define  Uni2cnsP0Table_AC  NULL
#define  Uni2cnsP0Table_AD  NULL
#define  Uni2cnsP0Table_AE  NULL
#define  Uni2cnsP0Table_AF  NULL
#define  Uni2cnsP0Table_B0  NULL
#define  Uni2cnsP0Table_B1  NULL
#define  Uni2cnsP0Table_B2  NULL
#define  Uni2cnsP0Table_B3  NULL
#define  Uni2cnsP0Table_B4  NULL
#define  Uni2cnsP0Table_B5  NULL
#define  Uni2cnsP0Table_B6  NULL
#define  Uni2cnsP0Table_B7  NULL
#define  Uni2cnsP0Table_B8  NULL
#define  Uni2cnsP0Table_B9  NULL
#define  Uni2cnsP0Table_BA  NULL
#define  Uni2cnsP0Table_BB  NULL
#define  Uni2cnsP0Table_BC  NULL
#define  Uni2cnsP0Table_BD  NULL
#define  Uni2cnsP0Table_BE  NULL
#define  Uni2cnsP0Table_BF  NULL
#define  Uni2cnsP0Table_C0  NULL
#define  Uni2cnsP0Table_C1  NULL
#define  Uni2cnsP0Table_C2  NULL
#define  Uni2cnsP0Table_C3  NULL
#define  Uni2cnsP0Table_C4  NULL
#define  Uni2cnsP0Table_C5  NULL
#define  Uni2cnsP0Table_C6  NULL
#define  Uni2cnsP0Table_C7  NULL
#define  Uni2cnsP0Table_C8  NULL
#define  Uni2cnsP0Table_C9  NULL
#define  Uni2cnsP0Table_CA  NULL
#define  Uni2cnsP0Table_CB  NULL
#define  Uni2cnsP0Table_CC  NULL
#define  Uni2cnsP0Table_CD  NULL
#define  Uni2cnsP0Table_CE  NULL
#define  Uni2cnsP0Table_CF  NULL
#define  Uni2cnsP0Table_D0  NULL
#define  Uni2cnsP0Table_D1  NULL
#define  Uni2cnsP0Table_D2  NULL
#define  Uni2cnsP0Table_D3  NULL
#define  Uni2cnsP0Table_D4  NULL
#define  Uni2cnsP0Table_D5  NULL
#define  Uni2cnsP0Table_D6  NULL
#define  Uni2cnsP0Table_D7  NULL
#define  Uni2cnsP0Table_D8  NULL
#define  Uni2cnsP0Table_D9  NULL
#define  Uni2cnsP0Table_DA  NULL
#define  Uni2cnsP0Table_DB  NULL
#define  Uni2cnsP0Table_DC  NULL
#define  Uni2cnsP0Table_DD  NULL
#define  Uni2cnsP0Table_DE  NULL
#define  Uni2cnsP0Table_DF  NULL
#define  Uni2cnsP0Table_E0  NULL
#define  Uni2cnsP0Table_E1  NULL
#define  Uni2cnsP0Table_E2  NULL
#define  Uni2cnsP0Table_E3  NULL
#define  Uni2cnsP0Table_E4  NULL
#define  Uni2cnsP0Table_E5  NULL
#define  Uni2cnsP0Table_E6  NULL
#define  Uni2cnsP0Table_E7  NULL
#define  Uni2cnsP0Table_E8  NULL
#define  Uni2cnsP0Table_E9  NULL
#define  Uni2cnsP0Table_EA  NULL
#define  Uni2cnsP0Table_EB  NULL
#define  Uni2cnsP0Table_EC  NULL
#define  Uni2cnsP0Table_ED  NULL
#define  Uni2cnsP0Table_EE  NULL
#define  Uni2cnsP0Table_EF  NULL
#define  Uni2cnsP0Table_F0  NULL
#define  Uni2cnsP0Table_F1  NULL
#define  Uni2cnsP0Table_F2  NULL
#define  Uni2cnsP0Table_F3  NULL
#define  Uni2cnsP0Table_F4  NULL
#define  Uni2cnsP0Table_F5  NULL
#define  Uni2cnsP0Table_F6  NULL
#define  Uni2cnsP0Table_F7  NULL
#define  Uni2cnsP0Table_F8  NULL
#define  Uni2cnsP0Table_F9  NULL

static const unsigned short Uni2cnsP0Table_FA [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA2x
      0xD8CC,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA3x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFABx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFACx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFADx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP0Table_FB  NULL
#define  Uni2cnsP0Table_FC  NULL
#define  Uni2cnsP0Table_FD  NULL

static const unsigned short Uni2cnsP0Table_FE [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x21AB,  0x21B6,  0x21B8,  0,       0,       0x21C0,  0x21C1,  0x21C4,  // 0xFE3x
      0x21C5,  0x21C8,  0x21C9,  0x21CC,  0x21CD,  0x21D0,  0x21D1,  0x21D4,  
      0x21D5,  0x21D8,  0x21D9,  0x21DC,  0x21DD,  0,       0,       0,       // 0xFE4x
      0,       0x22A7,  0x22A8,  0x22AB,  0x22AC,  0x22A9,  0x22AA,  0,       
      0x21AE,  0x21AF,  0x21B0,  0,       0x21B2,  0x21B3,  0x21B4,  0x21B5,  // 0xFE5x
      0,       0x21DE,  0x21DF,  0x21E0,  0x21E1,  0x21E2,  0x21E3,  0x22AD,  
      0x22AE,  0x22AF,  0x22BF,  0x22C0,  0x22C1,  0x22C3,  0x22C2,  0,       // 0xFE6x
      0x22E2,  0x22EC,  0x22ED,  0x22EE,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFECx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP0Table_FF [] = {
      0,       0x21AA,  0,       0x21EC,  0x22E3,  0x22E8,  0x21ED,  0,       // 0xFF0x
      0x21BE,  0x21BF,  0x21EE,  0x22B0,  0x21A2,  0x22B1,  0x21A5,  0x22DF,  
      0x24A1,  0x24A2,  0x24A3,  0x24A4,  0x24A5,  0x24A6,  0x24A7,  0x24A8,  // 0xFF1x
      0x24A9,  0x24AA,  0x21A8,  0x21A7,  0x22B6,  0x22B8,  0x22B7,  0x21A9,  
      0x22E9,  0x24C1,  0x24C2,  0x24C3,  0x24C4,  0x24C5,  0x24C6,  0x24C7,  // 0xFF2x
      0x24C8,  0x24C9,  0x24CA,  0x24CB,  0x24CC,  0x24CD,  0x24CE,  0x24CF,  
      0x24D0,  0x24D1,  0x24D2,  0x24D3,  0x24D4,  0x24D5,  0x24D6,  0x24D7,  // 0xFF3x
      0x24D8,  0x24D9,  0x24DA,  0,       0x22E0,  0,       0,       0x22A5,  
      0,       0x24DB,  0x24DC,  0x24DD,  0x24DE,  0x24DF,  0x24E0,  0x24E1,  // 0xFF4x
      0x24E2,  0x24E3,  0x24E4,  0x24E5,  0x24E6,  0x24E7,  0x24E8,  0x24E9,  
      0x24EA,  0x24EB,  0x24EC,  0x24ED,  0x24EE,  0x24EF,  0x24F0,  0x24F1,  // 0xFF5x
      0x24F2,  0x24F3,  0x24F4,  0x21C2,  0x22DE,  0x21C3,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFF6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFF7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFF8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFF9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFFAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFFBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFFCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFFDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x22E6,  0x22E7,  0,       0,       0,       0x22E4,  0,       0,       // 0xFFEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFFFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;



static const unsigned short *Uni2cnsP0Table ( int C ) {

   static const unsigned short *const Uni2cnsP0Table_00_FF [] = {
      Uni2cnsP0Table_00, Uni2cnsP0Table_01, Uni2cnsP0Table_02, Uni2cnsP0Table_03,
      Uni2cnsP0Table_04, Uni2cnsP0Table_05, Uni2cnsP0Table_06, Uni2cnsP0Table_07,
      Uni2cnsP0Table_08, Uni2cnsP0Table_09, Uni2cnsP0Table_0A, Uni2cnsP0Table_0B,
      Uni2cnsP0Table_0C, Uni2cnsP0Table_0D, Uni2cnsP0Table_0E, Uni2cnsP0Table_0F,

      Uni2cnsP0Table_10, Uni2cnsP0Table_11, Uni2cnsP0Table_12, Uni2cnsP0Table_13,
      Uni2cnsP0Table_14, Uni2cnsP0Table_15, Uni2cnsP0Table_16, Uni2cnsP0Table_17,
      Uni2cnsP0Table_18, Uni2cnsP0Table_19, Uni2cnsP0Table_1A, Uni2cnsP0Table_1B,
      Uni2cnsP0Table_1C, Uni2cnsP0Table_1D, Uni2cnsP0Table_1E, Uni2cnsP0Table_1F,

      Uni2cnsP0Table_20, Uni2cnsP0Table_21, Uni2cnsP0Table_22, Uni2cnsP0Table_23,
      Uni2cnsP0Table_24, Uni2cnsP0Table_25, Uni2cnsP0Table_26, Uni2cnsP0Table_27,
      Uni2cnsP0Table_28, Uni2cnsP0Table_29, Uni2cnsP0Table_2A, Uni2cnsP0Table_2B,
      Uni2cnsP0Table_2C, Uni2cnsP0Table_2D, Uni2cnsP0Table_2E, Uni2cnsP0Table_2F,

      Uni2cnsP0Table_30, Uni2cnsP0Table_31, Uni2cnsP0Table_32, Uni2cnsP0Table_33,
      Uni2cnsP0Table_34, Uni2cnsP0Table_35, Uni2cnsP0Table_36, Uni2cnsP0Table_37,
      Uni2cnsP0Table_38, Uni2cnsP0Table_39, Uni2cnsP0Table_3A, Uni2cnsP0Table_3B,
      Uni2cnsP0Table_3C, Uni2cnsP0Table_3D, Uni2cnsP0Table_3E, Uni2cnsP0Table_3F,

      Uni2cnsP0Table_40, Uni2cnsP0Table_41, Uni2cnsP0Table_42, Uni2cnsP0Table_43,
      Uni2cnsP0Table_44, Uni2cnsP0Table_45, Uni2cnsP0Table_46, Uni2cnsP0Table_47,
      Uni2cnsP0Table_48, Uni2cnsP0Table_49, Uni2cnsP0Table_4A, Uni2cnsP0Table_4B,
      Uni2cnsP0Table_4C, Uni2cnsP0Table_4D, Uni2cnsP0Table_4E, Uni2cnsP0Table_4F,

      Uni2cnsP0Table_50, Uni2cnsP0Table_51, Uni2cnsP0Table_52, Uni2cnsP0Table_53,
      Uni2cnsP0Table_54, Uni2cnsP0Table_55, Uni2cnsP0Table_56, Uni2cnsP0Table_57,
      Uni2cnsP0Table_58, Uni2cnsP0Table_59, Uni2cnsP0Table_5A, Uni2cnsP0Table_5B,
      Uni2cnsP0Table_5C, Uni2cnsP0Table_5D, Uni2cnsP0Table_5E, Uni2cnsP0Table_5F,

      Uni2cnsP0Table_60, Uni2cnsP0Table_61, Uni2cnsP0Table_62, Uni2cnsP0Table_63,
      Uni2cnsP0Table_64, Uni2cnsP0Table_65, Uni2cnsP0Table_66, Uni2cnsP0Table_67,
      Uni2cnsP0Table_68, Uni2cnsP0Table_69, Uni2cnsP0Table_6A, Uni2cnsP0Table_6B,
      Uni2cnsP0Table_6C, Uni2cnsP0Table_6D, Uni2cnsP0Table_6E, Uni2cnsP0Table_6F,

      Uni2cnsP0Table_70, Uni2cnsP0Table_71, Uni2cnsP0Table_72, Uni2cnsP0Table_73,
      Uni2cnsP0Table_74, Uni2cnsP0Table_75, Uni2cnsP0Table_76, Uni2cnsP0Table_77,
      Uni2cnsP0Table_78, Uni2cnsP0Table_79, Uni2cnsP0Table_7A, Uni2cnsP0Table_7B,
      Uni2cnsP0Table_7C, Uni2cnsP0Table_7D, Uni2cnsP0Table_7E, Uni2cnsP0Table_7F,

      Uni2cnsP0Table_80, Uni2cnsP0Table_81, Uni2cnsP0Table_82, Uni2cnsP0Table_83,
      Uni2cnsP0Table_84, Uni2cnsP0Table_85, Uni2cnsP0Table_86, Uni2cnsP0Table_87,
      Uni2cnsP0Table_88, Uni2cnsP0Table_89, Uni2cnsP0Table_8A, Uni2cnsP0Table_8B,
      Uni2cnsP0Table_8C, Uni2cnsP0Table_8D, Uni2cnsP0Table_8E, Uni2cnsP0Table_8F,

      Uni2cnsP0Table_90, Uni2cnsP0Table_91, Uni2cnsP0Table_92, Uni2cnsP0Table_93,
      Uni2cnsP0Table_94, Uni2cnsP0Table_95, Uni2cnsP0Table_96, Uni2cnsP0Table_97,
      Uni2cnsP0Table_98, Uni2cnsP0Table_99, Uni2cnsP0Table_9A, Uni2cnsP0Table_9B,
      Uni2cnsP0Table_9C, Uni2cnsP0Table_9D, Uni2cnsP0Table_9E, Uni2cnsP0Table_9F,

      Uni2cnsP0Table_A0, Uni2cnsP0Table_A1, Uni2cnsP0Table_A2, Uni2cnsP0Table_A3,
      Uni2cnsP0Table_A4, Uni2cnsP0Table_A5, Uni2cnsP0Table_A6, Uni2cnsP0Table_A7,
      Uni2cnsP0Table_A8, Uni2cnsP0Table_A9, Uni2cnsP0Table_AA, Uni2cnsP0Table_AB,
      Uni2cnsP0Table_AC, Uni2cnsP0Table_AD, Uni2cnsP0Table_AE, Uni2cnsP0Table_AF,

      Uni2cnsP0Table_B0, Uni2cnsP0Table_B1, Uni2cnsP0Table_B2, Uni2cnsP0Table_B3,
      Uni2cnsP0Table_B4, Uni2cnsP0Table_B5, Uni2cnsP0Table_B6, Uni2cnsP0Table_B7,
      Uni2cnsP0Table_B8, Uni2cnsP0Table_B9, Uni2cnsP0Table_BA, Uni2cnsP0Table_BB,
      Uni2cnsP0Table_BC, Uni2cnsP0Table_BD, Uni2cnsP0Table_BE, Uni2cnsP0Table_BF,

      Uni2cnsP0Table_C0, Uni2cnsP0Table_C1, Uni2cnsP0Table_C2, Uni2cnsP0Table_C3,
      Uni2cnsP0Table_C4, Uni2cnsP0Table_C5, Uni2cnsP0Table_C6, Uni2cnsP0Table_C7,
      Uni2cnsP0Table_C8, Uni2cnsP0Table_C9, Uni2cnsP0Table_CA, Uni2cnsP0Table_CB,
      Uni2cnsP0Table_CC, Uni2cnsP0Table_CD, Uni2cnsP0Table_CE, Uni2cnsP0Table_CF,

      Uni2cnsP0Table_D0, Uni2cnsP0Table_D1, Uni2cnsP0Table_D2, Uni2cnsP0Table_D3,
      Uni2cnsP0Table_D4, Uni2cnsP0Table_D5, Uni2cnsP0Table_D6, Uni2cnsP0Table_D7,
      Uni2cnsP0Table_D8, Uni2cnsP0Table_D9, Uni2cnsP0Table_DA, Uni2cnsP0Table_DB,
      Uni2cnsP0Table_DC, Uni2cnsP0Table_DD, Uni2cnsP0Table_DE, Uni2cnsP0Table_DF,

      Uni2cnsP0Table_E0, Uni2cnsP0Table_E1, Uni2cnsP0Table_E2, Uni2cnsP0Table_E3,
      Uni2cnsP0Table_E4, Uni2cnsP0Table_E5, Uni2cnsP0Table_E6, Uni2cnsP0Table_E7,
      Uni2cnsP0Table_E8, Uni2cnsP0Table_E9, Uni2cnsP0Table_EA, Uni2cnsP0Table_EB,
      Uni2cnsP0Table_EC, Uni2cnsP0Table_ED, Uni2cnsP0Table_EE, Uni2cnsP0Table_EF,

      Uni2cnsP0Table_F0, Uni2cnsP0Table_F1, Uni2cnsP0Table_F2, Uni2cnsP0Table_F3,
      Uni2cnsP0Table_F4, Uni2cnsP0Table_F5, Uni2cnsP0Table_F6, Uni2cnsP0Table_F7,
      Uni2cnsP0Table_F8, Uni2cnsP0Table_F9, Uni2cnsP0Table_FA, Uni2cnsP0Table_FB,
      Uni2cnsP0Table_FC, Uni2cnsP0Table_FD, Uni2cnsP0Table_FE, Uni2cnsP0Table_FF,
   } ;

   if ( (unsigned) C <= 0xFF ) return Uni2cnsP0Table_00_FF [ C ] ;

   return NULL ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                                UNICODE (P2) -> CNS
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short Uni2cnsP2Table_00 [] = {
      0x21A5,  0,       0xA1A1,  0xA12F,  0xA12D,  0xA12E,  0,       0xA142,  // 0x000x
      0xA143,  0x21B3,  0,       0xA1C4,  0,       0,       0,       0xA1BE,  
      0xA1BF,  0,       0xA22B,  0,       0x21CD,  0,       0,       0,       // 0x001x
      0xA340,  0xA33E,  0xA33F,  0,       0,       0,       0,       0,       
      0xA467,  0xA55F,  0x23AF,  0xA2F4,  0,       0xA567,  0,       0,       // 0x002x
      0,       0xA563,  0,       0,       0xA937,  0xA93A,  0xA938,  0,       
      0,       0,       0,       0,       0,       0xA9A2,  0xA9A3,  0,       // 0x003x
      0,       0,       0,       0xAE66,  0,       0,       0,       0,       
      0,       0x30F2,  0,       0x33A3,  0,       0,       0xB9B2,  0xB9B3,  // 0x004x
      0xC72D,  0,       0,       0xBBF3,  0xC0B5,  0xC0F5,  0,       0,       
      0,       0,       0xC7C2,  0xCDD6,  0,       0xA1A1,  0xD9C7,  0x4F7C,  // 0x005x
      0,       0,       0,       0xDABF,  0,       0,       0,       0,       
      0,       0xA12C,  0xA122,  0,       0xA25F,  0x2156,  0xA341,  0xA560,  // 0x006x
      0,       0xA93B,  0,       0x25A1,  0,       0x27FA,  0xAE4A,  0xA9D0,  
      0xB525,  0xB526,  0xC57D,  0,       0xC63F,  0,       0xC6C0,  0x44FE,  // 0x007x
      0,       0,       0,       0,       0,       0xA132,  0x21AD,  0xA22D,  
      0,       0,       0xA342,  0xADE1,  0xD050,  0xD3C4,  0x2121,  0x21A6,  // 0x008x
      0xA124,  0,       0,       0,       0xA1A2,  0xA133,  0,       0xA144,  
      0,       0,       0xA1A5,  0xA1A6,  0x21CE,  0xA230,  0,       0xA1C5,  // 0x009x
      0xA24E,  0xA22F,  0xA1C0,  0xA1C1,  0xA145,  0,       0xA231,  0,       
      0xA22E,  0,       0x2226,  0x2225,  0x22A4,  0x22A5,  0,       0,       // 0x00Ax
      0xA343,  0xA93E,  0,       0,       0xA45D,  0,       0xA556,  0xA561,  
      0xA562,  0xAC43,  0xA93C,  0xBA65,  0xA9A5,  0xAD2D,  0xA93D,  0xAE4B,  // 0x00Bx
      0,       0x2BE7,  0xB52A,  0,       0xB527,  0xB964,  0xB529,  0xBC7B,  
      0,       0,       0xC57E,  0xC640,  0xC641,  0,       0x3DD6,  0,       // 0x00Cx
      0,       0x21A3,  0,       0x21A2,  0,       0,       0,       0xA126,  
      0xA125,  0x21A1,  0x21AB,  0,       0xA1A3,  0xA146,  0x21B4,  0,       // 0x00Dx
      0xA1A7,  0xA1A8,  0,       0,       0,       0,       0xA233,  0xA232,  
      0xA22A,  0x21CF,  0,       0,       0xA346,  0xA344,  0xA1EE,  0xA345,  // 0x00Ex
      0,       0,       0xA2F5,  0,       0,       0xA93F,  0,       0,       
      0xAD2C,  0x2624,  0xAE4D,  0xAE4E,  0xA5C0,  0,       0xAE4C,  0,       // 0x00Fx
      0xB52B,  0,       0,       0xADE0,  0xBC7E,  0x30F3,  0xBC7D,  0,       
} ;


static const unsigned short Uni2cnsP2Table_01 [] = {
      0,       0,       0xB9B4,  0,       0xD051,  0x44D5,  0xC6C1,  0xDA63,  // 0x010x
      0xDA62,  0xB6F3,  0xC6A7,  0xCDBA,  0x21A4,  0x21A7,  0x2128,  0x21A8,  
      0,       0x21AC,  0xA147,  0xA148,  0xA149,  0xA347,  0x23B0,  0xA564,  // 0x011x
      0,       0xA940,  0x30F4,  0xC642,  0,       0xACBC,  0xA127,  0xA128,  
      0xA129,  0xA14A,  0xA565,  0xA348,  0xA349,  0,       0,       0,       // 0x012x
      0xA568,  0,       0xA2F6,  0,       0x2533,  0x25A2,  0x2532,  0,       
      0xAE50,  0x27FB,  0xA9A7,  0,       0xB07C,  0xB52D,  0,       0xB52C,  // 0x013x
      0xADE2,  0xBD21,  0,       0,       0,       0,       0,       0,       
      0xCDEE,  0,       0,       0xA34A,  0xA1EF,  0xA1F0,  0,       0xA2AB,  // 0x014x
      0x23B1,  0xA2F7,  0xA2F8,  0xA2F9,  0x25A3,  0,       0,       0xA941,  
      0,       0xA5C3,  0,       0xAE52,  0xAE51,  0xA9A8,  0xB52F,  0x2CE6,  // 0x015x
      0x2B5F,  0xB530,  0,       0,       0,       0xADE3,  0xB531,  0xC643,  
      0xBD23,  0xBD22,  0x3044,  0x30F5,  0xB2F4,  0xB2F5,  0,       0xB2F2,  // 0x016x
      0,       0xC645,  0xC644,  0xC646,  0x362F,  0xB9B5,  0xB9B6,  0xB9B7,  
      0xCC2D,  0,       0,       0,       0xC0B6,  0xC0B7,  0xC0B8,  0,       // 0x017x
      0,       0,       0,       0,       0,       0,       0xC6C2,  0,       
      0xD052,  0x4BF1,  0xA1A2,  0xCDD7,  0xCDD8,  0xCDD9,  0xA6F9,  0xA1A4,  // 0x018x
      0,       0xA1A3,  0xA1C6,  0,       0xACBF,  0,       0x53D3,  0xACBE,  
      0,       0,       0xACBD,  0,       0,       0,       0,       0,       // 0x019x
      0,       0,       0,       0,       0xC6A3,  0xC6A8,  0,       0,       
      0,       0,       0,       0xA134,  0xA135,  0xA1A4,  0xA14C,  0xA1A9,  // 0x01Ax
      0xA14B,  0xA1EF,  0,       0,       0xA1C3,  0xA235,  0,       0xA234,  
      0xA236,  0,       0x2158,  0,       0x222C,  0x222B,  0x2229,  0xA34F,  // 0x01Bx
      0x2230,  0xA350,  0x22A7,  0xA34D,  0xA34C,  0,       0,       0,       
      0,       0,       0x222F,  0xA34B,  0xA1F3,  0xA1F4,  0xA1F5,  0xA1F6,  // 0x01Cx
      0xA1F7,  0xA1F8,  0xA1F9,  0x22A8,  0,       0,       0,       0xA351,  
      0x22A6,  0,       0,       0,       0xA1FA,  0,       0,       0,       // 0x01Dx
      0x23B2,  0xA56A,  0x233A,  0xA56B,  0xA574,  0xA570,  0xA56C,  0xA2FA,  
      0xA2FB,  0xA2FC,  0xA2FD,  0xA3A1,  0xA3A2,  0xA3A3,  0xA3A5,  0xA3A8,  // 0x01Ex
      0xA3A9,  0xA3AA,  0xA3AB,  0xA3AC,  0,       0,       0,       0,       
      0,       0x2338,  0xA56D,  0,       0xA56F,  0,       0,       0xA3A6,  // 0x01Fx
      0,       0,       0,       0,       0,       0,       0xA56E,  0xA569,  
} ;


static const unsigned short Uni2cnsP2Table_02 [] = {
      0x23B3,  0xA573,  0,       0xA943,  0xA945,  0x253A,  0x25A8,  0xA946,  // 0x020x
      0x25A9,  0xA7CE,  0x25AA,  0x2537,  0x2535,  0xA94A,  0xA944,  0xA94C,  
      0xA947,  0xA94E,  0,       0,       0,       0x25A6,  0xA942,  0xA5C5,  // 0x021x
      0xA5C6,  0xA5C8,  0xA5C9,  0xA5CB,  0xA5CC,  0xA5CD,  0xA5CE,  0xA5CF,  
      0xA5D0,  0xA5D1,  0xA94D,  0,       0,       0,       0,       0xA948,  // 0x022x
      0xA949,  0xA94B,  0x25A4,  0,       0x25A7,  0x27FC,  0xAE64,  0xAE59,  
      0x2BF2,  0x2836,  0xAE63,  0xAE57,  0xAE56,  0x28A3,  0x283B,  0xAE5D,  // 0x023x
      0x27FE,  0x27FD,  0x28A2,  0xAE62,  0xAE55,  0xAE54,  0xAE65,  0xAE5C,  
      0,       0,       0,       0,       0xA9A9,  0xA9AA,  0xA9AB,  0xA9AC,  // 0x024x
      0xA9AE,  0xA9AF,  0xA9B1,  0xA9B2,  0xA9B3,  0xA9B4,  0xA9B5,  0xA9B6,  
      0xA9B7,  0xA9B8,  0xAE53,  0,       0xAE58,  0xAE5B,  0xAE5E,  0,       // 0x025x
      0xAE60,  0,       0,       0xA5C7,  0,       0,       0,       0,       
      0,       0xAE5F,  0x28A4,  0x2B63,  0x2BF0,  0x2B67,  0xB536,  0x2BEB,  // 0x026x
      0xB535,  0x2BF4,  0x2B66,  0x2B68,  0x2BEF,  0xB532,  0x2BE9,  0,       
      0,       0xADE4,  0xADEE,  0xB537,  0,       0,       0x2BEE,  0xADE6,  // 0x027x
      0xADE7,  0xADEA,  0xADEB,  0xADEC,  0xADED,  0xADEF,  0xADF1,  0xADF2,  
      0xADF3,  0xADF4,  0xADF5,  0xADF6,  0xADF8,  0xADF9,  0xADFA,  0xADFB,  // 0x028x
      0xADFC,  0,       0xB521,  0xB53A,  0xB53B,  0,       0,       0,       
      0,       0xB533,  0xB534,  0,       0x2BE8,  0,       0xB539,  0,       // 0x029x
      0,       0,       0,       0,       0,       0,       0xADF7,  0,       
      0xADF0,  0,       0x2BEA,  0x2BED,  0x2BF5,  0x2BF1,  0x2BF3,  0x2B60,  // 0x02Ax
      0xBD2B,  0xBD2D,  0xBD2C,  0x3049,  0x3048,  0xBD30,  0xBD28,  0,       
      0x31A1,  0xBD33,  0x30F7,  0xBD2E,  0xBD27,  0x31A2,  0x30F6,  0x3046,  // 0x02Bx
      0xBD2A,  0xBD31,  0xBD37,  0xBD32,  0,       0,       0xBD29,  0,       
      0,       0x304B,  0xBD34,  0xADE9,  0xB2F7,  0xB2F8,  0xB2F9,  0xB2FA,  // 0x02Cx
      0xB2FB,  0xB2FC,  0xB2FE,  0xB3A1,  0xB3A3,  0xB3A4,  0xB3A5,  0xB3A6,  
      0xB3A7,  0xC637,  0xBD38,  0xBE65,  0xBD39,  0xBD2F,  0x30FA,  0,       // 0x02Dx
      0,       0,       0,       0xC363,  0,       0x30FD,  0,       0,       
      0,       0x31A3,  0xBD24,  0xBD26,  0,       0xB2FD,  0,       0x30F9,  // 0x02Ex
      0x30FE,  0x30F8,  0xBD25,  0xBD36,  0x30FC,  0xC649,  0xC64F,  0x36D6,  
      0x36D1,  0xC64C,  0x36CE,  0x36D2,  0x36E3,  0x36D3,  0xC648,  0x36D5,  // 0x02Fx
      0x36D0,  0xC656,  0x3635,  0x36D4,  0xC652,  0xC650,  0xC64B,  0xC64E,  
} ;


static const unsigned short Uni2cnsP2Table_03 [] = {
      0xC653,  0,       0,       0,       0,       0,       0,       0xB2F6,  // 0x030x
      0xC658,  0x36CF,  0,       0x36D7,  0xC647,  0xB9B8,  0xB9B9,  0xB9BA,  
      0xB9BB,  0xB9BC,  0xB9BD,  0xB9BE,  0xB9BF,  0,       0,       0xC64D,  // 0x031x
      0x363B,  0,       0,       0,       0xC651,  0,       0,       0,       
      0xC654,  0x36CD,  0,       0,       0,       0,       0,       0,       // 0x032x
      0,       0xC64A,  0x34A1,  0xD05A,  0x4238,  0x3DDA,  0x3DD8,  0xD053,  
      0x30FB,  0x3DDE,  0x3DDC,  0xD058,  0x3DDB,  0xD05F,  0xD05D,  0x3C2E,  // 0x033x
      0,       0xD05C,  0xD062,  0xD055,  0x3C2F,  0,       0x3DE0,  0xD054,  
      0x3DD7,  0,       0,       0,       0xD057,  0,       0,       0,       // 0x034x
      0xD05E,  0xC0B9,  0xC0BA,  0xC0BB,  0xC0BC,  0xC0BD,  0xC0BE,  0xC0BF,  
      0xC0C0,  0xC0C1,  0xC0C2,  0xC0C3,  0xC0C4,  0xC0C5,  0xC0C6,  0,       // 0x035x
      0xD061,  0,       0,       0,       0,       0,       0xD64E,  0xD059,  
      0,       0,       0xD056,  0,       0,       0,       0,       0xC657,  // 0x036x
      0x3DD9,  0x3DDD,  0x3DDF,  0x3C2B,  0xD060,  0,       0xDA71,  0x3DE1,  
      0xA1AE,  0x4234,  0x44D6,  0xDA64,  0xDA69,  0x3DE2,  0xDA6B,  0x4239,  // 0x037x
      0xDA74,  0x4231,  0xDA75,  0xDA68,  0,       0,       0,       0,       
      0,       0,       0xDA67,  0xDA76,  0xC6C3,  0xC6C4,  0xC6C5,  0xC6C6,  // 0x038x
      0xC6C7,  0xC6C9,  0xC6CA,  0xC6CB,  0xC6CC,  0xC6CD,  0xC6CE,  0xC6CF,  
      0xC6D1,  0xC6D2,  0xC6D3,  0xC6D4,  0xC6D6,  0xC6D7,  0xC6D8,  0xD3C5,  // 0x039x
      0xA6AD,  0x44D8,  0xDA77,  0xDE57,  0,       0,       0xDA6D,  0,       
      0,       0xDA6F,  0xDA65,  0xC6D0,  0,       0,       0,       0xC6C8,  // 0x03Ax
      0,       0,       0,       0,       0xC6D5,  0,       0x4230,  0xDA66,  
      0xDA6A,  0xDA6E,  0xDA70,  0x4236,  0,       0,       0x3FC6,  0x487E,  // 0x03Bx
      0x487A,  0xDA6C,  0xA1AF,  0xA1B1,  0xA1A9,  0xA1A6,  0xA1A5,  0x4BF7,  
      0x487C,  0xA1AB,  0xA1AC,  0x4BF3,  0xA1AA,  0,       0,       0x4BF9,  // 0x03Cx
      0x4BF8,  0,       0xA1A7,  0,       0xCDDA,  0xCDDB,  0xCDDC,  0xCDDD,  
      0xCDDE,  0xCDE0,  0xCDE1,  0,       0xA1A8,  0,       0x4BF2,  0xA1AD,  // 0x03Dx
      0,       0,       0xCDE2,  0,       0,       0,       0,       0,       
      0,       0x4921,  0x4BF5,  0xA1B0,  0x4BF4,  0,       0,       0x4CC5,  // 0x03Ex
      0x53D4,  0x53DA,  0xACC0,  0x4F58,  0x4F5F,  0x53D8,  0x4F5C,  0x4F5E,  
      0x53D5,  0,       0,       0,       0x53D6,  0,       0xD3C6,  0xD3C7,  // 0x03Fx
      0xD3C8,  0,       0xD3C9,  0xD3CA,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_04 [] = {
      0x53DB,  0,       0,       0,       0,       0,       0x53D7,  0,       // 0x040x
      0xB6F8,  0x4BF6,  0x5AEF,  0x5AF0,  0x5567,  0x5566,  0xB6F6,  0,       
      0,       0,       0xD9C8,  0,       0,       0xD9CA,  0xD9CB,  0xD9CC,  // 0x041x
      0xD9CE,  0,       0xB6F5,  0xB6F7,  0,       0,       0,       0xD9C9,  
      0,       0x5568,  0xB6F4,  0xBEF6,  0x5A6B,  0x5A69,  0x5A6A,  0xBEF8,  // 0x042x
      0xBEF7,  0,       0xDEB0,  0xDEB1,  0,       0,       0xDEAC,  0xDEAE,  
      0xDEAF,  0xBEF5,  0x61B1,  0x5A6C,  0,       0x61AF,  0x61B0,  0,       // 0x043x
      0,       0,       0x61B2,  0x67CA,  0x67CE,  0x632E,  0x67CD,  0x67CF,  
      0xE1FE,  0xE2A1,  0xC7EF,  0,       0x67CC,  0x67CB,  0,       0,       // 0x044x
      0,       0,       0,       0,       0x69FC,  0xD2F5,  0xCDBC,  0xE4FA,  
      0,       0x6BEB,  0xCDBB,  0xCDE8,  0,       0,       0,       0x662F,  // 0x045x
      0x662E,  0x6FE8,  0xD7CE,  0x6BEC,  0xE7BF,  0xE7FE,  0,       0x662D,  
      0,       0,       0,       0,       0xD7CD,  0,       0xE9B8,  0xE9BA,  // 0x046x
      0xE9B9,  0x73B1,  0x6A40,  0xDBC5,  0,       0xEACB,  0xEBC1,  0x75E2,  
      0,       0,       0x6D52,  0xECC9,  0,       0,       0xA14D,  0x215C,  // 0x047x
      0,       0x2232,  0xA353,  0xA354,  0,       0xA575,  0xA577,  0xA578,  
      0x23B5,  0xA576,  0,       0xA951,  0xA950,  0xA94F,  0xA953,  0,       // 0x048x
      0xA5D3,  0,       0xA952,  0xA5D2,  0xAE67,  0xAE68,  0,       0,       
      0x2BF6,  0,       0,       0xADFD,  0xADFE,  0xAEA1,  0xB53C,  0xB3A8,  // 0x049x
      0x31A4,  0x31A5,  0xB3A9,  0xB3AA,  0,       0,       0xC659,  0xB9C0,  
      0xB9C1,  0xB9C2,  0x36D8,  0xB9C3,  0xC0C7,  0,       0,       0,       // 0x04Ax
      0xD063,  0xC0C8,  0xC6D9,  0xC6DA,  0,       0x44D9,  0,       0,       
      0xA1B4,  0xA1B2,  0x4BFB,  0xCDE3,  0xCDE4,  0x4BFA,  0xA1B3,  0,       // 0x04Bx
      0x53DC,  0xACC1,  0xD3CB,  0xD3CC,  0xD3CD,  0xD3CE,  0,       0x5AF1,  
      0,       0,       0xD9CF,  0xD9D0,  0xD9D1,  0,       0xBEF9,  0,       // 0x04Cx
      0x61B3,  0xDEB2,  0,       0xC6A9,  0x67D0,  0xE4FB,  0x67D1,  0x6BED,  
      0,       0,       0xE7C1,  0xE9BB,  0,       0xEACC,  0,       0x77D3,  // 0x04Dx
      0xEBC2,  0,       0,       0xA136,  0x21B6,  0x21B5,  0,       0xA237,  
      0xA356,  0xA355,  0,       0,       0x23B6,  0xA579,  0,       0x23B8,  // 0x04Ex
      0,       0,       0x28A5,  0x28A6,  0,       0x2B6A,  0xB53D,  0xAEA2,  
      0xAEA3,  0xBD3A,  0,       0xC65A,  0xD064,  0,       0x3DE3,  0x3C31,  // 0x04Fx
      0xDA78,  0,       0,       0,       0,       0x5AF2,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_05 [] = {
      0xA137,  0xA14E,  0x21B7,  0xA141,  0xA159,  0,       0x21D0,  0xA33B,  // 0x050x
      0x2235,  0xA357,  0xA57C,  0xA57E,  0x23B9,  0,       0xA3AD,  0xA57A,  
      0xA954,  0,       0xAE6B,  0xAE69,  0,       0x28A7,  0xAE6A,  0xAE4F,  // 0x051x
      0xB07B,  0xB540,  0xB53F,  0xB541,  0xB53E,  0xBD3B,  0,       0xC65D,  
      0x3DE4,  0xB9C4,  0xB9C5,  0,       0,       0xC65B,  0,       0xC65C,  // 0x052x
      0x3DE5,  0xD065,  0xC0C9,  0xC0CA,  0,       0,       0,       0x423A,  
      0,       0xDA79,  0,       0xD4C6,  0xD3CF,  0xD3D0,  0x61B4,  0xDEB3,  // 0x053x
      0xC6AA,  0xC6AB,  0,       0,       0x212D,  0xA14F,  0xA151,  0,       
      0,       0xA239,  0x215D,  0xA238,  0x21D2,  0,       0xA1C6,  0,       // 0x054x
      0xA23A,  0,       0x21D1,  0xA35A,  0,       0xA358,  0xA547,  0,       
      0xA623,  0xA621,  0xA622,  0x23BA,  0xA87A,  0,       0x25AC,  0,       // 0x055x
      0xA955,  0,       0xA956,  0xAE6C,  0,       0xB542,  0xB543,  0x2BF7,  
      0x2BF8,  0,       0xBD3D,  0xC65F,  0xB9F7,  0xC65E,  0x3C33,  0x3DE6,  // 0x056x
      0xDA7B,  0xDA7A,  0,       0,       0xA1B5,  0x53DD,  0xACC2,  0xD5F6,  
      0x5A6D,  0xE7C2,  0xD7CF,  0x21B8,  0,       0xA23B,  0xA1C8,  0xA1C9,  // 0x057x
      0,       0xA35B,  0x2237,  0x22A9,  0,       0xA1FB,  0,       0,       
      0xA3AE,  0xA3AF,  0,       0,       0x25AD,  0xA5D5,  0,       0,       // 0x058x
      0,       0,       0xAE6D,  0,       0xBD3E,  0xAEA5,  0,       0xAEA6,  
      0xAEA7,  0xAEA8,  0xAEA9,  0x31A7,  0xC660,  0xB9C7,  0xB9C8,  0xC661,  // 0x059x
      0,       0xBADD,  0xD066,  0,       0xDA7C,  0,       0xC6DB,  0x4EF7,  
      0xACC3,  0xD9D2,  0xD3D1,  0xBEFA,  0,       0,       0xC6AC,  0xCDBF,  // 0x05Ax
      0,       0x6FE9,  0,       0x75E3,  0,       0,       0xA1CA,  0,       
      0,       0xA35C,  0xA1FD,  0,       0xA1FE,  0,       0x2238,  0x23BB,  // 0x05Bx
      0xA624,  0x233C,  0xA3B0,  0xA3B1,  0xA3B2,  0xA3B3,  0,       0,       
      0xA3A4,  0xA2FE,  0x2541,  0x2542,  0xA958,  0xA959,  0x25AF,  0xA5D7,  // 0x05Cx
      0x28A9,  0x2841,  0x2842,  0x28AC,  0x28A8,  0x28AA,  0xAE6F,  0,       
      0,       0xA9BA,  0xA9BC,  0xA9BD,  0xA9BE,  0xA9BF,  0,       0xAE6E,  // 0x05Dx
      0x2BFA,  0x2B6B,  0x2BF9,  0x28AB,  0xB545,  0x2BFB,  0xAEAA,  0,       
      0,       0xAEAB,  0xB546,  0,       0,       0x31A8,  0xBD3F,  0xBD40,  // 0x05Ex
      0x304E,  0,       0xB3AB,  0,       0xB3AC,  0xB3AD,  0xB3AF,  0xB3B0,  
      0,       0xC662,  0x36DC,  0x36DA,  0x36DB,  0x36D9,  0x363E,  0xB3AE,  // 0x05Fx
      0,       0,       0x3DEC,  0x3DE7,  0x3DE9,  0x3DEA,  0x3DE8,  0x3DEB,  
} ;


static const unsigned short Uni2cnsP2Table_06 [] = {
      0xD067,  0,       0,       0,       0xDA7D,  0x4CA1,  0x44DA,  0xA1B7,  // 0x060x
      0xC6DD,  0xC6DE,  0x4BFE,  0x4BFD,  0x4BFC,  0xA1B6,  0xCDE7,  0,       
      0,       0xD3D3,  0xACC5,  0xCDE6,  0xD3D2,  0,       0x556A,  0xACC6,  // 0x061x
      0x5AF3,  0,       0,       0xD9D3,  0xD9D4,  0x61B6,  0x61B5,  0x61B7,  
      0xDEB4,  0xBEFB,  0x67D2,  0x67D3,  0xD2F6,  0x73B2,  0,       0x2129,  // 0x062x
      0,       0xA152,  0,       0xA1AA,  0xA1AB,  0xA1AC,  0xA1AE,  0xA15C,  
      0xA1AD,  0x21D3,  0xA23D,  0x215F,  0,       0xA35E,  0xA35D,  0xA35F,  // 0x063x
      0xA360,  0,       0xA1CB,  0,       0xA627,  0xA625,  0xA626,  0xA3B4,  
      0xA3B5,  0,       0,       0,       0,       0,       0x2546,  0xA95A,  // 0x064x
      0x2544,  0xA95B,  0xA95C,  0xA95D,  0xA5D8,  0xA5D9,  0,       0xAE72,  
      0xAE70,  0xAE71,  0xB547,  0xAEAC,  0,       0,       0,       0xB727,  // 0x065x
      0xBD42,  0xBD43,  0xBD41,  0xB3B1,  0xB3B2,  0xB3B3,  0,       0xC663,  
      0xC666,  0xB9C9,  0xC664,  0,       0,       0,       0,       0xB9CA,  // 0x066x
      0xC6DF,  0xC6E0,  0xC6E1,  0xCDE8,  0,       0xACC7,  0xD3D4,  0xD3D5,  
      0xD3C3,  0xD9D5,  0xDEB5,  0xE7C3,  0,       0x212E,  0x21B9,  0xA153,  // 0x067x
      0xA154,  0xA23F,  0x21D4,  0xA23E,  0,       0xA1CC,  0xA365,  0xA361,  
      0xA362,  0xA363,  0xA2A1,  0,       0,       0,       0x22AA,  0xA628,  // 0x068x
      0xA3B6,  0,       0,       0xA960,  0,       0xA95F,  0xAE73,  0xAE74,  
      0,       0xB47A,  0xB548,  0,       0,       0,       0xBD44,  0xBD45,  // 0x069x
      0x36DD,  0xDA7E,  0xC6E2,  0xA1F0,  0,       0xB6FB,  0x5AF6,  0x67D4,  
      0,       0xCEBE,  0,       0xA139,  0,       0x2140,  0xA155,  0x21BA,  // 0x06Ax
      0x21BB,  0xA156,  0x2141,  0xA1AF,  0xA157,  0x21D5,  0x21D6,  0x2162,  
      0xA244,  0x21D7,  0xA243,  0xA240,  0xA245,  0,       0,       0x223A,  // 0x06Bx
      0xA36A,  0x22AE,  0x22AC,  0x22AB,  0x223B,  0x2239,  0xA368,  0xA367,  
      0x22AF,  0xA36B,  0xA369,  0x22AD,  0x223D,  0,       0,       0xA2A2,  // 0x06Cx
      0xA2A3,  0x223E,  0,       0,       0,       0xA366,  0x2341,  0xA62B,  
      0x2343,  0x23BD,  0x2342,  0x23C6,  0x23C5,  0x23C3,  0x23C0,  0xA629,  // 0x06Dx
      0x23BF,  0x23C2,  0x23C1,  0xA62A,  0,       0,       0,       0,       
      0xA62C,  0,       0,       0,       0,       0x23BE,  0x23C4,  0xA969,  // 0x06Ex
      0x25B3,  0x25B5,  0x2549,  0x254B,  0xA7DC,  0xA966,  0x254D,  0xA964,  
      0xA965,  0xA96C,  0xAE75,  0,       0xA96A,  0x25B0,  0x25B6,  0xA96B,  // 0x06Fx
      0x25B2,  0xA967,  0,       0x25B4,  0xA5DA,  0xA5DB,  0xA5DC,  0xA5DD,  
} ;


static const unsigned short Uni2cnsP2Table_07 [] = {
      0,       0,       0xA968,  0,       0,       0,       0xA962,  0xA961,  // 0x070x
      0,       0x25B1,  0,       0,       0xA957,  0,       0,       0,       
      0x2847,  0x28AD,  0x2845,  0xAF24,  0xAE7B,  0xAF22,  0x2848,  0xAF21,  // 0x071x
      0x2844,  0x2846,  0xAE78,  0xAE7E,  0xAF23,  0xAE7A,  0,       0xAE7D,  
      0xAE7C,  0xA9C0,  0xA9C1,  0xA9C2,  0,       0xAE79,  0x28AE,  0,       // 0x072x
      0xAE77,  0,       0,       0,       0,       0,       0,       0,       
      0xB549,  0x2B70,  0x2B6D,  0x2CA5,  0x2CA3,  0x2B6F,  0x2B73,  0xB54E,  // 0x073x
      0xB552,  0x2CA2,  0xB553,  0x2B6C,  0x2CA6,  0xB551,  0x2B71,  0xB550,  
      0xB54F,  0xB54C,  0xB54B,  0x2B72,  0x2CA4,  0xB54D,  0,       0,       // 0x074x
      0xAEB3,  0xB554,  0xAEAE,  0xAEAF,  0xAEB0,  0xAEB2,  0,       0,       
      0,       0xAEB1,  0xB54A,  0,       0,       0,       0,       0,       // 0x075x
      0x2CA7,  0x2BFD,  0x2CA1,  0x2BFE,  0,       0x3050,  0x31AB,  0x3051,  
      0x31AA,  0xBD46,  0x3056,  0x3649,  0x3055,  0xBD49,  0,       0xBD47,  // 0x076x
      0x36DE,  0x304F,  0x2CA8,  0,       0,       0xB3B4,  0xB3B5,  0xB3B7,  
      0,       0xBD48,  0,       0,       0,       0,       0,       0,       // 0x077x
      0,       0,       0,       0,       0,       0xBD4A,  0xBD4B,  0x3643,  
      0x36DF,  0xC66D,  0xC669,  0x3646,  0x3647,  0x36E0,  0x36E4,  0x364A,  // 0x078x
      0x3644,  0x3641,  0x3640,  0xC66B,  0xC668,  0xC66C,  0x36E1,  0x36E2,  
      0xC66A,  0xB9CB,  0xB9CC,  0xB9CD,  0xB9CE,  0,       0,       0,       // 0x079x
      0x3648,  0,       0,       0,       0xCC46,  0xC66E,  0,       0,       
      0,       0,       0,       0,       0x36E5,  0x3C39,  0xD06F,  0x3DF3,  // 0x07Ax
      0xD06D,  0x3C35,  0x3DF4,  0xD06E,  0x3DED,  0x3C37,  0x3C36,  0x3DEE,  
      0x3C3A,  0x3DEF,  0xD06B,  0xC0CB,  0,       0,       0,       0xD06A,  // 0x07Bx
      0,       0,       0,       0xD068,  0xD070,  0xD069,  0x3DF2,  0x3DF1,  
      0,       0xC0CC,  0x44DB,  0x423B,  0xDB24,  0x44E1,  0xDB22,  0xDB21,  // 0x07Cx
      0x3C38,  0x4240,  0x44E2,  0x44DC,  0x44DF,  0x423D,  0x4244,  0xDB2B,  
      0xDB29,  0xDB28,  0x44DE,  0x4CA2,  0xDB26,  0x44DD,  0xDB2A,  0x44E0,  // 0x07Dx
      0xDB25,  0xC6E3,  0xC6E4,  0xC6E5,  0xDB23,  0,       0,       0xDB27,  
      0,       0,       0,       0,       0,       0,       0x4CA3,  0x4CA7,  // 0x07Ex
      0x4924,  0x4CA4,  0x4CA6,  0xA1BC,  0xA1BD,  0xA1BA,  0xA1BE,  0xA1BB,  
      0x4CA5,  0xA1B8,  0,       0xA2DA,  0,       0xA1B9,  0,       0,       // 0x07Fx
      0,       0,       0x4F60,  0xACC9,  0x5AF7,  0xACCA,  0xACCE,  0xACCD,  
} ;


static const unsigned short Uni2cnsP2Table_08 [] = {
      0xACCC,  0x53DF,  0x53E1,  0x53E0,  0x53DE,  0xACC8,  0xACCB,  0xA1BF,  // 0x080x
      0xD3D6,  0,       0,       0x58D1,  0,       0x5AFA,  0x556B,  0x5AF9,  
      0x5AF8,  0,       0xB6FC,  0xD9D6,  0,       0,       0,       0x556E,  // 0x081x
      0,       0,       0,       0xBEFC,  0x61B8,  0x61B9,  0xB6FD,  0xDEB6,  
      0x61BA,  0xC6AF,  0xC6AE,  0xC6AD,  0,       0,       0xCDC0,  0xCDC1,  // 0x082x
      0,       0,       0x6FEA,  0xD2F7,  0xE7C4,  0,       0x75E4,  0x6B65,  
      0xE2AD,  0xE2AC,  0xA13A,  0x21BC,  0xA158,  0,       0x2163,  0x21D9,  // 0x083x
      0x21D8,  0x22B1,  0,       0x22B2,  0xA2A5,  0xA2A6,  0xA2A7,  0xA2A8,  
      0,       0x22B3,  0xA62E,  0x2345,  0x23C7,  0,       0xA3B8,  0xA3BA,  // 0x084x
      0xA3BB,  0,       0,       0,       0xA62D,  0x2349,  0,       0,       
      0,       0x25BD,  0x25B9,  0xA96D,  0x25BC,  0xA96E,  0xA5E0,  0xA5E1,  // 0x085x
      0xA5E2,  0xA5E3,  0,       0,       0,       0,       0x28B0,  0x284A,  
      0xAF26,  0x28B1,  0x28AF,  0,       0,       0,       0xAF28,  0,       // 0x086x
      0xA9C3,  0xA9C4,  0xA9C5,  0xB555,  0xB559,  0x2B74,  0x2CAD,  0x2CA9,  
      0x2CAB,  0x2CAC,  0x2CAA,  0,       0xAEB4,  0xAEB5,  0,       0,       // 0x087x
      0xB556,  0xB557,  0,       0x31AD,  0xBD4E,  0xBD4C,  0xBD4F,  0xBD50,  
      0xBD51,  0xB3B8,  0xB3B9,  0,       0xBD4D,  0x36E9,  0x36E6,  0x36E8,  // 0x088x
      0x36EB,  0x36E7,  0xB9CF,  0xB9D0,  0,       0,       0xC66F,  0xC670,  
      0,       0,       0xC671,  0x3DF6,  0x3DF5,  0x3C3B,  0xD072,  0xD071,  // 0x089x
      0xC0CD,  0x3DF7,  0,       0,       0,       0,       0,       0,       
      0x4246,  0x44E6,  0x44E4,  0x44E5,  0x44E9,  0x4245,  0x44E8,  0xDB2E,  // 0x08Ax
      0xC6E6,  0,       0,       0,       0,       0xDB2C,  0,       0xDB2D,  
      0x4CAB,  0x4CA8,  0x4926,  0x4CA9,  0x4CAA,  0,       0xACCF,  0x5AFC,  // 0x08Bx
      0xD3D7,  0x5AFB,  0x5AFD,  0xB6FE,  0xB7A2,  0,       0,       0xB7A1,  
      0x61BC,  0xBEFE,  0,       0xBFA1,  0x67D6,  0x67D5,  0xCDC2,  0x6FEB,  // 0x08Cx
      0xDBC6,  0x75E5,  0x6C6B,  0xE6BB,  0x21BD,  0xA247,  0xA248,  0x22B5,  
      0,       0x22B4,  0x22B6,  0xA2AA,  0xA62F,  0,       0x23C8,  0x23C9,  // 0x08Dx
      0x2552,  0xA971,  0xA970,  0,       0xA5E4,  0xA5E5,  0xAF2A,  0x284C,  
      0xAF2B,  0xAF2C,  0xA9C6,  0xAF29,  0x2B76,  0xB55C,  0xB55B,  0xB55E,  // 0x08Ex
      0xB55F,  0xB55A,  0xB55D,  0x2CAF,  0,       0,       0x305D,  0xBD52,  
      0x2CAE,  0x31AE,  0,       0x31AF,  0xBD53,  0x364E,  0,       0xB9D1,  // 0x08Fx
      0xD073,  0x305B,  0x3DF9,  0xC0CE,  0xC0CF,  0xDB2F,  0x4247,  0x44EA,  
} ;


static const unsigned short Uni2cnsP2Table_09 [] = {
      0x44EB,  0xC6E7,  0,       0xCDE9,  0x4F65,  0xACD0,  0,       0xACD1,  // 0x090x
      0xB7A3,  0xB7A4,  0x5AFE,  0xCDC3,  0,       0,       0xA12A,  0x2142,  
      0xA24A,  0xA630,  0xA633,  0x23CA,  0xA631,  0xA632,  0,       0x284D,  // 0x091x
      0xAF2F,  0xAF31,  0xAF2D,  0xAF2E,  0xAF30,  0,       0xBD54,  0xB560,  
      0xAEB6,  0xAEB7,  0xB524,  0xC672,  0xB9D2,  0x3C3D,  0,       0,       // 0x092x
      0xC6E8,  0,       0xBFA2,  0x6DB2,  0xA12B,  0xA1B1,  0x22B7,  0xA36E,  
      0x2243,  0xA36D,  0,       0xA634,  0x234A,  0xA635,  0xA3BC,  0,       // 0x093x
      0xA973,  0x25BE,  0x25BF,  0,       0x284F,  0,       0xAF34,  0x28B3,  
      0xAF33,  0x28B2,  0xAF32,  0xAF37,  0xAF35,  0xA9C7,  0,       0,       // 0x094x
      0,       0x2CB0,  0xB562,  0xB561,  0x2CB1,  0,       0xBD55,  0xB3BA,  
      0x364F,  0xD075,  0xC673,  0xB563,  0,       0,       0x3DFA,  0,       // 0x095x
      0,       0x4248,  0xDB31,  0xDB30,  0x4CAC,  0x4CAD,  0x4CAE,  0,       
      0,       0xCDEA,  0x53E4,  0xB7A5,  0,       0xDEB7,  0x5F4B,  0,       // 0x096x
      0,       0xBFA3,  0xCDC4,  0xE0E9,  0xE4C3,  0xA1B2,  0x22B8,  0xA36F,  
      0x23CC,  0xA637,  0xA3BD,  0xA5E6,  0xAF36,  0x28B4,  0xB564,  0xC6E9,  // 0x097x
      0xCDC5,  0,       0xD7D0,  0xA15A,  0,       0x21DA,  0x21DB,  0,       
      0xA24B,  0,       0xA370,  0x2244,  0,       0x2245,  0xA373,  0xA372,  // 0x098x
      0x22BA,  0,       0,       0,       0x22B9,  0xA374,  0,       0,       
      0,       0xA639,  0x23CD,  0xA63A,  0xA375,  0xA63B,  0xA3BE,  0,       // 0x099x
      0x25C0,  0xA974,  0xA977,  0xA978,  0xA976,  0xA5E7,  0xA5E9,  0xA5EA,  
      0xA5EB,  0xA5E8,  0xA975,  0xB565,  0xB566,  0xAEB8,  0xAEB9,  0,       // 0x09Ax
      0,       0,       0x3063,  0x3061,  0x3062,  0xB3BB,  0,       0,       
      0xB9D3,  0xB9D4,  0,       0,       0xD078,  0xD077,  0xD079,  0xD07B,  // 0x09Bx
      0,       0,       0,       0,       0xC0D0,  0xC6EA,  0xC6EB,  0,       
      0x4CAF,  0xCDEB,  0xCDEC,  0,       0xA1C0,  0,       0,       0,       // 0x09Cx
      0xB7A6,  0,       0xDEB8,  0,       0,       0,       0xC6B0,  0xD2F8,  
      0xE0EA,  0xE2AE,  0,       0xA24C,  0xA377,  0,       0,       0xA376,  // 0x09Dx
      0xA378,  0x234C,  0x23CF,  0x23CE,  0xA63C,  0,       0x2555,  0x2554,  
      0xA97C,  0xA97B,  0xA97D,  0xA97A,  0xA97E,  0xA979,  0xA5EC,  0,       // 0x09Ex
      0xAA22,  0x2852,  0x2851,  0x28B7,  0xA9C8,  0xA9C9,  0xA9CA,  0xA9CB,  
      0,       0,       0xAF39,  0xB568,  0x2B79,  0x2CB2,  0xB567,  0xB56A,  // 0x09Fx
      0xBC7A,  0xB569,  0xBD57,  0xBD56,  0xB56B,  0xBD58,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_0A [] = {
      0xC675,  0xC676,  0xC677,  0x37BF,  0,       0xD07C,  0x44ED,  0xDB32,  // 0x0A0x
      0xA1C1,  0xD3D8,  0,       0xE3CB,  0,       0x21BE,  0x2143,  0xA1B4,  
      0xA15B,  0,       0x2246,  0xAA24,  0xA37A,  0,       0xA379,  0,       // 0x0A1x
      0x234E,  0xAF3B,  0x28B8,  0xAF3A,  0x2853,  0xB56C,  0xAF3C,  0xC678,  
      0x2CB3,  0,       0x3DFB,  0xD07D,  0,       0x44EE,  0,       0xBFA4,  // 0x0A2x
      0,       0,       0,       0,       0x21BF,  0x21DC,  0xA37B,  0xA24F,  
      0xA24D,  0xA250,  0x21DD,  0,       0x2247,  0x22BB,  0xA37C,  0xA37D,  // 0x0A3x
      0x22BF,  0x22C0,  0x22BD,  0x22BE,  0,       0xA2AD,  0,       0,       
      0xA63E,  0x23D0,  0xA63D,  0x23D1,  0xA55E,  0,       0,       0xA3BF,  // 0x0A4x
      0,       0,       0xAA27,  0xAA26,  0xAA29,  0xAA28,  0x25C1,  0x2558,  
      0,       0xA5ED,  0xA5EE,  0,       0,       0,       0xAA25,  0x28B9,  // 0x0A5x
      0x2854,  0xAF46,  0xAF41,  0xAF44,  0xAF45,  0xAF40,  0xAF3E,  0xAF42,  
      0xAF43,  0,       0xA9CD,  0xA9CE,  0x2855,  0,       0xAF3F,  0xB573,  // 0x0A6x
      0xB574,  0x2B7B,  0x2CB4,  0x2B7C,  0xB56F,  0xB56D,  0xB570,  0xB572,  
      0xB571,  0xB56E,  0x2CB5,  0xAEBA,  0xAEBB,  0,       0,       0,       // 0x0A7x
      0xBD60,  0xBD5B,  0x3067,  0xBD5F,  0xBD5C,  0xBD5D,  0xB3BD,  0x31B0,  
      0,       0,       0,       0,       0xBD5E,  0,       0x3066,  0x3652,  // 0x0A8x
      0xC67C,  0xC67A,  0x3653,  0xC67B,  0xC679,  0xC67D,  0xB9D5,  0xC67E,  
      0,       0x3DFC,  0x3DFD,  0xD124,  0xD123,  0xD07E,  0xC0D1,  0,       // 0x0A9x
      0xD121,  0x3C3F,  0x4249,  0xDB34,  0xDB37,  0xDB33,  0xDB38,  0x44EF,  
      0xC6ED,  0,       0xC6EE,  0,       0xDB36,  0xDB39,  0xDB3B,  0,       // 0x0AAx
      0,       0,       0xDB3A,  0xDB35,  0,       0xA1C3,  0x4928,  0x4CB0,  
      0xA1C4,  0,       0,       0xA1C2,  0,       0xCDED,  0,       0,       // 0x0ABx
      0,       0xA5C8,  0x53E5,  0xACD3,  0xACD2,  0xD3D9,  0xD3DA,  0xBBCD,  
      0xDEB9,  0xDEBA,  0xDEBB,  0,       0,       0,       0,       0xE4FC,  // 0x0ACx
      0xCEA7,  0xD2F9,  0,       0,       0x77D4,  0,       0xDED0,  0,       
      0xE5B3,  0,       0xE6B3,  0x21AE,  0xA13C,  0xA13D,  0,       0xA15D,  // 0x0ADx
      0,       0xA252,  0xA251,  0,       0,       0,       0x224A,  0xA423,  
      0xA421,  0,       0xA2AE,  0,       0x2249,  0xA422,  0xA640,  0xA3C0,  // 0x0AEx
      0x23BC,  0xAA2C,  0xAA2B,  0xAA2D,  0xAA2E,  0,       0,       0,       
      0xAF47,  0xAF48,  0,       0x2856,  0xA9CF,  0,       0,       0,       // 0x0AFx
      0,       0xB576,  0xB575,  0xB649,  0xB52E,  0,       0,       0x36EC,  
} ;


static const unsigned short Uni2cnsP2Table_0B [] = {
      0xC722,  0xC724,  0xCD62,  0,       0xB9D6,  0xC723,  0x3EA1,  0xD125,  // 0x0B0x
      0x3DFE,  0,       0xC0D2,  0,       0,       0,       0xDB3C,  0xC6EF,  
      0xE072,  0xA1C5,  0,       0x53E6,  0,       0,       0,       0xD9D7,  // 0x0B1x
      0xCBEA,  0,       0xA160,  0x21C0,  0xA15E,  0x21C2,  0xA162,  0xA15F,  
      0,       0xA255,  0x2168,  0x21DE,  0,       0xA256,  0x21DF,  0xA253,  // 0x0B2x
      0xA254,  0xA425,  0x224B,  0xA424,  0x22C2,  0xA426,  0x22C1,  0xA427,  
      0,       0xA644,  0xA642,  0x23D2,  0xA3C1,  0xA3C2,  0xA3C3,  0xA3C4,  // 0x0B3x
      0x2350,  0xAA31,  0xAA2F,  0xAA32,  0xAA30,  0xA5EF,  0,       0xAF4D,  
      0xAF4A,  0xAF4C,  0xAF4B,  0xAF49,  0xA9D1,  0xA9D2,  0,       0xB272,  // 0x0B4x
      0,       0x28B6,  0xB57B,  0x2CB6,  0xB57C,  0xB579,  0xB577,  0xB57A,  
      0xAEBC,  0xAEBD,  0xAEBE,  0xAEBF,  0xBC67,  0xBD66,  0xBD68,  0x31B2,  // 0x0B5x
      0x31B3,  0xBD65,  0xBD63,  0xBD6B,  0xBD64,  0x2CB7,  0xBD62,  0xBD69,  
      0xBD6A,  0xBC7C,  0,       0xBD67,  0,       0x3654,  0x36ED,  0xC727,  // 0x0B6x
      0xC725,  0xB3BE,  0xB9D7,  0xB9D8,  0xB9D9,  0xB9DA,  0xC726,  0x3C43,  
      0x3C42,  0xD127,  0xD128,  0xD126,  0x3C41,  0xC728,  0xD15B,  0,       // 0x0B7x
      0xD129,  0,       0,       0xDF21,  0xDB3E,  0,       0xDB3D,  0x44F0,  
      0,       0xD37B,  0xCDD5,  0x4CB3,  0x4CB4,  0xC6F0,  0x4CB2,  0xACD5,  // 0x0B8x
      0xD3DB,  0xD0B9,  0x54AE,  0xACD4,  0,       0xB7A9,  0xB7A8,  0xD9D8,  
      0x5A6F,  0xC6B2,  0xC6B1,  0x6631,  0xE7C5,  0xD7D1,  0x75E6,  0xDED1,  // 0x0B9x
      0xDED2,  0x21C3,  0xA164,  0x2147,  0x2146,  0xA1B6,  0xA163,  0,       
      0x21E1,  0xA259,  0xA258,  0xA25E,  0xA25A,  0xA25D,  0xA257,  0xA242,  // 0x0BAx
      0xA1CE,  0,       0xA25C,  0x22C7,  0xA42D,  0x22C5,  0xA42E,  0x224D,  
      0x22C6,  0x2250,  0xA42C,  0x224F,  0x224E,  0x22C4,  0,       0xA428,  // 0x0BBx
      0xA2AF,  0xA2B0,  0xA2B2,  0xA2B4,  0,       0,       0,       0,       
      0,       0xA42A,  0xA2B1,  0,       0,       0,       0xA2B3,  0,       // 0x0BCx
      0x22C3,  0xA429,  0xA42B,  0x2356,  0xA64F,  0xA646,  0xA64D,  0xA64C,  
      0x23D6,  0x235A,  0x235D,  0x23DB,  0x23D4,  0xA648,  0x2357,  0x2352,  // 0x0BDx
      0x2358,  0x23D8,  0xA649,  0x23D9,  0x2355,  0x23D5,  0xA647,  0,       
      0,       0x23DC,  0,       0xA3C5,  0xA3C6,  0xA3C7,  0xA3CA,  0xA3CB,  // 0x0BEx
      0xA3CC,  0,       0,       0xA3C8,  0xA64B,  0,       0xA64A,  0,       
      0,       0,       0,       0xA650,  0,       0xA645,  0x23D3,  0,       // 0x0BFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_0C [] = {
      0,       0,       0,       0,       0x23D7,  0x23DA,  0,       0,       // 0x0C0x
      0x255C,  0x255E,  0xAA36,  0x25CC,  0x25C4,  0x255B,  0xAA34,  0x25CD,  
      0x25C5,  0x25C7,  0x2561,  0x25D0,  0xAA33,  0x25D2,  0x28C7,  0xAA3B,  // 0x0C1x
      0x25C8,  0x25CB,  0x25CA,  0x25D1,  0x25C9,  0x25CE,  0xAA3D,  0,       
      0,       0x25CF,  0xA5F0,  0xA5F2,  0xA5F3,  0xA5F4,  0xA5F5,  0xA5F6,  // 0x0C2x
      0xA5F7,  0xA5F8,  0xA5F9,  0xA5FA,  0xA5FD,  0xA5FE,  0xA6A1,  0xA6A2,  
      0xA6A3,  0,       0x25C6,  0,       0,       0xAA35,  0x25C3,  0,       // 0x0C3x
      0xAA38,  0,       0,       0,       0,       0,       0,       0xAA37,  
      0xA5FC,  0,       0,       0,       0,       0,       0,       0,       // 0x0C4x
      0,       0,       0,       0,       0,       0,       0xAA3A,  0,       
      0x2CB8,  0x28C6,  0x28D2,  0x28CD,  0x28BC,  0x28D1,  0xAF54,  0xAF4E,  // 0x0C5x
      0x28BF,  0x285B,  0x285A,  0x28CF,  0x28C5,  0x28CB,  0x28CA,  0x28CE,  
      0x28C8,  0x28C9,  0x28BD,  0x28C1,  0x28CC,  0x2562,  0xAF59,  0xAF5A,  // 0x0C6x
      0x28D3,  0xAF4F,  0,       0x28BA,  0xAF57,  0xAF56,  0x28D0,  0xAF50,  
      0xAF58,  0xAF52,  0x28C0,  0x28C2,  0,       0xABB3,  0,       0,       // 0x0C7x
      0,       0xA9D3,  0xA9D5,  0xA9D6,  0xA9D7,  0xA9D8,  0xA9D9,  0xA9DA,  
      0xA9DB,  0xA9DE,  0xA9DF,  0xA9E0,  0xA9E1,  0xA9E2,  0xA9E3,  0xA9E4,  // 0x0C8x
      0xA9E6,  0xA9E7,  0,       0x28C3,  0x28C4,  0,       0x285D,  0xA9E5,  
      0xAF55,  0,       0,       0xAF53,  0,       0,       0,       0x2858,  // 0x0C9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0CAx
      0,       0x28BB,  0x28BE,  0xAF51,  0,       0xB629,  0x2C24,  0x2C2B,  
      0x2C2C,  0x2C27,  0xB622,  0x2CCE,  0x2CC1,  0x2CBF,  0x2CCC,  0x2CBD,  // 0x0CBx
      0x2CC6,  0x2CD6,  0x2CC9,  0x2C2A,  0x2CCD,  0x2CD4,  0x2CD2,  0x2C22,  
      0xB623,  0xB624,  0x2CD1,  0x2C23,  0x2CC0,  0xB627,  0xB628,  0x2CD7,  // 0x0CCx
      0xB626,  0x2CD3,  0x2CD8,  0x2CC7,  0x2CD9,  0x2CC4,  0x2CD5,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0CDx
      0,       0,       0,       0xAEC0,  0xAEC1,  0xAEC3,  0xAEC4,  0xAEC8,  
      0xAEC9,  0xAECB,  0xAECC,  0xAECD,  0xAECE,  0xAECF,  0xAED0,  0xAED1,  // 0x0CEx
      0xAED2,  0xAED3,  0xAED4,  0xB95E,  0,       0,       0xB621,  0x2CC2,  
      0x2CC5,  0x2CC8,  0,       0,       0xB625,  0,       0,       0x2CD0,  // 0x0CFx
      0x2CCB,  0x2CB9,  0x2CBA,  0x2CBB,  0,       0,       0,       0xAEC5,  
} ;


static const unsigned short Uni2cnsP2Table_0D [] = {
      0,       0,       0,       0x2CCA,  0,       0,       0,       0,       // 0x0D0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0D1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x2CCF,  0x2CBE,  0x2CBC,  0,       0,       0x2CDA,  0x31C6,  // 0x0D2x
      0x3069,  0xBD77,  0xBD74,  0x3078,  0xBD6F,  0x3075,  0x31D1,  0x31C9,  
      0x31CC,  0x306E,  0x3079,  0x31C4,  0xBD76,  0x31B6,  0x31CA,  0x31C5,  // 0x0D3x
      0x31CE,  0x31B4,  0x31CD,  0x31C2,  0x31BB,  0xBD71,  0xBD75,  0xBD7D,  
      0xBD7A,  0xBD7E,  0x31BA,  0x31BC,  0,       0,       0,       0,       // 0x0D4x
      0,       0,       0xBD6C,  0,       0,       0,       0,       0,       
      0,       0x31B8,  0xBD72,  0xBD7B,  0xB3BF,  0xB3C0,  0xB3C1,  0xB3C2,  // 0x0D5x
      0xB3C4,  0xB3C5,  0xB3C6,  0xB3C7,  0xB3C8,  0xB3C9,  0xB3CC,  0xB3CD,  
      0x31B7,  0xBD73,  0x31B9,  0,       0,       0xBD6D,  0,       0,       // 0x0D6x
      0,       0,       0x31C1,  0,       0,       0,       0,       0,       
      0x31C8,  0,       0xBE21,  0,       0,       0x31D2,  0,       0xBD70,  // 0x0D7x
      0,       0x31C0,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0D8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0D9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x31B5,  // 0x0DAx
      0x31C7,  0x31BE,  0x31C3,  0x31BD,  0x31D0,  0xBD79,  0xB4E0,  0,       
      0x31D3,  0x31CF,  0xBD78,  0xBD6E,  0x31BF,  0x31CB,  0,       0x3655,  // 0x0DBx
      0x3661,  0,       0xC732,  0x37A4,  0xC737,  0xC73E,  0x36F7,  0xC735,  
      0x36FC,  0x3656,  0x37A8,  0x36EF,  0x36F1,  0x365A,  0x36F8,  0x3657,  // 0x0DCx
      0x37A9,  0x36FE,  0x3662,  0x365B,  0x37A3,  0x37A7,  0x3666,  0x37B0,  
      0,       0x365D,  0x37AC,  0x37AE,  0xC72E,  0xC73C,  0x3EA2,  0xC72B,  // 0x0DDx
      0xC72F,  0xC738,  0x37A2,  0xC734,  0xC73F,  0xC73A,  0x3664,  0x37A6,  
      0,       0,       0,       0,       0,       0,       0,       0x36F3,  // 0x0DEx
      0xB9DB,  0xB9DD,  0xB9DE,  0xB9E1,  0xB9E2,  0xB9E3,  0xB9E4,  0xB9E5,  
      0xB9E6,  0xB9E7,  0xB9E8,  0xB9EA,  0xB9ED,  0xB9EE,  0xB9EF,  0xB9F0,  // 0x0DFx
      0x36F4,  0,       0,       0x36F5,  0x36FB,  0x37A5,  0x37A1,  0,       
} ;


static const unsigned short Uni2cnsP2Table_0E [] = {
      0xC73B,  0,       0,       0,       0xB9EB,  0,       0,       0,       // 0x0E0x
      0,       0,       0,       0,       0xB9DC,  0xB9DF,  0,       0,       
      0,       0,       0,       0,       0,       0,       0xB9E9,  0,       // 0x0E1x
      0,       0,       0,       0,       0,       0xB9EC,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0E2x
      0,       0,       0,       0,       0,       0x37AB,  0x37AF,  0,       
      0xC73D,  0x37AD,  0x37AA,  0x36FD,  0,       0xC736,  0xD139,  0x3EA3,  // 0x0E3x
      0x3C49,  0x3EA7,  0x3C4E,  0x36F2,  0,       0,       0,       0xD141,  
      0x3C48,  0x3C44,  0xDB42,  0x3EAD,  0xD133,  0xD135,  0x3EAA,  0x3EB8,  // 0x0E4x
      0xD13A,  0xD130,  0x3EAE,  0x3EA4,  0x3EB5,  0x3EBF,  0xD13F,  0xD137,  
      0x3EB4,  0x3EB7,  0x3C4D,  0x3EBA,  0x3C45,  0x3EB3,  0x3EAC,  0x3C4F,  // 0x0E5x
      0x3EAF,  0x3C51,  0x3EB1,  0x3EB2,  0xD13B,  0,       0xD140,  0xD12A,  
      0xD13E,  0xD13D,  0x3EBB,  0xD138,  0x3EA8,  0x3EB0,  0x3EAB,  0xD12C,  // 0x0E6x
      0xD144,  0xD12E,  0xD12B,  0xD12D,  0,       0,       0xC7A6,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0E7x
      0,       0,       0,       0,       0,       0,       0,       0x3EBE,  
      0xD131,  0xC0D6,  0xC0D7,  0xC0D8,  0xC0D9,  0xC0DA,  0xC0DB,  0xC0DC,  // 0x0E8x
      0xC0DD,  0xC0DE,  0xC0DF,  0xC0E0,  0xC0E1,  0xC0E3,  0xD12F,  0xD134,  
      0,       0,       0,       0xD13C,  0,       0,       0,       0,       // 0x0E9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0xC0D4,  0,       0xD142,  0,       0,       0,       // 0x0EAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0EBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0ECx
      0,       0,       0,       0,       0x3EBC,  0x3EB6,  0x3EA5,  0x3EA9,  
      0x3EA6,  0xC0E4,  0,       0,       0xDB46,  0xDB40,  0xDB4B,  0x424D,  // 0x0EDx
      0xDB4F,  0xDB45,  0xDB51,  0xDB50,  0x424E,  0xDB4C,  0x44F3,  0x44F7,  
      0x44F5,  0x44FC,  0xDB43,  0xDB47,  0x424C,  0x4254,  0x44FB,  0x4250,  // 0x0EEx
      0x44F6,  0xDB41,  0x44F1,  0x44F2,  0x44F9,  0xDB52,  0xDB3F,  0xDB49,  
      0xDB4A,  0x44F8,  0,       0,       0,       0,       0xDB4D,  0,       // 0x0EFx
      0,       0,       0,       0,       0,       0,       0xC6F1,  0xC6F2,  
} ;


static const unsigned short Uni2cnsP2Table_0F [] = {
      0xC6F3,  0xC6F4,  0xC6F6,  0xC6F7,  0xC6F8,  0xC6F9,  0xC6FA,  0xC6FB,  // 0x0F0x
      0xC6FC,  0xC6FE,  0xC7A1,  0xC7A2,  0xC7A3,  0xC7A7,  0xC7A8,  0xC7A9,  
      0xC7AA,  0xC7AB,  0xC7AC,  0xC7AD,  0xC7A4,  0xDB48,  0xC6F5,  0,       // 0x0F1x
      0x44F4,  0,       0x44FA,  0,       0xDB4E,  0,       0x45A1,  0,       
      0,       0,       0xC6FD,  0xDB44,  0,       0,       0,       0,       // 0x0F2x
      0,       0xC7A5,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0F3x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0F4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0F5x
      0,       0,       0,       0,       0x4CB5,  0x44FD,  0,       0,       
      0xC6EC,  0,       0xA1D1,  0x4CBB,  0xA1D5,  0xA1D2,  0x4CB9,  0xA1D8,  // 0x0F6x
      0xA1CA,  0x4CC0,  0x4CC6,  0x4CBD,  0xA1CF,  0x4CBE,  0xA1D7,  0xA1D0,  
      0x4CB6,  0xA1CB,  0x4CBF,  0xA1D6,  0xA1D9,  0x4CC1,  0x492F,  0,       // 0x0F7x
      0xA1DB,  0x4CBA,  0xA1C8,  0x4CB8,  0x5BA7,  0xA1DA,  0x492B,  0xA1D4,  
      0x45A3,  0xA1D3,  0xA1C9,  0xA1C7,  0xA1E2,  0xA1DC,  0xCDFA,  0,       // 0x0F8x
      0xA1DE,  0x4CC2,  0xA1E1,  0xACE1,  0x4CB7,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x4932,  0x4CC7,  // 0x0F9x
      0xCDEF,  0xCDF0,  0xCDF1,  0xCDF2,  0xCDF3,  0xCDF4,  0xCDF5,  0xCDF6,  
      0xCDF8,  0xCDF9,  0,       0,       0,       0x4CC4,  0xA1DF,  0xA6AB,  // 0x0FAx
      0,       0,       0xA1DD,  0,       0,       0,       0,       0xA1CD,  
      0xA1CC,  0,       0,       0,       0,       0,       0,       0,       // 0x0FBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x4CBC,  0x4CC3,  0xACEA,  // 0x0FCx
      0x4F6E,  0x53F4,  0xACDC,  0x53F2,  0xACE8,  0x4F72,  0x53EA,  0x53F8,  
      0xACE0,  0x4F68,  0x4F73,  0x4F66,  0x53F1,  0x4F70,  0x53EF,  0x53E8,  // 0x0FDx
      0xACEB,  0xACDB,  0xACE4,  0x53EE,  0xACDF,  0x53EC,  0x53E7,  0x53F5,  
      0x53F0,  0x53F3,  0xACD9,  0x53EB,  0x53E9,  0xACE7,  0xACD8,  0xACD7,  // 0x0FEx
      0,       0,       0,       0,       0,       0,       0xCDF7,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x0FFx
      0,       0,       0x4F69,  0x4F74,  0x53F7,  0xACE6,  0xD3DC,  0xD3DE,  
} ;


static const unsigned short Uni2cnsP2Table_10 [] = {
      0xD3DF,  0xD3E0,  0xD3E1,  0xD3E2,  0xD3E3,  0xD3E4,  0xD3E5,  0xD3E7,  // 0x100x
      0xD3E8,  0xD3E9,  0xD3EA,  0xD3EB,  0xD3EC,  0xD3ED,  0xD3EE,  0xD3EF,  
      0xACDE,  0,       0xACDD,  0xACE2,  0,       0,       0,       0,       // 0x101x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x102x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x103x
      0,       0xACE9,  0x53ED,  0xD5F4,  0x53F6,  0x557A,  0,       0x5BA6,  
      0,       0x5BA1,  0xB7AD,  0xB7AA,  0xB7B4,  0xB7B5,  0x5BA3,  0x5BAB,  // 0x104x
      0x5571,  0x5576,  0,       0x5BA8,  0x5577,  0xB7AB,  0x5BA9,  0x5579,  
      0xB7B1,  0xB7AF,  0xB7AE,  0x5BA4,  0,       0x5575,  0xB7B2,  0xB7B9,  // 0x105x
      0,       0,       0,       0,       0,       0,       0,       0xD9D9,  
      0xD9DA,  0xD9DE,  0xD9DF,  0xD9E0,  0xD9E1,  0xD9E2,  0,       0,       // 0x106x
      0xB7B8,  0xB7B0,  0,       0xB7B6,  0xB7B3,  0xB7AC,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x107x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x108x
      0,       0,       0x5BAA,  0x5BA2,  0,       0,       0,       0x5A74,  
      0xBFA9,  0xBFAF,  0x5A73,  0x61BE,  0xBFAB,  0x5A71,  0x5A76,  0x61C6,  // 0x109x
      0x5A77,  0x67D8,  0x61BD,  0x61C4,  0x61C3,  0x5A78,  0xBFAA,  0x5A75,  
      0x5A79,  0x5A72,  0xBFAE,  0x61C1,  0xBFA7,  0xBFAD,  0xBFA8,  0xBFA6,  // 0x10Ax
      0xBFAC,  0x61C2,  0,       0,       0xD9DB,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0xBFA5,  0xDEBC,  // 0x10Bx
      0xDEBD,  0xDEBE,  0xDEBF,  0xDEC0,  0xDEC3,  0xDEC4,  0xDEC5,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x10Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x10Dx
      0,       0,       0,       0,       0,       0x61BF,  0,       0xDECA,  
      0xC6B4,  0x5F4E,  0x5BA5,  0xC6BB,  0xC6B9,  0xC6B7,  0x67DA,  0x67DB,  // 0x10Ex
      0x5F50,  0x67D7,  0xC6BC,  0xC6BA,  0xC6B3,  0xC6B5,  0xC6B8,  0x5F4F,  
      0,       0,       0xDEC6,  0,       0,       0,       0,       0x67DC,  // 0x10Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_11 [] = {
      0,       0,       0xE2A2,  0xE2A3,  0xE2A4,  0xE2A5,  0xE2A6,  0,       // 0x110x
      0xC6B6,  0xC7EE,  0xC6BD,  0,       0,       0,       0,       0,       
      0,       0x6BF4,  0x6BF5,  0x6BEF,  0x6BF1,  0x6BF0,  0xCDC7,  0xCDC9,  // 0x111x
      0xCDCB,  0xCDC8,  0xCDC6,  0xCDCA,  0xE4FD,  0xE4FE,  0xE5A1,  0,       
      0xCDCC,  0,       0,       0x6BF2,  0,       0,       0,       0,       // 0x112x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xD2FB,  0x6FF1,  0x6FEF,  0x6635,  0x6FEE,  0xD2FA,  0x6FED,  // 0x113x
      0xD2FE,  0x6FF0,  0xD2FD,  0x6633,  0,       0,       0,       0xE7C7,  
      0xE7C8,  0x6FEC,  0,       0,       0,       0,       0,       0,       // 0x114x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0xD2FC,  0,       0,       0xD7D9,  // 0x115x
      0xD7DA,  0x73B3,  0xD7D5,  0,       0xD7D6,  0xD7D7,  0xD7D4,  0xD7D2,  
      0,       0xD7D3,  0,       0xE9BC,  0,       0,       0,       0,       // 0x116x
      0,       0,       0,       0,       0,       0x6864,  0xD7D8,  0,       
      0xDBC9,  0xDBCA,  0xEACD,  0,       0,       0,       0xDBC8,  0,       // 0x117x
      0xDBC7,  0x77D5,  0x77D6,  0x6B66,  0xDED3,  0xDED5,  0xDED4,  0xDED6,  
      0,       0,       0,       0xEBC3,  0,       0x75E7,  0x79A3,  0,       // 0x118x
      0,       0x6C6D,  0xECA2,  0xECA3,  0,       0,       0xE0EB,  0xE2B2,  
      0xE2B1,  0xE2B4,  0xE2B0,  0xE2B3,  0,       0,       0,       0,       // 0x119x
      0,       0,       0,       0xECF9,  0xECFA,  0,       0,       0,       
      0xA165,  0xA166,  0xA1B7,  0x216E,  0,       0,       0,       0xA432,  // 0x11Ax
      0xA430,  0x22C9,  0,       0,       0,       0xA2B5,  0,       0,       
      0xA431,  0,       0xA42F,  0x22C8,  0xA654,  0xAF5C,  0xAA3E,  0xA658,  // 0x11Bx
      0xA656,  0xA3CF,  0xA3D1,  0xA657,  0xA659,  0,       0xA65C,  0xA65A,  
      0,       0xA651,  0,       0xA655,  0xA652,  0,       0xA653,  0xA65B,  // 0x11Cx
      0x25D5,  0xAA43,  0xAA40,  0xAA41,  0xAA42,  0xAD34,  0xAA3F,  0,       
      0xA6A4,  0x25D4,  0x28D4,  0x28D6,  0xAF60,  0xAF5F,  0x28D5,  0xAF5B,  // 0x11Dx
      0xAF5E,  0,       0,       0xAF5D,  0,       0,       0,       0,       
      0x2CDC,  0xB62D,  0xB62A,  0xB62C,  0x2CDB,  0,       0,       0,       // 0x11Ex
      0,       0,       0xB62B,  0,       0,       0,       0,       0,       
      0x2CDD,  0x31D6,  0xBE25,  0x31D7,  0xBE24,  0xBE23,  0xBE22,  0x31D4,  // 0x11Fx
      0,       0xBE26,  0,       0,       0x37B3,  0xC740,  0xC741,  0x37B1,  
} ;


static const unsigned short Uni2cnsP2Table_12 [] = {
      0x31D5,  0,       0xB9F2,  0xB9F3,  0xB9F4,  0,       0,       0xC742,  // 0x120x
      0,       0x37B2,  0x3EC0,  0xD145,  0x3EC1,  0xD147,  0xD148,  0x3EC2,  
      0,       0xD146,  0,       0,       0xC0E5,  0xDB54,  0xDB58,  0x45A4,  // 0x121x
      0xDB55,  0xDB5A,  0xDB56,  0xC7AE,  0xC7AF,  0xC7B0,  0,       0xDB57,  
      0,       0,       0xA1E5,  0xA1E6,  0xA1E4,  0xCDFB,  0,       0,       // 0x122x
      0,       0,       0x4F75,  0,       0xD3F3,  0xB7BC,  0xB7BA,  0,       
      0,       0xB7BB,  0,       0x5F51,  0,       0,       0,       0xCDCD,  // 0x123x
      0xD3A2,  0xD3A1,  0,       0,       0x2148,  0,       0x21C4,  0xA260,  
      0,       0xA1D1,  0xA1D2,  0,       0xA261,  0,       0,       0,       // 0x124x
      0,       0,       0xA435,  0,       0xA2B6,  0xA2B7,  0,       0,       
      0,       0,       0xA434,  0,       0,       0,       0,       0,       // 0x125x
      0xA66A,  0x2360,  0xA666,  0xA662,  0,       0xA65E,  0,       0xA669,  
      0xA65D,  0xA665,  0xA667,  0xA3D3,  0xA3D4,  0xA3D6,  0xA3D8,  0xA3DA,  // 0x126x
      0,       0,       0,       0,       0xA660,  0,       0,       0,       
      0,       0xA663,  0xA668,  0xA664,  0,       0xA661,  0xA65F,  0x23DE,  // 0x127x
      0,       0,       0,       0,       0xA3D9,  0,       0,       0,       
      0x23DD,  0x23DF,  0x23E0,  0x23E1,  0x256A,  0xAA4F,  0xAA47,  0xAA4C,  // 0x128x
      0xAA46,  0x2567,  0xAA4A,  0x256C,  0xAA48,  0x25D6,  0xAA51,  0xA641,  
      0,       0,       0,       0xAA49,  0xA6A6,  0xA6A7,  0xA6A8,  0xA6A9,  // 0x129x
      0xA6AA,  0xA6B0,  0xA6B1,  0xA6AC,  0xA6AB,  0,       0x256B,  0,       
      0xA6AF,  0xA6AE,  0,       0xAA50,  0xAA4B,  0xAA4D,  0xAA4E,  0xA6B2,  // 0x12Ax
      0xA6A5,  0,       0,       0,       0xAA45,  0,       0,       0,       
      0,       0,       0,       0,       0xAA44,  0x25D7,  0x28DB,  0xAF62,  // 0x12Bx
      0x28D7,  0xAF64,  0xAF61,  0x28D8,  0x285F,  0xAF6B,  0xAF63,  0,       
      0,       0,       0,       0,       0xA9FA,  0xA9E8,  0xA9E9,  0xA9EB,  // 0x12Cx
      0xA9EC,  0xA9ED,  0xA9EE,  0xA9EF,  0xA9F0,  0xA9F2,  0xA9F3,  0xA9F5,  
      0xA9F6,  0xA9F7,  0xA9F8,  0xA9F9,  0xA9FB,  0xA9FC,  0xA9FD,  0,       // 0x12Dx
      0xAF6A,  0,       0,       0xAF6C,  0xB431,  0xAF67,  0xAF68,  0,       
      0xAF66,  0,       0,       0xA9F4,  0,       0,       0,       0x28DD,  // 0x12Ex
      0x28DA,  0x28DE,  0x28DC,  0x28D9,  0x2CDE,  0x2C32,  0xB634,  0x2C30,  
      0x2C34,  0xB632,  0xB63C,  0xB636,  0xB63D,  0xB63E,  0xB631,  0xB62E,  // 0x12Fx
      0xB63A,  0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_13 [] = {
      0,       0xB62F,  0,       0,       0,       0,       0xB640,  0xAED5,  // 0x130x
      0xAED6,  0xAED7,  0xAED8,  0xAED9,  0xAEDA,  0xAEDB,  0xAEDE,  0xAEDF,  
      0xAEE0,  0,       0xB630,  0xB63F,  0,       0xB637,  0xB638,  0xB639,  // 0x131x
      0x2CE0,  0xB63B,  0xAEDD,  0,       0xAEE1,  0,       0,       0xB633,  
      0,       0,       0,       0,       0x2CDF,  0x2CE2,  0x307D,  0xBE27,  // 0x132x
      0,       0x307C,  0x31DD,  0xBE34,  0xBE2D,  0x31DB,  0xBE2A,  0x2CE1,  
      0xBE33,  0xBE30,  0x31DA,  0x3122,  0x3123,  0,       0xB3CF,  0xB3DB,  // 0x133x
      0xBE2E,  0xBE2F,  0,       0xB3CE,  0xB3D0,  0xB3D1,  0xB3D2,  0xB3D3,  
      0xB3D4,  0xB3D5,  0xB3D6,  0xB3D8,  0xB3D9,  0xB3DA,  0xB3DE,  0xB3DF,  // 0x134x
      0xB3E0,  0xB3E1,  0x31DC,  0,       0,       0,       0,       0xBE31,  
      0,       0xBE35,  0,       0x307E,  0xBE28,  0xBE29,  0,       0,       // 0x135x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x31D8,  0x31D9,  0,       0,       0xBACF,  0xD14E,  0x3672,  0xC747,  // 0x136x
      0x366A,  0xC745,  0x3670,  0x366C,  0xC74B,  0xC750,  0x3675,  0xC744,  
      0xC746,  0xC74D,  0x37B4,  0xBE32,  0xC74F,  0x3C5A,  0x37B9,  0x3673,  // 0x137x
      0,       0,       0xCF6D,  0x37B8,  0xB9F6,  0xB9F8,  0xB9F9,  0xB9FA,  
      0xB9FB,  0xB9FC,  0xBAA1,  0xBAA2,  0xBAA3,  0xBAA4,  0xBAA5,  0xBAA6,  // 0x138x
      0,       0,       0,       0,       0,       0,       0xC751,  0,       
      0xC74A,  0,       0,       0,       0,       0xC749,  0x3674,  0xC74C,  // 0x139x
      0,       0,       0xB9F5,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x37B7,  // 0x13Ax
      0x37BA,  0xC748,  0x37B5,  0x37B6,  0x37BB,  0,       0x3EC6,  0xD156,  
      0xD14B,  0xD155,  0,       0x3ECD,  0x3C54,  0xDB62,  0xD152,  0x3ECC,  // 0x13Bx
      0xD151,  0x3EC4,  0x3ECB,  0x3EC3,  0xD154,  0xD150,  0x3EC9,  0x3ECA,  
      0x3C55,  0x3EC7,  0xD149,  0xD14C,  0,       0xB9F7,  0,       0xD153,  // 0x13Cx
      0xD14D,  0xC0E6,  0xC0E7,  0xC0E8,  0xC0EA,  0xC0EB,  0xC0EC,  0xC0ED,  
      0xC0EE,  0xC0EF,  0xC0F0,  0xC0F1,  0xC0F2,  0xC0F3,  0,       0xD14F,  // 0x13Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x13Ex
      0,       0x3ECE,  0x3EC8,  0x3EC5,  0,       0x45A9,  0x45A8,  0x45A7,  
      0xDB5C,  0x425C,  0xDB64,  0xDB66,  0xDB61,  0x45AA,  0xDB60,  0x45A6,  // 0x13Fx
      0xDB67,  0,       0,       0,       0,       0,       0,       0xC7B2,  
} ;


static const unsigned short Uni2cnsP2Table_14 [] = {
      0xC7B3,  0xC7B4,  0xC7B5,  0xC7B6,  0xC7B7,  0xC7B9,  0xC7BA,  0xC7BB,  // 0x140x
      0xC7BC,  0xDB5D,  0xC7B8,  0,       0,       0,       0xDB6B,  0,       
      0xDB63,  0xDB53,  0,       0xC7B1,  0x425A,  0xDB65,  0,       0,       // 0x141x
      0,       0,       0,       0xDB5E,  0,       0x45A5,  0x45AB,  0xA1F2,  
      0x4934,  0x4935,  0xA1EF,  0x4936,  0x4CCB,  0x4CCC,  0xA1EB,  0,       // 0x142x
      0xA1F8,  0x4937,  0xA1F7,  0xA1F4,  0,       0xCEA1,  0,       0,       
      0x4CCD,  0x4CCF,  0xA1E7,  0xA1F5,  0xCDFC,  0xCDFD,  0xCEA6,  0xCEA7,  // 0x143x
      0xCEA8,  0xCEA9,  0xCEAA,  0xCEAB,  0xCEAD,  0,       0xA1EC,  0,       
      0,       0,       0xA1ED,  0,       0,       0,       0,       0xA1EE,  // 0x144x
      0x4CF1,  0xA1F3,  0xA1F1,  0,       0,       0,       0,       0xA1E9,  
      0,       0xCDFE,  0xCEA4,  0,       0xCEA3,  0,       0,       0,       // 0x145x
      0x4CCE,  0x4CCA,  0x4CC8,  0xA1E8,  0x4CC9,  0,       0xACEF,  0xACF1,  
      0xACEC,  0x4F77,  0x4F7A,  0x4F79,  0xACED,  0,       0xACF0,  0,       // 0x146x
      0xCEAC,  0,       0,       0xD3F4,  0xD3F6,  0xD3F8,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x53FA,  0xACF2,  // 0x147x
      0x53FB,  0x53F9,  0xB4EF,  0,       0,       0,       0,       0,       
      0,       0,       0xACF3,  0,       0,       0,       0xACEE,  0xD3F7,  // 0x148x
      0x4F76,  0xB7C3,  0x557D,  0xB7BD,  0x5BAE,  0xB7BF,  0xB7C4,  0,       
      0xB7C2,  0,       0xB7C5,  0x5BAC,  0,       0,       0xACF4,  0,       // 0x149x
      0,       0xD9E4,  0xD9E5,  0xD9E6,  0xD9E7,  0xD9E8,  0xD9E9,  0xD9EA,  
      0xD9EB,  0xBEEC,  0,       0xB7C0,  0xB7C1,  0,       0,       0,       // 0x14Ax
      0x557E,  0,       0,       0,       0,       0,       0,       0x5BAF,  
      0xBFB4,  0x61C7,  0xB7BE,  0x61C9,  0xBFB3,  0xDEC7,  0,       0xDEC8,  // 0x14Bx
      0xDEC9,  0xDECB,  0xDECD,  0xDECE,  0xBFB1,  0xBFB2,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x14Cx
      0,       0x5BB0,  0x61C8,  0,       0xE2A8,  0x61CA,  0,       0,       
      0xC6C2,  0xC6BF,  0x67DD,  0xC6C7,  0xC6C1,  0xDECC,  0,       0xE2A7,  // 0x14Dx
      0,       0xC6C3,  0xC6C6,  0xCABB,  0,       0,       0,       0,       
      0,       0,       0,       0xC6C0,  0xBFB5,  0,       0x6333,  0xE5A2,  // 0x14Ex
      0,       0xE5A3,  0xE5A4,  0xE5A5,  0xCDCE,  0,       0,       0,       
      0x6BF7,  0xD3A8,  0x6636,  0xD3A4,  0xD3A3,  0xD3A7,  0xD3A5,  0,       // 0x14Fx
      0x6FF4,  0xE7C9,  0xE7CA,  0xE7CC,  0xD3A6,  0xE7CB,  0,       0x6FF2,  
} ;


static const unsigned short Uni2cnsP2Table_15 [] = {
      0,       0x6FF3,  0xD7DB,  0,       0xE9BD,  0,       0,       0x73B4,  // 0x150x
      0xD7DD,  0x73B5,  0xDBCB,  0xD7DC,  0,       0,       0,       0xDED7,  
      0,       0,       0,       0,       0,       0x77D7,  0,       0x7BDF,  // 0x151x
      0xE5DA,  0xE6C2,  0xE6CF,  0xA262,  0,       0xAF6D,  0xA66B,  0xAA52,  
      0xA9FE,  0xAAA1,  0x2CE4,  0,       0xB642,  0xAF6E,  0xB641,  0xAEE2,  // 0x152x
      0x2CE3,  0,       0,       0,       0xBE36,  0xB3E2,  0,       0xC752,  
      0xD159,  0,       0,       0,       0,       0xD158,  0xDB6A,  0xE47A,  // 0x153x
      0,       0xDB68,  0xC7BD,  0xDB69,  0xA1FA,  0xA1F9,  0xACF5,  0,       
      0,       0,       0,       0,       0,       0xBFB6,  0xC3BF,  0,       // 0x154x
      0,       0,       0xDECF,  0xBFB7,  0xC6C8,  0xC6C9,  0xC8BB,  0,       
      0,       0xD7DE,  0x21AF,  0xA263,  0,       0xA437,  0xA436,  0,       // 0x155x
      0xA66C,  0xA3DC,  0xB643,  0xBE37,  0xBE38,  0xD15A,  0xA439,  0xA438,  
      0x23E4,  0x23E3,  0x256F,  0xAA53,  0xA6B4,  0,       0xAEE3,  0x31DE,  // 0x156x
      0xBE39,  0xBE3C,  0x2CE5,  0xBE3B,  0xBE3A,  0,       0x3ECF,  0xD15C,  
      0,       0xC0F4,  0xDB6C,  0xC7BE,  0xDB6D,  0,       0x4CD0,  0xCEAF,  // 0x157x
      0xD3F9,  0xACF6,  0xACF7,  0xB7C6,  0xC6CA,  0xBFBA,  0xBFB8,  0xBFB9,  
      0xC6CB,  0xCDCF,  0,       0,       0xA264,  0,       0xA265,  0,       // 0x158x
      0xA43A,  0,       0xA66E,  0xA66D,  0,       0xAA54,  0,       0xA5C2,  
      0,       0x28DF,  0x2CE8,  0x2C35,  0x2CE7,  0xB646,  0,       0xB645,  // 0x159x
      0xAEE4,  0xAEE5,  0xB647,  0,       0x2CE9,  0x3124,  0x31E1,  0xBE3D,  
      0,       0,       0x31DF,  0x31E0,  0x31E2,  0xB3E3,  0,       0,       // 0x15Ax
      0,       0xC754,  0x37BE,  0x37C2,  0x37C0,  0x37C1,  0xBAA7,  0x3ED0,  
      0xD15D,  0,       0x3ED2,  0x3ED1,  0xD15F,  0,       0x4261,  0xDB6F,  // 0x15Bx
      0xDB70,  0xDB6E,  0,       0,       0,       0x45AC,  0x45AE,  0xA1FB,  
      0,       0x4CD1,  0,       0xBFBB,  0,       0,       0x5BB1,  0,       // 0x15Cx
      0x5BB2,  0,       0,       0,       0xC6CC,  0,       0,       0,       
      0,       0,       0xA167,  0xA168,  0xA1B8,  0xA266,  0,       0,       // 0x15Dx
      0xA1D3,  0xA1D4,  0,       0,       0x21F6,  0xA43C,  0x2254,  0xA43F,  
      0xA440,  0xA43E,  0xA43D,  0xA1EB,  0,       0x2363,  0x2364,  0,       // 0x15Ex
      0x2366,  0xA3DD,  0xA3DE,  0xA3DF,  0xA3E0,  0xA3E1,  0xA3E2,  0xA3E3,  
      0xA670,  0,       0,       0,       0xA66F,  0,       0,       0x2576,  // 0x15Fx
      0x25DA,  0x2574,  0xAA55,  0xAA56,  0x2863,  0xAA5C,  0xAA58,  0xAA59,  
} ;


static const unsigned short Uni2cnsP2Table_16 [] = {
      0xA6B6,  0xA6B7,  0xAA5A,  0,       0xAA5B,  0xAA5D,  0x2579,  0,       // 0x160x
      0,       0xAA57,  0,       0xA939,  0x2864,  0x2862,  0x28E1,  0x28E2,  
      0x28E0,  0,       0xAAA3,  0,       0xAAA4,  0xAAA5,  0xAAA6,  0xAAA8,  // 0x161x
      0xAAA9,  0xAAA7,  0xAAA2,  0,       0,       0x2CEC,  0,       0xB648,  
      0xB64B,  0,       0x2CEA,  0x2CED,  0xAEE7,  0xAEE8,  0xAEE9,  0,       // 0x162x
      0,       0xB64A,  0,       0x2C37,  0,       0,       0,       0,       
      0x2CEB,  0,       0x31E4,  0xAEE6,  0x2C36,  0xBE41,  0xBE44,  0xB4FE,  // 0x163x
      0xBE3E,  0xBE43,  0xBE40,  0xBE45,  0xBE3F,  0xB3E4,  0,       0xB3E5,  
      0,       0x3127,  0,       0,       0x31E3,  0,       0,       0x3C5E,  // 0x164x
      0xC758,  0xC75B,  0xC75D,  0,       0xC75A,  0xBAA8,  0xC755,  0xC75C,  
      0x37C3,  0,       0,       0,       0,       0xC759,  0x367A,  0x3678,  // 0x165x
      0x37C4,  0,       0xC757,  0,       0xD160,  0xD161,  0,       0,       
      0x3C5D,  0,       0xC0F6,  0,       0,       0,       0,       0,       // 0x166x
      0x3ED3,  0x3ED4,  0x3ED5,  0xDB72,  0x4263,  0x45AF,  0x4262,  0xC7BF,  
      0xC7C0,  0xC7C1,  0xDB71,  0,       0,       0,       0x45B0,  0x4938,  // 0x167x
      0xA2A2,  0xA1FC,  0xA2A1,  0xACFC,  0xA1FE,  0x4CD3,  0xCEB1,  0xCEB2,  
      0xA1FD,  0x4264,  0,       0,       0,       0x4CD2,  0xACFD,  0x53FC,  // 0x168x
      0xACF8,  0xACF9,  0x5621,  0xD3FA,  0xACFA,  0,       0,       0xB7C8,  
      0xB7C7,  0x5BB3,  0,       0,       0,       0,       0x562E,  0x5A7B,  // 0x169x
      0xE2A9,  0,       0,       0x6BF8,  0xD3A9,  0,       0xE9BE,  0,       
      0x75E8,  0,       0,       0xEBC4,  0xDED8,  0xECDF,  0,       0,       // 0x16Ax
      0x21E2,  0,       0xA1D5,  0xA1D6,  0,       0,       0,       0xA441,  
      0x2258,  0xA442,  0xA2B9,  0xA2BA,  0xA2BB,  0xA2BC,  0,       0,       // 0x16Bx
      0x2257,  0x22CB,  0xA443,  0x22CA,  0xA674,  0x2368,  0x236B,  0xA3E4,  
      0,       0,       0,       0xA3E6,  0xA3E8,  0xA3E9,  0xA3EB,  0xA3EC,  // 0x16Cx
      0xA3ED,  0xA3EE,  0xA3EF,  0xA3E5,  0,       0xA672,  0xA673,  0,       
      0xA675,  0,       0xA671,  0xA3EA,  0,       0xA3E7,  0x23E6,  0x23E7,  // 0x16Dx
      0x23E5,  0x257C,  0xAA61,  0xAA60,  0x25E0,  0x257A,  0x25DE,  0x257D,  
      0x25DB,  0x25DC,  0x257E,  0,       0,       0xA6BA,  0,       0,       // 0x16Ex
      0,       0xA6BB,  0xA6BE,  0xA6BF,  0xA6C0,  0xA6C1,  0xA6C2,  0xA6C3,  
      0xA6C5,  0xA6C6,  0xA6C7,  0xA6C8,  0xA6C9,  0,       0,       0xAA5F,  // 0x16Fx
      0,       0xAA5E,  0xA6C4,  0xA6BC,  0xA6BD,  0x25E2,  0x25DF,  0,       
} ;


static const unsigned short Uni2cnsP2Table_17 [] = {
      0x25E3,  0x25E1,  0x2868,  0x28E4,  0xAF76,  0xAF78,  0xAF79,  0x2865,  // 0x170x
      0x286B,  0x28E6,  0x2866,  0x28E3,  0xAF70,  0xAF7B,  0xAF74,  0x28EB,  
      0,       0xAF7E,  0xAAAD,  0xAAAE,  0xAAAF,  0xAAB0,  0xAAB1,  0xAAB2,  // 0x171x
      0xAAB3,  0xAAB4,  0,       0xAF73,  0xAF77,  0x286C,  0,       0xAF75,  
      0xAF7A,  0xAF6F,  0,       0xAF7D,  0,       0x28E9,  0x286A,  0x28EA,  // 0x172x
      0x28E7,  0xAF71,  0xAF7C,  0x28E5,  0x28E8,  0xAF72,  0xB0D3,  0x2CF0,  
      0xB64F,  0x2CF2,  0x2CF5,  0x2CEF,  0xB655,  0x2CEE,  0xB656,  0,       // 0x173x
      0xB650,  0,       0,       0,       0,       0xB651,  0xAEEC,  0xAEEE,  
      0xAEF0,  0xAEF1,  0xAEF3,  0xAEF4,  0xAEF5,  0xAEF6,  0xAEF7,  0xAEF9,  // 0x174x
      0,       0,       0xB654,  0,       0xB64E,  0x2CF1,  0,       0xB653,  
      0,       0xB652,  0,       0,       0,       0,       0,       0xAEEF,  // 0x175x
      0xAEF2,  0x2CF7,  0x2CF4,  0x2CF3,  0x2CF6,  0x2CF8,  0xBE4C,  0xBE52,  
      0xBE46,  0xBE47,  0x31EA,  0xBE48,  0xBE49,  0xBE4F,  0x31E9,  0x31ED,  // 0x176x
      0xBE4D,  0x312B,  0xBE4E,  0x31EB,  0,       0,       0,       0,       
      0,       0,       0xBE53,  0,       0,       0xB3E8,  0xB3E9,  0xB3EA,  // 0x177x
      0xB3EB,  0xB3EC,  0xB3ED,  0xB3EE,  0xB3EF,  0xB3F1,  0xB3F2,  0xB3F4,  
      0xB3F5,  0xB3F6,  0xB3F7,  0xB3F8,  0xB3F9,  0xB3FA,  0xB3FB,  0xB3FC,  // 0x178x
      0xB3FD,  0xB3FE,  0xB4A1,  0xB4A2,  0xB4A3,  0,       0xB3F0,  0,       
      0xBE51,  0x312A,  0,       0xBE4B,  0xBE4A,  0,       0,       0,       // 0x179x
      0x31E6,  0x31E7,  0x31E8,  0x31E5,  0x367B,  0xC762,  0x367C,  0x37DA,  
      0xC75F,  0x3721,  0x37C8,  0x37D9,  0xC764,  0,       0xC766,  0x37CF,  // 0x17Ax
      0xC765,  0xC760,  0x37D0,  0x37C9,  0x37D7,  0x37D4,  0x37C7,  0x37CB,  
      0xBAA9,  0,       0,       0,       0,       0,       0xBAAB,  0xBAAC,  // 0x17Bx
      0xBAAD,  0xBAAE,  0xBAAF,  0xBAB0,  0xBAB2,  0xBAB3,  0xBAB4,  0xBAB6,  
      0xBAB7,  0xBAB8,  0xBAB9,  0xBABA,  0xBABE,  0xBABF,  0xBAC1,  0xBAC2,  // 0x17Cx
      0xBAC3,  0xBAC4,  0xBAC5,  0,       0,       0,       0xBABB,  0,       
      0,       0x37D6,  0,       0,       0xC763,  0x37D8,  0xC75E,  0,       // 0x17Dx
      0,       0xBABD,  0xBAC0,  0xBAB1,  0xBAAA,  0x37C5,  0x3ED6,  0x37D3,  
      0x37CC,  0x37D2,  0x37D1,  0x37CA,  0x37CD,  0x37D5,  0xC767,  0xB3E7,  // 0x17Ex
      0x3EDF,  0x3EDA,  0x3EDD,  0x3ED7,  0x3C65,  0x3ED9,  0xD163,  0x3C62,  
      0x3C60,  0xD167,  0xD165,  0xDB7C,  0x3EDC,  0,       0,       0x3EDB,  // 0x17Fx
      0,       0,       0,       0,       0,       0xD166,  0xC0F8,  0xC0F9,  
} ;


static const unsigned short Uni2cnsP2Table_18 [] = {
      0xC0FA,  0xC0FC,  0xC0FD,  0xC0FE,  0xC1A2,  0xC1A3,  0,       0,       // 0x180x
      0xD162,  0,       0,       0xD164,  0,       0,       0xC0F7,  0,       
      0xD168,  0x3ED8,  0x3EDE,  0x3EE0,  0xD16A,  0xC1A1,  0,       0x4270,  // 0x181x
      0,       0x45B2,  0x426A,  0xDB7B,  0x4271,  0xDB73,  0x45B4,  0xA2A9,  
      0x4273,  0,       0xDB75,  0,       0xC7C8,  0x426F,  0x45B7,  0x426E,  // 0x182x
      0,       0,       0,       0xC7C7,  0xC7C9,  0xC7CA,  0xC7CB,  0xC7CC,  
      0xC7CD,  0xC7CE,  0xC7CF,  0xC7D0,  0xC7D1,  0xC7D2,  0xC7D4,  0xDB74,  // 0x183x
      0xDB78,  0,       0,       0,       0,       0x4272,  0,       0,       
      0,       0,       0x4265,  0xDB76,  0,       0xC7D3,  0,       0,       // 0x184x
      0x45B3,  0x45B6,  0x45B5,  0xA2A6,  0x45B1,  0xDB77,  0,       0x4CDB,  
      0x4CD9,  0x4939,  0x4CD6,  0xA2AF,  0x4CD7,  0x493F,  0x493B,  0xA2AC,  // 0x185x
      0,       0x493E,  0xA2A5,  0xDB79,  0xA2A4,  0xCEBA,  0,       0xB7D1,  
      0xC7C5,  0,       0,       0,       0,       0x4CD4,  0,       0,       // 0x186x
      0x4CDC,  0xCEB3,  0xCEB4,  0xCEB5,  0xCEB6,  0xCEB7,  0xCEB8,  0xCEB9,  
      0xCEBB,  0xCEBD,  0xCEBE,  0xCEBF,  0xCEC0,  0xCEC1,  0xCEC2,  0xCEC4,  // 0x187x
      0,       0xDB7A,  0,       0,       0xA2A7,  0xA2AE,  0xA2AD,  0xA2A8,  
      0,       0,       0xA2A3,  0xCEC5,  0xCEC3,  0xCEBC,  0x4CDA,  0x4CD5,  // 0x188x
      0x493D,  0xA2AA,  0x4CD8,  0xA2AB,  0,       0xD4A5,  0,       0,       
      0,       0x54A8,  0x54A3,  0xADA5,  0xACFE,  0x54A9,  0x54A6,  0xADA1,  // 0x189x
      0x4F7E,  0xADA8,  0x54A2,  0xADAB,  0x53FD,  0xADAA,  0,       0,       
      0,       0,       0,       0xADAC,  0xD3FB,  0xD3FC,  0xD3FD,  0xD3FE,  // 0x18Ax
      0xD4A2,  0xD4A3,  0xD4A4,  0xD4A6,  0xD4A7,  0xD4AB,  0xD4AC,  0,       
      0,       0x53FE,  0xADA6,  0,       0xADA7,  0xADA3,  0,       0xADA2,  // 0x18Bx
      0xADA4,  0,       0,       0,       0,       0,       0xD4A1,  0xD4A8,  
      0x54A7,  0x54A1,  0x54A5,  0xADA9,  0,       0xB7CB,  0xB7D4,  0xB7CF,  // 0x18Cx
      0x4F7D,  0xB7CD,  0,       0x5623,  0xB7D3,  0xB7CA,  0x5BB6,  0x5BB4,  
      0xB7CC,  0xB7CE,  0xB7D0,  0,       0x5BB5,  0x5625,  0,       0,       // 0x18Dx
      0,       0,       0xD9EC,  0xD9ED,  0xD9EE,  0xD9EF,  0xD9F0,  0xD9F1,  
      0,       0xB7D2,  0,       0,       0xB7D5,  0,       0,       0,       // 0x18Ex
      0,       0xB7C9,  0x61CB,  0x5A7C,  0,       0xBFBF,  0x61CC,  0x61CD,  
      0xBFBE,  0xBFC0,  0xDED0,  0xDED1,  0xDED2,  0xDED4,  0,       0xBFBD,  // 0x18Fx
      0xBFC1,  0,       0xDED3,  0,       0xBFBC,  0x67DF,  0x5F53,  0xC6CD,  
} ;


static const unsigned short Uni2cnsP2Table_19 [] = {
      0xC6D2,  0xC6D0,  0xDED5,  0,       0,       0,       0xE2AA,  0xE2AB,  // 0x190x
      0xC6CE,  0,       0,       0x67E1,  0x67E0,  0xDFF3,  0,       0xCDD1,  
      0,       0,       0x6BF9,  0,       0,       0xE5A6,  0x6BFA,  0x6BFB,  // 0x191x
      0xD3AA,  0x6FF6,  0xD3AB,  0x6FF5,  0xE7CD,  0xE7CE,  0,       0,       
      0,       0xD7E2,  0x73B6,  0xD7E1,  0xD7E3,  0xD7DF,  0xE9BF,  0,       // 0x192x
      0xD7E0,  0xD7E4,  0xE9C0,  0x75E9,  0xDBCC,  0,       0xDEDA,  0xDEDB,  
      0xEBC5,  0xDED9,  0xDEDC,  0,       0xECA4,  0,       0x79A4,  0xECCA,  // 0x193x
      0,       0xE3CD,  0x7AE5,  0,       0x2133,  0,       0xA268,  0x21E3,  
      0xA269,  0xA1D8,  0xA1D7,  0xA445,  0,       0xA444,  0xA676,  0xA677,  // 0x194x
      0x23EA,  0x236C,  0xA3F0,  0,       0,       0x23E9,  0x286F,  0xB024,  
      0xAA63,  0xAA62,  0xA6CA,  0xA6CB,  0xA6CC,  0xA6CD,  0xA6CF,  0xAA64,  // 0x195x
      0xA6CE,  0,       0,       0xB023,  0xB021,  0xB026,  0xB025,  0,       
      0,       0xAAB5,  0xAAB6,  0xAAB7,  0,       0,       0xB022,  0,       // 0x196x
      0xB659,  0x2CF9,  0xB658,  0xAEFA,  0xAEFB,  0x2CFA,  0xB3E6,  0xB4A4,  
      0xB4A5,  0xB4A6,  0xB4A7,  0,       0,       0,       0x37DC,  0xC769,  // 0x197x
      0,       0x37DB,  0xC76A,  0xBAC7,  0,       0xC768,  0xBAC6,  0,       
      0,       0,       0,       0x3C66,  0x3C68,  0xD16D,  0x3EE2,  0xC1A5,  // 0x198x
      0,       0xC1A6,  0,       0xD16B,  0xD16C,  0,       0x3EE1,  0x3C69,  
      0,       0xDB7D,  0xC7D5,  0xC7D6,  0,       0x45B8,  0,       0x4941,  // 0x199x
      0x4942,  0,       0xCEC6,  0,       0,       0x4CDD,  0xADAF,  0xADAE,  
      0xADB1,  0xADB2,  0x54AA,  0xADB0,  0xD4AD,  0xD4AE,  0,       0,       // 0x19Ax
      0,       0xB7D6,  0,       0,       0,       0xCDD2,  0,       0xE2AC,  
      0xE2AD,  0,       0,       0,       0,       0x6BFC,  0,       0,       // 0x19Bx
      0xECE0,  0xA169,  0,       0,       0x21E4,  0xA446,  0xA449,  0xA44A,  
      0,       0,       0x225A,  0xA2BD,  0xA2BE,  0xA2BF,  0xA2C0,  0xA2C1,  // 0x19Cx
      0xA447,  0,       0,       0xA67E,  0xA67D,  0x236E,  0xA67B,  0xA67C,  
      0,       0xA3F2,  0,       0,       0,       0,       0x25E5,  0x25E4,  // 0x19Dx
      0xAA66,  0x25E6,  0xAA67,  0,       0xAA68,  0xA6D1,  0xA6D2,  0xA6D4,  
      0xA6D5,  0,       0xAA65,  0xA6D3,  0,       0,       0,       0,       // 0x19Ex
      0,       0x28EC,  0xB028,  0xB02A,  0x28ED,  0x2871,  0x2872,  0x2873,  
      0xB02B,  0xB027,  0,       0,       0xB029,  0xAAB8,  0xAABA,  0xAABB,  // 0x19Fx
      0xAABC,  0,       0xB02C,  0xB02D,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_1A [] = {
      0x2C4A,  0xB661,  0x2C45,  0x2C44,  0x2C43,  0x2C47,  0xB664,  0xB665,  // 0x1A0x
      0xB65F,  0xB65E,  0x2CFD,  0,       0,       0x2DA2,  0xB65B,  0xB662,  
      0xAEFC,  0xAEFD,  0,       0xB660,  0xB663,  0,       0,       0,       // 0x1A1x
      0,       0,       0,       0,       0xB65A,  0,       0xB65C,  0x2DA1,  
      0x2CFE,  0,       0x312D,  0x31EF,  0xBE57,  0xBE59,  0xBE58,  0xBE56,  // 0x1A2x
      0xBE5B,  0x31F0,  0xB4A8,  0xB4A9,  0xB4AA,  0xB4AB,  0xB4AC,  0xB4AD,  
      0xB4AE,  0xB4AF,  0,       0,       0x312F,  0,       0xBE5C,  0,       // 0x1A3x
      0,       0,       0,       0x31EE,  0xBE55,  0x37DE,  0x3726,  0x37E1,  
      0xC770,  0xC76B,  0x3723,  0x37DD,  0x37E0,  0xC76E,  0x3725,  0x37DF,  // 0x1A4x
      0xC76F,  0xC76C,  0,       0,       0,       0,       0xBAC8,  0xBAC9,  
      0xBACA,  0xBACB,  0xBACC,  0xBACD,  0xBACE,  0xBACF,  0,       0,       // 0x1A5x
      0,       0xC76D,  0,       0x37E2,  0,       0,       0xBDEC,  0xD174,  
      0xD170,  0x3C6B,  0x3C70,  0x3EE3,  0xD177,  0x3EE4,  0xD172,  0xD171,  // 0x1A6x
      0xD176,  0x3C6D,  0xD173,  0,       0xD16F,  0xD175,  0xC1A7,  0xC1A8,  
      0xC1A9,  0xC1AA,  0xC1AC,  0xC1AD,  0xC1AE,  0,       0,       0,       // 0x1A7x
      0,       0,       0xD16E,  0xDB7E,  0xDC27,  0x45BC,  0x45BA,  0xDC24,  
      0xDC2C,  0x4276,  0xDC2E,  0xDC2B,  0xDC26,  0x45B9,  0xA2B3,  0,       // 0x1A8x
      0xC7D7,  0xC7D8,  0xC7D9,  0xC7DA,  0,       0,       0xDC28,  0xDC25,  
      0xDC29,  0,       0,       0xDC2D,  0xDC21,  0,       0xDC23,  0x45BB,  // 0x1A9x
      0xDC2A,  0,       0xC7C4,  0xE267,  0,       0,       0,       0xA2B0,  
      0x4CDE,  0x4947,  0xA2B7,  0x4948,  0xA2B5,  0xA2B2,  0,       0xCEC7,  // 0x1AAx
      0xCEC8,  0xCEC9,  0xCECA,  0xCECB,  0xCECC,  0xCECE,  0xCECF,  0,       
      0,       0,       0,       0,       0xA2B8,  0,       0xA2B6,  0xCECD,  // 0x1ABx
      0x4CE1,  0,       0x4CDF,  0,       0xA2B1,  0x4CE0,  0xADB5,  0xADB7,  
      0x54AC,  0x5022,  0x54AD,  0x54AB,  0xADB6,  0xADB3,  0xADB4,  0xD4AF,  // 0x1ACx
      0xD4B0,  0xD4B1,  0xD4B3,  0xD4B4,  0xD4B5,  0xD4B6,  0xD4B7,  0,       
      0,       0,       0xB7D9,  0xB7D7,  0x5BB8,  0xD9F2,  0xD9F3,  0xD9F4,  // 0x1ADx
      0xD9F5,  0,       0xB7D8,  0xB7DA,  0xA2B4,  0x5BB7,  0xC6D8,  0x61CE,  
      0xD9F6,  0,       0xDED6,  0xDED7,  0,       0,       0,       0,       // 0x1AEx
      0,       0xBFC2,  0xE2AE,  0,       0x5F57,  0xC6D3,  0xC6D5,  0x5F56,  
      0xC6D7,  0xC6D6,  0xE2AF,  0xC6D4,  0,       0,       0,       0x6336,  // 0x1AFx
      0,       0,       0,       0xCDD3,  0xD3AC,  0x6638,  0xD3AD,  0xE7CF,  
} ;


static const unsigned short Uni2cnsP2Table_1B [] = {
      0xE7D0,  0,       0,       0xD3AE,  0x73B8,  0x6866,  0xD7E5,  0x73B7,  // 0x1B0x
      0,       0,       0xD7E6,  0,       0x6A45,  0x6B67,  0,       0xEBC6,  
      0,       0xE0EC,  0xE4C5,  0x79A5,  0xECA5,  0,       0x6D54,  0,       // 0x1B1x
      0x7AA7,  0x6D71,  0xE3CE,  0xE5B4,  0,       0xA16A,  0,       0xAA6A,  
      0xAA69,  0,       0xA6D6,  0xA6D7,  0,       0,       0,       0x28EF,  // 0x1B2x
      0xB02E,  0xAABD,  0xB031,  0,       0xB02F,  0,       0x3131,  0xC367,  
      0xBE5E,  0xBE5D,  0,       0x3727,  0xBE5F,  0,       0,       0,       // 0x1B3x
      0,       0xD17A,  0xD178,  0xD179,  0,       0xDC30,  0x4426,  0xC7DB,  
      0,       0xDC31,  0x45BD,  0,       0,       0xCED1,  0xA2BA,  0,       // 0x1B4x
      0xA2B9,  0,       0xADB9,  0x53D2,  0xADB8,  0xB7DB,  0xB7DC,  0,       
      0x61CF,  0xC6D9,  0xCDD4,  0xD3AF,  0,       0xA16B,  0xA1B9,  0,       // 0x1B5x
      0,       0xA44C,  0x22CC,  0,       0,       0xA724,  0x2372,  0xA723,  
      0xA722,  0xA3F3,  0,       0,       0,       0x25E7,  0,       0,       // 0x1B6x
      0xA6D8,  0xAA6B,  0xB032,  0xB030,  0,       0,       0,       0xB033,  
      0,       0,       0,       0x28F0,  0x2C4B,  0xAFA1,  0,       0,       // 0x1B7x
      0,       0xB669,  0,       0,       0,       0xBE61,  0x31F1,  0x37E3,  
      0xBE63,  0xBE60,  0xBE62,  0xB4B0,  0,       0,       0,       0,       // 0x1B8x
      0,       0,       0,       0,       0,       0,       0xC771,  0xBAD0,  
      0xC773,  0,       0,       0,       0,       0xC772,  0,       0,       // 0x1B9x
      0,       0x3EE5,  0,       0,       0,       0xC1AF,  0x45BE,  0xDC33,  
      0,       0xDC32,  0,       0,       0,       0,       0x4CE2,  0xA2BB,  // 0x1BAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x54AF,  0xADBA,  0,       0,       0xD9F7,  0,       0,       0,       // 0x1BBx
      0,       0,       0,       0x61D0,  0,       0,       0,       0x6FF7,  
      0,       0,       0x214A,  0xA1BA,  0x21E5,  0xA1CD,  0xA1DA,  0,       // 0x1BCx
      0,       0xA26B,  0xA26A,  0,       0,       0x22CD,  0xA2C3,  0x23EC,  
      0x2373,  0,       0x25E8,  0,       0xA725,  0,       0x23EB,  0,       // 0x1BDx
      0x23EE,  0x23ED,  0,       0xB034,  0x25E9,  0xAA6C,  0x25EB,  0xA6D9,  
      0xB035,  0x25EA,  0x28F1,  0xB037,  0,       0xB038,  0x28F2,  0xB039,  // 0x1BEx
      0x2DA3,  0xB66C,  0xB66A,  0,       0x2DA4,  0xB66B,  0xB66D,  0xAFA2,  
      0,       0,       0xBE66,  0x31F2,  0x3134,  0x31F4,  0xC776,  0xC774,  // 0x1BFx
      0xC775,  0,       0x372A,  0xC777,  0xBAD1,  0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_1C [] = {
      0,       0,       0xD17B,  0xD17D,  0xD17C,  0,       0,       0x48A6,  // 0x1C0x
      0,       0x427A,  0xDC34,  0x45C0,  0x45BF,  0xDC35,  0x45C1,  0,       
      0xADBD,  0xA2BE,  0xA2BD,  0,       0xA2BC,  0xADBB,  0x54B0,  0xADBC,  // 0x1C1x
      0xADBE,  0xD4B8,  0,       0,       0xB7DD,  0x6639,  0,       0,       
      0x6867,  0,       0x79A6,  0xA13E,  0x2175,  0x2174,  0xA26C,  0,       // 0x1C2x
      0,       0xA44D,  0x225E,  0x22CE,  0xA44E,  0xA450,  0xA451,  0xA44F,  
      0xA2C4,  0,       0,       0,       0,       0,       0xA729,  0xA3F4,  // 0x1C3x
      0xA727,  0,       0xA726,  0,       0xA728,  0x23EF,  0x262C,  0x262B,  
      0xAA6D,  0xAA6E,  0x25EC,  0xAA6F,  0xA6DB,  0,       0,       0,       // 0x1C4x
      0,       0,       0,       0x25ED,  0x2877,  0xB03A,  0xB03F,  0x287A,  
      0x2876,  0x28F5,  0xB03E,  0xB03D,  0xB03C,  0xB03B,  0,       0xAAC0,  // 0x1C5x
      0xAAC1,  0xAAC2,  0xAAC3,  0xAAC4,  0,       0xAABF,  0,       0,       
      0xB040,  0x28F4,  0xB672,  0x2C50,  0xB66F,  0x2C4F,  0xBE67,  0xB670,  // 0x1C6x
      0xB66E,  0,       0xAFA3,  0xAFA4,  0xAFA6,  0xAFA7,  0xAFA8,  0,       
      0x2DA6,  0x2DA7,  0xB671,  0,       0xB673,  0,       0,       0x2DA5,  // 0x1C7x
      0,       0xB674,  0xBE6D,  0xBE69,  0x31F8,  0x31FA,  0x31F7,  0x31F9,  
      0x31F6,  0x31FB,  0xBE70,  0xBE6A,  0xB4B1,  0xB4B2,  0xB4B5,  0xB4B6,  // 0x1C8x
      0xB4B7,  0xB4B8,  0xB4B9,  0xB4BA,  0xBE68,  0,       0xBE6C,  0,       
      0,       0xBE6F,  0xBE6E,  0xB4B3,  0xC823,  0xC824,  0xC822,  0x372C,  // 0x1C9x
      0xC77E,  0xC77A,  0x37E4,  0x372D,  0x37E5,  0xC779,  0xC778,  0xC825,  
      0xC821,  0xC826,  0,       0xC77C,  0,       0,       0xBAD2,  0xBAD3,  // 0x1CAx
      0xBAD4,  0xC77D,  0x372E,  0,       0xD223,  0x3EE9,  0x3EE7,  0xD226,  
      0x3EE8,  0xD225,  0xD229,  0xD221,  0xD17E,  0xD227,  0xD224,  0,       // 0x1CBx
      0xC1B0,  0xC1B1,  0xC1B2,  0xD222,  0,       0,       0xD228,  0,       
      0,       0,       0x3EE6,  0,       0x427C,  0x427E,  0x427B,  0xDC38,  // 0x1CCx
      0xDC36,  0xDC37,  0xC7DD,  0,       0,       0xDC39,  0,       0x45C2,  
      0xA2C0,  0x4CE6,  0,       0xCED2,  0xCED3,  0xCED4,  0xCED5,  0xCED6,  // 0x1CDx
      0x4CE5,  0,       0,       0,       0,       0,       0x4CE4,  0xADC0,  
      0xADBF,  0xA2BF,  0,       0,       0,       0,       0xD4B9,  0xB0AD,  // 0x1CEx
      0xB7DE,  0,       0,       0xBFC3,  0x5F58,  0x67E2,  0,       0,       
      0,       0xE5A7,  0xE5A8,  0,       0x6BFD,  0,       0,       0xE7D1,  // 0x1CFx
      0x73BA,  0,       0,       0,       0,       0,       0x21B0,  0xA16C,  
} ;


static const unsigned short Uni2cnsP2Table_1D [] = {
      0xA26D,  0xA454,  0xA453,  0,       0xA452,  0x22CF,  0x2375,  0,       // 0x1D0x
      0xA72A,  0,       0,       0x262D,  0xAA71,  0xAA70,  0x28F7,  0xB042,  
      0,       0xB043,  0x28F6,  0xB044,  0,       0xB677,  0xB678,  0xB676,  // 0x1D1x
      0xB528,  0xB675,  0,       0xBE71,  0xBE72,  0xC828,  0x37E7,  0xC829,  
      0,       0xC827,  0,       0xBAD5,  0xD22A,  0xDC3A,  0xA2C1,  0xADC1,  // 0x1D2x
      0xA2C2,  0xA2C3,  0,       0xD3B0,  0xDEDD,  0x21C5,  0,       0x21C6,  
      0xA270,  0xA26E,  0xA272,  0xA271,  0,       0xA1DC,  0xA1DD,  0xA1DE,  // 0x1D3x
      0xA273,  0,       0,       0x21E6,  0xA26F,  0,       0,       0xA457,  
      0xA455,  0xA459,  0,       0,       0,       0,       0xA3D9,  0xA2C5,  // 0x1D4x
      0xA2C6,  0,       0xA456,  0x22D3,  0,       0,       0xA45A,  0xA458,  
      0,       0x22D2,  0,       0xA72E,  0x23F1,  0x23F8,  0x23F9,  0xA730,  // 0x1D5x
      0x23F6,  0x23F5,  0x23F7,  0x23F2,  0x23F3,  0xA731,  0xA72C,  0,       
      0,       0,       0,       0xA732,  0xA3F6,  0,       0xA3F7,  0xA3F9,  // 0x1D6x
      0xA3FA,  0xA3FB,  0xA3FE,  0xA4A1,  0,       0,       0xA72D,  0,       
      0xA72F,  0x237D,  0,       0xA3FD,  0,       0,       0,       0,       // 0x1D7x
      0,       0xA734,  0xA733,  0,       0x237C,  0,       0xA72B,  0,       
      0,       0,       0x23FA,  0x2630,  0x25F5,  0xAA75,  0x2633,  0xAA72,  // 0x1D8x
      0x25F3,  0x25F4,  0xAA7A,  0x25F1,  0xAA77,  0xAA7C,  0x25EF,  0xAA79,  
      0x25F2,  0x25F0,  0xAA74,  0xA735,  0xA6DC,  0xA6DD,  0xA6DE,  0xA6DF,  // 0x1D9x
      0xA6E0,  0xA6E1,  0xA6E3,  0xA6E4,  0,       0xA6E5,  0xA6E6,  0xA6E7,  
      0xA6E8,  0,       0xAA78,  0,       0xAD2B,  0,       0,       0,       // 0x1DAx
      0,       0xAA73,  0x25F6,  0xB050,  0xB04A,  0x28F8,  0xB04B,  0x28F9,  
      0x287E,  0x28FA,  0,       0xB046,  0,       0,       0,       0,       // 0x1DBx
      0xB049,  0xB052,  0,       0xAAC5,  0xAAC7,  0xAAC8,  0xAACB,  0xAACC,  
      0xAACD,  0xAACE,  0xAACF,  0xAAD0,  0xAAD1,  0xB04D,  0xB045,  0xB047,  // 0x1DCx
      0,       0xB051,  0,       0,       0xB04F,  0,       0,       0xB04C,  
      0xAACA,  0xAAC6,  0xB048,  0x28FB,  0x287C,  0x2DAC,  0x2DA9,  0x2C52,  // 0x1DDx
      0x2C59,  0x2DAA,  0xB721,  0x2C58,  0x2DB4,  0x2DB0,  0x2DAB,  0xB67D,  
      0x2DB1,  0x2DAD,  0x2DAF,  0xB724,  0xB67E,  0x2C62,  0xB679,  0x2C63,  // 0x1DEx
      0x2C56,  0xB725,  0xB722,  0,       0,       0xB723,  0xB67B,  0xAFA9,  
      0xAFAA,  0xAFAB,  0xAFAC,  0xAFAD,  0xAFAE,  0xAFAF,  0xAFB1,  0xAFB3,  // 0x1DFx
      0x2DA8,  0,       0,       0,       0,       0,       0,       0xAFB0,  
} ;


static const unsigned short Uni2cnsP2Table_1E [] = {
      0,       0,       0xAFB2,  0,       0,       0,       0,       0,       // 0x1E0x
      0x2DB3,  0x2C5D,  0x2DB5,  0,       0x2DB6,  0,       0x2DB2,  0,       
      0xBB4E,  0x313A,  0xBF2B,  0xBF24,  0xBF26,  0x313C,  0x313E,  0x31FE,  // 0x1E1x
      0xBE79,  0xBF22,  0xBE7B,  0x32A8,  0x3138,  0,       0xBF27,  0xBF2C,  
      0xBF29,  0xBE74,  0xBF2A,  0x3140,  0x313B,  0x31FC,  0x32A6,  0xBE73,  // 0x1E2x
      0x3136,  0x31FD,  0x32A4,  0,       0xBF28,  0,       0,       0,       
      0,       0,       0,       0,       0,       0xBF23,  0xB4BB,  0,       // 0x1E3x
      0xB4BC,  0xB4BD,  0xB4BE,  0xB4C0,  0xB4C1,  0xB4C2,  0xB4C3,  0xB4C4,  
      0xB4C6,  0xB4C7,  0xB4C8,  0xBE77,  0,       0,       0xB22A,  0,       // 0x1E4x
      0,       0,       0xBE7D,  0xBE7C,  0,       0xBE7E,  0,       0xBF21,  
      0,       0,       0xBF25,  0,       0x313F,  0,       0,       0,       // 0x1E5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x32A9,  0x32A1,  0x32A7,  0x32A3,  0,       0x32A2,  // 0x1E6x
      0x32A5,  0x32AA,  0x37E9,  0xC833,  0x37EE,  0xC82A,  0xC834,  0x37EF,  
      0x37EC,  0,       0x37EB,  0x3730,  0,       0x37F0,  0x37EA,  0x37F1,  // 0x1E7x
      0x37F2,  0x37F4,  0xC82E,  0xBE7A,  0x3731,  0xC82F,  0x37ED,  0,       
      0,       0,       0,       0,       0,       0,       0x3733,  0,       // 0x1E8x
      0x37E8,  0,       0x37F3,  0xBAD6,  0xBAD8,  0xBAD9,  0xBADA,  0xBADB,  
      0,       0,       0xC82D,  0,       0x37F5,  0,       0,       0,       // 0x1E9x
      0,       0xC832,  0xC82C,  0,       0,       0xC831,  0,       0,       
      0,       0xC830,  0,       0,       0xBADC,  0,       0,       0,       // 0x1EAx
      0,       0,       0,       0x3EF0,  0xD22D,  0x3EEC,  0x3C7A,  0x3EF1,  
      0xD22E,  0xDC3B,  0x3C7D,  0xD235,  0x3EEA,  0x3EF3,  0xD22B,  0x3EEF,  // 0x1EBx
      0,       0xD22C,  0xD239,  0xD230,  0xD238,  0x3EEE,  0xD236,  0xDC40,  
      0xC1B7,  0x3EF2,  0xC1B3,  0xC1B4,  0xC1B6,  0xC1B8,  0xC1B9,  0xD23A,  // 0x1ECx
      0,       0,       0,       0xD232,  0,       0xD237,  0,       0,       
      0,       0x3EEB,  0,       0,       0,       0xC1B5,  0,       0xD22F,  // 0x1EDx
      0x45C3,  0x45CB,  0x45C9,  0xDC41,  0xDC3C,  0x432B,  0x4326,  0x4325,  
      0x45C4,  0x45C8,  0x45C7,  0x45CA,  0x45CE,  0xDC3E,  0xDC47,  0x45CD,  // 0x1EEx
      0x45C5,  0x45C6,  0xDC42,  0,       0x4329,  0xDC46,  0x4327,  0x4323,  
      0x45CC,  0xDC45,  0xDC43,  0,       0xDC3F,  0x4328,  0xC7DE,  0xC7DF,  // 0x1EFx
      0xC7E0,  0xC7E1,  0,       0,       0,       0,       0xD231,  0,       
} ;


static const unsigned short Uni2cnsP2Table_1F [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x1F0x
      0,       0,       0x494E,  0xA2C9,  0x4952,  0xA2C5,  0x4CE9,  0,       
      0xA2D0,  0xA2CA,  0x4CEE,  0x4CE7,  0xA2C7,  0xA2D1,  0x4CEF,  0xA2CF,  // 0x1F1x
      0xA2CC,  0xA2CD,  0x4CF0,  0x4CEA,  0x4CED,  0xADC4,  0,       0,       
      0,       0,       0,       0,       0,       0xA2C6,  0xCED7,  0xCED8,  // 0x1F2x
      0xCED9,  0xCEDB,  0xCEDC,  0,       0,       0,       0,       0xA2C4,  
      0xA2CB,  0,       0,       0,       0,       0,       0xA2CE,  0,       // 0x1F3x
      0,       0,       0x4CEB,  0,       0xA2C8,  0x4951,  0x54B3,  0x5023,  
      0xADCA,  0x5024,  0x54B5,  0xADC2,  0x54B8,  0x54B4,  0x54B1,  0xADC7,  // 0x1F4x
      0xADC3,  0x5BB9,  0x54B2,  0,       0xD4BA,  0xD4BB,  0xD4BC,  0,       
      0xADC5,  0,       0,       0xADC9,  0xADC8,  0xADCB,  0,       0,       // 0x1F5x
      0xADC6,  0,       0xADCD,  0x54B7,  0x5629,  0x5BBB,  0x61D5,  0xB7E0,  
      0x5BBF,  0xB7E6,  0,       0x5BBA,  0xB7E2,  0xB7E4,  0xB7E1,  0x5BBD,  // 0x1F6x
      0,       0,       0,       0,       0xB7DF,  0xB7E5,  0xD9F9,  0xD9FA,  
      0xD9FB,  0,       0,       0,       0,       0x562A,  0,       0,       // 0x1F7x
      0xB7E3,  0,       0xB7E7,  0,       0,       0xB9A7,  0,       0,       
      0x5BC0,  0,       0xC6DA,  0,       0,       0x61D4,  0xBFC7,  0x5A7E,  // 0x1F8x
      0x61D1,  0x61D2,  0xBFC9,  0xDED9,  0x61D3,  0xBFC6,  0xDED8,  0,       
      0xBFC5,  0xBFC8,  0,       0,       0x61D6,  0x61D7,  0,       0,       // 0x1F9x
      0xC6DC,  0x5F5B,  0xC6DE,  0x67E5,  0x5F59,  0xC6DD,  0xC6DF,  0xC6E0,  
      0,       0,       0xE2B0,  0xE2B1,  0xE2B2,  0,       0xC6E1,  0xC6E2,  // 0x1FAx
      0,       0xC6DB,  0,       0,       0,       0,       0x6338,  0xCDD5,  
      0x6337,  0x6BFE,  0xCDD7,  0,       0,       0,       0xE5A9,  0xCDD6,  // 0x1FBx
      0,       0,       0,       0x5BBE,  0x6FF8,  0x6FFA,  0x6FF9,  0,       
      0,       0xD3B2,  0,       0,       0,       0,       0xD3B1,  0x73BB,  // 0x1FCx
      0x6869,  0x686A,  0xD7E7,  0xD7E9,  0xD7E8,  0,       0,       0xD7EA,  
      0,       0x73BC,  0,       0,       0xDEDE,  0x6B6A,  0x6B69,  0,       // 0x1FDx
      0xDEE0,  0,       0,       0x77D8,  0xDEDF,  0x79A7,  0,       0xECA6,  
      0x7AA8,  0x7AE6,  0x7BBC,  0xE3CF,  0,       0x7CB4,  0,       0xA16D,  // 0x1FEx
      0x2125,  0x2262,  0x22D4,  0xA45B,  0xA45C,  0x22D5,  0xA37E,  0x237E,  
      0x23FB,  0xAA7D,  0xA6EA,  0xA6E9,  0,       0,       0,       0xB055,  // 0x1FFx
      0xB054,  0xB056,  0,       0xB053,  0,       0xB726,  0x32AB,  0x3141,  
} ;


static const unsigned short Uni2cnsP2Table_20 [] = {
      0xBF2D,  0x37F6,  0xDC48,  0xA2D2,  0x54B9,  0xCEDD,  0xD4BD,  0xB7E8,  // 0x200x
      0xBFCA,  0xC6E3,  0x67E6,  0,       0,       0,       0xDEE1,  0,       
      0xE5B5,  0xA16F,  0xA171,  0xA170,  0xA1BB,  0,       0,       0,       // 0x201x
      0x21E8,  0x21E7,  0,       0,       0x23FC,  0xA737,  0,       0xA6EB,  
      0xB057,  0xB728,  0xAFB4,  0xBF2E,  0xBADE,  0,       0,       0,       // 0x202x
      0,       0xA2D3,  0,       0,       0,       0,       0,       0xC6E4,  
      0,       0,       0,       0,       0xA274,  0,       0x22D6,  0xAA7E,  // 0x203x
      0,       0xB059,  0,       0xB058,  0,       0,       0,       0x2C65,  
      0xBF2F,  0x35DF,  0x32AD,  0xBF30,  0x32AC,  0xC836,  0xBADF,  0xBAE0,  // 0x204x
      0xBAE1,  0,       0,       0,       0xA2D4,  0,       0,       0,       
      0xBFCB,  0,       0x2177,  0xA275,  0xA276,  0x22D9,  0x22D8,  0x2264,  // 0x205x
      0x22DB,  0xA461,  0xA460,  0xA45E,  0xA2C8,  0,       0,       0xA2CA,  
      0,       0,       0x22D7,  0xA45F,  0x22DA,  0xA741,  0xA73B,  0x24A2,  // 0x206x
      0xA738,  0x23FE,  0x23FD,  0,       0x24A3,  0xA740,  0x24A4,  0xA73C,  
      0xA73F,  0x24A1,  0xA4A4,  0xA739,  0xA73A,  0xA73D,  0,       0,       // 0x207x
      0,       0x24A5,  0xA73E,  0x25FB,  0x2635,  0x25F9,  0x25FD,  0x25FA,  
      0x25FC,  0x26A1,  0xAB23,  0x25FE,  0,       0,       0x26A2,  0xAB22,  // 0x208x
      0xA6EC,  0,       0x26A3,  0xAB21,  0,       0x25F7,  0,       0x25F8,  
      0x28FE,  0xB062,  0x28FD,  0x29A2,  0x28FC,  0x29A3,  0xB05F,  0x29A5,  // 0x209x
      0x29A4,  0,       0xB05B,  0,       0,       0x29A1,  0xB05A,  0xB065,  
      0xB067,  0xAAD3,  0xAAD4,  0xAAD5,  0,       0x2926,  0xB061,  0,       // 0x20Ax
      0,       0xB060,  0xB05C,  0xB05D,  0xB066,  0,       0xB064,  0xB05E,  
      0,       0x2DB8,  0xB732,  0,       0x2DB7,  0xB72E,  0x2DB9,  0x32AE,  // 0x20Bx
      0xB72A,  0x2C69,  0x2C6A,  0xB72F,  0x2DBA,  0xB72D,  0xB731,  0xB730,  
      0x2C67,  0xB733,  0xB734,  0xAFB6,  0xAFB5,  0,       0xB729,  0,       // 0x20Cx
      0,       0,       0,       0xB72B,  0xBF35,  0x32B5,  0x3146,  0x3143,  
      0x3144,  0x32B3,  0x32AF,  0xBF3A,  0x32B0,  0x32B4,  0xBF3C,  0x32B1,  // 0x20Dx
      0x32B6,  0xBF36,  0xBF3B,  0xBF32,  0x32B2,  0xBF34,  0xB4C9,  0xB4CA,  
      0xB4CB,  0xB4CC,  0,       0xBF39,  0xBF31,  0,       0,       0xBF3D,  // 0x20Ex
      0xBF37,  0,       0xBF33,  0xC839,  0x373E,  0xC83E,  0x37F9,  0x37FA,  
      0x3738,  0x37F8,  0xC83A,  0x3737,  0x38A1,  0x38A2,  0xBF38,  0xC840,  // 0x20Fx
      0xC83D,  0xC83B,  0x37FD,  0xC838,  0,       0xBAE2,  0xBAE3,  0,       
} ;


static const unsigned short Uni2cnsP2Table_21 [] = {
      0,       0xC83F,  0,       0,       0x37FB,  0x37F7,  0xC841,  0x37FE,  // 0x210x
      0xC0AB,  0,       0x3EF8,  0x3D22,  0x45D2,  0x3D25,  0x3EF5,  0x3EF4,  
      0x3D24,  0,       0,       0x3EF7,  0x3EFA,  0xD23E,  0xD23B,  0xD23D,  // 0x211x
      0xDC4B,  0,       0x3EFB,  0xD23C,  0x3EF6,  0,       0x3EF9,  0xDC4C,  
      0xDC4D,  0x45D8,  0x4334,  0x45CF,  0x45D5,  0xDC4A,  0x45D4,  0x45D7,  // 0x212x
      0,       0,       0,       0xC7E2,  0,       0,       0,       0,       
      0x45D9,  0x45D0,  0x45D6,  0x45D1,  0xA2D7,  0xA2D9,  0x4CF4,  0x4CF3,  // 0x213x
      0x4CF5,  0x4957,  0x4CF6,  0,       0x4CF8,  0x4956,  0xA2D6,  0xA2D5,  
      0,       0,       0xA2D8,  0,       0,       0,       0,       0,       // 0x214x
      0,       0x4CF7,  0x4CF9,  0x4CF2,  0,       0xADD0,  0x54BE,  0xADD2,  
      0xADD8,  0x54BD,  0x5028,  0xADD7,  0xADD6,  0x54BB,  0xADD1,  0x54BC,  // 0x215x
      0,       0xADD4,  0x54BF,  0xADCF,  0,       0,       0x502A,  0x5BC1,  
      0x5BC2,  0x562C,  0xB7EB,  0xD9FC,  0,       0,       0xB7E9,  0,       // 0x216x
      0xB7EA,  0x61DA,  0x61D9,  0x61D8,  0,       0xC6E6,  0x5F5D,  0x67E7,  
      0x5F5C,  0xC6E5,  0xC6E7,  0,       0,       0x67E8,  0xE2B3,  0,       // 0x217x
      0xCDD8,  0x6CA1,  0,       0xD3B3,  0xD7EC,  0x6FFB,  0x73BD,  0xD7EB,  
      0,       0,       0,       0xDEE2,  0xDEE3,  0x77D9,  0,       0xE3D0,  // 0x218x
      0xE3F5,  0x2178,  0xA742,  0x24A6,  0,       0x2426,  0xAB24,  0xA6ED,  
      0xA6EE,  0xB069,  0xB068,  0xAAD6,  0,       0,       0,       0,       // 0x219x
      0,       0xB735,  0x32B7,  0xC842,  0x38A3,  0,       0,       0xD23F,  
      0,       0,       0x45DA,  0,       0xC7E4,  0,       0,       0,       // 0x21Ax
      0,       0,       0,       0,       0xCDD9,  0,       0xEACE,  0xA172,  
      0,       0xA173,  0xA278,  0x21E9,  0xA277,  0xA1E2,  0x2267,  0x2427,  // 0x21Bx
      0x24A7,  0xA4A6,  0,       0xA95E,  0xAB25,  0x26A4,  0x26A5,  0xB06A,  
      0xB041,  0x2F27,  0,       0,       0,       0,       0xB736,  0x314A,  // 0x21Cx
      0,       0,       0xC843,  0x3EFC,  0x45DB,  0xA2DB,  0xC7E5,  0xDC4E,  
      0xCEDF,  0xA2DC,  0xA2DD,  0,       0x5626,  0,       0xD7ED,  0x2268,  // 0x21Dx
      0x22DE,  0xA464,  0x22DD,  0xA463,  0xA462,  0xA466,  0x2269,  0,       
      0xA465,  0,       0,       0xA745,  0x24AA,  0x24AC,  0x24AB,  0x24A8,  // 0x21Ex
      0x24A9,  0xA744,  0xA748,  0xAB28,  0,       0xA743,  0,       0xA746,  
      0x24AD,  0,       0x26AC,  0x26A8,  0x26A7,  0x26AB,  0x26AA,  0x2639,  // 0x21Fx
      0xAB26,  0xAB29,  0xAB27,  0x263E,  0xAB2A,  0xA6F0,  0xA6F1,  0xA6F2,  
} ;


static const unsigned short Uni2cnsP2Table_22 [] = {
      0xA6F3,  0xA6F4,  0x26A9,  0,       0x26AD,  0xAB2B,  0,       0x29A8,  // 0x220x
      0x29AA,  0x2927,  0xB06C,  0x29A9,  0xB06D,  0xAAD7,  0xAAD9,  0xAAD8,  
      0xAADA,  0xAADB,  0xAADC,  0,       0,       0,       0,       0xB06B,  // 0x221x
      0,       0x2DBD,  0x2DC0,  0x2DBE,  0x2DC1,  0x2DBB,  0xB73A,  0xB73B,  
      0x2C6E,  0x2DC2,  0x2DBF,  0xB73C,  0x2DBC,  0xB739,  0,       0,       // 0x222x
      0xAFB7,  0,       0,       0,       0xB737,  0xB738,  0,       0,       
      0,       0,       0x2CFB,  0x32C4,  0x32BB,  0x32B9,  0x314D,  0xBF43,  // 0x223x
      0x32C2,  0xBF48,  0xBF3E,  0x32BD,  0x32BC,  0x32BF,  0x32BE,  0xBF3F,  
      0xBF40,  0x32C1,  0x32B8,  0x3150,  0xBF44,  0x32C3,  0x38A8,  0,       // 0x224x
      0xBF41,  0,       0xB4CD,  0xB4CE,  0xB4CF,  0xB4D0,  0xB4D1,  0xB4D2,  
      0xB4D3,  0,       0,       0,       0,       0xBF47,  0xC63D,  0,       // 0x225x
      0x32BA,  0xBF42,  0x32C0,  0xC84A,  0x314B,  0x38AB,  0x38AC,  0x38AD,  
      0xC84B,  0xC84E,  0x38A7,  0xC84D,  0x3742,  0x38AA,  0x38A6,  0xC849,  // 0x226x
      0x3743,  0x38A5,  0xD244,  0xC846,  0xC847,  0x38A4,  0xBAE5,  0xBAE7,  
      0xBAE8,  0xBAE9,  0xBAEA,  0,       0xC848,  0,       0xC84C,  0,       // 0x227x
      0,       0,       0,       0,       0xBAE6,  0,       0,       0x3D2B,  
      0x3FA5,  0x3D2C,  0xD241,  0xD242,  0x3FA2,  0x3FA3,  0xD247,  0x3EFD,  // 0x228x
      0,       0xD245,  0xC1BA,  0xC1BB,  0xC1BC,  0,       0xD243,  0,       
      0xD248,  0,       0x3FA4,  0x3EFE,  0xD246,  0x4338,  0x45DC,  0x4337,  // 0x229x
      0x45DE,  0xDC50,  0,       0x45E0,  0x45DF,  0xDC4F,  0xC7E7,  0xC7E8,  
      0xC7E9,  0xC7EA,  0xC7EB,  0xC7EC,  0xC7ED,  0xC7EE,  0xC7EF,  0,       // 0x22Ax
      0xDC51,  0,       0xE031,  0,       0xCAD4,  0xA2DE,  0x495A,  0x373F,  
      0x4958,  0x4CFA,  0x4959,  0xADD9,  0xA2E2,  0x4CFC,  0x4CFE,  0xCEE0,  // 0x22Bx
      0xCEE2,  0xCEE3,  0xA2DF,  0xA2E1,  0xA2E3,  0,       0,       0,       
      0,       0xA2E0,  0x4CFB,  0x54C1,  0x4CFD,  0x54C3,  0x54C0,  0x502D,  // 0x22Cx
      0,       0,       0,       0,       0x54C4,  0xD4BF,  0xD4C0,  0xD4C1,  
      0xD4C2,  0xB7EE,  0x5BC4,  0xB7EC,  0xB7ED,  0xD9FE,  0xDAA1,  0xDAA2,  // 0x22Dx
      0xDAA3,  0,       0x5BC3,  0,       0xB7EF,  0x5BC5,  0,       0,       
      0,       0xBFD1,  0xBFCE,  0x61DB,  0xDEDA,  0xDEDC,  0xBFCD,  0xBFCF,  // 0x22Ex
      0,       0,       0xBFCC,  0xDEDB,  0,       0xBFD0,  0,       0xC6E8,  
      0xC6E9,  0x61DC,  0x67E9,  0,       0,       0xE2B4,  0xE2B5,  0xE2B6,  // 0x22Fx
      0x67EA,  0,       0,       0x6CA4,  0x6CA3,  0xCDDD,  0xCDDB,  0x6CA2,  
} ;


static const unsigned short Uni2cnsP2Table_23 [] = {
      0xCDDA,  0,       0xCDDC,  0xCDDE,  0x663C,  0,       0xD3B4,  0xD3E1,  // 0x230x
      0x73BE,  0xD7EE,  0,       0xD7EF,  0,       0x75EA,  0,       0xEACF,  
      0,       0xDBCD,  0xDEE4,  0xE2B6,  0x7AE8,  0x7AE7,  0xECFB,  0xA1E3,  // 0x231x
      0xA2CB,  0xA2CC,  0,       0xAB2C,  0xA4A7,  0xAB2D,  0xAB2E,  0,       
      0xAFB9,  0,       0xAFBB,  0xAFBC,  0,       0xAFBA,  0x32C5,  0xB4D4,  // 0x232x
      0xC84F,  0xBAEB,  0xBAEC,  0x3FA6,  0xA13F,  0xA175,  0,       0xA279,  
      0,       0xA749,  0,       0x242A,  0xB070,  0xA74D,  0xA4A8,  0,       // 0x233x
      0xA74B,  0,       0xA74E,  0x263F,  0xAB30,  0x26AE,  0xAB31,  0xAAB9,  
      0,       0x2741,  0xB523,  0xB072,  0xB073,  0xB071,  0xB06F,  0,       // 0x234x
      0,       0,       0xB06E,  0,       0,       0xB73F,  0xB73E,  0x2C6F,  
      0xB73D,  0,       0xB740,  0,       0xBF49,  0xBF4A,  0xBF4B,  0xBF4C,  // 0x235x
      0xBF4D,  0xBF4E,  0x3744,  0xC850,  0xC854,  0xC853,  0xC851,  0xBAED,  
      0xC852,  0,       0xD249,  0x3FA7,  0xC1BD,  0,       0xDC53,  0xDC54,  // 0x236x
      0xDC52,  0,       0,       0x45E1,  0xA2E4,  0,       0xADDA,  0xADDC,  
      0x502F,  0x54C5,  0xB7F1,  0xB7F0,  0,       0,       0xD7F0,  0xE3D1,  // 0x237x
      0xE3D2,  0xE5B6,  0xA140,  0xA176,  0,       0,       0xA2CD,  0x242B,  
      0xA750,  0xA74F,  0,       0x24AE,  0xAB32,  0,       0xB076,  0xB075,  // 0x238x
      0,       0,       0xB077,  0,       0x2EE8,  0xBF4F,  0x38AE,  0,       
      0xD24A,  0xDC55,  0xA2E5,  0xADDD,  0,       0,       0,       0,       // 0x239x
      0x21AA,  0x21C7,  0xA178,  0,       0xA17C,  0xA177,  0,       0xA17A,  
      0xA17B,  0,       0xA321,  0xA322,  0xA27C,  0xA27A,  0xA323,  0xA27B,  // 0x23Ax
      0xA27D,  0xA27E,  0x21EA,  0x22E0,  0,       0x22DF,  0,       0,       
      0xA468,  0xA469,  0xA46A,  0,       0,       0,       0xA46B,  0x24AF,  // 0x23Bx
      0xA751,  0x24B1,  0xA753,  0x24B0,  0xA4A9,  0,       0xA4AA,  0xA4AB,  
      0xA4AC,  0xA752,  0,       0,       0,       0x24B2,  0x26AF,  0xAB36,  // 0x23Cx
      0xAB33,  0xAB34,  0,       0,       0,       0,       0,       0,       
      0,       0,       0xAB37,  0xAB35,  0xB07E,  0x29AC,  0xB07D,  0x2930,  // 0x23Dx
      0xB079,  0x29AB,  0xB078,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x2DC4,  0,       0x2DC3,  0x2DC5,  // 0x23Ex
      0xB743,  0xB741,  0x2DC6,  0xAFBD,  0xB742,  0,       0x32CA,  0x32C8,  
      0x32C9,  0xBF56,  0xBF50,  0x292F,  0xC855,  0xBF52,  0xBF53,  0x32C7,  // 0x23Fx
      0xBF51,  0xB4D5,  0xB4D6,  0xB4D7,  0xBF54,  0xBF57,  0xBF55,  0,       
} ;


static const unsigned short Uni2cnsP2Table_24 [] = {
      0xC856,  0xC859,  0x38AF,  0x38B2,  0x38B1,  0xC85A,  0x38B0,  0xC858,  // 0x240x
      0xC857,  0,       0x3FA8,  0x3D31,  0xD24B,  0xC1C0,  0,       0xD24C,  
      0,       0,       0x45E2,  0xDC56,  0x45E3,  0xDC57,  0xDC59,  0,       // 0x241x
      0xC7F0,  0xDC5A,  0,       0,       0,       0xDC58,  0x4DA1,  0x4DA2,  
      0x4960,  0xA2E6,  0xCEE4,  0xCEE5,  0xA2E7,  0xADDF,  0x54C6,  0x5030,  // 0x242x
      0xADE0,  0xADDE,  0,       0,       0xB7F3,  0xB7F2,  0,       0xB7F4,  
      0xDAA4,  0,       0x5B22,  0x61DE,  0xBFD2,  0xDEDD,  0,       0x61DD,  // 0x243x
      0xC6ED,  0xC6EB,  0xC6EF,  0xC6EA,  0xC6EC,  0,       0x67EB,  0x6CA5,  
      0xCDDF,  0x5F5F,  0xCDE1,  0xCDE0,  0x6CA6,  0,       0x6FFC,  0x6FFD,  // 0x244x
      0x663D,  0xD3B5,  0x73BF,  0xE0BC,  0xE0EF,  0xE4C6,  0,       0,       
      0xA46E,  0xA46C,  0xA46D,  0x24B3,  0xB121,  0xAB38,  0xAD32,  0xB124,  // 0x245x
      0xB744,  0xB122,  0xB123,  0xB746,  0xB745,  0,       0xBF58,  0,       
      0,       0xCF21,  0x38B3,  0xC85C,  0xC85B,  0,       0x3FAA,  0,       // 0x246x
      0xDC5C,  0xDC5F,  0xDC5D,  0xDC5B,  0,       0xDC5E,  0,       0xADE1,  
      0xADCE,  0x5032,  0xB7F5,  0xBFD5,  0,       0xBFD4,  0xBFD3,  0xC6F2,  // 0x247x
      0xC6F0,  0xC6F1,  0,       0,       0,       0xD7F1,  0xDBCE,  0xE2B7,  
      0xA325,  0xA324,  0xA1E4,  0xA471,  0xA46F,  0,       0,       0xA4AD,  // 0x248x
      0xA754,  0x26B0,  0xAB3B,  0,       0xAB3A,  0,       0,       0xB747,  
      0x2C74,  0x2C73,  0,       0,       0x35E0,  0xBF5D,  0xBF59,  0xBF5A,  // 0x249x
      0xB4D8,  0xB4D9,  0xB4DA,  0xBF5C,  0xBF5B,  0x32CB,  0xC85D,  0xC860,  
      0xC85E,  0xC85F,  0xBAEE,  0,       0xD251,  0xD24E,  0xD250,  0xD24F,  // 0x24Ax
      0xC1C1,  0x433C,  0xDC60,  0xA2EB,  0xA2EC,  0xA2E9,  0xA2EA,  0x4DA3,  
      0x5033,  0,       0x54C7,  0xADE4,  0xB7F6,  0xBFD6,  0xE7D4,  0xCDE2,  // 0x24Bx
      0xD3B6,  0x73C1,  0,       0xECA7,  0,       0xA17D,  0x21EB,  0x2179,  
      0x22E1,  0,       0x226E,  0x22E2,  0x24B4,  0xA758,  0x24B5,  0xA757,  // 0x24Cx
      0xA759,  0xA75B,  0xA756,  0x24B6,  0,       0,       0,       0xA755,  
      0xA75A,  0,       0x26B3,  0xAB3D,  0x26B1,  0xAB3C,  0x26B2,  0x29AD,  // 0x24Dx
      0xAB3F,  0,       0,       0,       0x2933,  0xB126,  0x29B0,  0x29AE,  
      0xB128,  0,       0x29B2,  0x29B1,  0,       0xAADE,  0,       0,       // 0x24Ex
      0,       0xB127,  0xB74D,  0x2C79,  0x2C77,  0x2C7C,  0x2C75,  0x2DCB,  
      0x2DC9,  0x2C78,  0x2C7A,  0x2C76,  0x2C7B,  0x2DCA,  0xB749,  0xB74F,  // 0x24Fx
      0xB74C,  0xAFBF,  0xAFC0,  0,       0xB74B,  0xB750,  0xB74E,  0,       
} ;


static const unsigned short Uni2cnsP2Table_25 [] = {
      0xB74A,  0x3156,  0x32CF,  0xBF68,  0xBF61,  0,       0x32CC,  0x32D1,  // 0x250x
      0x32CE,  0xBF60,  0x32D0,  0x3158,  0xBF67,  0xBF65,  0xBF62,  0x3159,  
      0xBF66,  0x32CD,  0,       0,       0,       0,       0,       0,       // 0x251x
      0xBF64,  0,       0xBF5F,  0,       0xBF63,  0xC864,  0xB4DC,  0x3746,  
      0x38B6,  0x38B5,  0x38BB,  0x38BA,  0x38B7,  0x3747,  0xC861,  0x38B4,  // 0x252x
      0xC863,  0x38B8,  0x3155,  0xBAF0,  0,       0xC862,  0,       0,       
      0xBAEF,  0x38B9,  0,       0x3FAC,  0x3FAB,  0xD252,  0xD254,  0xD257,  // 0x253x
      0xD253,  0,       0,       0xC1C2,  0xC1C3,  0xC1C4,  0xC1C5,  0xC1C6,  
      0xC1C7,  0,       0,       0xD255,  0,       0,       0,       0xD256,  // 0x254x
      0xD66C,  0,       0,       0,       0,       0x3FAD,  0x3D32,  0xDC66,  
      0xDC63,  0x45E6,  0xDC62,  0x433E,  0x45E5,  0x4341,  0x4340,  0xDC61,  // 0x255x
      0x45E8,  0x45EA,  0x45E4,  0xDC68,  0xDC69,  0xDC6A,  0x45E7,  0xDC64,  
      0xC7F1,  0xC7F2,  0xC7F3,  0xC7F4,  0xC7F5,  0,       0,       0xDC65,  // 0x256x
      0,       0,       0x4964,  0x4DA4,  0x5BC8,  0x4963,  0x4962,  0x4DA5,  
      0xA2ED,  0xA2EF,  0,       0xCEE6,  0xCEE7,  0,       0xA2EE,  0xA2F0,  // 0x257x
      0,       0xADE5,  0x54C8,  0x54CA,  0xADE7,  0,       0xADE6,  0,       
      0,       0xD4C4,  0xD4C5,  0xADE8,  0x54C9,  0,       0,       0,       // 0x258x
      0x5BC7,  0xB7F7,  0x5630,  0,       0,       0xDCDF,  0x5BC6,  0x61E0,  
      0xBFD7,  0x61DF,  0xBFD8,  0xDEDE,  0,       0,       0,       0x61E1,  // 0x259x
      0xC6F3,  0xC6F5,  0xC6F6,  0xCDA2,  0xC6F4,  0x6CA7,  0x633E,  0x633D,  
      0xE5AA,  0,       0xCDE3,  0xD3B7,  0x6FFE,  0xD7F2,  0x6A47,  0x79A8,  // 0x25Ax
      0,       0x21B1,  0xA221,  0x226F,  0x21EC,  0xA326,  0,       0,       
      0xA2CF,  0,       0xA475,  0x22E3,  0xA760,  0x22E9,  0xA75D,  0x22E4,  // 0x25Bx
      0xA473,  0xA474,  0x22E5,  0xA75C,  0,       0xA75E,  0,       0,       
      0,       0xA761,  0,       0xA472,  0,       0,       0,       0x22E8,  // 0x25Cx
      0x24B7,  0x24B9,  0x2645,  0xA766,  0xA764,  0xAB46,  0xA767,  0,       
      0xAB40,  0xA762,  0xA763,  0xAB44,  0xA765,  0xA768,  0,       0xA5FE,  // 0x25Dx
      0xA769,  0,       0,       0x24BA,  0xA4AE,  0xA4AF,  0xA4B1,  0xA4B2,  
      0xA4B4,  0xA4B5,  0xA4B6,  0xA6F7,  0xA6F8,  0xA6F9,  0xA6FA,  0xA6FB,  // 0x25Ex
      0xA6FD,  0xA6FE,  0xA7A1,  0xA6FC,  0xAB45,  0,       0xAB41,  0,       
      0,       0xAB42,  0x242D,  0,       0,       0xA4B0,  0,       0,       // 0x25Fx
      0,       0x2644,  0x26B4,  0xAB43,  0,       0,       0,       0x2647,  
} ;


static const unsigned short Uni2cnsP2Table_26 [] = {
      0xAB4C,  0x2947,  0xB12F,  0x264B,  0xAB4D,  0xB129,  0x26B5,  0xB12C,  // 0x260x
      0xAB4F,  0x264A,  0x26B7,  0x2938,  0x26B6,  0x2943,  0xAB49,  0x26B8,  
      0x2651,  0x2944,  0xB12A,  0xB12B,  0xAB50,  0xAB47,  0xB12D,  0,       // 0x261x
      0,       0,       0xA6F5,  0,       0,       0xA7A2,  0xAAF0,  0,       
      0x2946,  0,       0,       0xB12E,  0,       0,       0xAB48,  0xAB4A,  // 0x262x
      0xAB4E,  0,       0xAB4B,  0xAAE4,  0,       0,       0,       0xAADF,  
      0xAAE2,  0xAAE5,  0xAAE8,  0xAAEC,  0xB75B,  0xB759,  0xB132,  0x2949,  // 0x263x
      0x29B7,  0,       0x2942,  0x2D29,  0x2DCE,  0x29B6,  0xB139,  0xB757,  
      0xB133,  0x2C7D,  0x2DCC,  0xB135,  0xB753,  0x2D21,  0xB138,  0x29B4,  // 0x264x
      0x2C7E,  0xB13A,  0xB131,  0xB137,  0xB756,  0xB755,  0x2D2A,  0,       
      0,       0,       0,       0,       0,       0,       0xB134,  0xAAE1,  // 0x265x
      0xAAE6,  0xAAE9,  0xAAEB,  0xAAED,  0xAAEE,  0xAAEF,  0xAFC6,  0xAFC7,  
      0xAFC8,  0xAFCA,  0xB752,  0xAFC4,  0,       0,       0xB758,  0,       // 0x266x
      0xAAE3,  0,       0,       0,       0,       0,       0x2DCD,  0,       
      0xB751,  0x2DD2,  0x2DD8,  0x2DDB,  0xBF6D,  0xB763,  0xBF6F,  0xBF6B,  // 0x267x
      0xBF70,  0xB764,  0x2DD5,  0xBF69,  0x2D2E,  0xBF73,  0x2DD6,  0x2D26,  
      0x32DD,  0x2DD1,  0x2DDC,  0xB762,  0xB75D,  0x32D4,  0xB75F,  0xB761,  // 0x268x
      0xBF6C,  0xB760,  0xBF71,  0x2D27,  0x2DD0,  0xB75C,  0x32D3,  0xBF72,  
      0xBF74,  0x32D2,  0,       0,       0,       0,       0,       0x2DCF,  // 0x269x
      0,       0xAFC1,  0xAFC2,  0xAFC3,  0xAFC9,  0xAFCB,  0xB4DD,  0xB4DF,  
      0xB4E0,  0xB4E4,  0xB4E5,  0xB4E6,  0xB4E7,  0xB4E8,  0xBF6A,  0,       // 0x26Ax
      0,       0,       0,       0,       0,       0,       0,       0xB765,  
      0xB766,  0,       0,       0,       0,       0,       0,       0,       // 0x26Bx
      0,       0,       0x2DD4,  0x2DD9,  0,       0,       0,       0,       
      0,       0x375A,  0xC871,  0x374D,  0x32D9,  0xBF7C,  0x374B,  0xC873,  // 0x26Cx
      0xC869,  0x38D5,  0xBF7E,  0xC872,  0xC022,  0x3165,  0x2DD3,  0x316D,  
      0xBF77,  0xC86E,  0x3161,  0x38BF,  0x32D7,  0x32DA,  0x374C,  0xBF79,  // 0x26Dx
      0x32DC,  0xBF76,  0xBF6E,  0x3169,  0x38BC,  0xC870,  0x32DE,  0x315F,  
      0xBF7D,  0xBF7B,  0xBF7A,  0xC866,  0xC86C,  0x38BE,  0x38C1,  0xC874,  // 0x26Ex
      0x32D5,  0xC86B,  0xC876,  0xC867,  0xC865,  0xBF75,  0x38C0,  0,       
      0xB4E1,  0,       0,       0,       0,       0,       0,       0xB4DE,  // 0x26Fx
      0xB4E2,  0xB4E3,  0xB4E9,  0xB4EA,  0xB4EB,  0xB4EC,  0xB4ED,  0xB4EF,  
} ;


static const unsigned short Uni2cnsP2Table_27 [] = {
      0xB4F0,  0xB4F2,  0xBAF2,  0xBAF3,  0xBAF4,  0xBAF5,  0xBAF6,  0xBAF7,  // 0x270x
      0xBAF9,  0xBAFA,  0xBAFC,  0xBAFD,  0xBAFE,  0xBBA1,  0xBBA2,  0xBBA5,  
      0xBBA9,  0xBBAA,  0xBBAC,  0xBBAE,  0,       0,       0xC868,  0x32D6,  // 0x271x
      0,       0,       0xBF78,  0xBBA7,  0,       0,       0,       0xB4EE,  
      0,       0,       0,       0xC924,  0xC86D,  0xC021,  0,       0xBBA4,  // 0x272x
      0x3D3F,  0x38CA,  0x38CD,  0x38D2,  0x374F,  0x3757,  0x3751,  0xD25D,  
      0xC923,  0x38D0,  0xC922,  0x3753,  0x38D6,  0x38D8,  0x38C3,  0xD261,  // 0x273x
      0x38DA,  0x3FB3,  0x375B,  0x38D3,  0xC921,  0x38C6,  0xC87B,  0x3FB4,  
      0x38C4,  0x38D4,  0x32DF,  0xD258,  0x38C7,  0x3D36,  0x3758,  0x38D9,  // 0x274x
      0x38D1,  0x38CB,  0x3FB1,  0xC877,  0x38CF,  0x38BD,  0xC87E,  0xD262,  
      0xD263,  0xD25A,  0xC87D,  0x38D7,  0xD25E,  0xD260,  0,       0x3FAF,  // 0x275x
      0,       0,       0,       0,       0,       0x3D40,  0x3752,  0x38C9,  
      0xC879,  0xBAF1,  0xBAFB,  0xBBA3,  0xBBA8,  0xBBAD,  0xC1C8,  0xC1CE,  // 0x276x
      0xC1D0,  0xC1D1,  0xC1D2,  0,       0,       0xD25C,  0xD25F,  0,       
      0,       0,       0xD25B,  0,       0,       0,       0,       0,       // 0x277x
      0,       0,       0,       0,       0,       0xC87A,  0,       0,       
      0,       0xBBAB,  0,       0,       0,       0,       0,       0x38CE,  // 0x278x
      0,       0x3FAE,  0x38CC,  0,       0xB4F1,  0xC7FD,  0x3FBC,  0x3FB6,  
      0x3FB5,  0xD26B,  0x4DA6,  0x3FC5,  0xDC6F,  0x3FB9,  0x3FBF,  0x3FC4,  // 0x279x
      0xDC74,  0xD26F,  0x45EB,  0,       0x3FBB,  0xDC6C,  0xD265,  0x3FB8,  
      0x3FBD,  0x3FBA,  0xD259,  0x496E,  0xDC76,  0xDC79,  0x3FC3,  0xD268,  // 0x27Ax
      0xDC72,  0x434F,  0xDC78,  0xDC77,  0x3FC1,  0x45ED,  0x3FBE,  0xDC71,  
      0xDC6E,  0xDC6D,  0x3FB7,  0xD267,  0,       0,       0xD26D,  0xC1CA,  // 0x27Bx
      0xC1CB,  0xC1CC,  0xC1CD,  0xC1CF,  0xC1D3,  0xC7F6,  0xC7F7,  0xC7F9,  
      0xC7FA,  0xC8A5,  0xC8A8,  0xDC70,  0xDC75,  0,       0,       0,       // 0x27Cx
      0,       0,       0x3FC0,  0xC1C9,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Dx
      0,       0,       0,       0,       0xDC73,  0xD26E,  0,       0,       
      0xDD23,  0xDD27,  0x4345,  0x4344,  0x4DA7,  0,       0xDC7C,  0x45F7,  // 0x27Ex
      0x45F6,  0x45F3,  0x3D35,  0xDC7B,  0xA2F2,  0,       0xA2F5,  0x4DA9,  
      0x45F0,  0x45EF,  0x45EC,  0x45F1,  0x45F2,  0x45F9,  0xDD25,  0xDC7D,  // 0x27Fx
      0xDC7E,  0xD26A,  0xDD22,  0xA2F4,  0xDD21,  0xA2F7,  0x45F4,  0x45F8,  
} ;


static const unsigned short Uni2cnsP2Table_28 [] = {
      0xADEA,  0,       0,       0,       0,       0,       0,       0,       // 0x280x
      0,       0,       0x4353,  0xC7F8,  0xC7FC,  0xC7FE,  0xC8A1,  0xC8A3,  
      0xC8A4,  0xC8A6,  0xCEE9,  0xCEEA,  0xCEEB,  0xCEEC,  0xCEED,  0xCEEE,  // 0x281x
      0xCEEF,  0xCEF3,  0xCEF5,  0,       0xA2F3,  0,       0xA2F8,  0xDC6B,  
      0x45EE,  0xDC7A,  0,       0,       0,       0,       0,       0,       // 0x282x
      0,       0,       0,       0,       0x4DA8,  0,       0x45F5,  0,       
      0,       0xADF1,  0x4966,  0x4352,  0xADEB,  0x4971,  0xADED,  0x4DAF,  // 0x283x
      0xADF3,  0x496A,  0x4DAE,  0xA2F9,  0x4DB3,  0x4972,  0xADF5,  0x38C5,  
      0x4DB2,  0x4DB5,  0x5035,  0x5036,  0xA3A1,  0x4DB4,  0xB7FC,  0x4DB0,  // 0x284x
      0x54CE,  0x5634,  0xA2FA,  0xA3A2,  0,       0,       0x54D4,  0x4DAB,  
      0x4DAD,  0x54CD,  0x4DAC,  0xAEA2,  0xADF7,  0xADF6,  0xA2FE,  0x503C,  // 0x285x
      0xADF0,  0xADEF,  0,       0,       0,       0,       0xC8A2,  0,       
      0,       0xCEF0,  0xADF2,  0,       0x4DB1,  0xADEC,  0xCEF1,  0xCEF2,  // 0x286x
      0xCEF4,  0xCEF6,  0xD4C7,  0xD4C8,  0xD4CA,  0xD4CB,  0xD4D1,  0xD4D3,  
      0,       0,       0,       0xADF4,  0x54CB,  0,       0,       0,       // 0x287x
      0xB0D0,  0,       0,       0,       0,       0xA2FD,  0xA5F1,  0x4970,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x288x
      0,       0,       0,       0,       0x54CC,  0x54CF,  0,       0xCEE8,  
      0,       0xD4CF,  0x54D0,  0x54D2,  0xADFB,  0xADF8,  0x54D5,  0x54D6,  // 0x289x
      0x54D1,  0xADFE,  0xADFC,  0xADFD,  0x54D7,  0x503D,  0x5BC9,  0xAEA1,  
      0xB7FB,  0xB7FD,  0xB7FA,  0xB8A1,  0x5BCB,  0xADFA,  0xB7F9,  0xADEE,  // 0x28Ax
      0,       0,       0,       0,       0,       0,       0xD4CD,  0,       
      0x54D3,  0xB8A2,  0xD4C9,  0xD4CE,  0xD4D2,  0xDAA5,  0xDAA6,  0xDAAE,  // 0x28Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xDAA7,  0,       0,       0,       0,       0,       0,       // 0x28Cx
      0,       0x5BCA,  0x54D8,  0xDAAA,  0xD4CC,  0xB7F8,  0x5BD1,  0x5635,  
      0x5631,  0x5B2A,  0x5BCE,  0x61E4,  0x61E2,  0xBFDB,  0xB8A6,  0,       // 0x28Dx
      0x5B26,  0x5BCD,  0x5BCF,  0xB8A3,  0xB8A5,  0x5BD0,  0x61E3,  0xBFDA,  
      0x61E5,  0xBFD9,  0xA2F6,  0,       0,       0,       0,       0,       // 0x28Ex
      0xDAAB,  0xDAAD,  0xDEDF,  0xDEE0,  0xDEE2,  0xDEE3,  0xDEE5,  0xDEE6,  
      0xDEE7,  0,       0xBFDC,  0,       0,       0,       0xB8A4,  0xDAA8,  // 0x28Fx
      0,       0,       0,       0x5B27,  0x5BD2,  0xC6F9,  0xBFDD,  0x61E8,  
} ;


static const unsigned short Uni2cnsP2Table_29 [] = {
      0xCDE4,  0x5F63,  0x5F62,  0xC6FC,  0x61E9,  0xCDE7,  0x5B28,  0x61EA,  // 0x290x
      0xC7A5,  0xC7A1,  0xC6F8,  0x61E7,  0xC6FE,  0,       0x67ED,  0xC6FA,  
      0x67F0,  0xC6F7,  0xC7A2,  0xBFDE,  0,       0xC6FD,  0x67EE,  0xDEE4,  // 0x291x
      0x67EF,  0xC6FB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x67EC,  0xE2B9,  0xC7AA,  0x6344,  // 0x292x
      0xC7A7,  0x67F4,  0xC7A4,  0x6CAA,  0xC7A9,  0xC7A6,  0xBFDF,  0x67F5,  
      0x633F,  0x67F1,  0x6CA8,  0xC7AB,  0xC7A3,  0xCDE5,  0x67F7,  0,       // 0x293x
      0,       0,       0xE2BA,  0xE2B8,  0xE2BB,  0xE2BC,  0xE2BD,  0,       
      0,       0xCDE6,  0,       0x61E6,  0x67F2,  0,       0,       0,       // 0x294x
      0,       0,       0xE5AB,  0x67F6,  0x6CA9,  0xD3B9,  0xCDEA,  0x6341,  
      0xCDE9,  0x6345,  0xD3B8,  0xCDEB,  0xE7D5,  0,       0,       0xDBCF,  // 0x295x
      0x663E,  0,       0x6CAB,  0xD7F3,  0xD7F4,  0xD7F5,  0xD3BB,  0xD3BA,  
      0,       0xD3BC,  0,       0,       0xE9C2,  0xD7F6,  0xDBD0,  0xDBD2,  // 0x296x
      0xDBD3,  0xDBD1,  0,       0xEAD0,  0xE9C1,  0xEAD1,  0xEAD2,  0xDBD5,  
      0x77DA,  0xDBD4,  0xDEE5,  0,       0,       0,       0,       0,       // 0x297x
      0xEAD3,  0xEBC7,  0xEBC8,  0x77DB,  0xDEE6,  0x79A9,  0xDEE7,  0xECA8,  
      0,       0xECA9,  0,       0,       0,       0x6D72,  0xECFC,  0xECFD,  // 0x298x
      0x7BBE,  0x7BE0,  0,       0xEDB4,  0,       0,       0x22EA,  0x2272,  
      0xA476,  0,       0,       0xA76B,  0x24BB,  0xA76A,  0xA76D,  0,       // 0x299x
      0,       0xA76C,  0x2652,  0xAB51,  0xAB58,  0xAB54,  0xAB56,  0x2653,  
      0xAB55,  0xAB53,  0xAB57,  0xA7A4,  0xA7A3,  0,       0xB13D,  0xB13B,  // 0x29Ax
      0xB13E,  0xB140,  0x294C,  0xB141,  0xB13F,  0,       0xAAF1,  0xAAF2,  
      0,       0,       0,       0,       0,       0,       0xB13C,  0xB767,  // 0x29Bx
      0x2DDF,  0xB769,  0x2DDE,  0xB768,  0,       0,       0,       0x32E1,  
      0x316F,  0xC025,  0xB4F3,  0xB4F4,  0,       0,       0xC024,  0x32E0,  // 0x29Cx
      0xC928,  0xC927,  0xC925,  0xC926,  0x375C,  0xC929,  0xBBAF,  0,       
      0,       0x38DB,  0x38DC,  0xB4F6,  0x3D44,  0xD271,  0x3FC7,  0,       // 0x29Dx
      0x3FC9,  0,       0,       0xC1D5,  0x3D41,  0,       0,       0xD270,  
      0x3FC8,  0,       0xDD29,  0,       0xDD2A,  0x45FA,  0x45FC,  0x45FB,  // 0x29Ex
      0xA3A4,  0x45FD,  0xC8A9,  0xC8AA,  0xDD28,  0,       0,       0,       
      0,       0,       0,       0x4DB6,  0x4973,  0x4974,  0xA3A8,  0xA3A7,  // 0x29Fx
      0xA3A5,  0xDD2B,  0xA3A3,  0,       0,       0xCEFB,  0xA3A9,  0xA3A6,  
} ;


static const unsigned short Uni2cnsP2Table_2A [] = {
      0,       0,       0,       0,       0xCEF7,  0xCEF8,  0xCEFA,  0xA3AA,  // 0x2A0x
      0xAEAA,  0xAEA5,  0xAEA4,  0xAEA7,  0xAEA6,  0xAEA9,  0xAEA8,  0,       
      0xACE3,  0xB1F0,  0xAEA3,  0xB8A7,  0x5BD3,  0xDAAF,  0,       0,       // 0x2A1x
      0,       0xBFE0,  0xC7AD,  0x5F65,  0,       0,       0xC7AE,  0x6CAC,  
      0xE5AC,  0x70A1,  0,       0xD3BD,  0xA327,  0x21ED,  0xA477,  0,       // 0x2A2x
      0,       0xA478,  0x2434,  0,       0xA4B7,  0xA4B8,  0,       0x26B9,  
      0,       0,       0xAB59,  0,       0xAB5A,  0,       0,       0xB143,  // 0x2A3x
      0xB142,  0xB144,  0x29B9,  0xAAF3,  0xAAF4,  0xAAF5,  0xB146,  0,       
      0,       0xB145,  0,       0,       0x29B8,  0xB76C,  0xB76A,  0xB76B,  // 0x2A4x
      0x2DE1,  0,       0,       0x2DE0,  0,       0xC026,  0xB4F7,  0,       
      0,       0x38DD,  0x38DF,  0x38E0,  0,       0x38DE,  0x3FCA,  0,       // 0x2A5x
      0x45FE,  0x4355,  0,       0,       0,       0xA3AB,  0,       0,       
      0x5BD4,  0,       0x70A2,  0,       0,       0xA328,  0x21EE,  0,       // 0x2A6x
      0xA329,  0xA32A,  0,       0x21EF,  0x22EC,  0x2276,  0xA479,  0,       
      0x22F2,  0x22F0,  0x22EF,  0x22EB,  0x22ED,  0xA2D0,  0xA2D2,  0,       // 0x2A7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x22F1,  0x2437,  0xA773,  0xA776,  0xA775,  0x2657,  // 0x2A8x
      0x24BD,  0xA76F,  0x2438,  0x2435,  0xA777,  0x24BE,  0x243B,  0xA772,  
      0xAB5D,  0xA771,  0xAB65,  0xAB5B,  0xA770,  0x24BC,  0xAB5C,  0xA774,  // 0x2A9x
      0,       0,       0,       0,       0xA4BB,  0xA4BC,  0xA4BD,  0xA4BE,  
      0xA4BF,  0xA4C0,  0xA4C1,  0xA4C3,  0xA4C4,  0,       0,       0xA4C5,  // 0x2AAx
      0,       0xA4BA,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0xAB5E,  0xAB5F,  0xAB61,  0x26BB,  // 0x2ABx
      0x29BA,  0,       0xAB64,  0xB148,  0x26BD,  0xB14A,  0x26BC,  0xB149,  
      0xB147,  0,       0xAB62,  0,       0,       0,       0xA7A6,  0xA7A7,  // 0x2ACx
      0xA7A8,  0xA7A9,  0xA7AA,  0xA7AB,  0xA7AC,  0xA7AD,  0xA7AF,  0,       
      0,       0,       0,       0,       0xA7A5,  0,       0,       0,       // 0x2ADx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x26BE,  0,       0xB152,  0xB154,  0x2958,  0x294F,  // 0x2AEx
      0x2950,  0xB153,  0xB76D,  0x29BF,  0x29C2,  0x29C1,  0xB14D,  0x29C7,  
      0x2D34,  0x295C,  0x29BE,  0x29BD,  0x2DE3,  0x2953,  0xB76E,  0x29C8,  // 0x2AFx
      0x295A,  0xB150,  0x29C0,  0x29C4,  0xB14E,  0xB156,  0xB14B,  0x29C3,  
} ;


static const unsigned short Uni2cnsP2Table_2B [] = {
      0x29BC,  0,       0,       0xB155,  0,       0,       0xB151,  0xAAF6,  // 0x2B0x
      0xAAF7,  0xAAF8,  0xAAF9,  0xAAFA,  0xAAFB,  0xAAFC,  0xAAFD,  0xAAFE,  
      0xABA1,  0xABA3,  0xABA4,  0xABA5,  0xABA6,  0xABA7,  0xABA8,  0xABA9,  // 0x2B1x
      0xABAA,  0xAFD3,  0xAFDC,  0xAFE1,  0,       0,       0xB14C,  0,       
      0,       0,       0xABA2,  0,       0,       0,       0,       0,       // 0x2B2x
      0,       0,       0x29BB,  0x2DE2,  0x2DE4,  0,       0,       0x2D3D,  
      0xB775,  0x2D38,  0x2DED,  0x2DEB,  0x2D39,  0x2957,  0x2D35,  0x2DEA,  // 0x2B3x
      0xB77B,  0xB770,  0xB77D,  0xB773,  0x2DE9,  0xB772,  0xB777,  0x2D36,  
      0xB778,  0x2DEC,  0x2DE5,  0x2D37,  0x2DE7,  0x2DE8,  0x2D3A,  0xB77A,  // 0x2B4x
      0x2DE6,  0xB157,  0xB776,  0xC027,  0xB779,  0xB774,  0x29C6,  0,       
      0,       0,       0xB77C,  0xB77E,  0xAFCC,  0xAFCD,  0xAFCE,  0xAFCF,  // 0x2B5x
      0xAFD0,  0xAFD1,  0xAFD2,  0xAFD5,  0xAFD6,  0xAFD7,  0xAFDA,  0xAFDB,  
      0xAFDD,  0xAFDE,  0xAFE0,  0xAFE2,  0xC028,  0,       0xAFD8,  0,       // 0x2B6x
      0xB76F,  0,       0xAFD4,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2B7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x3172,  0x3173,  0x375E,  0x32E9,  0,       0xC031,  0x2DEE,  // 0x2B8x
      0xC037,  0x32E3,  0x3174,  0x3222,  0x3176,  0x32E2,  0x317D,  0x38E1,  
      0x32E4,  0xC034,  0x32E7,  0xC035,  0xC02C,  0xC029,  0x3224,  0xC92F,  // 0x2B9x
      0xC92A,  0xC02A,  0x32E5,  0,       0xC92D,  0x375D,  0xC02F,  0xC92C,  
      0xC92B,  0x32E8,  0xC02D,  0xC92E,  0xC033,  0,       0,       0xC030,  // 0x2BAx
      0x3175,  0,       0,       0,       0,       0,       0xC02E,  0xB4F8,  
      0xB4F9,  0xB4FA,  0xB4FB,  0xB4FC,  0xB4FE,  0xB5A2,  0xB5A3,  0xB5A4,  // 0x2BBx
      0xB5A5,  0xB5A6,  0xB5A7,  0xB5A8,  0xB5A9,  0xB5AA,  0xB5AB,  0xB5AC,  
      0xB5AE,  0xB5AD,  0xB5AF,  0xB5B0,  0xBBB1,  0,       0xB4FD,  0,       // 0x2BCx
      0x32E6,  0,       0,       0,       0x3226,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2BDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xBBC1,  0,       0,       0,       0,       // 0x2BEx
      0,       0x38EB,  0xC934,  0x3769,  0xC93B,  0xC936,  0x38ED,  0xC941,  
      0x38F4,  0xC931,  0x3D51,  0x3767,  0x38E2,  0x38EA,  0x375F,  0x38E8,  // 0x2BFx
      0x3763,  0x38E9,  0x376A,  0x38E6,  0x376D,  0x38EF,  0x3766,  0xC942,  
} ;


static const unsigned short Uni2cnsP2Table_2C [] = {
      0xC943,  0xC93A,  0x38F1,  0xC933,  0xC946,  0xC937,  0x38F0,  0x376C,  // 0x2C0x
      0xC947,  0xC932,  0x38EC,  0x38EE,  0xC944,  0x38E4,  0xC93C,  0xC945,  
      0xC940,  0xC94C,  0xC93F,  0xC94D,  0xC948,  0xC939,  0x38F2,  0xC93D,  // 0x2C1x
      0x38F3,  0x38E7,  0xC938,  0xC94B,  0x38E5,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2C2x
      0xD273,  0xBBB0,  0xBBB2,  0xBBB4,  0xBBB5,  0xBBB6,  0xBBB7,  0xBBB8,  
      0xBBB9,  0xBBBA,  0xBBBB,  0xBBBC,  0xBBBD,  0xBBBF,  0xBBC0,  0xBBC2,  // 0x2C3x
      0xBBC3,  0xBBC4,  0xBBC5,  0xBBC6,  0xBBC8,  0xBBC9,  0xBBCA,  0,       
      0xD274,  0,       0xC93E,  0xC949,  0,       0xC935,  0,       0x38E3,  // 0x2C4x
      0,       0,       0,       0,       0,       0xBBC7,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2C5x
      0,       0,       0,       0,       0,       0,       0,       0x3FD2,  
      0xD27B,  0x3D4B,  0x3D49,  0x3FD5,  0x3D46,  0xD278,  0x3D4D,  0x3D53,  // 0x2C6x
      0x3D47,  0x3D52,  0xD27E,  0x3FD1,  0x46A1,  0,       0x3FCB,  0xDD2C,  
      0xD325,  0xD275,  0xD323,  0xD322,  0x3FCD,  0,       0x3FD3,  0x3FCE,  // 0x2C7x
      0xD279,  0xD321,  0x3FD0,  0xD324,  0xD27C,  0,       0x3FCC,  0xD27A,  
      0x3FCF,  0xC1D6,  0xC1D7,  0xC1D8,  0xC1D9,  0xC1DA,  0xC1DB,  0xC1DC,  // 0x2C8x
      0xC1DD,  0xC1DE,  0xC1E0,  0xC1E1,  0xC1E3,  0xC1E4,  0xC1E5,  0xC1E6,  
      0xC1E7,  0xC1E9,  0xC8B0,  0,       0,       0xD277,  0xD27D,  0,       // 0x2C9x
      0xD276,  0,       0,       0,       0,       0,       0,       0,       
      0,       0xC1E8,  0,       0,       0,       0,       0,       0,       // 0x2CAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x3FD4,  0,       0,       0xDD36,  0x4DB9,  0x46A7,  0x46AA,  0x4362,  // 0x2CBx
      0x435F,  0xDD3C,  0xDD3D,  0xDD2E,  0x4357,  0xDD3F,  0x46A6,  0,       
      0x4363,  0x4DB8,  0x46A9,  0xDD35,  0x4359,  0xA3AF,  0x435B,  0x435A,  // 0x2CCx
      0xA3AE,  0xA3B1,  0,       0x46A4,  0,       0x4365,  0xDD39,  0xDD3E,  
      0xDD3A,  0x46A8,  0xDD37,  0x46AB,  0xA3AC,  0xDD3B,  0xDD33,  0,       // 0x2CDx
      0xDD31,  0x46A2,  0x4360,  0,       0,       0,       0,       0,       
      0,       0xDD2F,  0xDD34,  0xC8AB,  0xC8AC,  0xC8AD,  0xC8AE,  0xC8AF,  // 0x2CEx
      0xC8B3,  0xC8B4,  0xC8B5,  0xC8B7,  0xC8B8,  0xC8BA,  0xC8BB,  0xC8B9,  
      0xC8BC,  0xC8BD,  0xC8BE,  0xC8BF,  0xC8C0,  0xC8C1,  0xC8C2,  0xC8C3,  // 0x2CFx
      0xC8C4,  0xC8C5,  0xC8C7,  0xC8C8,  0xC8C9,  0,       0xC8C6,  0,       
} ;


static const unsigned short Uni2cnsP2Table_2D [] = {
      0xDD30,  0xC8B6,  0,       0,       0,       0,       0,       0,       // 0x2D0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2D1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xA3B3,  0xA3B8,  0x4DBC,  0x4A25,  0xA3BD,  0xA3B7,  0xA3B9,  0x497B,  // 0x2D2x
      0x4978,  0x4DBD,  0x4DBB,  0xA3C5,  0x497D,  0xAEAF,  0x4A21,  0,       
      0x4DC1,  0x4A26,  0x497C,  0x54D9,  0xAEBC,  0xA3B5,  0xA3B4,  0xAEAD,  // 0x2D3x
      0xAEAB,  0xA3C4,  0xAEAC,  0xA3BC,  0x4DC0,  0xAEAE,  0x4DBF,  0xA3BB,  
      0xA3C2,  0xA3C3,  0,       0xA3BE,  0xA3C1,  0,       0,       0,       // 0x2D4x
      0x4977,  0,       0xC8B1,  0,       0,       0xA3B2,  0xA3BF,  0xA3C0,  
      0xCEFC,  0xCEFD,  0xCEFE,  0xCFA1,  0xCFA2,  0xCFA3,  0xCFA6,  0xCFA7,  // 0x2D5x
      0xCFA8,  0xCFA9,  0xCFAA,  0xCFAB,  0xCFAD,  0xCFAE,  0xCFAF,  0xCFB0,  
      0xD4DF,  0,       0,       0xCFA4,  0,       0,       0,       0,       // 0x2D6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x2D7x
      0,       0,       0,       0,       0,       0,       0,       0x5638,  
      0x5041,  0xAEB5,  0xAEB0,  0x54DA,  0x54DB,  0xAEBE,  0xAEBA,  0xAEB2,  // 0x2D8x
      0xA3B6,  0x503E,  0x5043,  0x5040,  0x54DD,  0x503F,  0xAEBD,  0x5046,  
      0xAEBB,  0x5048,  0x5042,  0x5047,  0xAEB9,  0xAEB1,  0xAEC0,  0xB8A9,  // 0x2D9x
      0xAEB8,  0x54DF,  0x54DC,  0xAEB7,  0xB8A8,  0xAEB3,  0,       0,       
      0,       0,       0,       0,       0,       0,       0xAEBF,  0xD4D5,  // 0x2DAx
      0xD4D6,  0xD4D7,  0xD4D8,  0xD4D9,  0xD4DA,  0xD4DB,  0xD4DC,  0xD4DD,  
      0xD4DE,  0xD4E0,  0,       0,       0,       0xAEB4,  0,       0,       // 0x2DBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xAEB6,  // 0x2DCx
      0x5044,  0xD4D4,  0,       0x5BD6,  0xB8B1,  0x5BD7,  0xB8B6,  0x563B,  
      0xB8AF,  0xB8B5,  0x563A,  0xB8B4,  0xB8AC,  0x5BD8,  0x5637,  0x5BD5,  // 0x2DDx
      0xB8AA,  0xB8B7,  0xB8B0,  0xB8AE,  0xB8B2,  0xB8B8,  0,       0,       
      0,       0,       0,       0,       0xB8AB,  0xB8AD,  0xDAB0,  0xDAB1,  // 0x2DEx
      0xDAB2,  0xDAB3,  0xDAB4,  0xDAB5,  0,       0xB8B3,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x5B33,  0x5B38,  // 0x2DFx
      0x61EE,  0x61EB,  0x61EC,  0x61ED,  0xBFE8,  0xBFE7,  0x5B35,  0x5B37,  
} ;


static const unsigned short Uni2cnsP2Table_2E [] = {
      0x67FA,  0x6CAD,  0xBFE9,  0xBFE6,  0x5B34,  0xBFE3,  0xBFE5,  0xC7AF,  // 0x2E0x
      0xBFE1,  0xBFE4,  0,       0,       0,       0,       0xDEE8,  0xDEE9,  
      0xDEEA,  0xDEED,  0xDEEE,  0xDEEF,  0xDEF1,  0xDEF2,  0xDEF4,  0,       // 0x2E1x
      0xDEEC,  0xDEEB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x5F66,  0x5F68,  0x5F67,  0x5F69,  0x6CAF,  // 0x2E2x
      0xC7B2,  0xC7B4,  0xC7B6,  0x67FB,  0xC7B0,  0x6CAE,  0xC7B8,  0x5F6B,  
      0xC7B5,  0xC7B3,  0xC7B1,  0x5F6A,  0x67F9,  0,       0,       0xE2BE,  // 0x2E3x
      0xE2BF,  0xE2C0,  0xE2C1,  0xE2C2,  0xE2C3,  0xE2C4,  0xE2C5,  0xE2C6,  
      0xE2C9,  0xE5AF,  0xBFEA,  0,       0xC7B7,  0,       0,       0,       // 0x2E4x
      0,       0,       0,       0xE2C7,  0,       0x6CB2,  0,       0x663F,  
      0xCDED,  0x6348,  0,       0xCDEC,  0x6349,  0xCDF0,  0x634A,  0xCDEE,  // 0x2E5x
      0x6CB3,  0x6CB0,  0x6CB1,  0,       0,       0,       0,       0xCDEF,  
      0xE5AD,  0xE5AE,  0xE5B0,  0,       0,       0,       0,       0,       // 0x2E6x
      0,       0,       0,       0,       0xD3C4,  0xD7F7,  0x6641,  0xD3BF,  
      0xD3C3,  0xD3C2,  0x6642,  0x73C5,  0xD3C1,  0xD3C0,  0,       0xE7D6,  // 0x2E7x
      0,       0xE7D7,  0xE7D8,  0xE7D9,  0,       0,       0,       0,       
      0,       0,       0xD7F8,  0xD7F9,  0x73C4,  0x73C7,  0x70A3,  0xD7FA,  // 0x2E8x
      0x73C2,  0x73C6,  0xD7FC,  0xDBD7,  0xD3BE,  0,       0,       0xE9C3,  
      0xE9C4,  0x73C3,  0,       0,       0,       0xD7FB,  0xDBD8,  0,       // 0x2E9x
      0xEAD4,  0xEAD5,  0xEAD6,  0,       0,       0,       0xDEEA,  0x77DD,  
      0xDEE9,  0x6B6B,  0xDEEB,  0,       0,       0x77DC,  0xDEE8,  0xEBC9,  // 0x2EAx
      0xEBCA,  0xEBCB,  0xEBCC,  0,       0xE2B8,  0xECAA,  0xECAB,  0,       
      0x6D73,  0xE3D3,  0xECE1,  0,       0xE6A6,  0x2277,  0x243D,  0x265A,  // 0x2EBx
      0xA7B1,  0xA7B2,  0xA7B3,  0,       0,       0,       0xB158,  0,       
      0,       0xB822,  0x2FDC,  0x2D3E,  0xB821,  0,       0,       0,       // 0x2ECx
      0xB644,  0,       0xC039,  0,       0,       0xC038,  0xC94F,  0xC94E,  
      0xBBCC,  0xBBCD,  0,       0,       0x38F5,  0xD326,  0xC1EA,  0xD327,  // 0x2EDx
      0,       0,       0x46AD,  0xDD40,  0,       0xA3C6,  0xA3C7,  0,       
      0x54E0,  0xD4E1,  0,       0,       0,       0xB8BB,  0xB8BA,  0x5BD9,  // 0x2EEx
      0,       0xB8BC,  0xCDF1,  0,       0x24BF,  0xA779,  0x24C0,  0xA77A,  
      0,       0x24C1,  0xA778,  0xAB68,  0x2660,  0,       0x26C2,  0x26C0,  // 0x2EFx
      0,       0x265D,  0xAB6C,  0xAB66,  0,       0xAB6A,  0xAB69,  0,       
} ;


static const unsigned short Uni2cnsP2Table_2F [] = {
      0,       0,       0,       0,       0,       0xAB67,  0x26BF,  0x26C1,  // 0x2F0x
      0x265C,  0x2960,  0xB159,  0x29CC,  0x29CB,  0xB15C,  0xB15E,  0xB15D,  
      0x29C9,  0x29CA,  0,       0,       0x295E,  0x295F,  0,       0,       // 0x2F1x
      0xB15B,  0,       0,       0,       0xB823,  0xB824,  0xB826,  0x2DF2,  
      0xB15F,  0x2D45,  0xB828,  0x2DF0,  0,       0xB82A,  0,       0x2DEF,  // 0x2F2x
      0x2DF4,  0,       0xB825,  0,       0x2DF3,  0x2DF1,  0xB829,  0xB827,  
      0,       0,       0,       0,       0,       0,       0x2D41,  0,       // 0x2F3x
      0,       0,       0x32ED,  0xC040,  0,       0x322E,  0,       0xC03A,  
      0xC03B,  0xC03D,  0x32EF,  0x32F0,  0x3230,  0xC03E,  0xC03C,  0x32EB,  // 0x2F4x
      0xC041,  0x3231,  0x322A,  0x322D,  0,       0,       0,       0x3229,  
      0x32EE,  0xB5B1,  0xB5B2,  0xB5B3,  0xB5B4,  0xB5B5,  0,       0x32EA,  // 0x2F5x
      0xC03F,  0,       0,       0xC958,  0,       0x39A2,  0xC955,  0x377A,  
      0x377B,  0xC959,  0,       0,       0xC954,  0xC95A,  0x38F6,  0x38FE,  // 0x2F6x
      0x39A1,  0x38FD,  0x38F7,  0,       0xC956,  0x38FB,  0xC951,  0xC950,  
      0xC953,  0,       0x3772,  0x3773,  0x3774,  0x38F8,  0x38F9,  0x32EC,  // 0x2F7x
      0,       0,       0xC952,  0,       0,       0,       0,       0xD32F,  
      0x38FA,  0,       0x3FD7,  0x3FDA,  0x3FDC,  0x3D57,  0x3D5F,  0xD32B,  // 0x2F8x
      0xD32E,  0xD329,  0,       0x3FDB,  0xD330,  0xD32D,  0,       0xD328,  
      0x3D60,  0,       0x3FD6,  0xD331,  0x3FD9,  0,       0,       0,       // 0x2F9x
      0,       0x3D5E,  0x3D55,  0x3D56,  0x3D58,  0x3FD8,  0xD32A,  0xC1EB,  
      0xD32C,  0,       0,       0x32F1,  0x3D5A,  0xD560,  0,       0x46B4,  // 0x2FAx
      0xDD49,  0x46B2,  0xDD41,  0x4368,  0x46B1,  0xDD42,  0x46AF,  0xDD46,  
      0,       0x46B7,  0,       0x46B5,  0xDD47,  0xDD45,  0xDD44,  0xDD48,  // 0x2FBx
      0xDD43,  0xDD4A,  0x46B3,  0,       0x4367,  0x46B6,  0xDD4B,  0,       
      0,       0,       0,       0,       0,       0,       0x48A5,  0x4DC2,  // 0x2FCx
      0x4DC7,  0x4A2C,  0xA3CE,  0xA3C9,  0,       0xA3C8,  0x4DC6,  0,       
      0xA3D2,  0xA3CF,  0xA3CD,  0x4DC5,  0xA3D0,  0x4DC3,  0x4DC4,  0xCFB1,  // 0x2FDx
      0xA3CB,  0xA3CC,  0,       0xA3CA,  0,       0,       0x504B,  0xAEC2,  
      0xAEC6,  0xAEC8,  0,       0xD4E2,  0x54E1,  0xAECB,  0,       0,       // 0x2FEx
      0xAEC7,  0xAEC9,  0xAEC1,  0xAEC5,  0xAECC,  0x54E3,  0xAECA,  0,       
      0,       0,       0x504A,  0x54E4,  0x54E5,  0x54E6,  0xD4E3,  0xAEC4,  // 0x2FFx
      0x54E2,  0xA3D1,  0,       0,       0,       0x54E7,  0xB8BE,  0xB8BD,  
} ;


static const unsigned short Uni2cnsP2Table_30 [] = {
      0x5BDA,  0x5BDE,  0x5BDD,  0,       0,       0,       0x563C,  0,       // 0x300x
      0,       0x563D,  0x5BDB,  0xDAB7,  0xDAB8,  0,       0xB8BF,  0x5BDC,  
      0x61F0,  0xBFEC,  0x61EF,  0,       0x5B3B,  0xBFED,  0xBFEE,  0,       // 0x301x
      0x5B39,  0,       0xBFEB,  0,       0,       0x68A1,  0x67FE,  0,       
      0x67FC,  0x67FD,  0xE2CA,  0x6CB4,  0x634D,  0x6CB5,  0xCDF2,  0x634B,  // 0x302x
      0xCDF5,  0,       0xCDF4,  0x6CB6,  0xCDF6,  0xCDF7,  0x6644,  0x70A5,  
      0,       0x70A6,  0,       0x73C8,  0xE9C5,  0xDBD9,  0x75EB,  0x6A4A,  // 0x303x
      0,       0,       0xDBDA,  0,       0x6C6F,  0xECE2,  0,       0,       
      0,       0xA2D3,  0xA4C6,  0xAB6D,  0,       0,       0xABAD,  0xABAE,  // 0x304x
      0xABAF,  0,       0xB82D,  0xB82E,  0xAFE5,  0,       0xC042,  0xC044,  
      0xB5B7,  0xB5B8,  0xC043,  0,       0,       0xBBCE,  0,       0x3FDD,  // 0x305x
      0xC1EC,  0xD332,  0xB5B6,  0,       0x4DC8,  0xA3D4,  0xA3D3,  0x4DC9,  
      0xCFB3,  0xCFB4,  0x4DCA,  0xAECD,  0xDAB9,  0xDEF5,  0,       0xE2CB,  // 0x306x
      0,       0xE7DA,  0,       0xDBDB,  0xA222,  0,       0xA7B4,  0,       
      0,       0xB160,  0,       0x2D48,  0x2DF6,  0x2DF5,  0xB82F,  0x32F2,  // 0x307x
      0xB5B9,  0,       0xC046,  0xC045,  0xC95D,  0xC0B2,  0,       0xC95B,  
      0xC95C,  0x3D61,  0xDD4C,  0,       0x3FDE,  0xC1ED,  0x436A,  0,       // 0x308x
      0,       0x4A2D,  0xA3D5,  0,       0xB8C0,  0,       0,       0x5F6C,  
      0,       0xA223,  0,       0xA4C7,  0xAB6F,  0xAB6E,  0,       0,       // 0x309x
      0,       0xB161,  0,       0xAFE6,  0,       0,       0x3232,  0xC048,  
      0xC047,  0xC960,  0xC964,  0xC963,  0x39A3,  0xC966,  0xC95F,  0xC95E,  // 0x30Ax
      0xC962,  0,       0x377C,  0xCC3E,  0,       0xC965,  0x3D62,  0xD336,  
      0,       0xD334,  0xD337,  0,       0,       0x3FDF,  0xDD4F,  0,       // 0x30Bx
      0xDD4E,  0xDD50,  0xC7B1,  0x4A2F,  0xDD4D,  0x4DCC,  0,       0x4DCD,  
      0xAED1,  0xAED0,  0xAECF,  0xAED2,  0,       0,       0xAECE,  0,       // 0x30Cx
      0x504D,  0,       0xB8C1,  0xB8C2,  0xBFEF,  0x5B3C,  0,       0xBFF0,  
      0xBFF1,  0xC7B9,  0,       0xE2CC,  0xCDF8,  0,       0xD7FD,  0,       // 0x30Dx
      0x2442,  0xA77B,  0,       0xA7B5,  0xA7B6,  0x29CD,  0xB164,  0xB163,  
      0,       0xABB0,  0xB162,  0,       0,       0,       0x2D4A,  0x2DF7,  // 0x30Ex
      0xB831,  0xB833,  0xB835,  0xAFE7,  0xAFE8,  0xAFE9,  0xAFEA,  0xB832,  
      0,       0,       0,       0x3233,  0,       0x3235,  0,       0xC04A,  // 0x30Fx
      0xB5BA,  0xB5BB,  0,       0xC049,  0xC969,  0x39A5,  0x39A4,  0xC968,  
} ;


static const unsigned short Uni2cnsP2Table_31 [] = {
      0xC96A,  0xC967,  0xBBCF,  0,       0xBBD0,  0,       0,       0,       // 0x310x
      0xD338,  0x3FE0,  0xD339,  0xC1EE,  0xC1EF,  0,       0x46B8,  0x46BA,  
      0xDD52,  0x46B9,  0,       0,       0xA3D6,  0,       0,       0xCFB5,  // 0x311x
      0xAED3,  0x54E8,  0xB8C3,  0,       0,       0x5BDF,  0xBFF3,  0x61F1,  
      0x5B3D,  0xBFF4,  0xBFF2,  0,       0xC7BA,  0,       0xD3C5,  0x686D,  // 0x312x
      0xD7FE,  0,       0xDEEC,  0xE0F0,  0,       0,       0x24C2,  0,       
      0x29CE,  0x2DF9,  0x2DF8,  0,       0x377D,  0xC96B,  0xD33A,  0xD33B,  // 0x313x
      0x3D66,  0xCFB6,  0,       0xA32C,  0xA32B,  0,       0xA47B,  0x22F3,  
      0xA47A,  0xA47C,  0xA2D4,  0,       0xA4CB,  0,       0xA77C,  0xA77D,  // 0x314x
      0xA825,  0x24C3,  0xA822,  0xA77E,  0xA824,  0,       0xA823,  0,       
      0xA821,  0xA4C8,  0xA4CA,  0xA4CC,  0,       0,       0x2444,  0,       // 0x315x
      0,       0,       0x26C8,  0xAB74,  0xAB73,  0x26C9,  0xAB7D,  0x26C4,  
      0xAB79,  0x26C7,  0xAB7A,  0xAB77,  0x26C6,  0x26C5,  0xAB75,  0xAB78,  // 0x316x
      0xA7B7,  0xA7B8,  0xA7B9,  0xA7BA,  0xA7BB,  0xA7BC,  0xA7BD,  0xAB71,  
      0,       0xAB7B,  0xAB7C,  0xAB72,  0xAB76,  0,       0,       0x29D1,  // 0x317x
      0xB165,  0xB166,  0x29D0,  0x2966,  0xB168,  0xB169,  0x2968,  0,       
      0,       0xABB1,  0,       0xABB2,  0xB16A,  0xABB5,  0xABB6,  0,       // 0x318x
      0,       0xB16E,  0xB16C,  0xB16B,  0,       0,       0,       0,       
      0,       0,       0x2DFE,  0xB83A,  0x2EA1,  0x2EA2,  0x2DFB,  0x2EA3,  // 0x319x
      0x2DFC,  0x2DFA,  0xB83E,  0xB838,  0xB83C,  0x2DFD,  0xB839,  0,       
      0xB83D,  0,       0,       0xAFEB,  0,       0,       0xAFED,  0xB83B,  // 0x31Ax
      0xAFEC,  0xB841,  0,       0xB83F,  0,       0,       0,       0,       
      0,       0,       0x32F3,  0x3238,  0x3821,  0xC053,  0x323D,  0xC04E,  // 0x31Bx
      0xC04B,  0xC04C,  0xC050,  0xC04D,  0xC055,  0x32F5,  0xB840,  0xC054,  
      0xC056,  0,       0,       0,       0,       0,       0xB5BC,  0,       // 0x31Cx
      0,       0,       0,       0xB5BD,  0xB5BE,  0xB5BF,  0xB5C0,  0xB5C1,  
      0xB5C2,  0xB5C3,  0xB5C4,  0xB5C5,  0xB5C6,  0xB5C7,  0,       0,       // 0x31Dx
      0,       0,       0xC052,  0,       0,       0,       0,       0,       
      0,       0,       0x32F4,  0xC971,  0xC974,  0x323C,  0x3FE1,  0x39AA,  // 0x31Ex
      0xC96F,  0x39A7,  0xC970,  0x39A9,  0x39A6,  0,       0xC96C,  0xC96D,  
      0x3823,  0xC976,  0x39AB,  0x3827,  0,       0,       0xC96E,  0,       // 0x31Fx
      0,       0,       0xC975,  0xC977,  0xBBD1,  0xBBD3,  0xBBD4,  0xBBD6,  
} ;


static const unsigned short Uni2cnsP2Table_32 [] = {
      0xBBD7,  0xBBD9,  0xBBDA,  0xBBDC,  0xBBDD,  0,       0,       0xBBD2,  // 0x320x
      0xBBD8,  0,       0,       0,       0,       0x3826,  0,       0x3828,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x321x
      0,       0,       0,       0,       0,       0,       0,       0xC972,  
      0x39AC,  0x39A8,  0,       0,       0xD343,  0x3FE3,  0xD341,  0xDD53,  // 0x322x
      0xD342,  0xD33F,  0xD344,  0,       0,       0,       0xC6B9,  0,       
      0,       0,       0,       0,       0,       0xBBDB,  0xD33E,  0xC1F0,  // 0x323x
      0xC1F1,  0xC1F3,  0xC1F4,  0xC1F5,  0xC1F6,  0xC1F7,  0xC1F8,  0,       
      0xC1F9,  0xC1FA,  0xC1FB,  0xC1FD,  0x3DD5,  0,       0,       0,       // 0x324x
      0xD345,  0,       0xD340,  0,       0,       0,       0,       0,       
      0,       0x3FE4,  0x46BB,  0x46BF,  0x46BD,  0x46BE,  0xDD56,  0x46C0,  // 0x325x
      0x46C3,  0x46C4,  0x436C,  0x46C2,  0x4DCE,  0,       0,       0,       
      0,       0,       0,       0xC8CA,  0xC8CB,  0xC8CC,  0xC8CD,  0xC8CE,  // 0x326x
      0xC8CF,  0xDD54,  0x46BC,  0xDD57,  0xDD59,  0xDD5A,  0,       0,       
      0xDD55,  0,       0,       0,       0,       0,       0,       0,       // 0x327x
      0,       0,       0xDD58,  0xA3E1,  0xA3DC,  0xA3DB,  0xA3DE,  0x4DD2,  
      0,       0x4DD5,  0xA3DA,  0xA3D7,  0xA3D8,  0,       0xA3E2,  0,       // 0x328x
      0,       0,       0,       0,       0,       0,       0,       0xCFB7,  
      0xCFB9,  0xCFBA,  0,       0,       0x4DD4,  0xA3E0,  0xCEB0,  0,       // 0x329x
      0,       0xA3DD,  0xA3DF,  0xA3D9,  0,       0x4DD1,  0x54E9,  0x54EB,  
      0xAED7,  0x5055,  0,       0xAED5,  0xAEDB,  0xAED9,  0xAEDD,  0x5054,  // 0x32Ax
      0xAEDC,  0,       0,       0,       0,       0,       0xAED4,  0xD4E5,  
      0xD4E6,  0xD4E7,  0xD4E9,  0xD4EA,  0xAED8,  0,       0x4DCF,  0,       // 0x32Bx
      0xADE2,  0,       0xD4E8,  0,       0,       0xAEC3,  0,       0,       
      0,       0,       0,       0,       0x54EA,  0xAED6,  0,       0,       // 0x32Cx
      0xCFB8,  0xB8C7,  0x5BE0,  0x5BE1,  0xB8C8,  0x5BE2,  0,       0xB8C5,  
      0xB8C6,  0,       0,       0xB8C9,  0xDABA,  0xDABB,  0xDABC,  0xB8C4,  // 0x32Dx
      0xDABD,  0,       0,       0,       0,       0,       0x5B3E,  0x61F2,  
      0,       0,       0,       0x61F3,  0,       0xBFF5,  0,       0,       // 0x32Ex
      0,       0,       0xDEF6,  0xDEF7,  0xDEF8,  0xDEF9,  0xDEFB,  0xBFF8,  
      0,       0,       0x68A3,  0xC7BD,  0xC7BC,  0x68A2,  0x68A4,  0xC7BB,  // 0x32Fx
      0xC7BE,  0,       0xE2CD,  0,       0,       0,       0,       0x6CB7,  
} ;


static const unsigned short Uni2cnsP2Table_33 [] = {
      0,       0,       0,       0xE5B1,  0xE5B2,  0x6BEE,  0,       0xCDF9,  // 0x330x
      0xD3C6,  0,       0,       0,       0,       0xD8A1,  0xE9C6,  0x73B9,  
      0,       0,       0,       0x73C9,  0,       0,       0xDBDC,  0x77DE,  // 0x331x
      0xDEED,  0xEBCD,  0,       0,       0x79AB,  0,       0,       0xE4C7,  
      0,       0,       0xA4CD,  0xAB7E,  0xA7BF,  0xA7C0,  0xAC21,  0x29D3,  // 0x332x
      0x29D2,  0xB170,  0xABB7,  0xABB9,  0xB16F,  0xB842,  0,       0xAFEF,  
      0xAFF0,  0xAFF1,  0xAFF2,  0xAFF3,  0,       0,       0,       0xB5C9,  // 0x333x
      0xB5CA,  0,       0,       0xBBDF,  0xC97A,  0xC979,  0x3FE5,  0,       
      0,       0,       0,       0x4370,  0xD346,  0,       0x4DD7,  0x4DD6,  // 0x334x
      0xA3E3,  0,       0,       0,       0xD4EB,  0,       0,       0x5BE3,  
      0,       0xBFFA,  0x61F4,  0xBFF9,  0xBFF7,  0,       0x5F6D,  0,       // 0x335x
      0xCDFA,  0xCDFB,  0,       0x7BBF,  0xE6BE,  0xA32D,  0xA47D,  0x24C4,  
      0xA829,  0xA827,  0xA828,  0xA826,  0xAC22,  0x29D4,  0x2969,  0x296A,  // 0x336x
      0,       0,       0,       0xABBA,  0xB171,  0,       0xB843,  0,       
      0,       0,       0,       0xB5CB,  0x32F6,  0xC059,  0xC05B,  0xC97D,  // 0x337x
      0xC97C,  0xC05A,  0x39AD,  0,       0xB9C6,  0,       0,       0,       
      0,       0xBBE1,  0xBBE2,  0,       0xD347,  0x3FE7,  0,       0,       // 0x338x
      0,       0xBBE0,  0xC1FE,  0xC2A1,  0xD348,  0xDD5D,  0,       0,       
      0xDD5E,  0,       0xA3E4,  0x4A34,  0x4DD9,  0,       0,       0x4A33,  // 0x339x
      0xCFBB,  0xCFBC,  0x54EE,  0x54EC,  0x5BE4,  0,       0,       0x54ED,  
      0xD4ED,  0xD4EE,  0,       0xB8CB,  0xB8CA,  0xDABE,  0,       0,       // 0x33Ax
      0,       0x61F5,  0,       0,       0xDEFC,  0xBFFB,  0x6CB8,  0,       
      0,       0x75EF,  0x77DF,  0x21C8,  0x214E,  0x217D,  0xA1E5,  0,       // 0x33Bx
      0x22F5,  0xA522,  0x22F4,  0xA47E,  0xA521,  0xA2D6,  0,       0x227B,  
      0x227A,  0xA82C,  0x2449,  0xA82A,  0,       0xA82B,  0xA4CE,  0xA4CF,  // 0x33Cx
      0xA4D4,  0xA4D0,  0xA4D2,  0x24C6,  0,       0,       0,       0,       
      0xA82D,  0x24C5,  0x2445,  0,       0x266B,  0x26CC,  0x2666,  0x26CB,  // 0x33Dx
      0xAC2B,  0x26D0,  0x26D2,  0xAC28,  0xAC27,  0xAC26,  0x26CD,  0x26D3,  
      0x26CF,  0x26CE,  0,       0,       0,       0xA7C3,  0,       0xA7C5,  // 0x33Ex
      0xA7C6,  0xA7C7,  0xA7C9,  0xA7CA,  0xA7CB,  0xA7CD,  0xA7CF,  0xA7D1,  
      0xA7D4,  0xA7D5,  0xAC24,  0xAC29,  0,       0,       0x26D4,  0,       // 0x33Fx
      0xAC2C,  0xA7C4,  0,       0xAC2D,  0,       0xAC2A,  0xA7C8,  0,       
} ;


static const unsigned short Uni2cnsP2Table_34 [] = {
      0xA7C2,  0xAC25,  0,       0x26D5,  0,       0,       0,       0xAD5C,  // 0x340x
      0xB174,  0xB173,  0x296B,  0x29D6,  0xB175,  0xB176,  0x29D5,  0x29D9,  
      0xB177,  0x2EA6,  0x29DA,  0x29D8,  0,       0,       0,       0xA7D3,  // 0x341x
      0xABBB,  0xABBC,  0xABBD,  0xABBF,  0xABC0,  0xABC1,  0xABC2,  0xABC3,  
      0xABC4,  0xABC5,  0xABC6,  0xABC7,  0xABC9,  0xABCA,  0xABCB,  0xABCC,  // 0x342x
      0xABCD,  0xABCE,  0xABCF,  0,       0,       0,       0,       0,       
      0x29DB,  0,       0,       0,       0,       0xC05C,  0xB84F,  0xB853,  // 0x343x
      0xB84B,  0xB84D,  0xB846,  0x2EA7,  0xB848,  0xB845,  0xB851,  0x2D50,  
      0xC05D,  0x29D7,  0x2EA9,  0x2EAA,  0xB844,  0,       0,       0,       // 0x344x
      0,       0,       0,       0,       0,       0,       0,       0xAFF4,  
      0,       0xAFF5,  0xAFF6,  0xAFF8,  0xAFF9,  0xAFFA,  0xAFFB,  0xAFFC,  // 0x345x
      0xAFFD,  0xAFFE,  0xB0A1,  0xB0A2,  0xB0A3,  0xB0A5,  0xB0A6,  0xB0A7,  
      0xB0A9,  0xB0AA,  0xB0AB,  0xB0AC,  0xB0AE,  0xB84C,  0,       0,       // 0x346x
      0xB847,  0,       0xB849,  0x2D53,  0,       0xB84E,  0xB0B0,  0xB0A8,  
      0,       0x2D5A,  0xB0AD,  0,       0,       0,       0,       0,       // 0x347x
      0x2EAC,  0x2EA8,  0,       0,       0,       0xAFF7,  0xB852,  0xC068,  
      0xC069,  0xC05F,  0x32F7,  0x33A1,  0x39B6,  0x3245,  0x3240,  0x32FD,  // 0x348x
      0xC067,  0xCA2E,  0,       0,       0,       0,       0,       0xC063,  
      0xB5CC,  0xB5CD,  0xB5CF,  0xB5D0,  0xB5D1,  0xB5D2,  0xB5D3,  0xB5D4,  // 0x349x
      0xB5D5,  0xB5D6,  0xB5D8,  0xB5D9,  0xB5DA,  0xB5DB,  0xB5DC,  0xB5DD,  
      0xB5DE,  0xB5DF,  0xB5E0,  0xB5E1,  0xB5E2,  0xB5E3,  0xB5E5,  0xB5E6,  // 0x34Ax
      0xC064,  0xC066,  0xC065,  0x3247,  0xC062,  0xC060,  0,       0xC061,  
      0,       0,       0,       0,       0,       0,       0x3244,  0x33A2,  // 0x34Bx
      0x32F8,  0x32FB,  0x32FA,  0x32FC,  0xC06A,  0,       0,       0xB5CE,  
      0xC05E,  0x3836,  0xCA34,  0x39B5,  0xD349,  0x382E,  0x39B8,  0xCA22,  // 0x34Cx
      0x39B2,  0x382B,  0x39B0,  0x39B4,  0x3831,  0xCA2D,  0xCA2F,  0x39BA,  
      0xCA24,  0xCA21,  0x39B7,  0xCA33,  0x39BC,  0x39BB,  0xCA26,  0x3830,  // 0x34Dx
      0xCA27,  0xCA2A,  0xCA31,  0x39C0,  0xD34A,  0x39BD,  0xCA38,  0xCA23,  
      0xCA25,  0xCA35,  0,       0,       0,       0,       0,       0x3833,  // 0x34Ex
      0x3838,  0xCA36,  0xCA37,  0xBBE4,  0xBBE5,  0xBBE7,  0xBBE8,  0xBBE9,  
      0xBBEB,  0xBBEC,  0xBBED,  0xBBEF,  0xBBF1,  0xBBF2,  0xBBF4,  0xBBF5,  // 0x34Fx
      0xBBF6,  0xBBF7,  0xBBF8,  0xBBF9,  0xBBFA,  0xBBFB,  0xBBFC,  0xBBFD,  
} ;


static const unsigned short Uni2cnsP2Table_35 [] = {
      0xBBFE,  0xBCA2,  0xBCA3,  0xBCA4,  0xBCA5,  0xBCA6,  0xBCA7,  0xBCA8,  // 0x350x
      0xBCAA,  0xBCAB,  0xBCAC,  0xBCAD,  0xBCAE,  0xBCAF,  0xCA29,  0xCA2B,  
      0,       0xCA2C,  0xCA32,  0x39C2,  0xCA30,  0xCA39,  0xCA28,  0,       // 0x351x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x352x
      0,       0,       0,       0x39BE,  0x39C1,  0x39AE,  0x39AF,  0x39B1,  
      0,       0xD34E,  0xD358,  0x3D77,  0xD356,  0x3D74,  0xD357,  0x3FEF,  // 0x353x
      0x3FEA,  0x3FEE,  0x3FEB,  0x3D6A,  0xD35B,  0x3FF3,  0xD361,  0x3FE8,  
      0x3D7A,  0x3FF4,  0x3FE9,  0xD355,  0x3FF0,  0x3FED,  0xD360,  0x3D73,  // 0x354x
      0xD359,  0xD35A,  0xD35D,  0xD350,  0x3D70,  0xD35C,  0x3FEC,  0,       
      0xD363,  0xD34F,  0xD351,  0xD34C,  0,       0,       0,       0,       // 0x355x
      0,       0xC2A3,  0,       0xC2A4,  0xC2A5,  0xC2A6,  0xC2A7,  0xC2A9,  
      0xC2AA,  0xC2AB,  0xC2AC,  0xC2AD,  0xC2AE,  0xC2B0,  0xC2B1,  0xC2B2,  // 0x356x
      0xC2B3,  0xC2B4,  0xC2B5,  0xC2B6,  0xC2B8,  0xC2B9,  0xC2BA,  0xC2BB,  
      0xC2BD,  0xC2BE,  0xC2BF,  0xC2C0,  0xC2C1,  0xC2C2,  0xC2C3,  0xC2C4,  // 0x357x
      0xC2C5,  0xC2C6,  0xC2C8,  0xC2CA,  0xC2CC,  0,       0,       0xD34D,  
      0xD352,  0xD354,  0x3D79,  0xD362,  0,       0,       0,       0xD34B,  // 0x358x
      0,       0,       0xD35F,  0,       0,       0,       0,       0,       
      0xC2A2,  0,       0,       0xC2AF,  0,       0xC2B7,  0,       0,       // 0x359x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x39BF,  0x3FF2,  0xD353,  0xC3F4,  0,       // 0x35Ax
      0x46CE,  0xC2CB,  0x46D0,  0x437B,  0x4372,  0x46CD,  0x46CF,  0xDD69,  
      0x46D5,  0x46D2,  0xA3E5,  0,       0xD364,  0x46C7,  0xDD5F,  0x46D4,  // 0x35Bx
      0x46C6,  0x46D8,  0xDD62,  0x46CA,  0x46D3,  0xDD63,  0x4376,  0x46C8,  
      0,       0x46C9,  0xDD65,  0x46CC,  0,       0,       0,       0,       // 0x35Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x46D1,  0,       0,       0,       0xC8D7,  0xC8D8,  0xC8D9,  0xC8DA,  // 0x35Dx
      0xC8DB,  0xC8DC,  0xC8DD,  0xC8DE,  0xC8DF,  0xC8E0,  0xC8E1,  0xC8E2,  
      0xC8E3,  0xC8E4,  0xC8E5,  0xC8E6,  0xC8E7,  0xC8E8,  0xC8E9,  0xC8EA,  // 0x35Ex
      0xC8EB,  0xC8EC,  0xC8ED,  0xC8EE,  0xC8EF,  0xC8F1,  0xC8F2,  0xC8F3,  
      0xC8F5,  0,       0,       0xC7CB,  0xDD6A,  0xDD67,  0,       0xDD6B,  // 0x35Fx
      0xDD6C,  0,       0x46D6,  0x46D7,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_36 [] = {
      0xC8F4,  0,       0,       0,       0,       0xDD64,  0,       0xDD66,  // 0x360x
      0,       0,       0,       0xC8D0,  0,       0xC8D1,  0xC8D3,  0xC8D4,  
      0xDD60,  0xDD6D,  0xDD61,  0,       0xC8D6,  0xA3E8,  0x4DE7,  0x4DDE,  // 0x361x
      0x4A3B,  0x4A47,  0x4DDB,  0x4A40,  0xA3F1,  0xA3EC,  0xA3F4,  0x4DEB,  
      0x4DE5,  0xA3F0,  0x4A46,  0x4DDF,  0x4A3F,  0x4DE4,  0x4A43,  0x4A3E,  // 0x362x
      0x4A35,  0xA3F3,  0x4DDC,  0x4A4A,  0x4DE9,  0xA3EE,  0x4DE3,  0x4DEA,  
      0xA3E9,  0x4A41,  0x4DDD,  0xA3F5,  0,       0,       0,       0,       // 0x363x
      0,       0,       0,       0x4A3C,  0,       0,       0,       0x4A45,  
      0,       0x4A49,  0xA3E6,  0xA3EA,  0xCFBD,  0xCFBE,  0xCFBF,  0xCFC3,  // 0x364x
      0xCFC4,  0xCFC6,  0xCFC7,  0xCFC8,  0xCFC9,  0xCFCA,  0xCFCB,  0xCFCC,  
      0xCFCD,  0xCFCE,  0xCFCF,  0xCFD0,  0xCFD1,  0xCFD2,  0xCFD3,  0,       // 0x365x
      0,       0xCFC0,  0,       0xA3EB,  0,       0,       0,       0,       
      0,       0,       0,       0,       0x4DEC,  0,       0,       0,       // 0x366x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x4DE8,  0x4DE6,  0xA3E7,  0xA3ED,  0x4DE0,  0x4DDA,  0x4DE2,  0,       // 0x367x
      0,       0,       0,       0x505B,  0x54FD,  0xAEE9,  0x5065,  0x5058,  
      0x5BE5,  0xB8CC,  0xAEE0,  0xAEE3,  0x54FB,  0xAEE8,  0xAEF2,  0x54FA,  // 0x368x
      0xAEEF,  0xAEE2,  0x5062,  0x564C,  0x5057,  0xAEDF,  0x505F,  0x54F9,  
      0xAEE7,  0xAEE4,  0x54F1,  0,       0x54F7,  0x505C,  0xAEEE,  0xAEF4,  // 0x369x
      0x54F8,  0x505D,  0xAEE6,  0xAEEB,  0x5063,  0x54F0,  0xAEE1,  0x61FB,  
      0x54F5,  0x54F6,  0x54F2,  0x4A44,  0xAEF3,  0xAEEC,  0xAEE5,  0,       // 0x36Ax
      0xAEDE,  0x54FC,  0x54EF,  0,       0,       0,       0,       0x54F3,  
      0xD4EF,  0xD4F0,  0xD4F1,  0xD4F2,  0xD4F3,  0xD4F5,  0xD4F6,  0xD4F7,  // 0x36Bx
      0xD4F8,  0xD4F9,  0xD4FA,  0xD4FC,  0xD4FD,  0xD4FE,  0xD5A1,  0xD5A2,  
      0xD5A4,  0xD5A5,  0xD5A6,  0xD5A7,  0xD5A8,  0xD5AB,  0xD5AC,  0xD5AD,  // 0x36Cx
      0xD5AE,  0xD5AF,  0xD5B0,  0xD5B2,  0xD5B3,  0xD5B4,  0xD5B5,  0xD5B6,  
      0xD5B7,  0xD5B8,  0,       0,       0,       0,       0xAEF0,  0,       // 0x36Dx
      0xAEF1,  0,       0x5061,  0,       0,       0,       0,       0xD5A3,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x36Ex
      0,       0,       0,       0x54F4,  0xC8F0,  0,       0xCFC1,  0,       
      0xAEED,  0x5643,  0xB8D0,  0xB8CE,  0x5647,  0xB8D2,  0xB8D6,  0x5BEA,  // 0x36Fx
      0x5BEB,  0x564A,  0x5646,  0x5BEE,  0xB8D3,  0x5BEC,  0,       0xB8D1,  
} ;


static const unsigned short Uni2cnsP2Table_37 [] = {
      0xB8D7,  0x61FC,  0x5BE7,  0x564D,  0x5644,  0xB8D9,  0x5642,  0x5BE9,  // 0x370x
      0xB8DB,  0,       0,       0,       0,       0x5BE6,  0xB8D4,  0xDAC0,  
      0xDAC1,  0xDAC3,  0xDAC4,  0xDAC5,  0xDAC6,  0xDAC7,  0xDAC8,  0xDAC9,  // 0x371x
      0xDACA,  0xDACB,  0xDACC,  0xDACE,  0xDACF,  0xDAD1,  0xDAD2,  0xDAD4,  
      0,       0,       0,       0xB8D8,  0x5BED,  0xB8DA,  0xB8CD,  0xB8CF,  // 0x372x
      0xB7A7,  0,       0,       0,       0xDAD3,  0,       0,       0xDACD,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x373x
      0,       0x5BEF,  0x5BF0,  0,       0xD5B1,  0,       0,       0xDAD0,  
      0,       0x5B47,  0x61F8,  0xC0A7,  0xC0A3,  0x5B42,  0xC0AB,  0x62A4,  // 0x374x
      0x61FD,  0x62A6,  0xC0A9,  0x5B45,  0x61FA,  0x62A2,  0x62A7,  0x61FE,  
      0xB8DC,  0x62AB,  0x61F9,  0x5B43,  0x5B4C,  0x5B46,  0xC0AD,  0xC0A8,  // 0x375x
      0x62A3,  0xC7C6,  0x62A9,  0xC0A6,  0x5B4B,  0x62A8,  0x62A5,  0,       
      0,       0,       0,       0,       0,       0x61F6,  0,       0xBFFC,  // 0x376x
      0xBFFD,  0xDEFE,  0xDFA2,  0xDFA3,  0xDFA4,  0xDFA5,  0xDFA6,  0xDFA7,  
      0xDFA8,  0xDFAA,  0xDFAB,  0xDFAC,  0xDFAE,  0xDFAF,  0xDFB0,  0xC0A1,  // 0x377x
      0,       0xC0A5,  0,       0xC0AC,  0xC0AA,  0,       0x62A1,  0,       
      0,       0xDFA1,  0,       0,       0,       0,       0x62AA,  0x61F7,  // 0x378x
      0,       0xC0A2,  0,       0xC0A4,  0xDFAD,  0,       0,       0,       
      0x68A5,  0xC7C3,  0x68A8,  0x68AB,  0x68A9,  0xC7C2,  0xC7C0,  0x68AD,  // 0x379x
      0xC7C1,  0x5F74,  0xC7C8,  0xC7C9,  0x68A7,  0x68A6,  0xC7C5,  0x68AF,  
      0,       0,       0,       0xC7C7,  0xBFFE,  0xE2D2,  0xE2D6,  0xE2D8,  // 0x37Ax
      0xE2D9,  0xE2DA,  0xE2DB,  0xE2DC,  0xE2DD,  0xE2DF,  0xE2E0,  0xE2E1,  
      0x68AE,  0,       0xC7C4,  0,       0,       0xC7BF,  0xE2D4,  0x68AC,  // 0x37Bx
      0,       0,       0,       0xE2D7,  0xE2CF,  0,       0,       0xE2DE,  
      0,       0,       0xDEFD,  0,       0x6353,  0xCDFC,  0x6CBF,  0xCDFE,  // 0x37Cx
      0x6CC2,  0x68B0,  0x6CBA,  0x6CB9,  0x6CBD,  0xCDFD,  0x6CBC,  0x6CC1,  
      0x6CBB,  0x68AA,  0x6CC0,  0,       0,       0,       0,       0,       // 0x37Dx
      0x6CBE,  0xE5B3,  0xE5B4,  0xE5B5,  0xE5B6,  0xE5B7,  0xE5B9,  0xE5BA,  
      0xE5BB,  0xE5BC,  0xE5BD,  0xE5BF,  0,       0,       0,       0,       // 0x37Ex
      0xCEA1,  0,       0,       0,       0x6352,  0,       0,       0xD3C9,  
      0xD3C8,  0,       0x70AB,  0x70AD,  0x6646,  0x70A9,  0xD3CD,  0,       // 0x37Fx
      0x70A8,  0x70AA,  0x70AC,  0xD3CA,  0x6645,  0x70AF,  0xD3CE,  0,       
} ;


static const unsigned short Uni2cnsP2Table_38 [] = {
      0,       0x70B2,  0xE7DB,  0xE7DC,  0xE7DD,  0xE7DE,  0xE7DF,  0xE7E0,  // 0x380x
      0xE7E1,  0xE7E2,  0xE7E3,  0xE7E4,  0xD3CC,  0,       0x70B1,  0x70B0,  
      0xD3CB,  0,       0,       0,       0x70AE,  0,       0,       0,       // 0x381x
      0,       0xD8A6,  0x73CE,  0x73CF,  0x73CC,  0x73CA,  0x686F,  0x73CB,  
      0x73CD,  0xD8A5,  0,       0,       0,       0xE9C7,  0xE9C8,  0xE9C9,  // 0x382x
      0xE9CB,  0xE9CE,  0xE9CF,  0xE9D0,  0xE9D1,  0xD8A4,  0xD8A2,  0,       
      0,       0,       0,       0,       0,       0xE7E5,  0,       0x75F1,  // 0x383x
      0x75F3,  0x77E0,  0x75F4,  0xDBE0,  0x75F2,  0xDBE1,  0x75F5,  0xDBDF,  
      0x77E1,  0,       0,       0xDBDD,  0xEAD7,  0xEAD9,  0xDBDE,  0,       // 0x384x
      0,       0x75F6,  0x75F0,  0,       0x6B6C,  0xDEEE,  0x77E2,  0xE0F1,  
      0xEBCE,  0xEBCF,  0xEBD0,  0xEBD3,  0xEBD4,  0,       0,       0,       // 0x385x
      0xDEEF,  0,       0,       0xDEF0,  0xEAD8,  0,       0xE0F2,  0,       
      0x79AD,  0,       0xECAC,  0xE0F3,  0,       0x79AC,  0,       0x79AE,  // 0x386x
      0xEBD2,  0x7AA9,  0xE3D4,  0xE0F4,  0,       0x6D55,  0xECAD,  0,       
      0,       0xECCC,  0xECE3,  0xE3CC,  0xE3D5,  0,       0x7BC0,  0xE4C8,  // 0x387x
      0xE4C9,  0,       0xE5DB,  0xEDAF,  0xE5F4,  0,       0,       0,       
      0xA524,  0x244B,  0xA82F,  0xAC2E,  0xA832,  0x24C7,  0xA831,  0x244A,  // 0x388x
      0,       0x26DC,  0x26DB,  0x26D8,  0xAC2F,  0x266F,  0xAC30,  0x26DD,  
      0x266E,  0x26D9,  0x26DA,  0x26D7,  0xA7D6,  0,       0,       0x29DF,  // 0x389x
      0xB17A,  0xB854,  0xB17C,  0x29E2,  0x2975,  0x29E1,  0x29DE,  0xB179,  
      0x29DC,  0x29E0,  0xB17B,  0x29DD,  0,       0,       0xACF7,  0xB857,  // 0x38Ax
      0xB858,  0xB855,  0x2EB3,  0,       0x2EAD,  0xB856,  0xC06B,  0x2EB2,  
      0x2D5F,  0x2EAF,  0x2EB4,  0x2EB1,  0x2EB0,  0xB0B1,  0,       0,       // 0x38Bx
      0,       0,       0x33A5,  0xC06C,  0,       0xC06D,  0,       0xB5E7,  
      0xB5E8,  0xB5E9,  0xB5EA,  0xB5EB,  0xB5EC,  0xB5ED,  0xB5EE,  0,       // 0x38Cx
      0x383D,  0x39C7,  0x3FF7,  0x383A,  0x39C5,  0xCA3C,  0x33A4,  0x39C8,  
      0xCA3D,  0x39C4,  0x39C9,  0xCA3E,  0,       0x39C6,  0xCA3B,  0xBCB0,  // 0x38Dx
      0xBCB1,  0xCA3A,  0,       0,       0,       0xD36E,  0x3FF6,  0x3FF5,  
      0x3FFA,  0xD36B,  0x3FF9,  0xD367,  0xD366,  0xD368,  0xD369,  0xD36A,  // 0x38Ex
      0xD36D,  0x3FF8,  0,       0xC2CE,  0xD85A,  0,       0,       0xD36C,  
      0xD365,  0xC2CD,  0x46DC,  0x442B,  0x46DE,  0xDD6F,  0xDD6E,  0x442C,  // 0x38Fx
      0x46DD,  0x4429,  0xDD75,  0xDD70,  0x46DA,  0xDD76,  0xDD74,  0x46DB,  
} ;


static const unsigned short Uni2cnsP2Table_39 [] = {
      0xDD72,  0xDD71,  0xDD73,  0xD36F,  0xC8F6,  0xC8F8,  0,       0x46D9,  // 0x390x
      0x4DEE,  0xA3FD,  0x4DF0,  0x4DF1,  0x4A4D,  0xA3F9,  0xA3F7,  0xA3FE,  
      0xA3F6,  0xA3FA,  0xA3FB,  0,       0x4DEF,  0xCFD4,  0,       0xA3FC,  // 0x391x
      0x54FE,  0xAEF6,  0x5068,  0,       0xAEF5,  0xD5BA,  0xD5BB,  0,       
      0xB8DE,  0xB8E0,  0x5BF1,  0xB8DF,  0xDAD5,  0xB8DD,  0,       0,       // 0x392x
      0,       0x62AC,  0,       0,       0x68B2,  0x68B1,  0xE2E2,  0,       
      0,       0x70B6,  0xCEA3,  0,       0x70B5,  0x70B4,  0x6870,  0x70B3,  // 0x393x
      0,       0x73D0,  0xD8A9,  0xD8A7,  0xD8A8,  0,       0x77E3,  0xE0F5,  
      0x6C70,  0x6D56,  0x21B2,  0x21F0,  0xA32E,  0xA526,  0,       0x24CA,  // 0x394x
      0xA834,  0xAC31,  0x24C9,  0x24CB,  0xA833,  0xAC3C,  0xAC34,  0xAC3B,  
      0xAC3A,  0xAC36,  0xAC33,  0xAC38,  0xAC32,  0xAC37,  0x26DE,  0xAC39,  // 0x395x
      0xAC35,  0x26DF,  0,       0xA7D7,  0xA7D8,  0xA7D9,  0,       0,       
      0x2672,  0,       0x2976,  0x29E3,  0,       0x28B5,  0xB859,  0xB85C,  // 0x396x
      0x2EB5,  0xB85A,  0xB85E,  0xB85D,  0,       0xB85B,  0,       0,       
      0,       0,       0xB748,  0x33A6,  0xC070,  0xB5EF,  0,       0,       // 0x397x
      0xC06F,  0x3840,  0x383E,  0x39CA,  0x39CB,  0xCA43,  0x3841,  0xCA42,  
      0,       0xCA44,  0xCA40,  0xCA45,  0xCA46,  0xCA41,  0,       0x3FFC,  // 0x398x
      0xD370,  0x3FFB,  0xC2CF,  0xDA61,  0,       0,       0,       0,       
      0,       0,       0,       0,       0xA4A2,  0xA4A5,  0xA4A3,  0xA4A6,  // 0x399x
      0xA4A1,  0xA4A4,  0xCFD5,  0,       0xAEFA,  0xAEF9,  0xAEF7,  0xAEF8,  
      0,       0xB8E1,  0x5650,  0,       0xDAD6,  0xDAD7,  0x62AD,  0x62AE,  // 0x39Ax
      0xC0AE,  0,       0,       0,       0,       0,       0,       0x73D1,  
      0,       0xDBE2,  0xDBE3,  0,       0,       0x21F1,  0x21C9,  0x22F6,  // 0x39Bx
      0xA835,  0x227D,  0xA527,  0x24CC,  0x244D,  0xA528,  0,       0xA836,  
      0xA83B,  0xA837,  0x244C,  0xA83C,  0x24CD,  0xA839,  0xA838,  0xA83A,  // 0x39Cx
      0,       0xAC3F,  0x26E0,  0x26E6,  0x26E1,  0x26E4,  0x2673,  0x2674,  
      0x26E3,  0x2677,  0xAC3D,  0xAC3E,  0xAC40,  0xB17D,  0x26E5,  0,       // 0x39Dx
      0,       0,       0,       0,       0,       0x29E8,  0x2978,  0x2979,  
      0xB226,  0x2977,  0xB17E,  0x29E4,  0x29E5,  0x29EB,  0x29E6,  0x29E7,  // 0x39Ex
      0xB225,  0x297A,  0xB222,  0xB223,  0x29EA,  0xB224,  0xB85F,  0xABD0,  
      0xB221,  0x29EC,  0x2EB6,  0x2D63,  0xB862,  0x2EBB,  0xB865,  0x2EBC,  // 0x39Fx
      0x2EB8,  0x2EB9,  0,       0xB863,  0xB866,  0x2EBD,  0x2EB7,  0x2EBA,  
} ;


static const unsigned short Uni2cnsP2Table_3A [] = {
      0x2EBE,  0xB860,  0,       0xB861,  0,       0x33AB,  0xC074,  0x33AA,  // 0x3A0x
      0xC073,  0x33A7,  0x33A8,  0x33A9,  0xC071,  0x324B,  0x33AC,  0xCA49,  
      0xC075,  0xC072,  0xB5F1,  0,       0,       0,       0xD372,  0xCA4A,  // 0x3A1x
      0x39D3,  0x3848,  0xCA4B,  0x3843,  0x39CE,  0x39CD,  0x39CF,  0x3847,  
      0x39D2,  0x39D4,  0x39D0,  0x39CC,  0x39D1,  0xCA4C,  0xD371,  0,       // 0x3A2x
      0xCA48,  0xBCB2,  0,       0,       0,       0,       0,       0xD374,  
      0,       0xD379,  0x3FFD,  0x3FFE,  0xD376,  0xD378,  0x3E25,  0xDD78,  // 0x3A3x
      0xD37A,  0xD375,  0,       0xD373,  0,       0xC2D0,  0,       0,       
      0,       0,       0,       0xB5F0,  0x4434,  0x442E,  0xDD7B,  0xDD7C,  // 0x3A4x
      0x442F,  0xDD79,  0,       0xDD7A,  0xDD2D,  0xA4A9,  0x4A51,  0x4DF2,  
      0xA4A7,  0x4DF5,  0xA4A8,  0xA4AB,  0x4DF4,  0x5069,  0xA4AC,  0xA4AA,  // 0x3A5x
      0xCFD6,  0x4DF3,  0,       0,       0,       0xAEFB,  0xAEFC,  0x55A1,  
      0x506C,  0x55A3,  0x55A2,  0xAEFE,  0xD5BC,  0xD5BD,  0,       0,       // 0x3A6x
      0xB8E4,  0xB8E2,  0x5BF3,  0xB8E5,  0xB8E3,  0x5BF4,  0,       0x62B0,  
      0x62AF,  0x5B4D,  0xC0B0,  0xAEFD,  0x5BF5,  0,       0xC0AF,  0x68B3,  // 0x3A7x
      0,       0,       0x70B7,  0x70B8,  0xD3CF,  0,       0xD8AA,  0x75FA,  
      0x75F9,  0,       0x26E8,  0x26E7,  0,       0xB227,  0xB228,  0,       // 0x3A8x
      0x2EBF,  0,       0,       0x324C,  0x324D,  0xC078,  0xC079,  0xC076,  
      0xC077,  0xB5F3,  0xB5F5,  0xB5F6,  0xB5F7,  0xC07B,  0xC07A,  0x33AD,  // 0x3A9x
      0,       0xCA4F,  0,       0xCA4E,  0xBCB3,  0,       0,       0xB5F2,  
      0xD421,  0xD422,  0,       0xD37D,  0xD37E,  0xD424,  0xC2D1,  0xC2D2,  // 0x3AAx
      0,       0xD423,  0xD37C,  0,       0x40A1,  0x40FB,  0x46E1,  0x4436,  
      0xDE21,  0x4437,  0xDD7E,  0xDD7D,  0,       0xC8FA,  0x4DF6,  0xDE22,  // 0x3ABx
      0xA4AD,  0x4A52,  0,       0xAFA5,  0xAFA3,  0xAFA6,  0xAFA1,  0xAFA4,  
      0x55A4,  0xAFA2,  0,       0,       0,       0xD5BE,  0xD5BF,  0xD5C0,  // 0x3ACx
      0,       0,       0,       0,       0xB8E6,  0xB8E7,  0,       0,       
      0x5B4E,  0xC0B3,  0x62B2,  0x62B1,  0,       0,       0xC0B1,  0,       // 0x3ADx
      0xC0B2,  0x5F78,  0xC7CC,  0,       0,       0,       0xCEA5,  0xC7CD,  
      0,       0xD3D0,  0x6A4D,  0x75FB,  0xDBE4,  0x73D2,  0xDEF3,  0x77E5,  // 0x3AEx
      0x77E4,  0xE0F6,  0,       0xE3D6,  0x21F2,  0xA83D,  0,       0xAC41,  
      0xB229,  0,       0,       0,       0xB867,  0,       0,       0,       // 0x3AFx
      0xBCB4,  0x40A2,  0x4A53,  0,       0xCFD7,  0xCFD8,  0xDAD9,  0xD5C1,  
} ;


static const unsigned short Uni2cnsP2Table_3B [] = {
      0xE2E3,  0xEADA,  0x24CF,  0xA83E,  0xAC45,  0xAC44,  0x26E9,  0,       // 0x3B0x
      0xB868,  0xB86A,  0xB869,  0xC07C,  0xC07D,  0x40A3,  0x3E26,  0x46E2,  
      0x46E3,  0xDE23,  0xA4AE,  0xAFA7,  0xAFA8,  0x55A5,  0xC7CE,  0x6CC3,  // 0x3B1x
      0,       0,       0x79B0,  0x21CA,  0x227E,  0,       0xA2DA,  0xA2DB,  
      0,       0xA840,  0xA83F,  0x244E,  0xA4D5,  0xA4D6,  0xA4D7,  0xA4D9,  // 0x3B2x
      0xA4DA,  0x26ED,  0x26EA,  0x26EC,  0x26EB,  0xAC47,  0xAC46,  0xA7DA,  
      0xA7DC,  0xA7DD,  0xA7DE,  0xA7DF,  0,       0x26C3,  0,       0,       // 0x3B3x
      0xB22C,  0x29EE,  0x29EF,  0x29ED,  0x29F0,  0x29F1,  0xB22D,  0x29F3,  
      0xB22F,  0xB86D,  0xB22E,  0,       0x29F4,  0xB22B,  0,       0x29F2,  // 0x3B4x
      0,       0xABD1,  0xABD2,  0xABD3,  0xABD4,  0xABD5,  0xABD6,  0xABD7,  
      0xABD8,  0xABD9,  0xABDA,  0xABDB,  0xABDC,  0xABDE,  0,       0,       // 0x3B5x
      0,       0,       0xABDD,  0,       0xB86F,  0x2EC1,  0xB86E,  0x2D69,  
      0x2EC3,  0x2D68,  0xB86C,  0x2EC2,  0,       0xB0B2,  0xB0B3,  0xB0B4,  // 0x3B6x
      0xB0B5,  0xB0B6,  0xB0B7,  0xB0B8,  0xB0B9,  0xB86B,  0x2EC0,  0,       
      0,       0xC126,  0x3256,  0xC121,  0x33B1,  0xC122,  0xC123,  0x33AE,  // 0x3B7x
      0xC125,  0x33B2,  0x33B0,  0x33AF,  0xC07E,  0xC124,  0xB5F8,  0xB5F9,  
      0xB5FA,  0xB5FB,  0xB5FC,  0,       0,       0,       0,       0,       // 0x3B8x
      0x39D5,  0x384D,  0x39D6,  0x3850,  0xCA51,  0xCA53,  0x39D9,  0x39D8,  
      0x39DA,  0xCA56,  0xCA50,  0xCA55,  0x39D7,  0xCA52,  0,       0xBCBA,  // 0x3B9x
      0xBCB5,  0xBCB7,  0xBCB8,  0xBCB9,  0xBCBB,  0xBCBD,  0xBCBF,  0xBCC0,  
      0,       0,       0,       0xCA54,  0xBCB6,  0,       0,       0x39DC,  // 0x3BAx
      0xD42E,  0xD42C,  0x3E2B,  0xD427,  0xD42B,  0x3E2A,  0xD428,  0xD425,  
      0xD429,  0xD426,  0xD42D,  0xD42A,  0xD42F,  0,       0,       0,       // 0x3BBx
      0,       0x40A4,  0xC2D3,  0xC2D5,  0xC2D6,  0xC2D7,  0,       0,       
      0,       0,       0xD430,  0,       0,       0xDE29,  0x46E6,  0x46E5,  // 0x3BCx
      0xDE2A,  0xDE2B,  0xDE2D,  0x443D,  0xDE24,  0x443E,  0x46E7,  0x443B,  
      0,       0xDE2E,  0xDE2F,  0xDE26,  0,       0xDE27,  0xC8FC,  0xC8FD,  // 0x3BDx
      0xC8FE,  0xC9A1,  0,       0xDE28,  0x46E9,  0xDE30,  0,       0xDE25,  
      0,       0,       0xDE2C,  0,       0x4A56,  0xA4B3,  0xA4B7,  0xA4B5,  // 0x3BEx
      0x4A55,  0x4A54,  0x4DF9,  0xA4B4,  0x4DF7,  0x4DF8,  0xA4B1,  0xA4B2,  
      0xA4B0,  0xA4AF,  0xA4B6,  0,       0,       0,       0,       0xA4B8,  // 0x3BFx
      0xAFA9,  0x55A7,  0xAFAA,  0x5070,  0x55A6,  0x5073,  0xAFAC,  0xD5C2,  
} ;


static const unsigned short Uni2cnsP2Table_3C [] = {
      0xD5C3,  0xD5C4,  0xD5C5,  0,       0,       0,       0xAFAB,  0,       // 0x3C0x
      0,       0xA4B9,  0xB8EA,  0x5655,  0x5654,  0xB8E9,  0x5BF6,  0,       
      0xB8E8,  0xDADA,  0xDADB,  0xDADC,  0xB8EC,  0,       0xB8EB,  0,       // 0x3C1x
      0,       0,       0x62B5,  0x62B4,  0x62B6,  0,       0xC0B7,  0xC7CF,  
      0xC0B5,  0x62B7,  0xC0B4,  0xC0B6,  0xDFB1,  0,       0,       0,       // 0x3C2x
      0x62B3,  0,       0xDFB2,  0xC7D2,  0x68B4,  0xC7D0,  0xC7D1,  0,       
      0,       0xE5C1,  0xCEA6,  0,       0,       0,       0x6647,  0x70B9,  // 0x3C3x
      0xD3D1,  0xE7E7,  0,       0xD8AB,  0x73D3,  0,       0xE9D2,  0x75FC,  
      0xDBE5,  0,       0,       0,       0xE4CA,  0xAC48,  0,       0xB230,  // 0x3C4x
      0x29F5,  0x29F6,  0xB34C,  0xC127,  0xB5FD,  0,       0xC128,  0xD431,  
      0x4440,  0xAFAD,  0xB8ED,  0x5B51,  0xDADD,  0xA52A,  0xA529,  0,       // 0x3C5x
      0xA4DC,  0xAC4B,  0xAC4A,  0xAC49,  0xB231,  0,       0xB232,  0xABDF,  
      0x29F7,  0x2EC4,  0,       0xB5FE,  0x39DD,  0xBCC1,  0xD432,  0,       // 0x3C6x
      0,       0,       0xA4BB,  0xA4BA,  0,       0,       0xC0B8,  0xD3D2,  
      0,       0,       0xA1E7,  0,       0xA224,  0xA52B,  0x21F3,  0xA52C,  // 0x3C7x
      0xA2DE,  0xA4E9,  0,       0,       0,       0,       0,       0,       
      0x2323,  0xA52D,  0x24D0,  0xA52F,  0xA531,  0,       0xA4A4,  0xA2DC,  // 0x3C8x
      0xA4DF,  0xA4E0,  0,       0xA530,  0,       0,       0xAC4D,  0x24D2,  
      0xA842,  0x24D1,  0x24D3,  0x2450,  0xA846,  0xA847,  0,       0,       // 0x3C9x
      0,       0,       0,       0,       0,       0xAC4C,  0xA843,  0xA841,  
      0xA845,  0xA848,  0,       0,       0,       0xA4E1,  0,       0xA4DE,  // 0x3CAx
      0xA4E2,  0xA4E3,  0xA4E4,  0xA4E5,  0xA4E6,  0xA4E7,  0xA7E3,  0xA7E4,  
      0xA7E5,  0,       0x2723,  0x26EF,  0xB233,  0x26F2,  0x26F3,  0x2721,  // 0x3CBx
      0xAC57,  0x2725,  0xAC50,  0x2724,  0xAC4E,  0x26EE,  0x26F0,  0xAC58,  
      0x26F1,  0xAC5A,  0xB234,  0,       0xAC56,  0xAC5C,  0,       0,       // 0x3CCx
      0,       0,       0x267C,  0xAC53,  0xA7E0,  0xA7E1,  0xA7E2,  0xA7E7,  
      0xA7E8,  0xA7E9,  0xA7EA,  0xA7EB,  0xA7ED,  0xABE4,  0xABE7,  0xABEC,  // 0x3CDx
      0xAC52,  0xAC54,  0xAC55,  0xAC59,  0,       0xAC4F,  0,       0,       
      0,       0,       0,       0x29F8,  0x297C,  0xB236,  0x2AA2,  0xB23B,  // 0x3CEx
      0xB23E,  0x29F9,  0x2A22,  0x2D71,  0x2AA1,  0x29FE,  0xB23A,  0xB240,  
      0x29FA,  0xB241,  0x29FD,  0xB870,  0xB23D,  0xB23C,  0x2A23,  0x297D,  // 0x3CFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_3D [] = {
      0,       0xB23F,  0xABE0,  0xABE1,  0xABE2,  0xABE3,  0xABE5,  0xABE6,  // 0x3D0x
      0xABE8,  0xABE9,  0xABEA,  0xABEB,  0xABED,  0xABEE,  0xB0BA,  0xB0BD,  
      0xB0C4,  0xB238,  0x2A24,  0,       0xB235,  0xB237,  0x2AA3,  0,       // 0x3D1x
      0,       0,       0,       0,       0,       0xB0D7,  0x2D6E,  0x2EC9,  
      0xB930,  0xB92E,  0x2EC8,  0x2EC7,  0xB87C,  0x2ECA,  0xB871,  0xB87B,  // 0x3D2x
      0x2D6D,  0x2D6F,  0xB925,  0xB876,  0xB926,  0xB92A,  0xB877,  0xB929,  
      0xB87E,  0xB928,  0xC12A,  0xC129,  0x3266,  0xB924,  0xB92C,  0x2EC5,  // 0x3D3x
      0xB923,  0xB873,  0xB92B,  0xB878,  0xB92F,  0,       0xB932,  0,       
      0,       0,       0xC146,  0xB0BB,  0xB0BE,  0xB0BF,  0xB0C0,  0xB0C1,  // 0x3D4x
      0xB0C2,  0xB0C3,  0xB0C5,  0xB0C6,  0xB0C7,  0xB0C8,  0xB0CA,  0xB0CB,  
      0xB0CC,  0xB0CD,  0xB0CE,  0xB0CF,  0xB0D0,  0xB0D1,  0xB0D2,  0xB0D3,  // 0x3D5x
      0xB0D4,  0xB0D5,  0xB0D6,  0xB0D8,  0xB0D9,  0xB0DA,  0xB879,  0,       
      0,       0,       0xB922,  0,       0xB931,  0,       0x2D72,  0,       // 0x3D6x
      0xB927,  0xB87D,  0,       0,       0xB875,  0,       0,       0,       
      0,       0x2EC6,  0,       0xB6AD,  0,       0,       0,       0x325D,  // 0x3D7x
      0x33C0,  0x325B,  0x326B,  0xC134,  0xC138,  0xC13C,  0x326A,  0xC143,  
      0x3261,  0xC136,  0x3265,  0xC135,  0xC145,  0x3269,  0x33B3,  0xC131,  // 0x3D8x
      0x3260,  0x3267,  0xCA64,  0x33BF,  0xC142,  0x33BE,  0xC13F,  0x3259,  
      0x325F,  0xC12C,  0x252F,  0xC13B,  0xC130,  0xCA66,  0x33B8,  0,       // 0x3D9x
      0x33C1,  0xCA58,  0xCA59,  0xC13E,  0xC144,  0x33B6,  0x3262,  0xC140,  
      0,       0x33BB,  0xC12F,  0xC132,  0x33BA,  0x33B5,  0x326C,  0,       // 0x3DAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x326E,  0,       0,       // 0x3DBx
      0,       0,       0,       0,       0,       0,       0x33B7,  0xC13D,  
      0xB6A1,  0xB6A2,  0xB6A3,  0xB6A5,  0xB6A6,  0xB6A7,  0xB6A8,  0xB6AA,  // 0x3DCx
      0xB6AC,  0xB6AE,  0xB6AF,  0xB6B0,  0xB6B1,  0xB6B2,  0xB6B6,  0xB6B7,  
      0xB6B8,  0xB6B9,  0xB6BA,  0xB6BB,  0xB6BC,  0xB6BD,  0xBCC2,  0xBCCB,  // 0x3DDx
      0xBCCD,  0xBCD7,  0xC2DF,  0xCA57,  0,       0xC133,  0,       0xC137,  
      0,       0x33B9,  0xC13A,  0,       0xC139,  0,       0xC147,  0xC12D,  // 0x3DEx
      0,       0xC12E,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x33B4,  0x33BC,  0,       // 0x3DFx
      0,       0,       0,       0xB87A,  0xCA62,  0xCA70,  0x3854,  0x39E3,  
} ;


static const unsigned short Uni2cnsP2Table_3E [] = {
      0x3855,  0xCA5D,  0xCA5F,  0x39E7,  0x39EA,  0x39E2,  0xD448,  0x39EC,  // 0x3E0x
      0xCA5A,  0x3853,  0x33C2,  0x3858,  0xCA6C,  0xCA5C,  0x39E8,  0xCA71,  
      0xD435,  0xCA67,  0xCA68,  0xCA6E,  0x39E0,  0xD434,  0xCA6F,  0x3E2C,  // 0x3E1x
      0x39DF,  0x39E6,  0x39E5,  0x39E4,  0xCA6A,  0x39E1,  0xD433,  0xCA72,  
      0x39ED,  0xCA61,  0,       0,       0,       0,       0,       0,       // 0x3E2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0xBCC4,  0xBCC5,  0xBCC6,  0xBCC8,  0xBCC9,  0xBCCA,  // 0x3E3x
      0xBCCE,  0xBCCF,  0xBCD0,  0xBCD1,  0xBCD2,  0xBCD3,  0xBCD4,  0xBCD5,  
      0xBCD6,  0xBCD8,  0xBCD9,  0xBCDB,  0xBCDC,  0,       0xCA69,  0x39E9,  // 0x3E4x
      0,       0xCA6B,  0x385D,  0,       0xCA5B,  0xCA60,  0xCA5E,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x3E5x
      0,       0,       0x39EB,  0xC2F3,  0,       0xD441,  0x40A5,  0x3E41,  
      0xD438,  0x3E34,  0xD43B,  0xD443,  0x3E3B,  0x3E43,  0x3E3E,  0x3E2E,  // 0x3E6x
      0xD44A,  0x40A9,  0x40A6,  0x3E40,  0xDE31,  0xD442,  0x3E3A,  0x40AF,  
      0,       0x40AD,  0x3E31,  0xDE32,  0x3E42,  0x40AC,  0x40AE,  0xD43E,  // 0x3E7x
      0xD44C,  0xA4BC,  0xD447,  0x444B,  0xD43F,  0xD446,  0xD437,  0xD436,  
      0x40AB,  0x40A8,  0,       0,       0,       0,       0,       0,       // 0x3E8x
      0,       0,       0,       0,       0x3E3D,  0xD43C,  0xD43D,  0xD440,  
      0xD445,  0xC2D8,  0xC2D9,  0xC2DA,  0xC2DB,  0xC2DC,  0xC2DD,  0xC2DE,  // 0x3E9x
      0xC2E0,  0xC2E1,  0xC2E2,  0xC2E5,  0xC2E6,  0xC2E7,  0xC2E8,  0xC2E9,  
      0xC2EA,  0xC2EC,  0xC2ED,  0xC2EE,  0xC2EF,  0xC2F0,  0xC2F1,  0xC2F2,  // 0x3EAx
      0xC2F5,  0xC9A2,  0xC9BE,  0,       0x40AA,  0,       0,       0xD444,  
      0x3E35,  0xD44D,  0xD43A,  0,       0xD44B,  0,       0xC9AF,  0,       // 0x3EBx
      0,       0,       0,       0,       0,       0,       0,       0xC2EB,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x3ECx
      0,       0,       0xCFEC,  0,       0xD439,  0xA4BD,  0,       0x4454,  
      0x4447,  0x4448,  0x444C,  0x46EB,  0x444E,  0x46EA,  0x46F4,  0x46F6,  // 0x3EDx
      0x4445,  0x4453,  0xDE44,  0x46EF,  0xDE41,  0xDE3A,  0x4451,  0x4450,  
      0x46F5,  0x46F2,  0x46ED,  0xA4C0,  0xA4BF,  0x46F7,  0xDE45,  0x444F,  // 0x3EEx
      0xDE39,  0xDE42,  0x46F0,  0x46F1,  0x4441,  0xDE3D,  0x4DFA,  0xA4BE,  
      0xDE34,  0x46EE,  0xDE3F,  0,       0,       0,       0,       0,       // 0x3EFx
      0,       0,       0,       0,       0,       0,       0,       0x46F3,  
} ;


static const unsigned short Uni2cnsP2Table_3F [] = {
      0xC9A3,  0xC9A4,  0xC9A5,  0xC9A6,  0xC9A7,  0xC9A8,  0xC9A9,  0xC9AB,  // 0x3F0x
      0xC9AC,  0xC9AD,  0xC9AE,  0xC9B0,  0xC9B1,  0xC9B4,  0xC9B6,  0xC9B7,  
      0xC9B8,  0xC9B9,  0xC9BA,  0xC9BC,  0xC9BD,  0xC9C1,  0xC9C2,  0xC9C3,  // 0x3F1x
      0xCFED,  0xA2E8,  0x4442,  0xDE3C,  0,       0xDE43,  0,       0xDE35,  
      0x46EC,  0xDE33,  0xDE37,  0xDE38,  0,       0,       0,       0,       // 0x3F2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0xC9BB,  0,       0,       // 0x3F3x
      0,       0,       0,       0xDE36,  0,       0,       0,       0xC9AA,  
      0,       0,       0,       0xA4E2,  0xA4D2,  0xA4CD,  0x4A60,  0xA4DA,  // 0x3F4x
      0xA4D4,  0xA4CC,  0x4A65,  0x4A67,  0x4EA5,  0,       0xA4E3,  0xA4CE,  
      0xA4D0,  0xA4D6,  0x4A5C,  0xA4D7,  0xA4C9,  0x4EA1,  0xA4E5,  0xA4C7,  // 0x3F5x
      0xA4C4,  0x4A66,  0x4DFB,  0x4EA4,  0xA4E4,  0x4A5B,  0xA4DB,  0x4A5A,  
      0xA4D9,  0x4DFE,  0xA4C3,  0xA4E7,  0x4EA3,  0x4DFD,  0xA4D3,  0xA4C2,  // 0x3F6x
      0xBAE9,  0xA4C5,  0xA4E8,  0x4EA2,  0xA4C1,  0xA4DE,  0xA4E6,  0x4EA6,  
      0x4EA8,  0,       0,       0x4DFC,  0x4A5E,  0xA4DF,  0xA4CB,  0,       // 0x3F7x
      0,       0,       0,       0,       0,       0xA4D1,  0,       0,       
      0,       0,       0,       0,       0x4EA7,  0xA4DC,  0xCFD9,  0xCFDA,  // 0x3F8x
      0xCFDB,  0xCFDC,  0xCFDD,  0xCFDE,  0xCFDF,  0xCFE2,  0xCFE3,  0xCFE4,  
      0xCFE5,  0xCFE6,  0xCFE7,  0xCFE8,  0xCFEA,  0xCFEB,  0xCFEF,  0xCFF0,  // 0x3F9x
      0xCFF1,  0xCFF2,  0xCFF3,  0xCFF4,  0xCFF5,  0xCFF6,  0xCFF7,  0xCFF8,  
      0xCFFB,  0xCFFC,  0xD5D1,  0xA4D5,  0,       0,       0,       0,       // 0x3FAx
      0xA4E0,  0xAFB0,  0x4A63,  0xA4C6,  0xA4DD,  0xA4C8,  0xA4CA,  0,       
      0xD5CA,  0,       0,       0,       0,       0,       0,       0xCFFE,  // 0x3FBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xC9C0,  0,       0,       0,       0x507C,  0x55B5,  0x55B4,  // 0x3FCx
      0x55A8,  0x55A9,  0x55AB,  0xAFB3,  0x55B0,  0xAFC7,  0xAFC0,  0xAFBA,  
      0x5079,  0xAFB9,  0x507E,  0x55B3,  0xAFBD,  0xAFB1,  0xAFB7,  0xAFC6,  // 0x3FDx
      0xAFBB,  0xAFB8,  0xAFC3,  0xAFB6,  0xAFB2,  0x55B1,  0x55AA,  0x5BF7,  
      0xAFBC,  0xAFC9,  0x55AC,  0x5BF9,  0x55B2,  0,       0,       0,       // 0x3FEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xAFAF,  0xAFB4,  0xAFBE,  0xAFC1,  0xD5C6,  0xD5C8,  0xD5C9,  // 0x3FFx
      0xD5CB,  0xD5CC,  0xD5CF,  0xD5D0,  0xD5D2,  0xD5D3,  0xD5D4,  0xD5D5,  
} ;


static const unsigned short Uni2cnsP2Table_40 [] = {
      0xD5D7,  0xDAED,  0,       0,       0x55AF,  0xAFBF,  0xAFC5,  0xAFC8,  // 0x400x
      0xAFCA,  0,       0,       0xAFAE,  0,       0,       0xAFC4,  0,       
      0,       0x5121,  0,       0,       0,       0,       0,       0,       // 0x401x
      0,       0,       0,       0,       0,       0,       0,       0xCFE1,  
      0xDAE6,  0xDADF,  0x54BA,  0x5BFC,  0x565A,  0x565F,  0x5BFA,  0xB8FA,  // 0x402x
      0xB8EE,  0x5B52,  0x5BFB,  0x5BF8,  0xB8F0,  0xB8F6,  0xB8EF,  0xB8F9,  
      0xB8F4,  0xB8F3,  0x62B8,  0xB8F5,  0xB8FB,  0x5BFD,  0xB8F7,  0x55B7,  // 0x403x
      0,       0xD5BA,  0,       0,       0,       0,       0xB8F8,  0xDAE0,  
      0xDAE1,  0xDAE2,  0xDAE3,  0xDAE4,  0xDAE5,  0xDAE7,  0xDAE9,  0xDAEB,  // 0x404x
      0xDAF0,  0xB8F2,  0x5BFE,  0,       0xB8FC,  0xB8F1,  0,       0,       
      0xD5CE,  0,       0,       0,       0,       0,       0,       0xDAEC,  // 0x405x
      0,       0,       0xDAEF,  0,       0xD5C7,  0xD5CD,  0xDADE,  0xAFB5,  
      0,       0x62BF,  0x62C6,  0x62C5,  0x5B5D,  0x62BD,  0x62B9,  0x62C2,  // 0x406x
      0xC0C0,  0xC0C6,  0x5B59,  0x62CB,  0x62C4,  0xC0BC,  0x62C1,  0x62CA,  
      0x5B58,  0x62C3,  0xC0C7,  0x62BB,  0xC0C1,  0x62C0,  0xC0C8,  0xC0BA,  // 0x407x
      0x5B5F,  0x5B55,  0xC0C5,  0xC0C4,  0xC0BE,  0x62BA,  0x5B53,  0x62BC,  
      0x62BE,  0x62C9,  0x62CC,  0x62C7,  0xC0BF,  0x5B5C,  0xC0C2,  0xC7DF,  // 0x408x
      0,       0,       0x62CD,  0,       0,       0,       0xDFB3,  0xDFB5,  
      0xDFB6,  0xDFB7,  0xDFB9,  0xDFBA,  0xDFBB,  0xDFBC,  0xDFBD,  0xDFBE,  // 0x409x
      0xDFBF,  0xDFC0,  0xDFC1,  0xDFC2,  0xDFC3,  0xE2E4,  0xE2E5,  0xE2EC,  
      0,       0xC7DE,  0xC0BD,  0xC0B9,  0,       0xC0C3,  0xC0BB,  0,       // 0x40Ax
      0,       0,       0,       0,       0,       0,       0,       0xDFB4,  
      0xDAEA,  0xDAEE,  0x62C8,  0xC7E5,  0xC7DC,  0xC7E2,  0x5F7C,  0x5F7A,  // 0x40Bx
      0xC7D3,  0x68B6,  0xC7D6,  0xC7D4,  0,       0xC7DB,  0xC7DA,  0xC7D5,  
      0x68B5,  0xC7D9,  0xC7DD,  0,       0x6CC5,  0,       0,       0,       // 0x40Cx
      0,       0,       0xC7E1,  0xE2E6,  0xE2E7,  0xE2E8,  0xE2E9,  0xE2EA,  
      0xE2ED,  0xE2EE,  0xE2EF,  0xE2F0,  0xE2F1,  0xC7D7,  0,       0xC7E0,  // 0x40Dx
      0xC7E6,  0xC7E4,  0xC7E3,  0,       0,       0,       0,       0,       
      0,       0,       0,       0xC7D8,  0,       0,       0,       0,       // 0x40Ex
      0,       0x6CC7,  0x6CCA,  0x6CCB,  0xCEAB,  0x6359,  0,       0x635D,  
      0xCEAA,  0xCEA9,  0x6CC8,  0,       0x635C,  0xCEAE,  0x6357,  0x6358,  // 0x40Fx
      0x6356,  0xCEAD,  0,       0x70BB,  0x6CC9,  0x6CCC,  0xCEAF,  0,       
} ;


static const unsigned short Uni2cnsP2Table_41 [] = {
      0,       0,       0,       0,       0,       0xE5C2,  0xE5C3,  0xE5C4,  // 0x410x
      0,       0xCEAC,  0,       0,       0,       0,       0x6648,  0x70C0,  
      0xD3D6,  0x70BF,  0,       0x70BD,  0x664B,  0xD3D4,  0x70BC,  0xD3D9,  // 0x411x
      0xD3D3,  0x664D,  0xD3DF,  0x70C1,  0xD3D5,  0xD3DA,  0xE7E8,  0xE7E9,  
      0xE7EA,  0xE7EB,  0xE7ED,  0xE7EE,  0xE7EF,  0,       0xD3DB,  0,       // 0x412x
      0xD3DC,  0xD3DD,  0xD3DE,  0x70BA,  0xE7F0,  0,       0,       0,       
      0,       0,       0,       0xE9D5,  0xD8AE,  0xD3D7,  0xD8AF,  0x73D4,  // 0x413x
      0x70C2,  0xD8AD,  0x73D5,  0xD8B1,  0,       0x6872,  0,       0,       
      0,       0xD8B2,  0xE9D3,  0xE9D4,  0,       0xD8B3,  0xD8B0,  0xD8AC,  // 0x414x
      0,       0,       0x76A1,  0x76A2,  0xDBE9,  0xDBE8,  0x75FE,  0,       
      0,       0xDBE7,  0x75FD,  0,       0,       0,       0,       0,       // 0x415x
      0xEADB,  0xEADC,  0xEADD,  0xDBEA,  0,       0xDBE6,  0,       0,       
      0xDEF6,  0x77E7,  0xDEF7,  0x6C71,  0xDEF4,  0,       0x77E6,  0,       // 0x416x
      0xDEF5,  0x6C72,  0xE0F9,  0xE0F8,  0,       0xE0F7,  0xECAF,  0,       
      0xE2B9,  0x6D58,  0x7AAB,  0x7AAA,  0x6D59,  0,       0,       0x6D74,  // 0x417x
      0x7AE9,  0x7AEA,  0,       0xE3D7,  0xE4CB,  0x7BC1,  0xEDA6,  0xE5DC,  
      0x7CBC,  0,       0xA32F,  0xA533,  0x2324,  0x2325,  0xA532,  0,       // 0x418x
      0xA2DF,  0xA2E0,  0xA2E1,  0xA534,  0,       0x2453,  0x2454,  0x24D4,  
      0xA84C,  0x24D5,  0x24D7,  0,       0xA4EB,  0xA4EC,  0xA4ED,  0xA4F0,  // 0x419x
      0xA4F2,  0,       0xA84B,  0,       0,       0x26F4,  0x2728,  0x26F5,  
      0,       0,       0,       0,       0,       0,       0xA7EF,  0xA7F0,  // 0x41Ax
      0xA7F1,  0xA7F3,  0xA7F4,  0xA7F5,  0xA7F6,  0xA7F7,  0,       0xAC5F,  
      0xA7F2,  0xAC5E,  0x272A,  0,       0x24D6,  0,       0,       0,       // 0x41Bx
      0,       0,       0,       0,       0x2AA5,  0xB24C,  0x2AA6,  0xB244,  
      0x2AA7,  0xB24B,  0,       0,       0,       0,       0,       0xB246,  // 0x41Cx
      0xABEF,  0xABF0,  0xABF1,  0xABF2,  0xABF3,  0xABF4,  0xABF5,  0xABF6,  
      0xABF7,  0xABF8,  0xABF9,  0xABFB,  0xABFC,  0xABFD,  0xABFE,  0xACA1,  // 0x41Dx
      0xACA3,  0x2A29,  0xB245,  0xB243,  0,       0xB247,  0,       0xB93A,  
      0x2AA8,  0xB24A,  0xACA2,  0,       0,       0,       0,       0,       // 0x41Ex
      0,       0,       0,       0xB249,  0,       0,       0,       0x2ECF,  
      0x2ECE,  0xB936,  0xB939,  0xB0EA,  0x326F,  0xB937,  0x2D74,  0xB934,  // 0x41Fx
      0,       0,       0,       0,       0,       0x2ECB,  0xB0DD,  0xB0DE,  
} ;


static const unsigned short Uni2cnsP2Table_42 [] = {
      0xB0DF,  0xB0E0,  0xB0E1,  0xB0E2,  0xB0E3,  0xB0E4,  0xB0E5,  0xB0E6,  // 0x420x
      0xB0E8,  0xB0E9,  0xB0EB,  0xB0EC,  0xB0EE,  0xB0EF,  0xB0F0,  0xB0F1,  
      0xB0F2,  0x2ECC,  0xB935,  0,       0,       0xB93B,  0xB93C,  0,       // 0x421x
      0xB0E7,  0,       0,       0xB0ED,  0,       0,       0,       0,       
      0,       0,       0xB938,  0x2ECD,  0,       0xC14B,  0x3274,  0x33C4,  // 0x422x
      0xC14F,  0x3273,  0x3275,  0xC14E,  0xC154,  0xC151,  0xC14D,  0xC14C,  
      0xCA73,  0xC152,  0xC150,  0,       0,       0,       0,       0,       // 0x423x
      0,       0xC153,  0xB6A4,  0xB6BE,  0xB6BF,  0xB6C0,  0xB6C1,  0xB6C3,  
      0xB6C4,  0xB6C5,  0xB6C6,  0xB6C7,  0xB6C9,  0xB6CA,  0xB6CC,  0xB6CD,  // 0x424x
      0xB6CE,  0xB6D0,  0xC149,  0,       0,       0,       0,       0,       
      0,       0xC148,  0,       0,       0,       0,       0,       0,       // 0x425x
      0,       0xB6CB,  0,       0,       0,       0x33C3,  0,       0x33C5,  
      0,       0xC155,  0x3869,  0xCA78,  0xC14A,  0x39F1,  0x39EF,  0xCA7E,  // 0x426x
      0,       0xCB21,  0x39EE,  0xCA75,  0x3866,  0xCA7A,  0xCA74,  0xCA7D,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x427x
      0,       0x3863,  0x39F0,  0xCA77,  0xBCDE,  0xBCDF,  0xBCE0,  0xBCE1,  
      0xBCE2,  0xBCE3,  0xBCE4,  0xBCE6,  0xBCE7,  0xBCE8,  0xBCE9,  0xBCEB,  // 0x428x
      0xBCEC,  0xBCED,  0xBCEE,  0xBCEF,  0xBCF0,  0xBCF1,  0xBCF2,  0xBCF5,  
      0xBCF7,  0xBCF8,  0xBCF9,  0xBCFA,  0xBCFB,  0xBCFC,  0xBDA1,  0xCA79,  // 0x429x
      0xCA7C,  0x3867,  0,       0xCA76,  0xCA7B,  0,       0,       0,       
      0,       0,       0,       0,       0,       0xBCEA,  0,       0,       // 0x42Ax
      0,       0,       0,       0,       0,       0,       0,       0x39F2,  
      0,       0,       0x40B4,  0,       0xD45A,  0xD458,  0x40B0,  0xD456,  // 0x42Bx
      0xD45D,  0x3E47,  0xD457,  0x3E44,  0xD45B,  0xD45E,  0x3E45,  0x40B2,  
      0xD453,  0xD463,  0xD45F,  0xD464,  0x40B5,  0,       0xD45C,  0xD462,  // 0x42Cx
      0,       0,       0,       0xC2F6,  0xC2F9,  0xC2FB,  0xC2FC,  0xC2FD,  
      0xC3A1,  0xC3A2,  0xC3A3,  0xC3A5,  0xC3A6,  0xC3A7,  0xC3A8,  0xC3A9,  // 0x42Dx
      0xC3AA,  0xC3AB,  0xC3AD,  0xC3AE,  0xC3B0,  0xC3B3,  0xC3B4,  0xC3B5,  
      0xC3B6,  0xC3B7,  0xC3B8,  0xC3B9,  0xC3BA,  0xC3BB,  0xC3BD,  0xC3BE,  // 0x42Ex
      0xD451,  0xD452,  0xD455,  0,       0xD466,  0,       0,       0x3E4A,  
      0xD461,  0xD465,  0,       0xDA54,  0,       0,       0,       0,       // 0x42Fx
      0,       0,       0xC3AC,  0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_43 [] = {
      0,       0x40B3,  0,       0x40B1,  0,       0,       0,       0xC9D4,  // 0x430x
      0xDE51,  0xDE50,  0x46FE,  0xDE4A,  0x47A2,  0x4455,  0x46FC,  0x46FB,  
      0x46FA,  0xA4F0,  0xA4EA,  0xDE46,  0x47A1,  0xDE47,  0xDE48,  0,       // 0x431x
      0,       0,       0,       0x46F9,  0xDE4B,  0xDE4F,  0xC9C4,  0xC9C5,  
      0xC9C6,  0xC9C7,  0xC9C9,  0xC9CA,  0xC9CC,  0xC9CD,  0xC9CE,  0xC9CF,  // 0x432x
      0xC9D0,  0xC9D1,  0xC9D2,  0xC9D3,  0xC9D5,  0xC9D6,  0xC9D7,  0xC9DA,  
      0xC9DB,  0xC9DD,  0xC9DE,  0xC9E0,  0xC9E2,  0xC9E3,  0xC9E4,  0,       // 0x433x
      0x445D,  0x46FD,  0xDE4C,  0xDE52,  0xDE49,  0xDE4D,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x434x
      0xC9DC,  0,       0,       0,       0,       0xD460,  0xC2FE,  0xC2FA,  
      0x4A6B,  0,       0,       0x4EAC,  0xA4F4,  0xA4ED,  0xA4E9,  0x4EAA,  // 0x435x
      0xA4EC,  0xA4F1,  0xA4F2,  0xA4F5,  0xA4EB,  0x4EA9,  0,       0,       
      0,       0,       0xCEA2,  0,       0,       0,       0x4EAB,  0xA4F3,  // 0x436x
      0xD0A3,  0xD0A4,  0xD0A6,  0xD0A7,  0xD0A8,  0xD0A9,  0xD0AA,  0xD0AB,  
      0xD0AE,  0xD0AF,  0xD0B1,  0xD0B2,  0xD0B3,  0xD0B4,  0xD0B5,  0xD0B7,  // 0x437x
      0xD0B8,  0xD0B9,  0xD0BA,  0xD0BB,  0xD0BC,  0,       0xA4EE,  0xD0AC,  
      0,       0,       0xAAF1,  0,       0xD0AD,  0xD0B0,  0,       0,       // 0x438x
      0,       0,       0,       0,       0xD0A5,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0xD0A2,  0x4EAE,  // 0x439x
      0x4EAD,  0,       0xDE4E,  0,       0,       0x512A,  0xAFD2,  0xAFE6,  
      0xAFD0,  0xAFE0,  0xAFDE,  0x55BB,  0x5127,  0xAFE1,  0xAFE3,  0xAFD5,  // 0x43Ax
      0xA4EF,  0x5128,  0xAFD6,  0xAFE4,  0xAFE5,  0x5126,  0xAFD8,  0xAFD4,  
      0x5129,  0xAFE7,  0x55BA,  0x55BC,  0xAFE2,  0xAFD9,  0,       0xAFDD,  // 0x43Bx
      0xAFDA,  0,       0,       0,       0,       0,       0xAFCB,  0xAFD3,  
      0xAFDC,  0xD5D9,  0xD5DA,  0xD5DB,  0xD5DC,  0xD5DD,  0xD5DE,  0xD5DF,  // 0x43Cx
      0xD5E0,  0xD5E1,  0xD5E2,  0xD5E3,  0xD5E6,  0xD5E7,  0xD5E8,  0xD5EA,  
      0xD5EB,  0xD5ED,  0xD5EE,  0xD5F0,  0xD5F1,  0xD5F2,  0,       0xD5E5,  // 0x43Dx
      0x55B8,  0xAFCD,  0xAFCE,  0xAFDB,  0,       0xAFDF,  0xB1FA,  0xAFD1,  
      0xACFB,  0,       0,       0,       0,       0,       0,       0,       // 0x43Ex
      0,       0xD5EF,  0,       0,       0,       0x55BD,  0x55B9,  0xAFCC,  
      0xA4F6,  0,       0,       0,       0xAFD7,  0xB9A3,  0x5661,  0xB9A5,  // 0x43Fx
      0x55BE,  0xB9A9,  0xB9A8,  0x5663,  0xAFE8,  0x5CA1,  0xB8FD,  0x5CA4,  
} ;


static const unsigned short Uni2cnsP2Table_44 [] = {
      0x5CA2,  0,       0,       0,       0xDAF1,  0xDAF2,  0xDAF6,  0xDAF7,  // 0x440x
      0xDAF8,  0xDAF9,  0xDAFA,  0xDAFB,  0xDAFC,  0xDAFD,  0xDAFE,  0xDBA1,  
      0xDBA2,  0xDBA3,  0xB8FE,  0,       0,       0xB9A4,  0,       0xB9A2,  // 0x441x
      0,       0,       0,       0,       0,       0,       0x5CA3,  0xB9A1,  
      0,       0,       0xD5E9,  0,       0,       0,       0xC0CF,  0x5B62,  // 0x442x
      0xC0CE,  0x62CE,  0xC0CB,  0xC0D3,  0xC0D1,  0xC0CC,  0,       0x5B63,  
      0x62CF,  0x62D0,  0x5B61,  0xC0D4,  0,       0,       0,       0xC0CA,  // 0x443x
      0xC0D2,  0xDFC4,  0xDFC6,  0xDFC5,  0xDFC7,  0xDFC8,  0xDFC9,  0xDFCA,  
      0xDFCC,  0xDFCD,  0xC0D0,  0xC2A2,  0,       0xC0D5,  0xC0CD,  0,       // 0x444x
      0,       0,       0xC0C9,  0xB9AA,  0,       0,       0xE1F6,  0xDAF4,  
      0xDAF5,  0,       0xC7EC,  0x68B7,  0x6021,  0,       0xC7ED,  0x6022,  // 0x445x
      0,       0,       0,       0,       0xC7EA,  0xE2F4,  0xE2F5,  0xE2F6,  
      0xE2F7,  0,       0xC7E9,  0,       0,       0,       0,       0xC7E7,  // 0x446x
      0xC7EB,  0,       0,       0,       0,       0,       0,       0,       
      0xDFCB,  0xC7E8,  0xE5C5,  0x6CCF,  0xCEB0,  0xCEB3,  0xCEBB,  0x6CCE,  // 0x447x
      0x6CCD,  0x6CD1,  0x6023,  0,       0xCEB2,  0xCEB8,  0x6362,  0x6360,  
      0xCEBC,  0xCEB1,  0xCEB5,  0,       0,       0,       0xCEB7,  0,       // 0x448x
      0xE5C8,  0xCEB4,  0xE5C6,  0xE5C7,  0xE5CA,  0xE5CB,  0xE5CC,  0xE5CD,  
      0xE5CE,  0,       0,       0xCEB9,  0,       0,       0,       0xCEB6,  // 0x449x
      0,       0,       0,       0,       0xCEBA,  0,       0x6CD0,  0,       
      0,       0xD3E4,  0x6361,  0xD3E6,  0x70C3,  0,       0x664F,  0xD3E7,  // 0x44Ax
      0,       0,       0,       0xD3E2,  0xD3E3,  0,       0xD3E5,  0,       
      0,       0,       0,       0xE7F1,  0,       0xE7F2,  0xE7F3,  0xE7F4,  // 0x44Bx
      0xE7F5,  0,       0xD8B6,  0x73D6,  0x6A4F,  0xD8B7,  0xD8B8,  0,       
      0xD8B4,  0xE9D6,  0xE9D7,  0xE9D8,  0xD8B5,  0xDBA4,  0,       0,       // 0x44Cx
      0xDBEE,  0xDBF0,  0xDBED,  0,       0,       0,       0,       0xDCC4,  
      0xDBEF,  0,       0xDBEC,  0,       0xDBEB,  0x76A3,  0xEAE0,  0xDEF8,  // 0x44Dx
      0,       0xEADF,  0x77E8,  0,       0xE1A1,  0xE0FC,  0xE0FE,  0xE1B8,  
      0xE0FB,  0xE0FD,  0,       0,       0,       0xE2BA,  0x7AEB,  0xECE4,  // 0x44Ex
      0xECE5,  0,       0xE4CD,  0xE4CC,  0xE4CE,  0xE5B7,  0xE6B4,  0x21CB,  
      0,       0xA330,  0xA84D,  0xA84E,  0x24D8,  0,       0xAC62,  0xAC61,  // 0x44Fx
      0xAC63,  0,       0,       0xA7F8,  0xA7F9,  0xB24E,  0x2AAB,  0,       
} ;


static const unsigned short Uni2cnsP2Table_45 [] = {
      0x2AA9,  0xB24F,  0x2AAA,  0xB251,  0xACA4,  0xACA5,  0xACA6,  0xB24D,  // 0x450x
      0,       0,       0xB250,  0,       0x2ED1,  0,       0x2ED0,  0xB0F3,  
      0xC157,  0xC156,  0xC158,  0xB6D1,  0x386A,  0xCB22,  0,       0xC743,  // 0x451x
      0xCD5D,  0,       0,       0,       0xD468,  0,       0,       0,       
      0xD469,  0,       0xDE53,  0x47A3,  0xDE56,  0xDE55,  0xDE54,  0xA4FA,  // 0x452x
      0x4EAF,  0xA4F7,  0xA4F9,  0,       0xA4F8,  0,       0xAFE9,  0,       
      0xAFEA,  0x55BF,  0x5665,  0xDBA4,  0xDBA5,  0xDBA6,  0,       0,       // 0x453x
      0xD5F3,  0xC0D6,  0,       0,       0,       0,       0,       0,       
      0x68B8,  0,       0xE5CF,  0xE5D0,  0,       0xCEBD,  0,       0,       // 0x454x
      0xD3E8,  0xDBF1,  0,       0xDEF9,  0,       0xE1A2,  0xA4F3,  0xA4F4,  
      0xAC64,  0xAC65,  0,       0xC159,  0,       0xC15A,  0xBDA2,  0xBDA3,  // 0x455x
      0xD46A,  0xC9E5,  0x47A4,  0x55C0,  0xA1E8,  0xAB6B,  0x2AAC,  0x2A2B,  
      0x2D77,  0xB0F4,  0x31EC,  0xCB23,  0xD46C,  0xD46B,  0x55C1,  0xA4FB,  // 0x456x
      0xA4FC,  0x55C2,  0xA225,  0xA331,  0,       0xA535,  0xA84F,  0x272D,  
      0xAC67,  0xAC66,  0xB252,  0x2A2D,  0xB253,  0xB254,  0xB93E,  0x2D78,  // 0x457x
      0,       0xB0F5,  0xB93D,  0xC15B,  0xC15E,  0xC15D,  0x3278,  0,       
      0,       0xC15C,  0xB6D2,  0xB6D3,  0,       0xCB28,  0xCB24,  0xCB26,  // 0x458x
      0xCB27,  0xCB29,  0xCB25,  0xCD58,  0xD46D,  0xD46E,  0xC3BF,  0xDE58,  
      0xDE59,  0xC9E6,  0,       0xA4FD,  0xD0BE,  0xA4FE,  0x55C3,  0x62D1,  // 0x459x
      0x512C,  0xAFEB,  0xA5A1,  0x55C4,  0xB9AB,  0xB9AC,  0x5CA5,  0,       
      0xC7F0,  0,       0x6CD2,  0xD8B9,  0xDBF2,  0xE3D8,  0x7BC2,  0xE4CF,  // 0x45Ax
      0xA1E9,  0xA851,  0x24D9,  0xA850,  0x272E,  0xAC6B,  0xAC6A,  0xAC69,  
      0xAC68,  0xB256,  0xB255,  0x2AAD,  0xB257,  0,       0,       0x2AAE,  // 0x45Bx
      0,       0,       0x2ED2,  0x2D79,  0x2D7B,  0xB941,  0xB93F,  0,       
      0x33C6,  0x33C7,  0xC15F,  0,       0xC162,  0xC160,  0,       0xCB2B,  // 0x45Cx
      0x386D,  0xCB2E,  0xCB2A,  0xCB2C,  0xCB2D,  0x39F3,  0x39F6,  0x39F4,  
      0,       0x39F5,  0,       0,       0,       0,       0,       0x386E,  // 0x45Dx
      0x40B8,  0xD46F,  0x3E4D,  0x40B6,  0x40B7,  0,       0,       0,       
      0xD470,  0xBDA4,  0x47A5,  0xDE5B,  0,       0xDE5C,  0xDE5A,  0xC9E7,  // 0x45Ex
      0x4EB2,  0xA5A5,  0x4EB1,  0x4EB0,  0x4EB3,  0xA5A4,  0xA5A2,  0x4EB4,  
      0,       0xA5A3,  0,       0x55C6,  0x55C7,  0x55C8,  0xAFED,  0x55C5,  // 0x45Fx
      0xAFEC,  0,       0x5CA6,  0x5666,  0xDBA7,  0xDBA8,  0,       0x62D3,  
} ;


static const unsigned short Uni2cnsP2Table_46 [] = {
      0x62D2,  0,       0,       0x6CD3,  0xD3E9,  0x23E8,  0,       0,       // 0x460x
      0xB943,  0xB942,  0,       0,       0x386F,  0xCB2F,  0xBDA5,  0xBDA6,  
      0xD471,  0xDE5D,  0,       0,       0x21F5,  0xA2E3,  0xA536,  0xA2E2,  // 0x461x
      0xA853,  0xA4F5,  0xA852,  0xA854,  0x26F9,  0x27A2,  0x26F8,  0x26FB,  
      0x26F6,  0x26FD,  0xAC6E,  0x2730,  0x27A1,  0xAC6C,  0x26FE,  0x27A3,  // 0x462x
      0,       0,       0,       0x26FC,  0xAC6D,  0xA7FB,  0xA7FC,  0xA7FE,  
      0xA8A1,  0,       0x26FA,  0xAC6F,  0xAC70,  0,       0,       0,       // 0x463x
      0x2AB2,  0x2AB0,  0x2AAF,  0xB25F,  0xB25C,  0x2AB3,  0x2AB1,  0x2A30,  
      0xB25A,  0,       0xB259,  0xACA8,  0xACA9,  0,       0,       0,       // 0x464x
      0,       0xB25B,  0xB25E,  0,       0xB258,  0xB25D,  0,       0x2AB4,  
      0xA7FD,  0x2ED8,  0x2ED4,  0x2ED6,  0x2ED7,  0x2ED5,  0,       0xB944,  // 0x465x
      0x2ED9,  0,       0,       0x327B,  0xC167,  0xC168,  0x33C9,  0x39F7,  
      0x327D,  0x327C,  0x33CB,  0,       0x33CC,  0,       0xB6D4,  0xB6D5,  // 0x466x
      0xC165,  0,       0xC169,  0xC164,  0,       0x33C8,  0,       0,       
      0x3871,  0x3874,  0x39FD,  0xCB34,  0x39F9,  0x39FB,  0,       0x39F8,  // 0x467x
      0xCB32,  0xCB35,  0xBDA7,  0xBDA8,  0,       0,       0,       0,       
      0,       0,       0xCB33,  0xCB30,  0xCB31,  0,       0,       0,       // 0x468x
      0x39FA,  0x39FC,  0x33CA,  0xBDA9,  0xCB36,  0x47AB,  0x40BE,  0x40BC,  
      0x3E50,  0xDE64,  0xD473,  0x47A6,  0xD472,  0xD475,  0xD474,  0,       // 0x469x
      0xC3C0,  0xC3C1,  0,       0,       0,       0,       0x40BD,  0,       
      0xD477,  0,       0,       0,       0,       0,       0,       0,       // 0x46Ax
      0x40BB,  0x4461,  0x47AD,  0x47A8,  0x47AE,  0x47AC,  0xDE5F,  0xDE63,  
      0x47A7,  0x47AA,  0xDE67,  0xDE62,  0xDE61,  0x40BA,  0xDE66,  0,       // 0x46Bx
      0xC9E8,  0xC9E9,  0xC9EA,  0xC9EB,  0x47AF,  0x47A9,  0xDE60,  0xD476,  
      0,       0,       0xDE65,  0,       0,       0,       0,       0,       // 0x46Cx
      0xC9EC,  0x47B0,  0x4EB6,  0xA5A6,  0x4A74,  0x4EB9,  0x4EBA,  0x4EB8,  
      0x4A70,  0x4EB5,  0,       0,       0,       0xD0BF,  0,       0,       // 0x46Dx
      0,       0,       0,       0xA5A8,  0,       0,       0,       0xA5A7,  
      0,       0xAFF0,  0x55C9,  0x55CE,  0xAFF1,  0x55CB,  0x55CD,  0x55CA,  // 0x46Ex
      0,       0x55CC,  0,       0xAFEF,  0,       0,       0,       0xB9B0,  
      0xB9AE,  0x5CA7,  0x5668,  0x5669,  0xAFEE,  0,       0xB9AF,  0,       // 0x46Fx
      0,       0xC0D7,  0xC0D8,  0x68BA,  0,       0xD3EA,  0xC7F2,  0xC7F3,  
} ;


static const unsigned short Uni2cnsP2Table_47 [] = {
      0xC7F1,  0,       0x68B9,  0xCEBF,  0x6CD4,  0x6CD5,  0,       0x70C5,  // 0x470x
      0xD3EC,  0x70C4,  0,       0x70C6,  0xD8BA,  0x73D9,  0,       0xDBF4,  
      0x73D8,  0xDBF5,  0xDBF3,  0,       0x77E9,  0,       0xE1A3,  0xECB1,  // 0x471x
      0,       0xE4D0,  0xA1BD,  0xA332,  0x21F7,  0x21F8,  0,       0,       
      0,       0x22F8,  0x22FB,  0x22F7,  0x2328,  0,       0x22FA,  0,       // 0x472x
      0xA537,  0,       0,       0x22F9,  0,       0,       0,       0x24DE,  
      0x24DF,  0x245B,  0x2737,  0xA858,  0x245A,  0x24DA,  0xA85E,  0x24DB,  // 0x473x
      0xA85B,  0x27AF,  0xAC72,  0x2457,  0x24DD,  0x24DC,  0xA85A,  0xA859,  
      0xAC73,  0xA4F7,  0xA857,  0xA85C,  0,       0,       0xA85D,  0,       // 0x474x
      0,       0,       0,       0,       0xA856,  0x2458,  0,       0xAC7A,  
      0x27A8,  0xAC7B,  0x27AC,  0xAC79,  0xAC7C,  0x27A7,  0x27AA,  0xAC78,  // 0x475x
      0x27AD,  0x27A5,  0x27A9,  0x27A4,  0xAC77,  0,       0x2738,  0x2AB6,  
      0xA855,  0xB260,  0,       0x27AB,  0xAC76,  0xA8A2,  0xAC7D,  0,       // 0x476x
      0xAC74,  0,       0,       0,       0x2735,  0,       0x2AB5,  0x2ABE,  
      0xB268,  0x2AB9,  0xB94B,  0x2ABD,  0xB261,  0xB94C,  0xC16C,  0x2ABC,  // 0x477x
      0x2A31,  0x2ABB,  0xB264,  0x2ABA,  0xB266,  0x2A33,  0x2AC0,  0xB263,  
      0x27A6,  0x2AB7,  0x2AB8,  0,       0xACAA,  0xACAC,  0xACAD,  0,       // 0x478x
      0xB265,  0,       0,       0,       0,       0,       0,       0xACAB,  
      0,       0,       0,       0,       0,       0,       0,       0x2ABF,  // 0x479x
      0,       0xB94E,  0x2EDE,  0x3321,  0xB949,  0xB94D,  0x2E25,  0x2EDB,  
      0x2EE0,  0x2EDD,  0x2E23,  0xB945,  0,       0xB94A,  0,       0,       // 0x47Ax
      0,       0,       0,       0,       0xB0F7,  0xB0F8,  0,       0xB948,  
      0x2EDA,  0,       0x2E24,  0,       0,       0,       0,       0,       // 0x47Bx
      0xB947,  0xB94F,  0,       0,       0,       0,       0x2EDF,  0xB946,  
      0x33CE,  0xB0F6,  0,       0x3324,  0xC16E,  0x33D5,  0x39FE,  0x33D2,  // 0x47Cx
      0xC170,  0xC173,  0x33CF,  0xC16F,  0xCB3B,  0x3326,  0x33D3,  0xCB38,  
      0xCB37,  0x33D0,  0xCB39,  0,       0xC171,  0xC172,  0,       0xC174,  // 0x47Dx
      0,       0xCB3A,  0x3AA8,  0,       0xD47B,  0x3AA6,  0x40BF,  0x3875,  
      0x3AA2,  0xCB44,  0x40C0,  0x3AA7,  0x3876,  0x3AA5,  0x3AA4,  0x3878,  // 0x47Ex
      0xCB3F,  0x3E51,  0x3AA1,  0xCB3C,  0xCB3E,  0x3E57,  0,       0,       
      0,       0,       0xBDAA,  0xBDAB,  0xD479,  0xD272,  0xD47A,  0,       // 0x47Fx
      0xCB40,  0,       0xCB41,  0xCB45,  0,       0xCB3D,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_48 [] = {
      0,       0,       0,       0,       0,       0,       0,       0x3AA3,  // 0x480x
      0,       0,       0xC3C3,  0,       0,       0x3E56,  0x40C8,  0xD522,  
      0x40C7,  0x3E55,  0xD527,  0x40CB,  0xD524,  0xD47E,  0xD47D,  0xD526,  // 0x481x
      0x40C6,  0x40C4,  0x40C3,  0,       0xD521,  0x40C2,  0xD528,  0x40CA,  
      0x40C1,  0x3E58,  0,       0,       0x40C9,  0xD525,  0xC3C5,  0xC3C6,  // 0x482x
      0xC9F0,  0xD0C0,  0,       0x40C5,  0xD523,  0,       0,       0,       
      0,       0,       0,       0,       0,       0x40CC,  0,       0,       // 0x483x
      0,       0xDE6D,  0x47BA,  0xDE69,  0xA5A9,  0x47B7,  0x446B,  0x47B5,  
      0x47B3,  0xDE6C,  0x47BB,  0x47B6,  0x47B4,  0xDE70,  0x446C,  0x47B1,  // 0x484x
      0,       0,       0,       0,       0,       0xC9ED,  0xA5AA,  0,       
      0xC9EF,  0xDE6B,  0,       0,       0,       0,       0,       0xDE68,  // 0x485x
      0xDE6A,  0xDE6F,  0,       0,       0x4A7D,  0x47BD,  0x47BC,  0x47B9,  
      0x47B8,  0xDE71,  0x47B2,  0xA5B1,  0x4A78,  0x4A79,  0xA5B0,  0x4EBC,  // 0x486x
      0xA5B4,  0xAFF3,  0x4EC1,  0xA5AF,  0xA5AB,  0x4EBE,  0x4EC5,  0,       
      0x4EBB,  0x4EC4,  0x4EC3,  0x4EBD,  0x55CF,  0xAFF2,  0x4EBF,  0,       // 0x487x
      0,       0x4EC0,  0x4EC6,  0xA5AC,  0xA5AD,  0xD5F5,  0,       0x55D0,  
      0,       0,       0,       0xA5AE,  0,       0xA5B3,  0,       0,       // 0x488x
      0,       0xC9EE,  0x5133,  0x4EC2,  0x55D7,  0x5135,  0x55D5,  0x55D1,  
      0x55D2,  0xAFF9,  0x5131,  0xAFF8,  0xAFF7,  0x5CA8,  0x5136,  0x55D3,  // 0x489x
      0x55D6,  0xAFF5,  0xB9B2,  0,       0x566D,  0xB9B1,  0xAFF6,  0,       
      0xA5B2,  0xD5F7,  0xA5B5,  0x55D4,  0,       0,       0x5CAA,  0xB9B3,  // 0x48Ax
      0x5CA9,  0xC7F7,  0xB9B5,  0,       0,       0,       0,       0xB9B4,  
      0xDBA9,  0xDBAA,  0xDBAB,  0xDBAC,  0xC0DD,  0x62D5,  0x62D4,  0xC0DA,  // 0x48Bx
      0xC0D9,  0xC0DC,  0x5B68,  0xC0DB,  0,       0,       0,       0,       
      0xDFCE,  0xDFCF,  0,       0x62D6,  0,       0x6364,  0,       0,       // 0x48Cx
      0xC7F8,  0xCEC0,  0xC7F6,  0xC7F4,  0,       0xCEC1,  0x6CD6,  0,       
      0xCEC2,  0x70C8,  0xD3ED,  0x70C7,  0,       0,       0,       0x6874,  // 0x48Dx
      0x70C9,  0xD8BB,  0,       0xDBF6,  0xDBF8,  0xDBF7,  0,       0x77EA,  
      0xDEFA,  0,       0xEBD5,  0xE1A4,  0xE3D9,  0,       0xA8A3,  0xCB46,  // 0x48Ex
      0xDE72,  0x21CC,  0xA538,  0xA333,  0,       0,       0xA85F,  0x24E1,  
      0x245D,  0,       0x245C,  0,       0xA861,  0xA860,  0,       0xA4F9,  // 0x48Fx
      0x24E0,  0x27B0,  0xAD25,  0x273C,  0x2AC1,  0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_49 [] = {
      0,       0,       0xA8A5,  0xA8A6,  0xA8A7,  0xA8A8,  0xA8A9,  0,       // 0x490x
      0xAD23,  0,       0,       0xACC0,  0xA8A4,  0xAD22,  0xACBC,  0xB269,  
      0x2AC5,  0x2AC2,  0x2A36,  0xB26B,  0,       0,       0,       0,       // 0x491x
      0xAF69,  0,       0xACAF,  0xACB0,  0xACB1,  0xACB3,  0xACB4,  0xACB5,  
      0xACB6,  0xACB7,  0xACB8,  0xACBA,  0xACBB,  0xACBD,  0,       0,       // 0x492x
      0xB26A,  0,       0xB26C,  0xACBE,  0xACBF,  0,       0,       0xACAE,  
      0,       0x2AC4,  0x2AC3,  0,       0,       0xB953,  0x33D6,  0x2EE1,  // 0x493x
      0x2E29,  0xB951,  0x2E28,  0xB952,  0xB954,  0,       0,       0,       
      0,       0,       0,       0xB0F9,  0xB0FA,  0xB0FB,  0xB0FC,  0xB0FD,  // 0x494x
      0xB0FE,  0xB1A1,  0xB1A3,  0xB1A4,  0xB1A5,  0xB1A6,  0xB950,  0xB6E3,  
      0,       0,       0,       0,       0x3331,  0xB955,  0xC17A,  0x33D7,  // 0x495x
      0xC17B,  0x3332,  0xC177,  0xC178,  0xC179,  0,       0,       0,       
      0,       0,       0,       0,       0xB1A2,  0xB6D6,  0xB6D8,  0xB6DC,  // 0x496x
      0xB6DF,  0xB6E0,  0xB6E1,  0xB6E2,  0xB6E4,  0xB6DD,  0,       0,       
      0,       0xC17C,  0,       0,       0xB6DB,  0xB6DA,  0xB6DE,  0x33D8,  // 0x497x
      0xC176,  0xBDBE,  0,       0xBDB4,  0xCB4B,  0x3AAB,  0x3AAA,  0x3AAC,  
      0xD529,  0x3E5A,  0,       0x40CD,  0,       0xBDB8,  0,       0,       // 0x498x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x387C,  0xCB49,  0xCB4C,  0xBDAC,  0xBDAD,  0xBDAE,  0xBDAF,  0xBDB0,  // 0x499x
      0xBDB2,  0xBDB5,  0xBDB6,  0xBDB7,  0xBDB9,  0xBDBA,  0xBDBF,  0xC3D0,  
      0xCB4E,  0xD532,  0xCB4D,  0,       0xBDC0,  0xCB48,  0xCB4A,  0,       // 0x49Ax
      0xD52A,  0,       0,       0xBDB3,  0xBDBD,  0xBDB1,  0x3AA9,  0xD52B,  
      0xD530,  0x3E5B,  0xD531,  0xD52F,  0xD52E,  0,       0,       0,       // 0x49Bx
      0,       0,       0,       0,       0x47BE,  0xC3C7,  0xC3CA,  0xC3CC,  
      0xC3CD,  0xC3CE,  0xC3CF,  0xC3D1,  0xC3D2,  0xC3D3,  0xC3D4,  0xC3D5,  // 0x49Cx
      0xC3D7,  0xC3D8,  0xC3DA,  0xC3DB,  0xC3DC,  0xC3DD,  0xC3DE,  0xC3DF,  
      0xC3E0,  0xC3E1,  0xC3E2,  0xC3E3,  0xC3E5,  0,       0xD52C,  0x40CF,  // 0x49Dx
      0,       0x3AAE,  0,       0,       0,       0,       0xC3CB,  0xC3C8,  
      0x47BF,  0,       0xD52D,  0xC3D9,  0xC9FA,  0xC9FB,  0xCAA6,  0xA5B8,  // 0x49Ex
      0,       0,       0xDE74,  0x47C1,  0xA5B6,  0x446D,  0x47C0,  0xDE75,  
      0xDE77,  0,       0xDE76,  0,       0,       0,       0,       0,       // 0x49Fx
      0,       0,       0xDE73,  0xC9F1,  0xC9F2,  0xC9F3,  0xC9F4,  0xC9F5,  
} ;


static const unsigned short Uni2cnsP2Table_4A [] = {
      0xC9F7,  0xC9F8,  0xC9F9,  0xC9FC,  0xC9FD,  0xC9FE,  0xCAA1,  0xCAA2,  // 0x4A0x
      0xCAA4,  0xCAA5,  0xCAA7,  0xCAA8,  0xCAA9,  0x47C2,  0,       0xC8A6,  
      0xA5B9,  0,       0,       0xCAA3,  0xA5C0,  0x4A7E,  0x4EC7,  0xAFFB,  // 0x4A1x
      0xA5BA,  0xAFFA,  0xA5BC,  0xA5BF,  0xA5C1,  0xA5C2,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4A2x
      0,       0,       0,       0xD0C1,  0xD0C2,  0xD0C3,  0xD0C4,  0xD0C5,  
      0xD0C6,  0xD0C8,  0xD0C9,  0xD0CA,  0xD0CB,  0xD0CC,  0,       0,       // 0x4A3x
      0xA5BD,  0x4EC8,  0xA5BB,  0x4EC9,  0xD5FC,  0xD6AE,  0xD0C7,  0,       
      0xB0A2,  0xA5BE,  0x55D8,  0x55DB,  0x55D9,  0x513B,  0xB0A4,  0xAFFD,  // 0x4A4x
      0xAFFE,  0xAFFC,  0,       0x513C,  0,       0,       0,       0,       
      0,       0,       0xB0A1,  0xD5F8,  0xD5F9,  0xD5FB,  0xD5FD,  0xD6A3,  // 0x4A5x
      0xD6A4,  0xD6A5,  0xD6A6,  0xD6A7,  0xD6A9,  0xD6AD,  0xD6AF,  0xB0A5,  
      0,       0,       0,       0xB0A3,  0xB9B6,  0xD6B0,  0xD6A1,  0xD6A8,  // 0x4A6x
      0x55DC,  0x55DA,  0xD6AC,  0xB9BB,  0xB9BD,  0x5CAD,  0x5CAB,  0xC0DE,  
      0xB9B9,  0x5B6A,  0x566E,  0,       0x5670,  0xB9B8,  0,       0,       // 0x4A7x
      0,       0,       0,       0xDBAE,  0xDBAF,  0xDBB0,  0xDBB1,  0xDBB2,  
      0xDBB3,  0xDBB4,  0xDBB5,  0x5CAC,  0xB9BA,  0xB9BC,  0xB9B7,  0xC0DF,  // 0x4A8x
      0,       0,       0,       0x68BC,  0x5B6B,  0x62D7,  0x6026,  0xC0E0,  
      0x6028,  0,       0,       0,       0,       0,       0,       0xDFD1,  // 0x4A9x
      0xDFD3,  0xDFD4,  0xDFD5,  0xDFD7,  0xDFD9,  0xDFDA,  0xDFDB,  0xDFDC,  
      0xDFDF,  0,       0xC0E1,  0xC0E2,  0xDFD0,  0xDFD2,  0xDFD8,  0,       // 0x4AAx
      0xE3A3,  0xC7FC,  0xC7FB,  0x68BE,  0xC7FA,  0xCEC3,  0x68BD,  0,       
      0,       0,       0,       0,       0xC7F9,  0xE2FC,  0xE2FE,  0xE3A1,  // 0x4ABx
      0xE3A2,  0x6029,  0xE2F9,  0,       0xE2FA,  0xE2FD,  0xD3EF,  0x6CD7,  
      0x6652,  0xE5D2,  0xE5D3,  0xE5D4,  0xE5D5,  0xCEC4,  0xD3EE,  0,       // 0x4ACx
      0xDFDE,  0x6651,  0xD5FC,  0,       0x6653,  0xD8BC,  0,       0,       
      0xE7F6,  0,       0,       0,       0xDBF9,  0x6A52,  0xE9D9,  0xE9DA,  // 0x4ADx
      0x76A4,  0,       0xEAE1,  0xEAE3,  0xEBD6,  0,       0,       0xEAE2,  
      0,       0,       0,       0x79B1,  0xE1A6,  0xE1A5,  0xECB2,  0,       // 0x4AEx
      0x7AAC,  0x6E34,  0xAD26,  0x2AC7,  0x2AC6,  0xB26D,  0xACC1,  0xB26E,  
      0xB956,  0x2EE3,  0x2EE4,  0xB957,  0xB958,  0x3336,  0x33D9,  0x33DA,  // 0x4AFx
      0xB6E5,  0,       0x3AAF,  0x3AB0,  0xCB4F,  0xBDC1,  0xCB50,  0,       
} ;


static const unsigned short Uni2cnsP2Table_4B [] = {
      0,       0x3E5C,  0x40D0,  0x40D1,  0xC3E6,  0,       0,       0xA5C5,  // 0x4B0x
      0xDE78,  0x47C3,  0,       0xCAAA,  0x47C4,  0xA5C4,  0xB0A6,  0x513D,  
      0x4ECA,  0xD0CD,  0xA5C3,  0,       0,       0,       0x513E,  0xB9BE,  // 0x4B1x
      0x62D8,  0xDFE0,  0x5B6D,  0x6654,  0xD3F0,  0x70CA,  0,       0,       
      0x76A5,  0xDBFA,  0xDEFB,  0xE2BB,  0xE2BC,  0,       0x24E2,  0,       // 0x4B2x
      0x27B1,  0x273D,  0xAD27,  0,       0x2AC8,  0x2AC9,  0xB26F,  0x2A3B,  
      0x2A3E,  0,       0,       0,       0x2EE5,  0x2EE7,  0xB95C,  0x2EE6,  // 0x4B3x
      0,       0xB1A9,  0xB95B,  0xB959,  0xB95A,  0,       0x33DD,  0xC222,  
      0xC17E,  0xC224,  0x33DE,  0xC223,  0x33DC,  0xB6E6,  0xB6E8,  0,       // 0x4B4x
      0,       0,       0,       0,       0x3922,  0x3AB1,  0xD536,  0x3927,  
      0x3AB4,  0x3AB3,  0x33DF,  0xCB52,  0x3AB2,  0x33DB,  0,       0xCB51,  // 0x4B5x
      0xCB53,  0,       0,       0x3E64,  0x40D2,  0xD537,  0x3E5E,  0x40D3,  
      0xD533,  0xD535,  0x3E5F,  0xD538,  0,       0xC3E7,  0xD534,  0x47C7,  // 0x4B6x
      0xDE7C,  0x47C5,  0xDE7A,  0,       0x4472,  0,       0,       0,       
      0xDE79,  0,       0,       0xDE7B,  0x47C6,  0,       0,       0,       // 0x4B7x
      0,       0x4B28,  0xA5CA,  0x4ECC,  0x4ECD,  0x4ECE,  0xA5C6,  0xA5C7,  
      0xA5C9,  0,       0,       0,       0,       0xB0A7,  0x5674,  0xB0A8,  // 0x4B8x
      0x55DF,  0x55E1,  0x5140,  0x55E0,  0,       0x55DE,  0x5676,  0x5CAE,  
      0x5677,  0,       0,       0xB9C0,  0xB9BF,  0,       0x4ECB,  0,       // 0x4B9x
      0x5B70,  0x62DB,  0x62DA,  0xC0E4,  0x62D9,  0xC0E5,  0,       0,       
      0,       0x68BF,  0xCEC5,  0,       0,       0,       0xD3F1,  0xD3F2,  // 0x4BAx
      0x6656,  0x70CB,  0x6655,  0xD3F3,  0,       0x6876,  0xD8BD,  0x73DA,  
      0x76A8,  0x76A7,  0xDBFB,  0x76A6,  0,       0xDCEB,  0,       0,       // 0x4BBx
      0x7AEC,  0xE5B8,  0xA334,  0xAD28,  0x27B3,  0x273E,  0,       0,       
      0xA8AB,  0xB270,  0,       0xACC3,  0,       0,       0,       0x40D4,  // 0x4BCx
      0xDE7D,  0xB0AB,  0,       0xB0A9,  0xB0AA,  0x5679,  0xC0E6,  0,       
      0x70CC,  0,       0,       0xA335,  0xA539,  0xAD29,  0x27B4,  0xAD2A,  // 0x4BDx
      0xACC4,  0xACC5,  0x2ACA,  0x2A3F,  0,       0xB271,  0xB479,  0x2EE9,  
      0xC226,  0x33E0,  0xC225,  0xC227,  0xB6E9,  0,       0xD539,  0xCB54,  // 0x4BEx
      0,       0,       0xBDC3,  0xBDC2,  0xD53B,  0,       0xC3E8,  0xD53A,  
      0,       0,       0xDE7E,  0xA5CB,  0xCAAB,  0,       0,       0x567A,  // 0x4BFx
      0,       0xDBB6,  0,       0,       0xE3A6,  0xC6EE,  0xE3A5,  0,       
} ;


static const unsigned short Uni2cnsP2Table_4C [] = {
      0xD3F4,  0,       0,       0xA53A,  0xA4FA,  0x27B5,  0xAD2E,  0xB95D,  // 0x4C0x
      0x33E1,  0,       0xCAAC,  0,       0,       0xDFE1,  0xC7FD,  0,       
      0xECB3,  0x73DB,  0,       0,       0,       0x245F,  0,       0xA4FC,  // 0x4C1x
      0,       0xA4FB,  0,       0xA863,  0,       0x2742,  0x2553,  0x273F,  
      0x27B6,  0xAD31,  0xAD30,  0xAD33,  0xA8AC,  0xA8AD,  0,       0,       // 0x4C2x
      0xAD2F,  0x2A42,  0x2ACD,  0xB274,  0x2ACC,  0xB273,  0x2ACB,  0xB276,  
      0xB27A,  0xB277,  0xB965,  0x2ACE,  0xB278,  0xB275,  0x2EEE,  0,       // 0x4C3x
      0xACC6,  0xACC7,  0xACC8,  0xACC9,  0xACCB,  0xACCC,  0xACCD,  0xACCE,  
      0xACCF,  0,       0,       0,       0,       0,       0,       0,       // 0x4C4x
      0,       0,       0,       0x2ACF,  0x2EEA,  0x2E2E,  0x2EEB,  0xB961,  
      0xB960,  0,       0xB962,  0,       0,       0xB95F,  0xB963,  0xB1AA,  // 0x4C5x
      0xB1AB,  0xB1AC,  0xB1AE,  0,       0,       0,       0x2E30,  0xB1AD,  
      0,       0,       0,       0x2EED,  0x2EEC,  0x333E,  0xC228,  0x33E3,  // 0x4C6x
      0x33E2,  0x333D,  0xC22C,  0xC22F,  0xC22A,  0xC22D,  0xC22E,  0xB6EB,  
      0xB6EC,  0xC22B,  0,       0xC229,  0,       0,       0xC16B,  0,       // 0x4C7x
      0,       0,       0,       0,       0x392B,  0x3929,  0x392A,  0,       
      0,       0,       0,       0xCB57,  0xCB59,  0xB6EA,  0xBDC6,  0xBDC7,  // 0x4C8x
      0xBDC8,  0,       0,       0xCB58,  0,       0x392D,  0xCB55,  0xBDC4,  
      0xBDC5,  0xD540,  0x3E6A,  0x3E67,  0xD53E,  0xD53F,  0x3E66,  0x40D6,  // 0x4C9x
      0xD53C,  0xD542,  0x40D5,  0xD543,  0xD544,  0xD541,  0,       0,       
      0xC3E9,  0xC3EA,  0,       0x40D7,  0,       0,       0,       0xD53D,  // 0x4CAx
      0,       0,       0,       0xDF23,  0x447A,  0x47CA,  0xDF22,  0xDF25,  
      0xDF28,  0xCAAD,  0xDF26,  0,       0,       0xDF24,  0xDF27,  0xA5D0,  // 0x4CBx
      0x4B2C,  0xA5CC,  0xA5CE,  0xA5CD,  0,       0xA5CF,  0x4ECF,  0xA5D1,  
      0xD0CF,  0,       0,       0,       0,       0x4B2B,  0,       0,       // 0x4CCx
      0x5145,  0x5143,  0x5146,  0xB0AC,  0x55E2,  0xD6B2,  0,       0xACBB,  
      0,       0,       0xB9C1,  0x5CB3,  0xB9C3,  0x5CB1,  0x567B,  0xB9C2,  // 0x4CDx
      0x5CB4,  0,       0xDBB7,  0xBCF6,  0,       0,       0,       0x5CB0,  
      0x5CB2,  0xD6B1,  0,       0,       0x5B71,  0,       0,       0,       // 0x4CEx
      0,       0xC7FE,  0x68C1,  0xC8A3,  0xCEC6,  0xC8A1,  0xC8A4,  0x602D,  
      0,       0,       0xC8A2,  0xCEC8,  0,       0,       0xCEC7,  0,       // 0x4CFx
      0,       0xD3F7,  0xE7F7,  0xD3F5,  0xD3F6,  0,       0xE7D2,  0xD8BE,  
} ;


static const unsigned short Uni2cnsP2Table_4D [] = {
      0x6877,  0xD3F8,  0xDBFD,  0xEAE4,  0xDBFC,  0xDEFC,  0,       0xE2BE,  // 0x4D0x
      0xE2BD,  0,       0,       0xE3DA,  0xE3DC,  0,       0xE3DB,  0,       
      0xE6A9,  0xE6B5,  0xE6C6,  0xA336,  0,       0xA53B,  0xA8AE,  0x2E32,  // 0x4D1x
      0x2AD0,  0x392E,  0,       0,       0xD546,  0xD545,  0xDF29,  0x55E3,  
      0xB0AE,  0xA5D2,  0,       0,       0xD8BF,  0x22FC,  0x24E4,  0x24E5,  // 0x4D2x
      0x2460,  0xA866,  0xA867,  0xA865,  0,       0,       0xA868,  0x2745,  
      0xAD35,  0x2744,  0xA8AF,  0x27B8,  0xAD36,  0,       0,       0xB27D,  // 0x4D3x
      0x2A4B,  0xB27C,  0xB27B,  0x2AD2,  0x2AD6,  0x2A47,  0x2A48,  0x2AD3,  
      0x2A45,  0x2AD4,  0x2AD1,  0x2AD5,  0,       0,       0,       0xB324,  // 0x4D4x
      0xACD0,  0,       0,       0xB27E,  0xACD1,  0xB322,  0,       0,       
      0,       0xB323,  0,       0,       0xB321,  0,       0,       0xB969,  // 0x4D5x
      0x2EEF,  0x2EF3,  0xB96F,  0x2EF1,  0xB970,  0xB96A,  0x2EF6,  0x2EF2,  
      0x2EF5,  0xB96D,  0xB971,  0xB966,  0x2E3D,  0x2EF4,  0xB968,  0x2E3E,  // 0x4D6x
      0x2EF0,  0xB96E,  0xB1AF,  0xB967,  0,       0xB96C,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xC231,  // 0x4D7x
      0xC237,  0x33E8,  0xC235,  0x33EB,  0x3341,  0x33EA,  0x33E6,  0xC233,  
      0x3344,  0x33E9,  0xB6ED,  0xB6EE,  0xB6EF,  0xC236,  0xC239,  0,       // 0x4D8x
      0,       0xC234,  0xC238,  0xB6F0,  0xC230,  0,       0,       0,       
      0,       0,       0,       0x33E7,  0x33EC,  0x3AB6,  0x3ABF,  0xCB61,  // 0x4D9x
      0x3AB5,  0xCB65,  0x3AB9,  0x3ABA,  0x3ABC,  0x3AB7,  0xCB63,  0xCB5F,  
      0x3AC0,  0xCB62,  0xCB5B,  0xCB66,  0x3ABE,  0xCB5E,  0,       0,       // 0x4DAx
      0x3939,  0xCB5D,  0xCB60,  0xCB64,  0xBDC9,  0xBDCA,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x3937,  0xCB5C,  // 0x4DBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x3931,  0x3AB8,  0xD54C,  0x3E72,  0x3E70,  0x3E7B,  0x40D9,  0x3E71,  // 0x4DCx
      0x3E75,  0x447D,  0x3E79,  0xD549,  0x40DA,  0x40DC,  0x40E2,  0x3E7C,  
      0xD547,  0x40E1,  0,       0xD54D,  0x40E5,  0x40E3,  0x40DB,  0x3ABD,  // 0x4DDx
      0x40DF,  0x40DE,  0xD54B,  0xD54A,  0x3E7D,  0xC3EB,  0xC3EC,  0,       
      0xD548,  0,       0,       0,       0,       0xD54E,  0,       0,       // 0x4DEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x40D8,  // 0x4DFx
      0x40E6,  0x40DD,  0,       0x47D8,  0x47D0,  0x4525,  0x452B,  0x47CB,  
} ;


static const unsigned short Uni2cnsP2Table_4E [] = {
      0x47CF,  0x4526,  0xDF2F,  0xDF2A,  0x452E,  0x452A,  0xDF2B,  0xDF34,  // 0x4E0x
      0x47CD,  0x47CE,  0x47D3,  0x452C,  0xDF37,  0xDF35,  0x47DA,  0xDF2E,  
      0,       0x4527,  0x4522,  0x47D1,  0x47D2,  0xDF33,  0x47CC,  0x47D6,  // 0x4E1x
      0xDF31,  0xDF30,  0,       0,       0,       0xCAAE,  0xDF38,  0xDF2C,  
      0x452D,  0,       0xDF32,  0,       0xDF36,  0,       0,       0,       // 0x4E2x
      0,       0x47D5,  0x4B3A,  0x4B36,  0x4B2D,  0x4B39,  0x4ED3,  0x4B34,  
      0xA5DD,  0x4B32,  0x4ED5,  0x4ED7,  0x4ED4,  0x4B31,  0xA5D5,  0x4B30,  // 0x4E3x
      0x4ED1,  0x4ED2,  0xA5D3,  0x47D7,  0x4ED8,  0xA5D4,  0xA5DB,  0xA5D9,  
      0,       0,       0xD0D0,  0xD0D1,  0xD0D2,  0xD0D3,  0xD0D4,  0,       // 0x4E4x
      0,       0xA5D6,  0,       0,       0,       0xA5DA,  0,       0xA5DE,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x4E5x
      0,       0,       0,       0x4ED6,  0x4ED0,  0x514B,  0x55E5,  0xB0AF,  
      0xB0B0,  0x55EC,  0x55ED,  0x514C,  0x5147,  0x55E8,  0xB0B5,  0x55E6,  // 0x4E6x
      0x55E7,  0x55EB,  0xB0B1,  0xB0B7,  0x55EE,  0,       0,       0xD6B4,  
      0xD6B5,  0xB0B4,  0,       0xB0B3,  0x55EA,  0,       0xB0B2,  0,       // 0x4E7x
      0,       0xB0B8,  0,       0xB0B9,  0,       0,       0,       0,       
      0x55E4,  0xA5D7,  0,       0,       0x567C,  0x5CB9,  0x55F0,  0xB9D0,  // 0x4E8x
      0x5151,  0x4529,  0x567E,  0xB9C7,  0x5CB5,  0xB9C8,  0x5CBC,  0x5CBA,  
      0x5CBD,  0xB9CF,  0xC0EA,  0x55EF,  0x5CB7,  0x567D,  0x5CB8,  0x5723,  // 0x4E9x
      0xB9C9,  0xB9CD,  0xB9D1,  0xB9CB,  0xB9C6,  0xB9CC,  0,       0,       
      0,       0xDBB8,  0,       0,       0,       0,       0xB9C4,  0xB9C5,  // 0x4EAx
      0xB9CE,  0x5CBB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x62DC,  // 0x4EBx
      0x5CBE,  0xB9CA,  0x5B78,  0x5CC0,  0x62E0,  0xC0E8,  0x62E5,  0xC0E9,  
      0x62E1,  0x62E4,  0x5B76,  0x5CBF,  0x62DD,  0x62E2,  0x62DE,  0x62DF,  // 0x4ECx
      0x5B7A,  0xC0ED,  0,       0,       0,       0x62E3,  0,       0,       
      0,       0,       0,       0,       0,       0xC8AB,  0x6033,  0xC8A7,  // 0x4EDx
      0x6034,  0x68C4,  0x6035,  0xC8A6,  0x68C3,  0x68C2,  0x6036,  0,       
      0,       0xE3A7,  0x6031,  0xC8A8,  0,       0xC8A9,  0,       0,       // 0x4EEx
      0xC8A5,  0,       0,       0,       0,       0,       0xC8AA,  0xC0EC,  
      0,       0x636A,  0x636B,  0xCEC9,  0xCECD,  0xCECC,  0x6CD8,  0x6CD9,  // 0x4EFx
      0xCECE,  0xCECB,  0xCECA,  0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_4F [] = {
      0x70D1,  0x70D0,  0x70CE,  0x6657,  0xD3FA,  0x70CF,  0xD3F9,  0xE7F8,  // 0x4F0x
      0,       0,       0,       0x73DF,  0x73DE,  0x73DD,  0,       0,       
      0xDCA2,  0xDBFE,  0x6A56,  0,       0,       0,       0xDCA1,  0x76A9,  // 0x4F1x
      0x77EB,  0xDEFD,  0xDEFE,  0,       0xE1C2,  0xE1A7,  0,       0xE2BF,  
      0xE2C0,  0xE2C1,  0x7AED,  0xE4D1,  0xE5B9,  0x2463,  0,       0xB325,  // 0x4F2x
      0xACD2,  0xB973,  0xB972,  0xB1B0,  0xC23A,  0xB6F1,  0,       0xCB69,  
      0xCB67,  0x3AC1,  0xCB68,  0,       0,       0,       0,       0xA5DF,  // 0x4F3x
      0,       0x5153,  0x5152,  0,       0xB0BA,  0xA53C,  0xA53D,  0,       
      0,       0x24E6,  0x27BA,  0x27BB,  0,       0,       0x27B9,  0x27BC,  // 0x4F4x
      0x2A4D,  0x2AD9,  0x2AD8,  0,       0x2AD7,  0xB327,  0xB328,  0,       
      0xB326,  0xACD3,  0xACD4,  0,       0xB329,  0,       0x2ADA,  0,       // 0x4F5x
      0xB974,  0x2E42,  0xB975,  0xC23C,  0,       0xB1B1,  0xB1B2,  0xB1B3,  
      0xB1B5,  0xB1B6,  0,       0,       0xB6F5,  0x3346,  0x33EE,  0xC23B,  // 0x4F6x
      0xB6F2,  0xB6F3,  0xB6F6,  0,       0xCB6B,  0,       0,       0xCB6C,  
      0xCB6A,  0,       0,       0,       0,       0,       0,       0xB6F4,  // 0x4F7x
      0,       0x40E8,  0x40E7,  0xD550,  0x3E7E,  0xD54F,  0,       0x40E9,  
      0,       0,       0,       0xC3ED,  0,       0,       0,       0,       // 0x4F8x
      0x452F,  0xDF39,  0xDF3A,  0xCAB0,  0xCAB1,  0xCAB3,  0xCAB4,  0xCAB2,  
      0,       0,       0,       0,       0,       0x4B3C,  0,       0,       // 0x4F9x
      0xA5E0,  0xA5E1,  0,       0x55F2,  0xB0BC,  0x55F1,  0xB0BB,  0,       
      0x5727,  0x5728,  0x5CC2,  0x5CC4,  0xC0EE,  0x5CC1,  0xB9D2,  0x62E6,  // 0x4FAx
      0xC0EF,  0,       0xC0F0,  0x68C5,  0x68C6,  0x68C7,  0,       0,       
      0,       0,       0x68C8,  0xC8AC,  0xCED0,  0,       0xCECF,  0,       // 0x4FBx
      0x62E7,  0,       0,       0xD8C0,  0xD8C1,  0xE7F9,  0xDCA3,  0,       
      0x6B73,  0,       0,       0xDFA1,  0,       0xE5BA,  0x24E7,  0x24E8,  // 0x4FCx
      0xAD39,  0xAD37,  0xAD38,  0x27BD,  0,       0,       0xB32B,  0x2ADB,  
      0x2A4F,  0xB036,  0xB32A,  0,       0,       0x2EF7,  0x2EF8,  0xB976,  // 0x4FDx
      0xB97A,  0x33EF,  0x2E44,  0xB977,  0xB978,  0xB979,  0,       0x3349,  
      0x33F0,  0xC23E,  0xB6F9,  0,       0,       0xC23D,  0,       0x393C,  // 0x4FEx
      0xCB6D,  0x3AC2,  0xCB6F,  0x393B,  0xBDCB,  0,       0xCB6E,  0,       
      0,       0,       0xB6F8,  0x40EA,  0x40ED,  0x40EB,  0x40EC,  0x40EE,  // 0x4FFx
      0,       0xD553,  0xC3EE,  0,       0,       0,       0,       0xD551,  
} ;


static const unsigned short Uni2cnsP2Table_50 [] = {
      0,       0x3F21,  0x4531,  0x4533,  0xDF3E,  0,       0xCAB5,  0xDF3D,  // 0x500x
      0x47DC,  0xDF3F,  0xDF3B,  0xDF3C,  0,       0xA5E3,  0x4EDA,  0x4EDB,  
      0x4EDC,  0xA5E2,  0,       0,       0x55F6,  0x55F8,  0x55F4,  0x5158,  // 0x501x
      0x55F7,  0x55F5,  0xD6B6,  0x55F3,  0xB0BD,  0,       0xB0BE,  0xB9D3,  
      0,       0xB0BF,  0x5729,  0x62E8,  0xC0F2,  0xC0F3,  0xC0F4,  0,       // 0x502x
      0xC0F1,  0,       0,       0x68CA,  0x68C9,  0xC8AD,  0,       0x636D,  
      0x6CDB,  0x6CDA,  0xCED1,  0,       0xD3FC,  0x665C,  0xD8C2,  0,       // 0x503x
      0,       0x77EC,  0x77ED,  0,       0xE3C4,  0xE5D8,  0,       0xA869,  
      0xA4FD,  0x2749,  0x27BE,  0x2747,  0xAD3B,  0x27BF,  0x2ADE,  0x2ADC,  // 0x504x
      0x2ADD,  0xB32D,  0,       0xB32C,  0xACD5,  0,       0x2EF9,  0xBA21,  
      0xBA23,  0x2E48,  0x2EFA,  0xB97E,  0xB97B,  0x2E4A,  0xBA22,  0,       // 0x505x
      0xB1B7,  0xB1B8,  0xBA24,  0xB97C,  0xB97D,  0,       0x334C,  0x33F2,  
      0x334A,  0xC23F,  0,       0xB6FA,  0xB6FB,  0xB6FC,  0xB6FD,  0xB7A1,  // 0x506x
      0xB7A2,  0xC240,  0xC241,  0xBA25,  0xCB74,  0xCB70,  0x3AC3,  0x393D,  
      0xCB72,  0xCB73,  0,       0xBDCC,  0xBDCD,  0,       0xCB71,  0xD554,  // 0x507x
      0xD556,  0x40F0,  0xD558,  0xD557,  0xD555,  0,       0,       0xC3EF,  
      0xC3F0,  0,       0,       0xDF41,  0xDF40,  0xDF4B,  0xCAB6,  0x4EDD,  // 0x508x
      0xA5E4,  0,       0xA5E5,  0,       0xD0D5,  0xD0D6,  0xD0D7,  0xD0D8,  
      0xD0D9,  0xD0DA,  0,       0x5159,  0xB0C4,  0x515B,  0xB0C0,  0xB0C5,  // 0x509x
      0x55FA,  0x55F9,  0xD6B7,  0xD6B8,  0xD6B9,  0,       0xD6BA,  0xD6BB,  
      0xB0C3,  0xB0C1,  0,       0,       0x572B,  0x5C23,  0x572A,  0xB9D4,  // 0x50Ax
      0x5CC7,  0xC0F5,  0,       0,       0x5CC6,  0xDBBB,  0xDBBC,  0,       
      0,       0xB9D5,  0xB9D6,  0xB6F9,  0,       0x5CC5,  0xB0C2,  0xB9D7,  // 0x50Bx
      0x5C22,  0x5C21,  0xC0F6,  0,       0xC0F8,  0,       0xC0F7,  0xDFE2,  
      0xC0F9,  0xC8AE,  0x68CB,  0xC8AF,  0xE3A8,  0xE3A9,  0,       0x6CDD,  // 0x50Cx
      0xCED3,  0x6CDC,  0xCED5,  0xE5D6,  0,       0xCED2,  0xCED4,  0,       
      0,       0,       0xE7FB,  0xD8C4,  0x73E0,  0xD8C3,  0xD8C5,  0xE7FA,  // 0x50Dx
      0xDFA2,  0x76AA,  0,       0,       0xDFA3,  0,       0,       0,       
      0,       0xE2C2,  0,       0,       0x22FD,  0xA2E7,  0xA86A,  0x2464,  // 0x50Ex
      0x24EA,  0x2466,  0x24EB,  0x24E9,  0xA4FE,  0,       0,       0,       
      0,       0,       0x2750,  0xAD3C,  0x27C1,  0x274B,  0xAD40,  0xAD42,  // 0x50Fx
      0xAD3E,  0x27C2,  0x27C3,  0xAD41,  0xAD3F,  0x27C0,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_51 [] = {
      0xAD43,  0,       0xAD44,  0xB339,  0xB335,  0xB32E,  0xB332,  0x2A5E,  // 0x510x
      0xB336,  0x2A5C,  0xB33C,  0x2AE5,  0xB333,  0x2AE9,  0x2A5B,  0xB32F,  
      0xB33B,  0x2AE0,  0x2AE7,  0x2AEB,  0x2AE1,  0x2AEA,  0x2AE8,  0x2AE3,  // 0x511x
      0x2AEC,  0xB330,  0,       0x2ADF,  0x2AE6,  0x2AE2,  0x2AE4,  0,       
      0,       0,       0,       0xACD6,  0xACD8,  0xB337,  0,       0xB33A,  // 0x512x
      0,       0xB334,  0,       0,       0,       0,       0,       0,       
      0,       0x2E50,  0x2FA4,  0xAEDA,  0x2E4C,  0x2EFB,  0xBA26,  0x2E4E,  // 0x513x
      0x2FA2,  0x2EFC,  0xBA28,  0x2E4B,  0xBA29,  0x2FA3,  0xBA2A,  0x2E53,  
      0xBA2C,  0x2EFE,  0,       0,       0x2FA5,  0,       0,       0,       // 0x514x
      0,       0xBA2B,  0xB1B9,  0xB1BA,  0xB1BB,  0xB1BC,  0xB1BD,  0,       
      0,       0,       0,       0xBA27,  0,       0,       0,       0x2FA1,  // 0x515x
      0x2EFD,  0x2E54,  0x3355,  0xC253,  0xC246,  0xC24D,  0x33F4,  0x33F3,  
      0x33FD,  0x3354,  0xC247,  0xC244,  0,       0xC242,  0x33FA,  0x33FB,  // 0x516x
      0x33F5,  0xC24A,  0x33F8,  0xC254,  0x33F9,  0xC243,  0xC24F,  0,       
      0xC24B,  0xC250,  0xB7A5,  0xC252,  0,       0,       0xC24C,  0,       // 0x517x
      0,       0xC249,  0,       0,       0xC251,  0xB7A6,  0,       0,       
      0,       0,       0,       0,       0,       0x33FE,  0xC245,  0xC24E,  // 0x518x
      0x33F7,  0x33FC,  0,       0x3AC9,  0x3ACC,  0xCB79,  0xCC23,  0x3353,  
      0xCB78,  0x3ACB,  0xCB7D,  0xCC21,  0x3AC6,  0xCC26,  0xCB77,  0x394F,  // 0x519x
      0x3ACA,  0x3AC8,  0x3AC4,  0x394E,  0x40F1,  0xCC25,  0x40FE,  0x3940,  
      0xCB7E,  0x3ACD,  0xCB7B,  0x3ACE,  0xCC28,  0x3AC5,  0x3AC7,  0,       // 0x51Ax
      0,       0,       0xBDCF,  0xBDD0,  0xBDD1,  0,       0,       0,       
      0xCB7C,  0,       0,       0xCC27,  0,       0xCB76,  0xCC24,  0,       // 0x51Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xCC22,  0x3944,  0x3950,  0x3ACF,  0x393E,  // 0x51Cx
      0,       0xD55B,  0xD55E,  0xD55A,  0x3F2A,  0x40F8,  0xD55C,  0x40F7,  
      0xD55F,  0x40F5,  0xD559,  0x3F23,  0x3F28,  0x3F31,  0x3F2E,  0,       // 0x51Dx
      0x40FA,  0xD562,  0x40F6,  0x3F2F,  0x3F24,  0xD564,  0x40F9,  0x40F2,  
      0x40FC,  0xD566,  0,       0,       0xD55D,  0,       0,       0,       // 0x51Ex
      0xC3F1,  0xC3F2,  0xC3F3,  0xCB75,  0,       0,       0xD563,  0,       
      0,       0,       0,       0,       0xD335,  0x40F3,  0,       0,       // 0x51Fx
      0,       0,       0,       0,       0,       0,       0x40FD,  0x40F4,  
} ;


static const unsigned short Uni2cnsP2Table_52 [] = {
      0xD565,  0,       0x47E0,  0x4545,  0,       0xDF44,  0x453E,  0x47E3,  // 0x520x
      0xDF48,  0x47E5,  0x47E6,  0xDF49,  0x4B4F,  0xDF4E,  0xDF46,  0xDF4F,  
      0xA5EC,  0xDF47,  0x47E7,  0x47E4,  0xDF43,  0xDF4A,  0xDF45,  0x47E2,  // 0x521x
      0xDF42,  0x47DF,  0x47DE,  0x47DD,  0xA5E6,  0,       0,       0,       
      0,       0,       0xCAB7,  0xCAB8,  0xCAB9,  0xCABA,  0xCABB,  0xCABC,  // 0x522x
      0xCABD,  0x453A,  0xDF4D,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xDF4C,  // 0x523x
      0x47E9,  0,       0,       0x453B,  0x4B50,  0x4B4C,  0x4B3E,  0x4EE2,  
      0x4EE7,  0x4B4E,  0xA5EB,  0x4EEC,  0x4EE5,  0x4B41,  0xA5F0,  0x4B40,  // 0x524x
      0x5165,  0xB0CD,  0x4EE4,  0x56A1,  0x4EE6,  0xA5ED,  0x4EEA,  0xA5F2,  
      0x4B49,  0x4B4B,  0x4B46,  0x4EDF,  0x4EEB,  0xA5E7,  0xA5E8,  0xA5EA,  // 0x525x
      0x4B4A,  0x4EE3,  0xA5EE,  0x4EDE,  0x4EE1,  0x55FB,  0x4EE9,  0x4EE8,  
      0,       0,       0xA5E9,  0xD0DB,  0xD0DC,  0xD0DD,  0xA5EF,  0,       // 0x526x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x4B48,  0,       0,       0,       0x56AA,  0x56AB,  0x515E,  0x56A5,  // 0x527x
      0x56A3,  0x56A7,  0x55FD,  0x5163,  0x56A9,  0x55FE,  0x56A6,  0x56A4,  
      0x5162,  0xB0C6,  0xB0CE,  0,       0xB0CF,  0xB0CB,  0xB0C7,  0x4EED,  // 0x528x
      0x5167,  0x55FC,  0xB0C9,  0,       0,       0,       0xD6BD,  0,       
      0xB0D1,  0,       0,       0,       0,       0xB0CC,  0,       0,       // 0x529x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x56AC,  // 0x52Ax
      0x5166,  0,       0x47E8,  0x56A8,  0x5C2B,  0x5CC8,  0x5CCB,  0x5735,  
      0x5736,  0xB0D2,  0xB9DE,  0xB9D9,  0x5CCA,  0xB9DA,  0x5CCC,  0xB9E4,  // 0x52Bx
      0x5CC9,  0xC1A2,  0xB9DF,  0xB9E0,  0xB9DD,  0x5737,  0xB9E3,  0x5CCF,  
      0xB0C8,  0x5CCE,  0xB9E1,  0xB9DC,  0xB9DB,  0,       0,       0,       // 0x52Cx
      0xDBBE,  0xDBBF,  0xDBC0,  0,       0,       0xB9E2,  0,       0,       
      0xB9D8,  0,       0,       0,       0,       0,       0,       0,       // 0x52Dx
      0,       0x5C28,  0xC1A3,  0xC0FE,  0x62EE,  0x5C2C,  0x62EB,  0xC0FB,  
      0xC0FC,  0x62F0,  0x5C24,  0x62EC,  0x62EF,  0x62F1,  0,       0,       // 0x52Ex
      0x62EA,  0xDFE3,  0xDFE4,  0xC1A4,  0xC1A5,  0xC0FD,  0,       0x62ED,  
      0xC0FA,  0,       0,       0,       0,       0,       0,       0,       // 0x52Fx
      0,       0,       0,       0xC1A1,  0,       0,       0,       0x68CF,  
} ;


static const unsigned short Uni2cnsP2Table_53 [] = {
      0x68CC,  0x68D1,  0x603E,  0x68D0,  0x603B,  0x68D4,  0x68CE,  0xC8B2,  // 0x530x
      0x603A,  0xC8B4,  0x603C,  0x603D,  0xC8B0,  0x68CD,  0xC8B1,  0x68D3,  
      0x68D2,  0,       0,       0,       0xE3AA,  0xCBDD,  0xC8B5,  0xC8B3,  // 0x531x
      0,       0,       0x6CE0,  0x6CE2,  0x6CDE,  0xCED8,  0x6CE1,  0x6CE3,  
      0,       0xCED7,  0xE5D7,  0x6372,  0,       0,       0,       0,       // 0x532x
      0x6CDF,  0x6373,  0xCED6,  0,       0,       0xD4A2,  0x70D2,  0x70D4,  
      0x70D3,  0x70D5,  0xD3FE,  0,       0,       0xD4A3,  0xD3FD,  0,       // 0x533x
      0,       0,       0x6879,  0x73E3,  0xD8C6,  0x73E1,  0x73E2,  0xD8C7,  
      0x73E5,  0x6A59,  0xD4A1,  0x73E4,  0xD9B3,  0,       0x73E6,  0,       // 0x534x
      0,       0x76AB,  0xDCA6,  0x6A58,  0xDCA5,  0,       0,       0xDFA4,  
      0,       0,       0,       0x6C74,  0xE2C3,  0xE2C5,  0,       0xE2C4,  // 0x535x
      0,       0xECE6,  0x7BC3,  0,       0,       0,       0x27C4,  0x2A60,  
      0x2A61,  0x2E56,  0x2FA8,  0x2FA7,  0xBA2F,  0xBA30,  0,       0x3358,  // 0x536x
      0x34A2,  0xB7A7,  0x3AD2,  0x3951,  0x3AD3,  0x3AD1,  0x3AD5,  0x3AD0,  
      0xCC29,  0x3AD4,  0x41A3,  0x41A2,  0,       0x41A1,  0xDF51,  0xDF52,  // 0x537x
      0x4547,  0x4548,  0x47EC,  0x47EA,  0x47EB,  0x4549,  0xDF50,  0x454B,  
      0xCDBF,  0,       0x4EEE,  0x4B52,  0xA5F5,  0x4EEF,  0x4B51,  0xA5F4,  // 0x538x
      0,       0x4B53,  0x5169,  0x5168,  0x516A,  0x56AD,  0x62F5,  0xB9E5,  
      0x5AF5,  0,       0x5CD0,  0x62F4,  0x62F3,  0x62F2,  0x68D7,  0x68D6,  // 0x539x
      0x68D5,  0x68D8,  0xC8B6,  0,       0xC8B7,  0,       0,       0,       
      0,       0x6A5A,  0,       0,       0xE6BF,  0xE6C9,  0xA63F,  0xA86B,  // 0x53Ax
      0xA86C,  0xB341,  0xB33F,  0xB340,  0x2AEE,  0,       0,       0,       
      0x2FAA,  0x2FAB,  0xBA33,  0xB1BF,  0xB1C0,  0xBA31,  0xBA32,  0,       // 0x53Bx
      0x2FA9,  0x34A3,  0x34A4,  0x335C,  0xC259,  0xC257,  0x34A5,  0xC255,  
      0xC25B,  0xC256,  0xC25A,  0,       0,       0,       0,       0,       // 0x53Cx
      0,       0xC258,  0,       0,       0,       0,       0x3952,  0xCC2C,  
      0,       0xBDD2,  0,       0,       0xCC2A,  0,       0,       0xBDD3,  // 0x53Dx
      0x41A4,  0x3F32,  0xD569,  0,       0x3F35,  0x3F34,  0xD567,  0x3AD6,  
      0x3F36,  0xC3F5,  0xD568,  0,       0,       0,       0,       0,       // 0x53Ex
      0,       0,       0x47ED,  0x47EE,  0xDF53,  0,       0,       0x47EF,  
      0x47F0,  0xCABE,  0xA5F8,  0x4B54,  0xA5F6,  0xA5F7,  0xD0E1,  0xA5F9,  // 0x53Fx
      0,       0,       0,       0xB0D4,  0x516B,  0xD6BF,  0xB0D3,  0,       
} ;


static const unsigned short Uni2cnsP2Table_54 [] = {
      0x5CD1,  0x5CD2,  0,       0xB9E6,  0xB9E7,  0,       0,       0,       // 0x540x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x73E7,  0,       0x76AC,  0,       0x22FE,  0xA53E,  0x2467,  // 0x541x
      0xA86D,  0x24ED,  0x24EC,  0xA5A1,  0xA5A2,  0x27C5,  0x2754,  0,       
      0xA8B0,  0xA8B1,  0xA8B2,  0xA8B3,  0xAD47,  0xA8B5,  0,       0,       // 0x542x
      0,       0x2A65,  0x2A63,  0xB345,  0x2AF0,  0,       0,       0,       
      0,       0xACD9,  0xACDA,  0xACDB,  0xACDD,  0xACDE,  0xACDF,  0xACE1,  // 0x543x
      0xACE3,  0,       0xB343,  0,       0xB344,  0xACE4,  0,       0,       
      0xACE0,  0xB342,  0,       0,       0x2AEF,  0x2AF1,  0x2E60,  0x2FB3,  // 0x544x
      0xBA34,  0xB346,  0xBA35,  0x2FAF,  0xBA39,  0x2FAC,  0x2FB1,  0x2FB0,  
      0x2E5B,  0x2E5D,  0x2FB6,  0x2FB2,  0x2FB5,  0,       0,       0xB1BE,  // 0x545x
      0x2E59,  0x2FB7,  0xBA38,  0xB1C2,  0xB1C3,  0xB1C5,  0xB1C6,  0,       
      0,       0,       0x2E5A,  0x2FAD,  0,       0,       0,       0,       // 0x546x
      0,       0xBA37,  0,       0,       0xB1C8,  0,       0xB1C1,  0x34A6,  
      0x2FAE,  0,       0xBA36,  0x34AC,  0x34A8,  0xC261,  0xC25F,  0,       // 0x547x
      0x34B1,  0x34B0,  0x34AA,  0xC260,  0x34B4,  0x34B2,  0x2FB8,  0x34AE,  
      0x34A7,  0x34A9,  0x34AD,  0,       0xB7A8,  0,       0xB7A9,  0xB7AA,  // 0x548x
      0xB7AB,  0xB7AE,  0xB7AF,  0xB7B1,  0xB7B2,  0xB7B3,  0,       0xC25E,  
      0,       0,       0xC25C,  0,       0xCC2E,  0,       0xB7B0,  0,       // 0x549x
      0,       0,       0,       0,       0x34AB,  0,       0xB7AC,  0,       
      0,       0,       0,       0,       0xC262,  0,       0,       0x34AF,  // 0x54Ax
      0x34B3,  0xC25D,  0x3AD8,  0x3ADE,  0x3AD7,  0x3ADB,  0x3956,  0xCC35,  
      0x3957,  0x3955,  0x3ADC,  0x3ADD,  0xCC31,  0x3ADA,  0x3ADF,  0,       // 0x54Bx
      0,       0xBDD4,  0xBDD5,  0xBDD6,  0xBDD7,  0xCC34,  0,       0,       
      0xCC30,  0xCC32,  0,       0,       0,       0,       0x3AE1,  0x3AE0,  // 0x54Cx
      0,       0,       0x41A8,  0xD571,  0x3F37,  0x41A9,  0xD56A,  0xD56C,  
      0x41A5,  0xD56E,  0x3F41,  0x3F43,  0xD56F,  0xD572,  0x41A6,  0x41A7,  // 0x54Dx
      0,       0,       0xD56D,  0xC3F7,  0xC3F8,  0xC3F9,  0xC3FA,  0xC3FB,  
      0xC3FC,  0xC3FD,  0xC3FE,  0xC4A1,  0xC4A2,  0xC4A3,  0xC4A4,  0xC4A6,  // 0x54Ex
      0,       0,       0,       0,       0,       0xD570,  0,       0,       
      0,       0xD573,  0,       0,       0,       0,       0,       0,       // 0x54Fx
      0,       0,       0xDF5B,  0x47F8,  0xDF54,  0xA5FE,  0x47FA,  0xDF56,  
} ;


static const unsigned short Uni2cnsP2Table_55 [] = {
      0x4552,  0x47F3,  0x47F2,  0xDF57,  0x47FB,  0xDF59,  0xDF5A,  0x47F5,  // 0x550x
      0xDF55,  0x47F1,  0x47FD,  0,       0,       0,       0,       0,       
      0xDF58,  0,       0xCAC1,  0xCAC3,  0xCAC4,  0xCAC5,  0xCAC6,  0xCAC7,  // 0x551x
      0xCAC8,  0xCAC9,  0xCACB,  0xCACC,  0xCACD,  0xCACF,  0xCAD0,  0xCAD1,  
      0xCAD2,  0,       0x4554,  0xCAC0,  0,       0,       0,       0,       // 0x552x
      0x47F7,  0x47FC,  0x47F9,  0x47F4,  0xD0E4,  0x4B5A,  0x4EF2,  0x4EF3,  
      0xA6A1,  0x4EF0,  0x4550,  0xA6A5,  0x4EF5,  0xA5FD,  0xD0E2,  0xD0E3,  // 0x553x
      0xD0E5,  0xD0E6,  0xD0E8,  0,       0,       0,       0,       0,       
      0,       0,       0,       0xA6A2,  0,       0xA5FA,  0xA6A3,  0x4EF1,  // 0x554x
      0x4EF4,  0xA5FC,  0,       0xCACA,  0xB0D8,  0x56B1,  0x56AE,  0x56B2,  
      0xB0D5,  0x5171,  0,       0x5173,  0x56B4,  0x5172,  0xB0D6,  0xB0DA,  // 0x555x
      0x516F,  0,       0xB0D7,  0,       0,       0,       0xD6C1,  0xD6C2,  
      0xD6C3,  0x56B0,  0,       0,       0,       0xD6C4,  0x56AF,  0xD6C5,  // 0x556x
      0xD6C6,  0xD6C7,  0xD6C9,  0xD6CB,  0xD6CC,  0xD6CD,  0,       0,       
      0x5CD6,  0xB9E8,  0x5CD4,  0xB9EF,  0xB9EA,  0x5CD3,  0x573A,  0xB9E9,  // 0x557x
      0x5CD5,  0x573D,  0xB9EC,  0x573C,  0x56B5,  0x5CD8,  0x5CD7,  0x5CD9,  
      0,       0,       0xDBC1,  0xDBC2,  0xDBC3,  0xDBC4,  0xDBC5,  0xDBC6,  // 0x558x
      0xDBC7,  0xDBC8,  0xDBC9,  0xB9EB,  0xB9EE,  0,       0,       0xD6CA,  
      0,       0,       0,       0,       0,       0,       0,       0xC1A9,  // 0x559x
      0x62F6,  0x62F8,  0xC1A6,  0xC1A8,  0x62F7,  0x5C30,  0x62FA,  0xC1A7,  
      0x62F9,  0xC1AA,  0xDFE5,  0xDFE6,  0xDFE7,  0xDFE8,  0xDFE9,  0,       // 0x55Ax
      0,       0,       0x6040,  0x68DA,  0x68D9,  0,       0xE3AB,  0xE3AC,  
      0xE3AD,  0xE3AE,  0,       0xC8BA,  0xC8B8,  0,       0,       0xC8B9,  // 0x55Bx
      0,       0xE3AF,  0,       0x6CE5,  0x6CE6,  0xCED9,  0xCEDA,  0x6CE4,  
      0x6CE7,  0x6041,  0xCEDB,  0xE5DA,  0xE5DB,  0xE5DC,  0xE5DD,  0,       // 0x55Cx
      0,       0xCEDD,  0,       0,       0,       0,       0,       0,       
      0,       0,       0x70D6,  0x70D7,  0,       0,       0xE7FD,  0,       // 0x55Dx
      0xD4A4,  0x6662,  0,       0xE7FC,  0,       0x73E8,  0xD8C8,  0x73E9,  
      0,       0xE9DB,  0xE9DC,  0xD8C9,  0,       0,       0,       0,       // 0x55Ex
      0,       0,       0x73EA,  0x76AE,  0x6A5B,  0x76AD,  0x76AF,  0xEAE5,  
      0,       0xDCA8,  0xDCA7,  0,       0xDFA6,  0,       0,       0xDFA5,  // 0x55Fx
      0xDFA7,  0,       0xE2C6,  0x7AAD,  0,       0,       0x7AEE,  0x6D75,  
} ;


static const unsigned short Uni2cnsP2Table_56 [] = {
      0,       0xE4D3,  0,       0xE5BB,  0x7CC3,  0xA227,  0xA540,  0,       // 0x560x
      0xA86E,  0xA2E8,  0,       0,       0,       0xAD48,  0xA5A4,  0,       
      0,       0,       0,       0,       0,       0xB347,  0xB349,  0,       // 0x561x
      0,       0xA8B6,  0xA8B8,  0xA8B9,  0xA8BA,  0xA8BB,  0xA8BD,  0,       
      0,       0,       0,       0,       0xA8B7,  0,       0xB15A,  0,       // 0x562x
      0,       0,       0,       0x2FB9,  0xBA3A,  0x2E63,  0x2FBA,  0,       
      0xBA3B,  0xB34B,  0,       0,       0,       0,       0,       0,       // 0x563x
      0xACE5,  0xACE6,  0xACE7,  0xACE8,  0xACE9,  0xB1C9,  0xB1CB,  0xB1CE,  
      0,       0,       0xBA3E,  0,       0xBA3F,  0,       0,       0,       // 0x564x
      0,       0xBA3D,  0xBA40,  0xBA3C,  0xACEA,  0x2A68,  0x34B6,  0xBA41,  
      0,       0,       0,       0,       0xB1CA,  0xB1CC,  0xB1CD,  0xB1CF,  // 0x565x
      0xB1D0,  0xB1D1,  0xB1D2,  0xB1D3,  0xB1D4,  0xB7B7,  0,       0,       
      0,       0,       0,       0,       0xC263,  0,       0,       0,       // 0x566x
      0x34B5,  0,       0,       0xCC38,  0x3AE2,  0xCC39,  0xCC3A,  0xCC3C,  
      0x3AE3,  0xCC3D,  0xCC3B,  0,       0,       0,       0,       0xCC36,  // 0x567x
      0xCC37,  0xB7B4,  0xB7B6,  0xB7B8,  0xBDDB,  0,       0,       0,       
      0,       0,       0,       0xB7B5,  0,       0,       0,       0,       // 0x568x
      0xD575,  0x41AB,  0x41AA,  0x41AC,  0xCC3F,  0x3F48,  0xBDD8,  0xBDD9,  
      0xBDDA,  0xBDDC,  0xBDDD,  0xBDDE,  0xBDDF,  0xBDE2,  0xBDE3,  0xBDE4,  // 0x569x
      0xC4A8,  0xC4AA,  0xBDE1,  0,       0xD574,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x48A3,  0xDF5F,  // 0x56Ax
      0xDF60,  0x4556,  0xDF63,  0xDF61,  0,       0,       0,       0,       
      0xC4A7,  0xC4A9,  0xC4AB,  0xC4AC,  0xC4AD,  0xC4AE,  0xC4AF,  0xC4B0,  // 0x56Bx
      0xC4B1,  0xC4B2,  0,       0,       0,       0,       0,       0,       
      0xDF5D,  0xDF62,  0x48A1,  0xDF5E,  0,       0x4B5F,  0xA6A6,  0xDF5C,  // 0x56Cx
      0xDF64,  0,       0xCAD3,  0xCAD5,  0xCAD6,  0xCAD7,  0xCAD8,  0xCADA,  
      0,       0,       0,       0,       0xA6A8,  0,       0,       0,       // 0x56Dx
      0x56B8,  0xB0DC,  0x56B6,  0xB0DD,  0x5177,  0x56B9,  0x56B7,  0x56BA,  
      0xA6AA,  0xB0DB,  0xD0EA,  0xD0E9,  0xD6D1,  0,       0,       0,       // 0x56Ex
      0,       0,       0,       0,       0,       0,       0x5743,  0x5CDA,  
      0xB9F3,  0x5744,  0xB9F6,  0xB9F4,  0xB0DE,  0xD0EB,  0,       0xD6CE,  // 0x56Fx
      0xD6CF,  0xD6D0,  0xD6D2,  0xB9F1,  0xB9F5,  0xB9F2,  0,       0xB9F0,  
} ;


static const unsigned short Uni2cnsP2Table_57 [] = {
      0,       0xDBCD,  0xDBCF,  0x5C34,  0x62FB,  0xC1AC,  0,       0xDBCB,  // 0x570x
      0xDBCC,  0xDBCE,  0xDBD0,  0xDBD1,  0xDBD2,  0,       0,       0xC1AB,  
      0,       0x5C33,  0x68DB,  0xC8BC,  0xC8BD,  0xDFEA,  0,       0xDFEB,  // 0x571x
      0,       0,       0x6CE8,  0x6377,  0,       0,       0xE5DE,  0xCEDE,  
      0xD4A6,  0,       0,       0xD4A5,  0,       0xE5DF,  0x687D,  0xD8CA,  // 0x572x
      0,       0xD8CB,  0xDCA9,  0xE9DD,  0xDCAA,  0,       0,       0xDCAB,  
      0x77EE,  0xDCAC,  0x77EF,  0xEAE7,  0x79B2,  0,       0,       0xE2C9,  // 0x573x
      0xE2C7,  0xE3DD,  0xECE7,  0xA2E9,  0xB34D,  0xC264,  0x395B,  0xCC40,  
      0,       0xD576,  0,       0xDF65,  0xA6AC,  0xB0DF,  0,       0xB0E0,  // 0x574x
      0xC1AD,  0,       0x73EB,  0xE1A8,  0x217E,  0xA541,  0,       0xA2EA,  
      0xA86F,  0,       0xA5A5,  0xA870,  0x2755,  0x27C8,  0x2757,  0,       // 0x575x
      0x27C7,  0,       0xA8BE,  0xA8BF,  0xA8C0,  0xA8C1,  0xA8C2,  0,       
      0,       0,       0xAD4A,  0xB351,  0xB354,  0x2AF4,  0x2AF2,  0x2A70,  // 0x576x
      0x2AF5,  0xB356,  0xB350,  0xB352,  0x2A6D,  0xB34F,  0x2AF3,  0xB357,  
      0,       0,       0,       0xACEB,  0xACEC,  0xACEE,  0xACEF,  0,       // 0x577x
      0,       0xACF0,  0xB355,  0xB353,  0xB34E,  0,       0x2FBC,  0x2FBB,  
      0xBA45,  0x2FBD,  0xBA46,  0x2FBE,  0x2AF6,  0x34BC,  0xBA47,  0,       // 0x578x
      0xB1D5,  0xB1D6,  0,       0,       0,       0,       0,       0,       
      0,       0,       0xBA42,  0,       0,       0,       0,       0xBA44,  // 0x579x
      0x34BA,  0xC269,  0x34BF,  0x3368,  0x34BD,  0xC268,  0x34B7,  0xB7BA,  
      0xB7BC,  0xB7BD,  0xB7BE,  0,       0,       0,       0,       0,       // 0x57Ax
      0,       0x336C,  0,       0,       0,       0,       0,       0xC265,  
      0,       0xC26A,  0x395F,  0x3AE4,  0x3960,  0x395C,  0xCC41,  0xCC42,  // 0x57Bx
      0xCC45,  0xCC47,  0x395D,  0xCC44,  0x3F51,  0xBDE5,  0xBDE7,  0xBDE9,  
      0,       0,       0,       0,       0,       0x34BE,  0,       0xBDE6,  // 0x57Cx
      0,       0,       0,       0,       0,       0x41B6,  0x41AF,  0xD579,  
      0xD577,  0xD57A,  0x41B0,  0x41AD,  0x41B2,  0x41B4,  0x41B8,  0x41B3,  // 0x57Dx
      0x3F4E,  0xD621,  0x41AE,  0xD57B,  0xD57E,  0,       0xD57C,  0,       
      0,       0,       0xC4B3,  0xC4B4,  0xC4B5,  0xC4B6,  0xC4B7,  0xC4B8,  // 0x57Ex
      0xC4B9,  0xC4BA,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xD578,  // 0x57Fx
      0xD57D,  0,       0x41B7,  0x41B5,  0,       0x48A8,  0xDF69,  0x45AD,  
} ;


static const unsigned short Uni2cnsP2Table_58 [] = {
      0x48AD,  0xDF68,  0xDF66,  0xDF6A,  0x455C,  0x48AE,  0x48A9,  0xDF6E,  // 0x580x
      0xDF6F,  0x48AB,  0x48A7,  0x48AC,  0xDF70,  0x48AA,  0xDF67,  0xCAE0,  
      0xCADB,  0xCADC,  0xCADD,  0xCADE,  0xCADF,  0xCAE1,  0xCAE2,  0xCAE3,  // 0x581x
      0xCAE5,  0,       0,       0,       0,       0,       0,       0,       
      0,       0xDF6D,  0xDF6C,  0,       0,       0,       0,       0,       // 0x582x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x4EFB,  0x4EF8,  0x4EFA,  0xA6B3,  0xA6B0,  0x4EF9,  0x4B69,  // 0x583x
      0,       0xA6B4,  0xA6B1,  0,       0xA6B8,  0x48AF,  0xA6AF,  0x56C5,  
      0x4EFC,  0x4EFD,  0,       0x4B67,  0,       0x4B6A,  0xA6B5,  0xD0EC,  // 0x584x
      0xD0EE,  0xD0EF,  0xD0F0,  0xD0F1,  0xD0F2,  0,       0,       0,       
      0,       0,       0,       0,       0xA6AE,  0,       0,       0,       // 0x585x
      0,       0,       0xA6B6,  0xA6B7,  0x517B,  0xB0ED,  0,       0x56BD,  
      0x56C0,  0xB0E9,  0x56BC,  0x56BF,  0x56BE,  0x517E,  0x56BB,  0x56C3,  // 0x586x
      0xB0E3,  0xB0E4,  0x56C2,  0xB0E2,  0x56C6,  0x5CDB,  0x56C7,  0xB0EB,  
      0xB0EA,  0,       0,       0xB0EC,  0xB0E1,  0xD6D4,  0xD6D5,  0,       // 0x587x
      0,       0xB0E5,  0,       0,       0,       0,       0,       0,       
      0xB0E7,  0xB0E8,  0,       0,       0,       0,       0,       0x56C4,  // 0x588x
      0x56C1,  0,       0x5CDE,  0x5CE1,  0x5CE2,  0x5CDF,  0x5CDC,  0x5CDD,  
      0,       0x574A,  0xB9F7,  0x5CE4,  0x5746,  0x5CE0,  0xB9FA,  0,       // 0x589x
      0xDBD4,  0xDBD5,  0xDBD6,  0xDBD7,  0xDBD8,  0xDBDA,  0xB9F8,  0,       
      0,       0,       0,       0,       0,       0,       0,       0xDBD3,  // 0x58Ax
      0,       0,       0,       0,       0,       0x56C8,  0xB9F9,  0,       
      0x5CE3,  0xD6D3,  0,       0,       0x62FD,  0x63A6,  0x63A4,  0x63A1,  // 0x58Bx
      0x63A2,  0x63A5,  0xC1B0,  0x62FE,  0xC1AF,  0x63A3,  0,       0xDFEC,  
      0xDFED,  0xDFEE,  0xDFEF,  0xDFF0,  0xDFF1,  0xDFF2,  0,       0,       // 0x58Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x62FC,  0,       0,       0x68DE,  0x6043,  // 0x58Dx
      0x68DC,  0x6044,  0x6047,  0,       0xC8BF,  0,       0x6046,  0x68DD,  
      0xCEE2,  0,       0,       0,       0,       0xC8C1,  0xC8BE,  0xE3B0,  // 0x58Ex
      0xC8C0,  0x6CEB,  0x637A,  0x6378,  0x6CEA,  0xCEE0,  0x5C38,  0x6CE9,  
      0x6CEC,  0xCEDF,  0xCEE1,  0xE5E0,  0xE5E1,  0xE5E3,  0,       0xCEE3,  // 0x58Fx
      0,       0,       0,       0,       0,       0,       0x6CED,  0,       
} ;


static const unsigned short Uni2cnsP2Table_59 [] = {
      0xD4A8,  0xD4A7,  0x70D8,  0xD4A9,  0,       0xD8CD,  0x73EC,  0xD8CE,  // 0x590x
      0,       0,       0x76B0,  0x76B1,  0xD8CF,  0,       0x77F0,  0,       
      0,       0xDCAD,  0xDCAE,  0xDFA8,  0xDEF1,  0xEBD7,  0xEBD8,  0x6C77,  // 0x591x
      0x79B3,  0xECB4,  0x6C78,  0,       0x7AAE,  0,       0x7BE1,  0x7BE2,  
      0,       0,       0xA337,  0x24EF,  0x24F0,  0,       0,       0x2759,  // 0x592x
      0x275A,  0x2758,  0xAD4D,  0xAD4C,  0,       0xAD4F,  0xAAC5,  0,       
      0xAD4B,  0xA8C3,  0,       0,       0x2A74,  0xB359,  0xB35B,  0xB358,  // 0x593x
      0x2AF7,  0x2A73,  0x2AF9,  0x2AF8,  0xB35A,  0xB35C,  0xB35D,  0x2AFA,  
      0,       0xACF1,  0xACF2,  0xACF3,  0,       0,       0,       0x2FBF,  // 0x594x
      0x2E66,  0x2E6B,  0x2E68,  0x2FC3,  0x2FC2,  0x2FC1,  0xBA4C,  0x2E69,  
      0x2E6A,  0x2E67,  0xBA4A,  0xBA48,  0x2FC0,  0,       0,       0x2FC4,  // 0x595x
      0xB1D8,  0xB1D9,  0xB1DA,  0xBA4B,  0,       0,       0xBA49,  0,       
      0x34C4,  0x34C3,  0xC26C,  0xC26B,  0xC26D,  0x34C1,  0x336E,  0x34C2,  // 0x596x
      0x34C0,  0xC26E,  0xB7C0,  0xB7C1,  0xB7C2,  0xB7C3,  0xB7C4,  0,       
      0,       0,       0,       0,       0,       0,       0x3AF2,  0x3966,  // 0x597x
      0x3AF4,  0xCC4E,  0xCC4A,  0x3969,  0xCC52,  0x3AE9,  0x3AEF,  0x3AF1,  
      0xCC50,  0x3AE7,  0xCC51,  0x3AE8,  0xCC4B,  0x3AEA,  0x3968,  0x3AF3,  // 0x598x
      0xCC4C,  0,       0x3AF0,  0xCC49,  0x3AE6,  0x3AED,  0xCC4F,  0x3AEE,  
      0x3AEB,  0xCC4D,  0,       0xBDEB,  0,       0,       0,       0,       // 0x599x
      0,       0,       0,       0x41BA,  0xD629,  0x41BC,  0x41BB,  0x41BE,  
      0xD622,  0xD624,  0x3AEC,  0,       0x41BD,  0x41BF,  0xD628,  0xD62B,  // 0x59Ax
      0x41C0,  0xD626,  0xD625,  0,       0,       0xC4BB,  0xC4BD,  0xC4BE,  
      0xC4BF,  0xC4C0,  0xD623,  0,       0,       0xD62A,  0xD726,  0,       // 0x59Bx
      0x4561,  0xDF77,  0x48B2,  0xDF76,  0xDF72,  0xDF74,  0xDF73,  0x48B1,  
      0,       0,       0,       0,       0,       0xDF79,  0xCAE6,  0x48B3,  // 0x59Cx
      0,       0,       0xDF71,  0,       0,       0,       0,       0xC4BC,  
      0xA6BB,  0,       0x4FA1,  0x4FA7,  0x4FAA,  0x48B0,  0xA6BA,  0x4FAB,  // 0x59Dx
      0x4FA6,  0x4FA2,  0x4FAC,  0x4FA5,  0xA6B9,  0x4EFE,  0x4FA8,  0x4FA4,  
      0x4FA9,  0,       0xA7AE,  0,       0,       0x4B6D,  0,       0,       // 0x59Ex
      0,       0,       0,       0,       0x56CF,  0x56D1,  0x5223,  0x56D0,  
      0x5226,  0x56C9,  0x5228,  0xB0F0,  0x56CA,  0x56CC,  0x56CB,  0x56D3,  // 0x59Fx
      0x56CD,  0x56D4,  0xB0EE,  0x56CE,  0x5CE5,  0x56D5,  0,       0xD6D6,  
} ;


static const unsigned short Uni2cnsP2Table_5A [] = {
      0xD6D7,  0xD6D8,  0xD6D9,  0xD6DA,  0,       0,       0,       0,       // 0x5A0x
      0,       0,       0xB0F1,  0,       0,       0x5CEA,  0x5CE7,  0xBAA1,  
      0x574E,  0x5CE9,  0xB9FC,  0xB9FD,  0xB9FB,  0x5CE6,  0xB9FE,  0xB0F2,  // 0x5A1x
      0x5CE8,  0,       0xDBDB,  0,       0,       0,       0,       0,       
      0,       0x63A8,  0x63A7,  0xDFF4,  0,       0,       0,       0,       // 0x5A2x
      0,       0,       0x604A,  0xC8C4,  0xC8C3,  0x68DF,  0xC8C2,  0,       
      0xCEE4,  0xCEE6,  0x68E0,  0x637B,  0x6CEE,  0xD4AD,  0xCEE7,  0xCEE5,  // 0x5A3x
      0xE5E4,  0,       0,       0x70DB,  0xD4AB,  0x6667,  0,       0x6666,  
      0x70D9,  0xD4AC,  0x70DA,  0xE8A1,  0,       0,       0,       0,       // 0x5A4x
      0xE5E5,  0,       0x76B2,  0xDCAF,  0x77F1,  0,       0xE1AA,  0xEBD9,  
      0xDFA9,  0,       0x79B4,  0xE2CA,  0x7BE3,  0xA872,  0xA871,  0x27C9,  // 0x5A5x
      0x27CA,  0x2A75,  0,       0xACF4,  0xACF8,  0,       0,       0,       
      0x2E6F,  0x2FC7,  0x2FC8,  0x2E6C,  0x2FC6,  0x2FC5,  0x2E6E,  0xB1DC,  // 0x5A6x
      0xB1DD,  0xB1DE,  0xB1DF,  0xB1E1,  0xB1E2,  0xBA4D,  0xBA4E,  0,       
      0,       0xC272,  0x3373,  0xC271,  0xC273,  0xC270,  0x3374,  0,       // 0x5A7x
      0xB7C5,  0xB7C7,  0,       0x34C7,  0xB7C8,  0,       0x396B,  0xCC55,  
      0x3AF5,  0x3AF7,  0x3AF6,  0x3AF8,  0xCC54,  0,       0xBDED,  0xBDEE,  // 0x5A8x
      0xBDEF,  0xBDF0,  0x3F56,  0x3F58,  0x41C2,  0x3F59,  0xD62C,  0x41C1,  
      0xD62D,  0xD62E,  0xC4C1,  0xC4C2,  0xC4C3,  0x41C3,  0,       0,       // 0x5A9x
      0x48B4,  0xDF7A,  0x48B5,  0x4562,  0,       0,       0,       0xCAE7,  
      0xCAE8,  0xCAEA,  0,       0,       0xCAE9,  0xA6BF,  0x4B6E,  0x4FAD,  // 0x5AAx
      0xD0F3,  0xD0F4,  0xD0F5,  0,       0xA6BD,  0xD6DC,  0xD6DB,  0x5751,  
      0xB0F4,  0x56D6,  0xDBDC,  0x5CEC,  0,       0x5DE3,  0xBAA2,  0,       // 0x5ABx
      0,       0,       0,       0x5CEB,  0x63AA,  0xBAA3,  0xDFF5,  0xC1B1,  
      0,       0,       0,       0x63A9,  0,       0,       0,       0,       // 0x5ACx
      0xCEE8,  0xD4AE,  0xE5E6,  0,       0,       0xC8C5,  0x70DC,  0xE8A2,  
      0xD8D0,  0xE9DE,  0xEAE8,  0,       0,       0,       0xE1AB,  0,       // 0x5ADx
      0xA5A6,  0x27CB,  0xAD50,  0x27CD,  0x27CC,  0x2AFC,  0x2AFD,  0x2AFB,  
      0xB35F,  0xB35E,  0x2AFE,  0,       0,       0xACF9,  0xACFA,  0xACFB,  // 0x5AEx
      0xACFC,  0,       0,       0,       0,       0xACFD,  0xA9A4,  0x2FCE,  
      0x2FC9,  0x2E74,  0,       0x2FCA,  0x2FCC,  0x2FCD,  0xBA50,  0x2FD1,  // 0x5AFx
      0x2FCF,  0x2FCB,  0xBA4F,  0xBA51,  0x2FD0,  0x2FD2,  0xB1E3,  0xB1E4,  
} ;


static const unsigned short Uni2cnsP2Table_5B [] = {
      0xB1E5,  0xB1E6,  0xB1E7,  0xB1E8,  0xB1E9,  0xB1EA,  0,       0x2E76,  // 0x5B0x
      0,       0,       0,       0,       0xC274,  0xC27A,  0x34CA,  0x3379,  
      0x34CD,  0xC277,  0x34CC,  0xC27C,  0x3375,  0x34CE,  0xC275,  0x2FD3,  // 0x5B1x
      0,       0x34C9,  0xC279,  0xC27B,  0,       0x34D0,  0x34D1,  0xC278,  
      0,       0xB7C9,  0xB7CA,  0xB7CB,  0xB7CC,  0xB7CE,  0xB7CF,  0,       // 0x5B2x
      0,       0,       0x3AFC,  0x3BA2,  0x3AFB,  0x3AFE,  0x396C,  0x396E,  
      0xCC5A,  0x34CB,  0x3973,  0x3BA1,  0x3AFA,  0x3979,  0x3977,  0x3970,  // 0x5B3x
      0xCC5D,  0x3978,  0,       0xCC57,  0x3BA5,  0xCC59,  0xCC5C,  0x34CF,  
      0x3AFD,  0xBDF1,  0xBDF2,  0xBDF3,  0xBDF4,  0xBDF5,  0xBDF6,  0xBDF8,  // 0x5B4x
      0xBDF9,  0xBDFA,  0xBDF7,  0x3BA3,  0,       0,       0,       0,       
      0x41D4,  0x41C8,  0x41CF,  0x3F5C,  0x41CD,  0x41C5,  0x3F64,  0x3F65,  // 0x5B5x
      0x41D0,  0x3F5F,  0x3AF9,  0xD630,  0x41C6,  0x41D5,  0x41CB,  0x41D2,  
      0x41C4,  0x41C9,  0x41CC,  0xD634,  0xD632,  0xD637,  0xD63A,  0xD633,  // 0x5B6x
      0xD636,  0,       0xD638,  0xDF7B,  0x41D3,  0x41D1,  0x41CE,  0x41C7,  
      0xD631,  0xCC58,  0,       0,       0,       0,       0,       0xD635,  // 0x5B7x
      0xD639,  0xC4C4,  0xC4C6,  0xC4C7,  0xC4C8,  0xC4C9,  0xC4CA,  0xC4CB,  
      0xC4CC,  0xC4CD,  0xC4CE,  0xC4CF,  0xC4D0,  0xD62F,  0,       0,       // 0x5B8x
      0,       0,       0,       0,       0xC1BE,  0x48C5,  0x41D6,  0x456C,  
      0x48C3,  0xE027,  0x4567,  0xDF7C,  0xDF7D,  0x48BC,  0x48BB,  0x48C2,  // 0x5B9x
      0x456F,  0xE028,  0x48C0,  0xE026,  0x48B8,  0x48B9,  0xE025,  0,       
      0xE021,  0,       0x48BA,  0x48C1,  0x48B7,  0x48BD,  0xE022,  0x41CA,  // 0x5BAx
      0x48C7,  0xDF7E,  0x48BE,  0xE024,  0,       0x48BF,  0x4571,  0x48C4,  
      0,       0,       0,       0,       0,       0xCAEB,  0xCAEC,  0xCAED,  // 0x5BBx
      0xCAEE,  0xCAEF,  0xCAF0,  0xCAF3,  0xCAF4,  0xCAF5,  0xCAF6,  0xCAF7,  
      0xCAF8,  0xCAF9,  0xCAFA,  0,       0,       0,       0xCAF2,  0,       // 0x5BCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xCAF1,  0x4FBA,  0xA6C9,  0xA6CB,  0x4FC4,  0x4C2F,  0x4FB3,  0xA6D1,  // 0x5BDx
      0xA6CA,  0x4FBE,  0x4B71,  0x4B6F,  0x4FC1,  0x4FAF,  0x4FB4,  0x4FC3,  
      0xA6C2,  0x4FC0,  0x4FB1,  0x5240,  0x4FB9,  0x4FC2,  0x4B72,  0x4C29,  // 0x5BEx
      0x4C23,  0x4B7D,  0x4FB8,  0x4FB7,  0x4FBC,  0xA6CE,  0x48C8,  0x4FB5,  
      0xA6D0,  0xA6C7,  0xA6C4,  0x4FBF,  0xA6C0,  0xA6D3,  0x4C24,  0xA6CF,  // 0x5BFx
      0x4B7C,  0xA6CC,  0x4FBD,  0,       0xA6C5,  0xA6C3,  0x4FAE,  0xA6C8,  
} ;


static const unsigned short Uni2cnsP2Table_5C [] = {
      0,       0,       0xA6C6,  0,       0,       0x4FC6,  0xD0F8,  0,       // 0x5C0x
      0,       0xA6D2,  0,       0xD0F7,  0xD0FA,  0xD0FB,  0xD0FC,  0xD0FD,  
      0xD0FE,  0xD1A2,  0xD1A4,  0xD1A9,  0xD1A5,  0xD1A6,  0xD1A7,  0xD1AA,  // 0x5C1x
      0x56E4,  0x5241,  0x523E,  0x56D8,  0x56DE,  0x56E6,  0xB1AA,  0x56DC,  
      0x522E,  0x56DD,  0x522C,  0x56E8,  0xA6C1,  0xB1A5,  0x5232,  0x56E7,  // 0x5C2x
      0x5231,  0xB1A9,  0x523C,  0xB0FE,  0xB1A6,  0x5230,  0x56E0,  0xB0FB,  
      0x523F,  0x56DF,  0x56D9,  0xB0FA,  0xB1A8,  0x522A,  0x56D7,  0xB1A4,  // 0x5C3x
      0x5235,  0x56E5,  0xB0FD,  0x56E2,  0x5233,  0xB1AB,  0xB0F5,  0xB1A7,  
      0x4FB0,  0x56E3,  0x56DA,  0,       0xB0F8,  0xB1A3,  0xB0F6,  0x56E1,  // 0x5C4x
      0,       0,       0,       0,       0xD6F2,  0x56DB,  0xB0FC,  0xB0F7,  
      0xB1A2,  0xD6DD,  0xD6DE,  0xD6E0,  0xD6E1,  0xD6E2,  0xD6E3,  0xD6E4,  // 0x5C5x
      0xD6E5,  0xD6E6,  0xD6E7,  0xD6E8,  0xD6E9,  0xD6EA,  0xD6EB,  0xD6EC,  
      0xD6ED,  0xD6EE,  0xD6EF,  0xD6F0,  0xD6F1,  0,       0xD6F3,  0,       // 0x5C6x
      0,       0xB0F9,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xD0F9,  0,       0x5DA4,  0x5DA1,  0x575D,  // 0x5C7x
      0x5CF5,  0x5DAD,  0x5CF9,  0x575C,  0x5763,  0x5767,  0xBAAC,  0x5DAB,  
      0x5760,  0x5DA2,  0,       0,       0x5CF0,  0x5DA3,  0x5CF2,  0x5DB1,  // 0x5C8x
      0x5CFB,  0x5DAA,  0x5CF7,  0x5DB4,  0xBAA4,  0x5CF6,  0x5CFC,  0x5DA6,  
      0x5764,  0x5DA7,  0xBAA9,  0,       0,       0x63C2,  0x5DAC,  0x5CFA,  // 0x5C9x
      0xBAAF,  0xBAA8,  0x5CEF,  0x5DB2,  0x5DA9,  0x5CF3,  0xBAAB,  0x5DAE,  
      0x5CF1,  0x5CEE,  0x5DA8,  0x5766,  0x5C3C,  0x5DB3,  0x5CF8,  0x5DAF,  // 0x5CAx
      0x5DA5,  0xB1A1,  0x5CF4,  0xBAA7,  0xBAA6,  0,       0xBAA5,  0xBAAD,  
      0xDBDD,  0xDBDE,  0xDBE0,  0xDBE1,  0xDBE2,  0xDBE3,  0xDBE4,  0xDBE6,  // 0x5CBx
      0xDBE7,  0xDBE8,  0xDBE9,  0xBAAA,  0xBAAE,  0x5768,  0,       0,       
      0xDBE5,  0,       0,       0,       0,       0,       0x5761,  0x63CB,  // 0x5CCx
      0x63C7,  0x5DB5,  0x5C52,  0x63C5,  0x63B8,  0x63B3,  0x5C47,  0x63CA,  
      0x63C0,  0xD8CF,  0x63AE,  0x5C4E,  0x5C45,  0x63C3,  0x63B9,  0x63CC,  // 0x5CDx
      0x5C3D,  0xC1BB,  0x63C6,  0x63B0,  0x63B7,  0x5C3E,  0x5C3F,  0x63C8,  
      0xC1B9,  0x63B5,  0x63B2,  0x63BF,  0xC1B5,  0x63AC,  0xC1B6,  0x5C41,  // 0x5CEx
      0xC1B3,  0x5C53,  0x63BE,  0xC1B8,  0x63BD,  0xC1BA,  0xC1BE,  0xC1B4,  
      0x63B1,  0x5C4D,  0x63B6,  0x63BA,  0x63C4,  0x63C9,  0x63BC,  0x63AD,  // 0x5CFx
      0xC1C2,  0xC1C1,  0x63BB,  0,       0,       0,       0,       0x63AB,  
} ;


static const unsigned short Uni2cnsP2Table_5D [] = {
      0x63AF,  0xC1B2,  0xC1B7,  0xDFF6,  0xDFF7,  0xDFF8,  0xDFF9,  0xDFFA,  // 0x5D0x
      0xDFFB,  0xDFFC,  0xDFFD,  0xDFFE,  0xE0A1,  0xE0A3,  0xE0A4,  0xE0A5,  
      0,       0,       0,       0xC1C0,  0xC1BD,  0,       0,       0,       // 0x5D1x
      0,       0,       0,       0,       0,       0xDBEA,  0xE3B6,  0xE3B7,  
      0xE0A2,  0x68EA,  0x68EF,  0xC8CE,  0x6059,  0xC8CC,  0x68E3,  0x6054,  // 0x5D2x
      0x6055,  0x6051,  0x68E9,  0x604F,  0x6050,  0xC8C8,  0x6052,  0x68E2,  
      0x6058,  0x604D,  0xC8C7,  0,       0x68ED,  0x68E8,  0x68F0,  0x68EC,  // 0x5D3x
      0x68EB,  0x68E5,  0x68E4,  0x68E7,  0,       0xC8C6,  0xC8CA,  0x68E1,  
      0,       0,       0,       0,       0x68F1,  0xC8C9,  0xE3B1,  0xE3B3,  // 0x5D4x
      0xE3B4,  0xE3B5,  0xE3B8,  0xE3B9,  0xE3BA,  0xE3BB,  0xE3BC,  0,       
      0xC8CB,  0,       0,       0xC8CD,  0,       0,       0,       0,       // 0x5D5x
      0,       0,       0,       0,       0x6CFC,  0x6CFB,  0x6CF6,  0x6057,  
      0x6CF4,  0xCEEC,  0x6CFA,  0x637D,  0xCEF4,  0x6422,  0x6CF8,  0x6CF3,  // 0x5D6x
      0x6670,  0xCEEA,  0x6CEF,  0x6CF5,  0x6CF1,  0xCEE9,  0xCEF5,  0x6CF7,  
      0xCEED,  0xCEEE,  0x6CF2,  0xCEEF,  0xD4B8,  0xCEF1,  0xCEF0,  0,       // 0x5D7x
      0xCEF2,  0xCEF3,  0xE5E8,  0xE5E9,  0,       0xCEEB,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x70E4,  0x70E8,  // 0x5D8x
      0x70E9,  0,       0x6671,  0x666B,  0x70E6,  0x70EB,  0xD4AF,  0x70DE,  
      0x70E3,  0x70E0,  0x6421,  0x70E7,  0x70DF,  0x6CF0,  0xD4B5,  0x70EA,  // 0x5D9x
      0x70DD,  0xD4B1,  0x70E5,  0x6927,  0x70EC,  0xD4B6,  0xD4B0,  0xD4B4,  
      0,       0,       0,       0xE8A3,  0xE8A4,  0xE8A5,  0xE8A6,  0xE8A7,  // 0x5DAx
      0xE8A8,  0xE8A9,  0xD4B3,  0xD4B9,  0,       0,       0,       0,       
      0,       0,       0,       0,       0xD4B2,  0xD8D5,  0x6924,  0x6923,  // 0x5DBx
      0x73F0,  0x73EE,  0x70E2,  0x73F1,  0xD8D2,  0x70ED,  0xD8D1,  0x73F4,  
      0x6925,  0x73ED,  0xD8D4,  0xD4B7,  0x73F6,  0x73F3,  0x73EF,  0x73F5,  // 0x5DCx
      0x73F2,  0xD8D6,  0,       0,       0xE9DF,  0xE9E0,  0xE9E1,  0xE9E2,  
      0xD8D3,  0xD9B4,  0,       0,       0x6A5E,  0x76B3,  0xDCB1,  0x76B4,  // 0x5DDx
      0x6A5F,  0x6A60,  0x6A62,  0xDCB0,  0x76B6,  0xDCB2,  0x76B5,  0xDCB6,  
      0xDCB5,  0xEAE9,  0xDCB3,  0xDCB7,  0xDCB4,  0,       0,       0,       // 0x5DEx
      0x77F2,  0xDFAB,  0xDFAE,  0x77F4,  0x77F5,  0xDFAD,  0x76B7,  0xDFAC,  
      0xDFAA,  0x77F3,  0xDFB1,  0,       0x6B77,  0xEBDA,  0xEBDB,  0xEBDC,  // 0x5DFx
      0xDFAF,  0,       0,       0,       0x79B5,  0xE1AC,  0xE1AE,  0xE1B1,  
} ;


static const unsigned short Uni2cnsP2Table_5E [] = {
      0x6C79,  0,       0,       0xE1AF,  0,       0xDFB0,  0,       0xE1AD,  // 0x5E0x
      0x7AB1,  0x7AAF,  0x7AB0,  0xE1B0,  0,       0,       0xECCF,  0xECCD,  
      0xE3DE,  0xE3DF,  0,       0,       0xECE8,  0,       0xE3E0,  0x7BC4,  // 0x5E1x
      0x7BE4,  0xEDA7,  0,       0,       0xE4D4,  0,       0,       0,       
      0,       0x6E4E,  0x7BFC,  0x7CAB,  0,       0x24F1,  0xA5A7,  0x27CE,  // 0x5E2x
      0xAD51,  0xA8C5,  0,       0xB361,  0x2BA2,  0xB360,  0,       0x2BA3,  
      0xACFE,  0xADA2,  0,       0xBA52,  0x2FD4,  0xBA56,  0x2FD5,  0xBA54,  // 0x5E3x
      0x2FD6,  0xB1EB,  0xB1EC,  0xB1ED,  0xB1EE,  0xBA53,  0xBA55,  0,       
      0,       0x337E,  0x34D5,  0x3424,  0,       0x34D4,  0x3421,  0x34D8,  // 0x5E4x
      0x34D3,  0x34D6,  0x34D7,  0x3423,  0x34DA,  0x34D2,  0xC27D,  0xCC63,  
      0xC321,  0xB7D0,  0xB7D1,  0,       0,       0xC27E,  0xB7D2,  0,       // 0x5E5x
      0,       0,       0x3BA6,  0,       0x397A,  0xCC61,  0xCC5E,  0xCC65,  
      0x3BA8,  0x3A21,  0xCC64,  0,       0xCC5F,  0,       0xBDFC,  0xBDFE,  // 0x5E6x
      0xBEA2,  0,       0,       0xBDFB,  0,       0xCC62,  0,       0,       
      0,       0,       0x41D7,  0x3F68,  0xD63D,  0x41D9,  0x41DA,  0x3BA7,  // 0x5E7x
      0x41D8,  0xD63F,  0xD63E,  0x397E,  0x41DB,  0x41DD,  0x41DC,  0xD641,  
      0,       0,       0,       0,       0xC4D2,  0xC4D3,  0xC4D5,  0xC4D6,  // 0x5E8x
      0xD63B,  0xC4D4,  0,       0xD640,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xC4D1,  // 0x5E9x
      0xE02D,  0x48CA,  0xE02B,  0xE02E,  0x48CC,  0x4573,  0xD63C,  0xE033,  
      0xE032,  0x48CB,  0xE030,  0x48C9,  0x48CD,  0,       0,       0xCAFC,  // 0x5EAx
      0xCAFD,  0xCAFE,  0xCBA1,  0xCBA2,  0xCBA3,  0xCBA5,  0xCBA6,  0xCBA8,  
      0xCBA9,  0xCBAA,  0xCBAD,  0xE02F,  0xCBAC,  0,       0xE029,  0,       // 0x5EBx
      0xE02A,  0,       0,       0,       0xCBA4,  0,       0,       0,       
      0,       0xA6D8,  0xA6D4,  0x4C36,  0x4FCB,  0xA6D5,  0xA6D9,  0x4C33,  // 0x5ECx
      0x4FCA,  0x4FCC,  0x4FD0,  0x48CE,  0x4FCF,  0x4FCD,  0xA6DB,  0xA6D6,  
      0x4FC9,  0x4C34,  0x4FCE,  0x4C32,  0xA6DA,  0x4FC8,  0x4FC7,  0,       // 0x5EDx
      0,       0xD1AB,  0xD1AC,  0xD1AD,  0xD1AF,  0,       0,       0,       
      0,       0,       0,       0,       0x56EE,  0x56EC,  0x5DBC,  0x5243,  // 0x5EEx
      0x56EB,  0x5242,  0xB1AF,  0xB1B0,  0x56EF,  0xB1AC,  0x56EA,  0x56ED,  
      0x56F0,  0xD6F4,  0xD6F5,  0xB1AE,  0,       0,       0,       0,       // 0x5EFx
      0,       0,       0,       0,       0,       0,       0,       0x5DB6,  
} ;


static const unsigned short Uni2cnsP2Table_5F [] = {
      0x5DB8,  0xBAB0,  0x5DB9,  0x5DB7,  0x5DBA,  0x5DBB,  0xBAB2,  0xBAB4,  // 0x5F0x
      0xBAB5,  0xBAB1,  0,       0,       0xDBEB,  0xDBEC,  0xDBED,  0xDBEF,  
      0xDBF0,  0xDBF1,  0xDBF2,  0x576C,  0,       0,       0,       0,       // 0x5F1x
      0x63D2,  0xC1C5,  0x5C57,  0x63D3,  0x63CF,  0xC8D6,  0x63D1,  0x5DBD,  
      0xC1C6,  0x63D0,  0xCEF8,  0,       0x63CD,  0xC1C3,  0xE0A7,  0xE0A8,  // 0x5F2x
      0xE0A9,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0xDBEE,  0x68F4,  0xC8CF,  // 0x5F3x
      0xC8D0,  0x605E,  0x605C,  0x68F3,  0x70EE,  0xC8D2,  0xC8D3,  0xC1C8,  
      0x605F,  0x5C58,  0x68F5,  0xC1C7,  0,       0x68F2,  0xE3BE,  0xC8D1,  // 0x5F4x
      0,       0xC8D4,  0xC8D5,  0xE3BF,  0,       0,       0,       0xCEF7,  
      0x6CFE,  0xCEF6,  0,       0,       0,       0xE5EA,  0xE5EB,  0x6673,  // 0x5F5x
      0x6672,  0x70EF,  0xD4BD,  0xD4BC,  0,       0xE8AA,  0xE8AB,  0,       
      0,       0,       0,       0xD4BB,  0,       0x73F7,  0xD8D7,  0x73F8,  // 0x5F6x
      0,       0,       0,       0,       0x6A63,  0x6A64,  0xDCB8,  0xEAEA,  
      0x76B8,  0xDCB9,  0xDFB2,  0x77F7,  0x77F6,  0,       0x79B8,  0xE1B3,  // 0x5F7x
      0x79B7,  0x79B6,  0xE1B2,  0xE2CC,  0x6D5D,  0x7AB2,  0xE2CB,  0x7AB3,  
      0xE3E2,  0xE3E1,  0x7BFD,  0,       0xE6B6,  0x27CF,  0xAD52,  0x27D0,  // 0x5F8x
      0xA8C7,  0xA8C8,  0x27D1,  0,       0x2BA6,  0xB362,  0xB365,  0x2BA4,  
      0x2BA5,  0xB367,  0xB363,  0x2BA7,  0xADA3,  0,       0xB368,  0,       // 0x5F9x
      0,       0xBA5B,  0xBA57,  0x2E79,  0xBA63,  0x2E7B,  0xBA5D,  0,       
      0xBA5C,  0xBA5F,  0x2FDA,  0x2E7A,  0x2F24,  0xBA64,  0xBA59,  0x2F23,  // 0x5FAx
      0xBA5E,  0x2F22,  0xBA60,  0xBA58,  0x2FD9,  0xBA61,  0x2FD8,  0x2FD7,  
      0xBA5A,  0,       0xB1F1,  0xB1F2,  0xB1F3,  0xB1F4,  0xB1F5,  0xB1F6,  // 0x5FBx
      0xB1F7,  0,       0x2F26,  0xBA62,  0,       0,       0,       0,       
      0,       0,       0,       0x34DF,  0x34DD,  0x3432,  0x3428,  0x342A,  // 0x5FCx
      0xC328,  0x342F,  0x34DE,  0x3431,  0xC329,  0x34DB,  0x342C,  0xC32B,  
      0xC32A,  0xC325,  0xC323,  0xC324,  0,       0x34DC,  0xB7D8,  0xB7D9,  // 0x5FDx
      0xB7DA,  0xB7DB,  0,       0,       0xC327,  0,       0,       0xC32C,  
      0,       0xB7D5,  0,       0,       0,       0,       0x3BB1,  0x3BB0,  // 0x5FEx
      0x3BAE,  0x3BB2,  0xCC6D,  0x3A23,  0xCC66,  0xCC6C,  0x3A22,  0x3A24,  
      0xCC6E,  0xC326,  0xCC67,  0xCC70,  0xCC68,  0x3BAD,  0xCC6A,  0xCC69,  // 0x5FFx
      0xCC6F,  0x3BAA,  0x3BA9,  0,       0x3BAB,  0xBEA5,  0xBEA6,  0xBEA7,  
} ;


static const unsigned short Uni2cnsP2Table_60 [] = {
      0xBEA8,  0xBEA9,  0xBEAA,  0xBEAB,  0xBEAC,  0xBEAD,  0xBEAE,  0xCC6B,  // 0x600x
      0,       0x3BAF,  0,       0,       0,       0,       0,       0,       
      0,       0,       0xD64B,  0xD642,  0x41DF,  0x41DE,  0x3F6C,  0xD644,  // 0x601x
      0x3F6D,  0xD648,  0xD645,  0x3F69,  0x41E1,  0x41E0,  0xD643,  0xD649,  
      0x3A25,  0x3F6B,  0xD646,  0x41E2,  0xD64C,  0xD64D,  0x3F72,  0xD64A,  // 0x602x
      0,       0,       0,       0,       0xC4D7,  0xC4D8,  0xC4D9,  0xC4DA,  
      0xC4DB,  0xC4DC,  0xC4DD,  0xC4DE,  0xC4DF,  0xC4E0,  0xC4E1,  0xC4E2,  // 0x603x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xD647,  0x3F70,  0,       0x4578,  0,       // 0x604x
      0x48D0,  0x4576,  0x48D2,  0xE03F,  0xE03E,  0x48D6,  0x457A,  0x48D5,  
      0x4577,  0xE039,  0xE043,  0xE042,  0xE036,  0x457D,  0x48CF,  0x41E3,  // 0x605x
      0xE041,  0x48D1,  0xE03C,  0xE034,  0x48D3,  0x48D7,  0xE040,  0,       
      0,       0xE03B,  0,       0,       0x4622,  0xE038,  0xCBAE,  0xCBAF,  // 0x606x
      0xCBB0,  0xCBB1,  0xCBB2,  0xCBB3,  0xCBB4,  0xCBB5,  0xCBB6,  0xCBB7,  
      0xE035,  0xE037,  0,       0,       0xE03D,  0,       0,       0,       // 0x607x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x4C38,  0x4C43,  0xA6E0,  0x4C42,  0x4C3B,  0x4FDB,  0x4FD9,  0x5248,  // 0x608x
      0x4FD8,  0x4FDD,  0,       0x4FD5,  0x4C46,  0x4FDA,  0xA6EC,  0xA6DE,  
      0xA6E4,  0x4FDC,  0x4FD2,  0xA6E1,  0xA6E6,  0x4FD7,  0,       0x4C41,  // 0x609x
      0x4C39,  0xA6DD,  0xA6E5,  0xA6DC,  0xA6E7,  0xE03A,  0xA6ED,  0xA6EB,  
      0x4FD1,  0x4FD6,  0x4FDE,  0,       0,       0,       0xD1B0,  0xD1B1,  // 0x60Ax
      0xD1B2,  0xD1B3,  0xD1B4,  0xD1B5,  0xD1B8,  0xD1B9,  0xD1BA,  0xD1BD,  
      0xD1BE,  0xD1BF,  0,       0,       0xA6E2,  0xA6E8,  0,       0xA6DF,  // 0x60Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xA6E3,  0,       0xB1C6,  0x5246,  0xB1C3,  0xB1C4,  0x524A,  // 0x60Cx
      0xB1C0,  0xB1BD,  0x56F4,  0x56F6,  0xB1B1,  0xB1C2,  0xB1B2,  0xBAB6,  
      0xB1B3,  0xB1B6,  0x56F5,  0x56F7,  0x56F3,  0x5DC5,  0x5245,  0x56F1,  // 0x60Dx
      0x56F2,  0x524B,  0,       0xB1BA,  0xB1B7,  0xB1B8,  0xB1C1,  0x524D,  
      0xB1B5,  0,       0x56F9,  0xB1B4,  0xB1C5,  0xB1BB,  0x56F8,  0xB1BF,  // 0x60Ex
      0xB1BE,  0,       0,       0,       0,       0,       0,       0,       
      0xB1B9,  0xB1BC,  0xD6F6,  0xD6F7,  0xD6F8,  0xD6F9,  0xD6FA,  0xD6FB,  // 0x60Fx
      0xD6FC,  0xD6FD,  0xD6FE,  0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_61 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x610x
      0,       0xBAC4,  0xBAC3,  0x5DC3,  0x5DC0,  0x5771,  0xBAB7,  0x5DC1,  
      0xBAC2,  0x576F,  0xBABA,  0x5DC4,  0x5DBE,  0xBABE,  0xBABB,  0xBABC,  // 0x611x
      0xBAC0,  0x5DC2,  0xBAC1,  0xBABD,  0x5DC7,  0,       0,       0,       
      0,       0,       0xDBF3,  0xDBF4,  0xDBF5,  0xDBF7,  0xDBF8,  0xDBF9,  // 0x612x
      0xDBFA,  0xDBFB,  0xDBFC,  0xDBFD,  0xDBFE,  0xDCA1,  0xDCA2,  0,       
      0,       0xBABF,  0xBAB8,  0,       0,       0,       0,       0,       // 0x613x
      0,       0,       0,       0,       0x5C64,  0x5C5C,  0xC1CE,  0x5C63,  
      0x5C5D,  0xC1CD,  0xC1D4,  0x5C61,  0x5770,  0xC1C9,  0x63D5,  0x63D8,  // 0x614x
      0x63D7,  0xC1CB,  0xC1D1,  0x63D6,  0xC1CA,  0xC1CF,  0xC1D2,  0xC1CC,  
      0xC1D7,  0xC1D5,  0xC1D0,  0xC1DB,  0x63DA,  0xC1D6,  0,       0,       // 0x615x
      0,       0,       0,       0,       0,       0xE0AA,  0xE0AB,  0xE0AC,  
      0xE0AD,  0xE0AE,  0xE0AF,  0xE0B0,  0xE0B1,  0xE0B2,  0,       0x63D9,  // 0x616x
      0xC1DC,  0,       0xC1DA,  0,       0xC1D8,  0,       0,       0,       
      0,       0,       0,       0xC1D3,  0,       0x6064,  0x6065,  0xC8DF,  // 0x617x
      0x6069,  0xC8E7,  0x68F6,  0xC8E4,  0x6067,  0xC8E6,  0x606B,  0x68F9,  
      0x6060,  0x68FA,  0xC8E1,  0xC7CB,  0x6061,  0xC8DD,  0x68F7,  0,       // 0x618x
      0xC8E3,  0xC8DB,  0xC8E2,  0x68F8,  0xC8D9,  0xC8DA,  0xC8E0,  0xC8DE,  
      0xE3C0,  0xE3C1,  0xE3C3,  0xE3C4,  0xE3C5,  0xCAF3,  0xC8DC,  0xC8E5,  // 0x619x
      0,       0,       0,       0x606A,  0xCEFD,  0xCEFC,  0x6DA3,  0x6DA1,  
      0x6425,  0xCEFE,  0xCFA3,  0xCEFB,  0xD4C2,  0xC8D8,  0x6DA4,  0xCFA4,  // 0x61Ax
      0,       0xCFA6,  0xCEFA,  0x6679,  0xCFA2,  0,       0,       0xCEF9,  
      0xCFA5,  0xE5EC,  0xE5ED,  0xE5EE,  0xE5F0,  0xE5F1,  0xCFA1,  0,       // 0x61Bx
      0,       0,       0,       0x70F2,  0x6675,  0xD4C3,  0x70F3,  0x6678,  
      0x6676,  0x6677,  0xD8DE,  0xCFA7,  0xD4BF,  0xD4BE,  0,       0,       // 0x61Cx
      0xD4C1,  0xE8AC,  0xE8AD,  0xE8AE,  0xE8AF,  0,       0x6674,  0xD4C0,  
      0,       0x70F1,  0,       0xD4C4,  0x73FB,  0xD8D9,  0x73FC,  0x73F9,  // 0x61Dx
      0x6929,  0x76BA,  0xD8DD,  0x73FA,  0xD8DB,  0,       0xE9E3,  0xE9E4,  
      0xE9E5,  0xE9E6,  0xD8DA,  0xD8DC,  0,       0x694B,  0,       0x6A67,  // 0x61Ex
      0xD8DF,  0xDCBA,  0xDCBB,  0x6A68,  0x6A69,  0,       0,       0,       
      0x6B7A,  0x77F8,  0xDFB7,  0xDFB5,  0xEBDD,  0,       0xDFB6,  0xDFB8,  // 0x61Fx
      0x79BA,  0xDFB4,  0x79B9,  0xE1B4,  0xE2CF,  0xE2CE,  0xE3E3,  0xECE9,  
} ;


static const unsigned short Uni2cnsP2Table_62 [] = {
      0xE3E5,  0xE3E4,  0,       0xE4D5,  0,       0x7BE5,  0xEDB0,  0xE5F5,  // 0x620x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x621x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0xA542,  0x2A78,  0,       0x2BA8,  0x2F28,  0xBA66,  // 0x622x
      0x2FDB,  0x34E1,  0,       0xC32D,  0x3BB4,  0xC32F,  0xC32E,  0xCC74,  
      0x3A29,  0xCC73,  0x3BB3,  0xBEAF,  0xD650,  0xD64F,  0x3F74,  0,       // 0x623x
      0x4624,  0xE045,  0x48D8,  0xE044,  0xA6EE,  0,       0xCBB9,  0xCBBA,  
      0xCBBB,  0xA6F0,  0x4C47,  0,       0xD1C0,  0xD1C1,  0,       0xA6EF,  // 0x624x
      0x56FB,  0x56FA,  0,       0xD7A2,  0xD7A1,  0,       0x5DC9,  0xBAC5,  
      0x5DC8,  0xDAD8,  0xDCA3,  0xDCA4,  0,       0xC1DD,  0xC1DE,  0xE0B3,  // 0x625x
      0,       0xC8E8,  0x606C,  0xE3C6,  0,       0x70F4,  0x6427,  0x667A,  
      0xD4C5,  0,       0x6A6A,  0xDCBC,  0xEAEB,  0xDFBA,  0xDFB9,  0x7AB4,  // 0x626x
      0,       0xE6AA,  0xA229,  0xA228,  0x246A,  0xA544,  0xA545,  0xA873,  
      0,       0,       0xA1FC,  0xA543,  0xA5A8,  0xA5AA,  0,       0xAD53,  // 0x627x
      0xB36A,  0x275D,  0,       0xB369,  0xAD54,  0,       0x275E,  0xA874,  
      0x246B,  0xB36B,  0x2A7A,  0x2A7C,  0,       0,       0,       0xA5D6,  // 0x628x
      0x2BA9,  0xA8C9,  0,       0x27D2,  0,       0xBA67,  0xBA68,  0xBA69,  
      0x2FDF,  0xBA6C,  0xBA6A,  0x2F2C,  0x2F2B,  0xB36E,  0xB36C,  0xB36F,  // 0x629x
      0xC335,  0xA9B9,  0,       0,       0x2FDD,  0xC330,  0xC331,  0xC332,  
      0xC334,  0xC336,  0xB1F9,  0xB36D,  0xB67A,  0,       0,       0x2BAA,  // 0x62Ax
      0x2A7D,  0xC333,  0xCC77,  0xC337,  0,       0xBA6D,  0xCC76,  0xC338,  
      0,       0,       0,       0x2FDE,  0x34E2,  0xB7DC,  0xCC75,  0,       // 0x62Bx
      0,       0,       0,       0,       0x3BB6,  0x3BB5,  0x3A2C,  0xCC78,  
      0,       0,       0xBEB0,  0,       0xD652,  0x41E7,  0xD654,  0xCC7A,  // 0x62Cx
      0x41E4,  0x41E6,  0xD653,  0xD655,  0xCC79,  0xD656,  0,       0,       
      0xBEB1,  0xD651,  0xC4E3,  0,       0,       0,       0xE046,  0xE048,  // 0x62Dx
      0xE049,  0xE04A,  0xE04B,  0xE04C,  0xE04D,  0xE050,  0x48DB,  0xA6F5,  
      0xE04E,  0x48DA,  0xD657,  0x48D9,  0xE04F,  0,       0,       0xE047,  // 0x62Ex
      0xCBBC,  0,       0,       0xA6F1,  0xA6F2,  0xA6F3,  0xA6F4,  0x4FE2,  
      0x4FDF,  0xE052,  0xA6F6,  0x4FE0,  0x4FE1,  0xE051,  0,       0xD1C2,  // 0x62Fx
      0xD1C3,  0xA5F3,  0,       0xB1C7,  0xB1C8,  0xB1CC,  0xB1C9,  0x56FC,  
} ;


static const unsigned short Uni2cnsP2Table_63 [] = {
      0xB1CB,  0x5251,  0xBACE,  0xB1CA,  0,       0xB1CD,  0x4FE3,  0,       // 0x630x
      0,       0x56FD,  0x5250,  0,       0,       0xA6F7,  0xA6F8,  0xBAC7,  
      0xBAC8,  0xBACB,  0x5DCA,  0xB1CE,  0x5774,  0x63DB,  0xBACC,  0xBACD,  // 0x631x
      0,       0xDCA5,  0,       0xD7A3,  0xC1DF,  0xC1E0,  0xC1E2,  0xC1E4,  
      0x5C67,  0x5C66,  0x63DC,  0xC1E3,  0xC8E9,  0,       0,       0,       // 0x632x
      0xBACA,  0x63DE,  0x68FB,  0xC8EC,  0x606E,  0xC8EA,  0xC8EB,  0,       
      0,       0xCFA8,  0xCFA9,  0xCFAA,  0xCFAB,  0x6DA5,  0x6DA7,  0xCFAC,  // 0x633x
      0x6DA6,  0,       0x6DA8,  0xD4C6,  0xCFAD,  0,       0x77FA,  0x6B7C,  
      0xDFBB,  0x77FB,  0x77F9,  0xE1B5,  0,       0,       0xE2D0,  0xE3E6,  // 0x634x
      0xE4D6,  0,       0xE5BC,  0x246C,  0x232C,  0xA1E0,  0xAD56,  0x27D3,  
      0xAD55,  0xADA4,  0xB371,  0,       0xB370,  0x2A7E,  0xA8CB,  0xBA6E,  // 0x635x
      0xBA6F,  0,       0xC33B,  0xBA73,  0xBA72,  0xBA71,  0xBA70,  0xC33A,  
      0,       0xB1FA,  0xB1FB,  0,       0,       0xC33D,  0x34E4,  0x3A2E,  // 0x636x
      0xC33E,  0x3439,  0x34E5,  0,       0xB7DD,  0x34E3,  0xC339,  0xB7DE,  
      0xB7DF,  0,       0xC33F,  0,       0,       0,       0,       0,       // 0x637x
      0,       0x3BB9,  0x3BB7,  0xCC7D,  0x3A2F,  0xCD21,  0x3BB8,  0xCC7E,  
      0xCC7C,  0,       0,       0xCD22,  0,       0xC721,  0xD65A,  0x41E8,  // 0x638x
      0xD65B,  0xD658,  0x41E9,  0xD659,  0,       0xD65C,  0,       0,       
      0,       0,       0,       0,       0x41EA,  0xBEB3,  0xBEB4,  0x48DC,  // 0x639x
      0xE053,  0xE055,  0x48DD,  0,       0,       0xE054,  0,       0,       
      0,       0,       0x4FE4,  0x4C4A,  0xA6FB,  0xA6FC,  0x4C4B,  0xB1CF,  // 0x63Ax
      0,       0xA6FA,  0,       0x4C48,  0,       0,       0,       0x57A1,  
      0x56FE,  0x5252,  0,       0xD7A5,  0xB1D0,  0,       0,       0x5778,  // 0x63Bx
      0x5776,  0x5DCB,  0xBAD0,  0xBACF,  0xBAD2,  0,       0,       0xDCA6,  
      0,       0x5254,  0,       0xBAD1,  0,       0x63DD,  0x5C69,  0x63DF,  // 0x63Cx
      0xC1E9,  0xC1EA,  0x5C6D,  0xC1E7,  0xC1E8,  0xC1E6,  0xD7A4,  0xE0B4,  
      0xE0B5,  0x5C6C,  0,       0,       0,       0x68FC,  0xC8F0,  0x76BB,  // 0x63Dx
      0xC8EF,  0xCFAE,  0xC8EE,  0,       0x6DA9,  0xCFAF,  0xCFB0,  0xCFB1,  
      0xCFB2,  0xC1E5,  0x70F5,  0xD4C7,  0,       0,       0,       0xD4C8,  // 0x63Ex
      0x73FD,  0xD8E0,  0xDCBE,  0xDCBD,  0,       0xE1B6,  0,       0xE3E7,  
      0xE5DE,  0,       0xAD57,  0,       0xB375,  0xB372,  0xB376,  0x2BAB,  // 0x63Fx
      0x2B22,  0x2B21,  0x2B24,  0xB374,  0x2B23,  0xADA5,  0xADA6,  0,       
} ;


static const unsigned short Uni2cnsP2Table_64 [] = {
      0xB373,  0,       0x2F33,  0xBA76,  0x2FE1,  0x2FE3,  0x2FE0,  0x2F31,  // 0x640x
      0x2F36,  0x2F35,  0xBA75,  0x2FE2,  0x2F34,  0x2F32,  0xBA77,  0,       
      0xAFE3,  0xAFE4,  0,       0x2F37,  0xB1FC,  0x34E6,  0xC341,  0xC340,  // 0x641x
      0xC342,  0xC343,  0xC344,  0xC346,  0xC347,  0,       0x343F,  0,       
      0,       0,       0xC345,  0x3BBB,  0x3A32,  0xCD26,  0xCD27,  0xCD2D,  // 0x642x
      0x3BBD,  0x3A36,  0xCD2E,  0,       0xCD28,  0xCD25,  0xCD2F,  0xCD30,  
      0x3BBC,  0xCD2A,  0xCD2C,  0xCD2B,  0,       0xBEB5,  0xBEB6,  0xCD29,  // 0x643x
      0x41EE,  0x41EB,  0x3F79,  0xD65D,  0xD65E,  0xD65F,  0x41ED,  0,       
      0x41EC,  0,       0,       0,       0xC4E4,  0,       0xCD24,  0x48E5,  // 0x644x
      0x48DE,  0xE057,  0x48DF,  0x48E3,  0x48E0,  0x48E4,  0x48E1,  0x48E2,  
      0xE056,  0x48E6,  0xCBBD,  0xCBBE,  0xCBBF,  0xCBC0,  0,       0,       // 0x645x
      0x4FEA,  0x4FEB,  0xA6FE,  0x4FE8,  0x4C4C,  0x4FEC,  0x4FE5,  0xA6FD,  
      0x4FE7,  0xD1C6,  0xE059,  0x4FE6,  0xA7A4,  0xA7A5,  0xA7A1,  0x4C4E,  // 0x646x
      0xA7A2,  0x4C4D,  0xA7A3,  0xD1C4,  0xD1C5,  0,       0,       0,       
      0xB1D1,  0xB1D3,  0x57A5,  0xB1D6,  0xB1D2,  0xB1D4,  0x5257,  0,       // 0x647x
      0x57A3,  0x57A6,  0x57A4,  0x4FE9,  0x57A2,  0xB1D5,  0x57A7,  0xD7A6,  
      0,       0,       0,       0x5779,  0xBAD4,  0x5DCC,  0xBAD5,  0xC8F1,  // 0x648x
      0x5DCD,  0,       0xBAD3,  0xDCA7,  0xDCA8,  0x63E0,  0x5C6E,  0xC1F1,  
      0x5DCE,  0x5C6F,  0xC1ED,  0xC1EF,  0xC1EC,  0xC1F0,  0xC1EE,  0,       // 0x649x
      0,       0xE0B6,  0xE0B7,  0xC1EB,  0x6070,  0x68FE,  0,       0x68FD,  
      0xC8F2,  0,       0xCFB5,  0xCFB6,  0xE5F2,  0xCFB3,  0x667C,  0,       // 0x64Ax
      0xD4C9,  0xD4CB,  0xCFB4,  0,       0xD4CA,  0xD8E2,  0xD8E3,  0xD8E1,  
      0,       0xA546,  0xAD58,  0xA875,  0,       0,       0x275F,  0x2760,  // 0x64Bx
      0xBA78,  0,       0x3440,  0x2BAC,  0xB7E0,  0xB7E1,  0xC348,  0,       
      0xCD31,  0xA7A6,  0,       0xB1D8,  0xB1D7,  0,       0,       0,       // 0x64Cx
      0,       0,       0,       0,       0xEBDE,  0,       0xAD59,  0xAD5A,  
      0x21F9,  0xA8CC,  0x2F39,  0x34E7,  0x3BBE,  0,       0x41EF,  0xE05A,  // 0x64Dx
      0xA7A7,  0xA7A9,  0x48E7,  0,       0,       0xB1DA,  0xB1D9,  0,       
      0xBAD6,  0,       0,       0,       0x23A1,  0xAD5B,  0xA8CD,  0,       // 0x64Ex
      0xB377,  0xADA7,  0xB378,  0xB1FE,  0x34E8,  0xB7E2,  0xC349,  0x3A37,  
      0x3BC1,  0x3BC0,  0,       0,       0x3F7B,  0xD660,  0,       0xE05C,  // 0x64Fx
      0x48EC,  0x48E8,  0x48ED,  0x48EA,  0x48E9,  0x48EB,  0x4631,  0,       
} ;


static const unsigned short Uni2cnsP2Table_65 [] = {
      0xC4E5,  0xE05B,  0x4FEF,  0x4FF0,  0x4FF1,  0x4FED,  0x4FEE,  0,       // 0x650x
      0,       0xA7AA,  0,       0x57A9,  0x57A8,  0x5258,  0x5259,  0xB1DC,  
      0xB1DD,  0xB1DB,  0xD1C7,  0x5DCF,  0x577C,  0xBADA,  0,       0xBAD7,  // 0x651x
      0xBAD8,  0,       0xD7A9,  0x63E1,  0x577E,  0xC1F2,  0xBAD9,  0xC8F5,  
      0x63E2,  0xC1F4,  0xC1F3,  0xDCA9,  0xDCAA,  0xC8F4,  0x69A1,  0,       // 0x652x
      0xC8F3,  0x667E,  0xD4CC,  0x6A6C,  0x77FC,  0x79BB,  0,       0x27D5,  
      0x27D4,  0xAD5E,  0xA8CE,  0xA8CF,  0,       0xAD5D,  0,       0x2BAF,  // 0x653x
      0x2BAD,  0x2BAE,  0,       0,       0x2F3C,  0xBA7E,  0x2F3B,  0xBA7A,  
      0x2FE4,  0xBB22,  0xB2A1,  0xB2A4,  0xB2A6,  0xB2A7,  0,       0xBA7B,  // 0x654x
      0xB2A2,  0,       0xBA7D,  0xBA7C,  0xBB23,  0xBA79,  0xB2A5,  0x2FE5,  
      0xC34B,  0x3443,  0x3442,  0x3444,  0xC34D,  0x34E9,  0xC34F,  0xC34E,  // 0x655x
      0xC34C,  0,       0xC34A,  0xB7E3,  0xB7E4,  0xB7E5,  0xB7E6,  0,       
      0x3BC2,  0xCD33,  0xCD34,  0,       0,       0x3BC3,  0xCD35,  0xBEB7,  // 0x656x
      0xBEB8,  0xBEB9,  0xBEBA,  0xBEBC,  0xBEBD,  0xBEBE,  0xBEBF,  0xBEC0,  
      0,       0xCD32,  0xBEBB,  0,       0,       0xD662,  0xD666,  0x41F1,  // 0x657x
      0x41F2,  0xD661,  0xD66B,  0xD669,  0xD667,  0x41F3,  0xD668,  0xD664,  
      0xD66A,  0,       0xD663,  0xC4E6,  0xC4E7,  0xD665,  0,       0,       // 0x658x
      0x48F0,  0x48F1,  0x48EE,  0x4C50,  0xE05E,  0x48F2,  0x48EF,  0,       
      0x48F3,  0xCBC1,  0xCBC2,  0xCBC3,  0xCBC4,  0xCBC5,  0xCBC6,  0xCBC7,  // 0x659x
      0xCBC8,  0xCBCA,  0xCBCB,  0xCBCC,  0xE05F,  0,       0,       0,       
      0,       0,       0x4FF2,  0xA7AC,  0x4FF5,  0xA7AF,  0x4FF4,  0x4FF3,  // 0x65Ax
      0x4C51,  0x4FF7,  0xA7AB,  0xA7B0,  0x4FF6,  0,       0,       0xD1C8,  
      0xD1C9,  0xD1CA,  0xD1CB,  0xD1CC,  0xD1CD,  0xD1CE,  0xD1CF,  0,       // 0x65Bx
      0,       0xA7AD,  0,       0,       0x57AC,  0x57AF,  0x57AB,  0x57AD,  
      0x57AE,  0xB1E1,  0xB1DF,  0xB1DE,  0xD7AA,  0xD7AB,  0xD7AC,  0xD7AD,  // 0x65Cx
      0xD7AE,  0xD7AF,  0xB1E0,  0,       0,       0x57AA,  0,       0,       
      0x5DD0,  0x5DD1,  0x5DD2,  0xBADB,  0x5825,  0x5826,  0x5DD4,  0x5DD3,  // 0x65Dx
      0xDCAC,  0xBADD,  0xBADC,  0,       0,       0,       0,       0xD8E3,  
      0xC1F7,  0x63E6,  0x63E3,  0x5C72,  0xC1F9,  0x5DD5,  0xC1F8,  0x63E4,  // 0x65Ex
      0x63E5,  0xC1F5,  0xE0B8,  0xE0B9,  0xE0BA,  0,       0,       0xC1F6,  
      0,       0xDCAB,  0xE3C7,  0xC8F6,  0x69A2,  0x69A3,  0xC8F8,  0xC8F7,  // 0x65Fx
      0xE3C8,  0xE3C9,  0,       0,       0,       0,       0xCFB9,  0,       
} ;


static const unsigned short Uni2cnsP2Table_66 [] = {
      0xE5F3,  0xE5F4,  0xE5F5,  0xCFB8,  0xCFB7,  0x70F6,  0xE8B0,  0xE8B1,  // 0x660x
      0xD4CD,  0xD4CE,  0x73FE,  0xD8E4,  0,       0x6A6D,  0xEAEC,  0xEBDF,  
      0xECB6,  0xECD0,  0x21FA,  0xAD5F,  0x2BB0,  0xC350,  0,       0,       // 0x661x
      0xCD36,  0,       0,       0xC86A,  0,       0xD66E,  0xE062,  0xE061,  
      0xA7B1,  0,       0xD1D0,  0xB1E2,  0,       0,       0,       0,       // 0x662x
      0xCFBA,  0x23A5,  0x23A3,  0xAD60,  0xAD61,  0xA548,  0xA2EC,  0xA2ED,  
      0,       0,       0x23A4,  0x23A2,  0x24F3,  0x24F2,  0xA879,  0xA878,  // 0x663x
      0xA877,  0,       0xA876,  0xB37B,  0,       0xB37A,  0xB379,  0x27DA,  
      0x27DE,  0xAD64,  0x2F43,  0xAD6D,  0xAD6E,  0xAD62,  0x27DD,  0xAD66,  // 0x664x
      0x27D9,  0x27D7,  0xAD6B,  0x27DB,  0,       0x276B,  0,       0,       
      0xAD68,  0xAD6F,  0xA8D0,  0xA8D1,  0xA8D3,  0xA8D4,  0xAD6C,  0x2664,  // 0x665x
      0xAD65,  0,       0,       0xAD67,  0x27DC,  0,       0,       0xAD6A,  
      0xAD63,  0xBB27,  0xBB25,  0,       0,       0,       0,       0x2F3D,  // 0x666x
      0x27D6,  0xBB26,  0xB42D,  0x2B2D,  0x2BB4,  0xB428,  0x2BB1,  0x2BB8,  
      0xB429,  0x2B2E,  0xC354,  0xB427,  0x2B2B,  0xB42B,  0x2B30,  0xB425,  // 0x667x
      0x2BB6,  0xB426,  0x2BB7,  0x2BB2,  0x2F48,  0,       0,       0x2BB5,  
      0xB37C,  0xB421,  0xB422,  0xB424,  0xADAA,  0xADAF,  0xB7E7,  0xB7E8,  // 0x668x
      0xB37E,  0xB42F,  0,       0,       0xB42C,  0xB42A,  0xB430,  0,       
      0,       0xB42E,  0xC353,  0xC352,  0xADAB,  0,       0,       0,       // 0x669x
      0xC355,  0xC356,  0xBB30,  0xC351,  0xADAD,  0x2FE7,  0x2F3E,  0x3445,  
      0x2F45,  0xBB32,  0x2FEC,  0x2F44,  0xBB2E,  0x2FEE,  0xBB2A,  0x2FF0,  // 0x66Ax
      0x3BC4,  0x2FEF,  0xBB29,  0x2FE6,  0xBB2B,  0x2F40,  0xCD3B,  0,       
      0,       0,       0x2FE9,  0xADA9,  0xB2A8,  0xB2A9,  0xB2AD,  0xBECC,  // 0x66Bx
      0x2FE8,  0x2EA4,  0xBB2F,  0xBB2D,  0,       0xBB2C,  0,       0,       
      0,       0xBB33,  0xCD3A,  0xCD38,  0xCD39,  0xCD37,  0,       0,       // 0x66Cx
      0,       0,       0,       0,       0,       0,       0xB423,  0x2FEB,  
      0x2FF1,  0,       0x2FEA,  0x34F4,  0xC35B,  0xC359,  0x34EB,  0x344E,  // 0x66Dx
      0x34EC,  0x2F42,  0x34F1,  0x3446,  0x3455,  0x41F4,  0x3454,  0xC357,  
      0x34EE,  0xC35F,  0,       0x3449,  0x34F5,  0x34F6,  0xC360,  0xC35E,  // 0x66Ex
      0,       0x344F,  0x34F2,  0xC361,  0xC362,  0xB7E9,  0xB7EB,  0,       
      0,       0,       0,       0xC35C,  0xC35D,  0,       0xD66F,  0xD670,  // 0x66Fx
      0,       0xD671,  0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_67 [] = {
      0,       0,       0x34F3,  0x34EF,  0x34F0,  0,       0xCD43,  0x3BC8,  // 0x670x
      0xCD3D,  0,       0x3BC5,  0xCD4B,  0xCD42,  0x3A3C,  0x3BCA,  0xCD4F,  
      0xCD3C,  0xE065,  0x3BC7,  0xCD50,  0xD675,  0x3A48,  0x3BCC,  0xCD55,  // 0x671x
      0xCD4E,  0xCD4C,  0xCD53,  0x3BC6,  0x48F5,  0,       0,       0xCD3E,  
      0xCD47,  0xCD4A,  0xBEC1,  0xBEC4,  0xBEC6,  0xBEC7,  0xBEC8,  0xBEC9,  // 0x672x
      0xBECA,  0xBECB,  0xCD44,  0,       0xCD49,  0,       0,       0,       
      0,       0,       0,       0xBBE3,  0,       0xCD4D,  0xCD41,  0,       // 0x673x
      0,       0xCD52,  0xCD3F,  0xCD40,  0,       0xE063,  0xE067,  0xE064,  
      0,       0xBEC5,  0,       0,       0,       0,       0,       0,       // 0x674x
      0,       0,       0,       0,       0,       0,       0,       0x3BC9,  
      0xCD46,  0x34ED,  0x3BCB,  0x3BCE,  0x3BCF,  0xCD51,  0x3BD1,  0xCD45,  // 0x675x
      0xE068,  0xE066,  0x41FD,  0x4021,  0x42A6,  0x42A1,  0x41F5,  0x41F9,  
      0x42A7,  0xD67D,  0x3F7E,  0xD672,  0x3A46,  0x42A2,  0x41F8,  0xD677,  // 0x676x
      0x4024,  0xD679,  0x4022,  0xD721,  0xD673,  0x42A9,  0xD674,  0xD678,  
      0x42A3,  0xD67C,  0x41FB,  0x41FA,  0x42A5,  0x42A4,  0xD67A,  0x41F6,  // 0x677x
      0xD67E,  0,       0xC4E9,  0xC4EA,  0xC4EB,  0xC4EC,  0xC4ED,  0xC4EF,  
      0xC4F1,  0x402B,  0,       0,       0xD723,  0xD722,  0,       0xC4F0,  // 0x678x
      0,       0xA7B2,  0,       0xA7B3,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0xD67B,  0x41FE,  0x41FC,  // 0x679x
      0,       0x4644,  0x48FB,  0x464C,  0x4643,  0x49A3,  0xE06A,  0x48FA,  
      0x464A,  0x49A4,  0x49A1,  0x4649,  0x48F7,  0x48FD,  0x463A,  0x464B,  // 0x67Ax
      0x48F8,  0xE071,  0xE06C,  0x48F6,  0xE06E,  0x48F9,  0,       0xE06D,  
      0x48FC,  0xB1E3,  0x49A2,  0,       0,       0x4648,  0xE06B,  0xCBCD,  // 0x67Bx
      0xCBCE,  0xCBCF,  0xCBD1,  0xCBD2,  0xCBD5,  0xCBD3,  0,       0,       
      0xE070,  0xDD5C,  0,       0,       0,       0,       0,       0,       // 0x67Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x41F7,  0x48FE,  0,       0,       // 0x67Dx
      0x4C53,  0x4FFB,  0,       0xA7B4,  0x4C57,  0xA7BB,  0,       0x4FFA,  
      0x4C59,  0xBAE0,  0xA7B7,  0x4FFC,  0xA7B5,  0x4C5A,  0xBADE,  0x4FF8,  // 0x67Ex
      0,       0xA7B8,  0xD1D1,  0xD1D2,  0xD1D3,  0xD1D4,  0,       0xA7B6,  
      0xA7B9,  0,       0,       0xA7BA,  0xBADF,  0,       0,       0,       // 0x67Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_68 [] = {
      0xE069,  0x4FF9,  0xDCB5,  0xB1EC,  0x57B7,  0x57B2,  0x5268,  0x525D,  // 0x680x
      0x57B1,  0x525F,  0xB1E7,  0xB1EE,  0x57B5,  0x57B6,  0x5265,  0x4FFD,  
      0x57B4,  0xB1E5,  0xB1ED,  0x57B9,  0xB1EA,  0x69A4,  0x5260,  0xB1EF,  // 0x681x
      0,       0xD7B1,  0xD7B3,  0,       0xD7B2,  0,       0xA7BC,  0xB1E8,  
      0xB1E9,  0,       0,       0,       0xB1E4,  0xB1E6,  0,       0,       // 0x682x
      0xB1EB,  0xC1FA,  0,       0xC8F9,  0xC1FB,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x57BA,  // 0x683x
      0x57B0,  0x57BB,  0x57B8,  0x57B3,  0xC2A1,  0,       0x5DDA,  0x5DD9,  
      0xBAE2,  0x582E,  0x582A,  0x5829,  0,       0x5DD8,  0x5DD6,  0x6071,  // 0x684x
      0xC8FB,  0,       0,       0,       0x5DDE,  0xBAE5,  0xDCAE,  0xDCAF,  
      0xDCB1,  0xDCB2,  0xDCB3,  0xDCB4,  0xDCB6,  0xDCB0,  0,       0xB7FE,  // 0x685x
      0xBAE3,  0,       0,       0xC8FA,  0xC8FD,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x686x
      0x5DDD,  0xBAE1,  0x5DDC,  0x5DD7,  0xBAE4,  0xC8FE,  0,       0,       
      0x5C75,  0x63EA,  0x63E7,  0,       0x63E9,  0x63EC,  0xC1FC,  0x63EE,  // 0x687x
      0xC1FE,  0x63EB,  0xC2A3,  0x63E8,  0x6DAA,  0x63EF,  0xE0BB,  0xE0BC,  
      0xE0BD,  0xE0C0,  0xE0C1,  0xC1FD,  0,       0xC2ED,  0,       0,       // 0x688x
      0x5C73,  0,       0x6072,  0,       0xC9A3,  0xC9A9,  0x69A5,  0x69A6,  
      0x63ED,  0xC9A4,  0,       0,       0xE3CA,  0xC9A8,  0xC9AA,  0xE3CC,  // 0x689x
      0xE3CD,  0xC9A2,  0xC9A6,  0xC9A5,  0xC9A7,  0xC9A1,  0,       0,       
      0,       0,       0,       0,       0xE3CB,  0xC9AB,  0xCFBD,  0x6DAE,  // 0x68Ax
      0x6DAD,  0x642B,  0x6429,  0x6DAB,  0xE5F6,  0xCFBC,  0,       0xCFBB,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x68Bx
      0x6726,  0xD4CF,  0x70F7,  0xDCC0,  0xD5BA,  0xDCBF,  0,       0x6931,  
      0x692F,  0xD8E5,  0,       0,       0,       0xE8B3,  0xDCC1,  0x76BD,  // 0x68Cx
      0xDCC3,  0xDCC5,  0xDCC6,  0x76BC,  0xDCC2,  0x6A6E,  0,       0xDCC7,  
      0xDCC8,  0xDFBD,  0x77FD,  0xDFBE,  0,       0,       0x79BC,  0,       // 0x68Dx
      0,       0,       0xE4D7,  0x7AEF,  0x7BC5,  0xA87C,  0x2471,  0xAAC9,  
      0xBB34,  0xB2AF,  0,       0,       0xCD56,  0,       0,       0,       // 0x68Ex
      0,       0xCD57,  0,       0xCBD8,  0xCBD9,  0xD1D6,  0xE073,  0,       
      0,       0xDCB7,  0xC2A5,  0xE0C2,  0x70F9,  0xE8B4,  0xE9E7,  0xE5BD,  // 0x68Fx
      0x7CAC,  0xA54A,  0xA87E,  0x2472,  0xA87D,  0xAD70,  0x2BBA,  0xB432,  
} ;


static const unsigned short Uni2cnsP2Table_69 [] = {
      0xADB0,  0,       0x2FF2,  0xBB36,  0x2F49,  0xB2B0,  0xBB37,  0,       // 0x690x
      0,       0,       0xBB35,  0,       0xC366,  0xC365,  0xB7ED,  0xB7EE,  
      0xCD59,  0,       0xCD5A,  0,       0xD724,  0x49A5,  0xCBDA,  0,       // 0x691x
      0x4C60,  0x4C61,  0x4FFE,  0xD1D7,  0,       0xA7BD,  0x5269,  0x57BC,  
      0,       0xBAE6,  0x5DE0,  0x5DDF,  0xDCB8,  0xE0C3,  0x69A7,  0x6075,  // 0x692x
      0x6DB1,  0xE3CE,  0xC9AC,  0x6DAF,  0x6DB0,  0,       0,       0,       
      0,       0,       0xE2D1,  0xA921,  0xAD71,  0xAD72,  0xBB3A,  0xADB1,  // 0x693x
      0,       0xBB38,  0xBB39,  0x34F7,  0x3456,  0,       0,       0xCD5B,  
      0,       0x42AA,  0x49A6,  0,       0xCBDB,  0x50A1,  0xA7BE,  0xD1D8,  // 0x694x
      0x50A2,  0xB1F1,  0x526A,  0x57BD,  0xD7B4,  0,       0x582F,  0x63F0,  
      0x63F1,  0x2474,  0xA54B,  0xA364,  0xAD73,  0xAD74,  0,       0xADB2,  // 0x695x
      0x2F4B,  0xB433,  0,       0xBB3B,  0,       0xBB41,  0xBB3D,  0xBB3C,  
      0x2F4C,  0xBB3F,  0xBB40,  0,       0,       0xC369,  0x34F8,  0xBB3E,  // 0x696x
      0xC368,  0xC36B,  0,       0xC36A,  0,       0x3BD2,  0xCD5C,  0,       
      0,       0,       0x3BD3,  0x49A7,  0xD728,  0xD727,  0xD725,  0xE074,  // 0x697x
      0xE07A,  0xE075,  0xE076,  0x50A3,  0xA7BF,  0xE077,  0xE07B,  0xE078,  
      0xA7C0,  0xA7C1,  0xA7C2,  0xE079,  0x49A8,  0x50A4,  0x50A5,  0xA7C3,  // 0x698x
      0xA7C4,  0xB1F2,  0xA7C5,  0,       0xA7C6,  0,       0xD7B5,  0xB1F4,  
      0xB1F3,  0x5DE2,  0,       0xB1F7,  0,       0xB1F6,  0xB1F5,  0x5DE1,  // 0x699x
      0x5DE4,  0xBAE7,  0xC2A8,  0xC2A7,  0x5DE5,  0x5C77,  0xC2A6,  0xE0C4,  
      0xE0C5,  0xC9AD,  0x63F3,  0x63F2,  0xC9AE,  0xCFBF,  0,       0x69A8,  // 0x69Ax
      0,       0x6DB3,  0x6DB4,  0x6DB5,  0xCFBE,  0xC9AF,  0xE3CF,  0x69A9,  
      0xCFC0,  0xCFC1,  0x70FA,  0xE5F8,  0xE8B5,  0xE8B7,  0xD8E6,  0,       // 0x69Bx
      0xE8B6,  0xD8E7,  0xDCC9,  0x77FE,  0xE1B7,  0x79BD,  0x79BF,  0x79BE,  
      0xECEA,  0xE5BE,  0xE5BF,  0,       0xE6D3,  0x7CD0,  0xA5AB,  0xB434,  // 0x69Cx
      0x2F4E,  0x2F4D,  0xBB42,  0,       0xBB43,  0,       0xBB44,  0x2FF3,  
      0x2FF4,  0xC36C,  0,       0xC36D,  0xC17D,  0xCD60,  0xCD5F,  0xCD61,  // 0x69Dx
      0,       0,       0xBED0,  0,       0,       0x49A9,  0,       0x464D,  
      0x45D3,  0x464E,  0xD729,  0xCBDC,  0xE07C,  0xE07E,  0xE07D,  0xA7C7,  // 0x69Ex
      0xD1D9,  0,       0xA7C9,  0xA7C8,  0,       0xB1F8,  0x57BE,  0,       
      0xB1F9,  0xBAE8,  0,       0xE0C6,  0x63F4,  0xC2AA,  0xC2A9,  0,       // 0x69Fx
      0x6DB6,  0x70FB,  0,       0xDCCA,  0x76BE,  0,       0x50A6,  0x50A7,  
} ;


static const unsigned short Uni2cnsP2Table_6A [] = {
      0xE0C7,  0xCFC2,  0,       0xDCCB,  0xDFBF,  0xE1B9,  0x7AF0,  0x24F4,  // 0x6A0x
      0x2771,  0x2770,  0xAD77,  0xAD76,  0xAD75,  0x27DF,  0x2B31,  0x2B35,  
      0x2B34,  0,       0xB435,  0xB437,  0xB436,  0xBB4A,  0x2FF5,  0xBB49,  // 0x6A1x
      0xBB45,  0x2FF6,  0x2F52,  0,       0x2F51,  0xBB46,  0,       0xBB47,  
      0xBB48,  0x34FA,  0x3459,  0x345B,  0xC372,  0,       0x34FB,  0xC36E,  // 0x6A2x
      0xC36F,  0,       0xB7F1,  0,       0x34F9,  0xB7F0,  0xB7F2,  0x3BD4,  
      0xCD65,  0xCD64,  0x345A,  0,       0x3A52,  0x3A50,  0x3A51,  0x3A53,  // 0x6A3x
      0,       0,       0xCD66,  0,       0x42AB,  0xD72C,  0x42AC,  0xD72A,  
      0,       0,       0,       0xC4F2,  0xD72B,  0,       0,       0xD72D,  // 0x6A4x
      0xD72E,  0x42AE,  0xE127,  0x49AD,  0x49AB,  0x4652,  0xE122,  0xE126,  
      0,       0,       0,       0xCBDE,  0xCBDF,  0,       0,       0,       // 0x6A5x
      0xCBDD,  0xE123,  0,       0,       0x49AA,  0x50AF,  0x4C67,  0x4C66,  
      0x50AE,  0x50AB,  0x50AC,  0x50B0,  0x50A8,  0xA7CF,  0xA7CD,  0x50B1,  // 0x6A6x
      0xA7CA,  0xA7CC,  0xA7CE,  0xA7CB,  0x50AD,  0,       0,       0,       
      0,       0x50A9,  0x50AA,  0,       0x57C2,  0x57BF,  0x57C3,  0xB1FC,  // 0x6A7x
      0x57C0,  0xB2A1,  0xB1FD,  0xB2A3,  0x57C1,  0xB2A2,  0xD7B6,  0,       
      0,       0,       0,       0,       0xB1FE,  0xB1FB,  0xBAEA,  0x5831,  // 0x6A8x
      0x5DEC,  0x5DE6,  0x5DE9,  0x5DE8,  0,       0x5DEA,  0x5DEB,  0,       
      0,       0x5C79,  0x63FB,  0xC2AC,  0x63F5,  0x63FA,  0x63FD,  0x63F9,  // 0x6A9x
      0x5C7A,  0x5C7B,  0x63F6,  0x63F7,  0x63FC,  0x5C78,  0,       0,       
      0,       0,       0,       0,       0xC2AD,  0xC2AB,  0,       0x63F8,  // 0x6AAx
      0,       0xC9B0,  0x69AD,  0x69AC,  0x69AB,  0x69AA,  0xC9B1,  0xE3D0,  
      0xC9B2,  0x6DB7,  0xCFC3,  0,       0,       0,       0x70FD,  0x70FC,  // 0x6ABx
      0xD4D2,  0,       0,       0,       0,       0x74A1,  0x74A2,  0x6932,  
      0xD8E8,  0xD4D0,  0xD4D1,  0x6A6F,  0xDCCC,  0xE1BB,  0xE1BA,  0xE2D2,  // 0x6ACx
      0x7AF1,  0,       0x6E4F,  0xB438,  0xB7F3,  0,       0x3BBF,  0xBED1,  
      0xD1DA,  0xDCB9,  0xCFC4,  0,       0x34FC,  0x34FD,  0,       0xC373,  // 0x6ADx
      0,       0x34FE,  0xBED2,  0xD72F,  0xD730,  0xD731,  0xE129,  0,       
      0xCBE0,  0,       0xE12A,  0xE128,  0xA7D1,  0xA7D0,  0xA7D2,  0xD1DB,  // 0x6AEx
      0xD1DC,  0xD1DD,  0x57C4,  0x57C5,  0xB2A5,  0xB2A4,  0,       0x6DB9,  
      0x6DB8,  0xCFC5,  0xECB7,  0x21FB,  0xA338,  0,       0x232E,  0xA550,  // 0x6AFx
      0xA551,  0xAD78,  0xA54E,  0x23A6,  0xA54D,  0xA2EF,  0xA2F0,  0xA2EE,  
} ;


static const unsigned short Uni2cnsP2Table_6B [] = {
      0xA54C,  0x2477,  0x2478,  0x247C,  0xA922,  0x247A,  0xA925,  0xA923,  // 0x6B0x
      0xA924,  0xA926,  0,       0xA5AC,  0xA5AD,  0xA5AE,  0xA5AF,  0xA5B0,  
      0xA5B1,  0,       0,       0xAD7B,  0x277C,  0x2777,  0x2779,  0x27E2,  // 0x6B1x
      0x277D,  0x2778,  0x2775,  0x27E0,  0xAD7C,  0x27E1,  0x2774,  0xBB4B,  
      0xA74C,  0xAE21,  0x27E4,  0x2776,  0xAD7A,  0xAD7E,  0xBB4D,  0xBB4C,  // 0x6B2x
      0,       0xA8D7,  0xA8D8,  0xA8D9,  0xA8DA,  0xA8DB,  0xA8DD,  0xA8DE,  
      0xA8DF,  0xA8E0,  0xA8E1,  0xA8E2,  0xA8E4,  0xAD79,  0,       0x2B3B,  // 0x6B3x
      0x2B37,  0x2B38,  0x2B39,  0x2BBF,  0xB443,  0xB43B,  0x2B3C,  0xB441,  
      0xB43D,  0x2BBD,  0xB439,  0xB440,  0xB43E,  0xB442,  0xB445,  0xB446,  // 0x6B4x
      0x2BBB,  0x2BBE,  0,       0x2BBC,  0,       0,       0,       0,       
      0,       0,       0,       0,       0xADB3,  0xADB5,  0xADB7,  0xADB8,  // 0x6B5x
      0xADB9,  0xADBA,  0xADBB,  0xADBC,  0xADB6,  0xB33E,  0,       0,       
      0,       0,       0xB43F,  0,       0,       0,       0,       0,       // 0x6B6x
      0xADB4,  0xAD7D,  0,       0xCD68,  0xAAD2,  0x2FFC,  0x2F56,  0x2F57,  
      0x2F62,  0x2FF8,  0x2FFA,  0x2FFE,  0x2F54,  0x2FF7,  0x30A3,  0x2F5B,  // 0x6B7x
      0x30A7,  0x2F58,  0x2F65,  0x30A4,  0x2F60,  0xBB5E,  0xBB5F,  0x30A5,  
      0xBB61,  0x30A2,  0x2F66,  0xBB59,  0xBB58,  0xCD67,  0xC422,  0xBB55,  // 0x6B8x
      0x2FFD,  0xBB54,  0xBB51,  0xBB4F,  0xBB5A,  0xBB5C,  0x2FFB,  0xBB57,  
      0x30A6,  0x2FF9,  0xBB53,  0xBB5B,  0,       0,       0,       0,       // 0x6B9x
      0xBB5D,  0xBB62,  0xB2B3,  0xB2B5,  0xB2B6,  0xB2B7,  0xB2B8,  0xB2B9,  
      0xB2BB,  0xB2BC,  0xB2BD,  0xB2BF,  0xB2C0,  0xB2C2,  0xB2C3,  0xB2C4,  // 0x6BAx
      0xB2C5,  0xB2C7,  0xB2C8,  0xB2C9,  0xB2CA,  0xB2CB,  0xBB50,  0xB2C6,  
      0,       0,       0,       0xB2CC,  0,       0xB2BE,  0,       0x35AB,  // 0x6BBx
      0x35AE,  0x35A7,  0x3470,  0x35AC,  0x3461,  0x346E,  0x3468,  0xC432,  
      0x3472,  0x3475,  0xC426,  0xC37B,  0xC423,  0x35A3,  0xC379,  0xC375,  // 0x6BCx
      0x3460,  0x35B2,  0xC374,  0xC421,  0xC438,  0x3464,  0xC436,  0xCE3A,  
      0,       0xC434,  0xBB60,  0xCD78,  0x345F,  0x35A1,  0x346B,  0,       // 0x6BDx
      0xC377,  0xC424,  0x35B0,  0xC42F,  0xC435,  0xC42E,  0xC429,  0x35AF,  
      0xC433,  0xC378,  0xC427,  0x35B1,  0x42AF,  0xD732,  0xD733,  0,       // 0x6BEx
      0xC430,  0xC431,  0xC37E,  0x35A2,  0x35B3,  0xC42A,  0x35A9,  0x35AD,  
      0x35A6,  0xCE37,  0xC439,  0xC43A,  0xC37C,  0,       0,       0,       // 0x6BFx
      0xC37A,  0xB7F4,  0xB7F5,  0xB7F6,  0xB7F7,  0xB7F9,  0xB7FB,  0xB7FC,  
} ;


static const unsigned short Uni2cnsP2Table_6C [] = {
      0xB7FD,  0xB7FE,  0xB8A1,  0xB8A2,  0xB8A4,  0xB8A5,  0xB8A6,  0xB8A7,  // 0x6C0x
      0xB8A8,  0xB8A9,  0xB8AA,  0xB8AB,  0xB8AC,  0xB8AD,  0xB8AE,  0xB8AF,  
      0xB8B0,  0xB8B1,  0xB8B2,  0xB8B3,  0xB8B4,  0xB8B5,  0x3BDD,  0xC37D,  // 0x6C1x
      0x35A8,  0xC425,  0,       0xB7FA,  0,       0xC42D,  0xC437,  0,       
      0,       0xB8A3,  0,       0,       0,       0,       0,       0x35A5,  // 0x6C2x
      0,       0,       0x3BD5,  0x3A55,  0x3BE9,  0x3BEA,  0x3BE2,  0x3BEC,  
      0x3BED,  0x3BE3,  0x3A5D,  0xCD7A,  0xCD72,  0xCE2B,  0xCD70,  0xCD6B,  // 0x6C3x
      0x3BDF,  0x3BE7,  0x3BE8,  0xCD7B,  0xCD79,  0x3BDE,  0x3BEE,  0x3BEB,  
      0x346A,  0x3A57,  0x3A5A,  0x3A58,  0x3A62,  0x3BDA,  0,       0x3A54,  // 0x6C4x
      0xCD69,  0xCE35,  0x3A63,  0xCD6A,  0x3BE4,  0xCD7C,  0xCE36,  0xCD7D,  
      0xCE2F,  0xCE30,  0x3A6B,  0xCE26,  0x3A69,  0xCE23,  0x3BDC,  0xCE28,  // 0x6C5x
      0xCD75,  0xCE2D,  0xCD74,  0xCE22,  0xCE31,  0,       0xCE29,  0x3BE5,  
      0xE132,  0xE12D,  0xE12E,  0x3BD7,  0xCE24,  0xCD6F,  0xCE2E,  0x49AE,  // 0x6C6x
      0xCD73,  0xCE2C,  0xCD77,  0xCE25,  0xCD6D,  0xCE2A,  0x3A6A,  0x3BE0,  
      0x3BDB,  0,       0xCD76,  0xCE38,  0xE12B,  0x3BE6,  0xE12F,  0x3BE1,  // 0x6C7x
      0xCE34,  0xE131,  0xE130,  0xCD6C,  0xCD7E,  0,       0,       0,       
      0,       0,       0,       0xCC7B,  0x3BD8,  0xCD6E,  0xCD71,  0xCE33,  // 0x6C8x
      0xCE39,  0xBED3,  0xBED5,  0xBED6,  0xBED8,  0xBEDA,  0xBEDB,  0xBEDC,  
      0xBEDD,  0xBEDE,  0xBEDF,  0xBEE0,  0xBEE1,  0xBEE3,  0xBEE4,  0xBEE5,  // 0x6C9x
      0xBEE8,  0xBEE9,  0xBEEA,  0xBEED,  0xBEEF,  0xBEF0,  0xBEF1,  0xBEF2,  
      0xBEF4,  0xBEF5,  0xBEF6,  0xBEF7,  0xBEF8,  0xBEF9,  0xBEFA,  0xBEFB,  // 0x6CAx
      0xBEFC,  0xBEFD,  0xBEFE,  0,       0xE12C,  0,       0,       0x3BD9,  
      0xCE21,  0,       0,       0,       0,       0,       0xBEE2,  0xBED4,  // 0x6CBx
      0,       0,       0,       0,       0,       0xBEEE,  0,       0,       
      0xBEF3,  0x4043,  0xD734,  0xD746,  0x42CE,  0xD73A,  0xD73B,  0x42B4,  // 0x6CCx
      0x403D,  0xD749,  0xD75A,  0x4040,  0x4042,  0x42C5,  0xD75E,  0x42BA,  
      0x4037,  0x4034,  0xD741,  0xD763,  0x42B3,  0xD751,  0xD755,  0x42C3,  // 0x6CDx
      0xD74A,  0x4038,  0x403B,  0x42B6,  0xD743,  0x403C,  0x4045,  0x42C1,  
      0x404D,  0x42CF,  0x403E,  0x42C6,  0xD75D,  0x42BF,  0x4033,  0x4031,  // 0x6CEx
      0xD765,  0x403F,  0xD742,  0x42C8,  0x42C2,  0x42B8,  0x42BE,  0,       
      0xD738,  0xD753,  0xD74F,  0xD740,  0xD767,  0x42BD,  0xD739,  0xD764,  // 0x6CFx
      0xD737,  0x42D0,  0xD74E,  0xD745,  0xD73C,  0x42C9,  0x42CD,  0x42BB,  
} ;


static const unsigned short Uni2cnsP2Table_6D [] = {
      0x42C7,  0xD752,  0xD760,  0,       0,       0xD75C,  0,       0xD748,  // 0x6D0x
      0xD756,  0x42B9,  0x4039,  0xD757,  0x42B0,  0x42C0,  0x42B2,  0x42CA,  
      0xD73F,  0x4035,  0x404B,  0xD74C,  0x42B5,  0x42B1,  0xD747,  0xD758,  // 0x6D1x
      0xA7D3,  0xD761,  0x42BC,  0xD744,  0xD754,  0xD736,  0xD762,  0xD766,  
      0xD759,  0,       0,       0,       0,       0,       0,       0,       // 0x6D2x
      0,       0,       0,       0x404E,  0x42C4,  0x42CB,  0xD735,  0xD73E,  
      0xD74B,  0xD74D,  0xD75B,  0xD75F,  0xC4F3,  0xC4F5,  0xC4F6,  0xC4F7,  // 0x6D3x
      0xC4F8,  0xC4F9,  0xC4FA,  0xC4FB,  0xC4FC,  0xC4FD,  0xC4FE,  0xC5A1,  
      0xC5A2,  0xC5A3,  0xC5A4,  0xC5A5,  0xC5A6,  0xC5A7,  0xC5A8,  0xC5A9,  // 0x6D4x
      0xC5AA,  0xC5AB,  0xC5AC,  0xC5AE,  0xC5AF,  0xC5B0,  0xC5B1,  0,       
      0x42CC,  0x404A,  0xD73D,  0,       0,       0,       0,       0,       // 0x6D5x
      0,       0,       0,       0,       0,       0xCE32,  0xBED7,  0x42B7,  
      0,       0x4666,  0xE160,  0x49C5,  0xE133,  0xE143,  0x49CB,  0x4663,  // 0x6D6x
      0xE156,  0x4656,  0xE145,  0x4659,  0xE13C,  0x49C1,  0xE14A,  0x4655,  
      0xE152,  0x49BD,  0xE140,  0xE159,  0x49C9,  0x49C6,  0xE14C,  0x49BA,  // 0x6D7x
      0x465A,  0xE139,  0xE155,  0xE14D,  0xE13F,  0x49C4,  0x49B9,  0x49B0,  
      0x4662,  0xE141,  0x465E,  0,       0xE136,  0x465D,  0x466B,  0x465B,  // 0x6D8x
      0x49BF,  0xA7D8,  0xE137,  0x49B2,  0x49B7,  0x49B1,  0x49C8,  0x50BB,  
      0x465F,  0x49C3,  0xE138,  0x4668,  0xE150,  0x49B8,  0xE157,  0xE146,  // 0x6D9x
      0xE13B,  0x49C0,  0x49B6,  0xB2A7,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x6DAx
      0x49AF,  0x49B4,  0xE147,  0xE149,  0xE14B,  0xE14E,  0xE15A,  0xE15D,  
      0xE15E,  0xCBE1,  0xCBE2,  0xCBE3,  0xCBE6,  0xCBE8,  0xCBE9,  0xCBEA,  // 0x6DBx
      0xCBEB,  0xCBEC,  0xCBED,  0xCBEE,  0xCBEF,  0xCBF0,  0xCBF1,  0xCBF2,  
      0xCBF3,  0xCBF4,  0xCBF5,  0xCBF6,  0xCBF8,  0xCBF9,  0xCBFA,  0xCBFC,  // 0x6DCx
      0xCBFD,  0xCBFE,  0xCCA1,  0xCCA2,  0xCCA3,  0xCCA5,  0xCCA6,  0xCCA7,  
      0xCCA8,  0xCCA9,  0xCCAA,  0xE148,  0x49C2,  0xE153,  0,       0xE151,  // 0x6DDx
      0xD768,  0x49CA,  0xE15C,  0xE15F,  0,       0xE15B,  0xE13A,  0xE135,  
      0xE142,  0xE13D,  0,       0xD750,  0,       0,       0,       0,       // 0x6DEx
      0,       0,       0xCBE4,  0,       0,       0,       0,       0,       
      0xCBE7,  0xE154,  0x466A,  0x4654,  0x49B5,  0x49CD,  0xB2A6,  0x49B3,  // 0x6DFx
      0xE161,  0x49C7,  0x49CC,  0x57C6,  0xCBFB,  0x49BE,  0,       0xA7EC,  
} ;


static const unsigned short Uni2cnsP2Table_6E [] = {
      0x4C7E,  0x50B2,  0x4C69,  0x4C7C,  0xA8A1,  0,       0x50B5,  0xA8A4,  // 0x6E0x
      0xA7F7,  0xA7DC,  0x50B9,  0xA7E9,  0xA7F8,  0xA7F9,  0xA7EA,  0xA7F3,  
      0x50BA,  0xA7EF,  0x4C75,  0x50BD,  0x50C2,  0xA7E0,  0xA8A2,  0x50C0,  // 0x6E1x
      0x50BF,  0x57C7,  0x50C1,  0x50CB,  0xA7EB,  0xA7F6,  0xA7D9,  0xA7F2,  
      0xA7E5,  0x50C8,  0x50B7,  0x4C7B,  0xA7D4,  0,       0xA7DB,  0xA7E4,  // 0x6E2x
      0xA7E3,  0xA7E7,  0x50B3,  0xA7E6,  0xA7FD,  0xA7DE,  0x50BE,  0xA7D6,  
      0x50B4,  0x50CA,  0xA7FC,  0xA7E2,  0xA7DD,  0xA7EE,  0x4C76,  0x50C9,  // 0x6E3x
      0x50C5,  0xA7F4,  0x57D8,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x4D22,  0x50C3,  // 0x6E4x
      0xA7D5,  0xA7DA,  0xA7DF,  0xA7F0,  0xA7F1,  0xA8A3,  0xD1DE,  0xD1DF,  
      0xD1E0,  0xD1E2,  0xD1E3,  0xD1E6,  0xD1E7,  0xD1E8,  0xD1E9,  0xD1EA,  // 0x6E5x
      0xD1EC,  0xD1ED,  0xD1EE,  0xD1EF,  0xD1F0,  0xD1F2,  0xD1F5,  0xD1F7,  
      0,       0x4D23,  0xA7FA,  0x50C4,  0xA7FE,  0,       0,       0,       // 0x6E6x
      0xA7F5,  0,       0xA7E8,  0,       0,       0,       0xD1F1,  0,       
      0,       0,       0xD1E1,  0,       0,       0,       0,       0xD1EB,  // 0x6E7x
      0,       0,       0,       0,       0,       0x50B6,  0xA7D7,  0x50C7,  
      0x50BC,  0xE134,  0xC2AE,  0,       0xCCA4,  0,       0xB2D1,  0x532D,  // 0x6E8x
      0xB2B2,  0x532A,  0x5334,  0xB2D3,  0x57C9,  0x532B,  0x57DD,  0xB2C3,  
      0x57D4,  0x5271,  0x5330,  0x57D1,  0x57DB,  0xB2BC,  0x5275,  0x57DA,  // 0x6E9x
      0x57CB,  0x57DF,  0xB2B3,  0x57E1,  0x532F,  0xB2A8,  0x57CD,  0x57CF,  
      0xB2CC,  0x57D5,  0x57E2,  0xB2BD,  0xB2BB,  0x50CC,  0x5270,  0x57C8,  // 0x6EAx
      0x57DE,  0xB2C5,  0xB2CB,  0xB2C1,  0x57E4,  0x57E0,  0xA8A5,  0xA7FB,  
      0xB2D2,  0x5DFA,  0x5326,  0xB2AE,  0x5329,  0xB2B6,  0x57D3,  0x5328,  // 0x6EBx
      0x5274,  0x50B8,  0xB2AF,  0x57D2,  0xB2B8,  0x57D6,  0x57CC,  0xB2AD,  
      0xB2D7,  0xB2CE,  0x532E,  0x57DC,  0xB2AA,  0x5278,  0xB2B9,  0xC2AF,  // 0x6ECx
      0xB2AB,  0xB2D5,  0x5332,  0xB2C2,  0xB2B5,  0xB2BF,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x6EDx
      0xD7BE,  0xD7BF,  0xD7C0,  0xD7C1,  0x57CA,  0x57D0,  0x57D7,  0xB2AC,  
      0xB2B4,  0xB2B7,  0xB2BE,  0xB2C0,  0xB2C7,  0xB2C9,  0xB2CD,  0xB2CF,  // 0x6EEx
      0xB2D4,  0xB2D9,  0xB2DA,  0xD7B7,  0xD7B8,  0xD7B9,  0xD7BA,  0xD7BB,  
      0xD7BC,  0xD7BD,  0xD7C2,  0xD7C3,  0xD7C4,  0xD7C9,  0xD7CC,  0xD7CD,  // 0x6EFx
      0xD7CE,  0xD7CF,  0xD7D0,  0xD7D1,  0xD7D2,  0xD7D3,  0xD7D4,  0xD7D6,  
} ;


static const unsigned short Uni2cnsP2Table_6F [] = {
      0xD7D7,  0xD7D8,  0xD7D9,  0xD7DA,  0xD7DB,  0xD7DC,  0xB2B1,  0xD7C5,  // 0x6F0x
      0,       0,       0x527D,  0xB2BA,  0xB2D8,  0xB2D0,  0x57E5,  0x57CE,  
      0xB2B0,  0xB2A9,  0xB2C8,  0,       0,       0xD7CA,  0,       0,       // 0x6F1x
      0,       0xB2D6,  0,       0,       0,       0,       0,       0,       
      0,       0x57E3,  0x57D9,  0,       0xB2C6,  0,       0,       0,       // 0x6F2x
      0,       0xBAF6,  0x583A,  0x583F,  0xBAEE,  0xC2BB,  0xBAF8,  0x5848,  
      0x5849,  0x57E6,  0x5DF5,  0x5DFD,  0x5DF3,  0xBBAB,  0xBBAF,  0x5DEF,  // 0x6F3x
      0x584A,  0x5837,  0xBAFB,  0x5845,  0x5EA1,  0xBAFC,  0xBBA3,  0xBBB3,  
      0x5DFE,  0x5EA5,  0xBBB1,  0x5EA2,  0x5DEE,  0x5DF8,  0xBAFE,  0x5DFC,  // 0x6F4x
      0xBAF3,  0xBBA4,  0xBBAA,  0x5DFB,  0x584B,  0,       0x5DED,  0x5EA3,  
      0x5841,  0xBBB0,  0x5DF7,  0x5846,  0x5DF1,  0x5EA4,  0xBBA5,  0x5DF6,  // 0x6F5x
      0xBAF0,  0xBAF5,  0xC2B9,  0xBAEB,  0xBAEC,  0xBBB5,  0xBAFD,  0x5847,  
      0xBBAE,  0xBAF2,  0xBAF7,  0xC9B4,  0xBAF1,  0xBBA2,  0xBBA9,  0xB2CA,  // 0x6F6x
      0xBAF9,  0xBBA1,  0xBBB7,  0x5DF4,  0x50CD,  0,       0x5843,  0,       
      0,       0xC9B5,  0,       0,       0,       0x5DF0,  0x5DF2,  0xBAED,  // 0x6F7x
      0xBBA7,  0xBBA8,  0xBBAC,  0xBBB4,  0xDCBA,  0xDCBB,  0xDCBC,  0xDCBD,  
      0xDCBE,  0xDCC0,  0xDCC1,  0xDCC2,  0xDCC3,  0xDCC4,  0xDCC5,  0xDCC6,  // 0x6F8x
      0xDCC7,  0xDCC9,  0xDCCA,  0xDCCB,  0xDCCC,  0xDCCF,  0xDCD0,  0x5839,  
      0xBAFA,  0,       0xBBAD,  0,       0xBBB6,  0,       0,       0xBAF4,  // 0x6F9x
      0,       0,       0,       0xDCC8,  0,       0,       0,       0xDCBF,  
      0,       0xDCCE,  0,       0,       0,       0,       0,       0xD7D5,  // 0x6FAx
      0,       0,       0xE3DB,  0,       0x64AC,  0xC2CB,  0x5D24,  0xC2CC,  
      0x64A2,  0x5D25,  0x5EA6,  0x64AF,  0xC2C8,  0x64A5,  0x63FE,  0xC2B0,  // 0x6FBx
      0x64A1,  0x64A9,  0x64B6,  0x64B9,  0xC2B6,  0x64B3,  0xC2C6,  0x5D22,  
      0x5EA7,  0x64B8,  0x64A6,  0x64B0,  0xC2BD,  0x64A4,  0x64AE,  0,       // 0x6FCx
      0xC2CD,  0x5D30,  0x64B1,  0x5D2E,  0x5D26,  0x5D2A,  0x64B4,  0x64B2,  
      0xC2BE,  0xCFC6,  0xC2BA,  0xC2B7,  0x5D2F,  0xC9C4,  0x64AB,  0xC2B3,  // 0x6FDx
      0xC2C5,  0xC2C9,  0,       0,       0,       0,       0,       0,       
      0x5D2D,  0xBBA6,  0xC2B2,  0xC2B4,  0xC2B5,  0xC2BF,  0xC2C2,  0xC2C4,  // 0x6FEx
      0xC2CA,  0xC2CE,  0xC2CF,  0xE0C8,  0xE0C9,  0xE0CA,  0xE0CB,  0xE0CC,  
      0xE0CF,  0xE0D0,  0xE0D1,  0xE0D2,  0xE0D3,  0xE0D4,  0,       0,       // 0x6FFx
      0,       0xE0D5,  0xE0D6,  0xE0D7,  0xE0D8,  0xE0D9,  0xE0DA,  0xE0DB,  
} ;


static const unsigned short Uni2cnsP2Table_70 [] = {
      0xE0DC,  0xE0DE,  0xE0DF,  0,       0x5D27,  0xC2C0,  0x64A7,  0xC2C1,  // 0x700x
      0,       0,       0,       0,       0,       0xC9B3,  0,       0,       
      0,       0,       0,       0,       0x64B5,  0x64AA,  0x5D29,  0xC2C7,  // 0x701x
      0x64A3,  0x64A8,  0x64B7,  0xC2C3,  0,       0xC2B1,  0,       0,       
      0x69BE,  0x69AF,  0xCFDD,  0x69B0,  0x69BA,  0x69B6,  0x607D,  0x6079,  // 0x702x
      0x69BF,  0x69B7,  0xC9B8,  0xC9C5,  0x69BB,  0x69B5,  0x607C,  0x69AE,  
      0x6DC2,  0xC9C3,  0x69B8,  0xC9C6,  0x69B9,  0xC9C1,  0,       0xC9D4,  // 0x703x
      0xC9D1,  0xC9BC,  0x69B3,  0x69BD,  0xC9CB,  0xC9CE,  0xC9BE,  0xC9BD,  
      0xC9C2,  0xC9C7,  0xCFD4,  0xC9CD,  0xC9B9,  0xC9CC,  0xC9CA,  0xCFC7,  // 0x704x
      0x69B4,  0x69B2,  0x6076,  0x69BC,  0xC9C9,  0xC9C0,  0,       0xC9BF,  
      0,       0xC9B6,  0,       0,       0xC9B7,  0xC9BA,  0xC9C8,  0xC9D0,  // 0x705x
      0xC9D2,  0xE3D1,  0xE3D2,  0xE3D4,  0xE3D5,  0xE3D6,  0xE3D7,  0xE3D8,  
      0xE3D9,  0xE3DA,  0xE3DC,  0xE3DD,  0xE3DE,  0xE3DF,  0xE3E0,  0xE3E1,  // 0x706x
      0xE3E2,  0xE3E3,  0xE3E4,  0xE3E5,  0xE3E6,  0xE3E7,  0xE3E8,  0xE3E9,  
      0xC9CF,  0,       0,       0,       0,       0,       0,       0,       // 0x707x
      0,       0,       0,       0xCFDE,  0xCFD5,  0xCFCE,  0x6DC0,  0x6DC7,  
      0xCFE1,  0x6DC1,  0x6DC4,  0x6439,  0xCFD8,  0x6DC6,  0x6435,  0,       // 0x708x
      0x6DBF,  0x70FE,  0xCFDF,  0x6DBB,  0xCFD1,  0xCFD0,  0xCFCC,  0x6DBE,  
      0x6DC5,  0xCFCD,  0x6431,  0xCFE7,  0x6DBC,  0xCFCB,  0xCFD3,  0xCFE2,  // 0x709x
      0xCFDB,  0xC9BB,  0xCFE5,  0x6DC3,  0x642E,  0xCFD9,  0x6DBD,  0xCFE6,  
      0,       0xCFDA,  0,       0x69B1,  0xD4E7,  0xD8E9,  0,       0xCFC9,  // 0x70Ax
      0x6DBA,  0x6DC8,  0,       0,       0,       0,       0,       0,       
      0xCFD2,  0xCFD6,  0xCFD7,  0xCFDC,  0xCFE3,  0xCFE4,  0xE5F9,  0xE5FA,  // 0x70Bx
      0xE5FB,  0xE5FC,  0xE5FD,  0xE5FE,  0xE6A1,  0xE6A2,  0xE6A3,  0xE6A4,  
      0xE6A5,  0xE6A6,  0xE6A7,  0xE6A8,  0xE6A9,  0xE6AA,  0xE6AB,  0xE6AC,  // 0x70Cx
      0xCFCA,  0xCFC8,  0,       0,       0,       0,       0xCFE0,  0xD4E3,  
      0x6935,  0x71A8,  0xD4E6,  0xD4DF,  0x71A4,  0x672C,  0x672A,  0xD4D9,  // 0x70Dx
      0x672E,  0x71A2,  0xD4E4,  0x71A5,  0xD4E5,  0x6729,  0x6DC9,  0x71A7,  
      0xD4DB,  0xD4D3,  0x71A6,  0xD4E2,  0xD4D7,  0xD4D5,  0xD4E0,  0x672D,  // 0x70Ex
      0x71A3,  0x71A9,  0x71AA,  0xD4D4,  0xD4DC,  0,       0xCFCF,  0xD4DA,  
      0xD8F6,  0,       0,       0,       0,       0,       0,       0,       // 0x70Fx
      0,       0x71A1,  0xD4D6,  0xD4DD,  0xD4E1,  0xE8B8,  0xE8BA,  0xE8BB,  
} ;


static const unsigned short Uni2cnsP2Table_71 [] = {
      0xE8BC,  0xE8BD,  0xE8BE,  0xE8BF,  0xE8C1,  0xE8C2,  0xE8C3,  0xE8C4,  // 0x710x
      0,       0xE8C0,  0,       0xD4D8,  0,       0x74A4,  0x6936,  0x74A5,  
      0x74A7,  0x74A8,  0xD8F0,  0x74A9,  0x693B,  0x693A,  0xD8F7,  0xD8F5,  // 0x711x
      0xD8ED,  0xDCD3,  0x74A3,  0x74A6,  0xD8EF,  0x6938,  0x6939,  0xD8EE,  
      0x6934,  0xD8F3,  0xD8EB,  0xD8F8,  0,       0,       0,       0,       // 0x712x
      0xD8EA,  0xD8EC,  0xD8F1,  0xD8F4,  0xE9E8,  0xE9EB,  0xE9EC,  0,       
      0,       0,       0,       0,       0,       0,       0xDCCF,  0xDCDA,  // 0x713x
      0x6A75,  0x76C0,  0x6A74,  0x76BF,  0x6A71,  0x6A73,  0x6A72,  0x6A70,  
      0x76C3,  0xDCD1,  0xDCDB,  0x76C2,  0x79C0,  0xDCD5,  0x76C4,  0xDCD7,  // 0x714x
      0xDCD8,  0xDCCD,  0xDCD0,  0x76C1,  0xDCD6,  0xDCD4,  0xDCD2,  0xDCD9,  
      0xEAED,  0xEAEE,  0xEAEF,  0xDCCE,  0xE9EA,  0,       0x78A3,  0x78A2,  // 0x715x
      0x78A1,  0xDFC0,  0x78A4,  0xDFC2,  0xDFC6,  0xDFC3,  0xDFC4,  0xDFC9,  
      0xDFC1,  0xDFC7,  0x79C2,  0,       0,       0,       0xEBE0,  0xEBE1,  // 0x716x
      0xEBE3,  0xDFC5,  0xDFC8,  0,       0,       0,       0x79C3,  0xE2D5,  
      0x79C1,  0xE2D3,  0xE1BE,  0xE1BD,  0xE1BC,  0,       0xECB8,  0xECB9,  // 0x717x
      0xE1BF,  0,       0x7AB5,  0x7AB6,  0xE2D9,  0xE2D7,  0xE2D6,  0,       
      0,       0xE2D8,  0,       0xE2D4,  0,       0xECD1,  0xE2C8,  0x6D7A,  // 0x718x
      0xE3E8,  0x7AF2,  0x6D5F,  0x6D7C,  0,       0xECEB,  0xECED,  0x7BC6,  
      0x6E35,  0xE4D8,  0xE4D9,  0x7CC9,  0xE5C0,  0x7BE6,  0xE5E0,  0xE5F6,  // 0x719x
      0x7CCF,  0x7CBD,  0xE5DF,  0xA8E5,  0x2B3F,  0xB449,  0xB448,  0,       
      0xB2CE,  0,       0,       0x35B6,  0x35B4,  0x3477,  0x3476,  0xC441,  // 0x71Ax
      0x3478,  0xC442,  0xC440,  0xC43F,  0xBB63,  0,       0,       0,       
      0,       0xCE3C,  0x3BF1,  0xCE3D,  0xBFA2,  0xBFA3,  0xBFA4,  0,       // 0x71Bx
      0,       0,       0x42D5,  0x42D1,  0x42D2,  0xD76B,  0xD76A,  0xD769,  
      0,       0x49CF,  0xE162,  0xE166,  0x466F,  0xE165,  0xE167,  0xE163,  // 0x71Cx
      0xE164,  0x49D0,  0xCCAB,  0xCCAC,  0,       0x466E,  0,       0,       
      0xA8A9,  0xA8A7,  0xB2DF,  0x50CE,  0xA8A6,  0xA8A8,  0,       0xD1F9,  // 0x71Dx
      0xA6A9,  0,       0,       0,       0x57EA,  0x57EB,  0x57E8,  0x57E9,  
      0x5335,  0x57E7,  0xB2E0,  0xB2DC,  0xB2DD,  0x5338,  0x5337,  0x57ED,  // 0x71Ex
      0xB2DE,  0xD7DD,  0xD7DE,  0xD7DF,  0x57EC,  0xB2DB,  0,       0,       
      0,       0x584C,  0xBBB9,  0xDCD1,  0xDCD2,  0xDCD3,  0,       0,       // 0x71Fx
      0,       0,       0,       0xC2D1,  0x64BD,  0x5D33,  0xC2D0,  0x5D31,  
} ;


static const unsigned short Uni2cnsP2Table_72 [] = {
      0xC2D2,  0x64BC,  0,       0xE0E0,  0,       0,       0xC9D6,  0xC9D5,  // 0x720x
      0x607E,  0xC9D7,  0,       0xCFE9,  0,       0x6DCA,  0xCFEA,  0,       
      0xCCA6,  0x71AC,  0xCFE8,  0x71AB,  0,       0x70CD,  0xD4EA,  0xD4E9,  // 0x721x
      0x74AA,  0,       0xDCA4,  0,       0x6E38,  0x24F5,  0xA929,  0x2822,  
      0xAE25,  0,       0,       0xA8E6,  0xA8E7,  0xA8E9,  0,       0xA8EA,  // 0x722x
      0x2B43,  0xB44B,  0x2B40,  0x2B42,  0xB44A,  0x2BC0,  0xB44D,  0xB44C,  
      0xB44E,  0,       0,       0,       0xADBD,  0xADBF,  0xADC2,  0xADC3,  // 0x723x
      0xADC4,  0xADC1,  0x2B41,  0x30B0,  0xBB68,  0x30AC,  0x30B3,  0xBB67,  
      0x30AD,  0x30B2,  0xBB66,  0x2F6C,  0x2F6A,  0x2F6E,  0x30AE,  0xBB70,  // 0x724x
      0x30A9,  0xBB6B,  0x30B1,  0x30A8,  0xBB6A,  0x30AF,  0x30B4,  0xBB6E,  
      0xBB64,  0x30AB,  0,       0,       0,       0xBB65,  0xB2CF,  0xBB6C,  // 0x725x
      0xBB6D,  0,       0,       0x30AA,  0xBB6F,  0,       0x35B7,  0x347D,  
      0xC445,  0x35B8,  0x35B9,  0x35BA,  0x35C0,  0x3522,  0xB8BD,  0x3523,  // 0x726x
      0xC44C,  0x35BC,  0x3521,  0x35BD,  0xC446,  0x35C1,  0xC449,  0x3524,  
      0x347E,  0,       0,       0xC447,  0xC44A,  0xC444,  0xC44B,  0xC44D,  // 0x727x
      0,       0,       0,       0xB8B6,  0xB8B7,  0xB8B8,  0xB8B9,  0xB8BB,  
      0xB8BC,  0xB8BE,  0xB8BF,  0xB8C0,  0,       0x35BE,  0xC44E,  0x3525,  // 0x728x
      0xC443,  0,       0,       0,       0,       0x35BF,  0x35BB,  0x3BF3,  
      0xCE40,  0xBFA8,  0x3A73,  0xCE48,  0x3CA8,  0x3BF8,  0x3BF5,  0x3BF7,  // 0x729x
      0x3BFA,  0x3CA3,  0x3BFD,  0xCE49,  0xCE3E,  0xCE43,  0x3BF6,  0x3CA7,  
      0xCE42,  0xCE4B,  0xCE4A,  0x3BFC,  0xCE3F,  0x3BF9,  0x3CA1,  0xCE4D,  // 0x72Ax
      0xCE44,  0xCE45,  0,       0xD76E,  0x3CA5,  0x3BFE,  0xD778,  0x3CA4,  
      0xCE4C,  0xCE47,  0,       0,       0,       0,       0x3CA2,  0x3BF2,  // 0x72Bx
      0xCE41,  0xBFA5,  0xBFA6,  0xBFA7,  0xBFA9,  0,       0,       0x3A77,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x72Cx
      0xD770,  0xD76F,  0x405A,  0x405C,  0xD774,  0x4054,  0x42D8,  0x42DB,  
      0x42D6,  0x4051,  0x4053,  0x42DC,  0x42DE,  0x42DA,  0x42D7,  0x405E,  // 0x72Dx
      0x4050,  0xD772,  0,       0xD773,  0xD76C,  0xD76D,  0xE168,  0xD771,  
      0xD775,  0x42D9,  0,       0,       0,       0,       0,       0xC5B2,  // 0x72Ex
      0xC5B3,  0xC5B4,  0xC5B5,  0xC5B6,  0xC5B7,  0xC5B8,  0xC5B9,  0xD776,  
      0xC9EB,  0,       0,       0xD777,  0,       0,       0,       0,       // 0x72Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_73 [] = {
      0,       0xD779,  0,       0x49D1,  0x49D6,  0x49DB,  0x49D7,  0x49DC,  // 0x730x
      0x4721,  0x49D5,  0x467D,  0xE223,  0x49DF,  0x4677,  0x49D9,  0x4674,  
      0xE176,  0xE16A,  0xE175,  0x4722,  0x49DE,  0xE16B,  0xE171,  0x49D4,  // 0x731x
      0xE17C,  0x49DD,  0x49D8,  0xE17B,  0xE221,  0x49E0,  0,       0xE174,  
      0xE17D,  0xE16D,  0x49E1,  0x49E2,  0xE172,  0,       0xE222,  0x49DA,  // 0x732x
      0xE16C,  0xE179,  0xE17A,  0xE170,  0x49D2,  0xE16E,  0,       0,       
      0,       0,       0,       0,       0x49D3,  0xE173,  0xCCAD,  0xCCAE,  // 0x733x
      0xCCB0,  0xCCB1,  0xCCB2,  0xE178,  0,       0x4058,  0,       0xE17E,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x734x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xE16F,  0x4D2D,  0xA8C3,  0x50D3,  0x4D2E,  0x4D2B,  0xA8B8,  // 0x735x
      0x4D34,  0x50DF,  0xA8B7,  0xA8AC,  0x50D1,  0xA8AB,  0xA8B5,  0xA8BF,  
      0x50D7,  0x4D32,  0x4D2A,  0xA8C0,  0xA8B4,  0x50D6,  0xA8BB,  0xA8B1,  // 0x736x
      0xA8BE,  0x57EE,  0x4D2C,  0x4D29,  0x50DC,  0x50DA,  0x50D0,  0x50D9,  
      0x50D8,  0xA8AA,  0x50DB,  0x467A,  0x50D2,  0x50DE,  0x50DD,  0x4D35,  // 0x737x
      0xA8C6,  0xA8B0,  0xA8AD,  0xA8C4,  0xA8B9,  0xA8C5,  0xA8BC,  0xA8AF,  
      0xE177,  0xA8B6,  0xA8BD,  0x50D4,  0x4D27,  0,       0,       0,       // 0x738x
      0x50CF,  0xD1FA,  0xD1FB,  0xD1FE,  0xD2A1,  0xD2A2,  0xD2A3,  0xD2A5,  
      0xD2A8,  0xD2A9,  0xD2AA,  0xD2AB,  0xA8B3,  0,       0,       0xA8C1,  // 0x739x
      0xA8BA,  0,       0xD2A7,  0,       0,       0,       0xA8B2,  0xCCAF,  
      0,       0x57F0,  0x5345,  0x57F6,  0x57F5,  0x533A,  0x57F4,  0,       // 0x73Ax
      0x57F1,  0xB2EE,  0xB2FD,  0x57F7,  0x5348,  0x57FB,  0x5349,  0x5340,  
      0x5342,  0x57FC,  0xB2ED,  0x533B,  0xB2E7,  0x533F,  0xB2FC,  0x57F9,  // 0x73Bx
      0x57EF,  0x58A1,  0x57F2,  0xBBBA,  0x57F8,  0xB2E9,  0x5346,  0x57FA,  
      0xB2F0,  0xB3A2,  0x57F3,  0xB2E4,  0x57FE,  0xB2F4,  0x5347,  0x50E0,  // 0x73Cx
      0xB2EB,  0xB2E5,  0x57FD,  0xB2F6,  0x5343,  0xB2FB,  0xB3A4,  0xB2E2,  
      0xB2F7,  0xB2E3,  0xB2F8,  0xB2EF,  0xB2FE,  0xB2F2,  0,       0,       // 0x73Dx
      0,       0,       0,       0,       0xB2E8,  0xB3A3,  0xD7E0,  0xD7E1,  
      0xD7E3,  0xD7E4,  0xD7E5,  0xD7E6,  0xB2F9,  0,       0xB2EA,  0,       // 0x73Ex
      0xB2FA,  0xB2F1,  0xB2E6,  0,       0xB2EC,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x73Fx
      0x5859,  0x5EA9,  0x5EAC,  0x5855,  0xBBD2,  0xBBC4,  0x5860,  0x585C,  
} ;


static const unsigned short Uni2cnsP2Table_74 [] = {
      0xBBC8,  0xBBC2,  0xBBD5,  0,       0x585E,  0xBBC6,  0xA8C7,  0x5850,  // 0x740x
      0x5EB1,  0xBBD0,  0xBBBF,  0x585D,  0xBBCF,  0x5EAB,  0x5EAF,  0xBBD3,  
      0x585A,  0xBBC7,  0xBBC1,  0x5EB3,  0x5853,  0xBBC0,  0x5851,  0xBBBE,  // 0x741x
      0xBBD4,  0x5EAA,  0xBBBC,  0xBBBB,  0xBBC9,  0x585B,  0x5EAD,  0x5EAE,  
      0,       0,       0,       0xBBC5,  0xDCD4,  0xDCD5,  0xDCD6,  0xDCD7,  // 0x742x
      0xDCD8,  0xDCD9,  0xDCDA,  0xDCDC,  0,       0xBBC3,  0xBBCB,  0xBBCE,  
      0,       0xBBD1,  0,       0xBBBD,  0x5EA8,  0xBBCA,  0xBBCC,  0,       // 0x743x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x5EB0,  0,       0,       0,       0x5D3D,  0x5D37,  0xC2D5,  0xC2E1,  // 0x744x
      0xC2D8,  0xC2E8,  0x64C3,  0x64C4,  0x5EB4,  0x5D38,  0x64D0,  0xC2D9,  
      0x5D36,  0x64C5,  0x5D35,  0x5D3A,  0x64BF,  0x64C2,  0x64CD,  0x5D34,  // 0x745x
      0x64CA,  0xC2D6,  0x64BE,  0,       0x64C1,  0x64CB,  0xC2D7,  0xC2DC,  
      0xC2DB,  0x64C0,  0xC2EF,  0xC2EB,  0x64CF,  0xC2EE,  0x64C9,  0x64CC,  // 0x746x
      0xC2E9,  0x64C6,  0xC2EC,  0x64C7,  0xC2E5,  0xC2E2,  0xC2DD,  0xC2E3,  
      0xC2D4,  0xC2DA,  0xC2D3,  0xC2DE,  0xC2EA,  0,       0,       0,       // 0x747x
      0xC2E6,  0xE0E2,  0xE0E4,  0xE0E5,  0xE0E6,  0xE0E8,  0xE0E9,  0xE0EA,  
      0,       0xC2E4,  0x5D3C,  0xC2E7,  0xE0E7,  0,       0xE0E1,  0,       // 0x748x
      0x64CE,  0,       0,       0,       0,       0,       0x6128,  0xC9EA,  
      0xC9D9,  0xC9E0,  0xC9EC,  0xC9DA,  0xC9E9,  0xC9ED,  0x6123,  0x69C2,  // 0x749x
      0x69C0,  0,       0xC9E2,  0xC9E7,  0xC9E5,  0x69C4,  0xC9DD,  0xC9E8,  
      0,       0xC9E4,  0xC9E6,  0xCFEB,  0xC9E1,  0xC9EE,  0xC9EF,  0xC9E3,  // 0x74Ax
      0x69C5,  0xC9DC,  0xC9DF,  0xC9D8,  0,       0,       0,       0,       
      0,       0,       0xE3EB,  0xE3EC,  0xE3ED,  0xE3EF,  0xE3F0,  0xE3F1,  // 0x74Bx
      0xE3F2,  0xE3F3,  0xE3F4,  0xE3F5,  0xC9DB,  0x6122,  0x6127,  0xC9DE,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x74Cx
      0xC2F0,  0xCFF5,  0xCFFA,  0x6DCD,  0xCFEC,  0,       0x6442,  0x6DCC,  
      0x6DD1,  0xCFF8,  0xCFF0,  0x6DD0,  0xCFF4,  0x6DD2,  0x6DD3,  0xCFF3,  // 0x74Dx
      0x6DCE,  0xCFF2,  0xCFF7,  0xCFF1,  0xCFED,  0x6DCF,  0xCFEF,  0xD4F7,  
      0,       0xCFEE,  0xCFFB,  0xE6AD,  0xE6AE,  0xE6AF,  0xE6B0,  0xE6B1,  // 0x74Ex
      0,       0,       0,       0xCFF6,  0x672F,  0,       0,       0,       
      0,       0x6734,  0xD4EB,  0xD4F0,  0x71AF,  0xD4F5,  0xD4EE,  0xD4F1,  // 0x74Fx
      0x71AE,  0xD4F3,  0x71AD,  0x71B0,  0xD4EC,  0x6733,  0xD4EF,  0x6735,  
} ;


static const unsigned short Uni2cnsP2Table_75 [] = {
      0x6731,  0xD4F2,  0x71B2,  0xD4F8,  0xCFF9,  0,       0xD4F4,  0x6732,  // 0x750x
      0xD4F9,  0,       0,       0,       0,       0,       0x71B1,  0x71B3,  
      0xD4F6,  0xE8C5,  0xE8C6,  0xE8C7,  0xE8C8,  0xE8C9,  0,       0,       // 0x751x
      0xD4ED,  0,       0,       0,       0,       0x74AE,  0x693C,  0x74AC,  
      0x74AB,  0xD9A3,  0xD8FC,  0x74AD,  0x74B1,  0x74B0,  0xD8FA,  0x74B3,  // 0x752x
      0x74B5,  0,       0x74B2,  0xD8F9,  0x693D,  0,       0xD9A6,  0xD9A8,  
      0xD9A7,  0xD8FE,  0xD9A1,  0x74B4,  0x74B6,  0xD9A4,  0xD9A9,  0x74AF,  // 0x753x
      0,       0,       0xD8FD,  0,       0,       0xD8FB,  0,       0,       
      0,       0xE9ED,  0xE9EE,  0x76C6,  0x6A76,  0x6A77,  0xDCDD,  0x76C7,  // 0x754x
      0x6A79,  0xDCDF,  0xDCDC,  0x76C8,  0xDCE2,  0x76C5,  0xDFCA,  0xDCE0,  
      0x6A7A,  0xDCE1,  0x76CA,  0,       0xD9A2,  0x76C9,  0xEAF0,  0xEAF1,  // 0x755x
      0xEAF2,  0,       0,       0x78AC,  0xDFCB,  0x6B7E,  0x78AB,  0x78A9,  
      0xDFCC,  0x78A6,  0x6C22,  0xDFCD,  0x78AA,  0x78A8,  0x6C24,  0x78AD,  // 0x756x
      0x78A7,  0,       0,       0,       0,       0,       0x79C4,  0x6C7E,  
      0x79C8,  0x79CA,  0x6C21,  0xE1C0,  0x79C6,  0xE1C4,  0xE1C3,  0xE1C5,  // 0x757x
      0x79C7,  0x79C9,  0xE1C1,  0,       0x79C5,  0xE2DD,  0xE2DB,  0xE2DE,  
      0xE2DC,  0,       0xE2DF,  0,       0xE3EE,  0xE3EC,  0x7AF3,  0xE3EB,  // 0x758x
      0xE3EF,  0,       0xE2DA,  0xE3E9,  0xE3F1,  0xE3EA,  0xE3F0,  0xE3ED,  
      0,       0xE4DC,  0x6E3A,  0xE4DD,  0x7BC7,  0x7BC8,  0xE4DA,  0xE4DB,  // 0x759x
      0x7BE7,  0xE5C1,  0xE5C2,  0x7BE8,  0x6E50,  0xE5E2,  0xE5E1,  0xEDB1,  
      0,       0,       0,       0,       0xE6AB,  0,       0,       0x27E5,  // 0x75Ax
      0xAE27,  0xAE26,  0x2B44,  0xBB72,  0x30B5,  0xBB75,  0,       0xBB74,  
      0,       0,       0xB8C1,  0xCE4E,  0xCE50,  0x42DF,  0xD77C,  0xD77A,  // 0x75Bx
      0xD77D,  0xD77B,  0x49E5,  0x49E3,  0x49E4,  0xE226,  0xE224,  0,       
      0xA8C8,  0x50E1,  0xA8C9,  0xA8CA,  0xE225,  0,       0x58A3,  0x58A4,  // 0x75Cx
      0x58A2,  0xB3A5,  0xB3A6,  0x5EB7,  0x5EB6,  0xDCDD,  0x5D3E,  0x5D3F,  
      0xC2F1,  0xC2F3,  0x5D40,  0,       0xC2F2,  0x69C6,  0x6DD4,  0xCFFC,  // 0x75Dx
      0xD4FA,  0xD9AB,  0xD9AA,  0xDFCE,  0xE5E3,  0x2823,  0xAE28,  0x2824,  
      0,       0xB44F,  0xB450,  0x2BC1,  0,       0xADC5,  0x30B6,  0xBB77,  // 0x75Ex
      0xBB76,  0x30B7,  0xC44F,  0x3CA9,  0xCE53,  0xCE52,  0xBFAA,  0xBFAB,  
      0,       0xCE51,  0xD823,  0xD821,  0x405F,  0xD822,  0xD77E,  0xC5BA,  // 0x75Fx
      0x4724,  0x50E2,  0xE227,  0xE228,  0,       0,       0,       0x5861,  
} ;


static const unsigned short Uni2cnsP2Table_76 [] = {
      0xBBD6,  0xDCDE,  0x5D41,  0xC2F4,  0xC9F0,  0xD4FB,  0xDCE4,  0,       // 0x760x
      0x27E6,  0xAE29,  0xAE2A,  0xAE2B,  0,       0x2BC3,  0xB451,  0x2B45,  
      0x2B47,  0x2BC5,  0xB453,  0x2BC4,  0,       0,       0xA8EB,  0,       // 0x761x
      0,       0xB452,  0x2BC2,  0,       0x2BC6,  0xBB7D,  0x30BC,  0x2F71,  
      0xBC21,  0xBC25,  0x30BF,  0xBC26,  0xBC27,  0x2F70,  0xBB79,  0x30C0,  // 0x762x
      0xBB7B,  0x30B8,  0xBC22,  0xBB7C,  0xBC23,  0xBB7E,  0x30BB,  0xBB7A,  
      0xBB78,  0,       0,       0x30BA,  0xB2D0,  0xBC24,  0xBC28,  0xBC29,  // 0x763x
      0,       0,       0xADC8,  0xADC9,  0xB2D2,  0x3528,  0x3CB2,  0,       
      0x352B,  0x3A7C,  0x35C6,  0x3529,  0xC458,  0x35C7,  0x35CA,  0x35C4,  // 0x764x
      0x35C5,  0x35C3,  0xC459,  0xC45A,  0x35C2,  0xC453,  0xC455,  0xC454,  
      0xC451,  0xC450,  0xC457,  0,       0,       0,       0,       0,       // 0x765x
      0xC452,  0xADC6,  0xB8C5,  0x35C8,  0xC456,  0x35C9,  0x3CB1,  0xCE5B,  
      0xCE59,  0x3CAE,  0xCE57,  0x3CAF,  0x3CB3,  0x3A7E,  0,       0xCE58,  // 0x766x
      0xCE54,  0x3A7D,  0xCE56,  0x3CB0,  0x3CAD,  0x3CAB,  0x42E4,  0x3CAA,  
      0,       0,       0xB8C4,  0xBFAE,  0,       0xCE55,  0,       0xCE5A,  // 0x767x
      0,       0xCE5C,  0,       0,       0,       0,       0x3CAC,  0xB8C3,  
      0x42EA,  0x42E2,  0x42E6,  0x4065,  0x42EB,  0x42E3,  0x42E7,  0x4063,  // 0x768x
      0x42E5,  0x42E9,  0xD82F,  0x4064,  0xD82A,  0xD828,  0xD830,  0x42E8,  
      0x42E0,  0xD824,  0xD827,  0,       0,       0xD82D,  0xBFAC,  0xBFAD,  // 0x769x
      0xBFAF,  0xBFB0,  0xC5BB,  0xD826,  0xD831,  0xD825,  0xD829,  0,       
      0,       0x42E1,  0,       0xC5BE,  0x4730,  0x472C,  0xE22D,  0xE233,  // 0x76Ax
      0x4729,  0x49E6,  0x49E9,  0x4728,  0x49E8,  0x3CB4,  0xE234,  0x49EA,  
      0xE22B,  0xE229,  0xE22A,  0xE232,  0xE231,  0x49E7,  0xE22F,  0x49EB,  // 0x76Bx
      0xE230,  0xE22C,  0x4733,  0,       0xE235,  0xE22E,  0xCCB4,  0xCCB6,  
      0xCCB7,  0,       0,       0x472F,  0,       0,       0,       0,       // 0x76Cx
      0,       0,       0,       0,       0,       0xC5BC,  0xC5BF,  0x50E6,  
      0xA8D4,  0x4D41,  0x50E9,  0xA8D7,  0x4732,  0xA8D6,  0x50E5,  0x4D38,  // 0x76Dx
      0xA8D5,  0xB3A8,  0x50E7,  0xA8DA,  0xA8CB,  0x4D45,  0x4D3B,  0x4D3D,  
      0xA8D3,  0x4D44,  0x4D43,  0x50E3,  0xA8D8,  0xA8D2,  0xA8CC,  0x50E4,  // 0x76Ex
      0xA8CF,  0x50E8,  0xA8D1,  0xA8D0,  0xA8CD,  0,       0,       0,       
      0xCCB5,  0xD2AD,  0xA8CE,  0xA8D9,  0,       0,       0,       0,       // 0x76Fx
      0x58AC,  0x58AB,  0xB3AB,  0x58A7,  0x58AA,  0xB3A7,  0x5351,  0xB3A9,  
} ;


static const unsigned short Uni2cnsP2Table_77 [] = {
      0x5354,  0xBBE2,  0x58A9,  0x58A8,  0xB3AA,  0x534E,  0xB3AC,  0xB3AF,  // 0x770x
      0x534D,  0,       0x58A5,  0xB3B0,  0,       0x58A6,  0,       0,       
      0,       0xB3AE,  0xD2AC,  0,       0,       0xB3AD,  0,       0,       // 0x771x
      0,       0,       0,       0,       0,       0x5EBE,  0x5EBF,  0xBBD7,  
      0x5EBB,  0xBBDD,  0xBBE4,  0x5866,  0x5EB8,  0x5EB9,  0x5EBD,  0x5EBC,  // 0x772x
      0,       0xBBDF,  0,       0xBBDB,  0xBBE3,  0xC2FB,  0xBBDC,  0xA8DB,  
      0xBBDE,  0xBBE0,  0x5EC0,  0,       0,       0,       0,       0xBBD8,  // 0x773x
      0xBBDA,  0,       0,       0,       0,       0x5EBA,  0xD7E7,  0xD7E8,  
      0xD7E9,  0xD7EA,  0xC2F5,  0x5D45,  0xC2FC,  0xC2FE,  0x64DB,  0x64D7,  // 0x774x
      0xC2FD,  0x5D4B,  0x64D4,  0x64D5,  0x64DF,  0x5D4D,  0,       0x5D42,  
      0xC2FA,  0x64D3,  0x5D47,  0x5D4C,  0x64DD,  0xC2F9,  0xC2F7,  0x64D1,  // 0x775x
      0x5D43,  0x5EC2,  0x64D2,  0xC2F8,  0,       0,       0,       0,       
      0,       0,       0xC3A3,  0xC2F6,  0,       0,       0,       0,       // 0x776x
      0,       0,       0x64D9,  0x64DA,  0x5EC1,  0x64DC,  0x64DE,  0x64D8,  
      0xDCE0,  0xC9F6,  0x69C9,  0x69CA,  0x6129,  0xC9FB,  0xC9FC,  0x69C7,  // 0x777x
      0x69C8,  0xC9F2,  0xC9F3,  0xC9F5,  0xC9F9,  0xC9FA,  0xC9F4,  0xC9F8,  
      0x612B,  0xC9F7,  0xC3A1,  0,       0,       0,       0xE0EB,  0xE0EC,  // 0x778x
      0xE3F6,  0,       0,       0,       0xCFFD,  0x6DD8,  0xD0A6,  0x6DDB,  
      0x71B4,  0,       0x6DD5,  0x6445,  0xD0A3,  0x6DD6,  0xD0A2,  0xD4FC,  // 0x779x
      0,       0xCFFE,  0,       0x6DD9,  0xC9F1,  0x6DDA,  0x6DDC,  0xD0A4,  
      0,       0xE6B4,  0xD0A1,  0,       0,       0,       0x6DDD,  0xD5A2,  // 0x77Ax
      0xD5A4,  0x71B6,  0x6736,  0xD5A6,  0xD5A5,  0x71B5,  0xD4FE,  0xD5A1,  
      0x6737,  0xD5A3,  0xD9B1,  0xD4FD,  0,       0xE6B3,  0x6941,  0xD9AE,  // 0x77Bx
      0x6940,  0x693F,  0x74B7,  0xD9AC,  0xD9AD,  0xD9B0,  0,       0,       
      0,       0,       0xD9AF,  0x78AE,  0,       0,       0,       0xE9EF,  // 0x77Cx
      0xDFD1,  0xDFD0,  0xDFCF,  0,       0x79CB,  0xE1C8,  0xE1C7,  0xE1C6,  
      0xE2E1,  0x7AB7,  0xE2E2,  0,       0xE2E0,  0xE4DF,  0xE3F3,  0xE3F2,  // 0x77Dx
      0xE4DE,  0x7BFE,  0xE5E4,  0xE6AC,  0,       0,       0x7CCB,  0xE6CD,  
      0,       0x24F6,  0,       0xAE2C,  0,       0,       0x2B48,  0x30C1,  // 0x77Ex
      0x2F74,  0xBC2A,  0xC45B,  0xB8C6,  0,       0xBFB1,  0xBFB2,  0xD832,  
      0,       0x4734,  0xE236,  0xE237,  0xE238,  0,       0,       0xCCB8,  // 0x77Fx
      0xCCB9,  0xA8DC,  0xCCBA,  0xD2B0,  0xB3B1,  0xB3B2,  0xD2AF,  0xBBE5,  
} ;


static const unsigned short Uni2cnsP2Table_78 [] = {
      0xE0ED,  0xE0EE,  0x69CB,  0xD0A7,  0xD5A7,  0,       0x27E7,  0xAE2D,  // 0x780x
      0,       0x2F77,  0,       0x30C2,  0xB2D3,  0,       0x35CD,  0x35CE,  
      0xC45C,  0xC45D,  0x35D0,  0x35CB,  0,       0xB8C7,  0xB8C9,  0xB8CB,  // 0x781x
      0x3532,  0x3536,  0x35CC,  0x35CF,  0xCE5F,  0x3B25,  0xCE62,  0xCE61,  
      0x3CB6,  0xCE5E,  0x3B24,  0xCE5D,  0,       0,       0,       0,       // 0x782x
      0xD836,  0x42ED,  0x42EF,  0x42EE,  0,       0xD833,  0xD837,  0,       
      0x42F0,  0xC5C0,  0xC5C1,  0xC5C2,  0,       0xD835,  0,       0,       // 0x783x
      0,       0,       0,       0xE239,  0x49F1,  0x49EE,  0x49F2,  0x4737,  
      0xE23A,  0,       0,       0xCCBB,  0xCCBC,  0x49EF,  0xE23B,  0,       // 0x784x
      0x49F0,  0,       0,       0x4D49,  0xA8DF,  0x50EC,  0x4D4B,  0x50EB,  
      0xA8E3,  0x50ED,  0xD834,  0xA8E2,  0,       0x50EA,  0x50EE,  0xD2B1,  // 0x785x
      0xA8E0,  0,       0,       0xA8DE,  0,       0xA8DD,  0,       0,       
      0xA8E1,  0x58B0,  0x58AF,  0x58AE,  0x5357,  0xB3B4,  0x58B4,  0xBBE7,  // 0x786x
      0x5358,  0x535E,  0x535D,  0x58B1,  0x58B5,  0xB3B3,  0x58AD,  0x58B3,  
      0,       0xD7EB,  0xD7EC,  0xD7ED,  0,       0,       0,       0xBBE6,  // 0x787x
      0x64E0,  0x5EC5,  0x5EC4,  0xBBEA,  0,       0xBBE9,  0xBBEB,  0xBBE8,  
      0xDCE1,  0xDCE2,  0x64E2,  0x5D51,  0x5D4F,  0xC3A4,  0x64E1,  0,       // 0x788x
      0xE0EF,  0xE0F0,  0xE0F1,  0,       0,       0xC3A5,  0xC9FD,  0xC9FE,  
      0,       0,       0x6DDF,  0xD0A9,  0xD0A8,  0xE6B5,  0x6DDE,  0,       // 0x789x
      0xE8CB,  0xE8CC,  0xD5A8,  0,       0x6943,  0x74B9,  0x6942,  0,       
      0xE9F0,  0xE9F1,  0x78AF,  0xDFD3,  0xEBE4,  0xDFD2,  0x79CD,  0x79CC,  // 0x78Ax
      0xE1C9,  0,       0,       0x6D21,  0,       0x7AF4,  0x6E3B,  0x7CC4,  
      0,       0xE6D4,  0xAE2E,  0xAE2F,  0xB454,  0x2BC8,  0,       0x2F78,  // 0x78Bx
      0xBC2C,  0x2F79,  0xBC2B,  0xC467,  0x353B,  0x35D3,  0x35D2,  0xC45F,  
      0xC463,  0x3537,  0xC464,  0x35D1,  0xC460,  0xB8CD,  0xB8CE,  0xB8CF,  // 0x78Cx
      0x353C,  0xC466,  0,       0,       0,       0xC45E,  0xC462,  0xC465,  
      0xC461,  0x3CB7,  0x3B26,  0xCE64,  0xCE67,  0x3CB8,  0xCE63,  0xCE66,  // 0x78Dx
      0xCE69,  0xCE65,  0x3B27,  0x3B28,  0xCE68,  0,       0xBFB3,  0,       
      0,       0x42F3,  0x42F1,  0x42F2,  0,       0xD838,  0,       0,       // 0x78Ex
      0xE23E,  0x49F5,  0x4739,  0xE240,  0x49F3,  0x49F4,  0xE23D,  0xE241,  
      0xE23C,  0xE23F,  0,       0,       0xA8E6,  0x50F5,  0xA8E7,  0x50F4,  // 0x78Fx
      0x50F0,  0x50EF,  0x4D50,  0x4D52,  0x4D4D,  0xA8E9,  0x4D54,  0,       
} ;


static const unsigned short Uni2cnsP2Table_79 [] = {
      0,       0,       0,       0x50F2,  0xA8E8,  0xA8EA,  0x50F1,  0xA8E4,  // 0x790x
      0xA8E5,  0x50F3,  0,       0xB3B8,  0xB3B7,  0x535F,  0x58B6,  0x5363,  
      0x58B9,  0x58BB,  0x5360,  0xB3B6,  0xB3B5,  0x58B7,  0x58B8,  0x58BA,  // 0x791x
      0xB3B9,  0,       0,       0x5EC6,  0xBBED,  0xBBF3,  0xBBEC,  0x5ECA,  
      0x5EC9,  0xBBEE,  0xB3BA,  0x5EC8,  0,       0,       0xBBEF,  0xBBF0,  // 0x792x
      0,       0xBBF1,  0x586C,  0xBBF4,  0xBBF2,  0,       0x5EC7,  0xC3A7,  
      0,       0xC3A8,  0x5D52,  0,       0,       0,       0xC3A6,  0xC3A9,  // 0x793x
      0,       0,       0x6135,  0x69CC,  0x6132,  0x6133,  0xCAA1,  0xCAA2,  
      0xCAA3,  0xCAA4,  0x6136,  0,       0xD0AA,  0,       0,       0,       // 0x794x
      0x71B7,  0,       0xD5A9,  0,       0x74BA,  0x6944,  0,       0,       
      0,       0xDCE5,  0,       0x78B0,  0,       0xE2E3,  0x6D60,  0xE4E0,  // 0x795x
      0xE4E1,  0x7BE9,  0xE5C3,  0x23A7,  0x23A8,  0xAE30,  0,       0,       
      0,       0xBC33,  0x3021,  0x2F7B,  0x2F7A,  0x3022,  0x30C3,  0,       // 0x796x
      0xBC30,  0xBC31,  0xBC2F,  0xBC32,  0,       0xBC2E,  0x3540,  0xC46A,  
      0xC473,  0x353E,  0,       0xC46F,  0x35DC,  0x35D9,  0,       0xC471,  // 0x797x
      0x3542,  0x35D4,  0x3546,  0xC479,  0x35D5,  0xC477,  0xC46B,  0xC478,  
      0x35D8,  0xC474,  0xC475,  0,       0,       0,       0xC46E,  0xC47A,  // 0x798x
      0xB8D0,  0xB8D1,  0xB8D3,  0xB8D4,  0xB8D5,  0xB8D6,  0,       0xC472,  
      0,       0,       0xC469,  0,       0,       0,       0,       0xC468,  // 0x799x
      0,       0xC476,  0xC46C,  0x35DA,  0xCE74,  0x3B32,  0x3B2E,  0x3CBB,  
      0xCE6F,  0xCE6E,  0xCE71,  0xCE6A,  0x3B2D,  0xCE78,  0x3B38,  0x3B39,  // 0x79Ax
      0x3CBC,  0xCE6D,  0xCE76,  0xCE70,  0xCE77,  0x3B37,  0x3CB9,  0x3CBA,  
      0xBFB4,  0xBFB5,  0xBFB6,  0xBFB7,  0xBFB8,  0xBFB9,  0xBFBA,  0xBFBC,  // 0x79Bx
      0,       0,       0xCE72,  0xCE75,  0,       0,       0xCE6C,  0,       
      0,       0xCE79,  0xCE73,  0,       0x42F5,  0x4068,  0x406A,  0,       // 0x79Cx
      0xD846,  0x42F6,  0x3CBD,  0x42F9,  0x4071,  0x4070,  0xD840,  0xD84B,  
      0xD83D,  0xD849,  0x4069,  0x406B,  0x42FC,  0x42F4,  0x4073,  0xD843,  // 0x79Dx
      0xD83C,  0xD847,  0xD842,  0xD83F,  0x4072,  0x42FA,  0xD848,  0x42F8,  
      0x42F7,  0xD844,  0,       0,       0xC5C3,  0xC5C5,  0xC5C6,  0xD84A,  // 0x79Ex
      0x42FB,  0,       0xD839,  0xD83B,  0,       0,       0,       0,       
      0x406F,  0xD83A,  0xD845,  0xD83E,  0xE24E,  0x473F,  0x49FA,  0x473B,  // 0x79Fx
      0x49F8,  0x49FB,  0x473E,  0x4748,  0xE242,  0xE24C,  0x4741,  0xE253,  
} ;


static const unsigned short Uni2cnsP2Table_7A [] = {
      0x4744,  0xE24F,  0x4747,  0xE246,  0x49F9,  0xE251,  0xE245,  0x4749,  // 0x7A0x
      0xE250,  0xE244,  0x49F6,  0x49F7,  0,       0,       0,       0xCCBD,  
      0xCCBE,  0xCCBF,  0xCCC0,  0xCCC2,  0xCCC3,  0xCCC4,  0xCCC5,  0,       // 0x7A1x
      0,       0xE248,  0x474B,  0xE24A,  0x42FD,  0xE24B,  0xE24D,  0,       
      0xE243,  0,       0,       0xE252,  0xE249,  0,       0xA9A1,  0x51AA,  // 0x7A2x
      0xA8EB,  0x50FA,  0x51A2,  0xA8F1,  0xA8F4,  0xA9A2,  0xA8FC,  0xA8F0,  
      0x51A7,  0x4D57,  0x51A9,  0x51A3,  0x50FB,  0x50FE,  0xA8F8,  0x51A4,  // 0x7A3x
      0x4D5D,  0x51A6,  0x4D62,  0xA9A4,  0xA8F7,  0xA8EF,  0x50F8,  0x50FC,  
      0xA8FD,  0,       0xA8ED,  0x51A5,  0x50FD,  0x50F7,  0x50F9,  0x50F6,  // 0x7A4x
      0,       0xD2B2,  0xD2B3,  0xD2B4,  0xD2B5,  0xD2B7,  0xD2B9,  0xD2BA,  
      0xA8F6,  0xA8F5,  0,       0,       0,       0,       0xA8EC,  0,       // 0x7A5x
      0xA8F2,  0xD2B8,  0x51A1,  0xA8FB,  0xA8EE,  0x51A8,  0xA9A3,  0xA8FE,  
      0xA8FA,  0xA8F3,  0xB3C6,  0x58C0,  0x5371,  0xB3D2,  0x5368,  0x5365,  // 0x7A6x
      0x536C,  0xB3C9,  0xB3D1,  0xB3C3,  0x58BD,  0xB3C2,  0x58BC,  0xB3BC,  
      0,       0x5370,  0x5367,  0xB3C5,  0x536F,  0xB3BD,  0x536E,  0xB3C7,  // 0x7A7x
      0xB3CE,  0x5366,  0xB3D0,  0xB3BE,  0x5369,  0xB3BB,  0xB3D3,  0xB3C0,  
      0xB3BF,  0xB3C8,  0xB3CA,  0x58BF,  0xB3CC,  0x536D,  0xB3C4,  0x58BE,  // 0x7A8x
      0xD7EE,  0xD7EF,  0xD7F0,  0xD7F1,  0xD7F2,  0xD7F3,  0xD7F4,  0xD7F5,  
      0xD7F6,  0xD7F7,  0xD7F8,  0,       0xB3D4,  0,       0xB3C1,  0xB3CB,  // 0x7A9x
      0x586E,  0x5ED2,  0x5ED1,  0xBBFD,  0x586F,  0x5ED4,  0x5871,  0xBBF9,  
      0x586D,  0x5ECD,  0x5ED3,  0x5ECE,  0xBBF6,  0xBCA5,  0x5872,  0xC3AA,  // 0x7AAx
      0x5ECF,  0xBCA1,  0xBBF7,  0x5ED6,  0xBCA7,  0xBBFC,  0xBBF8,  0x5ED0,  
      0x5874,  0xBBFB,  0xBBFE,  0xBCA2,  0xBCA3,  0x5873,  0x5ECB,  0xBCA6,  // 0x7ABx
      0,       0x5ECC,  0xBCA4,  0,       0,       0,       0,       0xBBF5,  
      0xDCE3,  0xDCE4,  0xDCE5,  0xDCE6,  0xDCE7,  0xDCE8,  0xDCE9,  0xDCEA,  // 0x7ACx
      0xDCEB,  0,       0,       0xBCA8,  0,       0,       0,       0xBCA9,  
      0xBBFA,  0,       0x5D5E,  0x5D56,  0xC3B7,  0x5D58,  0xC3B5,  0x64E8,  // 0x7ADx
      0xC3BA,  0xC3AB,  0x5D60,  0x64E6,  0x58C1,  0x5D59,  0x64E7,  0xC3B8,  
      0xC3B2,  0x64E4,  0x5D53,  0xC3BB,  0x5D55,  0x64E5,  0x5D5D,  0xC3B9,  // 0x7AEx
      0xC3AF,  0xC3B3,  0xCAAA,  0xC3B0,  0x5D5C,  0xC3B4,  0xC3B1,  0xC3BC,  
      0xC3AC,  0,       0xC3AD,  0,       0,       0xE0F2,  0xE0F5,  0,       // 0x7AFx
      0xC3B6,  0,       0x5D5F,  0,       0,       0xC3AE,  0x69CD,  0x69CF,  
} ;


static const unsigned short Uni2cnsP2Table_7B [] = {
      0xCAAF,  0,       0x613E,  0xCAAC,  0xCAAE,  0x6143,  0x6139,  0x69D0,  // 0x7B0x
      0x6141,  0xCAB4,  0x6142,  0x69CE,  0x613F,  0xCAA6,  0xCAA9,  0xC3BD,  
      0xCAA8,  0xCAB5,  0xD0B3,  0xCAB3,  0,       0x613C,  0x6DE0,  0xCAA7,  // 0x7B1x
      0,       0xE3F8,  0xE3F9,  0xE3FA,  0x6144,  0xCAAB,  0,       0xD0B5,  
      0xCAB0,  0xCAB1,  0xCAAD,  0xCAB2,  0x6138,  0xE0F4,  0,       0x644A,  // 0x7B2x
      0x644B,  0x6DE2,  0x6DE1,  0xD0AD,  0x6DE3,  0xD0AF,  0x6449,  0xD0AB,  
      0x69D3,  0xD0B2,  0xD0AE,  0xD0B4,  0xD0B6,  0xD0AC,  0xD0B0,  0,       // 0x7B3x
      0,       0,       0,       0xE6B6,  0xE6B7,  0xE6B8,  0xE6B9,  0xD0B8,  
      0xD0B7,  0xD0B9,  0xD5AA,  0x6742,  0xD5B4,  0xD5AD,  0xD5B3,  0,       // 0x7B4x
      0x6738,  0xD5AE,  0x71BD,  0xD5AC,  0xD5AF,  0x673C,  0x71BA,  0x71B9,  
      0x6743,  0xD9BB,  0xD9B5,  0x673A,  0x71BC,  0x71BB,  0xD5B1,  0,       // 0x7B5x
      0xD5AB,  0xD5B0,  0x71B8,  0xD5B5,  0x74BB,  0x74BD,  0x74C0,  0x76CB,  
      0x6947,  0xD9B9,  0x694A,  0x74BF,  0x6949,  0x74BE,  0,       0xD9B7,  // 0x7B6x
      0xD9C0,  0xD5B6,  0x74BC,  0xD9B6,  0xD9BA,  0xD9BF,  0x6946,  0xD9BE,  
      0xE9F2,  0xE9F3,  0xE9F4,  0,       0xD9BC,  0,       0,       0xD9BD,  // 0x7B7x
      0x6A7D,  0x6A7E,  0xDCE6,  0x76CE,  0x76CD,  0x78B1,  0xDCE8,  0xDCE9,  
      0xDCEA,  0xEAF4,  0xEAF5,  0xDCE7,  0xD9C2,  0xDFD7,  0xDFD8,  0xDFD5,  // 0x7B8x
      0x6C27,  0xDFD6,  0xDFDA,  0xEBE5,  0xEBE6,  0,       0xDFD4,  0xDFD9,  
      0xDFDB,  0x6D23,  0xE1CB,  0x79CE,  0xE1CC,  0xECBA,  0xECBB,  0,       // 0x7B9x
      0xE1CA,  0x7AF5,  0xE2E5,  0xE2E4,  0,       0x7AB9,  0x6D7E,  0xE3F4,  
      0,       0,       0xE4E2,  0x6E3C,  0,       0xE4C4,  0,       0,       // 0x7BAx
      0xE5C4,  0xE6D0,  0,       0x24F7,  0x3024,  0x30C4,  0x30C5,  0x3548,  
      0x3549,  0x3547,  0xC47B,  0x3B3A,  0,       0x42FE,  0x43A1,  0xD84C,  // 0x7BBx
      0x474D,  0,       0x51AC,  0x4D63,  0x51AD,  0x51AB,  0,       0,       
      0x58C2,  0xB3D6,  0xB3D5,  0,       0,       0,       0xBCAA,  0,       // 0x7BCx
      0,       0x5ED7,  0xC3BE,  0xCAB6,  0xCAB9,  0x69D4,  0xCAB7,  0x69D5,  
      0xCAB8,  0,       0,       0xD0BA,  0xCABA,  0x71BE,  0,       0,       // 0x7BDx
      0x7AF6,  0xE5F7,  0xB455,  0xBC35,  0xBC34,  0,       0,       0xB8D7,  
      0x3B3B,  0x3CBE,  0xCE7B,  0xBFBD,  0,       0x43A2,  0x4075,  0xDB5F,  // 0x7BEx
      0,       0x4750,  0xE254,  0x4751,  0,       0xA9A8,  0xA9A7,  0xA9A5,  
      0x51AF,  0x51AE,  0,       0xA9A6,  0xD2BB,  0,       0,       0x58C3,  // 0x7BFx
      0x5374,  0xB3D7,  0x58C4,  0xACD6,  0x5EDA,  0xBCAD,  0x5ED8,  0xBCAC,  
} ;


static const unsigned short Uni2cnsP2Table_7C [] = {
      0x5ED9,  0xBCAB,  0,       0x64E9,  0x5D63,  0xC3C0,  0x5D62,  0x5EDB,  // 0x7C0x
      0,       0xCABC,  0x69D7,  0xCABD,  0xC3C1,  0xC3C2,  0,       0,       
      0x69D6,  0x6DE6,  0x6DE5,  0x6DE7,  0xE6BA,  0x6DE4,  0xE3FB,  0,       // 0x7C1x
      0x71BF,  0x74C1,  0,       0,       0,       0xEAF6,  0xEAF7,  0,       
      0x78B2,  0x79CF,  0,       0x7AF7,  0,       0xE5C5,  0,       0xA554,  // 0x7C2x
      0x23A9,  0x2BCA,  0x30C8,  0x30C7,  0xBC37,  0xBC36,  0xC47E,  0xC47C,  
      0x35E1,  0,       0xC521,  0,       0xC47D,  0x3B3C,  0xCE7C,  0x3B3D,  // 0x7C3x
      0x3CC0,  0x3CBF,  0xCE7E,  0x3CC1,  0xCF23,  0xCE7D,  0xB2D5,  0x4077,  
      0x43A5,  0x4076,  0xD84E,  0xD84F,  0x43A7,  0x43A3,  0x43A6,  0xD84D,  // 0x7C4x
      0xCF22,  0x43A4,  0x43A8,  0,       0,       0xE255,  0xE256,  0x4753,  
      0x4752,  0xE259,  0x49FD,  0x49FC,  0xE25B,  0xE25A,  0xE257,  0xE258,  // 0x7C5x
      0x51B2,  0x4D66,  0xA9A9,  0xA9AB,  0x51B1,  0x51B3,  0xA9AD,  0xA9AC,  
      0x49FE,  0x51B0,  0xA9AA,  0x4AA1,  0xA9AE,  0xD2BC,  0,       0,       // 0x7C6x
      0x58C7,  0x58C8,  0x58C6,  0xB3D9,  0x5376,  0xB3DA,  0xB3DC,  0xB3DB,  
      0x58C5,  0xB3D8,  0x5EDD,  0x5EDE,  0x5EDF,  0x5EDC,  0xBCB0,  0xBCAE,  // 0x7C7x
      0xBCAF,  0,       0,       0x5D65,  0x64EA,  0,       0x64EB,  0xC3C3,  
      0xC3C4,  0xC3C5,  0x6147,  0x69D8,  0x58C9,  0xCABE,  0x6149,  0x6DEB,  // 0x7C8x
      0x6DE8,  0xD0BB,  0x6DEA,  0x6DE9,  0x6746,  0x71C0,  0xD5B7,  0xD5B8,  
      0xD9C3,  0xDCEC,  0xD9C4,  0xD9C5,  0xDCED,  0xDCEE,  0,       0x74C2,  // 0x7C9x
      0xDFDC,  0,       0xE1CD,  0xDFDD,  0x79D0,  0x7ABA,  0xE5C6,  0xE6C3,  
      0xA8EC,  0x2BCB,  0xBC38,  0xB2D6,  0x35E4,  0x35E3,  0x354F,  0x35E2,  // 0x7CAx
      0x354E,  0xC525,  0xC523,  0,       0xCF25,  0x3CC2,  0x3CC6,  0x3CC4,  
      0x3CC8,  0x3CC5,  0xCF28,  0xCF26,  0x3CC7,  0x3CC3,  0xCF27,  0xCF24,  // 0x7CBx
      0,       0xBFBE,  0,       0,       0,       0,       0x407C,  0x407D,  
      0x407A,  0xD852,  0x43AB,  0xD851,  0x43AA,  0x4079,  0x407B,  0xD853,  // 0x7CCx
      0xC5C7,  0x43A9,  0xE261,  0xE25C,  0x4AA5,  0x4AA3,  0x4AA2,  0xE25F,  
      0x4AA4,  0xE25E,  0xE260,  0xCCC8,  0xE25D,  0,       0xE262,  0xCCC9,  // 0x7CDx
      0,       0x51B5,  0x51B4,  0x4D69,  0x51B7,  0x51B6,  0x51B8,  0x4D6A,  
      0xA9AF,  0xA9B0,  0x4D6B,  0,       0,       0xA9B1,  0xB3E4,  0x58CB,  // 0x7CEx
      0xB3DE,  0xB3E0,  0xB3E1,  0x5378,  0x58CA,  0xB3E2,  0x58CC,  0xB3DF,  
      0,       0xD7FA,  0xB3DD,  0xB3E3,  0,       0x5879,  0x5EE3,  0xBCB1,  // 0x7CFx
      0x5EE2,  0x5878,  0x5EE0,  0x5EE4,  0x5EE1,  0,       0xDCEC,  0,       
} ;


static const unsigned short Uni2cnsP2Table_7D [] = {
      0,       0xC3C6,  0x5D67,  0xC3C7,  0x5D66,  0x64EC,  0xCABF,  0x64ED,  // 0x7D0x
      0,       0,       0,       0,       0x69DB,  0xCAC0,  0x69DA,  0xCAC3,  
      0xD0BD,  0,       0,       0,       0xCAC2,  0x69D9,  0x6DED,  0x6DEC,  // 0x7D1x
      0xD0BC,  0x71C2,  0x6DEE,  0,       0,       0x71C1,  0xD5B9,  0xD9C6,  
      0xDCF0,  0xDCEF,  0,       0x7AF8,  0x2BCC,  0x2B4A,  0xB456,  0,       // 0x7D2x
      0xADCA,  0,       0x3026,  0xBC39,  0x30C9,  0x30CA,  0,       0,       
      0xB2D7,  0xB2D8,  0xBC3A,  0xC52A,  0,       0xC52C,  0xC527,  0xC528,  // 0x7D3x
      0xC526,  0xC52B,  0x35E5,  0xB8D9,  0xB8DA,  0xB8DB,  0xB8DC,  0xB8DD,  
      0xB8DE,  0xB8DF,  0xB8E0,  0,       0xC52D,  0x3553,  0,       0xC529,  // 0x7D4x
      0x3552,  0xCF2B,  0x3B40,  0x3CC9,  0x3CCB,  0xCF2E,  0xCF2C,  0xCF2D,  
      0xD857,  0x3CCA,  0,       0,       0,       0xBFBF,  0xBFC1,  0xBFC2,  // 0x7D5x
      0xBFC3,  0xBFC4,  0xBFC5,  0,       0xCF2F,  0xCF2A,  0,       0,       
      0x3CCD,  0,       0,       0x4122,  0xD854,  0xD859,  0xD856,  0x43B0,  // 0x7D6x
      0x43AC,  0xD85E,  0xD855,  0x43AF,  0x43B1,  0x43B2,  0xD858,  0xD860,  
      0xD862,  0x43B3,  0xD85F,  0,       0xC5C8,  0xC5C9,  0xC5CA,  0xC5CB,  // 0x7D7x
      0xC5CC,  0xC5CD,  0xC5CE,  0,       0,       0xD861,  0xBFC0,  0xD85B,  
      0,       0,       0x43AE,  0xC6B4,  0,       0xE265,  0x4755,  0x4AA6,  // 0x7D8x
      0xE264,  0xE266,  0xE26C,  0xE263,  0xE269,  0x4AA7,  0x4757,  0,       
      0xCCCD,  0xCCCE,  0xCCCF,  0xCCD1,  0,       0,       0,       0xCCD0,  // 0x7D9x
      0xCCCC,  0xE26B,  0xD85D,  0xA9B3,  0xA9B5,  0x4AA8,  0x4D6F,  0xA9B4,  
      0x51BA,  0x4D70,  0x51BB,  0xA9B9,  0xA9B8,  0xA9B2,  0xD2BD,  0xD2BE,  // 0x7DAx
      0xD2BF,  0,       0xA9B7,  0,       0,       0,       0,       0,       
      0xCCCB,  0xB3EA,  0x58CE,  0xB3E7,  0xB3E6,  0x58CF,  0xB3EB,  0xB3EE,  // 0x7DBx
      0x537C,  0xB3E8,  0x58CD,  0xE268,  0xD4B2,  0,       0xD7FB,  0xD7FC,  
      0xD7FD,  0xD7FE,  0xD8A1,  0xD8A2,  0xB3ED,  0,       0,       0xB3EC,  // 0x7DCx
      0,       0xB3E5,  0xB3E9,  0x58D0,  0xBCB2,  0x5EE5,  0x5BAD,  0x5EE7,  
      0x58D2,  0x5EE6,  0x587B,  0xBCB8,  0xBCB4,  0xBCB6,  0xBCB7,  0xBCB5,  // 0x7DDx
      0,       0xDCEE,  0xDCF0,  0,       0xDCEF,  0,       0xC3CB,  0x64F3,  
      0xC3CE,  0x64EF,  0xC3C9,  0xC3CA,  0xC3D1,  0x64F1,  0x64EE,  0x64F2,  // 0x7DEx
      0xC3CD,  0xC3CC,  0,       0xE0F6,  0xE0F7,  0xE0F8,  0xE0F9,  0xE0FB,  
      0xE0FC,  0,       0xC3C8,  0,       0,       0xC3D0,  0,       0,       // 0x7DFx
      0,       0,       0,       0x64F0,  0xCAC7,  0xCACB,  0x69DD,  0x64F4,  
} ;


static const unsigned short Uni2cnsP2Table_7E [] = {
      0xCACA,  0xC3CF,  0x69DC,  0x614B,  0xCAC8,  0x69DE,  0xCACD,  0xCACC,  // 0x7E0x
      0x69E0,  0xCAC4,  0xCAC9,  0xCAC6,  0xE3FC,  0xE3FD,  0xE3FE,  0xE4A1,  
      0,       0xCACE,  0,       0,       0xCAC5,  0x69DF,  0x6451,  0x6DF0,  // 0x7E1x
      0x6450,  0x6DEF,  0xD0BE,  0,       0,       0,       0xD0C0,  0,       
      0xE6BB,  0xE6BC,  0xE6BD,  0xE6BE,  0xE6BF,  0xD0BF,  0x71C3,  0x6747,  // 0x7E2x
      0x71C4,  0,       0,       0x71C5,  0,       0xE8CE,  0xE8CF,  0xD5BB,  
      0,       0xD9C7,  0x74C5,  0x74C4,  0xE9F6,  0xE9F7,  0xE9F8,  0xD9CA,  // 0x7E3x
      0xD9C8,  0xD9C9,  0,       0,       0xE8CD,  0xDCF1,  0x6B22,  0x74C3,  
      0xDCF2,  0,       0,       0xEAF8,  0,       0,       0xDCF3,  0xDFDE,  // 0x7E4x
      0xDFE0,  0xDFDF,  0,       0,       0,       0,       0xE2E6,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x7E5x
      0xAE31,  0xB457,  0xB458,  0x35E6,  0xB8E1,  0xCF30,  0x3B44,  0,       
      0xD863,  0xC5CF,  0,       0x4AAA,  0xCCD2,  0,       0,       0xA9BA,  // 0x7E6x
      0,       0,       0,       0,       0x58D4,  0x58D3,  0xD8A3,  0xB3EF,  
      0,       0,       0x5EE9,  0x5EEA,  0x5EE8,  0xDCF1,  0x64F5,  0xC3D3,  // 0x7E7x
      0xCAD0,  0xCACF,  0,       0,       0,       0x71C6,  0,       0,       
      0,       0,       0,       0,       0xDCF4,  0,       0xAE32,  0xAE33,  // 0x7E8x
      0xB459,  0xADCB,  0xADCD,  0xADCE,  0xADCF,  0xADD0,  0x2B4B,  0x30CD,  
      0xBC3E,  0,       0xBC3D,  0x30CE,  0xBC3C,  0,       0x3029,  0xB2D9,  // 0x7E9x
      0xB2DA,  0xB2DB,  0xB2DC,  0xB2DD,  0,       0x35ED,  0xC530,  0x35E7,  
      0x3557,  0x35EA,  0x35EF,  0x35EE,  0x3558,  0xC52E,  0xC52F,  0x35EB,  // 0x7EAx
      0x35E8,  0xB8E3,  0xB8E4,  0xB8E5,  0xB8E6,  0xB8E8,  0xB8E9,  0xB8E2,  
      0,       0,       0x35EC,  0x35E9,  0,       0xB8E7,  0x3CD1,  0x3CD0,  // 0x7EBx
      0x3CD4,  0x3CCF,  0xCF34,  0xCF31,  0x43B9,  0x3CD3,  0x3CCE,  0xCF33,  
      0x3B46,  0x3CD5,  0xD864,  0xCF35,  0xBFC7,  0xBFC8,  0xBFC9,  0xBFCA,  // 0x7ECx
      0xBFCB,  0xBFCC,  0xBFCF,  0xBFD0,  0xBFD1,  0,       0xCF32,  0xBFCE,  
      0,       0xD866,  0x43B6,  0x4123,  0xD868,  0x4125,  0x43BB,  0x43B5,  // 0x7EDx
      0x43BD,  0x43B7,  0x4124,  0xD86A,  0xD869,  0x43BA,  0,       0xC5D0,  
      0xC5D1,  0xC5D2,  0xC5D3,  0xC5D4,  0xC5D5,  0xC5D6,  0xC5D7,  0xD865,  // 0x7EEx
      0,       0,       0,       0xD867,  0xE26D,  0,       0xBFCD,  0xE26E,  
      0x475C,  0x4AAC,  0x4AB0,  0xE272,  0x4AAB,  0x4AAE,  0x4AB1,  0,       // 0x7EFx
      0xE271,  0xE26F,  0x4AB3,  0x475D,  0x4AAF,  0xE276,  0,       0x4AAD,  
} ;


static const unsigned short Uni2cnsP2Table_7F [] = {
      0xE273,  0xCCD3,  0xCCD4,  0xCCD5,  0xCCD6,  0xCCD7,  0xCCD8,  0xCCD9,  // 0x7F0x
      0,       0xE270,  0,       0,       0,       0,       0x51C2,  0x51BC,  
      0x4D72,  0x51BF,  0x51BE,  0x51BD,  0x51C0,  0xA9BF,  0x51C6,  0x51C3,  // 0x7F1x
      0xA9C1,  0x51C1,  0xA9BC,  0xA9C0,  0xA9BE,  0xE274,  0xA9C2,  0xB3F2,  
      0x51C5,  0x51C4,  0xD2C0,  0xD2C1,  0,       0xA9C3,  0xA9BB,  0xD8AD,  // 0x7F2x
      0x5423,  0x5424,  0x5428,  0xB3F4,  0x58D9,  0x5421,  0x5422,  0x5427,  
      0xB3F5,  0x5425,  0xB3F1,  0xB3F0,  0x58D8,  0x58DA,  0xB3F6,  0xD8A4,  // 0x7F3x
      0xD8A6,  0xD8A7,  0xD8A8,  0xD8A9,  0xD8AA,  0xD8AB,  0xD8AC,  0xD8AE,  
      0,       0xB3F8,  0xB3F7,  0,       0x58DB,  0x58D6,  0x58D7,  0,       // 0x7F4x
      0,       0x5EEF,  0x5EF1,  0x5922,  0x5EF0,  0x5924,  0x5921,  0x5EF2,  
      0x587E,  0x5EEC,  0x5923,  0x5EEE,  0x5EEB,  0xBCBA,  0x5EF3,  0xD8A5,  // 0x7F5x
      0xDCF2,  0xDCF3,  0xDCF4,  0xDCF5,  0xDCF6,  0xBCB9,  0x64F9,  0x64FC,  
      0x5D6B,  0xC3D7,  0xC3D6,  0x64F6,  0x64FA,  0x64F8,  0x64F7,  0x64FD,  // 0x7F6x
      0x64FE,  0xC3DB,  0xC3DA,  0x64FB,  0xE0FD,  0xC3D8,  0,       0xC3D5,  
      0,       0,       0,       0xC3D9,  0xC3D4,  0,       0x58DD,  0x69E2,  // 0x7F7x
      0x69E6,  0x69E8,  0x614E,  0x614C,  0x69E3,  0x69E7,  0x69E5,  0x69E1,  
      0xCAD2,  0x69E9,  0x69E4,  0xE4A3,  0xE4A4,  0xE4A5,  0,       0,       // 0x7F8x
      0xCAD1,  0,       0,       0xCAD3,  0,       0x6452,  0x6454,  0x6458,  
      0x6457,  0x6DF1,  0xD0C1,  0xD0C3,  0x6DF2,  0xD0C2,  0xE6C0,  0xE6C1,  // 0x7F9x
      0xE6C2,  0x6749,  0x71C8,  0x71C9,  0xD5BF,  0xD5BD,  0xD5BC,  0xD5BE,  
      0x71C7,  0x74C6,  0x74C9,  0x694D,  0x74C8,  0x74C7,  0xE9F9,  0,       // 0x7FAx
      0x76CF,  0x76D0,  0xEAF9,  0xD9CB,  0xDCF5,  0xDCF6,  0x78B3,  0x78B4,  
      0x78B5,  0x6D26,  0,       0,       0xE1CE,  0x7AF9,  0x7BC9,  0,       // 0x7FBx
      0xAE35,  0xAE34,  0xB45B,  0x2BCD,  0xADD1,  0,       0,       0,       
      0xB45A,  0xBC41,  0x302B,  0xBC42,  0xBC40,  0x30D0,  0x30CF,  0,       // 0x7FCx
      0,       0xBC3F,  0,       0,       0,       0xBC43,  0,       0,       
      0,       0,       0x355F,  0xC533,  0x355A,  0x35F3,  0xC537,  0x35F7,  // 0x7FDx
      0xC53A,  0x35F1,  0x35F5,  0xC53C,  0xC53D,  0x35F4,  0xC53B,  0xC532,  
      0xC536,  0,       0xB8EA,  0xC531,  0xC535,  0,       0xC539,  0,       // 0x7FEx
      0,       0,       0,       0,       0,       0,       0x35F6,  0x35F0,  
      0,       0xC534,  0x3CE0,  0x3CD7,  0x3CD8,  0x3CDB,  0xCF3B,  0x3CD6,  // 0x7FFx
      0xCF38,  0x3B4E,  0x3CDD,  0x3CD9,  0x3CE1,  0x3CDA,  0xCF39,  0xD879,  
} ;


static const unsigned short Uni2cnsP2Table_80 [] = {
      0x3CE2,  0,       0,       0xBFD4,  0,       0,       0xCF37,  0,       // 0x800x
      0,       0xBFD2,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0xCF3A,  0x3CDE,  0x43C1,  0x43BF,  0xD871,  // 0x801x
      0x43C0,  0x43C2,  0xD874,  0xD870,  0x43C7,  0x43C5,  0xD86E,  0xD86D,  
      0x43BE,  0xD86F,  0xD872,  0xD876,  0x43CA,  0xD86C,  0xD877,  0x43C3,  // 0x802x
      0x43CC,  0x43C8,  0xD873,  0x43C9,  0x43C6,  0xD875,  0x4AB5,  0,       
      0,       0xC5D9,  0,       0,       0,       0,       0xD878,  0xD86B,  // 0x803x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xE322,  0x4AC3,  0x4760,  0x4AB7,  0x4ABF,  0x4AB6,  0x51CE,  0x4ABB,  // 0x804x
      0xE277,  0xE27B,  0x4AC2,  0x4ABC,  0x4AB9,  0x4AC0,  0x4AC1,  0x4ABD,  
      0x43C4,  0x4AB8,  0x4AC4,  0xE27E,  0x4AC6,  0xE279,  0,       0,       // 0x805x
      0,       0x4AC7,  0xCCDA,  0xCCDB,  0xE278,  0,       0xE27A,  0,       
      0xE27D,  0,       0xE321,  0xE27C,  0,       0,       0,       0,       // 0x806x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x4ABA,  0,       0xA9C6,  0x4D7A,  0x51CC,  // 0x807x
      0x51C7,  0x51CA,  0x51CF,  0xA9C5,  0xA9C9,  0x4D7C,  0xA9CD,  0x4D7B,  
      0x51CB,  0x51CD,  0x4E24,  0x51D1,  0x51D2,  0x4763,  0xA9CF,  0x51C9,  // 0x808x
      0xA9CB,  0,       0,       0xD2C2,  0xD2C3,  0xD2C4,  0xD2C5,  0xA9C8,  
      0,       0xA9CC,  0,       0xA9C7,  0,       0,       0,       0,       // 0x809x
      0,       0,       0,       0xA9CA,  0x51D0,  0x51D4,  0x51D5,  0x4AC5,  
      0xB4A1,  0x58E0,  0x4AC8,  0x58E9,  0x542A,  0xB3FA,  0x58E3,  0xB3FE,  // 0x80Ax
      0xB4A3,  0xB3FC,  0x58DF,  0xB3FB,  0xB4A5,  0x51D3,  0xB4A6,  0x58E7,  
      0x58E8,  0x58DE,  0x58E1,  0xB3FD,  0x58E5,  0x58E4,  0xB4A4,  0x542B,  // 0x80Bx
      0x58E6,  0,       0,       0,       0,       0,       0,       0x542C,  
      0xD8B1,  0xD8B2,  0,       0,       0,       0,       0,       0,       // 0x80Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0xB4A2,  0x5EFA,  0x5EFD,  0x5EF5,  0xBCC0,  0x5EF6,  // 0x80Dx
      0x5EFC,  0x5EF8,  0x5929,  0xBCBE,  0xC3E7,  0xBCC3,  0x5EFE,  0x592E,  
      0xBCBB,  0xBCC2,  0xBCC4,  0x5EF9,  0x5927,  0xBCC1,  0xB4A7,  0xBCBF,  // 0x80Ex
      0x592F,  0,       0,       0,       0xDCF7,  0,       0xBCBD,  0,       
      0,       0,       0,       0xDCF9,  0,       0,       0,       0,       // 0x80Fx
      0,       0,       0,       0,       0,       0,       0,       0x5EF7,  
} ;


static const unsigned short Uni2cnsP2Table_81 [] = {
      0x5EF4,  0,       0,       0xC3E2,  0,       0x5D70,  0xC3E6,  0x5D6F,  // 0x810x
      0x65A1,  0x65A2,  0x65AD,  0x65A6,  0x5D71,  0x65AC,  0x65A8,  0xC3DF,  
      0x69F0,  0xC3E5,  0xC3DC,  0x65AE,  0xC3DE,  0x65A4,  0xC3E1,  0x65A3,  // 0x811x
      0x65A9,  0x5F33,  0x5D76,  0x65A5,  0,       0,       0,       0,       
      0,       0xE0FE,  0xE1A1,  0xE1A2,  0xE1A3,  0xE1A4,  0xE1A5,  0xC3EB,  // 0x812x
      0x65A7,  0xC3E0,  0xC3E9,  0xC3E8,  0xC3EA,  0xC3DD,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x813x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x65AB,  0xC3E3,  0,       // 0x814x
      0xBCBC,  0,       0x65AF,  0x69EA,  0xCAE5,  0,       0x69EF,  0x69F1,  
      0xCAE8,  0x69F4,  0xCADB,  0x65AA,  0x69EE,  0xCAD8,  0x69ED,  0x69F2,  // 0x815x
      0x6155,  0xCAD4,  0x5D73,  0xCAD9,  0xC3E4,  0xCADE,  0x69F3,  0xCADA,  
      0xCAE6,  0xCAD5,  0xCADC,  0x69EB,  0x69EC,  0xCAE1,  0xCAE2,  0xCAE3,  // 0x816x
      0xCADF,  0x69F6,  0x69F5,  0,       0,       0,       0,       0,       
      0,       0xCAE0,  0xCADD,  0,       0xCAE7,  0xCAD6,  0xCAE4,  0,       // 0x817x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x6153,  0x6459,  0x6DFD,  0x6DF7,  0xD0C4,  0x6DFB,  0x6DF6,  0x6DF9,  // 0x818x
      0xD0C8,  0xD0C6,  0x645C,  0x6DF3,  0x645D,  0xD0C7,  0x6DF8,  0x6DF5,  
      0x6DF4,  0xD0C9,  0,       0,       0xE6C3,  0xE6C4,  0xE6C5,  0xE6C6,  // 0x819x
      0xE6C7,  0,       0xD0C5,  0xD0CA,  0xD0CB,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x6DFC,  0x6DFE,  // 0x81Ax
      0x6DFA,  0,       0x674E,  0xD5C2,  0x674F,  0x71CB,  0xD5C1,  0xD5C4,  
      0x674D,  0x674B,  0x71CC,  0xD5C3,  0xD5C0,  0x71CA,  0,       0,       // 0x81Bx
      0,       0,       0,       0xE8D1,  0xE8D2,  0,       0,       0,       
      0,       0x74CA,  0xD5C5,  0xD9CC,  0x74CD,  0x74CF,  0x74CE,  0x74CC,  // 0x81Cx
      0xD9CD,  0,       0x74D1,  0xD9CE,  0xE9FA,  0,       0,       0xD9CF,  
      0,       0,       0,       0,       0x74D0,  0,       0x76D4,  0x76D2,  // 0x81Dx
      0x76D5,  0xDCF9,  0xDCF8,  0,       0,       0x76D3,  0x76D1,  0,       
      0,       0,       0,       0,       0x6C2B,  0xDFE1,  0x78B7,  0x78B6,  // 0x81Ex
      0x6C2A,  0x78B8,  0xDFE2,  0xE1CF,  0,       0xDFE3,  0xE1D2,  0x6D28,  
      0xE1D4,  0xE2E7,  0xE1D3,  0xE1D1,  0xE1D0,  0,       0,       0,       // 0x81Fx
      0,       0,       0xEBE7,  0x7ABC,  0x7ABB,  0x7ABD,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_82 [] = {
      0,       0,       0,       0xE3F6,  0x7BCA,  0xE4E3,  0,       0,       // 0x820x
      0x7BEA,  0,       0xEDA8,  0xE5E5,  0,       0xEDB3,  0,       0xA339,  
      0xA33A,  0xA555,  0,       0x30D2,  0xBC44,  0x30D1,  0,       0,       // 0x821x
      0x35FA,  0x35F9,  0x35F8,  0xC53E,  0xC541,  0xC540,  0xC542,  0xC53F,  
      0xC543,  0xC544,  0x3560,  0,       0xB8EB,  0,       0,       0,       // 0x822x
      0,       0x3CE5,  0xCF3F,  0x3CE4,  0xCF41,  0xCF3E,  0x3CE6,  0xBFD5,  
      0xBFD6,  0xBFD7,  0xBFD8,  0,       0xCF3D,  0xCF40,  0,       0,       // 0x823x
      0xD87D,  0x43CD,  0xD87A,  0xD87E,  0xD921,  0xC5DA,  0xC5DB,  0xC5DC,  
      0xD87B,  0,       0xD87C,  0xD922,  0,       0,       0,       0,       // 0x824x
      0x4ACA,  0xE323,  0xE324,  0x4AC9,  0xE325,  0xE326,  0xCCDC,  0xCCDD,  
      0xCCDE,  0,       0,       0,       0xA9D1,  0x51D6,  0,       0x4E25,  // 0x825x
      0xD2C6,  0xD2C8,  0,       0xA9D0,  0,       0,       0,       0,       
      0,       0,       0x58EA,  0x5431,  0x58EB,  0xB4A8,  0xBCC6,  0xD8B4,  // 0x826x
      0xD8B6,  0,       0,       0,       0,       0,       0xBCC8,  0xBCC7,  
      0xBCC5,  0x5FA1,  0xDCFA,  0xDCFB,  0,       0,       0,       0,       // 0x827x
      0,       0x65B0,  0xC3EC,  0xE1A6,  0xE1A7,  0,       0,       0xCAEC,  
      0xCAED,  0xCAEA,  0,       0xE4A6,  0xE4A7,  0,       0xCAEB,  0,       // 0x828x
      0,       0,       0xCAE9,  0,       0,       0x645E,  0xD0CD,  0xE6C8,  
      0xE6C9,  0,       0xD0CE,  0xD5C6,  0x71CD,  0xD5C7,  0xD5C8,  0xD5C9,  // 0x829x
      0xD9D0,  0xE9FC,  0,       0x76D6,  0,       0x79D1,  0,       0,       
      0xB45C,  0x2BCE,  0xB45E,  0xADD2,  0xADD4,  0,       0,       0xBC45,  // 0x82Ax
      0,       0x30D4,  0xBC47,  0xB2DF,  0xB2E0,  0,       0,       0xBC46,  
      0,       0x30D3,  0xB2DE,  0x35FB,  0xC54E,  0xC54D,  0xC546,  0x3564,  // 0x82Bx
      0x36A2,  0x36A1,  0xC54A,  0x35FD,  0xC547,  0xC54C,  0xC54B,  0x35FC,  
      0x35FE,  0,       0,       0,       0xB8ED,  0,       0xC548,  0xC549,  // 0x82Cx
      0,       0,       0,       0,       0x3565,  0,       0xCF46,  0xCF47,  
      0x3CF0,  0x3CEE,  0xCF45,  0xCF44,  0xCF42,  0x36A3,  0x3CED,  0x3CE8,  // 0x82Dx
      0x3CEB,  0x3CEA,  0xCF43,  0x3CE9,  0x3CF1,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x3CEC,  0x3CEF,  // 0x82Ex
      0xD923,  0xD928,  0x43D3,  0xD926,  0xD929,  0x43D1,  0x412B,  0x43D2,  
      0x43CF,  0xD927,  0x43CE,  0,       0xC5DD,  0xC5DE,  0xC5DF,  0,       // 0x82Fx
      0,       0xD925,  0,       0,       0x412D,  0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_83 [] = {
      0,       0x43D4,  0xE32D,  0xE32F,  0x4AD0,  0x4768,  0xE328,  0xE32B,  // 0x830x
      0x4ACD,  0xE32C,  0xE327,  0xE330,  0,       0x4ACB,  0x4ACE,  0xE331,  
      0,       0,       0,       0,       0,       0,       0xE32E,  0,       // 0x831x
      0,       0xCCDF,  0xCCE0,  0xCCE1,  0xCCE3,  0x4ACF,  0,       0x4ACC,  
      0xA9D9,  0xE32A,  0x51E0,  0xA9D7,  0xA9DE,  0xA9E2,  0xA9D6,  0x51D9,  // 0x832x
      0xA9DA,  0xA9D5,  0xA9DC,  0x51D8,  0x51DB,  0x51DE,  0x4E2C,  0xE329,  
      0xA9D8,  0xA9DD,  0xA9DB,  0x51DD,  0x51DF,  0xA9D2,  0x51D7,  0xA9D4,  // 0x833x
      0xA9E3,  0,       0,       0xD2C9,  0xD2CA,  0xD2CB,  0xD2CC,  0,       
      0xA9D3,  0xA9DF,  0xA9E0,  0xA9E1,  0,       0x51DC,  0x51DA,  0xB4A9,  // 0x834x
      0x58F3,  0xB4AF,  0x58F4,  0xB4AD,  0x58F0,  0xB4AB,  0xB4B4,  0x58EE,  
      0x58F1,  0x58ED,  0xB4B5,  0xB4B0,  0xB4B6,  0,       0x58EC,  0xB4B3,  // 0x835x
      0xD8B7,  0xD8B9,  0xD8BA,  0,       0,       0,       0,       0xB4AC,  
      0xB4AE,  0,       0,       0xB4AA,  0,       0xD8B8,  0,       0x5435,  // 0x836x
      0x58EF,  0xBCCA,  0xBCD2,  0x5FA5,  0xBCCD,  0xBCCC,  0xBCCB,  0xBCD3,  
      0x5933,  0xBCD0,  0x5934,  0xBCD1,  0x5FA2,  0,       0x5FAB,  0x5936,  // 0x837x
      0x5FA8,  0x5FA7,  0,       0xBCD4,  0,       0,       0,       0x5FA4,  
      0x5FAA,  0xBCC9,  0xDCFC,  0xDCFD,  0xBCCE,  0xBCCF,  0,       0x5FA6,  // 0x838x
      0x5FA3,  0x5FA9,  0x5D79,  0xC3F0,  0x5E21,  0x65B2,  0,       0,       
      0x65B4,  0xE1A8,  0xE1A9,  0xE1AA,  0,       0xC3EF,  0xC3F2,  0,       // 0x839x
      0xC3F1,  0xC3EE,  0,       0,       0xC3ED,  0,       0,       0,       
      0,       0x65B1,  0x65B3,  0,       0x69F8,  0xCAEE,  0xCAF1,  0xCAEF,  // 0x83Ax
      0xCAF0,  0x69FA,  0x615A,  0x615B,  0x69F9,  0x69F7,  0x69FB,  0xCAF2,  
      0xE4A8,  0xCAF4,  0x6462,  0x6EA5,  0x6EA3,  0xD0D3,  0x6EA4,  0x6EA2,  // 0x83Bx
      0xD0D1,  0x6EA1,  0,       0,       0xE6CA,  0,       0xD0D2,  0,       
      0,       0xD0D0,  0,       0,       0,       0xD0CF,  0x6EA6,  0xD0D4,  // 0x83Cx
      0x6753,  0x71CE,  0x6754,  0xD5CC,  0,       0,       0xD5CB,  0xD5CA,  
      0,       0xD9D6,  0x6950,  0xD9D2,  0xD9D1,  0x6951,  0xD9D7,  0,       // 0x83Dx
      0xD9D3,  0xD9D4,  0,       0,       0,       0xD9D5,  0xDCFE,  0xDDA1,  
      0x76D7,  0xDCFB,  0xDCFA,  0xDCFC,  0xDCFD,  0,       0x76D9,  0,       // 0x83Ex
      0x76D8,  0x78BC,  0x78BB,  0x78BA,  0xDFE7,  0,       0,       0xDFE5,  
      0xDFE4,  0x78B9,  0xDFE6,  0x79D3,  0x79D2,  0x7ABE,  0x7ABF,  0,       // 0x83Fx
      0xE2E8,  0x7AFA,  0xE4E4,  0,       0,       0xE2E9,  0xE3F7,  0,       
} ;


static const unsigned short Uni2cnsP2Table_84 [] = {
      0,       0x7BEB,  0xE5E6,  0,       0,       0,       0,       0,       // 0x840x
      0,       0,       0,       0xA92B,  0xAE36,  0xBC48,  0,       0xC54F,  
      0x36A5,  0x36A4,  0,       0,       0x412E,  0xD92A,  0,       0xC5E1,  // 0x841x
      0x4AD1,  0xCCE5,  0xCCE6,  0x4AD2,  0xA9E4,  0xA9E5,  0xA9E6,  0x51E2,  
      0xB4B7,  0x58F5,  0xB4B8,  0,       0xD8BB,  0,       0,       0,       // 0x842x
      0x5FAD,  0x5FAC,  0xDCFE,  0xDDA1,  0xDDA2,  0xDDA3,  0,       0x5FAE,  
      0x65B7,  0x65B6,  0xC3F3,  0,       0,       0xCAF5,  0x615C,  0,       // 0x843x
      0,       0xCAF6,  0,       0xE6CB,  0xD0D5,  0xE8D4,  0xD9D8,  0,       
      0xDFE8,  0xE5C7,  0xE5E7,  0xA92C,  0xAE37,  0xD92D,  0xD92C,  0xD92B,  // 0x844x
      0xD2CD,  0xB3A1,  0x615D,  0xD5CD,  0,       0xA559,  0,       0xA558,  
      0xA557,  0x247E,  0xA92D,  0x2524,  0xBC49,  0,       0,       0,       // 0x845x
      0xA92E,  0xA5B3,  0xA5B4,  0xBC4A,  0,       0,       0xA92F,  0,       
      0x24F8,  0xBC4B,  0xC550,  0x27EA,  0x27EB,  0x27F0,  0xAE38,  0xAE3D,  // 0x846x
      0x27EF,  0x2825,  0x27F1,  0x27ED,  0x2828,  0xAE3B,  0,       0xA8ED,  
      0xA8EF,  0xA8F0,  0xA8F3,  0xA8F4,  0xA8F5,  0xAE3A,  0,       0xAE3F,  // 0x847x
      0,       0,       0,       0,       0x27EE,  0x27E8,  0xAE3C,  0x27EC,  
      0xAE39,  0xAE3E,  0,       0x2BCF,  0x2BD6,  0x2BD2,  0xB45F,  0x2BD1,  // 0x848x
      0xB462,  0x2BD5,  0x2BD3,  0x2B4F,  0x2B51,  0x2BD0,  0xB464,  0xB463,  
      0,       0,       0,       0xADD5,  0xADD6,  0xADD7,  0xADD8,  0xADD9,  // 0x849x
      0,       0,       0x2B52,  0xB465,  0,       0xB461,  0,       0,       
      0xCA47,  0,       0x2BD7,  0x2BD4,  0xBC54,  0xBC58,  0x30DB,  0xBC53,  // 0x84Ax
      0x30D6,  0x30DA,  0x3031,  0x30D7,  0x30D9,  0xBC52,  0xBC4C,  0xBC56,  
      0x3032,  0,       0xBC57,  0xBC4D,  0,       0,       0,       0,       // 0x84Bx
      0,       0,       0,       0,       0x43D5,  0xBC55,  0x30D8,  0xBC50,  
      0xBC4E,  0x30DC,  0x36A7,  0x36A6,  0xBC4F,  0xC55B,  0,       0x36AC,  // 0x84Cx
      0x356A,  0xC55C,  0x36AB,  0xBC51,  0,       0x36A9,  0xC557,  0,       
      0,       0,       0xC55A,  0xB8F0,  0xB8F1,  0xB8F2,  0xC556,  0xC554,  // 0x84Dx
      0xC555,  0xC552,  0,       0xC55D,  0,       0xC558,  0,       0,       
      0,       0,       0,       0,       0xC553,  0x36AA,  0x3567,  0xC559,  // 0x84Ex
      0x36AD,  0x36A8,  0xB8EF,  0xC551,  0x3CF6,  0x3CF2,  0x3CF8,  0x3CF7,  
      0x3B56,  0xCF53,  0x3B5A,  0x3B58,  0x3CF9,  0xCF52,  0xA9E7,  0xCF4D,  // 0x84Fx
      0xCF4C,  0xCF50,  0xCF4F,  0x3B5B,  0,       0xCF49,  0xCF4B,  0xBFE2,  
} ;


static const unsigned short Uni2cnsP2Table_85 [] = {
      0xCF51,  0,       0,       0xCF54,  0,       0xCF55,  0,       0,       // 0x850x
      0,       0,       0,       0xCF4A,  0,       0,       0xBFD9,  0xBFDA,  
      0xBFDB,  0xBFDC,  0xBFDD,  0xBFDF,  0xBFE0,  0xBFE1,  0x3CF5,  0xCF4E,  // 0x851x
      0,       0x3CF4,  0x3CF3,  0x3B59,  0xCF56,  0xD940,  0xD934,  0xD93D,  
      0,       0xD930,  0x4131,  0x4130,  0xD92E,  0,       0x43D9,  0xD931,  // 0x852x
      0xD941,  0xD93B,  0xD93F,  0xD937,  0xD935,  0xD943,  0xD942,  0x3CFA,  
      0x4132,  0xD933,  0xD93E,  0,       0,       0,       0,       0,       // 0x853x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xC5E2,  0xC5E3,  0xC5E4,  0xC5E5,  0xC5E6,  0xC5E7,  0xC5E8,  // 0x854x
      0xC5E9,  0xC5EA,  0xC5EB,  0xC5EC,  0,       0xD932,  0,       0xD936,  
      0xD93C,  0xD939,  0,       0xD938,  0xD93A,  0,       0xD92F,  0,       // 0x855x
      0,       0,       0x43D8,  0x43D7,  0x43D6,  0xE335,  0xE334,  0xE337,  
      0xE332,  0xE33A,  0x4AD4,  0xE336,  0xE338,  0xE33C,  0x4AD3,  0x4AD6,  // 0x856x
      0xE333,  0xE33B,  0xBCD5,  0,       0,       0,       0xCCE9,  0xCCEA,  
      0xCCEC,  0xCCED,  0xCCEE,  0xCCEF,  0xCCF0,  0xCCF1,  0xCCF2,  0,       // 0x857x
      0xE339,  0,       0,       0,       0xBCD6,  0xBCD7,  0,       0,       
      0,       0xBCD8,  0,       0x4AD5,  0,       0,       0xA9EE,  0xA9EC,  // 0x858x
      0xA9F2,  0xA9E9,  0xA9EB,  0x4E2F,  0x51E4,  0x4E30,  0x51E8,  0x51E5,  
      0x4E34,  0,       0,       0xA9F0,  0xD2CE,  0xD2CF,  0xD2D0,  0xD2D1,  // 0x859x
      0xD2D2,  0x51ED,  0,       0,       0,       0xA9EA,  0xA9EF,  0xA9F4,  
      0xA9F5,  0xA9F1,  0,       0xA9F3,  0xC3F4,  0xA9E8,  0,       0,       // 0x85Ax
      0,       0,       0xC3F5,  0xA9ED,  0x51E9,  0x51E7,  0x51EC,  0x51E6,  
      0x51EA,  0x51EB,  0,       0x51E3,  0xB4C6,  0x58FC,  0x58FB,  0x58F9,  // 0x85Bx
      0xB4C1,  0x58F7,  0xB4C5,  0xB4BE,  0xB4C7,  0,       0x5436,  0xB4C2,  
      0xB4C4,  0xB4B9,  0xB4CA,  0xCAF7,  0xB4BC,  0,       0,       0,       // 0x85Cx
      0,       0,       0,       0xB4C0,  0xB4CC,  0xD8BC,  0xD8BD,  0xD8BE,  
      0xB4BD,  0,       0xD8BF,  0xACDA,  0xB4C8,  0xB4BB,  0,       0xB4BA,  // 0x85Dx
      0xB4C3,  0xB4CB,  0,       0,       0,       0,       0x58F8,  0x58FD,  
      0,       0x58FA,  0xB4BF,  0x58F6,  0,       0x5FAF,  0x593A,  0xBCE0,  // 0x85Ex
      0x5FB3,  0xBCDD,  0x5FB4,  0xBCDB,  0xD0D7,  0xB4C9,  0xBCE2,  0xBCDE,  
      0x5FB2,  0x5FB5,  0,       0,       0,       0,       0xDDA4,  0xDDA6,  // 0x85Fx
      0xDDA7,  0xDDA8,  0xBCD9,  0xBCDC,  0xBCDF,  0xBCE3,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_86 [] = {
      0xDDA5,  0x5FB6,  0x5FB7,  0x5FB1,  0x5FB0,  0xBCDA,  0,       0x65BD,  // 0x860x
      0xC3FC,  0x5E22,  0xC3FA,  0,       0x65BA,  0xC3F8,  0xE1AB,  0xE1AC,  
      0xE1AD,  0xC4A1,  0,       0xC3FE,  0,       0,       0,       0,       // 0x861x
      0,       0x65B9,  0xC3FD,  0xC3F6,  0xC3F9,  0x65BC,  0x65BB,  0x65B8,  
      0xC3FB,  0xCBA1,  0xCBA2,  0xCAFE,  0,       0,       0xE4AA,  0xE4AB,  // 0x862x
      0xE4AD,  0xE4AE,  0xCAF9,  0xCAFA,  0xCAFD,  0xCAFB,  0xCAFC,  0,       
      0xCAF8,  0,       0x6AA1,  0,       0,       0x69FE,  0xE4AC,  0xD0DA,  // 0x863x
      0x6EA9,  0xD0D9,  0,       0,       0x6EA7,  0xE6CC,  0,       0xD0D8,  
      0x6EA8,  0xDDA2,  0x6755,  0xD5CF,  0x71D1,  0xD5D0,  0xD5CE,  0xE8D5,  // 0x864x
      0xE8D6,  0xE8D7,  0xE8D8,  0,       0,       0,       0x71CF,  0x71D0,  
      0x69FD,  0xD5D1,  0x71D2,  0x74D2,  0x6B25,  0xD9DB,  0,       0xD9DA,  // 0x865x
      0xD9D9,  0xDDA3,  0xDDA5,  0,       0xDDA4,  0,       0xE2EA,  0xDFEA,  
      0xDFE9,  0,       0,       0x78BD,  0xE1D5,  0,       0xE2EB,  0xE5E8,  // 0x866x
      0xA930,  0x21FC,  0,       0x23AC,  0,       0x23AB,  0x23AD,  0x23AA,  
      0x2331,  0xA55A,  0xA55C,  0,       0,       0x2333,  0x2527,  0x24F9,  // 0x867x
      0x2526,  0x2528,  0x2525,  0xA933,  0x252A,  0x24FA,  0x3571,  0,       
      0,       0,       0xA932,  0xA5B5,  0xA5B6,  0xA5B7,  0xB8F3,  0xB8F5,  // 0x868x
      0,       0xC561,  0xC55F,  0xC560,  0,       0xA931,  0,       0x2529,  
      0,       0x282E,  0xC55E,  0x282A,  0x282D,  0x282C,  0xB469,  0x282F,  // 0x869x
      0x27F2,  0x27F3,  0xCF58,  0xAE43,  0xA8F6,  0xA8F8,  0xA8F9,  0xA8FC,  
      0xCF5A,  0,       0xAE41,  0,       0,       0xAE42,  0,       0,       // 0x86Ax
      0xAE40,  0,       0xA8F7,  0xA8FB,  0xCF57,  0xCF59,  0x27F4,  0x2BDA,  
      0x2BD9,  0x2BD8,  0x2B57,  0x2B55,  0x2BDF,  0x4133,  0x2BDB,  0,       // 0x86Bx
      0,       0xADDA,  0xC5EE,  0xD945,  0xD944,  0xD946,  0,       0xB46C,  
      0,       0xB466,  0,       0xB467,  0xB468,  0,       0xB46B,  0xB46A,  // 0x86Cx
      0x2BDE,  0x2BDC,  0x2BDD,  0x30E1,  0x30DD,  0x3036,  0xBC5B,  0x30E5,  
      0x30E6,  0x30DE,  0x30E3,  0x30DF,  0x3035,  0xBC5D,  0x3037,  0,       // 0x86Dx
      0,       0xBC5F,  0xE33D,  0xE33F,  0xE340,  0,       0xBC5C,  0xBC5E,  
      0xBC5A,  0x30E2,  0,       0x30E4,  0x30E0,  0x30E7,  0xE33E,  0xBC59,  // 0x86Ex
      0xB2E2,  0xB2E3,  0xB2E4,  0x51EE,  0x4E36,  0x356F,  0x36B1,  0x36B0,  
      0x36B5,  0x36AE,  0,       0x36B2,  0x356D,  0xC566,  0x36B4,  0xA9FA,  // 0x86Fx
      0xA9F9,  0,       0,       0xC568,  0xB2E1,  0xB8F6,  0xD2D4,  0xA9F6,  
} ;


static const unsigned short Uni2cnsP2Table_87 [] = {
      0xA9F7,  0xA9FB,  0xA9F8,  0xC563,  0,       0xC565,  0xC564,  0,       // 0x870x
      0xC562,  0,       0xB3BC,  0xC567,  0x36AF,  0x36B3,  0x30E8,  0x3B5F,  
      0x3DA3,  0x3CFE,  0x3DA2,  0x3B5D,  0x3DA4,  0xCF64,  0x3DA1,  0x43E7,  // 0x871x
      0x3CFD,  0x3CFC,  0xCF62,  0xCF5B,  0x3B5C,  0,       0,       0xBFE3,  
      0xBFE4,  0xBFE5,  0xD8C1,  0xB4CE,  0xCF5D,  0xCF5C,  0xCF5E,  0xCF5F,  // 0x872x
      0xCF60,  0,       0xCF61,  0,       0,       0xBFE6,  0xCF63,  0xB4CD,  
      0x3CFB,  0,       0xBCE4,  0x43DB,  0x43E0,  0x43E3,  0x43DE,  0x43DD,  // 0x873x
      0x4135,  0xE341,  0x43DC,  0x43E2,  0x43DF,  0x43E4,  0x43E6,  0x4137,  
      0x43E5,  0xD949,  0,       0x43DA,  0xC5EF,  0,       0,       0xD948,  // 0x874x
      0,       0xD94B,  0x43E1,  0x476F,  0x4ADD,  0x4ADC,  0x4AD9,  0x4AD8,  
      0x4AE3,  0x4ADF,  0,       0x4ADB,  0xE346,  0xE343,  0,       0xE342,  // 0x875x
      0x4AE1,  0,       0,       0x4AE2,  0,       0xC4A2,  0xC4A4,  0xC4A3,  
      0xC4A5,  0xE345,  0x4AD7,  0x4772,  0,       0xE344,  0x65BE,  0x4ADA,  // 0x876x
      0x4ADE,  0,       0x4AE4,  0x4E38,  0xCBA3,  0x51F2,  0xAAA1,  0x4E37,  
      0x51F3,  0x4E39,  0,       0x59A8,  0x51EF,  0x51F0,  0xA9FE,  0xAAA2,  // 0x877x
      0x4E3A,  0,       0,       0,       0,       0xD2D3,  0xD2D5,  0xD2D6,  
      0xCBA6,  0xCBA4,  0xAAA3,  0xAAA5,  0xAAA6,  0xAAA4,  0,       0xA9FC,  // 0x878x
      0,       0xA9FD,  0,       0,       0x51F4,  0xB4D0,  0x51F1,  0xCBA5,  
      0,       0x6EAA,  0x59A5,  0x59A6,  0xD0DC,  0x5438,  0xB4CF,  0x59A1,  // 0x879x
      0x59A4,  0xB4D2,  0x59A2,  0x59A3,  0x5439,  0,       0xB4D1,  0xD8C0,  
      0xD0DD,  0xD0DB,  0,       0,       0,       0,       0x6EAB,  0xBCE5,  // 0x87Ax
      0xBCE9,  0x5FB8,  0x593B,  0x5FB9,  0,       0,       0xD5D2,  0xD5D3,  
      0xD5D4,  0xBCE7,  0,       0xBCEA,  0,       0xBCE6,  0x5FBB,  0x5FBA,  // 0x87Bx
      0xD5D5,  0xBCE8,  0x65C0,  0xC4A6,  0xC4A7,  0x65C1,  0x6AA5,  0x65C4,  
      0xC4A9,  0xC4A8,  0x65C2,  0x65C3,  0xD9DC,  0x65BF,  0,       0,       // 0x87Cx
      0xC4AA,  0,       0,       0,       0,       0xCBA8,  0xC4AB,  0x6AA4,  
      0xCBA7,  0x6AA3,  0,       0,       0xCBAA,  0xCBA9,  0x6160,  0x59A7,  // 0x87Dx
      0x6AA2,  0x6464,  0x6EAC,  0xD0DF,  0xD0E1,  0,       0xD0DE,  0xD0E0,  
      0x6756,  0xE8D9,  0xD5D6,  0xD5D7,  0xD9DD,  0,       0xD5D8,  0xE8DA,  // 0x87Ex
      0xDDA6,  0,       0,       0xDFEB,  0xDFEC,  0,       0x7BCB,  0xE3F8,  
      0x3039,  0xB2E5,  0xBC60,  0,       0x36B8,  0x36B7,  0xC572,  0xC56E,  // 0x87Fx
      0x36B9,  0x3576,  0xC56C,  0xC573,  0xC569,  0x3577,  0x36BA,  0xC570,  
} ;


static const unsigned short Uni2cnsP2Table_88 [] = {
      0xC56F,  0xC56A,  0xC56B,  0,       0,       0xB8F7,  0xC571,  0x3579,  // 0x880x
      0xC56D,  0,       0xC574,  0xCF6B,  0x3DA5,  0x3DA6,  0x3B65,  0xCF69,  
      0x43EA,  0x3B62,  0x3B63,  0xCF6A,  0xCF66,  0xCF65,  0x3B61,  0xCF67,  // 0x881x
      0xCF68,  0,       0,       0xBFE8,  0xBFE9,  0xBFEA,  0xBFEB,  0,       
      0,       0,       0xCF6C,  0,       0x43E9,  0x43EC,  0x43E8,  0xD94E,  // 0x882x
      0,       0,       0,       0,       0,       0,       0xD94D,  0,       
      0,       0,       0,       0,       0,       0,       0x43EB,  0xE34A,  // 0x883x
      0x4AE6,  0x4AE5,  0xCCF3,  0xCCF4,  0xCCF5,  0xCCF7,  0xE349,  0,       
      0,       0xE348,  0xCCF8,  0,       0,       0xE347,  0,       0,       // 0x884x
      0,       0,       0,       0xAAA8,  0x51F8,  0xAAAC,  0x51F9,  0x51F5,  
      0xAAB0,  0x51F6,  0,       0xAAAF,  0xAAAE,  0xAAAD,  0xAAA9,  0xAAA7,  // 0x885x
      0x51F7,  0,       0xCCF6,  0xD2D8,  0xD2D9,  0xAAAA,  0,       0,       
      0xAAAB,  0,       0xAAB2,  0xAAB1,  0,       0,       0,       0,       // 0x886x
      0,       0xB4D6,  0xB4D5,  0x59A9,  0xB4D8,  0x59AC,  0xB4DA,  0x5441,  
      0xB4DF,  0x543E,  0x543F,  0xB4DE,  0x59AA,  0xB4D7,  0xB4DD,  0xB4DC,  // 0x887x
      0x59AB,  0,       0,       0,       0,       0xD8C2,  0xD8C3,  0,       
      0xB4D9,  0xB4DB,  0,       0xB4D3,  0xB4E0,  0x5FC1,  0x5FBF,  0x5FC0,  // 0x888x
      0x5FC3,  0x5940,  0xBCEC,  0x5FC2,  0x593E,  0xBCEE,  0x5FBE,  0xBCF4,  
      0x5FC4,  0xBCED,  0xBCF3,  0,       0xDDAA,  0xDDAB,  0xDDAC,  0,       // 0x889x
      0,       0xBCEF,  0xBCF1,  0xBCF2,  0,       0,       0,       0,       
      0x5FBD,  0x65C6,  0x65C7,  0x65C9,  0xC4B3,  0xC4AF,  0x5E23,  0xC4AC,  // 0x88Ax
      0x65C8,  0x5E26,  0x65CA,  0xBCF5,  0x5E25,  0xC4B2,  0,       0x65CB,  
      0xC4B5,  0xC4B6,  0xC4AD,  0xE1AE,  0,       0xC4B1,  0xC4AE,  0,       // 0x88Bx
      0,       0x65CC,  0xC4B0,  0,       0,       0xCBAF,  0xCBAC,  0x6AAE,  
      0x6AAB,  0x6AA7,  0x6AAA,  0x6AA9,  0x6AAF,  0x6AAC,  0x6AA8,  0x6AAD,  // 0x88Cx
      0,       0,       0,       0xCBAD,  0,       0,       0xCBAE,  0,       
      0xCBB0,  0xCBAB,  0,       0xC4B4,  0x6AB0,  0x6AA6,  0xD0E2,  0x6EB1,  // 0x88Dx
      0x6EAE,  0x6EAF,  0x6EAD,  0x6EB0,  0xD0E3,  0xD0E4,  0,       0xE6CE,  
      0xD0E5,  0xD0E7,  0,       0xD0E6,  0,       0,       0x6759,  0x6757,  // 0x88Ex
      0x6758,  0x71D3,  0xD5DA,  0xE8DB,  0,       0xD5D9,  0xD9DE,  0xD9DF,  
      0xD9E2,  0x74D3,  0xD9E1,  0xD9E0,  0xE9FD,  0,       0xDDA7,  0xDDA9,  // 0x88Fx
      0x76DA,  0xDDAB,  0xDDAA,  0x76DB,  0xDDA8,  0xEAFA,  0x78BF,  0x6C2F,  
} ;


static const unsigned short Uni2cnsP2Table_89 [] = {
      0xDFED,  0xDFEE,  0x78BE,  0,       0,       0xE2EC,  0,       0x7AFB,  // 0x890x
      0xE3FA,  0xE3F9,  0xE4E6,  0,       0xE4E5,  0xE5F8,  0xE5F9,  0xB46E,  
      0x3DA7,  0x36BB,  0xE34B,  0xE34C,  0,       0x51FA,  0xAAB4,  0xAAB3,  // 0x891x
      0x59AD,  0xB4E1,  0x5FC5,  0xDDAD,  0,       0xC4B7,  0xE6CF,  0,       
      0xE8DC,  0x74D4,  0x36BC,  0xBC61,  0,       0xC575,  0xCF6E,  0,       // 0x892x
      0x3DA9,  0x3DA8,  0xC5F0,  0,       0xE34D,  0xAAB5,  0,       0,       
      0,       0,       0,       0,       0x5FC6,  0,       0xE1AF,  0x65CD,  // 0x893x
      0xE8DD,  0x71D4,  0xD5DB,  0,       0,       0,       0xBC64,  0xB2E6,  
      0xBC62,  0,       0x36BD,  0xC576,  0xC577,  0,       0,       0,       // 0x894x
      0,       0xB8F8,  0xCF73,  0xCF74,  0xCF75,  0xCF71,  0xCF72,  0xCF78,  
      0xCF76,  0xCF70,  0xCF79,  0xBFEC,  0xBFED,  0xBFEE,  0xBFEF,  0xBFF2,  // 0x895x
      0xBFF4,  0xBFF1,  0,       0,       0,       0,       0,       0,       
      0,       0,       0xCF77,  0,       0xBFF0,  0x4147,  0x43EE,  0x4145,  // 0x896x
      0x4144,  0xD953,  0xD94F,  0,       0,       0xC5F1,  0xC5F5,  0xC5F6,  
      0xC5F7,  0xC5F8,  0xD955,  0xD951,  0,       0xD952,  0xC5F9,  0,       // 0x897x
      0,       0xD954,  0,       0xD950,  0,       0,       0xC5F4,  0,       
      0,       0,       0x4AE7,  0,       0x4AE8,  0xE352,  0x4AE9,  0,       // 0x898x
      0,       0,       0xCCE8,  0xCCF9,  0xCCFB,  0xCCFC,  0xCCFD,  0xCDA1,  
      0xCDA3,  0xCDA4,  0xCDA5,  0xCDA8,  0xCDA9,  0,       0xE34E,  0,       // 0x899x
      0,       0x477A,  0,       0,       0xE350,  0xE351,  0xCDAA,  0xE354,  
      0xCCFA,  0,       0,       0xE355,  0,       0,       0,       0,       // 0x89Ax
      0xCDAB,  0,       0xCDA6,  0xCCFE,  0xAABA,  0x4E42,  0x51FE,  0xAAC1,  
      0xAABB,  0xAAC0,  0xAAB9,  0x51FD,  0xAAC3,  0,       0,       0xAAC4,  // 0x89Bx
      0xAABD,  0,       0,       0,       0,       0,       0x51FB,  0xAAB7,  
      0,       0xD2DB,  0xD2DD,  0xD2DF,  0xD2E0,  0xD2E3,  0xD2E4,  0xD2E5,  // 0x89Cx
      0xD2E7,  0xD2E8,  0xD2E9,  0xD2EA,  0xD2EC,  0xD2ED,  0xAAC2,  0xAABC,  
      0,       0,       0,       0xAABF,  0,       0xAAC5,  0xD2DE,  0,       // 0x89Dx
      0,       0xAAB6,  0,       0x51FC,  0xD2E2,  0,       0,       0,       
      0,       0xD2E6,  0,       0,       0xD2DA,  0x59B4,  0x59B7,  0x59B2,  // 0x89Ex
      0x5447,  0x59AE,  0x59B0,  0xB4E5,  0xB4E4,  0xB4EB,  0xB4E9,  0xB4E7,  
      0x59B6,  0x5444,  0xB4E2,  0xB4EA,  0xB4E8,  0x59AF,  0xB4E6,  0,       // 0x89Fx
      0,       0,       0,       0,       0,       0xD2DC,  0x59B3,  0xD8C4,  
} ;


static const unsigned short Uni2cnsP2Table_8A [] = {
      0xD8C6,  0xD8C7,  0xD8C9,  0xD8CA,  0xD8CB,  0xD8CD,  0xD8CE,  0xD8CF,  // 0x8A0x
      0xD8D1,  0xD8D3,  0xD8D4,  0xD8D6,  0xD8D7,  0xD8DA,  0xD8DC,  0,       
      0xD8DD,  0xD8DE,  0xD8E0,  0xD8E1,  0xD8E3,  0xD8E4,  0xD8D0,  0xD8D2,  // 0x8A1x
      0,       0,       0,       0,       0,       0xD8DF,  0,       0,       
      0,       0,       0,       0,       0,       0xD8C5,  0,       0,       // 0x8A2x
      0,       0xD8D8,  0,       0,       0x59B8,  0,       0x59B1,  0x5FC8,  
      0x5FC9,  0xBCF9,  0x5943,  0x5FCC,  0x5FCB,  0xBCFC,  0x59B5,  0x5FC7,  // 0x8A3x
      0xBCFA,  0x5FCA,  0x5FCF,  0xBCFE,  0xBDA4,  0xBDA1,  0xBDA5,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8A4x
      0,       0,       0,       0,       0xDDAF,  0xDDB0,  0xDDB4,  0xDDB5,  
      0xDDB6,  0xDDB7,  0xDDBA,  0xDDBB,  0xDDBC,  0xDDBD,  0xDDBF,  0xDDC0,  // 0x8A5x
      0xDDC2,  0,       0,       0xDDC3,  0xDDC4,  0xDDC5,  0xDDC6,  0xDDC7,  
      0xDDC8,  0xDDC9,  0xDDCB,  0xDDCE,  0xDDCF,  0,       0,       0,       // 0x8A6x
      0,       0xBCFD,  0,       0,       0xBDA2,  0,       0,       0,       
      0,       0,       0,       0,       0,       0xBCF8,  0,       0,       // 0x8A7x
      0,       0xBDA3,  0x5948,  0,       0xDDCA,  0,       0,       0,       
      0,       0xDDB8,  0xDDB3,  0xDDB1,  0x5FCE,  0x5FCD,  0xDDAE,  0x65D1,  // 0x8A8x
      0x5E2D,  0x5E2E,  0x65D2,  0x5E28,  0x5E2A,  0xC4B8,  0x65D0,  0x65CE,  
      0x6AB1,  0xC4BA,  0x65D3,  0x5E30,  0xC4C0,  0,       0xC4BF,  0x65D4,  // 0x8A9x
      0,       0,       0,       0,       0,       0,       0,       0x65D5,  
      0xC4C1,  0xE1B1,  0xE1B2,  0xE1B4,  0xE1B6,  0xE1B7,  0xE1B8,  0xE1BA,  // 0x8AAx
      0xE1BC,  0xE1BD,  0xE1BE,  0xE1C0,  0xE1C1,  0xE1C2,  0xE1C4,  0xE1C5,  
      0xE1C6,  0,       0,       0,       0,       0,       0xC4BB,  0xC4BC,  // 0x8ABx
      0,       0,       0,       0,       0xC4BE,  0xC4BD,  0,       0,       
      0,       0,       0,       0,       0,       0,       0xE1B0,  0,       // 0x8ACx
      0,       0,       0,       0xE1B9,  0xE1B5,  0,       0xDFDD,  0x616B,  
      0xCBB3,  0xCBB7,  0x6AB2,  0xCBB4,  0x6AB4,  0xCBB2,  0xCBBA,  0,       // 0x8ADx
      0xCBB6,  0xCBB9,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0xCBBB,  0xE4B1,  // 0x8AEx
      0xE4B2,  0xE4B3,  0xE4B5,  0xE4B6,  0xE4B8,  0xE4B9,  0xE4BA,  0xE4BB,  
      0xE4BC,  0xE4BD,  0xE4BF,  0xE4C0,  0xE4C1,  0xE4C2,  0xE4C3,  0xE4C4,  // 0x8AFx
      0xE4C5,  0xCBBC,  0,       0xCBB5,  0,       0xCBB8,  0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_8B [] = {
      0,       0,       0,       0x616A,  0xCBB1,  0x65D6,  0,       0,       // 0x8B0x
      0,       0,       0,       0,       0xE4BE,  0x6468,  0xD0ED,  0xD0EE,  
      0x6EB8,  0xD0F2,  0x6EB3,  0x646A,  0x6EB6,  0,       0x6EB2,  0xD0F0,  // 0x8B1x
      0xD0E8,  0xD0E9,  0x6EB7,  0x646E,  0,       0xD0F1,  0,       0x6EB4,  
      0,       0,       0,       0xE6D0,  0xE6D1,  0xE6D3,  0xE6D4,  0xE6D5,  // 0x8B2x
      0xE6D6,  0xE6D8,  0xE6D9,  0,       0,       0,       0xE6DA,  0xE6DB,  
      0xE6DD,  0xE6DF,  0xE6E0,  0xE6E1,  0xE6E2,  0xE6E3,  0xE6E4,  0xE6E6,  // 0x8B3x
      0xE6E8,  0xE6EA,  0xE6EB,  0xE6EC,  0xE6ED,  0xE6EE,  0xE6EF,  0,       
      0,       0,       0,       0,       0xD0EC,  0,       0,       0xD0EF,  // 0x8B4x
      0,       0xE6D2,  0,       0,       0,       0,       0xE6DC,  0,       
      0xE6E7,  0,       0,       0xD0EA,  0,       0xD5E2,  0x675E,  0xD5E7,  // 0x8B5x
      0xD5E1,  0xD5DC,  0x6760,  0x675D,  0xD5E0,  0xD5E3,  0xD5E9,  0xD5DE,  
      0,       0,       0xE8DE,  0,       0,       0,       0,       0xE8DF,  // 0x8B6x
      0xE8E0,  0xE8E1,  0xE8E2,  0xE8E3,  0,       0xE8E4,  0xE8E5,  0xE8E6,  
      0xE8E7,  0xE8E8,  0xE8E9,  0xE8EB,  0xE8EC,  0xE8ED,  0xE8EE,  0xE8EF,  // 0x8B7x
      0,       0,       0,       0,       0xD5DF,  0,       0xD5E4,  0,       
      0xD5E5,  0,       0,       0xD5E6,  0xD5DD,  0,       0,       0,       // 0x8B8x
      0,       0,       0,       0,       0,       0,       0,       0xE8EA,  
      0,       0,       0x74D7,  0xD9EB,  0xD9EA,  0xDDB0,  0,       0xD9E6,  // 0x8B9x
      0,       0,       0xD9E4,  0xE9FE,  0,       0,       0xEAA1,  0xEAA2,  
      0xEAA3,  0xEAA4,  0xEAA5,  0xEAA6,  0xEAA7,  0xEAA8,  0xEAA9,  0xEAAA,  // 0x8BAx
      0xEAAB,  0,       0,       0xD9E3,  0,       0,       0,       0xD9E5,  
      0,       0,       0,       0,       0,       0,       0,       0x74D6,  // 0x8BBx
      0x76DE,  0x6B28,  0,       0x76DC,  0xEBAF,  0xDDAF,  0xDDAD,  0xD9E9,  
      0,       0,       0,       0,       0xDDAC,  0,       0xEAFC,  0xEAFD,  // 0x8BCx
      0xEBA3,  0xEBA4,  0xEBA5,  0xEBA6,  0xEBA9,  0xEBAA,  0xEBAB,  0xEBAC,  
      0xEBAD,  0xEBAE,  0xDDAE,  0,       0xDDB1,  0,       0,       0xEBA1,  // 0x8BDx
      0,       0xEAFE,  0xEBA7,  0,       0,       0,       0x78C0,  0xDFF0,  
      0xDFF1,  0xDFF2,  0xDFEF,  0xDFF3,  0,       0,       0xEBE8,  0,       // 0x8BEx
      0,       0,       0,       0,       0,       0xEBE9,  0xEBEA,  0xEBEB,  
      0xEBEC,  0,       0,       0,       0,       0,       0,       0,       // 0x8BFx
      0,       0,       0x6D63,  0xE1D7,  0xE1D8,  0,       0xEBED,  0,       
} ;


static const unsigned short Uni2cnsP2Table_8C [] = {
      0xECBC,  0xECBD,  0,       0,       0,       0xE1D6,  0,       0,       // 0x8C0x
      0,       0xE2F2,  0xE2ED,  0xE2EE,  0xE2F4,  0xE2F0,  0xE2EF,  0x7AC0,  
      0xE2F3,  0xE2F1,  0xE2F5,  0,       0xECD2,  0xECD3,  0xECD4,  0xECD5,  // 0x8C1x
      0xECD6,  0xECD7,  0xECD8,  0,       0xECC0,  0x7AC1,  0x7AFC,  0xE3FD,  
      0xE3FB,  0,       0xECEF,  0,       0xE3FC,  0,       0,       0,       // 0x8C2x
      0xEDA3,  0xE4E8,  0,       0,       0xEDA1,  0,       0xE4E7,  0xE4E9,  
      0xEDA2,  0xECBE,  0xE5C8,  0xE5C9,  0,       0,       0xEDA9,  0,       // 0x8C3x
      0x7CA1,  0,       0,       0xEDB5,  0xEDB8,  0xEDB9,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8C4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xAE44,  // 0x8C5x
      0xA934,  0x2BE0,  0x36BF,  0xC57B,  0x36BE,  0x36C0,  0xC57A,  0xB8F9,  
      0,       0,       0xC579,  0,       0xC578,  0x3DAA,  0x3DAB,  0x3B68,  // 0x8C6x
      0xCF7A,  0xCF7B,  0,       0xBFF5,  0,       0,       0,       0,       
      0,       0,       0,       0xD959,  0xD958,  0x414A,  0xD956,  0xD957,  // 0x8C7x
      0,       0xC5FA,  0x43F0,  0,       0,       0,       0,       0x43EF,  
      0x4AEA,  0x477C,  0xE356,  0xE357,  0,       0,       0x4AEB,  0x52A1,  // 0x8C8x
      0x52A3,  0x59B9,  0x52A2,  0x52A4,  0x52A5,  0xD8E5,  0,       0,       
      0,       0,       0,       0x59BB,  0xB4EE,  0x59BA,  0,       0xBDA6,  // 0x8C9x
      0xB4ED,  0,       0xB4F0,  0xB4EC,  0,       0xBDA9,  0x594A,  0x5FD0,  
      0x594B,  0xBDAA,  0xBDA8,  0,       0,       0xBDA7,  0xC4C3,  0x65D8,  // 0x8CAx
      0xC4C2,  0x65D7,  0,       0,       0,       0x6AB8,  0x6AB6,  0x6AB5,  
      0,       0,       0x6AB7,  0x6EB9,  0xD0F3,  0,       0xD0F4,  0,       // 0x8CBx
      0x6764,  0,       0xD5EA,  0xD9ED,  0xD9EE,  0,       0xD9EC,  0,       
      0x76E1,  0x76E0,  0x78C1,  0xDFF4,  0xE2F6,  0xE4EA,  0,       0,       // 0x8CCx
      0,       0x2BE1,  0x30EA,  0x30EB,  0x30E9,  0,       0xB2E7,  0xBC66,  
      0x36C2,  0x36C1,  0,       0xB8FA,  0,       0xB8FB,  0xC57C,  0x3DB3,  // 0x8CDx
      0x3DB1,  0x3DAF,  0x3B6A,  0x3DB0,  0x3B6C,  0xBFED,  0x3DAC,  0x3DAD,  
      0x3DAE,  0xCF7E,  0xD021,  0x3DB2,  0,       0xCF7C,  0,       0xBFF8,  // 0x8CEx
      0xBFF9,  0xBFFA,  0xBFFB,  0xBFFC,  0xBFFD,  0xC0A1,  0,       0,       
      0xCF7D,  0,       0x3B69,  0x414C,  0xD95E,  0x4152,  0x414D,  0x414B,  // 0x8CFx
      0xC5FE,  0xD95D,  0x43F4,  0x43F1,  0x43F3,  0x43F2,  0xD95B,  0x4151,  
} ;


static const unsigned short Uni2cnsP2Table_8D [] = {
      0x414F,  0xD95C,  0xD95A,  0,       0xC5FD,  0xC6A1,  0,       0,       // 0x8D0x
      0,       0,       0,       0,       0,       0x4AF3,  0x4AEF,  0x4AF1,  
      0x477E,  0x4AED,  0x4821,  0x4AF4,  0xE35A,  0x4AF0,  0x4AF5,  0x477D,  // 0x8D1x
      0x4AF2,  0x4AF6,  0,       0,       0,       0xE359,  0,       0xE35B,  
      0xE35C,  0,       0,       0,       0,       0x4AEC,  0,       0,       // 0x8D2x
      0xAAC8,  0x52AD,  0x52A8,  0xAACD,  0x52AA,  0x52A7,  0xAACE,  0x4E49,  
      0x52AC,  0x52A9,  0,       0xAACC,  0,       0xD2EE,  0xD2EF,  0xD2F1,  // 0x8D3x
      0xAAC7,  0,       0,       0,       0,       0,       0,       0xAAC9,  
      0xAACA,  0xAACB,  0,       0,       0x52A6,  0x52AB,  0x52AE,  0xD2F0,  // 0x8D4x
      0x5450,  0x544D,  0x59BD,  0x59C0,  0xB4F2,  0x59BC,  0,       0x59BE,  
      0x59BF,  0xB4F5,  0xB4F7,  0xB4F9,  0xD8E6,  0xD8E7,  0xD8E8,  0xB4F4,  // 0x8D5x
      0,       0,       0,       0,       0xB4F8,  0,       0,       0,       
      0,       0,       0xB4F6,  0,       0x544E,  0x5953,  0x5951,  0x5FD4,  // 0x8D6x
      0xBDAB,  0x5FD1,  0x5FD3,  0x5FD5,  0x5FD2,  0xBDAD,  0x5950,  0xBDAC,  
      0x594C,  0,       0xBDAE,  0xDDD0,  0,       0xBDAF,  0,       0xBDB0,  // 0x8D7x
      0,       0xBDB1,  0,       0,       0,       0,       0,       0,       
      0x65DF,  0x65DE,  0x65DA,  0x5E33,  0xC4C4,  0x65DB,  0x65E1,  0x65E0,  // 0x8D8x
      0xC4C6,  0x65DD,  0x65D9,  0x65DC,  0xE1C7,  0xE1C8,  0xE1C9,  0xE1CC,  
      0,       0,       0xE1CB,  0,       0,       0,       0xC4C5,  0,       // 0x8D9x
      0,       0,       0xC4C7,  0,       0x6AB9,  0xCBBE,  0xCBBF,  0x616D,  
      0x6ABA,  0xCBBD,  0x616E,  0xE4C6,  0xE4C7,  0xE4C8,  0xE4C9,  0xE4CA,  // 0x8DAx
      0,       0,       0,       0,       0x6470,  0x6EBF,  0x6EBA,  0x6EBD,  
      0x6EBC,  0x6EBE,  0x6EC0,  0x6472,  0xD0F8,  0,       0x6ABB,  0xD0F5,  // 0x8DBx
      0xE6F0,  0xE6F1,  0,       0,       0,       0,       0xD0F6,  0,       
      0,       0x6EBB,  0xD0F7,  0x71DA,  0x6EC1,  0x6765,  0x71D9,  0x71D7,  // 0x8DCx
      0,       0xE8F0,  0xE8F1,  0xE8F3,  0xE8F4,  0xE8F5,  0,       0,       
      0,       0,       0x71DC,  0x71D8,  0x74D8,  0xD5EB,  0,       0xEAAF,  // 0x8DDx
      0,       0xD9EF,  0,       0xEAAC,  0xEAAD,  0xEAAE,  0xEAB0,  0xEAB1,  
      0,       0xEBB0,  0xEBB1,  0xEBB2,  0xDDB2,  0,       0x78C2,  0xEBEE,  // 0x8DEx
      0xEBEF,  0,       0xDFF6,  0xDFF5,  0,       0,       0,       0,       
      0x79D4,  0x6D29,  0x6D2A,  0xE1D9,  0,       0,       0,       0xE2F7,  // 0x8DFx
      0xE2F8,  0,       0,       0x7AFD,  0xEDAA,  0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_8E [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x8E0x
      0,       0,       0,       0,       0,       0,       0,       0xAE45,  
      0x22A2,  0x21FE,  0x2223,  0x22A3,  0x2222,  0x22A1,  0x23AE,  0x2334,  // 0x8E1x
      0xA55D,  0,       0x24FD,  0x252C,  0x252D,  0x24FE,  0x24FC,  0,       
      0xA5BA,  0xA5BB,  0xA5BC,  0xA5BD,  0xA5BE,  0,       0,       0,       // 0x8E2x
      0,       0xA5BF,  0,       0x27F5,  0xAE47,  0x27F6,  0x27F8,  0x27F9,  
      0x2830,  0x27F7,  0xAE46,  0xAE48,  0,       0xA8FD,  0,       0,       // 0x8E3x
      0xA8FE,  0,       0,       0,       0,       0,       0,       0,       
      0,       0x2BE2,  0xB470,  0xB473,  0x2B5C,  0x2BE5,  0xB471,  0xE35D,  // 0x8E4x
      0xB475,  0xB476,  0xB477,  0xB472,  0x2BE3,  0,       0xB478,  0xADDB,  
      0xADDC,  0xADDD,  0,       0xB474,  0,       0xB46F,  0,       0,       // 0x8E5x
      0xBC69,  0x30EF,  0x2BE6,  0xBC68,  0x30EC,  0x30EE,  0xBC6E,  0xBC6B,  
      0xBC6F,  0x30ED,  0xBC6A,  0xBC6D,  0,       0,       0,       0xBC6C,  // 0x8E6x
      0,       0,       0,       0,       0,       0xB2E8,  0xB2E9,  0xB2EA,  
      0xB2EB,  0xB2EC,  0xB2ED,  0xB2EE,  0,       0x36C3,  0xC628,  0xC621,  // 0x8E7x
      0x357E,  0x3622,  0x3621,  0x36C4,  0xC623,  0xC624,  0xC62B,  0xC62A,  
      0xE35E,  0xC626,  0xC622,  0xC629,  0xC627,  0xB4FB,  0xC625,  0,       // 0x8E8x
      0,       0,       0xB8FC,  0xB8FD,  0xB8FE,  0xB9A1,  0xB9A2,  0xB9A3,  
      0xB9A4,  0xB9A5,  0xB9A6,  0xB9A7,  0,       0,       0,       0,       // 0x8E9x
      0,       0,       0,       0,       0,       0,       0,       0x3DB8,  
      0x3DBD,  0x3DB9,  0x3DBA,  0x3DBC,  0xD025,  0xD023,  0x3DB4,  0x3DB5,  // 0x8EAx
      0x3DB7,  0xD024,  0xD029,  0xBDB4,  0xD027,  0x3DBB,  0xD028,  0xD026,  
      0,       0xC0A2,  0,       0,       0xC0A3,  0xBDB2,  0,       0,       // 0x8EBx
      0,       0,       0,       0,       0,       0,       0,       0x3DB6,  
      0xD96A,  0x43FB,  0x43F8,  0xD962,  0xD969,  0xD967,  0x43FC,  0x43F9,  // 0x8ECx
      0x43F7,  0xE35F,  0xD963,  0xD965,  0x43FD,  0x43FA,  0xD966,  0xC4C9,  
      0xD964,  0xC4C8,  0x43F6,  0xD95F,  0xD96B,  0xD960,  0x43F5,  0,       // 0x8EDx
      0xD961,  0,       0xC6A2,  0xC6A3,  0xC6A4,  0xC6A5,  0xC6A6,  0xC6A7,  
      0xC6A8,  0xC6A9,  0,       0,       0,       0,       0xD968,  0,       // 0x8EEx
      0xD96C,  0,       0xBDB3,  0,       0,       0,       0,       0xE364,  
      0xE362,  0xE366,  0x4827,  0x4826,  0x52AF,  0x4828,  0x4829,  0x4AF8,  // 0x8EFx
      0xE363,  0xE360,  0x4825,  0x4AF9,  0x4AFA,  0xE365,  0xE367,  0xCBC1,  
} ;


static const unsigned short Uni2cnsP2Table_8F [] = {
      0xCDAE,  0xCDAF,  0xCDB0,  0xCDB1,  0xCDB2,  0xCDB3,  0xE361,  0,       // 0x8F0x
      0x4AF7,  0,       0x52B6,  0x52B4,  0x52B5,  0xAAD5,  0x52B8,  0x52B2,  
      0x52B1,  0xAACF,  0x52B3,  0x52B7,  0x52B0,  0xD0FA,  0xAAD3,  0xAAD1,  // 0x8F1x
      0xAAD0,  0xAAD2,  0,       0xD2F2,  0xD2F3,  0xD2F4,  0xD2F5,  0xD2F6,  
      0xD2F7,  0,       0,       0,       0,       0,       0xAAD6,  0,       // 0x8F2x
      0,       0,       0x59C1,  0x59C2,  0x5454,  0xB4FC,  0x59C4,  0x59C3,  
      0xB4FE,  0xD0F9,  0,       0xD8E9,  0xD8EA,  0xD8EB,  0xD8EC,  0,       // 0x8F3x
      0,       0,       0,       0,       0,       0x6ABC,  0xB4FD,  0x5FD6,  
      0x5FD7,  0xBDB6,  0xBDB7,  0xBDB5,  0x74D9,  0xDDD1,  0xDDD2,  0xDDD3,  // 0x8F4x
      0,       0,       0,       0,       0xDDD4,  0x65E2,  0xC4CC,  0x5E34,  
      0xC4CA,  0xC4CB,  0xE1CD,  0xE1CE,  0xE1CF,  0xE1D0,  0x6ABD,  0xCBC3,  // 0x8F5x
      0xD5EC,  0xCBC5,  0,       0,       0xE4CC,  0x78C3,  0,       0xCBC2,  
      0xCBC4,  0xDFF7,  0xE6F2,  0xE6F3,  0,       0xD1F2,  0x71DD,  0xD5EE,  // 0x8F6x
      0xD5ED,  0,       0xE2F9,  0xE2FA,  0xD9F0,  0,       0xDDC9,  0,       
      0,       0xDFF8,  0x7AFE,  0x7BA1,  0xE6B7,  0xE6A8,  0xD96D,  0,       // 0x8F7x
      0x4E4B,  0xAAD7,  0xD2F9,  0xD2F8,  0x59C5,  0xB5A1,  0,       0x5956,  
      0xC4CD,  0xC4CE,  0x6ABE,  0xD0FB,  0,       0xBC70,  0xBC71,  0xBC72,  // 0x8F8x
      0xC62C,  0x36C5,  0x3623,  0xC62E,  0,       0xC62D,  0,       0xC630,  
      0,       0xC62F,  0x3B70,  0xD02C,  0x3B6E,  0xD02A,  0xD973,  0xD030,  // 0x8F9x
      0xD02E,  0xD02B,  0x3B71,  0x3B6F,  0xD02F,  0xD02D,  0,       0,       
      0xD97B,  0x43FE,  0xD96E,  0xD971,  0xD977,  0xD975,  0xD97A,  0xD972,  // 0x8FAx
      0xD970,  0xD974,  0xD979,  0xD978,  0,       0,       0xD96F,  0xD976,  
      0,       0,       0xE374,  0xE372,  0x4AFB,  0xE36B,  0xE36C,  0xE376,  // 0x8FBx
      0xE368,  0xE377,  0xE370,  0x482A,  0xE375,  0xE36F,  0x4AFC,  0xE371,  
      0xE369,  0x4AFD,  0x482B,  0xE36A,  0xCDB4,  0xCDB5,  0xE373,  0,       // 0x8FCx
      0xE378,  0xE36D,  0,       0xAADD,  0xAADB,  0xAAE4,  0xAADF,  0xAADC,  
      0x52BA,  0xAADE,  0xAAE6,  0xAAE2,  0xAAE0,  0xAAE1,  0xAAE3,  0xAADA,  // 0x8FDx
      0xAAD8,  0x52B9,  0xAAE5,  0,       0,       0,       0xAAE7,  0,       
      0x5957,  0x5455,  0x59C7,  0xB5A9,  0xB5A4,  0xB5AF,  0xB5A2,  0xB5AD,  // 0x8FEx
      0xB5A8,  0xB5A5,  0xB5AC,  0xB5AA,  0xB5A6,  0x59C6,  0xB5B0,  0x5456,  
      0xB5AB,  0xB5B3,  0xB5A7,  0xAAD9,  0xB5B4,  0xB5B1,  0xB5A3,  0,       // 0x8FFx
      0,       0xB5B2,  0xD8ED,  0,       0,       0xB5AE,  0xD2FA,  0x5959,  
} ;


static const unsigned short Uni2cnsP2Table_90 [] = {
      0xBDBD,  0xBDBB,  0xBDC5,  0xBDBC,  0xBDBE,  0xBDC9,  0xBDBA,  0xBDC2,  // 0x900x
      0xBDB9,  0xBDB8,  0xBDBF,  0x5FD8,  0xBDC7,  0xBDC1,  0xBDC0,  0xBDC3,  
      0xBDC8,  0xB5B6,  0xDDD5,  0xDDD7,  0xBDC4,  0xBDC6,  0,       0xC4D0,  // 0x901x
      0xC4D6,  0xC4D2,  0xC4D3,  0xC4CF,  0x65E3,  0xC4D7,  0xC4D5,  0x65E4,  
      0xC4D1,  0xC4D4,  0,       0,       0xCBCA,  0xCBC7,  0xCBCB,  0xCBC8,  // 0x902x
      0x6ABF,  0xCBCE,  0x616F,  0x6AC0,  0xCBC6,  0xCBCC,  0xCBCD,  0x6170,  
      0xCBC9,  0xCBCF,  0,       0,       0xD1A3,  0xD1A7,  0xD0FD,  0xD1AA,  // 0x903x
      0xD1A4,  0xD1AB,  0xD1A8,  0xD0FC,  0x6EC2,  0xD1A5,  0xD1A6,  0x6EC3,  
      0xD1A2,  0xE6F4,  0xD0FE,  0,       0,       0xD1AC,  0xD1A9,  0xD5F4,  // 0x904x
      0x6768,  0xD5F2,  0xD5EF,  0xD5F6,  0xD5F0,  0xD5F5,  0xD5F3,  0xD5F7,  
      0xD1A1,  0xE8F6,  0xD5F1,  0xD9F1,  0xD9F2,  0x6957,  0xD9F5,  0xD9F6,  // 0x905x
      0xD9F4,  0xEAB2,  0,       0xD9F3,  0xDDB8,  0xDDB9,  0xDDBA,  0x6B2B,  
      0xDDB7,  0xDDB3,  0xDDB4,  0xDDB5,  0xDDB6,  0,       0,       0xDFFC,  // 0x906x
      0xDFFA,  0xDFFB,  0,       0xDFF9,  0xE1DA,  0xECC1,  0,       0,       
      0xE3FE,  0,       0xE4EB,  0,       0,       0xE6C0,  0xADDE,  0x30F0,  // 0x907x
      0xB2F0,  0xC632,  0xC633,  0x3625,  0xC631,  0xB9A8,  0xB9A9,  0,       
      0,       0,       0x3DC0,  0x3DBE,  0x3DC1,  0x3DBF,  0x3B73,  0xD033,  // 0x908x
      0x3B72,  0xD032,  0xC0A5,  0,       0xC0A7,  0xC0A6,  0,       0,       
      0,       0,       0x4158,  0x44A5,  0x44A2,  0x44A1,  0x44A4,  0x44A3,  // 0x909x
      0xD97C,  0,       0xC6AB,  0xC6AC,  0xC6AD,  0,       0,       0,       
      0,       0x44A6,  0x4BA2,  0x4830,  0x4BA3,  0x4BA1,  0x4AFE,  0x482C,  // 0x90Ax
      0x482F,  0xE37D,  0x4832,  0,       0xE37C,  0xE37E,  0xCDB7,  0,       
      0,       0,       0xCDB8,  0xE37A,  0,       0xE379,  0,       0xAAEA,  // 0x90Bx
      0xAAE9,  0x52C5,  0x52C0,  0x52C1,  0x52BF,  0x52BE,  0x52C3,  0x52BD,  
      0x5457,  0x52BC,  0xAAEB,  0xAAEC,  0,       0xC6AA,  0xD2FB,  0xD2FC,  // 0x90Cx
      0xD2FD,  0xD2FE,  0xD3A1,  0,       0xAAE8,  0,       0,       0,       
      0x52C4,  0x52C2,  0x5FD9,  0xB5BB,  0x545B,  0x59CE,  0x59CB,  0x545A,  // 0x90Dx
      0xB5B8,  0x59CD,  0x59CA,  0xB5BA,  0x59C9,  0xB5B9,  0xB5B7,  0,       
      0x59C8,  0xB5BC,  0,       0xD8EE,  0,       0,       0xD8EF,  0xD8F1,  // 0x90Ex
      0xD8F2,  0xD8F3,  0xD8F4,  0xD8F5,  0,       0xD8F0,  0,       0xD5E4,  
      0,       0,       0,       0,       0x59CC,  0x595C,  0x595A,  0x595B,  // 0x90Fx
      0x5FDA,  0x5961,  0x5FDC,  0,       0x595E,  0xBDCA,  0x65E8,  0xBDCB,  
} ;


static const unsigned short Uni2cnsP2Table_91 [] = {
      0xBDCD,  0x5FDB,  0,       0xDDD9,  0xBDCC,  0,       0,       0,       // 0x910x
      0,       0xBDCE,  0,       0,       0,       0xDDDA,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x5FDD,  0x65EC,  // 0x911x
      0x65EF,  0xC4DF,  0xC4E3,  0x65E9,  0xC4DE,  0x65E6,  0xC4E5,  0xC4E2,  
      0x5E37,  0x65E5,  0x65E7,  0xC4E1,  0xC4DA,  0xC4DD,  0x65EE,  0xC4DB,  // 0x912x
      0,       0xE1D1,  0,       0xC4E4,  0,       0xC4D9,  0xC4DC,  0,       
      0,       0,       0,       0,       0,       0,       0,       0x65EB,  // 0x913x
      0x65ED,  0xDDD8,  0x65EA,  0x6AC7,  0x6AC1,  0x6AC5,  0x6AC2,  0x6AC3,  
      0x6172,  0x6AC6,  0x6AC4,  0x6AC9,  0x6171,  0xCBD0,  0xCBD5,  0xCBD1,  // 0x914x
      0,       0x6AC8,  0xCBD3,  0xE4CE,  0,       0,       0xCBD7,  0xCBD6,  
      0xCBD4,  0,       0xCBD2,  0xCBD8,  0,       0,       0,       0,       // 0x915x
      0,       0,       0,       0,       0,       0xD1AE,  0x6474,  0xD1B6,  
      0x6476,  0x6EC4,  0x676D,  0x6478,  0xD1B4,  0xD1B3,  0x6EC5,  0x647A,  // 0x916x
      0x6477,  0x6479,  0xD1AF,  0xD1B1,  0xD1B2,  0xE6F5,  0,       0,       
      0,       0xD1B5,  0xD1B7,  0,       0,       0,       0xD1B0,  0xD1AD,  // 0x917x
      0,       0,       0,       0,       0x676A,  0x6769,  0xD5F8,  0x71DE,  
      0x71DF,  0x676B,  0x676C,  0xD5FA,  0x71E0,  0x71E1,  0xD5FD,  0xD5F9,  // 0x918x
      0xD5FE,  0xD5FB,  0,       0,       0,       0,       0,       0,       
      0,       0x74DC,  0x74DF,  0x6959,  0xD9F8,  0x74DD,  0xD9F9,  0xD9FA,  // 0x919x
      0x74DA,  0,       0x74DE,  0x74DB,  0,       0,       0,       0xD9F7,  
      0,       0,       0,       0,       0x76E2,  0xDDBB,  0xDDBC,  0,       // 0x91Ax
      0,       0xEBB3,  0,       0x76E3,  0,       0x78C4,  0x6C32,  0x6C31,  
      0xDFFD,  0xDFFE,  0xE0A1,  0xEBF0,  0,       0x6D2C,  0x79D6,  0x6D2B,  // 0x91Bx
      0x79D5,  0,       0xE1DB,  0,       0,       0x79D7,  0,       0x7AC4,  
      0xE2FB,  0x7AC3,  0xE2FC,  0xECD9,  0xE3A3,  0,       0,       0x7AC2,  // 0x91Cx
      0xE4EC,  0x6E3E,  0xE5CB,  0xE5CA,  0xE5CC,  0,       0x7BEC,  0,       
      0,       0xE6AD,  0xE6CE,  0xE6D1,  0x6E5C,  0x3626,  0,       0xD034,  // 0x91Dx
      0xC6AE,  0xC6AF,  0xC6B0,  0xD97D,  0x4836,  0xACC4,  0xB5BD,  0x5AF4,  
      0xC4E6,  0xE4CF,  0,       0x71E2,  0xEBF1,  0,       0xBC74,  0xAE49,  // 0x91Ex
      0xBC73,  0x3627,  0xC634,  0x3629,  0xB9AD,  0xD035,  0x3DC2,  0x3B75,  
      0xD037,  0xD036,  0xC0A8,  0xC0A9,  0,       0xDA21,  0xD97E,  0xCDBB,  // 0x91Fx
      0x4E4D,  0xAAEE,  0xAAED,  0,       0xB5BE,  0,       0xD1B8,  0xD1B9,  
} ;


static const unsigned short Uni2cnsP2Table_92 [] = {
      0,       0,       0,       0xD039,  0xD03A,  0xD038,  0x4159,  0x415B,  // 0x920x
      0x44A8,  0x44A7,  0xDA23,  0,       0xDA22,  0xE422,  0x4BA5,  0x4839,  
      0,       0xE421,  0x4BA4,  0xCDBC,  0,       0,       0xE423,  0,       // 0x921x
      0,       0x4E4E,  0x52C6,  0x52C8,  0x52C7,  0xAAF0,  0,       0xAAEF,  
      0xD8F7,  0x59D0,  0x59CF,  0x59D4,  0x59D1,  0x59D2,  0x59D3,  0xD8F6,  // 0x922x
      0xB5BF,  0,       0,       0xBDCF,  0x5FDF,  0x5FE0,  0x5FE2,  0x5FE1,  
      0xDDDB,  0xBDD1,  0x65F2,  0xC4E7,  0x65F0,  0x65F1,  0x5E39,  0,       // 0x923x
      0x6ACB,  0x6ACA,  0,       0x6EC7,  0x6EC6,  0xCDD0,  0xD1BA,  0,       
      0x6CC6,  0x71E4,  0xD6A2,  0x71E6,  0x71E5,  0xE8F9,  0,       0xD6A1,  // 0x924x
      0xD6A4,  0xD6A3,  0xD9FB,  0xD9FC,  0xDDBD,  0x76E4,  0xEBB4,  0,       
      0,       0xE0A2,  0,       0,       0x7AC5,  0,       0xE4A1,  0,       // 0x925x
      0,       0xE4EE,  0xE4ED,  0xB9AE,  0,       0x3DC3,  0x3B78,  0xD03B,  
      0,       0x44AC,  0x44AB,  0xDA26,  0xDA29,  0x44AA,  0xDA27,  0x44A9,  // 0x926x
      0xDA25,  0xDA2B,  0xDA2A,  0x415C,  0x415E,  0,       0xC6B1,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x927x
      0x4BA7,  0x483C,  0x4BA6,  0xE427,  0xE425,  0x4BA8,  0x4BA9,  0x483E,  
      0x4BAC,  0x4BAA,  0x4BAD,  0x4BAB,  0xE429,  0x483F,  0,       0,       // 0x928x
      0xE428,  0xE424,  0,       0xE426,  0,       0,       0,       0,       
      0xAAF3,  0x52C9,  0xAAF7,  0xAAF6,  0x4E51,  0xAAF9,  0x52CA,  0x4E52,  // 0x929x
      0xAAF5,  0x4E53,  0x52CD,  0x4E50,  0x52CC,  0x52CE,  0xAAF4,  0x52CB,  
      0,       0,       0,       0,       0,       0xAAF8,  0xAAF2,  0,       // 0x92Ax
      0,       0xB5C4,  0x59D5,  0x59D8,  0x5466,  0x545E,  0x5465,  0x59D6,  
      0x59D7,  0,       0xB5C3,  0xB5C7,  0,       0,       0,       0xB5C0,  // 0x92Bx
      0xB5C1,  0xB5C5,  0,       0,       0xB5C6,  0,       0,       0xBDD8,  
      0xBDDA,  0x5FE3,  0x5FE9,  0x5966,  0x5FE5,  0xBDD3,  0x5967,  0xB5C2,  // 0x92Cx
      0x5FED,  0xBDD7,  0x5965,  0xBDD9,  0x5FE7,  0x5FEA,  0xBDD5,  0x5FEB,  
      0xBDDB,  0xB5C8,  0x5FE8,  0xBDD4,  0xBDDC,  0xDDDC,  0,       0,       // 0x92Dx
      0,       0,       0,       0xBDD2,  0,       0x5FEC,  0x5FE6,  0x5E44,  
      0x65FC,  0x65F4,  0x5E3A,  0x65F6,  0x66A2,  0xC4EA,  0xC4E8,  0x5E3F,  // 0x92Ex
      0x65F7,  0x5E40,  0xC4ED,  0xC4F0,  0x66A1,  0xC4EF,  0x5E3D,  0x66A3,  
      0xC4F1,  0xC4F2,  0xC4EE,  0xE1D3,  0xE1D4,  0x5FE4,  0xC4EC,  0,       // 0x92Fx
      0xC4EB,  0x65F8,  0x66A4,  0,       0xC4E9,  0x65F5,  0x65FA,  0x65F9,  
} ;


static const unsigned short Uni2cnsP2Table_93 [] = {
      0x65FD,  0,       0,       0x617A,  0x6AD1,  0x6AD4,  0x6ACF,  0x6179,  // 0x930x
      0x6ACD,  0xCBDA,  0x6AD5,  0xCBE3,  0x6ACE,  0x6178,  0xCBE1,  0x6176,  
      0xCBDE,  0x6175,  0xCBE2,  0x6AD0,  0xCBE0,  0xE4D0,  0xE4D2,  0xE4D3,  // 0x931x
      0,       0,       0xCBDB,  0xCBDC,  0,       0x6AD3,  0,       0,       
      0x6AD2,  0xCBD9,  0x6ACC,  0,       0,       0,       0x6524,  0x6ECE,  // 0x932x
      0x647D,  0x6ECF,  0x6ECA,  0xD1BB,  0x6EC8,  0xD1BD,  0x6521,  0x6ECC,  
      0x6522,  0x6525,  0x6ECD,  0xD1C1,  0,       0,       0xD1BC,  0xE6F8,  // 0x933x
      0,       0xD1BE,  0xD1C3,  0xD1C0,  0,       0,       0x6ECB,  0xD1BF,  
      0x6ED0,  0x6526,  0xD1C2,  0x71ED,  0xD6A8,  0x676F,  0xD6AA,  0xD6AB,  // 0x934x
      0,       0x71EA,  0x71EB,  0x71EC,  0,       0,       0x71E7,  0x71E8,  
      0,       0xD6A9,  0xE6F7,  0x74E0,  0xDAA6,  0xD9FD,  0x695D,  0x74E1,  // 0x935x
      0xDAA5,  0xDAA3,  0xD9FE,  0xDAA4,  0x74E3,  0x74E4,  0xDAA1,  0xDAA2,  
      0,       0,       0,       0,       0x74E5,  0x76E5,  0x76E8,  0x76E6,  // 0x936x
      0xDDBE,  0x76E9,  0x76E7,  0xDDC1,  0,       0,       0xDDBF,  0xDDC2,  
      0,       0xDDC0,  0x78C6,  0x79D8,  0xE0A3,  0x78C5,  0,       0x78C7,  // 0x937x
      0xE1DE,  0xE1DC,  0,       0,       0,       0,       0xE1DD,  0x7AC6,  
      0xE2FE,  0xE3A2,  0x79D9,  0,       0xE3A1,  0xE2FD,  0,       0x7BA2,  // 0x938x
      0xE4F0,  0xE4EF,  0x7BCC,  0xE5E9,  0x7CB5,  0xE6AE,  0xE6B9,  0xE6B8,  
      0,       0x7CCC,  0x3DC4,  0x4160,  0x4162,  0xDA2C,  0,       0x44AD,  // 0x939x
      0xE42B,  0x4BAF,  0x4BB1,  0x4BAE,  0x4BB0,  0xE42A,  0xCDBD,  0,       
      0,       0x4BB2,  0,       0,       0x4E55,  0x52D0,  0x4E54,  0x4E56,  // 0x93Ax
      0xAAFB,  0xAAFA,  0xAAFC,  0xAAFD,  0xAAFE,  0x52CF,  0x52D1,  0x59D9,  
      0xB5C9,  0xB5CA,  0x59DC,  0x59DD,  0,       0x59DB,  0xB5CB,  0x59DA,  // 0x93Bx
      0x5969,  0xBDDE,  0x5FEE,  0xBDDF,  0x596C,  0x596A,  0x5FEF,  0x5FF0,  
      0xDDDD,  0xBDDD,  0,       0xBDE0,  0,       0xC4F6,  0xC4F3,  0x5E46,  // 0x93Cx
      0xC4F4,  0xBDE1,  0x66A5,  0xC4F8,  0,       0,       0xC4F5,  0xCBE4,  
      0xCBE6,  0xCBE9,  0xCBE5,  0xCBE8,  0xCBE7,  0xD1C4,  0x6AD6,  0x6AD7,  // 0x93Dx
      0xD1C5,  0xD1C6,  0x6528,  0xE6F9,  0,       0,       0x6ED2,  0x6ED1,  
      0x71EE,  0x71F0,  0x71F2,  0x6774,  0xD6AC,  0x71EF,  0x71F1,  0,       // 0x93Ex
      0xDAA7,  0x695F,  0x74E6,  0xDAA8,  0xDAA9,  0x74E7,  0xDDC3,  0xDDC6,  
      0xDDC5,  0xDDC4,  0x6C35,  0,       0xE1DF,  0x7AC7,  0xE4A4,  0xE4A2,  // 0x93Fx
      0xE4A3,  0x7BCD,  0x7BED,  0x7CA2,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_94 [] = {
      0,       0x44AE,  0xDA2D,  0x52D2,  0xB5CC,  0x596D,  0,       0xBDE2,  // 0x940x
      0,       0xCBEC,  0xD1C8,  0x652B,  0x71F3,  0xD1C7,  0,       0xD6AD,  
      0,       0,       0,       0xDAAA,  0xDDC8,  0xDDC7,  0xE1E0,  0xC0AC,  // 0x941x
      0x44B0,  0x44AF,  0x4BB3,  0x4845,  0x4BB4,  0,       0x52DA,  0xABA1,  
      0x52D4,  0x52D7,  0xABA2,  0x52D5,  0x52D6,  0x52D9,  0x52D3,  0x546B,  // 0x942x
      0x52D8,  0,       0xD8F9,  0x59DE,  0xB5CD,  0xBDE3,  0x5FF1,  0,       
      0x5FF2,  0x66A6,  0x66A7,  0,       0x66A8,  0x6221,  0x6AD8,  0x6AD9,  // 0x943x
      0,       0xD1C9,  0xD1CA,  0x6ED4,  0x6ED3,  0,       0x6ED5,  0xD6AE,  
      0x71F4,  0x66A9,  0x74E8,  0x74E9,  0,       0x6961,  0xEAB3,  0xDDCA,  // 0x944x
      0x6C36,  0x7BA3,  0x7CBF,  0xB47B,  0xC635,  0x36C6,  0,       0,       
      0x3DCA,  0x3DC8,  0x3DC9,  0x3DC6,  0x3B7D,  0x3DC5,  0x3B7C,  0xD03C,  // 0x945x
      0x3B7A,  0x416C,  0x44BA,  0x416B,  0x44B1,  0x44B9,  0xDA2F,  0x4169,  
      0x4BBB,  0x44B7,  0x4166,  0x4167,  0x416A,  0xDA32,  0x44B6,  0x44B2,  // 0x946x
      0xDA30,  0xDA31,  0xDA2E,  0xC6B3,  0x44B3,  0,       0x44B8,  0,       
      0x4BBD,  0xE431,  0xE432,  0x4BB7,  0x4BC4,  0x4BB8,  0x4849,  0x4848,  // 0x947x
      0x4BBA,  0x4BB6,  0x484F,  0x4BC2,  0x4BB9,  0xABAB,  0x4BC3,  0,       
      0xE435,  0xE433,  0xE42E,  0x4BBC,  0x4BC1,  0xCDBE,  0xE42D,  0x4BC0,  // 0x948x
      0xE42C,  0xE436,  0x4BB5,  0xE42F,  0xE434,  0,       0,       0x52DD,  
      0x4E5B,  0xABA5,  0xABB0,  0x52DC,  0x52DB,  0x4E58,  0xABA4,  0xABAA,  // 0x949x
      0x484A,  0xABAE,  0x52DE,  0x4E5E,  0xABAD,  0xABA9,  0xB5CF,  0xABAC,  
      0xD3A3,  0xD3A4,  0xABA7,  0,       0xABA8,  0,       0xABAF,  0xABB1,  // 0x94Ax
      0,       0,       0xABA3,  0xABA6,  0,       0x52DF,  0x546C,  0x59E1,  
      0x546E,  0x59E9,  0xB5D8,  0x59E8,  0x59E6,  0xB5D9,  0xB5D7,  0x59E5,  // 0x94Bx
      0x59E3,  0xB5DB,  0xB5D0,  0x59EA,  0x59E2,  0x59EB,  0x59E4,  0x59E7,  
      0x5471,  0xB5CE,  0x59E0,  0xB5DA,  0x5472,  0xB5D6,  0xB5DC,  0,       // 0x94Cx
      0xCDC0,  0xD8FA,  0xD8FC,  0xD8FD,  0xD9A1,  0xD9A2,  0xD9A3,  0,       
      0,       0xB5D2,  0,       0xB5D3,  0xB5D4,  0xB5D5,  0x59EC,  0,       // 0x94Dx
      0x59DF,  0xD8FE,  0,       0,       0,       0x59ED,  0x5975,  0x5971,  
      0x596E,  0xBDE5,  0x5FF7,  0x5979,  0x5FF8,  0x5974,  0x5FF6,  0x5FF3,  // 0x94Ex
      0x5FF5,  0x596F,  0x5FFB,  0xBDEA,  0x5972,  0xBDEC,  0x5FF4,  0xBDE7,  
      0x5978,  0xBDEB,  0xDDDE,  0xDDDF,  0xDDE0,  0xDDE1,  0xDDE2,  0xDDE3,  // 0x94Fx
      0xBDE4,  0,       0xBDE6,  0x5FF9,  0x5FFA,  0xBDE8,  0xBDED,  0,       
} ;


static const unsigned short Uni2cnsP2Table_95 [] = {
      0x66AA,  0x5E4A,  0x66B0,  0x66AE,  0x6224,  0x66AD,  0x66AB,  0xC4FB,  // 0x950x
      0x66AC,  0x5E48,  0x66B1,  0x66AF,  0xC4FC,  0xE1D5,  0xE1D6,  0xE1D7,  
      0xE1D8,  0,       0,       0xC4F9,  0xC4FA,  0,       0,       0,       // 0x951x
      0,       0xCBF6,  0x6ADD,  0xCBF0,  0xCBED,  0x6ADE,  0x622E,  0xCBF2,  
      0x6ADC,  0x6ED6,  0x6ADB,  0x6ADA,  0xCBF4,  0xCBEF,  0x622A,  0xCBEE,  // 0x952x
      0xCBF5,  0xCBF1,  0,       0,       0xE4D4,  0xE4D5,  0,       0xCBF7,  
      0xCBF3,  0,       0,       0x652E,  0x652D,  0x6EDB,  0x6ED9,  0xD1CE,  // 0x953x
      0x6EDA,  0x6532,  0xD1CD,  0x6533,  0x6ED8,  0xD1CB,  0xD1CF,  0xE6FA,  
      0x6534,  0,       0xD1D0,  0,       0,       0xD1CC,  0x6ED7,  0,       // 0x954x
      0xD0CC,  0x71F5,  0x71F6,  0xD6AF,  0x71F8,  0xD6B8,  0xDAB1,  0x677A,  
      0x6778,  0xD6B3,  0xD6B1,  0xD6B6,  0x71F7,  0x71F9,  0x71FA,  0xD6B0,  // 0x955x
      0xD6B4,  0xE8FA,  0xE8FB,  0xE8FC,  0,       0xD6B7,  0xD6B5,  0xDAB0,  
      0x74EC,  0x74EB,  0xDAAD,  0xDAAF,  0x74EA,  0xEAB4,  0xDAAB,  0,       // 0x956x
      0,       0xDAAE,  0,       0xDAAC,  0xDDD2,  0xDDD1,  0xDDCF,  0x76EC,  
      0,       0x76ED,  0x6B2E,  0x76EA,  0xDDCD,  0x6B2F,  0xDDCE,  0xEBB5,  // 0x957x
      0xDDD0,  0,       0xDDCC,  0,       0xDDCB,  0,       0x6C38,  0xE0A4,  
      0x76EB,  0x6C37,  0,       0xEBF2,  0xE0A5,  0,       0x6D2E,  0x79DA,  // 0x958x
      0,       0,       0x7AC8,  0xE3A4,  0x7AC9,  0xE3A5,  0xE3A6,  0x6E23,  
      0xE4A5,  0,       0,       0xE5CD,  0,       0,       0,       0,       // 0x959x
      0,       0xC636,  0xD03F,  0x3C21,  0xD03D,  0x3DCB,  0,       0xC0AE,  
      0,       0xD03E,  0x44BB,  0x44C0,  0x416F,  0x44BD,  0x44BE,  0xDA34,  // 0x95Ax
      0xDA36,  0x44BC,  0,       0,       0x4170,  0,       0xDA35,  0,       
      0xD333,  0,       0x44BF,  0xDA37,  0x4858,  0x4BC8,  0x4855,  0x4BC7,  // 0x95Bx
      0x4BC6,  0x4BC5,  0x4853,  0xE437,  0x4852,  0xE43B,  0xE439,  0,       
      0,       0xE438,  0,       0,       0x4E5F,  0x52E2,  0x4E62,  0xABB4,  // 0x95Cx
      0xABB3,  0xABB2,  0x52E1,  0xABB5,  0xD3A5,  0xD3A6,  0,       0,       
      0,       0,       0,       0x59EF,  0x59F7,  0x59F0,  0xB5DD,  0xB5E0,  // 0x95Dx
      0x59EE,  0x59F3,  0x59F6,  0xB5DF,  0,       0xB5E1,  0x59F4,  0x59F5,  
      0xB5DE,  0xD9A5,  0x59F2,  0x59F1,  0,       0,       0,       0,       // 0x95Ex
      0xBDF1,  0x5A25,  0x60A5,  0x60A6,  0x597B,  0x5FFC,  0xBDF0,  0x5A24,  
      0x66B2,  0x60A2,  0x5A23,  0x5FFE,  0x60A1,  0x60A4,  0x5FFD,  0x60A3,  // 0x95Fx
      0xBDEE,  0,       0xDDE4,  0xDDE5,  0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_96 [] = {
      0,       0xBDF2,  0,       0xBDEF,  0,       0x5E53,  0xC5A2,  0xC5A4,  // 0x960x
      0x66B7,  0xC5A6,  0x66B4,  0x66B8,  0x5E54,  0x66BA,  0x6231,  0x66B5,  
      0xC5A5,  0x66B6,  0x66B9,  0x66B3,  0xE1D9,  0xC5A8,  0xC5A3,  0xC5A1,  // 0x961x
      0,       0xC5A7,  0xC4FD,  0,       0x6ADF,  0x6233,  0x6234,  0x6235,  
      0x6AE0,  0xCBF9,  0xE4D6,  0xE4D7,  0xCBF8,  0xCBFA,  0xCBFB,  0xCBFC,  // 0x962x
      0,       0,       0,       0,       0,       0x6EDE,  0x6EE1,  0x6EE0,  
      0x6535,  0x6EDC,  0x6537,  0x6EDF,  0xE6FB,  0x6EE2,  0x6EDD,  0x6538,  // 0x963x
      0xD6C0,  0x677D,  0x6821,  0x71FB,  0xD6B9,  0x71FC,  0xD6BC,  0xD6BA,  
      0xE8FD,  0xD6BF,  0xD6C1,  0xD6C2,  0xD6BD,  0xD6BE,  0xD6BB,  0,       // 0x964x
      0xDAB2,  0xEAB5,  0xDAB3,  0,       0,       0,       0xDDD3,  0,       
      0,       0x78C9,  0x6C3B,  0xE0A6,  0xE0A7,  0,       0x79DB,  0xE1E1,  // 0x965x
      0,       0x79DC,  0x6D2F,  0x6D66,  0x7ACA,  0x7BA4,  0xE4A6,  0xEDA4,  
      0,       0x7CC7,  0,       0,       0xE6D5,  0,       0,       0,       // 0x966x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xBC75,  0x40B9,  0,       0xABB6,  0,       0xCBFD,  0x6AE1,  // 0x967x
      0,       0,       0xD6C3,  0,       0x6964,  0x74ED,  0,       0,       
      0xB47C,  0xB47D,  0xB522,  0xB47E,  0x30F1,  0xBC76,  0xBC78,  0x3DCC,  // 0x968x
      0x36CA,  0x36C7,  0xC63A,  0xC638,  0x36C9,  0xC639,  0xC63B,  0xD040,  
      0,       0,       0x36C8,  0xD041,  0,       0xD046,  0x3C22,  0x3DCD,  // 0x969x
      0xD044,  0xD045,  0x3C26,  0x3DCE,  0xDA38,  0x3DCF,  0xD042,  0,       
      0xC0AF,  0,       0,       0xD043,  0x3C23,  0,       0,       0,       // 0x96Ax
      0xDA42,  0xDA39,  0x44C2,  0x44C4,  0x44C1,  0x44C7,  0x4176,  0x44C3,  
      0xE443,  0x44C5,  0xDA3C,  0xDA3B,  0xE43D,  0x4173,  0xDA3A,  0xE43E,  // 0x96Bx
      0xDA3E,  0x44C8,  0xDA41,  0x52E3,  0,       0xC6B7,  0,       0xDA40,  
      0xDA3F,  0xE43C,  0,       0,       0,       0x4178,  0x44C6,  0,       // 0x96Cx
      0xE43F,  0xABB7,  0xE444,  0x4BCD,  0x4BC9,  0xE445,  0x4BCA,  0x485A,  
      0xE442,  0x4BCB,  0xABB9,  0xE441,  0,       0,       0xC6B6,  0xD3A8,  // 0x96Dx
      0,       0,       0,       0xABBA,  0,       0x4E6B,  0xABC0,  0x4E6A,  
      0x52E9,  0x52E4,  0x59F9,  0x4E68,  0x52E6,  0x52EB,  0x52E8,  0x4E6C,  // 0x96Ex
      0x52EA,  0xABBC,  0x52E5,  0xABBB,  0xBDF3,  0x52E7,  0xABBE,  0xABBD,  
      0,       0xD3A7,  0,       0x59F8,  0,       0,       0,       0,       // 0x96Fx
      0,       0xABBF,  0x5AA3,  0x5A26,  0x5AA4,  0x547B,  0xB5E6,  0xB5EA,  
} ;


static const unsigned short Uni2cnsP2Table_97 [] = {
      0x60A7,  0x59FB,  0xB5E9,  0x59FE,  0xB5E7,  0x59FC,  0xB5EF,  0x5479,  // 0x970x
      0xB5EB,  0xB5F0,  0x5AA5,  0xB5E8,  0xB5E3,  0x59FA,  0xB5E5,  0xB5E4,  
      0xB5EC,  0,       0x60A9,  0xB5EE,  0xBDF5,  0xB5E2,  0x5AA2,  0xB5ED,  // 0x971x
      0,       0,       0x59FD,  0xD9A6,  0xD9A7,  0xD9A8,  0xD9A9,  0x5AA1,  
      0,       0,       0xBDF4,  0,       0,       0,       0,       0,       // 0x972x
      0,       0,       0,       0,       0x60A8,  0x60B4,  0,       0xBDF7,  
      0x60AD,  0x60AF,  0x60B3,  0x60AB,  0xBDF6,  0x60B2,  0x60B5,  0x5A2B,  // 0x973x
      0x60B6,  0xBDF8,  0xBDFD,  0xC5AA,  0xBDFA,  0x60AA,  0xC5AB,  0xBEA1,  
      0x60AE,  0xBDF9,  0xBDFE,  0,       0,       0xDDE6,  0xDDE7,  0,       // 0x974x
      0,       0xBDFB,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x60B0,  // 0x975x
      0xBDFC,  0xC5AF,  0x66BF,  0x66BB,  0,       0x5E56,  0x5E5C,  0x60B8,  
      0x5E5D,  0x66BD,  0x60B7,  0x66BC,  0xC5AE,  0xC5AD,  0xCBFE,  0x5E5E,  // 0x976x
      0x66BE,  0xCCA2,  0,       0xD1D4,  0xC5AC,  0,       0xC5A9,  0,       
      0xC5B1,  0xE1DA,  0xE1DB,  0,       0xCCA5,  0xCCA1,  0,       0,       // 0x977x
      0x5E55,  0xC5B2,  0,       0,       0xC5B0,  0x6AE4,  0xCCA3,  0x6AE2,  
      0x623B,  0x653D,  0xD1D3,  0x6AE9,  0x6AE6,  0x6AE8,  0x6AEA,  0xD1D1,  // 0x978x
      0x6237,  0x6AE7,  0x60B9,  0x6AE3,  0xD1D2,  0x6239,  0xD1D8,  0xCCA4,  
      0xD1D7,  0x623A,  0,       0,       0,       0,       0xE4D8,  0xE4D9,  // 0x979x
      0,       0x6AE5,  0xD1D6,  0,       0,       0,       0x6AEB,  0x653E,  
      0xD1D5,  0xD1D9,  0xD1DF,  0xD6C4,  0x71FD,  0xD1E0,  0x6EE5,  0x653F,  // 0x97Ax
      0x71FE,  0x6EE4,  0xD1DE,  0xD1E2,  0x6EE3,  0xCCA7,  0xD1E1,  0,       
      0,       0,       0xD1DB,  0,       0,       0xD1DC,  0,       0xD1DD,  // 0x97Bx
      0,       0,       0xD6C5,  0,       0xD1E3,  0xD1DA,  0x72A8,  0x72A2,  
      0xD6C6,  0x6825,  0x72A4,  0x72A1,  0xD6C7,  0x72AB,  0xD6C8,  0x72AA,  // 0x97Cx
      0x72A3,  0x72A7,  0x72A5,  0xD6C9,  0x72A6,  0x72A9,  0,       0xE8FE,  
      0,       0,       0,       0x6966,  0x74EE,  0x74EF,  0xDAB7,  0xDDD4,  // 0x97Dx
      0xDAB6,  0x74F0,  0,       0xDAB5,  0,       0xEAB7,  0,       0,       
      0,       0,       0,       0xDAB4,  0x76EE,  0xDDD6,  0x76EF,  0x76F0,  // 0x97Ex
      0x78CA,  0,       0xDDD5,  0,       0,       0x78CB,  0x78CC,  0x6C3C,  
      0xE0A8,  0xE0AA,  0,       0,       0xE0A9,  0,       0x79DD,  0xE4A7,  // 0x97Fx
      0x7BA5,  0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_98 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x980x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xBC79,  0xC63C,  0,       0,       0,       0xE446,  0xABC1,  0xE448,  // 0x981x
      0,       0xE447,  0x52EC,  0x5524,  0x5525,  0,       0,       0,       
      0,       0,       0xBEA2,  0xBEA3,  0xB5F1,  0xB5F3,  0xB5F2,  0,       // 0x982x
      0,       0,       0xCCA9,  0xCCA8,  0xC5B3,  0,       0,       0,       
      0xCDF3,  0,       0xD1E4,  0,       0,       0,       0,       0xE0AB,  // 0x983x
      0,       0x6E26,  0xB2F1,  0x417C,  0xDA43,  0,       0x47D4,  0xE449,  
      0xE44A,  0xCDC1,  0xD3A9,  0,       0xE44B,  0xABC2,  0xD3AA,  0xD9AA,  // 0x984x
      0xB5F4,  0xDDE8,  0xBEA4,  0,       0xC5B6,  0x66C1,  0x66C0,  0,       
      0x66C2,  0xC5B5,  0xC5B4,  0x6AEC,  0x623D,  0x623E,  0,       0,       // 0x985x
      0xCCAA,  0,       0xD1E5,  0xE6FC,  0,       0x72AC,  0xE9A1,  0,       
      0,       0xD6CA,  0,       0,       0xDDD7,  0x7ACB,  0,       0x36CB,  // 0x986x
      0x36CC,  0x3DD0,  0xD048,  0,       0,       0xC0B1,  0xD047,  0,       
      0x44C9,  0xDA45,  0xDA44,  0xDA47,  0,       0xDA46,  0,       0x4BD1,  // 0x987x
      0xE44D,  0xE44E,  0x4BD0,  0x4861,  0xE44C,  0xE452,  0x4BCF,  0xABC3,  
      0,       0xCDC2,  0xCDC3,  0xCDC4,  0xCDC5,  0,       0xABC6,  0,       // 0x988x
      0xE44F,  0xE451,  0,       0,       0x4BD2,  0xABCA,  0x52F2,  0xABCE,  
      0xABC7,  0x5AB2,  0x52F4,  0x52F7,  0x52ED,  0x52F0,  0x52EE,  0x52F5,  // 0x989x
      0xABC4,  0x52F6,  0xABC8,  0x52F3,  0xABCB,  0xABC9,  0x52EF,  0xABC5,  
      0xABCC,  0x52F1,  0,       0xD3AB,  0,       0xD3AC,  0xD3AD,  0xABCD,  // 0x98Ax
      0,       0,       0,       0,       0,       0xB5FA,  0x552C,  0xB5F9,  
      0x5AAF,  0x552A,  0x5527,  0x552B,  0x5528,  0xB5F5,  0x5AA9,  0x5529,  // 0x98Bx
      0x5AB0,  0x5AAD,  0xB6A4,  0x5AB3,  0x5AA7,  0x5AB1,  0x5AB4,  0x5AAB,  
      0xB5FC,  0xB5FB,  0xB6A6,  0xB6A1,  0xB5F8,  0xB6A3,  0,       0x5AAA,  // 0x98Cx
      0xB6A2,  0xD9AC,  0x5AA8,  0,       0xB5FD,  0xB5FE,  0xB6A7,  0,       
      0xB6A5,  0xD9AB,  0xB5F6,  0,       0,       0xB5F7,  0x60BA,  0xBEAC,  // 0x98Dx
      0x60BB,  0xBEA6,  0x5A2F,  0xBEA7,  0xBEA5,  0x60BC,  0x5A2C,  0xBEAA,  
      0xBEAB,  0x4BD3,  0xBEA8,  0x60BE,  0x60BD,  0,       0,       0xDDE9,  // 0x98Ex
      0xDDEA,  0,       0,       0,       0,       0xC5BC,  0x66CC,  0x66CB,  
      0x66C7,  0x5E64,  0x66C9,  0x66C8,  0x5E61,  0x66C5,  0x66CE,  0x5E6D,  // 0x98Fx
      0x5E69,  0x5E6A,  0x5E66,  0x66CF,  0x66C3,  0x5E6C,  0xC5BB,  0xC5BA,  
} ;


static const unsigned short Uni2cnsP2Table_99 [] = {
      0xC5B7,  0x66CA,  0,       0,       0xE1DD,  0,       0xE1DE,  0xE1E0,  // 0x990x
      0,       0x5E6B,  0,       0,       0,       0,       0,       0xE1DC,  
      0xC5B8,  0,       0x66C4,  0xC5B9,  0,       0,       0x66CD,  0x6AED,  // 0x991x
      0x6AF3,  0x6AEF,  0x6243,  0xCCB1,  0x66D0,  0xCCAC,  0x66C6,  0x6AF1,  
      0x6AF0,  0x6AF4,  0xCCAB,  0x6AF2,  0x6AF6,  0x6242,  0x6AF7,  0xCCB2,  // 0x992x
      0xCCB4,  0x6AF5,  0xCCB3,  0xCCAD,  0xCCAE,  0xCCAF,  0xE4DB,  0,       
      0xE4DC,  0xE4DD,  0,       0xCCB0,  0,       0,       0,       0xD7B6,  // 0x993x
      0,       0,       0,       0xCCB5,  0,       0x6545,  0xD1EA,  0xD1E9,  
      0x6EEE,  0x6EE9,  0x6EEB,  0x6EE8,  0x6542,  0x6EF0,  0xE6FD,  0x6543,  // 0x994x
      0x6544,  0x6548,  0x6EF1,  0x6EF2,  0x6EE7,  0xD1E8,  0x6826,  0x6EEA,  
      0x6EEF,  0x6EEC,  0xD1EB,  0xD1EF,  0xD1F0,  0,       0xD1F1,  0xD1ED,  // 0x995x
      0xD1EC,  0,       0xE6FE,  0xE7A1,  0xD1E7,  0,       0xD1EE,  0,       
      0,       0,       0xD2A7,  0,       0xD1E6,  0,       0,       0,       // 0x996x
      0,       0,       0,       0x72AF,  0x72AE,  0x72B1,  0x6827,  0x72B2,  
      0x72B0,  0x682C,  0xD6CD,  0xD6CC,  0xD6CE,  0,       0,       0,       // 0x997x
      0,       0,       0xD6CB,  0xE9A2,  0,       0,       0,       0,       
      0xD6CF,  0xD6D0,  0x74F8,  0xDABD,  0x72B4,  0xDAC1,  0xDAB8,  0x74F1,  // 0x998x
      0xDABB,  0x72B3,  0x74F4,  0x74F7,  0x74F3,  0xDAC0,  0x696C,  0x74F5,  
      0xDAB9,  0xDABA,  0,       0,       0xDABC,  0xEAB8,  0xEAB9,  0xEABA,  // 0x999x
      0,       0x74F2,  0,       0x74F9,  0xDABF,  0,       0xDDDF,  0xDDDD,  
      0x76F1,  0x78CE,  0xDDDC,  0xDDD9,  0x76F2,  0xDDDA,  0xDDDE,  0xDDDB,  // 0x99Ax
      0xDDE0,  0,       0,       0,       0xEBB8,  0xEBB9,  0,       0,       
      0,       0,       0,       0xDDD8,  0,       0,       0x78CF,  0xE0B1,  // 0x99Bx
      0xE0B4,  0x78CD,  0xE0B3,  0xE0B6,  0xE0B5,  0xE0AF,  0xE0B0,  0xE0AC,  
      0xE0B2,  0,       0x79E2,  0xE1E3,  0x79E3,  0x79DF,  0x6D31,  0x79E0,  // 0x99Cx
      0xE1E2,  0x79DE,  0x79E1,  0x6D32,  0,       0,       0xE1E4,  0x7ACC,  
      0x7ACD,  0,       0,       0,       0x6E27,  0xE4A9,  0xE4A8,  0,       // 0x99Dx
      0x6E40,  0xE4F2,  0xE4F3,  0xE4F1,  0,       0,       0,       0,       
      0xE5CE,  0x7CA3,  0xE5EA,  0xE5FA,  0xE5FB,  0xE6C4,  0,       0,       // 0x99Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x99Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_9A [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9A0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x3DD1,  0x3C27,  0,       0,       0xDA49,  0xDA4A,  0xDA48,  // 0x9A1x
      0,       0,       0,       0xDA4B,  0x4863,  0x4865,  0x4BD5,  0xE458,  
      0x4BD4,  0x4864,  0xE456,  0xE453,  0xE454,  0,       0xE455,  0xE457,  // 0x9A2x
      0,       0,       0,       0,       0x4E72,  0x4E71,  0x52FA,  0x52F9,  
      0xABD2,  0xB6AC,  0x52F8,  0x52FB,  0x4E77,  0xABD0,  0xABD4,  0xABD1,  // 0x9A3x
      0x4E78,  0,       0xABD3,  0,       0,       0x5AB6,  0x5AB5,  0x5533,  
      0xB6AB,  0xABCF,  0xB6AA,  0xB6A9,  0,       0,       0xBEAE,  0,       // 0x9A4x
      0,       0x5A34,  0xBEB2,  0x5A32,  0xBEB3,  0x60BF,  0xBEB1,  0xBEAD,  
      0,       0,       0,       0xBEAF,  0,       0xBEB0,  0,       0x66D9,  // 0x9A5x
      0xC5BE,  0x5E6F,  0xC5BD,  0x66D7,  0xC5BF,  0x66D2,  0x6AF8,  0x66D5,  
      0x66D3,  0x66D6,  0x66D8,  0xBEB4,  0,       0,       0x66D4,  0,       // 0x9A6x
      0,       0,       0,       0,       0,       0xCCBB,  0x6AFA,  0x6AF9,  
      0xCCBA,  0xCCB7,  0x6AFC,  0x6AFD,  0x6AFB,  0xCCBD,  0xCCBE,  0,       // 0x9A7x
      0xCCB9,  0xCCB8,  0,       0,       0,       0xCCBC,  0xCCB6,  0,       
      0x654A,  0x6EF5,  0x6EF4,  0x6EF3,  0xD1F3,  0xD1F4,  0xD1F5,  0,       // 0x9A8x
      0,       0x682F,  0x72B6,  0xD6D7,  0x682E,  0x72B5,  0x72B7,  0xD6D3,  
      0xD6D4,  0x72B8,  0xD6D5,  0xE9A3,  0xD6D6,  0xD6D2,  0,       0x696D,  // 0x9A9x
      0xDAC2,  0x6970,  0xDAC3,  0x696F,  0xDAC4,  0,       0,       0,       
      0xDDE5,  0xDDE6,  0x76F3,  0x6B36,  0x76F5,  0x6B37,  0xDDE2,  0x76F4,  // 0x9AAx
      0xDDE7,  0xDDE1,  0xDDE3,  0xDDE4,  0,       0x6C3F,  0x78D0,  0,       
      0,       0,       0x6D34,  0xE1E5,  0,       0,       0xEBBA,  0xE3A7,  // 0x9ABx
      0x7ACE,  0xE3A8,  0,       0xE4AA,  0xE4F4,  0,       0x7BEE,  0x4223,  
      0x4866,  0x46E4,  0x4BD6,  0xE45A,  0xCDC6,  0xCDC7,  0xCDC8,  0,       // 0x9ACx
      0,       0xE459,  0xABD6,  0xD3AE,  0xD3AF,  0,       0xB6AE,  0xB6AD,  
      0xD9AD,  0xD9AE,  0,       0,       0,       0x5A36,  0,       0x60C0,  // 0x9ADx
      0xDDEB,  0xDDEC,  0xC5C0,  0,       0xE1E1,  0xE1E2,  0xCCBF,  0xE4DF,  
      0x6EF6,  0xE7A2,  0xE7A3,  0xE7A4,  0xE7A5,  0x6831,  0xD6D8,  0xDAC5,  // 0x9AEx
      0xDDE8,  0xDDE9,  0xDDEA,  0xE0B7,  0xEBF3,  0xE1E6,  0xE1E7,  0xE3A9,  
      0xE4AB,  0x6E28,  0,       0xE5FC,  0xD049,  0,       0,       0xD04A,  // 0x9AFx
      0,       0xDA4D,  0xDA4C,  0,       0xC6BA,  0xC0E9,  0,       0x4868,  
} ;


static const unsigned short Uni2cnsP2Table_9B [] = {
      0x4BD8,  0xE460,  0,       0xE45F,  0xE45D,  0,       0,       0,       // 0x9B0x
      0,       0xE461,  0xE45B,  0xE45C,  0,       0,       0,       0x4BD7,  
      0x4BDA,  0x52FE,  0xABD7,  0xABDA,  0x4E7E,  0xABD8,  0x53A4,  0x4F22,  // 0x9B1x
      0xABDB,  0x53A3,  0x4E7C,  0x4E7D,  0x52FC,  0x4E7A,  0x52FD,  0x53A2,  
      0x53A1,  0xABDC,  0xABD9,  0,       0,       0,       0xD3B0,  0xD3B1,  // 0x9B2x
      0xD3B2,  0xD3B3,  0,       0,       0,       0,       0,       0,       
      0xB6AF,  0x5537,  0xB6B1,  0x5ABA,  0xB6B0,  0x5539,  0x5534,  0x553B,  // 0x9B3x
      0x5AB7,  0x5AB9,  0x553A,  0x5538,  0xB6B3,  0x5AB8,  0,       0xD9AF,  
      0xD9B0,  0xD9B1,  0xD9B3,  0xB6B2,  0,       0,       0,       0x5A3A,  // 0x9B4x
      0x5A3C,  0xBEBA,  0x60C1,  0x60C4,  0x60C2,  0xBEB8,  0x60C5,  0x60C6,  
      0x60C3,  0xBEB5,  0x5A39,  0xBEB6,  0,       0xDDED,  0xDDEE,  0xDDEF,  // 0x9B5x
      0xBEB7,  0,       0xBEB9,  0,       0,       0xBEBB,  0xC5C2,  0x66DE,  
      0x5E71,  0x66DC,  0x66E0,  0x66DF,  0xC5C4,  0x66E1,  0xCCC0,  0xC5C3,  // 0x9B6x
      0x5E72,  0x66DA,  0x5E78,  0x66DB,  0,       0xE1E3,  0xE1E5,  0,       
      0,       0,       0,       0,       0,       0,       0,       0x66DD,  // 0x9B7x
      0xC5C1,  0xE1E4,  0x624D,  0xCCC3,  0xCCC7,  0x6AFE,  0x6BA1,  0x6BA3,  
      0x6250,  0xCCC8,  0xCCC6,  0xCCC1,  0x6BA4,  0x6BA2,  0xCCC5,  0xCCC2,  // 0x9B8x
      0x624B,  0xCCC4,  0,       0xE4E0,  0xE4E1,  0xE4E3,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x6EFC,  0xD1F6,  // 0x9B9x
      0x6EF7,  0x6EFB,  0x6EFA,  0x6EF9,  0x6550,  0x654C,  0x6EFE,  0x6EF8,  
      0x654B,  0xD1F7,  0xD1F8,  0xD1FB,  0,       0,       0xD1FC,  0xE7A6,  // 0x9BAx
      0xE7A7,  0xE7A8,  0,       0,       0,       0,       0x6EFD,  0x72BB,  
      0x72BE,  0x72BA,  0xD6D9,  0x6832,  0x6834,  0x72B9,  0x6833,  0x72BD,  // 0x9BBx
      0xD6DA,  0x72BC,  0xD6DE,  0,       0xE9A4,  0xD6DB,  0xD6DC,  0,       
      0,       0,       0,       0x75A1,  0x74FC,  0xDAC6,  0x75A2,  0x74FE,  // 0x9BCx
      0x74FB,  0x75A5,  0x75A4,  0x75A3,  0x74FD,  0x75A6,  0xD6DD,  0x6973,  
      0xDAC7,  0xDAC8,  0,       0,       0xEABB,  0,       0xEABC,  0,       // 0x9BDx
      0,       0,       0,       0x76F7,  0x6B38,  0x6B39,  0x76F6,  0xDDEC,  
      0xDDED,  0,       0,       0,       0xDDEB,  0xEBBB,  0x6C40,  0xE0B8,  // 0x9BEx
      0x78D1,  0x6C44,  0,       0,       0,       0x6C42,  0,       0,       
      0x79E5,  0xE1E8,  0x79E4,  0x6D36,  0xECC2,  0xECC3,  0,       0,       // 0x9BFx
      0xE1E9,  0,       0x7ACF,  0xE3AA,  0,       0,       0,       0xE3AB,  
} ;


static const unsigned short Uni2cnsP2Table_9C [] = {
      0,       0xE4AC,  0x6E29,  0x7BA6,  0xECF2,  0xE4F7,  0xE4F6,  0x7BCE,  // 0x9C0x
      0,       0x6E54,  0xA33D,  0xA33C,  0x44CB,  0x4BDB,  0x4BDC,  0xE462,  
      0xABDD,  0xB6B4,  0xBEBC,  0xC5C5,  0x5E79,  0xD1FE,  0xD6DF,  0x72C0,  // 0x9C1x
      0,       0xDAC9,  0,       0,       0xE0BA,  0xE0B9,  0x78D3,  0x7BCF,  
      0xABDE,  0x4F23,  0x553C,  0xC5C6,  0xD2A1,  0xD6E1,  0xD6E0,  0xDACA,  // 0x9C2x
      0xDDEE,  0xECF3,  0x7BD0,  0x4224,  0xDA4E,  0xE464,  0xE463,  0xABDF,  
      0,       0xB6B8,  0x553E,  0x5ABB,  0xB6B6,  0xB6B5,  0x553D,  0xB6B7,  // 0x9C3x
      0,       0x60C7,  0,       0,       0xBEBD,  0,       0x5E7A,  0xC5C8,  
      0xC5C9,  0xC5C7,  0,       0xCCC9,  0x6BA5,  0xCCCA,  0,       0x6551,  // 0x9C4x
      0xD2A4,  0xD2A3,  0xD2A2,  0xD2A5,  0xD6E2,  0x6835,  0xD6E4,  0x72C2,  
      0xD6E3,  0xD6E5,  0xD6E6,  0x75A7,  0xDACC,  0,       0xDDF1,  0xDDF2,  // 0x9C5x
      0x76F8,  0x6975,  0x6B3A,  0xDDF0,  0x76F9,  0xDDEF,  0,       0xDDF3,  
      0x6C46,  0x6C45,  0xDDF4,  0xE0BB,  0xE1EB,  0xE1EC,  0x7AD0,  0xE3AC,  // 0x9C6x
      0xE3AD,  0xE3AE,  0,       0x6E2A,  0xE4AD,  0xE4F9,  0,       0xE4F8,  
      0xE4FA,  0xE5CF,  0x7CA4,  0x6E51,  0x7CAD,  0xE5FD,  0,       0xE6CA,  // 0x9C7x
      0xE6CB,  0xD04B,  0x3DD3,  0,       0,       0xDA52,  0x44CE,  0xDA51,  
      0x4226,  0x44CC,  0xDA50,  0x44CD,  0x4225,  0xDA4F,  0xB9B0,  0xB9AF,  // 0x9C8x
      0xDA53,  0,       0x4BDF,  0x4BE0,  0x4BE1,  0x4BDE,  0x4BDD,  0x4BE2,  
      0xE468,  0xE465,  0,       0,       0xE469,  0xCDC9,  0xCDCA,  0xCDCB,  // 0x9C9x
      0xE46B,  0xE466,  0xE46E,  0xE46C,  0xE46D,  0xE46A,  0xE467,  0,       
      0,       0x4F27,  0x53A9,  0xABE1,  0,       0xABE0,  0x53A8,  0x53AB,  // 0x9CAx
      0x5AC1,  0x53AA,  0x4F26,  0xABE3,  0x53A5,  0,       0xD3B4,  0xD3B5,  
      0xD3B6,  0,       0,       0x53A7,  0,       0,       0xABE2,  0,       // 0x9CBx
      0,       0x53A6,  0,       0x5ABC,  0xB6BA,  0x5AC5,  0x5AC3,  0xB6B9,  
      0x5540,  0x5AC4,  0xB6BB,  0,       0xD9B4,  0x5ABE,  0x5ABD,  0x5ABF,  // 0x9CCx
      0x5AC2,  0xB6BC,  0,       0x5AC0,  0x5A3D,  0x60C9,  0x60CC,  0x60D0,  
      0x5A3E,  0xBEBE,  0x60C8,  0x60CA,  0x60CF,  0x60CD,  0xBEC0,  0,       // 0x9CDx
      0xBEC1,  0xBEC3,  0xDDF0,  0xDDF1,  0xDDF2,  0x60CE,  0,       0xBEBF,  
      0xBEC2,  0x60CB,  0x66E3,  0xC5CB,  0x5E7B,  0x66E9,  0xC5CE,  0x66E7,  // 0x9CEx
      0x66E5,  0xC5CF,  0xC5CC,  0,       0xE1E7,  0xC5CA,  0xC5D1,  0x66E2,  
      0xC5CD,  0xC5D0,  0x66E6,  0,       0,       0x6BA6,  0x6BA9,  0xCCCB,  // 0x9CFx
      0x6BA7,  0xCCCC,  0xCCCD,  0,       0xE4E4,  0xE4E5,  0xE4E6,  0xE4E7,  
} ;


static const unsigned short Uni2cnsP2Table_9D [] = {
      0x66E4,  0,       0,       0x6BA8,  0,       0,       0xD2AB,  0x6552,  // 0x9D0x
      0xD2AA,  0x6FA1,  0xD2A9,  0xD2A8,  0,       0x6FA2,  0xD2A6,  0xE7A9,  
      0x72C4,  0x72C6,  0x72C8,  0x6837,  0xD6E7,  0xD6E8,  0xE9A5,  0,       // 0x9D1x
      0x72C5,  0x72C3,  0,       0xD6E9,  0x72C7,  0x75AA,  0x6251,  0xDAD0,  
      0x6978,  0x75A8,  0xDACE,  0x6979,  0x75AB,  0,       0xEABD,  0,       // 0x9D2x
      0x75AC,  0x75A9,  0x697A,  0xE7AA,  0,       0xDACD,  0x76FB,  0x76FA,  
      0xE9A6,  0x78D4,  0x78D5,  0x6C47,  0xE0BF,  0,       0xE0BE,  0xE0C0,  // 0x9D3x
      0xE0BD,  0,       0x79E7,  0x79E6,  0,       0xECC4,  0,       0xE3AF,  
      0x6E2B,  0xE4AE,  0xE4AF,  0,       0x6E41,  0x7BD1,  0,       0x7BEF,  // 0x9D4x
      0x7CA5,  0,       0x7CC0,  0x3043,  0x422A,  0x4227,  0xDA55,  0x4228,  
      0xDA56,  0x44CF,  0,       0xC6BB,  0xE46F,  0x4BE5,  0x486C,  0x4BE3,  // 0x9D5x
      0xCDCC,  0xCDCD,  0,       0x4BE6,  0,       0,       0,       0,       
      0x4F2F,  0x4F33,  0x4F31,  0x4F2D,  0xABE8,  0x53B1,  0x53B0,  0xABE5,  // 0x9D6x
      0xABE4,  0x53AE,  0x4F38,  0x53B3,  0x53AC,  0x53AD,  0xABEC,  0xABE6,  
      0x4F36,  0x53B2,  0,       0xD3B7,  0xD3BA,  0xD3BD,  0xABEB,  0xABE7,  // 0x9D7x
      0xABE9,  0x4F2E,  0,       0,       0xD3B9,  0,       0,       0,       
      0x53AF,  0x5AC8,  0x5AC6,  0xB6BD,  0x5AC9,  0x5546,  0x5A46,  0x5ACE,  // 0x9D8x
      0x5ACD,  0x5549,  0xB6C3,  0xB6BE,  0xB6C1,  0xB6C0,  0x5ACC,  0,       
      0,       0xB6C4,  0xD9B6,  0xD9B7,  0xD9B9,  0xD9BA,  0x5ACB,  0,       // 0x9D9x
      0,       0,       0xB6C2,  0xD9B5,  0,       0,       0x5AC7,  0,       
      0xB6BF,  0,       0x60D6,  0x5A48,  0x60D7,  0x60D4,  0x60D2,  0x5A47,  // 0x9DAx
      0xBECB,  0x60D5,  0xBEC6,  0xBECD,  0xBEC5,  0x5A4B,  0xBECC,  0x60DA,  
      0x60D8,  0xBEC4,  0,       0,       0,       0,       0x5A4A,  0xC6BC,  // 0x9DBx
      0xDDF3,  0xDDF4,  0xDDF5,  0xDDF7,  0xDDF9,  0xBEC8,  0,       0x60DB,  
      0,       0,       0x60D3,  0xBECA,  0,       0,       0,       0,       // 0x9DCx
      0,       0,       0,       0x60D1,  0x60D9,  0x66F7,  0x66F4,  0x66F0,  
      0x66EB,  0xC5D3,  0x5F28,  0x66ED,  0xC5D2,  0x66EA,  0x66F1,  0x66F5,  // 0x9DDx
      0x66F2,  0x66EF,  0x66EC,  0,       0xC5D4,  0xE1E8,  0xE1E9,  0xE1EA,  
      0xE1EB,  0xE1EC,  0xE1ED,  0xE1EE,  0xE1EF,  0xE1F1,  0xE1F3,  0,       // 0x9DEx
      0,       0,       0,       0,       0xC5D5,  0,       0xBEC7,  0,       
      0,       0,       0,       0,       0x66F6,  0x66F3,  0,       0xCCDB,  // 0x9DFx
      0xCCD8,  0x625E,  0xCCD2,  0x6BAD,  0x6252,  0x6BAF,  0xCCCF,  0xCCD1,  
} ;


static const unsigned short Uni2cnsP2Table_9E [] = {
      0x625F,  0x66F8,  0x6263,  0x6BB2,  0x625B,  0xCCCE,  0x625A,  0x6265,  // 0x9E0x
      0xCCDA,  0xCCD3,  0xCCD9,  0x6258,  0xCCD5,  0x6BB6,  0x6BAE,  0xCCD0,  
      0x6BB4,  0,       0xE4EE,  0,       0,       0,       0,       0xE4E8,  // 0x9E1x
      0xE4EA,  0xE4EC,  0xE4EF,  0xE4F0,  0xE4F1,  0,       0,       0x6BB0,  
      0xCCD4,  0,       0xCCD7,  0,       0,       0x6253,  0,       0x6BB7,  // 0x9E2x
      0x6BAA,  0,       0,       0,       0,       0xE4E9,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9E3x
      0,       0x6BAC,  0xE1F0,  0,       0xCCD6,  0,       0x6FA7,  0xD2AE,  
      0x6FA6,  0x6BB8,  0x6FA9,  0xD2AC,  0x6558,  0x6FAB,  0xD2AF,  0xD2AD,  // 0x9E4x
      0x6FA8,  0x6556,  0x6FA4,  0xD2B2,  0x655E,  0x6FA5,  0x6FA3,  0x6560,  
      0xD2B0,  0x6FAC,  0xD2B4,  0,       0,       0,       0xE7AB,  0xE7AC,  // 0x9E5x
      0xE7AD,  0xE7AF,  0xE7B0,  0xE7B1,  0xE7B2,  0,       0xE7AE,  0,       
      0,       0,       0x6FAA,  0,       0,       0,       0,       0,       // 0x9E6x
      0xE7B4,  0,       0,       0,       0,       0,       0,       0,       
      0,       0x72CA,  0x683F,  0x72CF,  0x72D3,  0x77A3,  0x72C9,  0x72D2,  // 0x9E7x
      0x6838,  0xD6F1,  0x72CC,  0xD6F2,  0x72D7,  0xD6ED,  0x72D4,  0x72CD,  
      0xD6F3,  0xD6F5,  0xD6EA,  0xD6F4,  0x72D6,  0xD6EE,  0xD6EF,  0,       // 0x9E8x
      0,       0,       0,       0,       0,       0xE9A8,  0xE9A9,  0xE9AB,  
      0xE9AC,  0xE9AD,  0xE9AE,  0xE9AF,  0xE9B0,  0xE9B1,  0xE9B2,  0,       // 0x9E9x
      0,       0xD6EB,  0xD6EC,  0x72D5,  0xD6F0,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x9EAx
      0,       0,       0,       0x72D0,  0,       0xDAD4,  0xDAD2,  0x75B2,  
      0x6A22,  0x75AE,  0x75AF,  0xDADA,  0xDAD7,  0x75B0,  0xDADC,  0xDAD9,  // 0x9EBx
      0x75B4,  0xDAD6,  0xDADB,  0xDAD3,  0xDAD5,  0xDAD1,  0xDADE,  0,       
      0,       0,       0,       0,       0,       0xEAC1,  0xEAC2,  0xEAC3,  // 0x9ECx
      0xEAC0,  0xDADF,  0x75B3,  0xDAD8,  0,       0xDADD,  0,       0,       
      0,       0,       0,       0,       0,       0,       0x75B1,  0,       // 0x9EDx
      0x76FE,  0xDDF8,  0x77A2,  0x6B3E,  0x6B3F,  0x76FC,  0xDDF7,  0x655C,  
      0xE0C6,  0xDDF5,  0xDEA2,  0xDDF6,  0x76FD,  0xDEA1,  0xDDFC,  0x77A1,  // 0x9EEx
      0xDDF9,  0,       0xEBBD,  0xEBBF,  0,       0,       0,       0,       
      0,       0,       0xDDFA,  0,       0xDDFD,  0xDDFE,  0xDDFB,  0,       // 0x9EFx
      0xEBBC,  0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_9F [] = {
      0,       0,       0xE0C3,  0x78DC,  0x78E0,  0x78DA,  0xE0C1,  0x6C4F,  // 0x9F0x
      0x6C4C,  0x78D9,  0x78E1,  0x6C4B,  0x78DF,  0x78DE,  0x78D7,  0,       
      0xE0CB,  0xE0C7,  0x78D8,  0,       0,       0,       0xEBF5,  0xEBF8,  // 0x9F1x
      0xE0C8,  0,       0,       0,       0xE0C2,  0xE0C4,  0xE0C5,  0x78DD,  
      0xE0CA,  0xE0C9,  0,       0,       0,       0xE1F3,  0x79E8,  0x6D38,  // 0x9F2x
      0x79E9,  0xE1EE,  0xE0FA,  0xE1F1,  0xE1EF,  0x79EB,  0xE1F2,  0,       
      0,       0xE1F0,  0xECC5,  0xECC6,  0x79EA,  0xE1ED,  0,       0,       // 0x9F3x
      0,       0,       0,       0xE3B5,  0xE3B0,  0xE3B2,  0xE3B3,  0xE3B4,  
      0x7AD1,  0x7AD2,  0xECDA,  0xECDB,  0xECDC,  0,       0,       0,       // 0x9F4x
      0xECDD,  0,       0,       0,       0xE3B1,  0x7BA8,  0x7BA7,  0xE4B0,  
      0x7BA9,  0xECF4,  0,       0xE4B1,  0,       0x7BAA,  0,       0,       // 0x9F5x
      0xE4B2,  0,       0xE4FE,  0x7BD3,  0x7BD2,  0x7BD5,  0xE4FC,  0xE5A1,  
      0xE4FB,  0x7BD4,  0,       0xE4FD,  0,       0,       0xECF5,  0x7BF3,  // 0x9F6x
      0x7BF2,  0x7BF1,  0x7BF0,  0xE5D0,  0x7CA6,  0xEDAB,  0xEDAC,  0,       
      0x7CA7,  0xE5EB,  0,       0x7CAE,  0,       0x7CB7,  0xE6AF,  0x7CB6,  // 0x9F7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xD3BC,  0,       0,       0,       0,       0,       0,       0,       // 0x9F8x
      0,       0xDDF8,  0,       0,       0,       0xEBBE,  0,       0xD04C,  
      0xC0B3,  0xD04D,  0x422B,  0xDA57,  0x44D1,  0x44D2,  0xDA5C,  0xDA58,  // 0x9F9x
      0xDA59,  0x44D0,  0,       0xDA5A,  0xDA5B,  0xE470,  0x4BEA,  0xE471,  
      0x4BE9,  0x486E,  0x486F,  0xE472,  0xE473,  0xE474,  0x4870,  0x4BE8,  // 0x9FAx
      0,       0xCDCF,  0xCDD0,  0xCDD1,  0x4BE7,  0,       0,       0,       
      0x4F45,  0xABF2,  0xABFD,  0xABEF,  0xABF3,  0xABF9,  0x53B7,  0x53BB,  // 0x9FBx
      0x53BD,  0x53B9,  0xABF6,  0xABFC,  0x53BF,  0x53B4,  0x4F3D,  0x53C1,  
      0x53BE,  0x53B5,  0x4F3E,  0x53C2,  0xABFA,  0x4F3C,  0xABF5,  0x4F43,  // 0x9FCx
      0x4F3A,  0x53C3,  0x4F46,  0xABF0,  0xABFB,  0,       0,       0xD3C0,  
      0xABEE,  0xABF7,  0xABF8,  0x53B6,  0x53BA,  0x53C0,  0xABF1,  0xABF4,  // 0x9FDx
      0,       0,       0,       0x53BC,  0xB6CB,  0x5AD4,  0x5AD6,  0x5AD1,  
      0x5ACF,  0x554C,  0x5AD3,  0x5AD9,  0x5AD2,  0xB6D7,  0xB6D2,  0x5AD7,  // 0x9FEx
      0x5556,  0xB6D4,  0x5AD8,  0xB6D0,  0x5AD5,  0xB6D3,  0xB6CC,  0,       
      0,       0xB6C5,  0xB6CE,  0xD9BD,  0xD9BE,  0xD9BF,  0xD9C0,  0xB6CD,  // 0x9FFx
      0xB6CF,  0,       0,       0,       0xB6D8,  0,       0,       0,       
} ;


static const unsigned short Uni2cnsP2Table_A0 [] = {
      0xB6D6,  0xB6C7,  0,       0,       0,       0,       0,       0xB6C8,  // 0xA00x
      0xB6D5,  0x5553,  0x5551,  0xD04E,  0xB6C9,  0x5AD0,  0,       0xB6C6,  
      0,       0xD6B3,  0xBED1,  0x5A4C,  0x60DE,  0x60E9,  0xBED4,  0x5A53,  // 0xA01x
      0x60E7,  0xBED5,  0x60DD,  0x60E1,  0,       0xBECE,  0x60E4,  0x60EB,  
      0x60E0,  0x60E2,  0x5A54,  0xBED7,  0x60DC,  0x60E3,  0x5A58,  0xBECF,  // 0xA02x
      0x5A5B,  0x60EC,  0xBED8,  0xBED3,  0x60E8,  0x60EA,  0,       0,       
      0xDDFA,  0xDDFB,  0xDDFC,  0xDDFD,  0xDEA1,  0xDEA2,  0xDEA3,  0xDEA5,  // 0xA03x
      0xBED0,  0,       0x60DF,  0,       0x5A5A,  0xBED6,  0,       0x60E5,  
      0x60E6,  0,       0,       0,       0,       0,       0,       0,       // 0xA04x
      0xBED2,  0x5A57,  0xC5DB,  0x60ED,  0xC5DF,  0x66FD,  0x67A5,  0x67A7,  
      0x5F2E,  0x67AA,  0x66FA,  0x67A1,  0x66FE,  0x66FB,  0xC5DD,  0xC5D8,  // 0xA05x
      0x5F2D,  0xC5DE,  0x66FC,  0x67AB,  0x5F30,  0xC5E7,  0x67A2,  0xC5E4,  
      0xC5DC,  0x67A8,  0xC5E1,  0xC5E2,  0xC5E6,  0x67A4,  0xC5D9,  0x67A3,  // 0xA06x
      0xC5E8,  0xC5D6,  0xC5E0,  0xE1F4,  0xE1F5,  0xC5D7,  0x67A9,  0,       
      0xC5E3,  0,       0x6BB9,  0,       0,       0,       0,       0xCCDD,  // 0xA07x
      0x6BBA,  0xCCE2,  0,       0x6BBE,  0x6BCA,  0x6BC0,  0xCCEA,  0xCCE4,  
      0x6BBB,  0xCCE8,  0xCCEB,  0xCCE3,  0x6BCC,  0x6BBD,  0x6BCB,  0x626B,  // 0xA08x
      0x6BC2,  0x6BC5,  0xCCE0,  0xCCDE,  0x6BC8,  0x6BC4,  0xCCDC,  0xCCE6,  
      0xCCEC,  0x6BC1,  0,       0x626D,  0xCCE9,  0x6BC6,  0,       0xE4F4,  // 0xA09x
      0xE4F6,  0xE4F7,  0xCCE1,  0x6BC7,  0,       0xCCEF,  0x6BC9,  0xC5E9,  
      0,       0xCCE5,  0,       0xCCE7,  0,       0xCCED,  0,       0,       // 0xA0Ax
      0,       0,       0x6BC3,  0,       0,       0xCCEE,  0,       0,       
      0,       0,       0,       0,       0xCCDF,  0x6269,  0x6FB8,  0x6FB0,  // 0xA0Bx
      0xD2BA,  0x6565,  0x6FBE,  0xD2C3,  0x6FB2,  0x6FC2,  0x6270,  0xD2B6,  
      0x6FAF,  0x6563,  0x6FB1,  0x656E,  0x6568,  0x6FB3,  0x6FAD,  0x6FB7,  // 0xA0Cx
      0x6FC4,  0x6FB9,  0x656D,  0x6566,  0x6FBA,  0x6FBC,  0x6FC0,  0x6567,  
      0x6FAE,  0x6FBB,  0x6FB6,  0x6FBF,  0xD2BF,  0xD2BB,  0xD2C0,  0xD2B5,  // 0xA0Dx
      0xD2B7,  0,       0x6FBD,  0x6FB5,  0x6FB4,  0x6FC3,  0,       0,       
      0xD2B8,  0,       0xE7B7,  0,       0xD2BE,  0,       0xD2BD,  0xD2B9,  // 0xA0Ex
      0,       0xD2C4,  0xD2C1,  0,       0,       0,       0,       0xD2BC,  
      0,       0,       0,       0xE7B8,  0,       0,       0x6FC1,  0,       // 0xA0Fx
      0,       0xC5DA,  0x72DE,  0xD6F9,  0x72E6,  0xD6FE,  0x72DD,  0x72E0,  
} ;


static const unsigned short Uni2cnsP2Table_A1 [] = {
      0x72DB,  0x72E5,  0x72E4,  0xD7A1,  0xD6FD,  0xD6FA,  0x72E8,  0xD7A7,  // 0xA10x
      0,       0xD7A6,  0xD7A4,  0x72DC,  0x72E1,  0x6FC5,  0x72DA,  0x72E2,  
      0xD7A2,  0xD6FC,  0x72E9,  0x72EA,  0xE9B4,  0,       0,       0x72DF,  // 0xA11x
      0xD7A3,  0,       0,       0xD6F7,  0xD7A8,  0,       0xD6F6,  0,       
      0xD6FB,  0,       0,       0xE9B3,  0,       0,       0,       0,       // 0xA12x
      0,       0x72D8,  0xD6F8,  0x72D9,  0xE7B6,  0x75C2,  0x75BD,  0x6A24,  
      0x6A2D,  0x75BC,  0x6A28,  0x75C3,  0x75B9,  0x6FC6,  0x75C4,  0x75C0,  // 0xA13x
      0x75BF,  0x6A2B,  0,       0xDAE2,  0xDAEC,  0xDAEA,  0xDAF0,  0x6A2A,  
      0xDAEB,  0xDAEE,  0x75BB,  0x6A29,  0xDAE9,  0x75B7,  0xDAE8,  0x75B8,  // 0xA14x
      0x75C6,  0x72E7,  0xDAF1,  0x75C1,  0xDAEF,  0xDAE7,  0xD7A5,  0,       
      0,       0xEAC4,  0xEAC5,  0xEAC6,  0xEAC7,  0xEAC8,  0x75BE,  0,       // 0xA15x
      0,       0,       0xDAE6,  0,       0xDAE4,  0,       0,       0xDAE1,  
      0,       0xDAE3,  0,       0,       0,       0,       0,       0,       // 0xA16x
      0,       0,       0,       0,       0,       0,       0x75BA,  0xDEAB,  
      0xDEA7,  0xDEB1,  0x77B3,  0xDEAF,  0x77AE,  0x77A9,  0x6B43,  0xDEB2,  // 0xA17x
      0xDEB6,  0x77A5,  0x77B0,  0x77AA,  0x77A8,  0x77AF,  0xDEAC,  0x77A7,  
      0x77A6,  0x77B8,  0x77AB,  0x6B49,  0x6B42,  0xDEB5,  0x77B1,  0xDEB0,  // 0xA18x
      0xDEB3,  0x77AD,  0xDAE5,  0x77B5,  0xDAED,  0xDEB4,  0,       0,       
      0,       0x77B6,  0,       0,       0xDEAD,  0xEBC0,  0xDEA4,  0xDEA6,  // 0xA19x
      0,       0,       0xDEAE,  0,       0,       0xDEA9,  0,       0,       
      0,       0xDEA8,  0,       0,       0,       0,       0,       0,       // 0xA1Ax
      0x77B2,  0xDEAA,  0xDEA5,  0x6B41,  0xEBFA,  0xDEB7,  0xE0CD,  0x78E7,  
      0x78E9,  0x78ED,  0x78E5,  0x77B7,  0x78E8,  0xE0CE,  0x78EA,  0x78EB,  // 0xA1Bx
      0xE0CF,  0xE0D0,  0xE0D4,  0x78EC,  0xE0D3,  0xE0CC,  0xE0D1,  0x78E3,  
      0,       0x78E6,  0x78E2,  0xEBF9,  0xE0D2,  0,       0x6C55,  0,       // 0xA1Cx
      0,       0x78E4,  0x6C53,  0,       0,       0,       0,       0,       
      0,       0x79F1,  0x79ED,  0x79F0,  0xE1F6,  0x6D3B,  0x79EE,  0x79EC,  // 0xA1Dx
      0x6D3C,  0,       0xE1F4,  0,       0x79EF,  0xE1F8,  0,       0,       
      0xE1F5,  0xE1F7,  0,       0,       0,       0,       0,       0,       // 0xA1Ex
      0,       0,       0,       0,       0x6D3E,  0x7AD8,  0xE3B9,  0x7AD6,  
      0x6D6B,  0x7ADA,  0x7AD9,  0x7AD5,  0x7AD7,  0x6D6A,  0xE3B8,  0x7AD4,  // 0xA1Fx
      0xE3BB,  0x7ADB,  0xE3BD,  0xECDE,  0xE3BA,  0,       0,       0xE3B6,  
} ;


static const unsigned short Uni2cnsP2Table_A2 [] = {
      0,       0xE3BC,  0,       0x7BAE,  0xE4B4,  0xE4B6,  0x7BAF,  0x7BAC,  // 0xA20x
      0,       0x7BAB,  0x7BB1,  0x7BB0,  0x7BAD,  0xE4B7,  0xECF6,  0,       
      0x6E2E,  0,       0xE4B3,  0xE4B5,  0,       0,       0,       0,       // 0xA21x
      0x7BD6,  0xE5A2,  0xE5D3,  0xE5A4,  0xE5A6,  0xE5A3,  0xE5A7,  0x7BD7,  
      0,       0,       0xE5A5,  0,       0x6E42,  0x7BF4,  0xE5D4,  0xE5D5,  // 0xA22x
      0x7BF5,  0xE5D2,  0xE5D6,  0xE5D1,  0,       0,       0xE5ED,  0xE5EC,  
      0x7CA9,  0x7CA8,  0xEDB2,  0,       0x7CAF,  0xE6A1,  0,       0xE5FE,  // 0xA23x
      0x7CB8,  0xE6B0,  0x7CB9,  0xE6BA,  0x7CC1,  0xEDB7,  0,       0x7CC8,  
      0xE6C5,  0,       0,       0,       0,       0,       0,       0,       // 0xA24x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x4871,  0x4872,  // 0xA25x
      0x53C4,  0xACA2,  0xACA1,  0xABFE,  0x5ADA,  0x5ADC,  0xB6DA,  0xB6DB,  
      0xD9C1,  0xB6D9,  0,       0x67AC,  0xBED9,  0,       0x6271,  0xCCF0,  // 0xA26x
      0x6BCD,  0xCCF1,  0,       0,       0,       0xD2C6,  0x6FC8,  0x6FC9,  
      0xD2C7,  0x6FC7,  0xD2C9,  0xD2C8,  0,       0x6845,  0xD7AB,  0xD7AA,  // 0xA27x
      0x72EB,  0,       0xDAF3,  0,       0xDAF2,  0,       0,       0x6B4C,  
      0xDEB8,  0xDEB9,  0x77B9,  0xE0D5,  0x6C57,  0,       0x79F2,  0x6D3F,  // 0xA28x
      0xE3BE,  0x7BB2,  0,       0xDA5D,  0xC6BD,  0x4BEC,  0xCDD2,  0xACA8,  
      0x53C5,  0xACA7,  0,       0xACA6,  0xACA4,  0x53C6,  0xACA5,  0x53C7,  // 0xA29x
      0xACA9,  0xACA3,  0,       0xB6DD,  0x5ADD,  0,       0xD9C2,  0,       
      0xD9C3,  0xD9C4,  0,       0,       0,       0x60EF,  0x60F2,  0x60F0,  // 0xA2Ax
      0x5A5C,  0,       0x60F3,  0x60F1,  0xBEDB,  0xBEDA,  0,       0xBEDE,  
      0,       0xBEDD,  0xDEA6,  0x60EE,  0xC5EE,  0x67B1,  0x67AE,  0x67AD,  // 0xA2Bx
      0xC5EB,  0xC5ED,  0xC5EA,  0x67B0,  0xC5EC,  0xE1F8,  0xE1F9,  0xE1FA,  
      0,       0,       0,       0x67AF,  0x6BCF,  0x6BCE,  0x6BD1,  0x6273,  // 0xA2Cx
      0xCCF3,  0x6BD0,  0,       0xCCF2,  0,       0x68C0,  0xD2CB,  0x6274,  
      0x656F,  0xCCF4,  0xE7B9,  0,       0xD2CA,  0xD2CC,  0x6FCA,  0x6847,  // 0xA2Dx
      0xD7AC,  0xD7AD,  0x6846,  0xE9B5,  0x75C7,  0x6A2E,  0xEAC9,  0,       
      0,       0x77BA,  0x77BC,  0x77BB,  0,       0xDEBA,  0,       0xDEBB,  // 0xA2Ex
      0,       0,       0xE0D6,  0x6C58,  0xE0D7,  0xEBFB,  0x79F5,  0x79F4,  
      0x78EE,  0,       0x6D40,  0x6D6C,  0xECC7,  0,       0,       0xE5A8,  // 0xA2Fx
      0xE5D7,  0,       0x7CC6,  0xE6C7,  0xDA5F,  0xDA5E,  0x44D3,  0xC6BF,  
} ;


static const unsigned short Uni2cnsP2Table_A3 [] = {
      0,       0x4875,  0xE475,  0xCDD3,  0,       0x53CB,  0x53CA,  0x4F4F,  // 0xA30x
      0x53C9,  0x53C8,  0xACAB,  0xACAF,  0xACAA,  0x4F4E,  0xACAC,  0,       
      0x53CC,  0xACAE,  0xACAD,  0,       0xB6E1,  0xB6DF,  0xB6DE,  0xB6E3,  // 0xA31x
      0x555B,  0,       0xB6E2,  0xC753,  0xD9C5,  0x5ADE,  0,       0,       
      0xB6E0,  0,       0x60F4,  0x60F5,  0xBEE0,  0xBEE1,  0xDEA8,  0,       // 0xA32x
      0xBEE2,  0,       0,       0,       0xBEDF,  0xC5F0,  0x67B2,  0xC5F2,  
      0x67B3,  0x67B5,  0xC5F3,  0x67B4,  0xE1FB,  0,       0,       0,       // 0xA33x
      0xC5F1,  0,       0,       0xC5EF,  0x627A,  0x6278,  0xCCF9,  0xCCFB,  
      0xCCF5,  0x6BD4,  0x6BD2,  0xCCFA,  0x6BD5,  0x6BD3,  0xCCF8,  0x627B,  // 0xA34x
      0,       0xCCF7,  0,       0xCCF6,  0x6FCB,  0xD2D3,  0xD2D2,  0x6FCC,  
      0xD2D0,  0x6570,  0xD2CF,  0x6FCE,  0x6FCD,  0xD2D1,  0xE7BA,  0,       // 0xA35x
      0xD2CE,  0,       0xD2CD,  0x72EC,  0xD7AF,  0x72EF,  0xD7B0,  0x72EE,  
      0xD7B1,  0xD7AE,  0x72ED,  0x75CB,  0x75CC,  0xDAF4,  0x75C9,  0x75CE,  // 0xA36x
      0xDAFB,  0xDAF6,  0xDAF7,  0xDAFC,  0xDAF9,  0x75CA,  0xDAF5,  0xDAF8,  
      0xDAFA,  0,       0x77BF,  0x6B4F,  0x77BE,  0x77C0,  0x77BD,  0,       // 0xA37x
      0x78EF,  0x78F1,  0x78F0,  0xE0D9,  0xDEBC,  0x6C59,  0xE0D8,  0x6D6D,  
      0xE3BF,  0xE4B9,  0xE4B8,  0x7BD8,  0xE5A9,  0,       0x6E52,  0x7CB0,  // 0xA38x
      0,       0,       0,       0,       0,       0xA9A1,  0xC6BE,  0xD3C2,  
      0xDEA7,  0,       0x4BF0,  0x4BEE,  0x4BEF,  0x53CE,  0x4F50,  0x53CD,  // 0xA39x
      0,       0,       0xACB0,  0x5AE1,  0xB6E4,  0x5ADF,  0x5AE0,  0xD9C6,  
      0x60F8,  0x60F6,  0xDEA9,  0x60F7,  0x67B6,  0xCCFC,  0x6BD6,  0xCCFD,  // 0xA3Ax
      0x6573,  0,       0xD7B2,  0x72F0,  0xDAFE,  0x6B50,  0xDBD6,  0xDEBD,  
      0x6B51,  0,       0x7CB1,  0xCDD4,  0xACB2,  0x5AE2,  0x5AE4,  0,       // 0xA3Bx
      0,       0x5AE3,  0x60FA,  0x67B8,  0,       0x60F9,  0x67B9,  0,       
      0,       0x67B7,  0x6BD7,  0x6322,  0xE4F9,  0,       0x6575,  0x6574,  // 0xA3Cx
      0x6FD0,  0x6FCF,  0x6577,  0xD2D4,  0xD2D5,  0xD2D6,  0xE7BB,  0,       
      0,       0xD2D7,  0,       0x72F3,  0x72F2,  0x72F1,  0xD7B3,  0,       // 0xA3Dx
      0xD7B4,  0x75CF,  0x6A2F,  0x6A30,  0xDBA3,  0xDBA2,  0xDBA1,  0,       
      0,       0xDEBE,  0,       0,       0x78F2,  0xE0DA,  0x78F3,  0xE1F9,  // 0xA3Ex
      0x79F6,  0,       0,       0,       0xE6A7,  0x4876,  0x53CF,  0x4F51,  
      0xB6E8,  0xB6E6,  0x5AE6,  0x5AE5,  0x5AE7,  0,       0x60FE,  0xBEE4,  // 0xA3Fx
      0x60FC,  0xBEE3,  0x60FB,  0x5A5E,  0x60FD,  0xBEE5,  0xBEE6,  0x67BB,  
} ;


static const unsigned short Uni2cnsP2Table_A4 [] = {
      0x67BA,  0,       0x6578,  0x6FD1,  0x6FD3,  0,       0,       0x72F4,  // 0xA40x
      0xD7B6,  0xD7B5,  0xE9B6,  0x75D0,  0x6B54,  0x77C2,  0x77C1,  0x6B53,  
      0,       0xE3C0,  0xE1FA,  0x6D6E,  0x7BDA,  0xE5AA,  0x7BD9,  0xE476,  // 0xA41x
      0x44D4,  0xE478,  0,       0xE477,  0xACB4,  0x4F55,  0x4F54,  0x53D0,  
      0xACB5,  0xACB6,  0,       0,       0xB6EA,  0x5AEA,  0x5AE8,  0x5AE9,  // 0xA42x
      0xB6E9,  0,       0xB6EB,  0xB6EC,  0,       0,       0,       0,       
      0,       0,       0x5A60,  0xBEE8,  0x61A1,  0,       0,       0,       // 0xA43x
      0xDEAA,  0xBEE7,  0,       0,       0,       0,       0,       0x67BE,  
      0x67BC,  0xC5F4,  0x6BD8,  0x61A2,  0x67BF,  0,       0,       0,       // 0xA44x
      0x6BDA,  0x6BD9,  0x6BDB,  0x6BDD,  0x6BDC,  0xCDA1,  0xCCFE,  0,       
      0,       0,       0x6FD6,  0x6FD7,  0xD2DB,  0x6FDB,  0x6FD9,  0x6FD5,  // 0xA45x
      0xD2D8,  0x657E,  0x657B,  0xD2DC,  0x6FDA,  0x657A,  0xD2DA,  0,       
      0,       0xE7BC,  0,       0xD2D9,  0,       0xD7B8,  0x6853,  0x6851,  // 0xA46x
      0x72F8,  0x6850,  0x72FB,  0xD7B7,  0x72F5,  0x72F9,  0x72F7,  0x6854,  
      0x72F6,  0x6855,  0x6A34,  0xD7B9,  0xD7BA,  0,       0,       0x72FA,  // 0xA47x
      0,       0,       0,       0,       0,       0,       0x75D1,  0x6A33,  
      0x6A35,  0xDBAA,  0xDBA7,  0xDBA6,  0x6A32,  0xDBA9,  0,       0,       // 0xA48x
      0xDBA8,  0,       0,       0x75D2,  0xDBA5,  0,       0,       0x77C7,  
      0xDEC1,  0x77C6,  0x77C4,  0x77C5,  0x77C3,  0x77C8,  0xDEBF,  0,       // 0xA49x
      0x78F6,  0x78F7,  0xE0DD,  0x6C5C,  0x6C60,  0x78F5,  0xE0DC,  0x78F4,  
      0x6C5F,  0x6C5E,  0x6C5D,  0xDEC0,  0,       0,       0,       0xE0DB,  // 0xA4Ax
      0,       0x79F8,  0x79F9,  0x79FA,  0x79F7,  0x6D45,  0xE1FB,  0xE1FC,  
      0x6D46,  0,       0,       0,       0x7ADC,  0xE4BA,  0,       0,       // 0xA4Bx
      0xE5AB,  0x6E30,  0xE4BB,  0x7BB3,  0,       0,       0x6E2F,  0x7BDB,  
      0x7BDC,  0xE5AC,  0,       0x6E4A,  0x7BF6,  0,       0xE5EE,  0,       // 0xA4Cx
      0,       0x7CCA,  0xE6D2,  0xC5F5,  0x6622,  0,       0x72FC,  0x6857,  
      0x77C9,  0xE479,  0xACB8,  0xACB7,  0x61A4,  0xB6ED,  0x5A61,  0xBEE9,  // 0xA4Dx
      0xBEEA,  0,       0xC5F8,  0x67C2,  0xC5F9,  0xC5F7,  0xC5F6,  0x5F41,  
      0,       0xCDA4,  0xCDA5,  0,       0xBEEB,  0xCDA3,  0,       0xD2DE,  // 0xA4Ex
      0xD2DF,  0xD2DD,  0,       0,       0x72FD,  0xD7BB,  0x6A36,  0xDBAC,  
      0xDBB1,  0xDBB2,  0xDBAE,  0xDBB0,  0xDBAD,  0xDBAB,  0xDBAF,  0x77CA,  // 0xA4Fx
      0xDEC2,  0x78F8,  0,       0x79FB,  0x7ADD,  0x6D47,  0xE3C1,  0x7BB4,  
} ;


static const unsigned short Uni2cnsP2Table_A5 [] = {
      0xE3C2,  0xE5AD,  0xD04F,  0,       0xB6EE,  0xB6EF,  0x5AEB,  0,       // 0xA50x
      0xC6CF,  0,       0xE5AE,  0x5AEC,  0,       0x61A5,  0xBEED,  0x67C3,  
      0xC5FA,  0x67C4,  0xE1FD,  0,       0xCDA7,  0x6BE0,  0xCDA6,  0x6BDE,  // 0xA51x
      0x6BDF,  0,       0,       0x6325,  0x6623,  0xD2E0,  0,       0,       
      0,       0,       0x6A39,  0x6858,  0xD7BC,  0xD7BD,  0x75D3,  0xDBB4,  // 0xA52x
      0xDBB5,  0x75D5,  0x6A38,  0xDBB3,  0x75D4,  0,       0xDEC3,  0xE0DE,  
      0x78F9,  0xE0DF,  0,       0x79FC,  0,       0xE3C3,  0x7BB5,  0x7BF7,  // 0xA53x
      0xACB9,  0,       0x5AED,  0xBEEE,  0x5AEE,  0x61A8,  0x61AA,  0x61AB,  
      0x61A9,  0x61A7,  0xBEF0,  0x61A6,  0xBEEF,  0,       0x61AC,  0,       // 0xA54x
      0x5A62,  0xC5FC,  0xCDAC,  0x67C7,  0x67C8,  0x67C6,  0x67C5,  0xC5FB,  
      0,       0xCDAA,  0x6BE1,  0x6BE3,  0x6BE2,  0,       0,       0xCDAD,  // 0xA55x
      0xCDAE,  0xCDA9,  0xD2E2,  0xD2E4,  0xD2E3,  0x6FDD,  0x6FDE,  0xCDAB,  
      0,       0xD2E5,  0,       0,       0x6FDC,  0,       0,       0xD2E1,  // 0xA56x
      0x73A1,  0x72FE,  0xD7BE,  0x75D7,  0xDBB6,  0x75D8,  0x75D9,  0x75D6,  
      0,       0x6A3A,  0,       0,       0,       0xDEC4,  0x77CB,  0x6B59,  // 0xA57x
      0xDEC8,  0x6B57,  0x6B5A,  0xDEC7,  0,       0xDEC6,  0xDEC5,  0x78FD,  
      0x6C63,  0x78FB,  0x78FA,  0xE0E0,  0,       0xE1FE,  0xE1FD,  0x6D49,  // 0xA58x
      0x79FD,  0,       0,       0x7BB6,  0x7BF9,  0x7BF8,  0xE5EF,  0xE6A2,  
      0x4F57,  0xB6F0,  0xB6F1,  0xBEF2,  0xBEF1,  0x67C9,  0xC5FE,  0xC6A1,  // 0xA59x
      0xC5FD,  0,       0x6BE4,  0x6BE5,  0,       0,       0,       0,       
      0,       0xD2E6,  0x6FDF,  0x6FE0,  0xD2E8,  0x685B,  0x73A2,  0xD7BF,  // 0xA5Ax
      0xD7C0,  0x73A3,  0x73A4,  0,       0,       0,       0xDBB7,  0x77CC,  
      0xDEC9,  0,       0,       0x78FC,  0xEBFE,  0xE0E1,  0x79FE,  0x7AA1,  // 0xA5Bx
      0,       0,       0,       0xE3C6,  0x7ADE,  0xE3C5,  0xE4BC,  0,       
      0,       0x6E53,  0x7CB2,  0,       0xC0B4,  0x5564,  0x5A65,  0xC6A2,  // 0xA5Cx
      0,       0x6328,  0xCDAF,  0x6DD7,  0x6624,  0x6A3B,  0xE9B7,  0x7AA3,  
      0x7AA2,  0xE2A1,  0xE5AF,  0,       0x61AE,  0xBEF3,  0,       0,       // 0xA5Dx
      0xC6A5,  0x5F47,  0xC6A4,  0xCDB0,  0x6BE6,  0x632A,  0xCDB1,  0xCDB4,  
      0xCDB2,  0xCDB3,  0xCDB5,  0xCDB6,  0x6BE7,  0xD2EB,  0x6FE3,  0x6FE2,  // 0xA5Ex
      0x6628,  0xD2E9,  0x662A,  0xD2ED,  0x6629,  0xD2EE,  0,       0xD2EA,  
      0,       0,       0x4878,  0,       0,       0xD2EC,  0xD7C6,  0x73AA,  // 0xA5Fx
      0x73A7,  0xD7C3,  0xD7C2,  0x685E,  0x73A8,  0x685F,  0x685D,  0xD7C4,  
} ;


static const unsigned short Uni2cnsP2Table_A6 [] = {
      0x73A5,  0x73AB,  0,       0,       0xD7C5,  0xD7C7,  0,       0,       // 0xA60x
      0,       0,       0x73A9,  0xD7C1,  0,       0x73A6,  0xDBB8,  0x6A3E,  
      0x75DC,  0x75DB,  0x75DE,  0xDBC0,  0xDBBF,  0x75DF,  0xDBBA,  0x75E0,  // 0xA61x
      0x6A3F,  0,       0,       0xDBB9,  0x75DA,  0,       0,       0xDBBB,  
      0xDBBD,  0xDBBE,  0xDBBC,  0,       0x75DD,  0x77CF,  0x77CE,  0x6B5E,  // 0xA62x
      0x6B62,  0x6B63,  0x6B5F,  0,       0x6B60,  0x77D0,  0xDECE,  0,       
      0xDECC,  0,       0x6B5D,  0,       0xDECA,  0,       0xDECB,  0xDECF,  // 0xA63x
      0x6B64,  0x6C67,  0x78FE,  0xE0E7,  0x6C68,  0xE0E5,  0x79A1,  0xE2A3,  
      0x6C65,  0xE0E3,  0xE0E6,  0xE0E4,  0,       0,       0xE0E2,  0xE0E8,  // 0xA64x
      0x79A2,  0x6D4E,  0x6D4A,  0xE2A5,  0x7AA6,  0x6D50,  0x6D4D,  0x7AA4,  
      0xE2A7,  0x6D4F,  0xE2A4,  0xE2A6,  0,       0,       0xE2A8,  0xE2A9,  // 0xA65x
      0xE2A2,  0x7AA5,  0xE3C8,  0x7AE0,  0xE3C7,  0x7AE2,  0x7ADF,  0x7AE1,  
      0,       0,       0,       0xE4BE,  0x6E32,  0xE4BD,  0x7BB7,  0x7BB9,  // 0xA66x
      0,       0x7BB8,  0xE4C0,  0,       0xE4C1,  0,       0xE4BF,  0,       
      0x6E46,  0,       0xE5B2,  0x7BDD,  0xE5B1,  0xE5B0,  0xE5D9,  0xE5F1,  // 0xA67x
      0xE5F2,  0x7CAA,  0,       0xE5F0,  0xE5F3,  0x7CB3,  0,       0xE6A4,  
      0xE6A3,  0x7CBB,  0xE6B2,  0x7CBA,  0xE6B1,  0,       0xE6BD,  0,       // 0xA68x
      0xE6BC,  0x7CC5,  0,       0xE6C1,  0xE6C8,  0x7CCE,  0x7CCD,  0,       
      0,       0x6BE8,  0xCDB7,  0x632C,  0,       0xD2F0,  0xD2EF,  0xCEA4,  // 0xA69x
      0x6FE4,  0xD7C8,  0,       0xE7BD,  0xDBC2,  0xDBC1,  0xDBC3,  0xDBC4,  
      0x77D1,  0,       0,       0,       0,       0x7CD1,  0xB6F2,  0xBEF4,  // 0xA6Ax
      0xC6A6,  0,       0,       0xD7C9,  0x6FE5,  0x662B,  0x6FE7,  0x6FE6,  
      0x662C,  0xD2F3,  0,       0xD2F1,  0xE7BE,  0xD2F2,  0x73AC,  0x73AE,  // 0xA6Bx
      0xD7CB,  0x73AF,  0x6BEA,  0x73AD,  0xD4AA,  0xD7CA,  0xCDB9,  0xCDB8,  
      0x7BDE,  0xE1A9,  0x7BBA,  0x77D2,  0xE4C2,  0,       0xEDAD,  0,       // 0xA6Cx
      0x7CC2,  0xA9A6,  0x73B0,  0xE2AB,  0,       0xE2AA,  0x7AE4,  0x7AE3,  
      0xE3CA,  0xE3C9,  0x7BBB,  0x6E47,  0xE6A5,  0x6E56,  0xE6CC,  0,       // 0xA6Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xA6Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xA6Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP2Table_A7  NULL
#define  Uni2cnsP2Table_A8  NULL
#define  Uni2cnsP2Table_A9  NULL
#define  Uni2cnsP2Table_AA  NULL
#define  Uni2cnsP2Table_AB  NULL
#define  Uni2cnsP2Table_AC  NULL
#define  Uni2cnsP2Table_AD  NULL
#define  Uni2cnsP2Table_AE  NULL
#define  Uni2cnsP2Table_AF  NULL
#define  Uni2cnsP2Table_B0  NULL
#define  Uni2cnsP2Table_B1  NULL
#define  Uni2cnsP2Table_B2  NULL
#define  Uni2cnsP2Table_B3  NULL
#define  Uni2cnsP2Table_B4  NULL
#define  Uni2cnsP2Table_B5  NULL
#define  Uni2cnsP2Table_B6  NULL
#define  Uni2cnsP2Table_B7  NULL
#define  Uni2cnsP2Table_B8  NULL
#define  Uni2cnsP2Table_B9  NULL
#define  Uni2cnsP2Table_BA  NULL
#define  Uni2cnsP2Table_BB  NULL
#define  Uni2cnsP2Table_BC  NULL
#define  Uni2cnsP2Table_BD  NULL
#define  Uni2cnsP2Table_BE  NULL
#define  Uni2cnsP2Table_BF  NULL
#define  Uni2cnsP2Table_C0  NULL
#define  Uni2cnsP2Table_C1  NULL
#define  Uni2cnsP2Table_C2  NULL
#define  Uni2cnsP2Table_C3  NULL
#define  Uni2cnsP2Table_C4  NULL
#define  Uni2cnsP2Table_C5  NULL
#define  Uni2cnsP2Table_C6  NULL
#define  Uni2cnsP2Table_C7  NULL
#define  Uni2cnsP2Table_C8  NULL
#define  Uni2cnsP2Table_C9  NULL
#define  Uni2cnsP2Table_CA  NULL
#define  Uni2cnsP2Table_CB  NULL
#define  Uni2cnsP2Table_CC  NULL
#define  Uni2cnsP2Table_CD  NULL
#define  Uni2cnsP2Table_CE  NULL
#define  Uni2cnsP2Table_CF  NULL
#define  Uni2cnsP2Table_D0  NULL
#define  Uni2cnsP2Table_D1  NULL
#define  Uni2cnsP2Table_D2  NULL
#define  Uni2cnsP2Table_D3  NULL
#define  Uni2cnsP2Table_D4  NULL
#define  Uni2cnsP2Table_D5  NULL
#define  Uni2cnsP2Table_D6  NULL
#define  Uni2cnsP2Table_D7  NULL
#define  Uni2cnsP2Table_D8  NULL
#define  Uni2cnsP2Table_D9  NULL
#define  Uni2cnsP2Table_DA  NULL
#define  Uni2cnsP2Table_DB  NULL
#define  Uni2cnsP2Table_DC  NULL
#define  Uni2cnsP2Table_DD  NULL
#define  Uni2cnsP2Table_DE  NULL
#define  Uni2cnsP2Table_DF  NULL
#define  Uni2cnsP2Table_E0  NULL
#define  Uni2cnsP2Table_E1  NULL
#define  Uni2cnsP2Table_E2  NULL
#define  Uni2cnsP2Table_E3  NULL
#define  Uni2cnsP2Table_E4  NULL
#define  Uni2cnsP2Table_E5  NULL
#define  Uni2cnsP2Table_E6  NULL
#define  Uni2cnsP2Table_E7  NULL
#define  Uni2cnsP2Table_E8  NULL
#define  Uni2cnsP2Table_E9  NULL
#define  Uni2cnsP2Table_EA  NULL
#define  Uni2cnsP2Table_EB  NULL
#define  Uni2cnsP2Table_EC  NULL
#define  Uni2cnsP2Table_ED  NULL
#define  Uni2cnsP2Table_EE  NULL
#define  Uni2cnsP2Table_EF  NULL
#define  Uni2cnsP2Table_F0  NULL
#define  Uni2cnsP2Table_F1  NULL
#define  Uni2cnsP2Table_F2  NULL
#define  Uni2cnsP2Table_F3  NULL
#define  Uni2cnsP2Table_F4  NULL
#define  Uni2cnsP2Table_F5  NULL
#define  Uni2cnsP2Table_F6  NULL
#define  Uni2cnsP2Table_F7  NULL

static const unsigned short Uni2cnsP2Table_F8 [] = {
      0xA936,  0xA131,  0xA121,  0xA566,  0xA572,  0x253D,  0xAE61,  0xADE8,  // 0xF80x
      0xBD35,  0xD05B,  0x3C30,  0xDA72,  0xD9CD,  0xA352,  0xA4D2,  0xA7D3,  
      0xE7C0,  0xA7D4,  0xBD3C,  0xCDBE,  0xA150,  0xA2FB,  0xA359,  0xA1CF,  // 0xF81x
      0xB544,  0x213F,  0xA23C,  0xA4C1,  0xB6FA,  0x21A9,  0xA138,  0xA3B7,  
      0xA963,  0xAE76,  0xC667,  0xC0C3,  0xA2A9,  0xAF25,  0xB558,  0x364C,  // 0xF82x
      0x212F,  0xA246,  0xA2A5,  0xA249,  0xA3A9,  0xAF38,  0xC674,  0xAA23,  
      0xAF3D,  0xBD59,  0xBD5A,  0xBAA6,  0xA1B3,  0xA4A9,  0xA161,  0xA643,  // 0xF83x
      0x31B1,  0xA25B,  0x21E0,  0xA3BC,  0x235C,  0xA64E,  0x235B,  0xAA3C,  
      0,       0xB0A3,  0xB57E,  0x3076,  0xBD7C,  0xC72A,  0xC72C,  0xC730,  // 0xF84x
      0xC731,  0xC733,  0x3C50,  0xDB5B,  0xD136,  0xDB59,  0xA1E0,  0xACE5,  
      0xA1FC,  0xA433,  0xB635,  0xBE2C,  0xBE2B,  0xB4F0,  0x3676,  0xD14A,  // 0xF85x
      0xA1F6,  0xC6BE,  0xA3DB,  0xD157,  0x23E2,  0xA43B,  0xD15E,  0xC756,  
      0xA267,  0xAAAB,  0xB64C,  0xB64D,  0xAEED,  0xBE54,  0xBE50,  0xC761,  // 0xF86x
      0xD169,  0xC7C6,  0xDAB3,  0xC6D1,  0xA448,  0x3130,  0xC1AB,  0xDC22,  
      0xDAB6,  0xE0ED,  0xA721,  0xB667,  0xA44B,  0x2134,  0x28F3,  0xC77B,  // 0xF87x
      0x2135,  0xA6E2,  0xACC0,  0xB04E,  0xC82B,  0xC835,  0xC0FE,  0xD233,  
      0xDC3D,  0xA736,  0xDC49,  0xA1DF,  0xC837,  0xB72C,  0xC83C,  0xADD3,  // 0xF88x
      0xADD5,  0xE0EE,  0x29A7,  0xBF46,  0xBF45,  0xB5DF,  0xD240,  0x45DD,  
      0xA174,  0xA74A,  0xAB2F,  0xB074,  0,       0xAADD,  0xAB39,  0xADE3,  // 0xF89x
      0x73C0,  0xACD1,  0xBF5E,  0x2DC8,  0xB5E5,  0xA75F,  0xA4B3,  0x24B8,  
      0xB136,  0xB130,  0xAAE7,  0x294A,  0xC87C,  0xC878,  0xC6F0,  0xD26C,  // 0xF8Ax
      0xD266,  0xDD26,  0xDD24,  0x4351,  0xADE9,  0xADF9,  0xA2FB,  0xD4E0,  
      0x5B2C,  0xC7A8,  0xA6A7,  0xC023,  0x22EE,  0xAB63,  0xAB60,  0xB14F,  // 0xF8Bx
      0xABAB,  0xB771,  0xB6A8,  0xC036,  0xC02B,  0xC94A,  0xC930,  0xC1DF,  
      0xA3B0,  0xDD38,  0x46AC,  0xA3AD,  0xCFA5,  0x4A27,  0xB8B9,  0xDEF0,  // 0xF8Cx
      0x2D46,  0xC957,  0xDAB6,  0xB6C0,  0xB836,  0,       0xC1F2,  0xD33C,  
      0x46C1,  0xABB8,  0xB16D,  0xC057,  0xC978,  0xDD5B,  0xAC23,  0x26CA,  // 0xF8Dx
      0x323E,  0xC058,  0x3FE6,  0x2447,  0xA82E,  0xA4D1,  0x2668,  0xADB5,  
      0xB84A,  0xB1DC,  0x2D5C,  0xB850,  0x32FE,  0xBCBA,  0xD35E,  0x3FF1,  // 0xF8Ex
      0xC1EE,  0xDD68,  0xA3F2,  0xD4F4,  0xAEEA,  0x5F76,  0xD8A3,  0xA523,  
      0xCA3F,  0xA3F8,  0xDEF2,  0xC8F9,  0xD377,  0x2D65,  0xB5F4,  0xCA4D,  // 0xF8Fx
      0xAC42,  0xC8FB,  0xA52E,  0xA4DD,  0xAC5B,  0xAC51,  0xADD2,  0xB239,  
} ;


static const unsigned short Uni2cnsP2Table_F9 [] = {
      0xB242,  0x2A25,  0x2D70,  0xB92D,  0xB874,  0xB921,  0xB0DB,  0xB6F5,  // 0xF90x
      0xCA65,  0xCA63,  0x3E33,  0xD449,  0xD44F,  0xC2F4,  0xDE3E,  0xA4CF,  
      0xA4D8,  0xCFE9,  0xAFC2,  0xD5D6,  0x565D,  0xCEA8,  0xD3E0,  0xD3D8,  // 0xF91x
      0xAC60,  0xAC5D,  0xB248,  0x3868,  0xC3AF,  0xD459,  0xD0BD,  0xD5D8,  
      0x7BFB,  0xD5C5,  0xC161,  0xC163,  0xC16A,  0xDE5E,  0xB262,  0xCB42,  // 0xF92x
      0xC7F5,  0xA226,  0xA4F8,  0xAD24,  0xACB9,  0xB1A8,  0xCB47,  0xC3E4,  
      0x446E,  0xC0E3,  0xE3A4,  0xC221,  0xBDBF,  0xB279,  0x2A44,  0x33E5,  // 0xF93x
      0xCB56,  0x3E6C,  0xC232,  0xCAAF,  0xD3FB,  0xAD3A,  0x33F1,  0xD6BC,  
      0xAD45,  0xAD3D,  0xB33D,  0xB331,  0x2FA6,  0xACD7,  0xBA2D,  0xBA2E,  // 0xF94x
      0xC248,  0xCB7A,  0xD0DF,  0xB0CA,  0xA53F,  0xAD46,  0xC3B3,  0xD56B,  
      0xA5FB,  0xB9ED,  0xA8BC,  0xB34A,  0xBDE0,  0x4B60,  0xA6A7,  0xBA43,  // 0xF95x
      0xC267,  0x455F,  0x5221,  0xB0E6,  0xDF75,  0xA6BE,  0xA6BC,  0xB0F3,  
      0xCAFB,  0xE023,  0xD1A3,  0xA6CD,  0xC1BC,  0x6CFD,  0xB1AD,  0xBAB3,  // 0xF96x
      0x5C59,  0xC1C4,  0xAED6,  0xB366,  0xC8EA,  0xD1B7,  0xA6EA,  0xA6E9,  
      0x6426,  0xE2CD,  0xCC72,  0xBAC6,  0xBEB2,  0xBAC9,  0xC8ED,  0xDFBC,  // 0xF97x
      0xCD23,  0xD7A7,  0x2B26,  0xA7A8,  0xD7A8,  0xE05D,  0x48F4,  0xDCAD,  
      0xA87B,  0x2768,  0xAD69,  0xB3D0,  0x3BD0,  0xCD48,  0xC4E8,  0xCBD7,  // 0xF98x
      0xCBD6,  0x4C56,  0x582D,  0x3457,  0xCD5E,  0xC4A5,  0xE125,  0xA7AA,  
      0xA552,  0xA927,  0xA8DC,  0xA928,  0,       0xAE22,  0xAE23,  0xB444,  // 0xF99x
      0xAE24,  0xBB52,  0xB2BA,  0x3473,  0xC42B,  0x3474,  0xC376,  0xC43B,  
      0x3A66,  0xC43E,  0xC43C,  0xC43D,  0xCE3B,  0xE13E,  0xE14F,  0xD1E4,  // 0xF9Ax
      0x4C79,  0xA7E1,  0xA7ED,  0xB2C4,  0xD7C7,  0xBAEF,  0xE0DD,  0xC2BC,  
      0xD4DE,  0x672B,  0,       0xB447,  0x404F,  0xBBB8,  0xDBA6,  0xBB71,  // 0xF9Bx
      0x3A75,  0xCE46,  0x467C,  0x4D33,  0xD2A4,  0xA8AE,  0xD1FD,  0xC2E0,  
      0xC2DF,  0xDBAD,  0x643F,  0x534C,  0xA553,  0x30BE,  0xD82E,  0xD82C,  // 0xF9Cx
      0xC5BD,  0xBBE1,  0xB8CA,  0x7AB8,  0xBC2D,  0x3545,  0xBFBB,  0xE247,  
      0xB3CF,  0xD9C1,  0xA92A,  0xD850,  0,       0xD85C,  0xE0FC,  0xBC3B,  // 0xF9Dx
      0xB3F9,  0xB3F3,  0xBFD3,  0xC4ED,  0xA9C4,  0xB45D,  0x302C,  0xB4B1,  
      0x5437,  0xBCE1,  0xA55B,  0x3572,  0xD947,  0xD94A,  0xBCEB,  0xC5F3,  // 0xF9Ex
      0xE353,  0xE34F,  0x544A,  0xE6DE,  0xD0EB,  0xECBF,  0xE358,  0xB4FA,  
      0xB4F1,  0xE1CA,  0xD022,  0xE36E,  0xB5B5,  0xD6F8,  0x5FDE,  0xBDD0,  // 0xF9Fx
      0xD8F8,  0xCBDF,  0x652A,  0xCBEB,  0x3DC7,  0x44B5,  0xDA33,  0xE430,  
} ;


static const unsigned short Uni2cnsP2Table_FA [] = {
      0x5976,  0xE43A,  0xBC77,  0xDA3D,  0x5523,  0x5E60,  0xE450,  0xBEA9,  // 0xFA0x
      0xABD5,  0xD9B2,  0xD1FA,  0xDAE0,  0x5A59,  0xC5E5,  0x5F37,  0x626E,  
      0xD2C5,  0x75B6,  0x75B5,  0xECF7,  0xBEDC,  0xC63E,  0x684F,  0xDA60,  // 0xFA1x
      0x2834,  0xDCAF,  0x53D1,  0xCDA8,  0x4877,  0xDECD,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA3x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFA9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFABx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFACx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFADx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFAFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2cnsP2Table_FB  NULL
#define  Uni2cnsP2Table_FC  NULL
#define  Uni2cnsP2Table_FD  NULL
#define  Uni2cnsP2Table_FE  NULL
#define  Uni2cnsP2Table_FF  NULL


static const unsigned short *Uni2cnsP2Table ( int C ) {

   static const unsigned short *const Uni2cnsP2Table_00_FF [] = {
      Uni2cnsP2Table_00, Uni2cnsP2Table_01, Uni2cnsP2Table_02, Uni2cnsP2Table_03,
      Uni2cnsP2Table_04, Uni2cnsP2Table_05, Uni2cnsP2Table_06, Uni2cnsP2Table_07,
      Uni2cnsP2Table_08, Uni2cnsP2Table_09, Uni2cnsP2Table_0A, Uni2cnsP2Table_0B,
      Uni2cnsP2Table_0C, Uni2cnsP2Table_0D, Uni2cnsP2Table_0E, Uni2cnsP2Table_0F,

      Uni2cnsP2Table_10, Uni2cnsP2Table_11, Uni2cnsP2Table_12, Uni2cnsP2Table_13,
      Uni2cnsP2Table_14, Uni2cnsP2Table_15, Uni2cnsP2Table_16, Uni2cnsP2Table_17,
      Uni2cnsP2Table_18, Uni2cnsP2Table_19, Uni2cnsP2Table_1A, Uni2cnsP2Table_1B,
      Uni2cnsP2Table_1C, Uni2cnsP2Table_1D, Uni2cnsP2Table_1E, Uni2cnsP2Table_1F,

      Uni2cnsP2Table_20, Uni2cnsP2Table_21, Uni2cnsP2Table_22, Uni2cnsP2Table_23,
      Uni2cnsP2Table_24, Uni2cnsP2Table_25, Uni2cnsP2Table_26, Uni2cnsP2Table_27,
      Uni2cnsP2Table_28, Uni2cnsP2Table_29, Uni2cnsP2Table_2A, Uni2cnsP2Table_2B,
      Uni2cnsP2Table_2C, Uni2cnsP2Table_2D, Uni2cnsP2Table_2E, Uni2cnsP2Table_2F,

      Uni2cnsP2Table_30, Uni2cnsP2Table_31, Uni2cnsP2Table_32, Uni2cnsP2Table_33,
      Uni2cnsP2Table_34, Uni2cnsP2Table_35, Uni2cnsP2Table_36, Uni2cnsP2Table_37,
      Uni2cnsP2Table_38, Uni2cnsP2Table_39, Uni2cnsP2Table_3A, Uni2cnsP2Table_3B,
      Uni2cnsP2Table_3C, Uni2cnsP2Table_3D, Uni2cnsP2Table_3E, Uni2cnsP2Table_3F,

      Uni2cnsP2Table_40, Uni2cnsP2Table_41, Uni2cnsP2Table_42, Uni2cnsP2Table_43,
      Uni2cnsP2Table_44, Uni2cnsP2Table_45, Uni2cnsP2Table_46, Uni2cnsP2Table_47,
      Uni2cnsP2Table_48, Uni2cnsP2Table_49, Uni2cnsP2Table_4A, Uni2cnsP2Table_4B,
      Uni2cnsP2Table_4C, Uni2cnsP2Table_4D, Uni2cnsP2Table_4E, Uni2cnsP2Table_4F,

      Uni2cnsP2Table_50, Uni2cnsP2Table_51, Uni2cnsP2Table_52, Uni2cnsP2Table_53,
      Uni2cnsP2Table_54, Uni2cnsP2Table_55, Uni2cnsP2Table_56, Uni2cnsP2Table_57,
      Uni2cnsP2Table_58, Uni2cnsP2Table_59, Uni2cnsP2Table_5A, Uni2cnsP2Table_5B,
      Uni2cnsP2Table_5C, Uni2cnsP2Table_5D, Uni2cnsP2Table_5E, Uni2cnsP2Table_5F,

      Uni2cnsP2Table_60, Uni2cnsP2Table_61, Uni2cnsP2Table_62, Uni2cnsP2Table_63,
      Uni2cnsP2Table_64, Uni2cnsP2Table_65, Uni2cnsP2Table_66, Uni2cnsP2Table_67,
      Uni2cnsP2Table_68, Uni2cnsP2Table_69, Uni2cnsP2Table_6A, Uni2cnsP2Table_6B,
      Uni2cnsP2Table_6C, Uni2cnsP2Table_6D, Uni2cnsP2Table_6E, Uni2cnsP2Table_6F,

      Uni2cnsP2Table_70, Uni2cnsP2Table_71, Uni2cnsP2Table_72, Uni2cnsP2Table_73,
      Uni2cnsP2Table_74, Uni2cnsP2Table_75, Uni2cnsP2Table_76, Uni2cnsP2Table_77,
      Uni2cnsP2Table_78, Uni2cnsP2Table_79, Uni2cnsP2Table_7A, Uni2cnsP2Table_7B,
      Uni2cnsP2Table_7C, Uni2cnsP2Table_7D, Uni2cnsP2Table_7E, Uni2cnsP2Table_7F,

      Uni2cnsP2Table_80, Uni2cnsP2Table_81, Uni2cnsP2Table_82, Uni2cnsP2Table_83,
      Uni2cnsP2Table_84, Uni2cnsP2Table_85, Uni2cnsP2Table_86, Uni2cnsP2Table_87,
      Uni2cnsP2Table_88, Uni2cnsP2Table_89, Uni2cnsP2Table_8A, Uni2cnsP2Table_8B,
      Uni2cnsP2Table_8C, Uni2cnsP2Table_8D, Uni2cnsP2Table_8E, Uni2cnsP2Table_8F,

      Uni2cnsP2Table_90, Uni2cnsP2Table_91, Uni2cnsP2Table_92, Uni2cnsP2Table_93,
      Uni2cnsP2Table_94, Uni2cnsP2Table_95, Uni2cnsP2Table_96, Uni2cnsP2Table_97,
      Uni2cnsP2Table_98, Uni2cnsP2Table_99, Uni2cnsP2Table_9A, Uni2cnsP2Table_9B,
      Uni2cnsP2Table_9C, Uni2cnsP2Table_9D, Uni2cnsP2Table_9E, Uni2cnsP2Table_9F,

      Uni2cnsP2Table_A0, Uni2cnsP2Table_A1, Uni2cnsP2Table_A2, Uni2cnsP2Table_A3,
      Uni2cnsP2Table_A4, Uni2cnsP2Table_A5, Uni2cnsP2Table_A6, Uni2cnsP2Table_A7,
      Uni2cnsP2Table_A8, Uni2cnsP2Table_A9, Uni2cnsP2Table_AA, Uni2cnsP2Table_AB,
      Uni2cnsP2Table_AC, Uni2cnsP2Table_AD, Uni2cnsP2Table_AE, Uni2cnsP2Table_AF,

      Uni2cnsP2Table_B0, Uni2cnsP2Table_B1, Uni2cnsP2Table_B2, Uni2cnsP2Table_B3,
      Uni2cnsP2Table_B4, Uni2cnsP2Table_B5, Uni2cnsP2Table_B6, Uni2cnsP2Table_B7,
      Uni2cnsP2Table_B8, Uni2cnsP2Table_B9, Uni2cnsP2Table_BA, Uni2cnsP2Table_BB,
      Uni2cnsP2Table_BC, Uni2cnsP2Table_BD, Uni2cnsP2Table_BE, Uni2cnsP2Table_BF,

      Uni2cnsP2Table_C0, Uni2cnsP2Table_C1, Uni2cnsP2Table_C2, Uni2cnsP2Table_C3,
      Uni2cnsP2Table_C4, Uni2cnsP2Table_C5, Uni2cnsP2Table_C6, Uni2cnsP2Table_C7,
      Uni2cnsP2Table_C8, Uni2cnsP2Table_C9, Uni2cnsP2Table_CA, Uni2cnsP2Table_CB,
      Uni2cnsP2Table_CC, Uni2cnsP2Table_CD, Uni2cnsP2Table_CE, Uni2cnsP2Table_CF,

      Uni2cnsP2Table_D0, Uni2cnsP2Table_D1, Uni2cnsP2Table_D2, Uni2cnsP2Table_D3,
      Uni2cnsP2Table_D4, Uni2cnsP2Table_D5, Uni2cnsP2Table_D6, Uni2cnsP2Table_D7,
      Uni2cnsP2Table_D8, Uni2cnsP2Table_D9, Uni2cnsP2Table_DA, Uni2cnsP2Table_DB,
      Uni2cnsP2Table_DC, Uni2cnsP2Table_DD, Uni2cnsP2Table_DE, Uni2cnsP2Table_DF,

      Uni2cnsP2Table_E0, Uni2cnsP2Table_E1, Uni2cnsP2Table_E2, Uni2cnsP2Table_E3,
      Uni2cnsP2Table_E4, Uni2cnsP2Table_E5, Uni2cnsP2Table_E6, Uni2cnsP2Table_E7,
      Uni2cnsP2Table_E8, Uni2cnsP2Table_E9, Uni2cnsP2Table_EA, Uni2cnsP2Table_EB,
      Uni2cnsP2Table_EC, Uni2cnsP2Table_ED, Uni2cnsP2Table_EE, Uni2cnsP2Table_EF,

      Uni2cnsP2Table_F0, Uni2cnsP2Table_F1, Uni2cnsP2Table_F2, Uni2cnsP2Table_F3,
      Uni2cnsP2Table_F4, Uni2cnsP2Table_F5, Uni2cnsP2Table_F6, Uni2cnsP2Table_F7,
      Uni2cnsP2Table_F8, Uni2cnsP2Table_F9, Uni2cnsP2Table_FA, Uni2cnsP2Table_FB,
      Uni2cnsP2Table_FC, Uni2cnsP2Table_FD, Uni2cnsP2Table_FE, Uni2cnsP2Table_FF,
   } ;

   if ( (unsigned) C <= 0xFF ) return Uni2cnsP2Table_00_FF [ C ] ;

   return NULL ;
}


#endif
